!----------------------------------------------------------------------
!     Copyright (c) 2010--2012 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_module テストプログラム
!      積分・平均計算
!
!履歴  2010/04/18  竹広真一  wt_module_sjpack_integral_test.f90 より改造
!      2011/09/14  竹広真一  テスト関数追加
!      2012/08/26  竹広真一  wt_module_integral_test.f90 より改造
!
program wt_module_integral_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wt_module

  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径
  real(8), dimension(0:im-1,1:jm,0:km)       :: xyz_Data

  real(8), dimension(0:im-1,1:jm)            :: xy_Data
  real(8), dimension(1:jm,0:km)              :: yz_Data
  real(8), dimension(0:im-1,0:km)            :: xz_Data
  real(8), dimension(0:im-1)                 :: x_Data
  real(8), dimension(1:jm)                   :: y_Data
  real(8), dimension(0:km)                   :: z_Data
  real(8)                                    :: Data

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  real(8), parameter  :: pi=3.1415926535897932385D0

  !============================ 積分(xyz) ==============================

  call MessageNotify('M','wt_module_integral_test', &
       'wt_module integration functions tests')

  call wt_Initial(im,jm,km,nm,lm,ri,ro)

 !---------- 定数 ----------
  xyz_Data = 1.0D0

  yz_Data = 2*pi
  call AssertEqual(&
       message='yz_IntLon_xyz with constant field',                &
       answer = yz_Data,                                           &
       check = yz_IntLon_xyz(xyz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xz_Data = 2.0D0
  call AssertEqual(&
       message='xz_IntLat_xyz with constant field',                &
       answer = xz_Data,                                           &
       check = xz_IntLat_xyz(xyz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = 1/3.0D0*(ro**3-ri**3)
  call AssertEqual(&
       message='xy_IntRad_xyz with constant field',                &
       answer = xy_Data,                                           &
       check = xy_IntRad_xyz(xyz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  z_Data = 4*pi
  call AssertEqual(&
       message='z_IntLonLat_xyz with constant field',              &
       answer = z_Data,                                            &
       check = z_IntLonLat_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2/3.0D0*(ro**3-ri**3)
  call AssertEqual(&
       message='x_IntLatRad_xyz with constant field',              &
       answer = x_Data,                                            &
       check = x_IntLatRad_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 2*pi/3.0D0*(ro**3-ri**3)
  call AssertEqual(&
       message='y_IntLonRad_xyz with constant field',              &
       answer = y_Data,                                            &
       check = y_IntLonRad_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = 4*pi/3*(ro**3-ri**3)
  call AssertEqual(&
       message='IntLonLatRad_xyz with constant field',             &
       answer = Data,                                              &
       check = IntLonLatRad_xyz(xyz_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  !------------------ r -----------------------
  xyz_Data = xyz_Rad 

  yz_Data = 2*pi* xyz_Rad(1,:,:)
  call AssertEqual(&
       message='yz_IntLon_xyz with r-field',                       &
       answer = yz_Data,                                           &
       check = yz_IntLon_xyz(xyz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xz_Data = 2.0D0 * xyz_Data(:,1,:)
  call AssertEqual(&
       message='xz_IntLat_xyz with r-field',                       &
       answer = xz_Data,                                           &
       check = xz_IntLat_xyz(xyz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = 1/4.0D0*(ro**4-ri**4) 
  call AssertEqual(&
       message='xy_IntRad_xyz with r field',                       &
       answer = xy_Data,                                           &
       check = xy_IntRad_xyz(xyz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  z_Data = 4*pi * xyz_Data(1,1,:)
  call AssertEqual(&
       message='z_IntLonLat_xyz with r field',                     &
       answer = z_Data,                                            &
       check = z_IntLonLat_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/2.0D0*(ro**4-ri**4)
  call AssertEqual(&
       message='x_IntLatRad_xyz with r field',                     &
       answer = x_Data,                                            &
       check = x_IntLatRad_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = pi/2.0D0*(ro**4-ri**4)
  call AssertEqual(&
       message='y_IntLonRad_xyz with constant field',              &
       answer = y_Data,                                            &
       check = y_IntLonRad_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = pi*(ro**4-ri**4)
  call AssertEqual(&
       message='IntLonLatRad_xyz with constant field',              &
       answer = Data,                                            &
       check = IntLonLatRad_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  !--------- sin(phi)**2  ---------
  xyz_Data = sin(xyz_Lat)**2

  yz_Data = 2*pi* xyz_Data(1,:,:)
  call AssertEqual(&
       message='yz_IntLon_xyz with sin^2φ field',                 &
       answer = yz_Data,                                           &
       check = yz_IntLon_xyz(xyz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xz_Data = 2.0D0/3.0D0
  call AssertEqual(&
       message='xz_IntLat_xyz with sin^2φ field',                 &
       answer = xz_Data,                                           &
       check = xz_IntLat_xyz(xyz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = 1/3.0D0*(ro**3-ri**3) * xyz_Data(:,:,1)
  call AssertEqual(&
       message='xy_IntRad_xyz with sin^2φ field',                 &
       answer = xy_Data,                                           &
       check = xy_IntRad_xyz(xyz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  z_Data = 4*pi/3.0
  call AssertEqual(&
       message='z_IntLonLat_xyz with sin^2φ field',               &
       answer = z_Data,                                            &
       check = z_IntLonLat_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2/9.0D0*(ro**3-ri**3)
  call AssertEqual(&
       message='x_IntLatRad_xyz with sin^2φ field',               &
       answer = x_Data,                                            &
       check = x_IntLatRad_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 2*pi/3.0D0*(ro**3-ri**3) * xyz_Data(1,:,1)
  call AssertEqual(&
       message='y_IntLonRad_xyz with sin^2φ field',               &
       answer = y_Data,                                            &
       check = y_IntLonRad_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = 4*pi/9*(ro**3-ri**3)
  call AssertEqual(&
       message='IntLonLatRad_xyz with constant field',             &
       answer = Data,                                              &
       check = IntLonLatRad_xyz(xyz_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(xy) =============================
  ! 定数
  xy_Data = 1.0D0

  y_Data = 2*pi
  call AssertEqual(&
       message='y_IntLon_xy with constant field',                  &
       answer = y_Data,                                            &
       check = y_IntLon_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2.0D0
  call AssertEqual(&
       message='x_IntLat_xy with constant field',                  &
       answer = x_Data,                                            &
       check = x_IntLat_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLat_xy with constant field',                 &
       answer = 4*pi,                                              &
       check = IntLonLat_xy(xy_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  xy_Data = sin(xy_Lat)**2

  y_Data = 2*pi* xy_Data(1,:)
  call AssertEqual(&
       message='y_IntLon_xy with sin(phi)**2',                     &
       answer = y_Data,                                            &
       check = y_IntLon_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2.0D0/3.0D0
  call AssertEqual(&
       message='x_IntLat_xy with sin(phi)**2',                     &
       answer = x_Data,                                            &
       check = x_IntLat_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLat_xy with sin(phi)**2',                    &
       answer = 4*pi/3.0,                                          &
       check = IntLonLat_xy(xy_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(yz) =============================
  ! 定数
  yz_Data = 1.0D0

  z_Data = 2.0D0
  call AssertEqual(&
       message='z_IntLat_yz with constant field',                  &
       answer = z_Data,                                            &
       check = z_IntLat_yz(yz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 1/3.0D0*(ro**3-ri**3)
  call AssertEqual(&
       message='y_IntRad_yz with constant field',                  &
       answer = y_Data,                                            &
       check = y_IntRad_yz(yz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLatRad_yz with constant field',                 &
       answer = 2/3.0D0*(ro**3-ri**3),                             &
       check = IntLatRad_yz(yz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  yz_Data = xyz_Rad(0,:,:)**2

  z_Data = 2.0D0 * yz_Data(1,:)
  call AssertEqual(&
       message='z_IntLat_yz with r^2',                             &
       answer = z_Data,                                            &
       check = z_IntLat_yz(yz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 1/5.0D0*(ro**5-ri**5)
  call AssertEqual(&
       message='y_IntRad_yz with r^2',                             &
       answer = y_Data,                                            &
       check = y_IntRad_yz(yz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLatRad_yz with r^2',                            &
       answer = 2/5.0D0*(ro**5-ri**5),                             &
       check = IntLatRad_yz(yz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  yz_Data = sin(xyz_Lat(0,:,:))**2

  z_Data = 2.0D0/3.0D0
  call AssertEqual(&
       message='z_IntLat_yz with sin(phi)**2',                     &
       answer = z_Data,                                            &
       check = z_IntLat_yz(yz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 1/3.0D0*(ro**3-ri**3) * yz_Data(:,1)
  call AssertEqual(&
       message='y_IntRad_yz with sin(phi)**2',                     &
       answer = y_Data,                                            &
       check = y_IntRad_yz(yz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLatRad_yz with sin(phi)**2',                    &
       answer = 2/9.0D0*(ro**3-ri**3),                             &
       check = IntLatRad_yz(yz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(xz) =============================
  ! 定数
  xz_Data = 1.0D0

  z_Data = 2*pi
  call AssertEqual(&
       message='z_IntLon_xz with constant field',                  &
       answer = z_Data,                                            &
       check = z_IntLon_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/3.0D0*(ro**3-ri**3)
  call AssertEqual(&
       message='x_IntRad_xz with constant field',                  &
       answer = x_Data,                                            &
       check = x_IntRad_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonRad_xz with constant field',                 &
       answer = 2*pi/3.0D0*(ro**3-ri**3),                          &
       check = IntLonRad_xz(xz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  xz_Data = spread(z_Rad**2,1,im)

  z_Data = 2*pi* z_Rad**2
  call AssertEqual(&
       message='z_IntLon_xz with r^2',                             &
       answer = z_Data,                                            &
       check = z_IntLon_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/5.0D0*(ro**5-ri**5)
  call AssertEqual(&
       message='x_IntRad_xz with r^2',                             &
       answer = x_Data,                                            &
       check = x_IntRad_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonRad_xz with r^2',                            &
       answer = 2*pi/5.0D0*(ro**5-ri**5),                          &
       check = IntLonRad_xz(xz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(x) =============================
  ! 定数
  x_Data = 1.0D0

  call AssertEqual(&
       message='IntLon_x with constant field',                     &
       answer = 2*pi,                                              &
       check = IntLon_x(x_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(y) =============================
  ! 定数
  y_Data = 1.0D0

  call AssertEqual(&
       message='IntLat_y with constant field',                     &
       answer = 2.0D0,                                             &
       check = IntLat_y(y_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  y_Data = sin(y_Lat)**2

  call AssertEqual(&
       message='IntLat_y with sin(phi)**2',                        &
       answer = 2.0D0/3.0D0,                                       &
       check = IntLat_y(y_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(z) =============================
  ! 定数
  z_Data = 1.0D0

  call AssertEqual(&
       message='IntRad_r with constant field',                     &
       answer = 1/3.0D0*(ro**3-ri**3),                             &
       check = IntRad_z(z_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  z_Data = z_Rad**2

  call AssertEqual(&
       message='IntRad_r with r^2',                                &
       answer = 1/5.0D0*(ro**5-ri**5),                             &
       check = IntRad_z(z_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

!============================ 平均(xyz) ==============================

 !---------- 定数 ----------
  xyz_Data = 1.0D0

  yz_Data = 1.0D0
  call AssertEqual(&
       message='yz_AvrLon_xyz with constant field',                &
       answer = yz_Data,                                           &
       check = yz_AvrLon_xyz(xyz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xz_Data = 1.0D0
  call AssertEqual(&
       message='xz_AvrLat_xyz with constant field',                &
       answer = xz_Data,                                           &
       check = xz_AvrLat_xyz(xyz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = 1.0D0
  call AssertEqual(&
       message='xy_AvrRad_xyz with constant field',                &
       answer = xy_Data,                                           &
       check = xy_AvrRad_xyz(xyz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  z_Data = 1.0D0
  call AssertEqual(&
       message='z_AvrLonLat_xyz with constant field',              &
       answer = z_Data,                                            &
       check = z_AvrLonLat_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0
  call AssertEqual(&
       message='x_AvrLatRad_xyz with constant field',              &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 1.0D0
  call AssertEqual(&
       message='y_AvrLonRad_xyz with constant field',              &
       answer = y_Data,                                            &
       check = y_AvrLonRad_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = 1.0D0
  call AssertEqual(&
       message='AvrLonLatRad_xyz with constant field',             &
       answer = Data,                                              &
       check = AvrLonLatRad_xyz(xyz_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  !------------------ r -----------------------
  xyz_Data = xyz_Rad 

  yz_Data = xyz_Rad(1,:,:)
  call AssertEqual(&
       message='yz_AvrLon_xyz with r-field',                &
       answer = yz_Data,                                           &
       check = yz_AvrLon_xyz(xyz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xz_Data = xyz_Data(:,1,:)
  call AssertEqual(&
       message='xz_AvrLat_xyz with r-field',                &
       answer = xz_Data,                                           &
       check = xz_AvrLat_xyz(xyz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = 1.0D0/4.0D0*(ro**4-ri**4)/(1/3.0D0*(ro**3-ri**3))
  call AssertEqual(&
       message='xy_AvrRad_xyz with r field',                &
       answer = xy_Data,                                           &
       check = xy_AvrRad_xyz(xyz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  z_Data = xyz_Data(1,1,:)
  call AssertEqual(&
       message='z_AvrLonLat_xyz with r field',                     &
       answer = z_Data,                                            &
       check = z_AvrLonLat_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/2.0D0*(ro**4-ri**4)/(2/3.0D0*(ro**3-ri**3))
  call AssertEqual(&
       message='x_AvrLatRad_xyz with r field',                     &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = pi/2.0D0*(ro**4-ri**4)/(2*pi/3.0D0*(ro**3-ri**3))
  call AssertEqual(&
       message='y_AvrLonRad_xyz with constant field',              &
       answer = y_Data,                                            &
       check = y_AvrLonRad_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = pi*(ro**4-ri**4)/(4*pi/3*(ro**3-ri**3))
  call AssertEqual(&
       message='AvrLonLatRad_xyz with constant field',              &
       answer = Data,                                            &
       check = AvrLonLatRad_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  !--------- sin(phi)**2  ---------
  xyz_Data = sin(xyz_Lat)**2

  yz_Data = xyz_Data(1,:,:)
  call AssertEqual(&
       message='yz_AvrLon_xyz with sin^2φ field',                 &
       answer = yz_Data,                                           &
       check = yz_AvrLon_xyz(xyz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xz_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='xz_AvrLat_xyz with sin^2φ field',                 &
       answer = xz_Data,                                           &
       check = xz_AvrLat_xyz(xyz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xy_Data = xyz_Data(:,:,1)
  call AssertEqual(&
       message='xy_AvrRad_xyz with sin^2φ field',                 &
       answer = xy_Data,                                           &
       check = xy_AvrRad_xyz(xyz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  z_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='z_AvrLonLat_xyz with sin^2φ field',               &
       answer = z_Data,                                            &
       check = z_AvrLonLat_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='x_AvrLatRad_xyz with sin^2φ field',               &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = xyz_Data(1,:,1)
  call AssertEqual(&
       message='y_AvrLonRad_xyz with sin^2φ field',               &
       answer = y_Data,                                            &
       check = y_AvrLonRad_xyz(xyz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = 1.0D0/3D0
  call AssertEqual(&
       message='AvrLonLatRad_xyz with constant field',             &
       answer = Data,                                              &
       check = AvrLonLatRad_xyz(xyz_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )


 !============================ 平均(xy) =============================
  ! 定数
  xy_Data = 1.0D0

  y_Data = 1.0D0
  call AssertEqual(&
       message='y_AvrLon_xy with constant field',                  &
       answer = y_Data,                                            &
       check = y_AvrLon_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0
  call AssertEqual(&
       message='x_AvrLat_xy with constant field',                  &
       answer = x_Data,                                            &
       check = x_AvrLat_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLat_xy with constant field',                 &
       answer = 1.0D0,                                             &
       check = AvrLonLat_xy(xy_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  xy_Data = sin(xy_Lat)**2

  y_Data = xy_Data(1,:)
  call AssertEqual(&
       message='y_AvrLon_xy with sin(phi)**2',                     &
       answer = y_Data,                                            &
       check = y_AvrLon_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='x_AvrLat_xy with sin(phi)**2',                     &
       answer = x_Data,                                            &
       check = x_AvrLat_xy(xy_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLat_xy with sin(phi)**2',                    &
       answer = 1.0D0/3.0D0,                                       &
       check = AvrLonLat_xy(xy_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(yz) =============================
  ! 定数
  yz_Data = 1.0D0

  z_Data = 1.0D0
  call AssertEqual(&
       message='z_AvrLat_yz with constant field',                  &
       answer = z_Data,                                            &
       check = z_AvrLat_yz(yz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 1.0D0
  call AssertEqual(&
       message='y_AvrRad_yz with constant field',                  &
       answer = y_Data,                                            &
       check = y_AvrRad_yz(yz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLatRad_yz with constant field',                 &
       answer = 1.0D0,                                             &
       check = AvrLatRad_yz(yz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  yz_Data = xyz_Rad(0,:,:)**2

  z_Data = yz_Data(1,:)
  call AssertEqual(&
       message='z_AvrLat_yz with r^2',                             &
       answer = z_Data,                                            &
       check = z_AvrLat_yz(yz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = 3.0D0/5.0D0*(ro**5-ri**5)/(ro**3-ri**3)
  call AssertEqual(&
       message='y_AvrRad_yz with r^2',                             &
       answer = y_Data,                                            &
       check = y_AvrRad_yz(yz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLatRad_yz with r^2',                            &
       answer = 3.0D0/5.0D0*(ro**5-ri**5)/(ro**3-ri**3),           &
       check = AvrLatRad_yz(yz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  yz_Data = sin(xyz_Lat(0,:,:))**2

  z_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='z_AvrLat_yz with sin(phi)**2',                     &
       answer = z_Data,                                            &
       check = z_AvrLat_yz(yz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  y_Data = yz_Data(:,1)
  call AssertEqual(&
       message='y_AvrRad_yz with sin(phi)**2',                     &
       answer = y_Data,                                            &
       check = y_AvrRad_yz(yz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLatRad_yz with sin(phi)**2',                    &
       answer = 1.0D0/3.0D0,                                       &
       check = AvrLatRad_yz(yz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(xz) =============================
  ! 定数
  xz_Data = 1.0D0

  z_Data = 1.0D0
  call AssertEqual(&
       message='z_AvrLon_xz with constant field',                  &
       answer = z_Data,                                            &
       check = z_AvrLon_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0
  call AssertEqual(&
       message='x_AvrRad_xz with constant field',                  &
       answer = x_Data,                                            &
       check = x_AvrRad_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonRad_xz with constant field',                 &
       answer = 1.0D0,                                             &
       check = AvrLonRad_xz(xz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  xz_Data = spread(z_Rad**2,1,im)

  z_Data = z_Rad**2
  call AssertEqual(&
       message='z_AvrLon_xz with r^2',                             &
       answer = z_Data,                                            &
       check = z_AvrLon_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 3.0D0/5.0D0*(ro**5-ri**5)/(ro**3-ri**3)
  call AssertEqual(&
       message='x_AvrRad_xz with r^2',                             &
       answer = x_Data,                                            &
       check = x_AvrRad_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonRad_xz with r^2',                            &
       answer = 3.0D0/5.0D0*(ro**5-ri**5)/(ro**3-ri**3),           &
       check = AvrLonRad_xz(xz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(x) =============================
  ! 定数
  x_Data = 1.0D0

  call AssertEqual(&
       message='AvrLon_x with constant field',                     &
       answer = 1.0D0,                                             &
       check = AvrLon_x(x_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(y) =============================
  ! 定数
  y_Data = 1.0D0

  xz_Data = 1.0D0
  call AssertEqual(&
       message='AvrLat_y with constant field',                     &
       answer = 1.0D0,                                             &
       check = AvrLat_y(y_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  y_Data = sin(y_Lat)**2

  call AssertEqual(&
       message='AvrLat_y with sin(phi)**2',                        &
       answer = 1.0D0/3.0D0,                                       &
       check = AvrLat_y(y_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(z) =============================
  ! 定数
  z_Data = 1.0D0

  call AssertEqual(&
       message='AvrRad_r with constant field',                     &
       answer = 1.0D0,                                             &
       check = AvrRad_z(z_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  z_Data = z_Rad**2

  call AssertEqual(&
       message='AvrRad_r with r^2',                                &
       answer = 3.0D0/5.0D0*(ro**5-ri**5)/(ro**3-ri**3),           &
       check = AvrRad_z(z_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call MessageNotify('M','wt_module_integral_test', &
       'wt_module integration/averaging function tests succeeded!')

end program wt_module_integral_test

!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  eq_module テストプログラム (ヤコビアン計算)
!
!履歴  2008/04/13  竹広真一
!
program eq_test_jacobian

  use dc_message, only : MessageNotify
  use eq_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=16            ! 格子点の設定(Phi,Rad)
  integer, parameter :: km=10, lm=21            ! 切断波数の設定(Phi,Rad)

 !---- 変数 ----
  real(8)            :: rp_A(jm,0:im-1)        ! 格子データ
  real(8)            :: rp_B(jm,0:im-1)        ! 格子データ
  real(8)            :: rp_Jacob(jm,0:im-1)    ! 格子データ

  integer            :: k=3,l=2

 !---- 座標変数など ----
  real(8), parameter :: ra=2.0

  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: eps = 1.0d-8            ! 判定誤差

  call MessageNotify('M','eq_test_jacobian', &
       'eq_module jacobian function tests')

 !---------------- 座標値の設定 ---------------------
  call eq_Initial(im,jm,km,lm,ra)                ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
  write(6,*) '*** Test of eq_module : Jacobian function check.'
  write(6,*) '  The result will be printed '
  write(6,*) '  only when the error is larger than ', eps
  write(6,*)

!!$  write(6,*) '  Input wavenumbers of the grid data, k and l :'
!!$  read(5,*) k,l
  write(6,*) '  k,l = ', k,l

  rp_A = sin(k*rp_Phi)*rp_Rad**k
  rp_B = sin(k*rp_Phi)*rp_Rad**k
  rp_Jacob = 0.0

  call check2d(rp_eq(eq_Jacobian_eq_eq(eq_rp(rp_A),eq_rp(rp_B)))-rp_Jacob, &
       eps, 'Jacob(sin(k*Phi)*rp_Rad**k,sin(k*Phi)*rp_Rad**k)')

  rp_A = sin(k*rp_Phi)*rp_Rad**k
  rp_B = cos(k*rp_Phi)*rp_Rad**k
  rp_Jacob = -k**2 * rp_Rad**(2*k-2)

  call check2d(rp_eq(eq_Jacobian_eq_eq(eq_rp(rp_A),eq_rp(rp_B)))-rp_Jacob, &
       eps, 'Jacob(sin(k*Phi)*rp_Rad**k,cos(k*rp_Phi)*Rad**k')

  rp_A = cos(k*rp_Phi)*rp_Rad**(k+2)
  rp_B = rp_Rad**2
  rp_Jacob =  2 * k * sin(k*rp_Phi)*rp_Rad**(k+2)

  call check2d(rp_eq(eq_Jacobian_eq_eq(eq_rp(rp_A),eq_rp(rp_B)))-rp_Jacob, &
       eps, 'Jacob(cos(k*Phi)*Rad**(k+2),Rad**2))')

  rp_A = rp_Rad**4
  rp_B = sin(l*rp_Phi)*rp_Rad**l
  rp_Jacob = 4 * l * rp_Rad**(l+2) * cos(l*rp_Phi)

  call check2d(rp_eq(eq_Jacobian_eq_eq(eq_rp(rp_A),eq_rp(rp_B)))-rp_Jacob, &
       eps, 'Jacob(Rad**4,sin(l*Phi)*Rad**l)')

  call MessageNotify('M','eq_test_jacobian', &
       'eq_module jacobian function tests succeeded!')

 stop
contains

  subroutine check2d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:)                ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    integer i, j

    if ( present(funcname) )then
       write(6,*) '  Checking ', funcname, '...'
    endif

    do i=1,size(var,1)
       do j=1,size(var,2)
          if (abs(var(i,j)) .gt. eps ) then
             write(6,*) &
                  '    Value larger than EPS : i= ', i, '  j= ', j, var(i,j)
             call MessageNotify('E','eq_test_jacobian', &
                  'jacobian error too large')
          endif
       enddo
    enddo
  end subroutine check2d

end program eq_test_jacobian

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wtq_mpi_module_supack テストプログラム :: スペクトル関数のテスト
!
!履歴  2016/04/04  竹広真一 
!
program wtq_mpi_module_supack_spectrum_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wtq_mpi_module_supack
  use mpi
  implicit none

  integer,parameter  :: im=32, jm=16         ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: kmo=16, kmi=10       ! 格子点の設定(球殻動径, 球動径)
  integer,parameter  :: nm=10                ! 切断波数の設定(水平)
  integer,parameter  :: lmo=10, lmi=16       ! 切断波数の設定(球殻動径, 球動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径
 
  real(8), allocatable ::  xvz_Torvel(:,:,:)
  real(8), allocatable ::  wt_Torvel(:,:)

  real(8), allocatable ::  xvz_Polvel(:,:,:)
  real(8), allocatable ::  wt_Polvel(:,:)

  real(8), allocatable ::  xvz_Vlon(:,:,:)
  real(8), allocatable ::  xvz_Vlat(:,:,:)
  real(8), allocatable ::  xvz_Vrad(:,:,:)

  real(8), dimension(0:nm,-nm:nm,0:kmo) ::  nmz_EkTor
  real(8), dimension(0:nm,-nm:nm,0:kmo) ::  nmz_EkPol
  real(8), dimension(0:nm,0:kmo)        ::  nz_EkTor
  real(8), dimension(0:nm,0:kmo)        ::  nz_EkPol

  real(8), dimension(0:kmo)             ::  z_Data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: PI
  integer :: n,m
  integer :: iproc, np, ierr

  PI = 4.0D0*Atan(1.0D0)

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call wtq_mpi_Initial(im,jm,kmi,kmo,nm,lmi,lmo,ri,ro)
 
  call MessageNotify('M','wtq_mpi_module_supack_spectrum_test',&
                         'wtq_mpi_module_supack spectrum functions tests.') 


  allocate(xvz_Torvel(0:im-1,jc,0:kmo))
  allocate(wt_Torvel(nc,0:lmo))

  allocate(xvz_Polvel(0:im-1,jc,0:kmo))
  allocate(wt_Polvel(nc,0:lmo))

  allocate(xvz_Vlon(0:im-1,jc,0:kmo))
  allocate(xvz_Vlat(0:im-1,jc,0:kmo))
  allocate(xvz_Vrad(0:im-1,jc,0:kmo))


  ! (2Y_1^0+3Y_2^1) * r
  xvz_Torvel =( 2*sqrt(3.0D0)*sin(xvz_Lat) &
              + 3*sqrt(5.0D0/6)*3.0*sin(xvz_Lat)*cos(xvz_Lat) * cos(xvz_Lon) )&
              * xvz_Rad

  ! (3*Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2) * r^2
  xvz_Polvel =( 3*sqrt(3.0D0)*sin(xvz_Lat) & 
                + 2* sqrt(3.0D0/2)*cos(xvz_Lat)*cos(xvz_Lon) &
                + 2*sqrt(5.0D0)*(3.0/2*sin(xvz_Lat)**2-1/2.0) &
                - sqrt(5.0D0/24)*3.0*cos(xvz_Lat)**2*sin(2*xvz_Lon) ) &
              * xvz_Rad**2

  wt_Torvel = wt_xvz(xvz_Torvel)
  wt_Polvel = wt_xvz(xvz_Polvel)

  !--------- Energy spectrum ---------
  nmz_EkTor=wt_VMiss
  nmz_EkPol=wt_VMiss

  do n=0,nm
     do m=-n,n
        nmz_EkTor(n,m,:) = 0.0D0
        nmz_EkPol(n,m,:) = 0.0D0
     enddo
  enddo

  nmz_EkTor(1,0,:) = 4.0D0 * z_Rad**2 * (4*pi)*z_Rad**2
  nmz_EkTor(2,1,:) = 2*3*(3.0D0/2)**2/2 * z_Rad**2 * (4*pi)*z_Rad**2 
  nmz_EkTor(2,-1,:)= nmz_EkTor(2,1,:)

  nmz_EkPol(1,0,:) = 9.0D0 * (9*z_Rad**4 + 2.0D0*z_Rad**4) * (4*pi)
  nmz_EkPol(1,1,:) = 1*2*(2/2)**2/2 &
       * (9*z_Rad**4 + 1*2* z_Rad**4) * (4*pi)
  nmz_EkPol(1,-1,:)= nmz_EkPol(1,1,:)
  nmz_EkPol(2,0,:) = 12.0D0 *(9*z_Rad**4 + 6.0D0*z_Rad**4) * (4*pi)
  nmz_EkPol(2,-2,:)= 2*3*(1.0D0/2)**2/2 &
       *(9*z_Rad**4 + 2*3* z_Rad**4 ) * (4*pi)
  nmz_EkPol(2,2,:) = nmz_EkPol(2,-2,:)

  call AssertEqual(&
    message='nmz_ToroidalEnergySpectrum_wt',                      &
    answer = nmz_ToroidalEnergySpectrum_wt(wt_Torvel),            &
    check =  nmz_EkTor,                                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='nmz_PoloidalEnergySpectrum_wt',                      &
    answer = nmz_PoloidalEnergySpectrum_wt(wt_Polvel),            &
    check =  nmz_EkPol,                                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nz_EkTor = 0.0D0
  nz_EkTor(1,:) = 4.0D0 * z_Rad**2 * (4*pi)*z_Rad**2 
  nz_EkTor(2,:) = 2 * 3 *(3.0D0/2)**2 * z_Rad**2 * (4*pi)*z_Rad**2 

  nz_EkPol = 0.0D0
  nz_EkPol(1,:) = (9.0D0+1*2*(2/2)**2/2*2 )*(9*z_Rad**4+2*z_Rad**4)*(4*pi)
  nz_EkPol(2,:) = (12.0D0+2*3*(1.0D0/2)**2)*(9*z_Rad**4+2*3*z_Rad**4)*(4*pi)

  call AssertEqual(&
    message='nz_ToroidalEnergySpectrum_wt',                       &
    answer = nz_ToroidalEnergySpectrum_wt(wt_Torvel),             &
    check =  nz_EkTor,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='nz_PoloidalEnergySpectrum_wt',                       &
    answer = nz_PoloidalEnergySpectrum_wt(wt_Polvel),             &
    check =  nz_EkPol,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call wt_Potential2VectorMPI(xvz_Vlon,xvz_Vlat,xvz_Vrad,wt_Torvel,wt_Polvel)

  nmz_EkTor = nmz_ToroidalEnergySpectrum_wt(wt_Torvel)
  nmz_EkPol = nmz_PoloidalEnergySpectrum_wt(wt_Polvel)

  z_Data = 0.0D0
  do n=0,nm
     do m=-n,n
        z_Data = z_Data + nmz_EkTor(n,m,:) + nmz_EkPol(n,m,:)
     enddo
  enddo

  call AssertEqual(&
    message='Total energy by nmz-spectrum',                        &
    answer = IntLonLatRad_xvz(xvz_VLon**2+xvz_VLat**2+xvz_VRad**2)/2.0D0, &
    check =  IntRad_z(z_Data/z_Rad**2),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nz_EkTor = nz_ToroidalEnergySpectrum_wt(wt_Torvel)
  nz_EkPol = nz_PoloidalEnergySpectrum_wt(wt_Polvel)

  call AssertEqual(&
    message='Total energy by nz-spectrum',                        &
    answer = IntLonLatRad_xvz(xvz_VLon**2+xvz_VLat**2+xvz_VRad**2)/2.0D0, &
    check =   IntRad_z(sum(nz_EkTor,1)/z_Rad**2) &
            + IntRad_z(sum(nz_EkPol,1)/z_Rad**2), &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wtq_mpi_module_supack_spectrum_test',&
                         'wtq_mpi_module_supack spectrum functions tests suceeded!') 

  CALL MPI_FINALIZE(IERR)

end program wtq_mpi_module_supack_spectrum_test

!----------------------------------------------------------------------
!     Copyright (c) 2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_galerkin_DN_test1d
!
!      チェビシェフ−ガラーキン法
!      片端ディリクレ片端ノイマン境界条件用モジュールテストプログラム(1次元)
!          f(i=0)=f'(i=im)=0 [ f(x=xmax)=f'(x=xmin)=0 ]
!
!      例 : f(x) = (x-xmin)**2 * (xmax-x)
!
!履歴  2005/12/30  竹広真一  新規作成
!      2006/01/23  竹広真一  モジュール名変更に伴う改訂
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!
program at_ap_galerkin_DN_test1d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_ap_galerkin_DN
  use at_module

  implicit none

  integer, parameter :: im=8, km=4
  real(8), parameter :: xmin=0.0D0, xmax=1.0D0

  real(8) :: g_data(0:im)
  real(8) :: g_data_orig(0:im)
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = - 10

  call MessageNotify('M','at_ap_galerkin_DN_test1d', &
    & '1D Dirichlt-Neumman B.C.')

  call at_Initial(im,km,xmin,xmax)
  call at_ap_galerkin_DN_Initial(im,km) 

  g_data = (g_X-xmin)**2*(xmax-g_X)
  g_data_orig = g_data
  g_data = g_p(p_t(t_g(g_data)))

  call AssertEqual(&
    & message = 'Grid -> Galerkin -> Grid ',                    &
    & answer  = g_data_orig,                                    &
    & check   = g_data,                                         &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call MessageNotify('M','at_ap_galerkin_DN_test1d', &
    & '1D Dirichlt-Neumman B.C. succeeded')

end program at_ap_galerkin_DN_test1d

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wa_integrale_module_supack テストプログラム :: 積分・平均関数のテスト
!
!履歴  2016/03/16  竹広真一
!
program wa_integral_mpi_module_supack_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wa_mpi_module_supack
  use mpi
  implicit none

  integer, parameter :: im=128, jm=64, nm=42, km=2

  real(8), dimension(0:im-1,jm,km) ::  xya_data            ! 元の関数
  real(8), dimension(im,km)        ::  xa_idata            ! 積分・平均の正解
  real(8), dimension(jm,km)        ::  ya_idata            ! 積分・平均の正解
  real(8), dimension(km)           ::  a_idata             ! 積分・平均の正解
  real(8), allocatable             ::  xva_data(:,:,:)     ! 元の関数
  real(8), allocatable             ::  va_idata(:,:)       ! 積分・平均の正解

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: pi
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','wa_integral_mpi_module_supack_test', &
                         'wa_integral_mpi_module_supack function tests') 

  call wa_mpi_Initial( nm, im, jm, km )

  allocate(xva_data(0:im-1,jc,km))
  allocate(va_idata(jc,km))

  !---- 積分のテスト(分割領域) ----
  xva_data(:,:,1) = sin(xv_Lat)**2*(1-cos(xv_Lon)**2)
  xva_data(:,:,2) = sin(xv_Lat)**4*(1-sin(xv_Lon)**2)

  a_idata(1) = 2*pi/3       ! a_IntLonLat_xva
  a_idata(2) = 2*pi/5       ! a_IntLonLat_xva
  call AssertEqual(&
    message='a_IntLonLat_xva',                                    &
    answer = a_IntLonLat_xva(xva_data),                           &
    check =  a_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  va_idata(:,1) = pi*sin(v_Lat)**2       ! v_IntLon_xva
  va_idata(:,2) = pi*sin(v_Lat)**4       ! v_IntLon_xva
  call AssertEqual(&
    message='va_IntLon_xva',                                      &
    answer = va_IntLon_xva(xva_data),                             &
    check =  va_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='a_IntLat_va',                                        &
    answer = a_IntLat_va(va_idata),                               &
    check =  a_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xa_idata(:,1) = 2.0D0/3*(1-cos(x_Lon)**2)       ! x_IntLat_xva
  xa_idata(:,2) = 2.0D0/5*(1-sin(x_Lon)**2)       ! x_IntLat_xva

  call AssertEqual(&
    message='xa_IntLat_xva',                                      &
    answer = xa_IntLat_xva(xva_data),                             &
    check =  xa_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='a_IntLon_xa',                                        &
    answer = a_IntLon_xa(xa_idata),                               &
    check =  a_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 平均のテスト(分割領域) ----
  xva_data(:,:,1) = sin(xv_Lat)**2*(1-cos(xv_Lon)**2)
  xva_data(:,:,2) = sin(xv_Lat)**4*(1-sin(xv_Lon)**2)

  a_idata(1) = 1.0D0/6       ! AvrLonLat_xva
  a_idata(2) = 1.0D0/10      ! AvrLonLat_xva
  call AssertEqual(&
    message='a_AvrLonLat_xva',                                    &
    answer = a_AvrLonLat_xva(xva_data),                           &
    check =  a_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  va_idata(:,1) = 0.5*sin(v_Lat)**2       ! v_AvrLon_xva
  va_idata(:,2) = 0.5*sin(v_Lat)**4       ! v_AvrLon_xva
  call AssertEqual(&
    message='va_AvrLon_xva',                                      &
    answer = va_AvrLon_xva(xva_data),                             &
    check =  va_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='a_AvrLat_va',                                        &
    answer = a_AvrLat_va(va_idata),                               &
    check =  a_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xa_idata(:,1) = 1.0D0/3*(1-cos(x_Lon)**2)       ! x_AvrLat_xva
  xa_idata(:,2) = 1.0D0/5*(1-sin(x_Lon)**2)       ! x_AvrLat_xva

  call AssertEqual(&
    message='xa_AvrLat_xva',                                      &
    answer = xa_AvrLat_xva(xva_data),                             &
    check =  xa_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='a_AvrLon_xa',                                        &
    answer = a_AvrLon_xa(xa_idata),                               &
    check =  a_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  call MessageNotify('M','wa_integral_mpi_module_supack_test', &
       'wa_integral_mpi_module_supack function tests succeded!') 

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wa_integral_mpi_module_supack_test

!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_module テストプログラム
!      Laplacian 逆解き問題
!
!履歴  2008/04/12  竹広真一
!      
!
program eq_test_LaplaInv

  use dc_message, only : MessageNotify
  use eq_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=16, jm=16              ! 格子点の設定(X,Y)
  integer, parameter :: km=5, lm=21             ! 切断波数の設定(X,Y)

 !---- 座標変数など ----
  real(8), parameter :: ra=1.5

  real(8), parameter :: eps = 1.0d-10         ! 判定誤差

  real(8)            :: rp_A(jm,0:im-1)       ! 格子データ
  real(8)            :: rp_A_sol(jm,0:im-1)   ! 格子データ
  real(8)            :: eq_A(-km:km,0:lm)     ! スペクトルデータ

  real(8), dimension(-km:km) :: value         ! 境界条件

  integer,parameter  :: k=2, l=k+2

  call MessageNotify('M','eq_test_LaplaInv', &
       'eq_module subroutine for Inverse Laplacian tests')

 !---------------- 座標値の設定 ---------------------
  call eq_Initial(im,jm,km,lm,ra)                ! スペクトル初期化

 !----- eq_LaplaInv_eq ------
  rp_A = sin(k*rp_Phi) * rp_Rad**l 
  rp_A_sol = sin(k*rp_Phi) * rp_Rad**(l+2)/((l+2)**2 - k**2)

  value = e_p(rp_A_sol(jm,:))

  eq_A = eq_rp(rp_A)
  rp_A = rp_eq(eq_LaplaInv_eq(eq_A,value))

  call check2d(rp_A-rp_A_sol, eps, 'LaplaInv(sin(k*Phi)*Rad**(l+2)')

  call MessageNotify('M','Test of eq_LaplaInv','Test of eq_LaplaInv suceeded!')

 stop
contains

  subroutine check2d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:)                ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    integer i, j

    if ( present(funcname) )then
       write(6,*) '  Checking ', funcname, '...'
    endif

    do i=1,size(var,1)
       do j=1,size(var,2)
          if (abs(var(i,j)) .gt. eps ) then
             write(6,*) &
                  '    Value larger than EPS : i= ', i, '  j= ', j, var(i,j)
             call MessageNotify('E','ee_test_LaplaInv', &
                  'Inverse Laplacian error too large')
          endif
       enddo
    enddo
  end subroutine check2d

end program eq_test_LaplaInv

!--
!----------------------------------------------------------------------
!     Copyright (c) 2007 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  au_module
!
!      spml/au_module モジュールは 1 次元有限領域の下での流体運動を
!      2 次の引数のシフトされたチェビシェフ関数 T_k(2r^2-1)で展開する
!      スペクトル数値計算ための Fortran90 関数を提供する. 
!      このルーチンは離散化にチェビシェフ--ガウス--ラダウ格子点を適用
!      しており, 主に 2 次元極座標,  円筒座標, 球座標の原点の
!      特異性を回避しながらスペクトル計算を行うために用いることを
!      念頭においている. 
!
!      2 次元データの 1 次元に関して同時にスペクトル計算を実行するための
!      関数も提供しており, 2, 3 次元領域での計算のベースも提供する. 
!
!
!履歴  2007/12/27  竹広真一  新規作成
!      2008/01/10  竹広真一  コメント修正
!      2009/01/09  竹広真一  au_Initial メッセージに日付を追加
!      2009/01/29  佐々木洋平 コメントをRDoc用に修正
!
!++
module au_module
  !
  != au_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/au_module モジュールは 1 次元有限領域の下での流体運動を
  ! 2 次の引数のシフトされたチェビシェフ関数 T_k(2r^2/a^2-1)で
  ! 展開するスペクトル数値計算ための Fortran90 関数を提供する. 
  ! このルーチンは離散化にチェビシェフ--ガウス--ラダウ格子点を適用
  ! しており, 主に 2 次元極座標,  円筒座標, 球座標の原点の
  ! 特異性を回避しながらスペクトル計算を行うために用いることを
  ! 念頭においている. 
  !
  ! 2 次元データの 1 次元に関して同時にスペクトル計算を実行するための
  ! 関数も提供しており, 2, 3 次元領域での計算のベースも提供する. 
  !
  ! 具体的な展開の仕方は
  !
  !         f(r)=Σf_k r^n T_k(2r^2/a^2-1)
  !
  ! である. 1 次元チェビシェフデータが複数並んだ 2 次元データを
  ! 扱う際には重みの指数 n を各データ毎に設定できる. 
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (u_, g_, au_, ag_) は, 返す値の形を示している.
  !   u_  :: チェビシェフデータ
  !   g_  :: 1 次元格子点データ
  !   au_ :: 1 次元チェビシェフデータが複数並んだ 2 次元データ
  !   ag_ :: 1 次元格子点データが複数並んだ 2 次元データ.
  !
  !   複数並んだ 2 次元データの第 1 次元の大きさは au_Initial で
  !   設定する重みの指数の配列 nd の大きさと同じでなければならない.
  !
  ! * 関数名の間の文字列(Dr)は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_e,_au,_g, _ag) は, 入力変数の形がチェビシェフデータ
  !   および格子点データであることを示している.
  !    _u  :: チェビシェフデータ
  !    _g  :: 1 次元格子点データ
  !    _au :: 1 次元チェビシェフデータが複数並んだ 2 次元データ
  !    _ag :: 1 次元格子点データが複数並んだ 2 次元データ
  !
  !=== 各データの種類の説明
  !
  ! * g : 1 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(0:im). 
  !   * im は R 座標の格子点数であり, サブルーチン au_Initial にて
  !     あらかじめ設定しておく.
  !
  ! * u : チェビシェフデータ.
  !   * 変数の種類と次元は real(8), dimension(0:km). 
  !     km は R 方向の最大波数であり, サブルーチン au_Initial にて
  !     あらかじめ設定しておく. スペクトルデータの格納のされ方については...
  !
  ! * ag : 1 次元(R)格子点データの並んだ 2 次元データ.
  !   * 変数の種類と次元は real(8), dimension(size(nd),0:im). 
  !     第 2 次元が R 方向を表す.
  !
  ! * au : 1 次元チェビシェフデータの並んだ 2 次元データ.
  !   * 変数の種類と次元は real(8), dimension(size(nd),0:km). 
  !     第 2 次元がスペクトルを表す.
  !
  ! * g_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * u_ で始まる関数が返す値はチェビシェフデータに同じ.
  !
  ! * ag_ で始まる関数が返す値は 1 次元格子点データの並んだ 
  !   2 次元データに同じ.
  !
  ! * au_ で始まる関数が返す値は 1 次元チェビシェフデータの並んだ
  !   2 次元データに同じ.
  !
  ! * チェビシェフデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをチェビシェフ変換したもののことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! au_Initial  :: チェビシェフ変換の格子点数, 波数, 領域の大きさの設定
  ! 
  !==== 座標変数
  !
  ! g_R        :: 格子点座標(R)を格納した 1 次元配列
  ! g_R_Weight :: 重み座標を格納した 1 次元配列
  !
  !==== 基本変換
  !
  ! g_u, ag_au :: チェビシェフデータから格子データへの変換
  ! u_g, au_ag :: 格子データからチェビシェフデータへの変換
  !
  !==== 微分
  !
  ! g_Dr_u, ag_Dr_au   :: チェビシェフデータに R 微分を作用させる
  ! g_Dr2_u, ag_Dr2_au :: チェビシェフデータに 2 階 R 微分を作用させる
  !
  !==== 積分・平均
  !
  ! a_Int_ag, a_Avr_ag :: 1 次元格子点データの並んだ 2 次元配列の積分および平均
  ! Int_g, Avr_g       :: 1 次元格子点データの積分および平均
  !
  !==== 境界値問題
  !
  ! au_Boundary_D, au_Boundary_N         :: ディリクレ,ノイマン外側境界条件
  ! au_BoundaryTau_D, au_BoundaryTau_N   :: ディリクレ,ノイマン外側境界条件
  ! au_BoundaryGrid_D, au_BoundaryGrid_N :: ディリクレ,ノイマン外側境界条件
  !
  use dc_message
  use lumatrix
  implicit none
  private
  public g_R, g_R_Weight                        ! 座標変数
  public au_Initial                             ! 初期化
  public ag_au, au_ag, g_u, u_g                 ! 基本変換
  public ag_Dr_au, g_Dr_u                       ! 微分
  public ag_Dr2_au, g_Dr2_u                     ! 微分
  public a_Int_ag, Int_g, a_Avr_ag, Avr_g       ! 積分・平均
  public au_Boundary_D, au_Boundary_N           ! 境界条件
  public au_BoundaryTau_D, au_BoundaryTau_N     ! 境界条件
  public au_BoundaryGrid_D, au_BoundaryGrid_N   ! 境界条件

  interface au_Boundary_D
     !
     ! 外側境界ディリクレ型境界条件の適用(タウ法). 
     !
     !  * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !    使い分けている. ユーザーインターフェースは共通であるので
     !    下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     !  * 1 次元チェビシェフデータの並んだ 2 次元配列の場合
     !
     !    real(8), dimension(size(nd),0:km),intent(inout)    :: au_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(size(nd)), intent(in), optional :: value
     !    !(in) 適用する境界値
     !
     !  * 1 次元チェビシェフデータの場合
     !
     !    real(8), dimension(0:km),intent(inout)       :: u_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), intent(in), optional                :: value
     !    !(in) 適用する境界値
     !
     module procedure au_BoundaryTau_D_1d, au_BoundaryTau_D_2d
  end interface

  interface au_Boundary_N
     !
     ! 外側ノイマン型境界条件の適用(タウ法).
     ! i=0 で勾配の値を与える.
     !
     !  * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !    使い分けている. ユーザーインターフェースは共通であるので
     !    下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     !  * 1 次元チェビシェフデータの並んだ 2 次元配列の場合
     !
     !    real(8), dimension(:,0:km),intent(inout)       :: au_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(size(at_data,1)), intent(in), optional :: value
     !    !(in) 適用する境界値
     !
     !  * 1 次元チェビシェフデータの場合
     !
     !    real(8), dimension(0:km),intent(inout)       :: t_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), intent(in), optional                 :: value
     !    !(in) 適用する境界値
     !
     module procedure au_BoundaryTau_N_1d, au_BoundaryTau_N_2d
  end interface

  interface au_BoundaryTau_D
     !
     ! 外側境界ディリクレ型境界条件の適用(タウ法). 
     !
     !  * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !    使い分けている. ユーザーインターフェースは共通であるので
     !    下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     !  * 1 次元チェビシェフデータの並んだ 2 次元配列の場合
     !
     !    real(8), dimension(size(nd),0:km),intent(inout)    :: au_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(size(nd)), intent(in), optional :: value
     !    !(in) 適用する境界値
     !
     !  * 1 次元チェビシェフデータの場合
     !
     !    real(8), dimension(0:km),intent(inout)       :: u_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), intent(in), optional                :: value
     !    !(in) 適用する境界値
     !
     module procedure au_BoundaryTau_D_1d, au_BoundaryTau_D_2d
  end interface

  interface au_BoundaryTau_N
     !
     ! 外側ノイマン型境界条件の適用(タウ法).
     ! i=0 で勾配の値を与える.
     !
     !  * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !    使い分けている. ユーザーインターフェースは共通であるので
     !    下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     !  * 1 次元チェビシェフデータの並んだ 2 次元配列の場合
     !
     !    real(8), dimension(size(nd),0:km),intent(inout)    :: au_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(size(nd)), intent(in), optional :: value
     !    !(in) 適用する境界値
     !
     !  * 1 次元チェビシェフデータの場合
     !
     !    real(8), dimension(0:km),intent(inout)       :: t_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), intent(in), optional                 :: value
     !    !(in) 適用する境界値
     !
     module procedure au_BoundaryTau_N_1d, au_BoundaryTau_N_2d
  end interface

  interface au_BoundaryGrid_D
     !
     ! 外側ディリクレ型境界条件の適用(実空間での評価).
     ! 外側境界(i=0)での値を与える.
     !
     !  * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !    使い分けている. ユーザーインターフェースは共通であるので
     !    下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     !  * 1 次元チェビシェフデータの並んだ 2 次元配列の場合
     !
     !    real(8), dimension(size(nd),0:km),intent(inout)    :: au_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(size(nd)), intent(in), optional :: value
     !    !(in) 適用する境界値
     !
     !  * 1 次元チェビシェフデータの場合
     !
     !    real(8), dimension(0:km),intent(inout)       :: u_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), intent(in), optional                 :: value
     !    !(in) 適用する境界値
     !
     module procedure au_BoundaryGrid_D_1d, au_BoundaryGrid_D_2d
  end interface

  interface au_BoundaryGrid_N
     !
     ! 外側境界ノイマン型境界条件の適用(実空間での評価).
     ! i=0 で勾配の値を与える.
     !
     !  * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !    使い分けている. ユーザーインターフェースは共通であるので
     !    下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     !  * 1 次元チェビシェフデータの並んだ 2 次元配列の場合
     !
     !    real(8), dimension(size(nd),0:km),intent(inout)    :: au_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(size(nd)), intent(in), optional :: value
     !    !(in) 適用する境界値
     !
     !  * 1 次元チェビシェフデータの場合
     !
     !    real(8), dimension(0:km),intent(inout)       :: u_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), intent(in), optional                :: value
     !    !(in) 適用する境界値
     !
     module procedure au_BoundaryGrid_N_1d, au_BoundaryGrid_N_2d
  end interface

  real(8), parameter                 :: pi=3.1415926535897932385D0

  integer :: im, km                        ! 格子点数, 切断波数
  real(8) :: ra                            ! 領域の大きさ

  integer, allocatable :: nd(:)
  ! r^n の指数

  real(8), allocatable :: g_R(:)
  ! 格子点座標
  ! Chebyshev-Gauss-Radau 格子点

  real(8), allocatable :: g_R_Weight(:)
  ! 格子点重み座標
  ! 各格子点における積分のための重みが格納してある

  real(8), allocatable :: CF(:,:), CB(:,:)   ! 正変換・逆変換用行列

  save :: im, km, ra, CF, CB, g_R, g_R_Weight, nd

contains

! ---- 初期化 ---- 
  subroutine au_Initial(i_in,k_in,r_in,nd_in)
    !
    ! チェビシェフ変換の格子点数, 波数, 領域の大きさ, 重みを設定する.
    ! 
    ! 他の関数や変数を呼ぶ前に, 最初にこのサブルーチンを呼んで
    ! 初期設定をしなければならない.
    !
    integer,intent(in) :: i_in              !(in) 格子点数
    integer,intent(in) :: k_in              !(in) 切断波数
    real(8),intent(in) :: r_in              !(in) 外側境界の座標(半径)
    integer,intent(in) :: nd_in(:)          !(in) 重み r^n の指数

    real(8), allocatable :: c(:), w(:)   ! 重み関数
    real(8) :: t
    integer :: ii,kk

    im=i_in ; km=k_in ; ra = r_in

    if ( km .gt. im ) then
       call MessageNotify('E','au_initial','KM shoud be less equal to IM')
    endif

    if ( allocated(nd) ) deallocate(nd)
    allocate(nd(size(nd_in)))
    nd = nd_in

    if ( allocated(CF) ) deallocate(CF)
    if ( allocated(CB) ) deallocate(CB)
    allocate(CF(0:im,0:im),CB(0:im,0:im))

    if ( allocated(C) ) deallocate(W)
    if ( allocated(W) ) deallocate(W)
    allocate(c(0:im),w(0:im))

    c = 1.0D0 ; c(0) = 2.0D0
    w = 2*pi/(2*im+1) ; w(0) = pi/(2*im+1)

    do ii=0,im
       do kk=0,im
          CF(kk,ii)=2.0D0/(pi*c(kk))*cos(2*pi*ii*kk/(2*im+1))*w(ii)
       enddo
    enddo

    do kk=0,im
       do ii=0,im
          CB(ii,kk)=cos(2*pi*ii*kk/(2*im+1))
       enddo
    enddo

    if ( allocated(g_R) ) deallocate(g_R)
    allocate(g_R(0:im))

    do ii=0,im
       t = 2*pi*ii/(2*im+1)
       g_R(ii) = ra*sqrt((1+cos(t))/2)    ! cos(t) = 2(r/a)^2 - 1
    enddo

    if ( allocated(g_R_Weight) ) deallocate(g_R_Weight)
    allocate(g_R_Weight(0:im))
    do ii=0,im
       g_R_Weight(ii) = 0.0
       do kk=0,km
          g_R_Weight(ii) = g_R_Weight(ii) &
               + 1.0D0/(1.0D0/4.0D0-kk**2) &
               * cos(2*kk*ii*pi/(2*im+1))/c(kk)
       enddo
       g_R_Weight(ii) = ra/(2*pi) * g_R_Weight(ii)* w(ii)
    enddo

    deallocate(c,w)

    call MessageNotify('M','au_initial','au_module (2009/01/09) is initialized')
  end subroutine au_Initial

! ---- 逆変換 ---- 
  function ag_au(au_data)
    !
    ! チェビシェフデータから格子データへ変換する(2 次元配列用).
    !
    double precision, dimension(:,:), intent(in)       :: au_data
    !(in) チェビシェフデータ

    double precision, dimension(size(au_data,1),0:im)  :: ag_au
    !(out) 格子点データ

    double precision, dimension(size(au_data,1),0:im)  :: au_work
    ! 作業用配列

    integer :: m, mm, i

    mm = size(au_data,1)
    if ( mm /= size(nd) ) then
       call MessageNotify('E','ag_au', &
            '1st dim. of the Chebyshev data should be same as dim. of ND.')
    end if

    if ( size(au_data,2)-1 < km ) then
       call MessageNotify('E','ag_au', &
            'The Chebyshev dimension of input data too small.')
    elseif ( size(au_data,2)-1 > km ) then
       call MessageNotify('W','ag_au', &
            'The Chebyshev dimension of input data too large.')
    endif

    au_work = 0.0 ; au_work(:,0:km) = au_data
    do m=1,mm
       do i=0,im
          ag_au(m,i) = sum(CB(i,:)*au_work(m,:))*g_R(i)**nd(m)
       enddo
    enddo

  end function ag_au

  function g_u(u_data)
    !
    ! チェビシェフデータから格子データへ変換する(1 次元配列用).
    !
    double precision, dimension(:), intent(in)  :: u_data
    !(in) チェビシェフデータ

    double precision, dimension(0:im)           :: g_u
    !(out) 格子点データ

    double precision, dimension(1,size(u_data)) :: u_work
    ! 作業用配列
    double precision, dimension(1,0:im)         :: g_work
    ! 作業用配列

    u_work(1,:) = u_data  
    g_work = ag_au(u_work)
    g_u = g_work(1,:)

  end function g_u

! ---- 正変換 ---- 
  function au_ag(ag_data)
    !
    ! 格子データからチェビシェフデータへ変換する(2 次元配列用).
    !
    double precision, dimension(:,:), intent(in)      :: ag_data
    !(in) 格子点データ

    double precision, dimension(size(ag_data,1),0:km) :: au_ag
    !(out) チェビシェフデータ

    double precision, dimension(size(ag_data,1),0:im) :: au_work
    !作業用配列

    integer :: m, mm, k

    mm = size(ag_data,1)
    if ( mm /= size(nd) ) then
       call MessageNotify('E','ag_au', &
            '1st dim. of the Chebyshev data should be same as dim. of ND.')
    end if

    if ( size(ag_data,2)-1 < im ) then
       call MessageNotify('E','au_ag', &
            'The Grid points of input data too small.')
    elseif ( size(ag_data,2)-1 > im ) then
       call MessageNotify('W','au_ag', &
            'The Grid points of input data too large.')
    endif

    do m=1,mm
       do k=0,im
          au_work(m,k) = sum(CF(k,:)*ag_data(m,:)/g_R**nd(m))
       enddo
    enddo
    au_ag = au_work(:,0:km)

  end function au_ag

  function u_g(g_data)  ! 格子 -> スペクトル
    !
    ! 格子データからチェビシェフデータへ変換する(1 次元配列用).
    !
    double precision, dimension(:), intent(in)     :: g_data
    !(in) 格子点データ

    double precision, dimension(0:km)              :: u_g
    !(out) チェビシェフデータ

    real(8), dimension(1,size(g_data)) :: ag_work
    real(8), dimension(1,0:km)         :: au_work

    ag_work(1,:) = g_data
    au_work = au_ag(ag_work)
    u_g = au_work(1,:)
    
  end function u_g

! ---- 微分計算 ---- 
  function au_Dx_au(au_data)
    !
    ! 入力チェビシェフデータ f_k T_k(x) に対して x 微分のチェビシェフ係数
    ! g_k T_k(x) = f_k T_k'(x) を計算する(2 次元配列用).
    !
    real(8), dimension(:,0:), intent(in)     :: au_data
    !(in) 入力チェビシェフデータ

    real(8), dimension(size(au_data,1),0:size(au_data,2)-1) :: au_Dx_au
    !(in) 出力チェビシェフデータ

    integer :: m, k
    integer :: nm, kmax

    nm=size(au_data,1)
    kmax=size(au_data,2)-1
    if ( kmax  < km ) then
       call MessageNotify('W','au_Dx_au', &
            'The Chebyshev dimension of input data too small.')
    elseif ( kmax > km ) then
       call MessageNotify('E','au_Dx_au', &
            'The Chebyshev dimension of input data too large.')
    endif

    do m=1,nm
       au_Dx_au(m,kmax)   = 0. 
       au_Dx_au(m,kmax-1) = 2 * kmax * au_data(m,kmax) 
    enddo

    do k=kmax-2,1,-1
       do m=1,nm
          au_Dx_au(m,k) = au_Dx_au(m,k+2) + 2*(k+1)*au_data(m,k+1)
       enddo
    enddo

    do m=1,nm
       au_Dx_au(m,0) = (au_Dx_au(m,2) + 2*au_data(m,1))/2.0D0
    enddo

  end function au_Dx_au

  function ag_Dr_au(au_data)
    !
    ! 入力チェビシェフデータに R 微分を作用する(2 次元配列用).
    !
    ! チェビシェフデータの R 微分とは, 対応する格子点データに R 微分を
    ! 作用させたデータのチェビシェフ変換のことである.
    !
    !
    real(8), dimension(:,0:), intent(in)     :: au_data
    !(in) 入力チェビシェフデータ

    real(8), dimension(size(au_data,1),0:im) :: ag_Dr_au
    !(out) チェビシェフデータの R 微分

    integer :: nm

    nm=size(au_data,1)

    ag_Dr_au = ag_au(au_Dx_au(au_data)) * 4*spread(g_R,1,nm)/ra**2&
             + spread(nd,2,im+1)/spread(g_R,1,nm) * ag_au(au_data)
  end function ag_Dr_au

  function g_Dr_u(u_data)
    !
    ! 入力チェビシェフデータに R 微分を作用する(1 次元配列用).
    !
    ! チェビシェフデータの R 微分とは, 対応する格子点データに R 微分を
    ! 作用させたデータのチェビシェフ変換のことである.
    !
    !
    real(8), dimension(:), intent(in)   :: u_data
    !(in) 入力チェビシェフデータ

    real(8), dimension(0:im)            :: g_Dr_u
    !(out) チェビシェフデータの R 微分

    real(8), dimension(1,size(u_data))  :: au_work
    ! 作業用配列

    real(8), dimension(1,0:im)          :: ag_work
    ! 作業用配列
    
    au_work(1,:) = u_data
    ag_work = ag_Dr_au(au_work)
    g_Dr_u = ag_work(1,:)

  end function g_Dr_u

  function ag_Dr2_au(au_data)
    !
    ! 入力チェビシェフデータに 2 階 R 微分を作用する(2 次元配列用).
    !
    ! チェビシェフデータの 2 階 R 微分とは, 対応する格子点データに
    ! 2 階 R 微分を作用させたデータのチェビシェフ変換のことである.
    !
    !
    real(8), dimension(:,0:), intent(in)     :: au_data
    !(in) 入力チェビシェフデータ

    real(8), dimension(size(au_data,1),0:im) :: ag_Dr2_au
    !(out) チェビシェフデータの 2 階 R 微分

    real(8), dimension(size(au_data,1),0:size(au_data,2)-1)  :: au_g
    real(8), dimension(size(au_data,1),0:size(au_data,2)-1)  :: au_h
    ! 作業配列

    integer :: nm

    nm=size(au_data,1)

    au_g = au_Dx_au(au_data)
    au_h = au_Dx_au(au_g)

    ag_Dr2_au = 16*spread(g_R,1,nm)**2/ra**4 * ag_au(au_h)  &
              + 4*spread(2*nd+1,2,im+1)/ra**2 * ag_au(au_g) &
              + spread(nd*(nd-1),2,im+1)/spread(g_R**2,1,nm) * ag_au(au_data)
  end function ag_Dr2_au

  function g_Dr2_u(u_data)
    !
    ! 入力チェビシェフデータに 2 階 R 微分を作用する(1 次元配列用).
    !
    ! チェビシェフデータの 2 階 R 微分とは, 対応する格子点データに 
    ! 2 階 R 微分を作用させたデータのチェビシェフ変換のことである.
    !
    !
    real(8), dimension(:), intent(in)   :: u_data
    !(in) 入力チェビシェフデータ

    real(8), dimension(0:im)            :: g_Dr2_u
    !(out) チェビシェフデータの 2 階 R 微分

    real(8), dimension(1,size(u_data))  :: au_work
    ! 作業用配列

    real(8), dimension(1,0:im)          :: ag_work
    ! 作業用配列
    
    au_work(1,:) = u_data
    ag_work = ag_Dr2_au(au_work)
    g_Dr2_u = ag_work(1,:)

  end function g_Dr2_u

  !--------------- 積分計算 -----------------
    function a_Int_ag(ag)
      !
      ! 1 次元格子点データが並んだ 2 次元配列の積分
      !
      real(8), dimension(:,0:), intent(in)     :: ag
      !(in)入力格子点データ

      real(8), dimension(size(ag,1))           :: a_Int_ag
      !(out) 積分したデータ
      integer :: i

      if ( size(ag,2) < im+1 ) then
         call MessageNotify('E','a_Int_ag', &
              'The Grid points of input data too small.')
      elseif ( size(ag,2) > im+1 ) then
         call MessageNotify('W','a_Int_ag', &
              'The Grid points of input data too large.')
      endif

      a_Int_ag = 0.0d0
      do i=0,im
         a_Int_ag(:) = a_Int_ag(:) + ag(:,i)*g_R_Weight(i)
      enddo
    end function a_Int_ag

    function Int_g(g)
      !
      ! 1 次元格子点データの積分および平均.
      !
      real(8), dimension(0:im), intent(in)   :: g
      !(in) 格子点データ

      real(8)                                :: Int_g
      !(out) 積分値

      Int_g = sum(g*g_R_Weight)
    end function Int_g

    function a_Avr_ag(ag)
      !
      ! 1 次元格子点データが並んだ 2 次元配列の平均
      !
      real(8), dimension(:,0:), intent(in)   :: ag
      !(in)入力格子点データ

      real(8), dimension(size(ag,1))         :: a_Avr_ag
      !(out) 平均したデータ

      a_Avr_ag = a_Int_ag(ag)/sum(g_R_Weight)
    end function a_Avr_ag

    function Avr_g(g)
      !
      ! 1 次元格子点データの平均
      !
      real(8), dimension(0:im), intent(in)   :: g
      !(in) 格子点データ

      real(8)                                :: Avr_g
      !(out) 積分値

      Avr_g = Int_g(g)/sum(g_R_Weight)
    end function Avr_g

!---- Dirichlet 型境界条件(タウ法) ----

  subroutine au_BoundaryTau_D_2d(au_data,value)
    !
    ! Dirichlet 型境界条件の適用(タウ法, 2 次元配列用)
    ! 外側境界(i=0)での値を与える.
    !
    real(8), dimension(:,0:),intent(inout)         :: au_data ! データ(m,0:km)
    !(inout) 境界条件を適用するチェビシェフデータ(m,0:km)

    real(8), dimension(:), intent(in), optional  :: value
    !(in) 境界値(m)

    real(8), dimension(:,:,:), allocatable  :: alu
    integer, dimension(:,:), allocatable    :: kp
    real(8), dimension(size(nd),0:km)        :: au_work
    real(8), dimension(size(nd),0:im)        :: ag_work
    real(8), dimension(size(au_data,1))   :: value0           ! 境界値

    logical :: first = .true.
    integer :: k
    save    :: alu, kp, first

    if ( size(au_data,2)-1 < km ) then
       call MessageNotify('E','au_BoundaryTau_D', &
            'The Chebyshev dimension of input data too small.')
    elseif ( size(au_data,2)-1 > km ) then
       call MessageNotify('W','au_BoundaryTau_D', &
            'The Chebyshev dimension of input data too large.')
    endif

    if (.not. present(value)) then
       value0=0
    else
       value0 = value
    endif

    if ( first ) then
       first = .false.

       allocate(alu(size(nd),0:km,0:km),kp(size(nd),0:km))

       alu=0.0D0
       do k=0,km
          alu(:,k,k) = 1.0D0
       enddo

       do k=0,km
          au_work = 0.0
          au_work(:,k) = 1.0
          ag_work = ag_au(au_work)
          alu(:,km,k) = ag_work(:,0)
       enddo

       call ludecomp(alu,kp)
    endif

    au_data(:,km)   = value0
    au_data = lusolve(alu,kp,au_data)

  end subroutine au_BoundaryTau_D_2d

  subroutine au_BoundaryTau_D_1d(u_data,value)
    !
    ! Dirichlet 型境界条件の適用(タウ法, 1 次元配列用)
    ! 両境界での値を与える.
    !
    real(8), dimension(0:km),intent(inout)       :: u_data
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    real(8), intent(in), optional                :: value
    !(in) 境界値

    real(8), dimension(1,0:km)                   :: au_work
    real(8), dimension(1)                        :: vwork           ! 境界値

    if (.not. present(value)) then
       vwork(1)=0
    else
       vwork(1) = value
    endif

    au_work(1,:)=u_data
    call au_BoundaryTau_D_2d(au_work,vwork)
    u_data=au_work(1,:)

  end subroutine au_BoundaryTau_D_1d

!---- Neumann 型境界条件(タウ法) ----

  subroutine au_BoundaryTau_N_2d(au_data,value)
    !
    ! 外側境界 Neumann 型境界条件の適用(タウ法, 2 次元配列用)
    ! i=0 で勾配の値を与える.
    !
    real(8), dimension(:,0:),intent(inout)         :: au_data
    !(inout) 境界条件を適用するチェビシェフデータ(m,0:km)

    real(8), dimension(:), intent(in), optional    :: value
    !(in) 境界値(m)

    real(8), dimension(:,:,:), allocatable  :: alu
    integer, dimension(:,:), allocatable    :: kp
    real(8), dimension(size(nd),0:km)        :: au_work
    real(8), dimension(size(nd),0:im)        :: ag_work
    real(8), dimension(size(au_data,1))   :: value0           ! 境界値

    logical :: first = .true.
    integer :: k
    save    :: alu, kp, first

    if ( size(au_data,2)-1 < km ) then
       call MessageNotify('E','au_BoundaryTau_DN', &
            'The Chebyshev dimension of input data too small.')
    elseif ( size(au_data,2)-1 > km ) then
       call MessageNotify('W','au_BoundaryTau_DN', &
            'The Chebyshev dimension of input data too large.')
    endif

    if (.not. present(value)) then
       value0=0
    else
       value0 = value
    endif

    if ( first ) then
       first = .false.
       allocate(alu(size(nd),0:km,0:km),kp(size(nd),0:km))

       alu=0.0D0
       do k=0,km
          alu(:,k,k) = 1.0D0
       enddo

       do k=0,km
          au_work = 0.0
          au_work(:,k) = 1.0
          ag_work = ag_Dr_au(au_work)
          alu(:,km,k) = ag_work(:,0)
       enddo

       call ludecomp(alu,kp)
    endif

    au_data(:,km)   = value0
    au_data = lusolve(alu,kp,au_data)

  end subroutine au_BoundaryTau_N_2d

  subroutine au_BoundaryTau_N_1d(u_data,value)
    !
    ! Dirichlet/Neumann 型境界条件の適用(タウ法, 1 次元配列用)
    ! i=0 で勾配の値を与える.
    !
    real(8), dimension(0:km),intent(inout)       :: u_data
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    real(8), intent(in), optional                :: value
    !(in) 境界値

    real(8), dimension(1,0:km)                   :: au_work
    real(8), dimension(1)                        :: vwork           ! 境界値

    if (.not. present(value)) then
       vwork(1)=0
    else
       vwork(1) = value
    endif

    au_work(1,:)=u_data
    call au_BoundaryTau_N_2d(au_work,vwork)
    u_data=au_work(1,:)

  end subroutine au_BoundaryTau_N_1d

!---- Dirichlet 型境界条件(実空間での評価) ----

  subroutine au_BoundaryGrid_D_2d(au_data,value)
    !
    ! Dirichlet 型境界条件の適用(実空間での評価, 2 次元配列用)
    ! 外側境界での値を与える.
    !
    real(8), dimension(:,0:),intent(inout)         :: au_data
    !(inout) 境界条件を適用するチェビシェフデータ(m,0:km)

    real(8), dimension(:), intent(in), optional    :: value
    !(in) 境界値(m)

    real(8), dimension(:,:,:), allocatable     :: alu
    integer, dimension(:,:), allocatable       :: kp
    real(8), dimension(size(au_data,1),0:im)   :: ag_data
    real(8), dimension(size(nd),0:km)          :: au_work
    real(8), dimension(size(au_data,1))        :: value0 ! 境界値

    logical :: first = .true.
    integer :: k
    save    :: alu, kp, first

    if ( im /= km ) then
       call MessageNotify('E','au_BoundaryGrid_DD', &
            'Chebyshev truncation and number of grid points should be same.')
    endif

    if ( size(au_data,2)-1 < km ) then
       call MessageNotify('E','au_BoundaryGrid_DD', &
            'The Chebyshev dimension of input data too small.')
    elseif ( size(au_data,2)-1 > km ) then
       call MessageNotify('W','au_BoundaryGrid_DD', &
            'The Chebyshev dimension of input data too large.')
    endif

    if (.not. present(value)) then
       value0=0
    else
       value0=value   
    endif

    if ( first ) then
       first = .false.
       allocate(alu(size(nd),0:im,0:km),kp(size(nd),0:im))

       do k=0,km
          au_work = 0
          au_work(:,k)=1.0
          alu(:,:,k) = ag_au(au_work)
       enddo

       call ludecomp(alu,kp)
    endif

    ag_data = ag_au(au_data)
    ag_data(:,0)  = value0
    au_data = lusolve(alu,kp,ag_data)

  end subroutine au_BoundaryGrid_D_2d

  subroutine au_BoundaryGrid_D_1d(u_data,value)
    !
    ! Dirichlet 型境界条件の適用(実空間での評価, 1 次元配列用)
    ! 外側境界での値を与える.
    !
    real(8), dimension(0:km),intent(inout)       :: u_data
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    real(8), intent(in), optional                :: value
    !(in) 境界値

    real(8), dimension(1,0:km)                   :: au_work
    real(8), dimension(1)                        :: vwork           ! 境界値

    if (.not. present(value)) then
       vwork(1)=0
    else
       vwork(1) = value
    endif

    au_work(1,:)=u_data
    call au_BoundaryGrid_D_2d(au_work,vwork)
    u_data=au_work(1,:)

  end subroutine au_BoundaryGrid_D_1d

!---- Neumann 型境界条件(実空間での評価) ----

  subroutine au_BoundaryGrid_N_2d(au_data,value)
    !
    ! 外側境界 Neumann 型境界条件の適用(実空間での評価, 2 次元配列用)
    ! i=0 で勾配の値を与える.
    !
    real(8), dimension(:,0:),intent(inout)         :: au_data
    !(inout) 境界条件を適用するチェビシェフデータ(m,0:km)

    real(8), dimension(:), intent(in), optional    :: value
    !(in) 境界値(m)

    real(8), dimension(:,:,:), allocatable   :: alu
    integer, dimension(:,:), allocatable     :: kp
    real(8), dimension(size(au_data,1),0:im) :: ag_data
    real(8), dimension(size(nd),0:km)        :: au_work
    real(8), dimension(size(nd),0:im)        :: ag_work
    real(8), dimension(size(au_data,1))      :: value0   ! 境界値

    logical :: first = .true.
    integer :: k
    save    :: alu, kp, first

    if ( im /= km ) then
       call MessageNotify('E','au_BoundaryGrid_N', &
            'Chebyshev truncation and number of grid points should be same.')
    endif

    if ( size(au_data,2)-1 < km ) then
       call MessageNotify('E','au_BoundaryGrid_N', &
            'The Chebyshev dimension of input data too small.')
    elseif ( size(au_data,2)-1 > km ) then
       call MessageNotify('W','au_BoundaryGrid_DN', &
            'The Chebyshev dimension of input data too large.')
    endif

    if (.not. present(value)) then
       value0=0
    else
       value0 = value
    endif

    if ( first ) then
       first = .false.
       allocate(alu(size(nd),0:im,0:km),kp(size(nd),0:im))

       do k=0,km
          au_work = 0
          au_work(:,k)=1.0
          ag_work = ag_au(au_work)
          alu(:,:,k) = ag_work
       enddo

       do k=0,km
          au_work = 0
          au_work(:,k)=1.0
          ag_work = ag_Dr_au(au_work)
          alu(:,0,k) = ag_work(:,0)
       enddo

       call ludecomp(alu,kp)
    endif

    ag_data = ag_au(au_data)
    ag_data(:,0)  = value0
    au_data = lusolve(alu,kp,ag_data)

  end subroutine au_BoundaryGrid_N_2d

  subroutine au_BoundaryGrid_N_1d(u_data,value)
    !
    ! 外側境界 Neumann 型境界条件の適用(実空間での評価, 1 次元配列用)
    ! i=0 で勾配の値を与える.
    !
    real(8), dimension(0:km),intent(inout)       :: u_data
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    real(8), intent(in), optional                :: value
    !(in) 境界値

    real(8), dimension(1,0:km)                   :: au_work
    real(8), dimension(1)                        :: vwork           ! 境界値

    if (.not. present(value)) then
       vwork(1)=0
    else
       vwork(1) = value
    endif

    au_work(1,:)=u_data
    call au_BoundaryGrid_N_2d(au_work,vwork)
    u_data=au_work(1,:)

  end subroutine au_BoundaryGrid_N_1d

end module au_module

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_module_fftj テストプログラム (境界値問題, トロイダル速度ポテンシャル)
!
!履歴  2009/12/19  竹広真一
!
program tee_module_fftj_torvelbcGrid

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=16       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: zyx_Torvel(0:km,0:jm-1,0:im-1)      ! 格子データ
  real(8)            :: zyx_Torvel_orig(0:km,0:jm-1,0:im-1) ! 格子データ
  real(8)            :: zyx_DTorvel(0:km,0:jm-1,0:im-1)     ! 格子データ
  real(8)            :: tee_Torvel(0:nm,-mm:mm,-lm:lm)      ! スペクトルデータ

  real(8)            :: zyx_Null(0:km,0:jm-1,0:im-1) =0.0D0 ! 格子データ

  integer            :: l=2, m=5

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','tee_module_fftj_TorvelbcGrid_test', &
       'tee_module_fftj toroidal velocity potential B.C. function tests')

 !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call tee_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

 !-------------------BC-FF(Grid) ----------------------
  zyx_Torvel = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)
  zyx_Torvel_orig = zyx_Torvel

  tee_Torvel = tee_zyx(zyx_Torvel)
 
  call tee_TorBoundariesGrid(tee_Torvel,cond='FF',new=.true.)
  zyx_Torvel = zyx_tee(tee_Torvel)

  call AssertEqual(&
    message='tee_TorBoundariesGrid [FF,internal]',                &
    answer = zyx_Torvel_orig(1:km-1,:,:),                         &
    check = zyx_Torvel(1:km-1,:,:),                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_DTorvel = zyx_tee(tee_Dz_tee(tee_Torvel))
  call AssertEqual(&
    message='tee_TorBoundariesGrid [FF,Top]',                     &
    answer = zyx_DTorvel(0,:,:),                                  &
    check = zyx_Null(0,:,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tee_TorBoundariesGrid [FF,Bottom]',                  &
    answer = zyx_DTorvel(km,:,:),                                 &
    check = zyx_Null(km,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !-------------------BC-RR(Grid) ----------------------
  zyx_Torvel = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)
  zyx_Torvel_orig = zyx_Torvel

  tee_Torvel = tee_zyx(zyx_Torvel)
  call tee_TorBoundariesGrid(tee_Torvel,cond='RR',new=.true.)
  zyx_Torvel = zyx_tee(tee_Torvel)

  call AssertEqual(&
    message='tee_TorBoundariesGrid [RR,internal]',                &
    answer = zyx_Torvel_orig(1:km-1,:,:),                         &
    check = zyx_Torvel(1:km-1,:,:),                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_DTorvel = zyx_tee(tee_Torvel)
  call AssertEqual(&
    message='tee_TorBoundariesGrid [RR,Top]',                     &
    answer = zyx_DTorvel(0,:,:),                                  &
    check = zyx_Null(0,:,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='tee_TorBoundariesGrid [RR,Bottom]',                  &
    answer = zyx_DTorvel(km,:,:),                                 &
    check = zyx_Null(km,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !-------------------BC-RF(Grid) ----------------------
  zyx_Torvel = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)
  zyx_Torvel_orig = zyx_Torvel

  tee_Torvel = tee_zyx(zyx_Torvel)
  call tee_TorBoundariesGrid(tee_Torvel,cond='RF',new=.true.)
  zyx_Torvel = zyx_tee(tee_Torvel)

  call AssertEqual(&
    message='tee_TorBoundariesGrid [RF,internal]',                &
    answer = zyx_Torvel_orig(1:km-1,:,:),                         &
    check = zyx_Torvel(1:km-1,:,:),                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_DTorvel = zyx_tee(tee_Torvel)
  call AssertEqual(&
    message='tee_TorBoundariesGrid [RF,Top]',                     &
    answer = zyx_DTorvel(0,:,:),                                  &
    check = zyx_Null(0,:,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_DTorvel = zyx_tee(tee_Dz_tee(tee_Torvel))
  call AssertEqual(&
    message='tee_TorBoundariesGrid [RF,Bottom]',                  &
    answer = zyx_DTorvel(km,:,:),                                 &
    check = zyx_Null(km,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !-------------------BC-FR(Grid) ----------------------
  zyx_Torvel = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)
  zyx_Torvel_orig = zyx_Torvel

  tee_Torvel = tee_zyx(zyx_Torvel)
  call tee_TorBoundariesGrid(tee_Torvel,cond='FR',new=.true.)
  zyx_Torvel = zyx_tee(tee_Torvel)

  call AssertEqual(&
    message='tee_TorBoundariesGrid [FR,internal]',                &
    answer = zyx_Torvel_orig(1:km-1,:,:),                         &
    check = zyx_Torvel(1:km-1,:,:),                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_DTorvel = zyx_tee(tee_Dz_tee(tee_Torvel))
  call AssertEqual(&
    message='tee_TorBoundariesGrid [FR,Top]',                     &
    answer = zyx_DTorvel(0,:,:),                                  &
    check = zyx_Null(0,:,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_DTorvel = zyx_tee(tee_Torvel)
  call AssertEqual(&
    message='tee_TorBoundariesGrid [RF,Bottom]',                  &
    answer = zyx_DTorvel(km,:,:),                                 &
    check = zyx_Null(km,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','tee_module_fftj_TorvelbcGrid_test', &
       'tee_module_fftj toroidal velocity potential B.C. function tests succeeded!')

end program tee_module_fftj_torvelbcGrid

!----------------------------------------------------------------------
!     Copyright (c) 2010 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wtq_module_sjpack テストプログラム
!
!      磁場トロイダルポテンシャルの境界値問題
!
!履歴  2010/04/18  竹広真一  wtq_test_polmagbctau.f90 より改変
!
program wtq_module_sjpack_polmagbctau

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wtq_module_sjpack

  implicit none

  integer,parameter  :: im=32, jm=16         ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: kmo=16, kmi=8        ! 格子点の設定(球殻動径, 球動径)
  integer,parameter  :: nm=10                ! 切断波数の設定(水平)
  integer,parameter  :: lmo=10, lmi=10       ! 切断波数の設定(球殻動径, 球動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), dimension(im,jm,0:kmo)           :: xyz_POLMAG
  real(8), dimension((nm+1)*(nm+1),0:lmo)   :: wt_POLMAG
  real(8), dimension(im,jm,kmi)             :: xyr_POLMAG
  real(8), dimension((nm+1)*(nm+1),0:lmi)   :: wq_POLMAG
  real(8), dimension(im,jm,0:kmo)           :: xyz_DPOLDR
  real(8), dimension(im,jm,kmi)             :: xyr_DPOLDR

  real(8), dimension((nm+1)*(nm+1),0:kmo)   :: wz_TopBoundary
  real(8), dimension((nm+1)*(nm+1),0:kmo)   :: wz_n   ! 全波数
  real(8), dimension((nm+1)*(nm+1))         :: w_Null=0.0D0

  real(8), parameter  :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  integer :: n,k, nn(2)

  call MessageNotify('M','wtq_test_tormagbctau', &
       'wtq_module  wtq_TormagBoundariesTau subroutine test')

  call wtq_Initial(im,jm,kmi,kmo,nm,lmi,lmo,ri,ro)

  do k=0,kmo
     do n=1,(nm+1)**2
        nn=nm_l(n)
        wz_n(n,k) = nn(1)
     enddo
  enddo

  ! P_10

  xyz_POLMAG = sin(xyz_lat) * cos( pi*(xyz_rad-ri)/(ro-ri) )
  xyr_POLMAG = sin(xyr_lat) * cos( pi*(xyr_rad-ri)/ri ) * xyr_Rad

  wt_POLMAG = wt_xyz(xyz_POLMAG)
  wq_POLMAG = wq_xyr(xyr_POLMAG)
  call wtq_PolmagBoundariesTau(wt_POLMAG,wq_POLMAG)
  xyz_POLMAG = xyz_wt(wt_POLMAG)
  xyr_POLMAG = xyr_wq(wq_POLMAG)

  xyz_DPOLDR = xyz_wt(wt_DRad_wt(wt_POLMAG))
  xyr_DPOLDR = xyr_wq(wq_RadDRad_wq(wq_POLMAG))/xyr_Rad
  wz_TopBoundary = wz_wt(wt_DRad_wt(wt_POLMAG)) &
                     + (wz_n +1)*wz_wt(wt_POLMAG)/wz_RAD

  call checkresults

  ! P_1_1
  xyz_POLMAG = cos(xyz_lat)*cos(xyz_lon)* cos( pi*(xyz_rad-ri)/(ro-ri) )
  xyr_POLMAG = cos(xyr_lat)*cos(xyr_lon)* cos( pi*(xyr_rad-ri)/ri )*xyr_Rad

  wt_POLMAG = wt_xyz(xyz_POLMAG)
  wq_POLMAG = wq_xyr(xyr_POLMAG)
  call wtq_PolmagBoundariesTau(wt_POLMAG,wq_POLMAG)
  xyz_POLMAG = xyz_wt(wt_POLMAG)
  xyr_POLMAG = xyr_wq(wq_POLMAG)

  xyz_DPOLDR = xyz_wt(wt_DRad_wt(wt_POLMAG))
  xyr_DPOLDR = xyr_wq(wq_RadDRad_wq(wq_POLMAG))/xyr_Rad

  call checkresults

  call MessageNotify('M','wtq_test_polmagbctau', &
       'wtq_module  wtq_TormagBoundary subroutine test succeded')


contains
  subroutine checkresults

     call AssertEqual(&
       message='Top B.C',                                            &
       answer = wz_TopBoundary(:,0),                                 &
       check = w_Null,                                               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

     call AssertEqual(&
       message='Inner B.C (value conituity) ',                       &
       answer = xyz_POLMAG(:,:,kmo),                                 &
       check = xyr_POLMAG(:,:,kmi),                                  &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

     call AssertEqual(&
       message='Inner B.C (derivative conituity) ',                  &
       answer = xyz_DPOLDR(:,:,kmo),                                 &
       check = xyr_DPOLDR(:,:,kmi),                                  &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
   end subroutine checkresults

 end program wtq_module_sjpack_polmagbctau

!----------------------------------------------------------------------
!     Copyright (c) 2010--2012 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wtq_module_sjpack テストプログラム
!
!      磁場トロイダルポテンシャルの境界値問題
!
!履歴  2010/04/18  竹広真一   wt_module_sjpack_test_tormagbc.f90 より改造
!      2011/09/14  竹広真一   MPI 並列化
!      2011/09/14  竹広真一   wtq_mpi_module 用に改造
!      2012/04/02  竹広真一   wtq_mpi_module_sjpack 用に改造
!      2012/04/03  竹広真一   wtq_module_sjpack 用に改造
!
program wtq_module_sjpack_tormagbc_wt

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wtq_module_sjpack

  implicit none

  integer,parameter  :: im=32, jm=16         ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: kmo=16, kmi=10       ! 格子点の設定(球殻動径, 球動径)
  integer,parameter  :: nm=10                ! 切断波数の設定(水平)
  integer,parameter  :: lmo=16, lmi=16       ! 切断波数の設定(球殻動径, 球動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), dimension(0:im-1,1:jm,0:kmo)     :: xyz_TORMAG
  real(8), dimension((nm+1)*(nm+1),0:lmo)   :: wt_TORMAG

  real(8), dimension(0:im-1,1:jm,0:kmo)     :: xyz_Zero = 0.0D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8), parameter  :: pi=3.1415926535897932385D0

  call MessageNotify('M','wt_module_sjpack_tormagbc_test', &
       'wt_module_sjpack wt_TormagBoundaries subroutine test')

  call wtq_Initial(im,jm,kmi,kmo,nm,lmi,lmo,ri,ro)

 !==================== wt_TormagBoundaries =========================
  ! P_10
  xyz_TORMAG = sin(xyz_lat) * cos( pi*(xyz_rad-ri)/(ro-ri) )
  ! P_1_1
  !xyz_TORMAG = cos(xyz_lat)*cos(xyz_lon)* cos( pi*(xyz_rad-ri)/(ro-ri) )
  !xyz_TORMAG = 2*sin(xyz_lat)**2 * cos( pi*(xyz_rad-ri)/(ro-ri) )

  wt_TORMAG = wt_xyz(xyz_TORMAG)
  call wt_TormagBoundaries(wt_TORMAG)
  xyz_TORMAG = xyz_wt(wt_TORMAG)

  call AssertEqual(&
       message='wt_TormagBoundaries (Top B.C.)',                     &
       answer = xyz_Zero(:,:,0),                                     &
       check = xyz_TORMAG(:,:,0),                                    &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='wt_TormagBoundaries (Bottom B.C.)',                  &
       answer = xyz_Zero(:,:,kmo),                                    &
       check = xyz_TORMAG(:,:,kmo),                                   &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

 !==================== wt_TormagBoundariesGrid =========================
  ! P_10
  !xyz_TORMAG = sin(xyz_lat) * cos( pi*(xyz_rad-ri)/(ro-ri) )
  ! P_1_1
  xyz_TORMAG = cos(xyz_lat)*cos(xyz_lon)* cos( pi*(xyz_rad-ri)/(ro-ri) )
  !xyz_TORMAG = 2*sin(xyz_lat)**2 * cos( pi*(xyz_rad-ri)/(ro-ri) )

  wt_TORMAG = wt_xyz(xyz_TORMAG)
  call wt_TormagBoundariesGrid(wt_TORMAG)
  xyz_TORMAG = xyz_wt(wt_TORMAG)


  call AssertEqual(&
       message='wt_TormagBoundariesGrid (Top B.C.)',                 &
       answer = xyz_Zero(:,:,0),                                     &
       check = xyz_TORMAG(:,:,0),                                    &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='wt_TormagBoundariesGrid (Bottom B.C.)',              &
       answer = xyz_Zero(:,:,kmo),                                    &
       check = xyz_TORMAG(:,:,kmo),                                   &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','wtq_module_sjpack_tormagbc_wt_test', &
       'wtq_module_sjpack wt_TormagBoundaries subroutine test succeeded!')

end program wtq_module_sjpack_tormagbc_wt

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wq_module テストプログラム
!
!      wq_KxRGrad_wq, xyr_KGrad_wq, wq_QOperator_wq のテスト
!      wr_RadRot_xyr_xyr, wr_RadRotRot_xyr_xyr_xyr のテスト
!      wq_Potential2Vector, wq_Potential2Rotation のテスト
!
!履歴  2009/12/07  竹広真一  wq_test_derivative[4-7].f90 を SJPACK 用に改造
!
program wq_module_sjpack_derivative2

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wq_module_sjpack
  implicit none

  integer,parameter  :: im=32, jm=16, km=8   ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=15         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ra=1.5               ! 球半径

  real(8), dimension(0:im-1,1:jm,km)     :: xyr_Psi
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_KxRGrad
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_KGrad
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_QOperator

  real(8), dimension(0:im-1,1:jm,km)     :: xyr_VLon
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_VLat
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_VRad
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_V0Lon  ! 速度(正解, 経度)
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_V0Lat  ! 速度(正解, 緯度)
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_V0rad  ! 速度(正解,動径)
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_RadRot
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_RadRotRot
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_Torvel
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_Polvel

  real(8), dimension((nm+1)*(nm+1),0:lm) :: wq_Torvel  ! トロイダルポテンシャル
  real(8), dimension((nm+1)*(nm+1),0:lm) :: wq_Polvel  ! ポロイダルポテンシャル

  integer, parameter :: n=3

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  call MessageNotify('M','wq_module_sjpack_derivative_test2', &
       'wq_module_sjpack derivative function test #1')

  call wq_Initial(im,jm,km,nm,lm,ra)

  !========== wq_KxRGrad_wq, xyr_KGrad_wq, wq_QOperator_wq =========
  call MessageNotify('M','wq_module_sjpack_derivative_test2', &
       'Test for wq_KxRGrad_wq, xyr_KGrad_wq, wq_QOperator_wq')

  xyr_Psi = xyr_rad**n * cos(xyr_lat)*sin(xyr_lon)       ! r**n Y_1^1

  xyr_KxRGrad = xyr_Rad**n * cos(xyr_lat)*cos(xyr_lon)   ! r**n Y_1^-1

  ! k ・▽ r**n Y_1^1 = (n-1)*r**(n-1)* Y_2^1
  xyr_KGrad = (n-1)*xyr_rad**(n-1)* cos(xyr_lat)*sin(xyr_lat)*sin(xyr_lon) 

  ! Q r**n Y_1^1 = -3*(n-1)*r**(n-1)* Y_2^1
  xyr_QOperator = - 3*(n-1)*xyr_rad**(n-1)* &
                   cos(xyr_lat)*sin(xyr_lat)*sin(xyr_lon) 

  call AssertEqual(&
       message='Checking k x r grad with r**n Y_1^1',                &
       answer = xyr_KxRgrad,                                         &
       check = xyr_wq(wq_KxRGrad_wq(wq_xyr(xyr_Psi))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking k grad with r**n Y_1^1',                    &
       answer = xyr_KGrad,                                           &
       check = xyr_KGrad_wq(wq_xyr(xyr_Psi)),                        &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking Q operator with r**n Y_1^1',                &
       answer = xyr_QOperator,                                       &
       check = xyr_wq(wq_QOperator_wq(wq_xyr(xyr_Psi))),             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyr_Psi = 3*cos(xyr_lat)*sin(xyr_lat) * sin(xyr_lon) * xyr_Rad**2 ! Y_2^1

  xyr_KxRGrad = 3*cos(xyr_lat)*sin(xyr_lat) * cos(xyr_lon) * xyr_Rad**2 ! Y_2^-1

  ! k・▽r^2 Y_2^1 = 3r Y_1^1 
  xyr_KGrad = 3*xyr_Rad*cos(2*xyr_Lat)*cos(xyr_Lat)*sin(xyr_Lon) &
             +3*xyr_Rad*sin(2*xyr_Lat)*sin(xyr_Lat)*sin(xyr_Lon)

  xyr_QOperator = -9*cos(xyr_lat)*sin(xyr_lon)*xyr_rad

  call AssertEqual(&
       message='Checking k x r grad with r**2 Y_2^1',                &
       answer = xyr_KxRgrad,                                         &
       check = xyr_wq(wq_KxRGrad_wq(wq_xyr(xyr_Psi))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking k grad with r**2 Y_2^1',                    &
       answer = xyr_KGrad,                                           &
       check = xyr_KGrad_wq(wq_xyr(xyr_Psi)),                        &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking Q operator with r**2 Y_2^1',                &
       answer = xyr_QOperator,                                       &
       check = xyr_wq(wq_QOperator_wq(wq_xyr(xyr_Psi))),             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !=========== wr_RadRot_xyr_xyr, wr_RadRotRot_xyr_xyr_xyr ============
  call MessageNotify('M','wq_module_sjpack_derivative_test2', &
       'Test for wr_RadRot_xyr_xyr, wr_RadRotRot_xyr_xyr_xyr')

  xyr_VLon = 0.0D0 ; xyr_VLat = 0.0D0 ; xyr_VRad = xyr_Rad
  xyr_RadRot = 0.0D0 ; xyr_RadRotRot = 0.0D0

  call AssertEqual(&
       message='Checking r Rot v with simple example (v_r=r)',       &
       answer = xyr_RadRot,                                          &
       check = xyr_wr(wr_RadRot_xyr_xyr(xyr_VLon,xyr_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking r Rot Rot v with simple example (v_r=r)',   &
       answer = xyr_RadRotRot,                                       &
       check = xyr_wr(wr_RadRotRot_xyr_xyr_xyr(xyr_VLon,xyr_VLat,xyr_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! 剛体回転解非線形項(東西流れ)
  xyr_VLon = 0.0D0
  xyr_VLat = xyr_Rad*sin(xyr_Lat)*cos(xyr_Lat)
  xyr_VRad = -xyr_Rad*cos(xyr_Lat)**2
  xyr_RadRot = 0.0D0 ; xyr_RadRotRot = 0.0D0

  call AssertEqual(&
       message='Checking r Rot v with rigid rotation(E-W flow)',     &
       answer = xyr_RadRot,                                          &
       check = xyr_wr(wr_RadRot_xyr_xyr(xyr_VLon,xyr_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking r Rot Rot v with rigid rotation(E-W flow)', &
       answer = xyr_RadRotRot,                                       &
       check = xyr_wr(wr_RadRotRot_xyr_xyr_xyr(xyr_VLon,xyr_VLat,xyr_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! 剛体回転解非線形項(南北流れ)
  xyr_VLon = xyr_Rad*cos(xyr_Lat)*sin(xyr_Lon)*cos(xyr_Lon)
  xyr_VLat = -xyr_Rad*sin(xyr_Lat)*cos(xyr_Lat)*sin(xyr_Lon)**2
  xyr_VRad = -xyr_Rad*(sin(xyr_Lat)**2*sin(xyr_Lon)**2 + cos(xyr_Lon)**2)
  xyr_RadRot = 0.0D0 ; xyr_RadRotRot = 0.0D0

  call AssertEqual(&
       message='Checking r Rot v with rigid rotation(N-S flow)',     &
       answer = xyr_RadRot,                                          &
       check = xyr_wr(wr_RadRot_xyr_xyr(xyr_VLon,xyr_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking r Rot Rot v with rigid rotation(N-S flow)', &
       answer = xyr_RadRotRot,                                       &
       check = xyr_wr(wr_RadRotRot_xyr_xyr_xyr(xyr_VLon,xyr_VLat,xyr_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )

! 鉛直渦度を伴うベクトル場
  xyr_Polvel = xyr_Rad**2 * cos(xyr_Lat)*sin(xyr_Lon)   ! r**2 P_1^1
  !xyr_Psi = xyr_Rad**3 * cos(xyr_Lat)*sin(xyr_Lat)*sin(xyr_Lon)   ! r**3 P_2^1

  xyr_VLon =   xyr_GradLat_wq(wq_xyr(xyr_Polvel*xyr_Rad))
  xyr_VLat = - xyr_GradLon_wq(wq_xyr(xyr_Polvel*xyr_Rad))
  xyr_VRad = 0.0D0
  xyr_RadRot = 2 * xyr_Polvel                       ! r・▽×▽×(ψr) = L_2ψ
  !xyr_RadRot = 6 * xyr_Polvel                      ! r・▽×▽×(ψr) = L_2ψ
  xyr_RadRotRot = 0.0D0

  call AssertEqual(&
       message='Checking r Rot v with vortical field',               &
       answer = xyr_RadRot,                                          &
       check = xyr_wr(wr_RadRot_xyr_xyr(xyr_VLon,xyr_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking r Rot Rot v with vortical field',           &
       answer = xyr_RadRotRot,                                       &
       check = xyr_wr(wr_RadRotRot_xyr_xyr_xyr(xyr_VLon,xyr_VLat,xyr_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )

! 鉛直速度を伴うベクトル場
  xyr_Torvel = 0.0D0
  xyr_Polvel = xyr_Rad**3 * cos(xyr_Lat)*sin(xyr_Lon)   ! r**2 P_1^1
  call wq_Potential2Vector(&
         xyr_VLon,xyr_VLat,xyr_VRad, wq_xyr(xyr_Torvel),wq_xyr(xyr_Polvel) )

  xyr_RadRot = 0.0D0
  xyr_RadRotRot = -xyr_wq(wq_L2_wq(wq_Lapla_wq(wq_xyr(xyr_Polvel))))
                 ! r・▽×▽×▽×▽×(ψr) = -L_2▽^2ψ

  call AssertEqual(&
       message='Checking r Rot v with non-vortical field',           &
       answer = xyr_RadRot,                                          &
       check = xyr_wr(wr_RadRot_xyr_xyr(xyr_VLon,xyr_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking r Rot Rot v with non-vortical field',       &
       answer = xyr_RadRotRot,                                       &
       check = xyr_wr(wr_RadRotRot_xyr_xyr_xyr(xyr_VLon,xyr_VLat,xyr_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !==================== wq_Potential2Vector ====================
  call MessageNotify('M','wq_module_sjpack_derivative_test2', &
       'Test for wq_Potential2Vector')

  ! ----------------- 例 1 --------------------
  ! 剛体回転場
  wq_Torvel = wq_xyr(xyr_Rad * sin(xyr_Lat))
  wq_Polvel = 0.0D0

  xyr_V0lon = xyr_Rad * cos(xyr_Lat)
  xyr_V0lat = 0.0D0
  xyr_V0Rad = 0.0D0

  call wq_Potential2Vector(&
       xyr_VLon,xyr_VLat,xyr_VRad, wq_Torvel, wq_Polvel )

  call AssertEqual(&
       message='Checking Potential2Vector(VLat) with rigid rotation(EW)',&
       answer = xyr_VLon,                                            &
       check = xyr_V0Lon,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking Potential2Vector(VLat) with rigid rotation(EW)',&
       answer = xyr_VLat,                                            &
       check = xyr_V0Lat,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking Potential2Vector(VRad) with rigid rotation(EW)',&
       answer = xyr_VRad,                                            &
       check = xyr_V0Rad,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ----------------- 例 2 --------------------
  ! 剛体回転場(南北流)
  wq_Torvel = wq_xyr(xyr_Rad * cos(xyr_Lat) * sin(xyr_Lon))
  wq_Polvel = 0.0D0

  xyr_V0Lon = -xyr_Rad*sin(xyr_Lat)*sin(xyr_Lon)
  xyr_V0Lat = -xyr_Rad*cos(xyr_Lon)
  xyr_V0Rad = 0.0D0

  call wq_Potential2Vector(&
       xyr_VLon,xyr_VLat,xyr_VRad, wq_Torvel, wq_Polvel )

  call AssertEqual(&
       message='Checking Potential2Vector(VLat) with rigid rotation(NS)',&
       answer = xyr_VLon,                                            &
       check = xyr_V0Lon,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking Potential2Vector(VLat) with rigid rotation(NS)',&
       answer = xyr_VLat,                                            &
       check = xyr_V0Lat,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking Potential2Vector(VRad) with rigid rotation(NS)',&
       answer = xyr_VRad,                                            &
       check = xyr_V0Rad,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ----------------- 例 3 --------------------
  ! 渦無し場

  wq_Torvel = 0.0D0
  wq_Polvel = wq_xyr(xyr_Rad**3 * sin(xyr_Lat))

  xyr_V0lon = 0.0D0
  xyr_V0lat = 4 * xyr_Rad**2 * cos(xyr_Lat)
  xyr_V0rad = 2 * xyr_Rad**2 * sin(xyr_Lat)

  call wq_Potential2Vector(&
       xyr_VLon,xyr_VLat,xyr_VRad, wq_Torvel, wq_Polvel )

  call AssertEqual(&
       message='Checking Potential2Vector(VLat) with no rotation',   &
       answer = xyr_VLon,                                            &
       check = xyr_V0Lon,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking Potential2Vector(VLat) with no rotation',   &
       answer = xyr_VLat,                                            &
       check = xyr_V0Lat,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking Potential2Vector(VRad) with no rotation',   &
       answer = xyr_VRad,                                            &
       check = xyr_V0Rad,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ----------------- 例 4 --------------------
  ! ポロイダル速度場

  wq_Torvel = 0.0D0
  wq_Polvel = wq_xyr(xyr_Rad**5 * cos(xyr_Lat)*sin(xyr_Lon))

  xyr_V0lon = 6 * xyr_Rad**4 * cos(xyr_Lon)
  xyr_V0lat = - 6 * xyr_Rad**4 * sin(xyr_Lat) * sin(xyr_Lon)
  xyr_V0rad = 2 * xyr_Rad**4 * cos(xyr_Lat) * sin(xyr_Lon)

  call wq_Potential2Vector(&
       xyr_VLon,xyr_VLat,xyr_VRad, wq_Torvel, wq_Polvel )

  call AssertEqual(&
       message='Checking Potential2Vector(VLat) with poloidal field',&
       answer = xyr_VLon,                                            &
       check = xyr_V0Lon,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking Potential2Vector(VLat) with poloidal field',&
       answer = xyr_VLat,                                            &
       check = xyr_V0Lat,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking Potential2Vector(VRad) with poloidal field',&
       answer = xyr_VRad,                                            &
       check = xyr_V0Rad,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !==================== wq_Potential2Rotation ====================
  call MessageNotify('M','wq_module_sjpack_derivative_test2', &
       'Test for wq_Potential2Rotation')

  ! ----------------- 例 1 --------------------
  ! 剛体回転場
  wq_Torvel = wq_xyr(xyr_Rad * sin(xyr_Lat))
  wq_Polvel = 0.0D0

  ! xyr_Vlon = xyr_Rad * cos(xyr_Lat)'
  ! xyr_Vlat = 0.0'
  ! xyr_VRad = 0.0'

  xyr_V0lon = 0.0D0
  xyr_V0lat = 2*cos(xyr_LAT)
  xyr_V0rad = 2*sin(xyr_LAT)

  call wq_Potential2Rotation(&
         xyr_VLon,xyr_VLat,xyr_VRad, wq_Torvel, wq_Polvel )

  call AssertEqual(&
       message='Checking Potential2Rotation(VLat) with rigid rotation(EW)',&
       answer = xyr_VLon,                                            &
       check = xyr_V0Lon,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking Potential2Rotation(VLat) with rigid rotation(EW)',&
       answer = xyr_VLat,                                            &
       check = xyr_V0Lat,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking Potential2Rotation(VRad) with rigid rotation(EW)',&
       answer = xyr_VRad,                                            &
       check = xyr_V0Rad,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

! ----------------- 例 2 --------------------
  ! 剛体回転場(南北流)
  wq_Torvel = wq_xyr(xyr_Rad * cos(xyr_Lat) * sin(xyr_Lon))
  wq_Polvel = 0.0D0

  !  xyr_VLon = -xyr_Rad*sin(xyr_Lat)*sin(xyr_Lon)
  !  xyr_VLat = -xyr_Rad*cos(xyr_Lon)
  !  xyr_VRad = 0.0

  xyr_V0Lon = 2*cos(xyr_Lon)
  xyr_V0Lat = -2*sin(xyr_Lon)*sin(xyr_Lat)
  xyr_V0Rad = 2*sin(xyr_Lon)*cos(xyr_Lat)

  call wq_Potential2Rotation(&
       xyr_VLon,xyr_VLat,xyr_VRad, wq_Torvel, wq_Polvel )

  call AssertEqual(&
       message='Checking Potential2Rotation(VLat) with rigid rotation(NS)',&
       answer = xyr_VLon,                                            &
       check = xyr_V0Lon,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking Potential2Rotation(VLat) with rigid rotation(NS)',&
       answer = xyr_VLat,                                            &
       check = xyr_V0Lat,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking Potential2Rotation(VRad) with rigid rotation(NS)',&
       answer = xyr_VRad,                                            &
       check = xyr_V0Rad,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ----------------- 例 3 --------------------
  ! 渦無し場

  wq_Torvel = 0.0D0
  wq_Polvel = wq_xyr(xyr_Rad * sin(xyr_Lat))

  ! xyr_Vlon = 0
  ! xyr_Vlat = 2 * cos(xyr_Lat)
  ! xyr_Vrad = 2 * sin(xyr_Lat)

  xyr_V0lon = 0.0D0
  xyr_V0lat = 0.0D0
  xyr_V0rad = 0.0D0

  call wq_Potential2Rotation(&
       xyr_VLon,xyr_VLat,xyr_VRad, wq_Torvel, wq_Polvel )

  call AssertEqual(&
       message='Checking Potential2Rotation(VLat) with no rotation',   &
       answer = xyr_VLon,                                            &
       check = xyr_V0Lon,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking Potential2Rotation(VLat) with no rotation',   &
       answer = xyr_VLat,                                            &
       check = xyr_V0Lat,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking Potential2Rotation(VRad) with no rotation',   &
       answer = xyr_VRad,                                            &
       check = xyr_V0Rad,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ----------------- 例 4 --------------------
  ! ポロイダル速度場

  wq_Torvel = 0.0D0
  wq_Polvel = wq_xyr(xyr_Rad **3 * cos(xyr_Lat)*sin(xyr_Lon))

  ! xyr_Vlon = 4 * xyr_Rad**2 * cos(xyr_Lon)
  ! xyr_Vlat = -4 * xyr_Rad**2 * sin(xyr_Lat) * sin(xyr_Lon)
  ! xyr_Vrad = 2 * xyr_Rad**2  * cos(xyr_Lat) * sin(xyr_Lon)

  xyr_V0lon = 10*xyr_Rad*sin(xyr_Lat)*sin(xyr_Lon)
  xyr_V0lat = 10*xyr_Rad*cos(xyr_Lon)
  xyr_V0rad = 0.0D0

  call wq_Potential2Rotation(&
       xyr_VLon,xyr_VLat,xyr_VRad, wq_Torvel, wq_Polvel )

  call AssertEqual(&
       message='Checking Potential2Rotation(VLat) with poloidal field',&
       answer = xyr_VLon,                                            &
       check = xyr_V0Lon,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking Potential2Rotation(VLat) with poloidal field',&
       answer = xyr_VLat,                                            &
       check = xyr_V0Lat,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='Checking Potential2Rotation(VRad) with poloidal field',&
       answer = xyr_VRad,                                            &
       check = xyr_V0Rad,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  call MessageNotify('M','wq_module_sjpack_derivative_test2', &
       'wq_module_sjpack derivative function test #2 succeeded!')

end program wq_module_sjpack_derivative2

!----------------------------------------------------------------------
!     Copyright (c) 2008--2010 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  eee_module テストプログラム
!
!履歴  2008/05/05  竹広真一
!      2010/04/20  竹広真一  Helicity 計算バグフィックス
!
program eee_test_EnergyHelicity

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use eee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=64, km=32          ! 格子点の設定(X,Y,Z)
  integer, parameter :: lm=10, mm=21, nm=10          ! 切断波数の設定(X,Y,Z)

 !---- 変数 ----
  real(8)            :: zyx_VelX(0:km-1,0:jm-1,0:im-1)    ! 格子データ(速度 X)
  real(8)            :: zyx_VelY(0:km-1,0:jm-1,0:im-1)    ! 格子データ(速度 Y)
  real(8)            :: zyx_VelZ(0:km-1,0:jm-1,0:im-1)    ! 格子データ(速度 Z)

  real(8)            :: zyx_VorX(0:km-1,0:jm-1,0:im-1)    ! 格子データ(渦度 X)
  real(8)            :: zyx_VorY(0:km-1,0:jm-1,0:im-1)    ! 格子データ(渦度 Y)
  real(8)            :: zyx_VorZ(0:km-1,0:jm-1,0:im-1)    ! 格子データ(渦度 Z)

  real(8)            :: eee_VorX(-nm:nm,-mm:mm,-lm:lm)    ! スペクトルデータ
  real(8)            :: eee_VorY(-nm:nm,-mm:mm,-lm:lm)    ! スペクトルデータ
  real(8)            :: eee_VorZ(-nm:nm,-mm:mm,-lm:lm)    ! スペクトルデータ

  real(8)            :: eee2_Zeta(-nm:nm,-mm:mm,-lm:lm,2) ! スペクトルデータx2

  real(8)            :: Energy, Helicity
  real(8)            :: EnergyHelicity(2)

 !---- 座標変数など ----
  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer :: l, m, n

  call MessageNotify('M','eee_test_EnergyHelicity', &
       'eee_module Energy and Helicity calculation tests')

 !---------------- 座標値の設定 ---------------------
  call eee_initial(im,jm,km,lm,mm,nm)

 !---------------- 速度・渦度の設定 ---------------------
!!$  write(6,*) '  Input wavenumbers of the grid data, l and m :'
!!$  read(5,*) l,m
  l = 2; m=1
  n = -(l+m)
  write(6,*) '  l,m,n = ', l,m,n

  zyx_VelX = cos(l*zyx_X)*sin(m*zyx_Y)*sin(n*zyx_Z)
  zyx_VelY = sin(l*zyx_X)*cos(m*zyx_Y)*sin(n*zyx_Z)
  zyx_VelZ = sin(l*zyx_X)*sin(m*zyx_Y)*cos(n*zyx_Z)

  zyx_VorX = (m-n)*sin(l*zyx_X)*cos(m*zyx_Y)*cos(n*zyx_Z)
  zyx_VorY = (n-l)*cos(l*zyx_X)*sin(m*zyx_Y)*cos(n*zyx_Z)
  zyx_VorZ = (l-m)*cos(l*zyx_X)*cos(m*zyx_Y)*sin(n*zyx_Z)

  eee_VorX = eee_zyx(zyx_VorX)
  eee_VorY = eee_zyx(zyx_VorY)
  eee_VorZ = eee_zyx(zyx_VorZ)

 !------------- 渦度 ζ への変換と Energy Helicity 計算 -----------------
  eee2_Zeta = eee2_ZetaFromVor_eee_eee_eee(eee_VorX,eee_VorY,eee_VorZ)
  EnergyHelicity = EnergyHelicityFromZeta_eee2(eee2_Zeta)

 !---------------- 格子点で Energy, Helicity の計算 ---------------------
  
  Energy = 0.5 * AvrZYX_zyx(zyx_VelX**2+zyx_VelY**2+zyx_VelZ**2)

  Helicity = AvrZYX_zyx(zyx_VelX*zyx_VorX +zyx_VelY*zyx_VorY + zyx_VelZ*zyx_VorZ)
  

 !---------------- 計算チェック ---------------------
  call AssertEqual(&
    message='Calculation of Energy',                            &
    answer = EnergyHelicity(1),                                 &
    check  = Energy,                                            &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call AssertEqual(&
    message='Calculation of Helicity',                          &
    answer = EnergyHelicity(2),                                 &
    check  = Helicity,                                          &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call MessageNotify('M','eee_test_EnergyHelicity', &
       'eee_module Energy Helicity calulcation tests suceeded')

end program eee_test_EnergyHelicity

!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  eq_module テストプログラム (積分・平均計算)
!
!履歴  2008/04/12  竹広真一
!
program eq_test_intavr

  use dc_message, only : MessageNotify
  use eq_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=16            ! 格子点の設定(Phi,Rad)
  integer, parameter :: km=10, lm=31            ! 切断波数の設定(Phi,Rad)

 !---- 変数 ----
  real(8)            :: rp_Data(jm,0:im-1)    ! 格子データ
  real(8)            :: p_Data(0:im-1)        ! 格子データ
  real(8)            :: r_Data(jm)            ! 格子データ

 !---- 座標変数など ----
  real(8), parameter :: ra=2.0

  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: eps = 1.0d-5            ! 判定誤差

  call MessageNotify('M','eq_test_intvar', &
                     'eq_module integrate/averaging function tests')

 !---------------- 座標値の設定 ---------------------
  call eq_Initial(im,jm,km,lm,ra)                ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
  rp_Data = 1
  write(6,*)
  write(6,*) 'f = 1.0'

    call check0d(IntRadPhi_rp(rp_Data) - pi*ra**2, eps, 'IntRadPhi_rp') 
    call check0d(AvrRadPhi_rp(rp_Data) - 1.0D0, eps, 'AvrRadPhi_rp')

    call check1d(r_IntPhi_rp(rp_Data) - 2*pi, eps, 'r_IntPhi_rp') 
    call check1d(r_AvrPhi_rp(rp_Data) - 1.0D0, eps, 'r_AvrPhi_rp')

    call check1d(p_IntRad_rp(rp_Data) - ra**2/2, eps, 'p_IntRad_rp')
    call check1d(p_AvrRad_rp(rp_Data) - 1.0, eps, 'p_AvrRad_rp')

  rp_Data = sin(rp_Phi) * rp_Rad**3
  write(6,*) 'f = sin(Phi)*Rad**3'

    call check0d(IntRadPhi_rp(rp_Data)-0.0, eps, 'IntRadPhi_rp') 
    call check0d(AvrRadPhi_rp(rp_Data)-0.0, eps, 'AvrRadPhi_rp')

    call check1d(r_IntPhi_rp(rp_Data) - 0.0, eps, 'r_IntPhi_rp') 
    call check1d(r_AvrPhi_rp(rp_Data) - 0.0, eps, 'r_AvrPhi_rp') 

    call check1d(p_IntRad_rp(rp_Data) - 1/5.0d0 *ra**5 * sin(p_Phi), eps, 'p_IntRad_rp')
    call check1d(p_AvrRad_rp(rp_Data) - 2/5.0d0 *ra**3 * sin(p_Phi), eps, 'p_AvrRad_rp')

  rp_Data = (1 - sin(rp_Phi))
  write(6,*)
  write(6,*) 'f = (1-sin(Phi)'

    call check0d(IntRadPhi_rp(rp_Data) - pi*ra**2, eps, 'IntRadPhi_rp') 
    call check0d(AvrRadPhi_rp(rp_Data) - 1.0D0, eps, 'AvrRadPhi_rp')

    call check1d(r_IntPhi_rp(rp_Data) - 2*pi, eps, 'r_IntPhi_rp') 
    call check1d(r_AvrPhi_rp(rp_Data) - 1.0D0, eps, 'r_AvrPhi_rp')

    call check1d(p_IntRad_rp(rp_Data) - (1 - sin(p_Phi))*ra**2/2, eps, 'p_IntRad_rp')
    call check1d(p_AvrRad_rp(rp_Data) - (1 - sin(p_Phi)), eps, 'p_AvrRad_rp')

  p_Data = 1 - sin(2*p_Phi)
  write(6,*)
  write(6,*) 'f = 1-sin(2*pi*Phi)'

    call check0d(IntPhi_p(p_Data) - 2.0*pi, eps, 'IntPhi_p')
    call check0d(AvrPhi_p(p_Data) - 1.0d0, eps, 'AvrPhi_p')

  r_Data = r_Rad**2
  write(6,*)
  write(6,*) 'f = Rad**2'

    call check0d(IntRad_r(r_Data) - 1.0D0/4.0D0*ra**4, eps, 'IntRad_r')
    call check0d(AvrRad_r(r_Data) - 1.0D0/2.0D0*ra**2, eps, 'AvrRad_r')

  call MessageNotify('M','eq_test_intvar', &
                     'eq_module integrate/averaging function tests succeeded!')
 stop
contains

  subroutine check1d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:)                  ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    integer i

    if ( present(funcname) )then
       write(6,*) '  Checking ', funcname, '...'
    endif

    do i=1,size(var)
       if (abs(var(i)) .gt. eps ) then
          write(6,*) '    Value larger than EPS : i= ', i, var(i)
          call MessageNotify('E','eq_test_intavr', &
               'Integrate/Avrage error too large.')
       endif
    enddo
  end subroutine check1d

  subroutine check0d(var,eps,funcname)   ! var の絶対値が eps 以上だと出力
    real(8) :: var                       ! 判定する配列
    real(8) :: eps                       ! 誤差
    real(8) :: vartmp(1)                 ! 
    character(len=*), optional :: funcname

    vartmp(1) = var
    if ( present(funcname) ) then
       call check1d(vartmp,eps,funcname)
    else
       call check1d(vartmp,eps)
    endif
  end subroutine check0d

end program eq_test_intavr

!--
!----------------------------------------------------------------------
! Copyright (c) 2008--2013 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  w_zonal_module
!
!   spml/w_zonal_module モジュールは球面上での経度方向に一様な帯状的 
!   1 次元流体運動をルジャンドル多項式を用いたスペクトル法によって
!   数値計算するための Fortran90 関数を提供する. 
!
!   内部で l_module を用いている. 最下部ではルジャンドル多項式変換
!   のエンジンとして ISPACK の Fortran77 サブルーチンを用いている.
!
!   w_zonal_modulde で提供される関数・サブルーチンは 2 次元的流体運動を扱う 
!   w_module モジュールで用いられているものと名前およびインターフェースが
!   共通になるように設計してある. したがって, w_module を用いて構成された
!   2 次元モデルを帯状方向に一様な 1 次元軸対称モデルへと改造するには
!   次の手順が必要となる. 
!
!      * use 文での w_module の引用を w_zonal_module に変更する. 
!      * 配列の大きさを経度方向格子点数 im -> 1 に, 
!        水平波数を (nm+1)**2 -> nm+1 に変更する. 
!      * DO 文で水平波数に関してループを回しているところを
!        (nm+1)**2 -> nm+1 に変更する. 
!      * gtool 出力の次元変数変更する. 
!
!
!履歴  2008/12/28  竹広真一  w_module より軸対称モデル用に改造
!      2009/01/08  竹広真一  w_Initial メッセージに日付を追加
!      2013/02/14  竹広真一  w_StreamPotential2Vector,  
!                            w_Vector2VorDiv, w_VectorCosLat2VorDiv 導入
!      2013/02/24  竹広真一  w_Finalize 導入
!
!++
module w_zonal_module
  !
  != w_zonal_module
  !
  ! Authors:: Shin-ichi Takehiro
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/w_zonal_module モジュールは球面上での経度方向に一様な帯状的 
  ! 1 次元流体運動をルジャンドル多項式を用いたスペクトル法によって
  ! 数値計算するための Fortran90 関数を提供する. 
  !
  ! 内部で l_module を用いている. 最下部ではルジャンドル多項式変換
  ! のエンジンとして ISPACK の Fortran77 サブルーチンを用いている.
  !
  ! w_zonal_modulde で提供される関数・サブルーチンは 2 次元的流体運動を扱う 
  ! w_module モジュールで用いられているものと名前およびインターフェースが
  ! 共通になるように設計してある. したがって, w_module を用いて構成された
  ! 2 次元モデルを帯状方向に一様な 1 次元軸対称モデルへと改造するには
  ! 次の手順が必要となる. 
  !
  ! 1. use 文での wt_module の引用を w_zonal_module に変更する. 
  ! 2. 配列の大きさを経度方向格子点数 im -> 1 に, 
  !    水平波数を (nm+1)**2 -> nm+1 に変更する. 
  ! 3. DO 文で水平波数に関してループを回しているところを
  !    (nm+1)**2 -> nm+1 に変更する. 
  ! 4. gtool 出力の次元変数変更する. 
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (w_, nm_, n_, xy_, x_, y_) は, 返す値の形を示している.
  !   w_   ::  スペクトルデータ
  !   xy_  ::  2 次元格子点データ
  !   nm_  ::  スペクトルデータの並んだ 3 次元配列(スペクトルデータの並びは
  !            全波数 n, 帯状波数 m で指定される 2 次元配列)
  !   n_   ::  スペクトルデータの並んだ 2 次元配列 (スペクトルデータの並びは
  !            全波数 n で指定される 1 次元配列)
  !   x_   ::  経度方向 1 次元格子点データ
  !   y_   ::  緯度方向 1 次元格子点データ
  !
  ! * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla, 
  !   LaplaInv, Jacobian)は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_w_w, _w, _xy, _x, _y) は, 入力変数の形スペクトルデータ
  !   および格子点データであることを示している.
  !   _w   :: スペクトルデータ
  !   _w_w :: 2 つのスペクトルデータ
  !   _xy  :: 2 次元格子点データ
  !   _x   :: 経度方向 1 次元格子点データ
  !   _y   :: 緯度方向 1 次元格子点データ
  !
  !=== 各データの種類の説明
  !
  ! * xy : 2 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(0:im-1,1:jm). 
  !   * im, jm はそれぞれ経度, 緯度座標の格子点数であり, サブルーチン
  !     w_Initial にてあらかじめ設定しておく.
  !
  ! * w : スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(nm+1). 
  !   * nm はルジャンドル多項式の最大次数であり, サブルーチン w_Initial にて
  !     あらかじめ設定しておく. w_module と配列の大きさが異なることに注意. 
  !
  ! * nm : スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,-nm:nm). 
  !     第 1 次元が水平全波数,  第 2 次元が帯状波数(ダミー)を表す. 
  !   * nm はルジャンドル多項式の最大次数であり, サブルーチン w_Initial にて
  !     あらかじめ設定しておく.
  !
  ! * n : スペクトルデータの並んだ 1 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm). 
  !   * 第 1 次元が水平全波数を表す. nm は球面調和函数の最大全波数であり, 
  !     サブルーチン w_Initial にてあらかじめ設定しておく.
  !
  ! * x, y : 経度, 緯度方向 1 次元格子点データ.
  !   * 変数の種類と次元はそれぞれ real(8), dimension(0:im-1) 
  !     および real(8), dimension(1:jm).
  !
  ! * w_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * xy_ で始まる関数が返す値は 2 次元格子点データに同じ.
  !
  ! * x_, y_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! w_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! 
  !==== 終了処理 
  !
  ! w_Finalize :: モジュールの終了処理(割り付け配列の解放)をおこなう. 
  ! 
  !==== 座標変数
  !
  ! x_Lon, y_Lat     ::  格子点座標(緯度, 経度座標)を格納した 1 次元配列
  ! x_Lon_Weight, y_Lat_Weight ::  重み座標を格納した 1 次元配列
  ! xy_Lon, xy_Lat   :: 格子点データの経度・緯度座標(X,Y)
  !                     (格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! xy_w :: スペクトルデータから格子データへの変換
  ! w_xy :: 格子データからスペクトルデータへの変換
  ! l_nm, nm_l :: スペクトルデータの格納位置と全波数・帯状波数の変換 
  !
  !==== 微分
  !
  ! w_Lapla_w       :: スペクトルデータにラプラシアンを作用させる
  ! rn              :: スペクトルデータのラプラシアンを計算するための係数. 
  ! irm             :: 経度微分演算用配列
  ! w_LaplaInv_w    :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! w_DLon_w        :: スペクトルデータに経度微分∂/∂λを作用させる
  ! xy_GradLon_w    :: スペクトルデータに
  !                    勾配型経度微分 1/cosφ・∂/∂λを作用させる
  ! xy_GradLat_w    :: スペクトルデータに勾配型緯度微分∂/∂φを作用させる
  ! w_DivLon_xy     :: 格子データに
  !                    発散型経度微分 1/cosφ・∂/∂λを作用させる
  ! w_DivLat_xy     :: 格子データに
  !                    発散型緯度微分 1/cosφ・∂(g cosφ)/∂φを作用させる
  ! w_Div_xy_xy     :: ベクトル成分である 2 つの格子データに発散を作用させる
  ! w_Jacobian_w_w  :: 2 つのスペクトルデータからヤコビアンを計算する
  !
  ! w_StreamPotential2Vector :: 流線ポテンシャルから速度場計算
  ! w_Vector2VorDiv   :: 速度場から渦度発散を計算
  ! w_VectorCosLat2VorDiv   :: 速度場から渦度発散を計算
  !
  !==== 微分(λ,μ=sinφ 座標)
  !
  ! xy_GradLambda_w :: スペクトルデータに勾配型経度微分∂/∂λを作用させる
  ! xy_GradMu_w     :: スペクトルデータに
  !                    勾配型緯度微分 (1-μ^2)∂/∂μを作用させる
  ! w_DivLambda_xy  :: 格子データに
  !                    発散型経度微分 1/(1-μ^2)・∂/∂λを作用させる
  ! w_DivMu_xy      :: 格子データに発散型緯度微分∂/∂μを作用させる
  !
  !==== 補間
  !
  ! Interpolate_w :: スペクトルデータから任意の点での値を求める. 
  !
  !==== 積分・平均
  !
  ! IntLonLat_xy, AvrLonLat_xy :: 2 次元格子点データの全領域積分および平均
  ! y_IntLon_xy, y_AvrLon_xy   :: 2 次元格子点データの経度方向積分および平均
  ! IntLon_x, AvrLon_x         :: 1 次元(X)格子点データの経度方向積分および平均
  ! x_IntLat_xy, x_AvrLat_xy   :: 2 次元格子点データの緯度方向積分および平均
  ! IntLat_y, AvrLat_y         :: 1 次元(Y)格子点データの緯度方向積分および平均
  !
  !==== スペクトル解析
  !
  ! nm_EnergyFromStreamfunc_w  :: 流線関数からエネルギースペクトルを
  !                               計算する (水平全波数 n, 帯状波数 m 空間)
  ! n_EnergyFromStreamfunc_w   :: 流線関数からエネルギースペクトルを
  !                               計算する (水平全波数 n 空間) 
  ! nm_EnstrophyFromStreamfunc_w  :: 流線関数からエンストロフィースペクトルを
  !                                  計算する (水平全波数 n, 帯状波数 m 空間)
  ! n_EnstrophyFromStreamfunc_w   :: 流線関数からエンストロフィースペクトルを
  !                                  計算する (水平全波数 n 空間)
  ! w_spectrum_VMiss              ::  欠損値
  !
  !
  use dc_message
  use l_module, w_y => l_y, y_w => y_l, &
       y_GradLat_w => y_GradLat_l, w_DivLat_y => l_DivLat_y, &
       w_Lapla_w => l_Lapla_l, w_LaplaInv_w => l_LaplaInv_l, &
       Interpolate_alat_w => Interpolate_l

  implicit none

  integer               :: im=64            ! 格子点の設定(東西)
  integer               :: jm=32            ! 格子点の設定(南北)
  integer               :: nm=21            ! 切断波数の設定
  integer               :: np=1             ! OPENMP 最大スレッド数

  real(8), allocatable  :: x_Lon(:)                  ! 経度経度
  real(8), allocatable  :: x_Lon_Weight(:)           ! 座標重み
  real(8), allocatable  :: xy_Lon(:,:), xy_Lat(:,:)

  real(8), allocatable  :: rn(:,:)
  integer, allocatable  :: irm(:,:)

  real(8), parameter    :: pi=3.1415926535897932385D0

  real(8) :: w_spectrum_VMiss = -999.000    ! 欠損値初期値

  logical               :: w_initialize = .false.  ! 初期化フラグ

  private

  public w_Initial                            ! 初期化
  public w_Finalize                           ! 終了処理

  public x_Lon, y_Lat                         ! 格子座標
  public x_Lon_weight, y_Lat_Weight           ! 格子座標重み
  public xy_Lon, xy_Lat                       ! 格子座標(im,jm)
  public xy_w, w_xy, l_nm, nm_l               ! 変換関数

  public rn, irm                              ! ラプラシアン/経度微分演算用配列

  public w_Lapla_w, w_LaplaInv_w              ! ラプラシアンと逆演算
  public w_DLon_w                             ! 経度微分
  public xy_GradLon_w, xy_GradLat_w           ! 勾配型微分
  public w_DivLon_xy, w_DivLat_xy             ! 発散型微分
  public w_Div_xy_xy                          ! 発散型微分
  public w_Jacobian_w_w                       ! ヤコビアン

  public w_StreamPotential2Vector             ! 流線ポテンシャルから速度場計算
  public w_Vector2VorDiv                      ! 速度場から渦度発散を計算
  public w_VectorCosLat2VorDiv                ! 速度場から渦度発散を計算

  public xy_GradLambda_w, xy_GradMu_w         ! 勾配型微分(λ,μ座標)
  public w_DivLambda_xy, w_DivMu_xy           ! 発散型微分(λ,μ座標)

  public Interpolate_w                        ! 補間関数

  public IntLonLat_xy                         ! 緯度経度積分
  public y_IntLon_xy, IntLon_x                ! 経度積分    
  public x_IntLat_xy, IntLat_y                ! 緯度積分    
  public AvrLonLat_xy                         ! 緯度経度平均
  public y_AvrLon_xy, AvrLon_x                ! 経度平均    
  public x_AvrLat_xy, AvrLat_y                ! 緯度平均    

  public nm_EnergyFromStreamfunc_w            ! エネルギースペクトル           
                                              ! (水平全波数 n, 帯状波数 m 空間)
  public n_EnergyFromStreamfunc_w             ! エネルギースペクトル
                                              ! (水平全波数 n 空間) 
  public nm_EnstrophyFromStreamfunc_w         ! エンストロフィースペクトル     
                                              ! (水平全波数 n, 帯状波数 m 空間)
  public n_EnstrophyFromStreamfunc_w          ! エンストロフィースペクトル  
                                              !  (水平全波数 n 空間)
  public w_spectrum_VMiss                     ! 欠損値

  interface l_nm
     module procedure l_nm_array00
     module procedure l_nm_array01
     module procedure l_nm_array10
     module procedure l_nm_array11
  end interface

  interface nm_l
     module procedure nm_l_int
     module procedure nm_l_array
  end interface

  save im, jm, nm                             ! 格子点数, 切断波数を記憶

contains

  !--------------- 初期化 -----------------
    subroutine w_initial(n_in,i_in,j_in,np_in)
      !
      ! スペクトル変換の格子点数, 波数および OPENMP 使用時の
      ! 最大スレッド数を設定する.
      !
      ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
      ! しなければならない. 
      !
      ! np_in は w_module との互換性のためにおいているだけである. 
      ! OPENMP 計算は実装されていない. 
      !
      integer,intent(in) :: i_in              !(in) 格子点数(東西)
      integer,intent(in) :: j_in              !(in) 格子点数(南北)
      integer,intent(in) :: n_in              !(in) 切断波数の設定
      integer,intent(in), optional :: np_in   !(in) OPENMP での最大スレッド数

      integer :: i, j, n

      if ( present (np_in) )then
         call MessageNotify('W','w_initial','OPENMP calculation not supported')
      endif

      if ( i_in /= 1  )then
         call MessageNotify('W','w_initial','Longitudinal dimension should be 1')
      endif

      im = i_in  ; jm = j_in  ; nm = n_in

      allocate(x_Lon(0:im-1))                ! 格子点座標格納配列(経度)
      allocate(x_Lon_Weight(0:im-1))
      allocate(xy_Lon(0:im-1,1:jm))
      allocate(xy_Lat(0:im-1,1:jm))          ! 格子点座標格納配列

      allocate(rn(0:nm,2),irm(nm+1,2))

      call l_initial(n_in,j_in)

      do i=0,im-1
         x_Lon(i)  = 2*pi/im*i               ! 経度座標
         x_Lon_Weight(i) = 2*pi/im           ! 経度座標重み
      enddo

      do j=1,jm
         xy_Lon(:,j) = x_Lon
      enddo

      do i=0,im-1
         xy_Lat(i,:) = y_Lat
      enddo

      do n=0,nm
         rn(n,1) = -n*(n+1)
      enddo

      rn(0,2) = 1.0D0
      do n=1,nm
         rn(n,2) = -1/(n*(n+1))
      enddo

      do n=1,nm+1
         irm(n,1) = n
         irm(n,2) = 0
      enddo
      
      w_initialize = .true.

      call MessageNotify('M','w_initial',&
           'w_zonal_module (2013/02/24) is initialized')

    end subroutine w_initial

  !--------------- 基本変換 -----------------

    function l_nm_array00(n,m)
      !
      ! 全波数(n)と東西波数(m,ダミー)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 引数 n,m がともに整数値の場合, 整数値を返す. 
      !
      integer               :: l_nm_array00   
      !(out) スペクトルデータの格納位置 

      integer, intent(in)   :: n     !(in) 全波数
      integer, intent(in)   :: m     !(in) 帯状波数           

      if ( m /= 0 ) then
         call MessageNotify('E','l_nm_array00', &
              'zonal wavenumber should be zero in w_zonal_module')
      end if

      l_nm_array00 = n+1

    end function l_nm_array00

    function l_nm_array01(n,marray)           ! スペクトルデータの格納位置 
      !
      ! 全波数(n)と東西波数(m, ダミー)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 第 1 引数 n が整数, 第 2 引数 marray が整数 1 次元配列の場合, 
      ! marray と同じ大きさの 1 次元整数配列を返す. 
      !
      integer, intent(in)  :: n               !(in) 全波数
      integer, intent(in)  :: marray(:)       !(in) 帯状波数
      integer              :: l_nm_array01(size(marray))
      !(out) スペクトルデータ位置

      integer              :: i 

      do i=1, size(marray)
         l_nm_array01(i) = l_nm_array00(n,marray(i))
      enddo
    end function l_nm_array01

    function l_nm_array10(narray,m)
      !
      ! 全波数(n)と東西波数(m,ダミー)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 第 1 引数 narray が整数 1 次元配列, 第 2 引数  m が整数の場合, 
      ! narray と同じ大きさの 1 次元整数配列を返す. 
      !
      integer, intent(in)  :: narray(:)           !(in) 全波数  
      integer, intent(in)  :: m                   !(in) 帯状波数
      integer              :: l_nm_array10(size(narray))
      !(out) スペクトルデータ位置

      integer              :: i 

      do i=1, size(narray)
         l_nm_array10(i) = l_nm_array00(narray(i),m)
      enddo
    end function l_nm_array10

    function l_nm_array11(narray,marray)
      !
      ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 第 1,2 引数 narray, marray がともに整数 1 次元配列の場合, 
      ! narray, marray と同じ大きさの 1 次元整数配列を返す. 
      ! narray, marray は同じ大きさでなければならない. 
      !
      integer, intent(in)  :: narray(:)          !(in) 全波数  
      integer, intent(in)  :: marray(:)          !(in) 帯状波数
      integer              :: l_nm_array11(size(narray))
      !(out) スペクトルデータ位置

      integer              :: i 

      if ( size(narray) .ne. size(marray) ) then
         call MessageNotify('E','l_nm_array11',&
              'dimensions of input arrays  n and m are different.')
      endif

      do i=1, size(narray)
         l_nm_array11(i) = l_nm_array00(narray(i),marray(i))
      enddo
    end function l_nm_array11

    function nm_l_int(l)
      ! 
      ! スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
      !
      ! 引数 l が整数値の場合, 対応する全波数と帯状波数を
      ! 長さ 2 の 1 次元整数値を返す. 
      ! nm_l(1) が全波数, nm_l(2) が帯状波数である. 
      !
      integer               :: nm_l_int(2)  !(out) 全波数, 帯状波数
      integer, intent(in)   :: l            !(in) スペクトルデータの格納位置
      
      nm_l_int(1) = l-1
      nm_l_int(2) = 0
    end function nm_l_int

    function nm_l_array(larray)
      ! 
      ! スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
      !
      ! 引数 larray が整数 1 次元配列の場合, 
      ! larray に対応する n, m を格納した 2 次元整数配列を返す. 
      ! nm_l_array(:,1) が全波数, nm_l_array(:,2) が帯状波数である. 
      !
      integer, intent(in)  :: larray(:)
      !(out) 全波数, 帯状波数

      integer              :: nm_l_array(size(larray),2)
      !(in) スペクトルデータの格納位置

      integer              :: i

      do i=1, size(larray)
         nm_l_array(i,:) = nm_l_int(larray(i))
      enddo
    end function nm_l_array

    function xy_w(w_data,ipow,iflag)
      !
      ! スペクトルデータから格子データへ変換する(1 層用).
      !
      real(8)               :: xy_w(0:im-1,1:jm)
      !(out) 格子点データ

      real(8), intent(in)   :: w_data(nm+1)
      !(in) スペクトルデータ

      integer, intent(in), optional  :: ipow      
      !(in) 作用させる 1/cosφ の次数. 省略時は 0. 

      integer, intent(in), optional  :: iflag
      !(in) 変換の種類
      !    0 : 通常の正変換
      !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
      !   -1 : 経度微分を作用させた逆変換
      !    2 : sinφを作用させた逆変換(非実装)
      !    省略時は 0.
      !
      integer, parameter  :: ipow_default  = 0
      integer, parameter  :: iflag_default = 0

      integer ipval, ifval, i

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      if ( ifval == -1 ) then                          ! 経度微分は 0 
         xy_w = 0.0D0        
      else if ( ifval == 1 ) then                    ! 緯度微分
         do i=0,im-1
            xy_w(i,:) = y_GradLat_w(w_data) * cos(y_Lat)
         enddo
      else if ( ifval == 2 ) then                     ! sinφ をかけた逆変換
         do i=0,im-1
            xy_w(i,:) = y_w(w_data)
         enddo
         xy_w = xy_w * sin(xy_Lat)
      else
         do i=0,im-1
            xy_w(i,:) = y_w(w_data)
         enddo
      endif

      if ( ipval /= 0 ) then
         xy_w = xy_w/cos(xy_Lat)**ipval
      end if

    end function xy_w

    function w_xy(xy_data,ipow,iflag)
      !
      ! 格子データからスペクトルデータへ(正)変換する(1 層用).
      !
      real(8)               :: w_xy(nm+1)
      !(out) スペクトルデータ

      real(8), intent(in)   :: xy_data(0:im-1,1:jm)
      !(in) 格子点データ

      integer, intent(in), optional  :: ipow
      !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

      integer, intent(in), optional  :: iflag
      ! 変換の種類
      !    0 : 通常の正変換
      !    1 : 緯度微分 1/cosφ・∂(f cos^2φ)/∂φ を作用させた正変換
      !   -1 : 緯度微分を作用させた正変換
      !    2 : sinφを作用させた正変換
      !  省略時は 0.


      integer, parameter  :: ipow_default  = 0    ! スイッチデフォルト値
      integer, parameter  :: iflag_default = 0    ! スイッチデフォルト値

      integer ipval, ifval

      real(8)             :: xy_work(0:im-1,1:jm) ! 格子点データ作業配列

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      xy_work = xy_data/cos(xy_Lat)**ipval

      if ( ifval == -1 ) then                         ! 経度微分は 0 
         w_xy = 0.0D0        
      else if ( ifval == 1 ) then                     ! 緯度微分
         xy_work = xy_work * cos(xy_Lat)
         w_xy = w_DivLat_y(xy_work(0,:))
      else if ( ifval == 2 ) then                     ! sinφ をかけた正変換
         xy_work = xy_work * sin(xy_Lat)
         w_xy = w_y(xy_work(0,:))
      else
         w_xy = w_y(xy_work(0,:))
      endif
      
    end function w_xy

  !--------------- 微分計算 -----------------
    function w_DLon_w(w_data)
      !
      ! スペクトルデータに経度微分 ∂/∂λ を作用させる(1 層用).
      !
      ! スペクトルデータの経度微分とは, 対応する格子点データに
      ! 経度微分∂/∂λを作用させたデータのスペクトル変換のことである.
      ! 
      real(8)              :: w_DLon_w(nm+1)
      !(out) スペクトルデータの経度微分

      real(8), intent(in)  :: w_data(nm+1)
      !(in) 入力スペクトルデータ

      w_DLon_w = 0.0D0

    end function w_DLon_w

    function xy_GradLon_w(w_data)
      !
      ! スペクトルデータに勾配型経度微分 1/cosφ・∂/∂λ を
      ! 作用させた格子点データを返す(1 層用).
      !
      real(8)              :: xy_GradLon_w(0:im-1,1:jm)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      real(8), intent(in)  :: w_data(nm+1)
      !(in) 入力スペクトルデータ

      xy_GradLon_w = xy_w(w_data,ipow=1,iflag=-1)

    end function xy_GradLon_w

    function xy_GradLat_w(w_data)
      !
      ! スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させて
      ! 格子点データに変換して返す(1 層用).
      !
      real(8)              :: xy_GradLat_w(0:im-1,1:jm)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      real(8), intent(in)  :: w_data(nm+1)
      !(in) 入力スペクトルデータ

      xy_GradLat_w = xy_w(w_data,ipow=1,iflag=1)

    end function xy_GradLat_w

    function w_DivLon_xy(xy_data)
      !
      ! 格子点データに発散型経度微分 1/cosφ・∂/∂λ を作用させて
      ! スペクトルデータに変換して返す(1 層用).
      !
      real(8)              :: w_DivLon_xy(nm+1)
      !(out) 格子点データを発散型経度微分したスペクトルデータ
      real(8), intent(in)  :: xy_data(0:im-1,1:jm)
      !(in) 入力格子点データ

      w_DivLon_xy = w_xy(xy_data,ipow=1,iflag=-1)

    end function w_DivLon_xy

    function w_DivLat_xy(xy_data)
      !
      ! 格子点データに発散型緯度微分 1/cosφ・∂(f cosφ)/∂φ を作用させて
      ! スペクトルデータに変換して返す(1 層用).
      !
      real(8)              :: w_DivLat_xy(nm+1)
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      real(8), intent(in)  :: xy_data(0:im-1,1:jm)
      !(in) 入力格子点データ

      w_DivLat_xy = w_xy(xy_data,ipow=1,iflag=1)

    end function w_DivLat_xy

    function w_Div_xy_xy(xy_u,xy_v)
      !
      ! 2 つの入力格子点データをベクトル成分とする発散を計算し, 
      ! スペクトルデータとして返す(1 層用).
      !
      real(8)              :: w_Div_xy_xy(nm+1)
      !(out) 2 つの入力格子点データをベクトル成分とする発散のスペクトルデータ

      real(8), intent(in)  :: xy_u(0:im-1,1:jm)
      !(in) ベクトル経度成分の格子点データ

      real(8), intent(in)  :: xy_v(0:im-1,1:jm)
      !(in) ベクトル緯度成分の格子点データ

      w_Div_xy_xy = w_Divlon_xy(xy_u) + w_Divlat_xy(xy_v)

    end function w_Div_xy_xy

    function w_Jacobian_w_w(w_a,w_b)
      ! 2 つのスペクトルデータにヤコビアン
      !
      !   J(f,g) = ∂f/∂λ・∂g/∂μ - ∂g/∂λ・∂f/∂μ
      !          = ∂f/∂λ・1/cosφ・∂g/∂φ
      !             - ∂g/∂λ・1/cosφ・∂f/∂φ
      !
      ! を作用させる(1 層用).

      real(8)             :: w_Jacobian_w_w(nm+1)
      !(out) 2 つのスペクトルデータのヤコビアン

      real(8), intent(in) :: w_a(nm+1)
      !(in) 1つ目の入力スペクトルデータ
      
      real(8), intent(in) :: w_b(nm+1)
      !(in) 2つ目の入力スペクトルデータ

      w_Jacobian_w_w = 0.0D0      

    end function w_Jacobian_w_w

  !----------- 速度, 渦度・発散, 流線・ポテンシャル計算 -------------

    subroutine w_StreamPotential2Vector(w_Psi, w_Chi, xy_U, xy_V)
      !
      ! 流線・ポテンシャル(スペクトルデータ)から速度場(格子データ)に
      ! (逆)変換する(1 層用)
      !
      !   u cosφ =      ∂χ/∂λ - cosφ∂ψ/∂φ, 
      !   v cosφ = cosφ∂χ/∂φ +      ∂ψ/∂λ 
      !
      real(8), intent(in)   :: w_Psi(nm+1)
      !(in) 流線関数
      real(8), intent(in)   :: w_Chi(nm+1)
      !(in) 速度ポテンシャル

      real(8), intent(out)   :: xy_U(0:im-1,1:jm)
      !(out) 速度経度成分
      real(8), intent(out)   :: xy_V(0:im-1,1:jm)
      !(out) 速度緯度成分
      !
      !   u cosφ = - cosφ∂ψ/∂φ の計算
      !
      xy_U = - xy_GradLat_w(w_Psi)
      !
      !   v cosφ = cosφ∂χ/∂φ の計算
      !
      xy_V = xy_GradLat_w(w_Chi)

    end subroutine w_StreamPotential2Vector

    subroutine w_Vector2VorDiv(xy_U, xy_V, w_Vor, w_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(1 層用)
      ! 
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xy_U(0:im-1,1:jm)
      !(in) 速度経度成分
      real(8), intent(in)   :: xy_V(0:im-1,1:jm)
      !(in) 速度緯度成分

      real(8), intent(out)   :: w_Vor(nm+1)
      !(out) 流線関数
      real(8), intent(out)   :: w_Div(nm+1)
      !(out) 速度ポテンシャル
      !
      !   ζ =  - 1/cosφ ∂(u cosφ)/∂φ の計算
      !
      w_Vor = - w_DivLat_xy(xy_U)
      !
      !    D =    1/cosφ ∂(v cosφ)/∂φ の計算
      !
      w_Div = w_DivLat_xy(xy_V)

    end subroutine w_Vector2VorDiv

    subroutine w_VectorCosLat2VorDiv(xy_UCosLat, xy_VCosLat, w_Vor, w_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(1 層用)
      ! 
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xy_UCosLat(0:im-1,1:jm)
      !(in) 速度経度成分 * cos(lat)
      real(8), intent(in)   :: xy_VCosLat(0:im-1,1:jm)
      !(in) 速度緯度成分 * cos(lat)

      real(8), intent(out)   :: w_Vor(nm+1)
      !(out) 流線関数
      real(8), intent(out)   :: w_Div(nm+1)
      !(out) 速度ポテンシャル
      !
      !   ζ =  - 1/cosφ ∂(u cosφ)/∂φ の計算
      !
      w_Vor = - w_xy(xy_UCosLat,ipow=2,iflag=1)
      !
      !    D =    1/cosφ ∂(v cosφ)/∂φ の計算
      !
      w_Div = w_xy(xy_VCosLat,ipow=2,iflag=1)

    end subroutine w_VectorCosLat2VorDiv

  !--------------- 微分計算 (λ,μ座標系用) -----------------
    function xy_GradLambda_w(w_data)
      !
      ! スペクトルデータに勾配型経度微分 ∂/∂λ を作用する(1 層用).
      !
      real(8)              :: xy_GradLambda_w(0:im-1,1:jm)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      real(8), intent(in)  :: w_data(nm+1)
      !(in) 入力スペクトルデータ
      
      xy_GradLambda_w = xy_w(w_data,ipow=0,iflag=-1)

    end function xy_GradLambda_w

    function xy_GradMu_w(w_data)
      !
      ! スペクトルデータに勾配型緯度微分 (1-μ^2)∂/∂μ  (μ=sinφ)
      ! を作用させて格子点データに変換して返す(1 層用).
      !
      real(8)              :: xy_GradMu_w(0:im-1,1:jm)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      real(8), intent(in)  :: w_data(nm+1)
      !(in) 入力スペクトルデータ

      xy_GradMu_w = xy_w(w_data,ipow=0,iflag=1)

    end function xy_GradMu_w

    function w_DivLambda_xy(xy_data)
      !
      ! 格子点データに発散型経度微分 1/(1-μ^2)・∂/∂λ (μ=sinφ) 
      ! を作用させてスペクトルデータに変換して返す(1 層用).
      !
      real(8)              :: w_DivLambda_xy(nm+1)
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      real(8), intent(in)  :: xy_data(0:im-1,1:jm)
      !(in) 入力格子点データ

      w_DivLambda_xy = w_xy(xy_data,ipow=2,iflag=-1)

    end function w_DivLambda_xy

    function w_DivMu_xy(xy_data)
      !
      ! 格子点データに発散型緯度微分 ∂/∂μ (μ=sinφ)を作用させて
      ! スペクトルデータに変換して返す(1 層用).
      !
      real(8)              :: w_DivMu_xy(nm+1)
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      real(8), intent(in)  :: xy_data(0:im-1,1:jm)
      !(in) 入力格子点データ

      w_DivMu_xy = w_xy(xy_data,ipow=2,iflag=1)

    end function w_DivMu_xy

  !--------------- 補間計算 -----------------
    function Interpolate_w(w_data,alon,alat)
      real(8), intent(IN) :: w_data(nm+1)   ! スペクトルデータ
      real(8), intent(IN) :: alon           ! 補間する位置(経度)
      real(8), intent(IN) :: alat           ! 補間する位置(緯度)
      real(8)             :: Interpolate_w  ! 補間した値
      
      Interpolate_w = Interpolate_alat_w(w_data,alat)

    end function Interpolate_w

  !--------------- 積分計算 -----------------
    function IntLon_x(x_data)
      !
      ! 1 次元経度(X)格子点データの X 方向積分(1 層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
      !
      real(8), intent(in) :: x_data(0:im-1)   !(in)  1 次元経度(X)格子点データ
      real(8)             :: IntLon_x         !(out) 積分値

      IntLon_x = sum(x_data * x_Lon_weight)

    end function IntLon_x

    function x_IntLat_xy(xy_data)
      !
      ! 2 次元緯度経度格子点データの緯度(Y)方向積分(1 層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: xy_data(0:im-1,1:jm)           
      !(in) 2 次元経度緯度格子点データ(0:im-1,1:jm)

      real(8)             :: x_IntLat_xy(0:im-1) 
      !(out) 積分された 1 次元経度(X)格子点データ

      integer :: j

      x_IntLat_xy = 0.0D0
      do j=1,jm
         x_IntLat_xy = x_IntLat_xy + xy_data(:,j) * y_Lat_weight(j)
      enddo

    end function x_IntLat_xy

    function y_IntLon_xy(xy_data)
      !
      ! 2 次元緯度経度格子点データの経度(X)方向積分(1 層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: xy_data(0:im-1,1:jm)
      !(in) 2 次元経度緯度格子点データ(0:im-1,1:jm)

      real(8)             :: y_IntLon_xy(1:jm)
      !(out) 積分された 1 次元緯度(Y)格子点データ

      integer :: i

      y_IntLon_xy = 0.0D0
      do i=0,im-1
         y_IntLon_xy = y_IntLon_xy + xy_data(i,:) * x_Lon_weight(i)
      enddo

    end function y_IntLon_xy

    function IntLonLat_xy(xy_data)
      !
      ! 2 次元緯度経度格子点データの全領域積分(1 層用). 
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), intent(in)   :: xy_data(0:im-1,1:jm)         
      !(in) 2 次元経度緯度格子点データ(0:im-1,1:jm)

      real(8) :: IntLonLat_xy                         
      !(out) 積分値

      IntLonLat_xy = IntLon_x(x_IntLat_xy(xy_data))

    end function IntLonLat_xy

  !--------------- 平均計算 -----------------
    function AvrLon_x(x_data)
      !
      ! 1 次元(X)格子点データの経度(X)方向平均(1 層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: x_data(0:im-1)
      !(in)  1 次元経度(X)格子点データ
      real(8)             :: AvrLon_x       
      !(out) 平均値

      AvrLon_x = IntLon_x(x_data)/sum(x_Lon_weight)

    end function AvrLon_x


    function x_AvrLat_xy(xy_data)
      !
      ! 2 次元緯度経度格子点データの緯度(Y)方向平均(1 層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: xy_data(0:im-1,1:jm)
      !(in) 2 次元経度緯度格子点データ(0:im-1,1:jm)
      real(8)             :: x_AvrLat_xy(im)
      !(out) 平均された 1 次元経度(X)格子点データ

      x_AvrLat_xy = x_IntLat_xy(xy_data)/sum(y_Lat_weight)

    end function x_AvrLat_xy

    function y_AvrLon_xy(xy_data)
      !
      ! 2 次元緯度経度格子点データの経度(X)方向平均(1 層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: xy_data(0:im-1,1:jm)
      !(in) 2 次元経度緯度格子点データ(0:im-1,1:jm)
      real(8)             :: y_AvrLon_xy(1:jm)
      !(out) 平均された 1 次元緯度(Y)格子点

      y_AvrLon_xy = y_IntLon_xy(xy_data)/sum(x_Lon_weight)

    end function y_AvrLon_xy


    function AvrLonLat_xy(xy_data)
      !
      ! 2 次元緯度経度格子点データの全領域平均(1 層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in)   :: xy_data(0:im-1,1:jm)
      !(in) 2 次元経度緯度格子点データ

      real(8) :: AvrLonLat_xy
      !(out) 平均値

      AvrLonLat_xy = AvrLon_x(x_AvrLat_xy(xy_data))

    end function AvrLonLat_xy

  !--------------- エネルギースペクトル計算 -----------------
    function nm_EnergyFromStreamfunc_w(w_Strfunc)
      ! 
      ! 流線関数のスペクトルデータからエネルギーの球面調和函数成分
      ! (スペクトル)を計算する(1 層用).
      !
      !  * 全波数 n, 帯状波数 m の流線関数のスペクトル成分ψ(n,m) から
      !    エネルギースペクトルは (1/2)n(n+1)ψ(n,m)^2 と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和に4πをかけたものが球面上での
      !    全エネルギーに等しい.
      !
      !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !    欠損値の値はモジュール変数 w_spectrum_VMiss によって設定できる
      !    (初期値は -999.0)
      !
      real(8), intent(in)   :: w_Strfunc(:)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm,-nm:nm) :: nm_EnergyFromStreamfunc_w
      !(out) エネルギースペクトル(水平全波数 n, 帯状波数 m 空間)

      integer :: n, m

      nm_EnergyFromStreamfunc_w = w_spectrum_VMiss

      do n=0,nm
         do m=1,n
            nm_EnergyFromStreamfunc_w(n,m)  = 0.0D0
            nm_EnergyFromStreamfunc_w(n,-m) = 0.0D0
         enddo
         nm_EnergyFromStreamfunc_w(n,0) &
              = 0.5 * n*(n+1) * w_Strfunc(l_nm(n,0))**2
      enddo
    end function nm_EnergyFromStreamfunc_w

    function n_EnergyFromStreamfunc_w(w_Strfunc)
      !
      ! 流線関数のスペクトルデータから各全波数のエネルギー成分(スペクトル)を
      ! 計算する(1 層用).
      !
      !  * 全波数 n の流線関数のスペクトル成分ψ(n,m) から
      !    エネルギースペクトルはΣ[m=-nm]^nm(1/2)n(n+1)ψ(n,m)^2 
      !    と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和に 4πをかけたものが
      !    球面上での全エネルギーに等しい.
      !

      real(8), intent(in)      :: w_Strfunc(:)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm) :: n_EnergyFromStreamfunc_w
      !(out) エネルギースペクトル (水平全波数 n 空間) 

      integer :: n

      do n=0,nm
         n_EnergyFromStreamfunc_w(n)  &
              = 0.5 * n*(n+1) * w_StrFunc(l_nm(n,0))**2
      enddo

    end function n_EnergyFromStreamfunc_w

  !--------------- エンストロフィースペクトル計算 -----------------
    function nm_EnstrophyFromStreamfunc_w(w_Strfunc)
      !
      ! 流線関数のスペクトルデータからエンストロフィーの球面調和函数成分
      ! (スペクトル)を計算する(1 層用). 
      !
      ! * 全波数 n, 帯状波数 m の流線関数のスペクトル成分ψ(n,m) から
      !    エンストロフィースペクトルは (1/2)n^2(n+1)^2ψ(n,m)^2 と計算される.
      !
      ! * 全てのエンストロフィースペクトル成分の和に4π/R^2をかけたものが
      !   球面上での全エンストロフィーに等しい. ここで R は球面の半径である.
      !
      ! * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !   欠損値の値はモジュール変数 w_spectrum_VMiss によって設定できる
      !   (初期値は -999.0)
      !
      real(8), intent(in)   :: w_Strfunc(:)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm,-nm:nm) :: nm_EnstrophyFromStreamfunc_w
      ! エンストロフィースペクトル (水平全波数 n, 帯状波数 m 空間)

      integer :: n, m

      nm_EnstrophyFromStreamfunc_w = w_spectrum_VMiss

      do n=0,nm
         do m=1,n
            nm_EnstrophyFromStreamfunc_w(n,m) = 0.0
            nm_EnstrophyFromStreamfunc_w(n,-m) = 0.0
         enddo
         nm_EnstrophyFromStreamfunc_w(n,0) &
                 = 0.5 * n**2 * (n+1)**2 * w_Strfunc(l_nm(n,0))**2
      enddo

    end function nm_EnstrophyFromStreamfunc_w

    function n_EnstrophyFromStreamfunc_w(w_Strfunc)
      !
      ! 流線関数のスペクトルデータから各全波数のエネルギー成分(スペクトル)を
      ! 計算する(1 層用)
      !
      ! * 全波数 n の流線関数のスペクトル成分ψ(n,m) からエンストロフィー
      !   スペクトルはΣ[m=-nm]^nm(1/2)n^2(n+1)^2ψ(n,m)^2 と計算される.
      !    
      ! * 全てのエネルギースペクトル成分の和に 4π/R^2 をかけたものが
      !   球面上での全エンストフィーに等しい.
      !
      real(8), intent(in)      :: w_Strfunc(:)
      !(in) 流線関数(スペクトルデータ)

      real(8), dimension(0:nm) :: n_EnstrophyFromStreamfunc_w  
      !(out) エンストロフィースペクトル(水平全波数 n 空間)

      integer :: n

      do n=0,nm
         n_EnstrophyFromStreamfunc_w(n)  &
              = 0.5 * n**2 * (n+1)**2 * w_StrFunc(l_nm(n,0))**2
      enddo
    end function n_EnstrophyFromStreamfunc_w

  !--------------- 終了処理 -----------------
    subroutine w_Finalize
      !
      ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
      !
      ! 解像度を変更する際にはこのサブルーチンを呼んで終了処理を
      ! おこなったのちに再度 w_Initial で初期設定しなければ
      ! ならない. 
      !
      if ( .not. w_initialize ) then
         call MessageNotify('W','w_finalize',&
              'w_zonal_module not initialized yet')
         return
      endif

      deallocate(x_Lon)           ! 格子点座標格納配列(経度)
      deallocate(x_Lon_Weight)
      deallocate(xy_Lon)
      deallocate(xy_Lat)          ! 格子点座標格納配列

      deallocate(rn,irm)

      call l_Finalize

      w_initialize = .false.

      call MessageNotify('M','w_finalize',&
           'w_zonal_module (2013/02/24) is finalized')

    end subroutine w_Finalize

end module w_zonal_module

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wq_mpi_module_supack テストプログラム
!
!      ポロイダルポテンシャルの境界値問題
!
!履歴  2016/04/01  竹広真一   wq_mpi_module_sjpack_polvelbc_test.f90 を supack 化
!
!
program wq_mpi_module_supack_polvelbc

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wq_mpi_module_supack
  use mpi

  implicit none

  integer,parameter  :: im=32, jm=16, km=8   ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=15         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ra=0.5D0             ! 球半径

  real(8), allocatable :: xvr_Poloidal(:,:,:)
  real(8), allocatable :: xvr_LaplaPol(:,:,:)
  real(8), allocatable :: xvr_True(:,:,:)
  real(8), allocatable :: xvr_Zero(:,:,:)
  real(8), allocatable :: wq_Poloidal(:,:)
  real(8), allocatable :: wq_LaplaPol(:,:)
  real(8), allocatable :: wq_LaplaPol0(:,:)
  character(len=1), dimension(2), parameter :: BCond=(/'F','R'/)

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  integer :: l
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wq_mpi_module_supack_polvelbc_test', &
       'wq_mpi_module_supack wq_LaplaPol2Pol_wq subroutine test')

  call wq_mpi_initial(im,jm,km,nm,lm,ra)

  allocate(xvr_Poloidal(0:im-1,1:jc,km))
  allocate(xvr_LaplaPol(0:im-1,1:jc,km))
  allocate(xvr_True(0:im-1,1:jc,km))
  allocate(xvr_Zero(0:im-1,1:jc,km))
  allocate(wq_Poloidal(nc,0:lm))
  allocate(wq_LaplaPol(nc,0:lm))
  allocate(wq_LaplaPol0(nc,0:lm))

  xvr_Zero = 0.0D0

  
  do l=1,2
     ! P_10
     xvr_Poloidal = sin(xvr_Lat) * xvr_Rad * ((xvr_Rad-ra)*(xvr_Rad+ra))**3
!!$     xvr_Poloidal = sin(xvr_Lat) * xvr_Rad * ((xvr_Rad-ra)*(xvr_Rad+ra))**2
     wq_LaplaPol0 = wq_Lapla_wq(wq_xvr(xvr_Poloidal))
     !xvr_LaplaPol = sin(xvr_Lat) * sin( pi*(xvr_Rad-ri)/(ro-ri) )
     ! P_1_1
     !xvr_LaplaPol = cos(xvr_Lat)*cos(xvr_Lon)* xvr_Rad * (xvr_Rad-ra) 
     !xvr_LaplaPol = 2*sin(xvr_Lat)**2 * xvr_Rad * (xvr_Rad-ra) 

     !xvr_Poloidal = xvr_wz(wr_LaplaPol2pol_wr(wr_xvr(xvr_LaplaPol),BCond(l)))
     !xvr_Poloidal = xvr_wq(wq_LaplaPol2PolTau_wq(wq_xvr(xvr_LaplaPol),BCond(l)))

     wq_Poloidal  = wq_LaplaPol2Pol_wq(wq_LaplaPol0,BCond(l),new=.true.)
     wq_LaplaPol  = wq_Lapla_wq(wq_Poloidal)
     xvr_Poloidal = xvr_wq(wq_Poloidal)

     !---------------- 内部チェック -----------------------
     call AssertEqual(&
          message='wq_Laplapol2Pol_wq (internal value)',                &
          answer = wq_cleanup_wq(wq_LaplaPol(:,0:lm-4)),                &
          check = wq_cleanup_wq(wq_LaplaPol0(:,0:lm-4)),                &
          significant_digits = check_digits, ignore_digits = ignore     &
       )

     !--------- 上端境界チェック ----------

     !----- Φ=0 at the top ---------
     call AssertEqual(&
          message='wq_LaplaPol2Pol_wq (Φ=0 Top Booundary)',            &
          answer = xvr_Poloidal(:,:,km),                                &
          check = xvr_Zero(:,:,km),                                     &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     !----- dΦ/dr=0, d^2Φ/dr^2 at the top ---------
     if( BCond(l)(1:1) == 'F' ) then
        xvr_True = xvr_wq(wq_RadDRad_wq(wq_RadDRad_wq(wq_Poloidal))&
                                       -wq_RadDRad_wq(wq_Poloidal))/xvr_Rad**2
     else
        xvr_True = xvr_wq(wq_RadDRad_wq(wq_Poloidal))/xvr_Rad
     endif

     call AssertEqual(&
          message='wq_LaplaPol2Pol_wq (Top Booundary)',                 &
          answer = xvr_True(:,:,km),                                    &
          check = xvr_Zero(:,:,km),                                     &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     call MessageNotify('M','wq_module_supack_polvelbc_test', &
          'wq_LaplaPol2Pol_wq: '//BCond(l)//'-Top B.C. test succeeded!')
          
  end do

  call MessageNotify('M','wq_mpi_module_supack_polvelbc_test', &
       'wq_mpi_module_supack wq_LaplaPol2Pol_wq subroutine test succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

contains

  function wq_cleanup_wq(wq_data)
    real(8), intent(IN) :: wq_data(:,:)
    real(8)             :: wq_cleanup_wq(size(wq_data,1),size(wq_data,2))

    integer l,nmary(2)

    wq_cleanup_wq = wq_data

    do l=1,nc
       nmary = nm_l(l)
       if ( nmary(1) .lt. 0 ) wq_cleanup_wq(l,:) = 0.0D0
    end do

  end function wq_cleanup_wq

end program wq_mpi_module_supack_polvelbc

!----------------------------------------------------------------------
! COPYRIGHT (c) 2007-2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  au_module テストプログラム
!
!履歴  2007/12/28  竹広真一  
!      2010/12/21  佐々木洋平 dc_test を使用するように修正
!      
!
program au_test_weight

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use au_module
  implicit none
  integer, parameter :: im=32, km=32
  real(8), parameter :: ra=2.0D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 6
  integer, parameter :: ignore = -6

  real(8), dimension(0:im) :: g_z

  integer :: i
  
  call MessageNotify('M','au_test_weight', 'au_module weight function tests')

  do i=1,2
    
    call au_initial(im,km/i,ra,(/1/))

    g_z(:) = 1.0D0
    
    call AssertEqual(&
      message='Test1: z = 1, int_0^a z dr ',                        &
      answer = ra,                                                  &
      check = sum(g_z*g_R_weight),                                  &
      significant_digits = check_digits, ignore_digits = ignore     &
      )
    
    g_z(:) = g_R**2
    
    call AssertEqual(&
      message='Test2: z = R**2, int_0^a z dr ',                     &
      answer = ra**3/3.0D0,                                         &
      check = sum(g_z*g_R_weight),                                  &
      significant_digits = check_digits, ignore_digits = ignore     &
      )
    
    g_z(:) = g_R**3
    
    call AssertEqual(&
      message='Test3: z = R**3, int_0^a z dr ',                     &
      answer = ra**4/4.0D0,                                         &
      check = sum(g_z*g_R_weight),                                  &
      significant_digits = check_digits, ignore_digits = ignore     &
      )
    
  end do
  
  call MessageNotify('M','au_test_weight', &
    'au_module weight function tests succeeded!')
  
end program au_test_weight

!----------------------------------------------------------------------
! Copyright (c) 2002-2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_module テストプログラム
!
!履歴  2002/04/10  竹広真一
!      2007/10/25  竹広真一  エラーメッセージ追加
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!
program at_test_base2d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_module
  implicit none
  integer, parameter :: im=8, km=5, nm=4
  real(8), parameter :: xmin=-1.0D0, xmax=1.0D0

  real(8), dimension(0:nm,0:im) :: ag_y
  real(8), dimension(0:nm,0:im) :: ag_y_deriv
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','at_test_base2d', &
    & '2D basic functions test')

  call at_initial(im,km,xmin,xmax)
  call MessageNotify('M','at_test_base2d', &
    & 'y(n) = T_n(x), n=0..4')

  ag_y(0,:) = 1.0d0                                  ! T_0
  ag_y(1,:) = g_x                                    ! T_1
  ag_y(2,:) = 2.0d0*g_x**2 - 1.0d0                   ! T_2
  ag_y(3,:) = 4.0d0*g_x**3 - 3.0d0*g_x               ! T_3
  ag_y(4,:) = 8.0d0*g_x**4 - 8.0d0*g_x**2 + 1.0d0    ! T_4

  ag_y_deriv(0,:) = 0.0D0                            ! T_0'= 0
  ag_y_deriv(1,:) = 1.0D0                            ! T_1'= T_0
  ag_y_deriv(2,:) = 4.0d0*g_x                        ! T_2'= 4*T_1
  ag_y_deriv(3,:) = 12.0d0*g_x**2 - 3.0d0            ! T_3'= 6*T_2 + 3*T_0
  ag_y_deriv(4,:) = 32.0d0*g_x**3 - 16.0d0*g_x       ! T_4'= 8*T_3 + 8*T_1

  call check2d(ag_at(at_ag(ag_y)), ag_y, 'test of ag_at, at_ag')
  call check2d(ag_at(at_dx_at(at_ag(ag_y))), ag_y_deriv, 'test of at_Dx_at')

  call MessageNotify('M','at_test_base2d', &
    & '2D basic functions test succeeded')

contains
  subroutine check2d(var, true, funcname)
    real(8) :: var(:,:)
    real(8) :: true(:,:)
    character(len=*), optional :: funcname

    call AssertEqual(&
      & message = funcname,   &
      & answer  = true,       &
      & check   = var,        &
      significant_digits = check_digits, ignore_digits = ignore   &
      )
  end subroutine check2d

end program at_test_base2d

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  fe_module テストプログラム (積分)
!
!履歴  2009/12/11  竹広真一
!      2016/01/01  竹広真一  ef => fe へ命名変更
!
program fe_module_integral_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use fe_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: x_Data(0:im-1)            ! 格子データ
  real(8)            :: y_Data(0:jm-1)            ! 格子データ

  integer            :: k=2,l=1

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: yrad = 2.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','fe_module_integeral_test', &
       'fe_module integral function tests')

 !---------------- 座標値の設定 ---------------------
  call fe_initial(im,jm,km,lm,xmin,xmax,yrad)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
  yx_Data = sin(k*pi*yx_X)**2 * exp(-yx_Y**2)

  y_Data = (xmax-xmin)/2 * exp(-y_Y**2)
  call AssertEqual(&
    message='y_IntX_yx with sin(k*pi*X)*exp(-Y**2)',              &
    answer = y_Data,                                              &
    check = y_IntX_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Data = sqrt(PI)*sin(k*pi*x_X)**2
  call AssertEqual(&
    message='x_IntY_yx with sin(k*pi*X)*exp(-Y**2)',              &
    answer = x_Data,                                              &
    check = x_IntY_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='IntYX_yx with sin(k*pi*X)*exp(-Y**2)',              &
    answer = (xmax-xmin)/2*sqrt(PI),                             &
    check = IntYX_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  call AssertEqual(&
    message='IntX_x with sqrt(PI)*sin(k*pi*X)**2',               &
    answer = (xmax-xmin)/2*sqrt(PI),                             &
    check = IntX_x(x_Data),                                      &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  call AssertEqual(&
    message='IntY_y with (xmax-xmin)/2*exp(-Y**2)',              &
    answer = (xmax-xmin)/2*sqrt(PI),                             &
    check = IntY_y(y_Data),                                      &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  yx_Data = cos(k*pi*yx_X)**2 * (sin(l*pi*yx_Y)+1.0D0)

  y_Data = 0.5D0 * (sin(l*pi*y_Y)+1.0D0)
  call AssertEqual(&
    message='y_AvrX_yx with cos(k*pi*X)**2*(sin(l*pi*Y)+1)',      &
    answer = y_Data,                                              &
    check = y_AvrX_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Data = cos(k*pi*x_X)**2
  call AssertEqual(&
    message='x_AvrY_yx with cos(k*pi*X)**2*(sin(l*pi*Y)+1)',      &
    answer = x_Data,                                              &
    check = x_AvrY_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='AvrYX_yx with cos(k*pi*X)**2*(sin(l*pi*Y)+1)',      &
    answer = 0.5D0,                                              &
    check = AvrYX_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  call AssertEqual(&
    message='AvrX_x with cos(k*pi*X)**2',                        &
    answer = 0.5D0,                                              &
    check = AvrX_x(x_Data),                                      &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  call AssertEqual(&
    message='AvrY_y with 0.5*(sin(l*pi*Y)+1)',                   &
    answer = 0.5D0,                                              &
    check = AvrY_y(y_Data),                                      &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  call MessageNotify('M','fe_module_integeral_test', &
       'fe_module integral function tests succeeded!')

end program fe_module_integral_test

!----------------------------------------------------------------------
!     Copyright (c) 2009--2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wa_zonal_module テストプログラム :: 微分関数のテスト
!
!履歴  2000/09/23  竹広真一
!      2013/02/14  竹広真一  SJPACK 用を改造
!
program wa_zonal_module_deriv_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wa_zonal_module
  implicit none

  integer, parameter :: im=1, jm=16, nm=10, km=2

  real(8), dimension(0:im-1,1:jm,km)     ::  xya_data1              ! 元の関数
  real(8), dimension(0:im-1,1:jm,km)     ::  xya_data2              ! 元の関数
  real(8), dimension(0:im-1,1:jm,km)     ::  xya_ddata              ! 微分の正解
  real(8), dimension(0:im-1,1:jm)        ::  xy_mu                  ! μ=sinφ

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','wa_zonal_module_deriv_test', &
                         'wa_zonal_module derivative functions test') 

  call wa_Initial( nm, im, jm, km )

  !---- Y_1^-1 Y_2^1 のテスト ----
  xya_data1(:,:,1) = sqrt(3.0D0)*sin(xy_Lat)                   ! Y_1^0
  xya_data1(:,:,2) = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)  ! Y_2^0

  xya_ddata(:,:,1) = -2*sqrt(3.0D0)*sin(xy_Lat)                   ! wa_Lapla_wa
  xya_ddata(:,:,2) = -6*sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)  ! 

  call AssertEqual(&
    message='wa_Lapla_wa',                                        &
    answer = xya_ddata,                                           &
    check = xya_wa(wa_Lapla_wa(wa_xya(xya_data1))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xya_ddata(:,:,1) = -1.0D0/2.0D0*sqrt(3.0D0)*sin(xy_Lat)        ! wa_Lapla_wa
  xya_ddata(:,:,2) = -1.0D0/6.0D0*sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)

  call AssertEqual(&
    message='wa_LaplaInv_wa',                                     &
    answer = xya_ddata,                                           &
    check = xya_wa(wa_LaplaInv_wa(wa_xya(xya_data1))),            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xya_ddata(:,:,1) = 0.0D0         ! wa_DLon_wa
  xya_ddata(:,:,2) = 0.0D0

  call AssertEqual(&
    message='wa_DLon_wa',                                         &
    answer = xya_ddata,                                           &
    check = xya_wa(wa_DLon_wa(wa_xya(xya_data1))),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xya_ddata(:,:,1) = 0.0D0                     ! xya_GradLon_wa
  xya_ddata(:,:,2) = 0.0D0

  call AssertEqual(&
    message='xya_GradLon_wa',                                     &
    answer = xya_ddata,                                           &
    check = xya_GradLon_wa(wa_xya(xya_data1)),                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xya_ddata(:,:,1) = sqrt(3.0D0)*cos(xy_Lat)         ! xya_GradLat_wa
  xya_ddata(:,:,2) = sqrt(5.0D0)*3.0*sin(xy_Lat)*cos(xy_Lat)

  call AssertEqual(&
    message='xya_GradLat_wa',                                     &
    answer = xya_ddata,                                           &
    check = xya_GradLat_wa(wa_xya(xya_data1)),                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_1^0 cosφ, Y_2^0 cosφ のテスト ----
  xya_data1(:,:,1) = sqrt(3.0D0)*sin(xy_Lat)*cos(xy_Lat)        
  ! Y_1^0 cosφ
  xya_data1(:,:,2) = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)*cos(xy_Lat)
  ! Y_2^0 cosφ

  xya_ddata(:,:,1) = 0.0D0   ! wa_DivLon_xya
  xya_ddata(:,:,2) = 0.0D0   ! wa_DivLon_xya

  call AssertEqual(&
    message='wa_DivLon_xya',                                      &
    answer = xya_ddata,                                           &
    check = xya_wa(wa_DivLon_xya(xya_data1)),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xya_ddata(:,:,1) = sqrt(3.0D0)*(cos(xy_Lat)**2-2*sin(xy_Lat)**2)
  ! wa_DivLat_xy
  xya_ddata(:,:,2) = sqrt(5.0D0) &
       *(3.0*(sin(xy_Lat)*cos(xy_Lat)**2-sin(xy_Lat)**3)+sin(xy_Lat)) 
  ! wa_DivLat_xya

  call AssertEqual(&
    message='wa_DivLat_xya',                                      &
    answer = xya_ddata,                                           &
    check = xya_wa(wa_DivLat_xya(xya_data1)),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Jacobian のテスト ----
  xya_data1(:,:,1) = sin(xy_Lat)                             ! Y_1^0
  xya_data1(:,:,2) = 3.0D0/2.0D0*sin(xy_Lat)**2-1.0D0/2.0D0  ! Y_2^0
  xya_data2(:,:,1) = sin(xy_Lat)                             ! Y_1^0
  xya_data2(:,:,2) = 3.0D0/2.0D0*sin(xy_Lat)**2-1.0D0/2.0D0  ! Y_2^0

  xya_ddata(:,:,1) = 0.0D0
  xya_ddata(:,:,2) = 0.0D0
  call AssertEqual(&
    message='wa_Jacobian_wa_wa',                                  &
    answer = xya_ddata,                                           &
    check = xya_wa(wa_Jacobian_wa_wa(wa_xya(xya_data1),wa_xya(xya_data2))),  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !============== 微分計算 (λ,μ座標系用) のテスト ==============
  xy_mu = sin(xy_Lat)

  !----- Y_2^0, Y_1^0 のテスト -----
  xya_data1(:,:,1) = 3*xy_mu**2-1                                 ! Y_2^0
  xya_data1(:,:,2) = xy_mu                                        ! Y_1^1

  xya_ddata(:,:,1) = 0.0
  xya_ddata(:,:,2) = 0.0D0

  call AssertEqual(&
    message='xya_GradLambda_wa',                                  &
    answer = xya_ddata,                                           &
    check = xya_GradLambda_wa(wa_xya(xya_data1)),                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xya_ddata(:,:,1) = 6*xy_mu*(1-xy_mu**2)
  xya_ddata(:,:,2) = 1-xy_mu**2

  call AssertEqual(&
    message='xya_GradMu_wa',                                      &
    answer = xya_ddata,                                           &
    check = xya_GradMu_wa(wa_xya(xya_data1)),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !----- Y_2^0(1-μ^2), Y_1^0 (1-μ^2) のテスト -----
  xya_data1(:,:,1) = (3*xy_mu**2-1)*(1-xy_mu**2)       ! Y_2^0 (1-μ^2)
  xya_data1(:,:,2) = xy_mu*(1-xy_mu**2)                ! Y_1^0 (1-μ^2)

  xya_ddata(:,:,1) = 0.0D0
  xya_ddata(:,:,2) = 0.0D0

  call AssertEqual(&
    message='wa_DivLambda_xya',                                   &
    answer = xya_ddata,                                           &
    check = xya_wa(wa_DivLambda_xya(xya_data1)),                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xya_ddata(:,:,1) = (2-3*xy_mu**2)*4*xy_mu
  xya_ddata(:,:,2) = (1-xy_mu**2) - 2*xy_mu**2

  call AssertEqual(&
    message='wa_DivMu_xya',                                       &
    answer = xya_ddata,                                           &
    check = xya_wa(wa_DivMu_xya(xya_data1)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wa_zonal_module_deriv_test', &
       'wa_zonal_module derivative functions test succeeded!') 

end program wa_zonal_module_deriv_test

!----------------------------------------------------------------------
!     Copyright (c) 2012 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_interpolate_module テストプログラム :: 補間関数のテスト
!
!履歴  2012/04/03  竹広真一
!
program w_interpolate00_mpi_module_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_mpi_module
  use mpi
  implicit none

  integer, parameter :: im=32, jm=16, nm=10

  real(8), dimension((nm+1)**2) ::  w_data
  real(8), dimension(im,jm)     ::  xy_data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: Alon
  real(8) :: Alat
  real(8) :: data_sol
  real(8) :: pi
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0
  Alon = pi/5 ; Alat = pi/3

  call w_mpi_Initial( nm, im, jm )

  call MessageNotify('M','w_Interpolate00_mpi_module_test', &
       'w_interpolate_module interpolate(00) tests') 

  !---- Y_1^0 のテスト ----
  xy_data = sqrt(3.0D0)*sin(xy_Lat)                      ! Y_1^0
  data_sol = sqrt(3.0D0)*sin(ALat)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_1^0',                           &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_1^1 のテスト ----
  xy_data = sqrt(3.0D0/2)*cos(xy_Lat)*cos(xy_Lon)          ! Y_1^1
  data_sol = sqrt(3.0D0/2)*cos(ALat)*cos(ALon)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_1^1',                           &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_1^-1 のテスト ----
  xy_data = -sqrt(3.0D0)*cos(xy_Lat)*sin(xy_Lon)         ! Y_1^{-1}
  data_sol = -sqrt(3.0D0)*cos(ALat)*sin(ALon)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_1^-1',                          &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^0 のテスト ----
  xy_data = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)                 ! Y_2^0
  data_sol = sqrt(5.0D0)*(3.0/2*sin(alat)**2-1.0/2)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^0',                          &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^1 のテスト ----
  xy_data = sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)! Y_2^1
  data_sol = sqrt(5.0D0/6)*3.0*sin(ALat)*cos(ALat) * cos(ALon)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^1',                           &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^-1 のテスト ----
  xy_data = -sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat) * sin(xy_Lon)! Y_2^{-1}
  data_sol = -sqrt(5.0D0/6)*3.0*sin(ALat)*cos(ALat) * sin(ALon)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^-1',                          &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^2 のテスト ----
  xy_data = sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*cos(2*xy_Lon)             ! Y_2^2
  data_sol = sqrt(5.0D0/24)*3.0*cos(ALat)**2*cos(2*ALon)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^2',                           &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^-2 のテスト ----
  xy_data = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(2*xy_Lon)          ! Y_2^-2
  data_sol = -sqrt(5.0D0/24)*3.0*cos(ALat)**2*sin(2*ALon)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^-2',                          &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的な関数のテスト ----
  xy_data = cos(2*xy_Lon-pi/3) &
       *(sin(xy_Lat)-1)**2*(sin(xy_Lat)-0.5)*(sin(xy_Lat)+1)
  data_sol = cos(2*ALon-pi/3) &
       *(sin(ALat)-1)**2*(sin(ALat)-0.5)*(sin(ALat)+1)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with generaul function',               &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','w_interpolate00_mpi_module_test', &
       'w_interpolate_module interpolate(00) tests succeeded') 

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)      

end program w_interpolate00_mpi_module_test

!----------------------------------------------------------------------
!   COPYRIGHT (c) 2005-2006 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_ab_galerkin_ND1
!
!      チェビシェフ−ガラーキン法
!      片端ノイマン片端ディリクレ境界条件用モジュール
!          f'(:,i=0)=f(:,i=im)=0 [ f'(:,x=xmax)=f(:,x=xmin)=0 ]
!
!      k 次のガラーキン基底が
!
!        \phi_k(x)=T_k(x) + C_{k-1}T_{k-1}(x) + C_{k-2}T_{k-2}(x) 
!
!      の型式(Type1)
!
!履歴  2006/01/20  竹広真一  新規作成
!      2006/01/23  竹広真一  モジュール名変更
!      2006/01/25  竹広真一  モジュール初期化フラッグ導入
!
module at_ab_galerkin_ND

  use lumatrix
  use at_module
  use dc_message

  implicit none

  private
  public :: at_ab_galerkin_ND_Initial  ! 初期化サブルーチン
  public :: ab_at, b_t                 ! チェビシェフ->ガラーキン変換
  public :: ab_ag, b_g                 ! 格子点->ガラーキンデータ変換
  public :: at_ab, t_b                 ! ガラーキン->チェビシェフ変換
  public :: ag_ab, g_b                 ! ガラーキン->格子点データ変換
  public :: ab_Dx_ab, b_Dx_b           ! X 微分

  real(8), allocatable :: TB(:,:)      ! ガラーキン->チェビシェフ変換行列
  real(8), allocatable :: BT(:,:)      ! チェビシェフ->ガラーキン変換行列
  integer, allocatable :: kp(:)        ! LU 分解用ピボット格納配列

  real(8), allocatable :: alpha(:)     ! チェビシェフ<->ガラーキン行列積係数
  real(8), allocatable :: beta(:)      ! チェビシェフ<->ガラーキン行列和係数

  integer :: im                        ! 格子点数              
  integer :: km                        ! チェビシェフ切断波数  
  integer,parameter :: ks=2            ! ガラーキン基底最低次数

  logical :: ND_Initialized=.false.    ! 初期化フラッグ

  save im, km, TB, BT, kp, alpha, beta, ND_Initialized
  public TB, BT, alpha, beta

contains

  !
  ! チェビシェフ−ガラーキン法 
  ! 片端ノイマン片端ディリクレ境界条件用モジュール
  ! 初期化サブルーチン
  !
  subroutine at_ab_galerkin_ND_Initial(i_in,k_in)

    integer, intent(IN) :: i_in     ! (in)格子点数
    integer, intent(IN) :: k_in     ! (in)チェビシェフ切断波数  

    integer :: k, l, m, n

    im=i_in ; km=k_in

    allocate(TB(0:km,ks:km),BT(ks:km,ks:km),kp(ks:km))
    allocate(alpha(0:km),beta(0:km))

    ! 片端ノイマン片端ディリクレ条件用変換行列設定
    TB = 0.0D0
    do k=ks,km
       TB(k,k) = 1.0D0
       TB(k-1,k) = -1.0D0*(k**2-(k-2)**2)/((k-1)**2+(k-2)**2)
       TB(k-2,k) = -1.0D0*(k**2+(k-1)**2)/((k-1)**2+(k-2)**2)
    enddo

    beta=1.0 ; beta(0)=0.5D0
    if (im .eq. km ) beta(km)=0.5D0

    ! 片端ノイマン片端ディリクレ条件用変換逆行列
    alpha=1.0 ; alpha(0)=2.0D0

    BT = 0.0D0
    do m=ks,km
       do n=ks,km
          do l=0,km
             BT(m,n) = BT(m,n) + alpha(l)*TB(l,m)*TB(l,n)
          enddo
       enddo
    enddo

    call LUDecomp(BT,kp)

    call MessageNotify('M','at_ab_galerkin_ND_Initial(Type1)',&
                           'Conversion matrices initialized')

    ND_Initialized=.true.

  end subroutine at_ab_galerkin_ND_Initial

  !
  ! 片端ノイマン片端ディリクレ境界条件
  ! チェビシェフ係数 -> ガラーキン係数変換(2次元データ)
  !
  function ab_at(at_data)
    real(8), intent(IN) :: at_data(:,0:)                !(in)  チェビシェフ係数
    real(8)             :: ab_at(size(at_data,1),ks:km) !(out) ガラーキン係数  

    real(8)             :: ab_work(size(at_data,1),ks:km)  ! 作業用配列

    integer :: k,m

    if ( .not. ND_Initialized ) &
         call MessageNotify('E','ab_at',&
                            'at_ab_galerkin_ND_module(Type1) not initialized')

    ab_work =0.0
    do m=ks,km
       do k=0,km
          ab_work(:,m) = ab_work(:,m) &
               + alpha(k) * beta(k) * at_data(:,k) * TB(k,m)
       enddo
    enddo

    ab_at = LUSolve(BT,kp,ab_work)
  end function ab_at

  !
  ! 片端ノイマン片端ディリクレ境界条件
  ! チェビシェフ係数 -> ガラーキン係数変換(1次元データ)
  !
  function b_t(t_data)

    real(8), intent(IN) :: t_data(0:km)        !(in)  チェビシェフ係数
    real(8)             :: b_t(ks:km)          !(out) ガラーキン係数  

    real(8)             :: b_work(ks:km)       ! 作業用配列

    integer :: k,m

    if ( .not. ND_Initialized ) &
         call MessageNotify('E','b_t',&
                            'at_ab_galerkin_ND_module(Type1) not initialized')

    b_work =0.0
    do m=ks,km
       do k=0,km
          b_work(m) = b_work(m) &
               + alpha(k) * beta(k) * t_data(k) * TB(k,m)
       enddo
    enddo

    b_t = LUSolve(BT,kp,b_work)
  end function b_t

  !
  ! 片端ノイマン片端ディリクレ境界条件
  ! ガラーキン係数 -> チェビシェフ係数変換(2次元データ)
  !
  function at_ab(ab_data)

    real(8), intent(IN)  :: ab_data(:,ks:)              !(in)  ガラーキン係数
    real(8)              :: at_ab(size(ab_data,1),0:km) !(out) チェビシェフ係数

    integer :: m, n

    if ( .not. ND_Initialized ) &
         call MessageNotify('E','at_ab',&
                            'at_ab_galerkin_ND_module(Type1) not initialized')

    at_ab = 0.0D0
    do m=0,km
       do n=ks,km
          at_ab(:,m) = at_ab(:,m) + TB(m,n)*ab_data(:,n)/beta(m)
       enddo
    enddo

  end function at_ab

  !
  ! 片端ノイマン片端ディリクレ境界条件
  ! ガラーキン係数 -> チェビシェフ係数変換(1次元データ)
  !
  function t_b(b_data)

    real(8), intent(IN)  :: b_data(ks:km)       !(in)  ガラーキン係数  
    real(8)              :: t_b(0:km)           !(out) チェビシェフ係数

    integer :: m, n

    if ( .not. ND_Initialized ) &
         call MessageNotify('E','t_b',&
                            'at_ab_galerkin_ND_module(Type1) not initialized')

    t_b = 0.0D0
    do m=0,km
       do n=ks,km
          t_b(m) = t_b(m) + TB(m,n)*b_data(n)/beta(m)
       enddo
    enddo

  end function t_b

  !
  ! 片端ノイマン片端ディリクレ境界条件
  ! 格子点データ -> ガラーキン係数変換(2次元データ)
  !
  function ab_ag(ag_data)
    real(8), intent(IN)  :: ag_data(:,0:)                !(in)  格子点データ
    real(8)              :: ab_ag(size(ag_data,1),ks:km) !(out) ガラーキン係数

    ab_ag = ab_at(at_ag(ag_data))
  end function ab_ag

  !
  ! 片端ノイマン片端ディリクレ境界条件
  ! 格子点データ -> ガラーキン係数変換(1次元データ)
  !
  function b_g(g_data)
    real(8), intent(IN)  :: g_data(0:im)        !(in)  格子点データ
    real(8)              :: b_g(ks:km)          !(out) ガラーキン係数

    b_g = b_t(t_g(g_data))
  end function b_g

  !
  ! 片端ノイマン片端ディリクレ境界条件
  ! ガラーキン係数 -> 格子点データ変換(2次元データ)
  !
  function ag_ab(ab_data)
    real(8), intent(IN) :: ab_data(:,ks:)              !(in)  ガラーキン係数  
    real(8)             :: ag_ab(size(ab_data,1),0:im) !(out) 格子点データ  
    
    ag_ab = ag_at(at_ab(ab_data))
  end function ag_ab

  !
  ! 片端ノイマン片端ディリクレ境界条件
  ! ガラーキン係数 -> 格子点データ変換(1次元データ)
  !
  function g_b(b_data)
    real(8), intent(IN) :: b_data(ks:km)        !(in)  ガラーキン係数  
    real(8)             :: g_b(0:im)            !(out) 格子点データ  
    
    g_b = g_t(t_b(b_data))
  end function g_b

  !
  ! 片端ノイマン片端ディリクレ境界条件
  ! X 微分計算(1 次元)
  !
  function ab_Dx_ab(ab_data)
    real(8), intent(IN) :: ab_data(:,ks:)                  !(in) ガラーキン係数
    real(8)             :: ab_Dx_ab(size(ab_data,1),ks:km) !(out) 微分ガラーキン
    ab_Dx_ab = ab_at(at_Dx_at(at_ab(ab_data)))
  end function ab_Dx_ab

  !
  ! 片端ノイマン片端ディリクレ境界条件
  ! X 微分計算(1 次元)
  !
  function b_Dx_b(b_data)
    real(8), intent(IN) :: b_data(ks:km)
    real(8)             :: b_Dx_b(ks:km)

    b_Dx_b = b_t(t_Dx_t(t_b(b_data)))

  end function b_Dx_b

end module at_ab_galerkin_ND

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ee_module_fftj テストプログラム (補間計算)
!
!履歴  2009/09/11  竹広真一  ee_test_interpolate.f90 より ee_module_fftj 用に改造
!
program ee_module_fftj_interpolate_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: yx_Data1(0:jm-1,0:im-1)   ! 格子データ
  real(8)            :: ee_Data(-lm:lm,-km:km)    ! スペクトルデータ

  integer            :: k=2,l=5
  integer            :: i, j

 !---- 座標変数など ----
!!$  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: xmin = 0.0d0, xmax=4.0d0
!!$  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0
  real(8), parameter :: ymin = 2.0d0, ymax=4.0d0

  real(8), parameter :: x0 = 2.0/3.0, x1=3.0/5.0d0
  real(8), parameter :: y0 = 1.0/7.0, y1=5.0/9.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','ee_module_fftj_interpolate_test', &
       'ee_module_fftj interpolate function tests')

 !---------------- 座標値の設定 ---------------------
  call ee_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- 関数チェック ----------------------
  yx_Data = sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  ee_Data = ee_yx(yx_Data)
  do i=0,im-1
     do j=0,jm-1
        yx_Data1(j,i) = Interpolate_ee( ee_Data, x_X(i), y_Y(j) )
     enddo
  enddo
  call AssertEqual(&
    message='Interpolate_ee with sin(k*pi*X)*sin(l*pi*Y)',        &
    answer = yx_Data1,                                            &
    check = yx_Data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Interpolate_ee with sin(k*pi*X0)*sin(l*pi*Y0)',      &
    answer = sin(k*pi*x0)*sin(l*pi*y0),                           &
    check = Interpolate_ee(ee_Data, x0, y0),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Interpolate_ee with sin(k*pi*X1)*sin(l*pi*Y1)',      &
    answer = sin(k*pi*x1)*sin(l*pi*y1),                           &
    check = Interpolate_ee(ee_Data, x1, y1),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  ee_Data = ee_yx(yx_Data)
  do i=0,im-1
     do j=0,jm-1
        yx_Data1(j,i) = Interpolate_ee( ee_Data, x_X(i), y_Y(j) )
     enddo
  enddo
  call AssertEqual(&
    message='Interpolate_ee with cos(k*pi*X)*cos(l*pi*Y)',        &
    answer = yx_Data1,                                            &
    check = yx_Data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Interpolate_ee with cos(k*pi*X0)*cos(l*pi*Y0)',      &
    answer = cos(k*pi*x0)*cos(l*pi*y0),                           &
    check = Interpolate_ee(ee_Data, x0, y0),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Interpolate_ee with cos(k*pi*X1)*cos(l*pi*Y1)',      &
    answer = cos(k*pi*x1)*cos(l*pi*y1),                           &
    check = Interpolate_ee(ee_Data, x1, y1),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  ee_Data = ee_yx(yx_Data)
  do i=0,im-1
     do j=0,jm-1
        yx_Data1(j,i) = Interpolate_ee( ee_Data, x_X(i), y_Y(j) )
     enddo
  enddo
  call AssertEqual(&
    message='Interpolate_ee with sin(k*pi*X)*cos(l*pi*Y)',        &
    answer = yx_Data1,                                            &
    check = yx_Data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Interpolate_ee with sin(k*pi*X0)*cos(l*pi*Y0)',      &
    answer = sin(k*pi*x0)*cos(l*pi*y0),                           &
    check = Interpolate_ee(ee_Data, x0, y0),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Interpolate_ee with sin(k*pi*X1)*cos(l*pi*Y1)',      &
    answer = sin(k*pi*x1)*cos(l*pi*y1),                           &
    check = Interpolate_ee(ee_Data, x1, y1),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  ee_Data = ee_yx(yx_Data)
  do i=0,im-1
     do j=0,jm-1
        yx_Data1(j,i) = Interpolate_ee( ee_Data, x_X(i), y_Y(j) )
     enddo
  enddo
  call AssertEqual(&
    message='Interpolate_ee with cos(k*pi*X)*sin(l*pi*Y)',        &
    answer = yx_Data1,                                            &
    check = yx_Data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Interpolate_ee with cos(k*pi*X0)*sin(l*pi*Y0)',      &
    answer = cos(k*pi*x0)*sin(l*pi*y0),                           &
    check = Interpolate_ee(ee_Data, x0, y0),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Interpolate_ee with cos(k*pi*X1)*sin(l*pi*Y1)',      &
    answer = cos(k*pi*x1)*sin(l*pi*y1),                           &
    check = Interpolate_ee(ee_Data, x1, y1),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = sin(k*pi*yx_X)
  ee_Data = ee_yx(yx_Data)
  do i=0,im-1
     do j=0,jm-1
        yx_Data1(j,i) = Interpolate_ee( ee_Data, x_X(i), y_Y(j) )
     enddo
  enddo
  call AssertEqual(&
    message='Interpolate_ee with sin(k*pi*X)',                    &
    answer = yx_Data1,                                            &
    check = yx_Data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Interpolate_ee with sin(k*pi*X0)',                   &
    answer = sin(k*pi*x0),                                        &
    check = Interpolate_ee(ee_Data, x0, y0),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Interpolate_ee with sin(k*pi*X1)',                   &
    answer = sin(k*pi*x1),                                        &
    check = Interpolate_ee(ee_Data, x1, y1),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = cos(k*pi*yx_X) 
  ee_Data = ee_yx(yx_Data)
  do i=0,im-1
     do j=0,jm-1
        yx_Data1(j,i) = Interpolate_ee( ee_Data, x_X(i), y_Y(j) )
     enddo
  enddo
  call AssertEqual(&
    message='Interpolate_ee with cos(k*pi*X)',                    &
    answer = yx_Data1,                                            &
    check = yx_Data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Interpolate_ee with cos(k*pi*X0)',                   &
    answer = cos(k*pi*x0),                                        &
    check = Interpolate_ee(ee_Data, x0, y0),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Interpolate_ee with cos(k*pi*X1)',                   &
    answer = cos(k*pi*x1),                                        &
    check = Interpolate_ee(ee_Data, x1, y1),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = cos(l*pi*yx_Y)
  ee_Data = ee_yx(yx_Data)
  do i=0,im-1
     do j=0,jm-1
        yx_Data1(j,i) = Interpolate_ee( ee_Data, x_X(i), y_Y(j) )
     enddo
  enddo
  call AssertEqual(&
    message='Interpolate_ee with cos(l*pi*Y)',                    &
    answer = yx_Data1,                                            &
    check = yx_Data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Interpolate_ee with cos(l*pi*Y0)',                   &
    answer = cos(l*pi*y0),                                        &
    check = Interpolate_ee(ee_Data, x0, y0),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Interpolate_ee with cos(l*pi*Y1)',                   &
    answer = cos(l*pi*y1),                                        &
    check = Interpolate_ee(ee_Data, x1, y1),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = sin(l*pi*yx_Y)
  ee_Data = ee_yx(yx_Data)
  do i=0,im-1
     do j=0,jm-1
        yx_Data1(j,i) = Interpolate_ee( ee_Data, x_X(i), y_Y(j) )
     enddo
  enddo
  call AssertEqual(&
    message='Interpolate_ee with sin(l*pi*Y)',                    &
    answer = yx_Data1,                                            &
    check = yx_Data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Interpolate_ee with sin(l*pi*Y0)',                   &
    answer = sin(l*pi*y0),                                        &
    check = Interpolate_ee(ee_Data, x0, y0),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Interpolate_ee with sin(l*pi*Y1)',                   &
    answer = sin(l*pi*y1),                                        &
    check = Interpolate_ee(ee_Data, x1, y1),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = 1.0D0
  ee_Data = ee_yx(yx_Data)
  do i=0,im-1
     do j=0,jm-1
        yx_Data1(j,i) = Interpolate_ee( ee_Data, x_X(i), y_Y(j) )
     enddo
  enddo

  call AssertEqual(&
    message='Interpolate_ee with 1',                              &
    answer = yx_Data1,                                            &
    check = yx_Data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Interpolate_ee with 1',                              &
    answer = 1.0D0,                                               &
    check = Interpolate_ee(ee_Data, x0, y0),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Interpolate_ee with 1',                              &
    answer = 1.0D0,                                               &
    check = Interpolate_ee(ee_Data, x1, y1),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','ee_module_fftj_interpolate_test', &
       'ee_module_fftj interpolate function tests succeeded!')

end program ee_module_fftj_interpolate_test

!--
!----------------------------------------------------------------------
!     Copyright 2008-2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  eee_module
!
!      spml/eee_module モジュールは周期境界条件の下での 3 次元矩形領域の
!      流体運動をスペクトル法により数値計算するための Fortran90 関数を
!      提供する. 
!
!      内部で ISPACK/P3PACK の Fortran77 サブルーチンを呼んでいる. 
!      スペクトルデータおよび格子点データの格納方法については
!      ISPACK/P3PACK のマニュアルを参照されたい. 
!
!履歴  2008/05/03  竹広真一
!      2008/05/10  竹広真一 解像度領域複数対応
!      2008/05/11  竹広真一 xyz_zyx 追加
!      2009/01/29  佐々木洋平 コメントを RDoc 用に修正
!      2009/07/31  竹広真一   作業領域をローカル変数に変更(for OpenMP)
!
!++
module eee_module
  !
  != eee_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/eee_module モジュールは周期境界条件の下での 3 次元矩形領域の
  ! 流体運動をスペクトル法により数値計算するための Fortran90 関数を
  ! 提供する. 
  !
  ! 内部で ISPACK/P3PACK の Fortran77 サブルーチンを呼んでいる. 
  ! スペクトルデータおよび格子点データの格納方法については
  ! ISPACK/P3PACK のマニュアルを参照されたい. 
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !  
  ! * 関数名の先頭 (eee_, zyx_, x_, y_) は, 返す値の形を示している.
  !   eee_ :: スペクトルデータ(第 1,2 3 次元がそれぞれ Z, Y,X 方向波数)
  !   eee2 :: 2 つのスペクトルデータの並んだもの
  !   zyx_ :; 3 次元格子点データ(第 1,2 3 次元がそれぞれ Z, Y,X 方向の格子点)
  !   yx_ :: XY 方向 2 次元格子点データ 
  !   zy_ :: YZ 方向 2 次元格子点データ
  !   zx_ :: XZ 方向 2 次元格子点データ
  !   x_ :: X 方向 1 次元格子点データ
  !   y_ :: Y 方向 1 次元格子点データ
  !   z_ :: Z 方向 1 次元格子点データ
  !  
  ! * 関数名の間の文字列(Dx, Dy, Dz, Lapla, LaplaInv)は, 
  !   その関数の作用を表している.
  !
  ! * 関数名の最後 (_eee_eee,_eee,_zyx, _x, _y) は, 入力変数の形が
  !   スペクトルデータおよび格子点データであることを示している.
  !   _eee     :: スペクトルデータ
  !   _eee_eee :: 2 つのスペクトルデータ
  !   _eee2    :: 2 つのスペクトルデータの並んだもの
  !   _zyx     :: 3 次元格子点データ
  !   _x       :: X 方向 1 次元格子点データ
  !   _y       :: Y 方向 1 次元格子点データ.
  !  
  !=== 各データの種類の説明
  !  
  ! * zyx : 2 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(0:km-1,0:jm-1,0:im-1). 
  !   * im, jm, km はそれぞれ X, Y Z 座標の格子点数であり, サブルーチン 
  !     eee_initial にてあらかじめ設定しておく.
  !   * 第 1 次元が Z 座標の格子点位置番号, 第 2 次元が Y 座標, 
  !     第 3 次元が X 座標の格子点位置番号であることに注意.
  !     (X, Y, Zの順ではない)
  !
  ! * eee : スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(-nm:nm,-mm:mm,-lm:lm). 
  !   * lm, mm, nm はそれぞれ X, Y, Z方向の最大波数であり, サブルーチン 
  !     eee_initial にてあらかじめ設定しておく.
  !     (X, Y, Z 方向波数の順ではない)ことに注意. 
  !   * スペクトルデータの格納のされ方については ISPACK/P3PACK の
  !     マニュアルを参照すること. 
  !
  ! * eee2 : 2 つのスペクトルデータのならび. 
  !   * 変数の種類と次元は real(8), dimension(-nm:nm,-mm:mm,-lm:lm,2). 
  !
  ! * x, y, z : X, Y, Z 方向 1 次元格子点データ.
  !   * 変数の種類と次元はそれぞれ 
  !     real(8), dimension(0:im-1),
  !     real(8), dimension(0:jm-1), 
  !     および real(8), dimension(0:km-1).
  !
  ! * eee_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * zyx_ で始まる関数が返す値は 3 次元格子点データに同じ.
  !
  ! * x_, y_ z_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! eee_Initial :: スペクトル変換の格子点数, 切断波数の設定
  ! eee_ChangeResolution :: 解像度設定の変更
  ! 
  !==== 座標変数
  !
  ! x_X, y_Y, z_Z    ::  格子点座標(X,Y座標)を格納した 1 次元配列
  ! x_X_Weight, y_Y_Weight,  z_Z_Weight ::  重み座標を格納した 1 次元配列
  ! zyx_X, zyx_Y, zyx_Z  :: 格子点データの XYZ 座標(X,Y,Z)
  !                         (格子点データ型 3 次元配列)
  !
  !==== 基本変換
  !
  ! zyx_eee :: スペクトルデータから格子データへの変換
  ! eee_zyx :: 格子データからスペクトルデータへの変換
  ! xyz_zyx :: 格子点データの添え字順序変換
  !
  !==== 微分
  !
  ! eee_Lapla_eee       :: スペクトルデータにラプラシアンを作用させる
  ! eee_LaplaInv_eee    :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! eee_Dx_eee          :: スペクトルデータに X 微分を作用させる
  ! eee_Dy_eee          :: スペクトルデータに Y 微分を作用させる
  ! eee_Dz_eee          :: スペクトルデータに Z 微分を作用させる
  !
  !==== 非線形計算
  !
  ! eee2_RotVelxVor_eee2   :: Euler 方程式の非線形項を計算する
  ! eee_VorFromZeta_eee2   :: 渦度 2 成分(ζ_1, ζ_2)ら渦度の 1 成分を計算する
  ! eee_VelFromZeta_eee2   :: 渦度 2 成分(ζ_1, ζ_2)ら速度の 1 成分を計算する
  ! eee2_ZetaFromVor_eee_eee_eee :: 渦度から渦度 2 成分(ζ_1, ζ_2)を計算する
  !
  !==== 積分・平均
  !
  ! IntZYX_zyx, AvrZYX_zyx   :: 3 次元格子点データの全領域積分および平均
  ! z_IntYX_zyx, z_AvrYX_zyx :: 3 次元格子点データの X,Y 方向積分および平均
  ! x_IntZY_zyx, x_AvrZY_zyx :: 3 次元格子点データの Y,Z 方向積分および平均
  ! y_IntZX_zyx, y_AvrZX_zyx :: 3 次元格子点データの Z,X 方向積分および平均
  ! zy_IntX_zyx, zy_AvrX_zyx :: 3 次元格子点データの X 方向積分および平均
  ! zx_IntY_zyx, zx_AvrY_zyx :: 3 次元格子点データの Y 方向積分および平均
  ! yx_IntZ_zyx, yx_AvrZ_zyx :: 3 次元格子点データの Z 方向積分および平均
  !
  ! IntYX_yx,  AvrYX_yx  :: 2 次元(XY)格子点データの X,Y 方向積分および平均
  ! y_IntX_yx, y_AvrX_yx :: 2 次元(XY)格子点データの X 方向積分および平均
  ! x_IntY_yx, x_AvrY_yx :: 2 次元(XY)格子点データの Y 方向積分および平均
  ! IntZX_zx, AvrZX_zx   :: 2 次元(ZX)格子点データの Z,X 方向積分および平均
  ! z_IntX_zx, z_AvrX_zx :: 2 次元(ZX)格子点データの X 方向積分および平均
  ! x_IntZ_zx, x_AvrZ_zx :: 2 次元(ZX)格子点データの Z 方向積分および平均
  ! IntZY_zy, AvrZY_zy   :: 2 次元(YZ)格子点データの Y,Z 方向積分および平均
  ! y_IntZ_zy, y_AvrZ_zy :: 2 次元(YZ)格子点データの Z 方向積分および平均
  ! z_IntY_zy, z_AvrY_zy :: 2 次元(YZ)格子点データの Y 方向積分および平均
  !
  ! IntX_x, AvrX_x       :: 1 次元(X)格子点データの X 方向積分および平均
  ! IntY_y, AvrY_y       :: 1 次元(Y)格子点データの Y 方向積分および平均
  ! IntZ_z, AvrZ_z       :: 1 次元(Z)格子点データの Z 方向積分および平均
  !
  !==== スペクトル解析
  !
  ! EnergyHelicityFromZeta_eee2  :: 全エネルギーと全ヘリシティーを計算する. 
  ! ESpectralFromZeta            :: エネルギースペクトルを計算する. 
  !
  use dc_message, only : MessageNotify
  implicit none

  private
  public eee_Initial                                  ! 初期化ルーチン
  public eee_ChangeResolution                         ! 解像度設定の変更
  public zyx_eee, eee_zyx, xyz_zyx                    ! 基本変換
  public eee_Dx_eee, eee_Dy_eee, eee_Dz_eee           ! 微分
  public eee_Lapla_eee, eee_LaplaInv_eee              ! 微分
  public eee2_RotVelxVor_eee2                         ! 非線形計算
  public eee_VorFromZeta_eee2, eee_VelFromZeta_eee2   ! 渦度速度計算
  public eee2_ZetaFromVor_eee_eee_eee                 ! 渦度変換

  public IntZYX_zyx, AvrZYX_zyx                       ! 積分・平均
  public z_IntYX_zyx, z_AvrYX_zyx                     ! 積分・平均
  public x_IntZY_zyx, x_AvrZY_zyx                     ! 積分・平均
  public y_IntZX_zyx, y_AvrZX_zyx                     ! 積分・平均
  public zy_IntX_zyx, zy_AvrX_zyx                     ! 積分・平均
  public zx_IntY_zyx, zx_AvrY_zyx                     ! 積分・平均
  public yx_IntZ_zyx, yx_AvrZ_zyx                     ! 積分・平均

  public IntYX_yx,  AvrYX_yx                          ! 積分・平均
  public y_IntX_yx, y_AvrX_yx                         ! 積分・平均
  public x_IntY_yx, x_AvrY_yx                         ! 積分・平均
  public IntZX_zx, AvrZX_zx                           ! 積分・平均
  public z_IntX_zx, z_AvrX_zx                         ! 積分・平均
  public x_IntZ_zx, x_AvrZ_zx                         ! 積分・平均
  public IntZY_zy, AvrZY_zy                           ! 積分・平均
  public y_IntZ_zy, y_AvrZ_zy                         ! 積分・平均
  public z_IntY_zy, z_AvrY_zy                         ! 積分・平均

  public IntX_x, AvrX_x                               ! 積分・平均
  public IntY_y, AvrY_y                               ! 積分・平均
  public IntZ_z, AvrZ_z                               ! 積分・平均

  public EnergyHelicityFromZeta_eee2                  ! エネルギーヘリシティー
  public ESpectralFromZeta                            ! エネルギースペクトル

  public x_X, y_Y, z_Z                                ! 座標変数
  public x_X_Weight, y_Y_Weight, z_Z_Weight           ! 座標変数
  public zyx_X, zyx_Y, zyx_Z                          ! 座標変数

  integer   :: im=32, jm=32, km=32                    ! 格子点の設定(X,Y,Z)
  integer   :: lm=10, mm=10, nm=10                    ! 切断波数の設定(X,Y,Z)
  real(8)   :: xl=1.0, yl=1.0, zl=1.0                 ! 領域の大きさ


  integer, dimension(:),   pointer :: itk => null()
  real(8), dimension(:),   pointer :: tk => null()
  integer, dimension(:),   pointer :: itj => null()
  real(8), dimension(:),   pointer :: tj => null()
  integer, dimension(:),   pointer :: iti => null()
  real(8), dimension(:),   pointer :: ti => null()


  real(8), dimension(:),   pointer :: x_X => null()   ! 格子点座標(X)
  real(8), dimension(:),   pointer :: y_Y => null()   ! 格子点座標(Y)
  real(8), dimension(:),   pointer :: z_Z => null()   ! 格子点座標(Y)

  real(8), dimension(:),   pointer :: x_X_Weight => null()
                                         ! 格子点重み(X)
                                         ! X 方向の格子点の間隔が格納してある.
  real(8), dimension(:),   pointer :: y_Y_Weight => null()
                                         ! 格子点重み(Y)
                                         ! Y 方向の格子点の間隔が格納してある.
  real(8), dimension(:),   pointer :: z_Z_Weight => null()
                                         ! 格子点重み(Y)
                                         ! Z 方向の格子点の間隔が格納してある.

  real(8), dimension(:,:,:), pointer :: zyx_X => null()
                          ! 格子点(X)座標(3 次元)
                          ! 各格子点(i,j,k)の位置の X 座標を格納した格子データ
  real(8), dimension(:,:,:), pointer :: zyx_Y => null()
                          ! 格子点(Y)座標(3 次元)
                          ! 各格子点(i,j,k)の位置の Y 座標を格納した格子データ
  real(8), dimension(:,:,:), pointer :: zyx_Z => null()
                          ! 格子点(Z)座標(3 次元)
                          ! 各格子点(i,j,k)の位置の Z 座標を格納した格子データ


  integer, parameter :: nparams_max = 10  ! eee_Initial を呼べる最大回数
  type eee_param                          ! 解像度領域情報構造体
     integer   :: im, jm, km
     integer   :: lm, mm, nm
     integer, dimension(:),     pointer :: itk
     real(8), dimension(:),     pointer :: tk
     integer, dimension(:),     pointer :: itj
     real(8), dimension(:),     pointer :: tj
     integer, dimension(:),     pointer :: iti
     real(8), dimension(:),     pointer :: ti
     real(8), dimension(:),     pointer :: x_X
     real(8), dimension(:),     pointer :: y_Y
     real(8), dimension(:),     pointer :: z_Z
     real(8), dimension(:),     pointer :: x_X_Weight
     real(8), dimension(:),     pointer :: y_Y_Weight
     real(8), dimension(:),     pointer :: z_Z_Weight
     real(8), dimension(:,:,:), pointer :: zyx_X
     real(8), dimension(:,:,:), pointer :: zyx_Y 
     real(8), dimension(:,:,:), pointer :: zyx_Z
  end type eee_param
  type(eee_param) :: params(nparams_max)  ! 解像度領域情報
  integer :: nparams                      ! 解像度領域情報の個数

  real(8), parameter  :: pi=3.1415926535897932385D0

  save im, jm, km, lm, mm, nm, itk, tk, itj, tj, iti, ti
  save x_X, y_Y, z_Z, x_X_Weight, y_Y_Weight, z_Z_Weight, zyx_X, zyx_Y, zyx_Z
  save params, nparams

  contains
  !--------------- 初期化 -----------------
    subroutine eee_Initial(i,j,k,l,m,n,id)
      !
      ! スペクトル変換の格子点数, 波数を設定する.
      ! 領域の範囲は [0,2pi]x[0,2pi]x[0,2pi] に決め打ち
      !
      ! 他の関数や変数を呼ぶ前に, 最初にこのサブルーチンを呼んで
      ! 初期設定をしなければならない.
      !
      ! オプショナル引数 id を用いて異なる解像度, 領域を同時に
      ! 扱うことができる. eee_Initial を解像度, 領域ごとに呼んで
      ! 引数 id をキープし, eee_ChangeResolution で切替える. 
      !
      integer,intent(in) :: i           ! 格子点数(X)
      integer,intent(in) :: j           ! 格子点数(Y)
      integer,intent(in) :: k           ! 格子点数(Z)
      integer,intent(in) :: l           ! 切断波数(X)
      integer,intent(in) :: m           ! 切断波数(Y)
      integer,intent(in) :: n           ! 切断波数(X)

      integer, intent(out), optional :: id  ! 解像度領域情報番号

      character(len=3) cid
      integer :: ii, jj, kk

      im = i         ; jm = j         ; km = k
      lm = l         ; mm = m         ; nm = n

      if ( nparams .ge. nparams_max ) then
         call MessageNotify('W','eee_initial',&
              'too many call of eee_Initial, nothing was done.')
         if ( present(id) ) id = -1
         return
      end if

      nparams = nparams + 1

      params(nparams)%im = im
      params(nparams)%jm = jm
      params(nparams)%km = km
      params(nparams)%lm = lm
      params(nparams)%mm = mm
      params(nparams)%nm = nm

      allocate(params(nparams)%itk(5))
      allocate(params(nparams)%itj(5))
      allocate(params(nparams)%iti(5))
      allocate(params(nparams)%tk(km*2))
      allocate(params(nparams)%tj(jm*2))
      allocate(params(nparams)%ti(im*2))

      allocate(params(nparams)%x_X(0:im-1))
      allocate(params(nparams)%x_X_Weight(0:im-1))
      allocate(params(nparams)%y_Y(0:jm-1))
      allocate(params(nparams)%y_Y_Weight(0:jm-1))
      allocate(params(nparams)%z_Z(0:km-1))
      allocate(params(nparams)%z_Z_Weight(0:km-1))
      allocate(params(nparams)%zyx_X(0:km-1,0:jm-1,0:im-1))
      allocate(params(nparams)%zyx_Y(0:km-1,0:jm-1,0:im-1))
      allocate(params(nparams)%zyx_Z(0:km-1,0:jm-1,0:im-1))

      call eee_ChangeResolution(nparams)

      call p3init(km,jm,im,itk,tk,itj,tj,iti,ti)

      do ii=0,im-1
         x_X(ii) = 2*pi/im*ii
      enddo
      x_X_Weight = 2*pi/im

      do jj=0,jm-1
         y_Y(jj) = 2*pi/jm*jj
      enddo
      y_Y_Weight = 2*pi/jm

      do kk=0,km-1
         z_Z(kk) = 2*pi/km*kk
      enddo
      z_Z_Weight = 2*pi/km

      zyx_X = spread(spread(x_X,1,jm),1,km)
      zyx_Y = spread(spread(y_Y,2,im),1,km)
      zyx_Z = spread(spread(z_Z,2,jm),3,im)

      if ( present(id) ) id = nparams

      write(cid,'(I3)') nparams
      call MessageNotify('M','eee_initial','eee_module (2009/07/31) is initialized')
      call MessageNotify('M','eee_initial',&
           'Resolution ID is '//trim(adjustl(cid)))
    end subroutine eee_initial

  !--------------- id 変更 -----------------
    subroutine eee_ChangeResolution(id)
      !
      ! 解像度設定の変更. eee_Initial で設定する際に
      ! かえってくるオプショナル引数 id の値を用いる. 
      ! 
      integer, intent(in) :: id

      if (id .gt. nparams .or. id .lt. 1) then
         write(*,*)"id is invalid"
      end if

      im = params(id)%im
      jm = params(id)%jm
      km = params(id)%km
      lm = params(id)%lm
      mm = params(id)%mm
      nm = params(id)%nm
      itk => params(id)%itk
      tk => params(id)%tk
      itj => params(id)%itj
      tj => params(id)%tj
      iti => params(id)%iti
      ti => params(id)%ti
      x_X => params(id)%x_X
      y_Y => params(id)%y_Y
      z_Z => params(id)%z_Z
      x_X_Weight => params(id)%x_X_Weight
      y_Y_Weight => params(id)%y_Y_Weight
      z_Z_Weight => params(id)%z_Z_Weight
      zyx_X => params(id)%zyx_X
      zyx_Y => params(id)%zyx_Y
      zyx_Z => params(id)%zyx_Z

    end subroutine eee_ChangeResolution

  !--------------- 基本変換 -----------------
    function zyx_eee(eee)
      !
      ! スペクトルデータから格子データへ変換する.
      !
      real(8), dimension(0:km-1,0:jm-1,0:im-1)             :: zyx_eee 
      !(out) 格子点データ

      real(8), dimension(-nm:nm,-mm:mm,-lm:lm), intent(in) :: eee
      !(in)  スペクトルデータ

      real(8), dimension(km*jm*im)                         :: w
      ! 作業領域

      call p3s2ga(nm,mm,lm,km,jm,im,eee,zyx_eee,w,itk,tk,itj,tj,iti,ti)
    end function zyx_eee

    function eee_zyx(zyx)
      !
      ! 格子データからスペクトルデータへ変換する.
      !
      real(8), dimension(-nm:nm,-mm:mm,-lm:lm)              :: eee_zyx
      !(out)  スペクトルデータ

      real(8), dimension(0:km-1,0:jm-1,0:im-1), intent(in)  :: zyx
      !(in) 格子点データ

      real(8), dimension(km*jm*im)                         :: w
      real(8), dimension(0:km-1,0:jm-1,0:im-1)             :: zyx_tmp
      ! 作業領域

      zyx_tmp = zyx
      call p3g2sa(nm,mm,lm,km,jm,im,zyx_tmp,eee_zyx,w,itk,tk,itj,tj,iti,ti)
    end function eee_zyx

    function xyz_zyx(zyx)
      !
      ! 格子データの添え字順序変更
      !
      real(8), dimension(0:im-1,0:jm-1,0:km-1)             :: xyz_zyx
                                                        !(out) 格子点データ

      real(8), dimension(0:km-1,0:jm-1,0:im-1), intent(in)  :: zyx
                                                      !(in) 格子点データ
      integer :: i,j,k

      do k=0,km-1
         do j=0,jm-1
            do i=0,im-1
               xyz_zyx(i,j,k) = zyx(k,j,i)
            enddo
         enddo
      enddo

    end function xyz_zyx
    
  !--------------- 微分計算 -----------------
    function eee_Lapla_eee(eee)
      !
      ! 入力スペクトルデータにラプラシアン(∂xx+∂yy+∂zz)を作用する.
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに全波数 (l**2 + m**2 + n**2) をかける
      ! 計算を行っている. 
      !
      real(8), dimension(-nm:nm,-mm:mm,-lm:lm)              :: eee_Lapla_eee
      !(out) スペクトルデータのラプラシアン

      real(8), dimension(-nm:nm,-mm:mm,-lm:lm), intent(in)  :: eee
      !(in) 入力スペクトルデータ

      integer l,m,n
      ! 作業変数

         do l=-lm,lm
            do m=-mm,mm
               do n=-nm,nm
                  eee_Lapla_eee(n,m,l) = -(l**2+m**2+n**2)*eee(n,m,l)
               enddo
            enddo
         enddo
    end function eee_Lapla_eee

    function eee_LaplaInv_eee(eee)
      !
      ! 入力スペクトルデータに逆ラプラシアン(∂xx+∂yy+∂zz)**(-1)を作用する.
      !
      ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
      ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに全波数 (l**2 + m**2 + n**2) で割る
      ! 計算を行っている. l=m=n=0 成分には 0 を代入している. 
      !
      real(8), dimension(-nm:nm,-mm:mm,-lm:lm)             :: eee_LaplaInv_eee
      !(out) スペクトルデータの逆ラプラシアン

      real(8), dimension(-nm:nm,-mm:mm,-lm:lm), intent(in) :: eee
      !(in) スペクトルデータ

      integer l,m,n

      do l=-lm,lm
         do m=-mm,mm
            do n=-nm,nm
               if ( l.ne.0 .or. m.ne.0 .or. n.ne.0 ) then
                  eee_LaplaInv_eee(n,m,l) = -eee(n,m,l)/(l**2+m**2+n**2)
               else
                  eee_LaplaInv_eee(n,m,l) = 0.0
               endif
            enddo
         enddo
      enddo
    end function eee_LaplaInv_eee

    function eee_Dx_eee(eee)
      !
      ! 入力スペクトルデータに X 微分(∂x)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 l をかけて
      ! 実部 <-> 虚部成分に入れ換える計算を行っている.
      !
      real(8), dimension(-nm:nm,-mm:mm,-lm:lm)              :: eee_Dx_eee
      !(out) スペクトルデータの X 微分

      real(8), dimension(-nm:nm,-mm:mm,-lm:lm), intent(in)  :: eee
      !(in) 入力スペクトルデータ

      integer l,m,n
      ! 作業変数


      do l=-lm,lm
         do m=-mm,mm
            do n=-nm,nm
               eee_Dx_eee(n,m,l) = -l*eee(-n,-m,-l)
            enddo
         enddo
      enddo
    end function eee_Dx_eee

    function eee_Dy_eee(eee)
      !
      ! 入力スペクトルデータに Y 微分(∂y)を作用する.
      !
      ! スペクトルデータの Y 微分とは, 対応する格子点データに Y 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに Y 方向波数 m をかけて
      ! 実部 <-> 虚部成分に入れ換える計算を行っている.
      !
      real(8), dimension(-nm:nm,-mm:mm,-lm:lm)              :: eee_Dy_eee
      !(out) スペクトルデータの X 微分

      real(8), dimension(-nm:nm,-mm:mm,-lm:lm), intent(in)  :: eee
      !(in) 入力スペクトルデータ

      integer l,m,n
      ! 作業変数


      do l=-lm,lm
         do m=-mm,mm
            do n=-nm,nm
               eee_Dy_eee(n,m,l) = -m*eee(-n,-m,-l)
            enddo
         enddo
      enddo
    end function eee_Dy_eee

    function eee_Dz_eee(eee)
      !
      ! 入力スペクトルデータに Z 微分(∂z)を作用する.
      !
      ! スペクトルデータの Z 微分とは, 対応する格子点データに Z 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに Z 方向波数 n をかけて
      ! 実部 <-> 虚部成分に入れ換える計算を行っている.
      !
      real(8), dimension(-nm:nm,-mm:mm,-lm:lm)              :: eee_Dz_eee
      !(out) スペクトルデータの X 微分

      real(8), dimension(-nm:nm,-mm:mm,-lm:lm), intent(in)  :: eee
      !(in) 入力スペクトルデータ

      integer l,m,n
      ! 作業変数


      do l=-lm,lm
         do m=-mm,mm
            do n=-nm,nm
               eee_Dz_eee(n,m,l) = -n*eee(-n,-m,-l)
            enddo
         enddo
      enddo
    end function eee_Dz_eee

  !--------------- 非線形項計算 -----------------

    function eee2_RotVelxVor_eee2(eee2)
      !
      !  渦度 2 成分(ζ_1, ζ_2)のスペクトルデータから Euler 方程式の非線形項
      !
      !     ▽x(u x ω) 
      !
      !  の 2 成分を計算する.
      !
      !  (ζ_1, ζ_2) と渦度 ω との関係は ISPACK/P3PACK のマニュアルを参照
      !
      real(8), dimension(-nm:nm,-mm:mm,-lm:lm,2)     :: eee2_RotVelxVor_eee2
      !(out) 非線形項のスペクトルデータの 2 つの成分

      real(8), dimension(-nm:nm,-mm:mm,-lm:lm,2), intent(in)  :: eee2
      !(in) 入力スペクトルデータ. 渦度の 2 成分(ζ_1, ζ_2)

      real(8), dimension((2*lm+1)*(2*mm+1)*(2*nm+1))      :: ws
      real(8), dimension(km*jm*im*4)                      :: wg

      call p3elnl(nm,mm,lm,km,jm,im,eee2,eee2_RotVelxVor_eee2, &
                  ws,wg,itk,tk,itj,tj,iti,ti)

    end function eee2_RotVelxVor_eee2

    function eee_VorFromZeta_eee2(eee2,isw)
      !
      !  渦度 2 成分(ζ_1, ζ_2)のスペクトルデータから渦度のスペクトルの 1 成分
      !  を計算する.
      !
      !  (ζ_1, ζ_2) と渦度 ω との関係は ISPACK/P3PACK のマニュアルを参照
      !
      real(8), dimension(-nm:nm,-mm:mm,-lm:lm)     :: eee_VorFromZeta_eee2
      !(out) 非線形項のスペクトルデータの 2 つの成分

      real(8), dimension(-nm:nm,-mm:mm,-lm:lm,2), intent(in)  :: eee2
      !(in) 入力スペクトルデータ. 渦度の 2 成分(ζ_1, ζ_2)

      integer, intent(IN) :: isw
      !(in) 出力する渦度の成分のインデックス(1,2,3)

      call p3geto(nm,mm,lm,eee2,eee_VorFromZeta_eee2,isw)

    end function eee_VorFromZeta_eee2

    function eee_VelFromZeta_eee2(eee2,isw)
      !
      !  渦度 2 成分(ζ_1, ζ_2)のスペクトルデータから速度スペクトルの 1 成分
      !  を計算する.
      !
      !  (ζ_1, ζ_2) と渦度 ω との関係は ISPACK/P3PACK のマニュアルを参照
      !
      real(8), dimension(-nm:nm,-mm:mm,-lm:lm)     :: eee_VelFromZeta_eee2
      !(out) 非線形項のスペクトルデータの 2 つの成分

      real(8), dimension(-nm:nm,-mm:mm,-lm:lm,2), intent(in)  :: eee2
      !(in) 入力スペクトルデータ. 渦度の 2 成分(ζ_1, ζ_2)

      integer, intent(IN) :: isw
      !(in) 出力する渦度の成分のインデックス(1,2,3)

      call p3getu(nm,mm,lm,eee2,eee_VelFromZeta_eee2,isw)

    end function eee_VelFromZeta_eee2

    function eee2_ZetaFromVor_eee_eee_eee(eee_1,eee_2,eee_3)
      !
      !  渦度のスペクトルから渦度 2 成分(ζ_1, ζ_2)を計算する.
      !
      !  (ζ_1, ζ_2) と渦度 ω との関係は ISPACK/P3PACK のマニュアルを参照
      !
      real(8), dimension(-nm:nm,-mm:mm,-lm:lm,2)     :: eee2_ZetaFromVor_eee_eee_eee
      !(out) 渦度の 2 成分(ζ_1, ζ_2)

      real(8), dimension(-nm:nm,-mm:mm,-lm:lm), intent(in)  :: eee_1, eee_2, eee_3
      !(in) 渦度スペクトルデータの各成分

      integer :: l,m,n

      do l=-lm,lm
         do m=-mm,mm
            do n=-nm,nm
               if ( l /= 0 ) then
                  eee2_ZetaFromVor_eee_eee_eee(n,m,l,1) = eee_2(n,m,l)
                  eee2_ZetaFromVor_eee_eee_eee(n,m,l,2) = eee_3(n,m,l)
               elseif( m /= 0 ) then
                  eee2_ZetaFromVor_eee_eee_eee(n,m,l,1) = eee_3(n,m,l)
                  eee2_ZetaFromVor_eee_eee_eee(n,m,l,2) = eee_1(n,m,l)
               else
                  eee2_ZetaFromVor_eee_eee_eee(n,m,l,1) = eee_1(n,m,l)
                  eee2_ZetaFromVor_eee_eee_eee(n,m,l,2) = eee_2(n,m,l)
               endif
            enddo
         enddo
      enddo

    end function eee2_ZetaFromVor_eee_eee_eee

  !--------------- 積分計算 -----------------
    function IntZYX_zyx(zyx)
      !
      ! 2 次元格子点データの全領域積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight, z_Z_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:km-1,0:jm-1,0:im-1), intent(IN)   :: zyx
      !(in)  3 次元格子点データ

      real(8)                                    :: IntZYX_zyx
      !(out) 積分値

      integer :: i, j, k
      ! 作業変数

      IntZYX_zyx = 0.0d0
      do i=0,im-1
         do j=0,jm-1
            do k=0,km-1
               IntZYX_zyx = IntZYX_zyx &
                    + zyx(k,j,i) * z_Z_Weight(k) * y_Y_Weight(j) * x_X_Weight(i)
            enddo
         enddo
      end do
    end function IntZYX_zyx

    function z_IntYX_zyx(zyx)
      !
      ! 3 次元格子点データの X,Y 方向積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:km-1,0:jm-1,0:im-1), intent(IN)   :: zyx
      !(in) 2 次元格子点データ

      real(8), dimension(0:km-1)          :: z_IntYX_zyx
      !(out) 積分された 1 次元(Y)格子点データ

      integer :: i, j
      ! 作業変数

      z_IntYX_zyx = 0.0d0
      do i=0,im-1
         do j=0,jm-1
            z_IntYX_zyx(:) = &
                 z_IntYX_zyx(:) + zyx(:,j,i) * x_X_Weight(i)* y_Y_Weight(j)
         enddo
      enddo
    end function z_IntYX_zyx

    function y_IntZX_zyx(zyx)
      !
      ! 3 次元格子点データの X,Z 方向積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight, z_Z_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:km-1,0:jm-1,0:im-1), intent(IN)   :: zyx
      !(in) 2 次元格子点データ

      real(8), dimension(0:jm-1)          :: y_IntZX_zyx
      !(out) 積分された 1 次元(Y)格子点データ

      integer :: i, k
      ! 作業変数

      y_IntZX_zyx = 0.0d0
      do i=0,im-1
         do k=0,km-1
            y_IntZX_zyx(:) = &
                 y_IntZX_zyx(:) + zyx(k,:,i) * x_X_Weight(i)* z_Z_Weight(k)
         enddo
      enddo
    end function y_IntZX_zyx

    function x_IntZY_zyx(zyx)
      !
      ! 3 次元格子点データの Y,Z 方向積分
      !
      ! 実際には格子点データ各点毎に y_Y_Weight, z_Z_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:km-1,0:jm-1,0:im-1), intent(IN)   :: zyx
      !(in) 2 次元格子点データ

      real(8), dimension(0:im-1)          :: x_IntZY_zyx
      !(out) 積分された 1 次元(Y)格子点データ

      integer :: j, k
      ! 作業変数

      x_IntZY_zyx = 0.0d0
      do j=0,jm-1
         do k=0,km-1
            x_IntZY_zyx(:) = &
                 x_IntZY_zyx(:) + zyx(k,j,:) * y_Y_Weight(j)* z_Z_Weight(k)
         enddo
      enddo
    end function x_IntZY_zyx

    function zy_IntX_zyx(zyx)
      !
      ! 3 次元格子点データの X 方向積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:km-1,0:jm-1,0:im-1), intent(IN)   :: zyx
      !(in) 2 次元格子点データ

      real(8), dimension(0:km-1,0:jm-1)          :: zy_IntX_zyx
      !(out) 積分された 2 次元(ZY)格子点データ

      integer :: i
      ! 作業変数

      zy_IntX_zyx = 0.0d0
      do i=0,im-1
         zy_IntX_zyx(:,:) = zy_IntX_zyx(:,:) + zyx(:,:,i) * x_X_Weight(i)
      enddo

    end function zy_IntX_zyx

    function zx_IntY_zyx(zyx)
      !
      ! 3 次元格子点データの Y 方向積分
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:km-1,0:jm-1,0:im-1), intent(IN)   :: zyx
      !(in) 2 次元格子点データ

      real(8), dimension(0:km-1,0:im-1)          :: zx_IntY_zyx
      !(out) 積分された 1 次元(Y)格子点データ

      integer :: j
      ! 作業変数

      zx_IntY_zyx = 0.0d0
      do j=0,jm-1
         zx_IntY_zyx(:,:) = zx_IntY_zyx(:,:) + zyx(:,j,:) * y_Y_Weight(j)
      enddo
    end function zx_IntY_zyx

    function yx_IntZ_zyx(zyx)
      !
      ! 3 次元格子点データの Z 方向積分
      !
      ! 実際には格子点データ各点毎に z_Z_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:km-1,0:jm-1,0:im-1), intent(IN)   :: zyx
      !(in) 2 次元格子点データ

      real(8), dimension(0:jm-1,0:im-1)          :: yx_IntZ_zyx
      !(out) 積分された 1 次元(YX)格子点データ

      integer :: k 
      ! 作業変数

      yx_IntZ_zyx = 0.0d0
      do k=0,km-1
         yx_IntZ_zyx(:,:) = yx_IntZ_zyx(:,:) + zyx(k,:,:) * z_Z_Weight(k)
      enddo

    end function yx_IntZ_zyx

    function IntYX_yx(yx)
      !
      ! 2 次元(YX)格子点データの全領域積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:jm-1,0:im-1), intent(IN)   :: yx          
      !(in)  2 次元(YX)格子点データ

      real(8)                             :: IntYX_yx
      !(out) 積分値

      integer :: i, j
      ! 作業変数

      IntYX_yx = 0.0d0
      do i=0,im-1
         do j=0,jm-1
            IntYX_yx = IntYX_yx + yx(j,i) * y_Y_Weight(j) * x_X_Weight(i)
         enddo
      enddo
    end function IntYX_yx

    function y_IntX_yx(yx)
      !
      ! 2 次元(YX)格子点データの X 方向積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:jm-1,0:im-1), intent(IN)   :: yx
      !(in) 2 次元(YX)格子点データ

      real(8), dimension(0:jm-1)          :: y_IntX_yx
      !(out) 積分された 1 次元(Y)格子点データ

      integer :: i
      ! 作業変数

      y_IntX_yx = 0.0d0
      do i=0,im-1
         y_IntX_yx(:) = y_IntX_yx(:) + yx(:,i) * x_X_Weight(i)
      enddo
    end function y_IntX_yx

    function x_IntY_yx(yx)
      !
      ! 2 次元(YX)格子点データの Y 方向積分
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:jm-1,0:im-1), intent(IN)   :: yx      
      !(in)  2 次元(YX)格子点データ

      real(8), dimension(0:im-1)        :: x_IntY_yx 
      !(out) 積分された 1 次元(X)格子点データ

      integer :: j
      ! 作業変数

      x_IntY_yx = 0.0d0
      do j=0,jm-1
         x_IntY_yx(:) = x_IntY_yx(:) + yx(j,:) * y_Y_Weight(j)
      enddo
    end function x_IntY_yx

    function IntZY_zy(zy)
      !
      ! 2 次元(ZY)格子点データの全領域積分および平均.
      !
      ! 実際には格子点データ各点毎に z_Z_Weight, y_Y_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:km-1,0:jm-1), intent(IN)   :: zy          
      !(in)  2 次元(ZY)格子点データ

      real(8)                             :: IntZY_zy
      !(out) 積分値

      integer :: j, k
      ! 作業変数

      IntZY_zy = 0.0d0
      do j=0,jm-1
         do k=0,km-1
            IntZY_zy = IntZY_zy + zy(k,j) * y_Y_Weight(j) * z_Z_Weight(k)
         enddo
      enddo
    end function IntZY_zy

    function y_IntZ_zy(zy)
      !
      ! 2 次元(ZY)格子点データの Z 方向積分
      !
      ! 実際には格子点データ各点毎に z_Z_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:km-1,0:jm-1), intent(IN)   :: zy          
      !(in)  2 次元(ZY)格子点データ

      real(8), dimension(0:jm-1)          :: y_IntZ_zy
      !(out) 積分された 1 次元(Y)格子点データ

      integer :: k
      ! 作業変数

      y_IntZ_zy = 0.0d0
      do k=0,km-1
         y_IntZ_zy(:) = y_IntZ_zy(:) + zy(k,:) * z_Z_Weight(k)
      enddo
    end function y_IntZ_zy

    function z_IntY_zy(zy)
      !
      ! 2 次元(ZY)格子点データの Y 方向積分
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:km-1,0:jm-1), intent(IN)   :: zy          
      !(in)  2 次元格子点データ

      real(8), dimension(0:km-1)        :: z_IntY_zy 
      !(out) 積分された 1 次元(X)格子点データ

      integer :: j
      ! 作業変数

      z_IntY_zy = 0.0d0
      do j=0,jm-1
         z_IntY_zy(:) = z_IntY_zy(:) + zy(:,j) * y_Y_Weight(j)
      enddo
    end function z_IntY_zy

    function IntZX_zx(zx)
      !
      ! 2 次元(ZX)格子点データの全領域積分および平均.
      !
      ! 実際には格子点データ各点毎に z_Z_Weight, x_X_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:km-1,0:im-1), intent(IN)   :: zx          
      !(in)  2 次元(ZX)格子点データ

      real(8)                             :: IntZX_zx
      !(out) 積分値

      integer :: i, k
      ! 作業変数

      IntZX_zx = 0.0d0
      do i=0,im-1
         do k=0,km-1
            IntZX_zx = IntZX_zx + zx(k,i) * x_X_Weight(i) * z_Z_Weight(k)
         enddo
      enddo
    end function IntZX_zx

    function x_IntZ_zx(zx)
      !
      ! 2 次元(ZX)格子点データの Z 方向積分
      !
      ! 実際には格子点データ各点毎に z_Z_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:km-1,0:im-1), intent(IN)   :: zx          
      !(in)  2 次元(ZX)格子点データ

      real(8), dimension(0:im-1)          :: x_IntZ_zx
      !(out) 積分された 1 次元(Y)格子点データ

      integer :: k
      ! 作業変数

      x_IntZ_zx = 0.0d0
      do k=0,km-1
         x_IntZ_zx(:) = x_IntZ_zx(:) + zx(k,:) * z_Z_Weight(k)
      enddo
    end function x_IntZ_zx

    function z_IntX_zx(zx)
      !
      ! 2 次元(ZX)格子点データの X 方向積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:km-1,0:im-1), intent(IN)   :: zx          
      !(in)  2 次元格子点データ

      real(8), dimension(0:km-1)        :: z_IntX_zx 
      !(out) 積分された 1 次元(X)格子点データ

      integer :: i
      ! 作業変数

      z_IntX_zx = 0.0d0
      do i=0,im-1
         z_IntX_zx(:) = z_IntX_zx(:) + zx(:,i) * x_X_Weight(i)
      enddo
    end function z_IntX_zx

    function IntX_x(x)
      !
      ! 1 次元(X)格子点データの X 方向積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:im-1)   :: x          !(in)  1 次元格子点データ
      real(8)                      :: IntX_x     !(out) 積分値

      IntX_x = sum(x*x_X_Weight)
    end function IntX_x

    function IntY_y(y)
      !
      ! 1 次元(Y)格子点データの Y 方向積分
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:jm-1)   :: y          !(in)  1 次元格子点データ
      real(8)                      :: IntY_y     !(out) 積分値

      IntY_y = sum(y*y_Y_Weight)
    end function IntY_y

    function IntZ_z(z)
      !
      ! 1 次元(Z)格子点データの Z 方向積分
      !
      ! 実際には格子点データ各点毎に z_Z_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:km-1)   :: z         !(in)  1 次元格子点データ
      real(8)                      :: IntZ_z     !(out) 積分値

      IntZ_z = sum(z*z_Z_Weight)
    end function IntZ_z

  !--------------- 平均計算 -----------------
    function AvrZYX_zyx(zyx)
      !
      ! 2 次元格子点データの全領域平均.
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight, z_Z_Weight を
      ! かけた総和を計算し, x_X_Weight*y_Y_Weight*z_Z_Weight の総和で割る
      ! ことで平均している. 
      !
      real(8), dimension(0:km-1,0:jm-1,0:im-1), intent(IN)   :: zyx
      !(in)  3 次元格子点データ

      real(8)                                    :: AvrZYX_zyx
      !(out) 積分値

      AvrZYX_zyx = IntZYX_zyx(zyx)/(sum(x_X_weight)*sum(y_Y_weight)*sum(z_Z_weight))

    end function AvrZYX_zyx

    function z_AvrYX_zyx(zyx)
      !
      ! 3 次元格子点データの X,Y 方向平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:jm-1,0:im-1), intent(IN)   :: zyx
      !(in) 2 次元格子点データ

      real(8), dimension(0:km-1)          :: z_AvrYX_zyx
      !(out) 積分された 1 次元(Y)格子点データ

      z_AvrYX_zyx = z_IntYX_zyx(zyx)/(sum(x_X_weight)*sum(y_Y_weight))

    end function z_AvrYX_zyx

    function y_AvrZX_zyx(zyx)
      !
      ! 3 次元格子点データの X,Z 方向平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight, z_Z_Weight をかけた
      ! 総和を計算し, x_X_Weight*z_Z_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:jm-1,0:im-1), intent(IN)   :: zyx
      !(in) 2 次元格子点データ

      real(8), dimension(0:jm-1)          :: y_AvrZX_zyx
      !(out) 積分された 1 次元(Y)格子点データ

      y_AvrZX_zyx = y_IntZX_zyx(zyx)/(sum(x_X_weight)*sum(z_Z_weight))

    end function y_AvrZX_zyx

    function x_AvrZY_zyx(zyx)
      !
      ! 3 次元格子点データの Y,Z 方向平均
      !
      ! 実際には格子点データ各点毎に y_Y_Weight, z_Z_Weight をかけた
      ! 総和を計算し, y_Y_Weight*z_Z_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:jm-1,0:im-1), intent(IN)   :: zyx
      !(in) 2 次元格子点データ

      real(8), dimension(0:im-1)          :: x_AvrZY_zyx
      !(out) 積分された 1 次元(Y)格子点データ

      x_AvrZY_zyx = x_IntZY_zyx(zyx)/(sum(y_Y_weight)*sum(z_Z_weight))

    end function x_AvrZY_zyx

    function zy_AvrX_zyx(zyx)
      !
      ! 3 次元格子点データの X 方向平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた
      ! 総和を計算し, x_X_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:jm-1,0:im-1), intent(IN)   :: zyx
      !(in) 2 次元格子点データ

      real(8), dimension(0:km-1,0:jm-1)          :: zy_AvrX_zyx
      !(out) 積分された 2 次元(ZY)格子点データ

      zy_AvrX_zyx = zy_IntX_zyx(zyx)/sum(x_X_weight)

    end function zy_AvrX_zyx

    function zx_AvrY_zyx(zyx)
      !
      ! 3 次元格子点データの Y 方向平均
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた
      ! 総和を計算し, y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:jm-1,0:im-1), intent(IN)   :: zyx
      !(in) 2 次元格子点データ

      real(8), dimension(0:km-1,0:im-1)          :: zx_AvrY_zyx
      !(out) 積分された 1 次元(Y)格子点データ

      zx_AvrY_zyx = zx_IntY_zyx(zyx)/sum(y_Y_weight)

    end function zx_AvrY_zyx

    function yx_AvrZ_zyx(zyx)
      !
      ! 3 次元格子点データの Z 方向平均
      !
      ! 実際には格子点データ各点毎に z_Z_Weight をかけた
      ! 総和を計算し, z_Z_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:jm-1,0:im-1), intent(IN)   :: zyx
      !(in) 2 次元格子点データ

      real(8), dimension(0:jm-1,0:im-1)          :: yx_AvrZ_zyx
      !(out) 積分された 1 次元(YX)格子点データ

      yx_AvrZ_zyx = yx_IntZ_zyx(zyx)/sum(z_Z_weight)

    end function yx_AvrZ_zyx

    function AvrYX_yx(yx)
      !
      ! 2 次元格子点データの全領域平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:jm-1,0:im-1), intent(IN)   :: yx
      !(in)  2 次元格子点データ

      real(8)                             :: AvrYX_yx    
      !(out) 平均値

      AvrYX_yx = IntYX_yx(yx)/(sum(x_X_weight)*sum(y_Y_weight))
    end function AvrYX_yx

    function y_AvrX_yx(yx)
      !
      ! 2 次元格子点データの X 方向平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:jm-1,0:im-1), intent(IN)   :: yx
      !(in) 2 次元格子点データ

      real(8), dimension(0:jm-1)          :: y_AvrX_yx
      !(out) 平均された 1 次元(Y)格子点データ

      y_AvrX_yx = y_IntX_yx(yx)/sum(x_X_weight)
    end function y_AvrX_yx

    function x_AvrY_yx(yx)
      !
      ! 2 次元格子点データの Y 方向平均
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:jm-1,0:im-1), intent(IN)   :: yx
      !(in) 2 次元格子点データ

      real(8), dimension(0:im-1)          :: x_AvrY_yx
      !(out) 平均された 1 次元(X)格子点データ

      x_AvrY_yx = x_IntY_yx(yx)/sum(y_Y_weight)
    end function x_AvrY_yx

    function AvrZX_zx(zx)
      !
      ! 2 次元(ZX)格子点データの全領域平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight, z_Z_Weight をかけた
      ! 総和を計算し, x_X_Weight*z_Z_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:im-1), intent(IN)   :: zx
      !(in)  2 次元(ZX)格子点データ

      real(8)                             :: AvrZX_zx    
      !(out) 平均値

      AvrZX_zx = IntZX_zx(zx)/(sum(x_X_weight)*sum(z_Z_weight))
    end function AvrZX_zx

    function z_AvrX_zx(zx)
      !
      ! 2 次元(ZX)格子点データの X 方向平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:im-1), intent(IN)   :: zx
      !(in) 2 次元(ZX)格子点データ

      real(8), dimension(0:km-1)          :: z_AvrX_zx
      !(out) 平均された 1 次元(Z)格子点データ

      z_AvrX_zx = z_IntX_zx(zx)/sum(x_X_weight)
    end function z_AvrX_zx

    function x_AvrZ_zx(zx)
      !
      ! 2 次元(ZX)格子点データの Z 方向平均
      !
      ! 実際には格子点データ各点毎に z_Z_Weight をかけた総和を計算し, 
      ! z_Z_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:im-1), intent(IN)   :: zx
      !(in) 2 次元(ZX)格子点データ

      real(8), dimension(0:im-1)          :: x_AvrZ_zx
      !(out) 平均された 1 次元(X)格子点データ

      x_AvrZ_zx = x_IntZ_zx(zx)/sum(z_Z_weight)
    end function x_AvrZ_zx

    function AvrZY_zy(zy)
      !
      ! 2 次元(ZY)格子点データの全領域平均
      !
      ! 実際には格子点データ各点毎に z_Z_Weight, y_Y_Weight をかけた
      ! 総和を計算し, z_Z_Weight*y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:jm-1), intent(IN)   :: zy
      !(in)  2 次元(ZY)格子点データ

      real(8)                             :: AvrZY_zy    
      !(out) 平均値

      AvrZY_zy = IntZY_zy(zy)/(sum(y_Y_weight)*sum(z_Z_weight))
    end function AvrZY_zy

    function z_AvrY_zy(zy)
      !
      ! 2 次元(ZY)格子点データの Y 方向平均
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:jm-1), intent(IN)   :: zy
      !(in) 2 次元(ZY)格子点データ

      real(8), dimension(0:km-1)          :: z_AvrY_zy
      !(out) 平均された 1 次元(Z)格子点データ

      z_AvrY_zy = z_IntY_zy(zy)/sum(y_Y_weight)
    end function z_AvrY_zy

    function y_AvrZ_zy(zy)
      !
      ! 2 次元(ZY)格子点データの Z 方向平均
      !
      ! 実際には格子点データ各点毎に z_Z_Weight をかけた総和を計算し, 
      ! z_Z_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:jm-1), intent(IN)   :: zy
      !(in) 2 次元(ZY)格子点データ

      real(8), dimension(0:jm-1)          :: y_AvrZ_zy
      !(out) 平均された 1 次元(X)格子点データ

      y_AvrZ_zy = y_IntZ_zy(zy)/sum(z_Z_weight)
    end function y_AvrZ_zy

    function AvrX_x(x)
      !
      ! 1 次元(X)格子点データの X 方向平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:im-1), intent(IN) :: x       !(in)  1 次元格子点データ
      real(8)                                :: AvrX_x  !(out) 平均値

      AvrX_x = IntX_x(x)/sum(x_X_weight)
    end function AvrX_x

    function AvrY_y(y)
      !
      ! 1 次元(Y)格子点データの Y 方向平均
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:jm-1), intent(IN) :: y      !(in)  1 次元格子点データ
      real(8)                                :: AvrY_y !(out) 平均値

      AvrY_y = IntY_y(y)/sum(y_Y_weight)
    end function AvrY_y

    function AvrZ_z(z)
      !
      ! 1 次元(Z)格子点データの Z 方向平均
      !
      ! 実際には格子点データ各点毎に z_Z_Weight をかけた総和を計算し, 
      ! z_Z_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1), intent(IN) :: z      !(in)  1 次元格子点データ
      real(8)                                :: AvrZ_z !(out) 平均値

      AvrZ_z = IntZ_z(z)/sum(z_Z_weight)
    end function AvrZ_z

  !--------------- スペクトル計算 -----------------
    function EnergyHelicityFromZeta_eee2(eee2)
      !
      ! 渦度成分(ζ_1, ζ_2)から全領域平均エネルギーとヘリシティーを計算する. 
      !
      real(8), dimension(2)                         :: EnergyHelicityFromZeta_eee2
      ! エネルギーヘリシティー

      real(8), dimension(-nm:nm,-mm:mm,-lm:lm,2), intent(in) :: eee2
      ! 渦度成分(ζ_1, ζ_2)

      real(8) :: E, H           ! エネルギー, ヘリシティー
      
      call p3cnsv(nm,mm,lm,eee2,E,H)

      EnergyHelicityFromZeta_eee2(1) = E ; EnergyHelicityFromZeta_eee2(2) = H

    end function EnergyHelicityFromZeta_eee2

    subroutine ESpectralFromZeta(esp,eee2)
      !
      ! 渦度成分(ζ_1, ζ_2)からエネルギースペクトルを計算する. 
      !
      !   * esp のサイズで求められる波数範囲が定められる
      !   * esp の総和が EFFromZeta で求められるエネルギー
      !     (全領域平均値)に等しい
      !
      real(8), dimension(:), intent(OUT)  :: esp
      ! エネルギースペクトル

      real(8), dimension(-nm:nm,-mm:mm,-lm:lm,2), intent(in) :: eee2
      ! 渦度成分(ζ_1, ζ_2)

      integer kmax
      ! 作業変数

      kmax=size(esp)
      call p3espt(nm,mm,lm,kmax,eee2,esp)

    end subroutine ESpectralFromZeta

end module eee_module

!----------------------------------------------------------------------
!     Copyright (c) 2009--2012 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_module テストプログラム (境界値問題, ▽^2φ から φを求める)
!
!履歴  2009/12/19  竹広真一
!      2012/07/09  竹広真一
!
program tee_module_polvelbcTau_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=16       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: zyx_Polvel(0:km,0:jm-1,0:im-1)      ! 格子データ
  real(8)            :: zyx_Polvel_orig(0:km,0:jm-1,0:im-1) ! 格子データ
  real(8)            :: zyx_LaplaPolvel(0:km,0:jm-1,0:im-1) ! 格子データ
  real(8)            :: zyx_LaplaPolvel_orig(0:km,0:jm-1,0:im-1) ! 格子データ
  real(8)            :: zyx_DPolvel(0:km,0:jm-1,0:im-1)     ! 格子データ
  real(8)            :: tee_Polvel(0:nm,-mm:mm,-lm:lm)      ! スペクトルデータ

  real(8)            :: zyx_Null(0:km,0:jm-1,0:im-1) =0.0D0 ! 格子データ

  integer            :: l=2, m=5

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','tee_module_PolvelbcTau_test', &
       'tee_module poloidal velocity potential B.C. function tests')

 !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call tee_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

 !-------------------BC-FF(Tau) ----------------------
  zyx_Polvel_orig = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (zyx_Z-zmin)**3 * (zyx_Z-zmax)**3
  zyx_LaplaPolvel_orig = zyx_tee(tee_Lapla_tee(tee_zyx(zyx_Polvel_orig)))

  tee_Polvel = tee_LaplaPol2PolTau_tee(tee_zyx(zyx_LaplaPolvel_orig),&
       cond='FF',new=.true.)

  zyx_Polvel = zyx_tee(tee_Polvel)
  zyx_LaplaPolvel = zyx_tee(tee_Lapla_tee(tee_Polvel))

  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [FF,poloidal]',             &
    answer = zyx_Polvel_orig,                                    &
    check = zyx_Polvel,                                          &
    significant_digits = check_digits, ignore_digits = ignore    &
    )
  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [FF,laplapol]',             &
    answer = zyx_LaplaPolvel_orig,                               &
    check = zyx_LaplaPolvel,                                     &
    significant_digits = check_digits, ignore_digits = ignore    &
    )
  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [FF,Top]',                  &
    answer = zyx_Polvel(0,:,:),                                  &
    check = zyx_Null(0,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore    &
    )
  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [FF,Bottom]',               &
    answer = zyx_Polvel(km,:,:),                                 &
    check = zyx_Null(km,:,:),                                    &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  zyx_DPolvel = zyx_tee(tee_Dz_tee(tee_Dz_tee(tee_Polvel)))

  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [FF,Top,deriv]',            &
    answer = zyx_DPolvel(0,:,:),                                 &
    check = zyx_Null(0,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [FF,Bottom,deriv]',         &
    answer = zyx_DPolvel(km,:,:),                                &
    check = zyx_Null(km,:,:),                                    &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

 !-------------------BC-RR(Tau) ----------------------
  zyx_Polvel_orig = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (zyx_Z-zmin)**2 * (zyx_Z-zmax)**2
  zyx_LaplaPolvel_orig = zyx_tee(tee_Lapla_tee(tee_zyx(zyx_Polvel_orig)))

  tee_Polvel = tee_LaplaPol2PolTau_tee(tee_zyx(zyx_LaplaPolvel_orig),&
       cond='RR',new=.true.)

  zyx_Polvel = zyx_tee(tee_Polvel)
  zyx_LaplaPolvel = zyx_tee(tee_Lapla_tee(tee_Polvel))

  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [RR,poloidal]',              &
    answer = zyx_Polvel_orig,                                     &
    check = zyx_Polvel,                                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [RR,laplapol]',              &
    answer = zyx_LaplaPolvel_orig,                                &
    check = zyx_LaplaPolvel,                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [RR,Top]',                   &
    answer = zyx_Polvel(0,:,:),                                   &
    check = zyx_Null(0,:,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [RR,Bottom]',                &
    answer = zyx_Polvel(km,:,:),                                  &
    check = zyx_Null(km,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_DPolvel = zyx_tee(tee_Dz_tee(tee_Polvel))

  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [RR,Top,deriv]',             &
    answer = zyx_DPolvel(0,:,:),                                  &
    check = zyx_Null(0,:,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [RR,Bottom,deriv]',          &
    answer = zyx_DPolvel(km,:,:),                                 &
    check = zyx_Null(km,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !-------------------BC-RF(Tau) ----------------------
  zyx_Polvel_orig = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (zyx_Z-zmin)**3 * (zyx_Z-zmax)**2
  zyx_LaplaPolvel_orig = zyx_tee(tee_Lapla_tee(tee_zyx(zyx_Polvel_orig)))

  tee_Polvel = tee_LaplaPol2PolTau_tee(tee_zyx(zyx_LaplaPolvel_orig),&
       cond='RF',new=.true.)

  zyx_Polvel = zyx_tee(tee_Polvel)
  zyx_LaplaPolvel = zyx_tee(tee_Lapla_tee(tee_Polvel))

  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [RF,poloidal]',              &
    answer = zyx_Polvel_orig,                                     &
    check = zyx_Polvel,                                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [RF,laplapol]',              &
    answer = zyx_LaplaPolvel_orig,                                &
    check = zyx_LaplaPolvel,                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [RF,Top]',                   &
    answer = zyx_Polvel(0,:,:),                                   &
    check = zyx_Null(0,:,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [RF,Bottom]',                &
    answer = zyx_Polvel(km,:,:),                                  &
    check = zyx_Null(km,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_DPolvel = zyx_tee(tee_Dz_tee(tee_Polvel))

  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [RF,Top,deriv]',             &
    answer = zyx_DPolvel(0,:,:),                                  &
    check = zyx_Null(0,:,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_DPolvel = zyx_tee(tee_Dz_tee(tee_Dz_tee(tee_Polvel)))

  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [RF,Bottom,deriv]',          &
    answer = zyx_DPolvel(km,:,:),                                 &
    check = zyx_Null(km,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !-------------------BC-FR(Tau) ----------------------
  zyx_Polvel_orig = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (zyx_Z-zmin)**2 * (zyx_Z-zmax)**3
  zyx_LaplaPolvel_orig = zyx_tee(tee_Lapla_tee(tee_zyx(zyx_Polvel_orig)))

  tee_Polvel = tee_LaplaPol2PolTau_tee(tee_zyx(zyx_LaplaPolvel_orig),&
       cond='FR',new=.true.)

  zyx_Polvel = zyx_tee(tee_Polvel)
  zyx_LaplaPolvel = zyx_tee(tee_Lapla_tee(tee_Polvel))

  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [FR,poloidal]',              &
    answer = zyx_Polvel_orig,                                     &
    check = zyx_Polvel,                                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [FR,laplapol]',              &
    answer = zyx_LaplaPolvel_orig,                                &
    check = zyx_LaplaPolvel,                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [FR,Top]',                   &
    answer = zyx_Polvel(0,:,:),                                   &
    check = zyx_Null(0,:,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [FR,Bottom]',                &
    answer = zyx_Polvel(km,:,:),                                  &
    check = zyx_Null(km,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_DPolvel = zyx_tee(tee_Dz_tee(tee_Dz_tee(tee_Polvel)))

  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [FR,Top,deriv]',             &
    answer = zyx_DPolvel(0,:,:),                                  &
    check = zyx_Null(0,:,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_DPolvel = zyx_tee(tee_Dz_tee(tee_Polvel))

  call AssertEqual(&
    message='tee_LaplaPol2PolTau_tee [RF,Bottom,deriv]',          &
    answer = zyx_DPolvel(km,:,:),                                 &
    check = zyx_Null(km,:,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','tee_module_PolvelbcTau_test', &
       'tee_module poloidal velocity potential B.C. function tests succeeded!')

end program tee_module_polvelbcTau_test

!----------------------------------------------------------------------
!   Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  et_module_fftj テストプログラム (正逆変換)
!
!履歴  2009/09/10  竹広真一  et_test_transform.f90 を fftj 用に改造
!      
program et_module_fftj_base_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use et_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm,0:im-1)    ! 格子データ
  real(8)            :: et_Data(-km:km,0:lm)    ! スペクトルデータ
  real(8)            :: yx_xi(0:jm,0:im-1)      ! チェビシェフ座標

  integer            :: k=2

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin =  0.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','et_module_fftj_base_test', &
       'et_module_fftj basic functions tests')

 !---------------- 座標値の設定 ---------------------
  call et_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

  yx_xi = (yx_Y - (ymin+ymax)/2 )*2/(ymax-ymin)

 !------------------- 関数チェック ----------------------
  yx_Data = sin(k*pi*yx_X) * yx_xi
  et_Data = 0.0 ; et_Data(-k,1) = -0.5
  call AssertEqual(&
    message='et_yx with sin(k*pi*X)*T_1(Y)',                      &
    answer = et_Data,                                             &
    check = et_yx(yx_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='yx_et with sin(k*pi*X)*T_1(Y)',                      &
    answer = yx_Data,                                             &
    check = yx_et(et_yx(yx_Data)),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = cos(k*pi*yx_X) * (2*yx_xi**2 -1)
  et_Data = 0.0 ; et_Data(k,2) = 0.5
  call AssertEqual(&
    message='et_yx with cos(k*pi*X)*T_2(Y)',                      &
    answer = et_Data,                                             &
    check = et_yx(yx_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='yx_et with cos(k*pi*X)*T_2(Y)',                      &
    answer = yx_Data,                                             &
    check = yx_et(et_yx(yx_Data)),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = sin(k*pi*yx_X) 
  et_Data = 0.0 ; et_Data(-k,0) = -1.0
  call AssertEqual(&
    message='et_yx with sin(k*pi*X)*T_0(Y)',                      &
    answer = et_Data,                                             &
    check = et_yx(yx_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='yx_et with sin(k*pi*X)*T_0(Y)',                      &
    answer = yx_Data,                                             &
    check = yx_et(et_yx(yx_Data)),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = cos(k*pi*yx_X) * (4*yx_xi**3 - 3*yx_xi)
  et_Data = 0.0 ; et_Data(k,3) = 0.5
  call AssertEqual(&
    message='et_yx with cos(k*pi*X)*T_3(Y)',                      &
    answer = et_Data,                                             &
    check = et_yx(yx_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='yx_et with cos(k*pi*X)*T_3(Y)',                      &
    answer = yx_Data,                                             &
    check = yx_et(et_yx(yx_Data)),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','et_module_fftj_base_test', &
       'et_module_fftj basic functions tests succeeded!')

end program et_module_fftj_base_test

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_mpi_module テストプログラム (微分演算)
!
!履歴  2016/09/19  竹広真一
!
program tee_mpi_module_deriv_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=10       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8), allocatable   :: zvx_Data(:,:,:)    ! 格子データ
  real(8), allocatable   :: zvx_Deriv(:,:,:)   ! 格子データ
  real(8), allocatable   :: tef_Data(:,:,:)    ! スペクトルデータ

  integer            :: l=2, m=5
  integer            :: np, ip, ierr

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','tee_mpi_module_deriv_test', &
       'tee_mpi_module derivative function tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)
   
 !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call tee_mpi_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

  allocate(zvx_Data(0:km,jc(ip),0:im-1))      ! 格子データ
  allocate(zvx_Deriv(0:km,jc(ip),0:im-1))     ! 格子データ
  allocate(tef_Data(0:nm,-mm:mm,2*lc(ip)))    ! スペクトルデータ

 !------------------- 関数チェック ----------------------
  zvx_Data = sin(l*pi*zvx_X) * sin(m*pi*zvx_Y) * zvx_Z

  zvx_Deriv = l*pi*cos(l*pi*zvx_X) * sin(m*pi*zvx_Y) * zvx_Z
  call AssertEqual(&
    message='tef_Dx_tef with sin(k*pi*X)*sin(l*pi*Y)*Z',          &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_Dx_tef(tef_zvx(zvx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = m*pi*sin(l*pi*zvx_X) * cos(m*pi*zvx_Y) * zvx_Z
  call AssertEqual(&
    message='tef_Dy_tef with sin(k*pi*X)*sin(l*pi*Y)*Z',          &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_Dy_tef(tef_zvx(zvx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = sin(l*pi*zvx_X) * sin(m*pi*zvx_Y) 
  call AssertEqual(&
    message='tef_Dz_tef with sin(k*pi*X)*sin(l*pi*Y)*Z',          &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_Dz_tef(tef_zvx(zvx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = -((l*pi)**2+(m*pi)**2)*sin(l*pi*zvx_X) * sin(m*pi*zvx_Y)*zvx_Z
  call AssertEqual(&
    message='tef_Lapla_tef with sin(k*pi*X)*sin(l*pi*Y)*Z',       &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_Lapla_tef(tef_zvx(zvx_Data))),            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = -((l*pi)**2+(m*pi)**2)*sin(l*pi*zvx_X) * sin(m*pi*zvx_Y)*zvx_Z
  call AssertEqual(&
    message='tef_LaplaH_tef with sin(k*pi*X)*sin(l*pi*Y)*Z',      &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_LaplaH_tef(tef_zvx(zvx_Data))),           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = -sin(l*pi*zvx_X) * sin(m*pi*zvx_Y)*zvx_Z/((l*pi)**2+(m*pi)**2)
  call AssertEqual(&
    message='tef_LaplaHInv_tef with sin(k*pi*X)*sin(l*pi*Y)*Z',   &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_LaplaHInv_tef(tef_zvx(zvx_Data))),        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  zvx_Data = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)

  zvx_Deriv = -l*pi*sin(l*pi*zvx_X) *cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)
  call AssertEqual(&
    message='tef_Dx_tef with cos(k*pi*X)*cos(l*pi*Y)*(2Z**2-1)',  &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_Dx_tef(tef_zvx(zvx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = -m*pi*cos(l*pi*zvx_X) * sin(m*pi*zvx_Y) * (2*zvx_Z**2 -1)
  call AssertEqual(&
    message='tef_Dy_tef with cos(k*pi*X)*cos(l*pi*Y)*(2Z**2-1)',  &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_Dy_tef(tef_zvx(zvx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * 4 * zvx_Z
  call AssertEqual(&
    message='tef_Dz_tef with cos(k*pi*X)*cos(l*pi*Y)*(2Z**2-1)',  &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_Dz_tef(tef_zvx(zvx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = -((l*pi)**2+(m*pi)**2) &
       * cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1) &
       + cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * 4
  call AssertEqual(&
    message='tef_Lapla_tef with cos(k*pi*X)*cos(l*pi*Y)*(2Z**2-1)',  &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_Lapla_tef(tef_zvx(zvx_Data))),            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = -((l*pi)**2+(m*pi)**2) &
       * cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)
  call AssertEqual(&
    message='tef_LaplaH_tef with cos(k*pi*X)*cos(l*pi*Y)*(2Z**2-1)',  &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_LaplaH_tef(tef_zvx(zvx_Data))),           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = -1.0D0/((l*pi)**2+(m*pi)**2) &
       * cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)
  call AssertEqual(&
    message='tef_LaplaHInv_tef with cos(k*pi*X)*cos(l*pi*Y)*(2Z**2-1)',  &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_LaplaHInv_tef(tef_zvx(zvx_Data))),        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Data = sin(l*pi*zvx_X) * cos(m*pi*zvx_Y)/2.0D0

  zvx_Deriv = l*pi*cos(l*pi*zvx_X) * cos(m*pi*zvx_Y)/2.0D0
  call AssertEqual(&
    message='tef_Dx_tef with sin(k*pi*X)*cos(l*pi*Y)/2',          &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_Dx_tef(tef_zvx(zvx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = -m*pi*sin(l*pi*zvx_X) * sin(m*pi*zvx_Y)/2.0D0
  call AssertEqual(&
    message='tef_Dy_tef with sin(k*pi*X)*cos(l*pi*Y)/2',          &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_Dy_tef(tef_zvx(zvx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = 0.0D0
  call AssertEqual(&
    message='tef_Dz_tef with sin(k*pi*X)*cos(l*pi*Y)/2',          &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_Dz_tef(tef_zvx(zvx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = -((l*pi)**2+(m*pi)**2)*sin(l*pi*zvx_X) * cos(m*pi*zvx_Y)/2.0D0
  call AssertEqual(&
    message='tef_Lapla_tef with sin(k*pi*X)*cos(l*pi*Y)/2',       &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_Lapla_tef(tef_zvx(zvx_Data))),            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = -((l*pi)**2+(m*pi)**2)*sin(l*pi*zvx_X) * cos(m*pi*zvx_Y)/2.0D0
  call AssertEqual(&
    message='tef_LaplaH_tef with sin(k*pi*X)*cos(l*pi*Y)/2',      &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_LaplaH_tef(tef_zvx(zvx_Data))),           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = -1/((l*pi)**2+(m*pi)**2)*sin(l*pi*zvx_X) * cos(m*pi*zvx_Y)/2.0D0
  call AssertEqual(&
    message='tef_LaplaHInv_tef with sin(k*pi*X)*cos(l*pi*Y)/2',   &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_LaplaHInv_tef(tef_zvx(zvx_Data))),        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Data = cos(l*pi*zvx_X) * sin(m*pi*zvx_Y)*(4*zvx_Z**3-3*zvx_Z)

  zvx_Deriv = - l*pi*sin(l*pi*zvx_X) * sin(m*pi*zvx_Y)*(4*zvx_Z**3-3*zvx_Z)
  call AssertEqual(&
    message='tef_Dx_tef with cos(k*pi*X)*sin(l*pi*Y)*(4Z**3-3Z)', &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_Dx_tef(tef_zvx(zvx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = m*pi*cos(l*pi*zvx_X) * cos(m*pi*zvx_Y)*(4*zvx_Z**3-3*zvx_Z)
  call AssertEqual(&
    message='tef_Dy_tef with cos(k*pi*X)*sin(l*pi*Y)*(4Z**3-3Z)', &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_Dy_tef(tef_zvx(zvx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = cos(l*pi*zvx_X) * sin(m*pi*zvx_Y)*(12*zvx_Z**2-3)
  call AssertEqual(&
    message='tef_Dz_tef with cos(k*pi*X)*sin(l*pi*Y)*(4Z**3-3Z)', &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_Dz_tef(tef_zvx(zvx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = -((l*pi)**2+(m*pi)**2) &
       * cos(l*pi*zvx_X) * sin(m*pi*zvx_Y)*(4*zvx_Z**3-3*zvx_Z) &
       + cos(l*pi*zvx_X) * sin(m*pi*zvx_Y)*(24*zvx_Z)
  call AssertEqual(&
    message='tef_Lapla_tef with cos(k*pi*X)*sin(l*pi*Y)*(4Z**3-3Z)', &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_Lapla_tef(tef_zvx(zvx_Data))),            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = -((l*pi)**2+(m*pi)**2) &
       * cos(l*pi*zvx_X) * sin(m*pi*zvx_Y)*(4*zvx_Z**3-3*zvx_Z)
  call AssertEqual(&
    message='tef_LaplaH_tef with cos(k*pi*X)*sin(l*pi*Y)*(4Z**3-3Z)', &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_LaplaH_tef(tef_zvx(zvx_Data))),           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Deriv = -1/((l*pi)**2+(m*pi)**2) &
       * cos(l*pi*zvx_X) * sin(m*pi*zvx_Y)*(4*zvx_Z**3-3*zvx_Z)
  call AssertEqual(&
    message='tef_LaplaHInv_tef with cos(k*pi*X)*sin(l*pi*Y)*(4Z**3-3Z)', &
    answer = zvx_Deriv,                                           &
    check = zvx_tef(tef_LaplaHInv_tef(tef_zvx(zvx_Data))),        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MPI_FINALIZE(IERR)
  
  call MessageNotify('M','tee_mpi_module_deriv_test', &
       'tee_mpi_module derivateiv functions tests succeeded!')

end program tee_mpi_module_deriv_test

!----------------------------------------------------------------------
!     Copyright (c) 2007 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  et_module テストプログラム
!      境界値問題
!
!履歴  2007/11/19  竹広真一  
!      
!
program et_test_boundaries

  use dc_message, only : MessageNotify
  use et_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=21              ! 切断波数の設定(X,Y)

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: eps = 1.0d-10            ! 判定誤差

  real(8)            :: yx_A(0:jm,0:im-1)     ! 格子データ
  real(8)            :: yx_dAdy(0:jm,0:im-1) ! 格子データ
  real(8)            :: et_A(-km:km,0:lm)     ! スペクトルデータ

  real(8), dimension(-km:km,2)  :: values

  integer            :: k=2

  call MessageNotify('M','et_test_boudaries', &
       'et_module subroutine for boundary value problem tests')

 !---------------- 座標値の設定 ---------------------
  call et_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

!----- et_Boundaries (DD) ------
  yx_A = sin(k*pi*yx_X)*sin(pi*yx_Y)
  et_A = et_yx(yx_a)
  values = 0.0

  call et_Boundaries(et_A,values=values,cond='DD')
  yx_A = yx_et(et_A)
  yx_dAdy = yx_et(et_Dy_et(et_A))

  if ( maxval(abs(yx_A(0,:)-values(0,1))) > eps .OR. &
       maxval(abs(yx_A(jm,:)-values(0,2))) > eps )then
     call MessageNotify('E','Test of et_Boundaries', &
          'B.C. adoption error too large.')
  endif

  call MessageNotify('M','Test of et_Boundaries','Test of DD b.c. suceeded!')
 
!----- et_Boundaries (DN) ------
  yx_A = sin(k*pi*yx_X)*sin(pi/2*yx_Y)
  et_A = et_yx(yx_a)

  call et_Boundaries(et_A,values,cond='DN')
  yx_A = yx_et(et_A)
  yx_dAdy = yx_et(et_Dy_et(et_A))
  if ( maxval(abs(yx_A(0,:)-values(0,1))) > eps .OR. &
       maxval(abs(yx_dAdy(jm,:)-values(0,2))) > eps )then
     call MessageNotify('E','Test of et_Boundaries', &
          'B.C. adoption error too large.')
  endif
  call MessageNotify('M','Test of et_Boundaries','Test of DN b.c. suceeded!')

!----- et_Boundaries (ND) ------
  yx_A = sin(k*pi*yx_X)*cos(pi/2*yx_Y)
  et_A = et_yx(yx_a)
  call et_Boundaries(et_A,values,cond='ND')
  yx_A = yx_et(et_A)
  yx_dAdy = yx_et(et_Dy_et(et_A))

  if ( maxval(abs(yx_dAdy(0,:)-values(0,1))) > eps .OR. &
       maxval(abs(yx_A(jm,:)-values(0,2))) > eps )then
     call MessageNotify('E','Test of et_Boundaries', &
          'B.C. adoption error too large.')
  endif
  call MessageNotify('M','Test of et_Boundaries','Test of ND b.c. suceeded!')

!----- et_Boundaries (ND) ------
  yx_A = sin(k*pi*yx_X)*cos(pi*yx_Y)
  et_A = et_yx(yx_a)
  call et_Boundaries(et_A,values,cond='NN')
  yx_A = yx_et(et_A)
  yx_dAdy = yx_et(et_Dy_et(et_A))

  if ( maxval(abs(yx_dAdy(0,:)-values(0,1))) > eps .OR. &
       maxval(abs(yx_dAdy(jm,:)-values(0,2))) > eps )then
     call MessageNotify('E','Test of et_Boundaries', &
          'B.C. adoption error too large.')
  endif
  call MessageNotify('M','Test of et_Boundaries','Test of NN b.c. suceeded!')

  call MessageNotify('M','et_test_boudaries', &
       'et_module subroutine for boundary value problem tests succeeded!')

end program et_test_boundaries

!--
!----------------------------------------------------------------------
! Copyright(c) 2008-2013 SPMDODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  aq_module
!
!      spml/aq_module モジュールは 1 次元有限領域の下での流体運動を
!      Matsushima and Marcus (1994) で提唱された多項式を用いた
!      スペクトル数値計算ための Fortran90 関数を提供する.
!      このルーチンは離散化にチェビシェフ--ガウス--ラダウ格子点を適用
!      しており, 主に 2 次元極座標,  円筒座標, 球座標の原点の
!      特異性を回避しながらスペクトル計算を行うために用いることを
!      念頭においている.
!
!      2 次元データの 1 次元に関して同時にスペクトル計算を実行するための
!      関数も提供しており, 2, 3 次元領域での計算のベースも提供する.
!
!      Matsushima and Marcus (1994) の多項式に関する説明は
!      doc/spectral_radial.tex を参照のこと.
!
!++
module aq_module
  !
  != aq_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/aq_module モジュールは 1 次元有限領域の下での流体運動を
  ! Matsushima and Marcus (1994) で提唱された多項式を用いたスペクトル法によって
  ! 数値計算するための Fortran90 関数を提供する.
  !
  ! このルーチンは離散化にチェビシェフ--ガウス--ラダウ格子点を適用して
  ! おり, 主に 2 次元極座標, 円筒座標, 球座標の原点の特異性を回避しな
  ! がらスペクトル計算を行うために用いることを念頭においている.
  !
  ! 2 次元データの 1 次元に関して同時にスペクトル計算を実行するための
  ! 関数も提供しており, 2, 3 次元領域での計算のベースも提供する.
  !
  ! Matsushima and Marcus (1994) の多項式に関する説明は
  ! 動径座標のスペクトル法(spectral_radial.pdf[link:spectral_radial.pdf])
  ! を参照のこと.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (u_, g_, aq_, ag_) は, 返す値の形を示している.
  !   複数並んだ 2 次元データの第 1 次元の大きさは aq_Initial で
  !   設定する重みの指数の配列 nd の大きさと同じでなければならない.
  !   q_  :: スペクトルデータ
  !   g_  :: 1 次元格子点データ
  !   aq_ :: 1 次元スペクトルデータが複数並んだ 2 次元データ
  !   ag_ :: 1 次元格子点データが複数並んだ 2 次元データ.
  !
  ! * 関数名の間の文字列(Dr)は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_e, _aq, _g, _ag) は, 入力変数の形がスペクトルデータ
  !   および格子点データであることを示している.
  !   _q  :: スペクトルデータ
  !   _g  :: 1 次元格子点データ
  !   _aq :: 1 次元スペクトルデータが複数並んだ 2 次元データ
  !   _ag :: 1 次元格子点データが複数並んだ 2 次元データ
  !
  !=== 各データの種類の説明
  !
  ! * g : 1 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(im).
  !   * im は R 座標の格子点数であり, サブルーチン aq_Initial にて
  !     あらかじめ設定しておく.
  !
  ! * q : スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(0:km).
  !   * km は R 方向の最大波数であり, サブルーチン aq_Initial にて
  !     あらかじめ設定しておく. スペクトルデータの格納のされ方については...
  !
  ! * ag : 1 次元(R)格子点データの並んだ 2 次元データ.
  !   * 変数の種類と次元は real(8), dimension(size(nd),im).
  !     第 2 次元が R 方向を表す.
  !
  ! * aq : 1 次元スペクトルデータの並んだ 2 次元データ.
  !   * 変数の種類と次元は real(8), dimension(size(nd),0:km).
  !     第 2 次元がスペクトルを表す.
  !
  ! * g_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * q_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * ag_ で始まる関数が返す値は 1 次元格子点データの並んだ
  !   2 次元データに同じ.
  !
  ! * aq_ で始まる関数が返す値は 1 次元スペクトルデータの並んだ
  !   2 次元データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したもののことである.
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! aq_Initial  :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  !
  !==== 座標変数
  !
  ! g_R        :: 格子点座標(R)を格納した 1 次元配列
  ! g_R_Weight :: 重み座標を格納した 1 次元配列
  !
  !==== 基本変換
  !
  ! g_q, ag_aq :: スペクトルデータから格子データへの変換
  ! q_g, aq_ag :: 格子データからスペクトルデータへの変換
  !
  !==== 微分
  !
  ! q_rDr_q, aq_rDr_aq :: スペクトルデータに r(d/dR) 微分を作用させる
  !
  !==== 積
  !
  ! q_r2_q,    aq_r2_aq    :: スペクトルデータに r^2 をかける
  ! q_r2Inv_q, aq_r2Inv_aq :: スペクトルデータに r^-2 をかける
  !
  !==== 積分・平均
  !
  ! a_Int_ag, a_Avr_ag :: 1 次元格子点データの並んだ 2 次元配列の積分および平均
  ! Int_g, Avr_g       :: 1 次元格子点データの積分および平均
  !
  !==== 境界値問題
  !
  ! aq_Boundary_D, aq_Boundary_N         :: 外側ディリクレ条件, ノイマン条件
  ! aq_BoundaryTau_D, aq_BoundaryTau_N   :: 外側ディリクレ条件,
  !                                         ノイマン条件(タウ法)
  ! ag_BoundaryGrid_D, ag_BoundaryGrid_N :: 外側ディリクレ条件,
  !                                         ノイマン条件(選点法)
  !
  use dc_message
  use lumatrix
  implicit none

  private

  public  aq_initial                           ! 初期化
  public  g_R, g_R_Weight                      ! 座標変数

  public  ag_aq, aq_ag, g_q, q_g               ! 基本変換

  public  aq_rDr_aq, q_rDr_q                   ! 微分
  public  aq_r2_aq, q_r2_q                     ! 積
  public  aq_r2Inv_aq, q_r2Inv_q               ! 積

  public  a_Int_ag, a_Avr_ag                   ! 積分・平均
  public  Int_g, Avr_g                         ! 積分・平均

  public  aq_Boundary_D, aq_Boundary_N         ! 境界条件
  public  aq_BoundaryTau_D, aq_BoundaryTau_N   ! 境界条件
  public  ag_BoundaryGrid_D, ag_BoundaryGrid_N ! 境界条件

  interface aq_Boundary_D
     !
     ! 外側境界ディリクレ型境界条件の適用(タウ法).
     !
     ! * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !   使い分けている. ユーザーインターフェースは共通であるので
     !   下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     ! * 1 次元スペクトルデータの並んだ 2 次元配列の場合
     !
     !   real(8), dimension(size(md),0:km),intent(inout)   :: aq_data
     !   !(inout) 境界条件を適用するスペクトルデータ
     !
     !   real(8), dimension(size(md)), intent(in), optional :: value
     !   !(in) 適用する境界値
     !
     ! * 1 次元チェビシェフデータの場合
     !
     !   real(8), dimension(0:km),intent(inout)       :: q_data
     !   !(inout) 境界条件を適用するスペクトルデータ
     !
     !   real(8), intent(in), optional                :: value
     !   !(in) 適用する境界値
     !
     module procedure aq_BoundaryTau_D_1d, aq_BoundaryTau_D_2d
  end interface

  interface aq_Boundary_N
     !
     ! 外側境界ノイマン型境界条件の適用(タウ法).
     !
     ! * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !   使い分けている. ユーザーインターフェースは共通であるので
     !   下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     ! * 1 次元スペクトルデータの並んだ 2 次元配列の場合
     !
     !   real(8), dimension(size(md),0:km),intent(inout)    :: aq_data
     !   !(inout) 境界条件を適用するスペクトルデータ
     !
     !   real(8), dimension(size(md)), intent(in), optional :: value
     !   !(in) 適用する境界値
     !
     ! * 1 次元チェビシェフデータの場合
     !
     !   real(8), dimension(0:km),intent(inout)       :: q_data
     !   !(inout) 境界条件を適用するスペクトルデータ
     !
     !   real(8), intent(in), optional                :: value
     !   !(in) 適用する境界値
     !
     module procedure aq_BoundaryTau_N_1d, aq_BoundaryTau_N_2d
  end interface

  interface aq_BoundaryTau_D
     !
     ! 外側境界ディリクレ型境界条件の適用(タウ法).
     !
     ! * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !   使い分けている. ユーザーインターフェースは共通であるので
     !   下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     ! * 1 次元スペクトルデータの並んだ 2 次元配列の場合
     !
     !   real(8), dimension(size(md),0:km),intent(inout)    :: aq_data
     !   !(inout) 境界条件を適用するチェビシェフデータ
     !
     !   real(8), dimension(size(md)), intent(in), optional :: value
     !   !(in) 適用する境界値
     !
     ! * 1 次元スペクトルデータの場合
     !
     !   real(8), dimension(0:km),intent(inout)       :: q_data
     !   !(inout) 境界条件を適用するチェビシェフデータ
     !
     !   real(8), intent(in), optional                :: value
     !   !(in) 適用する境界値
     !
     module procedure aq_BoundaryTau_D_1d, aq_BoundaryTau_D_2d
  end interface

  interface aq_BoundaryTau_N
     !
     ! 外側境界ノイマン型境界条件の適用(タウ法).
     !
     ! * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !   使い分けている. ユーザーインターフェースは共通であるので
     !   下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     ! * 1 次元スペクトルデータの並んだ 2 次元配列の場合
     !
     !   real(8), dimension(size(md),0:km),intent(inout)    :: aq_data
     !   !(inout) 境界条件を適用するチェビシェフデータ
     !
     !   real(8), dimension(size(md)), intent(in), optional :: value
     !   !(in) 適用する境界値
     !
     ! * 1 次元スペクトルデータの場合
     !
     !   real(8), dimension(0:km),intent(inout)       :: q_data
     !   !(inout) 境界条件を適用するチェビシェフデータ
     !
     !   real(8), intent(in), optional                :: value
     !   !(in) 適用する境界値
     !
     module procedure aq_BoundaryTau_N_1d, aq_BoundaryTau_N_2d
  end interface

  interface ag_BoundaryGrid_D
     !
     ! 外側境界ディリクレ型境界条件の適用(選点法).
     !
     ! * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !   使い分けている. ユーザーインターフェースは共通であるので
     !   下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     ! * 1 次元スペクトルデータの並んだ 2 次元配列の場合
     !
     !   real(8), dimension(size(md),0:km),intent(inout)    :: aq_data
     !   !(inout) 境界条件を適用するチェビシェフデータ
     !
     !   real(8), dimension(size(md)), intent(in), optional :: value
     !   !(in) 適用する境界値
     !
     ! * 1 次元スペクトルデータの場合
     !
     !   real(8), dimension(0:km),intent(inout)       :: q_data
     !   !(inout) 境界条件を適用するチェビシェフデータ
     !
     !   real(8), intent(in), optional                :: value
     !   !(in) 適用する境界値
     !
     module procedure ag_BoundaryGrid_D_1d, ag_BoundaryGrid_D_2d
  end interface

  interface ag_BoundaryGrid_N
     !
     ! 外側境界ノイマン型境界条件の適用(選点法).
     !
     ! * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !   使い分けている. ユーザーインターフェースは共通であるので
     !   下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     ! * 1 次元スペクトルデータの並んだ 2 次元配列の場合
     !
     !   real(8), dimension(size(md),0:km),intent(inout)    :: aq_data
     !   !(inout) 境界条件を適用するチェビシェフデータ
     !
     !   real(8), dimension(size(md)), intent(in), optional :: value
     !   !(in) 適用する境界値
     !
     ! * 1 次元スペクトルデータの場合
     !
     !   real(8), dimension(0:km),intent(inout)       :: q_data
     !   !(inout) 境界条件を適用するチェビシェフデータ
     !
     !   real(8), intent(in), optional                :: value
     !   !(in) 適用する境界値
     !
     module procedure ag_BoundaryGrid_N_1d, ag_BoundaryGrid_N_2d
  end interface

  integer :: im, km                       ! 格子点数, 切断波数
  real(8) :: ra                           ! 領域の大きさ

  real(8) :: alpha                        ! 展開多項式パラメター  0 < α <= 1
  real(8) :: beta                         ! 展開多項式パラメター  0 < β
  real(8) :: gamma                        ! 展開多項式パラメター  γ=2α+β
  integer, allocatable :: md(:)           ! 展開多項式上付次数のならび

  integer :: jmax                         ! a 座標(データ第 1 次元)の大きさ

  real(8), allocatable :: g_R(:)          ! ガウス--ラダウ格子点
  real(8), allocatable :: g_R_Weight(:)   ! ガウス重み

  real(8), allocatable :: CF(:,:,:)       ! 正変換用行列
  real(8), allocatable :: CB(:,:,:)       ! 逆変換用行列


  logical :: first_r2inv  =.true.
  logical :: first_Tau_D  =.true.
  logical :: first_Tau_N  =.true.
  logical :: first_Grid_N =.true.

  save im, km, ra, alpha, beta, gamma, CF, CB, g_R, g_R_Weight, md, jmax
  save first_r2inv, first_Tau_D, first_Tau_N, first_Grid_N

contains

! --- 初期化
  subroutine aq_Initial(i_in,k_in,r_in,alpha_in,beta_in,md_in)
    !
    ! スペクトル変換の格子点数, 波数, 領域の大きさ, 重みを設定する.
    !
    ! 他の関数や変数を呼ぶ前に, 最初にこのサブルーチンを呼んで
    ! 初期設定をしなければならない.
    !
    integer,intent(in) :: i_in              !(in) 格子点数
    integer,intent(in) :: k_in              !(in) 切断波数
    real(8),intent(in) :: r_in              !(in) 外側境界の座標(半径)
    real(8),intent(in) :: alpha_in          !(in) 展開多項式パラメター
    real(8),intent(in) :: beta_in           !(in) 展開多項式パラメター
    integer,intent(in) :: md_in(:)          !(in) 展開多項式上付次数のならび

    integer i, j, n

   !--- パラメターのチェック・記憶
    im=i_in ; km=k_in ; ra = r_in; alpha=alpha_in; beta=beta_in

    if ( km .ge. 2*im ) then
       call MessageNotify('E','aq_initial','KM shoud be less than 2*IM')
    endif

    if ( alpha .le. 0.0D0 ) then
       call MessageNotify('E','aq_initial','alpha must be larger than 0')
    endif
    if ( alpha .gt. 1.0D0 ) then
       call MessageNotify('E','aq_initial','alpha must be smaller equal to 1')
    endif
    if ( beta .le. 0.0D0 ) then
       call MessageNotify('E','aq_initial','beta must be larger than 0')
    endif

    gamma = 2.0D0 * alpha + beta

   !--- 次数情報の計算
    jmax = size(md_in)
    if ( allocated(md) ) deallocate(md)
    allocate(md(jmax))

    md = md_in

   !--- 格子点, 重みの設定
    if ( allocated(g_R) ) deallocate(g_R)
    if ( allocated(g_R_Weight) ) deallocate(g_R_Weight)
    allocate(g_R(im),g_R_Weight(im))

    call gauss_radau(2*im, g_R, g_R_Weight)
    g_R = ra * g_R
    g_R_Weight = ra**(gamma-1) * g_R_Weight

   !--- 変換行列の設定
    if ( allocated(CF) ) deallocate(CF)
    if ( allocated(CB) ) deallocate(CB)
    allocate(CF(jmax,0:km,im),CB(jmax,im,0:km))

    CF = 0.0D0
    do j=1,jmax
       do n=md(j),km,2
          do i=1,im
             CF(j,n,i) = Phi(g_R(i)/ra,n,md(j)) * g_R_Weight(i)/ra**(gamma-1)
          enddo
       enddo
    enddo

    CB = 0.0D0
    do j=1,jmax
       do i=1,im
          do n=md(j),km,2
             CB(j,i,n) = Phi(g_R(i)/ra,n,md(j))
          enddo
       enddo
    enddo

   !--- 各ルーチン変換行列の初期化スイッチ

    first_r2inv  = .true.
    first_Tau_D  = .true.
    first_Tau_N  = .true.
    first_Grid_N = .true.

    call MessageNotify(&
      'M','aq_initial','aq_module (2009/07/31) is initialized')

  end subroutine aq_Initial

! ---- 逆変換 ----
  function ag_aq(aq_data)
    !
    ! スペクトルデータから格子データへ変換する(2 次元配列用).
    !
    real(8), dimension(:,0:), intent(in)    :: aq_data
    !(in) スペクトルデータ

    real(8), dimension(size(aq_data,1),im)  :: ag_aq
    !(out) 格子点データ

    integer :: i, j

    if ( size(aq_data,1) /= jmax ) then
       call MessageNotify('E','ag_aq', &
            '1st dim. of the spectral data should be same as dim. of MD.')
    end if

    if ( size(aq_data,2)-1 < km ) then
       call MessageNotify('E','ag_aq', &
            'The spectral dimension of input data too small.')
    elseif ( size(aq_data,2)-1 > km ) then
       call MessageNotify('W','ag_aq', &
            'The spectral dimension of input data too large.')
    endif

    ag_aq = 0.0D0
    do i=1,im
!$omp parallel do
       do j=1,jmax
             ag_aq(j,i) = sum(CB(j,i,md(j):km:2)*aq_data(j,md(j):km:2))
       enddo
!$omp end parallel do
    enddo

  end function ag_aq

  function g_q(q_data)
    !
    ! スペクトルデータから格子データへ変換する(1 次元配列用).
    !
    real(8), dimension(:), intent(in)  :: q_data
    !(in) スペクトルデータ

    real(8), dimension(im)             :: g_q
    !(out) 格子点データ

    real(8), dimension(1,size(q_data)) :: q_work
    ! 作業用配列
    real(8), dimension(1,im)         :: g_work
    ! 作業用配列

    q_work(1,:) = q_data
    g_work = ag_aq(q_work)
    g_q = g_work(1,:)

  end function g_q

! ---- 正変換 ----
  function aq_ag(ag_data)
    !
    ! 格子データからスペクトルデータへ変換する(2 次元配列用).
    !
    real(8), dimension(:,:), intent(in)      :: ag_data
    !(in) 格子点データ

    real(8), dimension(size(ag_data,1),0:km) :: aq_ag
    !(out) スペクトルデータ

    integer :: j, n

    if ( size(ag_data,1) /= jmax ) then
       call MessageNotify('E','aq_ag', &
            '1st dim. of the grid data should be same as dim. of MD.')
    end if

    if ( size(ag_data,2) < im ) then
       call MessageNotify('E','aq_ag', &
            'The Grid points of input data too small.')
    elseif ( size(ag_data,2) > im ) then
       call MessageNotify('W','aq_ag', &
            'The Grid points of input data too large.')
    endif

    aq_ag = 0.0D0
!$omp parallel do private(n)
    do j=1,jmax
       do n=md(j),km,2
          aq_ag(j,n) = sum(CF(j,n,:)*ag_data(j,:))
       enddo
    enddo
!$omp end parallel do

  end function aq_ag

  function q_g(g_data)
    !
    ! 格子データからスペクトルデータへ変換する(1 次元配列用).
    !
    real(8), dimension(:), intent(in)     :: g_data
    !(in) 格子点データ

    real(8), dimension(0:km)              :: q_g
    !(out) スペクトルデータ

    real(8), dimension(1,size(g_data)) :: ag_work
    real(8), dimension(1,0:km)         :: aq_work

    ag_work(1,:) = g_data
    aq_work = aq_ag(ag_work)
    q_g = aq_work(1,:)

  end function q_g

! ---- 微分計算 ----
  function aq_rDr_aq(aq_data)
    !
    ! 入力スペクトルデータに対して微分 r(d/dr) のスペクトル係数
    ! を計算する(2 次元配列用).
    !
    !   a_n = aq_data/sqrt(Inm),  b_n = aq_rDr_aq/sqrt(Inm)
    !
    !   b_n = (2n+gamma-1)/(2n+gamma+3)b_n+2
    !       + (2n+gamma-1)(n+gamma+1)/(2n+gamma+3)a_n+2 + n a_n
    !
    real(8), dimension(:,0:), intent(in)     :: aq_data
    !(in) 入力スペクトルデータ

    real(8), dimension(size(aq_data,1),0:size(aq_data,2)-1) :: aq_rDr_aq
    !(out) 出力スペクトルデータ

    integer :: j, n
    integer :: nstr, nend
    real(8) :: sqInm, sqInm2

    if ( size(aq_data,1) /= jmax ) then
       call MessageNotify('E','aq_rDr_aq', &
            '1st dim. of the spectral data should be same as dim. of MD.')
    end if

    if ( size(aq_data,2)-1 < km ) then
       call MessageNotify('E','aq_rDr_aq', &
            'The spectral dimension of input data too small.')
    elseif ( size(aq_data,2)-1 > km ) then
       call MessageNotify('W','aq_rDr_aq', &
            'The spectral dimension of input data too large.')
    endif

    aq_rDr_aq = 0.0D0
!$omp parallel do private(nstr,nend,sqInm,sqInm2,n)
    do j=1,jmax
       if ( mod(md(j),2) .eq. mod(km,2) ) then
          nstr=md(j) ; nend=km
       else
          nstr=md(j) ; nend=km-1
       endif

       sqInm = sqrt(Inm(nend,md(j)))
       aq_rDr_aq(j,nend) = nend * aq_data(j,nend)

       do n=nend-2,nstr,-2
          sqInm2 = sqInm
          sqInm = sqrt(Inm(n,md(j)))

          aq_rDr_aq(j,n) = sqInm/sqInm2 * (&
                 (2*n+gamma-1)/(2*n+gamma+3) * aq_rDr_aq(j,n+2) &
               + (2*n+gamma-1)*(n+gamma+1)/(2*n+gamma+3) * aq_data(j,n+2) )&
               + n * aq_data(j,n)
       enddo
    enddo
!$omp end parallel do

  end function aq_rDr_aq

  function q_rDr_q(q_data)
    !
    ! 入力スペクトルデータに r(d/dR) 微分を作用する(1 次元配列用).
    !
    ! スペクトルデータの r(d/dR) 微分とは, 対応する格子点データに R 微分を
    ! 作用させたデータのスペクトル変換のことである.
    !
    !
    real(8), dimension(:), intent(in)   :: q_data
    !(in) 入力チェビシェフデータ

    real(8), dimension(0:km)            :: q_rDr_q
    !(out) チェビシェフデータの R 微分

    real(8), dimension(1,size(q_data))  :: aq_work
    ! 作業用配列

    aq_work(1,:) = q_data
    aq_work = aq_rDr_aq(aq_work)
    q_rDr_q = aq_work(1,:)

  end function q_rDr_q

! ---- r^2 積計算 ----
  function aq_r2_aq(aq_data)
    !
    ! 入力スペクトルデータに対して積 r^2 のスペクトル係数
    ! を計算する(2 次元配列用).
    !
    !   a_n^m = aq_data/sqrt(Inm),  b_n^m = aq_rDr_aq/sqrt(Inm)
    !
    !   b_n^m = (n-|m|)(n+|m|+beta-1)/((2n+gamma-5)(2n+gamma-3)) a_n-2^m
    !       + (2n(n+gamma-1) + 2|m|(|m|+beta-1)+(gamma-3)(beta+1)
    !            /((2n+gamma+1)(2n+gamma-3)) a_n^m
    !       + (n-|m|+gamma-beta)(n+|m|+gamma-1)
    !            /((2n+gamma+3)(2n+gamma+1)) a_n+2^m
    !
    real(8), dimension(:,0:), intent(in)     :: aq_data
    !(in) 入力スペクトルデータ

    real(8), dimension(size(aq_data,1),0:size(aq_data,2)-1) :: aq_r2_aq
    !(out) 出力スペクトルデータ

    integer :: j, n, m
    integer :: nstr, nend
    real(8) :: sqrInp2m, sqrInm, sqrInm2m

    if ( size(aq_data,1) /= jmax ) then
       call MessageNotify('E','aq_r2_aq', &
            '1st dim. of the spectral data should be same as dim. of MD.')
    end if

    if ( size(aq_data,2)-1 < km ) then
       call MessageNotify('E','aq_r2_aq', &
            'The spectral dimension of input data too small.')
    elseif ( size(aq_data,2)-1 > km ) then
       call MessageNotify('W','aq_r2_aq', &
            'The spectral dimension of input data too large.')
    endif

    aq_r2_aq = 0.0D0

!$omp parallel do private(nstr,nend,sqrInm,sqrInm2m,sqrInp2m,n,m)
    do j=1,jmax
       if ( mod(md(j),2) .eq. mod(km,2) ) then
          nstr=md(j) ; nend=km
       else
          nstr=md(j) ; nend=km-1
       endif

       m = abs(md(j))

       n = nstr
       sqrInm   = sqrt(Inm(n,m))
       sqrInp2m = sqrt(Inm(n+2,m))
       aq_r2_aq(j,n) =                                            &
            (2*n*(n+gamma-1) + 2*m*(m+beta-1)+(gamma-3)*(beta+1)) &
               /((2*n+gamma+1)*(2*n+gamma-3)) * aq_data(j,n)      &
          + (n-m+gamma-beta)*(n+m+gamma-1)                        &
               /((2*n+gamma+3)*(2*n+gamma+1))                     &
                * aq_data(j,n+2) * (sqrInm/sqrInp2m)

       do n=nstr+2,nend-2,2
          sqrInm2m = sqrInm
          sqrInm   = sqrInp2m
          sqrInp2m = sqrt(Inm(n+2,m))

          aq_r2_aq(j,n) = &
             (n-m)*(n+m+beta-1)/((2*n+gamma-5)*(2*n+gamma-3))      &
             * aq_data(j,n-2)* (sqrInm/sqrInm2m)                   &
           + (2*n*(n+gamma-1) + 2*m*(m+beta-1)+(gamma-3)*(beta+1)) &
                /((2*n+gamma+1)*(2*n+gamma-3)) * aq_data(j,n)      &
           + (n-m+gamma-beta)*(n+m+gamma-1)                        &
                /((2*n+gamma+3)*(2*n+gamma+1))                     &
                * aq_data(j,n+2) * (sqrInm/sqrInp2m)
       enddo

       n = nend
       sqrInm2m = sqrInm
       sqrInm   = sqrInp2m
       aq_r2_aq(j,n) = &
            (n-m)*(n+m+beta-1)/((2*n+gamma-5)*(2*n+gamma-3))       &
             * aq_data(j,n-2)* (sqrInm/sqrInm2m)                   &
           + (2*n*(n+gamma-1) + 2*m*(m+beta-1)+(gamma-3)*(beta+1)) &
                /((2*n+gamma+1)*(2*n+gamma-3)) * aq_data(j,n)
    enddo
!$omp end parallel do

    aq_r2_aq = aq_r2_aq * ra**2

  end function aq_r2_aq

  function q_r2_q(q_data)
    !
    ! 入力スペクトルデータに対して積 r^2 のスペクトル係数
    ! を計算する(1 次元配列用).
    !
    real(8), dimension(:), intent(in)   :: q_data
    !(in) 入力チェビシェフデータ

    real(8), dimension(0:km)            :: q_r2_q
    !(out) チェビシェフデータの R 微分

    real(8), dimension(1,size(q_data))  :: aq_work
    ! 作業用配列

    aq_work(1,:) = q_data
    aq_work = aq_r2_aq(aq_work)
    q_r2_q = aq_work(1,:)

  end function q_r2_q

! ---- r^-2 積計算 ----
  function aq_r2Inv_aq(aq_data)
    !
    ! 入力スペクトルデータに対して積 r^-2 のスペクトル係数
    ! を計算する(2 次元配列用).
    !
    !   a_n^m = aq_r2Inv_aq/sqrt(Inm),  b_n^m = aq_data/sqrt(Inm)
    !
    !   b_n^m = (n-|m|)(n+|m|+beta-1)/((2n+gamma-5)(2n+gamma-3)) a_n-2^m
    !       + (2n(n+gamma-1) + 2|m|(|m|+beta-1)+(gamma-3)(beta+1)
    !            /((2n+gamma+1)(2n+gamma-3)) a_n^m
    !       + (n-|m|+gamma-beta)(n+|m|+gamma-1)
    !            /((2n+gamma+3)(2n+gamma+1)) a_n+2^m
    !
    real(8), dimension(:,0:), intent(in)     :: aq_data
    !(in) 入力スペクトルデータ

    real(8), dimension(size(aq_data,1),0:size(aq_data,2)-1) :: aq_r2Inv_aq
    !(out) 出力スペクトルデータ

    real(8), dimension(:,:,:), allocatable    :: R2MTX
    integer, dimension(:,:), allocatable      :: kp

    integer :: j, n, m
    integer :: nstr, nend
    real(8) :: sqrInp2m, sqrInm, sqrInm2m

    save R2MTX, kp

    if ( size(aq_data,1) /= jmax ) then
       call MessageNotify('E','aq_r2Inv_aq', &
            '1st dim. of the spectral data should be same as dim. of MD.')
    end if

    if ( size(aq_data,2)-1 < km ) then
       call MessageNotify('E','aq_r2Inv_aq', &
            'The spectral dimension of input data too small.')
    elseif ( size(aq_data,2)-1 > km ) then
       call MessageNotify('W','aq_r2Inv_aq', &
            'The spectral dimension of input data too large.')
    endif

    if ( first_r2inv ) then
       first_r2inv = .false.
       if ( allocated(R2MTX) ) deallocate(R2MTX)
       if ( allocated(kp) ) deallocate(kp)
       allocate(R2MTX(jmax,0:km,0:km),kp(jmax,0:km))

       R2MTX(:,:,:) = 0.0D0
       do n=0,km
          R2MTX(:,n,n) = 1.0D0
       enddo

!$omp parallel do private(nstr,nend,sqrInm,sqrInm2m,sqrInp2m,n,m)
       do j=1,jmax
          if ( mod(md(j),2) .eq. mod(km,2) ) then
             nstr=md(j) ; nend=km
          else
             nstr=md(j) ; nend=km-1
          endif

          m = abs(md(j))

          n = nstr

          sqrInm   = sqrt(Inm(n,m))
          sqrInp2m = sqrt(Inm(n+2,m))

          R2MTX(j,n,n)   = &
               (2*n*(n+gamma-1) + 2*m*(m+beta-1)+(gamma-3)*(beta+1)) &
               /((2*n+gamma+1)*(2*n+gamma-3))

          R2MTX(j,n,n+2) = &
               (n-m+gamma-beta)*(n+m+gamma-1)                        &
               /((2*n+gamma+3)*(2*n+gamma+1))                        &
               * (sqrInm/sqrInp2m)

          do n=nstr+2,nend-2,2
             sqrInm2m = sqrInm
             sqrInm   = sqrInp2m
             sqrInp2m = sqrt(Inm(n+2,m))

             R2MTX(j,n,n-2) = &
                (n-m)*(n+m+beta-1)/((2*n+gamma-5)*(2*n+gamma-3))      &
                *(sqrInm/sqrInm2m)

             R2MTX(j,n,n)   = &
                (2*n*(n+gamma-1) + 2*m*(m+beta-1)+(gamma-3)*(beta+1)) &
                   /((2*n+gamma+1)*(2*n+gamma-3))

             R2MTX(j,n,n+2) = &
                (n-m+gamma-beta)*(n+m+gamma-1)                        &
                   /((2*n+gamma+3)*(2*n+gamma+1))                     &
                   * (sqrInm/sqrInp2m)
          enddo

          n = nend
          sqrInm2m = sqrInm
          sqrInm   = sqrInp2m
             R2MTX(j,n,n-2) = &
                (n-m)*(n+m+beta-1)/((2*n+gamma-5)*(2*n+gamma-3))      &
                *(sqrInm/sqrInm2m)
             R2MTX(j,n,n)   = &
                (2*n*(n+gamma-1) + 2*m*(m+beta-1)+(gamma-3)*(beta+1)) &
                   /((2*n+gamma+1)*(2*n+gamma-3))
       enddo
!$omp end parallel do

       R2MTX = R2MTX * ra**2

       call LuDecomp(R2MTX,kp)

    end if

    aq_r2Inv_aq = LuSolve(R2MTX,kp,aq_data)

  end function aq_r2Inv_aq

  function q_r2Inv_q(q_data)
    !
    ! 入力スペクトルデータに対して積 r^2 のスペクトル係数
    ! を計算する(1 次元配列用).
    !
    real(8), dimension(:), intent(in)   :: q_data
    !(in) 入力チェビシェフデータ

    real(8), dimension(0:km)            :: q_r2Inv_q
    !(out) チェビシェフデータの R 微分

    real(8), dimension(1,size(q_data))  :: aq_work
    ! 作業用配列

    aq_work(1,:) = q_data
    aq_work = aq_r2Inv_aq(aq_work)
    q_r2Inv_q = aq_work(1,:)

  end function q_r2Inv_q

!--------------- 積分計算 -----------------
  function a_Int_ag(ag)
    !
    ! 1 次元格子点データが並んだ 2 次元配列の積分
    !
    !      \int_0^a f(R) W(R) dR, W(R) = R^beta/(a^2-R^2)^(1-alpha)
    !
    ! を計算する.
    !
    real(8), dimension(:,:), intent(in)      :: ag
    !(in)入力格子点データ

    real(8), dimension(size(ag,1))           :: a_Int_ag
    !(out) 積分したデータ
    integer :: i

    if ( size(ag,2) < im ) then
       call MessageNotify('E','a_Int_ag', &
            'The Grid points of input data too small.')
    elseif ( size(ag,2) > im ) then
       call MessageNotify('W','a_Int_ag', &
            'The Grid points of input data too large.')
    endif

    a_Int_ag = 0.0d0
    do i=1,im
       a_Int_ag(:) = a_Int_ag(:) + ag(:,i)*g_R_Weight(i)
    enddo
  end function a_Int_ag

  function Int_g(g)
    !
    ! 1 次元格子点データの積分
    !
    !      \int_0^a f(R) W(R) dR, W(R) = R^beta/(a^2-R^2)^(1-alpha)
    !
    ! を行う
    !
    real(8), dimension(im), intent(in)   :: g
    !(in) 格子点データ

    real(8)                              :: Int_g
    !(out) 積分値

    Int_g = sum(g*g_R_Weight)

  end function Int_g

  function a_Avr_ag(ag)
    !
    ! 1 次元格子点データが並んだ 2 次元配列の平均
    !
    !      \int_0^a f(R) W(R) dR/\int_0^a W(R) dR,
    !          W(R) = R^beta/(a^2-R^2)^(1-alpha)
    !
    ! を計算する.
    !
    real(8), dimension(:,0:), intent(in)   :: ag
    !(in)入力格子点データ

    real(8), dimension(size(ag,1))         :: a_Avr_ag
    !(out) 平均したデータ

    a_Avr_ag = a_Int_ag(ag)/sum(g_R_Weight)

  end function a_Avr_ag

  function Avr_g(g)
    !
    ! 1 次元格子点データの平均
    !
    !      \int_0^a f(R) W(R) dR/\int_0^a W(R) dR,
    !          W(R) = R^beta/(a^2-R^2)^(1-alpha)
    !
    ! を計算する.
    !
    real(8), dimension(im), intent(in)   :: g
    !(in) 格子点データ

    real(8)                              :: Avr_g
    !(out) 積分値

    Avr_g = Int_g(g)/sum(g_R_Weight)
  end function Avr_g

!---- Dirichlet 型境界条件(タウ法) ----

  subroutine aq_BoundaryTau_D_2d(aq_data,value)
    !
    ! Dirichlet 型境界条件の適用(タウ法, 2 次元配列用)
    ! * 外側境界(i=im)での値を与える.
    !
    real(8), dimension(:,0:),intent(inout)         :: aq_data
    !(inout) 境界条件を適用するチェビシェフデータ(jmax,0:km)

    real(8), dimension(:), intent(in), optional  :: value
    !(in) 境界値(jmax)

    real(8), dimension(:,:,:), allocatable  :: alu
    integer, dimension(:,:), allocatable    :: kp
    real(8), dimension(size(aq_data,1),0:km):: aq_work
    real(8), dimension(size(aq_data,1),im)  :: ag_work
    real(8), dimension(size(aq_data,1))     :: value0           ! 境界値

    integer :: k, j, kstr, kend
    save    :: alu, kp

    if ( size(aq_data,2)-1 < km ) then
       call MessageNotify('E','aq_BoundaryTau_D', &
            'The spectral dimension of input data too small.')
    elseif ( size(aq_data,2)-1 > km ) then
       call MessageNotify('W','aq_BoundaryTau_D', &
            'The spectral dimension of input data too large.')
    endif

    if (.not. present(value)) then
       value0=0.0D0
    else
       value0 = value
    endif

    if ( first_Tau_D ) then
       first_Tau_D = .false.

       allocate(alu(size(aq_data,1),0:km,0:km),kp(size(aq_data,1),0:km))

       alu=0.0D0
       do k=0,km
          alu(:,k,k) = 1.0D0
       enddo

       do j=1,jmax
          if ( mod(md(j),2) .eq. mod(km,2) ) then
             kstr = md(j) ; kend = km
          else
             kstr = md(j) ; kend = km-1
          endif

          do k=kstr,kend,2
             aq_work = 0.0D0
             aq_work(j,k) = 1.0D0
             ag_work = ag_aq(aq_work)
             alu(j,kend,k) = ag_work(j,im)
          enddo
       enddo

       call ludecomp(alu,kp)
    endif

    do j=1,jmax
       if ( mod(md(j),2) .eq. mod(km,2) ) then
          aq_data(j,km)   = value0(j)
       else
          aq_data(j,km-1)   = value0(j)
       endif
    enddo

    aq_data = lusolve(alu,kp,aq_data)

  end subroutine aq_BoundaryTau_D_2d

  subroutine aq_BoundaryTau_D_1d(q_data,value)
    !
    ! Dirichlet 型境界条件の適用(タウ法, 1 次元配列用)
    ! * 両境界での値を与える.
    !
    real(8), dimension(0:km),intent(inout)       :: q_data
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    real(8), intent(in), optional                :: value
    !(in) 境界値

    real(8), dimension(1,0:km)                   :: aq_work
    real(8), dimension(1)                        :: vwork  ! 境界値

    if (.not. present(value)) then
       vwork(1)=0.0D0
    else
       vwork(1) = value
    endif

    aq_work(1,:)=q_data
    call aq_BoundaryTau_D_2d(aq_work,vwork)
    q_data=aq_work(1,:)

  end subroutine aq_BoundaryTau_D_1d

!---- Neumann 型境界条件(タウ法) ----

  subroutine aq_BoundaryTau_N_2d(aq_data,value)
    !
    ! 外側境界 Neumann 型境界条件の適用(タウ法, 2 次元配列用)
    ! * i=im で勾配の値を与える.
    !
    real(8), dimension(:,0:),intent(inout)         :: aq_data
    !(inout) 境界条件を適用するチェビシェフデータ(m,0:km)

    real(8), dimension(:), intent(in), optional    :: value
    !(in) 境界値(m)

    real(8), dimension(:,:,:), allocatable    :: alu
    integer, dimension(:,:), allocatable      :: kp
    real(8), dimension(size(aq_data,1),0:km)  :: aq_work
    real(8), dimension(size(aq_data,1),im)    :: ag_work
    real(8), dimension(size(aq_data,1))       :: value0           ! 境界値

    integer :: j, k, kstr, kend

    save    :: alu, kp

    if ( size(aq_data,2)-1 < km ) then
       call MessageNotify('E','aq_BoundaryTau_N', &
            'The spectral dimension of input data too small.')
    elseif ( size(aq_data,2)-1 > km ) then
       call MessageNotify('W','aq_BoundaryTau_N', &
            'The spectral dimension of input data too large.')
    endif

    if (.not. present(value)) then
       value0=0.0D0
    else
       value0 = value
    endif

    if ( first_Tau_N ) then
       first_Tau_N = .false.
       allocate(alu(jmax,0:km,0:km),kp(jmax,0:km))

       alu=0.0D0
       do k=0,km
          alu(:,k,k) = 1.0D0
       enddo

       do j=1,jmax
          if ( mod(md(j),2) .eq. mod(km,2) ) then
             kstr=md(j) ; kend = km
          else
             kstr=md(j) ; kend = km-1
          endif

          do k=kstr,kend,2
             aq_work = 0.0D0
             aq_work(j,k) = 1.0D0
             ag_work = ag_aq(aq_rDr_aq(aq_work))/spread(g_R,1,jmax)
             alu(j,kend,k) = ag_work(j,im)
          enddo
       enddo

       call ludecomp(alu,kp)
    endif

    do j=1,jmax
       if ( mod(md(j),2) .eq. mod(km,2) ) then
          aq_data(j,km)   = value0(j)
       else
          aq_data(j,km-1)   = value0(j)
       endif
    enddo

    aq_data = lusolve(alu,kp,aq_data)

  end subroutine aq_BoundaryTau_N_2d

  subroutine aq_BoundaryTau_N_1d(q_data,value)
    !
    ! Dirichlet/Neumann 型境界条件の適用(タウ法, 1 次元配列用)
    ! * i=0 で勾配の値を与える.
    !
    real(8), dimension(0:km),intent(inout)       :: q_data
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    real(8), intent(in), optional                :: value
    !(in) 境界値

    real(8), dimension(1,0:km)                   :: aq_work
    real(8), dimension(1)                        :: vwork           ! 境界値

    if (.not. present(value)) then
       vwork(1)=0.0D0
    else
       vwork(1) = value
    endif

    aq_work(1,:)=q_data
    call aq_BoundaryTau_N_2d(aq_work,vwork)
    q_data=aq_work(1,:)

  end subroutine aq_BoundaryTau_N_1d

!---- Dirichlet 型境界条件(選点法) ----

  subroutine ag_BoundaryGrid_D_2d(ag_data,value)
    !
    ! Dirichlet 型境界条件の適用(選点法, 2 次元配列用)
    ! * 外側境界(i=im)での値を与える.
    !
    real(8), dimension(:,:),intent(inout)         :: ag_data
    !(inout) 境界条件を適用するチェビシェフデータ(jmax,im)

    real(8), dimension(:), intent(in), optional  :: value
    !(in) 境界値(jmax)

    real(8), dimension(size(ag_data,1))       :: value0

    if (.not. present(value)) then
       value0=0.0d0
    else
       value0 = value
    endif
    ag_data(:,im) = value0

  end subroutine ag_BoundaryGrid_D_2d

  subroutine ag_BoundaryGrid_D_1d(g_data,value)
    !
    ! Dirichlet 型境界条件の適用(タウ法, 1 次元配列用)
    ! * 両境界での値を与える.
    !
    real(8), dimension(im),intent(inout)       :: g_data
    !(inout) 境界条件を適用するチェビシェフデータ(im)

    real(8), intent(in), optional              :: value
    !(in) 境界値

    real(8), dimension(1,im)                   :: ag_work
    real(8), dimension(1)                      :: vwork

    if (.not. present(value)) then
       vwork(1)=0.0d0
    else
       vwork(1) = value
    endif

    ag_work(1,:)=g_data
    call ag_BoundaryGrid_D_2d(ag_work,vwork)
    g_data=ag_work(1,:)

  end subroutine ag_BoundaryGrid_D_1d

!---- Neumann 型境界条件(選点法) ----

  subroutine ag_BoundaryGrid_N_2d(ag_data,value)
    !
    ! 外側境界 Neumann 型境界条件の適用(選点法, 2 次元配列用)
    ! * i=im で勾配の値を与える.
    !
    real(8), dimension(:,:),intent(inout)         :: ag_data
    !(inout) 境界条件を適用するチェビシェフデータ(m,im)

    real(8), dimension(:), intent(in), optional    :: value
    !(in) 境界値(m)

    real(8), dimension(:,:,:), allocatable    :: alu
    integer, dimension(:,:), allocatable      :: kp
    real(8), dimension(size(ag_data,1),im)    :: ag_work
    real(8), dimension(size(ag_data,1))       :: value0           ! 境界値

    integer :: i
    save    :: alu, kp

    if ( size(ag_data,2) < im ) then
       call MessageNotify('E','aq_BoundaryGrid_N', &
            'The dimension of input data too small.')
    elseif ( size(ag_data,2) > im ) then
       call MessageNotify('W','aq_BoundaryGrid_N', &
            'The dimension of input data too large.')
    endif

    if (.not. present(value)) then
       value0=0.0D0
    else
       value0 = value
    endif

    if ( first_Grid_N ) then
       first_Grid_N = .false.
       allocate(alu(jmax,im,im),kp(jmax,im))

       alu=0.0D0
       do i=1,im
          alu(:,i,i) = 1.0D0
       enddo

       do i=1,im
          ag_work = 0.0D0
          ag_work(:,i) = 1.0D0
          ag_work = ag_aq(aq_rDr_aq(aq_ag(ag_work)))/spread(g_R,1,jmax)
          alu(:,im,i) = ag_work(:,im)
       enddo

       call ludecomp(alu,kp)
    endif

    ag_data(:,im) = value0

    ag_data = lusolve(alu,kp,ag_data)

  end subroutine ag_BoundaryGrid_N_2d

  subroutine ag_BoundaryGrid_N_1d(g_data,value)
    !
    ! Dirichlet/Neumann 型境界条件の適用(選点法, 1 次元配列用)
    ! * i=0 で勾配の値を与える.
    !
    real(8), dimension(im),intent(inout)       :: g_data
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    real(8), intent(in), optional                :: value
    !(in) 境界値

    real(8), dimension(1,im)                   :: ag_work
    real(8), dimension(1)                        :: vwork           ! 境界値

    if (.not. present(value)) then
       vwork(1)=0.0D0
    else
       vwork(1) = value
    endif

    ag_work(1,:)=g_data
    call ag_BoundaryGrid_N_2d(ag_work,vwork)
    g_data=ag_work(1,:)

  end subroutine ag_BoundaryGrid_N_1d

!---- 下部ルーチン
  subroutine gauss_radau(M,g_R,g_W)
    !
    ! M 次の多項式 π(r) の零点から
    ! ガウス-ラダウ格子点とガウス重みを計算する
    !
    integer, intent(in)  :: M
    ! (in) 多項式打切次数(0 < M, M even)
    real(8), intent(out) :: g_R(M/2)         ! ガウス-ラダウ格子点
    real(8), intent(out) :: g_W(M/2)         ! ガウス重み

    real(8) :: r1,r2,dr
    real(8) :: pi1, pi2
    integer(8) :: i
    integer :: ir
    character(len=4) :: CNUM
    real(8), parameter :: eps = 1.0D-15      ! 打切誤差
    integer, parameter :: nrfact = 100       ! 格子点走査間隔を定める数

    !--- 入力チェック
    if ( mod(M,2) .ne. 0 ) then
       call MessageNotify('E','gauss_radau','M must be even')
    endif

    !--- ガウス--ラダウ格子点
    dr = 1.0D0/(nrfact*M)

    i = 0
    do ir = 1, nrfact*M
       r1  = ir*dr     ;  r2  = (ir+1)*dr
       pi1 = pir(r1,M) ;  pi2 = pir(r2,M)

       if ( pi1*pi2 .le. 0.0D0 ) then
          i = i+1
          g_R(i) = bisec_pir( r1, r2, M , eps )

          if ( i .eq. M/2-1 ) then
             i = i+1
             g_R(M/2) = 1.0D0
             goto 10
          endif
       end if
    enddo

    write( CNUM,'(I4)') i
    call MessageNotify('E','gauss_radau',&
         'Only '//CNUM//' Gauss-Radau points are found')

    !--- ガウス重み
10  continue
    write( CNUM,'(I4)') i
    call MessageNotify('M','gauss_radau',CNUM//' Gauss-Radau points are set up.')

    do i=1,M/2-1
       g_W(i) = 2*(2*M+gamma-5)*g_R(i)**2     &
                /((M+gamma-beta-2)*(M+gamma-3)*Phi(g_R(i),M-2,0)**2)
    enddo

    g_W(M/2) = Inm(0,0) - sum(g_W(1:M/2-1))

  end subroutine gauss_radau

  function bisec_pir( r1, r2, n, eps )
    !
    !  2 分法で π(r,n) の零点を区間 [r1,r2] の間で誤差 eps で探す
    !
    real(8)             :: r1, r2
    integer, intent(in) :: n
    real(8), intent(in) :: eps
    real(8)             :: bisec_pir

    real(8) :: rm, pim
    real(8) :: pi1, pi2

    pi1 = pir(r1,n)
    if ( abs(pi1) .lt. eps ) then
       bisec_pir = r1
       return
    end if

    pi2 = pir(r2,n)
    if ( abs(pi2) .lt. eps ) then
       bisec_pir = r2
       return
    end if

10  rm = (r1+r2)/2
    pim = pir(rm,n)

    if ( abs(pim) .lt. eps ) then
       bisec_pir = rm
       return
    end if

    if ( abs(r1-r2) .lt. eps ) then
       bisec_pir = rm
       return
    end if

    if ( pim * pi1 .gt. 0.0D0 ) then
       r1 = rm
       pi1 = pim
    else
       r2 = rm
       pi2 = pim
    endif
    goto 10

  end function bisec_pir

  function pir(r,n)
    !
    ! ガウス-ラダウ格子点を定義するための関数
    !
    real(8), intent(in)  :: r                ! 動径座標 ( 0 < r < ra )
    integer, intent(in)  :: n                ! 多項式次数(0 <= n)
    real(8)              :: pir              ! 多項式の値

    pir = qnm(r,n,0)-(n+gamma-beta-2)*(n+gamma-3)*qnm(r,n-2,0)/(n*(n+beta-1))

  end function pir

  function Phi(r,n_ind,m_ind)
    !
    ! 正規化された多項式計算
    !
    real(8), intent(in)  :: r                ! 動径座標 ( 0 < r < ra )
    integer, intent(in)  :: n_ind            ! 多項式次数(0 <= |m| <= n)
    integer, intent(in)  :: m_ind            ! 多項式次数(0 <= |m| <= n)
    real(8)              :: Phi              ! 多項式の値

    Phi = qnm(r,n_ind,m_ind)/sqrt(Inm(n_ind,m_ind))
  end function Phi

  function qnm(r,n_ind,m_ind)
    !
    ! 漸化式による多項式計算
    !
    real(8), intent(in)  :: r                ! 動径座標 ( 0 < r < ra )
    integer, intent(in)  :: n_ind            ! 多項式次数(0 <= |m| <= n)
    integer, intent(in)  :: m_ind            ! 多項式次数(0 <= |m| <= n)
    real(8)              :: qnm              ! 多項式の値

    real(8) :: qnp2m, qnm2m
    integer :: m, n

    m = abs(m_ind)

    !--- 入力チェック
    if ( n_ind .lt. 0 ) then
       call MessageNotify('E','qnm','n must be larger equal to 0')
    endif

    if ( m .gt. n_ind ) then
       call MessageNotify('E','qnm','abs(m) must be smaller equal to n')
    endif

    if ( mod(n_ind+m_ind,2) .ne. 0 ) then
       call MessageNotify('E','qnm','n+m must be even')
    endif

    !--- 初期値
    if ( m .eq. n_ind ) then
       qnm = r**m
       return
    endif

    if ( n_ind .eq. m+2 ) then
       qnm = (2*m+gamma-1)/2*((2*m+gamma+1)/(2*m+beta+1)*r**2 -1) * r**m
       return
    endif

    qnm2m = r**m
    qnm = (2*m+gamma-1)/2*((2*m+gamma+1)/(2*m+beta+1)*r**2 -1)* r**m

    !--- 漸化式

    do n = m+2, n_ind-2, 2
       qnp2m =( ( 2*n + gamma - 1 ) &
                * (  ( 2*n + gamma - 3 )*( 2*n + gamma + 1) * r**2       &
                    - 2*n * (n + gamma -1) - 2*m * (m + beta -1)       &
                    -(gamma-3) * (beta+1)                            )*qnm &
               -(n-m+gamma-beta-2)*(n+m+gamma-3)*(2*n+gamma+1)*qnm2m )&
              /(( n - m + 2 )*( n + m + beta + 1 )*( 2*n + gamma - 3 ))
       qnm2m = qnm
       qnm = qnp2m
    enddo

    return
  end function qnm

  function Inm(n_ind,m_ind)
    !
    ! 多項式の規格化定数を漸化式により求める
    !
    integer, intent(in)  :: n_ind            ! 多項式次数(0 <= |m| <= n)
    integer, intent(in)  :: m_ind            ! 多項式次数(0 <= |m| <= n)
    real(8)              :: Inm              ! 規格化定数

    integer :: n,m
    real(8) :: Inm2m
    real(8) :: Inmln                         ! 規格化定数のlog
    real(8) :: gammaln
    external gammaln

    m=abs(m_ind)

    !--- 入力チェック
    if ( n_ind .lt. 0 ) then
       call MessageNotify('E','Inm','n must be larger equal to 0')
    endif

    if ( m .gt. n_ind ) then
       call MessageNotify('E','Inm','abs(m) must be smaller equal to n')
    endif

    if ( mod(n_ind+m_ind,2) .ne. 0 ) then
       call MessageNotify('E','Inm','n+m must be even')
    endif

    !--- 初期値
    Inmln = gammaln((gamma-beta)/2) + gammaln(m+(beta+1)/2) &
          - gammaln(m+(gamma+1)/2) - log(2.0D0)
    Inm = exp(Inmln)

    !--- 漸化式
    do n=m+2, n_ind, 2
       Inm2m = Inm
       Inm = (2*n+gamma-5)*(n-m+gamma-beta-2)*(n+m+gamma-3) &
               /((n-m)*(n+m+beta-1)*(2*n+gamma-1)) * Inm2m
    enddo

    return
  end function Inm

end module aq_module

!----------------------------------------------------------------------
!     Copyright (c) 2011 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_aq_galerkin_RR_test1d
!
!      チェビシェフ−ガラーキン法テストプログラム(2次元)
!      非圧縮流体の流線関数・流れポテンシャル用, 両端粘着条件
!      (両端で値と 1 階微分が 0)
!
!        f(:,i=0)=f(:,i=im)=f'(:,i=0)=f'(:,i=im)=0
!        [ f(:,x=xmax)=f(:,x=xmin)=f'(:,x=xmax)=0=f'(:,x=xmin)=0 ]
!
!      例 : f(x) = cosh(alpha)*cos(lambda*t) - cos(lambda)*cosh(alpha*t)
!              t=(xmax+xmin)/2 + (xmax-xmin)/2 * t
!              lambda * tan(lambda) = -alpha * tanh(alpha)
!
!履歴  2006/01/05  竹広真一  新規作成
!      2006/01/24  竹広真一  モジュール変更に伴う改訂
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!      2011/02/15  佐々木洋平 goto/continue の廃止
!
program at_aq_galerkin_RR_test2d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_aq_galerkin_RRFF
  use at_module

  implicit none

  integer, parameter :: jm=5                   ! 1 次元目格子点数
  integer, parameter :: im=32                  ! 格子点数
  integer, parameter :: km=32                  ! チェビシェフ切断波数
  real(8), parameter :: xmin=0.0d0, xmax=1.0d0 ! 計算領域

  real(8), parameter :: nu=2.0D0            ! 境界条件係数

  real(8) :: ag_data(jm,0:im)
  real(8) :: ag_data_orig(jm,0:im)
  real(8) :: g_Tau(0:im)

  real(8) :: lambda(jm)                          ! 解析解係数
  integer :: j
  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = - 8


  lambda = InvXtanX(-nu*tanh(nu),jm)

  call MessageNotify('M','at_ag_galerkin_DD_test2d', &
    & '2D both no-slip B.C.')

  call at_Initial(im,km,xmin,xmax)
  call at_aq_galerkin_RRFF_Initial(im,km,'RR')   ! --- 両端粘着条件 ---

  g_Tau = 2.0D0/(xmax-xmin)*(g_X-(xmax+xmin)/2.0D0)
  do j=1,jm
     ag_data(j,:) = cosh(nu)*cos(lambda(j)*g_Tau) &
                   - cos(lambda(j))*cosh(nu*g_Tau)
  end do
  ag_data_orig = ag_data
  ag_data= ag_aq(aq_ag(ag_data))

  call AssertEqual(&
    & message = 'Grid -> Galerkin -> Grid ',                    &
    & answer  = ag_data_orig,                                   &
    & check   = ag_data,                                        &
    & significant_digits = check_digits, ignore_digits = ignore &
    )

  call MessageNotify('M','at_ag_galerkin_DD_test2d', &
    & '2D both no-slip B.C. succeeded' )

contains
  !
  ! x*tan(x)=val の解を求める
  !
  function InvXtanX(val,n)
    real(8), intent(IN) :: val                ! x*tan(x)=val < 0
    integer, intent(IN) :: n                  ! 求める解の個数
    real(8)             :: InvXtanX(n)
    real(8), parameter  :: eps = 5.0D-15     ! 解の精度

    real(8) :: pi
    integer :: i
    real(8) :: xs, xl, xm
    real(8) :: ValS, ValL, ValM

    pi = atan(1.0D0)*4.0D0

    do i=1,n
       xs=-pi/2.0D0  + i*pi + eps
       xl=i*pi

       ValS = xs*tan(xs)-val ; ValL = xl*tan(xl)-val
       if ( ValS * ValL .GT. 0.0D0 ) &
         call MessageNotify('E','InvXtanX',&
         'Initial values of ValS and ValL are the same sign.')
       do
         xm = (xs + xl)/2.0d0
         ValM = xm*tan(xm) - val
         if ( ValS * ValM .GT. 0.0D0 ) then
           xs = xm ; ValS=xs*tan(xs)-val
         else
           xl = xm ; ValL=xl*tan(xl)-val
         endif
         if ( abs(xl-xs) .lt. eps ) then
           InvXtanX(i) = xm
           exit
         endif
       end do

     end do
   end function InvXtanX

end program at_aq_galerkin_RR_test2d

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_zonal_module_svpack テストプログラム :: スペクトル関数のテスト
!
!履歴  2017/03/06  竹広真一 
!
program wt_zonal_module_svpack_spectrum

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wt_zonal_module_svpack
  implicit none

  integer,parameter  :: im=1, jm=16, km=16   ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), dimension(0:im-1,1:jm,0:km) ::  xyz_Torvel
  real(8), dimension(nm+1,0:lm)        ::  wt_Torvel

  real(8), dimension(0:im-1,1:jm,0:km) ::  xyz_Polvel
  real(8), dimension(nm+1,0:lm)        ::  wt_Polvel

  real(8), dimension(0:im-1,1:jm,0:km) ::  xyz_Vlon
  real(8), dimension(0:im-1,1:jm,0:km) ::  xyz_Vlat
  real(8), dimension(0:im-1,1:jm,0:km) ::  xyz_Vrad

  real(8), dimension(0:nm,-nm:nm,0:km) ::  nmz_EkTor
  real(8), dimension(0:nm,-nm:nm,0:km) ::  nmz_EkPol
  real(8), dimension(0:nm,0:km)        ::  nz_EkTor
  real(8), dimension(0:nm,0:km)        ::  nz_EkPol

  real(8), dimension(0:km)             ::  z_Data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: PI
  integer :: n,m

  PI = 4.0D0*Atan(1.0D0)

  call wt_Initial(im,jm,km,nm,lm,ri,ro)

  call MessageNotify('M','wt_zonal_module_svpack_spectrum_test',&
                         'wt_zonal_module_svpack spectrum functions tests.') 

  ! 2Y_1^0 * r
  xyz_Torvel =( 2*sqrt(3.0D0)*sin(xyz_Lat) ) * xyz_Rad

  ! (3*Y_1^0 + 2Y_2^0 ) * r^2
  xyz_Polvel =( 3*sqrt(3.0D0)*sin(xyz_Lat) & 
                + 2*sqrt(5.0D0)*(3.0/2*sin(xyz_Lat)**2-1/2.0) )&
              * xyz_Rad**2

  wt_Torvel = wt_xyz(xyz_Torvel)
  wt_Polvel = wt_xyz(xyz_Polvel)

  !--------- Energy spectrum ---------
  nmz_EkTor=wt_VMiss
  nmz_EkPol=wt_VMiss

  do n=0,nm
     do m=-n,n
        nmz_EkTor(n,m,:) = 0.0D0
        nmz_EkPol(n,m,:) = 0.0D0
     enddo
  enddo

  nmz_EkTor(1,0,:) = 4.0D0 * z_Rad**2 * (4*pi)*z_Rad**2

  nmz_EkPol(1,0,:) = 9.0D0 * (9*z_Rad**4 + 2.0D0*z_Rad**4) * (4*pi)
  nmz_EkPol(2,0,:) = 12.0D0 *(9*z_Rad**4 + 6.0D0*z_Rad**4) * (4*pi)

  call AssertEqual(&
    message='nmz_ToroidalEnergySpectrum_wt',                      &
    answer = nmz_ToroidalEnergySpectrum_wt(wt_Torvel),            &
    check =  nmz_EkTor,                                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='nmz_PoloidalEnergySpectrum_wt',                      &
    answer = nmz_PoloidalEnergySpectrum_wt(wt_Polvel),            &
    check =  nmz_EkPol,                                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nz_EkTor = 0.0D0
  nz_EkTor(1,:) = 4.0D0 * z_Rad**2 * (4*pi)*z_Rad**2 

  nz_EkPol = 0.0D0
  nz_EkPol(1,:) = (9.0D0 )*(9*z_Rad**4+2*z_Rad**4)*(4*pi)
  nz_EkPol(2,:) = (12.0D0)*(9*z_Rad**4+2*3*z_Rad**4)*(4*pi)

  call AssertEqual(&
    message='nz_ToroidalEnergySpectrum_wt',                       &
    answer = nz_ToroidalEnergySpectrum_wt(wt_Torvel),             &
    check =  nz_EkTor,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='nz_PoloidalEnergySpectrum_wt',                       &
    answer = nz_PoloidalEnergySpectrum_wt(wt_Polvel),             &
    check =  nz_EkPol,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call wt_Potential2Vector(xyz_Vlon,xyz_Vlat,xyz_Vrad,wt_Torvel,wt_Polvel)

  nmz_EkTor = nmz_ToroidalEnergySpectrum_wt(wt_Torvel)
  nmz_EkPol = nmz_PoloidalEnergySpectrum_wt(wt_Polvel)

  z_Data = 0.0D0
  do n=0,nm
     do m=-n,n
        z_Data = z_Data + nmz_EkTor(n,m,:) + nmz_EkPol(n,m,:)
     enddo
  enddo

  call AssertEqual(&
    message='Total energy by nmz-spectrum',                        &
    answer = IntLonLatRad_xyz(xyz_VLon**2+xyz_VLat**2+xyz_VRad**2)/2.0D0, &
    check =  IntRad_z(z_Data/z_Rad**2),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nz_EkTor = nz_ToroidalEnergySpectrum_wt(wt_Torvel)
  nz_EkPol = nz_PoloidalEnergySpectrum_wt(wt_Polvel)

  call AssertEqual(&
    message='Total energy by nz-spectrum',                        &
    answer = IntLonLatRad_xyz(xyz_VLon**2+xyz_VLat**2+xyz_VRad**2)/2.0D0, &
    check =   IntRad_z(sum(nz_EkTor,1)/z_Rad**2) &
            + IntRad_z(sum(nz_EkPol,1)/z_Rad**2), &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wt_zonal_module_svpack_spectrum_test',&
                         'wt_zonal_module_svpack spectrum functions tests suceeded!') 

end program wt_zonal_module_svpack_spectrum

!----------------------------------------------------------------------
! Copyright (c) 2007-2009 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  aq_module テストプログラム
!
!履歴  2007/12/28  竹広真一  
!      2008/12/04  佐々木洋平 DGamma の廃止に伴い exp(gammaln) へ変更
!      2009/07/24  佐々木洋平 dc_test を使用するように修正
!      
!
program aq_test_weight

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use aq_module
  implicit none

  integer, parameter :: im=16, km=31           ! 格子点数, 切断波数
  real(8), parameter :: ra=2                   ! 領域の大きさ
  real(8), parameter :: alpha=0.5D0            ! 展開多項式パラメター  0 < α <= 1
  real(8), parameter :: beta= 1.0D0            ! 展開多項式パラメター  0 < β
  real(8), parameter :: gamma=2.0D0*alpha+beta ! 展開多項式パラメター 
  real(8) :: gammaln
  external gammaln

  real(8), dimension(im) :: g_z
  real(8) :: Intsol

  ! 判定誤差設定
  integer, parameter :: check_digits = 7
  integer, parameter :: ignore = -8

  call MessageNotify('M', 'aq_test_boundary_weight', &
       'aq_module weight test')

  call aq_Initial(im,km,ra,alpha,beta,(/0/))

  !  W(R) = R^beta/(a^2-R^2)^(1-alpha)
  !
  !  \int_0^a R^n W(R) dR 
  !       = a^{n+gamma-1} \int_0^1 r^(n+beta) (1-r^2)^(alpha-1) dr
  !       = (1/2) a^{n+gamma-1}Γ((n+beta+1)/2)Γ(alpha)/Γ(alpha+(n+beta+1)/2)
  !
  !  \int_0^1 r^n w(r) dr = \int_0^1 r^(n+beta) (1-r^2)^(alpha-1) dr
  !                   = (1/2)\int_0^1 t^{(n+beta-1)/2} (1-t)^(alpha-1) dt
  !                   = (1/2) B((n+beta+1)/2,alpha)
  !                   = (1/2) Γ((n+beta+1)/2)Γ(alpha)/Γ(alpha+(n+beta+1)/2)
  !

  g_z(:) = 1.0D0
  Intsol = ra**(gamma-1) * 0.5D0 * exp(gammaln(alpha)) &
              *exp(gammaln((beta+1)*0.5D0))/exp(gammaln(alpha+(Beta+1)*0.5D0))

  call AssertEqual(&
    message='aq_test_weight(1)',                                &
    answer = Intsol,                                            &
    check  = abs(sum(g_z * g_R_weight)),                        &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  g_z(:) = g_R**2
  Intsol = ra**(2+gamma-1)/2 &
       * exp(gammaln(alpha)) &
       * exp(gammaln((2+beta+1)/2))/exp(gammaln(alpha+(2+Beta+1)/2))

  call AssertEqual(&
    message='aq_test_weight(2)',                                &
    answer = Intsol,                                            &
    check  = abs(sum(g_z * g_R_weight)),                        &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call aq_Initial(im,km,ra,alpha,beta,(/1/))

  g_z(:) = g_R**3
  Intsol = ra**(3+gamma-1)/2 &
       * exp(gammaln(alpha)) &
       * exp(gammaln((3+beta+1)/2))/exp(gammaln(alpha+(3+Beta+1)/2))

  call AssertEqual(&
    message='aq_test_weight(3)',                                &
    answer = Intsol,                                            &
    check  = abs(sum(g_z * g_R_weight)),                        &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call MessageNotify('M', 'aq_test_boundary_weight', &
       'aq_module weight test succeeded')

end program aq_test_weight

!------------------------------------------------------------------------
! Copyright (c) 2016 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  ee_mpi_module テストプログラム (ヤコビアン計算)
!
!履歴  2016/08/08  竹広真一
!
program ee_mpi_module_jacobian_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32              ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8), allocatable :: vx_A(:,:)     ! 格子データ
  real(8), allocatable :: vx_B(:,:)     ! 格子データ
  real(8), allocatable :: vx_Jacob(:,:)  ! 格子データ

  integer, parameter :: k=4,l=2
  integer            :: np, ip, ierr

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','ee_mpi_module_jacobian_test', &
       'ee_mpi_module jacobian function tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

 !---------------- 座標値の設定 ---------------------
  call ee_mpi_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

  allocate(vx_A(jc(ip),0:im-1))      ! 格子データ
  allocate(vx_B(jc(ip),0:im-1))      ! 格子データ
  allocate(vx_Jacob(jc(ip),0:im-1))  ! 格子データ

  !------------------- 初期値設定 ----------------------
  vx_A = sin(k*pi*vx_X)
  vx_B = sin(l*pi*vx_Y)
  vx_Jacob = k*pi*cos(k*pi*vx_X) * l*pi*cos(l*pi*vx_Y)

  call check2d(vx_ef(ef_Jacobian_ef_ef(ef_vx(vx_A),ef_vx(vx_B))), vx_Jacob, &
    'Jacob(sin(k*pi*X),sin(l*pi*Y))')

  vx_A = cos(k*pi*vx_X)
  vx_B = cos(l*pi*vx_Y)
  vx_Jacob = k*pi*sin(k*pi*vx_X) * l*pi*sin(l*pi*vx_Y)

  call check2d(vx_ef(ef_Jacobian_ef_ef(ef_vx(vx_A),ef_vx(vx_B))), vx_Jacob, &
    'Jacob(cos(k*pi*X),cos(l*pi*Y))')

  vx_A = sin(k*pi*vx_X)
  vx_B = cos(l*pi*vx_Y)
  vx_Jacob = - k*pi*cos(k*pi*vx_X) * l*pi*sin(l*pi*vx_Y)

  call check2d(vx_ef(ef_Jacobian_ef_ef(ef_vx(vx_A),ef_vx(vx_B))), vx_Jacob, &
    'Jacob(sin(k*pi*X),cos(l*pi*Y))')

  vx_A = cos(k*pi*vx_X)
  vx_B = sin(l*pi*vx_Y)
  vx_Jacob = - k*pi*sin(k*pi*vx_X) * l*pi*cos(l*pi*vx_Y)

  call check2d(vx_ef(ef_Jacobian_ef_ef(ef_vx(vx_A),ef_vx(vx_B))), vx_Jacob, &
    'Jacob(cos(k*pi*X),sin(l*pi*Y))')


  call MPI_FINALIZE(IERR)
  
  call MessageNotify('M','ee_mpi_module_derivative_test', &
       'ee_mpi_module jacobian function tests succefded!')

contains

  subroutine check2d(var,sol,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:)                ! 判定する配列
    real(8) :: sol(:,:)
    character(len=*) :: funcname

    call AssertEqual(     &
      message = funcname, &
      answer = sol,       &
      check = var,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check2d

end program ee_mpi_module_jacobian_test

!------------------------------------------------------------------------
! Copyright (c) 2011-2013 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  dlgamma テストプログラム
!
!履歴  --
!      2011/02/18  佐々木洋平 dc_test を使用するように修正
!      2013/05/22  佐々木洋平 精度落ちを修正
!
program gamma_test
  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  implicit none
  real(8)  :: factrl
  real(8)  :: gammaln
  integer  :: i
  character(len=2) :: mess_int

  integer, parameter :: iend=10
  real(8), parameter :: pi = 3.141592653589793238d0
  !! 判定誤差設定
  integer, parameter :: check_digits = 12
  integer, parameter :: ignore = -13
  external factrl, gammaln

 call MessageNotify('M','gamma_test','test of gamma function')
 do i=0,iend
   write(mess_int, '(I2)') i
   call AssertEqual(                            &
     message = 'Gamma(  '//mess_int//')',       &
     answer  =  dble(ansi(i)),                  &
     check   =  factrl(i),                      &
     significant_digits = check_digits, ignore_digits = ignore   )
 end do

 do i=0,iend
   write(mess_int, '(I2)') i
   call AssertEqual(                      &
     message = 'Gamma('//mess_int//'.5)', &
     answer  =  ansr(i),                  &
     check   =  exp(gammaln(0.5D0+i)),    &
     significant_digits = check_digits, ignore_digits = ignore   )
 end do

 call MessageNotify('M','gamma_test','test of gamma function succeeded!')

contains
 recursive function ansi(i) result(res)
   integer(8) :: res
   integer, intent(in) :: i
   if ( i > 0 ) then
     res = i * ansi(i-1)
   else
     res = 1
   end if
 end function ansi

 recursive function ansr(i) result(res)
   real(8) :: res
   integer, intent(in) :: i
   if ( i > 0 ) then
     res = (i - 0.5d0) * ansr(i-1)
   else
     res = dsqrt(pi)
   end if
 end function ansr

end program gamma_test

!----------------------------------------------------------------------
! COPYRIGHT (c) 2007-2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  au_module テストプログラム
!      2 次元境界値問題
!
!履歴  2007/12/28  竹広真一
!      2010/12/21  佐々木洋平 dc_test を使用するように修正
!                  Tau 法のテストと統合
!
program au_test_boundary2d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use au_module
  implicit none

  integer, parameter :: im=8, km=8, nm=2
  real(8), parameter :: ra=2.0D0

  real(8), dimension(nm,0:im) :: ag_a
  real(8), dimension(nm,0:im) :: ag_dadx
  real(8), dimension(nm,0:km) :: au_a
  real(8), dimension(nm)      :: amin

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  amin(:) = (/0.0D0,1.0D0/)

  call MessageNotify('M','au_test_boundary2d',    &
    'au_module 2-dim boundary condition solver tests')

  call au_initial(im,km,ra,(/1,2/))

  ag_a(1,:) = sin(g_R)
  ag_a(2,:) = cos(g_R)
  ag_a(1,:) = g_R
  ag_a(2,:) = g_R**2
  au_a = au_ag(ag_a)

!----- au_BoundaryGrid_D ------
  call au_BoundaryGrid_D(au_a,amin)
  ag_a = ag_au(au_a)

  call AssertEqual(&
    message='Test of au_BoundaryGrid_D',                      &
    answer = amin(:),                                         &
    check = ag_a(:,0),                                        &
    significant_digits = check_digits, ignore_digits = ignore &
    )

!----- au_BoundaryTau_D ------
  call au_BoundaryTau_D(au_a,amin)
  ag_a = ag_au(au_a)

  call AssertEqual(&
    message='Test of au_BoundaryTau_D',                       &
    answer = amin(:),                                         &
    check = ag_a(:,0),                                        &
    significant_digits = check_digits, ignore_digits = ignore &
    )


!----- au_BoundaryGrid_N ------
  call au_BoundaryGrid_N(au_a,amin)
  ag_a = ag_au(au_a)
  ag_dadx = ag_Dr_au(au_ag(ag_a))

  call AssertEqual(&
    message='Test of au_BoundaryGrid_N',                      &
    answer = amin(:),                                         &
    check = ag_dadx(:,0),                                     &
    significant_digits = check_digits, ignore_digits = ignore &
    )

!----- au_BoundaryTau_N ------
  call au_BoundaryTau_N(au_a,amin)
  ag_a = ag_au(au_a)
  ag_dadx = ag_Dr_au(au_ag(ag_a))

  call AssertEqual(&
    message='Test of au_BoundaryTau_N',                       &
    answer = amin(:),                                         &
    check = ag_dadx(:,0),                                     &
    significant_digits = check_digits, ignore_digits = ignore &
    )

  call MessageNotify('M','au_test_boundary_grid2d', &
    'au_module 2-dim boundary condition solver tests succeeded!')

end program au_test_boundary2d

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  la_module テストプログラム :: 微分関数のテスト
!
!履歴  2009/09/22  竹広真一
!
program la_module_deriv_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use la_module
  implicit none

  integer, parameter :: jm=16, nm=10, km=2

  real(8), dimension(1:jm,km)     ::  ya_data               ! 元の関数
  real(8), dimension(1:jm,km)     ::  ya_ddata              ! 微分の正解
  real(8), dimension(1:jm)        ::  y_mu                  ! μ=sinφ

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','la_module_deriv_test', &
                         'la_module derivative function tests') 

  call la_Initial( nm, jm )

  !---- P_1 P_2 のテスト ----
  ya_data(:,1) = sqrt(3.0D0)*sin(y_Lat)                   ! P_1
  ya_data(:,2) = sqrt(5.0D0)*(3.0/2*sin(y_Lat)**2-1/2.0)  ! P_2

  ya_ddata(:,1) = -2*sqrt(3.0D0)*sin(y_Lat)                   ! wa_Lapla_wa
  ya_ddata(:,2) = -6*sqrt(5.0D0)*(3.0/2*sin(y_Lat)**2-1/2.0)  ! 

  call AssertEqual(&
    message='P_1, P_2 Test of la_Lapla_la',                       &
    answer = ya_ddata,                                            &
    check = ya_la(la_Lapla_la(la_ya(ya_data))),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ya_ddata(:,1) = -1.0D0/2.0*sqrt(3.0D0)*sin(y_Lat)      ! wa_LaplaInv_wa
  ya_ddata(:,2) = -1.0D0/6.0*sqrt(5.0D0)*(3.0/2*sin(y_Lat)**2-1/2.0)

  call AssertEqual(&
    message='P_1, P_2 Test of la_LaplaInv_la',                    &
    answer = ya_ddata,                                            &
    check = ya_la(la_LaplaInv_la(la_ya(ya_data))),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ya_ddata(:,1) = sqrt(3.0D0)*cos(y_Lat)         ! xya_GradLat_wa
  ya_ddata(:,2) = sqrt(5.0D0)*3.0*sin(y_Lat)*cos(y_Lat)

  call AssertEqual(&
    message='P_1, P_2 Test of ya_GradLat_la',                     &
    answer = ya_ddata,                                            &
    check = ya_GradLat_la(la_ya(ya_data)),                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- P_1 cosφ, P_2 cosφ のテスト ----
  ya_data(:,1) = sqrt(3.0D0)*sin(y_Lat)*cos(y_Lat)        ! P_1 cosφ
  ya_data(:,2) = sqrt(5.0D0)*(3.0/2*sin(y_Lat)**2-1/2.0)*cos(y_Lat) ! P_2 cosφ

  ya_ddata(:,1) = sqrt(3.0D0)*(cos(y_Lat)**2-2*sin(y_Lat)**2)  ! wa_DivLat_xy
  ya_ddata(:,2) = sqrt(5.0D0)*(3.0*(sin(y_Lat)*cos(y_Lat)**2-sin(y_Lat)**3) &
                               +sin(y_Lat))                    ! wa_DivLat_xy

  call AssertEqual(&
    message='P_1 cos(phi), P_2 cos(phi) Test of la_DivLat_ya',    &
    answer = ya_ddata,                                            &
    check = ya_la(la_DivLat_ya(ya_data)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !============== 微分計算 (λ,μ座標系用) のテスト ==============
  y_mu = sin(y_Lat)

  !----- P_2, P_1 のテスト -----
  ya_data(:,1) = 3*y_mu**2-1                              ! P_2
  ya_data(:,2) = 5*y_mu**3/2 -3*y_mu/2                    ! P_3

  ya_ddata(:,1) = 6*y_mu*(1-y_mu**2)
  ya_ddata(:,2) = (15*y_mu**2/2 -3/2.0D0)*(1-y_mu**2)

  call AssertEqual(&
    message='P_2,P_3 Test of ya_GradMu_la',                       &
    answer = ya_ddata,                                            &
    check = ya_GradMu_la(la_ya(ya_data)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !----- P_2 (1-μ^2), P_1 (1-μ^2) のテスト -----
  ya_data(:,1) = (3*y_mu**2-1)*(1-y_mu**2)           ! P_2 (1-μ^2)
  ya_data(:,2) = (5*y_mu**3/2 -3*y_mu/2)*(1-y_mu**2) ! P_3 (1-μ^2)

  ya_ddata(:,1) = (2-3*y_mu**2)*4*y_mu
  ya_ddata(:,2) = (15*y_mu**2/2 -3.0D0/2)*(1-y_mu**2) &
                - (5*y_mu**3/2 -3*y_mu/2)*2*y_mu

  call AssertEqual(&
    message='P_2 (1-mu^2), P_3 (1-mu^2) Test of la_DivMu_ya',     &
    answer = ya_ddata,                                            &
    check = ya_la(la_DivMu_ya(ya_data)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','la_module_deriv_test', &
                         'la_module derivative function tests succeeded!') 

end program la_module_deriv_test

!----------------------------------------------------------------------
!   COPYRIGHT (c) 2005-2006 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_ah_galerkin_MM2ex
!
!      チェビシェフ−ガラーキン法
!      ディリクレ・ノイマン混合境界条件(可変係数)用モジュール
!
!          cfdx1_xmax(j) f'(j,i=0)  + cfdx0_xmax f(j,i=0)  = 0,
!          cfdx1_xmin(j) f'(j,i=im) + cfdx0_xmin f(j,i=im) = 0,
!
!      k 次のガラーキン基底が
!
!        \phi_k(x)=T_k(x) + C_1 T_1(x) + C_0 T_0(x) 
!
!      の型式(Type2)
!
!履歴  2006/01/06  竹広真一  新規作成
!      2006/01/07  竹広真一  debug
!      2006/01/22  竹広真一  係数変換定式化変更
!      2006/01/23  竹広真一  モジュール名変更
!      2006/01/25  竹広真一  モジュール初期化フラッグ導入
!      2006/02/15  竹広真一  係数行列式 0 の場合に対応
!      2006/02/26  竹広真一  係数行列式が 0 の場合に完全対応
!
module at_ah_galerkin_MMex

  use lumatrix
  use at_module
  use dc_message

  implicit none

  private
  public :: at_ah_galerkin_MMex_Initial   ! 初期化サブルーチン
  public :: ah_at                      ! チェビシェフ->ガラーキン変換
  public :: ah_ag                      ! 格子点->ガラーキンデータ変換
  public :: at_ah                      ! ガラーキン->チェビシェフ変換
  public :: ag_ah                      ! ガラーキン->格子点データ変換
  public :: ah_Dx_ah                   ! X 微分

  real(8), allocatable :: TH(:,:,:)    ! ガラーキン->チェビシェフ変換行列
  real(8), allocatable :: HT(:,:,:)    ! チェビシェフ->ガラーキン変換行列
  integer, allocatable :: kp(:,:)      ! LU 分解用ピボット格納配列

  real(8), allocatable :: alpha(:)  ! チェビシェフ<->ガラーキン行列積係数
  real(8), allocatable :: beta(:)   ! チェビシェフ<->ガラーキン行列和係数

  integer :: im                        ! 格子点数              
  integer :: km                        ! チェビシェフ切断波数  
  integer :: jm                        ! 第 1 次元の大きさ
  integer,parameter :: ks=2            ! ガラーキン基底最低次数

  logical :: MMex_Initialized=.false.  ! 初期化フラッグ

  real(8), allocatable :: cfd0_xmin(:) ! 境界条件係数(0階微分 at x=xmin)
  real(8), allocatable :: cfd1_xmin(:) ! 境界条件係数(1階微分 at x=xmin)
  real(8), allocatable :: cfd0_xmax(:) ! 境界条件係数(0階微分 at x=xmax)
  real(8), allocatable :: cfd1_xmax(:) ! 境界条件係数(1階微分 at x=xmax)

  logical, allocatable :: MMex_Delta0(:) ! 係数行列式判定
  real(8), parameter   :: EPS = 1.0D-14  ! 行列式判定用微小値

  save im, km, jm, TH, HT, kp, alpha, beta, MMex_Initialized, MMex_Delta0
  save cfd0_xmin, cfd1_xmin, cfd0_xmax, cfd1_xmax
  public TH, HT, alpha, beta

contains

  !
  ! チェビシェフ−ガラーキン法 
  ! ディリクレ・ノイマン混合境界条件用モジュール
  ! 初期化サブルーチン
  !
  subroutine at_ah_galerkin_MMex_Initial(i_in,k_in,j_in,      &
                                      cfdx0_xmax,cfdx1_xmax,  &
                                      cfdx0_xmin,cfdx1_xmin    )

    integer, intent(IN) :: i_in      ! (in)格子点数
    integer, intent(IN) :: k_in      ! (in)チェビシェフ切断波数  
    integer, intent(IN) :: j_in      ! (in)第 1 次元の大きさ

    real(8), intent(IN),optional :: cfdx0_xmin(j_in) ! 境界条件係数(0階微分@x=xmin)
    real(8), intent(IN),optional :: cfdx1_xmin(j_in) ! 境界条件係数(1階微分@x=xmin)
    real(8), intent(IN),optional :: cfdx0_xmax(j_in) ! 境界条件係数(0階微分@x=xmax)
    real(8), intent(IN),optional :: cfdx1_xmax(j_in) ! 境界条件係数(1階微分@x=xmax)

    real(8) :: Dfac                  ! 微分変換係数
    real(8) :: Delta(j_in)           ! 係数行列の行列式

    integer :: j, k, l, m, n
    real(8) :: a, b, c, d, e, f
    character(len=10) :: cnumber

    !---------- 格子点数・切断波数設定 ----------
    im=i_in ; km=k_in ; jm = j_in

    !---------- 境界条件係数設定 ----------
    if ( allocated(cfd0_xmin) ) deallocate(cfd0_xmin)
    if ( allocated(cfd1_xmin) ) deallocate(cfd1_xmin)
    if ( allocated(cfd0_xmax) ) deallocate(cfd0_xmax)
    if ( allocated(cfd1_xmax) ) deallocate(cfd1_xmax)
    if ( allocated(MMex_Delta0) ) deallocate(MMex_Delta0)

    allocate(cfd0_xmin(jm),cfd1_xmin(jm))
    allocate(cfd0_xmax(jm),cfd1_xmax(jm))
    allocate(MMex_Delta0(jm))

    Dfac = (g_X(0)-g_X(im))/2.0D0

    if( present(cfdx0_xmin) ) then
       cfd0_xmin = cfdx0_xmin
    else
       call MessageNotify('M','at_ah_galerkin_MM_Initial(Type2)',&
                          'cfdx0_xmin set to zero internally.')
       cfd0_xmin = 0.0D0
    endif

    if( present(cfdx0_xmax) ) then
       cfd0_xmax = cfdx0_xmax
    else
       call MessageNotify('M','at_ah_galerkin_MM_Initial(Type2)',&
                          'cfdx0_xmax set to zero internally.')
       cfd0_xmax = 0.0D0
    endif

    if( present(cfdx1_xmin) ) then
       cfd1_xmin = cfdx1_xmin/Dfac
    else
       call MessageNotify('M','at_ah_galerkin_MM_Initial(Type2)',&
                          'cfdx1_xmin set to zero internally.')
       cfd1_xmin = 0.0D0
    endif

    if( present(cfdx1_xmax) ) then
       cfd1_xmax = cfdx1_xmax/Dfac
    else
       call MessageNotify('M','at_ah_galerkin_MM_Initial(Type2)',&
                          'cfdx1_xmax set to zero internally.')
       cfd1_xmax = 0.0D0
    endif

    !---------- 境界条件係数チェック ----------

    Delta = cfd1_xmin*cfd0_xmax-cfd1_xmax*cfd0_xmin -2 * cfd0_xmin*cfd0_xmax

    do j=1,jm
       if ( abs(Delta(j))                             &
            /max(abs(cfd1_xmin(j)),abs(cfd0_xmin(j)), &
                 abs(cfd1_xmax(j)),abs(cfd0_xmax(j))) &
         .LT. EPS ) then

          write(cnumber,'(I10)') j
          MMex_Delta0(j) = .true.
          call MessageNotify('W','at_ah_galerkin_MM_Initial(Type2)',&
               'Determinant of coefficent matrix equals zero.' )
          call MessageNotify('M','at_ah_galerkin_MM_Initial(Type2)',&
               'T2 and T1 are used for Galerkin base functions at the ' &
               //trim(adjustl(cnumber))//'-th element.' )
         else
            MMex_Delta0(j) = .false.
         endif
    enddo

    !---------- ディリクレ・ノイマン混合条件用変換行列設定 ----------
    if ( allocated(TH) ) deallocate(TH)
    if ( allocated(HT) ) deallocate(HT)
    if ( allocated(kp) ) deallocate(kp)
    if ( allocated(alpha) ) deallocate(alpha)
    if ( allocated(beta) ) deallocate(beta)
    allocate(TH(jm,0:km,ks:km),HT(jm,ks:km,ks:km),kp(jm,ks:km))
    allocate(alpha(0:km),beta(0:km))

    TH = 0.0D0
    do j=1,jm
       if ( MMex_Delta0(j) ) then
          a = 4 * cfd1_xmax(j) + cfd0_xmax(j)
          b = cfd1_xmax(j) + cfd0_xmax(j)
          c = -4 * cfd1_xmin(j) + cfd0_xmin(j)
          d = cfd1_xmin(j) - cfd0_xmin(j)
          Delta(j) = a*d - b*c

          TH(j,0,2) = cfd1_xmax(j) + cfd0_xmax(j)
          TH(j,1,2) = -cfd0_xmax(j)
          do k=ks+1,km
             e = cfd1_xmax(j) * k**2 + cfd0_xmax(j)
             f = cfd1_xmin(j) * (-1)**(k+1) * k**2 + cfd0_xmin(j)*(-1)**k
             TH(j,1,k) = -1.0D0/Delta(j)*(-c*e+a*f)
             TH(j,2,k) = -1.0D0/Delta(j)*(d*e-b*f)
             TH(j,k,k) = 1.0D0
          enddo
       else
          do k=ks,km
             TH(j,0,k) = 1.0D0/Delta(j)                                &
                  * (   (-cfd1_xmin(j)+cfd0_xmin(j))                   &
                           *(cfd1_xmax(j)*k**2+cfd0_xmax(j))           &
                      + (cfd1_xmax(j)+cfd0_xmax(j))                    &
                        *(    cfd1_xmin(j)*(-1)**(k+1)*k**2            &
                            + (-1)**k*cfd0_xmin(j)         )           &
                     )
             TH(j,1,k) = 1.0D0/Delta(j)                                &
                   * (   cfd0_xmin(j)                                  &
                           *(cfd1_xmax(j)*k**2+cfd0_xmax(j))           &
                       - cfd0_xmax(j)                                  &
                           *(   cfd1_xmin(j)*(-1)**(k+1)*k**2          &
                              + (-1)**k*cfd0_xmin(j)         )         &
                     )
             TH(j,k,k) = 1.0D0
          enddo
       endif
    end do

    beta=1.0 ; beta(0)=0.5D0
    if (im .eq. km ) beta(km)=0.5D0

    ! ディリクレ・ノイマン混合条件用変換逆行列
    alpha=1.0 ; alpha(0)=2.0D0

    HT = 0.0D0
    do m=ks,km
       do n=ks,km
          do l=0,km
             HT(:,m,n) = HT(:,m,n) + alpha(l)*TH(:,l,m)*TH(:,l,n)
          enddo
       enddo
    enddo

    call LUDecomp(HT,kp)

    call MessageNotify('M','at_ah_galerkin_MMex_Initial(Type2)',&
                           'Conversion matrices initialized')

    MMex_Initialized=.true.

  end subroutine at_ah_galerkin_MMex_Initial

  !
  ! ディリクレ・ノイマン混合境界条件
  ! チェビシェフ係数 -> ガラーキン係数変換(2次元データ)
  !
  function ah_at(at_data)
    real(8), intent(IN) :: at_data(:,0:)                !(in)  チェビシェフ係数
    real(8)             :: ah_at(size(at_data,1),ks:km) !(out) ガラーキン係数  

    real(8)             :: ah_work(size(at_data,1),ks:km)  ! 作業用配列

    integer :: k,m

    if ( .not. MMex_Initialized ) &
         call MessageNotify('E','ah_at(Type2)',&
                            'at_ah_galerkin_MMex_module not initialized')

    ah_work =0.0
    do m=ks,km
       do k=0,km
          ah_work(:,m) = ah_work(:,m) &
               + alpha(k) * beta(k) * at_data(:,k) * TH(:,k,m)
       enddo
    enddo

    ah_at = LUSolve(HT,kp,ah_work)
  end function ah_at

  !
  ! ディリクレ・ノイマン混合境界条件
  ! ガラーキン係数 -> チェビシェフ係数変換(2次元データ)
  !
  function at_ah(ah_data)

    real(8), intent(IN)  :: ah_data(:,ks:)              !(in)  ガラーキン係数
    real(8)              :: at_ah(size(ah_data,1),0:km) !(out) チェビシェフ係数

    integer :: m, n

    if ( .not. MMex_Initialized ) &
         call MessageNotify('E','at_ah(Type2)',&
                            'at_ah_galerkin_MMex_module not initialized')
    at_ah = 0.0D0
    do m=0,km
       do n=ks,km
          at_ah(:,m) = at_ah(:,m) + TH(:,m,n)*ah_data(:,n)/beta(m)
       enddo
    enddo

  end function at_ah

  !
  ! ディリクレ・ノイマン混合境界条件
  ! 格子点データ -> ガラーキン係数変換(2次元データ)
  !
  function ah_ag(ag_data)
    real(8), intent(IN)  :: ag_data(:,0:)                !(in)  格子点データ
    real(8)              :: ah_ag(size(ag_data,1),ks:km) !(out) ガラーキン係数

    ah_ag = ah_at(at_ag(ag_data))
  end function ah_ag

  !
  ! ディリクレ・ノイマン混合境界条件
  ! ガラーキン係数 -> 格子点データ変換(2次元データ)
  !
  function ag_ah(ah_data)
    real(8), intent(IN) :: ah_data(:,ks:)              !(in)  ガラーキン係数  
    real(8)             :: ag_ah(size(ah_data,1),0:im) !(out) 格子点データ  
    
    ag_ah = ag_at(at_ah(ah_data))
  end function ag_ah

  !
  ! ディリクレ・ノイマン混合境界条件
  ! X 微分計算(1 次元)
  !
  function ah_Dx_ah(ah_data)
    real(8), intent(IN) :: ah_data(:,ks:)                  !(in) ガラーキン係数
    real(8)             :: ah_Dx_ah(size(ah_data,1),ks:km) !(out) 微分ガラーキン
    ah_Dx_ah = ah_at(at_Dx_at(at_ah(ah_data)))
  end function ah_Dx_ah

end module at_ah_galerkin_MMex

!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  eq_module テストプログラム (微分計算)
!
!履歴  2008/04/12  竹広真一
!
program eq_test_derivative

  use dc_message, only : MessageNotify
  use eq_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=16              ! 格子点の設定(Phi,Rad)
  integer, parameter :: km=10, lm=21              ! 切断波数の設定(Phi,Rad)

 !---- 変数 ----
  real(8)            :: rp_Data(jm,0:im-1)        ! 格子データ
  real(8)            :: rp_Deriv(jm,0:im-1)       ! 格子データ

  integer            :: k=2, l=4

 !---- 座標変数など ----
  real(8), parameter :: ra=3.0

  real(8), parameter :: eps = 1.0d-7            ! 判定誤差

  call MessageNotify('M','eq_test_derivative', &
       'eq_module derivative function tests')

 !---------------- 座標値の設定 ---------------------
  call eq_Initial(im,jm,km,lm,ra)                ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
  write(6,*)
  write(6,*) '  The result will be printed '
  write(6,*) '  only when the error is larger than ', eps
  write(6,*)

!!$  write(6,*) '  Input wavenumbers of the grid data, k and l :'
!!$  read(5,*) k,l
  write(6,*) '  k,l = ', k,l

  rp_Data = sin(k*rp_Phi) * rp_Rad**l

  rp_Deriv = k*cos(k*rp_Phi) * rp_Rad**l
  call check2d(rp_eq(eq_DPhi_eq(eq_rp(rp_Data)))-rp_Deriv, &
       eps, 'DPhi(sin(k*Phi)*Rad**l')

  rp_Deriv = sin(k*rp_Phi) * l * rp_Rad**l
  call check2d(rp_eq(eq_RadDRad_eq(eq_rp(rp_Data)))-rp_Deriv, &
       eps, 'RadDRad(sin(k*Phi)*Rad**l')

  rp_Deriv = (l**2 - k**2) * sin(k*rp_Phi) * rp_Rad**(l-2)
  call check2d(rp_er(er_Lapla_eq(eq_rp(rp_Data)))-rp_Deriv, &
       eps, 'Lapla(sin(k*Phi)*Rad**l')

  rp_Data = cos(k*rp_Phi) * rp_Rad**l

  rp_Deriv = -k*sin(k*rp_Phi) * rp_Rad**l
  call check2d(rp_eq(eq_DPhi_eq(eq_rp(rp_Data)))-rp_Deriv, &
       eps, 'DPhi(cos(k*Phi)*Rad**l')

  rp_Deriv = l * cos(k*rp_Phi) * rp_Rad**l
  call check2d(rp_eq(eq_RadDRad_eq(eq_rp(rp_Data)))-rp_Deriv, &
       eps, 'RadDRad(cos(k*Phi)*Rad**l')

  rp_Deriv = (l**2-k**2) * cos(k*rp_Phi) * rp_Rad**(l-2)
  call check2d(rp_er(er_Lapla_eq(eq_rp(rp_Data)))-rp_Deriv, &
       eps, 'Lapla(cos(k*Phi)*Rad**l')

  call MessageNotify('M','eq_test_derivative', &
       'eq_module derivative function tests succeeded!')

 stop
contains

  subroutine check2d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:)                ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    integer i, j

    if ( present(funcname) )then
       write(6,*) '  Checking ', funcname, '...'
    endif

    do i=1,size(var,1)
       do j=1,size(var,2)
          if (abs(var(i,j)) .gt. eps ) then
             write(6,*) &
                  '    Value larger than EPS : i= ', i, '  j= ', j, var(i,j)
             call MessageNotify('E','ee_test_derivative', &
                  'derivative error too large')
          endif
       enddo
    enddo
  end subroutine check2d

end program eq_test_derivative

!----------------------------------------------------------------------
!     Copyright (c) 2011 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wq_mpi_module テストプログラム
!
!      wr_RotRad_wq のテスト (1/r d/dr r)
!      wr_DivRad_wq のテスト (1/r^2 d/dr r^2)
!      wq_Rad2Inv_wq のテスト (1/r^2)
!      wq_Lapla_wq のテスト (1/r^2 d/dr r^2)
!      xyr_GradLon_wq のテスト
!      xyr_GradLat_wq のテスト
!      wq_Div_xyr_xyr_xyr のテスト
!      wr_DivLon_xyr のテスト (1/r cosφ d/dλ)
!      wr_DivLat_xyr のテスト (1/r cosφ d/dφ cosφ)
!      wr_DivRad_xyr のテスト (1/r^2 d/dr r^2)
!      xyr_RotLon_wq_wq のテスト (1/r ∂Vrad/∂φ-1/r ∂(r Vlat)/∂r)
!      xyr_RotLat_wq_wq のテスト (1/r ∂(r Vlon)/∂r - 1/rcosφ・∂Vrad/∂λ)
!      wr_RotRad_xyr_xyr のテスト (1/rcosφ・∂Vlat/∂λ - 1/rcosφ・∂(Vlon cosφ)/∂φ)
!
!      xvr_GradLon_wq のテスト
!      xvr_GradLat_wq のテスト
!      wq_Div_xvr_xvr_xvr のテスト
!      wr_DivLon_xvr のテスト (1/r cosφ d/dλ)
!      wr_DivLat_xvr のテスト (1/r cosφ d/dφ cosφ)
!      wr_DivRad_xvr のテスト (1/r^2 d/dr r^2)
!      xvr_RotLon_wq_wq のテスト (1/r ∂Vrad/∂φ-1/r ∂(r Vlat)/∂r)
!      xvr_RotLat_wq_wq のテスト (1/r ∂(r Vlon)/∂r - 1/rcosφ・∂Vrad/∂λ)
!      wr_RotRad_xvr_xvr のテスト (1/rcosφ・∂Vlat/∂λ - 1/rcosφ・∂(Vlon cosφ)/∂φ)
!
!履歴  2011/09/08  竹広真一  wq_module_deriv1_test.f90 を MPI 用に改造
!
program wq_mpi_module_derivative_test1

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wq_mpi_module
  use mpi
  implicit none

  integer,parameter  :: im=32, jm=16, km=8   ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=15         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ra=1.5               ! 球半径

  real(8), dimension(0:im-1,1:jm,km)     :: xyr_Data
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_Data1

  real(8), dimension(0:im-1,1:jm,km)     :: xyr_VLon
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_VLat
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_VRad
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_Psi
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_GradLon
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_GradLat
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_Div
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_DivLon
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_DivLat
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_DivRad
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_RotLon
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_RotLat
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_RotRad

  real(8), allocatable :: xvr_Data(:,:,:)
  real(8), allocatable :: xvr_Data1(:,:,:)

  real(8), allocatable :: xvr_VLon(:,:,:)
  real(8), allocatable :: xvr_VLat(:,:,:)
  real(8), allocatable :: xvr_VRad(:,:,:)
  real(8), allocatable :: xvr_Psi(:,:,:)
  real(8), allocatable :: xvr_GradLon(:,:,:)
  real(8), allocatable :: xvr_GradLat(:,:,:)
  real(8), allocatable :: xvr_Div(:,:,:)
  real(8), allocatable :: xvr_DivLon(:,:,:)
  real(8), allocatable :: xvr_DivLat(:,:,:)
  real(8), allocatable :: xvr_DivRad(:,:,:)
  real(8), allocatable :: xvr_RotLon(:,:,:)
  real(8), allocatable :: xvr_RotLat(:,:,:)
  real(8), allocatable :: xvr_RotRad(:,:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  integer, parameter :: nmin=1, nmax=10

  integer :: iproc, np, ierr
  integer :: n

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wq_mpi_module_derivative_test1', &
       'wq_mpi_module derivative function test #1')

  call wq_mpi_Initial(im,jm,km,nm,lm,ra)

  allocate(xvr_Data(0:im-1,1:jc,km))
  allocate(xvr_Data1(0:im-1,1:jc,km))

  allocate(xvr_VLon(0:im-1,1:jc,km))
  allocate(xvr_VLat(0:im-1,1:jc,km))
  allocate(xvr_VRad(0:im-1,1:jc,km))
  allocate(xvr_Psi(0:im-1,1:jc,km))
  allocate(xvr_GradLon(0:im-1,1:jc,km))
  allocate(xvr_GradLat(0:im-1,1:jc,km))
  allocate(xvr_Div(0:im-1,1:jc,km))
  allocate(xvr_DivLon(0:im-1,1:jc,km))
  allocate(xvr_DivLat(0:im-1,1:jc,km))
  allocate(xvr_DivRad(0:im-1,1:jc,km))
  allocate(xvr_RotLon(0:im-1,1:jc,km))
  allocate(xvr_RotLat(0:im-1,1:jc,km))
  allocate(xvr_RotRad(0:im-1,1:jc,km))

  !==================== wr_RotRad_wq ====================

  write( 6,* ) 'Test for wr_RotDRad_wq (even mode)'
  do n=nmin+1,nmax,2
     write(6,*) 'n=',n
     xyr_Data = xyr_Rad**n
     xyr_Data1 = (n+1)*xyr_Rad**(n-1)

     xyr_Data = xyr_wr(wr_RotDRad_wq(wq_xyr(xyr_Data)))

     call AssertEqual(&
       message='wq_RotRad_wq with r^n (even n)',                     &
       answer = xyr_Data1,                                           &
       check = xyr_Data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

     write(6,*) 'n=',n
     xvr_Data = xvr_Rad**n
     xvr_Data1 = (n+1)*xvr_Rad**(n-1)

     xvr_Data = xvr_wr(wr_RotDRad_wq(wq_xvr(xvr_Data)))

     call AssertEqual(&
       message='wq_RotRad_wq with r^n (even n)',                     &
       answer = xvr_Data1,                                           &
       check = xvr_Data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  enddo

  do n=nmin,nmax,2
     xyr_Data = xyr_Rad**n*cos(xyr_Lat)*sin(xyr_Lon)
     xyr_Data1 = (n+1)*xyr_Rad**(n-1)*cos(xyr_Lat)*sin(xyr_Lon)
     xyr_Data = xyr_wr(wr_RotDRad_wq(wq_xyr(xyr_Data)))

     call AssertEqual(&
       message='wq_RotRad_wq with r^n Y_1^-1 (odd n)',               &
       answer = xyr_Data1,                                           &
       check = xyr_Data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

     xvr_Data = xvr_Rad**n*cos(xvr_Lat)*sin(xvr_Lon)
     xvr_Data1 = (n+1)*xvr_Rad**(n-1)*cos(xvr_Lat)*sin(xvr_Lon)
     xvr_Data = xvr_wr(wr_RotDRad_wq(wq_xvr(xvr_Data)))

     call AssertEqual(&
       message='wq_RotRad_wq with r^n Y_1^-1 (odd n)',               &
       answer = xvr_Data1,                                           &
       check = xvr_Data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  enddo

  !==================== wr_DivRad_wq ====================
  do n=nmin,nmax,2
     write(6,*) 'n=',n
     xyr_Data = xyr_Rad**n * cos(xyr_Lat)*sin(xyr_Lon)
     xyr_Data1 = (n+2)*xyr_Rad**(n-1)*cos(xyr_Lat)*sin(xyr_Lon)

     xyr_Data = xyr_wr(wr_DivRad_wq(wq_xyr(xyr_Data)))

     call AssertEqual(&
       message='wr_DivRad_wq with r^n Y_1^-1 (odd n)',               &
       answer = xyr_Data1,                                           &
       check = xyr_Data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

     write(6,*) 'n=',n
     xvr_Data = xvr_Rad**n * cos(xvr_Lat)*sin(xvr_Lon)
     xvr_Data1 = (n+2)*xvr_Rad**(n-1)*cos(xvr_Lat)*sin(xvr_Lon)

     xvr_Data = xvr_wr(wr_DivRad_wq(wq_xvr(xvr_Data)))

     call AssertEqual(&
       message='wr_DivRad_wq with r^n Y_1^-1 (odd n)',               &
       answer = xvr_Data1,                                           &
       check = xvr_Data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  enddo

  do n=nmin+1,nmax,2
     write(6,*) 'n=',n
     xyr_Data = xyr_Rad**n
     xyr_Data1 = (n+2)*xyr_Rad**(n-1)

     xyr_Data = xyr_wr(wr_DivRad_wq(wq_xyr(xyr_Data)))

     call AssertEqual(&
       message='wr_DivRad_wq with r^n (even n)',                     &
       answer = xyr_Data1,                                           &
       check = xyr_Data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

     write(6,*) 'n=',n
     xvr_Data = xvr_Rad**n
     xvr_Data1 = (n+2)*xvr_Rad**(n-1)

     xvr_Data = xvr_wr(wr_DivRad_wq(wq_xvr(xvr_Data)))

     call AssertEqual(&
       message='wr_DivRad_wq with r^n (even n)',                     &
       answer = xvr_Data1,                                           &
       check = xvr_Data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  enddo

  !==================== wq_Rad2Inv_wq ====================
  do n=nmin+2,nmax,2
     write(6,*) 'n=',n
     xyr_Data = xyr_Rad**n * cos(xyr_Lat)*sin(xyr_Lon)
     xyr_Data1 = xyr_Data/xyr_Rad**2

     xyr_Data = xyr_wq(wq_Rad2Inv_wq(wq_xyr(xyr_Data)))

     call AssertEqual(&
       message='wq_Rad2Inv_wq with r^n Y_1^-1 (odd n)',              &
       answer = xyr_Data1,                                           &
       check = xyr_Data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

     write(6,*) 'n=',n
     xvr_Data = xvr_Rad**n * cos(xvr_Lat)*sin(xvr_Lon)
     xvr_Data1 = xvr_Data/xvr_Rad**2

     xvr_Data = xvr_wq(wq_Rad2Inv_wq(wq_xvr(xvr_Data)))

     call AssertEqual(&
       message='wq_Rad2Inv_wq with r^n Y_1^-1 (odd n)',              &
       answer = xvr_Data1,                                           &
       check = xvr_Data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  enddo

  do n=nmin+1,nmax,2
     write(6,*) 'n=',n
     xyr_Data = xyr_Rad**n
     xyr_Data1 = xyr_Data/xyr_Rad**2

     xyr_Data = xyr_wq(wq_Rad2Inv_wq(wq_xyr(xyr_Data)))

     call AssertEqual(&
       message='wq_Rad2Inv_wq with r^n (even n)',                    &
       answer = xyr_Data1,                                           &
       check = xyr_Data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

     write(6,*) 'n=',n
     xvr_Data = xvr_Rad**n
     xvr_Data1 = xvr_Data/xvr_Rad**2

     xvr_Data = xvr_wq(wq_Rad2Inv_wq(wq_xvr(xvr_Data)))

     call AssertEqual(&
       message='wq_Rad2Inv_wq with r^n (even n)',                    &
       answer = xvr_Data1,                                           &
       check = xvr_Data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  enddo

  !==================== wq_Lapla_wq ====================
  do n=nmin,nmax,2
     write(6,*) 'n=',n
     xyr_Data = xyr_Rad**n * cos(xyr_Lat)*sin(xyr_Lon)
     xyr_Data1 = (n*(n+1)-2)*xyr_Data/xyr_Rad**2

     xyr_Data = xyr_wq(wq_Lapla_wq(wq_xyr(xyr_Data)))

     call AssertEqual(&
       message='wq_Lapla_wq with r^n Y_1^-1 (odd n)',                &
       answer = xyr_Data1,                                           &
       check = xyr_Data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

     write(6,*) 'n=',n
     xvr_Data = xvr_Rad**n * cos(xvr_Lat)*sin(xvr_Lon)
     xvr_Data1 = (n*(n+1)-2)*xvr_Data/xvr_Rad**2

     xvr_Data = xvr_wq(wq_Lapla_wq(wq_xvr(xvr_Data)))

     call AssertEqual(&
       message='wq_Lapla_wq with r^n Y_1^-1 (odd n)',                &
       answer = xvr_Data1,                                           &
       check = xvr_Data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  enddo

  write( 6,* ) 'Test for wq_Lapla_wq(even mode)'
  do n=nmin+1,nmax,2
     write(6,*) 'n=',n
     xyr_Data = xyr_Rad**n
     xyr_Data1 = n*(n+1)*xyr_Data/xyr_Rad**2

     xyr_Data = xyr_wq(wq_Lapla_wq(wq_xyr(xyr_Data)))

     call AssertEqual(&
       message='wq_Lapla_wq with r^n (even n)',                      &
       answer = xyr_Data1,                                           &
       check = xyr_Data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

     write(6,*) 'n=',n
     xvr_Data = xvr_Rad**n
     xvr_Data1 = n*(n+1)*xvr_Data/xvr_Rad**2

     xvr_Data = xvr_wq(wq_Lapla_wq(wq_xvr(xvr_Data)))

     call AssertEqual(&
       message='wq_Lapla_wq with r^n (even n)',                      &
       answer = xvr_Data1,                                           &
       check = xvr_Data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  enddo

  !========== xyr_GradLon_wq, xyr_GradLat_wq, wr_Div_xyr_xyr_xyr ==========
  n=2

  ! ------ r^3 Y_1^1 Poloidal field -----
  xyr_VRad = 0.0D0
  xyr_Psi = xyr_Rad**(n+1) * cos(xyr_Lat)*sin(xyr_Lon)   ! r**3 P_1^1

  xyr_GradLon =  xyr_Rad**n * cos(xyr_Lon)
  xyr_GradLat = -xyr_Rad**n * sin(xyr_Lat)*sin(xyr_Lon)

  xyr_Div = - 2* xyr_Psi/xyr_Rad**2

  call AssertEqual(&
       message='xyr_GradLon_wq with r^3 Y_1^1',                      &
       answer = xyr_GradLon,                                         &
       check = xyr_GradLon_wq(wq_xyr(xyr_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='xyr_GradLat_wq with r^3 Y_1^1',                      &
       answer = xyr_GradLat,                                         &
       check = xyr_GradLat_wq(wq_xyr(xyr_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wr_Div_xyr_xyr_xyr with r^3 Y_1^1',                  &
       answer = xyr_Div,                                             &
       check = xyr_wr(wr_Div_xyr_xyr_xyr(xyr_GradLon,xyr_GradLat,xyr_Vrad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvr_VRad = 0.0D0
  xvr_Psi = xvr_Rad**(n+1) * cos(xvr_Lat)*sin(xvr_Lon)   ! r**3 P_1^1

  xvr_GradLon =  xvr_Rad**n * cos(xvr_Lon)
  xvr_GradLat = -xvr_Rad**n * sin(xvr_Lat)*sin(xvr_Lon)

  xvr_Div = - 2* xvr_Psi/xvr_Rad**2

  call AssertEqual(&
       message='xvr_GradLon_wq with r^3 Y_1^1',                      &
       answer = xvr_GradLon,                                         &
       check = xvr_GradLon_wq(wq_xvr(xvr_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='xvr_GradLat_wq with r^3 Y_1^1',                      &
       answer = xvr_GradLat,                                         &
       check = xvr_GradLat_wq(wq_xvr(xvr_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wr_Div_xvr_xvr_xvr with r^3 Y_1^1',                  &
       answer = xvr_Div,                                             &
       check = xvr_wr(wr_Div_xvr_xvr_xvr(xvr_GradLon,xvr_GradLat,xvr_Vrad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ------ r^2 Y_2^1 Poloidal field -----
  xyr_VRad = 0.0D0
  xyr_Psi = xyr_Rad**n * cos(xyr_Lat)*sin(xyr_Lat) * sin(xyr_Lon) ! P_2^1

  xyr_GradLon =  xyr_Rad**(n-1)*sin(xyr_Lat)*cos(xyr_Lon)
  xyr_GradLat =  xyr_Rad**(n-1)*cos(2*xyr_Lat)*sin(xyr_Lon)

  xyr_Div = - 6* xyr_Psi/xyr_Rad**2

  call AssertEqual(&
       message='xyr_GradLon_wq with r^2 Y_2^1',                      &
       answer = xyr_GradLon,                                         &
       check = xyr_GradLon_wq(wq_xyr(xyr_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='xyr_GradLat_wq with r^2 Y_2^1',                      &
       answer = xyr_GradLat,                                         &
       check = xyr_GradLat_wq(wq_xyr(xyr_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wr_Div_xyr_xyr_xyr with r^2 Y_2^1',                  &
       answer = xyr_Div,                                             &
       check = xyr_wr(wr_Div_xyr_xyr_xyr(xyr_GradLon,xyr_GradLat,xyr_Vrad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvr_VRad = 0.0D0
  xvr_Psi = xvr_Rad**n * cos(xvr_Lat)*sin(xvr_Lat) * sin(xvr_Lon) ! P_2^1

  xvr_GradLon =  xvr_Rad**(n-1)*sin(xvr_Lat)*cos(xvr_Lon)
  xvr_GradLat =  xvr_Rad**(n-1)*cos(2*xvr_Lat)*sin(xvr_Lon)

  xvr_Div = - 6* xvr_Psi/xvr_Rad**2

  call AssertEqual(&
       message='xvr_GradLon_wq with r^2 Y_2^1',                      &
       answer = xvr_GradLon,                                         &
       check = xvr_GradLon_wq(wq_xvr(xvr_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='xvr_GradLat_wq with r^2 Y_2^1',                      &
       answer = xvr_GradLat,                                         &
       check = xvr_GradLat_wq(wq_xvr(xvr_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wr_Div_xvr_xvr_xvr with r^2 Y_2^1',                  &
       answer = xvr_Div,                                             &
       check = xvr_wr(wr_Div_xvr_xvr_xvr(xvr_GradLon,xvr_GradLat,xvr_Vrad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !========== wr_DivLon_xyr, wr_DivLat_xyr, wr_DivRad_xyr ==========

  xyr_VLon   = xyr_rad**n * cos(xyr_Lat)**2*sin(xyr_Lon)
  xyr_DivLon = xyr_rad**(n-1)*cos(xyr_Lat)*cos(xyr_Lon)

  xyr_VLat   = xyr_rad**n * cos(xyr_Lat)**2*sin(xyr_Lon)
  xyr_DivLat = -3*xyr_rad**(n-1)*cos(xyr_Lat)*sin(xyr_Lat)*sin(xyr_Lon)

  xyr_VRad = xyr_Rad**n * cos(xyr_Lat)*sin(xyr_Lon)
  xyr_DivRad = (n+2)*xyr_Rad**(n-1)*cos(xyr_Lat)*sin(xyr_Lon)

  call AssertEqual(&
       message='wr_DivLon_xyr',                                      &
       answer = xyr_DivLon,                                          &
       check = xyr_wr(wr_DivLon_xyr(xyr_VLon)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wr_DivLat_xyr',                                      &
       answer = xyr_DivLat,                                          &
       check = xyr_wr(wr_DivLat_xyr(xyr_VLat)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wr_DivRad_xyr',                                      &
       answer = xyr_DivRad,                                          &
       check = xyr_wr(wr_DivRad_xyr(xyr_VRad)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvr_VLon   = xvr_rad**n * cos(xvr_Lat)**2*sin(xvr_Lon)
  xvr_DivLon = xvr_rad**(n-1)*cos(xvr_Lat)*cos(xvr_Lon)

  xvr_VLat   = xvr_rad**n * cos(xvr_Lat)**2*sin(xvr_Lon)
  xvr_DivLat = -3*xvr_rad**(n-1)*cos(xvr_Lat)*sin(xvr_Lat)*sin(xvr_Lon)

  xvr_VRad = xvr_Rad**n * cos(xvr_Lat)*sin(xvr_Lon)
  xvr_DivRad = (n+2)*xvr_Rad**(n-1)*cos(xvr_Lat)*sin(xvr_Lon)

  call AssertEqual(&
       message='wr_DivLon_xvr',                                      &
       answer = xvr_DivLon,                                          &
       check = xvr_wr(wr_DivLon_xvr(xvr_VLon)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wr_DivLat_xyr',                                      &
       answer = xvr_DivLat,                                          &
       check = xvr_wr(wr_DivLat_xvr(xvr_VLat)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wr_DivRad_xvr',                                      &
       answer = xvr_DivRad,                                          &
       check = xvr_wr(wr_DivRad_xvr(xvr_VRad)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !========== xyr_RotLon_wq_wq, xyr_DivLat_wq_wq, wr_DivRad_xyr_xyr ==========
  n=3

  xyr_VLon = xyr_rad**n * cos(xyr_Lat)*sin(xyr_Lon)
  xyr_VLat = xyr_rad**n * cos(xyr_Lat)*sin(xyr_Lon)
  xyr_VRad = xyr_Rad**n * cos(xyr_Lat)*sin(xyr_Lon)

  xyr_RotLon = - xyr_rad**(n-1) * sin(xyr_Lat) * sin(xyr_Lon)  &
               - (n+1)*xyr_rad**(n-1)*cos(xyr_Lat)*sin(xyr_Lon)

  xyr_RotLat =   (n+1)*xyr_rad**(n-1)*cos(xyr_Lat)*sin(xyr_Lon) &
               - xyr_rad**(n-1) * cos(xyr_Lon) 

  call AssertEqual(&
       message='xyr_RotLon_wq_wq',                                   &
       answer = xyr_RotLon,                                          &
       check = xyr_RotLon_wq_wq(wq_xyr(xyr_VRad),wq_xyr(xyr_VLat)),  &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='xyr_RotLat_wq_wq',                                   &
       answer = xyr_RotLat,                                          &
       check = xyr_RotLat_wq_wq(wq_xyr(xyr_VLon),wq_xyr(xyr_VRad)),  &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyr_VLon = xyr_rad**n * cos(xyr_Lat) 
  xyr_VLat = xyr_rad**n * cos(xyr_Lat)**2 * sin(xyr_Lon)

  xyr_RotRad =   xyr_rad**(n-1) * cos(xyr_Lat) * cos(xyr_Lon) &
               + 2 * xyr_rad**(n-1) * sin(xyr_Lat) 

  call AssertEqual(&
       message='wr_RotRad_xyr_xyr',                                  &
       answer = xyr_RotRad,                                          &
       check = xyr_wr(wr_RotRad_xyr_xyr(xyr_VLat,xyr_VLon)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvr_VLon = xvr_rad**n * cos(xvr_Lat)*sin(xvr_Lon)
  xvr_VLat = xvr_rad**n * cos(xvr_Lat)*sin(xvr_Lon)
  xvr_VRad = xvr_Rad**n * cos(xvr_Lat)*sin(xvr_Lon)

  xvr_RotLon = - xvr_rad**(n-1) * sin(xvr_Lat) * sin(xvr_Lon)  &
               - (n+1)*xvr_rad**(n-1)*cos(xvr_Lat)*sin(xvr_Lon)

  xvr_RotLat =   (n+1)*xvr_rad**(n-1)*cos(xvr_Lat)*sin(xvr_Lon) &
               - xvr_rad**(n-1) * cos(xvr_Lon) 

  call AssertEqual(&
       message='xvr_RotLon_wq_wq',                                   &
       answer = xvr_RotLon,                                          &
       check = xvr_RotLon_wq_wq(wq_xvr(xvr_VRad),wq_xvr(xvr_VLat)),  &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='xvr_RotLat_wq_wq',                                   &
       answer = xvr_RotLat,                                          &
       check = xvr_RotLat_wq_wq(wq_xvr(xvr_VLon),wq_xvr(xvr_VRad)),  &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvr_VLon = xvr_rad**n * cos(xvr_Lat) 
  xvr_VLat = xvr_rad**n * cos(xvr_Lat)**2 * sin(xvr_Lon)

  xvr_RotRad =   xvr_rad**(n-1) * cos(xvr_Lat) * cos(xvr_Lon) &
               + 2 * xvr_rad**(n-1) * sin(xvr_Lat) 

  call AssertEqual(&
       message='wr_RotRad_xvr_xvr',                                  &
       answer = xvr_RotRad,                                          &
       check = xvr_wr(wr_RotRad_xvr_xvr(xvr_VLat,xvr_VLon)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','wq_mpi_module_derivative_test1', &
       'wq_mpi_module derivative function test #1 succeeded!')

  call MPI_FINALIZE(IERR)

end program wq_mpi_module_derivative_test1

!-------------------------------------------------------------------------
! Copyright (c) 2017 SPMODEL Development Group. All rights reserved.!
!-------------------------------------------------------------------------
!
!表題  asc_module テストプログラム
!
!      補間関数のテスト
!
!履歴  2017/05/17  竹広真一
!
!
program asc_test_interpolate

  use asc_module
  use dc_test
  implicit none

  integer, parameter :: im = 16,  km=10
  real(8), parameter :: xmin=0.0, xmax=1.0
  
  real(8)            :: g_Data(0:im)
  real(8)            :: s_Data(km)
  real(8)            :: c_Data(0:km)

  real(8)            :: ag_Data(2,0:im)
  real(8)            :: as_Data(2,km)
  real(8)            :: ac_Data(2,0:km)  

  real(8)            :: xobs   = 0.3d0
  real(8)            :: answer(2)
  real(8)            :: PI

  ! 判定誤差設定
  integer, parameter :: check_digits = 16
  integer, parameter :: ignore = -14

  PI = 4.0D0 * atan(1.0D0)

  call asc_Initial(im,km,xmin,xmax)

  !
  ! ----------- cos 変換補間テスト -------------
  !
  g_Data = sin(PI*g_X)**2
  c_Data = c_g(g_Data)

  call AssertEqual(&
    message = '1-dim Interpolation (cos transform)',            &
    answer = sin(PI*xobs)**2,                                   &
    check =  Interpolate_c(c_Data,xobs),                        &
    significant_digits = check_digits, ignore_digits = ignore   &
  )

  ag_Data(1,:) = cos(PI*g_X)**2
  ag_Data(2,:) = sin(PI*g_X)**4
  ac_Data      = ac_ag(ag_Data)

  answer(1) = cos(PI*xobs)**2
  answer(2) = sin(PI*xobs)**4

  call AssertEqual(&
    message = '2-dim Interpolation (cos transform)',            &
    answer = answer,                                            &
    check =  a_Interpolate_ac(ac_Data,xobs),                    &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  
  !
  ! ----------- sin 変換補間テスト -------------
  !
  g_Data = sin(PI*g_X)
  s_Data = s_g(g_Data)

  call AssertEqual(&
    message = '1-dim Interpolation (sin transform)',            &
    answer = sin(PI*xobs),                                      &
    check =  Interpolate_s(s_Data,xobs),                        &
    significant_digits = check_digits, ignore_digits = ignore   &
  )

  ag_Data(1,:) = sin(2*PI*g_X)
  ag_Data(2,:) = sin(4*PI*g_X)
  as_Data      = as_ag(ag_Data)

  answer(1) = sin(2*PI*xobs)
  answer(2) = sin(4*PI*xobs)

  call AssertEqual(&
    message = '2-dim Interpolation (sin transform)',            &
    answer = answer,                                            &
    check =  a_Interpolate_as(as_Data,xobs),                    &
    significant_digits = check_digits, ignore_digits = ignore   &
  )

end program asc_test_interpolate

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_module_sjpack テストプログラム :: 微分関数のテスト
!
!履歴  2009/09/22  竹広真一
!
program w_module_sjpack_deriv_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_wave_module_sjpack
  implicit none

  integer, parameter :: im=2, jm=16, nm=10, m=1

  real(8), dimension(0:im-1,1:jm)  ::  xy_data1              ! 元の関数
  real(8), dimension(0:im-1,1:jm)  ::  xy_ddata              ! 微分の正解
  real(8), dimension(0:im-1,1:jm)  ::  xy_mu                 ! μ=sinφ

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  integer :: j

  call MessageNotify('M','w_wave_module_sjpack_deriv_test', &
                         'w_wave_module_sjpack tests of derivative functions') 

  call w_Initial( nm, m, im, jm )

  !============== 微分計算 (φ座標系用) のテスト ==============

  !---- P_1^1 のテスト ----
  xy_data1 = sqrt(3.0D0/2.0D0)*cos(xy_Lat)      ! P_1^1

  xy_ddata = -2*sqrt(3.0D0/2.0D0)*cos(xy_Lat)   ! w_Lapla_w
  call AssertEqual(&
    message='P_1^1 Test of w_Lapla_w',                          &
    answer = xy_ddata,                                          &
    check = xy_w(w_Lapla_w(w_xy(xy_data1))),                    &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  xy_ddata = -0.5*sqrt(3.0D0/2.0D0)*cos(xy_Lat)      ! w_LaplaInv_l
  call AssertEqual(&
    message='P_1^1 Test of w_LaplaInv_w',                       &
    answer = xy_ddata,                                          &
    check = xy_w(w_LaplaInv_w(w_xy(xy_data1))),                 &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  do j=1,jm
     xy_ddata(0,j) = - m*sqrt(3.0D0/2.0D0)*cos(y_Lat(j))    ! w_DLon_w
     xy_ddata(1,j) =   m*sqrt(3.0D0/2.0D0)*cos(y_Lat(j))
  enddo
  call AssertEqual(&
    message='P_1^1 Test of w_DLon_w',                           &
    answer = xy_ddata,                                            &
    check = xy_w(w_DLon_w(w_xy(xy_data1))),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  do j=1,jm
     xy_ddata(0,j) = -m * sqrt(3.0D0/2.0D0)    ! xy_GradLon_w
     xy_ddata(1,j) =  m * sqrt(3.0D0/2.0D0)
  enddo
  call AssertEqual(&
    message='P_1^1 Test of xy_GradLon_w',                        &
    answer = xy_ddata,                                           &
    check = xy_GradLon_w(w_xy(xy_data1)),                        &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  xy_ddata = -sqrt(3.0D0/2.0D0)*sin(xy_Lat)          ! xy_GradLat_w
  call AssertEqual(&
    message='P_1^1 Test of xy_GradLat_w',                        &
    answer = xy_ddata,                                           &
    check = xy_GradLat_w(w_xy(xy_data1)),                        &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  !---- P_1^1 cosφ のテスト ----
  xy_data1 = sqrt(3.0D0/2.0D0)*cos(xy_Lat)*cos(xy_Lat)         ! P_1^1 cosφ

  do j=1,jm
     xy_ddata(0,j) = -m * sqrt(3.0D0/2.0D0)*cos(y_Lat(j))      ! w_DivLat_xy
     xy_ddata(1,j) =  m * sqrt(3.0D0/2.0D0)*cos(y_Lat(j)) 
  enddo
  call AssertEqual(&
    message='P_1^1 cos(phi) Test of w_DivLon_xy',               &
    answer = xy_ddata,                                          &
    check = xy_w(w_DivLon_xy(xy_data1)),                        &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  xy_ddata = -3*sqrt(3.0D0/2.0D0)*cos(xy_Lat)*sin(xy_Lat)      ! xy_DivLat_xy
  call AssertEqual(&
    message='P_1^1 cos(phi) Test of w_DivLat_xy',               &
    answer = xy_ddata,                                          &
    check = xy_w(w_DivLat_xy(xy_data1)),                        &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  !---- P_2^1 のテスト ----
  xy_data1 = sqrt(5.0D0/6.0D0)*(3*sin(xy_Lat)*cos(xy_Lat))  ! P_2^1

  xy_ddata = -6*xy_data1                                    ! w_Lapla_w
  call AssertEqual(&
    message='P_2^1 Test of w_Lapla_w',                            &
    answer = xy_ddata,                                            &
    check = xy_w(w_Lapla_w(w_xy(xy_data1))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_ddata = -xy_data1/6.0D0                                ! w_Lapla_w
  call AssertEqual(&
    message='P_2^1 Test of w_LaplaInv_w',                         &
    answer = xy_ddata,                                            &
    check = xy_w(w_LaplaInv_w(w_xy(xy_data1))),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  do j=1,jm
     xy_ddata(0,j) = -m*sqrt(5.0D0/6.0D0)*(3*sin(y_Lat(j))*cos(y_Lat(j))) ! w_DLon_w
     xy_ddata(1,j) =  m*sqrt(5.0D0/6.0D0)*(3*sin(y_Lat(j))*cos(y_Lat(j)))
  enddo
  call AssertEqual(&
    message='P_2^1 Test of w_DLon_w',                           &
    answer = xy_ddata,                                          &
    check = xy_w(w_DLon_w(w_xy(xy_data1))),                     &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  do j=1,jm
     xy_ddata(0,j) = -m*sqrt(5.0D0/6.0D0)*3*sin(y_Lat(j))    ! xy_GradLon_w
     xy_ddata(1,j) =  m*sqrt(5.0D0/6.0D0)*3*sin(y_Lat(j)) 
  enddo
  call AssertEqual(&
    message='P_2^1 Test of xy_GradLon_w',                        &
    answer = xy_ddata,                                           &
    check = xy_GradLon_w(w_xy(xy_data1)),                        &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  xy_ddata = sqrt(5.0D0/6.0D0)*3.0*cos(2*xy_Lat)           ! xy_GradLat_w
  call AssertEqual(&
    message='P_2^1 Test of xy_GradLat_w',                        &
    answer = xy_ddata,                                           &
    check = xy_GradLat_w(w_xy(xy_data1)),                        &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  !---- P_2^1 cosφ のテスト ----
  xy_data1 = sqrt(5.0D0/6.0D0)*(3*sin(xy_Lat)*cos(xy_Lat))*cos(xy_Lat) !   P_2^1 cosφ

  do j=1,jm
     xy_ddata(0,j) = -m*sqrt(5.0D0/6.0D0)*(3*sin(y_Lat(j))*cos(y_Lat(j)))  ! w_DivLat_xy
     xy_ddata(1,j) =  m*sqrt(5.0D0/6.0D0)*(3*sin(y_Lat(j))*cos(y_Lat(j))) 
  enddo
  call AssertEqual(&
    message='P_2^1 cos(phi) Test of w_DivLon_xy',                &
    answer = xy_ddata,                                            &
    check = xy_w(w_DivLon_xy(xy_data1)),                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_ddata = sqrt(5.0D0/6.0D0)*(3.0*(cos(xy_Lat)**3-3*sin(xy_Lat)**2*cos(xy_Lat)))
                                                               ! w_DivLat_xy
  call AssertEqual(&
    message='P_2^1 cos(phi) Test of w_DivLat_xy',                  &
    answer = xy_ddata,                                            &
    check = xy_w(w_DivLat_xy(xy_data1)),                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !============== 微分計算 (μ座標系用) のテスト ==============
  xy_mu = sin(xy_Lat)

  !----- P_2^1 のテスト -----
  xy_data1 = xy_mu*sqrt(1-xy_mu**2)                       ! P_2^1
  xy_ddata = sqrt(1-xy_mu**2)*(1-2*xy_mu**2)              ! (1-μ^2)∂/∂μ 

  call AssertEqual(&
    message='P_2^1 Test of xy_GradMu_w',                           &
    answer = xy_ddata,                                            &
    check = xy_GradMu_w(w_xy(xy_data1)),                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !----- P_2^1 (1-μ^2) のテスト -----
  xy_data1 = xy_mu*sqrt(1-xy_mu**2)*(1-xy_mu**2)          ! P_2^1 (1-μ^2)
  xy_ddata = (1-4*xy_mu**2)*sqrt(1-xy_mu**2)              ! ∂/∂μ

  call AssertEqual(&
    message='P_2^1 (1-mu^2) Test of xy_DivMu_w',                  &
    answer = xy_ddata,                                            &
    check = xy_w(w_DivMu_xy(xy_data1)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','w_module_sjpack_deriv_test', &
       'w_module_sjpack tests of derivative functions succeeded!') 

end program w_module_sjpack_deriv_test

!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ee_module テストプログラム
!
!履歴  2008/05/04  竹広真一
!
program eee_intavr

  use dc_message, only : MessageNotify
  use eee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=64, km=16          ! 格子点の設定(X,Y,Z)
  integer, parameter :: lm=10, mm=21, nm=5           ! 切断波数の設定(X,Y,Z)

  integer, parameter :: im2=64, jm2=64, km2=64       ! 格子点の設定(X,Y,Z)
  integer, parameter :: lm2=21, mm2=21, nm2=21       ! 切断波数の設定(X,Y,Z)

 !---- 変数 ----
  real(8)            :: zyx_Data(0:km-1,0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: yx_Data(0:jm-1,0:im-1)            ! 格子データ
  real(8)            :: zx_Data(0:km-1,0:im-1)            ! 格子データ
  real(8)            :: zy_Data(0:km-1,0:jm-1)            ! 格子データ
  real(8)            :: x_Data(0:im-1)                    ! 格子データ
  real(8)            :: y_Data(0:jm-1)                    ! 格子データ
  real(8)            :: z_Data(0:km-1)                    ! 格子データ

  real(8)            :: zyx_Data2(0:km2-1,0:jm2-1,0:im2-1)! 格子データ
  real(8)            :: yx_Data2(0:jm2-1,0:im2-1)         ! 格子データ
  real(8)            :: zx_Data2(0:km2-1,0:im2-1)         ! 格子データ
  real(8)            :: zy_Data2(0:km2-1,0:jm2-1)         ! 格子データ
  real(8)            :: x_Data2(0:im2-1)                  ! 格子データ
  real(8)            :: y_Data2(0:jm2-1)                  ! 格子データ
  real(8)            :: z_Data2(0:km2-1)                  ! 格子データ

 !---- 座標変数など ----
  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: eps = 1.0d-10            ! 判定誤差

  integer :: id1, id2

  call MessageNotify('M','eee_test_intavr', &
       'eee_module integral/average function tests')

 !---------------- 座標値の設定 ---------------------
  call eee_initial(im,jm,km,lm,mm,nm,id1)
  call eee_initial(im2,jm2,km2,lm2,mm2,nm2,id2)


!-------------------------- 3 次元データ ------------------------------
  !--------------- id1 -----------------
  write(*,*) 'for id1'
  call eee_ChangeResolution(id1)

  zyx_Data = sin(zyx_X) * cos(zyx_Y) * cos(zyx_Z)
  write(6,*) 'f = sin(X)*cos(Y)*cos(Z)'

    call check0d(IntZYX_zyx(zyx_Data)-0.0, eps, 'IntZYX_zyx') 
    call check0d(AvrZYX_zyx(zyx_Data)-0.0, eps, 'AvrXYX_zyx')

    call check1d(x_IntZY_zyx(zyx_Data) - 0.0, eps, 'x_IntZY_zyx') 
    call check1d(x_AvrZY_zyx(zyx_Data) - 0.0, eps, 'x_AvrZY_zyx') 
    call check1d(y_IntZX_zyx(zyx_Data) - 0.0, eps, 'y_IntZX_zyx') 
    call check1d(y_AvrZX_zyx(zyx_Data) - 0.0, eps, 'y_AvrZX_zyx') 
    call check1d(z_IntYX_zyx(zyx_Data) - 0.0, eps, 'x_IntZY_zyx') 
    call check1d(z_AvrYX_zyx(zyx_Data) - 0.0, eps, 'x_AvrZY_zyx') 

    call check2d(yx_IntZ_zyx(zyx_Data) - 0.0, eps, 'yx_IntZ_zyx')
    call check2d(yx_AvrZ_zyx(zyx_Data) - 0.0, eps, 'yx_AvrZ_zyx')
    call check2d(zx_IntY_zyx(zyx_Data) - 0.0, eps, 'zx_IntY_zyx')
    call check2d(zx_AvrY_zyx(zyx_Data) - 0.0, eps, 'zx_AvrY_zyx')
    call check2d(zy_IntX_zyx(zyx_Data) - 0.0, eps, 'zy_IntX_zyx')
    call check2d(zy_AvrX_zyx(zyx_Data) - 0.0, eps, 'zy_AvrX_zyx')

  zyx_Data = (1 - sin(zyx_X)) * cos(zyx_Y)**2 * cos(zyx_Z)**2
  write(6,*)
  write(6,*) 'f = (1-sin(X)) * cos(Y)**2 * cos(Z)**2'

    call check0d(IntZYX_zyx(zyx_Data)-2.0*pi**3, eps, 'IntZYX_zyx') 
    call check0d(AvrZYX_zyx(zyx_Data)-0.25, eps, 'AvrXYX_zyx')

    call check1d(x_IntZY_zyx(zyx_Data) - (1 - sin(x_X))*pi**2, eps, 'x_IntZY_zyx') 
    call check1d(x_AvrZY_zyx(zyx_Data) - (1 - sin(x_X))/4, eps, 'x_AvrZY_zyx') 
    call check1d(y_IntZX_zyx(zyx_Data) - cos(y_Y)**2 * 2*pi**2, eps, 'y_IntZX_zyx') 
    call check1d(y_AvrZX_zyx(zyx_Data) - cos(y_Y)**2 /2 , eps, 'y_AvrZX_zyx') 
    call check1d(z_IntYX_zyx(zyx_Data) - cos(z_Z)**2 *2*pi**2 , eps, 'x_IntZY_zyx') 
    call check1d(z_AvrYX_zyx(zyx_Data) - cos(z_Z)**2 /2, eps, 'x_AvrZY_zyx') 

    call check2d(yx_IntZ_zyx(zyx_Data) &
         - (1 - sin(zyx_X(1,:,:)))*cos(zyx_Y(1,:,:))**2*pi, eps, 'yx_IntZ_zyx')
    call check2d(yx_AvrZ_zyx(zyx_Data) &
         - (1 - sin(zyx_X(1,:,:)))*cos(zyx_Y(1,:,:))**2/2,eps, 'yx_AvrZ_zyx')
    call check2d(zx_IntY_zyx(zyx_Data) &
         - (1 - sin(zyx_X(:,1,:)))*cos(zyx_Z(:,1,:))**2*pi, eps, 'zx_IntY_zyx')
    call check2d(zx_AvrY_zyx(zyx_Data) &
         - (1 - sin(zyx_X(:,1,:)))*cos(zyx_Z(:,1,:))**2/2, eps,'zx_AvrY_zyx')
    call check2d(zy_IntX_zyx(zyx_Data) &
         - cos(zyx_Y(:,:,1))**2 * cos(zyx_Z(:,:,1))**2*2*pi, eps, 'zy_IntX_zyx')
    call check2d(zy_AvrX_zyx(zyx_Data) &
         - cos(zyx_Y(:,:,1))**2 * cos(zyx_Z(:,:,1))**2, eps, 'zy_AvrX_zyx')

  !------------- id2 ------------------
  write(*,*) 'for id2'
  call eee_ChangeResolution(id2)

  zyx_Data2 = sin(zyx_X) * cos(zyx_Y) * cos(zyx_Z)
  write(6,*) 'f = sin(X)*cos(Y)*cos(Z)'

    call check0d(IntZYX_zyx(zyx_Data2)-0.0, eps, 'IntZYX_zyx') 
    call check0d(AvrZYX_zyx(zyx_Data2)-0.0, eps, 'AvrXYX_zyx')

    call check1d(x_IntZY_zyx(zyx_Data2) - 0.0, eps, 'x_IntZY_zyx') 
    call check1d(x_AvrZY_zyx(zyx_Data2) - 0.0, eps, 'x_AvrZY_zyx') 
    call check1d(y_IntZX_zyx(zyx_Data2) - 0.0, eps, 'y_IntZX_zyx') 
    call check1d(y_AvrZX_zyx(zyx_Data2) - 0.0, eps, 'y_AvrZX_zyx') 
    call check1d(z_IntYX_zyx(zyx_Data2) - 0.0, eps, 'x_IntZY_zyx') 
    call check1d(z_AvrYX_zyx(zyx_Data2) - 0.0, eps, 'x_AvrZY_zyx') 

    call check2d(yx_IntZ_zyx(zyx_Data2) - 0.0, eps, 'yx_IntZ_zyx')
    call check2d(yx_AvrZ_zyx(zyx_Data2) - 0.0, eps, 'yx_AvrZ_zyx')
    call check2d(zx_IntY_zyx(zyx_Data2) - 0.0, eps, 'zx_IntY_zyx')
    call check2d(zx_AvrY_zyx(zyx_Data2) - 0.0, eps, 'zx_AvrY_zyx')
    call check2d(zy_IntX_zyx(zyx_Data2) - 0.0, eps, 'zy_IntX_zyx')
    call check2d(zy_AvrX_zyx(zyx_Data2) - 0.0, eps, 'zy_AvrX_zyx')

  zyx_Data2 = (1 - sin(zyx_X)) * cos(zyx_Y)**2 * cos(zyx_Z)**2
  write(6,*)
  write(6,*) 'f = (1-sin(X)) * cos(Y)**2 * cos(Z)**2'

    call check0d(IntZYX_zyx(zyx_Data2)-2.0*pi**3, eps, 'IntZYX_zyx') 
    call check0d(AvrZYX_zyx(zyx_Data2)-0.25, eps, 'AvrXYX_zyx')

    call check1d(x_IntZY_zyx(zyx_Data2) - (1 - sin(x_X))*pi**2, eps, 'x_IntZY_zyx') 
    call check1d(x_AvrZY_zyx(zyx_Data2) - (1 - sin(x_X))/4, eps, 'x_AvrZY_zyx') 
    call check1d(y_IntZX_zyx(zyx_Data2) - cos(y_Y)**2 * 2*pi**2, eps, 'y_IntZX_zyx') 
    call check1d(y_AvrZX_zyx(zyx_Data2) - cos(y_Y)**2 /2 , eps, 'y_AvrZX_zyx') 
    call check1d(z_IntYX_zyx(zyx_Data2) - cos(z_Z)**2 *2*pi**2 , eps, 'x_IntZY_zyx') 
    call check1d(z_AvrYX_zyx(zyx_Data2) - cos(z_Z)**2 /2, eps, 'x_AvrZY_zyx') 

    call check2d(yx_IntZ_zyx(zyx_Data2) &
         - (1 - sin(zyx_X(1,:,:)))*cos(zyx_Y(1,:,:))**2*pi, eps, 'yx_IntZ_zyx')
    call check2d(yx_AvrZ_zyx(zyx_Data2) &
         - (1 - sin(zyx_X(1,:,:)))*cos(zyx_Y(1,:,:))**2/2,eps, 'yx_AvrZ_zyx')
    call check2d(zx_IntY_zyx(zyx_Data2) &
         - (1 - sin(zyx_X(:,1,:)))*cos(zyx_Z(:,1,:))**2*pi, eps, 'zx_IntY_zyx')
    call check2d(zx_AvrY_zyx(zyx_Data2) &
         - (1 - sin(zyx_X(:,1,:)))*cos(zyx_Z(:,1,:))**2/2, eps,'zx_AvrY_zyx')
    call check2d(zy_IntX_zyx(zyx_Data2) &
         - cos(zyx_Y(:,:,1))**2 * cos(zyx_Z(:,:,1))**2*2*pi, eps, 'zy_IntX_zyx')
    call check2d(zy_AvrX_zyx(zyx_Data2) &
         - cos(zyx_Y(:,:,1))**2 * cos(zyx_Z(:,:,1))**2, eps, 'zy_AvrX_zyx')

!-------------------------- 2 次元データ ------------------------------
  !------------------- id1 -----------------------
  write(*,*) 'for id1'
  call eee_ChangeResolution(id1)

  yx_Data = sin(zyx_X(1,:,:)) * cos(zyx_Y(1,:,:))
  write(6,*) 'f = sin(X)*cos(Y)'

    call check0d(IntYX_yx(yx_Data)-0.0, eps, 'IntYX_yx') 
    call check0d(AvrYX_yx(yx_Data)-0.0, eps, 'AvrYX_yx')

    call check1d(y_IntX_yx(yx_Data) - 0.0, eps, 'y_IntX_yx') 
    call check1d(y_AvrX_yx(yx_Data) - 0.0, eps, 'y_AvrX_yx') 

    call check1d(x_IntY_yx(yx_Data) - 0.0, eps, 'x_IntY_yx')
    call check1d(x_AvrY_yx(yx_Data) - 0.0, eps, 'x_AvrY_yx')

  yx_Data = (1 - sin(zyx_X(1,:,:))) * cos(zyx_Y(1,:,:))**2
  write(6,*)
  write(6,*) 'f = (1-sin(X)) * cos(Y)**2'

    call check0d(IntYX_yx(yx_Data) - 2.0*pi**2, eps, 'IntYX_yx') 
    call check0d(AvrYX_yx(yx_Data) - 0.5, eps, 'AvrYX_yx')

    call check1d(y_IntX_yx(yx_Data) - 2*cos(y_Y)**2*pi, eps, 'y_IntX_yx') 
    call check1d(y_AvrX_yx(yx_Data) - cos(y_Y)**2, eps, 'y_AvrX_yx')

    call check1d(x_IntY_yx(yx_Data) - (1 - sin(x_X))*pi, eps, 'x_IntY_yx')
    call check1d(x_AvrY_yx(yx_Data) - 0.5*(1 - sin(x_X)), eps, 'x_AvrY_yx')

  zx_Data = sin(zyx_X(:,1,:)) * cos(zyx_Z(:,1,:))
  write(6,*) 'f = sin(X)*cos(Y)'

    call check0d(IntZX_zx(zx_Data)-0.0, eps, 'IntZX_zx') 
    call check0d(AvrZX_zx(zx_Data)-0.0, eps, 'AvrZX_zx')

    call check1d(z_IntX_zx(zx_Data) - 0.0, eps, 'z_IntX_zx') 
    call check1d(z_AvrX_zx(zx_Data) - 0.0, eps, 'z_AvrX_zx') 

    call check1d(x_IntZ_zx(zx_Data) - 0.0, eps, 'x_IntZ_zx')
    call check1d(x_AvrZ_zx(zx_Data) - 0.0, eps, 'x_AvrZ_zx')

  zx_Data = (1 - sin(zyx_X(:,1,:))) * cos(zyx_Z(:,1,:))**2
  write(6,*)
  write(6,*) 'f = (1-sin(X)) * cos(Z)**2'

    call check0d(IntZX_zx(zx_Data) - 2.0*pi**2, eps, 'IntZX_zx') 
    call check0d(AvrZX_zx(zx_Data) - 0.5, eps, 'AvrZX_zx')

    call check1d(z_IntX_zx(zx_Data) - 2*cos(z_Z)**2*pi, eps, 'z_IntX_zx') 
    call check1d(z_AvrX_zx(zx_Data) - cos(z_Z)**2, eps, 'z_AvrX_zx')

    call check1d(x_IntZ_zx(zx_Data) - (1 - sin(x_X))*pi, eps, 'x_IntZ_zx')
    call check1d(x_AvrZ_zx(zx_Data) - 0.5*(1 - sin(x_X)), eps, 'x_AvrZ_zx')

  zy_Data = sin(zyx_Y(:,:,1)) * cos(zyx_Z(:,:,1))
  write(6,*) 'f = sin(Y)*cos(Y)'

    call check0d(IntZY_zy(zy_Data)-0.0, eps, 'IntZY_zy') 
    call check0d(AvrZY_zy(zy_Data)-0.0, eps, 'AvrZY_zy')

    call check1d(z_IntY_zy(zy_Data) - 0.0, eps, 'z_IntY_zy') 
    call check1d(z_AvrY_zy(zy_Data) - 0.0, eps, 'z_AvrY_zy') 

    call check1d(y_IntZ_zy(zy_Data) - 0.0, eps, 'y_IntZ_zy')
    call check1d(y_AvrZ_zy(zy_Data) - 0.0, eps, 'y_AvrZ_zy')

  zy_Data = (1 - sin(zyx_Y(:,:,1))) * cos(zyx_Z(:,:,1))**2
  write(6,*)
  write(6,*) 'f = (1-sin(Y)) * cos(Z)**2'

    call check0d(IntZY_zy(zy_Data) - 2.0*pi**2, eps, 'IntZY_zy') 
    call check0d(AvrZY_zy(zy_Data) - 0.5, eps, 'AvrZY_zy')

    call check1d(z_IntY_zy(zy_Data) - 2*cos(z_Z)**2*pi, eps, 'z_IntY_zy') 
    call check1d(z_AvrY_zy(zy_Data) - cos(z_Z)**2, eps, 'z_AvrY_zy')

    call check1d(y_IntZ_zy(zy_Data) - (1 - sin(y_Y))*pi, eps, 'y_IntZ_zy')
    call check1d(y_AvrZ_zy(zy_Data) - 0.5*(1 - sin(y_Y)), eps, 'y_AvrZ_zy')

  !---------------- id2 ----------------------
  write(*,*) 'for id2'
  call eee_ChangeResolution(id2)

  yx_Data2 = sin(zyx_X(1,:,:)) * cos(zyx_Y(1,:,:))
  write(6,*) 'f = sin(X)*cos(Y)'

    call check0d(IntYX_yx(yx_Data2)-0.0, eps, 'IntYX_yx') 
    call check0d(AvrYX_yx(yx_Data2)-0.0, eps, 'AvrYX_yx')

    call check1d(y_IntX_yx(yx_Data2) - 0.0, eps, 'y_IntX_yx') 
    call check1d(y_AvrX_yx(yx_Data2) - 0.0, eps, 'y_AvrX_yx') 

    call check1d(x_IntY_yx(yx_Data2) - 0.0, eps, 'x_IntY_yx')
    call check1d(x_AvrY_yx(yx_Data2) - 0.0, eps, 'x_AvrY_yx')

  yx_Data2 = (1 - sin(zyx_X(1,:,:))) * cos(zyx_Y(1,:,:))**2
  write(6,*)
  write(6,*) 'f = (1-sin(X)) * cos(Y)**2'

    call check0d(IntYX_yx(yx_Data2) - 2.0*pi**2, eps, 'IntYX_yx') 
    call check0d(AvrYX_yx(yx_Data2) - 0.5, eps, 'AvrYX_yx')

    call check1d(y_IntX_yx(yx_Data2) - 2*cos(y_Y)**2*pi, eps, 'y_IntX_yx') 
    call check1d(y_AvrX_yx(yx_Data2) - cos(y_Y)**2, eps, 'y_AvrX_yx')

    call check1d(x_IntY_yx(yx_Data2) - (1 - sin(x_X))*pi, eps, 'x_IntY_yx')
    call check1d(x_AvrY_yx(yx_Data2) - 0.5*(1 - sin(x_X)), eps, 'x_AvrY_yx')

  zx_Data2 = sin(zyx_X(:,1,:)) * cos(zyx_Z(:,1,:))
  write(6,*) 'f = sin(X)*cos(Y)'

    call check0d(IntZX_zx(zx_Data2)-0.0, eps, 'IntZX_zx') 
    call check0d(AvrZX_zx(zx_Data2)-0.0, eps, 'AvrZX_zx')

    call check1d(z_IntX_zx(zx_Data2) - 0.0, eps, 'z_IntX_zx') 
    call check1d(z_AvrX_zx(zx_Data2) - 0.0, eps, 'z_AvrX_zx') 

    call check1d(x_IntZ_zx(zx_Data2) - 0.0, eps, 'x_IntZ_zx')
    call check1d(x_AvrZ_zx(zx_Data2) - 0.0, eps, 'x_AvrZ_zx')

  zx_Data2 = (1 - sin(zyx_X(:,1,:))) * cos(zyx_Z(:,1,:))**2
  write(6,*)
  write(6,*) 'f = (1-sin(X)) * cos(Z)**2'

    call check0d(IntZX_zx(zx_Data2) - 2.0*pi**2, eps, 'IntZX_zx') 
    call check0d(AvrZX_zx(zx_Data2) - 0.5, eps, 'AvrZX_zx')

    call check1d(z_IntX_zx(zx_Data2) - 2*cos(z_Z)**2*pi, eps, 'z_IntX_zx') 
    call check1d(z_AvrX_zx(zx_Data2) - cos(z_Z)**2, eps, 'z_AvrX_zx')

    call check1d(x_IntZ_zx(zx_Data2) - (1 - sin(x_X))*pi, eps, 'x_IntZ_zx')
    call check1d(x_AvrZ_zx(zx_Data2) - 0.5*(1 - sin(x_X)), eps, 'x_AvrZ_zx')

  zy_Data2 = sin(zyx_Y(:,:,1)) * cos(zyx_Z(:,:,1))
  write(6,*) 'f = sin(Y)*cos(Y)'

    call check0d(IntZY_zy(zy_Data2)-0.0, eps, 'IntZY_zy') 
    call check0d(AvrZY_zy(zy_Data2)-0.0, eps, 'AvrZY_zy')

    call check1d(z_IntY_zy(zy_Data2) - 0.0, eps, 'z_IntY_zy') 
    call check1d(z_AvrY_zy(zy_Data2) - 0.0, eps, 'z_AvrY_zy') 

    call check1d(y_IntZ_zy(zy_Data2) - 0.0, eps, 'y_IntZ_zy')
    call check1d(y_AvrZ_zy(zy_Data2) - 0.0, eps, 'y_AvrZ_zy')

  zy_Data2 = (1 - sin(zyx_Y(:,:,1))) * cos(zyx_Z(:,:,1))**2
  write(6,*)
  write(6,*) 'f = (1-sin(Y)) * cos(Z)**2'

    call check0d(IntZY_zy(zy_Data2) - 2.0*pi**2, eps, 'IntZY_zy') 
    call check0d(AvrZY_zy(zy_Data2) - 0.5, eps, 'AvrZY_zy')

    call check1d(z_IntY_zy(zy_Data2) - 2*cos(z_Z)**2*pi, eps, 'z_IntY_zy') 
    call check1d(z_AvrY_zy(zy_Data2) - cos(z_Z)**2, eps, 'z_AvrY_zy')

    call check1d(y_IntZ_zy(zy_Data2) - (1 - sin(y_Y))*pi, eps, 'y_IntZ_zy')
    call check1d(y_AvrZ_zy(zy_Data2) - 0.5*(1 - sin(y_Y)), eps, 'y_AvrZ_zy')

!-------------------------- 1 次元データ ------------------------------
  !------------------- id1 -----------------------
  write(*,*) 'for id1'
  call eee_ChangeResolution(id1)

  x_Data = 1 - sin(2*x_X)
  write(6,*)
  write(6,*) 'f = 1-sin(2*X)'

    call check0d(IntX_x(x_Data) - 2.0d0*pi, eps, 'IntX_x')
    call check0d(AvrX_x(x_Data) - 1.0d0, eps, 'AvrX_x')

  y_Data = cos(y_Y)**2
  write(6,*)
  write(6,*) 'f = cos(Y)**2'

    call check0d(IntY_y(y_Data) - 1.0*pi, eps, 'IntY_y')
    call check0d(AvrY_y(y_Data) - 0.5, eps, 'AvrY_y')

  z_Data = 1 - sin(2*z_Z)
  write(6,*)
  write(6,*) 'f = 1-sin(2*Z)'

    call check0d(IntZ_z(z_Data) - 2.0d0*pi, eps, 'IntZ_z')
    call check0d(AvrZ_z(z_Data) - 1.0d0, eps, 'AvrZ_z')

  !------------------- id2 -----------------------
  write(*,*) 'for id2'
  call eee_ChangeResolution(id2)

  x_Data2 = 1 - sin(2*x_X)
  write(6,*)
  write(6,*) 'f = 1-sin(2*X)'

    call check0d(IntX_x(x_Data2) - 2.0d0*pi, eps, 'IntX_x')
    call check0d(AvrX_x(x_Data2) - 1.0d0, eps, 'AvrX_x')

  y_Data2 = cos(y_Y)**2
  write(6,*)
  write(6,*) 'f = cos(Y)**2'

    call check0d(IntY_y(y_Data2) - 1.0*pi, eps, 'IntY_y')
    call check0d(AvrY_y(y_Data2) - 0.5, eps, 'AvrY_y')

  z_Data2 = 1 - sin(2*z_Z)
  write(6,*)
  write(6,*) 'f = 1-sin(2*Z)'

    call check0d(IntZ_z(z_Data2) - 2.0d0*pi, eps, 'IntZ_z')
    call check0d(AvrZ_z(z_Data2) - 1.0d0, eps, 'AvrZ_z')

  call MessageNotify('M','eee_test_intavr', &
       'eee_module integral/average function tests succeeded!')

 stop
contains

  subroutine check2d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:)                ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    integer i,j

    if ( present(funcname) )then
       write(6,*) '  Checking ', funcname, '...'
    endif

    do j=1,size(var,2)
       do i=1,size(var,1)
          if (abs(var(i,j)) .gt. eps ) then
             write(6,*) '    Value larger than EPS : i= ', i, var(i,j)
             call MessageNotify('E','eee_test_intavr', &
                  'Integral/average error too large')
          endif
       enddo
    enddo
  end subroutine check2d

  subroutine check1d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:)                  ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    integer i

    if ( present(funcname) )then
       write(6,*) '  Checking ', funcname, '...'
    endif

    do i=1,size(var)
       if (abs(var(i)) .gt. eps ) then
          write(6,*) '    Value larger than EPS : i= ', i, var(i)
          call MessageNotify('E','eee_test_intavr', &
               'Integral/average error too large')
       endif
    enddo
  end subroutine check1d

  subroutine check0d(var,eps,funcname)   ! var の絶対値が eps 以上だと出力
    real(8) :: var                       ! 判定する配列
    real(8) :: eps                       ! 誤差
    real(8) :: vartmp(1)                 ! 
    character(len=*), optional :: funcname

    vartmp(1) = var
    if ( present(funcname) ) then
       call check1d(vartmp,eps,funcname)
    else
       call check1d(vartmp,eps)
    endif
  end subroutine check0d

end program eee_intavr

!--
!----------------------------------------------------------------------
! Copyright (c) 2001-2013 SPMODEL Development Group, All rights reserved.
!----------------------------------------------------------------------
!
!表題  esc_module
!
!      spml/esc_module モジュールは 2 次元チャネル領域での流体運動を
!      スペクトル法により数値計算するための Fortran90 関数を提供する.
!
!      内部で ISPACK/C2PACK の Fortran77 サブルーチンを呼んでいる.
!      スペクトルデータおよび格子点データの格納方法については
!      ISPACK/C2PACK のマニュアルを参照されたい.
!
!履歴  2001/10/07  竹広真一
!      2001/12/26  竹広真一  関数, 変数命名法変更
!      2002/03/25  竹広真一  モジュール名変更
!      2002/08/19  竹広真一  格子データ添字を gg -> xy に変更
!      2002/08/20  竹広真一  積分・平均関数追加
!      2005/03/15  竹広真一  xy -> yx に接頭子を変更
!      2006/03/06  竹広真一  コメントを RDoc 用に修正
!      2006/03/19  竹広真一  変数・手続き群の要約をコメントに追加
!      2007/11/12  竹広真一  ec_LaplaInv_ec 関数追加
!      2007/11/21  竹広真一  初期化サブルーチンメッセージ出力
!      2009/01/09  竹広真一  esc_Initial メッセージに日付を追加
!      2009/01/29  佐々木洋平 コメントを RDoc 用に修正
!      2009/07/30  竹広真一   作業領域をローカル変数に変更(for OpenMP)
!      2013/09/26  佐々木洋平 tj,ti を倍精度に変更
!
!++
module esc_module
  !
  != esc_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/esc_module モジュールは 2 次元チャネル領域での流体運動を
  ! スペクトル法により数値計算するための Fortran90 関数を提供する.
  !
  ! 内部で ISPACK/C2PACK の Fortran77 サブルーチンを呼んでいる.
  ! スペクトルデータおよび格子点データの格納方法については
  ! ISPACK/C2PACK のマニュアルを参照されたい.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (es_, ec_, yx_, x_, y_) は, 返す値の形を示している.
  !   es_,ec_ :: スペクトルデータ(Y 方向 SIN 展開, COS 展開)
  !   yx_     :: 2 次元格子点データ
  !   x_      :: X 方向 1 次元格子点データ
  !   y_      :: Y 方向 1 次元格子点データ
  !
  ! * 関数名の間の文字列(Dx, Dy, Lapla, LaplaInv, Jacobian)は,
  !   その関数の作用を表している.
  !
  ! * 関数名の最後 (_es_es, _es_ec, _es, _ec, _yx, _x, _y) は,
  !   入力変数の形スペクトルデータおよび格子点データであることを示している.
  !   _es    :: スペクトルデータ(Y 方向 SIN 型)
  !   _ec    :: スペクトルデータ(Y 方向 COS 型)
  !   _es_es :: 2 つのスペクトルデータ
  !   _es_ec :: 2 つのスペクトルデータ
  !   _yx    :: 2 次元格子点データ,
  !   _x     :: X 方向 1 次元格子点データ
  !   _y     :: Y 方向 1 次元格子点データ
  !
  !=== 各データの種類の説明
  !
  ! * yx : 2 次元格子点データ.
  !  * 変数の種類と次元は real(8), dimension(0:jm,0:im-1).
  !  * im, jm はそれぞれ X, Y 座標の格子点数であり,
  !    サブルーチン esc_Initial にてあらかじめ設定しておく.
  !  * 第 1 次元が Y 座標の格子点位置番号, 第 2 次元が X 座標の格子点位置番号
  !    である (X, Y の順ではない)ことに注意.
  !
  ! * es : X 方向フーリエ型, Y 方向 SIN 型スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(-km:km,lm).
  !   * km, lm はそれぞれ X, Y 方向の最大波数であり,
  !     サブルーチン esc_Initial にて
  !     あらかじめ設定しておく.
  !   * スペクトルデータの格納のされ方については...
  !
  ! * ec : X 方向フーリエ型, Y 方向 COS 型スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(-km:km,0:lm).
  !   * km, lm はそれぞれ
  !     X, Y 方向の最大波数であり,
  !     サブルーチン esc_Initial にてあらかじめ設定しておく.
  !   * スペクトルデータの格納のされ方については...
  !
  ! * x, y : X, Y 方向 1 次元格子点データ.
  !   * 変数の種類と次元はそれぞれ real(8), dimension(0:im-1)
  !     および real(8), dimension(0:jm).
  !
  ! * es_, ec_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * yx_ で始まる関数が返す値は 2 次元格子点データに同じ.
  !
  ! * x_, y_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! esc_initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  !
  !==== 座標変数
  !
  ! x_X, y_Y     ::  格子点座標(X,Y座標)を格納した 1 次元配列
  ! x_X_Weight, y_Y_Weight ::  重み座標を格納した 1 次元配列
  ! yx_X, yx_Y   :: 格子点データの XY 座標(X,Y)(格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! yx_es, yx_ec :: スペクトルデータから格子データへの変換
  ! es_yx, ec_yx :: 格子データからスペクトルデータへの変換
  !
  !==== 微分
  !
  ! es_Lapla_es, ec_Lapla_ec  :: スペクトルデータにラプラシアンを作用させる
  ! es_LaplaInv_es, ec_LaplaInv_ec :: スペクトルデータに
  !                                   ラプラシアンの逆変換を作用させる
  ! es_Dx_es, ec_Dx_ec  :: スペクトルデータに X 微分を作用させる
  ! ec_Dy_es, es_Dy_ec  :: スペクトルデータに Y 微分を作用させる
  ! es_Jacobian_es_es, ec_Jacobian_es_ec :: 2 つのスペクトルデータから
  !                                         ヤコビアンを計算する
  !
  !==== 積分・平均
  !
  ! IntYX_yx, AvrYX_yx   :: 2 次元格子点データの全領域積分および平均
  ! y_IntX_yx, y_AvrX_yx :: 2 次元格子点データの X 方向積分および平均
  ! IntX_x, AvrX_x       :: 1 次元(X)格子点データの X 方向積分および平均
  ! x_IntY_yx, x_AvrY_yx :: 2 次元格子点データの Y 方向積分および平均
  ! IntY_y, AvrY_y       :: 1 次元(Y)格子点データの Y 方向積分および平均
  !
  !
  use dc_message, only : MessageNotify
  use dc_types, only: DP
  implicit none

  private
  public esc_Initial                                      ! 初期化ルーチン
  public yx_es, yx_ec, es_yx, ec_yx                       ! 基本変換
  public es_Lapla_es, es_LaplaInv_es, es_Dx_es, ec_Dy_es  ! 微分
  public ec_Lapla_ec, ec_LaplaInv_ec, ec_Dx_ec, es_Dy_ec  ! 微分
  public es_Jacobian_es_es, ec_Jacobian_es_ec             ! 非線形計算
  public IntYX_yx, y_IntX_yx, x_IntY_yx, IntX_x, IntY_y   ! 積分
  public AvrYX_yx, y_AvrX_yx, x_AvrY_yx, AvrX_x, AvrY_y   ! 平均
  public x_X, y_Y, x_X_Weight, y_Y_Weight, yx_X, yx_Y     ! 座標変数

  integer   :: im=32, jm=8                                ! 格子点の設定(X,Y)
  integer   :: km=10, lm=5                                ! 切断波数の設定(X,Y)
  real(DP)   :: xl=2.0, yl=1.0                             ! 領域の大きさ

  integer, dimension(5)                  :: itj
  real(DP), dimension(:),allocatable      :: tj
  integer, dimension(5)                  :: iti
  real(DP), dimension(:),allocatable      :: ti

  real(DP), dimension(:), allocatable    :: x_X
  ! 格子点座標(X)を格納した 1 次元配列

  real(DP), dimension(:), allocatable    :: y_Y
  ! 格子点座標(X)を格納した 1 次元配列

  real(DP), dimension(:), allocatable    :: x_X_Weight
  ! 重み座標(X)を格納した 1 次元配列. X 方向の格子点の間隔が格納してある.

  real(DP), dimension(:), allocatable    :: y_Y_Weight
  ! 重み座標(Y)を格納した 1 次元配列. Y 方向の格子点の間隔が格納してある.

  real(DP), dimension(:,:), allocatable  :: yx_X
  ! 各格子点(i,j)の位置の X 座標を格納した格子データ.

  real(DP), dimension(:,:), allocatable  :: yx_Y
  ! 各格子点(i,j)の位置の Y 座標を格納した格子データ.

  real(DP), dimension(:),   allocatable  :: wg, ws, wgj
  real(DP), dimension(:,:), allocatable  :: yx_work,es_work,ec_work
  real(DP), parameter  ::  pi=3.1415926535897932385D0

  save im, jm, km, lm, itj, tj, iti, ti, xl, yl
  save x_X, y_Y, x_X_Weight, y_Y_Weight, yx_X, yx_Y

  contains
  !--------------- 初期化 -----------------
    subroutine esc_Initial(i,j,k,l,xmin,xmax,ymin,ymax)
      !
      ! スペクトル変換の格子点数, 波数, 領域の大きさを設定する.
      !
      ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで
      ! 初期設定をしなければならない.
      !
      integer,intent(in) :: i           !(in) 格子点数(X)
      integer,intent(in) :: j           !(in) 格子点数(Y)
      integer,intent(in) :: k           !(in) 切断波数(X)
      integer,intent(in) :: l           !(in) 切断波数(Y)

      real(DP),intent(in) :: xmin, xmax     !(in) X 座標範囲
      real(DP),intent(in) :: ymin, ymax     !(in) Y 座標範囲

      integer :: ii, jj

      im = i         ; jm = j
      km = k         ; lm = l
      xl = xmax-xmin ; yl = ymax-ymin

      allocate(tj(jm*6),ti(im*2))

      call c2init(jm,im,itj,tj,iti,ti)

      allocate(x_X(0:im-1), x_X_Weight(0:im-1))
      allocate(y_Y(0:jm), y_Y_Weight(0:jm))
      allocate(yx_X(0:jm,0:im-1), yx_Y(0:jm,0:im-1))

      do ii=0,im-1
         x_X(ii) = xmin + xl/im*ii
      enddo
      x_X_Weight = xl/im

      do jj=0,jm
         y_Y(jj) = ymin + yl/jm*jj
      enddo
      y_Y_Weight(0) = yl/(2*jm)
      y_Y_Weight(1:jm-1) = yl/jm
      y_Y_Weight(jm) = yl/(2*jm)

      yx_X = spread(x_X,1,jm+1)
      yx_Y = spread(y_Y,2,im)

      call MessageNotify('M','esc_initial', &
           'esc_module (2009/07/30) is initialized')

    end subroutine esc_Initial

  !--------------- 基本変換 -----------------
    function yx_es(es)
      !
      ! SIN(Y)型スペクトルデータから格子データへ変換する.
      !
      real(DP), dimension(0:jm,0:im-1)              :: yx_es
      !(out) 格子点データ

      real(DP), dimension(-km:km,lm), intent(in)    :: es
      !(in) SIN(Y)型スペクトルデータ

      real(DP)                                      :: wg((jm+1)*im)
      ! 作業領域

      call c2s2ga(lm,km,jm,im,es,yx_es,wg,itj,tj,iti,ti,1)
    end function yx_es

    function yx_ec(ec)
      !
      ! COS(Y)型スペクトルデータから格子データへ変換する.
      !
      real(DP), dimension(0:jm,0:im-1)              :: yx_ec
      !(out) 格子点データ

      real(DP), dimension(-km:km,0:lm), intent(in)  :: ec
      !(in) COS(Y)型スペクトルデータ

      real(DP)                                      :: wg((jm+1)*im)
      ! 作業領域

      call c2s2ga(lm,km,jm,im,ec,yx_ec,wg,itj,tj,iti,ti,2)
    end function yx_ec

    function es_yx(yx)
      !
      ! 格子データから SIN(Y)型スペクトルデータへ変換する.
      !
      real(DP), dimension(-km:km,lm)                :: es_yx
      !(out) SIN(Y)型スペクトルデータ

      real(DP), dimension(0:jm,0:im-1), intent(in)  :: yx
      !(in) 格子点データ

      real(DP)                                      :: wg((jm+1)*im)
      real(DP)                                      :: yx_work(0:jm,0:im-1)
      ! 作業領域

      yx_work = yx
      call c2g2sa(lm,km,jm,im,yx_work,es_yx,wg,itj,tj,iti,ti,1)
    end function es_yx

    function ec_yx(yx)
      !
      ! 格子データから COS(Y)型スペクトルデータへ変換する.
      !
      real(DP), dimension(-km:km,0:lm)              :: ec_yx
      !(in) COS(Y)型スペクトルデータ

      real(DP), dimension(0:jm,0:im-1), intent(in)  :: yx
      !(out) 格子点データ

      real(DP)                                      :: wg((jm+1)*im)
      real(DP)                                      :: yx_work(0:jm,0:im-1)
      ! 作業領域

      yx_work = yx
      call c2g2sa(lm,km,jm,im,yx_work,ec_yx,wg,itj,tj,iti,ti,2)
    end function ec_yx

  !--------------- 微分計算 -----------------
    function es_Lapla_es(es)
      !
      ! SIN(Y)型入力スペクトルデータにラプラシアン(∂xx+∂yy)を作用する.
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに全波数 (k**2 + l**2) をかける
      ! 計算を行っている.
      !
      real(DP), dimension(-km:km,lm)                :: es_Lapla_es
      !(out) スペクトルデータのラプラシアン

      real(DP), dimension(-km:km,lm), intent(in)    :: es
      !(in) SIN(Y)型入力スペクトルデータ

      integer k,l

      do l=1,lm
         do k=-km,km
            es_Lapla_es(k,l) = -((2*pi*k/xl)**2+(pi*l/yl)**2)*es(k,l)
         enddo
      enddo
    end function es_Lapla_es

    function ec_Lapla_ec(ec)
      !
      ! COS(Y)型入力スペクトルデータにラプラシアン(∂xx+∂yy)を作用する.
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに全波数 (k**2 + l**2) をかける
      ! 計算を行っている.
      !
      real(DP), dimension(-km:km,0:lm)                :: ec_Lapla_ec
      !(out) スペクトルデータのラプラシアン

      real(DP), dimension(-km:km,0:lm), intent(in)    :: ec
      !(in) COS(Y)型入力スペクトルデータ

      integer k,l

      do l=0,lm
         do k=-km,km
            ec_Lapla_ec(k,l) = -((2*pi*k/xl)**2+(pi*l/yl)**2)*ec(k,l)
         enddo
      enddo
    end function ec_Lapla_ec

    function es_LaplaInv_es(es)   ! スペクトル SINY に作用する逆 \lapla 演算子
      !
      ! 入力スペクトルデータに逆ラプラシアン(∂xx+∂yy)**(-1)を作用する.
      !
      ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
      ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに全波数 (k**2 + l**2) で割る
      ! 計算を行っている.
      !
      real(DP), dimension(-km:km,lm)                :: es_LaplaInv_es
      !(out) スペクトルデータの逆ラプラシアン

      real(DP), dimension(-km:km,lm), intent(in)    :: es
      !(in) SIN(Y)型スペクトルデータ

      integer k,l

      do l=1,lm
         do k=-km,km
            es_LaplaInv_es(k,l) = -es(k,l)/((2*pi*k/xl)**2+(pi*l/yl)**2)
         enddo
      enddo
    end function es_LaplaInv_es

    function ec_LaplaInv_ec(ec)   ! スペクトル COSY に作用する逆 \lapla 演算子
      !
      ! 入力スペクトルデータに逆ラプラシアン(∂xx+∂yy)**(-1)を作用する.
      !
      ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
      ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに全波数 (k**2 + l**2) で割る
      ! 計算を行っている.
      !
      real(DP), dimension(-km:km,0:lm)              :: ec_LaplaInv_ec
      !(out) スペクトルデータの逆ラプラシアン

      real(DP), dimension(-km:km,0:lm), intent(in)  :: ec
      !(in) SIN(Y)型スペクトルデータ

      integer k,l

      if ( abs(ec(0,0)) >= epsilon(0.0D0) ) then
           call MessageNotify('W','ec_LaplaInv_ec', &
                              '0-0 component of input data is not zero.')
           call MessageNotify('W','ec_LaplaInv_ec', &
                              '0-0 component of output set to zero.')
      endif

      do l=1,lm
         do k=-km,km
            ec_LaplaInv_ec(k,l) = -ec(k,l)/((2*pi*k/xl)**2+(pi*l/yl)**2)
         enddo
      enddo

      do k=1,km
         ec_LaplaInv_ec(k,0)  = -ec(k,0)/(2*pi*k/xl)**2
         ec_LaplaInv_ec(-k,0) = -ec(-k,0)/(2*pi*k/xl)**2
      enddo

      ec_LaplaInv_ec(0,0) = 0.0

    end function ec_LaplaInv_ec

    function es_Dx_es(es)
      !
      ! SIN(Y)型入力スペクトルデータに X 微分(∂x)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 k をかけて
      ! sin(kx) <-> cos(kx) 成分に入れ換える計算を行っている.
      !
      real(DP), dimension(-km:km,lm)                :: es_Dx_es
      !(out) スペクトルデータの X 微分

      real(DP), dimension(-km:km,lm), intent(in)    :: es
      !(in) SIN(Y)型入力スペクトルデータ

      integer k,l

      do l=1,lm
         do k=-km,km
            es_Dx_es(k,l)  =  (-2*pi*k/xl)*es(-k,l)
         enddo
      enddo
    end function es_Dx_es

    function ec_Dx_ec(ec)
      !
      ! COS(Y)型入力スペクトルデータに X 微分(∂x)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 k をかけて
      ! sin(kx) <-> cos(kx) 成分に入れ換える計算を行っている.
      !
      real(DP), dimension(-km:km,0:lm)                :: ec_Dx_ec
      !(out) スペクトルデータの X 微分

      real(DP), dimension(-km:km,0:lm), intent(in)    :: ec
      !(in) COS(Y)型入力スペクトルデータ

      integer k,l

      do l=0,lm
         do k=-km,km
            ec_Dx_ec(k,l)  =  (-2*pi*k/xl)*ec(-k,l)
         enddo
      enddo
    end function ec_Dx_ec

    function ec_Dy_es(es)   ! スペクトル SINY に作用する y 微分演算子
      !
      ! SIN(Y)型入力スペクトルデータに Y 微分(∂y)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに Y 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 l をかけている.
      !
      real(DP), dimension(-km:km,0:lm)              :: ec_Dy_es
      !(out) スペクトルデータの Y 微分, COS(Y)型.

      real(DP), dimension(-km:km,lm), intent(in)    :: es
      !(in) SIN(Y)型入力スペクトルデータ

      integer k,l

      do k=-km,km
         ec_Dy_es(k,0)  =  0.0
      enddo
      do l=1,lm
         do k=-km,km
            ec_Dy_es(k,l)  =  (pi*l/yl)*es(k,l)
         enddo
      enddo
    end function ec_Dy_es

    function es_Dy_ec(ec)   ! スペクトル COSY に作用する y 微分演算子
      !
      ! COS(Y)型入力スペクトルデータに Y 微分(∂y)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに Y 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 l をかけている.
      !
      real(DP), dimension(-km:km,lm)                 :: es_Dy_ec
      !(out) スペクトルデータの Y 微分, SIN(Y)型.

      real(DP), dimension(-km:km,0:lm), intent(in)   :: ec
      !(in) COS(Y)型入力スペクトルデータ

      integer k,l

      do l=1,lm
         do k=-km,km
            es_Dy_ec(k,l)  =  -(pi*l/yl)*ec(k,l)
         enddo
      enddo
    end function es_Dy_ec

 !------------------- 非線形項計算 ----------------------
    function es_Jacobian_es_es(es_a,es_b) !スペクトル SINY に作用するヤコビアン
      !
      !  2 つのスペクトルデータからヤコビアン
      !
      !     J(A,B)=(∂xA)(∂yB)-(∂yA)(∂xB)
      !
      !  を計算する.
      !
      !  2 つのスペクトルデータのヤコビアンとは, 対応する 2 つの
      !  格子点データのヤコビアンのスペクトル変換のことである.
      !
      real(DP), dimension(-km:km,lm)                :: es_Jacobian_es_es
      !(out) 2 つのスペクトルデータのヤコビアン

      real(DP), dimension(-km:km,lm), intent(in)    :: es_A,es_B
      !(in) 2つの SIN(Y)型入力スペクトルデータ

      real(DP)                                      :: ws((2*km+1)*(lm+1))
      real(DP)                                      :: wgj((jm+1)*im*3)
      real(DP)                                      :: es_work(-km:km,lm)
      ! 作業領域

      integer k,l

      call c2ajcb(lm,km,jm,im,es_A,es_B,es_work,ws,wgj,itj,tj,iti,ti)

      do l=1,lm
         do k=-km,km
            es_Jacobian_es_es(k,l) = (2*pi/xl)*(pi/yl)*es_work(k,l)
         enddo
      enddo
    end function es_Jacobian_es_es

    function ec_Jacobian_es_ec(es,ec)  ! スペクトル COS(Y) に作用するヤコビアン
      !
      !  2 つのスペクトルデータからヤコビアン
      !
      !     J(A,B)=(∂xA)(∂yB)-(∂yA)(∂xB)
      !
      !  を計算する.
      !
      !  2 つのスペクトルデータのヤコビアンとは, 対応する 2 つの
      !  格子点データのヤコビアンのスペクトル変換のことである.
      !
      real(DP), dimension(-km:km,0:lm)              :: ec_Jacobian_es_ec
      !(out) 2 つのスペクトルデータのヤコビアン

      real(DP), dimension(-km:km,lm), intent(in)    :: es
      !(in) 1つ目の SIN(Y)型入力スペクトルデータ

      real(DP), dimension(-km:km,0:lm), intent(in)  :: ec
      !(in) 2つ目の COS(Y)型入力スペクトルデータ

      real(DP)                                      :: ws((2*km+1)*(lm+1))
      real(DP)                                      :: wgj((jm+1)*im*3)
      real(DP)                                      :: ec_work(-km:km,0:lm)
      ! 作業領域

      integer k,l

      call c2ajcc(lm,km,jm,im,es,ec,ec_work,ws,wgj,itj,tj,iti,ti)

      do l=0,lm
         do k=-km,km
            ec_Jacobian_es_ec(k,l) = (2*pi/xl)*(pi/yl)*ec_work(k,l)
         enddo
      enddo
    end function ec_Jacobian_es_ec

  !--------------- 積分計算 -----------------
    function IntYX_yx(yx)
      !
      ! 2 次元格子点データの全領域積分および平均.
      !
      real(DP), dimension(0:jm,0:im-1)   :: yx
      !(in) 2 次元格子点データ

      real(DP)                           :: IntYX_yx
      !(out) 積分値

      integer :: i, j

      IntYX_yx = 0.0d0
      do i=0,im-1
         do j=0,jm
            IntYX_yx = IntYX_yx + yx(j,i) * y_Y_Weight(j) * x_X_Weight(i)
         enddo
      enddo
    end function IntYX_yx

    function y_IntX_yx(yx)  ! X 方向積分
      !
      ! 1 次元(X)格子点データの X 方向積分
      !
      real(DP), dimension(0:jm,0:im-1)   :: yx
      !(in) 2 次元格子点データ

      real(DP), dimension(0:jm)          :: y_IntX_yx
      !(out) X 方向に積分された 1 次元(Y)格子点データ

      integer :: i

      y_IntX_yx = 0.0d0
      do i=0,im-1
         y_IntX_yx(:) = y_IntX_yx(:) + yx(:,i) * x_X_Weight(i)
      enddo
    end function y_IntX_yx

    function x_IntY_yx(yx)
      !
      ! 2 次元格子点データの Y 方向積分
      !
      real(DP), dimension(0:jm,0:im-1)   :: yx
      !(in) 2 次元格子点データ

      real(DP), dimension(0:im-1)        :: x_IntY_yx
      !(out) Y 方向に積分された 1 次元(X)格子点データ

      integer :: j

      x_IntY_yx = 0.0d0
      do j=0,jm
         x_IntY_yx(:) = x_IntY_yx(:) + yx(j,:) * y_Y_Weight(j)
      enddo
    end function x_IntY_yx

    function IntX_x(x)      ! X 方向積分
      !
      ! 1 次元(X)格子点データの X 方向積分
      !
      real(DP), dimension(0:im-1)   :: x
      !(in) 1 次元(X)格子点データ

      real(DP)                      :: IntX_x
      !(out) 積分値

      IntX_x = sum(x*x_X_Weight)
    end function IntX_x

    function IntY_y(y)      ! Y 方向積分
      !
      ! 1 次元(Y)格子点データの Y 方向積分
      !
      real(DP), dimension(0:jm)   :: y
      !(in) 1 次元(Y)格子点データ

      real(DP)                    :: IntY_y
      !(out) 積分値

      IntY_y = sum(y*y_Y_Weight)
    end function IntY_y

  !--------------- 平均計算 -----------------
    function AvrYX_yx(yx)    ! 全領域平均
      !
      ! 2 次元格子点データの全領域平均
      !
      real(DP), dimension(0:jm,0:im-1)   :: yx
      !(in) 2 次元格子点データ

      real(DP)                           :: AvrYX_yx
      !(out) 平均値

      AvrYX_yx = IntYX_yx(yx)/(sum(x_X_weight)*sum(y_Y_weight))
    end function AvrYX_yx

    function y_AvrX_yx(yx)   ! X 方向平均
      !
      ! 1 次元(X)格子点データの X 方向平均
      !
      real(DP), dimension(0:jm,0:im-1)   :: yx
      !(in) 2 次元格子点データ

      real(DP), dimension(0:jm)          :: y_AvrX_yx
      !(out) X 方向に平均された 1 次元(Y)格子点データ

      y_AvrX_yx = y_IntX_yx(yx)/sum(x_X_weight)
    end function y_AvrX_yx

    function x_AvrY_yx(yx)   ! Y 方向平均
      !
      ! 2 次元格子点データの Y 方向平均
      !
      real(DP), dimension(0:jm,0:im-1)   :: yx
      !(in) 2 次元格子点データ

      real(DP), dimension(0:im-1)        :: x_AvrY_yx
      !(out) Y 方向に平均された 1 次元(X)格子点データ

      x_AvrY_yx = x_IntY_yx(yx)/sum(y_Y_weight)
    end function x_AvrY_yx

    function AvrX_x(x)       ! X 方向平均
      !
      ! 1 次元(X)格子点データの X 方向平均
      !
      real(DP), dimension(0:im-1)   :: x
      !(in) 1 次元(X)格子点データ

      real(DP)                      :: AvrX_x
      !(out) 平均値

      AvrX_x = IntX_x(x)/sum(x_X_weight)
    end function AvrX_x

    function AvrY_y(y)       ! Y 方向平均
      !
      ! 1 次元(Y)格子点データの Y 方向平均
      !
      real(DP), dimension(0:jm)   :: y
      !(in) 1 次元(Y)格子点データ

      real(DP)                    :: AvrY_y
      ! 平均値

      AvrY_y = IntY_y(y)/sum(y_Y_weight)
    end function AvrY_y

  end module esc_module

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wsc_mpi_module_supack テストプログラム
!
!      トロイダルポロイダル関係微分関数のテスト
!  
!履歴  2017/05/31  竹広真一   wt_module_nmomp_test_derivavit2.f90 より改造
!
program wsc_mpi_module_supack_derivative2_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wsc_mpi_module_supack
  use mpi
  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  real(8), allocatable :: wc_Psi(:,:)
  real(8), allocatable :: ws_Phi(:,:)

  real(8), allocatable :: xvz_DData(:,:,:)
  real(8), allocatable :: xvz_Psi(:,:,:)

  real(8), allocatable :: xvz_VLon(:,:,:)
  real(8), allocatable :: xvz_VLat(:,:,:)
  real(8), allocatable :: xvz_VRad(:,:,:)
  real(8), allocatable :: xvz_RadRot(:,:,:)
  real(8), allocatable :: xvz_RadRotRot(:,:,:)

  real(8), allocatable :: xvz_Xi(:,:,:)  

  integer, parameter :: n=2

  integer :: iproc, np, ierr

  real(8), parameter  :: pi=3.1415926535897932385D0

  !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wsc_mpi_module_supack_derivative2_test', &
       'wsc_mpi_module_supack derivative function test #2')

  call wsc_mpi_initial(im,jm,km,nm,lm,ri,ro)

  allocate(wc_Psi(nc,0:lm))
  allocate(ws_Phi(nc,lm))

  allocate(xvz_DData(0:im-1,1:jc,0:km))
  allocate(xvz_Psi(0:im-1,1:jc,0:km))

  allocate(xvz_VLon(0:im-1,1:jc,0:km))
  allocate(xvz_VLat(0:im-1,1:jc,0:km))
  allocate(xvz_VRad(0:im-1,1:jc,0:km))
  allocate(xvz_RadRot(0:im-1,1:jc,0:km))
  allocate(xvz_RadRotRot(0:im-1,1:jc,0:km))
  allocate(xvz_Xi(0:im-1,1:jc,0:km))

  xvz_xi = (xvz_Rad - ri)/(ro-ri)

  !========== wc_KxRGrad_wc, ws_KxRGrad_ws ==========

  ! ----------------- 例 1 --------------------
  xvz_Psi = sin(Pi*xvz_xi) * cos(xvz_lat)*sin(xvz_lon)   ! Y_1^-1 sin(z)

  xvz_DData = sin(Pi*xvz_xi) *  cos(xvz_lat)*cos(xvz_lon)
  call AssertEqual(&
       message='ws_KxRGrad_ws with Y_1^-1 sin(z)',                   &
       answer = xvz_DData,                                           &
       check = xvz_ws(ws_KxRGrad_ws(ws_xvz(xvz_Psi))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ----------------- 例 2 --------------------
  xvz_Psi = cos(xvz_lat)*sin(xvz_lat) * sin(xvz_lon) * cos(PI*xvz_xi)  ! Y_2^1 cos(z)

  xvz_DData = cos(xvz_lat)*sin(xvz_lat) * cos(xvz_lon) * cos(PI*xvz_xi) ! Y_2^1
  call AssertEqual(&
       message='wc_KxRGrad_wc with Y_2^1 cos(z)',                    &
       answer = xvz_DData,                                           &
       check = xvz_wc(wc_KxRGrad_wc(wc_xvz(xvz_Psi))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  !========== wsc_Potential2VectorMPI, wsc_Potential2RotationMPI, wc_RadRot, ws_RadRotRot ==========

  !----------------- 剛体回転場 --------------------
  ! 
  wc_Psi = wc_xvz(sin(xvz_Lat))
  ws_Phi = 0.0D0

  call wsc_Potential2VectorMPI(&
       xvz_VLon,xvz_VLat,xvz_VRad, wc_Psi, ws_Phi )

  xvz_DData = cos(xvz_Lat)
  call AssertEqual(&
      message='wsc_Potential2VectorMPI (Lon) with rigid rotation field(E-W)', &
       answer = xvz_VLon,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_DData = 0.0D0
  call AssertEqual(&
      message='wsc_Potential2VectorMPI (Lat) with rigid rotation field(E-W)', &
       answer = xvz_VLat,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_DData = 0.0D0
  call AssertEqual(&
      message='wsc_Potential2VectorMPI (Rad) with rigid rotation field(E-W)', &
       answer = xvz_VRad,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvz_RadRot = xvz_wc(wc_L2_wc(wc_Psi))
  call AssertEqual(&
       message='wc_RadRot_xvz_xvz with with rigid rotation field(E-W)', &
       answer = xvz_RadRot,                                          &
       check = xvz_wc(wc_RadRot_xvz_xvz(xvz_VLon,xvz_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvz_RadRotRot = 0.0D0
  call AssertEqual(&
       message='ws_RadRotRot_xvz_xvz with rigid rotation field(E-W)', &
       answer = xvz_RadRotRot,                                       &
       check = xvz_ws(ws_RadRotRot_xvz_xvz_xvz(xvz_VLon,xvz_VLat,xvz_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call wsc_Potential2RotationMPI(&
       xvz_VLon,xvz_VLat,xvz_VRad, wc_Psi, ws_Phi )

  xvz_DData = 0.0D0
  call AssertEqual(&
      message='wsc_Potential2RotationMPI (Lon) with rigid rotation field(E-W)', &
       answer = xvz_VLon,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_DData = 0.0D0
  call AssertEqual(&
      message='wsc_Potential2RotationMPI (Lat) with rigid rotation field(E-W)', &
       answer = xvz_VLat,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_DData = xvz_RadRot/Ro
  call AssertEqual(&
      message='wsc_Potential2RotationMPI (Rad) with rigid rotation field(E-W)', &
       answer = xvz_VRad,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !----------------- 剛体回転場(南北流) --------------------
  ! 
  wc_Psi = wc_xvz(cos(xvz_Lat) * sin(xvz_Lon))
  ws_Phi = 0.0D0

  call wsc_Potential2VectorMPI(&
       xvz_VLon,xvz_VLat,xvz_VRad, wc_Psi, ws_Phi )

  xvz_DData = -sin(xvz_Lat)*sin(xvz_Lon)
  call AssertEqual(&
      message='wsc_Potential2VectorMPI (Lon) with rigid rotation field(N-S)', &
       answer = xvz_VLon,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_DData = -cos(xvz_Lon)
  call AssertEqual(&
      message='wsc_Potential2VectorMPI (Lat) with rigid rotation field(N-S)', &
       answer = xvz_VLat,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_DData = 0.0D0
  call AssertEqual(&
      message='wsc_Potential2VectorMPI (Rad) with rigid rotation field(N-S)', &
       answer = xvz_VRad,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvz_RadRot = xvz_wc(wc_L2_wc(wc_Psi))
  call AssertEqual(&
       message='wc_RadRot_xvz_xvz with with rigid rotation field(N-S)', &
       answer = xvz_RadRot,                                          &
       check = xvz_wc(wc_RadRot_xvz_xvz(xvz_VLon,xvz_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvz_RadRotRot = 0.0D0
  call AssertEqual(&
       message='ws_RadRotRot_xvz_xvz with rigid rotation field(N-S)', &
       answer = xvz_RadRotRot,                                       &
       check = xvz_ws(ws_RadRotRot_xvz_xvz_xvz(xvz_VLon,xvz_VLat,xvz_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call wsc_Potential2RotationMPI(&
       xvz_VLon,xvz_VLat,xvz_VRad, wc_Psi, ws_Phi )

  xvz_DData = 0.0D0
  call AssertEqual(&
      message='wsc_Potential2RotationMPI (Lon) with rigid rotation field(N-S)', &
       answer = xvz_VLon,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_DData = 0.0D0
  call AssertEqual(&
      message='wsc_Potential2RotationMPI (Lat) with rigid rotation field(N-S)', &
       answer = xvz_VLat,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_DData = xvz_RadRot/Ro
  call AssertEqual(&
      message='wsc_Potential2RotationMPI (Rad) with rigid rotation field(N-S)', &
       answer = xvz_VRad,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ----------------- 渦無し場 --------------------
  wc_Psi = 0.0D0
  ws_Phi = ws_xvz(sin(PI*xvz_xi) * sin(xvz_Lat))

  call wsc_Potential2VectorMPI(&
       xvz_VLon,xvz_VLat,xvz_VRad, wc_Psi, ws_Phi )

  xvz_DData = 0
  call AssertEqual(&
       message='wsc_Potential2VectorMPI (Lon) with non-vortical field', &
       answer = xvz_VLon,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_DData = PI * cos(xvz_Lat) * cos(PI*xvz_xi) 
  call AssertEqual(&
       message='wsc_Potential2VectorMPI (Lat) with non-vortical field', &
       answer = xvz_VLat,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_DData = 2 * sin(xvz_Lat) * sin(PI*xvz_xi)/Ro
  call AssertEqual(&
      message='wsc_Potential2VectorMPI (Rad) with non-vortical field',  &
       answer = xvz_VRad,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvz_RadRot = 0.0D0
  call AssertEqual(&
       message='wc_RadRot_xvz_xvz with non-vortical field',          &
       answer = xvz_RadRot,                                          &
       check = xvz_wc(wc_RadRot_xvz_xvz(xvz_VLon,xvz_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvz_RadRotRot = - xvz_ws(ws_L2_ws(ws_Lapla_ws((ws_Phi))))
  call AssertEqual(&
       message='ws_RadRotRot_xvz_xvz with non-vortical field',       &
       answer = xvz_RadRotRot,                                       &
       check = xvz_ws(ws_RadRotRot_xvz_xvz_xvz(xvz_VLon,xvz_VLat,xvz_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call wsc_Potential2RotationMPI(&
       xvz_VLon,xvz_VLat,xvz_VRad, wc_Psi, ws_Phi )

  xvz_DData = (2/Ro**2 + PI**2) * cos(xvz_Lat) * sin(PI*xvz_xi)
  call AssertEqual(&
      message='wsc_Potential2RotationMPI (Lon) with non-vortical field', &
       answer = xvz_VLon,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_DData = 0.0D0
  call AssertEqual(&
      message='wsc_Potential2RotationMPI (Lat) with non-vortical field', &
       answer = xvz_VLat,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_DData = xvz_RadRot/Ro
  call AssertEqual(&
      message='wsc_Potential2RotationMPI (Rad) with non-vortical field', &
       answer = xvz_VRad,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ----------------- 例 4 --------------------
  ! ポロイダル速度場

  wc_Psi = 0.0D0
  ws_Phi = ws_xvz(sin(2*PI*xvz_xi) * cos(xvz_Lat)*sin(xvz_Lon))

  call wsc_Potential2VectorMPI(&
       xvz_VLon,xvz_VLat,xvz_VRad, wc_Psi, ws_Phi )

  xvz_DData = 2*PI * cos(2*PI*xvz_xi) * cos(xvz_Lon)
  call AssertEqual(&
      message='wsc_Potential2VectorMPI (Lon) with poloidal field',   &
       answer = xvz_VLon,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_DData = - 2*PI* cos(2*PI*xvz_xi) * sin(xvz_Lat)*sin(xvz_Lon)
  call AssertEqual(&
      message='wsc_Potential2VectorMPI (Lat) with poloidal field', &
       answer = xvz_VLat,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_DData = 2*sin(2*PI*xvz_xi) * cos(xvz_Lat)*sin(xvz_Lon)/Ro
  call AssertEqual(&
      message='wsc_Potential2VectorMPI (Rad) with poloidal field', &
       answer = xvz_VRad,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvz_RadRot = 0.0D0
  call AssertEqual(&
       message='wc_RadRot_xvz_xvz with with poloidal field',         &
       answer = xvz_RadRot,                                          &
       check = xvz_wc(wc_RadRot_xvz_xvz(xvz_VLon,xvz_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvz_RadRotRot = - xvz_ws(ws_L2_ws(ws_Lapla_ws((ws_Phi))))
  call AssertEqual(&
       message='ws_RadRotRot_xvz_xvz with with poloidal field',      &
       answer = xvz_RadRotRot,                                       &
       check = xvz_ws(ws_RadRotRot_xvz_xvz_xvz(xvz_VLon,xvz_VLat,xvz_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call wsc_Potential2RotationMPI(&
       xvz_VLon,xvz_VLat,xvz_VRad, wc_Psi, ws_Phi )

  xvz_DData = -(2/Ro**2 + 4*PI**2)*sin(2*PI*xvz_xi)*sin(xvz_Lat)*sin(xvz_Lon)
  call AssertEqual(&
      message='wsc_Potential2RotationMPI (Lon) with poloidal field',    &
       answer = xvz_VLon,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_DData = -(2/Ro**2+4*PI**2) * sin(2*PI*xvz_xi) * cos(xvz_Lon)
  call AssertEqual(&
      message='wsc_Potential2RotationMPI (Lat) with poloidal field', &
       answer = xvz_VLat,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xvz_DData = xvz_RadRot/Ro
  call AssertEqual(&
      message='wsc_Potential2RotationMPI (Rad) with poloidal field',    &
       answer = xvz_VRad,                                            &
       check = xvz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','wsc_mpi_module_supack_derivative_test2', &
       'wsc_mpi_module_supack derivative function test #2 succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wsc_mpi_module_supack_derivative2_test

!----------------------------------------------------------------------
!     Copyright (c) 2010--2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_zonal_module テストプログラム :: 補間関数のテスト
!
!履歴  2010/04/18  竹広真一   wt_module_sjpack_interpolate_test.f90 より改造
!      2012/08/26  竹広真一   wt_module_interpolate_test.f90 より改造
!      2013/08/20  竹広真一   スペクトル配列の大きさ修正
!
program wt_zonal_module_interpolate

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wt_zonal_module
  implicit none

  integer, parameter :: im=128, jm=64, km=16, nm=42, lm=16
  real(8), parameter :: ri = 0.5, ro= 1.5

  real(8), dimension(nm+1,0:lm)            ::  wt_data
  real(8), dimension(0:im-1,1:jm,0:km)     ::  xyz_data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: Alon
  real(8) :: Alat
  real(8) :: Arad
  real(8) :: data_sol
  real(8) :: pi

  pi = atan(1.0D0)*4.0D0

  Alon = pi/3
  Alat = pi/3
  Arad = 0.75
!!$  Alon =pi/4
!!$  Alat =pi/5
!!$  Arad =0.99
!!$  Alon = 3*pi/5
!!$  Alat = -pi/7
!!$  Arad = 1.333 

  call wt_Initial( im, jm, km, nm, lm, ri, ro )

  call MessageNotify('M','wt_zonal_module_interpolate_test', &
                         'wt_zonal_module interpolate tests') 


  !---- Interpolaate_array000_wt のテスト ----
  xyz_data = sqrt(3.0D0/2)*sin(xyz_Lat) & ! Y_1^0
            * (xyz_Rad-ri) *  (xyz_Rad-ro)
  data_sol = sqrt(3.0D0/2)*sin(ALat)* (ARad-ri) *  (ARad-ro)

  wt_data = wt_xyz(xyz_data)

  call AssertEqual(&
       message='Interpolate_wt Y_1^0' ,                              &
       answer = data_sol,                                            &
       check = Interpolate_wt(wt_data,alon,alat,arad),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','wt_zonal_module_interpolate_test',&
                         'wt_zonal_module interpolate function test succeeded!') 

end program wt_zonal_module_interpolate

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ut_mpi_module_supack テストプログラム
!
!      微分のテスト
!  
!履歴  2016/08/04  竹広真一   wt_module_supack_test_derivavit1.f90 より改造
!
program ut_mpi_module_svpack_derivative1_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ut_mpi_module_svpack
  use mpi
  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), allocatable              :: xyh_Data(:,:,:)
  real(8), allocatable              :: xyh_DData(:,:,:)
                                                      
  real(8), allocatable              :: xyh_VLon(:,:,:)
  real(8), allocatable              :: xyh_VLat(:,:,:)
  real(8), allocatable              :: xyh_VRad(:,:,:)
  real(8), allocatable              :: xyh_Div(:,:,:)
  real(8), allocatable              :: xyh_Psi(:,:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer, parameter :: nmin=1, nmax=9

  integer :: n

  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','ut_mpi_module_svpack_derivative_test1', &
       'ut_mpi_module_svpack derivative function test #1')

  call ut_mpi_Initial(im,jm,km,nm,lm,ri,ro)

  allocate(xyh_Data(0:im-1,1:jm,kc))
  allocate(xyh_DData(0:im-1,1:jm,kc))

  allocate(xyh_VLon(0:im-1,1:jm,kc))
  allocate(xyh_VLat(0:im-1,1:jm,kc))
  allocate(xyh_VRad(0:im-1,1:jm,kc))
  allocate(xyh_Div(0:im-1,1:jm,kc))
  allocate(xyh_Psi(0:im-1,1:jm,kc))

  !==================== ut_DivRad_ut ====================
  do n=nmin,nmax
     write(6,*) 'n=',n

     xyh_Data = xyh_Rad**n
     xyh_DData = (n+2)*xyh_Rad**(n-1)

     call AssertEqual(&
       message='ut_Divrat_ut with r^n',                              &
       answer = xyh_DData,                                           &
       check = xyh_ut(ut_DivRad_ut(ut_xyh(xyh_Data))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  enddo

  !========== xyh_GradLon_ut, xyh_GradLat_ut, ut_Div_xyh_xyh_xyh ==========

  ! ------ r^2 Y_1^1 Toridal field -----
  n = 2
  write(6,*) 'n=',n
  xyh_Psi = xyh_Rad**n * cos(xyh_Lat)*sin(xyh_Lon)   ! r^2 Y_1^1
  xyh_VRad = 0

  xyh_VLon =  xyh_Rad**(n-1)*cos(xyh_Lon)
  call AssertEqual(&
       message='xyh_GradLon_ut with r^2 Y_1^-1',                     &
       answer = xyh_VLon,                                            &
       check = xyh_GradLon_ut(ut_xyh(xyh_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyh_VLat = -xyh_Rad**(n-1)*sin(xyh_Lat)*sin(xyh_Lon)
  call AssertEqual(&
       message='xyh_GradLat_ut with r^2 Y_1^-1',                     &
       answer = xyh_VLat,                                            &
       check = xyh_GradLat_ut(ut_xyh(xyh_Psi)),                     &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyh_Div = - 2 * xyh_Psi/xyh_Rad**2
  call AssertEqual(&
       message='ut_Div_xyh_xyh_xyh_ut with Toroiral r^2 Y_1^-1',     &
       answer = xyh_Div,                                             &
       check = xyh_ut(ut_Div_xyh_xyh_xyh(xyh_VLon,xyh_VLat,xyh_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ------ r^2Y_2^-1 Toridal field -----
  n = 2
  xyh_VRad = 0
  xyh_Psi = xyh_Rad**n * cos(xyh_Lat)*sin(xyh_Lat) * sin(xyh_Lon) ! r^2Y_2^-1

  xyh_VLon =  xyh_Rad**(n-1)*sin(xyh_Lat)*cos(xyh_Lon)
  call AssertEqual(&
       message='xyh_GradLon_ut with r^2 Y_2^-1',                     &
       answer = xyh_VLon,                                            &
       check =  xyh_GradLon_ut(ut_xyh(xyh_Psi)),                     &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyh_VLat = xyh_Rad**(n-1)*cos(2*xyh_Lat)*sin(xyh_Lon)
  call AssertEqual(&
       message='xyh_GradLat_ut with r^2 Y_2^-1',                     &
       answer = xyh_VLat,                                            &
       check = xyh_GradLat_ut(ut_xyh(xyh_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyh_Div = - 6* xyh_Psi/xyh_Rad**2
  call AssertEqual(&
       message='ut_Div_xyh_xyh_xyh_ut with Toroiral r2 Y_1^-1',      &
       answer = xyh_Div,                                             &
       check = xyh_ut(ut_Div_xyh_xyh_xyh(xyh_VLon,xyh_VLat,xyh_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !==================== ut_DivLon_xyz, ut_DivLat_xyz ====================
  n=2
  write(6,*)'n =',n

  xyh_VLon  = xyh_rad**n * cos(xyh_Lat)**2*sin(xyh_Lon)
  xyh_DData = xyh_rad**(n-1)*cos(xyh_Lat)*cos(xyh_Lon)
  call AssertEqual(&
       message='ut_DivLon_xyh with r^n cos^2 φ sinλ',              &
       answer = xyh_DData,                                           &
       check = xyh_ut(ut_DivLon_xyh(xyh_VLon)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyh_VLat   = xyh_rad**n * cos(xyh_Lat)**2*sin(xyh_Lon)
  xyh_DData = -3*xyh_rad**(n-1)*cos(xyh_Lat)*sin(xyh_Lat)*sin(xyh_Lon)
  call AssertEqual(&
       message='ut_DivLat_xyh with r^n cos^2 φ sinλ',              &
       answer = xyh_DData,                                           &
       check = xyh_ut(ut_DivLat_xyh(xyh_VLat)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','ut_mpi_module_supack_derivative1_test', &
       'ut_mpi_module_supack derivative function test #1 succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ut_mpi_module_svpack_derivative1_test

!----------------------------------------------------------------------
!     Copyright (c) 2007 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  eq_module テストプログラム
!      境界値問題
!
!履歴  2008/04/12  竹広真一  
!      
!
program eq_test_boundary

  use dc_message, only : MessageNotify
  use eq_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=16              ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=21              ! 切断波数の設定(X,Y)

 !---- 座標変数など ----
  real(8), parameter :: ra=2.0

  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: eps = 1.0d-10            ! 判定誤差

  real(8)            :: rp_A(jm,0:im-1)          ! 格子データ
  real(8)            :: rp_dAdr(jm,0:im-1)       ! 格子データ
  real(8)            :: eq_A(-km:km,0:lm)        ! スペクトルデータ

  real(8), dimension(-km:km)  :: e_value
  real(8), dimension(0:im-1)  :: p_value

  integer            :: k=2

  call MessageNotify('M','eq_test_boudaries', &
       'eq_module subroutine for boundary value problem tests')

 !---------------- 座標値の設定 ---------------------
  call eq_Initial(im,jm,km,lm,ra)                ! スペクトル初期化

!----- eq_Boundary (D) ------
  rp_A = sin(k*rp_Phi)*sin(pi*rp_Rad/ra)
  eq_A = eq_rp(rp_a)
  e_value = 0.0 ; e_value(k) = 1.0
  p_value = p_e(e_value)

  call eq_Boundary(eq_A,value=e_value,cond='D')
  rp_A = rp_eq(eq_A)

  if ( maxval(abs(rp_A(jm,:)-p_value)) > eps )then
     call MessageNotify('E','Test of eq_Boundaries', &
          'B.C. adoption error too large.')
  endif

  call MessageNotify('M','Test of eq_Boundary','Test of D b.c. suceeded!')
 

!----- eq_Boundary (N) ------
  rp_A = sin(k*rp_Phi)*sin(pi*rp_Rad/ra)
  eq_A = eq_rp(rp_a)
  p_value = p_e(e_value)

  call eq_Boundary(eq_A,e_value,cond='N')
  rp_A = rp_eq(eq_A)
  rp_dAdr = rp_eq(eq_RadDRad_eq(eq_A))/rp_Rad

  if ( maxval(abs(rp_dAdr(jm,:)-p_value)) > eps )then
     call MessageNotify('E','Test of eq_Boundary', &
          'B.C. adoption error too large.')
  endif
  call MessageNotify('M','Test of eq_Boundary','Test of N b.c. suceeded!')

  call MessageNotify('M','eq_test_boudary', &
       'eq_module subroutine for boundary value problem tests succeeded!')

end program eq_test_boundary

! -*- mode:f90; coding: utf-8 -*-
!--
!------------------------------------------------------------------------
! Copyright (c) 2001-2016 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!++
module ae_module
  !
  != ae_module
  !
  ! Copyright :: 2001-2013 Shin-ichi Takehiro, Youhei SASAKI,
  !              SPMODEL Development Group
  ! License :: MIT/X11. Please see COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/ae_module モジュールは 1 次元周期境界条件の下での流体運動を実
  ! フーリエ変換によるスペクトル法で数値計算するための Fortran90 関数
  ! を提供する.
  !
  ! 2 次元データの 1 次元に関して同時にスペクトル計算を実行するための
  ! 関数も提供しており, 2, 3 次元領域での計算のベースも提供する.
  !
  ! このモジュールは内部で ISPACK/FTPACK の Fortran77 サブルーチンを呼
  ! んでいる. スペクトルデータの格納方法については ISPACK/FTPACK と異なっ
  ! ているので以下のコメントに注意されたい.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (e_, g_, ae_, ag_) は, 返す値の形を示している.
  !   e_  :: スペクトルデータ,
  !   g_  :: 1 次元格子点データ,
  !   ae_ :: 1 次元スペクトルデータが複数並んだ 2 次元データ,
  !   ag_ :: 1 次元格子点データが複数並んだ 2 次元データ.
  !
  ! * 関数名の間の文字列(Dx)は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_e, _ae, _g, _ag) は, 入力変数の形スペクトルデータおよび
  !   格子点データであることを示している.
  !   _e  :: スペクトルデータ
  !   _g  :: 1 次元格子点データ
  !   _ae :: 1 次元スペクトルデータが複数並んだ 2 次元データ
  !   _ag :: 1 次元格子点データが複数並んだ 2 次元データ
  !
  !=== 各データの種類の説明
  !
  ! * 以下, DP  = kind(1.0D) である
  ! * g : 1 次元格子点データ.
  !   * 変数の種類と次元は real(DP), dimension(0:im-1).
  !   * im は X 座標の格子点数であり, サブルーチン ae_Initial にて
  !     あらかじめ設定しておく.
  !
  ! * e : スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(-km:km).
  !   * km は X 方向の最大波数であり, サブルーチン ae_Initial にて
  !     あらかじめ設定しておく.
  !   * スペクトルデータの格納のされ方は 0:km までが cos(kx) の係数,
  !     -km:-1 が sin(kx) の係数となっている.
  !
  ! * ag : 1 次元(X)格子点データの並んだ 2 次元データ.
  !   * 変数の種類と次元は real(8), dimension(:,0:im-1).
  !     第 2 次元が X 方向を表す.
  !
  ! * ae : 1 次元スペクトルデータの並んだ 2 次元データ.
  !   * 変数の種類と次元は real(8), dimension(:,-km:km).
  !     第 2 次元がスペクトルを表す.
  !
  ! * g_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * e_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * ag_ で始まる関数が返す値は 1 次元格子点データの並んだ
  !   2 次元データに同じ.
  !
  ! * ae_ で始まる関数が返す値は 1 次元スペクトルデータの並んだ
  !   2 次元データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したもののことである.
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! ae_Initial       :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  !
  !==== 座標変数
  !
  ! g_X              :: 格子点座標(X)を格納した 1 次元配列
  ! g_X_Weight       :: 重み座標を格納した 1 次元配列
  !
  !==== 基本変換
  !
  ! g_e, ag_ae       :: スペクトルデータから格子データへの変換
  ! e_g, ae_ag       :: 格子データからスペクトルデータへの変換
  !
  !==== 微分
  !
  ! e_Dx_e, ae_Dx_ae :: スペクトルデータに X 微分を作用させる
  !
  !==== 積分・平均
  !
  ! a_Int_ag, a_Avr_ag :: 1 次元格子点データの並んだ 2 次元配列の積分および平均
  ! Int_g, Avr_g       :: 1 次元格子点データの積分および平均
  !
  !==== 補間
  !
  ! Interpolate_e      :: スペクトルデータからの特定の座標の値の補間(1 次元)
  ! a_Interpolate_ae   :: スペクトルデータからの特定の座標の値の補間(2 次元)
  !
  !
  use dc_message
  use dc_types, only: DP
  implicit none

  private
  public ae_Initial                       ! 初期化ルーチン
  public ag_ae, ae_ag, g_e, e_g           ! 基本変換
  public ae_Dx_ae, e_Dx_e                 ! 微分
  public a_Int_ag, Int_g, a_Avr_ag, Avr_g ! 積分・平均
  public Interpolate_e, a_Interpolate_ae  ! 補間
  public g_X, g_X_Weight                  ! 座標変数

  integer :: im = 32             ! 格子点の数
  integer :: km = 10             ! 切断波数
  real(DP) :: xl = 1.0            ! 領域の大きさ

  integer, dimension(5) :: iti
  real(DP), dimension(:), allocatable :: ti
  real(DP), parameter :: pi = 3.1415926535897932385D0

  real(DP), allocatable :: g_x(:)         ! 格子点座標(X)を格納した 1 次元配列.
  real(DP), allocatable :: g_x_weight(:)  ! 重み座標を格納した 1 次元配列.
  ! X 方向の格子点の間隔が格納してある.

  save im, km, iti, ti, xl, g_X, g_X_Weight

contains
  !--------------- 初期化 -----------------
  subroutine ae_Initial(i, k, xmin, xmax)
    !
    ! スペクトル変換の格子点数, 波数, 領域の大きさを設定する.
    !
    ! 他の関数や変数を呼ぶ前に, 最初にこのサブルーチンを呼んで
    ! 初期設定をしなければならない.
    !
    integer, intent(in) :: i              ! 格子点の数
    integer, intent(in) :: k              ! 切断波数
    real(DP), intent(in) :: xmin, xmax     ! X 座標範囲

    integer :: ii

    im = i
    km = k
    xl = xmax - xmin

    if (im <= 0 .or. km <= 0) then
      call MessageNotify('E', 'ae_Initial', &
                         'Number of grid points and waves should be positive')
    elseif (mod(im, 2) /= 0) then
      call MessageNotify('E', 'ae_Initial', &
                         'Number of grid points should be even')
    elseif (km >= im / 2) then
      call MessageNotify('E', 'ae_Initial', &
                         'KM shoud be less than IM/2')
    end if

    allocate (ti(im * 2))

    call fttrui(im, iti, ti)

    allocate (g_x(0:im - 1))
    do ii = 0, im - 1
      g_X(ii) = xmin + xl / im * ii
    end do

    allocate (g_x_weight(0:im - 1))
    g_X_Weight = xl / im

#ifdef SPML_VEC
    call MessageNotify('M', 'ae_initial', 'ae_module for Vector (2016/08/28) is initialized')
#else
    call MessageNotify('M', 'ae_initial', 'ae_module for OpenMP (2016/08/28) is initialized')
#endif

  end subroutine ae_Initial

  !--------------- 基本変換 -----------------
  function ag_ae(ae)
    !
    ! スペクトルデータから格子点データへ逆変換する(2 次元データ用)
    !
    ! スペクトル逆変換の定義は以下のとおり.
    !
    !   スペクトルデータ e_k (k=-km,...,km)
    !   格子点データ     g_j (j=-0,...,im-1)
    !
    !  g_j = e_0
    !      + 2\sum_{k=1}^{km}(e_k\cos(2\pi jk/im) - e_{-k}\sin(2\pi jk/im))
    !                                                    (j=0,1,...,im-1).
    !
    real(DP), dimension(:, -km:), intent(in) :: ae    !(in)  スペクトルデータ
    real(DP), dimension(size(ae, 1), 0:im - 1) :: ag_ae !(out) 格子点データ

    real(DP), dimension(size(ae, 1), im) :: y
    integer :: n, nm, k

    nm = size(ae, 1)
    if (size(ae, 2) < 2 * km + 1) then
      call MessageNotify('E', 'ag_ae', &
                         'The Fourier dimension of input data too small.')
    elseif (size(ae, 2) > 2 * km + 1) then
      call MessageNotify('W', 'ag_ae', &
                         'The Fourier dimension of input data too large.')
    end if

    ag_ae = 0.0D0
    ag_ae(:, 0) = ae(:, 0)
    ag_ae(:, 1) = 0.0D0
    do k = 1, km
      ag_ae(:, 2 * k) = ae(:, k)
      ag_ae(:, 2 * k + 1) = ae(:, -k)
    end do
    ag_ae(:, 2 * km + 2:im - 1) = 0.0D0

#ifdef SPML_VEC
    call fttrub(nm, im, ag_ae, y, iti, ti)
#else
!$omp parallel do default(shared)
    do n = 1, nm
      call fttrub(1, im, ag_ae(n, :), y(n, :), iti, ti)
    end do
!$omp end parallel do
#endif

  end function ag_ae

  function g_e(e)
    !
    ! スペクトルデータから格子点データへ逆変換する(1 次元データ用)
    !
    ! スペクトル逆変換の定義は以下のとおり.
    !
    !   スペクトルデータ e_k (k=-km,...,km)
    !   格子点データ     g_j (j=-0,...,im-1)
    !
    !  g_j = e_0
    !      + 2\sum_{k=1}^{km}(e_k\cos(2\pi jk/im) - e_{-k}\sin(2\pi jk/im))
    !                                                    (j=0,1,...,im-1).
    !
    real(DP), dimension(0:im - 1) :: g_e  !(out) 格子点データ
    real(DP), dimension(-km:km), intent(in) :: e    !(in)  スペクトルデータ

    real(DP), dimension(1, size(e)) :: ae_work
    real(DP), dimension(1, 0:im - 1) :: ag_work

    ae_work(1, :) = e
    ag_work = ag_ae(ae_work)
    g_e = ag_work(1, :)

  end function g_e

  function ae_ag(ag)
    !
    ! 格子点データからスペクトルデータへ正変換する(2 次元データ用)
    !
    ! スペクトル正変換の定義は以下のとおり.
    !
    !   格子点データ     g_j (j=-0,...,im-1)
    !   スペクトルデータ e_k (k=-km,...,km)
    !
    !   e_0 = (1/im)\sum_{j=0}^{im-1} g_j
    !   e_k = (1/im)\sum_{j=0}^{im-1} g_j \cos(2\pi jk/im)       (k=1,2,...,km)
    !   e_{-k} = - (1/im)\sum_{j=0}^{im-1} g_j \sin(2\pi jk/im)  (k=1,2,...,km)
    !
    real(DP), dimension(:, :), intent(in) :: ag     !(in)  格子点データ
    real(DP), dimension(size(ag, 1), -km:km) :: ae_ag  !(out) スペクトルデータ

    real(DP), dimension(size(ag, 1), im) :: y
    real(DP), dimension(size(ag, 1), 0:im - 1) :: ag_work
    integer :: n, nm, k

    nm = size(ag, 1)
    if (size(ag, 2) < im) then
      call MessageNotify('E', 'ae_ag', &
                         'The Grid points of input data too small.')
    elseif (size(ag, 2) > im) then
      call MessageNotify('W', 'ae_ag', &
                         'The Grid points of input data too large.')
    end if
    ag_work = ag

#ifdef SPML_VEC
    call fttruf(nm, im, ag_work, y, iti, ti)
#else
!$omp parallel do default(shared)
    do n = 1, nm
      call fttruf(1, im, ag_work(n, :), y(n, :), iti, ti)
    end do
!$omp end parallel do
#endif

    do k = 1, km
      ae_ag(:, k) = ag_work(:, 2 * k)
      ae_ag(:, -k) = ag_work(:, 2 * k + 1)
    end do
    ae_ag(:, 0) = ag_work(:, 0)

  end function ae_ag

  function e_g(g)
    !
    ! 格子点データからスペクトルデータへ正変換する(1 次元データ用)
    !
    ! スペクトル正変換の定義は以下のとおり.
    !
    !   格子点データ     g_j (j=-0,...,im-1)
    !   スペクトルデータ e_k (k=-km,...,km)
    !
    !   e_0 = (1/im)\sum_{j=0}^{im-1} g_j
    !   e_k = (1/im)\sum_{j=0}^{im-1} g_j \cos(2\pi jk/im)       (k=1,2,...,km)
    !   e_{-k} = - (1/im)\sum_{j=0}^{im-1} g_j \sin(2\pi jk/im)  (k=1,2,...,km)
    !
    real(DP), dimension(-km:km) :: e_g   !(out) スペクトルデータ
    real(DP), dimension(0:im - 1), intent(in) :: g     !(in)  格子点データ

    real(DP), dimension(1, size(g)) :: ag_work
    real(DP), dimension(1, -km:km) :: ae_work

    ag_work(1, :) = g
    ae_work = ae_ag(ag_work)
    e_g = ae_work(1, :)

  end function e_g

  !--------------- 微分計算 -----------------
  function ae_Dx_ae(ae)
    !
    ! 入力スペクトルデータに X 微分を作用する(2 次元データ).
    !
    ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
    ! 作用させたデータのスペクトル変換のことである.
    !
    !
    real(DP), dimension(:, -km:), intent(in) :: ae
    !(in)  入力スペクトルデータ
    real(DP), dimension(size(ae, 1), -km:km) :: ae_dx_ae
    !(out) 入力スペクトルデータの X 微分

    integer :: k

    if (size(ae, 2) < 2 * km + 1) then
      call MessageNotify('W', 'ae_Dx_ae', &
                         'The Fourier dimension of input data too small.')
    elseif (size(ae, 2) > 2 * km + 1) then
      call MessageNotify('W', 'ae_Dx_ae', &
                         'The Fourier dimension of input data too large.')
    end if

    do k = -km, km
      ae_Dx_ae(:, k) = -(2 * pi * k / xl) * ae(:, -k)
    end do
  end function ae_dx_ae

  function e_Dx_e(e)
    !
    ! 入力スペクトルデータに X 微分を作用する(1 次元データ).
    !
    ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
    ! 作用させたデータのスペクトル変換のことである.
    !
    !
    real(DP), dimension(-km:km), intent(in) :: e
    !(in)  入力スペクトルデータ
    real(DP), dimension(-km:km) :: e_Dx_e
    !(out) 入力スペクトルデータの X 微分
    real(DP), dimension(1, -km:km) :: ae_work

    ae_work(1, :) = e
    ae_work = ae_Dx_ae(ae_work)
    e_Dx_e = ae_work(1, :)

  end function e_Dx_e

  !--------------- 積分計算 -----------------
  function a_Int_ag(ag)
    !
    ! 1 次元格子点データが並んだ 2 次元配列の積分
    !
    real(DP), dimension(:, 0:), intent(in) :: ag        !(in) 格子点データ
    real(DP), dimension(size(ag, 1)) :: a_Int_ag  !(out) 積分結果
    integer :: i

    if (size(ag, 2) < im) then
      call MessageNotify('E', 'ae_Int_ag', &
                         'The Grid points of input data too small.')
    elseif (size(ag, 2) > im) then
      call MessageNotify('W', 'ae_Int_ag', &
                         'The Grid points of input data too large.')
    end if

    a_Int_ag = 0.0D0
    do i = 0, im - 1
      a_Int_ag(:) = a_Int_ag(:) + ag(:, i) * g_X_Weight(i)
    end do
  end function a_Int_ag

  function Int_g(g)
    !
    ! 1 次元格子点データの積分
    !
    real(DP), dimension(0:im - 1), intent(in) :: g      !(in) 格子点データ
    real(DP) :: Int_g  !(out) 積分結果

    Int_g = sum(g * g_X_Weight)

  end function Int_g

  function a_Avr_ag(ag)
    !
    ! 1 次元格子点データが並んだ 2 次元配列の平均
    !
    real(DP), dimension(:, 0:), intent(in) :: ag        !(in) 格子点データ
    real(DP), dimension(size(ag, 1)) :: a_Avr_ag  !(out) 平均結果

    a_Avr_ag = a_Int_ag(ag) / sum(g_X_Weight)

  end function a_Avr_ag

  function Avr_g(g)
    !
    ! 1 次元格子点データの平均
    !
    real(DP), dimension(0:im - 1), intent(in) :: g
    real(DP) :: Avr_g

    Avr_g = Int_g(g) / sum(g_X_Weight)

  end function Avr_g

  !--------------- 補間計算 -----------------
  function Interpolate_e(e_data, xval)
    real(DP), dimension(-km:km), intent(IN) :: e_data
    !(in) 入力フーリエデータ
    real(DP), intent(in) :: xval
    ! 補間する点の座標
    real(DP) :: Interpolate_e
    ! 補間した結果の値
    integer :: k
    ! DO 文変数

    Interpolate_e = e_data(0)

    do k = 1, km
      Interpolate_e = Interpolate_e                          &
        &  + 2.0D0 * (e_data(k) * cos(2 * PI * k / xl * xval)    &
        &              - e_data(-k) * sin(2 * PI * k / xl * xval))
    end do

  end function Interpolate_e

  function a_Interpolate_ae(ae_data, xval)
    real(DP), dimension(:, -km:), intent(IN) :: ae_data
    !(in) 入力フーリエデータ
    real(DP), intent(in) :: xval
    ! 補間する点の座標
    real(DP), dimension(size(ae_data, 1)) :: a_Interpolate_ae
    ! 補間した結果の値
    integer :: k
    ! DO 文変数

    a_Interpolate_ae = ae_data(:, 0)

    do k = 1, km
      a_Interpolate_ae = a_Interpolate_ae                      &
      &   + 2.0D0 * (ae_data(:, k) * cos(2 * PI * k / xl * xval)    &
      &               - ae_data(:, -k) * sin(2 * PI * k / xl * xval))
    end do

  end function a_Interpolate_ae

end module ae_module

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ee_module_fftj テストプログラム (微分計算)
!
!履歴  2009/09/09  竹広真一  ee_test_transform2.f90 より ee_module_fftj 用に改造
!
program ee_module_fftj_base_test2

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32              ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

  integer, parameter :: im2=64, jm2=64            ! 格子点の設定(X,Y)
  integer, parameter :: km2=21, lm2=21            ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: yx_Deriv(0:jm-1,0:im-1)   ! 格子データ

  real(8)            :: yx_Data2(0:jm2-1,0:im2-1)  ! 格子データ
  real(8)            :: yx_Deriv2(0:jm2-1,0:im2-1) ! 格子データ

  integer            :: k=2, l=3

  integer            :: id1, id2

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','ee_module_fftj_deriv_test2', &
       'ee_module_fftj derivative function tests for multiple domains and resolutions')

 !---------------- 座標値の設定 ---------------------
  call ee_initial(im,jm,km,lm,xmin,xmax,ymin,ymax,id1)        ! スペクトル初期化
  call ee_initial(im2,jm2,km2,lm2,xmin,xmax,ymin,ymax,id2)    ! スペクトル初期化

 !------------------- 関数チェック ----------------------

  !---------- id1 ---------
  call ee_ChangeResolutionDomain(id1)

  yx_Data = sin(k*pi*yx_X) * sin(l*pi*yx_Y)

  yx_Deriv = k*pi*cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Dx_ee with sin(k*pi*X)*sin(l*pi*Y) for id=1',     &
    answer = yx_Deriv,                                            &
    check = yx_ee(ee_Dx_ee(ee_yx(yx_Data))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = l*pi*sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Dy_ee with sin(k*pi*X)*sin(l*pi*Y) for id=1',     &
    answer = yx_Deriv,                                            &
    check = yx_ee(ee_Dy_ee(ee_yx(yx_Data))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = -((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Lapla_ee with sin(k*pi*X)*sin(l*pi*Y) for id=1',  &
    answer = yx_Deriv,                                            &
    check = yx_ee(ee_Lapla_ee(ee_yx(yx_Data))),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_LaplaInv_ee with sin(k*pi*X)*sin(l*pi*Y) for id=1',&
    answer = yx_Deriv,                                            &
    check = yx_ee(ee_LaplaInv_ee(ee_yx(yx_Data))),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = cos(k*pi*yx_X) * cos(l*pi*yx_Y)

  yx_Deriv = -k*pi*sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Dx_ee with cos(k*pi*X)*cos(l*pi*Y) for id=1',     &
    answer = yx_Deriv,                                            &
    check = yx_ee(ee_Dx_ee(ee_yx(yx_Data))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = -l*pi*cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Dy_ee with cos(k*pi*X)*cos(l*pi*Y) for id=1',     &
    answer = yx_Deriv,                                            &
    check = yx_ee(ee_Dy_ee(ee_yx(yx_Data))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = -((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Lapla_ee with cos(k*pi*X)*cos(l*pi*Y) for id=1',  &
    answer = yx_Deriv,                                            &
    check = yx_ee(ee_Lapla_ee(ee_yx(yx_Data))),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_LaplaInv_ee with cos(k*pi*X)*cos(l*pi*Y) for id=1',&
    answer = yx_Deriv,                                            &
    check = yx_ee(ee_LaplaInv_ee(ee_yx(yx_Data))),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = sin(k*pi*yx_X) * cos(l*pi*yx_Y)

  yx_Deriv = k*pi*cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Dx_ee with sin(k*pi*X)*cos(l*pi*Y) for id=1',     &
    answer = yx_Deriv,                                            &
    check = yx_ee(ee_Dx_ee(ee_yx(yx_Data))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = -l*pi*sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Dy_ee with sin(k*pi*X)*cos(l*pi*Y) for id=1',     &
    answer = yx_Deriv,                                            &
    check = yx_ee(ee_Dy_ee(ee_yx(yx_Data))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = -((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Lapla_ee with sin(k*pi*X)*cos(l*pi*Y) for id=1',  &
    answer = yx_Deriv,                                            &
    check = yx_ee(ee_Lapla_ee(ee_yx(yx_Data))),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_LaplaInv_ee with sin(k*pi*X)*cos(l*pi*Y) for id=1',&
    answer = yx_Deriv,                                            &
    check = yx_ee(ee_LaplaInv_ee(ee_yx(yx_Data))),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = cos(k*pi*yx_X) * sin(l*pi*yx_Y)

  yx_Deriv = -k*pi*sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Dx_ee with cos(k*pi*X)*sin(l*pi*Y) for id=1',     &
    answer = yx_Deriv,                                            &
    check = yx_ee(ee_Dx_ee(ee_yx(yx_Data))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = l*pi*cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Dy_ee with cos(k*pi*X)*sin(l*pi*Y) for id=1',     &
    answer = yx_Deriv,                                            &
    check = yx_ee(ee_Dy_ee(ee_yx(yx_Data))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = -((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Lapla_ee with cos(k*pi*X)*sin(l*pi*Y) for id=1',  &
    answer = yx_Deriv,                                            &
    check = yx_ee(ee_Lapla_ee(ee_yx(yx_Data))),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv = -1.0/((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_LaplaInv_ee with cos(k*pi*X)*sin(l*pi*Y) for id=1',&
    answer = yx_Deriv,                                            &
    check = yx_ee(ee_LaplaInv_ee(ee_yx(yx_Data))),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---------- id2 ----------
  write(*,*) 'for id2'
  call ee_ChangeResolutionDomain(id2)

  yx_Data2 = sin(k*pi*yx_X) * sin(l*pi*yx_Y)

  yx_Deriv2 = k*pi*cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Dx_ee with sin(k*pi*X)*sin(l*pi*Y) for id=2',     &
    answer = yx_Deriv2,                                           &
    check = yx_ee(ee_Dx_ee(ee_yx(yx_Data2))),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv2 = l*pi*sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Dy_ee with sin(k*pi*X)*sin(l*pi*Y) for id=2',     &
    answer = yx_Deriv2,                                           &
    check = yx_ee(ee_Dy_ee(ee_yx(yx_Data2))),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv2 = -((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Lapla_ee with sin(k*pi*X)*sin(l*pi*Y) for id=2',  &
    answer = yx_Deriv2,                                           &
    check = yx_ee(ee_Lapla_ee(ee_yx(yx_Data2))),                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv2 = -1.0/((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_LaplaInv_ee with sin(k*pi*X)*sin(l*pi*Y) for id=2',&
    answer = yx_Deriv2,                                           &
    check = yx_ee(ee_LaplaInv_ee(ee_yx(yx_Data2))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data2 = cos(k*pi*yx_X) * cos(l*pi*yx_Y)

  yx_Deriv2 = -k*pi*sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Dx_ee with cos(k*pi*X)*cos(l*pi*Y) for id=2',     &
    answer = yx_Deriv2,                                           &
    check = yx_ee(ee_Dx_ee(ee_yx(yx_Data2))),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv2 = -l*pi*cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Dy_ee with cos(k*pi*X)*cos(l*pi*Y) for id=2',     &
    answer = yx_Deriv2,                                           &
    check = yx_ee(ee_Dy_ee(ee_yx(yx_Data2))),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv2 = -((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Lapla_ee with cos(k*pi*X)*cos(l*pi*Y) for id=2',  &
    answer = yx_Deriv2,                                           &
    check = yx_ee(ee_Lapla_ee(ee_yx(yx_Data2))),                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv2 = -1.0/((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_LaplaInv_ee with cos(k*pi*X)*cos(l*pi*Y) for id=2',&
    answer = yx_Deriv2,                                           &
    check = yx_ee(ee_LaplaInv_ee(ee_yx(yx_Data2))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data2 = sin(k*pi*yx_X) * cos(l*pi*yx_Y)

  yx_Deriv2 = k*pi*cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Dx_ee with sin(k*pi*X)*cos(l*pi*Y) for id=2',     &
    answer = yx_Deriv2,                                           &
    check = yx_ee(ee_Dx_ee(ee_yx(yx_Data2))),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv2 = -l*pi*sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Dy_ee with sin(k*pi*X)*cos(l*pi*Y) for id=2',     &
    answer = yx_Deriv2,                                           &
    check = yx_ee(ee_Dy_ee(ee_yx(yx_Data2))),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv2 = -((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Lapla_ee with sin(k*pi*X)*cos(l*pi*Y) for id=2',  &
    answer = yx_Deriv2,                                           &
    check = yx_ee(ee_Lapla_ee(ee_yx(yx_Data2))),                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv2 = -1.0/((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_LaplaInv_ee with sin(k*pi*X)*cos(l*pi*Y) for id=2',&
    answer = yx_Deriv2,                                           &
    check = yx_ee(ee_LaplaInv_ee(ee_yx(yx_Data2))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data2 = cos(k*pi*yx_X) * sin(l*pi*yx_Y)

  yx_Deriv2 = -k*pi*sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Dx_ee with cos(k*pi*X)*sin(l*pi*Y) for id=2',     &
    answer = yx_Deriv2,                                           &
    check = yx_ee(ee_Dx_ee(ee_yx(yx_Data2))),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv2 = l*pi*cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Dy_ee with cos(k*pi*X)*sin(l*pi*Y) for id=2',     &
    answer = yx_Deriv2,                                           &
    check = yx_ee(ee_Dy_ee(ee_yx(yx_Data2))),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv2 = -((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_Lapla_ee with cos(k*pi*X)*sin(l*pi*Y) for id=2',  &
    answer = yx_Deriv2,                                           &
    check = yx_ee(ee_Lapla_ee(ee_yx(yx_Data2))),                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Deriv2 = -1.0/((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call AssertEqual(&
    message='ee_LaplaInv_ee with cos(k*pi*X)*sin(l*pi*Y) for id=2',&
    answer = yx_Deriv2,                                           &
    check = yx_ee(ee_LaplaInv_ee(ee_yx(yx_Data2))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','ee_module_fftj_deriv_test2', &
       'ee_module_fftj derivative function tests &
       &for multiple domains and resolutions succeeded!')

end program ee_module_fftj_base_test2

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ua_mpi_module_svpack テストプログラム :: スペクトル関数のテスト
!
!履歴  2016/08/15  竹広真一 wa_mpi_spectrum_mpi_module_supack_test.f90 より改造
!
program ua_mpi_module_svpack_spectrum_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ua_mpi_module_svpack
  use mpi
  implicit none

  integer, parameter :: im=64, jm=32, nm=21, km=2

  real(8), allocatable ::  ua_data(:,:)
  real(8), allocatable ::  xyb_data(:,:,:)

  real(8), dimension(0:nm,-nm:nm,km) ::  nma_data
  real(8), dimension(0:nm,km)        ::  na_data
  real(8), dimension(km)             ::  a_data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer :: n,m
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call ua_mpi_Initial( nm, im, jm, km )

  allocate(ua_data(nc,km))
  allocate(xyb_data(0:im-1,1:jm,kc))

  call MessageNotify('M','ua_spectrum_mpi_module_svpack_test',&
                         'ua_mpi_module_svpack spectrum functions tests.') 

  ! 2Y_1^0+3Y_2^1
  if ( kp_kl(1) /= 0 ) &
     xyb_data(:,:,kp_kl(1)) = 2*sqrt(3.0D0)*sin(xy_Lat) &
                + 3*sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)!
  ! 3*Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2
  if ( kp_kl(2) /= 0 ) &
     xyb_data(:,:,kp_kl(2)) = 3*sqrt(3.0D0)*sin(xy_Lat) & 
                + 2* sqrt(3.0D0/2)*cos(xy_Lat)*cos(xy_Lon) &
                + 2*sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0) &
                - sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(2*xy_Lon)

  ua_data = ua_xyb(xyb_data)

  !--------- Energy spectrum ---------
  nma_data=ua_spectrum_VMiss

  do n=0,nm
     do m=-n,n
        nma_data(n,m,:) = 0.0D0
     enddo
  enddo

  nma_data(1,0,1) = 4.0D0
  nma_data(2,1,1) = 2*3*(3.0D0/2)**2/2
  nma_data(2,-1,1)= nma_data(2,1,1)
  nma_data(1,0,2) = 9.0D0
  nma_data(1,1,2) = 1*2*(2/2)**2/2
  nma_data(1,-1,2)= nma_data(1,1,2)
  nma_data(2,0,2) = 12.0D0 
  nma_data(2,-2,2)= 2*3*(1.0D0/2)**2/2
  nma_data(2,2,2) = nma_data(2,-2,2)

  call AssertEqual(&
    message='nma_EnergyFromStreamfunc_ua',                        &
    answer = nma_EnergyFromStreamfunc_ua(ua_data),                &
    check =  nma_data,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  na_data = 0.0D0
  na_data(1,1) = 4.0D0
  na_data(2,1) = 2 * 3 *(3.0D0/2)**2
  na_data(1,2) = 9.0D0 + 1*2*(2/2)**2
  na_data(2,2) = 12.0D0 + 2*3*(1.0D0/2)**2

  call AssertEqual(&
    message='na_EnergyFromStreamfunc_ua',                         &
    answer = na_EnergyFromStreamfunc_ua(ua_data),                 &
    check =  na_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nma_Data = nma_EnergyFromStreamfunc_ua(ua_data)
  a_data = 0.0D0
  do n=0,nm
     do m=-n,n
        a_data = a_data + nma_Data(n,m,:)
     enddo
  enddo

  call AssertEqual(&
    message='total energy by nm-spectrum',                        &
    answer = a_AvrLonLat_xya(                                     &
    0.5*(xyb_GradLon_ua(ua_data)**2+xyb_GradLat_ua(ua_data)**2) ),&
    check = a_data(k1:k2),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

!!$  a_data = a_AvrLonLat_xya( 0.5*(xyb_GradLon_ua(ua_data)**2+xyb_GradLat_ua(ua_data)**2) )
!!$  call AssertEqual(&
!!$    message='total energy with n-spectrum',                       &
!!$    answer = sum(na_EnergyFromStreamfunc_ua(ua_data),1),          &
!!$    check =  a_data,                                              &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )

  !--------- Enstrophy spectrum ---------
  nma_data=ua_spectrum_VMiss
  do n=0,nm
     do m=-n,n
        nma_data(n,m,:) = 0.0D0
     enddo
  enddo

  nma_data(1,0,1) = 8.0D0
  nma_data(2,1,1) = 2**2*3**2*(3.0D0/2)**2/2
  nma_data(2,-1,1) = nma_data(2,1,1) 

  nma_data(1,0,2)  = 18.0D0
  nma_data(1,1,2)  = 1**2 * 2**2 * (2/2)**2 / 2
  nma_data(1,-1,2) = nma_data(1,1,2)
  nma_data(2,0,2)  = 72.0D0
  nma_data(2,-2,2) = 2**2 * 3**2 * (1.0D0/2)**2 /2
  nma_data(2,2,2)  = nma_data(2,-2,2)

  call AssertEqual(&
    message='nma_EnstrophyFromStreamfunc_ua',                     &
    answer = nma_EnstrophyFromStreamfunc_ua(ua_data),             &
    check =  nma_data,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  na_data = 0.0
  na_data(1,1) = 8.0D0  ;   na_data(2,1) = 2**2*3**2*(3.0D0/2)**2
  na_data(1,2) = 18.0D0 + 1**2 * 2**2 * (2/2)**2
  na_data(2,2) = 72.0D0 + 2**2 * 3**2 * (1.0D0/2)**2

  call AssertEqual(&
    message='na_EnstrophyFromStreamfunc_ua',                      &
    answer = na_EnstrophyFromStreamfunc_ua(ua_data),              &
    check =  na_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nma_Data = nma_EnstrophyFromStreamfunc_ua(ua_data)
  a_data = 0.0D0
  do n=0,nm
     do m=-n,n
        a_data = a_data + nma_Data(n,m,:)
     enddo
  enddo

  call AssertEqual(&
    message='total enstrophy by nm-spectrum',                     &
    answer = a_AvrLonLat_xya( 0.5*(xyb_ua(ua_Lapla_ua(ua_data))**2)),&
    check = a_data(k1:k2),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

!!$  a_data = a_AvrLonLat_xya( 0.5*(xyb_ua(ua_Lapla_ua(ua_data))**2))
!!$
!!$  call AssertEqual(&
!!$    message='total energy with n-spectrum',                       &
!!$    answer = sum(na_EnstrophyFromStreamfunc_ua(ua_data),1),       &
!!$    check =  a_data,                                              &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )

  call MessageNotify('M','ua_spectrum_mpi_module_svpack_test', &
                     'ua_mpimodule_svpack spectrum function tests succeeded!') 

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ua_mpi_module_svpack_spectrum_test

!----------------------------------------------------------------------
! Copyright (c) 2012--2016 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  w_base_mpi_module_sjpack
!
!  spml/w_base_mpi_module_sjpack モジュールは球面上での 2 次元流体運動を
!  球面調和函数を用いたスペクトル法と MPI によって数値計算するための 
!  モジュール w_mpi_module_sjpack の下部モジュールであり, スペクトル計算の
!  基本的な Fortran90 関数を提供する. 
!
!  内部で ISPACK の SJPACK-MPI の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK/SJPACK-MPI のマニュアルを参照されたい.
!
!
!履歴  2012/03/31  竹広真一  w_base_mpi_module を sjpack 化
!      2012/04/02  竹広真一  格子点数等を private 変数に
!      2013/02/12  竹広真一  w_StreamPotential2VectorMPI,  
!                            w_Vector2VorDivMPI 導入
!      2013/02/15  竹広真一  w_VectorCosLat2VorDivMPI 導入
!      2013/02/23  竹広真一  w_base_mpi_Finalize 導入
!      2016/07/07  竹広真一  AVX 用 32 bit alignment 対応
!
module w_base_mpi_module_sjpack
  !
  ! w_base_mpi_module_sjpack
  !
  !  spml/w_base_mpi_module_sjpack モジュールは球面上での 2 次元流体運動を
  !  球面調和函数を用いたスペクトル法と MPI によって数値計算するための 
  !  モジュール w_mpi_module_sjpack の下部モジュールであり, スペクトル法の
  !  基本的なな Fortran90 関数を提供する. 
  !
  !  内部で ISPACK の SJPACK-MPI の Fortran77 サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK/SJPACK のマニュアルを参照されたい.
  !
  use dc_message
  use iso_c_binding
  use w_base_module_sjpack, only : im, jm, nn, nm, mm, openmp, np, x_Lon

  implicit none

  real(8), allocatable  :: p(:), r(:)       ! 変換用配列
  integer               :: it(4)            ! 変換用配列

  real(8), allocatable  :: c(:)             ! 作業配列

  integer               :: jc               ! 分散配置用変数

  real(8), allocatable  :: y(:,:)           ! 作業配列

  real(8), allocatable  :: v_Lat(:),v_Lat_Weight(:)      ! 緯度経度
  real(8), allocatable  :: xv_Lon(:,:), xv_Lat(:,:)

  real(8), pointer      :: xv_pdata(:,:),q(:),t(:),w(:),wg(:)
  type(C_PTR)           :: pg, pq, pt, pw, pwg

  logical               :: w_base_initialize=.false.   ! 初期化フラッグ

  private
  private im, jm, nn, mm, nm                  ! 格子点数, 切断波数

  public it, t, p, r                          ! 変換用作業配列
  public openmp, np                           ! OPENMP 用変数
  public jc                                   ! 分散配置用変数

  public w_base_mpi_Initial                   ! 初期化サブルーチン
  public w_base_mpi_Finalize                  ! 終了サブルーチン

  public v_Lat                                ! 格子座標
  public v_Lat_Weight                         ! 格子座標重み
  public xv_Lon, xv_Lat                       ! 格子座標(im,jm)
  public xv_w, w_xv                           ! 変換関数
  public w_StreamPotential2VectorMPI          ! 流線ポテンシャルから速度場計算
  public w_Vector2VorDivMPI                   ! 速度場から渦度発散を計算
  public w_VectorCosLat2VorDivMPI             ! 速度場から渦度発散を計算

  save it, p, r                               ! 変換用配列を記憶
  save c                                      ! 変換用配列の大きさ
  save jc                                     ! 分散格子点配列の大きさ
  save xv_pdata, q, t, w, wg
  save w_base_initialize                      ! 初期化フラグ


  contains
  !--------------- 初期化 -----------------
    subroutine w_base_mpi_Initial
      !
      ! スペクトル変換の格子点数, 波数および OPENMP 使用時の
      ! 最大スレッド数を設定する.
      !
      ! 実際の使用には上位サブルーチン w_Initial を用いること.
      !
      integer :: i, j

      allocate(p(jm/2*(mm+4)))                ! 変換用配列
      allocate(r((mm+1)*(2*nm-mm-1)+1))       ! 変換用配列

      allocate(c((mm+1)*(mm+1)))              ! 変換用作業配列

      call mlallc(pt,im*6)
      call c_f_pointer(pt, t, [im*6])

      ! 注意 : 別ルーチンによって w_base_Initial が呼んであることを仮定
      call sjpini(mm,nm,jm,jc,im,p,r,it,t)
      call sjinic(mm,c)

      allocate(v_Lat(jc),v_Lat_Weight(jc))             ! 格子点座標格納配列

      allocate(xv_Lon(0:im-1,jc),xv_Lat(0:im-1,jc))   ! 格子点座標格納配列

      allocate(y(jc/2,mm+4))
      y = reshape(p(1:jc/2*(mm+4)),(/jc/2,mm+4/))

      do j=1,jc/2
         v_Lat(jc/2+j)   =  asin(y(j,1))        ! 緯度座標
         v_Lat(jc/2-j+1) = -asin(y(j,1))        ! 緯度座標
         v_Lat_Weight(jc/2+j)   = 2*y(j,2)      ! 緯度重み(Gauss grid)
         v_Lat_Weight(jc/2-j+1) = 2*y(j,2)      ! 緯度重み(Gauss grid)
      enddo
  
      do j=1,jc
         xv_Lon(:,j) = x_Lon
      enddo

      do i=0,im-1
         xv_Lat(i,:) = v_Lat
      enddo

      call mlallc(pg,jc*im)
      call mlallc(pq,jm/2*7*np)
      call mlallc(pw,(jc+1)*im)
      call mlallc(pwg,(jc+2)*im)
      call c_f_pointer(pg, xv_pdata, [IM,JC])
      call c_f_pointer(pq, q, [jm/2*7*np])
      call c_f_pointer(pw, w, [(jc+1)*im])
      call c_f_pointer(pwg, wg, [(jc+2)*im])      

      w_base_initialize = .true.

      call MessageNotify('M','w_base_mpi_initial',&
                         'w_base_mpi_module_sjpack (2016/07/07) is initialized')
    end subroutine w_base_mpi_Initial

  !--------------- 基本変換(格子点分散配置) -----------------

    function xv_w(w_data,ipow,iflag)
      !
      ! スペクトルデータから格子データへ変換する(1 層用).
      !
      real(8)               :: xv_w(0:im-1,1:jc)
      !(out) 格子点データ

      real(8), intent(in)   :: w_data((mm+1)*(mm+1))
      !(in) スペクトルデータ

      integer, intent(in), optional  :: ipow      
      !(in) 作用させる 1/cosφ の次数. 省略時は 0. 

      integer, intent(in), optional  :: iflag
      !(in) 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた逆変換
      !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
      !    2 : sinφを作用させた逆変換
      !    省略時は 0.
      !
      integer, parameter  :: ipow_default  = 0
      integer, parameter  :: iflag_default = 0

      integer ipval, ifval

      real(8)             :: w_Rdata((2*nn+1-mm)*mm+nn+1)
      ! 作業用スペクトルデータ(SJTS2G 出力用)
      real(8)             :: w_Xdata((mm+1)*(mm+1))
      ! 作業用スペクトルデータ(SJCS2X 出力用)
      real(8)             :: w_Ydata((mm+4)*mm+2)
      ! 作業用スペクトルデータ(SJCS2Y 出力用)

      real(8)  :: ws(2*(nn+1)*np)            ! 変換用作業配列
      real(8)  :: ws2(2*(nm+1)*np)           ! 変換用作業配列

      logical :: first=.true.                    ! 初回判定スイッチ
      save first

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','xv_w',&
              'w_base_mpi_module_sjpack not initialize yet.')
      endif

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      if ( openmp .and. first ) then
         call MessageNotify('M','xy_w', &
              'OpenMP routine SJTSOG/SJPACK-MPI is used for spherical harmonic transformation.')
      endif

      if ( ifval==0 ) then
         call sjcrup(mm,nn,w_data,w_Rdata)
         if ( openmp ) then
            call sjtsog(mm,nm,nn,im,jc,w_Rdata,xv_pdata,&
                        it,t,p,q,r,ws,wg,w,ipval)
         else
            call sjts2g(mm,nm,nn,im,jc,w_Rdata,xv_pdata,&
                        it,t,p,q,r,ws,wg,w,ipval)
         endif
         xv_w = xv_pdata
      else if( ifval==-1 ) then
         call sjcs2x(mm,w_data,w_Xdata)
         call sjcrup(mm,nn,w_Xdata,w_Rdata)
         if ( openmp ) then
            call sjtsog(mm,nm,nn,im,jc,w_Rdata,xv_pdata,&
                        it,t,p,q,r,ws,wg,w,ipval)
         else
            call sjts2g(mm,nm,nn,im,jc,w_Rdata,xv_pdata,&
                        it,t,p,q,r,ws,wg,w,ipval)
         endif
         xv_w = xv_pdata
      else if( ifval==1 ) then
         call sjcs2y(mm,w_data,w_Ydata,c)
         if ( openmp ) then
            call sjtsog(mm,nm,nm,im,jc,w_Ydata,xv_pdata,&
                        it,t,p,q,r,ws2,wg,w,ipval)
         else
            call sjts2g(mm,nm,nm,im,jc,w_Ydata,xv_pdata,&
                        it,t,p,q,r,ws2,wg,w,ipval)
         endif
         xv_w = xv_pdata
      else if( ifval==2 ) then
         call sjcrup(mm,nn,w_data,w_Rdata)
         if ( openmp ) then
            call sjtsog(mm,nm,nn,im,jc,w_Rdata,xv_pdata,&
                        it,t,p,q,r,ws,wg,w,ipval)
         else
            call sjts2g(mm,nm,nn,im,jc,w_Rdata,xv_pdata,&
                        it,t,p,q,r,ws,wg,w,ipval)
         endif
         xv_w = xv_pdata * sin(xv_Lat)
      else
         call MessageNotify('E','xv_w','invalid value of iflag')
      endif

      first = .false.

    end function xv_w

    function w_xv(xv_data,ipow,iflag)
      !
      ! 格子データからスペクトルデータへ(正)変換する(1 層用).
      !
      real(8)               :: w_xv((mm+1)*(mm+1))
      !(out) スペクトルデータ

      real(8), intent(in)   :: xv_data(0:im-1,1:jc)
      !(in) 格子点データ

      integer, intent(in), optional  :: ipow
      !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

      integer, intent(in), optional  :: iflag
      ! 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた正変換 
      !    1 : 緯度微分 1/cosφ・∂(f cos^2φ)/∂φ を作用させた正変換
      !    2 : sinφを作用させた正変換
      !  省略時は 0.


      integer, parameter  :: ipow_default  = 0    ! スイッチデフォルト値
      integer, parameter  :: iflag_default = 0    ! スイッチデフォルト値

      integer ipval, ifval

      real(8)             :: w_Rdata((2*nn+1-mm)*mm+nn+1)
      ! 作業用スペクトルデータ(SJTS2G 出力用)
      real(8)             :: w_Xdata((mm+1)*(mm+1))
      ! 作業用スペクトルデータ(SJCS2X 出力用)
      real(8)             :: w_Ydata((mm+4)*nm+2)
      ! 作業用スペクトルデータ(SJCY2S 出力用)

      real(8)  :: ws(2*(nn+1)*np+(2*NN+1-MM)*MM+NN+1)  ! 変換用作業配列
      real(8)  :: ws2(2*(nm+1)*np+(2*NM+1-MM)*MM+NM+1) ! 変換用作業配列

      logical :: first=.true.                     ! 初回判定スイッチ
      save first

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','xv_w',&
              'w_base_mpi_module_sjpack not initialize yet.')
      endif

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif
      
      if ( openmp .and. first ) then
         call MessageNotify('M','w_xv', &
              'OpenMP routine SJPGOS/SJPACK-MPI is used for spherical harmonic transformation.')
      endif

      if ( ifval == 0 ) then
         xv_pdata = xv_data
         if ( openmp ) then
            call sjpgos(mm,nm,nn,im,jc,w_Rdata,xv_pdata,&
                        it,t,p,q,r,ws,wg,w,ipval)
         else
            call sjpg2s(mm,nm,nn,im,jc,w_Rdata,xv_pdata,&
                        it,t,p,q,r,ws,wg,w,ipval)
         endif
         call sjcrdn(mm,nn,w_Rdata,w_xv)
      else if ( ifval == -1 ) then
         xv_pdata = xv_data
         if ( openmp ) then
            call sjpgos(mm,nm,nn,im,jc,w_Rdata,xv_pdata,&
                        it,t,p,q,r,ws,wg,w,ipval)
         else
            call sjpg2s(mm,nm,nn,im,jc,w_Rdata,xv_pdata,&
                        it,t,p,q,r,ws,wg,w,ipval)
         endif
         call sjcrdn(mm,nn,w_Rdata,w_Xdata)
         call sjcs2x(mm,w_Xdata,w_xv)
      else if ( ifval == 1 ) then
         xv_pdata = xv_data
         if ( openmp ) then
            call sjpgos(mm,nm,nm,im,jc,w_Ydata,xv_pdata,&
                        it,t,p,q,r,ws2,wg,w,ipval)
         else
            call sjpg2s(mm,nm,nm,im,jc,w_Ydata,xv_pdata,&
                        it,t,p,q,r,ws2,wg,w,ipval)
         endif
         call sjcy2s(mm,w_Ydata,w_xv,c)
      else if ( ifval == 2 ) then
         xv_pdata = xv_data * sin(xv_Lat)
         if ( openmp ) then
            call sjpgos(mm,nm,nn,im,jc,w_Rdata,xv_pdata,&
                        it,t,p,q,r,ws,wg,w,ipval)
         else
            call sjpg2s(mm,nm,nn,im,jc,w_Rdata,xv_pdata,&
                        it,t,p,q,r,ws,wg,w,ipval)
         endif
         call sjcrdn(mm,nn,w_Rdata,w_xv)
      end if

      first = .false.

    end function w_xv

  !----------- 速度, 渦度・発散, 流線・ポテンシャル計算 -------------

    subroutine w_StreamPotential2VectorMPI(w_Psi, w_Chi, xv_U, xv_V)
      !
      ! 流線・ポテンシャル(スペクトルデータ)から速度場(格子データ)に
      ! (逆)変換する(1 層用, MPI)
      !
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   u cosφ =      ∂χ/∂λ - cosφ∂ψ/∂φ, 
      !   v cosφ = cosφ∂χ/∂φ +      ∂ψ/∂λ 
      !
      real(8), intent(in)   :: w_Psi((mm+1)*(mm+1))
      !(in) 流線関数
      real(8), intent(in)   :: w_Chi((mm+1)*(mm+1))
      !(in) 速度ポテンシャル

      real(8), intent(out)   :: xv_U(0:im-1,1:jc)
      !(out) 速度経度成分
      real(8), intent(out)   :: xv_V(0:im-1,1:jc)
      !(out) 速度緯度成分

      real(8)             :: w_Rdata((mm+4)*mm+2)
      ! 作業用スペクトルデータ(SJTS2G 出力用)
      real(8)             :: w_Xdata((mm+1)*(mm+1))
      ! 作業用スペクトルデータ(SJCS2X 出力用)
      real(8)             :: w_Ydata((mm+4)*mm+2)
      ! 作業用スペクトルデータ(SJCS2Y 出力用)

      real(8)  :: ws2(2*(nm+1)*np)           ! 変換用作業配列

      logical :: first=.true.                     ! 初回判定スイッチ
      save first

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','w_StreamPotential2VectorMPI',&
              'w_base_module not initialize yet.')
      endif

      if ( openmp .and. first ) then
         call MessageNotify('M','w_StreamPotential2Vector', &
              'OpenMP routine SJTSOG/SNPACK-MPI is used for spherical harmonic transformation.')
      endif
      first = .false.

      !
      !   u cosφ = ∂χ/∂λ - cosφ∂ψ/∂φ の計算
      !
      call sjcs2x(mm,w_Chi,w_Xdata)
      call sjcs2y(mm,w_Psi,w_Ydata,c)
      call sjcrup(mm,nm,w_Xdata,w_Rdata)
      w_Rdata = w_Rdata - w_Ydata
      !
      !   u の計算
      !
      if ( openmp ) then
         call sjtsog(mm,nm,nm,im,jc,w_Rdata,xv_pdata,&
                        it,t,p,q,r,ws2,wg,w,1)
      else
         call sjts2g(mm,nm,nm,im,jc,w_Rdata,xv_pdata,&
              it,t,p,q,r,ws2,wg,w,1)
      endif
      xv_U = xv_pdata
      !
      !   v cosφ = cosφ∂χ/∂φ + ∂ψ/∂λ の計算
      !
      call sjcs2y(mm,w_Chi,w_Ydata,c)
      call sjcs2x(mm,w_Psi,w_Xdata)
      call sjcrup(mm,nm,w_Xdata,w_Rdata)
      w_Rdata= w_Rdata + w_Ydata
      !
      !   v の計算
      !
      if ( openmp ) then
         call sjtsog(mm,nm,nm,im,jc,w_Rdata,xv_pdata,&
                        it,t,p,q,r,ws2,wg,w,1)
      else
         call sjts2g(mm,nm,nm,im,jc,w_Rdata,xv_pdata,&
              it,t,p,q,r,ws2,wg,w,1)
      endif
      xv_V = xv_pdata

    end subroutine w_StreamPotential2VectorMPI

    subroutine w_Vector2VorDivMPI(xv_U, xv_V, w_Vor, w_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(1 層用, MPI)
      ! 
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xv_U(0:im-1,1:jc)
      !(in) 速度経度成分
      real(8), intent(in)   :: xv_V(0:im-1,1:jc)
      !(in) 速度緯度成分

      real(8), intent(out)   :: w_Vor((mm+1)*(mm+1))
      !(out) 流線関数
      real(8), intent(out)   :: w_Div((mm+1)*(mm+1))
      !(out) 速度ポテンシャル

      real(8)             :: w_Xdata((mm+1)*(mm+1))
      ! 作業用スペクトルデータ(SJCS2X 出力用)
      real(8)             :: w_Ydata((mm+4)*nm+2)
      ! 作業用スペクトルデータ(SJCY2S 出力用)

      real(8)  :: w_Data1((mm+1)*(mm+1))
      real(8)  :: w_Data2((mm+1)*(mm+1))

      real(8)  :: ws2(2*(nm+1)*np+(2*NM+1-MM)*MM+NM+1) ! 変換用作業配列

      logical :: first=.true.                     ! 初回判定スイッチ
      save first

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','w_Vector2VorDivMPI',&
              'w_base_module not initialize yet.')
      endif

      if ( openmp .and. first ) then
         call MessageNotify('M','w_Vector2VorDiv', &
              'OpenMP routine SJPGOS/SNPACK-MPI is used for spherical harmonic transformation.')
      endif
      first = .false.

      !
      ! 1/cosφ∂u/∂λ, 1/cosφ ∂(u cosφ)/∂φ の計算
      !
      xv_pdata = xv_U
      if ( openmp ) then
         call sjpgos(mm,nm,nm,im,jc,w_Ydata,xv_pdata,&
              it,t,p,q,r,ws2,wg,w,1)
      else
         call sjpg2s(mm,nm,nm,im,jc,w_Ydata,xv_pdata,&
              it,t,p,q,r,ws2,wg,w,1)
      endif
      call sjcrdn(mm,nm,w_Ydata,w_Xdata)
      call sjcs2x(mm,w_Xdata,w_Div)
      call sjcy2s(mm,w_Ydata,w_Data1,c)
      !
      ! 1/cosφ∂v/∂λ, 1/cosφ ∂(v cosφ)/∂φ の計算
      !
      xv_pdata = xv_V
      if ( openmp ) then
         call sjpgos(mm,nm,nm,im,jc,w_Ydata,xv_pdata,&
              it,t,p,q,r,ws2,wg,w,1)
      else
         call sjpg2s(mm,nm,nm,im,jc,w_Ydata,xv_pdata,&
              it,t,p,q,r,ws2,wg,w,1)
      endif
      call sjcrdn(mm,nm,w_Ydata,w_Xdata)
      call sjcs2x(mm,w_Xdata,w_Vor)
      call sjcy2s(mm,w_Ydata,w_Data2,c)
      !
      !  渦度・発散の計算
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      w_Vor = w_Vor - w_Data1
      w_Div = w_Div + w_Data2

    end subroutine w_Vector2VorDivMPI

    subroutine w_VectorCosLat2VorDivMPI(xv_UCosLat, xv_VCosLat, w_Vor, w_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(1 層用, MPI)
      ! 
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xv_UCosLat(0:im-1,1:jc)
      !(in) 速度経度成分 * cos(lat)
      real(8), intent(in)   :: xv_VCosLat(0:im-1,1:jc)
      !(in) 速度緯度成分 * cos(lat)

      real(8), intent(out)   :: w_Vor((mm+1)*(mm+1))
      !(out) 流線関数
      real(8), intent(out)   :: w_Div((mm+1)*(mm+1))
      !(out) 速度ポテンシャル

      real(8)             :: w_Xdata((mm+1)*(mm+1))
      ! 作業用スペクトルデータ(SJCS2X 出力用)
      real(8)             :: w_Ydata((mm+4)*nm+2)
      ! 作業用スペクトルデータ(SJCY2S 出力用)

      real(8)  :: w_Data1((mm+1)*(mm+1))
      real(8)  :: w_Data2((mm+1)*(mm+1))

      real(8)  :: ws2(2*(nm+1)*np+(2*NM+1-MM)*MM+NM+1) ! 変換用作業配列

      logical :: first=.true.                     ! 初回判定スイッチ
      save first

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','w_VectorCosLat2VorDivMPI',&
              'w_base_module not initialize yet.')
      endif

      if ( openmp .and. first ) then
         call MessageNotify('M','w_VectorCosLat2VorDiv', &
              'OpenMP routine SJPGOS/SNPACK-MPI is used for spherical harmonic transformation.')
      endif
      first = .false.

      !
      ! 1/cosφ∂u/∂λ, 1/cosφ ∂(u cosφ)/∂φ の計算
      !
      xv_pdata = xv_UCosLat
      if ( openmp ) then
         call sjpgos(mm,nm,nm,im,jc,w_Ydata,xv_pdata,&
              it,t,p,q,r,ws2,wg,w,2)
      else
         call sjpg2s(mm,nm,nm,im,jc,w_Ydata,xv_pdata,&
              it,t,p,q,r,ws2,wg,w,2)
      endif
      call sjcrdn(mm,nm,w_Ydata,w_Xdata)
      call sjcs2x(mm,w_Xdata,w_Div)
      call sjcy2s(mm,w_Ydata,w_Data1,c)
      !
      ! 1/cosφ∂v/∂λ, 1/cosφ ∂(v cosφ)/∂φ の計算
      !
      xv_pdata = xv_VCosLat
      if ( openmp ) then
         call sjpgos(mm,nm,nm,im,jc,w_Ydata,xv_pdata,&
              it,t,p,q,r,ws2,wg,w,2)
      else
         call sjpg2s(mm,nm,nm,im,jc,w_Ydata,xv_pdata,&
              it,t,p,q,r,ws2,wg,w,2)
      endif
      call sjcrdn(mm,nm,w_Ydata,w_Xdata)
      call sjcs2x(mm,w_Xdata,w_Vor)
      call sjcy2s(mm,w_Ydata,w_Data2,c)
      !
      !  渦度・発散の計算
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      w_Vor = w_Vor - w_Data1
      w_Div = w_Div + w_Data2

    end subroutine w_VectorCosLat2VorDivMPI

  !--------------- 終了処理 -----------------
    subroutine w_base_mpi_Finalize
      !
      ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
      !
      ! 実際の使用には上位サブルーチン w_Finalize を用いること.
      !
      if ( .not. w_base_initialize ) then
         call MessageNotify('W','w_base_mpi_Finalize',&
              'w_base_mpi_module_sjpack not initialized yet')
         return
      endif

      deallocate(p)              ! 変換用配列
      deallocate(r)              ! 変換用配列
      deallocate(c)              ! 変換用作業配列

      deallocate(v_Lat,v_Lat_Weight)   ! 格子点座標格納配列
      deallocate(xv_Lon,xv_Lat)        ! 格子点座標格納配列
      deallocate(y)

      nullify(xv_pdata)              ! 変換用作業配列
      nullify(q)                     ! 変換用作業配列
      nullify(t)                     ! 変換用作業配列
      nullify(w)                     ! 変換用作業配列
      nullify(wg)                    ! 変換用作業配列
      call mlfree(pg)                ! 変換用作業配列
      call mlfree(pq)                ! 変換用作業配列
      call mlfree(pt)                ! 変換用作業配列
      call mlfree(pw)                ! 変換用作業配列
      call mlfree(pwg)               ! 変換用作業配列      

      w_base_initialize = .false.

      call MessageNotify('M','w_base_mpi_Finalize',&
           'w_base_mpi_module_sjpack (2016/07/07) for AVX is finalized')

    end subroutine w_base_mpi_Finalize

end module w_base_mpi_module_sjpack

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_mpi_module テストプログラム (境界値問題, トロイダル磁場, Tau 法)
!
!履歴  2016/09/21  竹広真一
!
program tee_mpi_module_tormagbctau_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=10       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8), allocatable :: zvx_Tormag(:,:,:)      ! 格子データ

  real(8), allocatable :: vx_BoundaryTop(:,:)    ! 格子データ
  real(8), allocatable :: vx_BoundaryBtm(:,:)    ! 格子データ

  real(8), allocatable :: tef_Tormag(:,:,:)      ! スペクトルデータ
  real(8), allocatable :: tef_Tormag_orig(:,:,:) ! スペクトルデータ

  integer            :: l=2, m=5
  integer            :: np, ip, ierr
  
 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','tee_mpi_module_TormagbcTau_test', &
       'tee_mpi_module toroidal mag. field B.C. subruoutine tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

 !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call tee_mpi_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

  allocate(zvx_Tormag(0:km,jc(ip),0:im-1))      ! 格子データ

  allocate(vx_BoundaryTop(jc(ip),0:im-1))     ! 格子データ
  allocate(vx_BoundaryBtm(jc(ip),0:im-1))     ! 格子データ

  allocate(tef_Tormag(0:nm,-mm:mm,2*lc(ip)))      ! スペクトルデータ
  allocate(tef_Tormag_orig(0:nm,-mm:mm,2*lc(ip))) ! スペクトルデータ

 !-------------------BC-DD(Tau) ----------------------
  zvx_Tormag = sin(l*pi*zvx_X) * sin(m*pi*zvx_Y) * zvx_Z
  vx_BoundaryTop = 0.0D0
  vx_BoundaryBtm = 0.0D0

  tef_Tormag = tef_zvx(zvx_Tormag)
  tef_Tormag_orig = tef_Tormag

  call tef_TormagBoundariesTau(tef_Tormag)
  zvx_Tormag = zvx_tef(tef_Tormag)

  call AssertEqual(&
    message='tef_TormagBoundariesTau [internal]',&
    answer = tef_Tormag_orig(0:nm-2,:,:),                         &
    check = tef_Tormag(0:nm-2,:,:),                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tef_TormagBoundariesTau [Top]',&
    answer = zvx_Tormag(0,:,:),                                   &
    check = vx_BoundaryTop,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tef_TormagBoundariesTau [Bottom]', &
    answer = zvx_Tormag(km,:,:),                                  &
    check = vx_BoundaryBtm,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MPI_FINALIZE(IERR)

  call MessageNotify('M','tee_mpi_module_TormagbcTau_test', &
       'tee_mpi_module toroidal mag. field B.C. subruoutine tests succeeded!')

end program tee_mpi_module_tormagbctau_test

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wtq_mpi_module_supack テストプログラム
!
!      磁場トロイダルポテンシャルの境界値問題
!
!履歴  2016/04/04  竹広真一  wtq_mpi_module_sjpack_test_tormagbctgrid.f90 より改変
!
program wtq_mpi_supack_tormagbcgrid

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use mpi
  use wtq_mpi_module_supack

  implicit none

  integer,parameter  :: im=32, jm=16         ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: kmo=16, kmi=8        ! 格子点の設定(球殻動径, 球動径)
  integer,parameter  :: nm=10                ! 切断波数の設定(水平)
  integer,parameter  :: lmo=10, lmi=15       ! 切断波数の設定(球殻動径, 球動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), allocatable :: xvz_TORMAG(:,:,:)
  real(8), allocatable :: wz_TORMAG(:,:)
  real(8), allocatable :: xvr_TORMAG(:,:,:)
  real(8), allocatable :: wr_TORMAG(:,:)
  real(8), allocatable :: xvz_DTORDR(:,:,:)
  real(8), allocatable :: xvr_DTORDR(:,:,:)

  real(8), allocatable :: xv_Null(:,:)

  real(8), parameter  :: Pmo = 1.0           ! 球殻の磁気プランドル数
  real(8), parameter  :: Pmi = 2.0           ! 内球の磁気プランドル数

  real(8), parameter  :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wtq_mpi_module_supack_tormagbcgrid_test', &
       'wq_mpi_module_supack  wtq_TormagBoundariesTau subroutine test')

  call wtq_mpi_Initial(im,jm,kmi,kmo,nm,lmi,lmo,ri,ro)

  allocate(xvz_TORMAG(0:im-1,jc,0:kmo))
  allocate(wz_TORMAG(nc,0:kmo))
  allocate(xvr_TORMAG(0:im-1,jc,kmi))
  allocate(wr_TORMAG (nc,kmi))
  allocate(xvz_DTORDR(0:im-1,jc,0:kmo))
  allocate(xvr_DTORDR(0:im-1,jc,kmi))
              
  allocate(xv_Null(0:im-1,jc))

  xv_Null = 0.0D0

  !==================== wtq_TormagBoundariesGrid =========================
  ! P_10

  xvz_TORMAG = sin(xvz_lat) * cos( pi*(xvz_rad-ri)/(ro-ri) )
  xvr_TORMAG = sin(xvr_lat) * cos( pi*(xvr_rad-ri)/ri ) * xvr_Rad

  wz_TORMAG = wz_xvz(xvz_TORMAG)
  wr_TORMAG = wr_xvr(xvr_TORMAG)
  call wtq_TormagBoundariesGrid(wz_TORMAG,wr_TORMAG,Pmo,Pmi)
  xvz_TORMAG = xvz_wz(wz_TORMAG)
  xvr_TORMAG = xvr_wr(wr_TORMAG)

  xvz_DTORDR = xvz_wt(wt_DRad_wt(wt_wz(wz_TORMAG)))
  xvr_DTORDR = xvr_wq(wq_RadDRad_wq(wq_wr(wr_TORMAG)))/xvr_Rad

  call checkresults

  ! P_1_1
  xvz_TORMAG = cos(xvz_lat)*cos(xvz_lon)* cos( pi*(xvz_rad-ri)/(ro-ri) )
  xvr_TORMAG = cos(xvr_lat)*cos(xvr_lon)* cos( pi*(xvr_rad-ri)/ri )*xvr_Rad

  wz_TORMAG = wz_xvz(xvz_TORMAG)
  wr_TORMAG = wr_xvr(xvr_TORMAG)
  call wtq_TormagBoundariesGrid(wz_TORMAG,wr_TORMAG,Pmo,Pmi)
  xvz_TORMAG = xvz_wz(wz_TORMAG)
  xvr_TORMAG = xvr_wr(wr_TORMAG)

  xvz_DTORDR = xvz_wt(wt_DRad_wt(wt_wz(wz_TORMAG)))
  xvr_DTORDR = xvr_wq(wq_RadDRad_wq(wq_wr(wr_TORMAG)))/xvr_Rad

  call checkresults

  call MessageNotify('M','wtq_mpi_module_supack_tormagbcgrid_test', &
       'wtq_mpi_module_supack  wtq_TormagBoundariesTau subroutine test succeded')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

contains

  subroutine checkresults

    call AssertEqual(&
      message='Top B.C',                                            &
      answer = xvz_TORMAG(:,:,0),                                   &
      check = xv_Null,                                              &
      significant_digits = check_digits, ignore_digits = ignore     &
      )

    call AssertEqual(&
      message='Inner B.C (value conituity) ',                       &
      answer = xvz_TORMAG(:,:,kmo),                                 &
      check = xvr_TORMAG(:,:,kmi),                                  &
      significant_digits = check_digits, ignore_digits = ignore     &
      )

    call AssertEqual(&
      message='Inner B.C (derivative conituity) ',                  &
      answer = Pmo*xvz_DTORDR(:,:,kmo),                             &
      check = Pmi*xvr_DTORDR(:,:,kmi),                              &
      significant_digits = check_digits, ignore_digits = ignore     &
      )

  end subroutine checkresults

end program wtq_mpi_supack_tormagbcgrid

!------------------------------------------------------------------------
! Copyright (c) 2005-2011 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  ee_module テストプログラム (正逆変換)
!
!履歴  2005/07/19  竹広真一
!      2007/11/09  竹広真一  エラーメッセージ追加
!      2011/02/15  佐々木洋平 dc_test を使うように変更
!
program ee_test_transform

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: ee_Data(-lm:lm,-km:km)    ! スペクトルデータ

  integer            :: k=2,l=5

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','ee_test_transform', &
       'ee_module transform function tests')

 !---------------- 座標値の設定 ---------------------
  call ee_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
!!  write(6,*) '*** Test of ee_module : grid -> spectral -> grid transformation check.'
!!  write(6,*) '  The result will be printed '
!!  write(6,*) '  only when the error is larger than ', eps
!!  write(6,*)

!!$  write(6,*) '  Input wavenumbers of the grid data, k and l :'
!!$  read(5,*) k,l
!!  write(6,*) '  k,l = ', k,l

  yx_Data = sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  ee_Data = 0.0 ; ee_Data(-l,k) = 0.25  ; ee_Data(l,k) = -0.25
  call check(ee_yx(yx_Data), ee_Data, &
       'Transform sin(k*pi*X)*sin(l*pi*Y)')
  call check(yx_ee(ee_yx(yx_Data)), yx_Data, &
       'Inverse transform sin(k*pi*X)*sin(l*pi*Y)')

  yx_Data = cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  ee_Data = 0.0 ; ee_Data(l,k) = 0.25  ; ee_Data(-l,k) = 0.25
  call check(ee_yx(yx_Data), ee_Data, &
       'Transform cos(k*pi*X)*cos(l*pi*Y)')
  call check(yx_ee(ee_yx(yx_Data)), yx_Data, &
       'Inverse transoform cos(k*pi*X)*cos(l*pi*Y)')

  yx_Data = sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  ee_Data = 0.0 ; ee_Data(-l,-k) = -0.25  ; ee_Data(l,-k) = - 0.25
  call check(ee_yx(yx_Data), ee_Data, &
       'Transform sin(k*pi*X)*cos(l*pi*Y)')
  call check(yx_ee(ee_yx(yx_Data)), yx_Data, &
       'Inverse transform sin(k*pi*X)*cos(l*pi*Y)')

  yx_Data = cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  ee_Data = 0.0 ; ee_Data(-l,-k) = -0.25  ; ee_Data(l,-k) = 0.25
  call check(ee_yx(yx_Data), ee_Data, &
       'Transform cos(k*pi*X)*sin(l*pi*Y)')
  call check(yx_ee(ee_yx(yx_Data)), yx_Data, &
       'Inverse transform cos(k*pi*X)*sin(l*pi*Y)')

  call MessageNotify('M','ee_test_transform', &
       'ee_module transform function tests succeeded!')
contains

  subroutine check(var,sol,funcname)
    real(8) :: var(:,:)                ! 判定する配列
    real(8) :: sol(:,:)                ! 誤差
    character(len=*) :: funcname

    call AssertEqual(     &
      message = funcname, &
      answer = sol,       &
      check = var,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check

end program ee_test_transform

!------------------------------------------------------------------------
! Copyright (c) 2002-2011 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  ee_module テストプログラム (補間計算)
!
!履歴  2008/10/28  竹広真一
!      2011/02/15  佐々木洋平 dc_test を使うように変更
!
program ee_test_transform

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: yx_Data1(0:jm-1,0:im-1)   ! 格子データ
  real(8)            :: ee_Data(-lm:lm,-km:km)    ! スペクトルデータ

  integer            :: k=2,l=5
  integer            :: i, j

 !---- 座標変数など ----
!!$  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: xmin = 0.0d0, xmax=4.0d0
!!$  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0
  real(8), parameter :: ymin = 2.0d0, ymax=4.0d0

  real(8), parameter :: x0 = 2.0/3.0, x1=3.0/5.0d0
  real(8), parameter :: y0 = 1.0/7.0, y1=5.0/9.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','ee_test_transform', &
       'ee_module transform function tests')

 !---------------- 座標値の設定 ---------------------
  call ee_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------

!!$  write(6,*) '  Input wavenumbers of the grid data, k and l :'
!!$  read(5,*) k,l
!!$  write(6,*) '  k,l = ', k,l

  yx_Data = sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  ee_Data = ee_yx(yx_Data)
  do i=0,im-1
     do j=0,jm-1
        yx_Data1(j,i) = Interpolate_ee( ee_Data, x_X(i), y_Y(j) )
     enddo
  enddo
  call check2d(yx_Data1, yx_Data, 'Interpolation sin(k*pi*X)*sin(l*pi*Y)')
  call check0d(sin(k*pi*x0)*sin(l*pi*y0), Interpolate_ee(ee_Data, x0, y0), &
    'check (x0, y0)')
  call check0d(sin(k*pi*x1)*sin(l*pi*y1), Interpolate_ee(ee_Data, x1, y1), &
    'check (x1, y1)')

  yx_Data = cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  ee_Data = ee_yx(yx_Data)
  do i=0,im-1
     do j=0,jm-1
        yx_Data1(j,i) = Interpolate_ee( ee_Data, x_X(i), y_Y(j) )
     enddo
  enddo
  call check2d(yx_Data1, yx_Data, 'Interpolation cos(k*pi*X)*cos(l*pi*Y)')
  call check0d(cos(k*pi*x0)*cos(l*pi*y0), Interpolate_ee(ee_Data, x0, y0), &
    'check (x0, y0)')
  call check0d(cos(k*pi*x1)*cos(l*pi*y1), Interpolate_ee(ee_Data, x1, y1), &
    'check (x1, y1)')

  yx_Data = sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  ee_Data = ee_yx(yx_Data)
  do i=0,im-1
     do j=0,jm-1
        yx_Data1(j,i) = Interpolate_ee( ee_Data, x_X(i), y_Y(j) )
     enddo
  enddo
  call check2d(yx_Data1, yx_Data, 'Interpolation sin(k*pi*X)*cos(l*pi*Y)')
  call check0d(sin(k*pi*x0)*cos(l*pi*y0), Interpolate_ee(ee_Data, x0, y0), &
    'check (x0, y0)')
  call check0d(sin(k*pi*x1)*cos(l*pi*y1), Interpolate_ee(ee_Data, x1, y1), &
    'check (x1, y1)')

  yx_Data = cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  ee_Data = ee_yx(yx_Data)
  do i=0,im-1
     do j=0,jm-1
        yx_Data1(j,i) = Interpolate_ee( ee_Data, x_X(i), y_Y(j) )
     enddo
  enddo
  call check2d(yx_Data1, yx_Data, 'Interpolation cos(k*pi*X)*sin(l*pi*Y)')
  call check0d(cos(k*pi*x0)*sin(l*pi*y0), Interpolate_ee(ee_Data, x0, y0), &
    'check (x0, y0)')
  call check0d(cos(k*pi*x1)*sin(l*pi*y1), Interpolate_ee(ee_Data, x1, y1), &
    'check (x1, y1)')

  yx_Data = sin(k*pi*yx_X)
  ee_Data = ee_yx(yx_Data)
  do i=0,im-1
     do j=0,jm-1
        yx_Data1(j,i) = Interpolate_ee( ee_Data, x_X(i), y_Y(j) )
     enddo
  enddo
  call check2d(yx_Data1, yx_Data, 'Interpolation sin(k*pi*X)')
  call check0d(sin(k*pi*x0), Interpolate_ee(ee_Data, x0, y0), &
    'check (x0, y0)')
  call check0d(sin(k*pi*x1), Interpolate_ee(ee_Data, x1, y1), &
    'check (x1, y1)')

  yx_Data = cos(k*pi*yx_X)
  ee_Data = ee_yx(yx_Data)
  do i=0,im-1
     do j=0,jm-1
        yx_Data1(j,i) = Interpolate_ee( ee_Data, x_X(i), y_Y(j) )
     enddo
  enddo
  call check2d(ee_yx(yx_Data), ee_Data, 'Interpolation cos(k*pi*X)')

  call check0d(cos(k*pi*x0), Interpolate_ee(ee_Data, x0, y0), &
    'check (x0, y0)')
  call check0d(cos(k*pi*x1), Interpolate_ee(ee_Data, x1, y1), &
    'check (x1, y1)')

  yx_Data = cos(l*pi*yx_Y)
  ee_Data = ee_yx(yx_Data)
  do i=0,im-1
     do j=0,jm-1
        yx_Data1(j,i) = Interpolate_ee( ee_Data, x_X(i), y_Y(j) )
     enddo
  enddo
  call check2d(yx_Data1, yx_Data, 'Interpolation cos(l*pi*Y)')
  call check0d(cos(l*pi*y0), Interpolate_ee(ee_Data, x0, y0),&
    'check (x0, y0)')
  call check0d(cos(l*pi*y1), Interpolate_ee(ee_Data, x1, y1),&
    'check (x1, y1)')

  yx_Data = sin(l*pi*yx_Y)
  ee_Data = ee_yx(yx_Data)
  do i=0,im-1
     do j=0,jm-1
        yx_Data1(j,i) = Interpolate_ee( ee_Data, x_X(i), y_Y(j) )
     enddo
  enddo
  call check2d(yx_Data1, yx_Data, 'Interpolation sin(l*pi*Y)')
  call check0d(sin(l*pi*y0), Interpolate_ee(ee_Data, x0, y0),&
    'check (x0, y0)')
  call check0d(sin(l*pi*y1), Interpolate_ee(ee_Data, x1, y1),&
    'check (x1, y1)')

  yx_Data = 1.0D0
  ee_Data = ee_yx(yx_Data)
  do i=0,im-1
     do j=0,jm-1
        yx_Data1(j,i) = Interpolate_ee( ee_Data, x_X(i), y_Y(j) )
     enddo
  enddo
  call check2d(yx_Data1, yx_Data, 'Interpolation 1.0')

  call check0d(1.0D0, Interpolate_ee(ee_Data, x0, y0), 'check (x0, y0)')
  call check0d(1.0D0, Interpolate_ee(ee_Data, x1, y1), 'check (x1, y1)')

  call MessageNotify('M','ee_test_Interpolate', &
       'ee_module Interpolation function tests succeeded!')

 stop
contains

  subroutine check0d(var0,sol0,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var0                     ! 判定する配列
    real(8) :: sol0                     ! 誤差
    character(len=*)  :: funcname
    call AssertEqual(      &
      message = funcname,  &
      answer = sol0,       &
      check = var0,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check0d

  subroutine check2d(var,sol,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:)                ! 判定する配列
    real(8) :: sol(:,:)
    character(len=*) :: funcname

    call AssertEqual(     &
      message = funcname, &
      answer = sol,       &
      check = var,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check2d

end program ee_test_transform

!----------------------------------------------------------------------
!     Copyright (c) 2011 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_module_sjpack_cuda テストプログラム
!
!      トロイダルポロイダル関係微分関数のテスト
!  
!履歴  2011/03/12  竹広真一  wt_module_sjpack_deriv_test2.f90 を CUDA 用に改造
!
program wt_module_sjpack_cuda_derivative_test2

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wt_module_sjpack_cuda
  implicit none

  integer,parameter  :: im=512, jm=256, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=170, lm=16          ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5         ! 内外半径

  ! 判定誤差設定
  integer, parameter :: check_digits = 6
  integer, parameter :: ignore = -5

  real(8), dimension(0:im-1,jm,0:km)     :: xyz_DData
  real(8), dimension(0:im-1,jm,0:km)     :: xyz_Psi
  real(8), dimension((nm+1)**2,0:lm)     :: wt_Psi
  real(8), dimension((nm+1)**2,0:lm)     :: wt_Phi

  real(8), dimension(0:im-1,jm,0:km)     :: xyz_VLon
  real(8), dimension(0:im-1,jm,0:km)     :: xyz_VLat
  real(8), dimension(0:im-1,jm,0:km)     :: xyz_VRad
  real(8), dimension(0:im-1,jm,0:km)     :: xyz_RadRot
  real(8), dimension(0:im-1,jm,0:km)     :: xyz_RadRotRot

  integer, parameter :: n=2

  call MessageNotify('M','wt_module_sjpack_cuda_derivative_test2', &
       'wt_module_sjpack_cuda derivative function test #2')

  call wt_initial(im,jm,km,nm,lm,ri,ro)

  !========== wt_KxRGrad_wt, xyz_KGrad_wt, wt_QOperator_wt ==========

  ! ----------------- 例 1 --------------------
  xyz_Psi = xyz_rad**n * cos(xyz_lat)*sin(xyz_lon)   ! r**2 Y_1^-1

  xyz_DData = xyz_rad**n * cos(xyz_lat)*cos(xyz_lon)
  call AssertEqual(&
       message='wt_KxRGrad_wt with r^2 Y_1^-1',                      &
       answer = xyz_DData,                                           &
       check = xyz_wt(wt_KxRGrad_wt(wt_xyz(xyz_Psi))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! k ・▽ r**n Y_1^1 = (n-1)*r**(n-1)* Y_2^1
  xyz_DData = (n-1)*xyz_rad**(n-1)* cos(xyz_lat)*sin(xyz_lat)*sin(xyz_lon) 
  call AssertEqual(&
       message='xyz_KGrad_wt with r^2 Y_1^-1',                       &
       answer = xyz_DData,                                           &
       check = xyz_KGrad_wt(wt_xyz(xyz_Psi)),                        &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! Q r**n Y_1^1 = -3*(n-1)*r**(n-1)* Y_2^1
  xyz_DData = - 3*(n-1)*xyz_rad**(n-1)* cos(xyz_lat)*sin(xyz_lat)*sin(xyz_lon) 
  call AssertEqual(&
       message='wt_QOperator_wt r^2 Y_1^-1',                         &
       answer = xyz_DData,                                           &
       check = xyz_wt(wt_QOperator_wt(wt_xyz(xyz_Psi))),             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

! ----------------- 例 2 --------------------
  xyz_Psi = cos(xyz_lat)*sin(xyz_lat) * sin(xyz_lon) ! Y_2^1

  xyz_DData = cos(xyz_lat)*sin(xyz_lat) * cos(xyz_lon) ! Y_2^1
  call AssertEqual(&
       message='wt_KxRGrad_wt with Y_2^1',                           &
       answer = xyz_DData,                                           &
       check = xyz_wt(wt_KxRGrad_wt(wt_xyz(xyz_Psi))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! k・▽ Y_2^1 = (- 4 Y_3^1 / 15 - Y_1^1 /5) 
  xyz_DData = cos(2*xyz_lat)*cos(xyz_lat)*sin(xyz_lon)/xyz_rad
  call AssertEqual(&
       message='xyz_KGrad_wt with Y_2^1',                            &
       answer = xyz_DData,                                           &
       check = xyz_KGrad_wt(wt_xyz(xyz_Psi)),                        &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_DData = (16*sin(xyz_lat)**2 - 5)*cos(xyz_lat)*sin(xyz_lon)/xyz_rad
  call AssertEqual(&
       message='wt_QOperator_wt Y_2^1',                              &
       answer = xyz_DData,                                           &
       check = xyz_wt(wt_QOperator_wt(wt_xyz(xyz_Psi))),             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  !========== wt_RadRot_xyz_xyz, wt_RadRotRot_xyz_xyz_xyz ==========

  !---------- 単純流れ v_r=r ----------
  xyz_VLon = 0 ; xyz_VLat = 0 ; xyz_VRad = xyz_Rad
  xyz_RadRot = 0 ; xyz_RadRotRot = 0

  call AssertEqual(&
       message='wt_RadRot_xyz_xyz with v_r=r',                       &
       answer = xyz_RadRot,                                          &
       check = xyz_wt(wt_RadRot_xyz_xyz(xyz_VLon,xyz_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wt_RadRotRot_xyz_xyz with v_r=r',                    &
       answer = xyz_RadRotRot,                                       &
       check = xyz_wt(wt_RadRotRot_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !---------- 剛体回転解非線形項(東西流れ) ----------
  xyz_VLon = 0
  xyz_VLat = xyz_Rad*sin(xyz_Lat)*cos(xyz_Lat)
  xyz_VRad = -xyz_Rad*cos(xyz_Lat)**2

  xyz_RadRot = 0 ; xyz_RadRotRot = 0

  call AssertEqual(&
       message='wt_RadRot_xyz_xyz with rigid rotation(E-W)',         &
       answer = xyz_RadRot,                                          &
       check = xyz_wt(wt_RadRot_xyz_xyz(xyz_VLon,xyz_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wt_RadRotRot_xyz_xyz with rigid rotation(E-W)',      &
       answer = xyz_RadRotRot,                                       &
       check = xyz_wt(wt_RadRotRot_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  !---------- 剛体回転解非線形項(南北流れ) ----------
  xyz_VLon = xyz_Rad*cos(xyz_Lat)*sin(xyz_Lon)*cos(xyz_Lon)
  xyz_VLat = -xyz_Rad*sin(xyz_Lat)*cos(xyz_Lat)*sin(xyz_Lon)**2
  xyz_VRad = -xyz_Rad*(sin(xyz_Lat)**2*sin(xyz_Lon)**2 + cos(xyz_Lon)**2)
  xyz_RadRot = 0 ; xyz_RadRotRot = 0

  call AssertEqual(&
      message='wt_RadRot_xyz_xyz with rigid rotation(N-S)',          &
       answer = xyz_RadRot,                                          &
       check = xyz_wt(wt_RadRot_xyz_xyz(xyz_VLon,xyz_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wt_RadRotRot_xyz_xyz with rigid rotation(N-S)',      &
       answer = xyz_RadRotRot,                                       &
       check = xyz_wt(wt_RadRotRot_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  !--------- 鉛直渦度を伴うベクトル場 ----------
  xyz_Psi = xyz_Rad**2 * cos(xyz_Lat)*sin(xyz_Lon)   ! r**2 P_1^1
  !xyz_Psi = xyz_Rad**2 * cos(xyz_Lat)*sin(xyz_Lat)*sin(xyz_Lon)   ! r**2 P_2^1

  xyz_VLon =   xyz_gRadLat_wt(wt_xyz(xyz_Psi*xyz_Rad))
  xyz_VLat = - xyz_gRadLon_wt(wt_xyz(xyz_Psi*xyz_Rad))
  xyz_VRad = 0
  xyz_RadRot = 2 * xyz_Psi                           ! r・▽×▽×(ψr) = L_2ψ
  !xyz_RadRot = 6 * xyz_Psi                           ! r・▽×▽×(ψr) = L_2ψ
  xyz_RadRotRot = 0

  call AssertEqual(&
      message='wt_RadRot_xyz_xyz with r^2 Y_1^-1 toroidal field',    &
       answer = xyz_RadRot,                                          &
       check = xyz_wt(wt_RadRot_xyz_xyz(xyz_VLon,xyz_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wt_RadRotRot_xyz_xyz with r^2 Y_1^-1 toroidal field',&
       answer = xyz_RadRotRot,                                       &
       check = xyz_wt(wt_RadRotRot_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !---------- 鉛直速度を伴うベクトル場 -----------
  xyz_VRad = xyz_wt(wt_l2_wt(wt_xyz(xyz_Psi/xyz_Rad)))
  xyz_VLat = xyz_gRadLat_wt(wt_dRad_wt(wt_xyz(xyz_Psi*xyz_Rad)))
  xyz_VLon = xyz_gRadLon_wt(wt_dRad_wt(wt_xyz(xyz_Psi*xyz_Rad)))

  xyz_RadRot = 0
  xyz_RadRotRot = -xyz_wt(wt_l2_wt(wt_lapla_wt(wt_xyz(xyz_Psi))))
                 ! r・▽×▽×▽×▽×(ψr) = -L_2▽^2ψ

  call AssertEqual(&
      message='wt_RadRot_xyz_xyz with non-vortical field',           &
       answer = xyz_RadRot,                                          &
       check = xyz_wt(wt_RadRot_xyz_xyz(xyz_VLon,xyz_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wt_RadRotRot_xyz_xyz with r^2 Y_1^-1 toroidal field',&
       answer = xyz_RadRotRot,                                       &
       check = xyz_wt(wt_RadRotRot_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  !========== wt_Potential2Vector, wt_Potential2Rotation ==========

  !----------------- 剛体回転場 --------------------
  ! 
  wt_Psi = wt_xyz(xyz_Rad * sin(xyz_Lat))
  wt_Phi = 0.0D0

  call wt_Potential2Vector(&
       xyz_VLon,xyz_VLat,xyz_VRad, wt_Psi, wt_Phi )

  xyz_DData = xyz_Rad * cos(xyz_Lat)
  call AssertEqual(&
      message='wt_Potential2Vector (Lon) with rigid rotation field(E-W)', &
       answer = xyz_VLon,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 0.0D0
  call AssertEqual(&
      message='wt_Potential2Vector (Lat) with rigid rotation field(E-W)', &
       answer = xyz_VLat,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 0.0D0
  call AssertEqual(&
      message='wt_Potential2Vector (Rad) with rigid rotation field(E-W)', &
       answer = xyz_VRad,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call wt_Potential2Rotation(&
       xyz_VLon,xyz_VLat,xyz_VRad, wt_Psi, wt_Phi )

  xyz_DData = 0.0D0
  call AssertEqual(&
      message='wt_Potential2Rotation (Lon) with rigid rotation field(E-W)', &
       answer = xyz_VLon,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 2*cos(xyz_LAT)
  call AssertEqual(&
      message='wt_Potential2Rotation (Lat) with rigid rotation field(E-W)', &
       answer = xyz_VLat,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 2*sin(xyz_LAT)
  call AssertEqual(&
      message='wt_Potential2Rotation (Rad) with rigid rotation field(E-W)', &
       answer = xyz_VRad,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !----------------- 剛体回転場(南北流) --------------------
  ! 
  wt_Psi = wt_xyz(xyz_Rad * cos(xyz_Lat) * sin(xyz_Lon))
  wt_Phi = 0.0D0

  call wt_Potential2Vector(&
       xyz_VLon,xyz_VLat,xyz_VRad, wt_Psi, wt_Phi )

  xyz_DData = -xyz_Rad*sin(xyz_Lat)*sin(xyz_Lon)
  call AssertEqual(&
      message='wt_Potential2Vector (Lon) with rigid rotation field(N-S)', &
       answer = xyz_VLon,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = -xyz_Rad*cos(xyz_Lon)
  call AssertEqual(&
      message='wt_Potential2Vector (Lat) with rigid rotation field(N-S)', &
       answer = xyz_VLat,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 0.0D0
  call AssertEqual(&
      message='wt_Potential2Vector (Rad) with rigid rotation field(N-S)', &
       answer = xyz_VRad,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call wt_Potential2Rotation(&
       xyz_VLon,xyz_VLat,xyz_VRad, wt_Psi, wt_Phi )

  xyz_DData = 2*cos(xyz_Lon)
  call AssertEqual(&
      message='wt_Potential2Rotation (Lon) with rigid rotation field(N-S)', &
       answer = xyz_VLon,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = -2*sin(xyz_Lon)*sin(xyz_Lat)
  call AssertEqual(&
      message='wt_Potential2Rotation (Lat) with rigid rotation field(N-S)', &
       answer = xyz_VLat,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 2*sin(xyz_Lon)*cos(xyz_Lat)
  call AssertEqual(&
      message='wt_Potential2Rotation (Rad) with rigid rotation field(N-S)', &
       answer = xyz_VRad,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ----------------- 渦無し場 --------------------
  wt_Psi = 0.0D0
  wt_Phi = wt_xyz(xyz_Rad * sin(xyz_Lat))

  call wt_Potential2Vector(&
       xyz_VLon,xyz_VLat,xyz_VRad, wt_Psi, wt_Phi )

  xyz_DData = 0
  call AssertEqual(&
       message='wt_Potential2Vector (Lon) with non-vortical field',  &
       answer = xyz_VLon,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 2 * cos(xyz_Lat)
  call AssertEqual(&
       message='wt_Potential2Vector (Lat) with non-vortical field',  &
       answer = xyz_VLat,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 2 * sin(xyz_Lat)
  call AssertEqual(&
      message='wt_Potential2Vector (Rad) with non-vortical field', &
       answer = xyz_VRad,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call wt_Potential2Rotation(&
       xyz_VLon,xyz_VLat,xyz_VRad, wt_Psi, wt_Phi )

  xyz_DData = 0.0D0
  call AssertEqual(&
      message='wt_Potential2Rotation (Lon) with non-vortical field', &
       answer = xyz_VLon,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 0.0D0
  call AssertEqual(&
      message='wt_Potential2Rotation (Lat) with non-vortical field', &
       answer = xyz_VLat,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 0.0D0
  call AssertEqual(&
      message='wt_Potential2Rotation (Rad) with non-vortical field', &
       answer = xyz_VRad,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

! ----------------- 例 4 --------------------
 ! ポロイダル速度場

  wt_Psi = 0.0D0
  wt_Phi = wt_xyz(xyz_Rad**2 * cos(xyz_Lat)*sin(xyz_Lon))

  call wt_Potential2Vector(&
       xyz_VLon,xyz_VLat,xyz_VRad, wt_Psi, wt_Phi )

  xyz_DData = 3 * xyz_Rad * cos(xyz_Lon)
  call AssertEqual(&
      message='wt_Potential2Vector (Lon) with poloidal field',   &
       answer = xyz_VLon,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = - 3 * xyz_Rad * sin(xyz_Lat) * sin(xyz_Lon)
  call AssertEqual(&
      message='wt_Potential2Vector (Lat) with poloidal field', &
       answer = xyz_VLat,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 2 * xyz_Rad * cos(xyz_Lat) * sin(xyz_Lon)
  call AssertEqual(&
      message='wt_Potential2Vector (Rad) with poloidal field', &
       answer = xyz_VRad,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call wt_Potential2Rotation(&
       xyz_VLon,xyz_VLat,xyz_VRad, wt_Psi, wt_Phi )

  xyz_DData = 4*sin(xyz_Lat)*sin(xyz_Lon)
  call AssertEqual(&
      message='wt_Potential2Rotation (Lon) with poloidal field', &
       answer = xyz_VLon,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 4*cos(xyz_Lon)
  call AssertEqual(&
      message='wt_Potential2Rotation (Lat) with poloidal field', &
       answer = xyz_VLat,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 0.0D0
  call AssertEqual(&
      message='wt_Potential2Rotation (Rad) with poloidal field', &
       answer = xyz_VRad,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','wt_module_sjpack_cuda_derivative_test2', &
       'wt_module_sjpack_cuda derivative function test #2 succeeded!')

end program wt_module_sjpack_cuda_derivative_test2

!------------------------------------------------------------------------
! Copyright (c) 2016 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  ee_mpi_module テストプログラム (パワースペクトル計算)
!
!履歴  2016/08/08  竹広真一
!
!
program ee_mpi_module_spectrum_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10            ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8), allocatable :: vx_Data(:,:)          ! 格子データ
  real(8), allocatable :: ef_Data(:,:)          ! スペクトルデータ

  integer            :: k=2, l=3
  integer            :: np, ip, ierr

  real(8) :: EnergyTMP, ToTEnergy
  real(8) :: EnstrophyTMP, ToTEnstrophy
  
 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','ee_mpi_module_spectrum_test', &
       'ee_mpi_module spectrum function tests')

  !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  !---------------- 座標値の設定 ---------------------
  call ee_mpi_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

  allocate(vx_Data(jc(ip),0:im-1))     ! 格子データ
  allocate(ef_Data(-lm:lm,2*kc(ip)))   ! スペクトルデータ
  
  !------------------- 初期値設定 ----------------------
  vx_Data = sin(k*pi*vx_X) * sin(l*pi*vx_Y)
  ef_Data = 0.0d0
  if ( kf_k(k) > 0 ) then
     ef_Data(l,kf_k(k))   = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
     ef_Data(-l,kf_k(k))  = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
     ef_Data(l,kf_k(-k))  = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
     ef_Data(-l,kf_k(-k)) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  endif
     
  call AssertEqual(                                      &
    message = 'Energy spectrum sin(k*pi*X)*sin(l*pi*Y)', &
    answer = ef_Data,                                    &
    check = ef_EnergyFromStreamfunc_ef(ef_vx(vx_Data)),  &
    significant_digits = check_digits, ignore_digits = ignore     )

  EnergyTmp = sum(ef_EnergyFromStreamfunc_ef(ef_vx(vx_Data))) &
            *(xmax-xmin)*(ymax-ymin)

  CALL MPI_ALLREDUCE(EnergyTmp,ToTEnergy,1,MPI_REAL8, &
                     MPI_SUM,MPI_COMM_WORLD,IERR)
  
  call AssertEqual(                                         &
    message = 'total energy sin(k*pi*X)*sin(l*pi*Y)',       &
    answer = ((k*pi)**2 + (l*pi)**2)/2,                     &
    check = TotEnergy,                                      &
    significant_digits = check_digits, ignore_digits = ignore     )

  ef_Data = 0.0d0
  if ( kf_k(k) > 0 ) then
     ef_Data(l,kf_k(k))   = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
     ef_Data(-l,kf_k(k))  = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
     ef_Data(l,kf_k(-k))  = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
     ef_Data(-l,kf_k(-k)) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  endif
  
  call AssertEqual(                                         &
    message = 'Enstrophy spectrum sin(k*pi*X)*sin(l*pi*Y)', &
    answer = ef_Data,                                       &
    check = ef_EnstrophyFromStreamfunc_ef(ef_vx(vx_Data)),  &
    significant_digits = check_digits, ignore_digits = ignore     )

  EnstrophyTMP = sum(ef_EnstrophyFromStreamfunc_ef(ef_vx(vx_Data))) &
            *(xmax-xmin)*(ymax-ymin)

  CALL MPI_ALLREDUCE(EnstrophyTmp,ToTEnstrophy,1,MPI_REAL8, &
                     MPI_SUM,MPI_COMM_WORLD,IERR)

  call AssertEqual(                                            &
    message = 'total enstrophy sin(k*pi*X)*sin(l*pi*Y)',       &
    answer = ((k*pi)**2 + (l*pi)**2)**2/2,                     &
    check = ToTEnstrophy,                                      &
    significant_digits = check_digits, ignore_digits = ignore     )

  call MPI_FINALIZE(IERR)

  call MessageNotify('M','ee_mpi_module_spectrum_test', &
       'ee_mpi_module spectrum function tests succeeded!')

end program ee_mpi_module_spectrum_test

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ut_mpi_module_supack テストプログラム
!
!      トロイダルポテンシャルの境界値問題
!
!履歴  2016/08/04  竹広真一   wt_mpi_module_supack_test_torvelbc.f90 より改造!
!
program ut_mpi_module_svpack_torvelbc_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ut_mpi_module_svpack
  use mpi

  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5      ! 内外半径

  real(8), allocatable :: xyh_TorVel0(:,:,:)
  real(8), allocatable :: xyh_TorVel(:,:,:)
  real(8), allocatable :: ut_TorVel(:,:)
  real(8), allocatable :: xyh_Zero(:,:,:)
  real(8), allocatable :: xyh_True(:,:,:)

  character(len=2), dimension(4),parameter :: BCond=(/'FF','FR','RF','RR'/)


  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8), parameter  :: pi=3.1415926535897932385D0

  integer :: l

  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','ut_mpi_module_supack_torvelbc_test', &
       'ut_mpi_module_supack ut_TorgBoundariesGrid subroutine test')

  call ut_mpi_initial(im,jm,km,nm,lm,ri,ro)

  allocate(xyh_TorVel0(0:im-1,jm,kc))
  allocate(xyh_TorVel(0:im-1,jm,kc))
  allocate(ut_TorVel(nc,0:lm))
  allocate(xyh_Zero(0:im-1,jm,kc))
  allocate(xyh_True(0:im-1,jm,kc))

  xyh_Zero = 0.0D0

  do l=1,4

     ! P_10
     !xyh_TorVel = sin(xyh_lat) * cos( pi*(xyh_rad-ri)/(ro-ri) )
     ! P_1_1
     !xyh_TorVel = cos(xyh_lat)*cos(xyh_lon)* cos( pi*(xyh_rad-ri)/(ro-ri) )
     xyh_TorVel = 2*sin(xyh_lat)**2 * cos( pi*(xyh_rad-ri)/(ro-ri) )

     xyh_TorVel0 = xyh_TorVel
     ut_TorVel = ut_xyh(xyh_TorVel)
     call ut_TorBoundariesGrid(ut_TorVel,cond=BCond(l),new=.true.)
     xyh_TorVel = xyh_ut(ut_TorVel)

     ! 内部チェック
     if ( kh_kz(0) /= 0 .and. kh_kz(km) /= 0 )then
        call AssertEqual(&
             message='ut_TorBoundariesGrid_ut (intenal value)',            &
             answer = xyh_Torvel(:,:,2:kc-1),                                &
             check = xyh_Torvel0(:,:,2:kc-1),                                &
             significant_digits = check_digits, ignore_digits = ignore     &
             )
     else if ( kh_kz(0) == 0 .and. kh_kz(km) /= 0 ) then
        call AssertEqual(&
             message='ut_TorBoundariesGrid_ut (intenal value)',            &
             answer = xyh_Torvel(:,:,1:kc-1),                              &
             check = xyh_Torvel0(:,:,1:kc-1),                              &
             significant_digits = check_digits, ignore_digits = ignore     &
             )
     else if ( kh_kz(0) /= 0 .and. kh_kz(km) == 0 ) then
        call AssertEqual(&
             message='ut_TorBoundariesGrid_ut (intenal value)',            &
             answer = xyh_Torvel(:,:,kh_kz(0)+1:kc),                       &
             check = xyh_Torvel0(:,:,kh_kz(0)+1:kc),                       &
             significant_digits = check_digits, ignore_digits = ignore     &
             )
     else 
        call AssertEqual(&
             message='ut_TorBoundariesGrid_ut (intenal value)',            &
             answer = xyh_Torvel,                                          &
             check = xyh_Torvel0,                                          &
             significant_digits = check_digits, ignore_digits = ignore     &
             )
     endif

     ! 上端境界チェック
     if( BCond(l)(1:1) == 'F' ) then
        xyh_True = xyh_ut(ut_DRad_ut(ut_xyh(xyh_TorVel/xyh_Rad)))
     else
        xyh_True = xyh_TorVel
     endif

     if ( kh_kz(0) /= 0 )then
        call AssertEqual(&
             message='ut_TorvelBoundariesGrid_ut ('//BCond(l)//'-Top B.C)',&
             answer = xyh_Zero(:,:,kh_kz(0)),                              &
             check = xyh_True(:,:,kh_kz(0)),                               &
             significant_digits = check_digits, ignore_digits = ignore     &
             )
     endif
        
     ! 下端境界チェック
     if( BCond(l)(2:2) == 'F' ) then
        xyh_True = xyh_ut(ut_DRad_ut(ut_xyh(xyh_TorVel/xyh_Rad)))
     else
        xyh_True = xyh_TorVel
     endif

     if ( kh_kz(km) /= 0 )then
        call AssertEqual(&
             message='ut_TorvelBoundariesGrid_ut ('//BCond(l)//'-Bottom B.C)',&
             answer = xyh_Zero(:,:,kh_kz(km)),                             &
             check = xyh_True(:,:,kh_kz(km)),                              &
             significant_digits = check_digits, ignore_digits = ignore     &
             )
     endif
     
  enddo
  
  call MessageNotify('M','ut_mpi_module_svpack_torvelbc_test', &
       'ut_mpi_module_svpack  ut_TorvelBoundariesGrid subroutine test succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ut_mpi_module_svpack_torvelbc_test

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ut_mpi_module_svpack テストプログラム
!
!      磁場ポロイダルポテンシャルの境界値問題
!
!履歴  2016/08/04  竹広真一   wt_mpi_module_supack_test_polmagbc.f90 より改造
!
program ut_mpi_module_svpack_polmagbc_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ut_mpi_module_svpack
  use mpi

  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), allocatable  :: xyh_POLMAG(:,:,:)
  real(8), allocatable  :: ut_POLMAG(:,:)

  real(8), allocatable  :: uz_TopBoundary(:,:)
  real(8), allocatable  :: uz_BottomBoundary(:,:)

  real(8), allocatable  :: uz_Zero(:,:)

  real(8), allocatable  :: uz_n(:,:)   ! 全波数

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8), parameter  :: pi=3.1415926535897932385D0

  integer :: k, n, nn(2)

  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','ut_mpi_module_svpack_polmagbc_test', &
       'ut_mpi_module_svpack ut_PolmagBoundaries subroutine test')

  call ut_mpi_initial(im,jm,km,nm,lm,ri,ro)

  allocate(xyh_POLMAG(0:im-1,jm,kc))
  allocate(ut_POLMAG(nc,0:lm))

  allocate(uz_TopBoundary(nc,0:km))
  allocate(uz_BottomBoundary(nc,0:km))

  allocate(uz_Zero(nc,0:km))

  allocate(uz_n(nc,0:km))


  !=================== ut_PolmagBoundaries =======================
  ! P_10
  xyh_POLMAG = sin(xyh_lat) * sin( pi*(xyh_rad-ri)/(ro-ri) )

  ! P_1_1
  !xyh_POLMAG = cos(xyh_lat)*cos(xyh_lon)* sin( pi*(xyh_rad-ri)/(ro-ri) )
  !xyh_POLMAG = 2*sin(xyh_lat)**2 * sin( pi*(xyh_rad-ri)/(ro-ri) )

  ut_POLMAG = ut_xyh(xyh_POLMAG)
  call ut_PolmagBoundaries(ut_POLMAG)
  xyh_POLMAG = xyh_ut(ut_POLMAG)

  do k=0,km
     do n=1,nc
        nn=nm_l(n)
        uz_n(n,k) = nn(1)
     enddo
  enddo

  uz_Zero = 0.0D0
  uz_TopBoundary = uz_ut(ut_DRad_ut(ut_POLMAG)) &
                     + (uz_n +1)*uz_ut(ut_POLMAG)/uz_RAD
  uz_BottomBoundary = uz_ut(ut_DRad_ut(ut_POLMAG)) &
                     - uz_n * uz_ut(ut_POLMAG)/uz_RAD 
  call AssertEqual(&
       message='ut_PolmagBoundaries (Top B.C.)',                 &
       answer = u_cleanup_u(uz_Zero(:,0)),                       &
       check = u_cleanup_u(uz_TopBoundary(:,0)),                 &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='ut_PolmagBoundaries (Bottom B.C.)',              &
       answer = u_cleanup_u(uz_Zero(:,km)),                      &
       check = u_cleanup_u(uz_BottomBoundary(:,km)),             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !=================== ut_PolmagBoundariesGrid =======================
  ! P_10
  !xyz_POLMAG = sin(xyz_lat) * sin( pi*(xyz_rad-ri)/(ro-ri) )

  ! P_1_1
  !xyh_POLMAG = cos(xyh_lat)*cos(xyh_lon)* sin( pi*(xyh_rad-ri)/(ro-ri) )
  xyh_POLMAG = 2*sin(xyh_lat)**2 * sin( pi*(xyh_rad-ri)/(ro-ri) )

  ut_POLMAG = ut_xyh(xyh_POLMAG)
  call ut_PolmagBoundariesGrid(ut_POLMAG)
  xyh_POLMAG = xyh_ut(ut_POLMAG)

  do k=0,km
     do n=1,nc
        nn=nm_l(n)
        uz_n(n,k) = nn(1)
     enddo
  enddo

  uz_TopBoundary = uz_ut(ut_DRad_ut(ut_POLMAG)) &
                     + (uz_n +1)*uz_ut(ut_POLMAG)/uz_RAD
  uz_BottomBoundary = uz_ut(ut_DRad_ut(ut_POLMAG)) &
                     - uz_n * uz_ut(ut_POLMAG)/uz_RAD 

  uz_Zero = 0.0D0
  uz_TopBoundary = uz_ut(ut_DRad_ut(ut_POLMAG)) &
                     + (uz_n +1)*uz_ut(ut_POLMAG)/uz_RAD
  uz_BottomBoundary = uz_ut(ut_DRad_ut(ut_POLMAG)) &
                     - uz_n * uz_ut(ut_POLMAG)/uz_RAD 
  call AssertEqual(&
       message='ut_PolmagBoundariesTau (Top B.C.)',                  &
       answer = u_cleanup_u(uz_Zero(:,0)),                           &
       check = u_cleanup_u(uz_TopBoundary(:,0)),                     &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='ut_PolmagBoundariesTau (Bottom B.C.)',               &
       answer = u_cleanup_u(uz_Zero(:,km)),                          &
       check = u_cleanup_u(uz_BottomBoundary(:,km)),                 &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','ut_mpi_module_svpack_polmagbc_test', &
       'ut_mpi_module_svpack ut_PolmagBoundaries subroutine test succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

contains

  function u_cleanup_u(u_data)
    real(8), intent(IN) :: u_data(nc)
    real(8)             :: u_cleanup_u(nc)

    integer l,nmary(2)

    u_cleanup_u = u_data

    do l=1,nc
       nmary = nm_l(l)
       if ( nmary(1) .lt. 0 ) u_cleanup_u(l) = 0.0D0
    end do

 end function u_cleanup_u

end program ut_mpi_module_svpack_polmagbc_test

!--
!----------------------------------------------------------------------
! Copyright(c) 2017 SPMDODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  wsc_module_svpack
!
!    spml/wsc_module_svpack モジュールは球面上および球殻内での流体運動を
!    スペクトル法によって数値計算するための Fortran90 関数を提供する
!    ものである. 
!
!    水平方向に球面調和函数変換および鉛直方向に sin/cos 関数変換を
!    用いる場合のスペクトル計算のためのさまざまな関数を提供する. 
!
!    内部で wa_module_svpack, asc_module を用いている. 最下部では
!    球面調和変換およびチェビシェフ変換のエンジンとして ISPACK の 
!    Fortran77 サブルーチンを用いている.
!
!    関数, サブルーチンの名前と機能は wt_module のものと同じである. 
!    したがって use 文を wsc_module から wsc_module_svpack に
!    変更するだけで SVPACK の機能が使えるようになる. 
! 
!    ただし l_nm, nm_l の使い方には注意されたい. wt_module の l_nm, nm_l は
!    wt_Initial で初期化しなくとも用いることができる(結果が切断波数に依らない)が,
!    wsc_module_svpack のものは初期化したのちにしか使うことができない. 
!
!
!履歴  2017/05/21  竹広真一
!
!凡例
!      データ種類と index
!        x : 経度         y : 緯度        z : 動径
!        w : 球面調和関数スペクトル
!        n : 球面調和関数スペクトル(水平全波数)
!        m : 球面調和関数スペクトル(帯状波数)
!        s : sin 関数スペクトル
!        c : cos 関数スペクトル
!        a : 任意の次元
!
!        xyz : 3 次元格子点データ
!        xy  : 水平 2 次元格子点データ
!        yz  : 子午面 2 次元格子点データ
!        xz  : 緯度面 2 次元格子点データ
!
!        wz  : 水平スペクトル動径格子点データ
!        ws  : スペクトルデータ(鉛直 sin)
!        wc  : スペクトルデータ(鉛直 cos)
!
!++
module wsc_module_svpack
  !
  != wsc_module_svpack
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !    spml/wsc_module_svpack モジュールは球面上および球殻内での流体運動を
  !    スペクトル法によって数値計算するための Fortran90 関数を提供する
  !    ものである. 
  !
  !    水平方向に球面調和函数変換および上下の境界壁を扱うための
  !    チェビシェフ変換を用いる場合のスペクトル計算のためのさまざまな
  !    関数を提供する. 
  !
  !    内部で wa_module_sjpack, asc_module を用いている. 最下部では
  !    球面調和変換およびチェビシェフ変換のエンジンとして ISPACK の 
  !    Fortran77 サブルーチンを用いている.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (ws_, wc_, nmz_,nz_,xyz_,wz_,w_,xy_,x_,y_,s_,c_,a_) は, 
  !   返す値の形を示している.
  !   ws_,wc_ :: スペクトルデータ(球面調和函数・三角関数変換)
  !   nmz_    :: 水平スペクトルデータ(全波数 n, 帯状波数各成分, 動径)
  !   nz_     :: 水平スペクトルデータ(全波数 n, 動径)
  !   xyz_    :: 3 次元格子点データ(経度・緯度・動径)
  !   wz_     :: 水平スペクトル, 動径格子点データ
  !
  ! * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla,..)
  !   は, その関数の作用を表している.
  !
  ! * 関数名の最後 (ws_,wc_,xyz_,wz_,w_,xy_,x_,y_,z_,a_) は, 入力変数の
  !   形がスペクトルデータおよび格子点データであることを示している.
  !   _ws,_wc  :: スペクトルデータ
  !   _xyz     :: 3 次元格子点データ
  !   _xyz_xyz :: 2 つの3 次元格子点データ, ...
  !
  !=== 各データの種類の説明
  !
  ! * xyz : 3 次元格子点データ(経度・緯度・動径)
  !   * 変数の種類と次元は real(8), dimension(0:im-1,1:jm,0:km). 
  !   * im, jm, km はそれぞれ経度, 緯度, 動径座標の格子点数であり, 
  !     サブルーチン wt_Initial にてあらかじめ設定しておく.
  !
  ! * ws : スペクトルデータ(鉛直 sin)
  !   * 変数の種類と次元は real(8), dimension((nm+1)*(nm+1),lm). 
  !   * nm は球面調和函数の最大全波数, lm は三角関数展開の最大波数
  !     であり, サブルーチン wsc_Initial にてあらかじめ設定しておく. 
  !   * 水平スペクトルデータの格納のされ方は関数 l_nm, nm_l によって調べる
  !     ことができる.
  !
  ! * nmz : 水平スペクトルデータの並んだ 3 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,-nm:nm,0:km). 
  !   * 第 1 次元が水平全波数, 第 2 次元が帯状波数, 第 3 次元が動径座標を表す. 
  !   * nm は球面調和函数の最大全波数であり, サブルーチン wt_Initial にて
  !     あらかじめ設定しておく.
  !
  ! * nz : スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,0:km). 
  !   * 第 1 次元が水平全波数を表す. nm は球面調和函数の最大全波数であり, 
  !     サブルーチン wt_Initial にてあらかじめ設定しておく.
  !
  ! * wz : 水平スペクトル, 動径格子点データ.
  !   * 変数の種類と次元は real(8), dimension((nm+1)*(nm+1),0:km).
  !
  ! * ws_, wc_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * xyz_ で始まる関数が返す値は 3 次元格子点データに同じ.
  !
  ! * wz_ で始まる関数が返す値は水平スペクトル, 動径格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  ! 
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! wsc_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! 
  !==== 座標変数
  !
  ! x_Lon, y_Lat, z_Rad          :: 格子点座標(緯度, 経度, 動径座標)を
  !                                 格納した1 次元配列
  ! x_Lon_Weight, y_Lat_Weight, z_Rad_Weight :: 重み座標を格納した 1 次元配列
  ! xyz_Lon, xyz_Lat, xyz_Rad    :: 格子点データの経度・緯度・動径座標(X,Y,Z)
  !                                 (格子点データ型 3 次元配列)
  !
  !==== 基本変換
  !
  ! xyz_ws, ws_xyz :: スペクトルデータと 3 次元格子データの間の変換
  !                   (球面調和函数, sin 変換)
  ! xyz_wc, wc_xyz :: スペクトルデータと 3 次元格子データの間の変換
  !                   (球面調和函数, cos 変換)
  ! xyz_wz, wz_xyz :: 3 次元格子データと水平スペクトル・動径格子データとの間
  !                   の変換 (球面調和函数)
  ! wz_ws, ws_wz   :: スペクトルデータと水平スペクトル・動径格子データとの間
  !                   の変換 (sin 変換)
  ! wz_wc, wc_wz   :: スペクトルデータと水平スペクトル・動径格子データとの間
  !                   の変換 (cos 変換)
  ! w_xy, xy_w     :: スペクトルデータと 2 次元水平格子データの間の変換
  !                   (球面調和函数変換) 
  ! az_as, as_az   :: 格子データと sin 変換スペクトルデータの間の変換を
  !                   同時に複数個行う
  ! az_as, as_az   :: 格子データと cos 変換スペクトル間の変換を
  !                   同時に複数個行う
  ! l_nm, nm_l     :: スペクトルデータの格納位置と全波数・帯状波数の変換 
  !
  !==== 微分
  !
  ! ws_DRad_wc, wc_DRad_ws     :: スペクトルデータに動径微分∂/∂r を作用させる
  ! ws_DivRad_wc, wc_DivRad_ws :: スペクトルデータに発散型動径微分
  !                               ∂/∂r 
  ! ws_RotRad_wc, wc_RotRad_ws :: スペクトルデータに回転型動径微分
  !                               ∂/∂r を作用させる
  ! ws_Lapla_ws, wc_Lapla_wc   :: スペクトルデータにラプラシアンを作用させる
  ! ws_LaplaInv_ws, wc_LaplaInv_wc  :: スペクトルデータに逆ラプラシアンを作用させる  
  ! xyz_GradLon_ws, xyz_GradLon_wc :: スペクトルデータに勾配型経度微分
  !                                   1/(a cosφ)・∂/∂λを作用させる
  ! xyz_GradLat_wt, xyz_GradLat_wc :: スペクトルデータに勾配型緯度微分
  !                                   1/a・∂/∂φを作用させる
  ! ws_DivLon_xyz, wc_DivLon_xyz   :: 格子データに発散型経度微分
  !                                   1/(a cosφ)・∂/∂λを作用させる
  ! ws_DivLat_xyz, wc_DivLat_xyz   :: 格子データに発散型緯度微分
  !                                   (1/a cosφ)・∂(g cosφ)/∂φを作用させる
  ! wc_Div_xyz_xyz_xyz  :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! ws_Div_xyz_xyz_xyz  :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! xyz_Div_xyz_xyz_xyz :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! wc_RotRad_xyz_xyz   :: ベクトル場の回転の動径成分を計算する
  !
  !==== トロイダルポロイダル計算用微分
  !
  ! ws_KxRGrad_ws, wc_KxRGrad_wc :: スペクトルデータに
  !                                 経度微分 k×r・▽ = ∂/∂λを作用させる
  ! ws_L2_ws, wc_L2_wc       :: スペクトルデータに 
  !                             L2 演算子 = -水平ラプラシアンを作用させる
  ! ws_L2Inv_ws, ws_L2Inv_ws :: スペクトルデータに 
  !                             L2 演算子の逆 = -逆水平ラプラシアンを作用させる
  ! wc_RadRot_xyz_xyz        :: ベクトル v の渦度と動径ベクトル r の内積
  !                             r・(▽×v) を計算する
  ! ws_RadRotRot_xyz_xyz_xyz :: ベクトルの v の r・(▽×▽×v) を計算する
  ! wsc_Potential2Vector      :: トロイダルポロイダルポテンシャルから
  !                              ベクトル場を計算する
  ! wsc_Potential2Rotation    :: トロイダルポロイダルポテンシャルで表される
  !                              非発散ベクトル場の回転の各成分を計算する
  !
  !==== ポロイダル/トロイダルモデル用スペクトル解析
  !
  ! nmz_ToroidalEnergySpectrum_wc, nz_ToroidalEnergySpectrum_wc   ::
  !     トロイダルポテンシャルからエネルギーの球面調和函数各成分を計算する
  ! nmz_PoloidalEnergySpectrum_ws, nz_PoloidalEnergySpectrum_ws   :: 
  !     ポロイダルポテンシャルからエネルギーの球面調和函数各成分を計算する
  !
  !==== 積分・平均(3 次元データ)
  !
  ! IntLonLatRad_xyz, AvrLonLatRad_xyz :: 3 次元格子点データの
  !                                       全領域積分および平均
  ! z_IntLonLat_xyz, z_AvrLonLat_xyz   :: 3 次元格子点データの
  !                                       緯度経度(水平・球面)積分および平均
  ! y_IntLonRad_xyz, y_AvrLonRad_xyz   :: 3 次元格子点データの
  !                                       緯度動径積分および平均
  ! z_IntLatRad_xyz, z_AvrLatRad_xyz   :: 3 次元格子点データの
  !                                       経度動径(子午面)積分および平均
  ! yz_IntLon_xyz, yz_AvrLon_xyz       :: 3 次元格子点データの
  !                                       経度方向積分および平均
  ! xz_IntLat_xyz, xz_AvrLat_xyz       :: 3 次元格子点データの
  !                                       緯度方向積分および平均
  ! xz_IntRad_xyz, xz_AvrRad_xyz       :: 3 次元格子点データの
  !                                       動径方向積分および平均
  !
  !==== 積分・平均(2 次元データ)
  !
  ! IntLonLat_xy, AvrLonLat_xy :: 2 次元格子点データの水平(球面)積分および平均
  ! IntLonRad_xz, AvrLonRad_xz :: 2 次元(XZ)格子点データの経度動径積分
  !                               および平均
  ! IntLatRad_yz, AvrLatRad_yz :: 2 次元(YZ)格子点データの緯度動径(子午面)
  !                               積分および平均 
  ! y_IntLon_xy, y_AvrLon_xy   :: 水平 2 次元(球面)格子点データの経度方向
  !                               積分および平均
  ! x_IntLat_xy, x_AvrLat_xy   :: 水平2 次元(球面)格子点データの緯度方向積分
  !                               および平均
  ! z_IntLon_xz, z_AvrLon_xz   :: 2 次元(XZ)格子点データの経度方向積分および
  !                               平均
  ! x_IntRad_xz, x_AvrRad_xz   :: 2 次元(XZ)格子点データの動径方向積分および
  !                               平均
  ! z_IntLat_yz, z_AvrLat_yz   :: 2 次元(YZ)格子点データの緯度方向積分および
  !                               平均
  ! y_IntRad_yz, y_AvrRad_yz   :: 2 次元(YZ)格子点データの動径方向積分および
  !                               平均                  
  !
  !==== 積分・平均(1 次元データ)
  !
  ! IntLon_x, AvrLon_x  :: 1 次元(X)格子点データの経度方向積分および平均
  ! IntLat_y, AvrLat_y  :: 1 次元(Y)格子点データの緯度方向積分および平均
  ! IntRad_z, AvrRad_z  :: 1 次元(Z)格子点データの動径方向積分および平均
  !
  !==== 補間計算
  !
  ! Interpolate_ws, Interpolate_wc :: スペクトルデータから任意の点の値を補間する. 
  ! 
  use dc_message
  use lumatrix
  use wa_module_svpack
  use asc_module, z_RAD => g_X, z_RAD_WEIGHT => g_X_WEIGHT, &
                  as_az => as_ag, az_as => ag_as, &
                  ac_az => ac_ag, az_ac => ag_ac, &
                  s_z => s_g, z_s => g_s, c_z => c_g, z_c => g_c, &
                  s_Dr_c => s_Dx_c, as_Dr_ac => as_Dx_ac, &
                  c_Dr_s => s_Dx_c, ac_Dr_as => ac_Dx_as
  implicit none
  private

  public wsc_Initial

  public x_Lon, x_Lon_Weight
  public y_Lat, y_Lat_Weight
  public z_Rad, z_Rad_Weight
  public l_nm, nm_l
  public xy_Lon, xy_Lat
  public xyz_Lon, xyz_Lat, xyz_Rad
  public wz_Rad
  public wsc_VMiss

  public w_xy, xy_w
  public ac_Dr_as, c_Dr_s, az_as, as_az
  public as_Dr_ac, s_Dr_c, az_ac, ac_az
  public xyz_ws, ws_xyz, wz_ws, ws_wz
  public xyz_wc, wc_xyz, wz_wc, wc_wz
  public xyz_wz, wz_xyz

  public ws_DRad_wc, wc_DRad_ws, wc_DivRad_ws, ws_DivRad_wc
  public wc_RotRad_ws, ws_RotRad_wc
  public ws_Lapla_ws, wc_Lapla_wc, ws_LaplaInv_ws, wc_LaplaInv_wc
  public xyz_GradLon_ws, xyz_GradLon_wc, xyz_gradlat_ws, xyz_gradlat_wc
  public wc_DivLon_xyz, ws_DivLon_xyz, wc_DivLat_xyz, ws_DivLat_xyz
  public wc_Div_xyz_xyz_xyz, ws_Div_xyz_xyz_xyz, xyz_Div_xyz_xyz_xyz
  public wc_RotRad_xyz_xyz ! xyz_RotLon_ws_wc, xyz_RotLat_wc_ws

  public yz_IntLon_xyz, xz_IntLat_xyz, xy_IntRad_xyz
  public x_IntLatRad_xyz, y_IntLonRad_xyz, z_IntLonLat_xyz
  public IntLonLatRad_xyz

  public x_IntLat_xy, y_IntLon_xy, IntLonLat_xy
  public z_IntLat_yz, y_IntRad_yz, IntLatRad_yz
  public z_IntLon_xz, x_IntRad_xz, IntLonRad_xz
  public IntLon_x, IntLat_y, IntRad_z

  public yz_AvrLon_xyz, xz_AvrLat_xyz, xy_AvrRad_xyz
  public x_AvrLatRad_xyz, y_AvrLonRad_xyz, z_AvrLonLat_xyz
  public AvrLonLatRad_xyz

  public x_AvrLat_xy, y_AvrLon_xy, AvrLonLat_xy
  public z_AvrLat_yz, y_AvrRad_yz, AvrLatRad_yz
  public z_AvrLon_xz, x_AvrRad_xz, AvrLonRad_xz
  public AvrLon_x, AvrLat_y, AvrRad_z

  public wc_KxRGrad_wc, ws_KxRGrad_ws
  public wc_L2_wc, ws_L2_ws, wc_L2Inv_wc, ws_L2Inv_ws 
  public wc_RadRot_xyz_xyz, ws_RadRotRot_xyz_xyz_xyz
  public wsc_Potential2vector, wsc_Potential2Rotation

  public Interpolate_wc, Interpolate_ws

  public nmz_ToroidalEnergySpectrum_wc, nz_ToroidalEnergySpectrum_wc
  public nmz_PoloidalEnergySpectrum_ws, nz_PoloidalEnergySpectrum_ws


  integer            :: im=64, jm=32, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer            :: nm=21, lm=16         ! 切断波数の設定(水平, 動径)
  real(8)            :: ri=0.0, ro=1.0       ! 球殻内外半径
  real(8), parameter :: pi=3.1415926535897932385D0

  real(8), dimension(:,:,:), allocatable :: xyz_LON, xyz_LAT, xyz_RAD ! 座標
  real(8), dimension(:,:), allocatable   :: wz_RAD                    ! 座標

  real(8) :: wsc_VMiss = -999.0        ! 欠損値

  save im, jm, km, nm, lm, ri, ro

  contains
  !--------------- 初期化 -----------------
   subroutine wsc_Initial(i,j,k,n,l,r_in,r_out,np,wa_init)
     !
     ! スペクトル変換の格子点数, 波数, 動径座標の範囲を設定する.
     !
     ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
     ! しなければならない. 
     !
     ! np に 1 より大きな値を指定すれば ISPACK の球面調和函数変換 
     ! OPENMP 並列計算ルーチンが用いられる. 並列計算を実行するには, 
     ! 実行時に環境変数 OMP_NUM_THREADS を np 以下の数字に設定する等の
     ! システムに応じた準備が必要となる. 
     !
     ! np に 1 より大きな値を指定しなければ並列計算ルーチンは呼ばれない.
     !
     !
     integer,intent(in) :: i              ! 格子点数(経度λ)
     integer,intent(in) :: j              ! 格子点数(緯度φ)
     integer,intent(in) :: k              ! 格子点数(動径 r)
     integer,intent(in) :: n              ! 切断波数(水平全波数)
     integer,intent(in) :: l              ! 切断波数(動径波数)

     real(8),intent(in) :: r_in           ! 球殻内半径
     real(8),intent(in) :: r_out          ! 球殻外半径

     integer,intent(in), optional :: np   ! OPENMP での最大スレッド数
     logical,intent(in), optional :: wa_init   ! wa_initial スイッチ

     logical    :: wa_initialize=.true.   ! wa_initial スイッチ
     
     im = i  ; jm = j ; km = k
     nm = n  ; lm = l
     ri = r_in ; ro = r_out

     if ( present(wa_init) ) then
        wa_initialize = wa_init
     else
        wa_initialize = .true.
     endif

     if ( wa_initialize ) then
        if ( present(np) ) then
           call wa_Initial(nm,im,jm,km+1,np)
        else
           call wa_Initial(nm,im,jm,km+1)
        endif
     endif

     call asc_Initial(km,lm,r_in,r_out)

     allocate(xyz_Lon(0:im-1,1:jm,0:km))
     allocate(xyz_Lat(0:im-1,1:jm,0:km))
     allocate(xyz_Rad(0:im-1,1:jm,0:km))

     allocate(wz_Rad((nm+1)*(nm+1),0:km))

     xyz_Lon = spread(xy_Lon,3,km+1)
     xyz_Lat = spread(xy_Lat,3,km+1)
     xyz_Rad = spread(spread(z_Rad,1,jm),1,im)

     wz_Rad = spread(z_Rad,1,(nm+1)*(nm+1))

     z_Rad_Weight = z_Rad_Weight * Ro**2           ! r^2 dr の積分重み

     call MessageNotify('M','wsc_initial', &
          'wsc_module_svpack (2017/05/21) is initialized')

   end subroutine wsc_Initial

  !--------------- 基本変換 -----------------

    function xyz_ws(ws)
      !
      ! スペクトルデータから 3 次元格子点データへ(逆)変換する.
      !
      real(8), dimension((nm+1)*(nm+1),lm), intent(in) :: ws
      !(in) 2 次元球面調和函数 sin スペクトルデータ
      real(8), dimension(0:im-1,1:jm,0:km)             :: xyz_ws
      !(out) 3 次元経度緯度動径格子点データ

      xyz_ws = xya_wa(wz_ws(ws))

    end function xyz_ws

    function ws_xyz(xyz)
      !
      ! 3 次元格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ
      real(8), dimension((nm+1)*(nm+1),lm)             :: ws_xyz
      !(out) 2 次元球面調和函数 sin スペクトルデータ

      ws_xyz = ws_wz(wa_xya(xyz))

    end function ws_xyz

    function xyz_wc(wc)
      !
      ! スペクトルデータから 3 次元格子点データへ(逆)変換する.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wc
      !(in) 2 次元球面調和函数 cos スペクトルデータ
      real(8), dimension(0:im-1,1:jm,0:km)               :: xyz_wc
      !(out) 3 次元経度緯度動径格子点データ

      xyz_wc = xya_wa(wz_wc(wc))

    end function xyz_wc

    function wc_xyz(xyz)
      !
      ! 3 次元格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ
      real(8), dimension((nm+1)*(nm+1),0:lm)           :: wc_xyz
      !(out) 2 次元球面調和函数 cos スペクトルデータ

      wc_xyz = wc_wz(wa_xya(xyz))

    end function wc_xyz

    function xyz_wz(wz)
      !
      ! 水平スペクトル・動径格子点データから 3 次元格子点データへ(逆)変換する.
      !
      real(8), dimension((nm+1)*(nm+1),0:km), intent(in) :: wz
      !(in) 2 次元球面調和函数スペクトル・動径格子点データ
      real(8), dimension(0:im-1,1:jm,0:km)               :: xyz_wz
      !(out) 3 次元経度緯度動径格子点データ

      xyz_wz = xya_wa(wz)

    end function xyz_wz

    function wz_xyz(xyz)
      !
      ! 3 次元格子データから水平スペクトル・動径格子点データへ(正)変換する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in)   :: xyz
      !(in) 3 次元経度緯度動径格子点データ
      real(8), dimension((nm+1)*(nm+1),0:km)             :: wz_xyz
      !(out) 2 次元球面調和函数スペクトル・動径格子点データ

      wz_xyz = wa_xya(xyz)

    end function wz_xyz

    function wz_ws(ws)
      !
      ! スペクトルデータから水平スペクトル・動径格子点データへ(正)変換する.
      !
      real(8), dimension((nm+1)*(nm+1),lm), intent(in) :: ws
      !(in) 2 次元球面調和函数 sin スペクトルデータ
      real(8), dimension((nm+1)*(nm+1),0:km)           :: wz_ws
      !(out) 2 次元球面調和函数スペクトル・動径格子点データ

      wz_ws = az_as(ws)

    end function wz_ws

    function ws_wz(wz)
      !
      ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension((nm+1)*(nm+1),0:km), intent(in) :: wz
      !(in) 2 次元球面調和函数スペクトル・動径格子点データ
      real(8), dimension((nm+1)*(nm+1),lm)               :: ws_wz
      !(out) 2 次元球面調和函数 sin スペクトルデータ

      ws_wz = as_az(wz)

    end function ws_wz

    function wz_wc(wc)
      !
      ! スペクトルデータから水平スペクトル・動径格子点データへ(正)変換する.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wc
      !(in) 2 次元球面調和函数 cos スペクトルデータ
      real(8), dimension((nm+1)*(nm+1),0:km)             :: wz_wc
      !(out) 2 次元球面調和函数スペクトル・動径格子点データ

      wz_wc = az_ac(wc)

    end function wz_wc

    function wc_wz(wz)
      !
      ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension((nm+1)*(nm+1),0:km), intent(in) :: wz
      !(in) 2 次元球面調和函数スペクトル・動径格子点データ
      real(8), dimension((nm+1)*(nm+1),0:lm)             :: wc_wz
      !(out) 2 次元球面調和函数 cos スペクトルデータ

      wc_wz = ac_az(wz)

    end function wc_wz

  !--------------- 微分計算 -----------------
    function wc_DRad_ws(ws)
      !
      ! 入力スペクトルデータに動径微分 ∂/∂r を作用する.
      !
      ! スペクトルデータの動径微分とは, 対応する格子点データに動径微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension((nm+1)*(nm+1),lm), intent(in) :: ws
      !(in) 2 次元球面調和函数 sin スペクトルデータ

      real(8), dimension((nm+1)*(nm+1),0:lm)           :: wc_DRad_ws
      !(in) 動径微分された2 次元球面調和函数 cos スペクトルデータ

      wc_DRad_ws = ac_Dr_as(ws)

    end function wc_DRad_ws

    function ws_DRad_wc(wc)
      !
      ! 入力スペクトルデータに動径微分 ∂/∂r を作用する.
      !
      ! スペクトルデータの動径微分とは, 対応する格子点データに動径微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wc
      !(in) 2 次元球面調和函数 cos スペクトルデータ

      real(8), dimension((nm+1)*(nm+1),lm)             :: ws_DRad_wc
      !(in) 動径微分された2 次元球面調和函数 sin スペクトルデータ

      ws_DRad_wc = as_Dr_ac(wc)

    end function ws_DRad_wc

    function wc_DivRad_ws(ws)
      ! 
      ! 入力スペクトルデータに近似的発散型動径微分 ∂/∂r を作用する.
      !
      ! スペクトルデータの発散型動径微分とは, 対応する格子点データに
      ! 発散型動径微分を作用させたデータのスペクトル変換のことである. 
      !
      real(8), dimension((nm+1)*(nm+1),lm), intent(in) :: ws
      !(in) 2 次元球面調和函数 sin スペクトルデータ

      real(8), dimension((nm+1)*(nm+1),0:lm)           :: wc_DivRad_ws
      !(out) 発散型動径微分を作用された 2 次元スペクトルデータ

      wc_DivRad_ws = wc_Drad_ws(ws)

    end function wc_DivRad_ws

    function ws_DivRad_wc(wc)
      ! 
      ! 入力スペクトルデータに近似的発散型動径微分 ∂/∂r を作用する.
      !
      ! スペクトルデータの発散型動径微分とは, 対応する格子点データに
      ! 発散型動径微分を作用させたデータのスペクトル変換のことである. 
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wc
      !(in) 2 次元球面調和函数 cos スペクトルデータ

      real(8), dimension((nm+1)*(nm+1),lm)               :: ws_DivRad_wc
      !(out) 発散型動径微分を作用された 2 次元スペクトルデータ

      ws_DivRad_wc = ws_Drad_wc(wc)

    end function ws_DivRad_wc

    function wc_RotRad_ws(ws)
      !
      ! 入力スペクトルデータに近似的回転型動径微分 ∂/∂r を作用する.
      !
      ! スペクトルデータの回転型動径微分とは, 対応する格子点データに
      ! 回転型動径微分を作用させたデータのスペクトル変換のことである. 
      !
      real(8), dimension((nm+1)*(nm+1),lm), intent(in) :: ws
      !(in) 2 次元球面調和函数 sin スペクトルデータ

      real(8), dimension((nm+1)*(nm+1),0:lm)             :: wc_RotRad_ws
      !(out) 回転型動径微分を作用された 2 次元スペクトルデータ

      wc_RotRad_ws = wc_Drad_ws(ws)

    end function wc_RotRad_ws

    function ws_RotRad_wc(wc)
      !
      ! 入力スペクトルデータに近似的回転型動径微分 ∂/∂r を作用する.
      !
      ! スペクトルデータの回転型動径微分とは, 対応する格子点データに
      ! 回転型動径微分を作用させたデータのスペクトル変換のことである. 
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wc
      !(in) 2 次元球面調和函数 cos スペクトルデータ

      real(8), dimension((nm+1)*(nm+1),lm)             :: ws_RotRad_wc
      !(out) 回転型動径微分を作用された 2 次元スペクトルデータ

      ws_RotRad_wc = ws_Drad_wc(wc)

    end function ws_RotRad_wc

    function ws_Lapla_ws(ws)
      ! 入力スペクトルデータに近似的ラプラシアン
      !
      !     ▽^2 =   1/a^2 cos^2φ・∂^2/∂λ^2 
      !            + 1/a^2 cosφ・∂/∂φ(cosφ∂/∂φ) 
      !            + ∂^2/∂r^2
      !
      ! を作用する.
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである. 
      !
      real(8), dimension((nm+1)*(nm+1),lm), intent(in) :: ws
      !(in) 2 次元球面調和函数 sin スペクトルデータ

      real(8), dimension((nm+1)*(nm+1),lm)             :: ws_Lapla_ws
      !(out) ラプラシアンを作用された 2 次元スペクトルデータ

      ws_Lapla_ws = ws_Drad_wc(wc_Drad_ws(ws)) + wa_Lapla_wa(ws)/Ro**2

    end function ws_Lapla_ws

    function wc_Lapla_wc(wc)
      ! 入力スペクトルデータに近似的ラプラシアン
      !
      !     ▽^2 =   1/a^2 cos^2φ・∂^2/∂λ^2 
      !            + 1/a^2 cosφ・∂/∂φ(cosφ∂/∂φ) 
      !            + ∂^2/∂r^2
      !
      ! を作用する.
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである. 
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wc
      !(in) 2 次元球面調和函数 cos スペクトルデータ

      real(8), dimension((nm+1)*(nm+1),0:lm)             :: wc_Lapla_wc
      !(out) ラプラシアンを作用された 2 次元スペクトルデータ

      wc_Lapla_wc = wc_DRad_ws(ws_DRad_wc(wc)) + wa_Lapla_wa(wc)/Ro**2

    end function wc_Lapla_wc

    function wc_LaplaInv_wc(wc)
      !
      ! スペクトルデータに逆ラプラシアンを作用させる. 
      !
      real(8), dimension((nm+1)*(nm+1),0:lm),intent(in) :: wc
      real(8), dimension((nm+1)*(nm+1),0:lm)            :: wc_LaplaInv_wc

      real(8), allocatable, dimension(:,:) :: wc_LaplaInvFactor
      logical :: first=.true.
      integer :: n, m, l

      save first, wc_LaplaInvFactor

      if ( first ) then
         first = .false.
         allocate(wc_LaplaInvFactor((nm+1)*(nm+1),0:lm))
         do n=0,nm
            do m=-n,n
               do l=0,lm
                  if ( n==0 .and. l==0 ) then
                     wc_LaplaInvFactor(l_nm(n,0),l) = 0.0D0
                  else
                     wc_LaplaInvFactor(l_nm(n,m),l) &
                          = -1.0D0/( n*(n+1)/Ro**2 + (PI/(Ro-Ri)*l)**2 )
                  end if
               end do
            end do
         end do
      end if

      wc_LaplaInv_wc = wc_LaplaInvFactor * wc
            
    end function wc_LaplaInv_wc
    
    function ws_LaplaInv_ws(ws)
      !
      ! スペクトルデータに逆ラプラシアンを作用させる. 
      !
      real(8), dimension((nm+1)*(nm+1),lm),intent(in) :: ws
      real(8), dimension((nm+1)*(nm+1),lm)            :: ws_LaplaInv_ws

      real(8), allocatable, dimension(:,:) :: ws_LaplaInvFactor
      logical :: first=.true.
      integer :: n, m, l

      save first, ws_LaplaInvFactor

      if ( first ) then
         first = .false.
         allocate(ws_LaplaInvFactor((nm+1)*(nm+1),lm))
         do n=0,nm
            do m=-n,n
               do l=1,lm
                  ws_LaplaInvFactor(l_nm(n,m),l) &
                       = -1.0D0/( n*(n+1)/Ro**2 + (PI/(Ro-Ri)*l)**2 )
               end do
            end do
         end do
      end if

      ws_LaplaInv_ws = ws_LaplaInvFactor * ws
            
    end function ws_LaplaInv_ws
    
    function xyz_GradLon_wc(wc)
      !
      ! スペクトルデータに近似的勾配型経度微分 1/(a cosφ)・∂/∂λ
      ! を作用させる.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wc
      !(in) 2 次元球面調和函数 cos スペクトルデータ

      real(8), dimension(0:im-1,1:jm,0:km)   :: xyz_GradLon_wc
      !(out) 勾配型経度微分を作用された 2 次元スペクトルデータ

      xyz_GradLon_wc = xya_GradLon_wa(wz_wc(wc))/Ro

    end function xyz_GradLon_wc

    function xyz_GradLon_ws(ws)
      !
      ! スペクトルデータに近似的勾配型経度微分 1/(a cosφ)・∂/∂λ
      ! を作用させる.
      !
      real(8), dimension((nm+1)*(nm+1),lm), intent(in) :: ws
       !(in) 2 次元球面調和函数 cos スペクトルデータ

      real(8), dimension(0:im-1,1:jm,0:km)   :: xyz_GradLon_ws
      !(out) 勾配型経度微分を作用された 2 次元スペクトルデータ

      xyz_GradLon_ws = xya_GradLon_wa(wz_ws(ws))/Ro

    end function xyz_GradLon_ws

    function xyz_GradLat_wc(wc) 
      !
      ! スペクトルデータに近似的勾配型経度微分 1/a ∂/∂φ を作用させる.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wc
      !(in) 2 次元球面調和函数 cos スペクトルデータ

      real(8), dimension(0:im-1,1:jm,0:km)    :: xyz_GradLat_wc
      !(out) 勾配型緯度微分を作用された 2 次元スペクトルデータ

      xyz_GradLat_wc = xya_GradLat_wa(wz_wc(wc))/Ro

    end function xyz_GradLat_wc

    function xyz_GradLat_ws(ws) 
      !
      ! スペクトルデータに近似的勾配型経度微分 1/a ∂/∂φ を作用させる.
      !
      real(8), dimension((nm+1)*(nm+1),lm), intent(in) :: ws
      !(in) 2 次元球面調和函数 sin スペクトルデータ

      real(8), dimension(0:im-1,1:jm,0:km)    :: xyz_GradLat_ws
      !(out) 勾配型緯度微分を作用された 2 次元スペクトルデータ

      xyz_GradLat_ws = xya_GradLat_wa(wz_ws(ws))/Ro

    end function xyz_GradLat_ws

    function wc_DivLon_xyz(xyz)
      ! 
      ! 格子点データに近似的発散型経度微分 1/(a cosφ)・∂/∂λ を作用させた
      ! スペクトルデータを返す.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in)   :: xyz
      !(in) 3 次元経度緯度動径格子点データ
      real(8), dimension((nm+1)*(nm+1),0:lm)       :: wc_DivLon_xyz
      !(out) 発散型経度微分を作用された cos スペクトルデータ

      wc_DivLon_xyz = wc_wz(wa_DivLon_xya(xyz/Ro))

    end function wc_DivLon_xyz
    
    function ws_DivLon_xyz(xyz)
      ! 
      ! 格子点データに近似的発散型経度微分 1/(a cosφ)・∂/∂λ を作用させた
      ! スペクトルデータを返す.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in)   :: xyz
      !(in) 3 次元経度緯度動径格子点データ
      real(8), dimension((nm+1)*(nm+1),lm)       :: ws_DivLon_xyz
      !(out) 発散型経度微分を作用された sin スペクトルデータ

      ws_DivLon_xyz = ws_wz(wa_DivLon_xya(xyz/Ro))

    end function ws_DivLon_xyz

    function wc_DivLat_xyz(xyz)
      !
      ! 格子データに近似的発散型緯度微分 1/(a cosφ)・∂(f cosφ)/∂φ を
      ! 作用させたスペクトルデータを返す.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in)   :: xyz
      !(in) 3 次元経度緯度動径格子点データ
      real(8), dimension((nm+1)*(nm+1),0:lm)       :: wc_DivLat_xyz
      !(out) 発散型緯度微分を作用された cos スペクトルデータ

      wc_DivLat_xyz = wc_wz(wa_divlat_xya(xyz/Ro))

    end function wc_DivLat_xyz

    function ws_DivLat_xyz(xyz)
      !
      ! 格子データに近似的発散型緯度微分 1/(a cosφ)・∂(f cosφ)/∂φ を
      ! 作用させたスペクトルデータを返す.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in)   :: xyz
      !(in) 3 次元経度緯度動径格子点データ
      real(8), dimension((nm+1)*(nm+1),lm)       :: ws_DivLat_xyz
      !(out) 発散型緯度微分を作用された cos スペクトルデータ

      ws_DivLat_xyz = ws_wz(wa_divlat_xya(xyz/Ro))

    end function ws_DivLat_xyz

    function wc_Div_xyz_xyz_xyz(xyz_Vlon,xyz_Vlat,xyz_Vrad)
      !
      ! べクトル成分である 3 つの格子データに近似的発散を作用させた
      ! スペクトルデータを返す.
      !
      ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分, 
      ! 動径成分を表し, 近似的発散は 
      !
      !   1/(a cosφ)・∂u/∂λ + 1/(a cosφ)・∂(v cosφ)/∂φ + ∂w/∂r 
      !
      ! と計算される.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlon
      !(in) ベクトル場の経度成分
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension((nm+1)*(nm+1),0:lm)     :: wc_Div_xyz_xyz_xyz
      !(out) ベクトル場の発散

      wc_Div_xyz_xyz_xyz =   wc_DivLon_xyz(xyz_Vlon) &
                           + wc_DivLat_xyz(xyz_Vlat) &
                           + wc_DivRad_ws(ws_xyz(xyz_Vrad))

    end function wc_Div_xyz_xyz_xyz

    function ws_Div_xyz_xyz_xyz(xyz_Vlon,xyz_Vlat,xyz_Vrad)
      !
      ! べクトル成分である 3 つの格子データに近似的発散を作用させた
      ! スペクトルデータを返す.
      !
      ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分, 
      ! 動径成分を表し, 近似的発散は 
      !
      !   1/(a cosφ)・∂u/∂λ + 1/(a cosφ)・∂(v cosφ)/∂φ + ∂w/∂r 
      !
      ! と計算される.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlon
      !(in) ベクトル場の経度成分
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension((nm+1)*(nm+1),lm)     :: ws_Div_xyz_xyz_xyz
      !(out) ベクトル場の発散

      ws_Div_xyz_xyz_xyz =   ws_DivLon_xyz(xyz_Vlon) &
                           + ws_DivLat_xyz(xyz_Vlat) &
                           + ws_DivRad_wc(wc_xyz(xyz_Vrad))

    end function ws_Div_xyz_xyz_xyz

    function xyz_Div_xyz_xyz_xyz(xyz_Vlon,xyz_Vlat,xyz_Vrad)
      !
      ! ベクトル成分である 3 つの格子データに近似的発散を作用させる.
      !
      ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分, 
      ! 動径成分を表す.
      !
      ! 極の特異性を回避するためにベクトル場に cosφの重みをかけて
      ! 計算している. 
      !
      !      div V = (1/cosφ)・div (Vcosφ) + V_φtanφ/a
      ! 
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension(0:im-1,1:jm,0:km)             :: xyz_Div_xyz_xyz_xyz
      !(out) ベクトル場の発散

      xyz_Div_xyz_xyz_xyz &
           = 1.0D0/cos(xyz_Lat) &
                * xyz_wc(wc_Div_xyz_xyz_xyz(xyz_VLon*cos(xyz_Lat),  &
                                            xyz_VLat*cos(xyz_Lat),  &
                                            xyz_VRad*cos(xyz_Lat))) &
             + xyz_VLat*tan(xyz_Lat)/Ro
      
    end function xyz_Div_xyz_xyz_xyz

!!$    function xyz_RotLon_ws_wc(ws_Vrad,wc_Vlat) 
!!$      !
!!$      ! ベクトル場の動径成分, 緯度成分である第 1, 2 引数 Vrad, Vlat から
!!$      ! 回転の近似的経度成分 
!!$      !
!!$      !    1/a ∂Vrad/∂φ-∂Vlat/∂r を計算する.
!!$      !
!!$      ! を計算する
!!$      !
!!$      real(8), dimension((nm+1)*(nm+1),lm), intent(in)   :: ws_Vrad
!!$      !(in) ベクトル場の動径成分
!!$
!!$      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wc_Vlat
!!$      !(in) ベクトル場の緯度成分
!!$
!!$      real(8), dimension(0:im-1,1:jm,0:km)               :: xyz_RotLon_ws_wc
!!$      !(out) ベクトル場の回転の経度成分
!!$
!!$      xyz_RotLon_ws_wc =  xyz_GradLat_ws(ws_Vrad) &
!!$                        - xyz_ws(ws_RotRad_wc(wc_Vlat))
!!$
!!$    end function xyz_RotLon_ws_wc
!!$
!!$    function xyz_RotLat_wc_ws(wc_Vlon,ws_Vrad) 
!!$      !
!!$      ! ベクトル場の経度成分, 動径成分である第 1, 2 引数 Vlon, Vrad から
!!$      ! 回転の緯度成分 
!!$      !
!!$      !    1/r ∂(r Vlon)/∂r - 1/rcosφ・∂Vrad/∂λ
!!$      !
!!$      ! を計算する.
!!$      !
!!$      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wc_Vlon
!!$      !(in) ベクトル場の経度成分
!!$
!!$      real(8), dimension((nm+1)*(nm+1),lm), intent(in)   :: ws_Vrad
!!$      !(in) ベクトル場の動径成分
!!$
!!$      real(8), dimension(0:im-1,1:jm,0:km)               :: xyz_RotLat_wc_ws
!!$      !(out) ベクトル場の回転の緯度成分
!!$
!!$      xyz_RotLat_wc_ws =   xyz_ws(ws_RotRad_wc(wc_Vlon)) &
!!$                         - xyz_GradLon_ws(ws_Vrad) 
!!$
!!$    end function xyz_RotLat_wc_ws

    function wc_RotRad_xyz_xyz(xyz_Vlat,xyz_Vlon) 
      !
      ! ベクトルの緯度成分, 経度成分である第 1, 2 引数 Vlat, Vlon に対して
      ! ベクトル場の近似的回転の動径成分 
      !
      !    1/(a cosφ)・∂Vlat/∂λ - 1/(a cosφ)・∂(Vlon cosφ)/∂φ
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension((nm+1)*(nm+1),0:lm)     :: wc_RotRad_xyz_xyz
      !(out) ベクトル場の回転の動径成分

      wc_RotRad_xyz_xyz =   wc_DivLon_xyz(xyz_Vlat) - wc_DivLat_xyz(xyz_Vlon)

    end function wc_RotRad_xyz_xyz

  !--------------- 積分計算 -----------------
    !----(入力データ xyz)---
    function yz_IntLon_xyz(xyz)  ! 経度(帯状)積分
      !
      ! 3 次元格子点データの経度方向(帯状)積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)dλ を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jm,0:km)  :: yz_IntLon_xyz
      !(out) 経度方向(帯状)積分された 2 次元子午面格子点データ

      integer :: i

      yz_IntLon_xyz = 0.0d0
      do i=0,im-1
         yz_IntLon_xyz(:,:) = yz_IntLon_xyz(:,:) &
                       + xyz(i,:,:) * x_Lon_Weight(i)
      enddo
    end function yz_IntLon_xyz

    function xz_IntLat_xyz(xyz)
      !
      ! 3 次元格子点データの緯度方向域積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) cosφ dφ を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,0:km)  :: xz_IntLat_xyz        
      !(out) 緯度積分された 2 次元緯度動径格子点データ.
      ! 緯度円格子点データ

      integer :: j

      xz_IntLat_xyz = 0.0d0
      do j=1,jm
         xz_IntLat_xyz(:,:) = xz_IntLat_xyz(:,:) &
                       + xyz(:,j,:) * y_Lat_Weight(j)
      enddo
    end function xz_IntLat_xyz

    function xy_IntRad_xyz(xyz)  ! 動径積分
      !
      ! 3 次元格子点データの動径方向域積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) r^2dr を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,1:jm)  :: xy_IntRad_xyz
      !(out) 動径積分された 2 次元経度緯度(水平, 球面)格子点データ

      integer :: k

      xy_IntRad_xyz = 0.0d0
      do k=0,km
         xy_IntRad_xyz(:,:) = xy_IntRad_xyz(:,:) &
                       + xyz(:,:,k) * z_Rad_Weight(k) 
      enddo
    end function xy_IntRad_xyz

    function x_IntLatRad_xyz(xyz)
      !
      ! 3 次元格子点データの緯度動径(子午面)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) r^2cosφ dφdr 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1)     :: x_IntLatRad_xyz
      !(out) 緯度動径(子午面)積分された 1 次元経度格子点データ

      integer :: j, k

      x_IntLatRad_xyz = 0.0D0
      do k=0,km
         do j=1,jm
            x_IntLatRad_xyz = x_IntLatRad_xyz &
                 + xyz(:,j,k) * y_Lat_Weight(j) * z_Rad_Weight(k)
         enddo
      enddo
    end function x_IntLatRad_xyz

    function y_IntLonRad_xyz(xyz)
      !
      ! 3 次元格子点データの経度動径(緯度円)積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) r^2dλdr を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jm)       :: y_IntLonRad_xyz
      !(out) 経度動径(緯度円)積分された 1 次元緯度格子点データ

      integer :: i, k

      y_IntLonRad_xyz = 0
      do k=0,km
         do i=0,im-1
            y_IntLonRad_xyz = y_IntLonRad_xyz &
                 + xyz(i,:,k) * x_Lon_Weight(i) * z_Rad_Weight(k)
         enddo
      enddo
    end function y_IntLonRad_xyz

    function z_IntLonLat_xyz(xyz)  ! 緯度経度(水平)積分
      !
      ! 3 次元格子点データの緯度経度(水平, 球面)積分
      ! 
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) cosφ dλdφ 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:km)     :: z_IntLonLat_xyz
      !(out) 緯度経度(水平, 球面)積分された 1 次元動径格子点データ

      integer :: i, j

      z_IntLonLat_xyz = 0
      do j=1,jm
         do i=0,im-1
            z_IntLonLat_xyz = z_IntLonLat_xyz &
                 + xyz(i,j,:) * x_Lon_Weight(i) * y_Lat_Weight(j)
         enddo
      enddo
    end function z_IntLonLat_xyz

    function IntLonLatRad_xyz(xyz) ! 緯度経度動径(全球)積分
      !
      ! 3 次元格子点データの緯度経度動径(全球)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !     ∫f(λ,φ,r) r^2cosφ dλdφdr 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz 
      !(in) 3 次元経度緯度動径格子点データ

      real(8)                     :: IntLonLatRad_xyz 
      !(out) 全球積分値

      integer :: i, j, k

      IntLonLatRad_xyz = 0
      do k=0,km
         do j=1,jm
            do i=0,im-1
               IntLonLatRad_xyz = IntLonLatRad_xyz &
                    + xyz(i,j,k) * x_Lon_Weight(i) &
                         * y_Lat_Weight(j) * z_Rad_Weight(k)
            enddo
         enddo
      enddo
    end function IntLonLatRad_xyz

    !----(入力データ yz)---
    function z_IntLat_yz(yz)  ! 緯度積分
      !
      ! 2 次元(YZ)格子点データの緯度方向域積分.
      !
      ! 2 次元データ f(φ,r) に対して∫f(φ,r) cosφ dφ を計算する.
      !
      real(8), dimension(jm,0:km), intent(in) :: yz
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(0:km)  :: z_IntLat_yz
      !(out) 緯度積分された 1 次元動径格子点データ

      integer :: j

      z_IntLat_yz = 0.0d0
      do j=1,jm
         z_IntLat_yz(:) = z_IntLat_yz(:) + yz(j,:) * y_Lat_Weight(j)
      enddo
    end function z_IntLat_yz

    function y_IntRad_yz(yz)  ! 動径積分
      !
      ! 2 次元(YZ)格子点データの動径方向域積分.
      !
      ! 2 次元データ f(φ,r) に対して∫f(φ,r) r^2dr を計算する.
      !
      real(8), dimension(1:jm,0:km), intent(in) :: yz
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(1:jm)  :: y_IntRad_yz
      !(out) 動径積分された 1 次元緯度格子点データ

      integer :: k

      y_IntRad_yz = 0.0d0
      do k=0,km
         y_IntRad_yz(:) = y_IntRad_yz(:) &
                       + yz(:,k) * z_Rad_Weight(k) 
      enddo
    end function y_IntRad_yz

    function IntLatRad_yz(yz)
      !
      ! 2 次元(YZ)格子点データの緯度動径積分(子午面)および平均
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) r^2cosφ dφdr を計算する.
      !
      real(8), dimension(1:jm,0:km), intent(in) :: yz
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8)                   :: IntLatRad_yz
      !(out) 積分値
      integer :: j, k

      IntLatRad_yz = 0
      do k=0,km
         do j=1,jm
            IntLatRad_yz = IntLatRad_yz &
                 + yz(j,k) * y_Lat_Weight(j) * z_Rad_Weight(k)
         enddo
      enddo
    end function IntLatRad_yz

    !----(入力データ xz)---
    function z_IntLon_xz(xz)
      !
      ! 2 次元(XZ)格子点データの経度方向積分.
      !
      ! 2 次元データ f(λ,r) に対して ∫f(λ,r)dλ を計算する.
      !
      real(8), dimension(0:im-1,0:km), intent(in) :: xz
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(0:km)  :: z_IntLon_xz
      !(out) 経度積分された 1 次元動径格子点データ

      integer :: i

      z_IntLon_xz = 0.0d0
      do i=0,im-1
         z_IntLon_xz(:) = z_IntLon_xz(:) + xz(i,:) * x_Lon_Weight(i)
      enddo

    end function z_IntLon_xz

    function x_IntRad_xz(xz)
      !
      ! 2 次元(XZ)格子点データの動径方向域積分.
      !
      ! 2 次元データ f(λ,r) に対して ∫f(λ,r) r^2dr を計算する.
      !
      real(8), dimension(0:im-1,0:km), intent(in) :: xz
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(0:im-1)  :: x_IntRad_xz
      !(out) 動径積分された 1 次元経度格子点データ

      integer :: k

      x_IntRad_xz = 0.0d0
      do k=0,km
         x_IntRad_xz(:) = x_IntRad_xz(:) &
                       + xz(:,k) * z_Rad_Weight(k) 
      enddo

    end function x_IntRad_xz

    function IntLonRad_xz(xz)  ! 経度動径(緯度円)積分
      !
      ! 2 次元(XZ)格子点データの経度動径積分
      !
      ! 2 次元データ f(λ,r) に対して∫f(λ,r) r^2dλdr を計算する.
      !
      real(8), dimension(0:im-1,0:km), intent(in) :: xz
      !(in) 2 次元緯度動径格子点データ

      real(8)                                 :: IntLonRad_xz
      !(out) 積分値

      integer :: i, k

      IntLonRad_xz = 0
      do k=0,km
         do i=0,im-1
            IntLonRad_xz = IntLonRad_xz &
                 + xz(i,k) * x_Lon_Weight(i) * z_Rad_Weight(k)
         enddo
      enddo
    end function IntLonRad_xz

    !----(入力データ z)---
    function IntRad_z(z)  ! 動径積分
      !
      ! 1 次元(Z)格子点データの動径方向域積分.
      !
      ! 1 次元データ f(r) に対して ∫f(r) r^2dr を計算する.
      !
      real(8), dimension(0:km), intent(in) :: z
      !(in) 1 次元動径格子点データ

      real(8)                              :: IntRad_z
      !(out) 積分値

      integer :: k

      IntRad_z = 0.0d0
      do k=0,km
         IntRad_z = IntRad_z + z(k) * z_Rad_Weight(k) 
      enddo
    end function IntRad_z

  !--------------- 平均計算 -----------------
    !----(入力データ xyz)---
    function yz_AvrLon_xyz(xyz)  ! 経度(帯状)積分
      !
      ! 3 次元格子点データの経度方向(帯状)平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)dλ/2π を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jm,0:km)  :: yz_AvrLon_xyz
      !(out) 経度方向(帯状)平均された 2 次元子午面格子点データ

      yz_AvrLon_xyz = yz_IntLon_xyz(xyz)/sum(x_Lon_Weight)

    end function yz_AvrLon_xyz

    function xz_AvrLat_xyz(xyz)  ! 緯度積分
      !
      ! 3 次元格子点データの緯度方向域平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)cosφ dφ/2 を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,0:km)  :: xz_AvrLat_xyz
      !(out) 緯度平均された 2 次元緯度動径格子点データ

      xz_AvrLat_xyz = xz_IntLat_xyz(xyz)/sum(y_Lat_Weight)

    end function xz_AvrLat_xyz

    function xy_AvrRad_xyz(xyz)
      !
      ! 3 次元格子点データの動径方向域平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して 
      !
      !    ∫f(λ,φ,r) r^2dr/((r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,1:jm)  :: xy_AvrRad_xyz          
      !(out) 動径平均された 2 次元経度緯度(水平, 球面)格子点データ
      ! 水平格子点データ

      xy_AvrRad_xyz = xy_IntRad_xyz(xyz)/sum(z_Rad_Weight)

    end function xy_AvrRad_xyz

    function x_AvrLatRad_xyz(xyz)  ! 緯度動径(子午面)積分
      !
      ! 3 次元格子点データの緯度動径(子午面)平均
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,,r) r^2cosφ dφdr /(2(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1)     :: x_AvrLatRad_xyz
      !(out) 緯度動径(子午面)平均された 1 次元経度格子点データ

      x_AvrLatRad_xyz = x_IntLatRad_xyz(xyz) &
                   /( sum(y_Lat_Weight)*sum(z_Rad_Weight) )

    end function x_AvrLatRad_xyz

    function y_AvrLonRad_xyz(xyz)  ! 経度動径(緯度円)積分
      !
      ! 3 次元格子点データの経度動径(緯度円)平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !     ∫f(λ,φ,r) r^2dλdr /(2π(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jm)       :: y_AvrLonRad_xyz
      !(out) 経度動径(緯度円)平均された 1 次元緯度格子点データ

      y_AvrLonRad_xyz = y_IntLonRad_xyz(xyz) &
                 /(sum(x_Lon_Weight)*sum(z_Rad_Weight))

    end function y_AvrLonRad_xyz

    function z_AvrLonLat_xyz(xyz)  ! 緯度経度(水平)積分
      !
      ! 3 次元格子点データの緯度経度(水平, 球面)積分
      ! 
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) cosφ dλdφ /4π 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:km)     :: z_AvrLonLat_xyz
      !(out) 緯度経度(水平, 球面)平均された 1 次元動径格子点データ

      z_AvrLonLat_xyz = z_IntLonLat_xyz(xyz) &
                 /(sum(x_Lon_Weight)*sum(y_Lat_Weight))

    end function z_AvrLonLat_xyz

    function AvrLonLatRad_xyz(xyz) ! 緯度経度動径(全球)積分
      !
      ! 3 次元格子点データの緯度経度動径(全球)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) r^2cosφ dλdφdr /(4π(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8)                     :: AvrLonLatRad_xyz
      !(out) 全球平均値

      AvrLonLatRad_xyz = IntLonLatRad_xyz(xyz) &
            /(sum(x_Lon_Weight)*sum(y_Lat_Weight) * sum(z_Rad_Weight))

    end function AvrLonLatRad_xyz

    !----(入力データ yz)---
    function z_AvrLat_yz(yz)
      !
      ! 2 次元(YZ)格子点データの緯度方向域平均.
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) cosφ dφ/2 を計算する.
      !
      real(8), dimension(1:jm,0:km), intent(in) :: yz
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(0:km)  :: z_AvrLat_yz
      !(out) 緯度平均された 1 次元動径格子点データ

      z_AvrLat_yz = z_IntLat_yz(yz)/sum(y_Lat_Weight)

    end function z_AvrLat_yz

    function y_AvrRad_yz(yz)
      !
      ! 2 次元(YZ)格子点データの動径方向域平均.
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) r^2dr /((r[o]^3-r[i]^3)/3) 
      ! を計算する.
      !
      real(8), dimension(1:jm,0:km), intent(in) :: yz
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(1:jm)  :: y_AvrRad_yz
      !(out) 動径平均された 1 次元緯度格子点データ

      y_AvrRad_yz = y_IntRad_yz(yz)/sum(z_Rad_Weight)

    end function y_AvrRad_yz

    function AvrLatRad_yz(yz)  ! 緯度動径(子午面)積分
      !
      ! 2 次元(YZ)格子点データの緯度動径(子午面)平均
      !
      ! 2 次元データ f(φ,r) に対して
      !
      !    ∫f(φ,r) r^2cosφ dφdr /(2(r[o]^3-r[i]^3)/3)
      !
      ! を計算する.
      !
      real(8), dimension(1:jm,0:km), intent(in) :: yz
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8)                   :: AvrLatRad_yz
      !(out) 平均値

      AvrLatRad_yz = IntLatRad_yz(yz)/(sum(y_Lat_Weight)*sum(z_Rad_Weight))

    end function AvrLatRad_yz

    !----(入力データ xz)---
    function z_AvrLon_xz(xz)  ! 経度(帯状)積分
      !
      ! 2 次元(XZ)格子点データの経度方向平均.
      !
      ! 2 次元データ f(λ,r) に対して ∫f(λ,r)dλ/2π を計算する.
      !
      real(8), dimension(0:im-1,0:km), intent(in) :: xz
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(0:km)  :: z_AvrLon_xz 
      !(out) 経度平均された 1 次元動径格子点データ

      z_AvrLon_xz = z_IntLon_xz(xz)/sum(x_Lon_Weight)

    end function z_AvrLon_xz

    function x_AvrRad_xz(xz)  ! 動径積分
      !
      ! 2 次元(XZ)格子点データの動径方向域平均.
      !
      ! 2 次元データ f(λ,r) に対して
      !
      !   ∫f(λ,r) r^2dr /((r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,0:km), intent(in) :: xz
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(0:im-1)  :: x_AvrRad_xz
      !(out) 動径平均された 1 次元経度格子点データ

      x_AvrRad_xz = x_IntRad_xz(xz)/sum(z_Rad_Weight)

    end function x_AvrRad_xz

    function AvrLonRad_xz(xz)  ! 経度動径(緯度円)積分
      !
      ! 2 次元(XZ)格子点データの経度動径平均
      !
      ! 2 次元データ f(λ,r) に対して 
      ! 
      !    ∫f(λ,r) r^2dλdr /(2π(r[o]^3-r[i]^3)/3)
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,0:km), intent(in) :: xz    
      ! (in) 2 次元格子点データ
      real(8)                                 :: AvrLonRad_xz      
      ! 積分値

      AvrLonRad_xz = IntLonRad_xz(xz)/(sum(x_Lon_Weight)*sum(z_Rad_Weight))

    end function AvrLonRad_xz

    !----(入力データ z)---
    function AvrRad_z(z)
      !
      ! 1 次元(Z)格子点データの動径方向域平均.
      !
      ! 1 次元データ f(r) に対して ∫f(r) r^2dr /((r[o]^3-r[i]^3)/3) を
      ! 計算する.
      !
      real(8), dimension(0:km), intent(in) :: z
      !(in) 1 次元動径格子点データ
      real(8)                              :: AvrRad_z
      !(out) 平均値

      AvrRad_z = IntRad_z(z)/sum(z_Rad_Weight)

    end function AvrRad_z

  !--------------- ポロイダル/トロイダルモデル用微分 -----------------

    function wc_KxRGrad_wc(wc)
      !
      ! 入力スペクトルデータに経度微分 k×r・▽ = ∂/∂λを作用する.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wc
      !(in) 2 次元球面調和函数 cos スペクトルデータ

      real(8), dimension((nm+1)*(nm+1),0:lm)             :: wc_KxRGrad_wc
      !(out) 経度微分を作用された 2 次元スペクトルデータ

      wc_KxRGrad_wc =  wa_Dlon_wa(wc)

    end function wc_KxRGrad_wc

    function ws_KxRGrad_ws(ws)
      !
      ! 入力スペクトルデータに経度微分 k×r・▽ = ∂/∂λを作用する.
      !
      real(8), dimension((nm+1)*(nm+1),lm), intent(in) :: ws
      !(in) 2 次元球面調和函数 sin スペクトルデータ

      real(8), dimension((nm+1)*(nm+1),lm)             :: ws_KxRGrad_ws
      !(out) 経度微分を作用された 2 次元スペクトルデータ

      ws_KxRGrad_ws =  wa_Dlon_wa(ws)

    end function ws_KxRGrad_ws

    function wc_L2_wc(wc)
      !
      ! 入力スペクトルデータに L^2 演算子(=-水平ラプラシアン)を作用する.
      !
      ! L^2 演算子は単位球面上の水平ラプラシアンの逆符号にあたる. 
      !  入力スペクトルデ ータに対応する格子点データに演算子 
      !
      !     L^2 = -1/cos^2φ・∂^2/∂λ^2 - 1/cosφ・∂/∂φ(cosφ∂/∂φ)
      !
      ! を作用させたデータのスペクトル変換が返される.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wc
      !(in) 2 次元球面調和函数 cos スペクトルデータ

      real(8), dimension((nm+1)*(nm+1),0:lm)             :: wc_L2_wc
      !(out) L^2 演算子を作用された 2 次元スペクトルデータ

      wc_L2_wc = -wa_Lapla_wa(wc)

    end function wc_L2_wc

    function ws_L2_ws(ws)
      !
      ! 入力スペクトルデータに L^2 演算子(=-水平ラプラシアン)を作用する.
      !
      ! L^2 演算子は単位球面上の水平ラプラシアンの逆符号にあたる. 
      !  入力スペクトルデ ータに対応する格子点データに演算子 
      !
      !     L^2 = -1/cos^2φ・∂^2/∂λ^2 - 1/cosφ・∂/∂φ(cosφ∂/∂φ)
      !
      ! を作用させたデータのスペクトル変換が返される.
      !
      real(8), dimension((nm+1)*(nm+1),lm), intent(in) :: ws
      !(in) 2 次元球面調和函数 sin スペクトルデータ

      real(8), dimension((nm+1)*(nm+1),lm)             :: ws_L2_ws
      !(out) L^2 演算子を作用された 2 次元スペクトルデータ

      ws_L2_ws = -wa_Lapla_wa(ws)

    end function ws_L2_ws

    function wc_L2Inv_wc(wc)
      !
      ! 入力スペクトルデータに L^2 演算子の逆演算(-逆水平ラプラシアン)を
      ! 作用する.
      !
      ! スペクトルデータに L^2 演算子を作用させる関数 wc_L2_wc の逆計算を
      ! 行う関数である.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wc
      !(in) 2 次元球面調和函数 cos スペクトルデータ

      real(8), dimension((nm+1)*(nm+1),0:lm)             :: wc_L2Inv_wc
      !(out) L^2 演算子の逆演算を作用された 2 次元スペクトルデータ

      wc_L2Inv_wc = -wa_LaplaInv_wa(wc)

    end function wc_L2Inv_wc

    function ws_L2Inv_ws(ws)
      !
      ! 入力スペクトルデータに L^2 演算子の逆演算(-逆水平ラプラシアン)を
      ! 作用する.
      !
      ! スペクトルデータに L^2 演算子を作用させる関数 ws_L2_ws の逆計算を
      ! 行う関数である.
      !
      real(8), dimension((nm+1)*(nm+1),lm), intent(in) :: ws
      !(in) 2 次元球面調和函数 sin スペクトルデータ

      real(8), dimension((nm+1)*(nm+1),lm)             :: ws_L2Inv_ws
      !(out) L^2 演算子の逆演算を作用された 2 次元スペクトルデータ

      ws_L2Inv_ws = -wa_LaplaInv_wa(ws)

    end function ws_L2Inv_ws

    function wc_RadRot_xyz_xyz(xyz_VLON,xyz_VLAT)  ! r・(▽×v)
      !
      ! ベクトルの渦度と動径ベクトルの内積 r・(▽×v) を計算する.
      !
      ! 第 1, 2 引数(v[λ], v[φ])がそれぞれベクトルの経度成分, 緯度成分を表す.
      !
      !    r・(▽×v) = 1/cosφ・∂v[φ]/∂λ - 1/cosφ・∂(v[λ] cosφ)/∂φ
      !
      ! のスペクトル データが返される.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_VLON
      !(in) ベクトルの経度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_VLAT
      !(in) ベクトルの緯度成分

      real(8), dimension((nm+1)*(nm+1),0:lm)     :: wc_RadRot_xyz_xyz
      !(out) ベクトルの渦度と動径ベクトルの内積

      wc_RadRot_xyz_xyz = wc_wz(wa_DivLon_xya(xyz_VLAT) &
                                - wa_DivLat_xya(xyz_VLON))
      
    end function wc_RadRot_xyz_xyz

    function ws_RadRotRot_xyz_xyz_xyz(xyz_VLON,xyz_VLAT,xyz_VRAD) 
      ! 
      ! ベクトル v に対して近似的な r・(▽×▽×v) を計算する.
      !
      ! 第 1, 2, 3 引数(v[λ], v[φ], v[r])がそれぞれベクトルの経度成分, 
      ! 緯度成分, 動径成分を表す. 
      !
      !    r・(▽×▽×v)  = ∂/∂r ((  1/cosφ・∂v[λ]/∂λ 
      !                               + 1/cosφ・∂(v[φ] cosφ)/∂φ ) ) 
      !                     + L^2 v[r]/a 
      !
      ! のスペクトルデータが返される.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_VLON
      !(in) ベクトルの経度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_VLAT
      !(in) ベクトルの緯度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_VRAD
      !(in) ベクトルの動径成分

      real(8), dimension((nm+1)*(nm+1),lm)     :: ws_RadRotRot_xyz_xyz_xyz
      !(out) ベクトル v の r・(▽×▽×v) 

      ws_RadRotRot_xyz_xyz_xyz = &
               ws_RotRad_wc(wc_wz( &
                   (wa_DivLon_xya(xyz_VLON)+ wa_DivLat_xya(xyz_VLAT)))) &
             + ws_L2_ws(ws_xyz(xyz_VRAD/Ro))

    end function ws_RadRotRot_xyz_xyz_xyz

    subroutine wsc_Potential2Vector(&
         xyz_VLON,xyz_VLAT,xyz_VRAD,wc_TORPOT,ws_POLPOT)
      !
      ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
      !
      !     v = ▽x(Ψr) + ▽x▽x(Φr) 
      !
      ! の各成分を計算する
      !
      real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VLON
      !(out) ベクトル場の経度成分

      real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VLAT
      !(out) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VRAD
      !(out) ベクトル場の動径成分

      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wc_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension((nm+1)*(nm+1),lm), intent(in) :: ws_POLPOT
      !(in) ポロイダルポテンシャル

      xyz_VLON =   Ro * xyz_GradLat_wc(wc_TORPOT) &
                 + xya_GradLon_wa(wz_wc(wc_RotRad_ws(ws_POLPOT)))
      xyz_VLAT = - Ro * xyz_GradLon_wc(wc_TORPOT) &
                 + xya_GradLat_wa(wz_wc(wc_RotRad_ws(ws_POLPOT)))
      xyz_VRAD = xyz_ws(ws_L2_ws(ws_POLPOT))/Ro

    end subroutine wsc_Potential2Vector

    subroutine wsc_Potential2Rotation(&
       xyz_RotVLON,xyz_RotVLAT,xyz_RotVRAD,wc_TORPOT,ws_POLPOT)
      !
      ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
      !
      !     v = ▽x(Ψr) + ▽x▽x(Φr) 
      !
      ! に対して, その回転
      !
      !     ▽xv = ▽x▽x(Ψr) + ▽x▽x▽x(Φr) = ▽x▽x(Ψr) - ▽x((▽^2Φ)r)
      !
      ! を計算する. 
      
      ! ベクトル場の回転
      real(8), dimension(0:im-1,1:jm,0:km), intent(OUT) :: xyz_RotVLON
      !(out) 回転の経度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(OUT) :: xyz_RotVLAT
      !(out) 回転の緯度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(OUT) :: xyz_RotVRAD
      !(out) 回転の動径成分

      ! 入力ベクトル場を表すポテンシャル
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wc_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension((nm+1)*(nm+1),lm), intent(in) :: ws_POLPOT
      !(in) ポロイダルポテンシャル

      xyz_RotVLON =   Ro * xyz_GradLat_ws(-ws_Lapla_ws(ws_POLPOT)) &
                    + xya_GradLon_wa(wz_ws(ws_RotRad_wc(wc_TORPOT)))
      xyz_RotVLAT = - Ro * xyz_GradLon_ws(-ws_Lapla_ws(ws_POLPOT)) &
                    + xya_GradLat_wa(wz_ws(ws_RotRad_wc(wc_TORPOT)))
      xyz_RotVRAD = xyz_wc(wc_L2_wc(wc_TORPOT))/Ro

    end subroutine wsc_Potential2Rotation


  !--------------- 補間計算 -----------------
    function Interpolate_wc(wc_data,alon,alat,arad)
      !
      ! 緯度 alon, 経度 alat 動径 arad における関数値を
      ! その球面調和変換係数 wa_data から補間計算する
      !
      real(8), intent(IN) :: wc_data((nm+1)**2,0:lm)  ! スペクトルデータ
      real(8), intent(IN) :: alon                     ! 補間する位置(経度)
      real(8), intent(IN) :: alat                     ! 補間する位置(緯度)
      real(8), intent(IN) :: arad                     ! 補間する位置(動径)
      real(8) :: Interpolate_wc                       ! 補間した値
      
      Interpolate_wc = &
           Interpolate_w(a_Interpolate_ac(wc_data,arad),alon,alat)

    end function Interpolate_wc

    function Interpolate_ws(ws_data,alon,alat,arad)
      !
      ! 緯度 alon, 経度 alat 動径 arad における関数値を
      ! その球面調和変換係数 wa_data から補間計算する
      !
      real(8), intent(IN) :: ws_data((nm+1)**2,lm)    ! スペクトルデータ
      real(8), intent(IN) :: alon                     ! 補間する位置(経度)
      real(8), intent(IN) :: alat                     ! 補間する位置(緯度)
      real(8), intent(IN) :: arad                     ! 補間する位置(動径)
      real(8) :: Interpolate_ws                       ! 補間した値
      
      Interpolate_ws = &
           Interpolate_w(a_Interpolate_as(ws_data,arad),alon,alat)

    end function Interpolate_ws

  !--------------- ポロイダル/トロイダルモデル用スペクトル解析 ----------------

    function nmz_ToroidalEnergySpectrum_wc(wc_TORPOT)
      !
      ! トロイダルポテンシャルから, トロイダルエネルギーの
      ! 球面調和函数全波数 n, 帯状波数 m の各成分を計算する
      !
      !  * 全波数 n, 帯状波数 m のトロイダルポテンシャルのスペクトル成分
      !    ψ(n,m,r)から全波数 n, 帯状波数 m 成分のトロイダルエネルギー
      !    スペクトルは  (1/2)n(n+1)4πa^2|ψ(n,m,r)|^2  と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和を動径積分したもの(a^2の重み無し)
      !    が球殻内での全エネルギーに等しい.
      !    
      !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !    wsc_VMiss によって設定できる (初期値は -999.0)
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wc_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension(0:nm,-nm:nm,0:km) :: nmz_ToroidalEnergySpectrum_wc
      !(out) エネルギースペクトルトロイダル成分

      real(8), dimension((nm+1)*(nm+1),0:km) ::wz_DATA   ! 作業領域
      integer :: n, m

      nmz_ToroidalEnergySpectrum_wc = wsc_VMiss

      wz_DATA = wz_wc(wc_TORPOT)
      do n=0,nm
         nmz_ToroidalEnergySpectrum_wc(n,0,:) &
              = 0.5 * n*(n+1)* (4*pi) * Ro**2 &
                * wz_DATA(l_nm(n,0),:)**2
         do m=1,n
            nmz_ToroidalEnergySpectrum_wc(n,m,:) &
              = 0.5 * n*(n+1)* (4*pi) * Ro**2    &
                * (wz_DATA(l_nm(n,m),:)**2+wz_DATA(l_nm(n,-m),:)**2)
            nmz_ToroidalEnergySpectrum_wc(n,-m,:) &
                 = nmz_ToroidalEnergySpectrum_wc(n,m,:) 
         enddo
      enddo

    end function nmz_ToroidalEnergySpectrum_wc

    function nz_ToroidalEnergySpectrum_wc(wc_TORPOT)
      !
      ! トロイダルポテンシャルから, トロイダルエネルギーの
      ! 球面調和函数全波数の各成分を計算する.
      !
      !  * 全波数 n, 帯状波数 m のトロイダルポテンシャルのスペクトル成分
      !    ψ(n,m,r)から全波数 n 成分のトロイダルエネルギースペクトルは
      !    Σ[m=-n]^n(1/2)n(n+1)4πa^2|ψ(n,m,r)|^2 と計算される.
      !
      ! * 全てのエネルギースペクトル成分の和を動径積分したもの(a^2の重み無し)
      !    が球殻内での全エネルギーに等しい.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wc_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension(0:nm,0:km) :: nz_ToroidalEnergySpectrum_wc
      !(out) エネルギースペクトルトロイダル成分

      real(8), dimension((nm+1)*(nm+1),0:km) ::wz_DATA   ! 作業領域
      integer :: n, m

      wz_DATA = wz_wc(wc_TORPOT)
      do n=0,nm
         nz_ToroidalEnergySpectrum_wc(n,:) &
              = 0.5 * n*(n+1)* (4*pi) * Ro**2 * wz_Data(l_nm(n,0),:)**2
         do m=1,n
            nz_ToroidalEnergySpectrum_wc(n,:) &
                 = nz_ToroidalEnergySpectrum_wc(n,:) &
                 + 0.5 * n*(n+1)* (4*pi) * Ro**2  &
                 * 2* (wz_Data(l_nm(n,m),:)**2 + wz_Data(l_nm(n,-m),:)**2)
         enddo
      enddo

    end function nz_ToroidalEnergySpectrum_wc

    function nmz_PoloidalEnergySpectrum_ws(ws_POLPOT)
      !
      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
      ! 球面調和函数全波数 n, 帯状波数 m の各成分を計算する.
      !
      !  * 全波数 n, 帯状波数 m のポロイダルポテンシャルのスペクトル成分
      !    φ(n,m,r)から全波数 n, 帯状波数 m 成分のポロイダルエネルギー
      !    スペクトルは 
      !
      !      (1/2)n(n+1)4π{|d(aφ(n,m,r))/dr|^2 + n(n+1)|φ(n,m,r)|^2} 
      !
      !    と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和を動径積分したもの(a^2の重み無し)
      !    が球殻内での全エネルギーに等しい.
      !
      !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !    欠損値の値はモジュール変数 wsc_VMiss によって設定できる
      !    (初期値は -999.0)
      !
      real(8), dimension((nm+1)*(nm+1),lm), intent(in) :: ws_POLPOT
      !(in) ポロイダルポテンシャル

      real(8), dimension(0:nm,-nm:nm,0:km) :: nmz_PoloidalEnergySpectrum_ws
      !(out) エネルギースペクトルポロイダル成分


      real(8), dimension((nm+1)*(nm+1),0:km) ::wz_DATA1   ! 作業領域
      real(8), dimension((nm+1)*(nm+1),0:km) ::wz_DATA2   ! 作業領域
      integer :: n, m

      nmz_PoloidalEnergySpectrum_ws = wsc_VMiss

      wz_Data1 = wz_ws(ws_POLPOT)
      wz_Data2 = Ro*wz_wc(wc_DRad_ws(ws_POLPOT))      ! d(rφ)/dr ~ a dφ/dr

      do n=0,nm
         nmz_PoloidalEnergySpectrum_ws(n,0,:) = &
                 + 0.5* n*(n+1)* (4*pi) &
                 *( wz_Data2(l_nm(n,0),:)**2  &
                   + n*(n+1)*wz_Data1(l_nm(n,0),:)**2 )
         do m=1,n
            nmz_PoloidalEnergySpectrum_ws(n,m,:) = &
                 + 0.5* n*(n+1)* (4*pi) &
                 *( wz_Data2(l_nm(n,m),:)**2 + wz_Data2(l_nm(n,-m),:)**2 &
                 + n*(n+1)* ( wz_Data1(l_nm(n,m),:)**2 + wz_Data1(l_nm(n,-m),:)**2))
            nmz_PoloidalEnergySpectrum_ws(n,-m,:) = &
                 nmz_PoloidalEnergySpectrum_ws(n,m,:)
         enddo
      enddo

    end function nmz_PoloidalEnergySpectrum_ws

    function nz_PoloidalEnergySpectrum_ws(ws_POLPOT)
      !
      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
      ! 球面調和函数全波数の各成分を計算する
      !
      !  * 全波数 n, 帯状波数 m のポロイダルポテンシャルのスペクトル成分
      !    φ(n,m,r)から全波数 n 成分のポロイダルエネルギースペクトルは
      !
      !      Σ[m=-n]^n ((1/2)n(n+1)4π{|d(rφ(n,m,r))/dr|^2 
      !                 + n(n+1)|φ(n,m,r)|^2} 
      !
      !    と計算される.
      !
      !  * 全ての全波数に対してのエネルギースペクトル成分の和を動径積分したもの
      !    (r^2の重み無し)が球殻内での全エネルギーに等しい.
      !
      real(8), dimension((nm+1)*(nm+1),lm), intent(in) :: ws_POLPOT
      !(in) ポロイダルポテンシャル

      real(8), dimension(0:nm,0:km) :: nz_PoloidalEnergySpectrum_ws
      !(out) エネルギースペクトルポロイダル成分

      real(8), dimension((nm+1)*(nm+1),0:km) ::wz_DATA1   ! 作業領域
      real(8), dimension((nm+1)*(nm+1),0:km) ::wz_DATA2   ! 作業領域
      integer :: n, m

      wz_Data1 = wz_ws(ws_POLPOT)
      wz_Data2 = Ro * wz_wc(wc_DRad_ws(ws_POLPOT))  ! d(rφ)/dr ~ a dφ/dr

      do n=0,nm
         nz_PoloidalEnergySpectrum_ws(n,:) &
              = 0.5* n*(n+1)* (4*pi) &
              *( wz_Data2(l_nm(n,0),:)**2  + n*(n+1)*wz_Data1(l_nm(n,0),:)**2 )
         do m=1,n
            nz_PoloidalEnergySpectrum_ws(n,:) &
                 = nz_PoloidalEnergySpectrum_ws(n,:) &
                 + 2 * 0.5* n*(n+1)* (4*pi) &
                 *( wz_Data2(l_nm(n,m),:)**2 + wz_Data2(l_nm(n,-m),:)**2 &
                 + n*(n+1)*(wz_Data1(l_nm(n,m),:)**2 +wz_Data1(l_nm(n,-m),:)**2))
         enddo
      enddo

    end function nz_PoloidalEnergySpectrum_ws

end module wsc_module_svpack

!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  eee_mpi_module テストプログラム
!
!履歴  2008/05/21  竹広真一
!
program eee_mpi_test_EnergyHelicity

  use dc_message, only : MessageNotify
  use eee_mpi_module
  use mpi
  implicit none
  !include 'mpif.h'

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=64, km=32          ! 格子点の設定(X,Y,Z)
  integer, parameter :: lm=10, mm=21, nm=10          ! 切断波数の設定(X,Y,Z)

 !---- 変数 ----
  real(8), allocatable :: zxv_VelX(:,:,:)    ! 格子データ(速度 X)
  real(8), allocatable :: zxv_VelY(:,:,:)    ! 格子データ(速度 Y)
  real(8), allocatable :: zxv_VelZ(:,:,:)    ! 格子データ(速度 Z)

  real(8), allocatable :: zxv_VorX(:,:,:)    ! 格子データ(渦度 X)
  real(8), allocatable :: zxv_VorY(:,:,:)    ! 格子データ(渦度 Y)
  real(8), allocatable :: zxv_VorZ(:,:,:)    ! 格子データ(渦度 Z)

  real(8), allocatable :: eef_VorX(:,:,:)    ! スペクトルデータ
  real(8), allocatable :: eef_VorY(:,:,:)    ! スペクトルデータ
  real(8), allocatable :: eef_VorZ(:,:,:)    ! スペクトルデータ

  real(8), allocatable :: ee2f_Zeta(:,:,:,:) ! スペクトルデータx2

  real(8)            :: Energy, Helicity
  real(8)            :: EnergyHelicity(2)

 !---- 座標変数など ----
  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: eps = 1.0d-10            ! 判定誤差

  integer            :: np, ip, ierr
  integer :: l=2, m=1, n

  call MessageNotify('M','eee_mpi_test_EnergyHelicity', &
       'eee_mpi_module Energy and Helicity calculation tests')


 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

 !---------------- 座標値の設定 ---------------------
  call eee_mpi_initial(im,jm,km,lm,mm,nm)

 !---------------- 変数の割付け ---------------------
  allocate(zxv_VelX(0:km-1,0:im-1,js(ip):je(ip)))
  allocate(zxv_VelY(0:km-1,0:im-1,js(ip):je(ip)))
  allocate(zxv_VelZ(0:km-1,0:im-1,js(ip):je(ip)))

  allocate(zxv_VorX(0:km-1,0:im-1,js(ip):je(ip)))
  allocate(zxv_VorY(0:km-1,0:im-1,js(ip):je(ip)))
  allocate(zxv_VorZ(0:km-1,0:im-1,js(ip):je(ip)))

  allocate(eef_VorX(-nm:nm,-mm:mm,2*lc(ip)))
  allocate(eef_VorY(-nm:nm,-mm:mm,2*lc(ip)))
  allocate(eef_VorZ(-nm:nm,-mm:mm,2*lc(ip)))

  allocate(ee2f_Zeta(-nm:nm,-mm:mm,2,2*lc(ip)))

 !---------------- 速度・渦度の設定 ---------------------
!!$  write(6,*) '  Input wavenumbers of the grid data, l and m :'
!!$  read(5,*) l,m
  n = -(l+m)
  write(6,*) '  l,m,n = ', l,m,n

  zxv_VelX = cos(l*zxv_X)*sin(m*zxv_Y)*sin(n*zxv_Z)
  zxv_VelY = sin(l*zxv_X)*cos(m*zxv_Y)*sin(n*zxv_Z)
  zxv_VelZ = sin(l*zxv_X)*sin(m*zxv_Y)*cos(n*zxv_Z)

  zxv_VorX = (m-n)*sin(l*zxv_X)*cos(m*zxv_Y)*cos(n*zxv_Z)
  zxv_VorY = (n-l)*cos(l*zxv_X)*sin(m*zxv_Y)*cos(n*zxv_Z)
  zxv_VorZ = (l-m)*cos(l*zxv_X)*cos(m*zxv_Y)*sin(n*zxv_Z)

  eef_VorX = eef_zxv(zxv_VorX)
  eef_VorY = eef_zxv(zxv_VorY)
  eef_VorZ = eef_zxv(zxv_VorZ)

 !------------- 渦度 ζ への変換と Energy Helicity 計算 -----------------
  ee2f_Zeta = ee2f_ZetaFromVor_eef_eef_eef(eef_VorX,eef_VorY,eef_VorZ)
  EnergyHelicity = EnergyHelicityFromZeta_ee2f(ee2f_Zeta)

 !---------------- 格子点で Energy, Helicity の計算 ---------------------
  
  Energy = 0.5 * AvrZXV_zxv(zxv_VelX**2+zxv_VelY**2+zxv_VelZ**2)

  Helicity = AvrZXV_zxv(zxv_VelX*zxv_VorX +zxv_VelY*zxv_VorY + zxv_VelZ*zxv_VorZ)
  

 !---------------- 計算チェック ---------------------
  call check0d(EnergyHelicity(1)-Energy, eps, 'Calculation of Energy')
  call check0d(EnergyHelicity(2)-Helicity, eps, 'Calculation of Helicity')

  call MessageNotify('M','eee_mpi_test_EnergyHelicity', &
       'eee_mpi_module Energy Helicity calulcation tests suceeded')

  call MPI_FINALIZE(IERR)

 stop
contains

  subroutine check0d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var                     ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname

    if ( present(funcname) )then
       write(6,*) '  Checking ', funcname, '...'
    endif

    if (abs(var) .gt. eps ) then
       write(6,*) '    Value larger than EPS : ', var
       call MessageNotify('E','eee_test_EnergyHelicity', &
                          'calculation error too large')
    end if

  end subroutine check0d


end program eee_mpi_test_EnergyHelicity

!------------------------------------------------------------------------
! Copyright (c) 2011 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  eea_module_fftj テストプログラム (正逆変換)
!
!履歴  2011/12/10  竹広真一
!
program eea_module_fftj_transform_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use eea_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32              ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yxa_Data(0:jm-1,0:im-1,2)    ! 格子データ
  real(8)            :: xya_Data(0:jm-1,0:im-1,2)    ! 格子データ
  real(8)            :: eea_Data(-lm:lm,-km:km,2)    ! スペクトルデータ

  integer            :: k=2,l=5

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','eea_module_fftj_transform_test', &
       'eea_module_fftj transform function tests')

 !---------------- 座標値の設定 ---------------------
  call eea_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
  yxa_Data(:,:,1) = sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  eea_Data(:,:,1) = 0.0 ; eea_Data(-l,k,1) = 0.25  ; eea_Data(l,k,1) = -0.25

  yxa_Data(:,:,2) = cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  eea_Data(:,:,2) = 0.0 ; eea_Data(l,k,2) = 0.25  ; eea_Data(-l,k,2) = 0.25

  call check(eea_yxa(yxa_Data), eea_Data, &
       'Transform sin(k*pi*X)*sin(l*pi*Y),cos(k*pi*X)*cos(l*pi*Y)')
  call check(yxa_eea(eea_yxa(yxa_Data)), yxa_Data, &
       'Inverse transform sin(k*pi*X)*sin(l*pi*Y),cos(k*pi*X)*cos(l*pi*Y)')

  yxa_Data(:,:,1) = sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  eea_Data(:,:,1) = 0.0 ; eea_Data(-l,-k,1) = -0.25  ; eea_Data(l,-k,1) = - 0.25
  yxa_Data(:,:,2) = cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  eea_Data(:,:,2) = 0.0 ; eea_Data(-l,-k,2) = -0.25  ; eea_Data(l,-k,2) = 0.25
  call check(eea_yxa(yxa_Data), eea_Data, &
       'Transform sin(k*pi*X)*cos(l*pi*Y),cos(k*pi*X)*sin(l*pi*Y)')
  call check(yxa_eea(eea_yxa(yxa_Data)), yxa_Data, &
       'Inverse transform sin(k*pi*X)*cos(l*pi*Y),cos(k*pi*X)*sin(l*pi*Y)')

  call MessageNotify('M','eea_module_fftj_transform_test', &
       'eea_module_fftj transform function tests succeeded!')

  yxa_Data(:,:,1) = sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  xya_Data(:,:,1) = sin(k*pi*xy_X) * sin(l*pi*xy_Y)

  yxa_Data(:,:,2) = cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  xya_Data(:,:,2) = cos(k*pi*xy_X) * cos(l*pi*xy_Y)

  call check(xya_yxa(yxa_Data), xya_Data, &
       'Shape transform sin(k*pi*X)*cos(l*pi*Y),cos(k*pi*X)*sin(l*pi*Y)')
  call check(yxa_xya(xya_yxa(yxa_Data)), yxa_Data, &
       'Inverse shape transform sin(k*pi*X)*cos(l*pi*Y),cos(k*pi*X)*sin(l*pi*Y)')

contains

  subroutine check(var,sol,funcname)
    real(8) :: var(:,:,:)                ! 判定する配列
    real(8) :: sol(:,:,:)                ! 誤差
    character(len=*) :: funcname

    call AssertEqual(     &
      message = funcname, &
      answer = sol,       &
      check = var,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check

end program eea_module_fftj_transform_test

!------------------------------------------------------------------------
! Copyright (c) 2009-2013 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  fe_module テストプログラム (正逆変換)
!
!履歴  2009/12/11  竹広真一
!      2013/05/22  佐々木洋平
!      2016/01/01  竹広真一  ef => fe へ命名変更
!
program fe_module_base_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use fe_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm-1,0:im-1)    ! 格子データ
  integer            :: k=2

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: yrad = 2.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 3
  integer, parameter :: ignore = -4

  call MessageNotify('M','fe_module_base_test', &
       'fe_module basic transform function tests')

 !---------------- 座標値の設定 ---------------------
  call fe_initial(im,jm,km,lm,xmin,xmax,yrad)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
  yx_Data = sin(k*pi*yx_X) * exp(-yx_Y**2)

  call AssertEqual(&
    message='fe_yx, yx_ef with sin(k*pi*X)*exp(-Y**2)',           &
    answer = yx_Data,                                             &
    check = yx_fe(fe_yx(yx_Data)),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = cos(k*pi*yx_X) * yx_Y/2 * exp(-yx_Y**2)

  call AssertEqual(&
    message='fe_yx, yx_ef with sin(k*pi*X) Y *exp(-Y**2)',&
    answer = yx_Data,                                             &
    check = yx_fe(fe_yx(yx_Data)),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','fe_module_base_test', &
       'fe_module basic transform function tests succeeded!')

end program fe_module_base_test

!--
!----------------------------------------------------------------------
!     Copyright 2001--2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ee_module
!
!      spml/ee_module モジュールは周期境界条件の下での 2 次元矩形領域の
!      流体運動をスペクトル法により数値計算するための Fortran90 関数を
!      提供する. 
!
!      内部で ISPACK/P2PACK の Fortran77 サブルーチンを呼んでいる. 
!      スペクトルデータおよび格子点データの格納方法については
!      ISPACK/P2PACK のマニュアルを参照されたい. 
!
!履歴  2001/10/07  竹広真一
!      2001/12/25  竹広真一  関数, 変数命名法変更
!      2002/03/25  竹広真一  モジュール名変更
!      2002/08/19  竹広真一  格子データ添字を gg -> xy に変更
!      2002/08/20  竹広真一  積分・平均関数追加
!      2005/03/15  竹広真一  xy -> yx に接頭子を変更
!      2005/07/18  竹広真一  使用する ISPACK ライブラリを p2pack に変更
!      2005/10/26  竹広真一  エネルギー, エンストロフィースペクトル追加
!      2006/03/05  竹広真一  コメントを RDoc 用に修正
!      2006/03/19  竹広真一  変数・手続き群の要約をコメントに追加
!      2008/05/10  西澤誠也 => 竹広真一 解像度領域複数対応
!      2008/10/28  竹広真一  補間計算追加
!      2009/01/09  竹広真一  ee_Initial メッセージに日付を追加
!      2009/01/29  佐々木洋平 コメントを RDoc 用に修正
!      2009/07/31  竹広真一   作業領域をローカル変数に変更(for OpenMP)
!      2016/06/23  竹広真一  ee_JacobianZ_ee の符号を修正
!
!++
module ee_module
  !
  != ee_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/ee_module モジュールは周期境界条件の下での 2 次元矩形領域の
  ! 流体運動をスペクトル法により数値計算するための Fortran90 関数を
  ! 提供する. 
  !
  ! 内部で ISPACK/P2PACK の Fortran77 サブルーチンを呼んでいる. 
  ! スペクトルデータおよび格子点データの格納方法については
  ! ISPACK/P2PACK のマニュアルを参照されたい. 
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !  
  ! * 関数名の先頭 (ee_, yx_, x_, y_) は, 返す値の形を示している.
  !   ee_ :: スペクトルデータ(第 1,2 次元がそれぞれ Y,X 方向波数)
  !   yx_ :: 2 次元格子点データ(第 1,2 次元がそれぞれ Y,X 方向の格子点)
  !   x_  :: X 方向 1 次元格子点データ, y_ : Y 方向 1 次元格子点データ
  !
  ! * 関数名の間の文字列(Dx, Dy, Lapla, LaplaInv, Jacobian)は, 
  !   その関数の作用を表している.
  !
  ! * 関数名の最後 (_ee_ee, _ee, _yx, _x, _y) は, 入力変数の形が
  !   スペクトルデータおよび格子点データであることを示している.
  !   _ee    :: スペクトルデータ
  !   _ee_ee :: 2 つのスペクトルデータ
  !   _yx    :: 2 次元格子点データ
  !   _x     :: X 方向 1 次元格子点データ
  !   _y     :: Y 方向 1 次元格子点データ.
  !  
  !=== 各データの種類の説明
  !  
  ! * yx : 2 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(0:jm-1,0:im-1). 
  !   * im, jm はそれぞれ X, Y 座標の格子点数であり, サブルーチン 
  !     ee_initial にてあらかじめ設定しておく.
  !   * 第 1 次元が Y 座標の格子点位置番号, 第 2 次元が X 座標の
  !     格子点位置番号である (X, Y の順ではない)ことに注意.
  !
  ! * ee : スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(-lm:lm,-km:km). 
  !   * km, lm はそれぞれ X, Y 方向の最大波数であり, サブルーチン 
  !     ee_initial にてあらかじめ設定しておく.
  !     (X, Y 方向波数の順ではない)ことに注意. 
  !   * スペクトルデータの格納のされ方については...
  !
  ! * x, y : X, Y 方向 1 次元格子点データ.
  !   * 変数の種類と次元はそれぞれ
  !     real(8), dimension(0:im-1) および real(8), dimension(0:jm-1).
  !
  ! * ee_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * yx_ で始まる関数が返す値は 2 次元格子点データに同じ.
  !
  ! * x_, y_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! ee_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! ee_ChangeResolutionDomain :: 解像度, 領域設定の変更
  !
  !==== 座標変数
  !
  ! x_X, y_Y     ::  格子点座標(X,Y座標)を格納した 1 次元配列
  ! x_X_Weight, y_Y_Weight ::  重み座標を格納した 1 次元配列
  ! yx_X, yx_Y   :: 格子点データの XY 座標(X,Y)(格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! yx_ee :: スペクトルデータから格子データへの変換
  ! ee_yx :: 格子データからスペクトルデータへの変換
  !
  !==== 微分
  !
  ! ee_Lapla_ee       :: スペクトルデータにラプラシアンを作用させる
  ! ee_LaplaInv_ee    :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! ee_Dx_ee          :: スペクトルデータに X 微分を作用させる
  ! ee_Dy_ee          :: スペクトルデータに Y 微分を作用させる
  ! ee_Jacobian_ee_ee :: 2 つのスペクトルデータからヤコビアンを計算する
  !
  !==== 積分・平均
  !
  ! IntYX_yx, AvrYX_yx   :: 2 次元格子点データの全領域積分および平均
  ! y_IntX_yx, y_AvrX_yx :: 2 次元格子点データの X 方向積分および平均
  ! IntX_x, AvrX_x       :: 1 次元(X)格子点データの X 方向積分および平均
  ! x_IntY_yx, x_AvrY_yx :: 2 次元格子点データの Y 方向積分および平均
  ! IntY_y, AvrY_y       :: 1 次元(Y)格子点データの Y 方向積分および平均
  !
  !==== スペクトル解析
  !
  ! ee_EnergyFromStreamfunc_ee    :: 
  ! 流線関数からエネルギースペクトルを計算する
  !
  ! ee_EnstrophyFromStreamfunc_ee :: 
  ! 流線関数からエンストロフィースペクトルを計算する
  !
  !==== 補間計算
  !
  ! Interpolate_ee       :: 任意の点の値をスペクトルデータから計算する
  !
  use dc_message, only : MessageNotify
  implicit none

  private
  public ee_Initial                                       ! 初期化ルーチン
  public ee_ChangeResolutionDomain                        ! 解像度領域設定変更
  public yx_ee, ee_yx                                     ! 基本変換
  public ee_Lapla_ee, ee_LaplaInv_ee, ee_Dx_ee, ee_Dy_ee  ! 微分
  public ee_JacobianZ_ee, ee_Jacobian_ee_ee               ! 非線形計算
  public IntYX_yx, y_IntX_yx, x_IntY_yx, IntX_x, IntY_y   ! 積分
  public AvrYX_yx, y_AvrX_yx, x_AvrY_yx, AvrX_x, AvrY_y   ! 平均
  public ee_EnergyFromStreamfunc_ee                       ! エネルギー
  public ee_EnstrophyFromStreamfunc_ee                    ! エンストロフィー
  public Interpolate_ee                                   ! 補間
  public x_X, y_Y, x_X_Weight, y_Y_Weight, yx_X, yx_Y     ! 座標変数

  integer   :: im=32, jm=32                      ! 格子点の設定(X,Y)
  integer   :: km=10, lm=10                      ! 切断波数の設定(X,Y)
  real(8)   :: xl=1.0, yl=1.0                    ! 領域の大きさ

  integer, dimension(:),   pointer :: itj => null()
  real(8), dimension(:),   pointer :: tj => null()
  integer, dimension(:),   pointer :: iti => null()
  real(8), dimension(:),   pointer :: ti => null()

  real(8), dimension(:),   pointer :: x_X => null()
                                         ! 格子点座標(X)
  real(8), dimension(:),   pointer :: y_Y => null()
                                         ! 格子点座標(Y)

  real(8), dimension(:),   pointer :: x_X_Weight => null()
                                         ! 格子点重み(X)
                                         ! X 方向の格子点の間隔が格納してある.
  real(8), dimension(:),   pointer :: y_Y_Weight => null()
                                         ! 格子点重み(Y)
                                         ! Y 方向の格子点の間隔が格納してある.

  real(8), dimension(:,:), pointer :: yx_X => null()
                          ! 格子点(X)座標(2 次元)
                          ! 各格子点(i,j)の位置の X 座標を格納した格子データ
  real(8), dimension(:,:), pointer :: yx_Y => null()
                          ! 格子点(Y)座標(2 次元)
                          ! 各格子点(i,j)の位置の Y 座標を格納した格子データ


  integer, parameter :: nparams_max = 10 ! ee_Initial を呼べる最大回数
  type ee_param                          ! 解像度領域情報構造体
     integer   :: im, jm
     integer   :: km, lm
     real(8)   :: xl, yl
     integer, dimension(:),   pointer :: itj
     real(8), dimension(:),   pointer :: tj
     integer, dimension(:),   pointer :: iti
     real(8), dimension(:),   pointer :: ti
     real(8), dimension(:),   pointer :: x_X
     real(8), dimension(:),   pointer :: y_Y
     real(8), dimension(:),   pointer :: x_X_Weight
     real(8), dimension(:),   pointer :: y_Y_Weight
     real(8), dimension(:,:), pointer :: yx_X
     real(8), dimension(:,:), pointer :: yx_Y 
  end type ee_param
  type(ee_param) :: params(nparams_max)  ! 解像度領域情報
  integer :: nparams                     ! 解像度領域情報の個数

  real(8), parameter  :: pi=3.1415926535897932385D0

  save im, jm, km, lm, itj, tj, iti, ti, xl, yl
  save x_X, y_Y, x_X_Weight, y_Y_Weight, yx_X, yx_Y
  save params, nparams

  contains
  !--------------- 初期化 -----------------
    subroutine ee_Initial(i,j,k,l,xmin,xmax,ymin,ymax,id)
      !
      ! スペクトル変換の格子点数, 波数, 領域の大きさを設定する.
      !
      ! 他の関数や変数を呼ぶ前に, 最初にこのサブルーチンを呼んで
      ! 初期設定をしなければならない.
      !
      ! オプショナル引数 id を用いて異なる解像度, 領域を同時に
      ! 扱うことができる. ee_Initial を解像度, 領域ごとに呼んで
      ! 引数 id をキープし, ee_ChangeResolutionDomain で切替える. 
      !
      integer,intent(in) :: i           ! 格子点数(X)
      integer,intent(in) :: j           ! 格子点数(Y)
      integer,intent(in) :: K           ! 切断波数(X)
      integer,intent(in) :: l           ! 切断波数(Y)

      real(8),intent(in) :: xmin, xmax     ! X 座標範囲
      real(8),intent(in) :: ymin, ymax     ! Y 座標範囲

      integer, intent(out), optional :: id  ! 解像度領域情報番号

      character(len=3) cid
      integer :: ii, jj

      im = i         ; jm = j
      km = k         ; lm = l
      xl = xmax-xmin ; yl = ymax-ymin

      if ( nparams .ge. nparams_max ) then
         call MessageNotify('W','ee_initial',&
              'too many call of ee_Initial, nothing was done.')
         if ( present(id) ) id = -1
         return
      end if

      nparams = nparams + 1

      params(nparams)%im = im
      params(nparams)%jm = jm
      params(nparams)%km = km
      params(nparams)%lm = lm
      params(nparams)%xl = xl
      params(nparams)%yl = yl

      allocate(params(nparams)%itj(5))
      allocate(params(nparams)%iti(5))
      allocate(params(nparams)%tj(jm*2))
      allocate(params(nparams)%ti(im*2))

      allocate(params(nparams)%x_X(0:im-1))
      allocate(params(nparams)%x_X_Weight(0:im-1))
      allocate(params(nparams)%y_Y(0:jm-1))
      allocate(params(nparams)%y_Y_Weight(0:jm-1))
      allocate(params(nparams)%yx_X(0:jm-1,0:im-1))
      allocate(params(nparams)%yx_Y(0:jm-1,0:im-1))

      call ee_ChangeResolutionDomain(nparams)

      call p2init(jm,im,itj,tj,iti,ti)

      do ii=0,im-1
         x_X(ii) = xmin + xl/im*ii
      enddo
      x_X_Weight = xl/im

      do jj=0,jm-1
         y_Y(jj) = ymin + yl/jm*jj
      enddo
      y_Y_Weight = yl/jm

      yx_X = spread(x_X,1,jm)
      yx_Y = spread(y_Y,2,im)

      if ( present(id) ) id = nparams

      write(cid,'(I3)') nparams
      call MessageNotify('M','ee_initial','ee_module (2016/06/23) is initialized')
      call MessageNotify('M','ee_initial',&
           'ResolutionDomain ID is '//trim(adjustl(cid)))
    end subroutine ee_initial

  !--------------- id 変更 -----------------
    subroutine ee_ChangeResolutionDomain(id)
      !
      ! 解像度, 領域設定の変更. ee_Initial で設定する際に
      ! かえってくるオプショナル引数 id の値を用いる. 
      ! 
      integer, intent(in) :: id

      if (id .gt. nparams .or. id .lt. 1) then
         write(*,*)"id is invalid"
      end if

      im = params(id)%im
      jm = params(id)%jm
      km = params(id)%km
      lm = params(id)%lm
      xl = params(id)%xl
      yl = params(id)%yl
      itj => params(id)%itj
      tj => params(id)%tj
      iti => params(id)%iti
      ti => params(id)%ti
      x_X => params(id)%x_X
      y_Y => params(id)%y_Y
      x_X_Weight => params(id)%x_X_Weight
      y_Y_Weight => params(id)%y_Y_Weight
      yx_X => params(id)%yx_X
      yx_Y => params(id)%yx_Y

    end subroutine ee_ChangeResolutionDomain

  !--------------- 基本変換 -----------------
    function yx_ee(ee)
      !
      ! スペクトルデータから格子データへ変換する.
      !
      real(8), dimension(0:jm-1,0:im-1)             :: yx_ee 
      !(out) 格子点データ

      real(8), dimension(-lm:lm,-km:km), intent(in) :: ee
      !(in)  スペクトルデータ

      real(8), dimension(jm*im)                     :: w
      ! 作業用配列

      call p2s2ga(lm,km,jm,im,ee,yx_ee,w,itj,tj,iti,ti)
    end function yx_ee

    function ee_yx(yx)
      !
      ! 格子データからスペクトルデータへ変換する.
      !
      real(8), dimension(-lm:lm,-km:km)              :: ee_yx
      !(out)  スペクトルデータ

      real(8), dimension(0:jm-1,0:im-1), intent(in)  :: yx
      !(in) 格子点データ

      real(8), dimension(jm*im)                     :: w
      real(8), dimension(0:jm-1,0:im-1)             :: yx_tmp
      ! 作業用配列

      yx_tmp = yx
      call p2g2sa(lm,km,jm,im,yx_tmp,ee_yx,w,itj,tj,iti,ti)

    end function ee_yx

  !--------------- 微分計算 -----------------
    function ee_Lapla_ee(ee)
      !
      ! 入力スペクトルデータにラプラシアン(∂xx+∂yy)を作用する.
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに全波数 (k**2 + l**2) をかける
      ! 計算を行っている. 
      !
      real(8), dimension(-lm:lm,-km:km)              :: ee_Lapla_ee
      !(out) スペクトルデータのラプラシアン

      real(8), dimension(-lm:lm,-km:km), intent(in)  :: ee
      !(in) 入力スペクトルデータ

      integer k,l
      ! 作業変数

      do k=-km,km
         do l=-lm,lm
            ee_Lapla_ee(l,k) = -((2*pi*k/xl)**2+(2*pi*l/yl)**2)*ee(l,k)
         enddo
      enddo
    end function ee_Lapla_ee

    function ee_LaplaInv_ee(ee)
      !
      ! 入力スペクトルデータに逆ラプラシアン(∂xx+∂yy)**(-1)を作用する.
      !
      ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
      ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに全波数 (k**2 + l**2) で割る
      ! 計算を行っている. k=l=0 成分には 0 を代入している. 
      !
      real(8), dimension(-lm:lm,-km:km)             :: ee_LaplaInv_ee
      !(out) スペクトルデータの逆ラプラシアン

      real(8), dimension(-lm:lm,-km:km), intent(in) :: ee
      !(in) スペクトルデータ

      integer k,l

      do k=-km,km
         do l=-lm,lm
            if ( k.ne.0 .or. l.ne.0 ) then
               ee_LaplaInv_ee(l,k) = -ee(l,k)/((2*pi*k/xl)**2+(2*pi*l/yl)**2)
            else
               ee_LaplaInv_ee(l,k) = 0.0
            endif
         enddo
      enddo
    end function ee_LaplaInv_ee

    function ee_Dx_ee(ee)
      !
      ! 入力スペクトルデータに X 微分(∂x)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 k をかけて
      ! sin(kx) <-> cos(kx) 成分に入れ換える計算を行っている.
      !
      real(8), dimension(-lm:lm,-km:km)              :: ee_Dx_ee
      !(out) スペクトルデータの X 微分

      real(8), dimension(-lm:lm,-km:km), intent(in)  :: ee
      !(in) 入力スペクトルデータ

      integer k,l
      ! 作業変数

      do k=-km,km
         do l=-lm,lm
            ee_Dx_ee(l,k) = -(2*pi*k/xl)*ee(-l,-k)
         enddo
      enddo
    end function ee_Dx_ee

    function ee_Dy_ee(ee)
      !
      ! 入力スペクトルデータに Y 微分(∂y)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに Y 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 l をかけて
      ! sin(ky) <-> cos(ky) 成分に入れ換える計算を行っている.
      !
      real(8), dimension(-lm:lm,-km:km)              :: ee_Dy_ee
      !(out) スペクトルデータの Y 微分

      real(8), dimension(-lm:lm,-km:km), intent(in)  :: ee
      !(in) 入力スペクトルデータ

      integer k,l
      ! 作業変数

      do k=-km,km
         do l=-lm,lm
            ee_Dy_ee(l,k) = -(2*pi*l/yl)*ee(-l,-k)
         enddo
      enddo

    end function ee_Dy_ee

    function ee_Jacobian_ee_ee(ee_a,ee_b)
      !
      !  2 つのスペクトルデータからヤコビアン
      !
      !     J(A,B)=(∂xA)(∂yB)-(∂yA)(∂xB)
      !
      !  を計算する.
      !
      !  2 つのスペクトルデータのヤコビアンとは, 対応する 2 つの
      !  格子点データのヤコビアンのスペクトル変換のことである.
      !
      real(8), dimension(-lm:lm,-km:km)              :: ee_Jacobian_ee_ee
      !(out) 2 つのスペクトルデータのヤコビアン

      real(8), dimension(-lm:lm,-km:km), intent(in)  :: ee_a
      !(in) 1つ目の入力スペクトルデータ

      real(8), dimension(-lm:lm,-km:km), intent(in)  :: ee_b
      !(in) 2つ目の入力スペクトルデータ

      real(8), dimension((2*km+1)*(2*lm+1))          :: ws
      real(8), dimension(jm*im*3)                    :: wg
      ! 作業領域

      call p2ajcb(lm,km,jm,im,ee_a,ee_b,ee_Jacobian_ee_ee,ws,wg,itj,tj,iti,ti)

      ee_Jacobian_ee_ee  = (2*pi/xl)*(2*pi/yl) * ee_Jacobian_ee_ee

    end function ee_Jacobian_ee_ee

    function ee_JacobianZ_ee(ee_zeta)
      !
      ! 渦度スペクトルデータ ζ から流線関数と渦度のヤコビアン
      !
      !     J(ψ,ζ)=(∂xψ)(∂yζ)-(∂yψ)(∂xζ)
      !
      !  を計算する. ただしψ は (∂xx+∂yy)ψ=ζ を満たす流線関数である.
      !
      real(8), dimension(-lm:lm,-km:km)              :: ee_JacobianZ_ee
      !(out) 流線関数と渦度のヤコビアン

      real(8), dimension(-lm:lm,-km:km), intent(in)  :: ee_Zeta
      !(in) 渦度スペクトルデータ

      real(8), dimension((2*km+1)*(2*lm+1))          :: ws
      real(8), dimension(jm*im*3)                    :: wg
      ! 作業領域

      call p2ajbs(lm,km,jm,im,yl/xl,ee_Zeta,ee_JacobianZ_ee,ws,wg,itj,tj,iti,ti)

      ee_JacobianZ_ee = - (2*pi/xl)*(2*pi/yl)/(2*pi/yl)**2 * ee_JacobianZ_ee

    end function ee_JacobianZ_ee

  !--------------- 積分計算 -----------------
    function IntYX_yx(yx)
      !
      ! 2 次元格子点データの全領域積分および平均.
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:jm-1,0:im-1)   :: yx          
      !(in)  2 次元格子点データ

      real(8)                             :: IntYX_yx
      !(out) 積分値

      integer :: i, j
      ! 作業変数

      IntYX_yx = 0.0d0
      do i=0,im-1
         do j=0,jm-1
            IntYX_yx = IntYX_yx + yx(j,i) * y_Y_Weight(j) * x_X_Weight(i)
         enddo
      enddo
    end function IntYX_yx

    function y_IntX_yx(yx)
      !
      ! 2 次元格子点データの X 方向積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:jm-1,0:im-1)   :: yx
      !(in) 2 次元格子点データ

      real(8), dimension(0:jm-1)          :: y_IntX_yx
      !(out) 積分された 1 次元(Y)格子点データ

      integer :: i
      ! 作業変数

      y_IntX_yx = 0.0d0
      do i=0,im-1
         y_IntX_yx(:) = y_IntX_yx(:) + yx(:,i) * x_X_Weight(i)
      enddo
    end function y_IntX_yx

    function x_IntY_yx(yx)
      !
      ! 2 次元格子点データの Y 方向積分
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:jm-1,0:im-1)   :: yx      
      !(in)  2 次元格子点データ

      real(8), dimension(0:im-1)        :: x_IntY_yx 
      !(out) 積分された 1 次元(X)格子点データ

      integer :: j
      ! 作業変数

      x_IntY_yx = 0.0d0
      do j=0,jm-1
         x_IntY_yx(:) = x_IntY_yx(:) + yx(j,:) * y_Y_Weight(j)
      enddo
    end function x_IntY_yx

    function IntX_x(x)
      !
      ! 1 次元(X)格子点データの X 方向積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:im-1)   :: x          !(in)  1 次元格子点データ
      real(8)                      :: IntX_x     !(out) 積分値

      IntX_x = sum(x*x_X_Weight)
    end function IntX_x

    function IntY_y(y)      ! Y 方向積分
      !
      ! 1 次元(Y)格子点データの Y 方向積分
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:jm-1)   :: y          !(in)  1 次元格子点データ
      real(8)                      :: IntY_y     !(out) 積分値

      IntY_y = sum(y*y_Y_Weight)
    end function IntY_y

  !--------------- 平均計算 -----------------
    function AvrYX_yx(yx)
      !
      ! 2 次元格子点データの全領域平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:jm-1,0:im-1)   :: yx
      !(in)  2 次元格子点データ

      real(8)                             :: AvrYX_yx    
      !(out) 平均値

      AvrYX_yx = IntYX_yx(yx)/(sum(x_X_weight)*sum(y_Y_weight))
    end function AvrYX_yx

    function y_AvrX_yx(yx)
      !
      ! 2 次元格子点データの X 方向平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:jm-1,0:im-1)   :: yx
      !(in) 2 次元格子点データ

      real(8), dimension(0:jm-1)          :: y_AvrX_yx
      !(out) 平均された 1 次元(Y)格子点データ

      y_AvrX_yx = y_IntX_yx(yx)/sum(x_X_weight)
    end function y_AvrX_yx

    function x_AvrY_yx(yx)
      !
      ! 2 次元格子点データの Y 方向平均
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:jm-1,0:im-1)   :: yx
      !(in) 2 次元格子点データ

      real(8), dimension(0:im-1)          :: x_AvrY_yx
      !(out) 平均された 1 次元(X)格子点データ

      x_AvrY_yx = x_IntY_yx(yx)/sum(y_Y_weight)
    end function x_AvrY_yx

    function AvrX_x(x)
      !
      ! 1 次元(X)格子点データの X 方向平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:im-1)   :: x          !(in)  1 次元格子点データ
      real(8)                      :: AvrX_x     !(out) 平均値

      AvrX_x = IntX_x(x)/sum(x_X_weight)
    end function AvrX_x

    function AvrY_y(y)
      !
      ! 1 次元(Y)格子点データの Y 方向平均
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:jm-1) :: y          !(in)  1 次元格子点データ
      real(8)                    :: AvrY_y     !(out) 平均値

      AvrY_y = IntY_y(y)/sum(y_Y_weight)
    end function AvrY_y

  !--------------- スペクトル計算 -----------------
    function ee_EnergyFromStreamfunc_ee(ee_StrFunc)
      !
      ! 流線関数からエネルギースペクトルを計算する. 
      !
      !   E_kl = (1/2)(k^2+l^2)|\psi_kl|^2
      !
      ! * E_kl の総和が場の平均運動エネルギーとなる. 
      ! * それに領域の面積をかけると全運動エネルギーとなる. 
      !
      real(8), dimension(-lm:lm,-km:km)    :: ee_EnergyFromStreamfunc_ee
      ! エネルギースペクトル

      real(8), dimension(-lm:lm,-km:km), intent(in) :: ee_StrFunc
      ! 流線関数

      integer k,l
      ! 作業変数

      do k=-km,km
         do l=-lm,lm
            ee_EnergyFromStreamfunc_ee(l,k) &
                 = 0.5 * ( (2*pi*k/xl)**2 + (2*pi*l/yl)**2 ) & 
                          * (ee_StrFunc(l,k)**2 + ee_StrFunc(-l,-k)**2)
         enddo
      enddo

    end function ee_EnergyFromStreamfunc_ee

    function ee_EnstrophyFromStreamfunc_ee(ee_StrFunc)
      !
      ! 流線関数からエンストロフィースペクトルを計算する. 
      !
      !   Q_kl = (1/2)(k^2+l^2)^2|\psi_kl|^2
      !
      ! * Q_kl の総和が場の平均エンストロフィーとなる. 
      ! * それに領域の面積をかけると全エンストロフィーとなる. 
      !

      real(8), dimension(-lm:lm,-km:km)    :: ee_EnstrophyFromStreamfunc_ee
      ! エンストロフィーースペクトル

      real(8), dimension(-lm:lm,-km:km), intent(in) :: ee_StrFunc
      ! 流線関数

      integer k,l
      ! 作業変数

      do k=-km,km
         do l=-lm,lm
            ee_EnstrophyFromStreamfunc_ee(l,k) &
                 = 0.5 * ( (2*pi*k/xl)**2 + (2*pi*l/yl)**2 )**2 & 
                          * (ee_StrFunc(l,k)**2 + ee_StrFunc(-l,-k)**2)
         enddo
      enddo

    end function ee_EnstrophyFromStreamfunc_ee

  !--------------- 補間計算 -----------------
    function Interpolate_ee( ee_Data, x, y )
      real(8), intent(IN)  :: ee_data(-lm:lm,-km:km)  ! スペクトルデータ
      real(8), intent(IN)  :: x                       ! 補間する点の x 座標 
      real(8), intent(IN)  :: y                       ! 補間する点の y 座標 
      real(8)              :: Interpolate_ee          ! 補間した値

      integer :: k, l
      real(8) :: xx, yy

      xx =(2*PI/xl)*(x - x_X(0))
      yy =(2*PI/yl)*(y - y_Y(0))

      Interpolate_ee = ee_Data(0,0)

      ! l=0
      do k=1,km
         Interpolate_ee = Interpolate_ee &
              + 2*( ee_Data(0,k)*cos(k*xx) - ee_Data(0,-k)*sin(k*xx) )
      end do

      ! k=0
      do l=1,lm
         Interpolate_ee = Interpolate_ee &
              + 2*( ee_Data(l,0)*cos(l*yy) - ee_Data(-l,0)*sin(l*yy) )
      end do

      ! k*l > 0
      do l=1,lm
         do k=1,km
            Interpolate_ee = Interpolate_ee &
              + 2*(  ee_Data(l,k)*(   cos(k*xx)*cos(l*yy)   &
                                    - sin(k*xx)*sin(l*yy) ) &
                    -ee_Data(-l,-k)*(   sin(k*xx)*cos(l*yy)   &
                                      + cos(k*xx)*sin(l*yy) ) )
         end do
      end do

      ! k*l < 0
      do l=1,lm
         do k=1,km
            Interpolate_ee = Interpolate_ee &
              + 2*(  ee_Data(-l,k)*(   cos(k*xx)*cos(l*yy)   &
                                     + sin(k*xx)*sin(l*yy) ) &
                    -ee_Data(l,-k)*(   sin(k*xx)*cos(l*yy)   &
                                     - cos(k*xx)*sin(l*yy) ) )
         end do
      end do

    end function Interpolate_ee

end module ee_module

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_module テストプログラム (境界値問題, トロイダル磁場, Tau 法)
!
!履歴  2009/12/19  竹広真一
!
program tee_module_tormagbctau_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=10       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: zyx_Tormag(0:km,0:jm-1,0:im-1)      ! 格子データ

  real(8)            :: yx_BoundaryTop(0:jm-1,0:im-1)     ! 格子データ
  real(8)            :: yx_BoundaryBtm(0:jm-1,0:im-1)     ! 格子データ

  real(8)            :: tee_Tormag(0:nm,-mm:mm,-lm:lm)      ! スペクトルデータ
  real(8)            :: tee_Tormag_orig(0:nm,-mm:mm,-lm:lm) ! スペクトルデータ

  integer            :: l=2, m=5

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','tee_module_TormagbcTau_test', &
       'tee_module toroidal mag. field B.C. subruoutine tests')

 !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call tee_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

 !-------------------BC-DD(Tau) ----------------------
  zyx_Tormag = sin(l*pi*zyx_X) * sin(m*pi*zyx_Y) * zyx_Z
  yx_BoundaryTop = 0.0D0
  yx_BoundaryBtm = 0.0D0

  tee_Tormag = tee_zyx(zyx_Tormag)
  tee_Tormag_orig = tee_Tormag

  call tee_TormagBoundariesTau(tee_Tormag)
  zyx_Tormag = zyx_tee(tee_Tormag)

  call AssertEqual(&
    message='tee_TormagBoundariesTau [internal]',&
    answer = tee_Tormag_orig(0:nm-2,:,:),                         &
    check = tee_Tormag(0:nm-2,:,:),                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tee_TormagBoundariesTau [Top]',&
    answer = zyx_Tormag(0,:,:),                                   &
    check = yx_BoundaryTop,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tee_TormagBoundariesTau [Bottom]', &
    answer = zyx_Tormag(km,:,:),                                  &
    check = yx_BoundaryBtm,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','tee_module_TormagbcTau_test', &
       'tee_module toroidal mag. field B.C. subruoutine tests succeeded!')

end program tee_module_tormagbctau_test

!----------------------------------------------------------------------
!     Copyright (c) 2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_ad_galerkin_DD_test1d
!
!      チェビシェフ−ガラーキン法
!      両端ディリクレ境界条件用モジュールテストプログラム(1次元)
!          f(x=xmin)=f(x=xmax)=0
!
!      例 : f(x) = (x-xmin)*(xmax-x)
!
!履歴  2005/12/29  竹広真一  新規作成
!      2006/01/23  竹広真一  モジュール名変更に伴う改訂
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!
program at_ad_galerkin_DD_test1d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_ad_galerkin_DD
  use at_module

  implicit none

  integer, parameter :: im=8, km=4
  real(8), parameter :: xmin=0.0D0, xmax=1.0D0

  real(8) :: g_data(0:im)
  real(8) :: g_data_orig(0:im)
  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','at_ad_galerkin_DD_test1d', &
       & '1D both Dirichlet B.C.')

  call at_Initial(im,km,xmin,xmax)
  call at_ad_galerkin_DD_Initial(im,km)

  g_data = (g_X-xmin)*(xmax-g_X)
  g_data_orig = g_data
  g_data=g_t(t_d(d_t(t_g(g_data))))
  call check1d(g_data, g_data_orig, &
    &' test of Grid -> Galerkin -> Grid ')

  call MessageNotify('M','at_ad_galerkin_DD_test1d', &
       & '1D both Dirichlet B.C. succeeded')

contains
  subroutine check1d(var, true, funcname)
    real(8) :: var(:)
    real(8) :: true(:)
    character(len=*), optional :: funcname

    call AssertEqual(&
      & message = funcname,   &
      & answer  = true,       &
      & check   = var,        &
      significant_digits = check_digits, ignore_digits = ignore   &
      )
  end subroutine check1d

end program at_ad_galerkin_DD_test1d

!----------------------------------------------------------------------
!     Copyright (c) 2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  l_module テストプログラム :: 基本変換関数のテスト
!
!履歴  2013/02/24  竹広真一
!
program l_module_base_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use l_module
  implicit none

  integer :: jm(2)=(/16,32/)
  integer :: nm(2)=(/10,21/)

  real(8), allocatable :: l_data(:)
  real(8), allocatable :: y_data(:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  integer :: n

  call MessageNotify('M','l_module_base_test', &
                         'l_module basic functions tests') 

  do n=1,2

  call l_Initial( nm(n), jm(n) )

  allocate(l_data(0:nm(n)))
  allocate(y_data(1:jm(n)))

  !---- P_1 のテスト ----
  y_data = sqrt(3.0D0)*sin(y_Lat)
  l_data= 0.0D0 ; l_data(1)=1.0D0

  call AssertEqual(&
    message='P_1 Test of l_y(y_data)',                            &
    answer = l_data,                                              &
    check = l_y(y_data),                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='P_1 Test of y_l(l_y(y_data))',                       &
    answer = y_data,                                              &
    check = y_l(l_y(y_data)),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- P_2 のテスト ----
  y_data = sqrt(5.0D0)*(3.0/2*sin(y_Lat)**2-1/2.0)                 ! P_2
  l_data= 0.0D0 ; l_data(2)=1.0D0

  call AssertEqual(&
    message='P_2 Test of l_y(y_data)',                            &
    answer = l_data,                                              &
    check = l_y(y_data),                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='P_2 Test of y_l(l_y(y_data))',                       &
    answer = y_data,                                              &
    check = y_l(l_y(y_data)),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的関数のテスト ----
  y_data = (sin(y_Lat)-1)**2*(sin(y_Lat)-0.5)*(sin(y_Lat)+1)

  call AssertEqual(&
    message='General func test of y_l(l_y(y_data))',              &
    answer = y_data,                                              &
    check = y_l(l_y(y_data)),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  deallocate(l_data)
  deallocate(y_data)

  call l_Finalize

  enddo

  call MessageNotify('M','l_module_base_test', &
                         'l_module basic functions tests succeeded!') 

end program l_module_base_test

!----------------------------------------------------------------------
!     Copyright (c) 2009--2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_module テストプログラム (境界値問題, ポロイダル磁場, 選点法)
!
!履歴  2009/12/19  竹広真一
!      2016/09/20  竹広真一  Polmagbc ルーチンバグ fix
!
program tee_module_polmagbcgrid_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=64, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=21, nm=16       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: zyx_Polmag(0:km,0:jm-1,0:im-1)      ! 格子データ
  real(8)            :: zyx_Polmag_orig(0:km,0:jm-1,0:im-1) ! 格子データ

  real(8)            :: tee_Polmag(0:nm,-mm:mm,-lm:lm)      ! スペクトルデータ

  real(8)            :: tee_Kh(0:nm,-mm:mm,-lm:lm)          ! 水平全波数

  real(8)            :: zee_Boundary(0:km,-mm:mm,-lm:lm)    ! 境界条件
  real(8)            :: ee_Null(-mm:mm,-lm:lm)=0.0D0        ! 0 

  real(8)            :: rl, rm
  integer            :: l=2, m=5
  integer            :: l1, m1

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','tee_module_PolmagbcGrid_test', &
       'tee_module poloidal mag. field B.C. subruoutine tests')

 !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call tee_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

  do m1=-mm,mm
     do l1=-lm,lm
        rl = 2*PI/(xmax-xmin)*l1 ; rm = 2*PI/(ymax-ymin)*m1
        tee_Kh(:,m1,l1) = sqrt(rl**2+rm**2)
     enddo
  enddo

 !-------------------BC-DD(Grid) ----------------------
  zyx_Polmag = sin(l*pi*zyx_X) * sin(m*pi*zyx_Y) * zyx_Z
  zyx_Polmag_orig = zyx_Polmag

  tee_Polmag = tee_zyx(zyx_Polmag)

  call tee_PolmagBoundariesGrid(tee_Polmag)
  zyx_Polmag = zyx_tee(tee_Polmag)

  call AssertEqual(&
    message='tee_PolmagBoundariesGrid [internal]',&
    answer = zyx_Polmag_orig(1:km-1,:,:),                         &
    check = zyx_Polmag(1:km-1,:,:),                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zee_Boundary = zee_tee(tee_Dz_tee(tee_Polmag) + tee_Kh * tee_Polmag)
  call AssertEqual(&
    message='tee_PolmagBoundariesGrid [Top]',&
    answer = ee_Null,                                             &
    check = zee_Boundary(0,:,:),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zee_Boundary = zee_tee(tee_Dz_tee(tee_Polmag) - tee_Kh * tee_Polmag)
  call AssertEqual(&
    message='tee_PolmagBoundariesGrid [Bottom]',&
    answer = ee_Null,                                             &
    check = zee_Boundary(km,:,:),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','tee_module_PolmagbcGrid_test', &
       'tee_module poloidal mag. field B.C. subruoutine tests succeeded!')

end program tee_module_polmagbcgrid_test

!----------------------------------------------------------------------
!     Copyright (c) 2012 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_zonal_module テストプログラム
!
!      ポロイダルポテンシャルの境界値問題
!
!履歴  2012/07/08  竹広真一   et_test_Vor2StrmCheb.f90 より 
!                             wt_module 用に改造
!      2012/08/26  竹広真一   wt_module_polvelbc_tau_test.f90 より改造
!
program wt_zonal_module_polvelbc_tau

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wt_zonal_module

  implicit none

  integer,parameter  :: im=1, jm=16, km=32  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=21        ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5      ! 内外半径

  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Poloidal
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_LaplaPol
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Poloidal_sol
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_LaplaPol_sol
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_dPoloidaldz
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_d2Poloidaldz2
  real(8), dimension(0:im-1,1:jm)          :: xy_Zero=0.0D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  real(8), parameter  :: pi=3.1415926535897932385D0

  call MessageNotify('M','wt_zonal_module_polvelbc_tau_test', &
       'wt_zonal_module wt_LaplaPol2polTau_wt function tests')

  call wt_initial(im,jm,km,nm,lm,ri,ro)

  !----- wt_LaplaPol2PolTau (FF) ------

  ! P_10
  xyz_Poloidal_sol = sin(xyz_Lat) * sin( pi*(xyz_Rad-ri)/(ro-ri) )
  xyz_LaplaPol_sol = xyz_wt(wt_Lapla_wt(wt_xyz(xyz_Poloidal_sol)))
  !xyz_LaplaPol_sol = sin(xyz_Lat) * sin( pi*(xyz_Rad-ri)/(ro-ri) )
  ! P_1_1
  !xyz_LaplaPol_sol = cos(xyz_Lat)*cos(xyz_Lon)* sin( pi*(xyz_Rad-ri)/(ro-ri) )
  !xyz_LaplaPol_sol = 2*sin(xyz_Lat)**2 * sin( pi*(xyz_Rad-ri)/(ro-ri) )
  
  xyz_Poloidal = xyz_wt(wt_LaplaPol2PolTau_wt(wt_xyz(xyz_LaplaPol_sol),&
                                                  cond='FF',new=.true.))

  xyz_LaplaPol = xyz_wt(wt_Lapla_wt(wt_xyz(xyz_Poloidal)))
  xyz_dPoloidaldz   = xyz_wt(wt_DRad_wt(wt_xyz(xyz_Poloidal)))
  xyz_d2Poloidaldz2 = xyz_wt(wt_DRad_wt(wt_DRad_wt(wt_xyz(xyz_Poloidal))))

  call AssertEqual(&
    message='wt_LaplaPol2PolTau_wt (FF)',                         &
    answer =xyz_Poloidal_sol,                                     &
    check = xyz_Poloidal,                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_LaplaPol2PolTau_wt (FF, LaplaPol)',               &
    answer =xyz_LaplaPol_sol,                                     &
    check = xyz_LaplaPol,                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_LaplaPol2PolTau_wt (FF, Top)',                    &
    answer =xy_Zero,                                              &
    check = xyz_d2Poloidaldz2(:,:,0),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_LaplaPol2PolTau_wt (FF, Bottom)',                 &
    answer =xy_Zero,                                              &
    check = xyz_d2Poloidaldz2(:,:,km),                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !----- wt_LaplaPol2PolTau (RF) ------

  ! P_10
  xyz_Poloidal_sol = sin(xyz_Lat) * (xyz_Rad-ri)**3*(xyz_Rad-ro)**2
  xyz_LaplaPol_sol = xyz_wt(wt_Lapla_wt(wt_xyz(xyz_Poloidal_sol)))
  !xyz_LaplaPol_sol = sin(xyz_Lat) * sin( pi*(xyz_Rad-ri)/(ro-ri) )
  ! P_1_1
  !xyz_LaplaPol_sol = cos(xyz_Lat)*cos(xyz_Lon)* sin( pi*(xyz_Rad-ri)/(ro-ri) )
  !xyz_LaplaPol_sol = 2*sin(xyz_Lat)**2 * sin( pi*(xyz_Rad-ri)/(ro-ri) )
  
  xyz_Poloidal = xyz_wt(wt_LaplaPol2PolTau_wt(wt_xyz(xyz_LaplaPol_sol),&
                                                  cond='RF',new=.true.))

  xyz_LaplaPol = xyz_wt(wt_Lapla_wt(wt_xyz(xyz_Poloidal)))
  xyz_dPoloidaldz   = xyz_wt(wt_DRad_wt(wt_xyz(xyz_Poloidal)))
  xyz_d2Poloidaldz2 = xyz_wt(wt_DRad_wt(wt_DRad_wt(wt_xyz(xyz_Poloidal))))

  call AssertEqual(&
    message='wt_LaplaPol2PolTau_wt (RF)',                         &
    answer =xyz_Poloidal_sol,                                     &
    check = xyz_Poloidal,                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_LaplaPol2PolTau_wt (RF, LaplaPol)',               &
    answer =xyz_LaplaPol_sol,                                     &
    check = xyz_LaplaPol,                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_LaplaPol2PolTau_wt (RF, Top)',                    &
    answer =xy_Zero,                                              &
    check = xyz_dPoloidaldz(:,:,0),                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_LaplaPol2PolTau_wt (RF, Bottom)',                 &
    answer =xy_Zero,                                              &
    check = xyz_d2Poloidaldz2(:,:,km),                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !----- wt_LaplaPol2PolTau (FR) ------

  ! P_10
  xyz_Poloidal_sol = sin(xyz_Lat) * (xyz_Rad-ri)**2*(xyz_Rad-ro)**3
  xyz_LaplaPol_sol = xyz_wt(wt_Lapla_wt(wt_xyz(xyz_Poloidal_sol)))
  !xyz_LaplaPol_sol = sin(xyz_Lat) * sin( pi*(xyz_Rad-ri)/(ro-ri) )
  ! P_1_1
  !xyz_LaplaPol_sol = cos(xyz_Lat)*cos(xyz_Lon)* sin( pi*(xyz_Rad-ri)/(ro-ri) )
  !xyz_LaplaPol_sol = 2*sin(xyz_Lat)**2 * sin( pi*(xyz_Rad-ri)/(ro-ri) )
  
  xyz_Poloidal = xyz_wt(wt_LaplaPol2PolTau_wt(wt_xyz(xyz_LaplaPol_sol),&
                                                  cond='FR',new=.true.))

  xyz_LaplaPol = xyz_wt(wt_Lapla_wt(wt_xyz(xyz_Poloidal)))
  xyz_dPoloidaldz   = xyz_wt(wt_DRad_wt(wt_xyz(xyz_Poloidal)))
  xyz_d2Poloidaldz2 = xyz_wt(wt_DRad_wt(wt_DRad_wt(wt_xyz(xyz_Poloidal))))

  call AssertEqual(&
    message='wt_LaplaPol2PolTau_wt (FR)',                         &
    answer =xyz_Poloidal_sol,                                     &
    check = xyz_Poloidal,                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_LaplaPol2PolTau_wt (FR, LaplaPol)',               &
    answer =xyz_LaplaPol_sol,                                     &
    check = xyz_LaplaPol,                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_LaplaPol2PolTau_wt (FR, Top)',                    &
    answer =xy_Zero,                                              &
    check = xyz_d2Poloidaldz2(:,:,0),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_LaplaPol2PolTau_wt (FR, Bottom)',                 &
    answer =xy_Zero,                                              &
    check = xyz_dPoloidaldz(:,:,km),                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !----- wt_LaplaPol2PolTau (RR) ------

  ! P_10
  xyz_Poloidal_sol = sin(xyz_Lat) * (xyz_Rad-ri)**2*(xyz_Rad-ro)**2
  xyz_LaplaPol_sol = xyz_wt(wt_Lapla_wt(wt_xyz(xyz_Poloidal_sol)))
  !xyz_LaplaPol_sol = sin(xyz_Lat) * sin( pi*(xyz_Rad-ri)/(ro-ri) )
  ! P_1_1
  !xyz_LaplaPol_sol = cos(xyz_Lat)*cos(xyz_Lon)* sin( pi*(xyz_Rad-ri)/(ro-ri) )
  !xyz_LaplaPol_sol = 2*sin(xyz_Lat)**2 * sin( pi*(xyz_Rad-ri)/(ro-ri) )
  
  xyz_Poloidal = xyz_wt(wt_LaplaPol2PolTau_wt(wt_xyz(xyz_LaplaPol_sol),&
                                                  cond='RR',new=.true.))

  xyz_LaplaPol = xyz_wt(wt_Lapla_wt(wt_xyz(xyz_Poloidal)))
  xyz_dPoloidaldz   = xyz_wt(wt_DRad_wt(wt_xyz(xyz_Poloidal)))
  xyz_d2Poloidaldz2 = xyz_wt(wt_DRad_wt(wt_DRad_wt(wt_xyz(xyz_Poloidal))))

  call AssertEqual(&
    message='wt_LaplaPol2PolTau_wt (RR)',                         &
    answer =xyz_Poloidal_sol,                                     &
    check = xyz_Poloidal,                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_LaplaPol2PolTau_wt (RR, LaplaPol)',               &
    answer =xyz_LaplaPol_sol,                                     &
    check = xyz_LaplaPol,                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_LaplaPol2PolTau_wt (RR, Top)',                    &
    answer =xy_Zero,                                              &
    check = xyz_dPoloidaldz(:,:,0),                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_LaplaPol2PolTau_wt (RR, Bottom)',                 &
    answer =xy_Zero,                                              &
    check = xyz_dPoloidaldz(:,:,km),                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wt_zonal_module_polvelbc_tau_test', &
       'wt_zonal_module wt_LaplaPol2polTau_wt function tests suceeded!')

end program wt_zonal_module_polvelbc_tau

!----------------------------------------------------------------------
!   COPYRIGHT (c) 2005-2006 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_af_galerkin_MM2
!
!      チェビシェフ−ガラーキン法
!      ディリクレ・ノイマン混合境界条件用モジュール
!          cfdx1_xmax f'(:,i=0)  + cfdx0_xmax f(:,i=0)  = 0,
!          cfdx1_xmin f'(:,i=im) + cfdx0_xmin f(:,i=im) = 0,
!
!      k 次のガラーキン基底が
!
!        \phi_k(x)=T_k(x) + C_1 T_1(x) + C_0 T_0(x) 
!
!      の型式(Type2)
!
!履歴  2006/01/03  竹広真一  新規作成
!      2006/01/07  竹広真一  debug
!      2006/01/22  竹広真一  係数変換定式化変更
!      2006/01/23  竹広真一  モジュール名変更
!      2006/01/25  竹広真一  モジュール初期化フラッグ導入
!      2006/02/15  竹広真一  係数行列式 0 の場合に対応
!      2006/02/26  竹広真一  係数行列式が 0 の場合に完全対応
!
module at_af_galerkin_MM

  use lumatrix
  use at_module
  use dc_message

  implicit none

  private
  public :: at_af_galerkin_MM_Initial  ! 初期化サブルーチン
  public :: af_at, f_t                 ! チェビシェフ->ガラーキン変換
  public :: af_ag, f_g                 ! 格子点->ガラーキンデータ変換
  public :: at_af, t_f                 ! ガラーキン->チェビシェフ変換
  public :: ag_af, g_f                 ! ガラーキン->格子点データ変換
  public :: af_Dx_af, f_Dx_f           ! X 微分

  real(8), allocatable :: TF(:,:)      ! ガラーキン->チェビシェフ変換行列
  real(8), allocatable :: FT(:,:)      ! チェビシェフ->ガラーキン変換行列
  integer, allocatable :: kp(:)        ! LU 分解用ピボット格納配列

  real(8), allocatable :: alpha(:)     ! チェビシェフ<->ガラーキン行列積係数
  real(8), allocatable :: beta(:)      ! チェビシェフ<->ガラーキン行列和係数

  integer :: im                        ! 格子点数              
  integer :: km                        ! チェビシェフ切断波数  
  integer :: jm                        ! 第 1 次元の大きさ
  integer,parameter :: ks=2            ! ガラーキン基底最低次数

  real(8) :: cfd0_xmin                 ! 境界条件係数(0階微分 at x=xmin)
  real(8) :: cfd1_xmin                 ! 境界条件係数(1階微分 at x=xmin)
  real(8) :: cfd0_xmax                 ! 境界条件係数(0階微分 at x=xmax)
  real(8) :: cfd1_xmax                 ! 境界条件係数(1階微分 at x=xmax)

  logical :: MM_Initialized=.false.    ! 初期化フラッグ
  logical :: MM_Delta0     =.false.    ! 係数行列式判定
  real(8),parameter :: EPS = 1.0D-14   ! 行列式判定用微小値

  save im, km, jm, TF, FT, kp, alpha, beta, MM_Initialized, MM_Delta0
  save cfd0_xmin, cfd1_xmin, cfd0_xmax, cfd1_xmax
  public TF, FT, alpha, beta

contains

  !
  ! チェビシェフ−ガラーキン法 
  ! ディリクレ・ノイマン混合境界条件用モジュール
  ! 初期化サブルーチン
  !
  subroutine at_af_galerkin_MM_Initial(i_in,k_in,              &
                                    cfdx0_xmax,cfdx1_xmax,  &
                                    cfdx0_xmin,cfdx1_xmin    )

    integer, intent(IN) :: i_in      ! (in)格子点数
    integer, intent(IN) :: k_in      ! (in)チェビシェフ切断波数  

    real(8), intent(IN),optional :: cfdx0_xmin ! 境界条件係数(0階微分@x=xmin)
    real(8), intent(IN),optional :: cfdx1_xmin ! 境界条件係数(1階微分@x=xmin)
    real(8), intent(IN),optional :: cfdx0_xmax ! 境界条件係数(0階微分@x=xmax)
    real(8), intent(IN),optional :: cfdx1_xmax ! 境界条件係数(1階微分@x=xmax)

    real(8) :: Dfac                  ! 微分変換係数
    real(8) :: Delta                 ! 係数行列の行列式

    real(8) :: a, b, c, d, e, f
    integer :: k, l, m, n

    !---------- 格子点数・切断波数設定 ----------
    im=i_in ; km=k_in

    !---------- 境界条件係数設定 ----------
    Dfac = (g_X(0)-g_X(im))/2.0D0

    if( present(cfdx0_xmin) ) then
       cfd0_xmin = cfdx0_xmin
    else
       call MessageNotify('M','at_af_galerkin_MM_Initial(Type2)',&
                          'cfdx0_xmin set to zero internally.')
       cfd0_xmin = 0.0D0
    endif

    if( present(cfdx0_xmax) ) then
       cfd0_xmax = cfdx0_xmax
    else
       call MessageNotify('M','at_af_galerkin_MM_Initial(Type2)',&
                          'cfdx0_xmax set to zero internally.')
       cfd0_xmax = 0.0D0
    endif

    if( present(cfdx1_xmin) ) then
       cfd1_xmin = cfdx1_xmin/Dfac
    else
       call MessageNotify('M','at_af_galerkin_MM_Initial(Type2)',&
                          'cfdx1_xmin set to zero internally.')
       cfd1_xmin = 0.0D0
    endif

    if( present(cfdx1_xmax) ) then
       cfd1_xmax = cfdx1_xmax/Dfac
    else
       call MessageNotify('M','at_af_galerkin_MM_Initial(Type2)',&
                          'cfdx1_xmax set to zero internally.')
       cfd1_xmax = 0.0D0
    endif

    !---------- 境界条件係数チェック ----------

    Delta = cfd1_xmin*cfd0_xmax-cfd1_xmax*cfd0_xmin -2 * cfd0_xmin*cfd0_xmax

    if ( abs(Delta) &
         /max(abs(cfd1_xmin),abs(cfd0_xmin),abs(cfd1_xmax),abs(cfd0_xmax)) &
         .LT. EPS ) then
       MM_Delta0 = .true.
       call MessageNotify('W','at_af_galerkin_MM_Initial(Type2)',&
                           'Determinant of coefficent matrix equals zero.' )
       call MessageNotify('M','at_af_galerkin_MM_Initial(Type2)',&
                           'T2 and T1 are used for Galerkin base functions' )
    else
       MM_Delta0 = .false.
    endif

    !---------- ディリクレ・ノイマン混合条件用変換行列設定 ----------
    if ( allocated(TF) ) deallocate(TF)
    if ( allocated(FT) ) deallocate(FT)
    if ( allocated(kp) ) deallocate(kp)
    if ( allocated(alpha) ) deallocate(alpha)
    if ( allocated(beta) ) deallocate(beta)
    allocate(TF(0:km,ks:km),FT(ks:km,ks:km),kp(ks:km))
    allocate(alpha(0:km),beta(0:km))

    TF = 0.0D0
    if ( MM_Delta0 ) then
       a = 4 * cfd1_xmax + cfd0_xmax  ; b = cfd1_xmax + cfd0_xmax
       c = -4 * cfd1_xmin + cfd0_xmin ;  d = cfd1_xmin - cfd0_xmin
       Delta = a*d - b*c

       TF(0,2) = cfd1_xmax + cfd0_xmax
       TF(1,2) = -cfd0_xmax
       do k=ks+1,km
          e = cfd1_xmax * k**2 + cfd0_xmax
          f = cfd1_xmin * (-1)**(k+1) * k**2 + cfd0_xmin*(-1)**k
          TF(1,k) = -1.0D0/Delta*(-c*e+a*f)
          TF(2,k) = -1.0D0/Delta*(d*e-b*f)
          TF(k,k) = 1.0D0
       enddo
    else
       do k=ks,km
          TF(0,k) = 1.0D0/Delta                                       &
                * ( (-cfd1_xmin+cfd0_xmin)*(cfd1_xmax*k**2+cfd0_xmax) &
                   +  (cfd1_xmax+cfd0_xmax)                           &
                     *(    cfd1_xmin*(-1)**(k+1)*k**2                 &
                         + (-1)**k*cfd0_xmin         )                &
                  )
          TF(1,k) = 1.0D0/Delta                                       &
                * (   cfd0_xmin*(cfd1_xmax*k**2+cfd0_xmax)            &
                    - cfd0_xmax*(   cfd1_xmin*(-1)**(k+1)*k**2        &
                                  + (-1)**k*cfd0_xmin         )       &
                  )
          TF(k,k) = 1.0D0
       enddo
    endif

    beta=1.0 ; beta(0)=0.5D0
    if (im .eq. km ) beta(km)=0.5D0

    ! ディリクレ・ノイマン混合条件用変換逆行列
    alpha=1.0 ; alpha(0)=2.0D0

    FT = 0.0D0
    do m=ks,km
       do n=ks,km
          do l=0,km
             FT(m,n) = FT(m,n) + alpha(l)*TF(l,m)*TF(l,n)
          enddo
       enddo
    enddo

    call LUDecomp(FT,kp)

    call MessageNotify('M','at_af_galerkin_MM_Initial(Type2)',&
                           'Conversion matrices initialized')

    MM_Initialized=.true.

  end subroutine at_af_galerkin_MM_Initial

  !
  ! ディリクレ・ノイマン混合境界条件
  ! チェビシェフ係数 -> ガラーキン係数変換(2次元データ)
  !
  function af_at(at_data)
    real(8), intent(IN) :: at_data(:,0:)                !(in)  チェビシェフ係数
    real(8)             :: af_at(size(at_data,1),ks:km) !(out) ガラーキン係数  

    real(8)             :: af_work(size(at_data,1),ks:km)  ! 作業用配列

    integer :: k,m

    if ( .not. MM_Initialized ) &
         call MessageNotify('E','af_at',&
                            'at_af_galerkin_MM_module(Type2) not initialized')

    af_work =0.0
    do m=ks,km
       do k=0,km
          af_work(:,m) = af_work(:,m) &
               + alpha(k) * beta(k) * at_data(:,k) * TF(k,m)
       enddo
    enddo

    af_at = LUSolve(FT,kp,af_work)
  end function af_at

  !
  ! ディリクレ・ノイマン混合境界条件
  ! チェビシェフ係数 -> ガラーキン係数変換(1次元データ)
  !
  function f_t(t_data)

    real(8), intent(IN) :: t_data(0:km)        !(in)  チェビシェフ係数
    real(8)             :: f_t(ks:km)          !(out) ガラーキン係数  

    real(8)             :: f_work(ks:km)       ! 作業用配列

    integer :: k,m

    if ( .not. MM_Initialized ) &
         call MessageNotify('E','f_t',&
                            'at_af_galerkin_MM_module(Type2) not initialized')

    f_work =0.0
    do m=ks,km
       do k=0,km
          f_work(m) = f_work(m) &
               + alpha(k) * beta(k) * t_data(k) * TF(k,m)
       enddo
    enddo

    f_t = LUSolve(FT,kp,f_work)
  end function f_t

  !
  ! ディリクレ・ノイマン混合境界条件
  ! ガラーキン係数 -> チェビシェフ係数変換(2次元データ)
  !
  function at_af(af_data)

    real(8), intent(IN)  :: af_data(:,ks:)              !(in)  ガラーキン係数
    real(8)              :: at_af(size(af_data,1),0:km) !(out) チェビシェフ係数
    integer :: m, n

    if ( .not. MM_Initialized ) &
         call MessageNotify('E','at_af',&
                            'at_af_galerkin_MM_module(Type2) not initialized')

    at_af = 0.0D0
    do m=0,km
       do n=ks,km
          at_af(:,m) = at_af(:,m) + TF(m,n)*af_data(:,n)/beta(m)
       enddo
    enddo

  end function at_af

  !
  ! ディリクレ・ノイマン混合境界条件
  ! ガラーキン係数 -> チェビシェフ係数変換(1次元データ)
  !
  function t_f(f_data)

    real(8), intent(IN)  :: f_data(ks:km)       !(in)  ガラーキン係数  
    real(8)              :: t_f(0:km)           !(out) チェビシェフ係数

    integer :: m, n

    if ( .not. MM_Initialized ) &
         call MessageNotify('E','t_f',&
                            'at_af_galerkin_MM_module(Type2) not initialized')

    t_f = 0.0D0
    do m=0,km
       do n=ks,km
          t_f(m) = t_f(m) + TF(m,n)*f_data(n)/beta(m)
       enddo
    enddo

  end function t_f

  !
  ! ディリクレ・ノイマン混合境界条件
  ! 格子点データ -> ガラーキン係数変換(2次元データ)
  !
  function af_ag(ag_data)
    real(8), intent(IN)  :: ag_data(:,0:)                !(in)  格子点データ
    real(8)              :: af_ag(size(ag_data,1),ks:km) !(out) ガラーキン係数

    af_ag = af_at(at_ag(ag_data))
  end function af_ag

  !
  ! ディリクレ・ノイマン混合境界条件
  ! 格子点データ -> ガラーキン係数変換(1次元データ)
  !
  function f_g(g_data)
    real(8), intent(IN)  :: g_data(0:im)        !(in)  格子点データ
    real(8)              :: f_g(ks:km)          !(out) ガラーキン係数

    f_g = f_t(t_g(g_data))
  end function f_g

  !
  ! ディリクレ・ノイマン混合境界条件
  ! ガラーキン係数 -> 格子点データ変換(2次元データ)
  !
  function ag_af(af_data)
    real(8), intent(IN) :: af_data(:,ks:)              !(in)  ガラーキン係数  
    real(8)             :: ag_af(size(af_data,1),0:im) !(out) 格子点データ  
    
    ag_af = ag_at(at_af(af_data))
  end function ag_af

  !
  ! ディリクレ・ノイマン混合境界条件
  ! ガラーキン係数 -> 格子点データ変換(1次元データ)
  !
  function g_f(f_data)
    real(8), intent(IN) :: f_data(ks:km)        !(in)  ガラーキン係数  
    real(8)             :: g_f(0:im)            !(out) 格子点データ  
    
    g_f = g_t(t_f(f_data))
  end function g_f

  !
  ! ディリクレ・ノイマン混合境界条件
  ! X 微分計算(1 次元)
  !
  function af_Dx_af(af_data)
    real(8), intent(IN) :: af_data(:,ks:)                  !(in) ガラーキン係数
    real(8)             :: af_Dx_af(size(af_data,1),ks:km) !(out) 微分ガラーキン
    af_Dx_af = af_at(at_Dx_at(at_af(af_data)))
  end function af_Dx_af

  !
  ! ディリクレ・ノイマン混合境界条件
  ! X 微分計算(1 次元)
  !
  function f_Dx_f(f_data)
    real(8), intent(IN) :: f_data(ks:km)
    real(8)             :: f_Dx_f(ks:km)

    f_Dx_f = f_t(t_Dx_t(t_f(f_data)))

  end function f_Dx_f

end module at_af_galerkin_MM

! -*- mode: f90; coding: utf-8 -*-
!--
!----------------------------------------------------------------------
!     Copyright (c) 2005--2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  eigmatrix :: 固有値問題サブルーチン
!
!       spml/eigmatrix モジュールは, 実行列の固有値問題を解くための
!       Fortran90 サブルーチンを提供する. このモジュールで提供する
!       サブルーチンは単純なインターフェースを提供するだけであり,
!       実際には内部で行列計算ライブラリ SSL II あるいは LAPACK の
!       固有値問題を解くサブルーチンを呼んでいる.
!
!履歴  2005/01/25  竹広真一
!      2006/03/19  竹広真一  RDoc 用コメントを追加
!      2008/08/14  竹広真一  スレッド並列版 ssl2 サブルーチン追加
!      2009/01/29  佐々木洋平 RDoc 用コメントを追加
!      2011/11/08  竹広真一  ceigen 追加
!++
module eigmatrix
  !
  != eigmatrix
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id: eigmatrix.g90,v 1.4 2009-01-29 09:37:20 uwabami Exp $
  ! Copyright&License:: See COPYRIGHT[link:../../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/eigmatrix モジュールは, 実行列の固有値問題を解くための
  ! Fortran90 サブルーチンを提供する.
  !
  ! このモジュールで提供するサブルーチンは単純なインターフェースを
  ! 提供するだけであり, 実際には内部で行列計算ライブラリ SSL II あるいは
  ! Lapack の固有値問題を解くサブルーチンを呼んでいる.
  !
  !== 変数・手続き群の要約
  !
  ! eigen  :: 実正方行列の固有値, 固有ベクトルを求める
  ! ceigen :: 複素正方行列の固有値, 固有ベクトルを求める
  ! indexx :: 並び替えのための番号順づけを行う
  !

#ifdef EIG_SSL2
  use ssl2_eigen,  only : eigen  => deig1_ssl2
  use ssl2_ceigen, only : ceigen => dceig2_ssl2
#endif
#ifdef EIG_SSL2TP
  use ssl2tp_eigen,  only : eigen => dm_eig1_ssl2tp
  use ssl2tp_ceigen, only : ceigen => dm_ceigen_ssl2tp
#endif
#ifdef EIG_LAPACK
  use lapack_eigen,  only : eigen  => deigen_lapack
  use lapack_ceigen, only : ceigen => dceigen_lapack
#endif
  private
  public eigen, ceigen

end module eigmatrix

!----------------------------------------------------------------------
!   Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  et_module_fftj テストプログラム (境界値問題)
!
!履歴  2009/09/11  竹広真一  et_test_boundaries.f90 を fftj 用に改造
!
program et_module_fftj_boundaries_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use et_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=21              ! 切断波数の設定(X,Y)

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: eps = 1.0d-10            ! 判定誤差

  real(8)            :: yx_A(0:jm,0:im-1)     ! 格子データ
  real(8)            :: yx_dAdy(0:jm,0:im-1)  ! 格子データ
  real(8)            :: et_A(-km:km,0:lm)     ! スペクトルデータ
  real(8)            :: x_Ans(0:im-1)         ! 格子データ

  real(8), dimension(-km:km,2)  :: values

  integer            :: k=2

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  call MessageNotify('M','et_module_fftj_boundaries_test', &
       'et_module_fftj subroutines for boundary vaule problems tests')

 !---------------- 座標値の設定 ---------------------
  call et_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

!----- et_Boundaries (DD) ------
  yx_A = sin(k*pi*yx_X)*sin(pi*yx_Y)
  et_A = et_yx(yx_a)
  values = 0.0

  call et_Boundaries(et_A,values=values,cond='DD')
  yx_A = yx_et(et_A)
  yx_dAdy = yx_et(et_Dy_et(et_A))

  x_Ans = values(0,1)
  call AssertEqual(&
    message='et_Boundaries (DD, top)',                            &
    answer = x_Ans,                                               &
    check = yx_A(0,:),                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  x_Ans = values(0,2)
  call AssertEqual(&
    message='et_Boundaries (DD, bottom)',                         &
    answer = x_Ans,                                               &
    check = yx_A(jm,:),                                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

!----- et_Boundaries (DN) ------
  yx_A = sin(k*pi*yx_X)*sin(pi/2*yx_Y)
  et_A = et_yx(yx_a)

  call et_Boundaries(et_A,values,cond='DN')
  yx_A = yx_et(et_A)
  yx_dAdy = yx_et(et_Dy_et(et_A))

  x_Ans = values(0,1)
  call AssertEqual(&
    message='et_Boundaries (DN, top)',                            &
    answer = x_Ans,                                               &
    check = yx_A(0,:),                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  x_Ans = values(0,2)
  call AssertEqual(&
    message='et_Boundaries (DN, bottom)',                         &
    answer = x_Ans,                                               &
    check = yx_dAdy(jm,:),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

!----- et_Boundaries (ND) ------
  yx_A = sin(k*pi*yx_X)*cos(pi/2*yx_Y)
  et_A = et_yx(yx_a)
  call et_Boundaries(et_A,values,cond='ND')
  yx_A = yx_et(et_A)
  yx_dAdy = yx_et(et_Dy_et(et_A))

  x_Ans = values(0,1)
  call AssertEqual(&
    message='et_Boundaries (ND, top)',                            &
    answer = x_Ans,                                               &
    check = yx_dAdy(0,:),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  x_Ans = values(0,2)
  call AssertEqual(&
    message='et_Boundaries (ND, bottom)',                         &
    answer = x_Ans,                                               &
    check = yx_A(jm,:),                                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

!----- et_Boundaries (NN) ------
  yx_A = sin(k*pi*yx_X)*cos(pi*yx_Y)
  et_A = et_yx(yx_a)
  call et_Boundaries(et_A,values,cond='NN')
  yx_A = yx_et(et_A)
  yx_dAdy = yx_et(et_Dy_et(et_A))

  x_Ans = values(0,1)
  call AssertEqual(&
    message='et_Boundaries (ND, top)',                            &
    answer = x_Ans,                                               &
    check = yx_dAdy(0,:),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  x_Ans = values(0,2)
  call AssertEqual(&
    message='et_Boundaries (ND, bottom)',                         &
    answer = x_Ans,                                               &
    check = yx_dAdy(jm,:),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','et_module_fftj_boundaries_test', &
       'et_module_fftj subroutines for boundary vaule problems tests succeeded!')

end program et_module_fftj_boundaries_test

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wq_mpi_module_supack テストプログラム
!
!      磁場ポロイダルポテンシャルの境界値問題
!
!履歴  2016/04/01  竹広真一   wq_mpi_module_sjpack_polmagbc_test.f90 を supack 化
!
program wq_mpi_module_supack_polmagbc

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wq_mpi_module_supack
  use mpi

  implicit none

  integer,parameter  :: im=32, jm=16, km=8   ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=15         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ra=2.5               ! 球半径

  real(8), allocatable :: xvr_POLMAG(:,:,:)
  real(8), allocatable :: xvr_POLMAG_orig(:,:,:)
  real(8), allocatable :: wq_POLMAG(:,:)
  real(8), allocatable :: wq_POLMAG_orig(:,:)
  real(8), allocatable :: wr_POLMAG(:,:)

  real(8), allocatable :: wr_TopBoundary(:,:)
  real(8), allocatable :: wr_Zero(:,:)

  real(8), allocatable :: wr_n(:,:)   ! 全波数

  ! 判定誤差設定
  integer, parameter :: check_digits = 12
  integer, parameter :: ignore = -13

  real(8), parameter  :: pi=3.1415926535897932385D0

  integer :: k, n, nn(2)
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wq_mpi_module_supack_polmagbc_test', &
       'wq_mpi_module_supack wq_PolmagBoundary subroutine test')

  call wq_mpi_initial(im,jm,km,nm,lm,ra)

  allocate(xvr_POLMAG(0:im-1,1:jc,km))
  allocate(xvr_POLMAG_orig(0:im-1,1:jc,km))
  allocate(wq_POLMAG(nc,0:lm))
  allocate(wq_POLMAG_orig(nc,0:lm))
  allocate(wr_POLMAG(nc,km))
                 
  allocate(wr_TopBoundary(nc,km))
  allocate(wr_Zero(nc,km))
                 
  allocate(wr_n(nc,km))

  wr_Zero = 0.0D0
  
  !=================== wq_PolmagBoundary =======================
  ! P_10
  xvr_POLMAG = sin(xvr_lat) * sin( pi*xvr_rad/ra )

  ! P_1_1
  !xvr_POLMAG = cos(xvr_lat)*cos(xvr_lon)* sin( pi*(xvr_rad-ra)/ra )
  !xvr_POLMAG = 2*sin(xvr_lat)**2 * sin( pi*(xvr_rad-ra)/ra )

  xvr_POLMAG_orig = xvr_POLMAG
  wq_POLMAG = wq_xvr(xvr_POLMAG)
  wq_POLMAG_orig = wq_POLMAG
  call wq_PolmagBoundary(wq_POLMAG)

  call AssertEqual(&
       message='wq_PolmagBoundary (internal value)',                 &
       answer = wq_Polmag(:,0:lm-2),                                 &
       check = wq_Polmag_orig(:,0:lm-2),                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  do k=1,km
     do n=1,nc
        nn=nm_l(n)
        wr_n(n,k) = nn(1)
     enddo
  enddo

  wr_TopBoundary = wr_wq(wq_RadDRad_wq(wq_POLMAG))/wr_RAD &
                     + (wr_n +1)*wr_wq(wq_POLMAG)/wr_RAD

  call AssertEqual(&
       message='wq_PolmagBoundary (Top B.C.)',                       &
       answer = w_cleanup_w(wr_TopBoundary(:,km)),                   &
       check = wr_Zero(:,km),                                        &
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  !=================== wq_PolmagBoundaryGrid =======================
  ! P_10
  !xvr_POLMAG = sin(xvr_lat) * sin( pi*(xvr_rad-ri)/(ro-ri) )

  ! P_1_1
  !xvr_POLMAG = cos(xvr_lat)*cos(xvr_lon)* sin( pi*(xvr_rad-ri)/(ro-ri) )
  xvr_POLMAG = 2*sin(xvr_lat)**2 * sin( pi*(xvr_rad-ra)/ra ) * xvr_Rad

  xvr_POLMAG_orig = xvr_POLMAG
  wr_POLMAG = wr_xvr(xvr_POLMAG)
  call wr_PolmagBoundaryGrid(wr_POLMAG)
  xvr_POLMAG = xvr_wr(wr_POLMAG)
  wq_POLMAG  = wq_wr(wr_POLMAG)

  call AssertEqual(&
       message='wq_PolmagBoundaryGrid (internal value)',             &
       answer = xvr_Polmag(:,:,1:km-1),                              &
       check = xvr_Polmag_orig(:,:,1:km-1),                          &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  do k=1,km
     do n=1,nc
        nn=nm_l(n)
        wr_n(n,k) = nn(1)
     enddo
  enddo

  wr_TopBoundary = wr_wq(wq_RadDRad_wq(wq_POLMAG))/wr_RAD &
                      + (wr_n +1)*wr_POLMAG/wr_RAD
  call AssertEqual(&
       message='wq_PolmagBoundaryGrid (Top B.C.)',                   &
       answer = w_cleanup_w(wr_TopBoundary(:,km)),                   &
       check = wr_Zero(:,km),                                        &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','wq_mpi_module_supack_polmagbc_test', &
       'wq_mpi_module_supack wq_PolmagBoundary subroutine test succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

contains

  function w_cleanup_w(w_data)
    real(8), intent(IN) :: w_data(nc)
    real(8)             :: w_cleanup_w(nc)

    integer l,nmary(2)

    w_cleanup_w = w_data

    do l=1,nc
       nmary = nm_l(l)
       if ( nmary(1) .lt. 0 ) w_cleanup_w(l) = 0.0D0
    end do

  end function w_cleanup_w

end program wq_mpi_module_supack_polmagbc

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  l_module_svpack テストプログラム :: 微分関数のテスト
!
!履歴  2017/03/06  竹広真一
!
program l_module_svpack_deriv_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use l_module_svpack
  implicit none

  integer, parameter :: jm=16, nm=10

  real(8), dimension(1:jm)  ::  y_data1              ! 元の関数
  real(8), dimension(1:jm)  ::  y_ddata              ! 微分の正解
  real(8), dimension(1:jm)  ::  mu                   ! μ=sinφ

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','l_module_svpack_deriv_test', &
                         'l_module_svpack tests of derivative functions') 

  call l_Initial( nm, jm )

  !============== 微分計算 (φ座標系用) のテスト ==============

  !---- P_1 のテスト ----
  y_data1 = sqrt(3.0D0)*sin(y_Lat)         ! P_1

  y_ddata = -2*sqrt(3.0D0)*sin(y_Lat)      ! l_Lapla_l
  call AssertEqual(&
    message='P_1 Test of l_Lapla_l',                              &
    answer = y_ddata,                                             &
    check = y_l(l_Lapla_l(l_y(y_data1))),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_ddata = -0.5*sqrt(3.0D0)*sin(y_Lat)      ! l_Lapla_l
  call AssertEqual(&
    message='P_1 Test of l_LaplaInv_l',                           &
    answer = y_ddata,                                             &
    check = y_l(l_LaplaInv_l(l_y(y_data1))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_ddata = sqrt(3.0D0)*cos(y_Lat)         ! y_GradLat_l
  call AssertEqual(&
    message='P_1 Test of y_GradLat_l',                            &
    answer = y_ddata,                                             &
    check = y_GradLat_l(l_y(y_data1)),                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- P_1 cosφ のテスト ----
  y_data1 = sqrt(3.0D0)*sin(y_Lat)*cos(y_Lat)               ! P_1
  y_ddata = sqrt(3.0D0)*(cos(y_Lat)**2-2*sin(y_Lat)**2)     ! p_DivLat_y
  call AssertEqual(&
    message='P_1 cos(phi) Test of l_DivLat_y',                    &
    answer = y_ddata,                                             &
    check = y_l(l_DivLat_y(y_data1)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- P_2 のテスト ----
  y_data1 = sqrt(5.0D0)*(3.0/2*sin(y_Lat)**2-1/2.0)       ! P_2

  y_ddata = -6*y_data1                                    ! l_Lapla_l
  call AssertEqual(&
    message='P_2 Test of l_Lapla_l',                              &
    answer = y_ddata,                                             &
    check = y_l(l_Lapla_l(l_y(y_data1))),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_ddata = -y_data1/6.0D0                                ! l_Lapla_l
  call AssertEqual(&
    message='P_2 Test of l_LaplaInv_l',                           &
    answer = y_ddata,                                             &
    check = y_l(l_LaplaInv_l(l_y(y_data1))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_ddata = sqrt(5.0D0)*3.0*sin(y_Lat)*cos(y_Lat)         ! y_GradLat_l
  call AssertEqual(&
    message='P_2 Test of y_GradLat_l',                            &
    answer = y_ddata,                                             &
    check = y_GradLat_l(l_y(y_data1)),                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- P_2 cosφ のテスト ----
  y_data1 = sqrt(5.0D0)*(3.0/2*sin(y_Lat)**2-1/2.0)*cos(y_Lat)    ! P_2 cosφ
  y_ddata = sqrt(5.0D0)*(3.0*(sin(y_Lat)*cos(y_Lat)**2-sin(y_Lat)**3) &
                         +sin(y_Lat))                             ! l_DivLat_y
  call AssertEqual(&
    message='P_2 cos(phi) Test of l_DivLat_y',                    &
    answer = y_ddata,                                             &
    check = y_l(l_DivLat_y(y_data1)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !============== 微分計算 (μ座標系用) のテスト ==============
  mu = sin(y_Lat)

  !----- P_2 のテスト -----
  y_data1 = 3*mu**2-1                              ! P_2
  y_ddata = 6*mu*(1-mu**2)                         ! (1-μ^2)∂/∂μ 

  call AssertEqual(&
    message='P_2 Test of y_GradMu_l',                             &
    answer = y_ddata,                                             &
    check = y_GradMu_l(l_y(y_data1)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !----- P_2 (1-μ^2) のテスト -----
  y_data1 = (3*mu**2-1)*(1-mu**2)                ! P_2 (1-μ^2)
  y_ddata = (2-3*mu**2)*4*mu                     ! ∂/∂μ

  call AssertEqual(&
    message='P_2 (1-mu^2) Test of y_DivMu_l',                     &
    answer = y_ddata,                                             &
    check = y_l(l_DivMu_y(y_data1)),                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','l_module_svpack_deriv_test', &
       'l_module_svpack tests of derivative functions succeeded!') 

end program l_module_svpack_deriv_test

!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_zonal_module テストプログラム
!
!      トロイダルポテンシャルの境界値問題
!
!履歴  2008/12/30  竹広真一
!
program wt_zonal_test_torvelbc

  use dc_message, only : MessageNotify
  use wt_zonal_module

  implicit none

  integer,parameter  :: im=1, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16        ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5      ! 内外半径

  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_TorVel0
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_TorVel
  real(8), dimension(nm+1,0:lm)            :: wt_TorVel
  character(len=2), dimension(4),parameter :: BCond=(/'FF','FR','RF','RR'/)

  real(8), dimension(0:im-1,1:jm,0:km)           :: xyz_True

  real(8), parameter  :: pi=3.1415926535897932385D0
  real(8), parameter  :: eps=1D-10

  integer :: i,j,k,l

  call MessageNotify('M','wt_zonal_test_torvelbc', &
       'wt_zonal_module  wt_TorgBoundariesGrid subroutine test')

  call wt_initial(im,jm,km,nm,lm,ri,ro)

  do l=1,4

     ! P_10
     !xyz_TorVel = sin(xyz_Lat) * cos( pi*(xyz_rad-ri)/(ro-ri) )
     ! P_1_1
     !xyz_TorVel = cos(xyz_Lat)*cos(xyz_lon)* cos( pi*(xyz_rad-ri)/(ro-ri) )
     xyz_TorVel = 2*sin(xyz_Lat)**2 * cos( pi*(xyz_rad-ri)/(ro-ri) )

     xyz_TorVel0 = xyz_TorVel
     wt_TorVel = wt_xyz(xyz_TorVel)
     call wt_TorBoundariesGrid(wt_TorVel,cond=BCond(l),new=.true.)
     xyz_TorVel = xyz_wt(wt_TorVel)


     ! 内部チェック
     xyz_True = xyz_TorVel - xyz_TorVel0

     do k=1,km-1
        do j=1,jm
           do i=0,im-1
              if ( abs(xyz_True(i,j,k)) > eps ) then
                 write(6,*) 'internal value. : ', i,j,xyz_True(i,j,k)
                 call MessageNotify('E','wt_zonal_test_torvelbc',&
                              'internal value error too large')
              endif
           enddo
        enddo
     enddo

     ! 上端境界チェック
     if( BCond(l)(1:1) == 'F' ) then
        xyz_True = xyz_wt(wt_DRad_wt(wt_xyz(xyz_TorVel/xyz_Rad)))
     else
        xyz_True = xyz_TorVel
     endif

     do j=1,jm
        do i=0,im-1
           if ( abs(xyz_True(i,j,0)) > eps ) then
              write(6,*) 'Top B.C. : ', i,j,xyz_True(i,j,0)
              call MessageNotify('E','wt_zonal_test_torvelbc',&
                              'Top B.C. error too large')
           endif
        enddo
     enddo
     call MessageNotify('M','wt_zonal_test_torvelbc', &
                        BCond(l)//'-Top B.C. test succeeded!')

     ! 下端境界チェック
     if( BCond(l)(2:2) == 'F' ) then
        xyz_True = xyz_wt(wt_DRad_wt(wt_xyz(xyz_TorVel/xyz_Rad)))
     else
        xyz_True = xyz_TorVel
     endif

     do j=1,jm
        do i=0,im-1
           if ( abs(xyz_True(i,j,km)) > eps ) then
              write(6,*) 'Bottom B.C. : ', i,j,xyz_True(i,j,km)
              call MessageNotify('E','wt_zonal_test_torvelbc',&
                              'Bottom B.C. error too large')
           endif
        enddo
     enddo

     call MessageNotify('M','wt_zonal_test_torvelbc', &
                        BCond(l)//'-Bottom B.C. test succeeded!')
  enddo

  call MessageNotify('M','wt_zonal_test_torvelbc', &
       'wt_zonal_module  wt_TorgBoundariesGrid subroutine test succeeded!')

end program wt_zonal_test_torvelbc

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  l_module_svpack テストプログラム :: 補間関数のテスト
!
!履歴  2017/03/06  竹広真一
!
program l_module_svpack_interpolate

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use l_module_svpack
  implicit none

  integer, parameter :: jm=16, nm=10

  real(8), dimension(0:nm) ::  l_data
  real(8), dimension(1:jm) ::  y_data

  real(8) :: Alat
  real(8) :: y_data_sol
  real(8) :: error
  real(8) :: pi

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  pi = atan(1.0D0)*4.0D0
  Alat = pi/3

  call l_Initial( nm, jm )

  call MessageNotify('M','l_module_svpack_Interpolate_test', &
                         'l_module_svpack interpolate function tests') 


  !---- P_1 のテスト ----
  y_data = sqrt(3.0D0)*sin(y_Lat)                      ! P_1
  y_data_sol = sqrt(3.0D0)*sin(ALat)
  l_data = l_y(y_data)

  call AssertEqual(&
    message='P_1 Test of interpolate function',                   &
    answer = y_data_sol,                                          &
    check = Interpolate_l(l_data,alat),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- P_2 のテスト ----
  y_data = sqrt(5.0D0)*(3.0/2*sin(y_Lat)**2-1/2.0)                 ! P_2
  y_data_sol = sqrt(5.0D0)*(3.0/2*sin(alat)**2-1.0/2)
  l_data = l_y(y_data)

  call AssertEqual(&
    message='P_2 Test of interpolate function',                   &
    answer = y_data_sol,                                          &
    check = Interpolate_l(l_data,alat),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的な関数のテスト ----
  y_data = (sin(y_Lat)-1)**2*(sin(y_Lat)-0.5)*(sin(y_Lat)+1)
  y_data_sol = (sin(ALat)-1)**2*(sin(ALat)-0.5)*(sin(ALat)+1)
  l_data = l_y(y_data)
  error = Interpolate_l(l_data,alat)-y_data_sol

  call AssertEqual(&
    message='generaul function Test of interpolate function',     &
    answer = y_data_sol,                                          &
    check = Interpolate_l(l_data,alat),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','l_module_svpack_Interpolate_test', &
                         'l_module_svpack interpolate function tests succeeded!') 

end program l_module_svpack_interpolate

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ut_mpi_module_supack テストプログラム
!
!      ポロイダルポテンシャルの境界値問題
!
!履歴  2016/03/27  竹広真一   wt_module_nmomp_test_polvelbc.f90 より改造
!
program ut_mpi_module_svpack_polvelbc_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ut_mpi_module_svpack
  use mpi

  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5      ! 内外半径

  real(8), allocatable :: xyh_Poloidal(:,:,:)
  real(8), allocatable :: xyh_LaplaPol(:,:,:)
  real(8), allocatable :: xyh_LaplaPol1(:,:,:)
  real(8), allocatable :: xyh_True(:,:,:)
  real(8), allocatable :: xyh_Zero(:,:,:)
  character(len=2), dimension(4), parameter :: BCond=(/'FF','FR','RF','RR'/)

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8), parameter  :: pi=3.1415926535897932385D0

  integer :: l

  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','ut_mpi_module_svpack_polvelbc_test', &
       'ut_mpi_module_svpack ut_LaplaPol2polGrid_ut function tests')

  call ut_mpi_initial(im,jm,km,nm,lm,ri,ro)

  allocate(xyh_Poloidal(0:im-1,jm,kc))
  allocate(xyh_LaplaPol(0:im-1,jm,kc))
  allocate(xyh_LaplaPol1(0:im-1,jm,kc))
  allocate(xyh_True(0:im-1,jm,kc))
  allocate(xyh_Zero(0:im-1,jm,kc))

  do l=1,4

     ! P_10
     xyh_Poloidal = sin(xyh_Lat) * sin( pi*(xyh_Rad-ri)/(ro-ri) )
     xyh_LaplaPol = xyh_ut(ut_Lapla_ut(ut_xyh(xyh_Poloidal)))
     !xyh_LaplaPol = sin(xyh_Lat) * sin( pi*(xyh_Rad-ri)/(ro-ri) )
     ! P_1_1
     !xyh_LaplaPol = cos(xyh_Lat)*cos(xyh_Lon)* sin( pi*(xyh_Rad-ri)/(ro-ri) )
     !xyh_LaplaPol = 2*sin(xyh_Lat)**2 * sin( pi*(xyh_Rad-ri)/(ro-ri) )

     !xyh_Poloidal = xyh_wz(wz_LaplaPol2pol_wz(wz_xyh(xyh_LaplaPol),BCond(l)))
     !xyh_Poloidal = xyh_ut(ut_LaplaPol2PolTau_ut(ut_xyh(xyh_LaplaPol),BCond(l)))

     xyh_Poloidal = xyh_ut(ut_LaplaPol2PolGrid_ut(ut_xyh(xyh_LaplaPol),BCond(l),new=.true.))

     xyh_LaplaPol1 = xyh_ut(ut_Lapla_ut(ut_xyh(xyh_Poloidal)))
     xyh_Zero = 0.0D0

     !---------------- 内部チェック -----------------------
     if ( kh_kz(0) /= 0 .and. kh_kz(km) /= 0 )then
        call AssertEqual(&
             message='ut_TorBoundariesGrid_ut (intenal value)',            &
             answer = xyh_LaplaPol1(:,:,3:kc-2),                           &
             check = xyh_LaplaPol(:,:,3:kc-2),                             &
             significant_digits = check_digits, ignore_digits = ignore     &
             )
     else if ( kh_kz(0) == 0 .and. kh_kz(km) /= 0 ) then
        call AssertEqual(&
             message='ut_TorBoundariesGrid_ut (intenal value)',            &
             answer = xyh_LaplaPol1(:,:,1:kc-2),                           &
             check = xyh_LaplaPol(:,:,1:kc-2),                             &
             significant_digits = check_digits, ignore_digits = ignore     &
             )
     else if ( kh_kz(0) /= 0 .and. kh_kz(km) == 0 ) then
        call AssertEqual(&
             message='ut_TorBoundariesGrid_ut (intenal value)',            &
             answer = xyh_LaplaPol1(:,:,kh_kz(0)+2:kc),                    &
             check = xyh_LaplaPol(:,:,kh_kz(0)+2:kc),                      &
             significant_digits = check_digits, ignore_digits = ignore     &
             )
     else 
        call AssertEqual(&
             message='ut_TorBoundariesGrid_ut (intenal value)',            &
             answer = xyh_LaplaPol1,                                       &
             check = xyh_LaplaPol,                                         &
             significant_digits = check_digits, ignore_digits = ignore     &
             )
     endif
     !--------- 上端境界チェック ----------

     !----- Φ=0 at the top ---------
     if ( kh_kz(0) /= 0 )then
        call AssertEqual(&
             message='ut_LaplaPol2polGrid_ut (Top B.C. Φ=0)',             &
             answer = xyh_Zero(:,:,kh_kz(0)),                              &
             check = xyh_Poloidal(:,:,kh_kz(0)),                           &
             significant_digits = check_digits, ignore_digits = ignore     &
             )
     endif
        
     !----- dΦ/dr=0, d^2Φ/dr^2 at the top ---------
     if( BCond(l)(1:1) == 'F' ) then
        xyh_True = xyh_ut(ut_DRad_ut(ut_DRad_ut(ut_xyh(xyh_Poloidal))))
     else
        xyh_True = xyh_ut(ut_DRad_ut(ut_xyh(xyh_Poloidal)))
     endif

     if ( kh_kz(0) /= 0 )then
        call AssertEqual(&
             message='ut_LaplaPol2polGrid_ut ('//BCond(l)//'-Top B.C)',    &
             answer = xyh_Zero(:,:,kh_kz(0)),                              &
             check = xyh_True(:,:,kh_kz(0)),                               &
             significant_digits = check_digits, ignore_digits = ignore     &
             )
     endif
        
     !--------- 下端境界チェック ----------

     !----- Φ=0 at the bottom ---------
     if ( kh_kz(km) /= 0 )then
        call AssertEqual(&
             message='ut_LaplaPol2polGrid_ut (Bottom B.C. Φ=0)',          &
             answer = xyh_Zero(:,:,kh_kz(km)),                             &
             check = xyh_Poloidal(:,:,kh_kz(km)),                          &
             significant_digits = check_digits, ignore_digits = ignore     &
             )
     endif

     !----- dΦ/dr=0, d^2Φ/dr^2 at the bottom ---------
     if( BCond(l)(2:2) == 'F' ) then
        xyh_True = xyh_ut(ut_DRad_ut(ut_DRad_ut(ut_xyh(xyh_Poloidal))))
     else
        xyh_True = xyh_ut(ut_DRad_ut(ut_xyh(xyh_Poloidal)))
     endif

     if ( kh_kz(km) /= 0 )then
        call AssertEqual(&
             message='ut_LaplaPol2polGrid_ut ('//BCond(l)//'-Bottom B.C)', &
             answer = xyh_Zero(:,:,kh_kz(km)),                             &
             check = xyh_True(:,:,kh_kz(km)),                              &
             significant_digits = check_digits, ignore_digits = ignore     &
             )
     endif
  end do

  call MessageNotify('M','ut_mpi_module_svpack_polvelbc_test', &
       'ut_mpi_module_svpack ut_LaplaPol2polGrid_ut function tests suceeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ut_mpi_module_svpack_polvelbc_test

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wq_mpi_module_supack テストプログラム
!
!      磁場トロイダルポテンシャルの境界値問題
!
!履歴  2016/04/01  竹広真一   wq_mpi_module_sjpack_tormagbc_test.f90 を supack 化
!
program wq_mpi_module_supack_tormagbc

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wq_mpi_module_supack
  use mpi

  implicit none

  integer,parameter  :: im=32, jm=16, km=8   ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=15         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ra=0.5D0               ! 球半径

  real(8), allocatable :: xvr_TORMAG(:,:,:)
  real(8), allocatable :: xvr_TORMAG_orig(:,:,:)
  real(8), allocatable :: wq_TORMAG(:,:)
  real(8), allocatable :: wq_TORMAG_orig(:,:)
  real(8), allocatable :: wr_TORMAG(:,:)

  real(8), allocatable :: xvr_Zero(:,:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  real(8), parameter  :: pi=3.1415926535897932385D0
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wq_mpi_module_supack_tormagbc_test', &
       'wq_mpi_module_supack wq_TormagBoundary subroutine test')

  call wq_mpi_initial(im,jm,km,nm,lm,ra)

  allocate(xvr_TORMAG(0:im-1,1:jc,km))
  allocate(xvr_TORMAG_orig(0:im-1,1:jc,km))
  allocate(wq_TORMAG(nc,0:lm))
  allocate(wq_TORMAG_orig(nc,0:lm))
  allocate(wr_TORMAG(nc,km))
                
  allocate(xvr_Zero(0:im-1,1:jc,km))

  xvr_Zero = 0.0D0

 !==================== wq_TormagBoundary =========================
  ! P_10
  xvr_TORMAG = sin(xvr_lat) * cos( pi*(xvr_rad-ra)/ra )*xvr_Rad
  ! P_1_1
  !xvr_TORMAG = cos(xvr_lat)*cos(xvr_lon)* cos( pi*(xvr_rad-ri)/(ro-ri) )
  !xvr_TORMAG = 2*sin(xvr_lat)**2 * cos( pi*(xvr_rad-ri)/(ro-ri) )

  wq_TORMAG = wq_xvr(xvr_TORMAG)
  wq_TORMAG_orig = wq_TORMAG

  call wq_TormagBoundary(wq_TORMAG)
  xvr_TORMAG = xvr_wq(wq_TORMAG)

  call AssertEqual(&
       message='wq_TormagBoundaryGrid (Top B.C.)',                   &
       answer = xvr_Zero(:,:,km),                                    &
       check = xvr_TORMAG(:,:,km),                                   &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wq_TormagBoundary (internal value)',                 &
       answer = wq_Tormag(:,0:lm-2),                                 &
       check = wq_Tormag_orig(:,0:lm-2),                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

 !==================== wq_TormagBoundaryGrid =========================
  ! P_10
  !xvr_TORMAG = sin(xvr_lat) * cos( pi*(xvr_rad-ra)/ra )
  ! P_1_1
  xvr_TORMAG = cos(xvr_lat)*cos(xvr_lon)* cos( pi*(xvr_rad-ra)/ra )*xvr_Rad
  !xvr_TORMAG = 2*sin(xvr_lat)**2 * cos( pi*(xvr_rad-ra)/ra )

  xvr_TORMAG_orig = xvr_TORMAG
  wr_TORMAG = wr_xvr(xvr_TORMAG)
  call wr_TormagBoundaryGrid(wr_TORMAG)
  xvr_TORMAG = xvr_wr(wr_TORMAG)

  call AssertEqual(&
       message='wq_TormagBoundaryGrid (Top B.C.)',                   &
       answer = xvr_Zero(:,:,km),                                    &
       check = xvr_TORMAG(:,:,km),                                   &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wq_TormagBoundaryGrid (internal value)',             &
       answer = xvr_TORMAG_orig(:,:,1:km-1),                         &
       check = xvr_TORMAG(:,:,1:km-1),                               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  call MessageNotify('M','wq_mpi_module_supack_tormagbc_test', &
       'wq_mpi_module_supack wq_TormagBoundary subroutine test succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wq_mpi_module_supack_tormagbc

!----------------------------------------------------------------------
!     Copyright (c) 2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_aq_galerkin_SS_test2d
!
!      チェビシェフ−ガラーキン法テストプログラム(2次元)
!      非圧縮流体の流線関数・流れポテンシャル用, 両端自由すべり条件
!      (両端で値と 2 階微分が 0)
!
!        f(:,i=0)=f(:,i=im)=f''(:,i=0)=f''(:,i=im)=0 
!        [ f(:,x=xmax)=f(:,x=xmin)=f''(:,x=xmax)=0=f''(:,x=xmin)=0 ]
!
!      例  : f(x) = sin(j*pi*x),    0<x<1
!
!履歴  2006/01/05  竹広真一  新規作成
!      2006/01/24  竹広真一  モジュール変更に伴う改訂
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!
program at_aq_galerkin_SS_test2d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_aq_galerkin_RRFF
  use at_module

  implicit none

  integer, parameter :: jm=3                   ! 1 次元目格子点数
  integer, parameter :: im=32                  ! 格子点数              
  integer, parameter :: km=32                  ! チェビシェフ切断波数  
  real(8), parameter :: xmin=0.0d0, xmax=1.0d0 ! 計算領域

  real(8) :: ag_data(jm,0:im)
  real(8) :: ag_data_orig(jm,0:im)
  real(8) :: pi
  integer :: j

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = - 10

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','at_aq_galerkin_SS_test2d', &
    & '2D Slip-Slip B.C.')

  call at_Initial(im,km,xmin,xmax)
  call at_aq_galerkin_RRFF_Initial(im,km,'SS')    !--- 両端自由すべり条件 ---

  do j=1,jm
     ag_data(j,:) = sin(j*pi*g_X)
  enddo
  ag_data_orig = ag_data
  ag_data = ag_aq(aq_ag(ag_data))

  call AssertEqual(&
    & message = 'Grid -> Galerkin -> Grid ',                    &
    & answer  = ag_data_orig,                                   &
    & check   = ag_data,                                        &
    & significant_digits = check_digits, ignore_digits = ignore &
    )
!  だめな例
!  ag_data = ag_aq(aq_Dx_aq(aq_Dx_aq(aq_data)))
!  よい例 : 微分値はチェビシェフ係数で保持するべし
  ag_data = ag_aq(aq_at(at_Dx_at(at_Dx_at(at_aq(aq_ag(ag_data))))))

  do j=1,jm
    ag_data_orig(j,:) = -(j*pi)**2 * ag_data_orig(j,:)
  enddo

  call AssertEqual(&
    & message = 'Grid -> Galerkin -> (Dx)^2 -> Grid ',          &
    & answer  = ag_data_orig,                                   &
    & check   = ag_data,                                        &
    & significant_digits = check_digits, ignore_digits = ignore &
    )

  call MessageNotify('M','at_aq_galerkin_SS_test2d', &
    & '2D Slip-Slip B.C. succeeded!')
  
end program at_aq_galerkin_SS_test2d

!------------------------------------------------------------------------
! Copyright (c) 2016 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  ee_module テストプログラム (渦度方程式移流項ヤコビアン計算)
!
!履歴  2016/08/08  竹広真一
!
program ee_mpi_module_jacobianZ_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10            ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8), allocatable  :: vx_Data(:,:)    ! 格子データ
  real(8), allocatable  :: vx_JacobZ(:,:)  ! 格子データ
  real(8), allocatable  :: ef_JacobZ(:,:)  ! 格子データ

  integer, parameter :: k=3,l=1
  integer            :: kk, ll 
  integer            :: np, ip, ierr

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','ee_mpi_module_jacobianZ_test', &
       'ee_mpi_module jacobian function tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

 !---------------- 座標値の設定 ---------------------
  call ee_mpi_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

  allocate(vx_Data(jc(ip),0:im-1))    ! 格子データ
  allocate(vx_JacobZ(jc(ip),0:im-1))  ! 格子データ
  allocate(ef_JacobZ(-lm:lm,2*kc(ip)))  ! 格子データ

  !------------------- 初期値設定 ----------------------
  vx_Data = sin(k*pi*vx_X) + cos(l*pi*vx_Y)
!!$  vx_JacobZ = (dble(l)/k-dble(k)/l)*cos(k*pi*vx_X)*sin(l*pi*vx_Y)
  vx_JacobZ = - (dble(l)/k-dble(k)/l)*cos(k*pi*vx_X)*sin(l*pi*vx_Y)

  ef_JacobZ = ef_JacobianZ_ef(ef_vx(vx_Data))
  do kk=1,2*kc(ip)
     do ll=-lm,lm
        if ( abs(ef_JacobZ(ll,kk)) .gt. 1.0D-10 ) then
           write(6,*) ip, ll, kk, ef_JacobZ(ll,kk)
        endif
     enddo
  enddo
  
  call AssertEqual(                                 &
    message = 'JacobZ(sin(k*pi*X)+cos(l*pi*Y))',    &
    answer = vx_JacobZ,                             &
    check = vx_ef(ef_JacobianZ_ef(ef_vx(vx_Data))), &
    significant_digits = check_digits, ignore_digits = ignore     )


  call MPI_FINALIZE(IERR)
  
  call MessageNotify('M','ee_mpi_module_jacobianZ_test', &
       'ee_mpi_module jacobian function tests succeeded!')

end program ee_mpi_module_jacobianZ_test

!--
!----------------------------------------------------------------------
! Copyright(c) 2008-2012 SPMDODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  wq_mpi_module_sjpack
!
!    spml/wq_mpi_module_sjpack モジュールは球内での流体運動をスペクトル法と 
!    MPI 並列化によって数値計算するための Fortran90 関数を提供する
!    ものである. 
!
!    水平方向に球面調和函数変換および動径方向に
!    Matsushima and Marcus (1994) で提唱された多項式を用いた
!    スペクトル計算のためのさまざまな関数を提供する. 
!
!    内部で wa_mpi_module_sjpack, aq_module を用いている. 
!    最下部では球面調和変換変換のエンジンとして 
!    ISPACK の Fortran77 サブルーチンを用いている.
!
!    関数, サブルーチンの名前と機能は wq_mpi_module のものと同じである.
!    したがって use 文を wq_mpi_module から wq_mpi_module_sjpack に
!    変更するだけで SJPACK-MPI の機能が使えるようになる.
!
!    ただし l_nm, nm_l の使い方には注意されたい. wq_module の l_nm,
!    nm_l はwq_Initial で初期化しなくとも用いることができる(結果が切断
!    波数に依らない)が, wq_mpi_module_sjpack のものは初期化したのちにしか使
!    うことができない.
!
!    Matsushima and Marcus (1994) の多項式に関する説明は 
!    doc/spectral_radial.tex を参照のこと. 
!
!
!履歴  2008/04/03  竹広真一  wu_module より改変
!      2008/05/02  竹広真一  コメント追加
!      2008/07/01  佐々木洋平 水平方向の格子点を 0:im-1,1:jm に修正
!      2008/07/04  佐々木洋平 コメントを RDoc 用に微修正
!      2008/07/20  竹広真一  wq_Rad2_wq, wq_Rad2Inv_wq, wq_Lapla_wq 追加
!      2008/07/21  竹広真一  行列設定計算変更
!      2009/01/09  竹広真一  wu_Initial メッセージに日付を追加
!      2009/01/29  佐々木洋平 コメントを RDoc 用に微修正
!      2009/07/31  竹広真一  境界条件計算用配列を threadprivate 指定(OpenMP)
!      2009/12/06  竹広真一  先頭コメントを修正
!      2010/03/10  佐々木洋平  threadprivate 削除(コンパイラ依存)
!      2010/04/17  竹広真一  wr_DivRad_xyr 追加, wr_Div_xyr_xyr_xyr を変更
!                            wq_LaplaPol2Pol_wq の計算法変更
!      2010/05/08  竹広真一  wq_LaplaPol2Pol_wq の計算法元にもどす.
!      2011/09/08  竹広真一  MPI 並列化
!      2012/04/02  竹広真一  sjpack 化
!      2012/05/25  竹広真一  wq_QoperatorMPI_wq を追加
!
!凡例
!      データ種類と index
!        x : 経度         y : 緯度    v : 緯度(分散格子)     r : 動径
!        w : 球面調和関数スペクトル
!        n : 球面調和関数スペクトル(水平全波数)
!        m : 球面調和関数スペクトル(帯状波数)
!        q : スペクトル関数スペクトル
!        a : 任意の次元
!
!        xyr : 3 次元格子点データ
!        xvr : 3 次元分散格子点データ
!        xy  : 水平 2 次元格子点データ
!        xv  : 水平 2 次元分散格子点データ
!        yr  : 子午面 2 次元格子点データ
!        vr  : 子午面 2 次元分散格子点データ
!        xr  : 緯度面 2 次元格子点データ
!
!        wr  : 水平スペクトル動径格子点データ
!        wq  : スペクトルデータ
!
!++
module wq_mpi_module_sjpack
  !
  != wq_mpi_module_sjpack
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/wq_mpi_module_sjpack モジュールは球内での流体運動をスペクトル法と 
  ! MPI 並列化によって数値計算するための Fortran90 関数を提供する
  ! ものである. 
  !
  ! 水平方向に球面調和函数変換および動径方向に
  ! Matsushima and Marcus (1994) で提唱された多項式を用いた
  ! スペクトル計算のためのさまざまな関数を提供する. 
  !
  ! 内部で wa_mpi_module_sjpack, aq_module を用いている. 
  ! 最下部では球面調和変換のエンジンとして 
  ! ISPACK の Fortran77 サブルーチンを用いている.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (wq_, nmr_, nr_, xyr_, wr_, w_, xy_, xv_, yr_, vr_, xr_, 
  !   x_, y_, v_, r_, a_) は, 返す値の形を示している.
  !   wq_  :: スペクトルデータ(球面調和函数・チェビシェフ変換)
  !   nmr_ :: 水平スペクトルデータ(全波数 n, 帯状波数各成分, 動径)
  !   nr_  :: 水平スペクトルデータ(全波数 n, 動径)
  !   xyr_ :: 3 次元格子点データ(経度・緯度・動径)
  !   xvr_ :: 3 次元分散格子点データ(経度・緯度・動径)
  !   wr_  :: 水平スペクトル, 動径格子点データ
  !   xy_  :: 2 次元格子点データ(経度・緯度)
  !   xv_  :: 2 次元分散格子点データ(経度・緯度)
  !   yr_  :: 2 次元格子点データ(緯度・動径)
  !   vr_  :: 2 次元分散格子点データ(緯度・動径)
  !   xr_  :: 2 次元格子点データ(経度・動径)
  !   x_   :: 1 次元格子点データ(経度)
  !   y_   :: 1 次元格子点データ(緯度)
  !   v_   :: 1 次元分散格子点データ(緯度)
  !   r_   :: 1 次元格子点データ(動径)
  !   a_   :: 任意の次元
  !
  ! * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla,..)
  !   は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_wq, _nmr, _nr, _xyr, _wr, _w, _xy, _xv, _yr, _vr, _xr, 
  !   _x, _y, _v, _r, _a) は, 入力変数の形がスペクトルデータおよび
  !   格子点データであることを示している. 
  !   _wq      :: スペクトルデータ
  !   _xyr     :: 3 次元格子点データ
  !   _xyr_xyr :: 2 つの3 次元格子点データ, ...
  !   _xvr     :: 3 次元分散格子点データ
  !   _xvr_xvr :: 2 つの3 次元分散格子点データ, ...
  !
  !=== 各データの種類の説明
  !
  ! * xyr : 3 次元格子点データ(経度・緯度・動径)
  !   * 変数の種類と次元は real(8), dimension(0:im-1,1:jm,km). 
  !   * im, jm, km はそれぞれ経度, 緯度, 動径座標の格子点数であり, 
  !     サブルーチン wq_mpi_Initial にてあらかじめ設定しておく.
  !
  ! * xvr : 3 次元分散格子点データ(経度・緯度・動径)
  !   * 変数の種類と次元は real(8), dimension(0:im-1,jc,km). 
  !   * im, km はそれぞれ経度, 動径座標の格子点数であり, 
  !   * jc はこのプロセスで保有する緯度格子点数である. 
  !     サブルーチン wq_mpi_Initial を呼ぶと jc が設定される. 
  !
  ! * wq : スペクトルデータ
  !   * 変数の種類と次元は real(8), dimension((nm+1)*(nm+1),0:lm). 
  !   * nm は球面調和函数の最大全波数, lm はチェビシェフ多項式の最大次数
  !     であり, サブルーチン wq_mpi_Initial にてあらかじめ設定しておく. 
  !   * 水平スペクトルデータの格納のされ方は関数 l_nm, nm_l によって調べる
  !     ことができる. 
  !   * 動径スペクトルデータの格納方法については aq_module.f90 を
  !     参照のこと. km < 2*im でなければならない. 
  !
  ! * nmr : 水平スペクトルデータの並んだ 3 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,-nm:nm,km). 
  !   * 第 1 次元が水平全波数, 第 2 次元が帯状波数, 第 3 次元が動径座標を表す. 
  !   * nm は球面調和函数の最大全波数であり, サブルーチン wq_Initial にて
  !     あらかじめ設定しておく.
  !
  ! * nr : スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,km). 
  !   * 第 1 次元が水平全波数を表す. nm は球面調和函数の最大全波数であり, 
  !     サブルーチン wq_Initial にてあらかじめ設定しておく.
  !
  ! * wr : 水平スペクトル, 動径格子点データ.
  !   * 変数の種類と次元は real(8), dimension((nm+1)*(nm+1),km).
  !
  ! * wq_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * xyr_ で始まる関数が返す値は 3 次元格子点データに同じ.
  !
  ! * xvr_ で始まる関数が返す値は 3 次元分散格子点データに同じ.
  !
  ! * wr_ で始まる関数が返す値は水平スペクトル, 動径格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  ! 
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! wq_mpi_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! 
  !==== 座標変数
  !
  ! x_Lon, x_Lon_Weight,  ::  格子点座標(経度)と重みを格納した 1 次元配列
  ! y_Lat, y_Lat_Weight   ::  格子点座標(緯度)と重みを格納した 1 次元配列
  ! v_Lat, v_Lat_Weight   ::  分散格子点座標(緯度)と重みを格納した 1 次元配列
  ! r_Rad, r_Rad_Weight   ::  格子点座標(同形)と重みを格納した 1 次元配列
  ! xyr_Lon, xyr_Lat, xyr_Rad :: 格子点データの経度・緯度・動径座標(X,Y,Z) (格子点データ型 3 次元配列)
  ! xvr_Lon, xvr_Lat, xvr_Rad :: 格子点データの経度・緯度・動径座標(X,Y,Z) (分散格子点データ型 3 次元配列)
  !
  !==== 基本変換
  !
  ! xyr_wq, wq_xyr :: スペクトルデータと 3 次元格子データの間の変換
  !                   (球面調和函数, チェビシェフ変換)
  !
  ! xvr_wq, wq_xvr :: スペクトルデータと 3 次元分散格子データの間の変換
  !                   (球面調和函数, チェビシェフ変換)
  !
  ! xyr_wr, wr_xyr :: 3 次元格子データと水平スペクトル・動径格子データとの
  !                   間の変換 (球面調和函数)
  !
  ! xvr_wr, wr_xvr :: 3 次元分散格子データと水平スペクトル・動径格子データとの
  !                   間の変換 (球面調和函数)
  !
  ! wr_wq, wq_wr   :: スペクトルデータと水平スペクトル・動径格子データとの
  !                   間の変換 (チェビシェフ変換)
  !
  ! w_xy, xy_w     :: スペクトルデータと 2 次元水平格子データの
  !                   間の変換(球面調和函数変換) 
  !
  ! w_xv, xv_w     :: スペクトルデータと 2 次元水平分散格子データの
  !                   間の変換(球面調和函数変換) 
  !
  ! l_nm, nm_l     :: スペクトルデータの格納位置と全波数・帯状波数の変換 
  !
  !==== 微分
  !
  ! wq_RadDRad_wq       :: スペクトルデータに動径微分 r∂/∂r を作用させる
  ! wr_DivRad_wq        :: スペクトルデータに発散型動径微分
  !                        1/r^2 ∂/∂r r^2 = ∂/∂r + 2/r を作用させる
  ! wr_DivRad_xyr       :: 格子点データに発散型動径微分
  !                        1/r^2 ∂/∂r r^2 = ∂/∂r + 2/r を作用させる
  ! wr_DivRad_xvr       :: 格子点データに発散型動径微分
  !                        1/r^2 ∂/∂r r^2 = ∂/∂r + 2/r を作用させる
  ! wr_RotDRad_wq       :: スペクトルデータに回転型動径微分
  !                        1/r ∂/∂rr = ∂/∂r + 1/r を作用させる
  ! wr_RotDRad_wr       :: スペクトルデータに回転型動径微分
  !                        1/r ∂/∂rr = ∂/∂r + 1/r を作用させる
  ! wq_RotDRad_wr       :: スペクトルデータに回転型動径微分
  !                        1/r ∂/∂rr = ∂/∂r + 1/r を作用させる
  ! wq_Lapla_wq         :: スペクトルデータにラプラシアンを作用させる
  ! xyr_GradLon_wq      :: スペクトルデータに勾配型経度微分
  !                        1/rcosφ・∂/∂λを作用させる
  ! xvr_GradLon_wq      :: スペクトルデータに勾配型経度微分
  !                        1/rcosφ・∂/∂λを作用させる
  ! xyr_GradLat_wq      :: スペクトルデータに勾配型緯度微分
  !                        1/r・∂/∂φを作用させる
  ! xvr_GradLat_wq      :: スペクトルデータに勾配型緯度微分
  !                        1/r・∂/∂φを作用させる
  ! wr_DivLon_xyr       :: 格子データに発散型経度微分
  !                        1/rcosφ・∂/∂λを作用させる
  ! wr_DivLon_xvr       :: 格子データに発散型経度微分
  !                        1/rcosφ・∂/∂λを作用させる
  ! wr_DivLat_xyr       :: 格子データに発散型緯度微分
  !                        1/rcosφ・∂(g cosφ)/∂φを作用させる
  ! wr_DivLat_xvr       :: 格子データに発散型緯度微分
  !                        1/rcosφ・∂(g cosφ)/∂φを作用させる
  ! wr_Div_xyr_xyr_xyr  :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! xyr_Div_xyr_xyr_xyr :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! xyr_RotLon_wq_wq    :: ベクトル場の回転の経度成分を計算する
  ! xvr_RotLon_wq_wq    :: ベクトル場の回転の経度成分を計算する
  ! xyr_RotLat_wq_wq    :: ベクトル場の回転の緯度成分を計算する
  ! xvr_RotLat_wq_wq    :: ベクトル場の回転の緯度成分を計算する
  ! wr_RotRad_xyr_xyr   :: ベクトル場の回転の動径成分を計算する
  ! wr_RotRad_xvr_xvr   :: ベクトル場の回転の動径成分を計算する
  !
  !==== トロイダルポロイダル計算用微分
  !
  ! wq_KxRGrad_wq     :: スペクトルデータに経度微分
  !                      k×r・▽ = ∂/∂λを作用させる
  ! xyr_KGrad_wq      :: スペクトルデータに軸方向微分
  !                      k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r を作用させる
  ! xvr_KGrad_wq      :: スペクトルデータに軸方向微分
  !                      k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r を作用させる
  ! wq_L2_wq          :: スペクトルデータに L2 演算子 = -水平ラプラシアンを
  !                      作用させる
  ! wq_L2Inv_wq       :: スペクトルデータに L2 演算子の逆 = -逆水平ラプラシアン
  !                      を作用させる
  ! wq_QOperator_wq   :: スペクトルデータに演算子
  !                      Q=(k・▽-1/2(L2 k・▽+ k・▽L2)) を作用させる
  ! wq_QOperatorMPI_wq:: スペクトルデータに演算子
  !                      Q=(k・▽-1/2(L2 k・▽+ k・▽L2)) を作用させる
  ! wr_RadRot_xyr_xyr :: ベクトル v の渦度と動径ベクトル r の内積 r・(▽×v) を
  !                      計算する
  ! wr_RadRot_xvr_xvr :: ベクトル v の渦度と動径ベクトル r の内積 r・(▽×v) を
  !                      計算する
  ! wr_RadRotRot_xyr_xyr_xyr :: ベクトルの v の r・(▽×▽×v) を計算する
  ! wr_RadRotRot_xvr_xvr_xvr :: ベクトルの v の r・(▽×▽×v) を計算する
  ! wq_RadRotRot_xyr_xyr_xyr :: ベクトルの v の r・(▽×▽×v) を計算する
  ! wq_RadRotRot_xvr_xvr_xvr :: ベクトルの v の r・(▽×▽×v) を計算する
  ! wq_Potential2Vector      :: トロイダルポロイダルポテンシャルから
  !                             ベクトル場を計算する
  ! wq_Potential2VectorMPI   :: トロイダルポロイダルポテンシャルから
  !                             ベクトル場を計算する
  ! wq_Potential2Rotation    :: トロイダルポロイダルポテンシャルで表される
  !                             非発散ベクトル場の回転の各成分を計算する
  ! wq_Potential2RotationMPI :: トロイダルポロイダルポテンシャルで表される
  !                             非発散ベクトル場の回転の各成分を計算する
  !
  !==== ポロイダル/トロイダルモデル用スペクトル解析
  !
  ! nmr_ToroidalEnergySpectrum_wq, nr_ToroidalEnergySpectrum_wq  ::
  !     トロイダルポテンシャルからエネルギーの球面調和函数各成分を計算する
  ! nmr_PoloidalEnergySpectrum_wq, nr_PoloidalEnergySpectrum_wq  ::
  !     ポロイダルポテンシャルからエネルギーの球面調和函数各成分を計算する
  !
  !==== 境界値問題
  !
  ! wq_BoundaryTau, wr_BoundaryGrid, wq_Boundary                         ::
  !     ディリクレ, ノイマン境界条件を適用する(タウ法, 選点法)
  ! wq_TorBoundaryTau, wr_TorBoundaryGrid, wq_TorBoundary                ::
  !     速度トロイダルポテンシャルの境界条件を適用する(タウ法,選点法)       
  ! wq_LaplaPol2Pol_wq, wq_LaplaPol2PolTau_wq                            ::
  !     速度ポロイダルポテンシャルΦを▽^2Φから求める
  !     (入出力がそれぞれ格子点およびスペクトル係数)
  ! wq_TorMagBoundaryTau, wr_TorMagBoundaryGrid, wq_TorMagBoundary       ::
  !     磁場トロイダルポテンシャルの境界条件を適用する(タウ法, 選点法)
  ! wq_PolMagBoundaryTau, wr_PolMagBoundaryGrid, wq_PolMagBoundary       ::
  !     磁場トロイダルポテンシャル境界の境界条件を適用する(タウ法, 選点法)
  !
  !==== 積分・平均(3 次元データ)
  !
  ! IntLonLatRad_xyr, AvrLonLatRad_xyr :: 3 次元格子点データの
  !                                       全領域積分および平均
  ! IntLonLatRad_xvr, AvrLonLatRad_xvr :: 3 次元格子点データの
  !                                       全領域積分および平均
  ! r_IntLonLat_xyr, r_AvrLonLat_xyr   :: 3 次元格子点データの
  !                                       緯度経度(水平・球面)積分および平均
  ! r_IntLonLat_xvr, r_AvrLonLat_xvr   :: 3 次元格子点データの
  !                                       緯度経度(水平・球面)積分および平均
  ! y_IntLonRad_xyr, y_AvrLonRad_xyr   :: 3 次元格子点データの
  !                                       緯度動径積分および平均
  ! v_IntLonRad_xvr, v_AvrLonRad_xvr   :: 3 次元格子点データの
  !                                       緯度動径積分および平均
  ! x_IntLatRad_xyr,xr_AvrLatRad_xyr   :: 3 次元格子点データの
  !                                       経度動径(子午面)積分および平均
  ! x_IntLatRad_xvr,xr_AvrLatRad_xvr   :: 3 次元格子点データの
  !                                       経度動径(子午面)積分および平均
  ! yr_IntLon_xyr, yr_AvrLon_xyr       :: 3 次元格子点データの
  !                                       経度方向積分および平均
  ! vr_IntLon_xvr, vr_AvrLon_xvr       :: 3 次元格子点データの
  !                                       経度方向積分および平均
  ! xr_IntLat_xyr, xr_AvrLat_xyr       :: 3 次元格子点データの
  !                                       緯度方向積分および平均
  ! xr_IntLat_xvr, xr_AvrLat_xvr       :: 3 次元格子点データの
  !                                       緯度方向積分および平均
  ! xr_IntRad_xyr, xr_AvrRad_xyr       :: 3 次元格子点データの
  !                                       動径方向積分および平均
  ! xr_IntRad_xvr, xr_AvrRad_xvr       :: 3 次元格子点データの
  !                                       動径方向積分および平均
  !
  !==== 積分・平均(2 次元データ)
  !
  ! IntLonLat_xy, AvrLonLat_xy :: 2 次元格子点データの水平(球面)積分および平均
  ! IntLonLat_xv, AvrLonLat_xv :: 2 次元格子点データの水平(球面)積分および平均
  ! IntLonRad_xr, AvrLonRad_xr :: 2 次元(XZ)格子点データの経度動径積分
  !                               および平均
  ! IntLatRad_yr, AvrLatRad_yr :: 2 次元(YZ)格子点データの緯度動径(子午面)
  !                               積分および平均 
  ! IntLatRad_vr, AvrLatRad_vr :: 2 次元(YZ)格子点データの緯度動径(子午面)
  !                               積分および平均 
  ! y_IntLon_xy, y_AvrLon_xy   :: 水平 2 次元(球面)格子点データの経度方向
  !                               積分および平均
  ! v_IntLon_xv, v_AvrLon_xv   :: 水平 2 次元(球面)格子点データの経度方向
  !                               積分および平均
  ! x_IntLat_xy, x_AvrLat_xy   :: 水平2 次元(球面)格子点データの緯度方向積分
  !                               および平均
  ! x_IntLat_xv, x_AvrLat_xv   :: 水平2 次元(球面)格子点データの緯度方向積分
  !                               および平均
  ! r_IntLon_xr, r_AvrLon_xr   :: 2 次元(XZ)格子点データの経度方向積分および
  !                               平均
  ! x_IntRad_xr, x_AvrRad_xr   :: 2 次元(XZ)格子点データの動径方向積分および
  !                               平均
  ! r_IntLat_yr, r_AvrLat_yr   :: 2 次元(YZ)格子点データの緯度方向積分および
  !                               平均
  ! r_IntLat_vr, r_AvrLat_vr   :: 2 次元(YZ)格子点データの緯度方向積分および
  !                               平均
  ! y_IntRad_yr, y_AvrRad_yr   :: 2 次元(YZ)格子点データの動径方向積分および
  !                               平均                  
  ! v_IntRad_vr, v_AvrRad_vr   :: 2 次元(YZ)格子点データの動径方向積分および
  !                               平均                  
  !
  !==== 積分・平均(1 次元データ)
  !
  ! IntLon_x, AvrLon_x  :: 1 次元(X)格子点データの経度方向積分および平均
  ! IntLat_y, AvrLat_y  :: 1 次元(Y)格子点データの緯度方向積分および平均
  ! IntLat_v, AvrLat_v  :: 1 次元(Y)格子点データの緯度方向積分および平均
  ! IntRad_r, AvrRad_r  :: 1 次元(Z)格子点データの動径方向積分および平均
  !
  ! 
  use dc_message
  use lumatrix
  use w_base_mpi_module_sjpack
  use w_deriv_mpi_module_sjpack
  use w_integral_mpi_module_sjpack
  use wa_base_mpi_module_sjpack
  use wa_deriv_mpi_module_sjpack
  use wq_module_sjpack
  use wa_module_sjpack, only : wa_Lapla_wa
  use mpi
  implicit none
  integer :: ierr

  private

  public wq_mpi_Initial
  public jc

  public x_Lon, x_Lon_Weight
  public y_Lat, y_Lat_Weight
  public v_Lat, v_Lat_Weight
  public r_Rad, r_Rad_Weight
  public l_nm, nm_l
  public xy_Lon, xy_Lat
  public xv_Lon, xv_Lat
  public xyr_Lon, xyr_Lat, xyr_Rad
  public xvr_Lon, xvr_Lat, xvr_Rad
  public wr_Rad
  public wq_VMiss

  public w_xy, xy_w
  public w_xv, xv_w
  public wq_RadDRad_wq, q_RadDRad_q, wr_wq, wq_wr
  public wq_Rad2_wq, q_Rad2_q, wq_Rad2Inv_wq, q_Rad2Inv_q
  public xyr_wq, wq_xyr, xyr_wr, wr_xyr
  public xvr_wq, wq_xvr, xvr_wr, wr_xvr
  public wr_DivRad_wq, wr_RotDRad_wq, wr_RotDRad_wr, wq_Lapla_wq
  public wq_RotDRad_wr
  public xyr_GradLon_wq, xyr_GradLat_wq
  public xvr_GradLon_wq, xvr_GradLat_wq
  public wr_DivLon_xyr, wr_DivLat_xyr, wr_DivRad_xyr
  public wr_DivLon_xvr, wr_DivLat_xvr, wr_DivRad_xvr
  public wr_Div_xyr_xyr_xyr, xyr_Div_xyr_xyr_xyr
  public wr_Div_xvr_xvr_xvr, xvr_Div_xvr_xvr_xvr
  public xyr_RotLon_wq_wq, xyr_RotLat_wq_wq, wr_RotRad_xyr_xyr
  public xvr_RotLon_wq_wq, xvr_RotLat_wq_wq, wr_RotRad_xvr_xvr

  public yr_IntLon_xyr, xr_IntLat_xyr, xy_IntRad_xyr
  public vr_IntLon_xvr, xr_IntLat_xvr, xv_IntRad_xvr
  public x_IntLatRad_xyr, y_IntLonRad_xyr, r_IntLonLat_xyr
  public x_IntLatRad_xvr, v_IntLonRad_xvr, r_IntLonLat_xvr
  public IntLonLatRad_xyr
  public IntLonLatRad_xvr

  public x_IntLat_xy, y_IntLon_xy, IntLonLat_xy
  public x_IntLat_xv, v_IntLon_xv, IntLonLat_xv
  public r_IntLat_yr, y_IntRad_yr, IntLatRad_yr
  public r_IntLat_vr, v_IntRad_vr, IntLatRad_vr
  public r_IntLon_xr, x_IntRad_xr, IntLonRad_xr
  public IntLon_x, IntLat_y, IntRad_r
  public IntLat_v

  public yr_AvrLon_xyr, xr_AvrLat_xyr, xy_AvrRad_xyr
  public vr_AvrLon_xvr, xr_AvrLat_xvr, xv_AvrRad_xvr
  public x_AvrLatRad_xyr, y_AvrLonRad_xyr, r_AvrLonLat_xyr
  public x_AvrLatRad_xvr, v_AvrLonRad_xvr, r_AvrLonLat_xvr
  public AvrLonLatRad_xyr
  public AvrLonLatRad_xvr

  public x_AvrLat_xy, y_AvrLon_xy, AvrLonLat_xy
  public x_AvrLat_xv, v_AvrLon_xv, AvrLonLat_xv
  public r_AvrLat_yr, y_AvrRad_yr, AvrLatRad_yr
  public r_AvrLat_vr, v_AvrRad_vr, AvrLatRad_vr
  public r_AvrLon_xr, x_AvrRad_xr, AvrLonRad_xr
  public AvrLon_x, AvrLat_y, AvrRad_r
  public AvrLat_v

  public wq_KxRGrad_wq, xyr_KGrad_wq, wq_L2_wq, wq_L2Inv_wq, wq_QOperator_wq
  public xvr_KGrad_wq, wq_QOperatorMPI_wq
  public wr_RadRot_xyr_xyr, wr_RadRotRot_xyr_xyr_xyr
  public wr_RadRot_xvr_xvr, wr_RadRotRot_xvr_xvr_xvr
  public wq_RadRotRot_xyr_xyr_xyr
  public wq_RadRotRot_xvr_xvr_xvr
  public wq_Potential2vector, wq_Potential2Rotation
  public wq_Potential2vectorMPI, wq_Potential2RotationMPI

  public nmr_ToroidalEnergySpectrum_wq, nr_ToroidalEnergySpectrum_wq
  public nmr_PoloidalEnergySpectrum_wq, nr_PoloidalEnergySpectrum_wq

  public wq_Boundary, wq_TorBoundary, wq_LaplaPol2Pol_wq ! wr_LaplaPol2Pol_wr
  public wq_TormagBoundary, wq_PolmagBoundary

  public wq_BoundaryTau, wq_TorBoundaryTau, wq_LaplaPol2PolTau_wq
  public wq_TormagBoundaryTau, wq_PolmagBoundaryTau

  public wr_BoundaryGrid, wr_TorBoundaryGrid
  public wr_TormagBoundaryGrid, wr_PolmagBoundaryGrid

  integer            :: im=64, jm=32, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer            :: nm=21, lm=31         ! 切断波数の設定(水平, 動径)
  real(8)            :: ra=1.0               ! 球半径
  real(8), parameter :: pi=3.1415926535897932385D0

  real(8), dimension(:,:,:), allocatable :: xvr_LON, xvr_LAT, xvr_RAD ! 座標

  save im, jm, km, nm, lm, ra, xvr_Lon, xvr_Lat, xvr_Rad

  contains
  !--------------- 初期化 -----------------
   subroutine wq_mpi_Initial(i,j,k,n,l,r,np,wa_init)
     !
     ! スペクトル変換の格子点数, 波数, 動径座標の範囲を設定する.
     !
     ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
     ! しなければならない. 
     !
     ! np に 1 より大きな値を指定すれば ISPACK の球面調和函数変換 
     ! OPENMP 並列計算ルーチンが用いられる. 並列計算を実行するには, 
     ! 実行時に環境変数 OMP_NUM_THREADS を np 以下の数字に設定する等の
     ! システムに応じた準備が必要となる. 
     !
     ! np に 1 より大きな値を指定しなければ並列計算ルーチンは呼ばれない.
     !
     !
     integer,intent(in) :: i              ! 格子点数(経度λ)
     integer,intent(in) :: j              ! 格子点数(緯度φ)
     integer,intent(in) :: k              ! 格子点数(動径 r)
     integer,intent(in) :: n              ! 切断波数(水平全波数)
     integer,intent(in) :: l              ! 切断波数(動径波数)

     real(8),intent(in) :: r              ! 球半径

     integer,intent(in), optional :: np   ! OPENMP での最大スレッド数
     logical,intent(in), optional :: wa_init   ! wa_initial スイッチ

     logical    :: wa_initialize=.true.   ! wa_initial スイッチ

     im = i  ; jm = j ; km = k
     nm = n  ; lm = l
     ra = r

     if ( present(wa_init) ) then
        wa_initialize = wa_init
     else
        wa_initialize = .true.
     endif

     if ( present(np) ) then
        call wq_Initial(im,jm,km,nm,lm,ra,np,wa_initialize)
     else
        call wq_Initial(im,jm,km,nm,lm,ra,wa_init=wa_initialize)
     endif
     if ( wa_initialize ) then
        call w_base_mpi_Initial
        call w_deriv_mpi_Initial
        call wa_base_mpi_Initial
     endif

     allocate(xvr_Lon(0:im-1,jc,km))
     allocate(xvr_Lat(0:im-1,jc,km))
     allocate(xvr_Rad(0:im-1,jc,km))

     xvr_Lon = spread(xv_Lon,3,km)
     xvr_Lat = spread(xv_Lat,3,km)
     xvr_Rad = spread(spread(r_Rad,1,jc),1,im)

     call MessageNotify('M','wq_mpi_initial','wq_mpi_module_sjpack (2012/04/02) is initialized')

  end subroutine wq_mpi_Initial

  !--------------- 基本変換 -----------------

    function xvr_wq(wq)
      !
      ! スペクトルデータから 3 次元分散格子点データへ(逆)変換する.
      !
      real(8), dimension(0:im-1,1:jc,km)                       :: xvr_wq
      !(out) 3 次元経度緯度動径格子点データ

      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      xvr_wq = xva_wa(wr_wq(wq))

    end function xvr_wq

    function wq_xvr(xvr)
      !
      ! 3 次元格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm)             :: wq_xvr
      !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,1:jc,km), intent(in)           :: xvr
      !(in) 3 次元経度緯度動径格子点データ

      wq_xvr = wq_wr(wa_xva(xvr))

    end function wq_xvr

    function xvr_wr(wr)
      !
      ! 水平スペクトル・動径格子点データから 3 次元分散格子点データへ(逆)変換する.
      !
      real(8), dimension(0:im-1,1:jc,km)                     :: xvr_wr
      !(out) 3 次元経度緯度動径格子点データ

      real(8), dimension((nm+1)*(nm+1),km), intent(in) :: wr
      !(in) 2 次元球面調和函数スペクトル・動径格子点データ

      xvr_wr = xva_wa(wr)

    end function xvr_wr

    function wr_xvr(xvr)
      !
      ! 3 次元格子データから水平スペクトル・動径格子点データへ(正)変換する.
      !
      real(8), dimension((nm+1)*(nm+1),km)               :: wr_xvr
      !(out) 2 次元球面調和函数スペクトル・動径格子点データ

      real(8), dimension(0:im-1,1:jc,km), intent(in)         :: xvr
      !(in) 3 次元経度緯度動径格子点データ

      wr_xvr = wa_xva(xvr)

    end function wr_xvr

  !--------------- 微分計算 -----------------
    function wr_DivRad_xvr(xvr)
      ! 
      ! 格子点データに発散型動径微分
      !
      !       1/r^2 ∂/∂r (r^2  = ∂/∂r + 2/= 1/r∂/∂(r.) + 1/r
      !
      ! を作用する.
      !
      ! この関数の入力は動径次数と水平全波数の偶奇性が異なっていることを
      ! 仮定している. 偶奇性が一致している場合には wr_DigRad_wq を使用すること.
      !
      real(8), dimension(0:im-1,jc,km), intent(in) :: xvr
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension((nm+1)*(nm+1),km)             :: wr_DivRad_xvr
      !(out) 発散型動径微分を作用された水平スペクトル動径格子点データ

      wr_DivRad_xvr = wr_wq(wq_RadDRad_wq(wq_xvr(xvr_Rad*xvr)))/wr_Rad**2 &
                    + 1/wr_Rad * wr_xvr(xvr)

    end function wr_DivRad_xvr

    function xvr_GradLon_wq(wq)
      !
      ! スペクトルデータに勾配型経度微分 1/rcosφ・∂/∂λ
      ! を作用させる.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,1:jc,km)    :: xvr_GradLon_wq
      !(out) 勾配型経度微分を作用された 2 次元スペクトルデータ

      xvr_GradLon_wq = xva_GradLon_wa(wr_wq(wq))/xvr_Rad

    end function xvr_GradLon_wq

    function xvr_GradLat_wq(wq) 
      !
      ! スペクトルデータに勾配型経度微分 1/r ∂/∂φ を作用させる.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,1:jc,km)    :: xvr_GradLat_wq
      !(out) 勾配型緯度微分を作用された 2 次元スペクトルデータ

      xvr_GradLat_wq = xva_GradLat_wa(wr_wq(wq))/xvr_Rad

    end function xvr_GradLat_wq

    function wr_DivLon_xvr(xvr)
      ! 
      ! 格子点データに発散型経度微分 1/rcosφ・∂/∂λ を作用させた
      ! スペクトルデータを返す.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in)     :: xvr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension((nm+1)*(nm+1),km)         :: wr_DivLon_xvr
      !(out) 発散型経度微分を作用された水平スペクトル動径格子点データ

      wr_DivLon_xvr = wa_DivLon_xva(xvr/xvr_Rad)

    end function wr_DivLon_xvr

    function wr_DivLat_xvr(xvr)
      !
      ! 格子データに発散型緯度微分 1/rcosφ・∂(f cosφ)/∂φ を
      ! 作用させたスペクトルデータを返す.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in)     :: xvr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension((nm+1)*(nm+1),km)         :: wr_DivLat_xvr
      !(out) 発散型緯度微分を作用された水平スペクトル動径格子点データ

      wr_DivLat_xvr = wa_DivLat_xva(xvr/xvr_Rad)

    end function wr_DivLat_xvr

    function wr_Div_xvr_xvr_xvr(xvr_Vlon,xvr_Vlat,xvr_Vrad)
      !
      ! べクトル成分である 3 つの格子データに発散を作用させた
      ! スペクトルデータを返す.
      !
      ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分, 
      ! 動径成分を表し, 発散は 
      !
      !      1/rcosφ・∂u/∂λ + 1/rcosφ・∂(v cosφ)/∂φ 
      !    + 1/r^2 ∂/∂r (r^2 w)
      !
      ! と計算される.
      !
      ! 第3成分の動径次数と水平全波数の偶奇性がずれていることを仮定している.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension((nm+1)*(nm+1),km)     :: wr_Div_xvr_xvr_xvr
      !(out) ベクトル場の発散

      wr_Div_xvr_xvr_xvr =   wr_DivLon_xvr(xvr_Vlon) &
                           + wr_DivLat_xvr(xvr_Vlat) &
                           + wr_DivRad_xvr(xvr_Vrad)

    end function wr_Div_xvr_xvr_xvr

    function xvr_Div_xvr_xvr_xvr(xvr_Vlon,xvr_Vlat,xvr_Vrad)
      !
      ! ベクトル成分である 3 つの格子データに発散を作用させる.
      !
      ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分, 
      ! 動径成分を表す.
      !
      ! 極の特異性を回避するためにベクトル場に cosφ/r の重みをかけて
      ! 計算している. 
      !
      !      div V = (r/cosφ)・div (Vcosφ/r) + V_φtanφ/r + V_r/r
      ! 
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension(0:im-1,1:jc,km)             :: xvr_Div_xvr_xvr_xvr
      !(out) ベクトル場の発散

      xvr_Div_xvr_xvr_xvr &
           = xvr_Rad/cos(xvr_Lat) &
                * xvr_wr(wr_Div_xvr_xvr_xvr(xvr_VLon*cos(xvr_Lat)/xvr_Rad,  &
                                            xvr_VLat*cos(xvr_Lat)/xvr_Rad,  &
                                            xvr_VRad*cos(xvr_Lat)/xvr_Rad ))&
             + xvr_VLat*tan(xvr_Lat)/xvr_Rad &
             + xvr_VRad/xvr_Rad

    end function xvr_Div_xvr_xvr_xvr

    function xvr_RotLon_wq_wq(wq_Vrad,wq_Vlat) 
      !
      ! ベクトル場の動径成分, 緯度成分である第 1, 2 引数 Vrad, Vlat から
      ! 回転の経度成分 
      !
      !    1/r ∂Vrad/∂φ-1/r ∂(r Vlat)/∂r を計算する.
      !
      ! を計算する
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jc,km)                 :: xvr_RotLon_wq_wq
      !(out) ベクトル場の回転の経度成分

      xvr_RotLon_wq_wq =   xvr_GradLat_wq(wq_Vrad) &
                         - xvr_wr(wr_RotDRad_wq(wq_Vlat))

    end function xvr_RotLon_wq_wq

    function xvr_RotLat_wq_wq(wq_Vlon,wq_Vrad) 
      !
      ! ベクトル場の経度成分, 動径成分である第 1, 2 引数 Vlon, Vrad から
      ! 回転の緯度成分 
      !
      !    1/r ∂(r Vlon)/∂r - 1/rcosφ・∂Vrad/∂λ
      !
      ! を計算する.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension(0:im-1,1:jc,km)                 :: xvr_RotLat_wq_wq
      !(out) ベクトル場の回転の緯度成分

      xvr_RotLat_wq_wq =   xvr_wr(wr_RotDRad_wq(wq_Vlon)) &
                         - xvr_GradLon_wq(wq_Vrad) 

    end function xvr_RotLat_wq_wq

    function wr_RotRad_xvr_xvr(xvr_Vlat,xvr_Vlon) 
      !
      ! ベクトルの緯度成分, 経度成分である第 1, 2 引数 Vlat, Vlon に対して
      ! ベクトル場の回転の動径成分 
      !
      !    1/rcosφ・∂Vlat/∂λ - 1/rcosφ・∂(Vlon cosφ)/∂φ
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension((nm+1)*(nm+1),km)       :: wr_RotRad_xvr_xvr
      !(out) ベクトル場の回転の動径成分

      wr_RotRad_xvr_xvr =   wr_DivLon_xvr(xvr_Vlat) &
                          - wr_DivLat_xvr(xvr_Vlon)

    end function wr_RotRad_xvr_xvr

  !--------------- 積分計算 -----------------
    !----(入力データ xvr)---
    function vr_IntLon_xvr(xvr)  ! 経度(帯状)積分
      !
      ! 3 次元格子点データの経度方向(帯状)積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)dλ を計算する.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jc,km)  :: vr_IntLon_xvr
      !(out) 経度方向(帯状)積分された 2 次元子午面格子点データ

      integer :: i

      vr_IntLon_xvr = 0.0d0
      do i=0,im-1
         vr_IntLon_xvr(:,:) = vr_IntLon_xvr(:,:) &
                       + xvr(i,:,:) * x_Lon_Weight(i)
      enddo
    end function vr_IntLon_xvr

    function xr_IntLat_xvr(xvr)
      !
      ! 3 次元格子点データの緯度方向域積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) cosφ dφ を計算する.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,km)  :: xr_IntLat_xvr   
      !(out) 緯度積分された 2 次元緯度動径格子点データ
      ! 緯度円格子点データ

      real(8), dimension(0:im-1,km)  :: xr_IntLatTMP
      integer :: j

      xr_IntLat_xvr = 0.0d0
      do j=1,jc
         xr_IntLat_xvr(:,:) = xr_IntLat_xvr(:,:) &
                       + xvr(:,j,:) * v_Lat_Weight(j)
      enddo
      xr_IntLatTmp=xr_IntLat_xvr
      CALL MPI_ALLREDUCE(xr_IntLatTMP,xr_IntLat_xvr,im*km,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function xr_IntLat_xvr

    function xv_IntRad_xvr(xvr)  ! 動径積分
      !
      ! 3 次元格子点データの動径方向域積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) r^2dr を計算する.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,1:jc)  :: xv_IntRad_xvr
      !(out) 動径積分された 2 次元経度緯度(水平, 球面)格子点データ

      integer :: k

      xv_IntRad_xvr = 0.0d0
      do k=1,km
         xv_IntRad_xvr(:,:) = xv_IntRad_xvr(:,:) &
                       + xvr(:,:,k) * r_Rad_Weight(k) 
      enddo

    end function xv_IntRad_xvr

    function x_IntLatRad_xvr(xvr)
      !
      ! 3 次元格子点データの緯度動径(子午面)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) r^2cosφ dφdr 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1)     :: x_IntLatRad_xvr
      !(out) 緯度動径(子午面)積分された 1 次元経度格子点データ

      real(8), dimension(0:im-1)     :: x_IntLatRadTMP
      integer :: j, k

      x_IntLatRad_xvr = 0.0D0
      do k=1,km
         do j=1,jc
            x_IntLatRad_xvr = x_IntLatRad_xvr &
                 + xvr(:,j,k) * v_Lat_Weight(j) * r_Rad_Weight(k)
         enddo
      enddo

      x_IntLatRadTmp=x_IntLatRad_xvr
      CALL MPI_ALLREDUCE(x_IntLatRadTMP,x_IntLatRad_xvr,im,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function x_IntLatRad_xvr

    function v_IntLonRad_xvr(xvr)
      !
      ! 3 次元格子点データの経度動径(緯度円)積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) r^2dλdr を計算する.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jc)       :: v_IntLonRad_xvr
      !(out) 経度動径(緯度円)積分された 1 次元緯度格子点データ

      integer :: i, k

      v_IntLonRad_xvr = 0.0D0
      do k=1,km
         do i=0,im-1
            v_IntLonRad_xvr = v_IntLonRad_xvr &
                 + xvr(i,:,k) * x_Lon_Weight(i) * r_Rad_Weight(k)
         enddo
      enddo

    end function v_IntLonRad_xvr

    function r_IntLonLat_xvr(xvr)  ! 緯度経度(水平)積分
      !
      ! 3 次元格子点データの緯度経度(水平, 球面)積分
      ! 
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) cosφ dλdφ 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(km)     :: r_IntLonLat_xvr
      !(out) 緯度経度(水平, 球面)積分された 1 次元動径格子点データ

      real(8), dimension(km)     :: r_IntLonLatTMP
      integer :: i, j

      r_IntLonLat_xvr = 0.0D0
      do j=1,jc
         do i=0,im-1
            r_IntLonLat_xvr = r_IntLonLat_xvr &
                 + xvr(i,j,:) * x_Lon_Weight(i) * v_Lat_Weight(j)
         enddo
      enddo

      r_IntLonLatTmp=r_IntLonLat_xvr
      CALL MPI_ALLREDUCE(r_IntLonLatTMP,r_IntLonLat_xvr,km,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function r_IntLonLat_xvr

    function IntLonLatRad_xvr(xvr) ! 緯度経度動径(全球)積分
      !
      ! 3 次元格子点データの緯度経度動径(全球)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !     ∫f(λ,φ,r) r^2cosφ dλdφdr 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr 
      !(in) 3 次元経度緯度動径格子点データ

      real(8)                     :: IntLonLatRad_xvr 
      !(out) 全球積分値

      real(8)                     :: IntLonLatRadTMP
      integer :: i, j, k

      IntLonLatRad_xvr = 0.0D0
      do k=1,km
         do j=1,jc
            do i=0,im-1
               IntLonLatRad_xvr = IntLonLatRad_xvr &
                    + xvr(i,j,k) * x_Lon_Weight(i) &
                         * v_Lat_Weight(j) * r_Rad_Weight(k)
            enddo
         enddo
      enddo

      IntLonLatRadTmp=IntLonLatRad_xvr
      CALL MPI_ALLREDUCE(IntLonLatRadTMP,IntLonLatRad_xvr,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function IntLonLatRad_xvr

    !----(入力データ vr)---
    function r_IntLat_vr(vr)  ! 緯度積分
      !
      ! 2 次元(VR)格子点データの緯度方向域積分.
      !
      ! 2 次元データ f(φ,r) に対して∫f(φ,r) cosφ dφ を計算する.
      !
      real(8), dimension(1:jc,km), intent(in) :: vr
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(km)  :: r_IntLat_vr
      !(out) 緯度積分された 1 次元動径格子点データ

      real(8), dimension(km)  :: r_IntLatTMP
      integer :: j

      r_IntLat_vr = 0.0d0
      do j=1,jc
         r_IntLat_vr(:) = r_IntLat_vr(:) + vr(j,:) * v_Lat_Weight(j)
      enddo
      r_IntLatTmp=r_IntLat_vr
      CALL MPI_ALLREDUCE(r_IntLatTMP,r_IntLat_vr,km,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function r_IntLat_vr

    function v_IntRad_vr(vr)  ! 動径積分
      !
      ! 2 次元(VR)格子点データの動径方向域積分.
      !
      ! 2 次元データ f(φ,r) に対して∫f(φ,r) r^2dr を計算する.
      !
      real(8), dimension(1:jc,km), intent(in) :: vr
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(1:jc)  :: v_IntRad_vr
      !(out) 動径積分された 1 次元緯度格子点データ

      integer :: k

      v_IntRad_vr = 0.0d0
      do k=1,km
         v_IntRad_vr(:) = v_IntRad_vr(:) &
                       + vr(:,k) * r_Rad_Weight(k) 
      enddo

    end function v_IntRad_vr

    function IntLatRad_vr(vr)
      !
      ! 2 次元(VR)格子点データの緯度動径積分(子午面)および平均
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) r^2cosφ dφdr を計算する.
      !
      real(8), dimension(1:jc,km), intent(in) :: vr
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8)                   :: IntLatRad_vr
      !(out) 積分値

      real(8)                   :: IntLatRadTMP
      integer :: j, k

      IntLatRad_vr = 0.0D0
      do k=1,km
         do j=1,jc
            IntLatRad_vr = IntLatRad_vr &
                 + vr(j,k) * v_Lat_Weight(j) * r_Rad_Weight(k)
         enddo
      enddo

      IntLatRadTmp=IntLatRad_vr
      CALL MPI_ALLREDUCE(IntLatRadTMP,IntLatRad_vr,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function IntLatRad_vr

  !--------------- 平均計算 -----------------
    !----(入力データ xvr)---
    function vr_AvrLon_xvr(xvr)  ! 経度(帯状)積分
      !
      ! 3 次元格子点データの経度方向(帯状)平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)dλ/2π を計算する.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jc,km)  :: vr_AvrLon_xvr
      !(out) 経度方向(帯状)平均された 2 次元子午面格子点データ

      vr_AvrLon_xvr = vr_IntLon_xvr(xvr)/sum(x_Lon_Weight)

    end function vr_AvrLon_xvr

    function xr_AvrLat_xvr(xvr)  ! 緯度積分
      !
      ! 3 次元格子点データの緯度方向域平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)cosφ dφ/2 を計算する.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,km)  :: xr_AvrLat_xvr
      !(out) 緯度平均された 2 次元緯度動径格子点データ

      xr_AvrLat_xvr = xr_IntLat_xvr(xvr)/sum(y_Lat_Weight)

    end function xr_AvrLat_xvr

    function xv_AvrRad_xvr(xvr)
      !
      ! 3 次元格子点データの動径方向域平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して 
      !
      !    ∫f(λ,φ,r) r^2dr/((r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,1:jc)  :: xv_AvrRad_xvr
      !(out) 動径平均された 2 次元経度緯度(水平, 球面)格子点データ
      ! 水平格子点データ

      xv_AvrRad_xvr = xv_IntRad_xvr(xvr)/sum(r_Rad_Weight)

    end function xv_AvrRad_xvr

    function x_AvrLatRad_xvr(xvr)  ! 緯度動径(子午面)積分
      !
      ! 3 次元格子点データの緯度動径(子午面)平均
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,,r) r^2cosφ dφdr /(2(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1)     :: x_AvrLatRad_xvr
      !(out) 緯度動径(子午面)平均された 1 次元経度格子点データ

      x_AvrLatRad_xvr = x_IntLatRad_xvr(xvr) &
                   /( sum(y_Lat_Weight)*sum(r_Rad_Weight) )

    end function x_AvrLatRad_xvr

    function v_AvrLonRad_xvr(xvr)  ! 経度動径(緯度円)積分
      !
      ! 3 次元格子点データの経度動径(緯度円)平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !     ∫f(λ,φ,r) r^2dλdr /(2π(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jc)       :: v_AvrLonRad_xvr
      !(out) 経度動径(緯度円)平均された 1 次元緯度格子点データ

      v_AvrLonRad_xvr = v_IntLonRad_xvr(xvr) &
                 /(sum(x_Lon_Weight)*sum(r_Rad_Weight))

    end function v_AvrLonRad_xvr

    function r_AvrLonLat_xvr(xvr)  ! 緯度経度(水平)積分
      !
      ! 3 次元格子点データの緯度経度(水平, 球面)積分
      ! 
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) cosφ dλdφ /4π 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(km)     :: r_AvrLonLat_xvr
      !(out) 緯度経度(水平, 球面)平均された 1 次元動径格子点データ

      r_AvrLonLat_xvr = r_IntLonLat_xvr(xvr) &
                 /(sum(x_Lon_Weight)*sum(y_Lat_Weight))

    end function r_AvrLonLat_xvr

    function AvrLonLatRad_xvr(xvr) ! 緯度経度動径(全球)積分
      !
      ! 3 次元格子点データの緯度経度動径(全球)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) r^2cosφ dλdφdr /(4π(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr
      !(in) 3 次元経度緯度動径格子点データ

      real(8)                     :: AvrLonLatRad_xvr
      !(out) 全球平均値

      AvrLonLatRad_xvr = IntLonLatRad_xvr(xvr) &
            /(sum(x_Lon_Weight)*sum(y_Lat_Weight) * sum(r_Rad_Weight))

    end function AvrLonLatRad_xvr

    !----(入力データ vr)---
    function r_AvrLat_vr(vr)
      !
      ! 2 次元(VR)格子点データの緯度方向域平均.
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) cosφ dφ/2 を計算する.
      !
      real(8), dimension(1:jc,km), intent(in) :: vr
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(km)  :: r_AvrLat_vr
      !(out) 緯度平均された 1 次元動径格子点データ

      r_AvrLat_vr = r_IntLat_vr(vr)/sum(y_Lat_Weight)

    end function r_AvrLat_vr

    function v_AvrRad_vr(vr)
      !
      ! 2 次元(VR)格子点データの動径方向域平均.
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) r^2dr /((r[o]^3-r[i]^3)/3) 
      ! を計算する.
      !
      real(8), dimension(1:jc,km), intent(in) :: vr
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(1:jc)  :: v_AvrRad_vr
      !(out) 動径平均された 1 次元緯度格子点データ

      v_AvrRad_vr = v_IntRad_vr(vr)/sum(r_Rad_Weight)

    end function v_AvrRad_vr

    function AvrLatRad_vr(vr)  ! 緯度動径(子午面)積分
      !
      ! 2 次元(VR)格子点データの緯度動径(子午面)平均
      !
      ! 2 次元データ f(φ,r) に対して
      !
      !    ∫f(φ,r) r^2cosφ dφdr /(2(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(1:jc,km), intent(in) :: vr
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8)                   :: AvrLatRad_vr
      !(out) 平均値

      AvrLatRad_vr = IntLatRad_vr(vr)/(sum(y_Lat_Weight)*sum(r_Rad_Weight))

    end function AvrLatRad_vr

  !--------------- ポロイダル/トロイダルモデル用微分 -----------------

    function xvr_KGrad_wq(wq)    ! k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r
      !
      ! 入力スペクトルデータに対応する格子データに軸方向微分 
      !
      !    k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r 
      !
      ! を作用させた格子データが返される. 
      ! ここでベクトル k は球の中心から北極向きの単位ベクトルである.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,1:jc,km)                 :: xvr_KGrad_wq
      !(out) 軸方向微分を作用された 2 次元スペクトルデータ

      xvr_KGrad_wq =  cos(xvr_Lat)*xvr_GradLat_wq(wq) &
                    + sin(xvr_Lat)*xvr_wq(wq_RadDRad_wq(wq))/xvr_Rad

    end function xvr_KGrad_wq

    function wq_QOperatorMPI_wq(wq)
      !
      ! 入力スペクトルデータに対応する格子点データに演算子
      !
      !    Q=(k・▽-1/2(L2 k・▽+ k・▽L2))
      !
      ! を作用させたデータのスペクトル変換が返される.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension((nm+1)*(nm+1),0:lm)             :: wq_QOperatorMPI_wq
      !(out) Q 演算子を作用された 2 次元スペクトルデータ

      wq_QOperatorMPI_wq = &
             wq_xvr(xvr_KGrad_wq(wq) - xvr_KGrad_wq(wq_L2_wq(wq))/2) &
           - wq_L2_wq(wq_xvr(xvr_KGrad_wq(wq)))/2

    end function wq_QOperatorMPI_wq

    function wr_RadRot_xvr_xvr(xvr_VLON,xvr_VLAT)  ! r・(▽×v)
      !
      ! ベクトルの渦度と動径ベクトルの内積 r・(▽×v) を計算する.
      !
      ! 第 1, 2 引数(v[λ], v[φ])がそれぞれベクトルの経度成分, 緯度成分を表す.
      !
      !    r・(▽×v) = 1/cosφ・∂v[φ]/∂λ - 1/cosφ・∂(v[λ] cosφ)/∂φ
      !
      ! のスペクトル データが返される.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr_VLON
      !(in) ベクトルの経度成分

      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr_VLAT
      !(in) ベクトルの緯度成分

      real(8), dimension((nm+1)*(nm+1),km)     :: wr_RadRot_xvr_xvr
      !(out) ベクトルの渦度と動径ベクトルの内積

      wr_RadRot_xvr_xvr = wa_DivLon_xva(xvr_VLAT) - wa_DivLat_xva(xvr_VLON)
      
    end function wr_RadRot_xvr_xvr

    function wr_RadRotRot_xvr_xvr_xvr(xvr_VLON,xvr_VLAT,xvr_VRAD) 
      ! 
      ! ベクトル v に対して r・(▽×▽×v) を計算する.
      !
      ! 第 1, 2, 3 引数(v[λ], v[φ], v[r])がそれぞれベクトルの経度成分, 
      ! 緯度成分, 動径成分を表す. 
      !
      !    r・(▽×▽×v)  = 1/r ∂/∂r (r・( 1/cosφ・∂v[λ]/∂λ 
      !                                  + 1/cosφ・∂(v[φ] cosφ)/∂φ ) ) 
      !                     + L^2 v[r]/r 
      !
      ! のスペクトルデータが返される.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr_VLON
      !(in) ベクトルの経度成分

      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr_VLAT
      !(in) ベクトルの緯度成分

      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr_VRAD
      !(in) ベクトルの動径成分

      real(8), dimension((nm+1)*(nm+1),km)     :: wr_RadRotRot_xvr_xvr_xvr
      !(out) ベクトル v の r・(▽×▽×v) 

      wr_RadRotRot_xvr_xvr_xvr = &
                   wr_RotDRad_wr( &
                      wa_DivLon_xva(xvr_VLON)+ wa_DivLat_xva(xvr_VLAT)) &
             - wa_Lapla_wa(wr_xvr(xvr_VRAD/xvr_RAD))

    end function wr_RadRotRot_xvr_xvr_xvr

    function wq_RadRotRot_xvr_xvr_xvr(xvr_VLON,xvr_VLAT,xvr_VRAD) 
      ! 
      ! ベクトル v に対して r・(▽×▽×v) を計算する.
      !
      ! 第 1, 2, 3 引数(v[λ], v[φ], v[r])がそれぞれベクトルの経度成分, 
      ! 緯度成分, 動径成分を表す. 
      !
      !    r・(▽×▽×v)  = 1/r ∂/∂r (r・( 1/cosφ・∂v[λ]/∂λ 
      !                                  + 1/cosφ・∂(v[φ] cosφ)/∂φ ) ) 
      !                     + L^2 v[r]/r 
      !
      ! のスペクトルデータが返される.
      !
      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr_VLON
      !(in) ベクトルの経度成分

      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr_VLAT
      !(in) ベクトルの緯度成分

      real(8), dimension(0:im-1,1:jc,km), intent(in) :: xvr_VRAD
      !(in) ベクトルの動径成分

      real(8), dimension((nm+1)*(nm+1),0:lm)     :: wq_RadRotRot_xvr_xvr_xvr
      !(out) ベクトル v の r・(▽×▽×v) 

      wq_RadRotRot_xvr_xvr_xvr = &
                   wq_RotDRad_wr( &
                      wa_DivLon_xva(xvr_VLON)+ wa_DivLat_xva(xvr_VLAT)) &
             - wa_Lapla_wa(wq_xvr(xvr_VRAD/xvr_RAD))

    end function wq_RadRotRot_xvr_xvr_xvr

    subroutine wq_Potential2VectorMPI(&
         xvr_VLON,xvr_VLAT,xvr_VRAD,wq_TORPOT,wq_POLPOT)
      !
      ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
      !
      !     v = ▽x(Ψr) + ▽x▽x(Φr) 
      !
      ! の各成分を計算する
      !
      real(8), dimension(0:im-1,1:jc,km)     :: xvr_VLON
      !(out) ベクトル場の経度成分

      real(8), dimension(0:im-1,1:jc,km)     :: xvr_VLAT
      !(out) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jc,km)     :: xvr_VRAD
      !(out) ベクトル場の動径成分

      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_POLPOT
      !(in) ポロイダルポテンシャル

      xvr_VLON =   xvr_RAD * xvr_GradLat_wq(wq_TORPOT) &
                 + xva_GradLon_wa(wr_RotDRad_wq(wq_POLPOT))
      xvr_VLAT = - xvr_RAD * xvr_GradLon_wq(wq_TORPOT) &
                 + xva_GradLat_wa(wr_RotDRad_wq(wq_POLPOT))
      xvr_VRAD = xvr_wq(wq_L2_wq(wq_POLPOT))/xvr_RAD

    end subroutine wq_Potential2VectorMPI

    subroutine wq_Potential2RotationMPI(&
       xvr_RotVLON,xvr_RotVLAT,xvr_RotVRAD,wq_TORPOT,wq_POLPOT)
      !
      ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
      !
      !     v = ▽x(Ψr) + ▽x▽x(Φr) 
      !
      ! に対して, その回転
      !
      !     ▽xv = ▽x▽x(Ψr) + ▽x▽x▽x(Φr) = ▽x▽x(Ψr) - ▽x((▽^2Φ)r)
      !
      ! を計算する. 
      
      ! ベクトル場の回転
      real(8), dimension(0:im-1,1:jc,km), intent(OUT) :: xvr_RotVLON
      !(out) 回転の経度成分

      real(8), dimension(0:im-1,1:jc,km), intent(OUT) :: xvr_RotVLAT
      !(out) 回転の緯度成分

      real(8), dimension(0:im-1,1:jc,km), intent(OUT) :: xvr_RotVRAD
      !(out) 回転の動径成分

      ! 入力ベクトル場を表すポテンシャル
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_POLPOT
      !(in) ポロイダルポテンシャル

      call wq_Potential2VectorMPI( &
           xvr_RotVLON,xvr_RotVLAT,xvr_RotVRAD, &
           -wq_Lapla_wq(wq_POLPOT), wq_TORPOT)

    end subroutine wq_Potential2RotationMPI

end module wq_mpi_module_sjpack

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  l_module テストプログラム :: 積分・平均関数のテスト
!
!履歴  2009/09/22  竹広真一
!
program l_module_integral_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use l_module
  implicit none

  integer, parameter :: jm=16, nm=10

  real(8), dimension(1:jm)        ::  y_idata            ! 積分・平均の正解
  real(8)                         ::  idata              ! 積分・平均の正解
  real(8) :: pi

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','l_module_integral_test', &
                         'l_module tests of integral/average functions') 

  call l_Initial( nm, jm )

  !---- 積分のテスト ----
  y_idata = pi*sin(y_Lat)
  idata   = 0.0D0                   ! IntLat_y

  call AssertEqual(&
    message='Test of IntLat_y for an odd function',               &
    answer = idata,                                               &
    check = IntLat_y(y_idata),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_idata = pi*sin(y_Lat)**2      
  idata   = 2*pi/3                  ! IntLat_y

  call AssertEqual(&
    message='Test of IntLat_y for an even function',              &
    answer = idata,                                               &
    check = IntLat_y(y_idata),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 平均のテスト ----
  y_idata = 0.5*sin(y_Lat)
  idata   = 0.0D0                   ! AvrLat_y

  call AssertEqual(&
    message='Test of AvrLat_y for an odd function',               &
    answer = idata,                                               &
    check = AvrLat_y(y_idata),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_idata = 0.5*sin(y_Lat)**2
  idata   = 1.0D0/6                 ! AvrLat_y

  call AssertEqual(&
    message='Test of AvrLat_y for an even function',              &
    answer = idata,                                               &
    check = AvrLat_y(y_idata),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','l_module_integral_test', &
       'l_module tests of integral/average functions succeeded') 

end program l_module_integral_test

!----------------------------------------------------------------------
!     Copyright (c) 2012 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_spectrum_module テストプログラム :: スペクトル解析関数のテスト
!
!履歴  2012/03/31  竹広真一   w_mpi_spectrum_module_test.f90 を改造
!
program w_spectrum_mpi_module_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_mpi_module
  use mpi
  implicit none

  integer, parameter :: im=32, jm=16, nm=10


  real(8), dimension((nm+1)**2)   ::  w_data
  real(8), dimension(0:im-1,1:jm) ::  xy_data

  real(8), dimension(0:nm,-nm:nm) ::  nm_data
  real(8), dimension(0:nm)        ::  n_data
  real(8)                         ::  data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer :: n,m
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call w_mpi_Initial( nm, im, jm )

  call MessageNotify('M','w_spectrum_mpi_module_test',&
                         'w_spectrum_module tests') 

  !================= 2Y_1^0+3Y_2^1 のテスト ================
  xy_data = 2*sqrt(3.0D0)*sin(xy_Lat) &        ! 2Y_1^0+3Y_2^1
       + 3*sqrt(2*5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)! 
  w_data = w_xy(xy_data)

  !--------- Energy spectrum ---------
  nm_data=w_spectrum_VMiss
  do n=0,nm
     do m=-n,n
        nm_data(n,m) = 0.0
     enddo
  enddo
  nm_data(1,0) = 4.0D0 ;   nm_data(2,1) = 27.0D0
  call AssertEqual(&
    message='nm_EnergyFromStreamfunc_w with 2Y_1^0+3Y_2^1 ',      &
    answer = nm_data,                                             &
    check = nm_EnergyFromStreamfunc_w(w_data),                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  n_data = 0.0; n_data(1) = 4.0D0 ;   n_data(2) = 27.0D0
  call AssertEqual(&
    message='n_EnergyFromStreamfunc_w with 2Y_1^0+3Y_2^1 ',       &
    answer = n_data,                                              &
    check = n_EnergyFromStreamfunc_w(w_data),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nm_Data = nm_EnergyFromStreamfunc_w(w_data)
  data = 0.0D0
  do n=0,nm
     do m=-n,n
        data = data + nm_Data(n,m)
     enddo
  enddo

  call AssertEqual(&
    message='total energy by nm-spectrum with 2Y_1^0+3Y_2^1 ',    &
    answer = AvrLonLat_xy( &
         0.5*(xy_GradLon_w(w_data)**2+xy_GradLat_w(w_data)**2) ), &
    check = data,                                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  data = AvrLonLat_xy( 0.5*(xy_GradLon_w(w_data)**2+xy_GradLat_w(w_data)**2) )
  call AssertEqual(&
    message='total energy by n-spectrum with 2Y_1^0+3Y_2^1 ',     &
    answer = data,                                                &
    check = sum(n_EnergyFromStreamfunc_w(w_data)),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !--------- Enstrophy spectrum ---------
  nm_data=w_spectrum_VMiss
  do n=0,nm
     do m=-n,n
        nm_data(n,m) = 0.0
     enddo
  enddo
  nm_data(1,0) = 8.0D0 ;   nm_data(2,1) = 162.0D0
  call AssertEqual(&
    message='nm_EnstrophyFromStreamfunc_w with 2Y_1^0+3Y_2^1 ',   &
    answer = nm_data,                                             &
    check = nm_EnstrophyFromStreamfunc_w(w_data),                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  n_data = 0.0; n_data(1) = 8.0D0 ;   n_data(2) = 162.0D0
  call AssertEqual(&
    message='n_EnstrophyFromStreamfunc_w with 2Y_1^0+3Y_2^1 ',    &
    answer = n_data,                                              &
    check = n_EnstrophyFromStreamfunc_w(w_data),                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nm_Data = nm_EnstrophyFromStreamfunc_w(w_data)
  data = 0.0D0
  do n=0,nm
     do m=-n,n
        data = data + nm_Data(n,m)
     enddo
  enddo

  call AssertEqual(&
    message='total enstrophy by nm-spectrum with 2Y_1^0+3Y_2^1 ', &
    answer =  AvrLonLat_xy( 0.5*(xy_w(w_Lapla_w(w_data))**2)),    &
    check = data,                                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  data = AvrLonLat_xy( 0.5*(xy_w(w_Lapla_w(w_data))**2))
  call AssertEqual(&
    message='total enstrophy by n-spectrum with 2Y_1^0+3Y_2^1 ',  &
    answer = data,                                                &
    check = sum(n_EnstrophyFromStreamfunc_w(w_data)),             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !======== 3*Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2 のテスト ========
  xy_data = 3*sqrt(3.0D0)*sin(xy_Lat) &        ! 2Y_1^0+3Y_2^1
          + 2* sqrt(2*3.0D0/2)*cos(xy_Lat)*cos(xy_Lon) &
          + 2*sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0) &
          - sqrt(2*5.0D0/24)*3.0*cos(xy_Lat)**2*sin(2*xy_Lon)
  w_data = w_xy(xy_data)

  !--------- Energy spectrum ---------
  nm_data=w_spectrum_VMiss
  do n=0,nm
     do m=-n,n
        nm_data(n,m) = 0.0
     enddo
  enddo
  nm_data(1,0) = 9.0D0 ; nm_data(1,1)  = 4.0D0
  nm_data(2,0) = 12.0D0 ; nm_data(2,-2) = 3.0D0
  call AssertEqual(&
    message='nm_EnergyFromStreamfunc_w with 3Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2',&
    answer = nm_data,                                             &
    check = nm_EnergyFromStreamfunc_w(w_data),                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  n_data = 0.0
  n_data = 0.0; n_data(1) = 13.0D0 ;   n_data(2) = 15.0D0
  call AssertEqual(&
    message='n_EnergyFromStreamfunc_w with 3Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2', &
    answer = n_data,                                              &
    check = n_EnergyFromStreamfunc_w(w_data),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nm_Data = nm_EnergyFromStreamfunc_w(w_data)
  data = 0.0D0
  do n=0,nm
     do m=-n,n
        data = data + nm_Data(n,m)
     enddo
  enddo

  call AssertEqual(&
    message='total energy by nm-spectrum with 3Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2', &
    answer = AvrLonLat_xy( &
         0.5*(xy_GradLon_w(w_data)**2+xy_GradLat_w(w_data)**2) ), &
    check = data,                                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  data = AvrLonLat_xy( 0.5*(xy_GradLon_w(w_data)**2+xy_GradLat_w(w_data)**2) )
  call AssertEqual(&
    message='total energy by n-spectrum with 3Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2', &
    answer = data,                                                &
    check = sum(n_EnergyFromStreamfunc_w(w_data)),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !--------- Enstrophy spectrum ---------
  nm_data=w_spectrum_VMiss
  do n=0,nm
     do m=-n,n
        nm_data(n,m) = 0.0
     enddo
  enddo
  nm_data(1,0) = 18.0D0 ; nm_data(1,1)  = 8.0D0
  nm_data(2,0) = 72.0D0 ; nm_data(2,-2) = 18.0D0
  call AssertEqual(&
    message='nm_EnstrophyFromStreamfunc_w with 3Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2', &
    answer = nm_data,                                             &
    check = nm_EnstrophyFromStreamfunc_w(w_data),                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  n_data = 0.0
  n_data = 0.0; n_data(1) = 26.0D0 ;   n_data(2) = 90.0D0
  call AssertEqual(&
    message='n_EnstrophyFromStreamfunc_w with 3Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2', &
    answer = n_data,                                              &
    check = n_EnstrophyFromStreamfunc_w(w_data),                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nm_Data = nm_EnstrophyFromStreamfunc_w(w_data)
  data = 0.0D0
  do n=0,nm
     do m=-n,n
        data = data + nm_Data(n,m)
     enddo
  enddo

  call AssertEqual(&
    message='total enstrophy by nm-spectrum with 3Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2',&
    answer =  AvrLonLat_xy( 0.5*(xy_w(w_Lapla_w(w_data))**2)),    &
    check = data,                                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  data = AvrLonLat_xy( 0.5*(xy_w(w_Lapla_w(w_data))**2))
  call AssertEqual(&
    message='total enstrophy by n-spectrum with 3Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2',&
    answer = data,                                                &
    check = sum(n_EnstrophyFromStreamfunc_w(w_data)),             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  call MessageNotify('M','w_spectrum_mpi_module_test', &
                         'w_spectrum_module tests succeeded!') 

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)      

end program w_spectrum_mpi_module_test

!----------------------------------------------------------------------
! Copyright (c) 2016 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  w_base_mpi_module_supack
!
!  spml/w_base_mpi_module_supack モジュールは球面上での 2 次元流体運動を
!  球面調和函数を用いたスペクトル法と MPI によって数値計算するための 
!  モジュール w_mpi_module_supack の下部モジュールであり, スペクトル計算の
!  基本的な Fortran90 関数を提供する. 
!
!  内部で ISPACK2 の SUPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK2/SUPACK のマニュアルを参照されたい.
!
!
!履歴  2016/03/13  竹広真一  w_base_mpi_module_sjpack を supack 化
!      2017/06/01  竹広真一  作業配列大きさ修正
!
module w_base_mpi_module_supack
  !
  ! w_base_mpi_module_supack
  !
  !  spml/w_base_mpi_module_supack モジュールは球面上での 2 次元流体運動を
  !  球面調和函数を用いたスペクトル法と MPI によって数値計算するための 
  !  モジュール w_mpi_module_supack の下部モジュールであり, スペクトル法の
  !  基本的なな Fortran90 関数を提供する. 
  !
  !  内部で ISPACK2 の SUPACK の Fortran77 サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK2/SUPACK のマニュアルを参照されたい.
  !
  use dc_message
  use mpi
  
  implicit none

  integer               :: im=64            ! 格子点の設定(東西)
  integer               :: jm=32            ! 格子点の設定(南北)
  integer               :: nm=21            ! 計算する最大の全波数の設定
  integer               :: nn=22            ! 切断波数(全波数)の設定
  integer               :: mm=21            ! 切断波数(東西波数)の設定

  integer, allocatable  :: it(:)            ! 変換用配列
  real(8), allocatable  :: t(:)             ! 変換用配列
  real(8), allocatable  :: p(:,:), r(:)     ! 変換用配列
  integer, allocatable  :: jc(:)            ! 作業配列
  real(8), allocatable  :: wp(:)            ! 変換用作業配列

  real(8), allocatable  :: c(:)             ! 作業配列

  integer               :: j1, j2           ! 分散配置用変数
  integer               :: jl               ! 分散格子データの大きさ
  integer               :: nc               ! 分散スペクトルデータの大きさ

  integer, parameter    :: jv=1             ! ベクトル長

  integer               :: np               ! MPI プロセス数
  integer               :: ip               ! MPI プロセス番号
  
  real(8), allocatable  :: x_Lon(:), x_Lon_Weight(:)     ! 経度
  real(8), allocatable  :: v_Lat(:), v_Lat_Weight(:)     ! 緯度
  real(8), allocatable  :: xv_Lon(:,:), xv_Lat(:,:)

  logical               :: w_base_initialize=.false.   ! 初期化フラッグ

  real(8), parameter    :: pi=3.1415926535897932385D0
  
  private

  public im, jm, nn, mm, nm                   ! 格子点数, 切断波数
  public it, t, p, r, jc                      ! 変換用作業配列
  public j1, j2                               ! 分散格子データの大きさ
  public jl                                   ! 分散スペクトルデータの大きさ
  public nc
  public np, ip
  
  public w_base_mpi_Initial                   ! 初期化サブルーチン
  public w_base_mpi_Finalize                  ! 終了サブルーチン

  public x_Lon                                ! 格子座標
  public x_Lon_Weight                         ! 格子座標重み
  public v_Lat                                ! 格子座標
  public v_Lat_Weight                         ! 格子座標重み
  public xv_Lon, xv_Lat                       ! 格子座標(im,jm)
  public l_nm, nm_l                           ! 波数格納位置
  public xv_w, w_xv                           ! 変換関数
  public w_StreamPotential2VectorMPI          ! 流線ポテンシャルから速度場計算
  public w_Vector2VorDivMPI                   ! 速度場から渦度発散を計算
  public w_VectorCosLat2VorDivMPI             ! 速度場から渦度発散を計算

  interface l_nm
     module procedure l_nm_array00
     module procedure l_nm_array01
     module procedure l_nm_array10
     module procedure l_nm_array11
  end interface

  interface nm_l
     module procedure nm_l_int
     module procedure nm_l_array
  end interface

  save im, jm, nm, mm, nn                     ! 格子点数, 切断波数を記憶
  save it, t, p, r, jc                        ! 変換用配列を記憶
  save j1, j2
  save jl, nc
  save np, ip
  save c                                      ! 変換用配列

  contains
  !--------------- 初期化 -----------------
    subroutine w_base_mpi_Initial(n_in,i_in,j_in)
      !
      ! スペクトル変換の格子点数, 波数および OPENMP 使用時の
      ! 最大スレッド数を設定する.
      !
      ! 実際の使用には上位サブルーチン w_Initial を用いること.
      !
      integer,intent(in) :: i_in              !(in) 格子点数(東西), 2の巾乗(<=2048)
      integer,intent(in) :: j_in              !(in) 格子点数(南北), 4 の倍数
      integer,intent(in) :: n_in              !(in) 切断全波数

      integer :: i, j
      integer :: ierr

      im = i_in   ; jm = j_in
      nn = n_in   ; nm = n_in+1 ;  mm = n_in      ! default は三角波数切断

      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)

      allocate(it(im/2))                                ! 変換用配列
      allocate(t(im))                                   ! 変換用配列
      allocate(p(jm/2,2*(mm/np+1)+5))                   ! 変換用配列
      allocate(r(5*(mm/np+1)*(2*nm-mm/np*np)/4))        ! 変換用配列
      allocate(jc(5*(mm/np+1)*(2*nm-mm/np*np+8)/8))     ! 変換用配列
      allocate(wp(jm/2*mm))                             ! 変換用作業配列

      allocate(c((mm/np+1)*(2*(mm+1)-mm/np*np)))        ! 変換用作業配列

      call suinit(mm,nm,im,jm,it,t,p,r,jc,wp)
      call suinic(mm,c)
      
      call suqrnj(jm,jv,j1,j2)

      jl = j2-j1+1                              ! 分散格子データの大きさ
      nc = (mm/np+1)*(2*(nn+1)-mm/np*np)        ! 分散スペクトルデータの大きさ

      allocate(x_Lon(0:im-1))                   ! 格子点座標格納配列(経度)
      allocate(x_Lon_Weight(0:im-1))
      allocate(v_Lat(jl),v_Lat_Weight(jl))            ! 格子点座標格納配列
      allocate(xv_Lon(0:im-1,jl),xv_Lat(0:im-1,jl))   ! 格子点座標格納配列

      do i=0,im-1
         x_Lon(i)  = 2*pi/im*i               ! 経度座標
         x_Lon_Weight(i) = 2*pi/im           ! 経度座標重み
      enddo

      do j=j1,j2
         if ( j .gt. jm/2 ) then
            v_Lat(j-j1+1)         =  asin(p(j-jm/2,1)) ! 緯度座標
            v_Lat_Weight(j-j1+1)  = 2*p(j-jm/2,2)      ! 緯度重み(Gauss grid)
         else
            v_Lat(j-j1+1)         =  -asin(p(jm/2-j+1,1)) ! 緯度座標
            v_Lat_Weight(j-j1+1)  = 2*p(jm/2-j+1,2)       ! 緯度重み(Gauss grid)
         endif
      enddo

      do j=1,jl
         xv_Lon(:,j) = x_Lon
      enddo

      do i=0,im-1
         xv_Lat(i,:) = v_Lat
      enddo

      w_base_initialize = .true.

      call MessageNotify('M','w_base_mpi_initial',&
           'w_base_mpi_module_supack (2017/06/01) for FORT is initialized')

    end subroutine w_base_mpi_Initial

  !--------------- 基本関数 -----------------

    function l_nm_array00(n,m)
      !
      ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 引数 n,m がともに整数値の場合, 整数値を返す.
      ! プロセスに n,m が存在しない場合 0 を返す
      !
      integer               :: l_nm_array00   
      !(out) スペクトルデータの格納位置 

      integer, intent(in)   :: n     !(in) 全波数
      integer, intent(in)   :: m     !(in) 帯状波数

      integer :: ip_w

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','l_nm_array00',&
              'w_base_mpi_module_supack not initialize yet. Use sunm2l routine in ISPACK2 directly.')
      else
         call sunm2l(nn,n,m,ip_w,l_nm_array00)
         if ( ip_w /= ip ) l_nm_array00 = 0
      endif

    end function l_nm_array00

    function l_nm_array01(n,marray)           ! スペクトルデータの格納位置 
      !
      ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 第 1 引数 n が整数, 第 2 引数 marray が整数 1 次元配列の場合, 
      ! marray と同じ大きさの 1 次元整数配列を返す. 
      !
      integer, intent(in)  :: n               !(in) 全波数
      integer, intent(in)  :: marray(:)       !(in) 帯状波数
      integer              :: l_nm_array01(size(marray))
      !(out) スペクトルデータ位置

      integer              :: i 

      do i=1, size(marray)
         l_nm_array01(i) = l_nm_array00(n,marray(i))
      enddo
    end function l_nm_array01

    function l_nm_array10(narray,m)
      !
      ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 第 1 引数 narray が整数 1 次元配列, 第 2 引数  m が整数の場合, 
      ! narray と同じ大きさの 1 次元整数配列を返す. 
      !
      integer, intent(in)  :: narray(:)           !(in) 全波数  
      integer, intent(in)  :: m                   !(in) 帯状波数
      integer              :: l_nm_array10(size(narray))
      !(out) スペクトルデータ位置

      integer              :: i 

      do i=1, size(narray)
         l_nm_array10(i) = l_nm_array00(narray(i),m)
      enddo
    end function l_nm_array10

    function l_nm_array11(narray,marray)
      !
      ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 第 1,2 引数 narray, marray がともに整数 1 次元配列の場合, 
      ! narray, marray と同じ大きさの 1 次元整数配列を返す. 
      ! narray, marray は同じ大きさでなければならない. 
      !
      integer, intent(in)  :: narray(:)          !(in) 全波数  
      integer, intent(in)  :: marray(:)          !(in) 帯状波数
      integer              :: l_nm_array11(size(narray))
      !(out) スペクトルデータ位置

      integer              :: i 

      if ( size(narray) .ne. size(marray) ) then
         call MessageNotify('E','l_nm_array11',&
              'dimensions of input arrays  n and m are different.')
      endif

      do i=1, size(narray)
         l_nm_array11(i) = l_nm_array00(narray(i),marray(i))
      enddo
    end function l_nm_array11

    function nm_l_int(l)
      ! 
      ! スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
      !
      ! 引数 l が整数値の場合, 対応する全波数と帯状波数を
      ! 長さ 2 の 1 次元整数値を返す. 
      ! nm_l(1) が全波数, nm_l(2) が帯状波数である. 
      !
      integer               :: nm_l_int(2)  !(out) 全波数, 帯状波数
      integer, intent(in)   :: l            !(in) スペクトルデータの格納位置
      
      if ( .not. w_base_initialize ) then
         call MessageNotify('E','nm_l_int',&
              'w_base_mpi_module_supack not initialize yet. Use sul2nm routine in ISPACK2 directly.')
      else
         call sul2nm(mm,nn,l,nm_l_int(1),nm_l_int(2))
      endif

    end function nm_l_int

    function nm_l_array(larray)
      ! 
      ! スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
      !
      ! 引数 larray が整数 1 次元配列の場合, 
      ! larray に対応する n, m を格納した 2 次元整数配列を返す. 
      ! nm_l_array(:,1) が全波数, nm_l_array(:,2) が帯状波数である. 
      !
      integer, intent(in)  :: larray(:)
      !(out) 全波数, 帯状波数

      integer              :: nm_l_array(size(larray),2)
      !(in) スペクトルデータの格納位置

      integer              :: i

      do i=1, size(larray)
         nm_l_array(i,:) = nm_l_int(larray(i))
      enddo
    end function nm_l_array

    !--------------- 基本変換(格子点分散配置) -----------------

    function xv_w(w_data,ipow,iflag)
      !
      ! スペクトルデータから格子データへ変換する(1 層用).
      !
      real(8)               :: xv_w(0:im-1,1:jl)
      !(out) 格子点データ

      real(8), intent(in)   :: w_data(nc)

      !(in) スペクトルデータ

      integer, intent(in), optional  :: ipow      
      !(in) 作用させる 1/cosφ の次数. 省略時は 0. 

      integer, intent(in), optional  :: iflag
      !(in) 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた逆変換
      !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
      !    2 : sinφを作用させた逆変換
      !    省略時は 0.
      !
      integer, parameter  :: ipow_default  = 0
      integer, parameter  :: iflag_default = 0

      integer ipval, ifval

      real(8)             :: w_Xdata((mm/np+1)*(2*(mm+1)-mm/np*np))
      ! 作業用スペクトルデータ(SUCS2X 出力用)
      real(8)             :: w_Ydata((mm/np+1)*(2*(mm+2)-mm/np*np))
      ! 作業用スペクトルデータ(SUCS2Y 出力用)

      real(8)  :: ws((nm+1)*2,mm/np+1)           ! 変換用作業配列
      real(8)  :: w(4*2*jv*((jm/jv-1)/np+1)*((im/2-1)/np+1)*np)
      
      if ( .not. w_base_initialize ) then
         call MessageNotify('E','xv_w',&
              'w_base_mpi_module_supack not initialize yet.')
      endif

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      if ( ifval==0 ) then
         call suts2g(mm,nm,nn,im,jm,jv,w_data,xv_w,it,t,p,r,jc,ws,w,ipval)
      else if( ifval==-1 ) then
         call sucs2x(mm,w_data,w_Xdata)
         call suts2g(mm,nm,nn,im,jm,jv,w_Xdata,xv_w,it,t,p,r,jc,ws,w,ipval)
      else if( ifval==1 ) then
         call sucs2y(mm,w_data,w_Ydata,c)
         call suts2g(mm,nm,nm,im,jm,jv,w_Ydata,xv_w,it,t,p,r,jc,ws,w,ipval)
      else if( ifval==2 ) then
         call suts2g(mm,nm,nn,im,jm,jv,w_data,xv_w,it,t,p,r,jc,ws,w,ipval)
         xv_w = xv_w * sin(xv_Lat)
      else
         call MessageNotify('E','xv_w','invalid value of iflag')
      endif

    end function xv_w

    function w_xv(xv_data,ipow,iflag)
      !
      ! 格子データからスペクトルデータへ(正)変換する(1 層用).
      !
      real(8)               :: w_xv(nc)
      !(out) スペクトルデータ

      real(8), intent(in)   :: xv_data(0:im-1,1:jl)
      !(in) 格子点データ

      integer, intent(in), optional  :: ipow
      !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

      integer, intent(in), optional  :: iflag
      ! 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた正変換 
      !    1 : 緯度微分 1/cosφ・∂(f cos^2φ)/∂φ を作用させた正変換
      !    2 : sinφを作用させた正変換
      !  省略時は 0.


      integer, parameter  :: ipow_default  = 0    ! スイッチデフォルト値
      integer, parameter  :: iflag_default = 0    ! スイッチデフォルト値

      integer ipval, ifval

      real(8)             :: w_Xdata((mm/np+1)*(2*(mm+1)-mm/np*np))
      ! 作業用スペクトルデータ(SUCS2X 出力用)
      real(8)             :: w_Ydata((mm/np+1)*(2*(mm+2)-mm/np*np))
      ! 作業用スペクトルデータ(SUCS2Y 出力用)

      real(8)  :: ws((nm+1)*2,mm/np+1)            ! 変換用作業配列
      real(8)  :: w(4*2*jv*((jm/jv-1)/np+1)*((im/2-1)/np+1)*np)
      
      if ( .not. w_base_initialize ) then
         call MessageNotify('E','xv_w',&
              'w_base_mpi_module_supack not initialize yet.')
      endif

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif
      
      if ( ifval == 0 ) then
         call sutg2s(mm,nm,nn,im,jm,jv,w_xv,xv_data,it,t,p,r,jc,ws,w,ipval)
      else if ( ifval == -1 ) then
         call sutg2s(mm,nm,nn,im,jm,jv,w_Xdata,xv_data,it,t,p,r,jc,ws,w,ipval)
         call sucs2x(mm,w_Xdata,w_xv)
      else if ( ifval == 1 ) then
         call sutg2s(mm,nm,nm,im,jm,jv,w_Ydata,xv_data,it,t,p,r,jc,ws,w,ipval)
         call sucy2s(mm,w_Ydata,w_xv,c)
      else if ( ifval == 2 ) then
         call sutg2s(mm,nm,nn,im,jm,jv,w_xv,xv_data*sin(xv_Lat),it,t,p,r,jc,ws,w,ipval)
      end if

    end function w_xv

  !----------- 速度, 渦度・発散, 流線・ポテンシャル計算 -------------

    subroutine w_StreamPotential2VectorMPI(w_Psi, w_Chi, xv_U, xv_V)
      !
      ! 流線・ポテンシャル(スペクトルデータ)から速度場(格子データ)に
      ! (逆)変換する(1 層用, MPI)
      !
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   u cosφ =      ∂χ/∂λ - cosφ∂ψ/∂φ, 
      !   v cosφ = cosφ∂χ/∂φ +      ∂ψ/∂λ 
      !
      real(8), intent(in)   :: w_Psi(nc)
      !(in) 流線関数
      real(8), intent(in)   :: w_Chi(nc)
      !(in) 速度ポテンシャル

      real(8), intent(out)   :: xv_U(0:im-1,1:jl)
      !(out) 速度経度成分
      real(8), intent(out)   :: xv_V(0:im-1,1:jl)
      !(out) 速度緯度成分

      real(8)  :: ws((nm+1)*2,mm/np+1)            ! 変換用作業配列
      real(8)  :: w(4*2*jv*((jm/jv-1)/np+1)*((im/2-1)/np+1)*np)

      real(8)             :: w_Rdata((mm/np+1)*(2*(mm+2)-mm/np*np))
      ! 作業用スペクトルデータ(SUTS2G 出力用)
      real(8)             :: w_Xdata((mm/np+1)*(2*(mm+1)-mm/np*np))
      ! 作業用スペクトルデータ(SUCS2X 出力用)
      real(8)             :: w_Ydata((mm/np+1)*(2*(mm+2)-mm/np*np))
      ! 作業用スペクトルデータ(SUCS2Y 出力用)

      
      if ( .not. w_base_initialize ) then
         call MessageNotify('E','w_StreamPotential2VectorMPI',&
              'w_base_module not initialize yet.')
      endif
      !
      !   u cosφ = ∂χ/∂λ - cosφ∂ψ/∂φ の計算
      !
      call sucs2x(mm,w_Chi,w_Xdata)
      call sucs2y(mm,w_Psi,w_Ydata,c)
      call sucrup(mm,nm,w_Xdata,w_Rdata)
      w_Rdata = w_Rdata - w_Ydata
      !
      !   u の計算
      !
      call suts2g(mm,nm,nm,im,jm,jv,w_Rdata,xv_U,it,t,p,r,jc,ws,w,1)
      !
      !   v cosφ = cosφ∂χ/∂φ + ∂ψ/∂λ の計算
      !
      call sucs2y(mm,w_Chi,w_Ydata,c)
      call sucs2x(mm,w_Psi,w_Xdata)
      call sucrup(mm,nm,w_Xdata,w_Rdata)
      w_Rdata= w_Rdata + w_Ydata
      !
      !   v の計算
      !
      call suts2g(mm,nm,nm,im,jm,jv,w_Rdata,xv_V,it,t,p,r,jc,ws,w,1)

    end subroutine w_StreamPotential2VectorMPI

    subroutine w_Vector2VorDivMPI(xv_U, xv_V, w_Vor, w_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(1 層用, MPI)
      ! 
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xv_U(0:im-1,1:jl)
      !(in) 速度経度成分
      real(8), intent(in)   :: xv_V(0:im-1,1:jl)
      !(in) 速度緯度成分

      real(8), intent(out)   :: w_Vor(nc)
      !(out) 流線関数
      real(8), intent(out)   :: w_Div(nc)
      !(out) 速度ポテンシャル

      real(8)  :: ws((nm+1)*2,mm/np+1)            ! 変換用作業配列
      real(8)  :: w(4*2*jv*((jm/jv-1)/np+1)*((im/2-1)/np+1)*np)

      real(8)             :: w_Xdata((mm/np+1)*(2*(mm+1)-mm/np*np))
      ! 作業用スペクトルデータ(SUCS2X 出力用)
      real(8)             :: w_Ydata((mm/np+1)*(2*(mm+2)-mm/np*np))
      ! 作業用スペクトルデータ(SUCS2Y 出力用)

      real(8)  :: w_Data1((mm/np+1)*(2*(mm+1)-mm/np*np))
      real(8)  :: w_Data2((mm/np+1)*(2*(mm+1)-mm/np*np))

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','w_Vector2VorDivMPI',&
              'w_base_module not initialize yet.')
      endif
      !
      ! 1/cosφ∂u/∂λ, 1/cosφ ∂(u cosφ)/∂φ の計算
      !
      call sutg2s(mm,nm,nm,im,jm,jv,w_Ydata,xv_U,it,t,p,r,jc,ws,w,1)
      call sucrdn(mm,nm,w_Ydata,w_Xdata)
      call sucs2x(mm,w_Xdata,w_Div)
      call sucy2s(mm,w_Ydata,w_Data1,c)
      !
      ! 1/cosφ∂v/∂λ, 1/cosφ ∂(v cosφ)/∂φ の計算
      !
      call sutg2s(mm,nm,nm,im,jm,jv,w_Ydata,xv_V,it,t,p,r,jc,ws,w,1)
      call sucrdn(mm,nm,w_Ydata,w_Xdata)
      call sucs2x(mm,w_Xdata,w_Vor)
      call sucy2s(mm,w_Ydata,w_Data2,c)
      !
      !  渦度・発散の計算
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      w_Vor = w_Vor - w_Data1
      w_Div = w_Div + w_Data2

    end subroutine w_Vector2VorDivMPI

    subroutine w_VectorCosLat2VorDivMPI(xv_UCosLat, xv_VCosLat, w_Vor, w_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(1 層用, MPI)
      ! 
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xv_UCosLat(0:im-1,1:jl)
      !(in) 速度経度成分 * cos(lat)
      real(8), intent(in)   :: xv_VCosLat(0:im-1,1:jl)
      !(in) 速度緯度成分 * cos(lat)

      real(8), intent(out)   :: w_Vor(nc)
      !(out) 流線関数
      real(8), intent(out)   :: w_Div(nc)
      !(out) 速度ポテンシャル

      real(8)  :: ws((nm+1)*2,mm/np+1)            ! 変換用作業配列
      real(8)  :: w(4*2*jv*((jm/jv-1)/np+1)*((im/2-1)/np+1)*np)

      real(8)             :: w_Xdata((mm/np+1)*(2*(mm+1)-mm/np*np))
      ! 作業用スペクトルデータ(SUCS2X 出力用)
      real(8)             :: w_Ydata((mm/np+1)*(2*(mm+2)-mm/np*np))
      ! 作業用スペクトルデータ(SUCS2Y 出力用)

      real(8)  :: w_Data1((mm/np+1)*(2*(mm+1)-mm/np*np))
      real(8)  :: w_Data2((mm/np+1)*(2*(mm+1)-mm/np*np))

      if ( .not. w_base_initialize ) then
         call MessageNotify('E','w_VectorCosLat2VorDivMPI',&
              'w_base_module not initialize yet.')
      endif
      !
      ! 1/cosφ∂u/∂λ, 1/cosφ ∂(u cosφ)/∂φ の計算
      !
      call sutg2s(mm,nm,nm,im,jm,jv,w_Ydata,xv_UCosLat,it,t,p,r,jc,ws,w,2)
      call sucrdn(mm,nm,w_Ydata,w_Xdata)
      call sucs2x(mm,w_Xdata,w_Div)
      call sucy2s(mm,w_Ydata,w_Data1,c)
      !
      ! 1/cosφ∂v/∂λ, 1/cosφ ∂(v cosφ)/∂φ の計算
      !
      call sutg2s(mm,nm,nm,im,jm,jv,w_Ydata,xv_VCosLat,it,t,p,r,jc,ws,w,2)
      call sucrdn(mm,nm,w_Ydata,w_Xdata)
      call sucs2x(mm,w_Xdata,w_Vor)
      call sucy2s(mm,w_Ydata,w_Data2,c)
      !
      !  渦度・発散の計算
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      w_Vor = w_Vor - w_Data1
      w_Div = w_Div + w_Data2

    end subroutine w_VectorCosLat2VorDivMPI

  !--------------- 終了処理 -----------------
    subroutine w_base_mpi_Finalize
      !
      ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
      !
      ! 実際の使用には上位サブルーチン w_Finalize を用いること.
      !
      if ( .not. w_base_initialize ) then
         call MessageNotify('W','w_base_mpi_Finalize',&
              'w_base_mpi_module_supack not initialized yet')
         return
      endif

      deallocate(it)                 ! 変換用配列
      deallocate(t)                  ! 変換用配列
      deallocate(p)                  ! 変換用配列
      deallocate(r)                  ! 変換用配列
      deallocate(jc)                 ! 変換用作業配列

      deallocate(wp)                 ! 変換用作業配列

      deallocate(c)                  ! 変換用作業配列

      deallocate(x_Lon)              ! 格子点座標格納配列(経度)
      deallocate(x_Lon_Weight)
      deallocate(xv_Lon)
      deallocate(v_Lat)
      deallocate(v_Lat_Weight)       ! 格子点座標格納配列
      deallocate(xv_Lat)             ! 格子点座標格納配列

      w_base_initialize = .false.

      call MessageNotify('M','w_base_mpi_Finalize',&
           'w_base_mpi_module_supack (2016/03/13) for FORT is finalized')

    end subroutine w_base_mpi_Finalize

end module w_base_mpi_module_supack

!--
!----------------------------------------------------------------------
! Copyright (c) 2017 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  l_module_svpack
!
!   spml/l_module_svpack モジュールは球面上での経度方向に一様な帯状的 
!   1 次元流体運動をルジャンドル多項式を用いたスペクトル法によって
!   数値計算するための Fortran90 関数を提供する. 
!
!   内部で ISPACK の SVPACK の Fortran77 サブルーチンを呼んでいる.
!   スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!   ついては ISPACK/SVPACK のマニュアルを参照されたい.
!
!   関数, サブルーチンの名前と機能は l_module のものと同じに設計してある. 
!   したがって use 文を l_module から l_module_svpack に変更するだけで 
!   SVPACK の機能が使えるようになる. 
!
!履歴  2017/03/06  竹広真一  l_module_sjpack を元に SVPACK 用に改造
!
!++
module l_module_svpack
  !
  != l_module_svpack
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !   spml/l_module_svpack モジュールは球面上での経度方向に一様な帯状的 
  !   1 次元流体運動をルジャンドル多項式を用いたスペクトル法によって
  !   数値計算するための Fortran90 関数を提供する. 
  !
  !   内部で ISPACK の SVPACK の Fortran77 サブルーチンを呼んでいる.
  !   スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !   ついては ISPACK/SVPACK のマニュアルを参照されたい.
  !
  !   関数, サブルーチンの名前と機能は l_module のものと同じに設計してある. 
  !   したがって use 文を l_module から l_module_svpack に変更するだけで 
  !   SVPACK の機能が使えるようになる. 
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (l_, y_) は, 返す値の形を示している.
  !   l_ :: スペクトル(ルジャンドル多項式成分)データ
  !   y_ :: 1 次元緯度格子点データ
  !
  ! * 関数名の間の文字列(GradLat, DivLat, Lapla, LaplaInv)は, 
  !   その関数の作用を表している.
  !
  ! * 関数名の最後 (_l, _y) は, 入力変数の形スペクトルデータ
  !   および格子点データであることを示している.
  !   _l :: スペクト(ルジャンドル多項式成分)ルデータ
  !   _y :: 緯度方向 1 次元格子点データ
  !
  !=== 各データの種類の説明
  !
  ! * p : スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(0:nn). 
  !   * nn はルジャンドル多項式の最大次数であり, サブルーチン l_Initial にて
  !     あらかじめ設定しておく. 
  !
  ! * y : 緯度方向 1 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(1:jm).
  !
  ! * l_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * y_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! l_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! 
  !==== 終了処理 
  !
  ! l_Finalize :: モジュールの終了処理(割り付け配列の解放)をおこなう. 
  ! 
  !==== 座標変数
  !
  ! y_Lat        ::  格子点座標(緯度, 経度座標)を格納した 1 次元配列
  ! y_Lat_Weight ::  重み座標を格納した 1 次元配列
  !
  !==== 基本変換
  !
  ! y_l :: スペクトルデータから格子データへの変換
  ! l_y :: 格子データからスペクトルデータへの変換
  !
  !==== 微分
  !
  ! l_Lapla_l       :: スペクトルデータにラプラシアンを作用させる
  ! l_LaplaInv_l    :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! y_GradLat_l     :: スペクトルデータに勾配型緯度微分∂/∂φを作用させる
  ! l_DivLat_y      :: 格子データに発散型緯度微分
  !                    1 /cosφ・∂(g cosφ)/∂φを作用させる
  !
  !==== 微分(λ,μ=sinφ 座標)
  !
  ! y_GradMu_l     :: スペクトルデータに
  !                   勾配型緯度微分 (1-μ^2)∂/∂μを作用させる
  ! l_DivMu_y      :: 格子データに発散型緯度微分∂/∂μを作用させる
  !
  !==== 補間
  !
  ! Interpolate_l  :: スペクトルデータから任意の点での値を求める. 
  !
  !==== 積分・平均
  !
  ! IntLat_y, AvrLat_y :: 1 次元(Y)格子点データの緯度方向積分および平均
  !
  !==== スペクトル解析
  !
  ! 作成中
  !
  use dc_message, only : MessageNotify
  use iso_c_binding
  implicit none

  private

  public l_Initial                            ! 初期化
  public l_Finalize                           ! 終了処理

  public y_Lat                                ! 格子座標
  public y_Lat_Weight                         ! 格子座標重み

  public y_l, l_y                             ! 変換関数
  public l_Lapla_l, l_LaplaInv_l              ! ラプラシアンと逆演算
  public y_GradLat_l                          ! 勾配型微分
  public l_DivLat_y                           ! 発散型微分

  public y_GradMu_l                           ! 勾配型微分
  public l_DivMu_y                            ! 発散型微分

  public IntLat_y, AvrLat_y                   ! 緯度平均

  public Interpolate_l                        ! 補間計算

  integer               :: jm=32            ! 格子点の設定(南北)
  integer               :: nm=21            ! 計算する最大の全波数の設定
  integer               :: nn=22            ! 切断波数(全波数)の設定
  integer               :: mm=0             ! 切断波数(東西波数)の設定

  real(8), allocatable  :: p(:,:), r(:)     ! 変換用配列
  integer, allocatable  :: jc(:)            ! 変換用配列
  real(8), allocatable  :: c(:)             ! 変換用配列

  real(8), allocatable  :: y_Lat(:)         ! 緯度経度
  real(8), allocatable  :: y_Lat_Weight(:)  ! 座標重み

  real(8), pointer      :: y_pdata(:),q(:)
  type(C_PTR)           :: pg, pq
  
  logical               :: l_initialize = .false.  ! 初期化フラグ

  save jm, nm, nn, mm, p, r, c, y_Lat, y_Lat_Weight, y_pdata, q, l_initialize

contains

  !--------------- 初期化 -----------------
    subroutine l_initial(n_in,j_in)
      !
      ! スペクトル変換の格子点数, 波数を設定する.
      !
      ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
      ! しなければならない. 
      !
      integer,intent(in) :: j_in              !(in) 格子点数(南北)
      integer,intent(in) :: n_in              !(in) 切断波数の設定

      integer :: j

      real(8), allocatable :: wp(:)           ! 作業領域

      jm = j_in ; nn = n_in ; nm = n_in+1 ; mm = 0

      allocate(p(jm/2,5+2*mm))                ! 変換用配列
      allocate(r(((mm+1)*(2*nm-mm-1)+1)/4*3+(2*nm-mm)*(mm+1)/2)) ! 変換用配列
      allocate(jc(mm*(2*nm-mm-1)/8+mm))       ! 微分用配列
      allocate(c((nn+1)*(nn+1)))              ! 変換用配列

      allocate(wp(jm/2*mm))                     ! 作業領域
      
      allocate(y_Lat(jm),y_Lat_Weight(jm))      ! 座標変数配列

      call mlallc(pg,jm)
      call mlallc(pq,jm/2*5)
      call c_f_pointer(pg, y_pdata, [JM])
      call c_f_pointer(pq, q, [jm/2*5])

      call lvinit(mm,nm,jm,p,r,jc,wp)
      call svinic(nn,c)

      deallocate(wp)                            ! 作業領域

      do j=1,jm/2
         y_Lat(jm/2+j)   =  asin(p(j,1))        ! 緯度座標
         y_Lat(jm/2-j+1) = -asin(p(j,1))        ! 緯度座標
         y_Lat_Weight(jm/2+j)   = 2*p(j,2)      ! 緯度重み(Gauss grid)
         y_Lat_Weight(jm/2-j+1) = 2*p(j,2)      ! 緯度重み(Gauss grid)
      enddo

      l_initialize = .true.

      call MessageNotify(&
        'M','l_initial','l_module_svpack (2017/03/06) for AVX is initialized')

    end subroutine l_initial

  !--------------- 基本変換 -----------------
    function y_l(l_data)
      !
      ! スペクトルデータから格子データへ変換する(1 層用).
      !
      real(8)               :: y_l(1:jm)
      !(out) 格子点データ

      real(8), intent(in)   :: l_data(0:nn)
      !(in) スペクトルデータ

      real(8)  :: ws(nn+1)                 ! 変換用作業配列

      call lvtszg(nm,nn,jm,l_data,y_pdata,p,q,r,ws,0)
      y_l = y_pdata
      
    end function y_l

    function l_y(y_data)
      !
      ! スペクトルデータから格子データへ変換する(1 層用).
      !
      real(8)               :: l_y(0:nn)
      !(in) スペクトルデータ

      real(8), intent(in)   :: y_data(1:jm)
      !(in) 格子点データ

      real(8)  :: ws(nn+1)                ! 変換用作業配列

      y_pdata = y_data
      call lvtgzs(nm,nn,jm,l_y,y_pdata,p,q,r,ws,0)

    end function l_y


  !--------------- 微分計算 -----------------
    function l_Lapla_l(l_data)
      !
      ! 入力スペクトルデータにラプラシアン
      !
      !    ▽^2 = 1/cosφ・∂/∂φ(cosφ∂/∂φ)
      !
      ! を作用する. 
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである. 
      !
      real(8)              :: l_Lapla_l(0:nn)
      !(out) 入力スペクトルデータのラプラシアン

      real(8), intent(in)  :: l_data(0:nn)
      !(in) 入力スペクトルデータ

      integer :: n

      do n=0,nn
         l_Lapla_l(n) = -n*(n+1)*l_data(n)
      enddo

    end function l_Lapla_l

    function l_LaplaInv_l(l_data)
      !
      ! 入力スペクトルデータに逆ラプラシアン
      !
      !    ▽^{-2}
      !      =[1/cosφ・∂/∂φ(cosφ∂/∂φ)]^{-1}
      !
      ! を作用する. 
      !
      ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
      ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである. 
      !
      real(8)              :: l_LaplaInv_l(0:nn)
      !(out) スペクトルデータの逆ラプラシアン

      real(8), intent(in)  :: l_data(0:nn)
      !(in) 入力スペクトルデータ

      integer ::  n

      l_LaplaInv_l(0) = 0.0D0
      do n=1,nn
         l_LaplaInv_l(n) = -l_data(n)/(n*(n+1))
      enddo

    end function l_LaplaInv_l

    function y_GradLat_l(l_data)
      !
      ! スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させて
      ! 格子点データに変換して返す(1 層用).
      !
      real(8)              :: y_GradLat_l(1:jm)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      real(8), intent(in)  :: l_data(0:nn)
      !(in) 入力スペクトルデータ

      real(8)              :: work(0:nn+1)
      ! 作業スペクトルデータ

      real(8)  :: ws(nn+2)                 ! 変換用作業配列

      call svcszy(nn,l_data,work,c)
      call lvtszg(nm,nn+1,jm,work,y_pdata,p,q,r,ws,1)
      y_GradLat_l = y_pdata
      
    end function y_GradLat_l

    function l_DivLat_y(y_data)
      !
      ! 格子点データに発散型緯度微分 1/cosφ・∂(f cosφ)/∂φ を作用させて
      ! スペクトルデータに変換して返す. 
      !
      real(8)              :: l_DivLat_y(0:nn)
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      real(8), intent(in)  :: y_data(1:jm)
      !(in) 入力格子点データ

      real(8)              :: work(0:nn+1)
      ! 作業スペクトルデータ

      real(8)  :: ws(nn+2)                 ! 変換用作業配列

      y_pdata = y_data
      call lvtgzs(nm,nn+1,jm,work,y_pdata,p,q,r,ws,1)
      call svcyzs(nn,work,l_DivLat_y,c)

    end function l_DivLat_y

  !--------------- 微分計算 (μ座標系用) -----------------
    function y_GradMu_l(l_data)
      !
      ! スペクトルデータに勾配型緯度微分 (1-μ^2)∂/∂μ  (μ=sinφ)
      ! を作用させて格子点データに変換して返す. 
      !
      real(8)              :: y_GradMu_l(1:jm)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      real(8), intent(in)  :: l_data(0:nm)
      !(in) 入力スペクトルデータ

      y_GradMu_l = y_GradLat_l(l_data)*cos(y_Lat)

    end function y_GradMu_l

    function l_DivMu_y(y_data)
      !
      ! 格子点データに発散型緯度微分 ∂/∂μ (μ=sinφ)を作用させて
      ! スペクトルデータに変換して返す(1 層用).
      !
      real(8)              :: l_DivMu_y(0:nn)
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      real(8), intent(in)  :: y_data(1:jm)
      !(in) 入力格子点データ

      l_DivMu_y = l_DivLat_y(y_data/cos(y_Lat))

    end function l_DivMu_y

  !--------------- 積分計算 -----------------
    function IntLat_y(y_data)
      !
      ! 1 次元緯度(Y)格子点データの Y 方向積分.
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), intent(in) :: y_data(1:jm)    !(in)  1 次元緯度(Y)格子点データ
      real(8)             :: IntLat_y        !(out) 積分値

      IntLat_y = sum(y_data * y_Lat_weight)

    end function IntLat_y

  !--------------- 平均計算 -----------------
    function AvrLat_y(y_data)
      !
      ! 1 次元(Y)格子点データの緯度(Y)方向平均.
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), intent(in) :: y_data(1:jm)    !(in)  1 次元緯度格子点データ
      real(8)             :: AvrLat_y        !(out) 平均値

      AvrLat_y = IntLat_y(y_data)/sum(y_Lat_weight)

    end function AvrLat_y

  !--------------- 補間計算 -----------------    
    function Interpolate_l(l_data,alat)
      !
      ! 緯度 alat における関数値を
      ! そのルジャンドル変換係数 l_data から補間計算する
      !
      real(8), intent(IN) :: l_data(0:nn)           ! スペクトルデータ
      real(8), intent(IN) :: alat                   ! 補間する位置(緯度)
      real(8)             :: Interpolate_l          ! 補間した値
      
      real(8) :: mu
      real(8) :: y0, y1, y2
      integer :: k

      mu = sin(alat)
      Interpolate_l = 0.0D0

      !---- Σa_n^0 L_n^0 の計算
      y2 = 0 ; y1 = 0
      do k=nn,1,-1
         y0 = alpha(k,mu) * y1 + beta(k+1)*y2 + l_data(k)
         y2 = y1 ; y1 = y0
      enddo
      Interpolate_l = beta(1) * y2 + mu*sqrt(3.0D0) * y1 + l_data(0) 

    end function Interpolate_l

  !--------------- 下部ルーチン -----------------
    function alpha(n,x)
      !
      !  漸化式の P_n の係数
      !
      integer, intent(IN) :: n
      real(8), intent(IN) :: x
      real(8)             :: alpha

      alpha = sqrt( (2.0D0*n+3)*(2.0D0*n+1)/((n+1)*(n+1)) ) * x
    end function alpha

    function beta(n)
      !
      !  漸化式の P_{n-1} の係数
      !
      integer, intent(IN) :: n
      real(8)             :: beta

      beta = - sqrt( (2.0D0*n+3)*n*n/((2*n-1)*(n+1)*(n+1)) )
    end function beta

  !--------------- 終了処理 -----------------
    subroutine l_Finalize
      !
      ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
      !
      ! 解像度を変更する際にはこのサブルーチンを呼んで終了処理を
      ! おこなったのちに再度 l_Initial で初期設定しなければ
      ! ならない. 
      !
      if ( .not. l_initialize ) then
         call MessageNotify('W','l_finalize',&
              'l_module_svpack not initialized yet')
         return
      endif

      deallocate(p)                     ! 変換用配列
      deallocate(r)                     ! 変換用配列
      deallocate(jc)                    ! 微分用配列
      deallocate(c)                     ! 微分用配列      

      deallocate(y_Lat,y_Lat_Weight)    ! 座標変数配列

      nullify(y_pdata)               ! 変換用作業配列
      nullify(q)                     ! 変換用作業配列
      call mlfree(pg)                ! 変換用作業配列
      call mlfree(pq)                ! 変換用作業配列

      l_initialize = .false.

      call MessageNotify('M','l_finalize',&
           'l_module_svpack (2017/03/06) for AVX is finalized')

    end subroutine l_Finalize

end module l_module_svpack

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_spectrum_module_svpack テストプログラム :: スペクトル解析関数のテスト
!
!履歴  2016/03/09  竹広真一   w_test_spectrum.f90 を改造, SVPACK 対応
!
program w_spectrum_module_svpack_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_module_svpack
  implicit none

  integer, parameter :: im=32, jm=16, nm=10


  real(8), dimension((nm+1)**2)   ::  w_data
  real(8), dimension(0:im-1,1:jm) ::  xy_data

  real(8), dimension(0:nm,-nm:nm) ::  nm_data
  real(8), dimension(0:nm)        ::  n_data
  real(8)                         ::  data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer :: n,m

  call w_Initial( nm, im, jm )

  call MessageNotify('M','w_test_spectrum','w_spectrum_module tests') 

  !================= 2Y_1^0+3Y_2^1 のテスト ================
  xy_data = 2*sqrt(3.0D0)*sin(xy_Lat) &        ! 2Y_1^0+3Y_2^1
       + 3*sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)! 
  w_data = w_xy(xy_data)

  !--------- Energy spectrum ---------
  nm_data=w_spectrum_VMiss
  do n=0,nm
     do m=-n,n
        nm_data(n,m) = 0.0
     enddo
  enddo
  nm_data(1,0) = 1*2*(2**2)/2
  nm_data(2,1) = 2*3*(3.0D0/2)**2/2
  nm_data(2,-1) =  nm_data(2,1)
  call AssertEqual(&
    message='nm_EnergyFromStreamfunc_w with 2Y_1^0+3Y_2^1 ',      &
    answer = nm_data,                                             &
    check = nm_EnergyFromStreamfunc_w(w_data),                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  n_data = 0.0; n_data(1) = 4.0D0 ;   n_data(2) = 2*3*(3.0D0/2)**2
  call AssertEqual(&
    message='n_EnergyFromStreamfunc_w with 2Y_1^0+3Y_2^1 ',       &
    answer = n_data,                                              &
    check = n_EnergyFromStreamfunc_w(w_data),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nm_Data = nm_EnergyFromStreamfunc_w(w_data)
  data = 0.0D0
  do n=0,nm
     do m=-n,n
        data = data + nm_Data(n,m)
     enddo
  enddo

  call AssertEqual(&
    message='total energy by nm-spectrum with 2Y_1^0+3Y_2^1 ',    &
    answer = AvrLonLat_xy( &
         0.5*(xy_GradLon_w(w_data)**2+xy_GradLat_w(w_data)**2) ), &
    check = data,                                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  data = AvrLonLat_xy( 0.5*(xy_GradLon_w(w_data)**2+xy_GradLat_w(w_data)**2) )
  call AssertEqual(&
    message='total energy by n-spectrum with 2Y_1^0+3Y_2^1 ',     &
    answer = data,                                                &
    check = sum(n_EnergyFromStreamfunc_w(w_data)),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !--------- Enstrophy spectrum ---------
  nm_data=w_spectrum_VMiss
  do n=0,nm
     do m=-n,n
        nm_data(n,m) = 0.0
     enddo
  enddo
  nm_data(1,0) = (1**2)*(2**2)*(2**2)/2
  nm_data(2,1) = (2**2)*(3**2)*(3.0D0/2.0D0)**2/2
  nm_data(2,-1) = nm_data(2,1)
  call AssertEqual(&
    message='nm_EnstrophyFromStreamfunc_w with 2Y_1^0+3Y_2^1 ',   &
    answer = nm_data,                                             &
    check = nm_EnstrophyFromStreamfunc_w(w_data),                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  n_data = 0.0; 
  n_data(1) = (1**2)*(2**2)*(2**2)/2
  n_data(2) = (2**2)*(3**2)*(3.0D0/2.0D0)**2
  call AssertEqual(&
    message='n_EnstrophyFromStreamfunc_w with 2Y_1^0+3Y_2^1 ',    &
    answer = n_data,                                              &
    check = n_EnstrophyFromStreamfunc_w(w_data),                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nm_Data = nm_EnstrophyFromStreamfunc_w(w_data)
  data = 0.0D0
  do n=0,nm
     do m=-n,n
        data = data + nm_Data(n,m)
     enddo
  enddo

  call AssertEqual(&
    message='total enstrophy by nm-spectrum with 2Y_1^0+3Y_2^1 ', &
    answer =  AvrLonLat_xy( 0.5*(xy_w(w_Lapla_w(w_data))**2)),    &
    check = data,                                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  data = AvrLonLat_xy( 0.5*(xy_w(w_Lapla_w(w_data))**2))
  call AssertEqual(&
    message='total enstrophy by n-spectrum with 2Y_1^0+3Y_2^1 ',  &
    answer = data,                                                &
    check = sum(n_EnstrophyFromStreamfunc_w(w_data)),             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !======== 3*Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2 のテスト ========
  xy_data = 3*sqrt(3.0D0)*sin(xy_Lat) &        ! 2Y_1^0+3Y_2^1
          + 2* sqrt(3.0D0/2)*cos(xy_Lat)*cos(xy_Lon) &
          + 2*sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0) &
          - sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(2*xy_Lon)
  w_data = w_xy(xy_data)

  !--------- Energy spectrum ---------
  nm_data=w_spectrum_VMiss
  do n=0,nm
     do m=-n,n
        nm_data(n,m) = 0.0
     enddo
  enddo
  nm_data(1,0)  = 1*2*3**2/2
  nm_data(1,1)  = 1*2*(2/2)**2/2
  nm_data(1,-1) = nm_data(1,1)
  nm_data(2,0)  = 2*3*2**2/2
  nm_data(2,-2) = 2*3*(1.0D0/2.0D0)**2/2
  nm_data(2,2)  = nm_data(2,-2)
  call AssertEqual(&
    message='nm_EnergyFromStreamfunc_w with 3Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2',&
    answer = nm_data,                                             &
    check = nm_EnergyFromStreamfunc_w(w_data),                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  n_data = 0.0
  n_data(1) = 1*2*3**2/2 + 1*2*(2/2)**2
  n_data(2) = 2*3*2**2/2 + 2*3*(1.0D0/2.0D0)**2
  call AssertEqual(&
    message='n_EnergyFromStreamfunc_w with 3Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2', &
    answer = n_data,                                              &
    check = n_EnergyFromStreamfunc_w(w_data),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nm_Data = nm_EnergyFromStreamfunc_w(w_data)
  data = 0.0D0
  do n=0,nm
     do m=-n,n
        data = data + nm_Data(n,m)
     enddo
  enddo

  call AssertEqual(&
    message='total energy by nm-spectrum with 3Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2', &
    answer = AvrLonLat_xy( &
         0.5*(xy_GradLon_w(w_data)**2+xy_GradLat_w(w_data)**2) ), &
    check = data,                                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  data = AvrLonLat_xy( 0.5*(xy_GradLon_w(w_data)**2+xy_GradLat_w(w_data)**2) )
  call AssertEqual(&
    message='total energy by n-spectrum with 3Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2', &
    answer = data,                                                &
    check = sum(n_EnergyFromStreamfunc_w(w_data)),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !--------- Enstrophy spectrum ---------
  nm_data=w_spectrum_VMiss
  do n=0,nm
     do m=-n,n
        nm_data(n,m) = 0.0
     enddo
  enddo
  nm_data(1,0)  = (1**2)*(2**2)*3**2/2
  nm_data(1,1)  = (1**2)*(2**2)*(2/2)**2/2
  nm_data(1,-1) = nm_data(1,1)
  nm_data(2,0)  = (2**2)*(3**2)*2**2/2
  nm_data(2,-2) = (2**2)*(3**2)*(1.0D0/2.0D0)**2/2
  nm_data(2,2)  = nm_data(2,-2)
  call AssertEqual(&
    message='nm_EnstrophyFromStreamfunc_w with 3Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2', &
    answer = nm_data,                                             &
    check = nm_EnstrophyFromStreamfunc_w(w_data),                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  n_data = 0.0
  n_data(1) = (1**2)*(2**2)*3**2/2 + (1**2)*(2**2)*(2/2)**2
  n_data(2) = (2**2)*(3**2)*2**2/2 + (2**2)*(3**2)*(1.0D0/2.0D0)**2
  call AssertEqual(&
    message='n_EnstrophyFromStreamfunc_w with 3Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2', &
    answer = n_data,                                              &
    check = n_EnstrophyFromStreamfunc_w(w_data),                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nm_Data = nm_EnstrophyFromStreamfunc_w(w_data)
  data = 0.0D0
  do n=0,nm
     do m=-n,n
        data = data + nm_Data(n,m)
     enddo
  enddo

  call AssertEqual(&
    message='total enstrophy by nm-spectrum with 3Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2',&
    answer =  AvrLonLat_xy( 0.5*(xy_w(w_Lapla_w(w_data))**2)),    &
    check = data,                                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  data = AvrLonLat_xy( 0.5*(xy_w(w_Lapla_w(w_data))**2))
  call AssertEqual(&
    message='total enstrophy by n-spectrum with 3Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2',&
    answer = data,                                                &
    check = sum(n_EnstrophyFromStreamfunc_w(w_data)),             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','w_spectrum_module_svpack_test', &
                         'w_spectrum_module_svpack tests succeeded!') 

end program w_spectrum_module_svpack_test

!----------------------------------------------------------------------
!     Copyright (c) 2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_wave_module_sjpack テストプログラム
!
!      微分のテスト
!  
!履歴  2013/06/16  竹広真一  wt_module_sjpack_derivative_test1.f90 から改造
!
program wt_wave_module_sjpack_derivative_test1

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wt_wave_module_sjpack
  implicit none

  integer,parameter  :: im=2,  jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  integer,parameter  :: m=1                  ! 東西波数の設定
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Data
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_DData

  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VLon
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VLat
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VRad
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Div
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Psi


  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer, parameter :: nmin=1, nmax=9

  integer :: n, j

  call MessageNotify('M','wt_wave_module_sjpack_derivative_test1', &
       'wt_wave_module_sjpack derivative function test #1')

  call wt_Initial(im,jm,km,nm,m,lm,ri,ro)

  !==================== wt_DivRad_wt ====================
  do n=nmin,nmax
     write(6,*) 'n=',n
     xyz_Data = xyz_Rad**n * cos(xyz_Lat)
     xyz_DData = (n+2)*xyz_Rad**(n-1) * cos(xyz_Lat)

     call AssertEqual(&
       message='wt_DivRad_wt with r^n',                            &
       answer = xyz_DData,                                         &
       check = xyz_wt(wt_DivRad_wt(wt_xyz(xyz_Data))),             &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
  enddo

  !========== xyz_GradLon_wt, xyz_GradLat_wt, wt_Div_xyz_xyz_xyz ==========

  ! ------ r^2 P_1^1 Toridal field -----
  n = 2
  write(6,*) 'n=',n
  xyz_Psi = xyz_Rad**n * cos(xyz_Lat)   ! r^2 P_1^1
  xyz_VRad = 0

  do j=1,jm
     xyz_VLon(0,j,:) = -m * z_Rad**(n-1)
     xyz_VLon(1,j,:) =  m* z_Rad**(n-1)
  enddo
  call AssertEqual(&
       message='xyz_GradLon_wt with r^2 P_1^1',                      &
       answer = xyz_VLon,                                            &
       check = xyz_GradLon_wt(wt_xyz(xyz_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_VLon = xyz_GradLon_wt(wt_xyz(xyz_Psi))

  xyz_VLat = -xyz_Rad**(n-1)*sin(xyz_Lat)
  call AssertEqual(&
       message='xyz_GradLat_wt with r^2 P_1^1',                     &
       answer = xyz_VLat,                                           &
       check = xyz_GradLat_wt(wt_xyz(xyz_Psi)),                     &
       significant_digits = check_digits, ignore_digits = ignore    &
       )

  xyz_Div = - 2 * xyz_Psi/xyz_Rad**2
  call AssertEqual(&
       message='wt_Div_xyz_xyz_xyz with Toroiral r^2 P_1^',         &
       answer = xyz_Div,                                             &
       check = xyz_wt(wt_Div_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ------ r^2 P_2^1 Toridal field -----
  n = 2
  xyz_VRad = 0
  xyz_Psi = xyz_Rad**n * cos(xyz_Lat)*sin(xyz_Lat)  ! r^2 P_2^1

  do j=1,jm
     xyz_VLon(0,j,:) = -m * z_Rad**(n-1)*sin(y_Lat(j))
     xyz_VLon(1,j,:) =  m * z_Rad**(n-1)*sin(y_Lat(j))
  enddo
  call AssertEqual(&
       message='xyz_GradLon_wt with r^2 P_2^1',                     &
       answer = xyz_VLon,                                           &
       check =  xyz_GradLon_wt(wt_xyz(xyz_Psi)),                    &
       significant_digits = check_digits, ignore_digits = ignore    &
       )
  xyz_VLon = xyz_GradLon_wt(wt_xyz(xyz_Psi))

  xyz_VLat = xyz_Rad**(n-1)*cos(2*xyz_Lat)
  call AssertEqual(&
       message='xyz_GradLat_wt with r^2 P_2^1',                     &
       answer = xyz_VLat,                                           &
       check = xyz_GradLat_wt(wt_xyz(xyz_Psi)),                     &
       significant_digits = check_digits, ignore_digits = ignore    &
       )

  xyz_Div = - 6* xyz_Psi/xyz_Rad**2
  call AssertEqual(&
       message='wt_Div_xyz_xyz_xyz with Toroiral r2 P_2^1',           &
       answer = xyz_Div,                                              &
       check = xyz_wt(wt_Div_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore      &
       )

  !==================== wt_DivLon_xyz, wt_DivLat_xyz ====================
  n=2
  write(6,*)'n =',n

  xyz_VLon  = xyz_rad**n * cos(xyz_Lat)**2
  do j=1,jm
     xyz_DData(0,j,:) = -m * z_rad**(n-1)*cos(y_Lat(j))
     xyz_DData(1,j,:) =  m * z_rad**(n-1)*cos(y_Lat(j))
  enddo
  call AssertEqual(&
       message='wt_DivLon_xyz with r^n P_1^1cos φ',                &
       answer = xyz_DData,                                          &
       check = xyz_wt(wt_DivLon_xyz(xyz_VLon)),                     &
       significant_digits = check_digits, ignore_digits = ignore    &
       )

  xyz_VLat   = xyz_rad**n * cos(xyz_Lat)**2
  xyz_DData = -3*xyz_rad**(n-1)*cos(xyz_Lat)*sin(xyz_Lat)
  call AssertEqual(&
       message='wt_DivLat_xyz with r^n P_1^1cosφ',                 &
       answer = xyz_DData,                                          &
       check = xyz_wt(wt_DivLat_xyz(xyz_VLat)),                     &
       significant_digits = check_digits, ignore_digits = ignore    &
       )

  call MessageNotify('M','wt_wave_module_sjpack_derivative_test1', &
       'wt_wave_module_sjpack derivative function test #1 succeeded!')

end program wt_wave_module_sjpack_derivative_test1

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_module_fftj テストプログラム (微分演算)
!
!履歴  2009/12/15  竹広真一
!
program tee_module_fftj_deriv_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=10       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: zyx_Data(0:km,0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: zyx_Deriv(0:km,0:jm-1,0:im-1)   ! 格子データ

  integer            :: l=2, m=5

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','tee_module_fftj_deriv_test', &
       'tee_module_fftj derivative function tests')

 !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call tee_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

 !------------------- 関数チェック ----------------------
  zyx_Data = sin(l*pi*zyx_X) * sin(m*pi*zyx_Y) * zyx_Z

  zyx_Deriv = l*pi*cos(l*pi*zyx_X) * sin(m*pi*zyx_Y) * zyx_Z
  call AssertEqual(&
    message='tee_Dx_tee with sin(k*pi*X)*sin(l*pi*Y)*Z',          &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_Dx_tee(tee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = m*pi*sin(l*pi*zyx_X) * cos(m*pi*zyx_Y) * zyx_Z
  call AssertEqual(&
    message='tee_Dy_tee with sin(k*pi*X)*sin(l*pi*Y)*Z',          &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_Dy_tee(tee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = sin(l*pi*zyx_X) * sin(m*pi*zyx_Y) 
  call AssertEqual(&
    message='tee_Dz_tee with sin(k*pi*X)*sin(l*pi*Y)*Z',          &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_Dz_tee(tee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -((l*pi)**2+(m*pi)**2)*sin(l*pi*zyx_X) * sin(m*pi*zyx_Y)*zyx_Z
  call AssertEqual(&
    message='tee_Lapla_tee with sin(k*pi*X)*sin(l*pi*Y)*Z',       &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_Lapla_tee(tee_zyx(zyx_Data))),            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -((l*pi)**2+(m*pi)**2)*sin(l*pi*zyx_X) * sin(m*pi*zyx_Y)*zyx_Z
  call AssertEqual(&
    message='tee_LaplaH_tee with sin(k*pi*X)*sin(l*pi*Y)*Z',      &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_LaplaH_tee(tee_zyx(zyx_Data))),           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -sin(l*pi*zyx_X) * sin(m*pi*zyx_Y)*zyx_Z/((l*pi)**2+(m*pi)**2)
  call AssertEqual(&
    message='tee_LaplaH_tee with sin(k*pi*X)*sin(l*pi*Y)*Z',      &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_LaplaHInv_tee(tee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  zyx_Data = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)

  zyx_Deriv = -l*pi*sin(l*pi*zyx_X) *cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)
  call AssertEqual(&
    message='tee_Dx_tee with cos(k*pi*X)*cos(l*pi*Y)*(2Z**2-1)',  &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_Dx_tee(tee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -m*pi*cos(l*pi*zyx_X) * sin(m*pi*zyx_Y) * (2*zyx_Z**2 -1)
  call AssertEqual(&
    message='tee_Dy_tee with cos(k*pi*X)*cos(l*pi*Y)*(2Z**2-1)',  &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_Dy_tee(tee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * 4 * zyx_Z
  call AssertEqual(&
    message='tee_Dz_tee with cos(k*pi*X)*cos(l*pi*Y)*(2Z**2-1)',  &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_Dz_tee(tee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -((l*pi)**2+(m*pi)**2) &
       * cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1) &
       + cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * 4
  call AssertEqual(&
    message='tee_Lapla_tee with cos(k*pi*X)*cos(l*pi*Y)*(2Z**2-1)',  &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_Lapla_tee(tee_zyx(zyx_Data))),            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -((l*pi)**2+(m*pi)**2) &
       * cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)
  call AssertEqual(&
    message='tee_LaplaH_tee with cos(k*pi*X)*cos(l*pi*Y)*(2Z**2-1)',  &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_LaplaH_tee(tee_zyx(zyx_Data))),           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -1.0D0/((l*pi)**2+(m*pi)**2) &
       * cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)
  call AssertEqual(&
    message='tee_LaplaH_tee with cos(k*pi*X)*cos(l*pi*Y)*(2Z**2-1)',  &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_LaplaHInv_tee(tee_zyx(zyx_Data))),        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Data = sin(l*pi*zyx_X) * cos(m*pi*zyx_Y)/2.0D0

  zyx_Deriv = l*pi*cos(l*pi*zyx_X) * cos(m*pi*zyx_Y)/2.0D0
  call AssertEqual(&
    message='tee_Dx_tee with sin(k*pi*X)*cos(l*pi*Y)/2',          &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_Dx_tee(tee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -m*pi*sin(l*pi*zyx_X) * sin(m*pi*zyx_Y)/2.0D0
  call AssertEqual(&
    message='tee_Dy_tee with sin(k*pi*X)*cos(l*pi*Y)/2',          &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_Dy_tee(tee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = 0.0D0
  call AssertEqual(&
    message='tee_Dz_tee with sin(k*pi*X)*cos(l*pi*Y)/2',          &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_Dz_tee(tee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -((l*pi)**2+(m*pi)**2)*sin(l*pi*zyx_X) * cos(m*pi*zyx_Y)/2.0D0
  call AssertEqual(&
    message='tee_Lapla_tee with sin(k*pi*X)*cos(l*pi*Y)/2',       &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_Lapla_tee(tee_zyx(zyx_Data))),            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -((l*pi)**2+(m*pi)**2)*sin(l*pi*zyx_X) * cos(m*pi*zyx_Y)/2.0D0
  call AssertEqual(&
    message='tee_LaplaH_tee with sin(k*pi*X)*cos(l*pi*Y)/2',      &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_LaplaH_tee(tee_zyx(zyx_Data))),           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -1/((l*pi)**2+(m*pi)**2)*sin(l*pi*zyx_X) * cos(m*pi*zyx_Y)/2.0D0
  call AssertEqual(&
    message='tee_LaplaHInv_tee with sin(k*pi*X)*cos(l*pi*Y)/2',   &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_LaplaHInv_tee(tee_zyx(zyx_Data))),        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Data = cos(l*pi*zyx_X) * sin(m*pi*zyx_Y)*(4*zyx_Z**3-3*zyx_Z)

  zyx_Deriv = - l*pi*sin(l*pi*zyx_X) * sin(m*pi*zyx_Y)*(4*zyx_Z**3-3*zyx_Z)
  call AssertEqual(&
    message='tee_Dx_tee with cos(k*pi*X)*sin(l*pi*Y)*(4Z**3-3Z)', &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_Dx_tee(tee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = m*pi*cos(l*pi*zyx_X) * cos(m*pi*zyx_Y)*(4*zyx_Z**3-3*zyx_Z)
  call AssertEqual(&
    message='tee_Dy_tee with cos(k*pi*X)*sin(l*pi*Y)*(4Z**3-3Z)', &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_Dy_tee(tee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = cos(l*pi*zyx_X) * sin(m*pi*zyx_Y)*(12*zyx_Z**2-3)
  call AssertEqual(&
    message='tee_Dz_tee with cos(k*pi*X)*sin(l*pi*Y)*(4Z**3-3Z)', &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_Dz_tee(tee_zyx(zyx_Data))),               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -((l*pi)**2+(m*pi)**2) &
       * cos(l*pi*zyx_X) * sin(m*pi*zyx_Y)*(4*zyx_Z**3-3*zyx_Z) &
       + cos(l*pi*zyx_X) * sin(m*pi*zyx_Y)*(24*zyx_Z)
  call AssertEqual(&
    message='tee_Lapla_tee with cos(k*pi*X)*sin(l*pi*Y)*(4Z**3-3Z)', &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_Lapla_tee(tee_zyx(zyx_Data))),            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -((l*pi)**2+(m*pi)**2) &
       * cos(l*pi*zyx_X) * sin(m*pi*zyx_Y)*(4*zyx_Z**3-3*zyx_Z)
  call AssertEqual(&
    message='tee_LaplaH_tee with cos(k*pi*X)*sin(l*pi*Y)*(4Z**3-3Z)', &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_LaplaH_tee(tee_zyx(zyx_Data))),           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Deriv = -1/((l*pi)**2+(m*pi)**2) &
       * cos(l*pi*zyx_X) * sin(m*pi*zyx_Y)*(4*zyx_Z**3-3*zyx_Z)
  call AssertEqual(&
    message='tee_LaplaHInv_tee with cos(k*pi*X)*sin(l*pi*Y)*(4Z**3-3Z)', &
    answer = zyx_Deriv,                                           &
    check = zyx_tee(tee_LaplaHInv_tee(tee_zyx(zyx_Data))),        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','tee_module_fftj_deriv_test', &
       'tee_module_fftj derivateiv functions tests succeeded!')

end program tee_module_fftj_deriv_test

!--
!----------------------------------------------------------------------
! Copyright (c) 2017 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  wsc_mpi_module_supack
!
!    spml/wsc_mpi_module_supack モジュールは球面上および球殻内での流体運動を
!    スペクトル法と MPI 並列化によって数値計算するための Fortran90 
!    関数を提供するものである. 
!
!    水平方向に球面調和函数変換および鉛直方向に sin/cos 関数変換を
!    用いる場合のスペクトル計算のためのさまざまな関数を提供する. 
!
!    関数, サブルーチンの名前と機能は wsc_mpi_module のものと同じである.
!    したがって use 文を wsc_mpi_module から wsc_mpi_module_supack に
!    変更するだけで SUPACK-MPI の機能が使えるようになる.
!
!    ただし l_nm, nm_l の使い方には注意されたい. wt_mpi_module の l_nm, nm_l は
!    wt_Initial で初期化しなくとも用いることができる(結果が切断波数に依らない)が,
!    wsc_mpi_module_supack のものは初期化したのちにしか使うことができない.
!
!    内部で wa_mpi_module_supack を用いている. 
!    最下部では球面調和変換およびチェビシェフ変換のエンジンとして 
!    ISPACK2 の Fortran77 サブルーチンを用いている.
!
!
!履歴  2017/05/30  竹広真一  wt_mpi_module_supack より wsc 用に改造
!                             
!凡例
!      データ種類と index
!        x : 経度         y : 緯度    v : 緯度(分散格子)     z : 動径
!        w : 球面調和関数スペクトル
!        n : 球面調和関数スペクトル(水平全波数)
!        m : 球面調和関数スペクトル(帯状波数)
!        s : sin 関数スペクトル
!        c : cos 関数スペクトル
!        a : 任意の次元
!
!        xyz : 3 次元格子点データ
!        xvz : 3 次元分散格子点データ
!        xy  : 水平 2 次元格子点データ
!        yz  : 子午面 2 次元格子点データ
!        xz  : 緯度面 2 次元格子点データ
!
!        wz  : 水平スペクトル動径格子点データ
!        ws  : スペクトルデータ(鉛直 sin)
!        wc  : スペクトルデータ(鉛直 cos)
!
!++
module wsc_mpi_module_supack
  !
  != wsc_mpi_module_supack
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id: wt_mpi_module_supack.f90 598 2013-08-20 03:23:44Z takepiro $
  ! Copyright&License:: See COPYRIGHT[link:../../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/wt_mpi_module_supack モジュールは球面上および球殻内での流体運動を
  ! スペクトル法と MPI 並列化によって数値計算するための Fortran90 
  ! 関数を提供するものである. 
  !
  ! 水平方向に球面調和函数変換および鉛直方向に sin/cos 関数変換を
  ! 用いる場合のスペクトル計算のためのさまざまな関数を提供する. 
  !
  ! 内部で wa_mpi_module_supack を用いている. 
  ! 最下部では球面調和変換およびチェビシェフ変換のエンジンとして 
  ! ISPACK2 の Fortran77 サブルーチンを用いている.
  !
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (ws_, wc_, nmz_,nz_,xyz_,wz_,w_,xy_,x_,y_,s_,c_,a_) は, 
  !   返す値の形を示している.
  !   ws_,wc_ :: スペクトルデータ(球面調和函数・三角関数変換)
  !   nmz_    :: 水平スペクトルデータ(全波数 n, 帯状波数各成分, 動径)
  !   nz_     :: 水平スペクトルデータ(全波数 n, 動径)
  !   xyz_    :: 3 次元格子点データ(経度・緯度・動径)
  !   wz_     :: 水平スペクトル, 動径格子点データ
  !
  ! * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla,..)
  !   は, その関数の作用を表している.
  !
  ! * 関数名の最後 (ws_,wc_,xyz_,wz_,w_,xy_,x_,y_,z_,a_) は, 入力変数の
  !   形がスペクトルデータおよび格子点データであることを示している.
  !   _ws,_wc  :: スペクトルデータ
  !   _xyz     :: 3 次元格子点データ
  !   _xyz_xyz :: 2 つの3 次元格子点データ, ...
  !
  !=== 各データの種類の説明
  !
  ! * xyz : 3 次元格子点データ(経度・緯度・動径)
  !   * 変数の種類と次元は real(8), dimension(0:im-1,jm,0:km). 
  !   * im, jm, km はそれぞれ経度, 緯度, 動径座標の格子点数であり, 
  !     サブルーチン wt_mpi_Initial にてあらかじめ設定しておく.
  !
  ! * xvz : 3 次元分散格子点データ(経度・緯度・動径)
  !   * 変数の種類と次元は real(8), dimension(0:im-1,jc,0:km). 
  !   * im, km はそれぞれ経度, 動径座標の格子点数であり, 
  !   * jc はこのプロセスで保有する緯度格子点数である. 
  !     サブルーチン wsc_mpi_Initial を呼ぶと jc が設定される. 
  !
  ! * ws : スペクトルデータ(鉛直 sin)
  !   * 変数の種類と次元は real(8), dimension(nc,lm). 
  !   * nm は球面調和函数の最大全波数, lm は sin 変換の最大次数であり,
  !     サブルーチン wsc_mpi_Initial にてあらかじめ設定しておく. 
  !   * 水平スペクトルデータの格納のされ方は関数 l_nm, nm_l によって調べる
  !     ことができる.
  !
  ! * wc : スペクトルデータ(鉛直 cos)
  !   * 変数の種類と次元は real(8), dimension(nc,0:lm). 
  !   * nm は球面調和函数の最大全波数, lm は cos 変換の最大次数であり,
  !     サブルーチン wsc_mpi_Initial にてあらかじめ設定しておく. 
  !   * 水平スペクトルデータの格納のされ方は関数 l_nm, nm_l によって調べる
  !     ことができる.
  !
  ! * nmz : 水平スペクトルデータの並んだ 3 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,-nm:nm,0:km). 
  !   * 第 1 次元が水平全波数, 第 2 次元が帯状波数, 第 3 次元が動径座標を表す. 
  !   * nm は球面調和函数の最大全波数であり, サブルーチン wt_Initial にて
  !     あらかじめ設定しておく.
  !
  ! * nz : スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,0:km). 
  !     第 1 次元が水平全波数を表す. 
  !   * nm は球面調和函数の最大全波数であり, 
  !     サブルーチン wt_Initial にてあらかじめ設定しておく.
  !
  ! * wz : 水平スペクトル, 動径格子点データ.
  !   * 変数の種類と次元は real(8), dimension(nc,0:km).
  !
  ! * ws_, wc_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * xyz_ で始まる関数が返す値は 3 次元格子点データに同じ.
  !
  ! * xvz_ で始まる関数が返す値は 3 次元分散格子点データに同じ.
  !
  ! * wz_ で始まる関数が返す値は水平スペクトル, 動径格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! wsc_mpi_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! 
  !==== 座標変数
  !
  ! x_Lon, x_Lon_Weight,  ::  格子点座標(経度)と重みを格納した 1 次元配列
  ! y_Lat, y_Lat_Weight   ::  格子点座標(緯度)と重みを格納した 1 次元配列
  ! v_Lat, v_Lat_Weight   ::  分散格子点座標(緯度)と重みを格納した 1 次元配列
  ! z_Rad, z_Rad_Weight   ::  格子点座標(同形)と重みを格納した 1 次元配列
  ! xyz_Lon, xyz_Lat, xyz_Rad :: 格子点データの経度・緯度・動径座標(X,Y,Z) (格子点データ型 3 次元配列)
  ! xvz_Lon, xvz_Lat, xvz_Rad :: 格子点データの経度・緯度・動径座標(X,Y,Z) (分散格子点データ型 3 次元配列)
  !
  !==== 基本変換
  !
  ! xyz_ws, ws_xyz :: スペクトルデータと 3 次元格子データの間の変換
  !                   (球面調和函数, sin 変換)
  ! xyz_wc, wc_xyz :: スペクトルデータと 3 次元格子データの間の変換
  !                   (球面調和函数, cos 変換)
  ! xvz_ws, ws_xvz :: スペクトルデータと 3 次元分散格子データの間の変換
  !                   (球面調和函数, sin 変換)
  ! xvz_wc, wc_xvz :: スペクトルデータと 3 次元分散格子データの間の変換
  !                   (球面調和函数, cos 変換)
  ! xyz_wz, wz_xyz :: 3 次元格子データと水平スペクトル・動径格子データとの間
  !                   の変換 (球面調和函数)
  ! xvz_wz, wz_xvz :: 3 次元分散格子データと水平スペクトル・動径格子データとの間
  !                   の変換 (球面調和函数)
  ! wz_ws, ws_wz   :: スペクトルデータと水平スペクトル・動径格子データとの間
  !                   の変換 (sin 変換)
  ! wz_wc, wc_wz   :: スペクトルデータと水平スペクトル・動径格子データとの間
  !                   の変換 (cos 変換)
  ! w_xy, xy_w     :: スペクトルデータと 2 次元水平格子データの間の変換
  !                   (球面調和函数変換) 
  ! w_xv, xv_w     :: スペクトルデータと 2 次元水平分散格子データの間の変換
  !                   (球面調和函数変換) 
  ! az_as, as_az   :: 格子データと sin 変換スペクトルデータの間の変換を
  !                   同時に複数個行う
  ! az_as, as_az   :: 格子データと cos 変換スペクトル間の変換を
  !                   同時に複数個行う
  ! l_nm, nm_l     :: スペクトルデータの格納位置と全波数・帯状波数の変換 
  !
  ! ws_DRad_wc, wc_DRad_ws     :: スペクトルデータに動径微分∂/∂r を作用させる
  ! ws_DivRad_wc, wc_DivRad_ws :: スペクトルデータに発散型動径微分
  !                               ∂/∂r 
  ! ws_RotRad_wc, wc_RotRad_ws :: スペクトルデータに回転型動径微分
  !                               ∂/∂r を作用させる
  ! ws_Lapla_ws, wc_Lapla_wc   :: スペクトルデータにラプラシアンを作用させる
  ! ws_LaplaInv_ws, wc_LaplaInv_wc  :: スペクトルデータに逆ラプラシアンを作用させる  
  ! xyz_GradLon_ws, xyz_GradLon_wc :: スペクトルデータに勾配型経度微分
  !                                   1/(a cosφ)・∂/∂λを作用させる
  ! xyz_GradLat_wt, xyz_GradLat_wc :: スペクトルデータに勾配型緯度微分
  !                                   1/a・∂/∂φを作用させる
  ! ws_DivLon_xyz, wc_DivLon_xyz   :: 格子データに発散型経度微分
  !                                   1/(a cosφ)・∂/∂λを作用させる
  ! ws_DivLat_xyz, wc_DivLat_xyz   :: 格子データに発散型緯度微分
  !                                   (1/a cosφ)・∂(g cosφ)/∂φを作用させる
  ! wc_Div_xyz_xyz_xyz  :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! ws_Div_xyz_xyz_xyz  :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! xyz_Div_xyz_xyz_xyz :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! wc_RotRad_xyz_xyz   :: ベクトル場の回転の動径成分を計算する
  !
  !==== トロイダルポロイダル計算用微分
  !
  ! ws_KxRGrad_ws, wc_KxRGrad_wc :: スペクトルデータに
  !                                 経度微分 k×r・▽ = ∂/∂λを作用させる
  ! ws_L2_ws, wc_L2_wc       :: スペクトルデータに 
  !                             L2 演算子 = -水平ラプラシアンを作用させる
  ! ws_L2Inv_ws, ws_L2Inv_ws :: スペクトルデータに 
  !                             L2 演算子の逆 = -逆水平ラプラシアンを作用させる
  ! wc_RadRot_xyz_xyz        :: ベクトル v の渦度と動径ベクトル r の内積
  !                             r・(▽×v) を計算する
  ! ws_RadRotRot_xyz_xyz_xyz :: ベクトルの v の r・(▽×▽×v) を計算する
  ! wsc_Potential2Vector      :: トロイダルポロイダルポテンシャルから
  !                              ベクトル場を計算する
  ! wsc_Potential2Rotation    :: トロイダルポロイダルポテンシャルで表される
  !                              非発散ベクトル場の回転の各成分を計算する
  !
  !==== ポロイダル/トロイダルモデル用スペクトル解析
  !
  ! nmz_ToroidalEnergySpectrum_wt, :: トロイダルポテンシャルからエネルギーの
  ! nz_ToroidalEnergySpectrum_wt   :: 球面調和函数各成分を計算する
  ! 
  ! nmz_PoloidalEnergySpectrum_wt, :: ポロイダルポテンシャルからエネルギーの
  ! nz_PoloidalEnergySpectrum_wt   :: 球面調和函数各成分を計算する
  !
  !==== 積分・平均(3 次元データ)
  !
  ! IntLonLatRad_xyz, AvrLonLatRad_xyz :: 3 次元格子点データの全領域積分および平均
  !
  ! z_IntLonLat_xyz, z_AvrLonLat_xyz :: 3 次元格子点データの緯度経度(水平・球面)積分および平均               
  !
  ! y_IntLonRad_xyz, y_AvrLonRad_xyz :: 3 次元格子点データの緯度動径積分および平均
  !
  ! z_IntLatRad_xyz, z_AvrLatRad_xyz :: 3 次元格子点データの経度動径(子午面)積分および平均              
  !
  ! yz_IntLon_xyz, yz_AvrLon_xyz :: 3 次元格子点データの経度方向積分および平均
  ! xz_IntLat_xyz, xz_AvrLat_xyz :: 3 次元格子点データの緯度方向積分および平均
  ! xz_IntRad_xyz, xz_AvrRad_xyz :: 3 次元格子点データの動径方向積分および平均
  !
  ! IntLonLatRad_xvz, AvrLonLatRad_xvz :: 3 次元格子点データの全領域積分および平均
  !
  ! z_IntLonLat_xvz, z_AvrLonLat_xvz :: 3 次元格子点データの緯度経度(水平・球面)積分および平均               
  !
  ! v_IntLonRad_xvz, v_AvrLonRad_xvz :: 3 次元格子点データの緯度動径積分および平均
  !
  ! z_IntLatRad_xvz, z_AvrLatRad_xvz :: 3 次元格子点データの経度動径(子午面)積分および平均              
  !
  ! vz_IntLon_xvz, vz_AvrLon_xvz :: 3 次元格子点データの経度方向積分および平均
  ! xz_IntLat_xvz, xz_AvrLat_xvz :: 3 次元格子点データの緯度方向積分および平均
  ! xy_IntRad_xvz, xy_AvrRad_xvz :: 3 次元格子点データの動径方向積分および平均
  !
  !==== 積分・平均(2 次元データ)
  !
  ! IntLonLat_xy, AvrLonLat_xy :: 2 次元格子点データの水平(球面)積分および平均
  ! IntLonRad_xz, AvrLonRad_xz :: 2 次元(XZ)格子点データの経度動径積分
  !                            :: および平均
  ! IntLatRad_yz, AvrLatRad_yz :: 2 次元(YZ)格子点データの緯度動径(子午面)
  !                            :: 積分および平均 
  ! y_IntLon_xy, y_AvrLon_xy   :: 水平 2 次元(球面)格子点データの経度方向
  !                            :: 積分および平均
  ! x_IntLat_xy, x_AvrLat_xy   :: 水平2 次元(球面)格子点データの緯度方向積分
  !                            :: および平均
  ! z_IntLon_xz, z_AvrLon_xz   :: 2 次元(XZ)格子点データの経度方向積分および
  !                            :: 平均
  ! x_IntRad_xz, x_AvrRad_xz   :: 2 次元(XZ)格子点データの動径方向積分および
  !                            :: 平均
  ! z_IntLat_yz, z_AvrLat_yz   :: 2 次元(YZ)格子点データの緯度方向積分および
  !                            :: 平均
  ! y_IntRad_yz, y_AvrRad_yz   :: 2 次元(YZ)格子点データの動径方向積分および
  !                            :: 平均                  
  !
  ! IntLonLat_xv, AvrLonLat_xv :: 2 次元格子点データの水平(球面)積分および平均
  ! IntLonRad_xz, AvrLonRad_xz :: 2 次元(XZ)格子点データの経度動径積分
  !                            :: および平均
  ! IntLatRad_vz, AvrLatRad_vz :: 2 次元(YZ)格子点データの緯度動径(子午面)
  !                            :: 積分および平均 
  ! v_IntLon_xv, v_AvrLon_xv   :: 水平 2 次元(球面)格子点データの経度方向
  !                            :: 積分および平均
  ! v_IntLat_xv, x_AvrLat_xv   :: 水平2 次元(球面)格子点データの緯度方向積分
  !                            :: および平均
  ! z_IntLon_xz, z_AvrLon_xz   :: 2 次元(XZ)格子点データの経度方向積分および
  !                            :: 平均
  ! x_IntRad_xz, x_AvrRad_xz   :: 2 次元(XZ)格子点データの動径方向積分および
  !                            :: 平均
  ! z_IntLat_vz, z_AvrLat_vz   :: 2 次元(YZ)格子点データの緯度方向積分および
  !                            :: 平均
  ! v_IntRad_vz, v_AvrRad_vz   :: 2 次元(YZ)格子点データの動径方向積分および
  !                            :: 平均                  
  !
  !==== 積分・平均(1 次元データ)
  !
  ! IntLon_x, AvrLon_x  :: 1 次元(X)格子点データの経度方向積分および平均
  ! IntLat_y, AvrLat_y  :: 1 次元(Y)格子点データの緯度方向積分および平均
  ! IntRad_z, AvrRad_z  :: 1 次元(Z)格子点データの動径方向積分および平均
  !
  ! IntLat_v, AvrLat_v  :: 1 次元(Y)格子点データの緯度方向積分および平均
  !
  !==== 補間計算
  !
  ! Interpolate_ws, Interpolate_wc :: スペクトルデータから任意の点の値を補間する  ! 
  use dc_message
!  use lumatrix
  use mpi
  use wa_mpi_module_supack
  use asc_module, z_RAD => g_X, z_RAD_WEIGHT => g_X_WEIGHT, &
                  as_az => as_ag, az_as => ag_as, &
                  ac_az => ac_ag, az_ac => ag_ac, &
                  s_z => s_g, z_s => g_s, c_z => c_g, z_c => g_c, &
                  s_Dr_c => s_Dx_c, as_Dr_ac => as_Dx_ac, &
                  c_Dr_s => s_Dx_c, ac_Dr_as => ac_Dx_as
  implicit none
  integer :: ierr

  private

  public wsc_mpi_Initial
  public jc
  public nc

  public x_Lon, x_Lon_Weight
  public v_Lat, v_Lat_Weight
  public z_Rad, z_Rad_Weight
  public l_nm, nm_l
  public xv_Lon, xv_Lat
  public xvz_Lon, xvz_Lat, xvz_Rad
  public wz_Rad
  public wsc_VMiss

  public w_xv, xv_w
  public az_ac, ac_az, az_as, as_az
  public wz_wc, wc_wz, wz_ws, ws_wz
  public xvz_wc, wc_xvz, xvz_ws, ws_xvz, xvz_wz, wz_xvz
  public as_Dr_ac, s_Dr_c, ac_Dr_as, c_Dr_s
  public ws_DRad_wc, ws_DivRad_wc, ws_RotRad_wc, wc_Lapla_wc, wc_LaplaInv_wc
  public wc_DRad_ws, wc_DivRad_ws, wc_RotRad_ws, ws_Lapla_ws, ws_LaplaInv_ws
  public xvz_GradLon_wc, xvz_Gradlat_wc, xvz_GradLon_ws, xvz_Gradlat_ws
  public wc_DivLon_xvz, ws_DivLat_xvz
  public wc_Div_xvz_xvz_xvz, ws_Div_xvz_xvz_xvz, xvz_Div_xvz_xvz_xvz
  public wc_RotRad_xvz_xvz

!!$  public xvz_RotLon_wt_wt, xvz_RotLat_wt_wt, wt_RotRad_xvz_xvz

  public vz_IntLon_xvz, xz_IntLat_xvz, xv_IntRad_xvz
  public x_IntLatRad_xvz, v_IntLonRad_xvz, z_IntLonLat_xvz
  public IntLonLatRad_xvz

  public z_IntLon_xz, x_IntRad_xz, IntLonRad_xz

  public x_IntLat_xv, v_IntLon_xv, IntLonLat_xv
  public z_IntLat_vz, v_IntRad_vz, IntLatRad_vz
  public IntLon_x, IntLat_v, IntRad_z

  public vz_AvrLon_xvz, xz_AvrLat_xvz, xv_AvrRad_xvz
  public x_AvrLatRad_xvz, v_AvrLonRad_xvz, z_AvrLonLat_xvz
  public AvrLonLatRad_xvz

  public z_AvrLon_xz, x_AvrRad_xz, AvrLonRad_xz

  public x_AvrLat_xv, v_AvrLon_xv, AvrLonLat_xv
  public z_AvrLat_vz, v_AvrRad_vz, AvrLatRad_vz
  public AvrLon_x, AvrLat_v, AvrRad_z

  public wc_KxRGrad_wc, ws_KxRGrad_ws
  public wc_L2_wc, wc_L2Inv_wc, ws_L2_ws, ws_L2Inv_ws
  public wc_RadRot_xvz_xvz, ws_RadRotRot_xvz_xvz_xvz
  public wsc_Potential2vectorMPI, wsc_Potential2RotationMPI

  public Interpolate_ws, Interpolate_wc

  public nmz_ToroidalEnergySpectrum_wc, nz_ToroidalEnergySpectrum_wc
  public nmz_PoloidalEnergySpectrum_ws, nz_PoloidalEnergySpectrum_ws


  integer            :: im=64, jm=32, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer            :: nm=21, lm=16         ! 切断波数の設定(水平, 動径)
  real(8)            :: ri=0.0, ro=1.0       ! 球殻内外半径
  real(8), parameter :: pi=3.1415926535897932385D0

  real(8), dimension(:,:,:), allocatable :: xvz_LON, xvz_LAT, xvz_RAD ! 座標
  real(8), dimension(:,:), allocatable   :: wz_RAD                    ! 座標

  real(8)             :: Lat_Weight_Sum

  real(8) :: wsc_VMiss = -999.0        ! 欠損値
  
  save im, jm, km, nm, lm, ri, ro, Lat_Weight_Sum, wsc_VMiss

contains
  !--------------- 初期化 -----------------
  subroutine wsc_mpi_Initial(i,j,k,n,l,r_in,r_out,np,wa_init)
    !
    ! スペクトル変換の格子点数, 波数, 動径座標の範囲を設定する.
    !
    ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
    ! しなければならない. 
    !
    integer,intent(in) :: i              ! 格子点数(経度λ)
    integer,intent(in) :: j              ! 格子点数(緯度φ)
    integer,intent(in) :: k              ! 格子点数(動径 r)
    integer,intent(in) :: n              ! 切断波数(水平全波数)
    integer,intent(in) :: l              ! 切断波数(動径波数)

    real(8),intent(in) :: r_in           ! 球殻内半径
    real(8),intent(in) :: r_out          ! 球殻外半径

    integer,intent(in), optional :: np   ! OPENMP での最大スレッド数
    logical,intent(in), optional :: wa_init   ! wa_initial スイッチ

    logical    :: wa_initialize=.true.   ! wa_initial スイッチ

    im = i  ; jm = j ; km = k
    nm = n  ; lm = l
    ri = r_in ; ro = r_out

    if ( present(wa_init) ) then
       wa_initialize = wa_init
    else
       wa_initialize = .true.
    endif

    if ( present(np) ) then
       call MessageNotify('M','wt_mpi_Initial', &
            'Optional argument "NP_IN" is dummy in wt_mpi_module_supack')
    endif

    if ( wa_initialize ) then
       call wa_mpi_Initial(nm,im,jm,km+1)
    endif

    call asc_Initial(km,lm,r_in,r_out)

    allocate(xvz_Lon(0:im-1,jc,0:km))
    allocate(xvz_Lat(0:im-1,jc,0:km))
    allocate(xvz_Rad(0:im-1,jc,0:km))

    allocate(wz_Rad(nc,0:km))

    wz_Rad = spread(z_Rad,1,nc)

    z_Rad_Weight = z_Rad_Weight * Ro**2           ! ro^2 dr の積分重み

    xvz_Lon = spread(xv_Lon,3,km+1)
    xvz_Lat = spread(xv_Lat,3,km+1)
    xvz_Rad = spread(spread(z_Rad,1,jc),1,im)

    CALL MPI_ALLREDUCE(sum(v_Lat_weight),Lat_Weight_Sum,1,MPI_REAL8, &
         MPI_SUM,MPI_COMM_WORLD,IERR)


    call MessageNotify('M','wsc_mpi_initial', &
         'wsc_mpi_module_supack (2017/05/30) is initialized')

  end subroutine wsc_mpi_Initial

  !--------------- 基本変換 -----------------

  function xvz_wc(wc)
    !
    ! スペクトルデータから 3 次元格子点データへ(逆)変換する.
    !
    real(8), dimension(0:im-1,jc,0:km)      :: xvz_wc
    !(out) 3 次元経度緯度動径格子点データ

    real(8), dimension(nc,0:lm), intent(in) :: wc
    !(in) 2 次元球面調和函数 cos スペクトルデータ

    xvz_wc = xva_wa(wz_wc(wc))

  end function xvz_wc

  function wc_xvz(xvz)
    !
    ! 3 次元格子点データからスペクトルデータへ(正)変換する.
    !
    real(8), dimension(nc,0:lm)                    :: wc_xvz
    !(out) 2 次元球面調和函数 cos スペクトルデータ

    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    wc_xvz = wc_wz(wa_xva(xvz))

  end function wc_xvz

  function xvz_ws(ws)
    !
    ! スペクトルデータから 3 次元格子点データへ(逆)変換する.
    !
    real(8), dimension(0:im-1,jc,0:km)      :: xvz_ws
    !(out) 3 次元経度緯度動径格子点データ

    real(8), dimension(nc,lm), intent(in) :: ws
    !(in) 2 次元球面調和函数 sin スペクトルデータ

    xvz_ws = xva_wa(wz_ws(ws))

  end function xvz_ws

  function ws_xvz(xvz)
    !
    ! 3 次元格子点データからスペクトルデータへ(正)変換する.
    !
    real(8), dimension(nc,lm)                    :: ws_xvz
    !(out) 2 次元球面調和函数 sin スペクトルデータ

    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    ws_xvz = ws_wz(wa_xva(xvz))

  end function ws_xvz

  function xvz_wz(wz)
    !
    ! 水平スペクトル・動径格子点データから 3 次元格子点データへ(逆)変換する.
    !
    real(8), dimension(0:im-1,jc,0:km)                     :: xvz_wz
    !(out) 3 次元経度緯度動径格子点データ

    real(8), dimension(nc,0:km), intent(in) :: wz
    !(in) 2 次元球面調和函数スペクトル・動径格子点データ

    xvz_wz = xva_wa(wz)

  end function xvz_wz

  function wz_xvz(xvz)
    !
    ! 3 次元格子データから水平スペクトル・動径格子点データへ(正)変換する.
    !
    real(8), dimension(nc,0:km)             :: wz_xvz
    !(out) 2 次元球面調和函数スペクトル・動径格子点データ

    real(8), dimension(0:im-1,jc,0:km), intent(in)         :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    wz_xvz = wa_xva(xvz)

  end function wz_xvz

  function wz_wc(wc)
    !
    ! スペクトルデータから水平スペクトル・動径格子点データへ(正)変換する.
    !
    real(8), dimension(nc,0:lm), intent(in) :: wc
    !(in) 2 次元球面調和函数 cos スペクトルデータ
    real(8), dimension(nc,0:km)             :: wz_wc
    !(out) 2 次元球面調和函数スペクトル・動径格子点データ

    wz_wc = az_ac(wc)

  end function wz_wc

  function wc_wz(wz)
    !
    ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
    !
    real(8), dimension(nc,0:km), intent(in) :: wz
    !(in) 2 次元球面調和函数スペクトル・動径格子点データ
    real(8), dimension(nc,0:lm)             :: wc_wz
    !(out) 2 次元球面調和函数 cos スペクトルデータ

    wc_wz = ac_az(wz)

  end function wc_wz

  function wz_ws(ws)
    !
    ! スペクトルデータから水平スペクトル・動径格子点データへ(正)変換する.
    !
    real(8), dimension(nc,lm), intent(in) :: ws
    !(in) 2 次元球面調和函数 sin スペクトルデータ
    real(8), dimension(nc,0:km)           :: wz_ws
    !(out) 2 次元球面調和函数スペクトル・動径格子点データ

    wz_ws = az_as(ws)

  end function wz_ws

  function ws_wz(wz)
    !
    ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
    !
    real(8), dimension(nc,0:km), intent(in) :: wz
    !(in) 2 次元球面調和函数スペクトル・動径格子点データ
    real(8), dimension(nc,lm)             :: ws_wz
    !(out) 2 次元球面調和函数 sin スペクトルデータ

    ws_wz = as_az(wz)

  end function ws_wz

  !--------------- 微分計算 -----------------
  function ws_DRad_wc(wc)
    !
    ! 入力スペクトルデータに動径微分 ∂/∂r を作用する.
    !
    ! スペクトルデータの動径微分とは, 対応する格子点データに動径微分を
    ! 作用させたデータのスペクトル変換のことである.
    !
    real(8), dimension(nc,0:lm), intent(in) :: wc
    !(in) 2 次元球面調和函数 cos スペクトルデータ

    real(8), dimension(nc,lm)               :: ws_DRad_wc
    !(in) 動径微分された2 次元球面調和函数 sin スペクトルデータ

    ws_DRad_wc = as_Dr_ac(wc)

  end function ws_DRad_wc

  function wc_DRad_ws(ws)
    !
    ! 入力スペクトルデータに動径微分 ∂/∂r を作用する.
    !
    ! スペクトルデータの動径微分とは, 対応する格子点データに動径微分を
    ! 作用させたデータのスペクトル変換のことである.
    !
    real(8), dimension(nc,lm), intent(in) :: ws
    !(in) 2 次元球面調和函数 sin スペクトルデータ

    real(8), dimension(nc,0:lm)           :: wc_DRad_ws
    !(in) 動径微分された2 次元球面調和函数 cos スペクトルデータ

    wc_DRad_ws = ac_Dr_as(ws)

  end function wc_DRad_ws

  function ws_DivRad_wc(wc)
    !
    ! 入力スペクトルデータに近似的発散型動径微分 ∂/∂r を作用する.
    !
    ! スペクトルデータの発散型動径微分とは, 対応する格子点データに
    ! 発散型動径微分を作用させたデータのスペクトル変換のことである.
    !
    real(8), dimension(nc,0:lm), intent(in) :: wc
    !(in) 2 次元球面調和函数 cos スペクトルデータ

    real(8), dimension(nc,lm)               :: ws_DivRad_wc
    !(out) 発散型動径微分を作用された 2 次元スペクトルデータ

    ws_DivRad_wc = ws_Drad_wc(wc)

  end function ws_DivRad_wc

  function wc_DivRad_ws(ws)
    !
    ! 入力スペクトルデータに近似的発散型動径微分 ∂/∂r を作用する.
    !
    ! スペクトルデータの発散型動径微分とは, 対応する格子点データに
    ! 発散型動径微分を作用させたデータのスペクトル変換のことである.
    !
    real(8), dimension(nc,lm), intent(in) :: ws
    !(in) 2 次元球面調和函数 sin スペクトルデータ

    real(8), dimension(nc,0:lm)           :: wc_DivRad_ws
    !(out) 発散型動径微分を作用された 2 次元スペクトルデータ

    wc_DivRad_ws = wc_Drad_ws(ws)

  end function wc_DivRad_ws

  function ws_RotRad_wc(wc)
    !
    ! 入力スペクトルデータに近似的回転型動径微分 ∂/∂r を作用する.
    !
    ! スペクトルデータの回転型動径微分とは, 対応する格子点データに
    ! 回転型動径微分を作用させたデータのスペクトル変換のことである.
    !
    real(8), dimension(nc,0:lm), intent(in) :: wc
    !(in) 2 次元球面調和函数 cos スペクトルデータ

    real(8), dimension(nc,lm)               :: ws_RotRad_wc
    !(out) 回転型動径微分を作用された 2 次元スペクトルデータ

    ws_RotRad_wc = ws_Drad_wc(wc)

  end function ws_RotRad_wc

  function wc_RotRad_ws(ws)
    !
    ! 入力スペクトルデータに近似的回転型動径微分 ∂/∂r を作用する.
    !
    ! スペクトルデータの回転型動径微分とは, 対応する格子点データに
    ! 回転型動径微分を作用させたデータのスペクトル変換のことである.
    !
    real(8), dimension(nc,lm), intent(in) :: ws
    !(in) 2 次元球面調和函数 sin スペクトルデータ

    real(8), dimension(nc,0:lm)           :: wc_RotRad_ws
    !(out) 回転型動径微分を作用された 2 次元スペクトルデータ

    wc_RotRad_ws = wc_Drad_ws(ws)

  end function wc_RotRad_ws

  function wc_Lapla_wc(wc)
    !
    ! 入力スペクトルデータに近似的ラプラシアン
    !
    !     ▽^2 =   1/a^2 cos^2φ・∂^2/∂λ^2 
    !            + 1/a^2 cosφ・∂/∂φ(cosφ∂/∂φ) 
    !            + ∂^2/∂r^2
    !
    ! を作用する.
    !
    ! スペクトルデータのラプラシアンとは, 対応する格子点データに
    ! ラプラシアンを作用させたデータのスペクトル変換のことである.
    !
    real(8), dimension(nc,0:lm), intent(in) :: wc
    !(in) 2 次元球面調和函数 cos スペクトルデータ

    real(8), dimension(nc,0:lm)             :: wc_Lapla_wc
    !(out) ラプラシアンを作用された 2 次元スペクトルデータ

    wc_Lapla_wc = wc_DivRad_ws(ws_Drad_wc(wc)) + wa_Lapla_wa(wc)/Ro**2

  end function wc_Lapla_wc

  function ws_Lapla_ws(ws)
    !
    ! 入力スペクトルデータに近似的ラプラシアン
    !
    !     ▽^2 =   1/a^2 cos^2φ・∂^2/∂λ^2 
    !            + 1/a^2 cosφ・∂/∂φ(cosφ∂/∂φ) 
    !            + ∂^2/∂r^2
    !
    ! を作用する.
    !
    ! スペクトルデータのラプラシアンとは, 対応する格子点データに
    ! ラプラシアンを作用させたデータのスペクトル変換のことである.
    !
    real(8), dimension(nc,lm), intent(in) :: ws
    !(in) 2 次元球面調和函数 sin スペクトルデータ

    real(8), dimension(nc,lm)             :: ws_Lapla_ws
    !(out) ラプラシアンを作用された 2 次元スペクトルデータ

    ws_Lapla_ws = ws_DivRad_wc(wc_Drad_ws(ws)) + wa_Lapla_wa(ws)/Ro**2

  end function ws_Lapla_ws

  function wc_LaplaInv_wc(wc)
    !
    ! スペクトルデータに逆ラプラシアンを作用させる. 
    !
    real(8), dimension(nc,0:lm),intent(in) :: wc
    real(8), dimension(nc,0:lm)            :: wc_LaplaInv_wc

    real(8), allocatable, dimension(:,:)   :: wc_LaplaInvFactor
    logical :: first=.true.
    integer :: n, m, l, nn, nmary(2)

    save first, wc_LaplaInvFactor

    if ( first ) then
       first = .false.
       allocate(wc_LaplaInvFactor(nc,0:lm))
       do nn=1,nc
          nmary=nm_l(nn)
          n = nmary(1) ; m = nmary(2)
          do l=0,lm
             if ( n==0 .and. l==0 ) then
                wc_LaplaInvFactor(nn,l) = 0.0D0
             else
                wc_LaplaInvFactor(nn,l) &
                     = -1.0D0/( n*(n+1)/Ro**2 + (PI/(Ro-Ri)*l)**2 )
             end if
          end do
       end do
    end if

    wc_LaplaInv_wc = wc_LaplaInvFactor * wc

  end function wc_LaplaInv_wc

  function ws_LaplaInv_ws(ws)
    !
    ! スペクトルデータに逆ラプラシアンを作用させる. 
    !
    real(8), dimension(nc,lm),intent(in) :: ws
    real(8), dimension(nc,lm)            :: ws_LaplaInv_ws

    real(8), allocatable, dimension(:,:) :: ws_LaplaInvFactor
    logical :: first=.true.
    integer :: n, m, l, nn, nmary(2)

    save first, ws_LaplaInvFactor

    if ( first ) then
       first = .false.
       allocate(ws_LaplaInvFactor(nc,lm))
       do nn=1,nc
          nmary=nm_l(nn)
          n = nmary(1) ; m = nmary(2)
          do l=1,lm
             ws_LaplaInvFactor(nn,l) &
                  = -1.0D0/( n*(n+1)/Ro**2 + (PI/(Ro-Ri)*l)**2 )
          end do
       end do
    end if

    ws_LaplaInv_ws = ws_LaplaInvFactor * ws

  end function ws_LaplaInv_ws

  function xvz_GradLon_wc(wc)
    !
    ! スペクトルデータに近似的勾配型経度微分 1/(a cosφ)・∂/∂λ
    ! を作用させる.
    !
    real(8), dimension(nc,0:lm), intent(in) :: wc
    !(in) 2 次元球面調和函数 cos スペクトルデータ

    real(8), dimension(0:im-1,jc,0:km)                     :: xvz_GradLon_wc
    !(out) 勾配型経度微分を作用された 2 次元スペクトルデータ

    xvz_GradLon_wc = xva_GradLon_wa(wz_wc(wc))/Ro

  end function xvz_GradLon_wc

  function xvz_GradLon_ws(ws)
    !
    ! スペクトルデータに近似的勾配型経度微分 1/(a cosφ)・∂/∂λ
    ! を作用させる.
    !
    real(8), dimension(nc,lm), intent(in) :: ws
    !(in) 2 次元球面調和函数 cos スペクトルデータ

    real(8), dimension(0:im-1,jc,0:km)    :: xvz_GradLon_ws
    !(out) 勾配型経度微分を作用された 2 次元スペクトルデータ

    xvz_GradLon_ws = xva_GradLon_wa(wz_ws(ws))/Ro

  end function xvz_GradLon_ws

  function xvz_GradLat_wc(wc) 
    !
    ! スペクトルデータに近似的勾配型経度微分 1/a ∂/∂φ を作用させる.
    !
    real(8), dimension(nc,0:lm), intent(in) :: wc
    !(in) 2 次元球面調和函数 cos スペクトルデータ

    real(8), dimension(0:im-1,jc,0:km)      :: xvz_GradLat_wc
    !(out) 勾配型緯度微分を作用された 2 次元スペクトルデータ

    xvz_GradLat_wc = xva_GradLat_wa(wz_wc(wc))/Ro
  end function xvz_GradLat_wc

  function xvz_GradLat_ws(ws) 
    !
    ! スペクトルデータに近似的勾配型経度微分 1/a ∂/∂φ を作用させる.
    !
    real(8), dimension(nc,lm), intent(in) :: ws
    !(in) 2 次元球面調和函数 sin スペクトルデータ

    real(8), dimension(0:im-1,jc,0:km)    :: xvz_GradLat_ws
    !(out) 勾配型緯度微分を作用された 2 次元スペクトルデータ

    xvz_GradLat_ws = xva_GradLat_wa(wz_ws(ws))/Ro
  end function xvz_GradLat_ws

  function wc_DivLon_xvz(xvz)
    ! 
    ! 格子点データに近似的発散型経度微分 1/(a cosφ)・∂/∂λ を作用させた
    ! スペクトルデータを返す.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    real(8), dimension(nc,0:lm)                    :: wc_DivLon_xvz
    !(out) 発散型経度微分を作用された 2 次元スペクトルデータ

    wc_DivLon_xvz = wc_wz(wa_DivLon_xva(xvz/Ro))
  end function wc_DivLon_xvz

  function wc_DivLat_xvz(xvz)
    !
    ! 格子データに近似的発散型緯度微分 1/(a cosφ)・∂(f cosφ)/∂φ を
    ! 作用させたスペクトルデータを返す.
    !
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in)   :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    real(8), dimension(nc,0:lm)       :: wc_DivLat_xvz
    !(out) 発散型緯度微分を作用された 2 次元スペクトルデータ

    wc_DivLat_xvz = wc_wz(wa_divlat_xva(xvz/Ro))
  end function wc_DivLat_xvz

  function ws_DivLon_xvz(xvz)
    ! 
    ! 格子点データに近似的発散型経度微分 1/(a cosφ)・∂/∂λ を作用させた
    ! スペクトルデータを返す.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    real(8), dimension(nc,lm)                      :: ws_DivLon_xvz
    !(out) 発散型経度微分を作用された 2 次元スペクトルデータ

    ws_DivLon_xvz = ws_wz(wa_DivLon_xva(xvz/Ro))
  end function ws_DivLon_xvz

  function ws_DivLat_xvz(xvz)
    !
    ! 格子データに近似的発散型緯度微分 1/(a cosφ)・∂(f cosφ)/∂φ を
    ! 作用させたスペクトルデータを返す.
    !
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    real(8), dimension(nc,lm)                      :: ws_DivLat_xvz
    !(out) 発散型緯度微分を作用された 2 次元スペクトルデータ

    ws_DivLat_xvz = ws_wz(wa_divlat_xva(xvz/Ro))
  end function ws_DivLat_xvz

  function wc_Div_xvz_xvz_xvz(xvz_Vlon,xvz_Vlat,xvz_Vrad)
    !
    ! べクトル成分である 3 つの格子データに近似的発散を作用させた
    ! スペクトルデータを返す.
    !
    ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分, 
    ! 動径成分を表し, 近似的発散は 
    !
    !   1/(a cosφ)・∂u/∂λ + 1/(a cosφ)・∂(v cosφ)/∂φ + ∂w/∂r 
    !
    ! と計算される.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vlon
    !(in) ベクトル場の経度成分

    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vlat
    !(in) ベクトル場の緯度成分

    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vrad
    !(in) ベクトル場の動径成分

    real(8), dimension(nc,0:lm)     :: wc_Div_xvz_xvz_xvz
    !(out) ベクトル場の発散

    wc_Div_xvz_xvz_xvz =   wc_DivLon_xvz(xvz_Vlon) &
         + wc_DivLat_xvz(xvz_Vlat) &
         + wc_DivRad_ws(ws_xvz(xvz_Vrad))

  end function wc_Div_xvz_xvz_xvz

  function ws_Div_xvz_xvz_xvz(xvz_Vlon,xvz_Vlat,xvz_Vrad)
    !
    ! べクトル成分である 3 つの格子データに近似的発散を作用させた
    ! スペクトルデータを返す.
    !
    ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分, 
    ! 動径成分を表し, 近似的発散は 
    !
    !   1/(a cosφ)・∂u/∂λ + 1/(a cosφ)・∂(v cosφ)/∂φ + ∂w/∂r 
    !
    ! と計算される.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vlon
    !(in) ベクトル場の経度成分

    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vlat
    !(in) ベクトル場の緯度成分

    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vrad
    !(in) ベクトル場の動径成分

    real(8), dimension(nc,lm)     :: ws_Div_xvz_xvz_xvz
    !(out) ベクトル場の発散

    ws_Div_xvz_xvz_xvz =   ws_DivLon_xvz(xvz_Vlon) &
         + ws_DivLat_xvz(xvz_Vlat) &
         + ws_DivRad_wc(wc_xvz(xvz_Vrad))

  end function ws_Div_xvz_xvz_xvz

  function xvz_Div_xvz_xvz_xvz(xvz_Vlon,xvz_Vlat,xvz_Vrad)
    !
    ! ベクトル成分である 3 つの格子データに近似的発散を作用させる.
    !
    ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分, 
    ! 動径成分を表す.
    !
    ! 極の特異性を回避するためにベクトル場に cosφ/r の重みをかけて
    ! 計算している. 
    !
    !      div V = (1/cosφ)・div (Vcosφ) + V_φtanφ/a
    ! 
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vlon
    !(in) ベクトル場の経度成分

    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vlat
    !(in) ベクトル場の緯度成分

    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vrad
    !(in) ベクトル場の動径成分

    real(8), dimension(0:im-1,jc,0:km)             :: xvz_Div_xvz_xvz_xvz
    !(out) ベクトル場の発散

    xvz_Div_xvz_xvz_xvz &
         = 1.0D0/cos(xvz_Lat) &
         * xvz_wc(wc_Div_xvz_xvz_xvz(xvz_VLon*cos(xvz_Lat),  &
         xvz_VLat*cos(xvz_Lat),  &
         xvz_VRad*cos(xvz_Lat))) &
         + xvz_VLat*tan(xvz_Lat)/Ro

  end function xvz_Div_xvz_xvz_xvz

!!$    function xvz_RotLon_wt_wt(wt_Vrad,wt_Vlat) 
!!$      !
!!$      ! ベクトル場の動径成分, 緯度成分である第 1, 2 引数 Vrad, Vlat から
!!$      ! 回転の経度成分 
!!$      !
!!$      !    1/r ∂Vrad/∂φ-1/r ∂(r Vlat)/∂r を計算する.
!!$      !
!!$      ! を計算する
!!$      !
!!$      real(8), dimension(nc,0:lm), intent(in) :: wt_Vrad
!!$      !(in) ベクトル場の動径成分
!!$
!!$      real(8), dimension(nc,0:lm), intent(in) :: wt_Vlat
!!$      !(in) ベクトル場の緯度成分
!!$
!!$      real(8), dimension(0:im-1,jc,0:km)                     :: xvz_RotLon_wt_wt
!!$      !(out) ベクトル場の回転の経度成分
!!$
!!$        xvz_RotLon_wt_wt =   xvz_GradLat_wt(wt_Vrad) &
!!$                           - xvz_wt(wt_RotRad_wt(wt_Vlat))
!!$
!!$    end function xvz_RotLon_wt_wt
!!$
!!$    function xvz_RotLat_wt_wt(wt_Vlon,wt_Vrad) 
!!$      !
!!$      ! ベクトル場の経度成分, 動径成分である第 1, 2 引数 Vlon, Vrad から
!!$      ! 回転の緯度成分 
!!$      !
!!$      !    1/r ∂(r Vlon)/∂r - 1/rcosφ・∂Vrad/∂λ
!!$      !
!!$      ! を計算する.
!!$      !
!!$      real(8), dimension(nc,0:lm), intent(in) :: wt_Vlon
!!$      !(in) ベクトル場の経度成分
!!$
!!$      real(8), dimension(nc,0:lm), intent(in) :: wt_Vrad
!!$      !(in) ベクトル場の動径成分
!!$
!!$      real(8), dimension(0:im-1,jc,0:km)                     :: xvz_RotLat_wt_wt
!!$      !(out) ベクトル場の回転の緯度成分
!!$
!!$        xvz_RotLat_wt_wt =   xvz_wt(wt_RotRad_wt(wt_Vlon)) &
!!$                           - xvz_GradLon_wt(wt_Vrad) 
!!$
!!$    end function xvz_RotLat_wt_wt

  function wc_RotRad_xvz_xvz(xvz_Vlat,xvz_Vlon) 
    !
    ! ベクトルの緯度成分, 経度成分である第 1, 2 引数 Vlat, Vlon に対して
    ! ベクトル場の近似的回転の動径成分 
    !
    !    1/(a cosφ)・∂Vlat/∂λ - 1/(a cosφ)・∂(Vlon cosφ)/∂φ
    !
    ! を計算する.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vlat
    !(in) ベクトル場の緯度成分

    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_Vlon
    !(in) ベクトル場の経度成分

    real(8), dimension(nc,0:lm)     :: wc_RotRad_xvz_xvz
    !(out) ベクトル場の回転の動径成分

    wc_RotRad_xvz_xvz =   wc_DivLon_xvz(xvz_Vlat) &
         - wc_DivLat_xvz(xvz_Vlon)

  end function wc_RotRad_xvz_xvz

  !--------------- ポロイダル/トロイダルモデル用微分 -----------------
  function wc_KxRGrad_wc(wc)
    !
    ! 入力スペクトルデータに経度微分 k×r・▽ = ∂/∂λを作用する.
    !
    real(8), dimension(nc,0:lm), intent(in) :: wc
    !(in) 2 次元球面調和函数 cos スペクトルデータ

    real(8), dimension(nc,0:lm)             :: wc_KxRGrad_wc
    !(out) 経度微分を作用された 2 次元スペクトルデータ

    wc_KxRGrad_wc =  wa_Dlon_wa(wc)

  end function wc_KxRGrad_wc

  function ws_KxRGrad_ws(ws)
    !
    ! 入力スペクトルデータに経度微分 k×r・▽ = ∂/∂λを作用する.
    !
    real(8), dimension(nc,lm), intent(in) :: ws
    !(in) 2 次元球面調和函数 sin スペクトルデータ

    real(8), dimension(nc,lm)             :: ws_KxRGrad_ws
    !(out) 経度微分を作用された 2 次元スペクトルデータ

    ws_KxRGrad_ws =  wa_Dlon_wa(ws)

  end function ws_KxRGrad_ws

  function wc_L2_wc(wc)
    !
    ! 入力スペクトルデータに L^2 演算子(=-水平ラプラシアン)を作用する.
    !
    ! L^2 演算子は単位球面上の水平ラプラシアンの逆符号にあたる.
    !  入力スペクトルデ ータに対応する格子点データに演算子
    !
    !     L^2 = -1/cos^2φ・∂^2/∂λ^2 - 1/cosφ・∂/∂φ(cosφ∂/∂φ)
    !
    ! を作用させたデータのスペクトル変換が返される.
    !
    real(8), dimension(nc,0:lm), intent(in) :: wc
    !(in) 2 次元球面調和函数 cos スペクトルデータ

    real(8), dimension(nc,0:lm)             :: wc_L2_wc
    !(out) L^2 演算子を作用された 2 次元スペクトルデータ

    wc_L2_wc = -wa_Lapla_wa(wc)

  end function wc_L2_wc

  function ws_L2_ws(ws)
    !
    ! 入力スペクトルデータに L^2 演算子(=-水平ラプラシアン)を作用する.
    !
    ! L^2 演算子は単位球面上の水平ラプラシアンの逆符号にあたる.
    !  入力スペクトルデ ータに対応する格子点データに演算子
    !
    !     L^2 = -1/cos^2φ・∂^2/∂λ^2 - 1/cosφ・∂/∂φ(cosφ∂/∂φ)
    !
    ! を作用させたデータのスペクトル変換が返される.
    !
    real(8), dimension(nc,lm), intent(in) :: ws
    !(in) 2 次元球面調和函数 sin スペクトルデータ

    real(8), dimension(nc,lm)             :: ws_L2_ws
    !(out) L^2 演算子を作用された 2 次元スペクトルデータ

    ws_L2_ws = -wa_Lapla_wa(ws)

  end function ws_L2_ws

  function wc_L2Inv_wc(wc)
    !
    ! 入力スペクトルデータに L^2 演算子の逆演算(-逆水平ラプラシアン)を
    ! 作用する.
    !
    ! スペクトルデータに L^2 演算子を作用させる関数 wc_L2_wc の逆計算を
    ! 行う関数である.
    !
    real(8), dimension(nc,0:lm), intent(in) :: wc
    !(in) 2 次元球面調和函数 cos スペクトルデータ

    real(8), dimension(nc,0:lm)             :: wc_L2Inv_wc
    !(out) L^2 演算子の逆演算を作用された 2 次元スペクトルデータ

    wc_L2Inv_wc = -wa_LaplaInv_wa(wc)

  end function wc_L2Inv_wc

  function ws_L2Inv_ws(ws)
    !
    ! 入力スペクトルデータに L^2 演算子の逆演算(-逆水平ラプラシアン)を
    ! 作用する.
    !
    ! スペクトルデータに L^2 演算子を作用させる関数 ws_L2_ws の逆計算を
    ! 行う関数である.
    !
    real(8), dimension(nc,lm), intent(in) :: ws
    !(in) 2 次元球面調和函数 sin スペクトルデータ

    real(8), dimension(nc,lm)             :: ws_L2Inv_ws
    !(out) L^2 演算子の逆演算を作用された 2 次元スペクトルデータ

    ws_L2Inv_ws = -wa_LaplaInv_wa(ws)

  end function ws_L2Inv_ws

  function wc_RadRot_xvz_xvz(xvz_VLON,xvz_VLAT)  ! r・(▽×v)
    !
    ! ベクトルの渦度と動径ベクトルの内積 r・(▽×v) を計算する.
    !
    ! 第 1, 2 引数(v[λ], v[φ])がそれぞれベクトルの経度成分, 緯度成分を表す.
    !
    !    r・(▽×v) = 1/cosφ・∂v[φ]/∂λ - 1/cosφ・∂(v[λ] cosφ)/∂φ
    !
    ! のスペクトル データが返される.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_VLON
    !(in) ベクトルの経度成分

    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_VLAT
    !(in) ベクトルの緯度成分

    real(8), dimension(nc,0:lm)     :: wc_RadRot_xvz_xvz
    !(out) ベクトルの渦度と動径ベクトルの内積

    wc_RadRot_xvz_xvz = wc_wz(wa_DivLon_xva(xvz_VLAT) &
         - wa_DivLat_xva(xvz_VLON))

  end function wc_RadRot_xvz_xvz

  function ws_RadRotRot_xvz_xvz_xvz(xvz_VLON,xvz_VLAT,xvz_VRAD) 
    ! 
    ! ベクトル v に対して近似的な r・(▽×▽×v) を計算する.
    !
    ! 第 1, 2, 3 引数(v[λ], v[φ], v[r])がそれぞれベクトルの経度成分, 
    ! 緯度成分, 動径成分を表す. 
    !
    !    r・(▽×▽×v)  = ∂/∂r ((  1/cosφ・∂v[λ]/∂λ 
    !                               + 1/cosφ・∂(v[φ] cosφ)/∂φ ) ) 
    !                     + L^2 v[r]/a 
    !
    ! のスペクトルデータが返される.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_VLON
    !(in) ベクトルの経度成分

    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_VLAT
    !(in) ベクトルの緯度成分

    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz_VRAD
    !(in) ベクトルの動径成分

    real(8), dimension(nc,lm)     :: ws_RadRotRot_xvz_xvz_xvz
    !(out) ベクトル v の r・(▽×▽×v) 

    ws_RadRotRot_xvz_xvz_xvz = &
         ws_RotRad_wc(wc_wz( &
         (wa_DivLon_xva(xvz_VLON)+ wa_DivLat_xva(xvz_VLAT)))) &
         + ws_L2_ws(ws_xvz(xvz_VRAD/Ro))

  end function ws_RadRotRot_xvz_xvz_xvz

  subroutine wsc_Potential2VectorMPI(&
       xvz_VLON,xvz_VLAT,xvz_VRAD,wc_TORPOT,ws_POLPOT)
    !
    ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
    !
    !     v = ▽x(Ψr) + ▽x▽x(Φr) 
    !
    ! の各成分を計算する
    !
    real(8), dimension(0:im-1,jc,0:km)     :: xvz_VLON
    !(out) ベクトル場の経度成分

    real(8), dimension(0:im-1,jc,0:km)     :: xvz_VLAT
    !(out) ベクトル場の緯度成分

    real(8), dimension(0:im-1,jc,0:km)     :: xvz_VRAD
    !(out) ベクトル場の動径成分

    real(8), dimension(nc,0:lm), intent(in) :: wc_TORPOT
    !(in) トロイダルポテンシャル

    real(8), dimension(nc,lm), intent(in)   :: ws_POLPOT
    !(in) ポロイダルポテンシャル

    xvz_VLON =   Ro * xvz_GradLat_wc(wc_TORPOT) &
         + xva_GradLon_wa(wz_wc(wc_RotRad_ws(ws_POLPOT)))
    xvz_VLAT = - Ro * xvz_GradLon_wc(wc_TORPOT) &
         + xva_GradLat_wa(wz_wc(wc_RotRad_ws(ws_POLPOT)))
    xvz_VRAD = xvz_ws(ws_L2_ws(ws_POLPOT))/Ro

  end subroutine wsc_Potential2VectorMPI

  subroutine wsc_Potential2RotationMPI(&
       xvz_RotVLON,xvz_RotVLAT,xvz_RotVRAD,wc_TORPOT,ws_POLPOT)
    !
    ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
    !
    !     v = ▽x(Ψr) + ▽x▽x(Φr) 
    !
    ! に対して, その回転
    !
    !     ▽xv = ▽x▽x(Ψr) + ▽x▽x▽x(Φr) = ▽x▽x(Ψr) - ▽x((▽^2Φ)r)
    !
    ! を計算する. 

    ! ベクトル場の回転
    real(8), dimension(0:im-1,jc,0:km), intent(OUT) :: xvz_RotVLON
    !(out) 回転の経度成分

    real(8), dimension(0:im-1,jc,0:km), intent(OUT) :: xvz_RotVLAT
    !(out) 回転の緯度成分

    real(8), dimension(0:im-1,jc,0:km), intent(OUT) :: xvz_RotVRAD
    !(out) 回転の動径成分

    ! 入力ベクトル場を表すポテンシャル
    real(8), dimension(nc,0:lm), intent(in) :: wc_TORPOT
    !(in) トロイダルポテンシャル

    real(8), dimension(nc,lm), intent(in)   :: ws_POLPOT
    !(in) ポロイダルポテンシャル

    xvz_RotVLON =   Ro * xvz_GradLat_ws(-ws_Lapla_ws(ws_POLPOT)) &
         + xva_GradLon_wa(wz_ws(ws_RotRad_wc(wc_TORPOT)))
    xvz_RotVLAT = - Ro * xvz_GradLon_ws(-ws_Lapla_ws(ws_POLPOT)) &
         + xva_GradLat_wa(wz_ws(ws_RotRad_wc(wc_TORPOT)))
    xvz_RotVRAD = xvz_wc(wc_L2_wc(wc_TORPOT))/Ro

  end subroutine wsc_Potential2RotationMPI

  !--------------- 積分計算 -----------------
  !----(入力データ xvz)---
  function vz_IntLon_xvz(xvz)  ! 経度(帯状)積分
    !
    ! 3 次元格子点データの経度方向(帯状)積分.
    !
    ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)dλ を計算する.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    real(8), dimension(jc,0:km)  :: vz_IntLon_xvz
    !(out) 経度方向(帯状)積分された 2 次元子午面格子点データ

    integer :: i

    vz_IntLon_xvz = 0.0d0
    do i=0,im-1
       vz_IntLon_xvz(:,:) = vz_IntLon_xvz(:,:) &
            + xvz(i,:,:) * x_Lon_Weight(i)
    enddo
  end function vz_IntLon_xvz

  function xz_IntLat_xvz(xvz)
    !
    ! 3 次元格子点データの緯度方向域積分.
    !
    ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) cosφ dφ を計算する.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    real(8), dimension(0:im-1,0:km)  :: xz_IntLat_xvz        ! 緯度円格子点データ
    !(out) 緯度積分された 2 次元緯度動径格子点データ

    real(8), dimension(0:im-1,0:km)  :: xz_IntLatTMP
    integer :: j

    xz_IntLat_xvz = 0.0d0
    do j=1,jc
       xz_IntLat_xvz(:,:) = xz_IntLat_xvz(:,:) &
            + xvz(:,j,:) * v_Lat_Weight(j)
    enddo
    xz_IntLatTmp=xz_IntLat_xvz
    CALL MPI_ALLREDUCE(xz_IntLatTMP,xz_IntLat_xvz,im*(km+1),MPI_REAL8, &
         MPI_SUM,MPI_COMM_WORLD,IERR)

  end function xz_IntLat_xvz

  function xv_IntRad_xvz(xvz)  ! 動径積分
    !
    ! 3 次元格子点データの動径方向域積分.
    !
    ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) r^2dr を計算する.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    real(8), dimension(0:im-1,jc)  :: xv_IntRad_xvz
    !(out) 動径積分された 2 次元経度緯度(水平, 球面)格子点データ

    integer :: k

    xv_IntRad_xvz = 0.0d0
    do k=0,km
       xv_IntRad_xvz(:,:) = xv_IntRad_xvz(:,:) &
            + xvz(:,:,k) * z_Rad_Weight(k) 
    enddo
  end function xv_IntRad_xvz

  function x_IntLatRad_xvz(xvz)
    !
    ! 3 次元格子点データの緯度動径(子午面)積分
    !
    ! 3 次元データ f(λ,φ,r) に対して
    !
    !    ∫f(λ,φ,r) r^2cosφ dφdr 
    !
    ! を計算する.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    real(8), dimension(0:im-1)     :: x_IntLatRad_xvz
    !(out) 緯度動径(子午面)積分された 1 次元経度格子点データ

    real(8), dimension(0:im-1)     :: x_IntLatRadTMP
    integer :: j, k

    x_IntLatRad_xvz = 0
    do k=0,km
       do j=1,jc
          x_IntLatRad_xvz = x_IntLatRad_xvz &
               + xvz(:,j,k) * v_Lat_Weight(j) * z_Rad_Weight(k)
       enddo
    enddo

    x_IntLatRadTmp=x_IntLatRad_xvz
    CALL MPI_ALLREDUCE(x_IntLatRadTMP,x_IntLatRad_xvz,im,MPI_REAL8, &
         MPI_SUM,MPI_COMM_WORLD,IERR)

  end function x_IntLatRad_xvz

  function v_IntLonRad_xvz(xvz)
    !
    ! 3 次元格子点データの経度動径(緯度円)積分.
    !
    ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) r^2dλdr を計算する.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    real(8), dimension(jc)       :: v_IntLonRad_xvz
    !(out) 経度動径(緯度円)積分された 1 次元緯度格子点データ

    integer :: i, k

    v_IntLonRad_xvz = 0
    do k=0,km
       do i=0,im-1
          v_IntLonRad_xvz = v_IntLonRad_xvz &
               + xvz(i,:,k) * x_Lon_Weight(i) * z_Rad_Weight(k)
       enddo
    enddo
  end function v_IntLonRad_xvz

  function z_IntLonLat_xvz(xvz)  ! 緯度経度(水平)積分
    !
    ! 3 次元格子点データの緯度経度(水平, 球面)積分
    ! 
    ! 3 次元データ f(λ,φ,r) に対して
    !
    !    ∫f(λ,φ,r) cosφ dλdφ 
    !
    ! を計算する.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    real(8), dimension(0:km)     :: z_IntLonLat_xvz
    !(out) 緯度経度(水平, 球面)積分された 1 次元動径格子点データ

    real(8), dimension(0:km)     :: z_IntLonLatTMP
    integer :: i, j

    z_IntLonLat_xvz = 0
    do j=1,jc
       do i=0,im-1
          z_IntLonLat_xvz = z_IntLonLat_xvz &
               + xvz(i,j,:) * x_Lon_Weight(i) * v_Lat_Weight(j)
       enddo
    enddo

    z_IntLonLatTmp=z_IntLonLat_xvz
    CALL MPI_ALLREDUCE(z_IntLonLatTMP,z_IntLonLat_xvz,km+1,MPI_REAL8, &
         MPI_SUM,MPI_COMM_WORLD,IERR)

  end function z_IntLonLat_xvz

  function IntLonLatRad_xvz(xvz) ! 緯度経度動径(全球)積分
    !
    ! 3 次元格子点データの緯度経度動径(全球)積分
    !
    ! 3 次元データ f(λ,φ,r) に対して
    !
    !     ∫f(λ,φ,r) r^2cosφ dλdφdr 
    !
    ! を計算する.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz 
    !(in) 3 次元経度緯度動径格子点データ

    real(8)                     :: IntLonLatRad_xvz 
    !(out) 全球積分値

    real(8)                     :: IntLonLatRadTMP
    integer :: i, j, k

    IntLonLatRad_xvz = 0
    do k=0,km
       do j=1,jc
          do i=0,im-1
             IntLonLatRad_xvz = IntLonLatRad_xvz &
                  + xvz(i,j,k) * x_Lon_Weight(i) &
                  * v_Lat_Weight(j) * z_Rad_Weight(k)
          enddo
       enddo
    enddo

    IntLonLatRadTmp=IntLonLatRad_xvz
    CALL MPI_ALLREDUCE(IntLonLatRadTMP,IntLonLatRad_xvz,1,MPI_REAL8, &
         MPI_SUM,MPI_COMM_WORLD,IERR)

  end function IntLonLatRad_xvz

  !----(入力データ vz)---
  function z_IntLat_vz(vz)  ! 緯度積分
    !
    ! 2 次元(VZ)格子点データの緯度方向域積分.
    !
    ! 2 次元データ f(φ,r) に対して∫f(φ,r) cosφ dφ を計算する.
    !
    real(8), dimension(jc,0:km), intent(in) :: vz
    !(in) 2 次元緯度動径(子午面)格子点データ

    real(8), dimension(0:km)  :: z_IntLat_vz
    !(out) 緯度積分された 1 次元動径格子点データ

    real(8), dimension(0:km)  :: z_IntLatTMP
    integer :: j

    z_IntLat_vz = 0.0d0
    do j=1,jc
       z_IntLat_vz(:) = z_IntLat_vz(:) + vz(j,:) * v_Lat_Weight(j)
    enddo
    z_IntLatTmp=z_IntLat_vz
    CALL MPI_ALLREDUCE(z_IntLatTMP,z_IntLat_vz,km+1,MPI_REAL8, &
         MPI_SUM,MPI_COMM_WORLD,IERR)

  end function z_IntLat_vz

  function v_IntRad_vz(vz)  ! 動径積分
    !
    ! 2 次元(VZ)格子点データの動径方向域積分.
    !
    ! 2 次元データ f(φ,r) に対して∫f(φ,r) r^2dr を計算する.
    !
    real(8), dimension(jc,0:km), intent(in) :: vz
    !(in) 2 次元緯度動径(子午面)格子点データ

    real(8), dimension(jc)  :: v_IntRad_vz
    !(out) 動径積分された 1 次元緯度格子点データ

    integer :: k

    v_IntRad_vz = 0.0d0
    do k=0,km
       v_IntRad_vz(:) = v_IntRad_vz(:) &
            + vz(:,k) * z_Rad_Weight(k) 
    enddo
  end function v_IntRad_vz

  function IntLatRad_vz(vz)
    !
    ! 2 次元(VZ)格子点データの緯度動径積分(子午面)および平均
    !
    ! 2 次元データ f(φ,r) に対して ∫f(φ,r) r^2cosφ dφdr を計算する.
    !
    real(8), dimension(jc,0:km), intent(in) :: vz
    !(in) 2 次元緯度動径(子午面)格子点データ

    real(8)                   :: IntLatRad_vz
    !(out) 積分値

    real(8)                   :: IntLatRadTMP
    integer :: j, k

    IntLatRad_vz = 0
    do k=0,km
       do j=1,jc
          IntLatRad_vz = IntLatRad_vz &
               + vz(j,k) * v_Lat_Weight(j) * z_Rad_Weight(k)
       enddo
    enddo

    IntLatRadTmp=IntLatRad_vz
    CALL MPI_ALLREDUCE(IntLatRadTMP,IntLatRad_vz,1,MPI_REAL8, &
         MPI_SUM,MPI_COMM_WORLD,IERR)

  end function IntLatRad_vz

  !----(入力データ xz)---
  function z_IntLon_xz(xz)
    !
    ! 2 次元(XZ)格子点データの経度方向積分.
    !
    ! 2 次元データ f(λ,r) に対して ∫f(λ,r)dλ を計算する.
    !
    real(8), dimension(0:im-1,0:km), intent(in) :: xz
    !(in) 2 次元緯度動径格子点データ

    real(8), dimension(0:km)  :: z_IntLon_xz
    !(out) 経度積分された 1 次元動径格子点データ

    integer :: i

    z_IntLon_xz = 0.0d0
    do i=0,im-1
       z_IntLon_xz(:) = z_IntLon_xz(:) + xz(i,:) * x_Lon_Weight(i)
    enddo

  end function z_IntLon_xz

  function x_IntRad_xz(xz)
    !
    ! 2 次元(XZ)格子点データの動径方向域積分.
    !
    ! 2 次元データ f(λ,r) に対して ∫f(λ,r) r^2dr を計算する.
    !
    real(8), dimension(0:im-1,0:km), intent(in) :: xz
    !(in) 2 次元緯度動径格子点データ

    real(8), dimension(0:im-1)  :: x_IntRad_xz
    !(out) 動径積分された 1 次元経度格子点データ

    integer :: k

    x_IntRad_xz = 0.0d0
    do k=0,km
       x_IntRad_xz(:) = x_IntRad_xz(:) &
            + xz(:,k) * z_Rad_Weight(k)
    enddo

  end function x_IntRad_xz

  function IntLonRad_xz(xz)  ! 経度動径(緯度円)積分
    !
    ! 2 次元(XZ)格子点データの経度動径積分
    !
    ! 2 次元データ f(λ,r) に対して∫f(λ,r) r^2dλdr を計算する.
    !
    real(8), dimension(0:im-1,0:km), intent(in) :: xz
    !(in) 2 次元緯度動径格子点データ

    real(8)                                 :: IntLonRad_xz
    !(out) 積分値

    integer :: i, k

    IntLonRad_xz = 0
    do k=0,km
       do i=0,im-1
          IntLonRad_xz = IntLonRad_xz &
               + xz(i,k) * x_Lon_Weight(i) * z_Rad_Weight(k)
       enddo
    enddo
  end function IntLonRad_xz

  !----(入力データ z)---
  function IntRad_z(z)  ! 動径積分
    !
    ! 1 次元(Z)格子点データの動径方向域積分.
    !
    ! 1 次元データ f(r) に対して ∫f(r) r^2dr を計算する.
    !
    real(8), dimension(0:km), intent(in) :: z
    !(in) 1 次元動径格子点データ

    real(8)                              :: IntRad_z
    !(out) 積分値

    integer :: k

    IntRad_z = 0.0d0
    do k=0,km
       IntRad_z = IntRad_z + z(k) * z_Rad_Weight(k)
    enddo
  end function IntRad_z

  !--------------- 平均計算 -----------------
  !----(入力データ xvz)---
  function vz_AvrLon_xvz(xvz)  ! 経度(帯状)積分
    !
    ! 3 次元格子点データの経度方向(帯状)平均.
    !
    ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)dλ/2π を計算する.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    real(8), dimension(jc,0:km)  :: vz_AvrLon_xvz
    !(out) 経度方向(帯状)平均された 2 次元子午面格子点データ

    vz_AvrLon_xvz = vz_IntLon_xvz(xvz)/sum(x_Lon_Weight)

  end function vz_AvrLon_xvz

  function xz_AvrLat_xvz(xvz)  ! 緯度積分
    !
    ! 3 次元格子点データの緯度方向域平均.
    !
    ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)cosφ dφ/2 を計算する.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    real(8), dimension(im,0:km)  :: xz_AvrLat_xvz
    !(out) 緯度平均された 2 次元緯度動径格子点データ

    xz_AvrLat_xvz = xz_IntLat_xvz(xvz)/Lat_Weight_Sum

  end function xz_AvrLat_xvz

  function xv_AvrRad_xvz(xvz)
    !
    ! 3 次元格子点データの動径方向域平均.
    !
    ! 3 次元データ f(λ,φ,r) に対して 
    !
    !    ∫f(λ,φ,r) r^2dr/((r[o]^3-r[i]^3)/3) 
    !
    ! を計算する.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    real(8), dimension(0:im-1,jc)  :: xv_AvrRad_xvz          ! 水平格子点データ
    !(out) 動径平均された 2 次元経度緯度(水平, 球面)格子点データ

    xv_AvrRad_xvz = xv_IntRad_xvz(xvz)/sum(z_Rad_Weight)

  end function xv_AvrRad_xvz

  function x_AvrLatRad_xvz(xvz)  ! 緯度動径(子午面)積分
    !
    ! 3 次元格子点データの緯度動径(子午面)平均
    !
    ! 3 次元データ f(λ,φ,r) に対して
    !
    !    ∫f(λ,,r) r^2cosφ dφdr /(2(r[o]^3-r[i]^3)/3) 
    !
    ! を計算する.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    real(8), dimension(0:im-1)     :: x_AvrLatRad_xvz
    !(out) 緯度動径(子午面)平均された 1 次元経度格子点データ

    x_AvrLatRad_xvz = x_IntLatRad_xvz(xvz) &
         /( Lat_Weight_Sum*sum(z_Rad_Weight) )

  end function x_AvrLatRad_xvz

  function v_AvrLonRad_xvz(xvz)  ! 経度動径(緯度円)積分
    !
    ! 3 次元格子点データの経度動径(緯度円)平均.
    !
    ! 3 次元データ f(λ,φ,r) に対して
    !
    !     ∫f(λ,φ,r) r^2dλdr /(2π(r[o]^3-r[i]^3)/3) 
    !
    ! を計算する.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    real(8), dimension(jc)       :: v_AvrLonRad_xvz
    !(out) 経度動径(緯度円)平均された 1 次元緯度格子点データ

    v_AvrLonRad_xvz = v_IntLonRad_xvz(xvz) &
         /(sum(x_Lon_Weight)*sum(z_Rad_Weight))

  end function v_AvrLonRad_xvz

  function z_AvrLonLat_xvz(xvz)  ! 緯度経度(水平)積分
    !
    ! 3 次元格子点データの緯度経度(水平, 球面)積分
    ! 
    ! 3 次元データ f(λ,φ,r) に対して
    !
    !    ∫f(λ,φ,r) cosφ dλdφ /4π 
    !
    ! を計算する.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    real(8), dimension(0:km)     :: z_AvrLonLat_xvz
    !(out) 緯度経度(水平, 球面)平均された 1 次元動径格子点データ

    z_AvrLonLat_xvz = z_IntLonLat_xvz(xvz) &
         /(sum(x_Lon_Weight)*Lat_Weight_Sum)

  end function z_AvrLonLat_xvz

  function AvrLonLatRad_xvz(xvz) ! 緯度経度動径(全球)積分
    !
    ! 3 次元格子点データの緯度経度動径(全球)積分
    !
    ! 3 次元データ f(λ,φ,r) に対して
    !
    !    ∫f(λ,φ,r) r^2cosφ dλdφdr /(4π(r[o]^3-r[i]^3)/3) 
    !
    ! を計算する.
    !
    real(8), dimension(0:im-1,jc,0:km), intent(in) :: xvz
    !(in) 3 次元経度緯度動径格子点データ

    real(8)                     :: AvrLonLatRad_xvz
    !(out) 全球平均値

    AvrLonLatRad_xvz = IntLonLatRad_xvz(xvz) &
         /(sum(x_Lon_Weight)*Lat_Weight_Sum * sum(z_Rad_Weight))

  end function AvrLonLatRad_xvz

  !----(入力データ vz)---
  function z_AvrLat_vz(vz)
    !
    ! 2 次元(VZ)格子点データの緯度方向域平均.
    !
    ! 2 次元データ f(φ,r) に対して ∫f(φ,r) cosφ dφ/2 を計算する.
    !
    real(8), dimension(jc,0:km), intent(in) :: vz
    !(in) 2 次元緯度動径(子午面)格子点データ

    real(8), dimension(0:km)  :: z_AvrLat_vz
    !(out) 緯度平均された 1 次元動径格子点データ

    z_AvrLat_vz = z_IntLat_vz(vz)/Lat_Weight_Sum
  end function z_AvrLat_vz

  function v_AvrRad_vz(vz)
    !
    ! 2 次元(VZ)格子点データの動径方向域平均.
    !
    ! 2 次元データ f(φ,r) に対して ∫f(φ,r) r^2dr /((r[o]^3-r[i]^3)/3) 
    ! を計算する.
    !
    real(8), dimension(jc,0:km), intent(in) :: vz
    !(in) 2 次元緯度動径(子午面)格子点データ

    real(8), dimension(jc)  :: v_AvrRad_vz
    !(out) 動径平均された 1 次元緯度格子点データ

    v_AvrRad_vz = v_IntRad_vz(vz)/sum(z_Rad_Weight)

  end function v_AvrRad_vz

  function AvrLatRad_vz(vz)  ! 緯度動径(子午面)積分
    !
    ! 2 次元(VZ)格子点データの緯度動径(子午面)平均
    !
    ! 2 次元データ f(φ,r) に対して
    !
    !    ∫f(φ,r) r^2cosφ dφdr /(2(r[o]^3-r[i]^3)/3) 
    !
    ! を計算する.
    !
    real(8), dimension(jc,0:km), intent(in) :: vz
    !(in) 2 次元緯度動径(子午面)格子点データ

    real(8)                   :: AvrLatRad_vz
    !(out) 平均値

    AvrLatRad_vz = IntLatRad_vz(vz)/(Lat_Weight_Sum*sum(z_Rad_Weight))

  end function AvrLatRad_vz

  !----(入力データ xz)---
  function z_AvrLon_xz(xz)  ! 経度(帯状)積分
    !
    ! 2 次元(XZ)格子点データの経度方向平均.
    !
    ! 2 次元データ f(λ,r) に対して ∫f(λ,r)dλ/2π を計算する.
    !
    real(8), dimension(0:im-1,0:km), intent(in) :: xz
    !(in) 2 次元緯度動径格子点データ

    real(8), dimension(0:km)  :: z_AvrLon_xz
    !(out) 経度平均された 1 次元動径格子点データ

    z_AvrLon_xz = z_IntLon_xz(xz)/sum(x_Lon_Weight)

  end function z_AvrLon_xz

  function x_AvrRad_xz(xz)  ! 動径積分
    !
    ! 2 次元(XZ)格子点データの動径方向域平均.
    !
    ! 2 次元データ f(λ,r) に対して
    !
    !   ∫f(λ,r) r^2dr /((r[o]^3-r[i]^3)/3)
    !
    ! を計算する.
    !
    real(8), dimension(0:im-1,0:km), intent(in) :: xz
    !(in) 2 次元緯度動径格子点データ

    real(8), dimension(0:im-1)  :: x_AvrRad_xz
    !(out) 動径平均された 1 次元経度格子点データ

    x_AvrRad_xz = x_IntRad_xz(xz)/sum(z_Rad_Weight)

  end function x_AvrRad_xz

  function AvrLonRad_xz(xz)  ! 経度動径(緯度円)積分
    !
    ! 2 次元(XZ)格子点データの経度動径平均
    !
    ! 2 次元データ f(λ,r) に対して
    !
    !    ∫f(λ,r) r^2dλdr /(2π(r[o]^3-r[i]^3)/3)
    !
    ! を計算する.
    !
    real(8), dimension(0:im-1,0:km), intent(in) :: xz
    ! (in) 2 次元格子点データ
    real(8)                                 :: AvrLonRad_xz
    ! 積分値

    AvrLonRad_xz = IntLonRad_xz(xz)/(sum(x_Lon_Weight)*sum(z_Rad_Weight))

  end function AvrLonRad_xz

  !----(入力データ z)---
  function AvrRad_z(z)
    !
    ! 1 次元(Z)格子点データの動径方向域平均.
    !
    ! 1 次元データ f(r) に対して ∫f(r) r^2dr /((r[o]^3-r[i]^3)/3) を
    ! 計算する.
    !
    real(8), dimension(0:km), intent(in) :: z
    !(in) 1 次元動径格子点データ
    real(8)                              :: AvrRad_z
    !(out) 平均値

    AvrRad_z = IntRad_z(z)/sum(z_Rad_Weight)

  end function AvrRad_z

  !--------------- 補間計算 -----------------
  function Interpolate_wc(wc_data,alon,alat,arad)
    !
    ! 緯度 alon, 経度 alat 動径 arad における関数値を
    ! その球面調和変換係数 wa_data から補間計算する
    !
    real(8), intent(IN) :: wc_data(nc,0:lm)         ! スペクトルデータ
    real(8), intent(IN) :: alon                     ! 補間する位置(経度)
    real(8), intent(IN) :: alat                     ! 補間する位置(緯度)
    real(8), intent(IN) :: arad                     ! 補間する位置(動径)
    real(8) :: Interpolate_wc                       ! 補間した値

    Interpolate_wc = &
         Interpolate_w(a_Interpolate_ac(wc_data,arad),alon,alat)

  end function Interpolate_wc

  function Interpolate_ws(ws_data,alon,alat,arad)
    !
    ! 緯度 alon, 経度 alat 動径 arad における関数値を
    ! その球面調和変換係数 wa_data から補間計算する
    !
    real(8), intent(IN) :: ws_data(nc,lm)           ! スペクトルデータ
    real(8), intent(IN) :: alon                     ! 補間する位置(経度)
    real(8), intent(IN) :: alat                     ! 補間する位置(緯度)
    real(8), intent(IN) :: arad                     ! 補間する位置(動径)
    real(8) :: Interpolate_ws                       ! 補間した値

    Interpolate_ws = &
         Interpolate_w(a_Interpolate_as(ws_data,arad),alon,alat)

  end function Interpolate_ws

  !--------------- ポロイダル/トロイダルモデル用スペクトル解析 -------------

  function nmz_ToroidalEnergySpectrum_wc(wc_TORPOT)
    !
    ! トロイダルポテンシャルから, トロイダルエネルギーの
    ! 球面調和函数全波数 n, 帯状波数 m の各成分を計算する
    !
    !  * 全波数 n, 帯状波数 m のトロイダルポテンシャルのスペクトル成分
    !    ψ(n,m,r)から全波数 n, 帯状波数 m 成分のトロイダルエネルギー
    !    スペクトルは  (1/2)n(n+1)4πa^2|ψ(n,m,r)|^2  と計算される.
    !
    !  * 全てのエネルギースペクトル成分の和を動径積分したもの(a^2の重み無し)
    !    が球殻内での全エネルギーに等しい.
    !
    !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
    !    wsc_VMiss によって設定できる (初期値は -999.0)
    !
    real(8), intent(in)   :: wc_TORPOT(nc,0:lm)
    !(in) 流線関数(スペクトルデータ)

    real(8), dimension(0:nm,-nm:nm,0:km) :: nmz_ToroidalEnergySpectrum_wc
    !(out) エネルギースペクトル(水平全波数 n, 帯状波数 m 空間)

    real(8), dimension(0:nm,-nm:nm,0:km) :: nmz_Work ! 作業領域

    real(8), dimension(nc,0:km) ::wz_DATA      ! 作業領域

    integer :: l, n, m, nm_ary(2)

    integer :: ierr

    wz_DATA = wz_wc(wc_TORPOT)

    nmz_work = 0.0D0
    do l=1,nc
       nm_ary = nm_l(l)
       n = nm_ary(1) ; m = abs(nm_ary(2))
       if ( n .ge. 0 ) then
          if ( m == 0 ) then
             nmz_Work(n,0,:) = nmz_Work(n,0,:) &
                  +  0.5 * n*(n+1) * (4*pi) * Ro**2 * wz_Data(l,:)**2
          else
             nmz_Work(n,m,:) = nmz_Work(n,m,:) &
                  +  0.5 * n*(n+1) * (4*pi) * Ro**2 * wz_Data(l,:)**2
             nmz_Work(n,-m,:) = nmz_Work(n,-m,:) &
                  +  0.5 * n*(n+1) * (4*pi) * Ro**2 * wz_Data(l,:)**2
          endif
       endif
    enddo

    CALL MPI_ALLREDUCE(nmz_Work,nmz_ToroidalEnergySpectrum_wc, &
         (nm+1)*(2*nm+1)*(km+1), &
         MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

    do m=1,nm
       do n=0,m-1
          nmz_ToroidalEnergySpectrum_wc(n,m,:)  = wsc_Vmiss
          nmz_ToroidalEnergySpectrum_wc(n,-m,:) = wsc_Vmiss
       enddo
    enddo

  end function nmz_ToroidalEnergySpectrum_wc

  function nz_ToroidalEnergySpectrum_wc(wc_TORPOT)
    !
    ! トロイダルポテンシャルから, トロイダルエネルギーの
    ! 球面調和函数全波数の各成分を計算する.
    !
    !  * 全波数 n, 帯状波数 m のトロイダルポテンシャルのスペクトル成分
    !    ψ(n,m,r)から全波数 n 成分のトロイダルエネルギースペクトルは
    !    Σ[m=-n]^n(1/2)n(n+1)4πa^2|ψ(n,m,r)|^2 と計算される.
    !
    ! * 全てのエネルギースペクトル成分の和を動径積分したもの(a^2の重み無し)
    !    が球殻内での全エネルギーに等しい.
    !
    real(8), dimension(nc,0:lm), intent(in) :: wc_TORPOT
    !(in) トロイダルポテンシャル

    real(8), dimension(0:nm,0:km) :: nz_ToroidalEnergySpectrum_wc
    !(out) エネルギースペクトルトロイダル成分

    real(8), dimension(nc,0:km) ::wz_DATA   ! 作業領域
    real(8), dimension(0:nm,0:km)     ::nz_Work
    integer :: l, n, m, nm_ary(2)
    real(8) :: factor

    nz_Work = 0.0D0
    wz_DATA = wz_wc(wc_TORPOT)
    do l=1,nc
       nm_ary = nm_l(l)
       n = nm_ary(1) ; m = abs(nm_ary(2))
       if ( n .ge. 0 ) then
          if ( m == 0 ) then
             factor = 1.0D0
          else
             factor = 2.0D0
          endif
          nz_Work(n,:) = nz_Work(n,:) &
               + factor * 0.5 * n*(n+1)* (4*pi) * Ro**2 * wz_Data(l,:)**2
          !              + 0.5 * n*(n+1)* (4*pi) * z_Rad**2 * wz_Data(l,:)**2
       endif
    enddo

    CALL MPI_ALLREDUCE(nz_Work,nz_ToroidalEnergySpectrum_wc,(nm+1)*(km+1), &
         MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

  end function nz_ToroidalEnergySpectrum_wc

  function nmz_PoloidalEnergySpectrum_ws(ws_POLPOT)
    !
    ! ポロイダルポテンシャルから, ポロイダルエネルギーの
    ! 球面調和函数全波数 n, 帯状波数 m の各成分を計算する.
    !
    !  * 全波数 n, 帯状波数 m のポロイダルポテンシャルのスペクトル成分
    !    φ(n,m,r)から全波数 n, 帯状波数 m 成分のポロイダルエネルギー
    !    スペクトルは
    !
    !      (1/2)n(n+1)4π{|d(aφ(n,m,r))/dr|^2 + n(n+1)|φ(n,m,r)|^2} 
    !
    !    と計算される.
    !
    !  * 全てのエネルギースペクトル成分の和を動径積分したもの(a^2の重み無し)
    !    が球殻内での全エネルギーに等しい.
    !
    !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
    !    欠損値の値はモジュール変数 wsc_VMiss によって設定できる
    !    (初期値は -999.0)
    !
    real(8), intent(in)   :: ws_POLPOT(nc,lm)
    !(in) 流線関数(スペクトルデータ)

    real(8), dimension(0:nm,-nm:nm,0:km) :: nmz_PoloidalEnergySpectrum_ws
    !(out) エネルギースペクトル(水平全波数 n, 帯状波数 m 空間)

    real(8), dimension(0:nm,-nm:nm,0:km) :: nmz_Work ! 作業領域

    real(8), dimension(nc,0:km) ::wz_DATA1   ! 作業領域
    real(8), dimension(nc,0:km) ::wz_DATA2   ! 作業領域

    integer :: l, n, m, nm_ary(2)

    integer :: ierr

    wz_Data1 = wz_ws(ws_POLPOT)
    wz_Data2 = Ro*wz_wc(wc_DRad_ws(ws_POLPOT))  ! d(rφ)/dr ~ a dφ/dr

    nmz_work = 0.0D0
    do l=1,nc
       nm_ary = nm_l(l)
       n = nm_ary(1) ; m = abs(nm_ary(2))
       if ( n .ge. 0 ) then
          if ( m == 0 ) then
             nmz_Work(n,0,:) = nmz_Work(n,0,:) &
                  +  0.5 * n*(n+1) * (4*pi) &
                  * ( wz_Data2(l,:)**2 +  n*(n+1)*wz_Data1(l,:)**2 )
          else
             nmz_Work(n,m,:) = nmz_Work(n,m,:) &
                  +  0.5 * n*(n+1) * (4*pi) &
                  * ( wz_Data2(l,:)**2 +  n*(n+1)*wz_Data1(l,:)**2 )
             nmz_Work(n,-m,:) = nmz_Work(n,-m,:) &
                  +  0.5 * n*(n+1) * (4*pi) &
                  * ( wz_Data2(l,:)**2 +  n*(n+1)*wz_Data1(l,:)**2 )
          endif
       endif
    enddo

    CALL MPI_ALLREDUCE(nmz_Work,nmz_PoloidalEnergySpectrum_ws, &
         (nm+1)*(2*nm+1)*(km+1), &
         MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

    do m=1,nm
       do n=0,m-1
          nmz_PoloidalEnergySpectrum_ws(n,m,:)  = wsc_Vmiss
          nmz_PoloidalEnergySpectrum_ws(n,-m,:) = wsc_Vmiss
       enddo
    enddo

  end function nmz_PoloidalEnergySpectrum_ws

  function nz_PoloidalEnergySpectrum_ws(ws_POLPOT)
    !
    ! ポロイダルポテンシャルから, ポロイダルエネルギーの
    ! 球面調和函数全波数の各成分を計算する
    !
    !  * 全波数 n, 帯状波数 m のポロイダルポテンシャルのスペクトル成分
    !    φ(n,m,r)から全波数 n 成分のポロイダルエネルギースペクトルは
    !
    !      Σ[m=-n]^n ((1/2)n(n+1)4π{|d(rφ(n,m,r))/dr|^2 
    !                 + n(n+1)|φ(n,m,r)|^2} 
    !
    !    と計算される.
    !
    !  * 全ての全波数に対してのエネルギースペクトル成分の和を動径積分したもの
    !    (a^2の重み無し)が球殻内での全エネルギーに等しい.
    !
    real(8), dimension(nc,lm), intent(in) :: ws_POLPOT
    !(in) ポロイダルポテンシャル

    real(8), dimension(0:nm,0:km) :: nz_PoloidalEnergySpectrum_ws
    !(out) エネルギースペクトルポロイダル成分

    real(8), dimension(nc,0:km) ::wz_DATA1   ! 作業領域
    real(8), dimension(nc,0:km) ::wz_DATA2   ! 作業領域
    real(8), dimension(0:nm,0:km)     ::nz_Work
    integer :: l, n, m, nm_ary(2)
    real(8) :: factor

    nz_Work = 0.0D0
    wz_Data1 = wz_ws(ws_POLPOT)
    wz_Data2 = Ro*wz_wc(wc_DRad_ws(ws_POLPOT))  ! d(rφ)/dr ~ a dφ/dr

    do l=1,nc
       nm_ary = nm_l(l)
       n = nm_ary(1) ; m = abs(nm_ary(2))
       if ( n .ge. 0 ) then
          if ( m == 0 ) then
             factor = 1.0D0
          else
             factor = 2.0D0
          endif
          nz_Work(n,:) = nz_Work(n,:) &
               + factor * 0.5* n*(n+1)* (4*pi) &
               *( wz_Data2(l,:)**2 + n*(n+1)*wz_Data1(l,:)**2 )
       endif
    enddo

    CALL MPI_ALLREDUCE(nz_Work,nz_PoloidalEnergySpectrum_ws,(nm+1)*(km+1), &
         MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

  end function nz_PoloidalEnergySpectrum_ws
    
end module wsc_mpi_module_supack
  

!------------------------------------------------------------------------
! Copyright (c) 2007-2011 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  ee_module テストプログラム (パワースペクトル計算)
!
!履歴  2007/11/09  竹広真一
!      2008/05/10  竹広真一  解像度複数設定チェック
!      2011/02/15  佐々木洋平 dc_test を使うように変更
!
!
program ee_test_spectrum2

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

  integer, parameter :: im2=64, jm2=64            ! 格子点の設定(X,Y)
  integer, parameter :: km2=21, lm2=21            ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: ee_Data(-lm:lm,-km:km)    ! スペクトルデータ

  real(8)            :: yx_Data2(0:jm2-1,0:im2-1)      ! 格子データ
  real(8)            :: ee_Data2(-lm2:lm2,-km2:km2)    ! スペクトルデータ

  integer            :: k=2, l=3

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer            :: id1, id2

  call MessageNotify('M','ee_test_spectrum', &
       'ee_module spectrum function tests')

 !---------------- 座標値の設定 ---------------------
  call ee_initial(im,jm,km,lm,xmin,xmax,ymin,ymax,id1)        ! スペクトル初期化
  call ee_initial(im2,jm2,km2,lm2,xmin,xmax,ymin,ymax,id2)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
!!  write(6,*) '*** Test of ee_module : derivative function check.'
!!  write(6,*) '  The result will be printed '
!!  write(6,*) '  only when the error is larger than ', eps
!!  write(6,*)

!!$  write(6,*) '  Input wavenumbers of the grid data, k and l :'
!!$  read(5,*) k,l
!!  write(6,*) '  k,l = ', k,l

  ! id1
  write(*,*) 'for id1'
  call ee_ChangeResolutionDomain(id1)

  yx_Data = sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  ee_Data = 0.0d0
  ee_Data(l,k) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  ee_Data(-l,k) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  ee_Data(l,-k) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  ee_Data(-l,-k) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2


  call AssertEqual(                                      &
    message = 'Energy spectrum sin(k*pi*X)*sin(l*pi*Y)', &
    answer = ee_Data,                                    &
    check = ee_EnergyFromStreamfunc_ee(ee_yx(yx_Data)),  &
    significant_digits = check_digits, ignore_digits = ignore     )

  call AssertEqual(                                         &
    message = 'total energy sin(k*pi*X)*sin(l*pi*Y)',       &
    answer = ((k*pi)**2 + (l*pi)**2)/2,                     &
    check = sum(ee_EnergyFromStreamfunc_ee(ee_yx(yx_Data))) &
            *(xmax-xmin)*(ymax-ymin),                       &
    significant_digits = check_digits, ignore_digits = ignore     )

  ee_Data = 0.0d0
  ee_Data(l,k) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  ee_Data(-l,k) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  ee_Data(l,-k) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  ee_Data(-l,-k) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2

  call AssertEqual(                                         &
    message = 'Enstrophy spectrum sin(k*pi*X)*sin(l*pi*Y)', &
    answer = ee_Data,                                       &
    check = ee_EnstrophyFromStreamfunc_ee(ee_yx(yx_Data)),  &
    significant_digits = check_digits, ignore_digits = ignore     )

  call AssertEqual(                                            &
    message = 'total enstrophy sin(k*pi*X)*sin(l*pi*Y)',       &
    answer = ((k*pi)**2 + (l*pi)**2)**2/2,                     &
    check = sum(ee_EnstrophyFromStreamfunc_ee(ee_yx(yx_Data))) &
            *(xmax-xmin)*(ymax-ymin),                          &
    significant_digits = check_digits, ignore_digits = ignore     )

  ! id2
  write(*,*) 'for id2'
  call ee_ChangeResolutionDomain(id2)

  yx_Data2 = sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  ee_Data2 = 0.0d0
  ee_Data2(l,k) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  ee_Data2(-l,k) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  ee_Data2(l,-k) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2
  ee_Data2(-l,-k) = ((k*pi)**2 + (l*pi)**2)*0.25**2/2

  call AssertEqual(                                       &
    message = 'Energy spectrum sin(k*pi*X)*sin(l*pi*Y)',  &
    answer = ee_Data2,                                    &
    check = ee_EnergyFromStreamfunc_ee(ee_yx(yx_Data2)),  &
    significant_digits = check_digits, ignore_digits = ignore     )

  call AssertEqual(                                          &
    message = 'total energy sin(k*pi*X)*sin(l*pi*Y)',        &
    answer = ((k*pi)**2 + (l*pi)**2)/2,                      &
    check = sum(ee_EnergyFromStreamfunc_ee(ee_yx(yx_Data2))) &
            *(xmax-xmin)*(ymax-ymin),                        &
    significant_digits = check_digits, ignore_digits = ignore     )


  ee_Data2 = 0.0d0
  ee_Data2(l,k) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  ee_Data2(-l,k) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  ee_Data2(l,-k) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2
  ee_Data2(-l,-k) = ((k*pi)**2 + (l*pi)**2)**2*0.25**2/2

  call AssertEqual(                                          &
    message = 'Enstrophy spectrum sin(k*pi*X)*sin(l*pi*Y)',  &
    answer = ee_Data2,                                       &
    check = ee_EnstrophyFromStreamfunc_ee(ee_yx(yx_Data2)),  &
    significant_digits = check_digits, ignore_digits = ignore     )

  call AssertEqual(                                             &
    message = 'total enstrophy sin(k*pi*X)*sin(l*pi*Y)',        &
    answer = ((k*pi)**2 + (l*pi)**2)**2/2,                      &
    check = sum(ee_EnstrophyFromStreamfunc_ee(ee_yx(yx_Data2))) &
            *(xmax-xmin)*(ymax-ymin),                           &
    significant_digits = check_digits, ignore_digits = ignore     )


  call MessageNotify('M','ee_test_spectrum', &
       'ee_module spectrum function tests succeeded!')

end program ee_test_spectrum2

!----------------------------------------------------------------------
!     Copyright (c) 2011--2012 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wtq_module テストプログラム
!
!      磁場トロイダルポテンシャルの境界値問題
!
!履歴  2011/09/09  竹広真一   wq_module_tormagbc_test.f90 を MPI 化
!      2011/09/14  竹広真一   wtq_mpi_module 用に改造
!      2012/04/02  竹広真一   wtq_mpi_module_sjpack 用に改造
!      2012/04/03  竹広真一   wtq_module_sjpack 用に改造
!      2012/04/03  竹広真一   wtq_module 用に改造
!      2012/06/06  竹広真一   メッセージ修正
!
program wtq_module_tormagbc_wq_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wtq_module

  implicit none

  integer,parameter  :: im=32, jm=16         ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: kmo=16, kmi=10       ! 格子点の設定(球殻動径, 球動径)
  integer,parameter  :: nm=10                ! 切断波数の設定(水平)
  integer,parameter  :: lmo=16, lmi=16       ! 切断波数の設定(球殻動径, 球動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), dimension(0:im-1,1:jm,kmi)       :: xyr_TORMAG
  real(8), dimension(0:im-1,1:jm,kmi)       :: xyr_TORMAG_orig
  real(8), dimension((nm+1)*(nm+1),0:lmi)   :: wq_TORMAG
  real(8), dimension((nm+1)*(nm+1),0:lmi)   :: wq_TORMAG_orig
  real(8), dimension((nm+1)*(nm+1),kmi)     :: wr_TORMAG

  real(8), dimension(0:im-1,1:jm,kmi)       :: xyr_Zero = 0.0D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  real(8), parameter  :: pi=3.1415926535897932385D0

  call MessageNotify('M','wtq_module_tormagbc_wq_test', &
       'wtq_module wq_TormagBoundary subroutine test')

  call wtq_Initial(im,jm,kmi,kmo,nm,lmi,lmo,ri,ro)

 !==================== wq_TormagBoundary =========================
  ! P_10
  xyr_TORMAG = sin(xyr_lat) * cos( pi*(xyr_rad-ri)/ri )*xyr_Rad
  ! P_1_1
  !xyr_TORMAG = cos(xyr_lat)*cos(xyr_lon)* cos( pi*(xyr_rad-ri)/(ro-ri) )
  !xyr_TORMAG = 2*sin(xyr_lat)**2 * cos( pi*(xyr_rad-ri)/(ro-ri) )

  wq_TORMAG = wq_xyr(xyr_TORMAG)
  wq_TORMAG_orig = wq_TORMAG

  call wq_TormagBoundary(wq_TORMAG)
  xyr_TORMAG = xyr_wq(wq_TORMAG)

  call AssertEqual(&
       message='wq_TormagBoundary (Top B.C.)',                   &
       answer = xyr_Zero(:,:,kmi),                                   &
       check = xyr_TORMAG(:,:,kmi),                                  &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wq_TormagBoundary (internal value)',                 &
       answer = wq_Tormag(:,0:lmi-2),                                &
       check = wq_Tormag_orig(:,0:lmi-2),                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

 !==================== wq_TormagBoundaryGrid =========================
  ! P_10
  !xyr_TORMAG = sin(xyr_lat) * cos( pi*(xyr_rad-ri)/ri )
  ! P_1_1
  xyr_TORMAG = cos(xyr_lat)*cos(xyr_lon)* cos( pi*(xyr_rad-ri)/ri )*xyr_Rad
  !xyr_TORMAG = 2*sin(xyr_lat)**2 * cos( pi*(xyr_rad-ri)/ri )

  xyr_TORMAG_orig = xyr_TORMAG
  wr_TORMAG = wr_xyr(xyr_TORMAG)
  call wr_TormagBoundaryGrid(wr_TORMAG)
  xyr_TORMAG = xyr_wr(wr_TORMAG)

  call AssertEqual(&
       message='wr_TormagBoundaryGrid (Top B.C.)',                   &
       answer = xyr_Zero(:,:,kmi),                                   &
       check = xyr_TORMAG(:,:,kmi),                                  &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wr_TormagBoundaryGrid (internal value)',             &
       answer = xyr_TORMAG_orig(:,:,1:kmi-1),                        &
       check = xyr_TORMAG(:,:,1:kmi-1),                              &
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  call MessageNotify('M','wtq_module_tormagbc_wq_test', &
       'wtq_module wq_TormagBoundary subroutine test succeeded!')

end program wtq_module_tormagbc_wq_test

!--
!----------------------------------------------------------------------
! Copyright(c) 2009-2013 SPMDODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_galerkin_module_sjpack
!
!      3 次元球殻領域
!      球面調和函数展開 + チェビシェフ−ガラーキン法(sjpack 版)
!
!      spml/wt_galerkin_module モジュールは球面上および球殻内での流体運動を
!      スペクトル法によって数値計算するための Fortran90 関数を提供する
!      ものである. 
!
!      水平方向に球面調和函数変換および上下にチェビシェフガラーキン法
!      を用いる場合のスペクトル計算のためのさまざまな関数を提供する. 
!
!      内部で wt_module_sjpack および上下境界条件を解くための
!      チェビシェフーガラーキン法のモジュール群
!      (at_ab_galerkin_ND, at_ad_galerkin_DD, at_af_galerkin_MM,
!       at_ah_galerkin_MMex, at_ap_galerkin_DN, at_aq_galerkin_RRFF,
!       at_av_galerkin_NN) を用いている.
!
!      最下部では球面調和変換およびチェビシェフ変換のエンジンとして 
!      ISPACK の Fortran77 サブルーチン(sjpack, ftack)を用いている.
!
!      関数, サブルーチンの名前と機能は wt_galerkin_module のものと同じである. 
!      したがって use 文を wt_galerkin_module から wt_galerkin_module_sjpack に
!      変更するだけで SJPACK の機能が使えるようになる. 
! 
!      ただし l_nm, nm_l の使い方には注意されたい. wt_galerkin_module の
!      l_nm, nm_l は wt_galerkin_Initial で初期化しなくとも用いることが
!      できる(結果が切断波数に依らない)が, wt_galerkin_module_sjpack の
!      ものは初期化したのちにしか使うことができない. 
!
!
!履歴  2009/09/18  竹広 真一 wt_galerkin_module より sjpack 用に改造
!      2009/09/20  竹広真一  使用上の注意を追加
!      2010/03/10  佐々木洋平  threadprivate 削除(コンパイラ依存)
!      2013/08/24  竹広 真一  gfortran 対応
!
!++
module wt_galerkin_module_sjpack
  !
  != wt_galerkin_module_sjpack
  !
  ! Authors:: Youhei SASAKI, Shin-Ichi Takehiro
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !      3 次元球殻領域
  !      球面調和函数展開 + チェビシェフ−ガラーキン法(sjpack 版)
  !
  !      spml/wt_galerkin_module モジュールは球面上および球殻内での流体運動を
  !      スペクトル法によって数値計算するための Fortran90 関数を提供する
  !      ものである. 
  !
  !      水平方向に球面調和函数変換および上下にチェビシェフガラーキン法
  !      を用いる場合のスペクトル計算のためのさまざまな関数を提供する. 
  !
  !      内部で wt_module_sjpack および上下境界条件を解くための
  !      チェビシェフーガラーキン法のモジュール群
  !      (at_ab_galerkin_ND, at_ad_galerkin_DD, at_af_galerkin_MM,
  !       at_ah_galerkin_MMex, at_ap_galerkin_DN, at_aq_galerkin_RRFF,
  !       at_av_galerkin_NN) を用いている.
  !
  !      最下部では球面調和変換およびチェビシェフ変換のエンジンとして 
  !      ISPACK の Fortran77 サブルーチン(sjpack, ftack)を用いている.
  !
  !      関数, サブルーチンの名前と機能は wt_galerkin_module のものと同じである. 
  !      したがって use 文を wt_galerkin_module から wt_galerkin_module_sjpack に
  !      変更するだけで SJPACK の機能が使えるようになる. 
  ! 
  !      ただし l_nm, nm_l の使い方には注意されたい. wt_galerkin_module の
  !      l_nm, nm_l は wt_galerkin_Initial で初期化しなくとも用いることが
  !      できる(結果が切断波数に依らない)が, wt_galerkin_module_sjpack の
  !      ものは初期化したのちにしか使うことができない. 
  !
  use dc_message
  use lumatrix
  use wt_module_sjpack
  use at_ad_galerkin_DD, only: at_ad_galerkin_DD_Initial,      &
                               ad_at, at_ad, ad_ag, ag_ad,     &
                               ad_Dx_ad,                       &
                               d_t, t_d, d_z=>d_g, z_d=>g_d,   &
                               d_DRad_d => d_Dx_d
  use at_av_galerkin_NN, only: at_av_galerkin_NN_Initial,      &
                               av_at, at_av, av_ag, ag_av,     &
                               av_Dx_av,                       &
                               v_t, t_v, v_z=>v_g, z_v=>g_v,   &
                               v_DRad_v => v_Dx_V
  use at_ab_galerkin_ND, only: at_ab_galerkin_ND_Initial,      &
                               ab_at, at_ab, ab_ag, ag_ab,     &
                               ab_Dx_ab,                       &
                               b_t, t_b, b_z=>b_g, z_b=>g_b,   &
                               b_DRad_b => b_Dx_b
  use at_ap_galerkin_DN, only: at_ap_galerkin_DN_Initial,      &
                               ap_at, at_ap, ap_ag, ag_ap,     &
                               ap_Dx_ap,                       &
                               p_t, t_p, p_z=>p_g, z_p=>g_p,   &
                               p_DRad_p => p_Dx_p
  use at_af_galerkin_MM, only: at_af_galerkin_MM_Initial,      &
                               af_at, at_af, af_ag, ag_af,     &
                               af_Dx_af,                       &
                               f_t, t_f, f_z=>f_g, z_f=>g_f,   &
                               f_DRad_f => f_Dx_f
  use at_ah_galerkin_MMex, only: at_ah_galerkin_MMex_Initial,  &
                                 ah_at, at_ah, ah_ag, ag_ah,   &
                                 ah_Dx_ah
  use at_aq_galerkin_RRFF, only: at_aq_galerkin_RRFF_Initial,  &
                                 aq_at, at_aq, aq_ag, ag_aq,   &
                                 aq_Dx_aq,                     &
                                 q_t, t_q, q_z=>q_g, z_q=>g_q, &
                                 q_DRad_q => q_Dx_q,           &
                                 TQ, QT, alpha, beta

  implicit none
  private

  public wt_galerkin_Initial       ! 初期化
  public wq_LaplaPol2Pol_wt        ! ポロイダル速度場ポテンシャル φ <= ▽^2φ

  !-- wt_module 
  public x_Lon, x_Lon_Weight
  public y_Lat, y_Lat_Weight
  public z_Rad, z_Rad_Weight
  public l_nm, nm_l
  public xy_Lon, xy_Lat
  public xyz_Lon, xyz_Lat, xyz_Rad
  public wz_Rad
  public wt_VMiss

  public w_xy, xy_w
  public at_Dr_at, t_Dr_t, az_at, at_az
  public xyz_wt, wt_xyz, xyz_wz, wz_xyz, wz_wt, wt_wz
  public wt_DRad_wt, wt_DivRad_wt, wt_RotRad_wt, wt_Lapla_wt
  public xyz_GradLon_wt, xyz_gradlat_wt
  public wt_DivLon_xyz, wt_DivLat_xyz
  public wt_Div_xyz_xyz_xyz, xyz_Div_xyz_xyz_xyz
  public xyz_RotLon_wt_wt, xyz_RotLat_wt_wt, wt_RotRad_xyz_xyz

  public yz_IntLon_xyz, xz_IntLat_xyz, xy_IntRad_xyz
  public x_IntLatRad_xyz, y_IntLonRad_xyz, z_IntLonLat_xyz
  public IntLonLatRad_xyz

  public x_IntLat_xy, y_IntLon_xy, IntLonLat_xy
  public z_IntLat_yz, y_IntRad_yz, IntLatRad_yz
  public z_IntLon_xz, x_IntRad_xz, IntLonRad_xz
  public IntLon_x, IntLat_y, IntRad_z

  public yz_AvrLon_xyz, xz_AvrLat_xyz, xy_AvrRad_xyz
  public x_AvrLatRad_xyz, y_AvrLonRad_xyz, z_AvrLonLat_xyz
  public AvrLonLatRad_xyz

  public x_AvrLat_xy, y_AvrLon_xy, AvrLonLat_xy
  public z_AvrLat_yz, y_AvrRad_yz, AvrLatRad_yz
  public z_AvrLon_xz, x_AvrRad_xz, AvrLonRad_xz
  public AvrLon_x, AvrLat_y, AvrRad_z

  public wt_KxRGrad_wt, xyz_KGrad_wt, wt_L2_wt, wt_L2Inv_wt, wt_QOperator_wt
  public wt_RadRot_xyz_xyz, wt_RadRotRot_xyz_xyz_xyz
  public wt_Potential2vector, wt_Potential2Rotation
  public wt_VGradV

  public nmz_ToroidalEnergySpectrum_wt, nz_ToroidalEnergySpectrum_wt
  public nmz_PoloidalEnergySpectrum_wt, nz_PoloidalEnergySpectrum_wt

  public wt_Boundaries, wt_TorBoundaries, wz_LaplaPol2Pol_wz
  public wt_TormagBoundaries, wt_PolmagBoundaries

  public wt_BoundariesTau, wt_TorBoundariesTau
  public wt_TormagBoundariesTau, wt_PolmagBoundariesTau

  public wt_BoundariesGrid, wt_TorBoundariesGrid, wt_LaplaPol2PolGrid_wt
  public wt_TormagBoundariesGrid, wt_PolmagBoundariesGrid

  !-- at_ad_galerkin_DD
  public :: wd_wt, d_t                 ! チェビシェフ->ガラーキン変換
  public :: wd_wz, d_z                 ! 格子点->ガラーキンデータ変換
  public :: wt_wd, t_d                 ! ガラーキン->チェビシェフ変換
  public :: wz_wd, z_d                 ! ガラーキン->格子点データ変換
  public :: wd_DRad_wd, d_DRad_d       ! 動径微分

  !-- at_av_galerkin_NN
  public :: wv_wt, v_t                 ! チェビシェフ->ガラーキン変換
  public :: wv_wz, v_z                 ! 格子点->ガラーキンデータ変換
  public :: wt_wv, t_v                 ! ガラーキン->チェビシェフ変換
  public :: wz_wv, z_v                 ! ガラーキン->格子点データ変換
  public :: wv_DRad_wv, v_DRad_v       ! 動径微分

  !-- at_ab_galerkin_ND
  public :: wb_wt, b_t                 ! チェビシェフ->ガラーキン変換
  public :: wb_wz, b_z                 ! 格子点->ガラーキンデータ変換
  public :: wt_wb, t_b                 ! ガラーキン->チェビシェフ変換
  public :: wz_wb, z_b                 ! ガラーキン->格子点データ変換
  public :: wb_DRad_wb, b_DRad_b       ! 動径微分

  !-- at_ap_galerkin_DN
  public :: wp_wt, p_t                 ! チェビシェフ->ガラーキン変換
  public :: wp_wz, p_z                 ! 格子点->ガラーキンデータ変換
  public :: wt_wp, t_p                 ! ガラーキン->チェビシェフ変換
  public :: wz_wp, z_p                 ! ガラーキン->格子点データ変換
  public :: wp_DRad_wp, p_DRad_p       ! 動径微分

  !-- at_af_galerkin_MM
  public :: wf_wt, f_t                 ! チェビシェフ->ガラーキン変換
  public :: wf_wz, f_z                 ! 格子点->ガラーキンデータ変換
  public :: wt_wf, t_f                 ! ガラーキン->チェビシェフ変換
  public :: wz_wf, z_f                 ! ガラーキン->格子点データ変換
  public :: wf_DRad_wf, f_DRad_f       ! 動径微分

  !-- at_ab_galerkin_MMex
  public :: wh_wt                      ! チェビシェフ->ガラーキン変換
  public :: wh_wz                      ! 格子点->ガラーキンデータ変換
  public :: wt_wh                      ! ガラーキン->チェビシェフ変換
  public :: wz_wh                      ! ガラーキン->格子点データ変換
  public :: wh_DRad_wh                 ! 動径微分

  !-- at_aq_galerkin_RRFF
  public :: wq_wt, q_t                 ! チェビシェフ->ガラーキン変換
  public :: wq_wz, q_z                 ! 格子点->ガラーキンデータ変換
  public :: wt_wq, t_q                 ! ガラーキン->チェビシェフ変換
  public :: wz_wq, z_q                 ! ガラーキン->格子点データ変換
  public :: wq_DRad_wq, q_DRad_q       ! 動径微分


  !-- 内部変数--
  integer :: im=64, jm=32, km=16       ! 格子点の設定(経度, 緯度, 動径)
  integer :: nm=21, lm=16              ! 切断波数の設定(水平, 動径)

  logical :: Set_DD    =.false.        ! モジュール読み込みスイッチ
  logical :: Set_NN    =.false.        ! モジュール読み込みスイッチ
  logical :: Set_DN    =.false.        ! モジュール読み込みスイッチ
  logical :: Set_ND    =.false.        ! モジュール読み込みスイッチ
  logical :: Set_MM    =.false.        ! モジュール読み込みスイッチ
  logical :: Set_MMex  =.false.        ! モジュール読み込みスイッチ
  logical :: Set_RRFF  =.false.        ! モジュール読み込みスイッチ

  save im, jm, km, nm, lm, &
       Set_DD, Set_NN, Set_DN, Set_ND, Set_MM, Set_MMex, Set_RRFF

  contains
  !--------------- 初期化 -----------------
    subroutine wt_galerkin_Initial(i,j,k,n,l,r_in,r_out,&
         DD,NN,DN,ND,velBC,&
         MM_cfdx0_ri, MM_cfdx1_ri, MM_cfdx0_ro, MM_cfdx1_ro,&
         MMex_cfdx0_ri, MMex_cfdx1_ri, MMex_cfdx0_ro, MMex_cfdx1_ro, np)
      !
      !  3 次元球殻領域
      !  球面調和函数展開 + チェビシェフ−ガラーキン法
      !
      !  初期化サブルーチン
      !
      integer,intent(in) :: i, j, k        ! 格子点の設定(経度, 緯度, 動径)
      integer,intent(in) :: n, l           ! 切断波数の設定(水平, 動径)
      integer,intent(in),optional :: np    ! OPENMP での最大スレッド数

      real(8),intent(in) :: r_in, r_out    ! 球殻内外半径

      logical,intent(in),optional :: DD  ! モジュール読み込みスイッチ
      logical,intent(in),optional :: NN  ! モジュール読み込みスイッチ
      logical,intent(in),optional :: DN  ! モジュール読み込みスイッチ
      logical,intent(in),optional :: ND  ! モジュール読み込みスイッチ

      ! at_af_galerkin_MM_module 境界条件係数
      real(8),intent(in),optional :: MM_cfdx0_ri ! (0階微分@x=xmin)
      real(8),intent(In),optional :: MM_cfdx1_ri ! (1階微分@x=xmin)
      real(8),intent(in),optional :: MM_cfdx0_ro ! (0階微分@x=xmax)
      real(8),intent(in),optional :: MM_cfdx1_ro ! (1階微分@x=xmax)

      ! at_ah_galerkin_MMex_module 境界条件係数
      real(8),intent(in),optional :: MMex_cfdx0_ri((n+1)*(n+1)) ! (0階微分@r=ri)
      real(8),intent(in),optional :: MMex_cfdx1_ri((n+1)*(n+1)) ! (1階微分@r=ri)
      real(8),intent(in),optional :: MMex_cfdx0_ro((n+1)*(n+1)) ! (0階微分@r=ro)
      real(8),intent(in),optional :: MMex_cfdx1_ro((n+1)*(n+1)) ! (1階微分@r=ro)

      ! at_aq_galerkin_RRFF_module 速度場境界条件
      character(LEN=2),intent(in),optional :: velBC  ! 境界条件(RR/FF/RF/FR)

      !--------------- 引数処理 -----------------
      im=i ; jm = j ; km=k ; nm=n ; lm=l

      if ( present(DD) ) Set_DD = DD
      if ( present(NN) ) Set_NN = NN
      if ( present(DN) ) Set_DN = DN
      if ( present(ND) ) Set_ND = ND

      if ( present(MM_cfdx0_ri) .AND.present(MM_cfdx1_ri) .AND.&
           present(MM_cfdx0_ro) .AND.present(MM_cfdx1_ro) ) &
           Set_MM=.true.

      if ( present(MMex_cfdx0_ri) .AND.present(MMex_cfdx1_ri) .AND.&
           present(MMex_cfdx0_ro) .AND.present(MMex_cfdx1_ro) ) &
           Set_MMex=.true.

      if ( present(velBC) ) Set_RRFF = .true.

      !--------------- モジュール初期化 -----------------
      if ( present(np) ) then
        call wt_Initial(i,j,k,n,l,r_in,r_out, np)
      else
        call wt_Initial(i,j,k,n,l,r_in,r_out)
      endif

      if ( Set_DD ) call at_ad_galerkin_DD_Initial(km,lm)
      if ( Set_NN ) call at_av_galerkin_NN_Initial(km,lm)
      if ( Set_DN ) call at_ap_galerkin_DN_Initial(km,lm)
      if ( Set_ND ) call at_ab_galerkin_ND_Initial(km,lm)
      if ( Set_MM ) call at_af_galerkin_MM_Initial      &
                               (km,lm, MM_cfdx0_ro, MM_cfdx1_ro,&
                                       MM_cfdx0_ri, MM_cfdx1_ri   )
      if ( Set_MMex ) call at_ah_galerkin_MMex_Initial      &
                               (km,lm,(nm+1)*(nm+1), &
                                MMex_cfdx0_ro, MMex_cfdx1_ro,&
                                MMex_cfdx0_ri, MMex_cfdx1_ri   )

      if ( Set_RRFF ) call at_aq_galerkin_RRFF_Initial(km,lm,velBC)

      call MessageNotify('M','wt_galerkin_initial','wt_galerkin_module_sjpack (2013/08/24) is initialized')
    end subroutine wt_galerkin_initial

    !-- at_ad_galerkin_DD --
    function wd_wt(wt)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ディリクレ境界条件
      !
      ! 動径チェビシェフ係数 -> 動径ガラーキン係数変換
      !
      real(8), intent(IN) :: wt((nm+1)**2,0:lm)       !(in)  チェビシェフデータ
      real(8)             :: wd_wt((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wd_wt = ad_at(wt)

    end function wd_wt

    function wt_wd(wd)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ディリクレ境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径チェビシェフ係数
      !
      real(8), intent(IN) :: wd((nm+1)**2,2:lm)
      real(8)             :: wt_wd((nm+1)**2,0:lm)

      wt_wd = at_ad(wd)

    end function wt_wd

    function wd_wz(wz)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ディリクレ境界条件
      !
      ! 動径格子点データ -> 動径ガラーキン係数変換
      !

      real(8), intent(IN)  :: wz((nm+1)**2,0:km)       !(in)  格子点データ
      real(8)              :: wd_wz((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wd_wz = ad_ag(wz)

    end function wd_wz

    function wz_wd(wd)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ディリクレ境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径格子点データ
      !

      real(8), intent(IN) :: wd((nm+1)**2,2:lm)        !(in) ガラーキン係数
      real(8)             :: wz_wd((nm+1)**2,0:km)     !(out)  格子点データ

      wz_wd = ag_ad(wd)

    end function wz_wd

    function wd_DRad_wd(wd)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ディリクレ境界条件
      !
      ! 動径微分計算(2 次元データ)
      !
      real(8), intent(IN) :: wd((nm+1)**2,2:lm)         !(in) ガラーキン係数
      real(8)             :: wd_DRad_wd((nm+1)**2,2:lm) !(out) 微分ガラーキン

      wd_DRad_wd = wd_wt(wt_DRad_wt(wt_wd(wd)))

    end function wd_DRad_wd

    !-- at_av_galerkin_NN --
    function wv_wt(wt)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ノイマン境界条件
      !
      ! 動径チェビシェフ係数 -> 動径ガラーキン係数変換
      !
      real(8), intent(IN) :: wt((nm+1)**2,0:lm)       !(in)  チェビシェフデータ
      real(8)             :: wv_wt((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wv_wt = av_at(wt)

    end function wv_wt

    function wt_wv(wv)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ノイマン境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径チェビシェフ係数
      !
      real(8), intent(IN) :: wv((nm+1)**2,2:lm)
      real(8)             :: wt_wv((nm+1)**2,0:lm)

      wt_wv = at_av(wv)

    end function wt_wv

    function wv_wz(wz)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ノイマン境界条件
      !
      ! 動径格子点データ -> 動径ガラーキン係数変換
      !

      real(8), intent(IN)  :: wz((nm+1)**2,0:km)       !(in)  格子点データ
      real(8)              :: wv_wz((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wv_wz = av_ag(wz)

    end function wv_wz

    function wz_wv(wv)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ノイマン境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径格子点データ
      !

      real(8), intent(IN) :: wv((nm+1)**2,2:lm)        !(in) ガラーキン係数
      real(8)             :: wz_wv((nm+1)**2,0:km)     !(out)  格子点データ

      wz_wv = ag_av(wv)

    end function wz_wv

    function wv_DRad_wv(wv)
      !
      ! チェビシェフ−ガラーキン法
      ! 両端ノイマン境界条件
      !
      ! 動径微分計算(2 次元データ)
      !
      real(8), intent(IN) :: wv((nm+1)**2,2:lm)         !(in) ガラーキン係数
      real(8)             :: wv_DRad_wv((nm+1)**2,2:lm) !(out) 微分ガラーキン

      wv_DRad_wv = wv_wt(wt_DRad_wt(wt_wv(wv)))

    end function wv_DRad_wv

    !-- at_ab_galerkin_ND --
    function wb_wt(wt)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ノイマン下端ディリクレ境界条件
      !
      ! 動径チェビシェフ係数 -> 動径ガラーキン係数変換
      !
      real(8), intent(IN) :: wt((nm+1)**2,0:lm)       !(in)  チェビシェフデータ
      real(8)             :: wb_wt((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wb_wt = ab_at(wt)

    end function wb_wt

    function wt_wb(wb)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ノイマン下端ディリクレ境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径チェビシェフ係数
      !
      real(8), intent(IN) :: wb((nm+1)**2,2:lm)
      real(8)             :: wt_wb((nm+1)**2,0:lm)

      wt_wb = at_ab(wb)

    end function wt_wb

    function wb_wz(wz)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ノイマン下端ディリクレ境界条件
      !
      ! 動径格子点データ -> 動径ガラーキン係数変換
      !

      real(8), intent(IN)  :: wz((nm+1)**2,0:km)       !(in)  格子点データ
      real(8)              :: wb_wz((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wb_wz = ab_ag(wz)

    end function wb_wz

    function wz_wb(wb)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ノイマン下端ディリクレ境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径格子点データ
      !

      real(8), intent(IN) :: wb((nm+1)**2,2:lm)        !(in) ガラーキン係数
      real(8)             :: wz_wb((nm+1)**2,0:km)     !(out)  格子点データ

      wz_wb = ag_ab(wb)

    end function wz_wb

    function wb_DRad_wb(wb)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ノイマン下端ディリクレ境界条件
      !
      ! 動径微分計算(2 次元データ)
      !
      real(8), intent(IN) :: wb((nm+1)**2,2:lm)         !(in) ガラーキン係数
      real(8)             :: wb_DRad_wb((nm+1)**2,2:lm) !(out) 微分ガラーキン

      wb_DRad_wb = wb_wt(wt_DRad_wt(wt_wb(wb)))

    end function wb_DRad_wb

    !-- at_ap_galerkin_DN --
    function wp_wt(wt)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ディリクレ下端ノイマン境界条件
      !
      ! 動径チェビシェフ係数 -> 動径ガラーキン係数変換
      !
      real(8), intent(IN) :: wt((nm+1)**2,0:lm)       !(in)  チェビシェフデータ
      real(8)             :: wp_wt((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wp_wt = ap_at(wt)

    end function wp_wt

    function wt_wp(wp)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ディリクレ下端ノイマン境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径チェビシェフ係数
      !
      real(8), intent(IN) :: wp((nm+1)**2,2:lm)
      real(8)             :: wt_wp((nm+1)**2,0:lm)

      wt_wp = at_ap(wp)

    end function wt_wp

    function wp_wz(wz)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ディリクレ下端ノイマン境界条件
      !
      ! 動径格子点データ -> 動径ガラーキン係数変換
      !

      real(8), intent(IN)  :: wz((nm+1)**2,0:km)       !(in)  格子点データ
      real(8)              :: wp_wz((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wp_wz = ap_ag(wz)

    end function wp_wz

    function wz_wp(wp)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ディリクレ下端ノイマン境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径格子点データ
      !

      real(8), intent(IN) :: wp((nm+1)**2,2:lm)        !(in) ガラーキン係数
      real(8)             :: wz_wp((nm+1)**2,0:km)     !(out)  格子点データ

      wz_wp = ag_ap(wp)

    end function wz_wp

    function wp_DRad_wp(wp)
      !
      ! チェビシェフ−ガラーキン法
      ! 上端ディリクレ下端ノイマン境界条件
      !
      ! 動径微分計算(2 次元データ)
      !
      real(8), intent(IN) :: wp((nm+1)**2,2:lm)         !(in) ガラーキン係数
      real(8)             :: wp_DRad_wp((nm+1)**2,2:lm) !(out) 微分ガラーキン

      wp_DRad_wp = wp_wt(wt_DRad_wt(wt_wp(wp)))

    end function wp_DRad_wp

    !-- at_af_galerkin_MM --
    function wf_wt(wt)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレノイマン混合型境界条件
      !
      ! 動径チェビシェフ係数 -> 動径ガラーキン係数変換
      !
      real(8), intent(IN) :: wt((nm+1)**2,0:lm)       !(in)  チェビシェフデータ
      real(8)             :: wf_wt((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wf_wt = af_at(wt)

    end function wf_wt

    function wt_wf(wf)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレノイマン混合型境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径チェビシェフ係数
      !
      real(8), intent(IN) :: wf((nm+1)**2,2:lm)
      real(8)             :: wt_wf((nm+1)**2,0:lm)

      wt_wf = at_af(wf)

    end function wt_wf

    function wf_wz(wz)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレノイマン混合型境界条件
      !
      ! 動径格子点データ -> 動径ガラーキン係数変換
      !

      real(8), intent(IN)  :: wz((nm+1)**2,0:km)       !(in)  格子点データ
      real(8)              :: wf_wz((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wf_wz = af_ag(wz)

    end function wf_wz

    function wz_wf(wf)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレノイマン混合型境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径格子点データ
      !

      real(8), intent(IN) :: wf((nm+1)**2,2:lm)        !(in) ガラーキン係数
      real(8)             :: wz_wf((nm+1)**2,0:km)     !(out)  格子点データ

      wz_wf = ag_af(wf)

    end function wz_wf

    function wf_DRad_wf(wf)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレノイマン混合型境界条件
      !
      ! 動径微分計算(2 次元データ)
      !
      real(8), intent(IN) :: wf((nm+1)**2,2:lm)         !(in) ガラーキン係数
      real(8)             :: wf_DRad_wf((nm+1)**2,2:lm) !(out) 微分ガラーキン

      wf_DRad_wf = wf_wt(wt_DRad_wt(wt_wf(wf)))

    end function wf_DRad_wf

    !-- at_ah_galerkin_MMex --
    function wh_wt(wt)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレ・ノイマン混合境界条件(可変係数)境界条件
      !
      ! 動径チェビシェフ係数 -> 動径ガラーキン係数変換
      !
      real(8), intent(IN) :: wt((nm+1)**2,0:lm)       !(in)  チェビシェフデータ
      real(8)             :: wh_wt((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wh_wt = ah_at(wt)

    end function wh_wt

    function wt_wh(wh)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレ・ノイマン混合境界条件(可変係数)
      !
      ! 動径ガラーキン係数変換 -> 動径チェビシェフ係数
      !
      real(8), intent(IN) :: wh((nm+1)**2,2:lm)
      real(8)             :: wt_wh((nm+1)**2,0:lm)

      wt_wh = at_ah(wh)

    end function wt_wh

    function wh_wz(wz)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレ・ノイマン混合境界条件(可変係数)
      !
      ! 動径格子点データ -> 動径ガラーキン係数変換
      !

      real(8), intent(IN)  :: wz((nm+1)**2,0:km)       !(in)  格子点データ
      real(8)              :: wh_wz((nm+1)**2,2:lm)    !(out) ガラーキン係数

      wh_wz = ah_ag(wz)

    end function wh_wz

    function wz_wh(wh)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレ・ノイマン混合境界条件(可変係数)
      !
      ! 動径ガラーキン係数変換 -> 動径格子点データ
      !

      real(8), intent(IN) :: wh((nm+1)**2,2:lm)        !(in) ガラーキン係数
      real(8)             :: wz_wh((nm+1)**2,0:km)     !(out)  格子点データ

      wz_wh = ag_ah(wh)

    end function wz_wh

    function wh_DRad_wh(wh)
      !
      ! チェビシェフ−ガラーキン法
      ! ディリクレ・ノイマン混合境界条件(可変係数)
      !
      ! 動径微分計算
      !
      real(8), intent(IN) :: wh((nm+1)**2,2:lm)         !(in) ガラーキン係数
      real(8)             :: wh_DRad_wh((nm+1)**2,2:lm) !(out) 微分ガラーキン

      wh_DRad_wh = wh_wt(wt_DRad_wt(wt_wh(wh)))

    end function wh_DRad_wh

    !-- at_aq_galerkin_RRFF --
    function wq_wt(wt)
      !
      ! チェビシェフ−ガラーキン法
      ! 非圧縮流体の流線関数・流れポテンシャル用境界条件
      !
      ! 動径チェビシェフ係数 -> 動径ガラーキン係数変換
      !
      real(8), intent(IN) :: wt((nm+1)**2,0:lm)       !(in)  チェビシェフデータ
      real(8)             :: wq_wt((nm+1)**2,4:lm)    !(out) ガラーキン係数

      wq_wt = aq_at(wt)

    end function wq_wt

    function wt_wq(wq)
      !
      ! チェビシェフ−ガラーキン法
      ! 非圧縮流体の流線関数・流れポテンシャル用境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径チェビシェフ係数
      !
      real(8), intent(IN) :: wq((nm+1)**2,4:lm)
      real(8)             :: wt_wq((nm+1)**2,0:lm)

      wt_wq = at_aq(wq)

    end function wt_wq

    function wq_wz(wz)
      !
      ! チェビシェフ−ガラーキン法
      ! 非圧縮流体の流線関数・流れポテンシャル用境界条件
      !
      ! 動径格子点データ -> 動径ガラーキン係数変換
      !

      real(8), intent(IN)  :: wz((nm+1)**2,0:km)       !(in)  格子点データ
      real(8)              :: wq_wz((nm+1)**2,4:lm)    !(out) ガラーキン係数

      wq_wz = aq_ag(wz)

    end function wq_wz

    function wz_wq(wq)
      !
      ! チェビシェフ−ガラーキン法
      ! 非圧縮流体の流線関数・流れポテンシャル用境界条件
      !
      ! 動径ガラーキン係数変換 -> 動径格子点データ
      !

      real(8), intent(IN) :: wq((nm+1)**2,4:lm)        !(in) ガラーキン係数
      real(8)             :: wz_wq((nm+1)**2,0:km)     !(out)  格子点データ

      wz_wq = ag_aq(wq)

    end function wz_wq

    function wq_DRad_wq(wq)
      !
      ! チェビシェフ−ガラーキン法
      ! 非圧縮流体の流線関数・流れポテンシャル用境界条件
      !
      ! X 微分計算(2 次元データ)
      !
      real(8), intent(IN) :: wq((nm+1)**2,4:lm)         !(in) ガラーキン係数
      real(8)             :: wq_DRad_wq((nm+1)**2,4:lm) !(out) 微分ガラーキン

      wq_DRad_wq = wq_wt(wt_DRad_wt(wt_wq(wq)))

    end function wq_DRad_wq

   !----- ポロイダル速度場ポテンシャル φを ▽^2φ から求める ------
    function wq_LaplaPol2Pol_wt(wt_LaplaPolvel)
      !
      !  3 次元球殻領域
      !  球面調和函数展開 + チェビシェフ−ガラーキン法
      !
      !  ポロイダル速度場ポテンシャル φを ▽^2φ から求める
      !
      real(8), intent(IN) :: wt_LaplaPolvel((nm+1)*(nm+1),0:lm)
        !(in) ポロイダル速度場ポテンシャルのラプラシアン ▽^2φ
      real(8)             :: wq_LaplaPol2Pol_wt((nm+1)*(nm+1),4:lm) 
        !(out) ポロイダル速度場ポテンシャル φ

      real(8), allocatable :: LaplaMT(:,:,:)
      real(8), allocatable :: LaplaInvMT(:,:,:)
      integer, allocatable :: kpvot(:,:)

      integer, parameter :: ls=4

      real(8) :: wq_work((nm+1)*(nm+1),ls:lm)
      real(8) :: wt_work((nm+1)*(nm+1),0:lm)

      integer :: k, m, n, l, p
      logical :: first = .true.
      save LaplaInvMT, kpvot, first

      if ( .not. Set_RRFF ) &
           call MessageNotify('E','wq_LaplaPol2Pol_wt',&
                    'at_aq_galerkin_RRFF_module not initialized.')

      if ( first ) then
         first = .false.
         allocate(LaplaMT((nm+1)*(nm+1),0:lm,0:lm))
         allocate(LaplaInvMT((nm+1)*(nm+1),ls:lm,ls:lm))
         allocate(kpvot((nm+1)*(nm+1),ls:lm))

         LaplaMT=0.0D0
         do l=0,lm
            wt_work = 0.0D0 ; wt_work(:,l) = 1.0D0
            wt_work = wt_Lapla_wt(wt_work)
            LaplaMT(:,:,l) = wt_work
         enddo

         LaplaInvMT=0.0D0
         do n=ls,lm
            do m=ls,lm
               do l=0,lm
                  do p=0,lm
                     LaplaInvMT(:,n,m)=LaplaInvMT(:,n,m) &
                          +TQ(l,n)*LaplaMT(:,l,p)*alpha(p)*TQ(p,m)
                  enddo
               enddo
            enddo
         enddo

         call LUDecomp(LaplaInvMT,kpvot)
         deallocate(LaplaMT)
      endif

      wq_work=0.0D0
      do m=ls,lm
         do k=0,lm
            wq_work(:,m)=wq_work(:,m) &
                 + alpha(k) * beta(k) * wt_LaplaPolvel(:,k)* TQ(k,m) 
         enddo
      enddo

      wq_LaplaPol2Pol_wt = LUSolve(LaplaInvMT,kpvot,wq_work)

    end function wq_LaplaPol2Pol_wt

end module wt_galerkin_module_sjpack

!--
!----------------------------------------------------------------------
!     Copyright (c) 2002-2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  lumatrix : 行列の LU 分解による線形連立方程式の解
!
!      spml/lumatrix モジュールは, LU 分解法により連立 1 次方程式を解くための
!      Fortran90 関数を提供する. 
!
!      他のスペクトル計算用モジュールの中で登場する境界値問題を解くために
!      用いられている. 
!
!      並列計算機を意識して, 同じ次数の複数個の連立1 次方程式 
!
!          A[ij]^(n) X [j]^(n) = B[i]^(n) 
!
!      の解を同時に複数個の右辺ベクトル B[i]^(n)b に対して求めることが
!      できるようになっている.
!
!
!履歴  2002/01/20  竹広真一
!      2002/06/10  竹広真一  ベクトル長問題回避のため lusol2 を使用
!      2005/01/10  竹広真一  msgdmp -> MessageNotify に変更
!      2006/03/04  竹広真一  コメントを RDoc 用に修正
!      2009/01/29  佐々木洋平  コメントを RDoc 用に修正
!      2009/08/06  竹広真一    ludecomp21 用ルーチン OMP 版変更
!      2010/03/17  竹広真一    ssl2tp 版作成
!
! * ドキュメントは後半部の module 宣言部に記載
!++
subroutine ludecomp21(alu,kp)
  !
  ! ALU(NDIM,NDIM), KP(NDIM)
  ! NDIM x NDIM の行列を LU 分解.
  ! ＬＵ行列は 入力行列に上書きされる.
  !
  use dc_message
  
  real(8), intent(inout) :: alu(:,:)                  ! 入力／ＬＵ行列
  integer, intent(out)   :: kp(size(alu,2))           ! ピボット
  integer  :: is, icon
  integer  :: kk, nn
  
  kk = size(alu,1) ;  nn = size(alu,2)

  if ( kk > nn ) then
     call MessageNotify('W','ludecomp21',&
          'The first dimension is greater than the second')
  elseif( kk < nn ) then
     call MessageNotify('E','ludecomp21',&
          'The first dimension is less than the second')
  endif
  
  !" 行列のＬＵ分解（クラウト法）
  call DM_VALU( alu, kk, nn, 0.0D0, kp, is, icon)

  if ( icon /= 0 ) &
       call MessageNotify('E','ludecomp21','LU decompostion not succeeded.')
  
end subroutine ludecomp21

subroutine ludecomp32(alu,kp)
  !
  ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM)
  ! NDIM x NDIM の行列 JDIM 個を一度に LU 分解.
  ! ＬＵ行列は 入力行列に上書きされる.
  !
  use dc_message
  
  real(8), intent(inout) :: alu(:,:,:)                  ! 入力／ＬＵ行列
  integer, intent(out)   :: kp(size(alu,1),size(alu,3)) ! ピボット

  integer  :: is, icon
  integer  :: jj, kk, nn
  integer  :: j
  
  jj = size(alu,1) ; kk = size(alu,2) ;  nn = size(alu,3)
  
  if ( kk > nn ) then
     call MessageNotify('W','ludecomp32',&
          'The second dimension is greater than the third')
  elseif( kk < nn ) then
     call MessageNotify('E','ludecomp32',&
          'The second dimension is less than the third')
  endif
 
 !" 行列のＬＵ分解（クラウト法）
!$omp parallel do private(vw,is,icon)
  do j=1,jj
     call DM_VALU( alu(j,:,:), kk, nn, 0.0D0, kp(j,:), is, icon)

     if ( icon /= 0 ) &
          call MessageNotify('E','ludecomp32','LU decompostion not succeeded.')
  end do
!$omp end parallel do
  
end subroutine ludecomp32

function lusolve211(alu,kp,b)
  !
  ! ALU(NDIM,NDIM), KP(NDIM), B(NDIM)
  ! NDIM x NDIM 型行列の連立方程式
  ! A X = B を 1 個の B に対して計算する. 
  !
  use dc_message
  
  real(8), intent(in)  :: alu(:,:)              ! 入力／ＬＵ行列
  integer, intent(in)  :: kp(:)                 ! ピボット
  real(8), intent(in)  :: b(:)                  ! 右辺ベクトル
  
  real(8) :: lusolve211(size(b))                   ! 解
  integer :: icon
  integer :: kk, nn

  kk = size(alu,1) ;  nn = size(alu,2)

  if ( kk > nn ) then
     call MessageNotify('W','ludsolve211',&
          'The first dimension is greater than the second')
  elseif( kk < nn ) then
     call MessageNotify('E','lusolve211',&
          'The first dimension is less than the second')
  elseif ( nn /= size(b)) then
     call MessageNotify('E','lusolve211', &
          'The input vector length differs from the second dimension of the matrix')
  endif

  lusolve211 = b

  call DM_VLUX( lusolve211, alu, kk, nn, kp, icon )
  if ( icon /= 0 ) &
       call MessageNotify('E','lusolve211','LU solve not succeeded.')
  
end function lusolve211

function lusolve212(alu,kp,b)
  !
  ! ALU(NDIM,NDIM), KP(NDIM), B(JDIM,NDIM)
  ! NDIM x NDIM 型行列の連立方程式
  ! A X = B を JDIM 個の B に対して計算する. 
  !
  use dc_message
  
  real(8), intent(in)  :: alu(:,:)              ! 入力／ＬＵ行列
  integer, intent(in)  :: kp(:)                 ! ピボット
  real(8), intent(in)  :: b(:,:)                ! 右辺ベクトル
  
  real(8) :: lusolve212(size(b,1),size(b,2))       ! 解

  integer :: icon
  integer :: kk, nn
  integer :: j
  
  kk = size(alu,1) ;  nn = size(alu,2)

  if ( kk > nn ) then
     call MessageNotify('W','ludsolve212',&
          'The first dimension is greater than the second')
  elseif( kk < nn ) then
     call MessageNotify('E','lusolve212',&
          'The first dimension is less than the second')
  elseif ( nn /= size(b,2)) then
     call MessageNotify('E','lusolvep212', &
          'The vector length differs from the second dimension of the matrix')
  endif

  lusolve212 = b

!$omp parallel do private(icon)
  do j=1,size(b,1)
     call DM_VLUX( lusolve212(j,:), alu, kk, nn, kp, icon )
     if ( icon /= 0 ) &
          call MessageNotify('E','lusolve211','LU solve not succeeded.')
  end do
!$omp end parallel do

end function lusolve212

function lusolve322(alu,kp,b)
  !
  ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM), B(JDIM,NDIM)
  ! NDIM x NDIM 型行列を JDIM 個並べた連立方程式
  ! A X = B をひとつの B の並びに対して計算する. 
  !
  use dc_message
  
  real(8), intent(in)  :: alu(:,:,:)                   ! 入力／ＬＵ行列
  integer, intent(in)  :: kp(:,:)                      ! ピボット
  real(8), intent(in)  :: b(:,:)                       ! 右辺ベクトル
  
  real(8) :: lusolve322(size(b,1),size(b,2))             ! 解
  
  integer  :: icon
  integer  :: jj, kk, nn
  integer  :: j

  jj = size(alu,1) ; kk = size(alu,2) ;  nn = size(alu,3)
  
  if ( kk > nn ) then
     call MessageNotify('W','lusovel322',&
          'The second dimension is greater than the third')
  elseif( kk < nn ) then
     call MessageNotify('E','lusolve322',&
          'The second dimension is less than the third')
  elseif( jj  /= size(b,1) .OR. nn /= size(b,2) ) then
     call MessageNotify('E','lusovle322',&
          'The input vector dimension does not match the matrix dimension')
  endif

  lusolve322 = b
 
!$omp parallel do private(icon)
  do j=1,jj
     call DM_VLUX( lusolve322(j,:), alu(j,:,:), kk, nn, kp(j,:), icon )
     if ( icon /= 0 ) &
          call MessageNotify('E','lusolve322','LU solve not succeeded.')
  end do
!$omp end parallel do
  
end function lusolve322

function lusolve323(alu,kp,b)
  !
  ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM), B(IDIM,JDIM,NDIM)
  ! NDIM x NDIM 型行列を JDIM 個並べた連立方程式
  ! A X = B を IDIM 個の B に対して計算する. 
  !
  use dc_message
  
  real(8), intent(in)  :: alu(:,:,:)                   ! 入力／ＬＵ行列
  integer, intent(in)  :: kp(:,:)                      ! ピボット
  real(8), intent(in)  :: b(:,:,:)                     ! 右辺ベクトル
  
  real(8) :: lusolve323(size(b,1),size(b,2),size(b,3)) ! 解

  integer  :: icon
  integer  :: jj, kk, nn
  integer  :: i, j

  jj = size(alu,1) ; kk = size(alu,2) ;  nn = size(alu,3)
  
  if ( kk > nn ) then
     call MessageNotify('W','lusovel322',&
          'The second dimension is greater than the third')
  elseif( kk < nn ) then
     call MessageNotify('E','lusolve322',&
          'The second dimension is less than the third')
  elseif( jj  /= size(b,2) .OR. nn /= size(b,3) ) then
     call MessageNotify('E','lusovle322',&
          'The input vector dimension does not match the matrix dimension')
  endif
  
  lusolve323 = b

!$omp parallel do private(icon)
  do i=1,size(b,1)
     do j=1,jj
         call DM_VLUX( lusolve323(i,j,:), alu(j,:,:), kk, nn, kp(j,:), icon )
        if ( icon /= 0 ) &
             call MessageNotify('E','lusolve323','LU solve not succeeded.')
     end do
  enddo
!$omp end parallel do
  
end function lusolve323

module lumatrix
  !
  != lumatrix
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/lumatrix モジュールは, LU 分解法により連立 1 次方程式を解くための
  ! Fortran90 関数を提供する. 
  !
  ! 他のスペクトル計算用モジュールの中で登場する境界値問題を解くために
  ! 用いられている. 
  !
  ! ベクトル計算機を意識して, 同じ次数の複数個の連立1 次方程式 
  !
  !     A[ij]^(n) X [j]^(n) = B[i]^(n) 
  !
  ! の解を同時に複数個の右辺ベクトル B[i]^(n)b に対して求めることが
  ! できるようになっている.
  !
  !== 変数・手続き群の要約
  !
  ! LUDecomp    :: 行列の LU 分解を行う
  ! LUSolve     :: 連立 1 次方程式の解を求める
  !
  private 
  public LUDecomp, LUSolve

  interface LUDecomp
     !
     !=== 与えられた行列の LU 分解を行い, ピボットを格納する.
     !
     ! * LU 分解された結果は Alu に上書きされる. 
     !   そのピボット情報は kp に格納される.
     !
     ! * LUSolve を用いる前にこのサブルーチンを呼んで Alu と kp を
     !   計算しておく.
     !
     ! * 入力する行列とピボット用配列の次元によって内部でサブルーチンを
     !   使い分けている. ユーザーインターフェースは共通であるので
     !   下部ルーチンである ludecomp21, ludecomp32 を呼ぶ必要はない.
     !
     !=== 引数と結果の型
     !
     ! * Alu が 2 次元配列(与える係数行列が 1 つ)の場合
     !
     !     ! ALU(NDIM,NDIM), KP(NDIM)
     !     ! NDIM x NDIM の行列を LU 分解.
     !     ! ＬＵ行列は 入力行列に上書きされる.
     !
     !     real(8), intent(inout) :: alu(:,: )         ! 入力／ＬＵ行列
     !     integer, intent(out)   :: kp(size(alu,1))   ! ピボット
     !
     !
     ! * Alu が 3 次元配列(与える係数行列が複数)の場合
     !
     !     ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM)
     !     ! NDIM x NDIM の行列 JDIM 個を一度に LU 分解.
     !     ! ＬＵ行列は 入力行列に上書きされる.
     !
     !     real(8), intent(inout) :: alu(:,:,:)      ! 入力／ＬＵ行
     !     integer, intent(out)   :: kp(size(alu,1),size(alu,2)) ! ピボット
     !
     !
     subroutine ludecomp21(alu,kp)
       !
       ! ALU(NDIM,NDIM), KP(NDIM)
       ! NDIM x NDIM の行列を LU 分解.
       ! ＬＵ行列は 入力行列に上書きされる.
       !
       real(8), intent(inout) :: alu(:,: )                 ! 入力／ＬＵ行列
       integer, intent(out)   :: kp(size(alu,1))           ! ピボット
     end subroutine ludecomp21

     subroutine ludecomp32(alu,kp)
       !
       ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM)
       ! NDIM x NDIM の行列 JDIM 個を一度に LU 分解.
       ! ＬＵ行列は 入力行列に上書きされる.
       !
       real(8), intent(inout) :: alu(:,:,:)                  ! 入力／ＬＵ行列
       integer, intent(out)   :: kp(size(alu,1),size(alu,2)) ! ピボット
     end subroutine ludecomp32
  end interface

  interface LUSolve
     !
     ! 連立 1 次方程式の解を求める
     !
     !  * LUSolve を用いる前に LUDecompを呼んで Alu を LU 分解し, 
     !    ピボット情報 kp を計算しておかねばならない.
     !
     !  * 入力する行列とピボット用配列の次元によって内部でサブルーチンを
     !    使い分けている. ユーザーインターフェースは共通であるので
     !    下部ルーチンである lusolve??? を呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     !  *  Alu が 2 次元配列(与える係数行列が 1 つ), 
     !     b が 1 次元配列(与える右辺ベクトルが 1 つ)の場合
     !
     !     ! ALU(NDIM,NDIM), KP(NDIM), B(NDIM)
     !     ! NDIM x NDIM 型行列の連立方程式
     !     ! A X = B を 1 個の B に対して計算する.
     !
     !     real(8), intent(in)  :: alu(:,:)              ! 入力／ＬＵ行列
     !     integer, intent(in)  :: kp(:)                 ! ピボット
     !     real(8), intent(in)  :: b(:)                  ! 右辺ベクトル
     !
     !     real(8) :: lusolve(size(b))                   ! 解
     !
     !  * Alu が 2 次元配列(与える係数行列が 1 つ), 
     !    b が 2 次元配列(与える右辺ベクトルが複数)の場合
     !
     !     ! ALU(NDIM,NDIM), KP(NDIM), B(JDIM,NDIM)
     !     ! NDIM x NDIM 型行列の連立方程式
     !     ! A X = B を JDIM 個の B に対して計算する.
     !
     !     real(8), intent(in)  :: alu(:,:)              ! 入力／ＬＵ行列
     !     integer, intent(in)  :: kp(:)                 ! ピボット
     !     real(8), intent(in)  :: b(:,:)                ! 右辺ベクトル
     !
     !     real(8) :: lusolve(size(b,1),size(b,2))       ! 解
     !
     !
     !  * Alu が 3 次元配列(与える係数行列が複数), 
     !    b が 2 次元配列(与える右辺ベクトルが 1 つ)の場合
     !
     !     ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM), B(JDIM,NDIM)
     !     ! NDIM x NDIM 型行列を JDIM 個並べた連立方程式
     !     ! A X = B をひとつの B の並びに対して計算する.
     !
     !     real(8), intent(in)  :: alu(:,:,:)            ! 入力／ＬＵ行列
     !     integer, intent(in)  :: kp(:,:)               ! ピボット
     !     real(8), intent(in)  :: b(:,:)                ! 右辺ベクトル
     !
     !     real(8) :: lusolve(size(b,1),size(b,2))             ! 解
     !
     !
     !  * Alu が 3 次元配列(与える係数行列が複数), 
     !    b が 3 次元配列(与える右辺ベクトルが複数)の場合
     !
     !     ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM), B(IDIM,JDIM,NDIM)
     !     ! NDIM x NDIM 型行列を JDIM 個並べた連立方程式
     !     ! A X = B を IDIM 個の B に対して計算する.
     !
     !     real(8), intent(in)  :: alu(:,:,:)                ! 入力／ＬＵ行列
     !     integer, intent(in)  :: kp(:,:)                   ! ピボット
     !     real(8), intent(in)  :: b(:,:,:)                  ! 右辺ベクトル
     !
     !     real(8) :: lusolve(size(b,1),size(b,2),size(b,3)) ! 解
     !
     !
     function lusolve211(alu,kp,b)
       !
       ! ALU(NDIM,NDIM), KP(NDIM), B(NDIM)
       ! NDIM x NDIM 型行列の連立方程式
       ! A X = B を IDIM 個の B に対して計算する. 
       ! 解は右辺の入力ベクトルに上書きされる
       !
       real(8), intent(in)  :: alu(:,:)              ! 入力／ＬＵ行列
       integer, intent(in)  :: kp(:)                 ! ピボット
       real(8), intent(in)  :: b(:)                  ! 右辺ベクトル
       real(8) :: lusolve211(size(b))                 ! 解
     end function lusolve211

     function lusolve212(alu,kp,b)
       !
       ! ALU(NDIM,NDIM), KP(NDIM), B(JDIM,NDIM)
       ! NDIM x NDIM 型行列の連立方程式
       ! A X = B を IDIM 個の B に対して計算する. 
       !
       real(8), intent(in)  :: alu(:,:)              ! 入力／ＬＵ行列
       integer, intent(in)  :: kp(:)                 ! ピボット
       real(8), intent(in)  :: b(:,:)                ! 右辺ベクトル

       real(8) :: lusolve212(size(b,1),size(b,2))       ! 解

     end function lusolve212

     function lusolve322(alu,kp,b)
       !
       ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM), B(JDIM,NDIM)
       ! NDIM x NDIM 型行列を JDIM 個並べた連立方程式
       ! A X = B を B に対して計算する. 
       !
       real(8), intent(in)  :: alu(:,:,:)                   ! 入力／ＬＵ行列
       integer, intent(in)  :: kp(:,:)                      ! ピボット
       real(8), intent(in)  :: b(:,:)                       ! 右辺ベクトル

       real(8) :: lusolve322(size(b,1),size(b,2))             ! 解
     end function lusolve322

     function lusolve323(alu,kp,b)
       !
       ! ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM), B(IDIM,JDIM,NDIM)
       ! NDIM x NDIM 型行列を JDIM 個並べた連立方程式
       ! A X = B を IDIM 個の B に対して計算する. 
       !
       real(8), intent(in)  :: alu(:,:,:)                   ! 入力／ＬＵ行列
       integer, intent(in)  :: kp(:,:)                      ! ピボット
       real(8), intent(in)  :: b(:,:,:)                     ! 右辺ベクトル

       real(8) :: lusolve323(size(b,1),size(b,2),size(b,3)) ! 解

     end function lusolve323
  end interface

end module lumatrix

!--
!----------------------------------------------------------------------
! Copyright (c) 2008-2009 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  eee_mpi_module
!
!      spml/eee_module モジュールは周期境界条件の下での 3 次元矩形領域の
!      流体運動をスペクトル法により数値計算するための Fortran90 関数を
!      提供する. 
!
!      内部で ISPACK/P3PACK, P3PACK-MPI の Fortran77 サブルーチンを呼んでいる.
!      スペクトルデータおよび格子点データの格納方法については
!      ISPACK/P3PACK のマニュアルを参照されたい. 
!
!履歴  2008/05/21  竹広真一  eee_module より改造
!      2008/06/03  竹広真一  ee2f_ZetaFromVor_eef_eef_eef bug fix
!      2008/06/03  竹広真一  ESpectralFromZeta bug fix
!      2009/02/23  佐々木洋平  RDoc 用のドキュメントを修正
!      2010/01/07  佐々木洋平  include 'mpif.h' -> use mpi
!
!++
module eee_mpi_module
  !
  != eee_mpi_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/eee_module モジュールは周期境界条件の下での 3 次元矩形領域の
  ! 流体運動をスペクトル法により数値計算するための Fortran90 関数を
  ! 提供する.
  !
  ! 内部で ISPACK/P3PACK の Fortran77 サブルーチンを呼んでいる.
  ! スペクトルデータおよび格子点データの格納方法については
  ! ISPACK/P3PACK のマニュアルを参照されたい.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (eef_, zxv_, x_, v_, z_) は, 返す値の形を示している.
  !   eef_ :: スペクトルデータ
  !           (第 1,2 3 次元がそれぞれ Z,Y,X 方向波数(X について分割配置))
  !   ee2f :: 2 つのスペクトルデータの並んだもの
  !   zxv_ :: 3 次元格子点データ
  !           (第 1,2 3 次元がそれぞれ Z,X,Y 方向の格子点(Y について分割配置)
  !   xv_  :: XY 方向 2 次元格子点データ, zv_ : YZ 方向 2 次元格子点データ
  !   zx_  :: XZ 方向 2 次元格子点データ
  !   x_   :: X 方向 1 次元格子点データ, v_ : Y 方向 1 次元格子点データ
  !   z_   :: Z 方向 1 次元格子点データ
  !
  ! * 関数名の間の文字列(Dx, Dy, Dz, Lapla, LaplaInv)は,
  !   その関数の作用を表している.
  !
  ! * 関数名の最後 (_eee_eee,_eee,_zyx, _x, _v) は, 入力変数の形が
  !   スペクトルデータおよび格子点データであることを示している.
  !    _eef     :: スペクトルデータ
  !    _eef_eef :: 2 つのスペクトルデータ
  !    _ee2f    :: 2 つのスペクトルデータの並んだもの
  !    _zxv     :: 3 次元格子点データ
  !    _x       :: X 方向 1 次元格子点データ
  !    _v       :: Y 方向 1 次元格子点データ.
  !
  !=== 各データの種類の説明
  !
  ! * zxv : 2 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(0:km-1,0:im-1,js(ip):je(ip)). 
  !   * im, km はそれぞれ X, Z 座標の格子点数であり, サブルーチン 
  !     eee_mpi_initial にてあらかじめ設定しておく.
  !   * eee_mpi_Initial によってプロセス毎に Y 方向の
  !     分割配置が設定され, その情報が public 変数 js,je,jc に設定される. 
  !   * js が分割配置の最小格子点, je が最大格子点, jc が格子点数である. 
  !   * 第 1 次元が Z 座標の格子点位置番号, 
  !     第 2 次元が X 座標の格子点位置番号, 
  !     第 3 次元が Y 座標であることに注意(X, Y, Zの順ではない).
  !
  ! * eee : スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(-nm:nm,-mm:mm,2*lc). 
  !   * mm, nm はそれぞれ Y, Z方向の最大波数であり, サブルーチン 
  !     eee_initial にてあらかじめ設定しておく
  !     (X, Y, Z 方向波数の順ではない)ことに注意. 
  !   * eee_mpi_Initial によってプロセス毎に X 方向波数の
  !     分割配置が設定され, その情報が public 変数 ls,le,lc に設定される. 
  !   * ls が分割配置の最小波数, le が最大波数, jc が波数の数である. 
  !     実際の格納のされ方は ls, ls+1,...,le,-le,-le+1,...,-ls の順である.
  !     ISPACK/P3PACK-MPI マニュアル参照のこと.
  !
  ! * ee2f : 2 つのスペクトルデータのならび. 
  !   * 変数の種類と次元は real(8), dimension(-nm:nm,-mm:mm,2,2*lc). 
  !
  ! * x, v, z : X, Y, Z 方向 1 次元格子点データ.
  !   * 変数の種類と次元はそれぞれ real(8), dimension(0:im-1),
  !     real(8), dimension(js(ip):je(ip)) および real(8), dimension(0:km-1).
  !
  ! * eee_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * zxv_ で始まる関数が返す値は 3 次元格子点データに同じ.
  !
  ! * x_, v_ z_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! eee_Initial :: スペクトル変換の格子点数, 切断波数の設定
  ! eee_ChangeResolution :: 解像度設定の変更
  ! lf_l        :: X 方向波数の位置情報
  !
  !==== 座標変数
  !
  ! x_X, v_Y, z_Z    ::  格子点座標(X,Y座標)を格納した 1 次元配列
  ! x_X_Weight, v_Y_Weight,  z_Z_Weight ::  重み座標を格納した 1 次元配列
  ! zxv_X, zxv_Y, zxv_Z  :: 格子点データの XYZ 座標(X,Y,Z)
  !                         (格子点データ型 3 次元配列)
  !
  !==== 基本変換
  !
  ! zxv_eef   :: スペクトルデータから格子データへの変換
  ! eef_zxv   :: 格子データからスペクトルデータへの変換
  ! xyz_zxv   :: 分散格子点データの集積
  ! eee2_ee2f :: 分散スペクトルデータの集積
  ! ee2f_eee2 :: 集積スペクトルデータの分散
  !
  !==== 微分
  !
  ! eef_Lapla_eef       :: スペクトルデータにラプラシアンを作用させる
  ! eef_LaplaInv_eef    :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! eef_Dx_eef          :: スペクトルデータに X 微分を作用させる
  ! eef_Dy_eef          :: スペクトルデータに Y 微分を作用させる
  ! eef_Dz_eef          :: スペクトルデータに Z 微分を作用させる
  !
  !==== 非線形計算
  !
  ! ee2f_RotVelxVor_ee2f   :: Euler 方程式の非線形項を計算する
  ! eef_VorFromZeta_ee2f   :: 渦度 2 成分(ζ_1, ζ_2)ら渦度の 1 成分を計算する
  ! eef_VelFromZeta_ee2f   :: 渦度 2 成分(ζ_1, ζ_2)ら速度の 1 成分を計算する
  ! ee2f_ZetaFromVor_eef_eef_eef :: 渦度から渦度 2 成分(ζ_1, ζ_2)を計算する
  !
  !==== 積分・平均
  !
  ! IntZXV_zxv, AvrZXV_zxv   :: 3 次元格子点データの全領域積分および平均
  ! z_IntXV_zxv, z_AvrXV_zxv :: 3 次元格子点データの X,Y 方向積分および平均
  ! x_IntZV_zxv, x_AvrZV_zxv :: 3 次元格子点データの Y,Z 方向積分および平均
  ! y_IntZX_zxv, y_AvrZX_zxv :: 3 次元格子点データの Z,X 方向積分および平均
  ! zv_IntX_zxv, zv_AvrX_zxv :: 3 次元格子点データの X 方向積分および平均
  ! zx_IntY_zxv, zx_AvrY_zxv :: 3 次元格子点データの Y 方向積分および平均
  ! vx_IntZ_zxv, vx_AvrZ_zxv :: 3 次元格子点データの Z 方向積分および平均
  !
  ! IntXV_xv,  AvrXV_xv  :: 2 次元(XY)格子点データの X,Y 方向積分および平均
  ! v_IntX_xv, v_AvrX_xv :: 2 次元(XY)格子点データの X 方向積分および平均
  ! x_IntV_xv, x_AvrV_xv :: 2 次元(XY)格子点データの Y 方向積分および平均
  ! IntZX_zx, AvrZX_zx   :: 2 次元(ZX)格子点データの Z,X 方向積分および平均
  ! z_IntX_zx, z_AvrX_zx :: 2 次元(ZX)格子点データの X 方向積分および平均
  ! x_IntZ_zx, x_AvrZ_zx :: 2 次元(ZX)格子点データの Z 方向積分および平均
  ! IntZV_zv, AvrZV_zv   :: 2 次元(YZ)格子点データの Y,Z 方向積分および平均
  ! v_IntZ_zv, v_AvrZ_zv :: 2 次元(YZ)格子点データの Z 方向積分および平均
  ! z_IntV_zv, z_AvrV_zv :: 2 次元(YZ)格子点データの Y 方向積分および平均
  !
  ! IntX_x, AvrX_x       :: 1 次元(X)格子点データの X 方向積分および平均
  ! IntV_v, AvrV_v       :: 1 次元(Y)格子点データの Y 方向積分および平均
  ! IntZ_z, AvrZ_z       :: 1 次元(Z)格子点データの Z 方向積分および平均
  !
  !==== スペクトル解析
  !
  ! EnergyHelicityFromZeta_ee2f  :: 全エネルギーと全ヘリシティーを計算する. 
  ! ESpectralFromZeta            :: エネルギースペクトルを計算する. 
  !
  use dc_message, only : MessageNotify
  use mpi
  implicit none

  private
  public ls, le, lc
  public js, je, jc
  public lf_l
  public eee_mpi_Initial                                  ! 初期化ルーチン
  public eee_ChangeResolution                             ! 解像度設定の変更
  public zxv_eef, eef_zxv                                 ! 基本変換
  public xyz_zxv                                          ! 基本変換
  public eee2_ee2f, ee2f_eee2                             ! 基本変換
  public eef_Dx_eef, eef_Dy_eef, eef_Dz_eef               ! 微分
  public eef_Lapla_eef, eef_LaplaInv_eef                  ! 微分
  public ee2f_RotVelxVor_ee2f                             ! 非線形計算
  public eef_VorFromZeta_ee2f, eef_VelFromZeta_ee2f       ! 渦度速度計算
  public ee2f_ZetaFromVor_eef_eef_eef                     ! 渦度変換

  public IntZXV_zxv, AvrZXV_zxv                           ! 積分・平均
  public z_IntXV_zxv, z_AvrXV_zxv                         ! 積分・平均
  public x_IntZV_zxv, x_AvrZV_zxv                         ! 積分・平均
  public v_IntZX_zxv, v_AvrZX_zxv                         ! 積分・平均
  public zv_IntX_zxv, zv_AvrX_zxv                         ! 積分・平均
  public zx_IntV_zxv, zx_AvrV_zxv                         ! 積分・平均
  public xv_IntZ_zxv, xv_AvrZ_zxv                         ! 積分・平均

  public IntXV_xv,  AvrXV_xv                              ! 積分・平均
  public v_IntX_xv, v_AvrX_xv                             ! 積分・平均
  public x_IntV_xv, x_AvrV_xv                             ! 積分・平均
  public IntZX_zx, AvrZX_zx                               ! 積分・平均
  public z_IntX_zx, z_AvrX_zx                             ! 積分・平均
  public x_IntZ_zx, x_AvrZ_zx                             ! 積分・平均
  public IntZV_zv, AvrZV_zv                               ! 積分・平均
  public v_IntZ_zv, v_AvrZ_zv                             ! 積分・平均
  public z_IntV_zv, z_AvrV_zv                             ! 積分・平均

  public IntX_x, AvrX_x                                   ! 積分・平均
  public IntV_v, AvrV_v                                   ! 積分・平均
  public IntZ_z, AvrZ_z                                   ! 積分・平均

  public EnergyHelicityFromZeta_ee2f                      ! エネルギーヘリシティー
  public ESpectralFromZeta                                ! エネルギースペクトル

  public x_X, v_Y, z_Z                                    ! 座標変数
  public x_X_Weight, v_Y_Weight, z_Z_Weight               ! 座標変数
  public zxv_X, zxv_Y, zxv_Z                              ! 座標変数

  integer   :: im=32, jm=32, km=32                      ! 格子点の設定(X,Y,Z)
  integer   :: lm=10, mm=10, nm=10                      ! 切断波数の設定(X,Y,Z)

  integer, dimension(:),   pointer :: le => null()      ! X 波数範囲, 数
  integer, dimension(:),   pointer :: ls => null()      ! X 波数範囲, 数
  integer, dimension(:),   pointer :: lc => null()      ! X 波数範囲, 数
  integer, dimension(:),   pointer :: je => null()      ! Y 座標格子点範囲, 数
  integer, dimension(:),   pointer :: js => null()      ! Y 座標格子点範囲, 数
  integer, dimension(:),   pointer :: jc => null()      ! Y 座標格子点範囲, 数
  integer   :: np, ip                             ! MPI プロセス数, プロセス ID

  integer, dimension(:),   pointer :: itk => null()
  real(8), dimension(:),   pointer :: tk => null()
  integer, dimension(:),   pointer :: itj => null()
  real(8), dimension(:),   pointer :: tj => null()
  integer, dimension(:),   pointer :: iti => null()
  real(8), dimension(:),   pointer :: ti => null()


  real(8), dimension(:),   pointer :: x_X => null()   ! 格子点座標(X)
  real(8), dimension(:),   pointer :: v_Y => null()   ! 格子点座標(Y)
  real(8), dimension(:),   pointer :: z_Z => null()   ! 格子点座標(Y)

  real(8), dimension(:),   pointer :: x_X_Weight => null()
                                         ! 格子点重み(X)
                                         ! X 方向の格子点の間隔が格納してある.
  real(8), dimension(:),   pointer :: v_Y_Weight => null()
                                         ! 格子点重み(Y)
                                         ! Y 方向の格子点の間隔が格納してある.
  real(8), dimension(:),   pointer :: z_Z_Weight => null()
                                         ! 格子点重み(Y)
                                         ! Z 方向の格子点の間隔が格納してある.

  real(8), dimension(:,:,:), pointer :: zxv_X => null()
                          ! 格子点(X)座標(3 次元)
                          ! 各格子点(i,j,k)の位置の X 座標を格納した格子データ
  real(8), dimension(:,:,:), pointer :: zxv_Y => null()
                          ! 格子点(Y)座標(3 次元)
                          ! 各格子点(i,j,k)の位置の Y 座標を格納した格子データ
  real(8), dimension(:,:,:), pointer :: zxv_Z => null()
                          ! 格子点(Z)座標(3 次元)
                          ! 各格子点(i,j,k)の位置の Z 座標を格納した格子データ

  real(8), dimension(:), pointer :: w => null(), ws => null(), wg => null()
  real(8), dimension(:), pointer :: sgwork => null()

  integer, parameter :: nparams_max = 10  ! eee_Initial を呼べる最大回数
  type eee_param                          ! 解像度領域情報構造体
     integer   :: im, jm, km
     integer   :: lm, mm, nm
     integer, dimension(:),     pointer :: ls, le, lc
     integer, dimension(:),     pointer :: js, je, jc
     integer, dimension(:),     pointer :: itk
     real(8), dimension(:),     pointer :: tk
     integer, dimension(:),     pointer :: itj
     real(8), dimension(:),     pointer :: tj
     integer, dimension(:),     pointer :: iti
     real(8), dimension(:),     pointer :: ti
     real(8), dimension(:),     pointer :: x_X
     real(8), dimension(:),     pointer :: v_Y
     real(8), dimension(:),     pointer :: z_Z
     real(8), dimension(:),     pointer :: x_X_Weight
     real(8), dimension(:),     pointer :: v_Y_Weight
     real(8), dimension(:),     pointer :: z_Z_Weight
     real(8), dimension(:,:,:), pointer :: zxv_X
     real(8), dimension(:,:,:), pointer :: zxv_Y 
     real(8), dimension(:,:,:), pointer :: zxv_Z
     real(8), dimension(:),     pointer :: w, ws, wg
     real(8), dimension(:),     pointer :: sgwork
  end type eee_param
  type(eee_param) :: params(nparams_max)  ! 解像度領域情報
  integer :: nparams                      ! 解像度領域情報の個数

  real(8), parameter  :: pi=3.1415926535897932385D0

  save im, jm, km, lm, mm, nm, itk, tk, itj, tj, iti, ti
  save ls, le, lc, js, je, jc, np, ip
  save x_X, v_Y, z_Z, x_X_Weight, v_Y_Weight, z_Z_Weight, zxv_X, zxv_Y, zxv_Z
  save params, nparams

  contains
  !--------------- 初期化 -----------------
    subroutine eee_mpi_Initial(i,j,k,l,m,n,id)
      !
      ! スペクトル変換の格子点数, 波数を設定する.
      ! 領域の範囲は [0,2pi]x[0,2pi]x[0,2pi] に決め打ち
      !
      ! 他の関数や変数を呼ぶ前に, 最初にこのサブルーチンを呼んで
      ! 初期設定をしなければならない.
      !
      ! オプショナル引数 id を用いて異なる解像度, 領域を同時に
      ! 扱うことができる. eee_Initial を解像度, 領域ごとに呼んで
      ! 引数 id をキープし, eee_ChangeResolution で切替える.
      !
      integer,intent(in) :: i           ! 格子点数(X)
      integer,intent(in) :: j           ! 格子点数(Y)
      integer,intent(in) :: k           ! 格子点数(Z)
      integer,intent(in) :: l           ! 切断波数(X)
      integer,intent(in) :: m           ! 切断波数(Y)
      integer,intent(in) :: n           ! 切断波数(X)

      integer, intent(out), optional :: id  ! 解像度領域情報番号

      character(len=3) cid
      integer :: ii, jj, kk
      integer :: lls, lle, llc, jjs, jje, jjc
      integer :: iip
      integer :: lp, jp
      integer :: ierr

      im = i         ; jm = j         ; km = k
      lm = l         ; mm = m         ; nm = n

      if ( nparams .ge. nparams_max ) then
         call MessageNotify('W','eee_initial',&
              'too many call of eee_Initial, nothing was done.')
         if ( present(id) ) id = -1
         return
      end if

      CALL MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

      lp=lm/np+1
      lls=lp*ip
      lle=min(lp*(ip+1)-1,lm)
      if(lle.ge.lls) then
         llc=lle-lls+1
      else
         llc=0 ;  lls=0  ; lle=0
      end if

      jp=(jm-1)/np+1
      jjs=jp*ip
      jje=min(jp*(ip+1)-1,jm-1)
      if(jje.ge.jjs) then
         jjc=jje-jjs+1
      else
         jjc=0 ; jjs=0 ; jje=0
      end if

      nparams = nparams + 1

      params(nparams)%im = im
      params(nparams)%jm = jm
      params(nparams)%km = km
      params(nparams)%lm = lm
      params(nparams)%mm = mm
      params(nparams)%nm = nm
      allocate(params(nparams)%ls(0:np-1))
      allocate(params(nparams)%le(0:np-1))
      allocate(params(nparams)%lc(0:np-1))
      allocate(params(nparams)%js(0:np-1))
      allocate(params(nparams)%je(0:np-1))
      allocate(params(nparams)%jc(0:np-1))

      allocate(params(nparams)%itk(5))
      allocate(params(nparams)%itj(5))
      allocate(params(nparams)%iti(5))
      allocate(params(nparams)%tk(km*2))
      allocate(params(nparams)%tj(jm*2))
      allocate(params(nparams)%ti(im*2))
      allocate(params(nparams)%w(km*max(im*((jm-1)/np+1),jm*2*(lm/np+1))))
      allocate(params(nparams)%ws((2*mm+1)*(2*nm+1)*2*2*(lm+1)))
      allocate(params(nparams)%wg(4*km*max(im*((jm-1)/np+1),jm*2*(lm/np+1))))
      allocate(params(nparams)%sgwork(km*max(im*((jm-1)/np+1),jm*2*(lm/np+1))))

      allocate(params(nparams)%x_X(0:im-1))
      allocate(params(nparams)%x_X_Weight(0:im-1))
      allocate(params(nparams)%v_Y(jjs:jje))
      allocate(params(nparams)%v_Y_Weight(jjs:jje))
      allocate(params(nparams)%z_Z(0:km-1))
      allocate(params(nparams)%z_Z_Weight(0:km-1))
      allocate(params(nparams)%zxv_X(0:km-1,0:im-1,jjs:jje))
      allocate(params(nparams)%zxv_Y(0:km-1,0:im-1,jjs:jje))
      allocate(params(nparams)%zxv_Z(0:km-1,0:im-1,jjs:jje))

      call eee_ChangeResolution(nparams)

      call p3init(km,jm,im,itk,tk,itj,tj,iti,ti)

      do iip=0,np-1
         lp=lm/np+1
         ls(iip)=lp*iip
         le(iip)=min(lp*(iip+1)-1,lm)
         if(le(iip).ge.ls(iip)) then
            lc(iip)=le(iip)-ls(iip)+1
         else
            lc(iip)=0 ;  ls(iip)=0  ; le(iip)=0
         end if

         jp=(jm-1)/np+1
         js(iip)=jp*iip
         je(iip)=min(jp*(iip+1)-1,jm-1)
         if(je(iip).ge.js(iip)) then
            jc(iip)=je(iip)-js(iip)+1
         else
            jc(iip)=0 ; js(iip)=0 ; je(iip)=0
         end if
      enddo

      do ii=0,im-1
         x_X(ii) = 2*pi/im*ii
      enddo
      x_X_Weight = 2*pi/im

      do jj=js(ip),je(ip)
         v_Y(jj) = 2*pi/jm*jj
      enddo
      v_Y_Weight = 2*pi/jm

      do kk=0,km-1
         z_Z(kk) = 2*pi/km*kk
      enddo
      z_Z_Weight = 2*pi/km

      zxv_X = spread(spread(x_X,1,km),3,jc(ip))
      zxv_Y = spread(spread(v_Y,1,im),1,km)
      zxv_Z = spread(spread(z_Z,2,im),3,jc(ip))

      if ( present(id) ) id = nparams

      write(cid,'(I3)') nparams
      call MessageNotify('M','eee_mpi_initial','eee_mpi_module is initialized')
      call MessageNotify('M','eee_mpi_initial',&
           'Resolution ID is '//trim(adjustl(cid)))
    end subroutine eee_mpi_Initial

  !--------------- id 変更 -----------------
    subroutine eee_ChangeResolution(id)
      !
      ! 解像度設定の変更. eee_Initial で設定する際に
      ! かえってくるオプショナル引数 id の値を用いる. 
      !
      integer, intent(in) :: id

      if (id .gt. nparams .or. id .lt. 1) then
         write(*,*)"id is invalid"
      end if

      im = params(id)%im
      jm = params(id)%jm
      km = params(id)%km
      lm = params(id)%lm
      mm = params(id)%mm
      nm = params(id)%nm
      ls => params(id)%ls
      le => params(id)%le
      lc => params(id)%lc
      js => params(id)%js
      je => params(id)%je
      jc => params(id)%jc
      itk => params(id)%itk
      tk  => params(id)%tk
      itj => params(id)%itj
      tj  => params(id)%tj
      iti => params(id)%iti
      ti  => params(id)%ti
      x_X => params(id)%x_X
      v_Y => params(id)%v_Y
      z_Z => params(id)%z_Z
      x_X_Weight => params(id)%x_X_Weight
      v_Y_Weight => params(id)%v_Y_Weight
      z_Z_Weight => params(id)%z_Z_Weight
      zxv_X => params(id)%zxv_X
      zxv_Y => params(id)%zxv_Y
      zxv_Z => params(id)%zxv_Z
      w => params(id)%w
      ws => params(id)%ws
      wg => params(id)%wg
      sgwork => params(id)%sgwork

    end subroutine eee_ChangeResolution

  !--------------- 波数位置問い合わせ -----------------
    function lf_l(l)
      !
      ! スペクトルデータ eef(-nm:nm,-mm,mm,2*lc) での
      ! X 方向波数 L の位置情報(第 3 添え字)を調べる.
      !
      ! X 方向波数については ls,ls+1,... le, -le,-le+1,...,-ls
      ! の順に格納されている(ISPACK/P3PACK マニュアル参照のこと)
      !
      integer, intent(IN)  ::  l        ! X 方向波数
      integer              ::  lf_l     ! スペクトルデータ第 3 添え字

      if ( abs(l) < ls(ip) .OR. le(ip) < abs(l) ) then
         call MessageNotify('E','l_l','Input wavenumber out of range')
      endif
      
      if ( l >= 0 ) then
         lf_l = l-ls(ip)+1
      else
         lf_l = ls(ip)+2*lc(ip)-abs(l)
      endif

    end function lf_l

  !--------------- 基本変換 -----------------
    function zxv_eef(eef)
      !
      ! スペクトルデータから格子データへ変換する.
      !
      real(8), dimension(0:km-1,0:im-1,js(ip):je(ip))        :: zxv_eef
                                                        !(out) 格子点データ
      real(8), dimension(-nm:nm,-mm:mm,2*lc(ip)), intent(in) :: eef
                                                        !(in)  スペクトルデータ
      sgwork(1:(2*nm+1)*(2*mm+1)*2*lc(ip)) &
           = reshape(eef,(/(2*nm+1)*(2*mm+1)*2*lc(ip)/))

      call p3smgb(nm,mm,lm,km,jm,im,sgwork,w,itk,tk,itj,tj,iti,ti)

      zxv_eef = reshape(sgwork(1:im*km*jc(ip)),(/km,im,jc(ip)/))
    end function zxv_eef

    function eef_zxv(zxv)
      !
      ! 格子データからスペクトルデータへ変換する.
      !
      real(8), dimension(-nm:nm,-mm:mm,2*lc(ip))                  :: eef_zxv
                                                      !(out)  スペクトルデータ
      real(8), dimension(0:km-1,0:im-1,js(ip):je(ip)), intent(in) :: zxv
                                                      !(in) 格子点データ

      sgwork(1:im*jc(ip)*km) = reshape(zxv,(/im*jc(ip)*km/))

      call p3gmsb(nm,mm,lm,km,jm,im,sgwork,w,itk,tk,itj,tj,iti,ti)

      eef_zxv = reshape(sgwork(1:(2*nm+1)*(2*mm+1)*2*lc(ip)),&
                               (/2*nm+1,2*mm+1,2*lc(ip)/))

    end function eef_zxv

    function eee2_ee2f(ee2f)
      !
      ! 分散スペクトルデータを集積する
      !
      real(8), dimension(-nm:nm,-mm:mm,-lm:lm,2)             :: eee2_ee2f
      !(out)  スペクトルデータ

      real(8), dimension(-nm:nm,-mm:mm,2,2*lc(ip)),intent(IN) :: ee2f
      !(in) 分散スペクトルデータ
      
      real(8), dimension(-nm:nm,-mm:mm,2,0:2*sum(lc)-1)       :: ee2e
      ! 作業データ
      integer, dimension(0:np-1) :: nm2ls
      integer :: ierr, iip
      integer :: l

      nm2ls(0)   = 0
      do iip=1,np-1
         nm2ls(iip) = nm2ls(iip-1) + (2*nm+1)*(2*mm+1)*2*2*lc(iip-1)
      enddo

      call MPI_ALLGATHERV(ee2f,(2*nm+1)*(2*mm+1)*2*2*lc(ip),MPI_REAL8,&
                          ee2e,(2*nm+1)*(2*mm+1)*2*2*lc,nm2ls,&
                          MPI_REAL8,MPI_COMM_WORLD,IERR)

      do l=ls(0),le(0)
         eee2_ee2f(:,:,l,:) = ee2e(:,:,:,l-ls(0))
         if ( l /= 0 ) then
            eee2_ee2f(:,:,-l,:) = ee2e(:,:,:,2*lc(0)-(l-ls(0)+1))
         endif
      enddo

      do iip=1,np-1
         do l=ls(iip),le(iip)
            eee2_ee2f(:,:,l,:) = ee2e(:,:,:,2*sum(lc(0:iip-1))+(l-ls(iip)))
            eee2_ee2f(:,:,-l,:) = ee2e(:,:,:,2*sum(lc(0:iip))-(l-ls(iip)+1))
         enddo
      enddo

    end function eee2_ee2f

    function ee2f_eee2(eee2)
      !
      ! スペクトルデータを分散する
      !
      real(8), dimension(-nm:nm,-mm:mm,2,2*lc(ip))       :: ee2f_eee2
      !(out)  スペクトルデータ

      real(8), dimension(-nm:nm,-mm:mm,-lm:lm,2), intent(IN) :: eee2
      !(in) 分散スペクトルデータ
      
      ! 作業データ
      integer :: l 

      do l=ls(ip),le(ip)
         ee2f_eee2(:,:,:,l-ls(ip)+1) = eee2(:,:,l,:)
         ee2f_eee2(:,:,:,2*lc(ip)-(l-ls(ip))) = eee2(:,:,-l,:)
      enddo
      
    end function ee2f_eee2

    function xyz_zxv(zxv)
      !
      ! 分散格子データの集積
      !
      real(8), dimension(0:im-1,0:jm-1,0:km-1)             :: xyz_zxv
                                                        !(out) 格子点データ

      real(8), dimension(0:km-1,0:im-1,js(ip):je(ip)), intent(in)  :: zxv
                                                        !(in) 格子点データ
      real(8), dimension(0:km-1,0:im-1,0:jm-1)  :: zxy
      ! 作業変数

      integer :: i,j,k
      integer :: ierr

      call MPI_ALLGATHERV(zxv,km*im*jc(ip),MPI_REAL8,&
                          zxy,km*im*jc,km*im*js,MPI_REAL8,&
                          MPI_COMM_WORLD,IERR)

      do k=0,km-1
         do j=0,jm-1
            do i=0,im-1
               xyz_zxv(i,j,k) = zxy(k,i,j)
            enddo
         enddo
      enddo

    end function xyz_zxv
    
  !--------------- 微分計算 -----------------
    function eef_Lapla_eef(eef)
      !
      ! 入力スペクトルデータにラプラシアン(∂xx+∂yy+∂zz)を作用する.
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに全波数 (l**2 + m**2 + n**2) をかける
      ! 計算を行っている. 
      !
      real(8), dimension(-nm:nm,-mm:mm,2*lc(ip))              :: eef_Lapla_eef
      !(out) スペクトルデータのラプラシアン

      real(8), dimension(-nm:nm,-mm:mm,2*lc(ip)), intent(in)  :: eef
      !(in) 入力スペクトルデータ

      integer l,m,n
      ! 作業変数

      eef_Lapla_eef = 0.0

      do l=ls(ip),le(ip)
         do m=-mm,mm
            do n=-nm,nm
               eef_Lapla_eef(n,m,lf_l(l)) = -(l**2+m**2+n**2)*eef(n,m,lf_l(l))
               eef_Lapla_eef(n,m,lf_l(-l)) = -(l**2+m**2+n**2)*eef(n,m,lf_l(-l))
            enddo
         enddo
      enddo

    end function eef_Lapla_eef

    function eef_LaplaInv_eef(eef)
      !
      ! 入力スペクトルデータに逆ラプラシアン(∂xx+∂yy+∂zz)**(-1)を作用する.
      !
      ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
      ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに全波数 (l**2 + m**2 + n**2) で割る
      ! 計算を行っている. l=m=n=0 成分には 0 を代入している. 
      !
      real(8), dimension(-nm:nm,-mm:mm,2*lc(ip))             :: eef_LaplaInv_eef
      !(out) スペクトルデータの逆ラプラシアン

      real(8), dimension(-nm:nm,-mm:mm,2*lc(ip)), intent(in) :: eef
      !(in) スペクトルデータ

      integer l,m,n

      eef_LaplaInv_eef = 0.0
      do l=ls(ip),le(ip)
         do m=-mm,mm
            do n=-nm,nm
               if ( l.ne.0 .or. m.ne.0 .or. n.ne.0 ) then
                  eef_LaplaInv_eef(n,m,lf_l(l)) = -eef(n,m,lf_l(l))/(l**2+m**2+n**2)
                  eef_LaplaInv_eef(n,m,lf_l(-l)) = -eef(n,m,lf_l(-l))/(l**2+m**2+n**2)
               endif
            enddo
         enddo
      enddo
    end function eef_LaplaInv_eef

    function eef_Dx_eef(eef)
      !
      ! 入力スペクトルデータに X 微分(∂x)を作用する.
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 l をかけて
      ! 実部 <-> 虚部成分に入れ換える計算を行っている.
      !
      real(8), dimension(-nm:nm,-mm:mm,2*lc(ip))              :: eef_Dx_eef
      !(out) スペクトルデータの X 微分

      real(8), dimension(-nm:nm,-mm:mm,2*lc(ip)), intent(in)  :: eef
      !(in) 入力スペクトルデータ

      integer l,m,n
      ! 作業変数

      eef_Dx_eef = 0.0
      do l=ls(ip),le(ip)
         do m=-mm,mm
            do n=-nm,nm
               eef_Dx_eef(n,m,lf_l(l)) = -l*eef(-n,-m,lf_l(-l))
            enddo
         enddo
      enddo

      do l=-le(ip),-ls(ip)
         do m=-mm,mm
            do n=-nm,nm
               eef_Dx_eef(n,m,lf_l(l)) = -l*eef(-n,-m,lf_l(-l))
            enddo
         enddo
      enddo
    end function eef_Dx_eef

    function eef_Dy_eef(eef)
      !
      ! 入力スペクトルデータに Y 微分(∂y)を作用する.
      !
      ! スペクトルデータの Y 微分とは, 対応する格子点データに Y 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに Y 方向波数 m をかけて
      ! 実部 <-> 虚部成分に入れ換える計算を行っている.
      !
      real(8), dimension(-nm:nm,-mm:mm,2*lc(ip))              :: eef_Dy_eef
      !(out) スペクトルデータの X 微分

      real(8), dimension(-nm:nm,-mm:mm,2*lc(ip)), intent(in)  :: eef
      !(in) 入力スペクトルデータ

      integer l,m,n
      ! 作業変数

      eef_Dy_eef = 0.0
      do l=ls(ip),le(ip)
         do m=-mm,mm
            do n=-nm,nm
               eef_Dy_eef(n,m,lf_l(l)) = -m*eef(-n,-m,lf_l(-l))
            enddo
         enddo
      enddo

      do l=-le(ip),-ls(ip)
         do m=-mm,mm
            do n=-nm,nm
               eef_Dy_eef(n,m,lf_l(l)) = -m*eef(-n,-m,lf_l(-l))
            enddo
         enddo
      enddo

    end function eef_Dy_eef

    function eef_Dz_eef(eef)
      !
      ! 入力スペクトルデータに Z 微分(∂z)を作用する.
      !
      ! スペクトルデータの Z 微分とは, 対応する格子点データに Z 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに Z 方向波数 n をかけて
      ! 実部 <-> 虚部成分に入れ換える計算を行っている.
      !
      real(8), dimension(-nm:nm,-mm:mm,2*lc(ip))              :: eef_Dz_eef
      !(out) スペクトルデータの X 微分

      real(8), dimension(-nm:nm,-mm:mm,2*lc(ip)), intent(in)  :: eef
      !(in) 入力スペクトルデータ

      integer l,m,n
      ! 作業変数

      eef_Dz_eef = 0.0
      do l=ls(ip),le(ip)
         do m=-mm,mm
            do n=-nm,nm
               eef_Dz_eef(n,m,lf_l(l)) = -n*eef(-n,-m,lf_l(-l))
            enddo
         enddo
      enddo

      do l=-le(ip),-ls(ip)
         do m=-mm,mm
            do n=-nm,nm
               eef_Dz_eef(n,m,lf_l(l)) = -n*eef(-n,-m,lf_l(-l))
            enddo
         enddo
      enddo

    end function eef_Dz_eef

  !--------------- 非線形項計算 -----------------

    function ee2f_RotVelxVor_ee2f(ee2f)
      !
      !  渦度 2 成分(ζ_1, ζ_2)のスペクトルデータから Euler 方程式の非線形項
      !
      !     ▽x(u x ω) 
      !
      !  の 2 成分を計算する.
      !
      !  (ζ_1, ζ_2) と渦度 ω との関係は ISPACK/P3PACK のマニュアルを参照
      !
      real(8), dimension(-nm:nm,-mm:mm,2,2*lc(ip))     :: ee2f_RotVelxVor_ee2f
      !(out) 非線形項のスペクトルデータの 2 つの成分

      real(8), dimension(-nm:nm,-mm:mm,2,2*lc(ip)), intent(in)  :: ee2f
      !(in) 入力スペクトルデータ. 渦度の 2 成分(ζ_1, ζ_2)

      ee2f_RotVelxVor_ee2f = 0.0D0
      call p3emnl(nm,mm,lm,km,jm,im,ee2f,ee2f_RotVelxVor_ee2f, &
                  wg,itk,tk,itj,tj,iti,ti)

    end function ee2f_RotVelxVor_ee2f

    function eef_VorFromZeta_ee2f(ee2f,isw)
      !
      !  渦度 2 成分(ζ_1, ζ_2)のスペクトルデータから渦度のスペクトルの 1 成分
      !  を計算する.
      !
      !  (ζ_1, ζ_2) と渦度 ω との関係は ISPACK/P3PACK のマニュアルを参照
      !
      real(8), dimension(-nm:nm,-mm:mm,2*lc(ip))     :: eef_VorFromZeta_ee2f
      !(out) 非線形項のスペクトルデータの 2 つの成分

      real(8), dimension(-nm:nm,-mm:mm,2,2*lc(ip)), intent(in)  :: ee2f
      !(in) 入力スペクトルデータ. 渦度の 2 成分(ζ_1, ζ_2)

      integer, intent(IN) :: isw
      !(in) 出力する渦度の成分のインデックス(1,2,3)

      eef_VorFromZeta_ee2f = 0.0D0
      call p3gmto(nm,mm,lm,ee2f,eef_VorFromZeta_ee2f,isw)

    end function eef_VorFromZeta_ee2f

    function eef_VelFromZeta_ee2f(ee2f,isw)
      !
      !  渦度 2 成分(ζ_1, ζ_2)のスペクトルデータから速度スペクトルの 1 成分
      !  を計算する.
      !
      !  (ζ_1, ζ_2) と渦度 ω との関係は ISPACK/P3PACK のマニュアルを参照
      !
      real(8), dimension(-nm:nm,-mm:mm,2*lc(ip))     :: eef_VelFromZeta_ee2f
      !(out) 非線形項のスペクトルデータの 2 つの成分

      real(8), dimension(-nm:nm,-mm:mm,2,2*lc(ip)), intent(in)  :: ee2f
      !(in) 入力スペクトルデータ. 渦度の 2 成分(ζ_1, ζ_2)

      integer, intent(IN) :: isw
      !(in) 出力する渦度の成分のインデックス(1,2,3)

      eef_VelFromZeta_ee2f = 0.0D0
      call p3gmtu(nm,mm,lm,ee2f,eef_VelFromZeta_ee2f,isw)

    end function eef_VelFromZeta_ee2f

    function ee2f_ZetaFromVor_eef_eef_eef(eef_1,eef_2,eef_3)
      !
      !  渦度のスペクトルから渦度 2 成分(ζ_1, ζ_2)を計算する.
      !
      !  (ζ_1, ζ_2) と渦度 ω との関係は ISPACK/P3PACK のマニュアルを参照
      !
      real(8), dimension(-nm:nm,-mm:mm,2,2*lc(ip))     :: ee2f_ZetaFromVor_eef_eef_eef
      !(out) 渦度の 2 成分(ζ_1, ζ_2)

      real(8), dimension(-nm:nm,-mm:mm,2*lc(ip)), intent(in)  :: eef_1, eef_2, eef_3
      !(in) 渦度スペクトルデータの各成分

      integer :: l,m,n

      ee2f_ZetaFromVor_eef_eef_eef = 0.0D0
      do l=ls(ip),le(ip)
         do m=-mm,mm
            do n=-nm,nm
               if ( l /= 0 ) then
                  ee2f_ZetaFromVor_eef_eef_eef(n,m,1,lf_l(l)) = eef_2(n,m,lf_l(l))
                  ee2f_ZetaFromVor_eef_eef_eef(n,m,2,lf_l(l)) = eef_3(n,m,lf_l(l))
               elseif( m /= 0 ) then
                  ee2f_ZetaFromVor_eef_eef_eef(n,m,1,lf_l(l)) = eef_3(n,m,lf_l(l))
                  ee2f_ZetaFromVor_eef_eef_eef(n,m,2,lf_l(l)) = eef_1(n,m,lf_l(l))
               else
                  ee2f_ZetaFromVor_eef_eef_eef(n,m,1,lf_l(l)) = eef_1(n,m,lf_l(l))
                  ee2f_ZetaFromVor_eef_eef_eef(n,m,2,lf_l(l)) = eef_2(n,m,lf_l(l))
               endif
            enddo
         enddo
      enddo

      do l=-le(ip),-ls(ip)
         do m=-mm,mm
            do n=-nm,nm
               if ( l /= 0 ) then
                  ee2f_ZetaFromVor_eef_eef_eef(n,m,1,lf_l(l)) = eef_2(n,m,lf_l(l))
                  ee2f_ZetaFromVor_eef_eef_eef(n,m,2,lf_l(l)) = eef_3(n,m,lf_l(l))
               elseif( m /= 0 ) then
                  ee2f_ZetaFromVor_eef_eef_eef(n,m,1,lf_l(l)) = eef_3(n,m,lf_l(l))
                  ee2f_ZetaFromVor_eef_eef_eef(n,m,2,lf_l(l)) = eef_1(n,m,lf_l(l))
               else
                  ee2f_ZetaFromVor_eef_eef_eef(n,m,1,lf_l(l)) = eef_1(n,m,lf_l(l))
                  ee2f_ZetaFromVor_eef_eef_eef(n,m,2,lf_l(l)) = eef_2(n,m,lf_l(l))
               endif
            enddo
         enddo
      enddo

    end function ee2f_ZetaFromVor_eef_eef_eef

  !--------------- 積分計算 -----------------
    function IntZXV_zxv(zxv)
      !
      ! 3 次元格子点データの全領域積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight, z_Z_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:km-1,0:im-1,js(ip):je(ip)), intent(IN)   :: zxv
      !(in)  3 次元格子点データ

      real(8)                                    :: IntZXV_zxv
      !(out) 積分値

      real(8) :: IntZXVTMP
      integer :: i, j, k
      integer :: ierr
      ! 作業変数

      IntZXV_zxv = 0.0d0
      do j=js(ip),je(ip)
         do i=0,im-1
            do k=0,km-1
               IntZXV_zxv = IntZXV_zxv &
                    + zxv(k,i,j) * z_Z_Weight(k) * v_Y_Weight(j) * x_X_Weight(i)
            enddo
         enddo
      end do

      IntZXVTMP=IntZXV_zxv
      CALL MPI_ALLREDUCE(IntZXVTMP,IntZXV_zxv,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function IntZXV_zxv

    function z_IntXV_zxv(zxv)
      !
      ! 3 次元格子点データの X,Y 方向積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:km-1,0:im-1,js(ip):je(ip)), intent(IN)   :: zxv
      !(in) 2 次元格子点データ

      real(8), dimension(0:km-1)          :: z_IntXV_zxv
      !(out) 積分された 1 次元(Y)格子点データ

      real(8), dimension(0:km-1)          :: z_IntXVTmp
      integer :: i, j
      integer :: ierr
      ! 作業変数

      z_IntXV_zxv = 0.0d0
      do i=0,im-1
         do j=js(ip),je(ip)
            z_IntXV_zxv(:) = &
                 z_IntXV_zxv(:) + zxv(:,i,j) * x_X_Weight(i)* v_Y_Weight(j)
         enddo
      enddo

      z_IntXVTMP=z_IntXV_zxv
      CALL MPI_ALLREDUCE(z_IntXVTMP,z_IntXV_zxv,km,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function z_IntXV_zxv

    function v_IntZX_zxv(zxv)
      !
      ! 3 次元格子点データの X,Z 方向積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight, z_Z_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:km-1,0:im-1,js(ip):je(ip)), intent(IN)   :: zxv
      !(in) 2 次元格子点データ

      real(8), dimension(js(ip):je(ip))          :: v_IntZX_zxv
      !(out) 積分された 1 次元(Y)格子点データ

      integer :: i, k
      ! 作業変数

      v_IntZX_zxv = 0.0d0
      do i=0,im-1
         do k=0,km-1
            v_IntZX_zxv(:) = &
                 v_IntZX_zxv(:) + zxv(k,i,:) * x_X_Weight(i)* z_Z_Weight(k)
         enddo
      enddo
    end function v_IntZX_zxv

    function x_IntZV_zxv(zxv)
      !
      ! 3 次元格子点データの Y,Z 方向積分
      !
      ! 実際には格子点データ各点毎に y_Y_Weight, z_Z_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:km-1,0:im-1,js(ip):je(ip)), intent(IN)   :: zxv
      !(in) 2 次元格子点データ

      real(8), dimension(0:im-1)          :: x_IntZV_zxv
      !(out) 積分された 1 次元(Y)格子点データ

      real(8), dimension(0:im-1)          :: x_IntZVTMP
      integer :: j, k
      integer :: ierr
      ! 作業変数

      x_IntZV_zxv = 0.0d0
      do j=js(ip),je(ip)
         do k=0,km-1
            x_IntZV_zxv(:) = &
                 x_IntZV_zxv(:) + zxv(k,:,j) * v_Y_Weight(j)* z_Z_Weight(k)
         enddo
      enddo

      x_IntZVTMP=x_IntZV_zxv
      CALL MPI_ALLREDUCE(x_IntZVTMP,x_IntZV_zxv,im,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function x_IntZV_zxv

    function zv_IntX_zxv(zxv)
      !
      ! 3 次元格子点データの X 方向積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:km-1,0:im-1,js(ip):je(ip)), intent(IN)   :: zxv
      !(in) 2 次元格子点データ

      real(8), dimension(0:km-1,js(ip):je(ip))          :: zv_IntX_zxv
      !(out) 積分された 2 次元(ZY)格子点データ

      integer :: i
      ! 作業変数

      zv_IntX_zxv = 0.0d0
      do i=0,im-1
         zv_IntX_zxv(:,:) = zv_IntX_zxv(:,:) + zxv(:,i,:) * x_X_Weight(i)
      enddo

    end function zv_IntX_zxv

    function zx_IntV_zxv(zxv)
      !
      ! 3 次元格子点データの Y 方向積分
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:km-1,0:im-1,js(ip):je(ip)), intent(IN)   :: zxv
      !(in) 2 次元格子点データ

      real(8), dimension(0:km-1,0:im-1)          :: zx_IntV_zxv
      !(out) 積分された 1 次元(Y)格子点データ

      real(8), dimension(0:km-1,0:im-1)          :: zx_IntVTMP
      integer :: j
      integer :: ierr
      ! 作業変数

      zx_IntV_zxv = 0.0d0
      do j=js(ip),je(ip)
         zx_IntV_zxv(:,:) = zx_IntV_zxv(:,:) + zxv(:,:,j) * v_Y_Weight(j)
      enddo

      zx_IntVTMP=zx_IntV_zxv
      CALL MPI_ALLREDUCE(zx_IntVTMP,zx_IntV_zxv,im*km,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)
    end function zx_IntV_zxv

    function xv_IntZ_zxv(zxv)
      !
      ! 3 次元格子点データの Z 方向積分
      !
      ! 実際には格子点データ各点毎に z_Z_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:km-1,0:im-1,js(ip):je(ip)), intent(IN)   :: zxv
      !(in) 2 次元格子点データ

      real(8), dimension(0:im-1,js(ip):je(ip))          :: xv_IntZ_zxv
      !(out) 積分された 1 次元(YX)格子点データ

      integer :: k 
      ! 作業変数

      xv_IntZ_zxv = 0.0d0
      do k=0,km-1
         xv_IntZ_zxv(:,:) = xv_IntZ_zxv(:,:) + zxv(k,:,:) * z_Z_Weight(k)
      enddo

    end function xv_IntZ_zxv

    function IntXV_xv(xv)
      !
      ! 2 次元(XY)格子点データの全領域積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:im-1,js(ip):je(ip)), intent(IN)   :: xv          
      !(in)  2 次元(YX)格子点データ

      real(8)                             :: IntXV_xv
      !(out) 積分値

      real(8) :: IntXVTMP
      integer :: i, j
      integer :: ierr
      ! 作業変数

      IntXV_xv = 0.0d0
      do j=js(ip),je(ip)
         do i=0,im-1
            IntXV_xv = IntXV_xv + xv(i,j) * v_Y_Weight(j) * x_X_Weight(i)
         enddo
      enddo

      IntXVTMP=IntXV_xv
      CALL MPI_ALLREDUCE(IntXVTMP,IntXV_xv,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function IntXV_xv

    function v_IntX_xv(xv)
      !
      ! 2 次元(XV)格子点データの X 方向積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:im-1,js(ip):je(ip)), intent(IN)   :: xv
      !(in) 2 次元(YX)格子点データ

      real(8), dimension(js(ip):je(ip))          :: v_IntX_xv
      !(out) 積分された 1 次元(Y)格子点データ

      integer :: i
      ! 作業変数

      v_IntX_xv = 0.0d0
      do i=0,im-1
         v_IntX_xv(:) = v_IntX_xv(:) + xv(i,:) * x_X_Weight(i)
      enddo
    end function v_IntX_xv

    function x_IntV_xv(xv)
      !
      ! 2 次元(YX)格子点データの Y 方向積分
      !
      ! 実際には格子点データ各点毎に v_Y_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:im-1,js(ip):je(ip)), intent(IN)   :: xv      
      !(in)  2 次元(XV)格子点データ

      real(8), dimension(0:im-1)        :: x_IntV_xv 
      !(out) 積分された 1 次元(X)格子点データ

      real(8), dimension(0:im-1)        :: x_IntVTMP
      integer :: j
      integer :: ierr
      ! 作業変数

      x_IntV_xv = 0.0d0
      do j=js(ip),je(ip)
         x_IntV_xv(:) = x_IntV_xv(:) + xv(:,j) * v_Y_Weight(j)
      enddo

      x_IntVTMP=x_IntV_xv
      CALL MPI_ALLREDUCE(x_IntVTMP,x_IntV_xv,im,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)
    end function x_IntV_xv

    function IntZV_zv(zv)
      !
      ! 2 次元(ZY)格子点データの全領域積分および平均.
      !
      ! 実際には格子点データ各点毎に z_Z_Weight, y_Y_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:km-1,js(ip):je(ip)), intent(IN)   :: zv          
      !(in)  2 次元(ZY)格子点データ

      real(8)                             :: IntZV_zv
      !(out) 積分値

      real(8) :: IntZVTMP
      integer :: j, k
      integer :: ierr
      ! 作業変数

      IntZV_zv = 0.0d0
      do j=js(ip),je(ip)
         do k=0,km-1
            IntZV_zv = IntZV_zv + zv(k,j) * v_Y_Weight(j) * z_Z_Weight(k)
         enddo
      enddo

      IntZVTMP=IntZV_zv
      CALL MPI_ALLREDUCE(IntZVTMP,IntZV_zv,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function IntZV_zv

    function v_IntZ_zv(zv)
      !
      ! 2 次元(ZY)格子点データの Z 方向積分
      !
      ! 実際には格子点データ各点毎に z_Z_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:km-1,js(ip):je(ip)), intent(IN)   :: zv          
      !(in)  2 次元(ZY)格子点データ

      real(8), dimension(js(ip):je(ip))          :: v_IntZ_zv
      !(out) 積分された 1 次元(Y)格子点データ

      integer :: k
      ! 作業変数

      v_IntZ_zv = 0.0d0
      do k=0,km-1
         v_IntZ_zv(:) = v_IntZ_zv(:) + zv(k,:) * z_Z_Weight(k)
      enddo
    end function v_IntZ_zv

    function z_IntV_zv(zv)
      !
      ! 2 次元(ZY)格子点データの Y 方向積分
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:km-1,js(ip):je(ip)), intent(IN)   :: zv          
      !(in)  2 次元格子点データ

      real(8), dimension(0:km-1)        :: z_IntV_zv 
      !(out) 積分された 1 次元(X)格子点データ

      real(8), dimension(0:km-1)        :: z_IntVTMP
      integer :: j
      integer :: ierr
      ! 作業変数

      z_IntV_zv = 0.0d0
      do j=js(ip),je(ip)
         z_IntV_zv(:) = z_IntV_zv(:) + zv(:,j) * v_Y_Weight(j)
      enddo

      z_IntVTMP=z_IntV_zv
      CALL MPI_ALLREDUCE(z_IntVTMP,z_IntV_zv,km,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)

    end function z_IntV_zv

    function IntZX_zx(zx)
      !
      ! 2 次元(ZX)格子点データの全領域積分および平均.
      !
      ! 実際には格子点データ各点毎に z_Z_Weight, x_X_Weight をかけた
      ! 総和を計算している. 
      !
      real(8), dimension(0:km-1,0:im-1), intent(IN)   :: zx          
      !(in)  2 次元(ZX)格子点データ

      real(8)                             :: IntZX_zx
      !(out) 積分値

      integer :: i, k
      ! 作業変数

      IntZX_zx = 0.0d0
      do i=0,im-1
         do k=0,km-1
            IntZX_zx = IntZX_zx + zx(k,i) * x_X_Weight(i) * z_Z_Weight(k)
         enddo
      enddo
    end function IntZX_zx

    function x_IntZ_zx(zx)
      !
      ! 2 次元(ZX)格子点データの Z 方向積分
      !
      ! 実際には格子点データ各点毎に z_Z_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:km-1,0:im-1), intent(IN)   :: zx          
      !(in)  2 次元(ZX)格子点データ

      real(8), dimension(0:im-1)          :: x_IntZ_zx
      !(out) 積分された 1 次元(Y)格子点データ

      integer :: k
      ! 作業変数

      x_IntZ_zx = 0.0d0
      do k=0,km-1
         x_IntZ_zx(:) = x_IntZ_zx(:) + zx(k,:) * z_Z_Weight(k)
      enddo
    end function x_IntZ_zx

    function z_IntX_zx(zx)
      !
      ! 2 次元(ZX)格子点データの X 方向積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:km-1,0:im-1), intent(IN)   :: zx          
      !(in)  2 次元格子点データ

      real(8), dimension(0:km-1)        :: z_IntX_zx 
      !(out) 積分された 1 次元(X)格子点データ

      integer :: i
      ! 作業変数

      z_IntX_zx = 0.0d0
      do i=0,im-1
         z_IntX_zx(:) = z_IntX_zx(:) + zx(:,i) * x_X_Weight(i)
      enddo
    end function z_IntX_zx

    function IntX_x(x)
      !
      ! 1 次元(X)格子点データの X 方向積分
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:im-1)   :: x          !(in)  1 次元格子点データ
      real(8)                      :: IntX_x     !(out) 積分値

      IntX_x = sum(x*x_X_Weight)
    end function IntX_x

    function IntV_v(v)
      !
      ! 1 次元(Y)格子点データの Y 方向積分
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
      !
      real(8), dimension(js(ip):je(ip))    :: v          !(in)  1 次元格子点データ
      real(8)                      :: IntV_v     !(out) 積分値
      
      real(8) :: IntVTMP
      integer :: ierr

      IntV_v = sum(v*v_Y_Weight)

      IntVTMP=IntV_v
      CALL MPI_ALLREDUCE(IntVTMP,IntV_v,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_WORLD,IERR)
    end function IntV_v

    function IntZ_z(z)
      !
      ! 1 次元(Z)格子点データの Z 方向積分
      !
      ! 実際には格子点データ各点毎に z_Z_Weight をかけた総和を計算している. 
      !
      real(8), dimension(0:km-1)   :: z         !(in)  1 次元格子点データ
      real(8)                      :: IntZ_z     !(out) 積分値

      IntZ_z = sum(z*z_Z_Weight)
    end function IntZ_z

  !--------------- 平均計算 -----------------
    function AvrZXV_zxv(zxv)
      !
      ! 2 次元格子点データの全領域平均.
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight, z_Z_Weight を
      ! かけた総和を計算し, x_X_Weight*y_Y_Weight*z_Z_Weight の総和で割る
      ! ことで平均している. 
      !
      real(8), dimension(0:km-1,0:im-1,js(ip):je(ip)), intent(IN)   :: zxv
      !(in)  3 次元格子点データ

      real(8)                                    :: AvrZXV_zxv
      !(out) 積分値

      real(8) :: Vol, VolTMP
      integer :: ierr
      ! 作業変数

      VolTMP=sum(x_X_weight)*sum(v_Y_weight)*sum(z_Z_weight)
      
      CALL MPI_ALLREDUCE(VolTMP,Vol,1,MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

      AvrZXV_zxv = IntZXV_zxv(zxv)/Vol

    end function AvrZXV_zxv

    function z_AvrXV_zxv(zxv)
      !
      ! 3 次元格子点データの X,Y 方向平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:im-1,js(ip):je(ip)), intent(IN)   :: zxv
      !(in) 2 次元格子点データ

      real(8), dimension(0:km-1)          :: z_AvrXV_zxv
      !(out) 積分された 1 次元(Y)格子点データ

      real(8) :: Area, AreaTMP
      integer :: ierr
      ! 作業変数

      AreaTMP = sum(x_X_weight)*sum(v_Y_weight)
      CALL MPI_ALLREDUCE(AreaTMP,Area,1,MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

      z_AvrXV_zxv = z_IntXV_zxv(zxv)/Area

    end function z_AvrXV_zxv

    function v_AvrZX_zxv(zxv)
      !
      ! 3 次元格子点データの X,Z 方向平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight, z_Z_Weight をかけた
      ! 総和を計算し, x_X_Weight*z_Z_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:im-1,js(ip):je(ip)), intent(IN)   :: zxv
      !(in) 2 次元格子点データ

      real(8), dimension(js(ip):je(ip))          :: v_AvrZX_zxv
      !(out) 積分された 1 次元(Y)格子点データ

      v_AvrZX_zxv = v_IntZX_zxv(zxv)/(sum(x_X_weight)*sum(z_Z_weight))

    end function v_AvrZX_zxv

    function x_AvrZV_zxv(zxv)
      !
      ! 3 次元格子点データの Y,Z 方向平均
      !
      ! 実際には格子点データ各点毎に y_Y_Weight, z_Z_Weight をかけた
      ! 総和を計算し, y_Y_Weight*z_Z_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:im-1,js(ip):je(ip)), intent(IN)   :: zxv
      !(in) 2 次元格子点データ

      real(8), dimension(0:im-1)          :: x_AvrZV_zxv
      !(out) 積分された 1 次元(Y)格子点データ

      real(8) :: Area, AreaTMP
      integer :: ierr
      ! 作業変数

      AreaTMP = sum(z_Z_weight)*sum(v_Y_weight)
      CALL MPI_ALLREDUCE(AreaTMP,Area,1,MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

      x_AvrZV_zxv = x_IntZV_zxv(zxv)/Area

    end function x_AvrZV_zxv

    function zv_AvrX_zxv(zxv)
      !
      ! 3 次元格子点データの X 方向平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた
      ! 総和を計算し, x_X_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:im-1,js(ip):je(ip)), intent(IN)   :: zxv
      !(in) 2 次元格子点データ

      real(8), dimension(0:km-1,js(ip):je(ip))          :: zv_AvrX_zxv
      !(out) 積分された 2 次元(ZY)格子点データ

      zv_AvrX_zxv = zv_IntX_zxv(zxv)/sum(x_X_weight)

    end function zv_AvrX_zxv

    function zx_AvrV_zxv(zxv)
      !
      ! 3 次元格子点データの Y 方向平均
      !
      ! 実際には格子点データ各点毎に v_Y_Weight をかけた
      ! 総和を計算し, v_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:im-1,js(ip):je(ip)), intent(IN)   :: zxv
      !(in) 2 次元格子点データ

      real(8), dimension(0:km-1,0:im-1)          :: zx_AvrV_zxv
      !(out) 積分された 1 次元(Y)格子点データ

      real(8) :: Length, LengthTMP
      integer :: ierr
      ! 作業変数

      LengthTMP = sum(v_Y_weight)
      CALL MPI_ALLREDUCE(LengthTMP,Length,1,MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

      zx_AvrV_zxv = zx_IntV_zxv(zxv)/Length

    end function zx_AvrV_zxv

    function xv_AvrZ_zxv(zxv)
      !
      ! 3 次元格子点データの Z 方向平均
      !
      ! 実際には格子点データ各点毎に z_Z_Weight をかけた
      ! 総和を計算し, z_Z_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:im-1,js(ip):je(ip)), intent(IN)   :: zxv
      !(in) 2 次元格子点データ

      real(8), dimension(0:im-1,js(ip):je(ip))          :: xv_AvrZ_zxv
      !(out) 積分された 1 次元(YX)格子点データ

      xv_AvrZ_zxv = xv_IntZ_zxv(zxv)/sum(z_Z_weight)

    end function xv_AvrZ_zxv

    function AvrXV_xv(xv)
      !
      ! 2 次元格子点データの全領域平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:im-1,js(ip):je(ip)), intent(IN)   :: xv
      !(in)  2 次元格子点データ

      real(8)                             :: AvrXV_xv    
      !(out) 平均値

      real(8) :: Area, AreaTMP
      integer :: ierr
      ! 作業変数

      AreaTMP = sum(x_X_weight)*sum(v_Y_weight)
      CALL MPI_ALLREDUCE(AreaTMP,Area,1,MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

      AvrXV_xv = IntXV_xv(xv)/Area

    end function AvrXV_xv

    function v_AvrX_xv(xv)
      !
      ! 2 次元格子点データの X 方向平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:im-1,js(ip):je(ip)), intent(IN)   :: xv
      !(in) 2 次元格子点データ

      real(8), dimension(js(ip):je(ip))          :: v_AvrX_xv
      !(out) 平均された 1 次元(Y)格子点データ

      v_AvrX_xv = v_IntX_xv(xv)/sum(x_X_weight)
    end function v_AvrX_xv

    function x_AvrV_xv(xv)
      !
      ! 2 次元格子点データの Y 方向平均
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:im-1,js(ip):je(ip)), intent(IN)   :: xv
      !(in) 2 次元格子点データ

      real(8), dimension(0:im-1)          :: x_AvrV_xv
      !(out) 平均された 1 次元(X)格子点データ

      real(8) :: Length, LengthTMP
      integer :: ierr
      ! 作業変数

      LengthTMP = sum(v_Y_weight)
      CALL MPI_ALLREDUCE(LengthTMP,Length,1,MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

      x_AvrV_xv = x_IntV_xv(xv)/Length
    end function x_AvrV_xv

    function AvrZX_zx(zx)
      !
      ! 2 次元(ZX)格子点データの全領域平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight, z_Z_Weight をかけた
      ! 総和を計算し, x_X_Weight*z_Z_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:im-1), intent(IN)   :: zx
      !(in)  2 次元(ZX)格子点データ

      real(8)                             :: AvrZX_zx    
      !(out) 平均値

      AvrZX_zx = IntZX_zx(zx)/(sum(x_X_weight)*sum(z_Z_weight))
    end function AvrZX_zx

    function z_AvrX_zx(zx)
      !
      ! 2 次元(ZX)格子点データの X 方向平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:im-1), intent(IN)   :: zx
      !(in) 2 次元(ZX)格子点データ

      real(8), dimension(0:km-1)          :: z_AvrX_zx
      !(out) 平均された 1 次元(Z)格子点データ

      z_AvrX_zx = z_IntX_zx(zx)/sum(x_X_weight)
    end function z_AvrX_zx

    function x_AvrZ_zx(zx)
      !
      ! 2 次元(ZX)格子点データの Z 方向平均
      !
      ! 実際には格子点データ各点毎に z_Z_Weight をかけた総和を計算し, 
      ! z_Z_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,0:im-1), intent(IN)   :: zx
      !(in) 2 次元(ZX)格子点データ

      real(8), dimension(0:im-1)          :: x_AvrZ_zx
      !(out) 平均された 1 次元(X)格子点データ

      x_AvrZ_zx = x_IntZ_zx(zx)/sum(z_Z_weight)
    end function x_AvrZ_zx

    function AvrZV_zv(zv)
      !
      ! 2 次元(ZV)格子点データの全領域平均
      !
      ! 実際には格子点データ各点毎に z_Z_Weight, y_Y_Weight をかけた
      ! 総和を計算し, z_Z_Weight*v_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,js(ip):je(ip)), intent(IN)   :: zv
      !(in)  2 次元(ZY)格子点データ

      real(8)                             :: AvrZV_zv    
      !(out) 平均値

      real(8) :: Area, AreaTMP
      integer :: ierr
      ! 作業変数

      AreaTMP = sum(z_Z_weight)*sum(v_Y_weight)
      CALL MPI_ALLREDUCE(AreaTMP,Area,1,MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

      AvrZV_zv = IntZV_zv(zv)/Area
    end function AvrZV_zv

    function z_AvrV_zv(zv)
      !
      ! 2 次元(ZY)格子点データの Y 方向平均
      !
      ! 実際には格子点データ各点毎に v_Y_Weight をかけた総和を計算し, 
      ! v_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,js(ip):je(ip)), intent(IN)   :: zv
      !(in) 2 次元(ZV)格子点データ

      real(8), dimension(0:km-1)          :: z_AvrV_zv
      !(out) 平均された 1 次元(Z)格子点データ
      real(8) :: Length, LengthTMP
      integer :: ierr
      ! 作業変数

      LengthTMP = sum(v_Y_weight)
      CALL MPI_ALLREDUCE(LengthTMP,Length,1,MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

      z_AvrV_zv = z_IntV_zv(zv)/Length
    end function z_AvrV_zv

    function v_AvrZ_zv(zv)
      !
      ! 2 次元(ZY)格子点データの Z 方向平均
      !
      ! 実際には格子点データ各点毎に z_Z_Weight をかけた総和を計算し, 
      ! z_Z_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1,js(ip):je(ip)), intent(IN)   :: zv
      !(in) 2 次元(ZY)格子点データ

      real(8), dimension(js(ip):je(ip))          :: v_AvrZ_zv
      !(out) 平均された 1 次元(X)格子点データ

      v_AvrZ_zv = v_IntZ_zv(zv)/sum(z_Z_weight)
    end function v_AvrZ_zv

    function AvrX_x(x)
      !
      ! 1 次元(X)格子点データの X 方向平均
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
      ! x_X_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:im-1), intent(IN) :: x       !(in)  1 次元格子点データ
      real(8)                                :: AvrX_x  !(out) 平均値

      AvrX_x = IntX_x(x)/sum(x_X_weight)
    end function AvrX_x

    function AvrV_v(v)
      !
      ! 1 次元(Y)格子点データの Y 方向平均
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
      ! y_Y_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(js(ip):je(ip)), intent(IN) :: v
      !(in)  1 次元格子点データ

      real(8)                               :: AvrV_v !(out) 平均値

      real(8) :: Length, LengthTMP
      integer :: ierr
      ! 作業変数

      LengthTMP = sum(v_Y_weight)
      CALL MPI_ALLREDUCE(LengthTMP,Length,1,MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

      AvrV_v = IntV_v(v)/Length
    end function AvrV_v

    function AvrZ_z(z)
      !
      ! 1 次元(Z)格子点データの Z 方向平均
      !
      ! 実際には格子点データ各点毎に z_Z_Weight をかけた総和を計算し, 
      ! z_Z_Weight の総和で割ることで平均している. 
      !
      real(8), dimension(0:km-1), intent(IN) :: z      !(in)  1 次元格子点データ
      real(8)                                :: AvrZ_z !(out) 平均値

      AvrZ_z = IntZ_z(z)/sum(z_Z_weight)
    end function AvrZ_z

  !--------------- スペクトル計算 -----------------
    function EnergyHelicityFromZeta_ee2f(ee2f)
      !
      ! 渦度成分(ζ_1, ζ_2)から全領域平均エネルギーとヘリシティーを計算する.
      !
      real(8), dimension(2)                 :: EnergyHelicityFromZeta_ee2f
      ! エネルギーヘリシティー

      real(8), dimension(-nm:nm,-mm:mm,2,2*lc(ip)), intent(in) :: ee2f
      ! 渦度成分(ζ_1, ζ_2)

      real(8) :: E, H           ! エネルギー, ヘリシティー
      
      call p3cmsv(nm,mm,lm,ee2f,E,H)

      EnergyHelicityFromZeta_ee2f(1) = E ; EnergyHelicityFromZeta_ee2f(2) = H

    end function EnergyHelicityFromZeta_ee2f

    subroutine ESpectralFromZeta(esp,ee2f)
      !
      ! 渦度成分(ζ_1, ζ_2)からエネルギースペクトルを計算する. 
      !
      !   * esp のサイズで求められる波数範囲が定められる
      !   * esp の総和が EFFromZeta で求められるエネルギー
      !     (全領域平均値)に等しい
      !
      real(8), dimension(:), intent(OUT)  :: esp
      ! エネルギースペクトル

      real(8), dimension(-nm:nm,-mm:mm,2,2*lc(ip)), intent(in) :: ee2f
      ! 渦度成分(ζ_1, ζ_2)

      integer kmax
      ! 作業変数
      real(8), allocatable :: wesp(:)

      kmax=size(esp)
      allocate(wesp(kmax))
      call p3empt(nm,mm,lm,kmax,ee2f,esp,wesp)
      deallocate(wesp)

    end subroutine ESpectralFromZeta

  end module eee_mpi_module

!----------------------------------------------------------------------
!   COPYRIGHT (c) 2006 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_aq_galerkin_RRFF2
!
!      チェビシェフ−ガラーキン法
!      非圧縮流体の流線関数・流れポテンシャル用
!
!      case RR: 両端粘着条件(両端で値と 1 階微分が 0)
!               f(:,i=0)=f(:,i=im)=f'(:,i=0)=f'(:,i=im)=0 
!               [ f(:,x=xmax)=f(:,x=xmin)=f'(:,x=xmax)=0=f'(:,x=xmin)=0 ]
!
!      case FF: 両端自由すべり条件(両端で値と 2 階微分が 0)
!               f(:,i=0)=f(:,i=im)=f''(:,i=0)=f''(:,i=im)=0 
!               [ f(:,x=xmax)=f(:,x=xmin)=f''(:,x=xmax)=0=f''(:,x=xmin)=0 ]
!
!      case RF: 片端粘着条件, 片端自由すべり条件
!               (両端で値が 0, 片側で 1 階微分, もう一方で 2 階微分が 0)
!               f(:,i=0)=f(:,i=im)=f'(:,i=0)=f''(:,i=im)=0 
!               [ f(:,x=xmax)=f(:,x=xmin)=f''(:,x=xmax)=0=f'(:,x=xmin)=0 ]
!
!      case FR: 片端自由すべり条件, 片端粘着条件
!               (両端で値が 0, 片側で 2 階微分, もう一方で 1 階微分が 0)
!               f(:,i=0)=f(:,i=im)=f''(:,i=0)=f'(:,i=im)=0 
!               [ f(:,x=xmax)=f(:,x=xmin)=f'(:,x=xmax)=0=f''(:,x=xmin)=0 ]
!
!      k 次のガラーキン基底が
!        \phi_k(x)=T_k(x) + C_3 T_3(x) + C_2 T_2(x) 
!                         + C_1 T_1(x) + C_0 T_0(x) 
!      の型式(Type2)
!
!履歴  2006/01/24  竹広真一  新規作成
!      2006/01/25  竹広真一  モジュール初期化フラッグ導入
!      2010/09/21  竹広真一  at_module と境界条件スイッチを揃えた
!
module at_aq_galerkin_RRFF

  use lumatrix
  use at_module
  use dc_message

  implicit none

  private
  public :: at_aq_galerkin_RRFF_Initial  ! 初期化サブルーチン
  public :: aq_at, q_t                   ! チェビシェフ->ガラーキン変換
  public :: aq_ag, q_g                   ! 格子点->ガラーキンデータ変換
  public :: at_aq, t_q                   ! ガラーキン->チェビシェフ変換
  public :: ag_aq, g_q                   ! ガラーキン->格子点データ変換
  public :: aq_Dx_aq, q_Dx_q             ! X 微分

  real(8), allocatable :: TQ(:,:)   ! ガラーキン->チェビシェフ変換行列
  real(8), allocatable :: QT(:,:)   ! チェビシェフ->ガラーキン変換行列
  integer, allocatable :: kp(:)     ! LU 分解用ピボット格納配列

  real(8), allocatable :: alpha(:)  ! チェビシェフ<->ガラーキン行列積係数
  real(8), allocatable :: beta(:)   ! チェビシェフ<->ガラーキン行列和係数

  integer :: im                     ! 格子点数              
  integer :: km                     ! チェビシェフ切断波数  
  integer,parameter :: ks=4         ! ガラーキン基底最低次数
  character(LEN=2) :: bc            ! 境界条件(RR/FF/RF/FR)

  logical :: RRFF_Initialized=.false.    ! 初期化フラッグ

  save im, km, bc, TQ, QT, kp, alpha, beta, RRFF_Initialized
  public TQ, QT, alpha, beta

contains

  !
  ! チェビシェフ−ガラーキン法 
  ! 両端粘着条件用モジュール
  ! 初期化サブルーチン
  !
  subroutine at_aq_galerkin_RRFF_Initial(i_in,k_in,bc_in)

    integer, intent(IN)          :: i_in     ! (in)格子点数
    integer, intent(IN)          :: k_in     ! (in)チェビシェフ切断波数  
    character(LEN=2), intent(IN) :: bc_in    ! (in)境界条件(RR/FF/RF/FR)

    integer :: k, l, m, n

    im=i_in ; km=k_in ; bc=bc_in

    allocate(TQ(0:km,ks:km),QT(ks:km,ks:km),kp(ks:km))
    allocate(alpha(0:km),beta(0:km))


    select case (bc)

    !---- 両端粘着条件用変換行列設定
    case ('RR','rr')
       TQ = 0.0D0
       do k=ks,km
          TQ(0,k) =  ( (-1)**k + 1 ) * (k**2-4)/8.0D0
          TQ(1,k) = -( 1 - (-1)**k ) * (9-k**2)/16.0D0
          TQ(2,k) = -( (-1)**k + 1 ) * k**2    /8.0D0
          TQ(3,k) =  ( 1 - (-1)**k ) * (1-k**2)/16.0D0
          TQ(k,k) = 1.0
       enddo
       call MessageNotify('M','at_aq_galerkin_RRFF_Initial(Type2)',&
                          'Conversion matrices for RR-B.C. initialized.')

    !---- 両端自由すべり条件用変換行列設定
    case ('FF','ff','SS','ss')
       TQ = 0.0D0
       do k=ks,km
          TQ(0,k) =  ( (-1)**k + 1 ) * ( k**2*(k**2-1)-12 )/24.0D0
          TQ(1,k) =  ( 1 - (-1)**k ) * ( k**2*(k**2-1)-72 )/144.0D0
          TQ(2,k) = -( (-1)**k + 1 ) * k**2*(k**2-1)       /24.0D0
          TQ(3,k) = -( 1 - (-1)**k ) * k**2*(k**2-1)       /144.0D0
          TQ(k,k) = 1.0
       enddo
       call MessageNotify('M','at_aq_galerkin_RRFF_Initial(Type2)',&
                          'Conversion matrices for FF-B.C. initialized.')


    !---- 片端粘着条件, 片端自由すべり条件変換行列設定
    case ('RF','rf','RS','rs')
       TQ = 0.0D0
       do k=ks,km
          TQ(0,k) =      (-1)**k * k**2*(k**2-1)/48.0D0         &
                       + 3.0D0/16.0D0 * k**2                    &
                       - 3.0D0/32.0D0 * ( 1 - (-1)**k )         &
                       - 1.0D0/2.0D0  * ( 1 + (-1)**k )

          TQ(1,k) =  - (-1)**k * k**2*(k**2-1)/96.0D0           &
                     + 1.0D0/32.0D0 * k**2                      &
                     - 33.0D0/64.0D0 * ( 1 - (-1)**k )

          TQ(2,k) =  - (-1)**k * k**2*(k**2-1)/48.0D0           &
                     - 3.0D0/16.0D0 * k**2                      &
                     + 3.0D0/32.0D0 * ( 1 - (-1)**k )

          TQ(3,k) = 1.0D0/32.0D0 * (    (-1)**k * k**2*(k**2-1)/3.0D0 &
                                      - k**2                          &
                                      + ( 1 - (-1)**k )/2.0D0 )
          TQ(k,k) = 1.0
       enddo
       call MessageNotify('M','at_aq_galerkin_RRFF_Initial(Type2)',&
                          'Conversion matrices for RF-B.C. initialized.')

    !---- 片端自由すべり条件, 片端粘着条件変換行列設定
    case ('FR','fr','SR','sr')
       TQ = 0.0D0
       do k=ks,km
          TQ(0,k) =      k**2*(k**2-1)/48.0D0                   &
                       - 3.0D0/16.0D0 * (-1)**(k+1) * k**2      &
                       + 3.0D0/32.0D0 * ( 1 - (-1)**k )         &
                       - 1.0D0/2.0D0  * ( 1 + (-1)**k )

          TQ(1,k) =    k**2*(k**2-1)/96.0D0                     &
                     + 1.0D0/32.0D0 * (-1)**(k+1) * k**2        &
                     - 33.0D0/64.0D0 * ( 1 - (-1)**k )

          TQ(2,k) =  - k**2*(k**2-1)/48.0D0                     &
                     + 3.0D0/16.0D0 * (-1)**(k+1) * k**2        &
                     - 3.0D0/32.0D0 * ( 1 - (-1)**k )

          TQ(3,k) = -1.0D0/32.0D0 * (   k**2*(k**2-1)/3.0D0     &
                                      + (-1)**(k+1) * k**2      &
                                      - ( 1 - (-1)**k )/2.0D0 )
          TQ(k,k) = 1.0
       enddo
       call MessageNotify('M','at_aq_galerkin_RRFF_Initial(Type2)',&
                          'Conversion matrices for FR-B.C. initialized.')

    case default
       call MessageNotify('E','at_aq_galerkin_RRFF_Initial(Type2)',&
                'Argument for B.C. not valid. Should be RR/FF/RF/FR.')

    end select

    beta=1.0 ; beta(0)=0.5D0
    if (im .eq. km ) beta(km)=0.5D0

    ! 両端粘着条件用変換逆行列
    alpha=1.0 ; alpha(0)=2.0D0

    QT = 0.0D0
    do m=ks,km
       do n=ks,km
          do l=0,km
             QT(m,n) = QT(m,n) + alpha(l)*TQ(l,m)*TQ(l,n)
          enddo
       enddo
    enddo

    call LUDecomp(QT,kp)

    RRFF_Initialized=.true.

  end subroutine at_aq_galerkin_RRFF_Initial

  !
  ! 両端粘着条件
  ! チェビシェフ係数 -> ガラーキン係数変換(2次元データ)
  !
  function aq_at(at_data)
    real(8), intent(IN) :: at_data(:,0:)                !(in)  チェビシェフ係数
    real(8)             :: aq_at(size(at_data,1),ks:km) !(out) ガラーキン係数  

    real(8)             :: aq_work(size(at_data,1),ks:km)  ! 作業用配列
    
    integer :: k,m

    if ( .not. RRFF_Initialized ) &
         call MessageNotify('E','aq_at',&
                            'at_aq_galerkin_RRFF_module(Type2) not initialized')

    aq_work =0.0
    do m=ks,km
       do k=0,km
          aq_work(:,m) = aq_work(:,m) &
               + alpha(k) * beta(k) * at_data(:,k) * TQ(k,m)
       enddo
    enddo

    aq_at = LUSolve(QT,kp,aq_work)
  end function aq_at

  !
  ! 両端粘着条件
  ! チェビシェフ係数 -> ガラーキン係数変換(1次元データ)
  !
  function q_t(t_data)

    real(8), intent(IN) :: t_data(0:km)        !(in)  チェビシェフ係数
    real(8)             :: q_t(ks:km)          !(out) ガラーキン係数  

    real(8)             :: q_work(ks:km)       ! 作業用配列

    integer :: k,m

    if ( .not. RRFF_Initialized ) &
         call MessageNotify('E','q_t',&
                            'at_aq_galerkin_RRFF_module(Type2) not initialized')

    q_work =0.0
    do m=ks,km
       do k=0,km
          q_work(m) = q_work(m) &
               + alpha(k) * beta(k) * t_data(k) * TQ(k,m)
       enddo
    enddo

    q_t = LUSolve(QT,kp,q_work)
  end function q_t

  !
  ! 両端粘着条件
  ! ガラーキン係数 -> チェビシェフ係数変換(2次元データ)
  !
  function at_aq(aq_data)

    real(8), intent(IN)  :: aq_data(:,ks:)              !(in)  ガラーキン係数
    real(8)              :: at_aq(size(aq_data,1),0:km) !(out) チェビシェフ係数

    integer :: m, n

    if ( .not. RRFF_Initialized ) &
         call MessageNotify('E','at_aq',&
                            'at_aq_galerkin_RRFF_module(Type2) not initialized')
    at_aq = 0.0D0
    do m=0,km
       do n=ks,km
          at_aq(:,m) = at_aq(:,m) + TQ(m,n)*aq_data(:,n)/beta(m)
       enddo
    enddo
  end function at_aq

  !
  ! 両端粘着条件
  ! ガラーキン係数 -> チェビシェフ係数変換(1次元データ)
  !
  function t_q(q_data)

    real(8), intent(IN)  :: q_data(ks:km)       !(in)  ガラーキン係数  
    real(8)              :: t_q(0:km)           !(out) チェビシェフ係数

    integer :: m, n

    if ( .not. RRFF_Initialized ) &
         call MessageNotify('E','q_t',&
                            'at_aq_galerkin_RRFF_module(Type2) not initialized')

    t_q = 0.0D0
    do m=0,km
       do n=ks,km
          t_q(m) = t_q(m) + TQ(m,n)*q_data(n)/beta(m)
       enddo
    enddo
  end function t_q

  !
  ! 両端粘着条件
  ! 格子点データ -> ガラーキン係数変換(2次元データ)
  !
  function aq_ag(ag_data)
    real(8), intent(IN)  :: ag_data(:,0:)                !(in)  格子点データ
    real(8)              :: aq_ag(size(ag_data,1),ks:km) !(out) ガラーキン係数

    aq_ag = aq_at(at_ag(ag_data))
  end function aq_ag

  !
  ! 両端粘着条件
  ! 格子点データ -> ガラーキン係数変換(1次元データ)
  !
  function q_g(g_data)
    real(8), intent(IN)  :: g_data(0:im)        !(in)  格子点データ
    real(8)              :: q_g(ks:km)          !(out) ガラーキン係数

    q_g = q_t(t_g(g_data))
  end function q_g

  !
  ! 両端粘着条件
  ! ガラーキン係数 -> 格子点データ変換(2次元データ)
  !
  function ag_aq(aq_data)
    real(8), intent(IN) :: aq_data(:,ks:)              !(in)  ガラーキン係数  
    real(8)             :: ag_aq(size(aq_data,1),0:im) !(out) 格子点データ  
    
    ag_aq = ag_at(at_aq(aq_data))
  end function ag_aq

  !
  ! 両端粘着条件
  ! ガラーキン係数 -> 格子点データ変換(1次元データ)
  !
  function g_q(q_data)
    real(8), intent(IN) :: q_data(ks:km)        !(in)  ガラーキン係数  
    real(8)             :: g_q(0:im)            !(out) 格子点データ  
    
    g_q = g_t(t_q(q_data))
  end function g_q

  !
  ! 両端粘着条件
  ! X 微分計算(1 次元)
  !
  function aq_Dx_aq(aq_data)
    real(8), intent(IN) :: aq_data(:,ks:)                  !(in) ガラーキン係数
    real(8)             :: aq_Dx_aq(size(aq_data,1),ks:km) !(out) 微分ガラーキン
    aq_Dx_aq = aq_at(at_Dx_at(at_aq(aq_data)))
  end function aq_Dx_aq

  !
  ! 両端粘着条件
  ! X 微分計算(1 次元)
  !
  function q_Dx_q(q_data)
    real(8), intent(IN) :: q_data(ks:km)
    real(8)             :: q_Dx_q(ks:km)

    q_Dx_q = q_t(t_Dx_t(t_q(q_data)))

  end function q_Dx_q

end module at_aq_galerkin_RRFF

!-------------------------------------------------------------------------
! Copyright (c) 2011 SPMODEL Development Group. All rights reserved.!
!-------------------------------------------------------------------------
!
!表題  ae_module_fvpack テストプログラム 補間関数のテスト
!
!履歴  2002/08/20  竹広真一
!
!
program ae_module_fvpack_test_interpolate

  use ae_module_fvpack
  use dc_test
  implicit none

  integer, parameter :: im = 16,  km=5
  real(8), parameter :: xmin=0.0, xmax=1.0
  
  real(8)            :: g_Data(0:im-1)
  real(8)            :: e_Data(-km:km)

  real(8)            :: ag_Data(2,0:im-1)
  real(8)            :: ae_Data(2,-km:km)

  real(8)            :: xobs   = 0.3d0
  real(8)            :: answer(2)
  real(8)            :: PI

  ! 判定誤差設定
  integer, parameter :: check_digits = 16
  integer, parameter :: ignore = -14

  PI = 4.0D0 * atan(1.0D0)

  call ae_Initial(im,km,xmin,xmax)

  g_Data = sin(PI*g_X)**2
  e_Data = e_g(g_Data)

  call AssertEqual(&
    message = '1-dim Interpolation ',                           &
    answer = sin(PI*xobs)**2,                                   &
    check =  Interpolate_e(e_Data,xobs),                        &
    significant_digits = check_digits, ignore_digits = ignore   &
  )

  ag_Data(1,:) = cos(PI*g_X)**2
  ag_Data(2,:) = sin(PI*g_X)**4
  ae_Data      = ae_ag(ag_Data)

  answer(1) = cos(PI*xobs)**2
  answer(2) = sin(PI*xobs)**4

  call AssertEqual(&
    message = '2-dim Interpolation ',                           &
    answer = answer,                                            &
    check =  a_Interpolate_ae(ae_Data,xobs),                    &
    significant_digits = check_digits, ignore_digits = ignore   &
  )

end program ae_module_fvpack_test_interpolate

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wsc_module_svpack テストプログラム :: 基本変換関数のテスト
!
!履歴  2017/05/20  竹広真一
!
program wsc_module_svpack_base_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wsc_module_svpack
  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5      ! 内外半径

  real(8), dimension((nm+1)**2,lm)         ::  ws_data
  real(8), dimension((nm+1)**2,0:lm)       ::  wc_data
  real(8), dimension(0:im-1,1:jm,0:km)     ::  xyz_data
  real(8), dimension(0:im-1,1:jm,0:km)     ::  xyz_xi

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: pi

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','wsc_module_svpack_base_test', &
                         'wsc_module_svpack basic transformation functions tests') 

  call wsc_Initial(im,jm,km,nm,lm,ri,ro)

  xyz_xi = (xyz_Rad - ri)/(ro-ri)

  !---- Y_1^* のテスト ----
  xyz_data = sqrt(3.0D0)*sin(xyz_Lat)*sin(PI*xyz_xi)            ! Y_1^0 sin(z)
  ws_data= 0.0D0 ; ws_data(l_nm(1,0),1)=1.0D0

  call AssertEqual(&
    message='ws_xyz with Y_1^0 sin(z)',                           &
    answer = ws_data,                                             &
    check = ws_xyz(xyz_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_ws with Y_1^0 sin(z)',                           &
    answer = xyz_data,                                            &
    check = xyz_ws(ws_xyz(xyz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xyz_data = sqrt(3.0D0/2)*cos(xyz_Lat)*cos(xyz_Lon)     ! Y_1^1
  wc_data= 0.0D0 ;  wc_data(l_nm(1,1),0)=1.0D0/2.0D0*2

  call AssertEqual(&
    message='wt_xyz with Y_1^1',                                  &
    answer = wc_data,                                             &
    check = wc_xyz(xyz_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_wt with Y_1^1',                                  &
    answer = xyz_data,                                            &
    check = xyz_wc(wc_xyz(xyz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xyz_data = -sqrt(3.0D0/2)*cos(xyz_Lat)*sin(xyz_Lon)*cos(2*PI*xyz_xi) !Y_1^{-1} cos(2z)
  wc_data= 0.0D0 ;  wc_data(l_nm(1,-1),2)=1.0D0/2.0D0

  call AssertEqual(&
    message='wc_xyz with Y_1^-1 cos(2z)',                         &
    answer = wc_data,                                             &
    check = wc_xyz(xyz_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_wc with Y_1^-1 cos(2z)',                         &
    answer = xyz_data,                                            &
    check = xyz_wc(wc_xyz(xyz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xyz_data = -sqrt(3.0D0/2)*cos(xyz_Lat)*sin(xyz_Lon)*sin(2*PI*xyz_xi) !Y_1^{-1}sin(2z)
  ws_data= 0.0D0 ;  ws_data(l_nm(1,-1),2)=1.0D0/2.0D0

  call AssertEqual(&
    message='ws_xyz with Y_1^-1 sin(2z)',                         &
    answer = ws_data,                                             &
    check = ws_xyz(xyz_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_ws with Y_1^-1 sin(2z)',                         &
    answer = xyz_data,                                            &
    check = xyz_ws(ws_xyz(xyz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^* のテスト ----
  ! Y_2^0 sin(3z)
  xyz_data = sqrt(5.0D0)*(3.0/2*sin(xyz_Lat)**2-1/2.0)*sin(3*PI*xyz_xi)
  ws_data= 0.0D0 ; ws_data(l_nm(2,0),3)=1.0D0

  call AssertEqual(&
    message='wt_xyz with Y_2^0 sin(3z)',                          &
    answer = ws_data,                                             &
    check = ws_xyz(xyz_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_ws with Y_2^0 sin(3z)',                          &
    answer = xyz_data,                                            &
    check = xyz_ws(ws_xyz(xyz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !Y_2^1 cos(4z)
  xyz_data = sqrt(5.0D0/6)*3.0*sin(xyz_Lat)*cos(xyz_Lat)*cos(xyz_Lon) &
            * cos(4*PI*xyz_xi)
  wc_data= 0.0D0 ; wc_data(l_nm(2,1),4)=1.0D0/2.0D0

  call AssertEqual(&
    message='wt_xyz with Y_2^1 cos(4z)',                          &
    answer = wc_data,                                             &
    check = wc_xyz(xyz_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_wt with Y_2^1 cos(4z)',                          &
    answer = xyz_data,                                            &
    check = xyz_wc(wc_xyz(xyz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ! Y_2^-2
  xyz_data = -sqrt(5.0D0/24)*3.0*cos(xyz_Lat)**2*sin(2*xyz_Lon) &
            *cos(5*PI*xyz_xi)
  wc_data= 0.0D0 ; wc_data(l_nm(2,-2),5)=1.0D0/2.0D0

  call AssertEqual(&
    message='wt_xyz with Y_2^-2 cos(5z)',                         &
    answer = wc_data,                                             &
    check = wc_xyz(xyz_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_wt with Y_2^-2 cos(5z)',                         &
    answer = xyz_data,                                            &
    check = xyz_wc(wc_xyz(xyz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的関数のテスト ----
  xyz_data = cos(2*xyz_Lon-pi/3) &
       *(sin(xyz_Lat)-1)**2*(sin(xyz_Lat)-0.5)*(sin(xyz_Lat)+1) &
       * xyz_xi*(1.0-xyz_xi)

  call AssertEqual(&
    message='xyz_ws and ws_xyz with a general function',          &
    answer = xyz_data,                                            &
    check = xyz_ws(ws_xyz(xyz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xyz_data = cos(2*xyz_Lon-pi/3) &
       *(sin(xyz_Lat)-1)**2*(sin(xyz_Lat)-0.5)*(sin(xyz_Lat)+1) &
       * xyz_xi**2*(1.0-xyz_xi)**2

  call AssertEqual(&
    message='xyz_wc and wc_xyz with a general function',          &
    answer = xyz_data,                                            &
    check = xyz_wc(wc_xyz(xyz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wsc_module_svpack_base_test_base', &
                         'wsc_module_svpack basic functions tests succeeded!') 

end program wsc_module_svpack_base_test

program lnmtest

  use w_base_module, only : w_base_initial, l_nm

  integer, parameter :: nm=10, im=32, jm=16
  integer, parameter :: nfix=nm
  integer, parameter :: mfix=0
  integer            :: narray(nm+1), marray(nm+1)
  integer            :: n, m

  call w_base_initial(nm,im,jm)

  narray=(/(n,n=0,nm)/)
  marray=(/(m,m=0,nm)/)

  write(6,*) 'test 00'
  write(6,*) 'n=1, m=1, l=', l_nm(1,1)

  write(6,*) 
  write(6,*) 'test 01'
  write(6,*) 'n = ', nfix
  write(6,*) 'marray = ', narray
  write(6,*) 'l= ', l_nm(nfix,marray)

  write(6,*) 
  write(6,*) 'test 10'
  write(6,*) 'narray = ', narray
  write(6,*) 'm = ', mfix
  write(6,*) 'l= ', l_nm(narray,mfix)

  write(6,*) 
  write(6,*) 'test 11'
  write(6,*) 'narray = ', narray
  write(6,*) 'marray = ', marray
  write(6,*) 'l= ', l_nm(narray,marray)

end program lnmtest

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wtq_mpi_module_supack テストプログラム :: スペクトル関数のテスト
!
!履歴  2016/04/04  竹広真一   wq_mpi_module_supack_spectrum_test.f90 を改造
!
program wtq_mpi_module_supack_spectrum_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wtq_mpi_module_supack
  use mpi
  implicit none

  integer,parameter  :: im=32, jm=16         ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: kmo=16, kmi=10       ! 格子点の設定(球殻動径, 球動径)
  integer,parameter  :: nm=10                ! 切断波数の設定(水平)
  integer,parameter  :: lmo=10, lmi=16       ! 切断波数の設定(球殻動径, 球動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径
  
  real(8), allocatable ::  xvr_Torvel(:,:,:)
  real(8), allocatable ::  wq_Torvel(:,:)

  real(8), allocatable ::  xvr_Polvel(:,:,:)
  real(8), allocatable ::  wq_Polvel(:,:)

  real(8), allocatable ::  xvr_Vlon(:,:,:)
  real(8), allocatable ::  xvr_Vlat(:,:,:)
  real(8), allocatable ::  xvr_Vrad(:,:,:)

  real(8), dimension(0:nm,-nm:nm,kmi) ::  nmr_EkTor
  real(8), dimension(0:nm,-nm:nm,kmi) ::  nmr_EkPol
  real(8), dimension(0:nm,kmi)        ::  nr_EkTor
  real(8), dimension(0:nm,kmi)        ::  nr_EkPol
 
  real(8), dimension(kmi)             ::  r_Data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: PI
  integer :: n,m
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  PI = 4.0D0*Atan(1.0D0)

  call wtq_mpi_Initial(im,jm,kmi,kmo,nm,lmi,lmo,ri,ro)
 
  call MessageNotify('M','wtq_mpi_module_supack_spectrum_test',&
                         'wtq_mpi_module_supack spectrum functions tests.') 


  allocate(xvr_Torvel(0:im-1,1:jc,kmi))
  allocate(wq_Torvel(nc,0:lmi))
            
  allocate(xvr_Polvel(0:im-1,1:jc,kmi))
  allocate(wq_Polvel(nc,0:lmi))
            
  allocate(xvr_Vlon(0:im-1,1:jc,kmi))
  allocate(xvr_Vlat(0:im-1,1:jc,kmi))
  allocate(xvr_Vrad(0:im-1,1:jc,kmi))

  ! 2Y_1^0 * r
  xvr_Torvel = 2*sqrt(3.0D0)*sin(xvr_Lat) * xvr_Rad

  ! (2Y_2^0 +Y_2^-2) * r^2
  xvr_Polvel =( 2*sqrt(5.0D0)*(3.0/2*sin(xvr_Lat)**2-1/2.0) &
                - sqrt(5.0D0/24)*3.0*cos(xvr_Lat)**2*sin(2*xvr_Lon) ) &
              * xvr_Rad**2

  wq_Torvel = wq_xvr(xvr_Torvel)
  wq_Polvel = wq_xvr(xvr_Polvel)

  !--------- Energy spectrum ---------
  nmr_EkTor=wq_VMiss
  nmr_EkPol=wq_VMiss

  do n=0,nm
     do m=-n,n
        nmr_EkTor(n,m,:) = 0.0D0
        nmr_EkPol(n,m,:) = 0.0D0
     enddo
  enddo

  nmr_EkTor(1,0,:) = 4.0D0 * r_Rad**2 * (4*pi)*r_Rad**2

  nmr_EkPol(2,0,:) = 12.0D0 *(9*r_Rad**4 + 6.0D0*r_Rad**4) * (4*pi)

  nmr_EkPol(2,-2,:)= 2*3*(1.0D0/2)**2/2 &
       *(9*r_Rad**4 + 2*3* r_Rad**4 ) * (4*pi)
  nmr_EkPol(2,2,:) = nmr_EkPol(2,-2,:)

  call AssertEqual(&
    message='nmr_ToroidalEnergySpectrum_wq',                      &
    answer = nmr_ToroidalEnergySpectrum_wq(wq_Torvel),            &
    check =  nmr_EkTor,                                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='nmr_PoloidalEnergySpectrum_wq',                      &
    answer = nmr_PoloidalEnergySpectrum_wq(wq_Polvel),            &
    check =  nmr_EkPol,                                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nr_EkTor = 0.0D0
  nr_EkTor(1,:) = 4.0D0 * r_Rad**2 * (4*pi)*r_Rad**2 

  nr_EkPol = 0.0D0
  nr_EkPol(2,:) = (12.0D0+2*3*(1.0D0/2)**2)*(9*r_Rad**4+2*3*r_Rad**4)*(4*pi)

  call AssertEqual(&
    message='nr_ToroidalEnergySpectrum_wq',                       &
    answer = nr_ToroidalEnergySpectrum_wq(wq_Torvel),             &
    check =  nr_EkTor,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='nr_PoloidalEnergySpectrum_wq',                       &
    answer = nr_PoloidalEnergySpectrum_wq(wq_Polvel),             &
    check =  nr_EkPol,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call wq_Potential2VectorMPI(xvr_Vlon,xvr_Vlat,xvr_Vrad,wq_Torvel,wq_Polvel)

  nmr_EkTor = nmr_ToroidalEnergySpectrum_wq(wq_Torvel)
  nmr_EkPol = nmr_PoloidalEnergySpectrum_wq(wq_Polvel)

  r_Data = 0.0D0
  do n=0,nm
     do m=-n,n
        r_Data = r_Data + nmr_EkTor(n,m,:) + nmr_EkPol(n,m,:)
     enddo
  enddo

  call AssertEqual(&
    message='Total energy by nmr-spectrum',                        &
    answer = IntLonLatRad_xvr(xvr_VLon**2+xvr_VLat**2+xvr_VRad**2)/2.0D0, &
    check =  IntRad_r(r_Data/r_Rad**2),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nr_EkTor = nr_ToroidalEnergySpectrum_wq(wq_Torvel)
  nr_EkPol = nr_PoloidalEnergySpectrum_wq(wq_Polvel)

  call AssertEqual(&
    message='Total energy by nr-spectrum',                        &
    answer = IntLonLatRad_xvr(xvr_VLon**2+xvr_VLat**2+xvr_VRad**2)/2.0D0, &
    check =   IntRad_r(sum(nr_EkTor,1)/r_Rad**2) &
            + IntRad_r(sum(nr_EkPol,1)/r_Rad**2), &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wtq_mpi_module_supack_spectrum_test',&
                         'wtq_mpi_module_supack spectrum functions tests suceeded!') 

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wtq_mpi_module_supack_spectrum_test

!--
!----------------------------------------------------------------------
!     Copyright (c) 2002-2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  wa_deriv_module
!
!  spml/wa_deriv_module モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための 
!  モジュール wa_module の下部モジュールであり, スペクトル法の
!  微分計算のための Fortran90 関数を提供する. 
!
!  球面上の 1 層モデル用 w_deriv_module モジュールを多層モデル用に
!  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!  対する変換が行える.
!
!  内部で ISPACK の SPPACK と SNPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
!
!履歴  2002/02/02  竹広真一 
!      2002/02/07  竹広真一  関数,変数名前再変更
!      2002/03/30  竹広真一  モジュール名変更
!      2002/05/25  竹広真一  格子点座標を区別すべく命名法変更
!      2002/10/07  竹広真一  λ, μ座標系用微分追加
!      2006/03/08  竹広真一  コメントを RDoc 用に修正
!      2007/11/21  竹広真一  初期化サブルーチンメッセージ出力
!      2008/05/31  竹広真一  初期化サブルーチン削除
!      2008/06/21  佐々木洋平 水平方向の格子点データ配列の始点を 1 から 0 へ.
!      2008/06/28  佐々木洋平 コメントを RDoc 用に微修正
!      2008/07/07  竹広真一  配列最終次元の不定性を許容する変更
!      2009/01/29  佐々木洋平 コメントを RDoc 用に微修正
!
!      制限
!         ・変換する格子点データ, スペクトルデータの配列の大きさは決めうち
!
module wa_deriv_module
  !
  != wa_deriv_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/wa_deriv_module モジュールは球面上での流体運動を
  ! 球面調和函数を用いたスペクトル法によって数値計算するための 
  ! モジュール wa_module の下部モジュールであり, スペクトル法の
  ! 微分計算のための Fortran90 関数を提供する. 
  !
  ! 球面上の 1 層モデル用 w_deriv_module モジュールを多層モデル用に
  ! 拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  ! 対する変換が行える.
  !
  ! 内部で ISPACK の SPPACK と SNPACK の Fortran77 サブルーチンを呼んでいる. 
  ! スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  ! ついては ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
  !
  ! このモジュールを使うためには前もって w_initial を呼んで
  ! 切断波数, 格子点数の設定をしておく必要がある. 
  !
  use dc_message, only : MessageNotify
  use w_base_module, only : im, jm, nm
  use wa_base_module, only : km, wa_base_Initial, xya_wa, wa_xya
  use w_deriv_module, only : rn, irm, w_Jacobian_w_w

  implicit none

  private
 
  public wa_Lapla_wa, wa_LaplaInv_wa          ! ラプラシアンと逆演算
  public wa_DLon_wa                           ! 経度微分
  public xya_GradLon_wa, xya_GradLat_wa       ! 勾配型微分
  public wa_DivLon_xya, wa_DivLat_xya         ! 発散型微分
  public wa_Div_xya_xya                       ! 発散型微分
  public wa_Jacobian_wa_wa                    ! ヤコビアン
  public xya_GradLambda_wa, xya_GradMu_wa     ! 勾配型微分(λ,μ座標)
  public wa_DivLambda_xya, wa_DivMu_xya       ! 発散型微分(λ,μ座標)

  contains

  !--------------- 微分計算 -----------------
    function wa_Lapla_wa(wa_data)
      !
      ! 入力スペクトルデータにラプラシアン
      !
      !    ▽^2 = 1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)
      !
      ! を作用する(多層用).
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである. 
      !
      real(8), intent(in)  :: wa_data(:,:)
      !(in) 入力スペクトルデータ
      real(8)              :: wa_lapla_wa((nm+1)*(nm+1),size(wa_data,2))
      !(out) 入力スペクトルデータのラプラシアン
      integer :: l,k

      do k=1,size(wa_data,2)
        do l=1,(nm+1)**2
          wa_Lapla_wa(l,k) = rn(l,1)*wa_data(l,k)
        enddo
      enddo
      
    end function wa_Lapla_wa

    function wa_LaplaInv_wa(wa_data)
      !
      ! 入力スペクトルデータに逆ラプラシアン
      !
      !    ▽^{-2}
      !      =[1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)]^{-1}
      !
      ! を作用する(多層用).
      !
      ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
      ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである. 
      !
      real(8), intent(in)  :: wa_data(:,:)
      !(in) 入力スペクトルデータ
      real(8)              :: wa_LaplaInv_wa((nm+1)*(nm+1),size(wa_data,2))
      !(out) スペクトルデータの逆ラプラシアン
      integer :: l,k

      do k=1,size(wa_data,2)
         do l=1,(nm+1)**2
            wa_LaplaInv_wa(l,k) = rn(l,2)*wa_data(l,k)
         enddo
      enddo

    end function wa_LaplaInv_wa

    function wa_DLon_wa(wa_data)
      !
      ! スペクトルデータに経度微分 ∂/∂λ を作用させる(多層用).
      !
      ! スペクトルデータの経度微分とは, 対応する格子点データに
      ! 経度微分∂/∂λを作用させたデータのスペクトル変換のことである.
      ! 
      real(8), intent(in)  :: wa_data(:,:)
      !(in) 入力スペクトルデータ
      real(8)              :: wa_DLon_wa((nm+1)*(nm+1),size(wa_data,2))
      !(out) スペクトルデータの経度微分
      integer :: l,k

      do k=1,size(wa_data,2)
         do l=1,(nm+1)**2
            wa_DLon_wa(irm(l,1),k) = irm(l,2)*wa_data(l,k)
         enddo
      enddo

    end function wa_DLon_wa

    function xya_GradLon_wa(wa_data)
      !
      ! スペクトルデータに勾配型経度微分 1/cosφ・∂/∂λ を
      ! 作用させた格子点データを返す(多層用).
      !
      real(8), intent(in)  :: wa_data(:,:)
      !(in) 入力スペクトルデータ
      real(8)              :: xya_GradLon_wa(0:im-1,1:jm,size(wa_data,2))
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      xya_GradLon_wa = xya_wa(wa_data,ipow=1,iflag=-1)

    end function xya_GradLon_wa

    function xya_GradLat_wa(wa_data)
      !
      ! スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させて
      ! 格子点データに変換して返す(多層用).
      !
      real(8), intent(in)  :: wa_data(:,:)
      !(in) 入力スペクトルデータ
      real(8)              :: xya_GradLat_wa(0:im-1,1:jm,size(wa_data,2))
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      xya_GradLat_wa = xya_wa(wa_data,ipow=1,iflag=1)

    end function xya_GradLat_wa

    function wa_DivLon_xya(xya_data)
      !
      ! 格子点データに発散型経度微分 1/cosφ・∂/∂λ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(8), intent(in)  :: xya_data(0:,:,:)
      !(in) 入力格子点データ
      real(8)              :: wa_DivLon_xya((nm+1)**2,size(xya_data,3))
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      wa_DivLon_xya = wa_xya(xya_data,ipow=1,iflag=-1)

    end function wa_DivLon_xya

    function wa_DivLat_xya(xya_data)
      !
      ! 格子点データに発散型緯度微分 1/cosφ・∂(f cosφ)/∂φ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(8), intent(in)  :: xya_data(0:,:,:)
      !(in) 入力格子点データ
      real(8)              :: wa_DivLat_xya((nm+1)**2,size(xya_data,3))
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      wa_DivLat_xya = wa_xya(xya_data,ipow=1,iflag=1)

    end function wa_DivLat_xya

    function wa_Div_xya_xya(xya_u,xya_v)
      !
      ! 2 つの入力格子点データをベクトル成分とする発散を計算し, 
      ! スペクトルデータとして返す(多層用).
      !
      real(8), intent(in)  :: xya_u(0:,:,:)
      !(in) ベクトル経度成分の格子点データ
      real(8), intent(in)  :: xya_v(0:,:,:)
      !(in) ベクトル緯度成分の格子点データ
      real(8)              :: wa_Div_xya_xya((nm+1)**2,size(xya_u,3))
      !(out) 2 つの入力格子点データをベクトル成分とする発散のスペクトルデータ

      wa_Div_xya_xya = wa_DivLon_xya(xya_u) + wa_DivLat_xya(xya_v)

    end function wa_Div_xya_xya

    function wa_Jacobian_wa_wa(wa_a,wa_b)
      ! 2 つのスペクトルデータにヤコビアン
      !
      !   J(f,g) = ∂f/∂λ・∂g/∂μ - ∂g/∂λ・∂f/∂μ
      !          = ∂f/∂λ・1/cosφ・∂g/∂φ
      !             - ∂g/∂λ・1/cosφ・∂f/∂φ
      !
      ! を作用させる(多層用).
      !
      real(8), intent(in) :: wa_a(:,:)
      !(in) 1つ目の入力スペクトルデータ
      real(8), intent(in) :: wa_b(:,:)
      !(in) 2つ目の入力スペクトルデータ
      real(8)             :: wa_Jacobian_wa_wa((nm+1)**2,size(wa_a,2))
      !(out) 2 つのスペクトルデータのヤコビアン
      integer :: k

      do k=1,size(wa_a,2)
         wa_Jacobian_wa_wa(:,k) = w_Jacobian_w_w(wa_a(:,k),wa_b(:,k))
      end do
    end function wa_Jacobian_wa_wa


  !--------------- 微分計算 (λ,μ座標系用) -----------------
    function xya_GradLambda_wa(wa_data)
      !
      ! スペクトルデータに勾配型経度微分 ∂/∂λ を作用する(多層用).
      !
      real(8), intent(in)  :: wa_data(:,:)
      !(in) 入力スペクトルデータ
      real(8)              :: xya_GradLambda_wa(0:im-1,1:jm,size(wa_data,2))
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      xya_GradLambda_wa = xya_wa(wa_data,ipow=0,iflag=-1)

    end function xya_GradLambda_wa

    function xya_GradMu_wa(wa_data)
      !
      ! スペクトルデータに勾配型緯度微分 (1-μ^2)∂/∂μ  (μ=sinφ)
      ! を作用させて格子点データに変換して返す(多層用).
      !
      real(8), intent(in)  :: wa_data(:,:)
      !(in) 入力スペクトルデータ
      real(8)              :: xya_GradMu_wa(0:im-1,1:jm,size(wa_data,2))
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      xya_GradMu_wa = xya_wa(wa_data,ipow=0,iflag=1)

    end function xya_GradMu_wa

    function wa_DivLambda_xya(xya_data)
      !
      ! 格子点データに発散型経度微分 1/(1-μ^2)・∂/∂λ (μ=sinφ) 
      ! を作用させてスペクトルデータに変換して返す(多層用).
      !
      real(8), intent(in)  :: xya_data(0:,:,:)
      !(in) 入力格子点データ
      real(8)              :: wa_DivLambda_xya((nm+1)**2,size(xya_data,3))
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      wa_DivLambda_xya = wa_xya(xya_data,ipow=2,iflag=-1)

    end function wa_DivLambda_xya

    function wa_DivMu_xya(xya_data)
      !
      ! 格子点データに発散型緯度微分 ∂/∂μ (μ=sinφ)を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(8), intent(in)  :: xya_data(0:,:,:)
      !(in) 入力格子点データ
      real(8)              :: wa_DivMu_xya((nm+1)**2,size(xya_data,3))
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      wa_DivMu_xya = wa_xya(xya_data,ipow=2,iflag=1)

    end function wa_DivMu_xya

  end module wa_deriv_module

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wsc_mpi_module_supack テストプログラム
!
!      微分のテスト
!  
!履歴  2017/05/31  竹広真一   wt_module_nmomp_test_derivavit1.f90 より改造
!
program wsc_mpi_module_supack_derivative1_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wsc_mpi_module_supack
  use wa_mpi_module_supack, only : wa_Lapla_wa
  use mpi
  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nmm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), allocatable              :: xvz_Data(:,:,:)
  real(8), allocatable              :: xvz_DData(:,:,:)
                                                      
  real(8), allocatable              :: xvz_VLon(:,:,:)
  real(8), allocatable              :: xvz_VLat(:,:,:)
  real(8), allocatable              :: xvz_VRad(:,:,:)
  real(8), allocatable              :: xvz_Div(:,:,:)
  real(8), allocatable              :: xvz_Psi(:,:,:)
  real(8), allocatable              :: xvz_Xi(:,:,:)  

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer, parameter :: nmin=1, nmax=9

  integer :: iproc, np, ierr

  real(8) :: pi

  pi = atan(1.0D0)*4.0D0

  !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wsc_mpi_module_supack_derivative_test1', &
       'wsc_mpi_module_supack derivative function test #1')

  call wsc_mpi_Initial(im,jm,km,nmm,lm,ri,ro)

  allocate(xvz_Data(0:im-1,1:jc,0:km))
  allocate(xvz_DData(0:im-1,1:jc,0:km))

  allocate(xvz_VLon(0:im-1,1:jc,0:km))
  allocate(xvz_VLat(0:im-1,1:jc,0:km))
  allocate(xvz_VRad(0:im-1,1:jc,0:km))
  allocate(xvz_Div(0:im-1,1:jc,0:km))
  allocate(xvz_Psi(0:im-1,1:jc,0:km))

  allocate(xvz_Xi(0:im-1,1:jc,0:km))

  xvz_xi = (xvz_Rad - ri)/(ro-ri)

  !==================== wc_DRad_ws, ws_DRad_wc ====================  
  xvz_Data  = sin(PI*xvz_xi)
  xvz_DData = xvz_GradLat_wc(wc_xvz(xvz_Psi))

  xvz_DData = PI*cos(PI*xvz_xi)
  !
  call AssertEqual(&
       message='wc_DRad_ws with sin(z)',                             &
       answer = xvz_DData,                                           &
       check = xvz_wc(wc_DRad_ws(ws_xvz(xvz_Data))),                 &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvz_Data  = cos(2*PI*xvz_xi)
  xvz_DData = -2*PI*sin(2*PI*xvz_xi)
  !
  call AssertEqual(&
       message='ws_DRad_wc with cos(2z)',                            &
       answer = xvz_DData,                                           &
       check = xvz_ws(ws_DRad_wc(wc_xvz(xvz_Data))),                 &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !==================== wc_DivRad_ws, ws_DivRad_wc ====================  

  xvz_Data = cos(xvz_Lat)*sin(xvz_Lat) * sin(xvz_Lon) * cos(PI*xvz_xi) ! Y_2^-1 cos(z)
  xvz_DData = -PI* cos(xvz_Lat)*sin(xvz_Lat) * sin(xvz_Lon) * sin(PI*xvz_xi)
  !
  call AssertEqual(&
       message='ws_DivRad_wc with Y_2^-1 cos(z)',                    &
       answer = xvz_DData,                                           &
       check = xvz_ws(ws_DivRad_wc(wc_xvz(xvz_Data))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvz_Data = cos(xvz_Lat)*sin(xvz_Lat) * cos(xvz_Lon) * sin(2*PI*xvz_xi) ! Y_2^1 sin(2z)
  xvz_DData =2*PI*cos(xvz_Lat)*sin(xvz_Lat) * cos(xvz_Lon) * cos(2*PI*xvz_xi)
  !
  call AssertEqual(&
       message='wc_DivRad_ws with Y_2^1 sin(2z)',                    &
       answer = xvz_DData,                                           &
       check = xvz_wc(wc_DivRad_ws(ws_xvz(xvz_Data))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !==================== wc_RotRad_ws, ws_RotRad_wc ====================  

  xvz_Data = sin(xvz_Lat) * cos(3*PI*xvz_xi) ! Y_2^0 cos(3z)
  xvz_DData = -3*PI* sin(xvz_Lat) * sin(3*PI*xvz_xi)
  !
  call AssertEqual(&
       message='ws_RotRad_wc with Y_2^0 cos(3z)',                    &
       answer = xvz_DData,                                           &
       check = xvz_ws(ws_RotRad_wc(wc_xvz(xvz_Data))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvz_Data = sin(xvz_Lat) * sin(4*PI*xvz_xi) ! Y_2^0 sin(4z)
  xvz_DData = 4*PI* sin(xvz_Lat) * cos(4*PI*xvz_xi)
  !
  call AssertEqual(&
       message='wc_RotRad_ws with Y_2^0 sin(4z)',                    &
       answer = xvz_DData,                                           &
       check = xvz_wc(wc_RotRad_ws(ws_xvz(xvz_Data))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !==================== ws_Lapla_ws, wc_Lapla_wc ====================  
  
  xvz_Data  = cos(xvz_Lat)*sin(xvz_Lon)*sin(3*PI*xvz_xi)  ! Y_1^-1 sin(3z)
  xvz_DData = -( 9*PI**2 + 1*2/Ro**2) * xvz_Data
  !
  call AssertEqual(&
       message='ws_Lapla_ws with Y_1^-1 sin(3z)',                    &
       answer = xvz_DData,                                           &
       check = xvz_ws(ws_Lapla_ws(ws_xvz(xvz_Data))),                &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvz_Data  = cos(xvz_Lat)*cos(xvz_Lon)*cos(4*PI*xvz_xi)  ! Y_1^1 cos(4z)
  xvz_DData = -( 16*PI**2 + 1*2/Ro**2) * xvz_Data
  !
  call AssertEqual(&
       message='wc_Lapla_wc with Y_1^1 cos(4z)',                     &
       answer = xvz_DData,                                           &
       check = xvz_wc(wc_Lapla_wc(wc_xvz(xvz_Data))),                &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !==================== ws_LaplaInv_ws, wc_LaplaInv_wc ====================  
  
  xvz_Data  = cos(xvz_Lat)*sin(xvz_Lon)*sin(3*PI*xvz_xi)  ! Y_1^-1 sin(3z)
  xvz_DData = -1.0D0/( 9*PI**2 + 1*2/Ro**2) * xvz_Data
  !
  call AssertEqual(&
       message='ws_LaplaInv_ws with Y_1^-1 sin(3z)',                 &
       answer = xvz_DData,                                           &
       check = xvz_ws(ws_LaplaInv_ws(ws_xvz(xvz_Data))),             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvz_Data  = cos(xvz_Lat)*sin(xvz_Lon)*sin(2*PI*xvz_xi)  ! Y_1^-1 sin(2z)
  xvz_DData = -1.0D0/( 4*PI**2 + 1*2/Ro**2) * xvz_Data
  !
  call AssertEqual(&
       message='ws_LaplaInv_ws with Y_1^-1 sin(2z)',                 &
       answer = xvz_DData,                                           &
       check = xvz_ws(ws_LaplaInv_ws(ws_xvz(xvz_Data))),             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvz_Data  = cos(xvz_Lat)*cos(xvz_Lon)*cos(4*PI*xvz_xi)  ! Y_1^1 cos(4z)
  xvz_DData = -1.0D0/( 16*PI**2 + 1*2/Ro**2) * xvz_Data
  !
  call AssertEqual(&
       message='wc_LaplaInv_wc with Y_1^1 cos(4z)',                  &
       answer = xvz_DData,                                           &
       check = xvz_wc(wc_LaplaInv_wc(wc_xvz(xvz_Data))),             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvz_Data  = cos(xvz_Lat)*cos(xvz_Lon)*cos(5*PI*xvz_xi)  ! Y_1^1 cos(4z)
  xvz_DData = -1.0D0/( 25*PI**2 + 1*2/Ro**2) * xvz_Data
  !
  call AssertEqual(&
       message='wc_LaplaInv_wc with Y_1^1 cos(5z)',                  &
       answer = xvz_DData,                                           &
       check = xvz_wc(wc_LaplaInv_wc(wc_xvz(xvz_Data))),             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  !========== xvz_GradLon_ws, xvz_GradLat_ws ==========

  ! ------ Y_1^-1 sin(z) Toridal field -----

  xvz_Psi = cos(xvz_Lat)*sin(xvz_Lon) * sin(PI*xvz_xi)    ! Y_1^-1 sin(z)
  xvz_VRad = 0

  xvz_VLon =  cos(xvz_Lon) * sin(PI*xvz_xi) /Ro
  call AssertEqual(&
       message='xvz_GradLon_ws with Y_1^-1 sin(z)',                  &
       answer = xvz_VLon,                                            &
       check = xvz_GradLon_ws(ws_xvz(xvz_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvz_VLat = -sin(xvz_Lat)*sin(xvz_Lon) * sin(PI*xvz_xi) /Ro
  call AssertEqual(&
       message='xvz_GradLat_ws with Y_1^-1 sin(z)',                  &
       answer = xvz_VLat,                                            &
       check = xvz_GradLat_ws(ws_xvz(xvz_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !========== xvz_GradLon_wc, xvz_GradLat_wc, wc_Div_xvz_xvz_xvz, wc_RotRad_xvz_xvz ==========
  ! ------ Y_1^1 cos(2z) Toridal field -----

  xvz_Psi = cos(xvz_Lat)*cos(xvz_Lon) * cos(2*PI*xvz_xi)    ! Y_1^1 cos(2z)
  xvz_VRad = 0

  xvz_VLon =  - sin(xvz_Lon) * cos(2*PI*xvz_xi) /Ro
  call AssertEqual(&
       message='xvz_GradLon_wc with Y_1^1 cos(2z)',                  &
       answer = xvz_VLon,                                            &
       check = xvz_GradLon_wc(wc_xvz(xvz_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvz_VLat = -sin(xvz_Lat)*cos(xvz_Lon) * cos(2*PI*xvz_xi) /Ro
  call AssertEqual(&
       message='xvz_GradLat_wc with Y_1^1 cos(2z)',                  &
       answer = xvz_VLat,                                            &
       check = xvz_GradLat_wc(wc_xvz(xvz_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvz_Div = - 2 * xvz_Psi/Ro**2
  call AssertEqual(&
       message='wc_Div_xvz_xvz_xvz with Toroiral Y_1^-1 cos(2z)',     &
       answer = xvz_Div,                                              &
       check = xvz_wc(wc_Div_xvz_xvz_xvz(xvz_VLon,xvz_VLat,xvz_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore      &
       )

  xvz_VLat = - xvz_Vlat
  call AssertEqual(&
       message='wc_RotRad_xvz_xvz with Toroiral Y_1^-1 cos(2z)',      &
       answer = xvz_Div,                                              &
       check = xvz_wc(wc_RotRad_xvz_xvz(xvz_VLon,xvz_VLat)),          &
       significant_digits = check_digits, ignore_digits = ignore      &
       )


  ! ------ Y_2^-1 sin(z) Poloidal field -----

  xvz_Psi = cos(xvz_Lat)*sin(xvz_Lat) * sin(xvz_Lon) * sin(PI*xvz_xi) ! Y_2^-1 sin(z)

  xvz_VLon = xvz_GradLon_wc(wc_DRad_ws(ws_xvz(xvz_Psi)))*Ro ! PI*sin(lat)cos(lon))cos(z)
  xvz_VLat = xvz_GradLat_wc(wc_DRad_ws(ws_xvz(xvz_Psi)))*Ro ! PI*cos(2lat)sin(lon)cos(z)
  xvz_Vrad = -xvz_wz(wa_Lapla_wa(wz_xvz(xvz_Psi)))/Ro       ! (2*3/Ro) Psi

  xvz_DData = 0.0D0
  call AssertEqual(&
       message='wc_Div_xvz_xvz_xvz with  Y_2^-1 sin(z)',                &
       answer = xvz_DData,                                              &
       check =  xvz_wc(wc_Div_xvz_xvz_xvz(xvz_Vlon,xvz_Vlat,xvz_Vrad)), &
       significant_digits = check_digits, ignore_digits = ignore        &
       )

  ! ------ Y_2^-1 cos(z) Poloidal field -----

  xvz_Psi = cos(xvz_Lat)*sin(xvz_Lat) * sin(xvz_Lon) * cos(PI*xvz_xi) ! Y_2^-1 sin(z)

  xvz_VLon = xvz_GradLon_ws(ws_DRad_wc(wc_xvz(xvz_Psi)))*Ro ! PI*sin(lat)cos(lon))cos(z)
  xvz_VLat = xvz_GradLat_ws(ws_DRad_wc(wc_xvz(xvz_Psi)))*Ro ! PI*cos(2lat)sin(lon)cos(z)
  xvz_Vrad = -xvz_wz(wa_Lapla_wa(wz_xvz(xvz_Psi)))/Ro       ! (2*3/Ro) Psi

  xvz_DData = 0.0D0
  call AssertEqual(&
       message='ws_Div_xvz_xvz_xvz with  Y_2^-1 sin(z)',                &
       answer = xvz_DData,                                              &
       check =  xvz_ws(ws_Div_xvz_xvz_xvz(xvz_Vlon,xvz_Vlat,xvz_Vrad)), &
       significant_digits = check_digits, ignore_digits = ignore        &
       )

  call MessageNotify('M','wsc_mpi_module_supack_derivative1_test', &
       'wsc_mpi_module_supack derivative function test #1 succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wsc_mpi_module_supack_derivative1_test

!----------------------------------------------------------------------
!     Copyright (c) 2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_base_mpi_module テストプログラム :: 終了処理のテスト
!
!履歴  2013/02/23  竹広真一
!
program w_base_mpi_module_finalize_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_mpi_module
  use mpi
  implicit none

  integer :: im(2)=(/16,32/)
  integer :: jm(2)=(/8,16/)
  integer :: nm(2)=(/5,10/)

  real(8), allocatable  :: w_data(:)
  real(8), allocatable  :: xv_data(:,:)
  real(8), allocatable  :: xv_Ddata(:,:)
  real(8), allocatable  :: xy_data(:,:)
  real(8), allocatable  :: xy_Ddata(:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  real(8) :: pi
  integer :: iproc, np, ierr
  integer :: n

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','w_base_mpi_module_finalize_test', &
                         'w_base_mpi_module finalize subroutine tests') 

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  do n=1,2

  call w_mpi_Initial( nm(n), im(n), jm(n) )

  allocate(w_data((nm(n)+1)**2))
  allocate(xy_data(0:im(n)-1,jm(n)))
  allocate(xy_Ddata(0:im(n)-1,jm(n)))
  allocate(xv_data(0:im(n)-1,jc))
  allocate(xv_Ddata(0:im(n)-1,jc))

  !========================= xv_w, w_xv のテスト===========================

  call MessageNotify('M','w_base_mpi_module_test', &
                         'w_base_mpi_module functions xv_w, w_xv tests') 
  !==================== Y_1^0 のテスト ====================
  xv_data = sqrt(3.0D0)*sin(xv_Lat)                      ! Y_1^0
  w_data= 0.0D0 ; w_data(l_nm(1,0))=1.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_1^0 Test of w_xv(xv_data)',                        &
    answer = w_data,                                              &
    check = w_xv(xv_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xv_w(w_xv(xv_data))',                  &
    answer = xv_data,                                             &
    check = xv_w(w_xv(xv_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xv_Ddata = 0.0D0
  call AssertEqual(&
    message='Y_1^0 Test of xv_w(w_xv(xv_data,iflag=-1))',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xv_w(w_xv(xv_data),iflag=-1)',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xv_Ddata = sqrt(3.0D0) * ( cos(xv_Lat)**2 - 2*sin(xv_Lat)**2 )
  call AssertEqual(&
    message='Y_1^0 Test of xv_w(w_xv(xv_data,iflag=1,ipow=0))',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Ddata = sqrt(3.0D0)*cos(xv_Lat)
  call AssertEqual(&
    message='Y_1^0 Test of xv_w(w_xv(xv_data),iflag=1,ipow=1)',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xv_Ddata = sqrt(3.0D0) * sin(xv_Lat)**2
  call AssertEqual(&
    message='Y_1^0 Test of xv_w(w_xv(xv_data,iflag=2))',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xv_w(w_xv(xv_data),iflag=2)',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_1^0','Test of Y_1^0 succeeded!') 

  !==================== Y_1^1 のテスト ====================
  xv_data = sqrt(3.0D0/2)*cos(xv_Lat)*cos(xv_Lon)          ! Y_1^1
  w_data= 0.0D0 ; w_data(l_nm(1,1))=1.0D0/sqrt(2.0D0)

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_1^1 Test of w_xv(xv_data)',                        &
    answer = w_data,                                              &
    check = w_xv(xv_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data))',                  &
    answer = xv_data,                                             &
    check = xv_w(w_xv(xv_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xv_Ddata = -sqrt(3.0D0/2)*cos(xv_Lat)*sin(xv_Lon)          ! Y_1^1
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data,iflag=-1))',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data),iflag=-1)',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xv_Ddata = - sqrt(3.0D0/2) * 3 * sin(xv_Lat) * cos(xv_Lat) * cos(xv_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data,iflag=1,ipow=0))',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Ddata = - sqrt(3.0D0/2) * sin(xv_Lat) * cos(xv_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data),iflag=1,ipow=1)',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xv_Ddata = sqrt(3.0D0/2) * sin(xv_Lat)* cos(xv_Lat) * cos(xv_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data,iflag=2))',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data),iflag=2)',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_1^1','Test of Y_1^1 succeeded!') 

  !==================== Y_1^{-1} のテスト ====================
  xv_data = -sqrt(3.0D0/2)*cos(xv_Lat)*sin(xv_Lon)         ! Y_1^{-1}
  w_data= 0.0D0 ; w_data(l_nm(1,-1))=1.0D0/sqrt(2.0D0)

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_1^1 Test of w_xv(xv_data)',                        &
    answer = w_data,                                              &
    check = w_xv(xv_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data))',                  &
    answer = xv_data,                                             &
    check = xv_w(w_xv(xv_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xv_Ddata = -sqrt(3.0D0/2)*cos(xv_Lat)*cos(xv_Lon)          ! Y_1^{-1}
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data,iflag=-1))',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data),iflag=-1)',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xv_Ddata = sqrt(3.0D0/2) * 3 * sin(xv_Lat) * cos(xv_Lat) * sin(xv_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data,iflag=1,ipow=0))',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Ddata = sqrt(3.0D0/2) * sin(xv_Lat) * sin(xv_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data),iflag=1,ipow=1)',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xv_Ddata = - sqrt(3.0D0/2) * sin(xv_Lat)* cos(xv_Lat) * sin(xv_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data,iflag=2))',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xv_w(w_xv(xv_data),iflag=2)',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !==================== Y_2^0 のテスト ====================
  xv_data = sqrt(5.0D0)*(3.0/2*sin(xv_Lat)**2-1/2.0)                 ! Y_2^0
  w_data= 0.0D0 ; w_data(l_nm(2,0))=1.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^0 Test of w_xv(xv_data)',                        &
    answer = w_data,                                              &
    check = w_xv(xv_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xv_w(w_xv(xv_data))',                  &
    answer = xv_data,                                             &
    check = xv_w(w_xv(xv_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xv_Ddata = 0.0D0
  call AssertEqual(&
    message='Y_2^0 Test of xv_w(w_xv(xv_data,iflag=-1))',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xv_w(w_xv(xv_data),iflag=-1)',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xv_Ddata = sqrt(5.0D0)*(   3.0*sin(xv_Lat)*cos(xv_Lat)**2  &
                           - 3.0*sin(xv_Lat)**3 + sin(xv_Lat)  ) 
  call AssertEqual(&
    message='Y_2^0 Test of xv_w(w_xv(xv_data,iflag=1,ipow=0))',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Ddata = sqrt(5.0D0)*3.0*sin(xv_Lat)*cos(xv_Lat)
  call AssertEqual(&
    message='Y_2^0 Test of xv_w(w_xv(xv_data),iflag=1,ipow=1)',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xv_Ddata = sqrt(5.0D0)*(3.0/2*sin(xv_Lat)**2-1/2.0)*sin(xv_Lat)
  call AssertEqual(&
    message='Y_2^0 Test of xv_w(w_xv(xv_data,iflag=2))',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xv_w(w_xv(xv_data),iflag=2)',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^0','Test of Y_2^0 succeeded!') 

  !==================== Y_2^1 のテスト ====================
  xv_data = sqrt(5.0D0/6)*3.0*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)! Y_2^1
  w_data= 0.0D0 ; w_data(l_nm(2,1))=1.0D0/sqrt(2.0D0)

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^1 Test of w_xv(xv_data)',                        &
    answer = w_data,                                              &
    check = w_xv(xv_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^1 Test of xv_w(w_xv(xv_data))',                  &
    answer = xv_data,                                             &
    check = xv_w(w_xv(xv_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xv_Ddata = -sqrt(5.0D0/6)*3.0*sin(xv_Lat)*cos(xv_Lat)*sin(xv_Lon)! Y_2^1
  call AssertEqual(&
    message='Y_2^1 Test of xv_w(w_xv(xv_data,iflag=-1))',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^1 Test of xv_w(w_xv(xv_data),iflag=-1)',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xv_Ddata = sqrt(5.0D0/6)*3.0 &
       *(cos(xv_Lat)**3-3*sin(xv_Lat)**2*cos(xv_Lat))*cos(xv_Lon)
  call AssertEqual(&
    message='Y_2^1 Test of xv_w(w_xv(xv_data,iflag=1,ipow=1))',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Ddata = sqrt(5.0D0/6)*3.0 * cos(2*xv_Lat) * cos(xv_Lon)
  call AssertEqual(&
    message='Y_2^1 Test of xv_w(w_xv(xv_data),iflag=1,ipow=1)',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xv_Ddata = sqrt(5.0D0/6)*3.0*sin(xv_Lat)**2*cos(xv_Lat) * cos(xv_Lon)
  call AssertEqual(&
    message='Y_2^1 Test of xv_w(w_xv(xv_data,iflag=2))',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^1 Test of xv_w(w_xv(xv_data),iflag=2)',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^1','Test of Y_2^1 succeeded!') 

  !==================== Y_2^-1 のテスト ====================
  xv_data = -sqrt(5.0D0/6)*3.0*sin(xv_Lat)*cos(xv_Lat) * sin(xv_Lon)! Y_2^-1
  w_data= 0.0D0 ; w_data(l_nm(2,-1))=1.0D0/sqrt(2.0D0)

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^-1 Test of w_xv(xv_data)',                       &
    answer = w_data,                                              &
    check = w_xv(xv_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-1 Test of xv_w(w_xv(xv_data))',                 &
    answer = xv_data,                                             &
    check = xv_w(w_xv(xv_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xv_Ddata = -sqrt(5.0D0/6)*3.0*sin(xv_Lat)*cos(xv_Lat)*cos(xv_Lon)! Y_2^-1
  call AssertEqual(&
    message='Y_2^-1 Test of xv_w(w_xv(xv_data,iflag=-1))',        &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-1 Test of xv_w(w_xv(xv_data),iflag=-1)',        &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xv_Ddata = -sqrt(5.0D0/6)*3.0 &
       *(cos(xv_Lat)**3-3*sin(xv_Lat)**2*cos(xv_Lat))*sin(xv_Lon)
  call AssertEqual(&
    message='Y_2^-1 Test of xv_w(w_xv(xv_data,iflag=1,ipow=0))',  &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Ddata = -sqrt(5.0D0/6)*3.0 * cos(2*xv_Lat) * sin(xv_Lon)
  call AssertEqual(&
    message='Y_2^-1 Test of xv_w(w_xv(xv_data),iflag=1,ipow=1)',  &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xv_Ddata = -sqrt(5.0D0/6)*3.0*sin(xv_Lat)**2*cos(xv_Lat) * sin(xv_Lon)
  call AssertEqual(&
    message='Y_2^-1 Test of xv_w(w_xv(xv_data,iflag=2))',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-1 Test of xv_w(w_xv(xv_data),iflag=2)',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^-1','Test of Y_2^-1 succeeded!') 

  !==================== Y_2^2 のテスト ====================
  xv_data = sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*cos(2*xv_Lon)         ! Y_2^2
  w_data= 0.0D0 ; w_data(l_nm(2,2))=1.0D0/sqrt(2.0D0)

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^2 Test of w_xv(xv_data)',                        &
    answer = w_data,                                              &
    check = w_xv(xv_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^2 Test of xv_w(w_xv(xv_data))',                  &
    answer = xv_data,                                             &
    check = xv_w(w_xv(xv_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xv_Ddata = sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2* (-2)* sin(2*xv_Lon)  ! Y_2^2
  call AssertEqual(&
    message='Y_2^2 Test of xv_w(w_xv(xv_data,iflag=-1))',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^2 Test of xv_w(w_xv(xv_data),iflag=-1)',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xv_Ddata = - sqrt(5.0D0/24)*3.0*4*sin(xv_Lat)*cos(xv_Lat)**2*cos(2*xv_Lon)
  call AssertEqual(&
    message='Y_2^2 Test of xv_w(w_xv(xv_data,iflag=1,ipow=0))',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Ddata = -sqrt(5.0D0/24)*3.0*2*cos(xv_Lat)*sin(xv_Lat)*cos(2*xv_Lon)
  call AssertEqual(&
    message='Y_2^2 Test of xv_w(w_xv(xv_data),iflag=1,ipow=1)',   &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xv_Ddata = sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*sin(xv_Lat)*cos(2*xv_Lon)
  call AssertEqual(&
    message='Y_2^2 Test of xv_w(w_xv(xv_data,iflag=2))',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^2 Test of xv_w(w_xv(xv_data),iflag=2)',          &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^2','Test of Y_2^2 succeeded!') 

  !==================== Y_2^-2 のテスト ====================
  xv_data = -sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*sin(2*xv_Lon)         ! Y_2^-2
  w_data= 0.0D0 ; w_data(l_nm(2,-2))=1.0D0/sqrt(2.0D0)

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^-2 Test of w_xv(xv_data)',                        &
    answer = w_data,                                              &
    check = w_xv(xv_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-2 Test of xv_w(w_xv(xv_data))',                 &
    answer = xv_data,                                             &
    check = xv_w(w_xv(xv_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xv_Ddata = -sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2* 2*cos(2*xv_Lon)  ! Y_2^2
  call AssertEqual(&
    message='Y_2^-2 Test of xv_w(w_xv(xv_data,iflag=-1))',        &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-2 Test of xv_w(w_xv(xv_data),iflag=-1)',        &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xv_Ddata = sqrt(5.0D0/24)*3.0*4*sin(xv_Lat)*cos(xv_Lat)**2*sin(2*xv_Lon)
  call AssertEqual(&
    message='Y_2^-2 Test of xv_w(w_xv(xv_data,iflag=1,ipow=0))',  &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_Ddata = sqrt(5.0D0/24)*3.0*2*cos(xv_Lat)*sin(xv_Lat)*sin(2*xv_Lon)
  call AssertEqual(&
    message='Y_2^-2 Test of xv_w(w_xv(xv_data),iflag=1,ipow=1)',  &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xv_Ddata = -sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*sin(xv_Lat)*sin(2*xv_Lon)
  call AssertEqual(&
    message='Y_2^-2 Test of xv_w(w_xv(xv_data,iflag=2))',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-2 Test of xv_w(w_xv(xv_data),iflag=2)',         &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^-2','Test of Y_2^-2 succeeded!') 

  !==================== 一般的関数のテスト ====================
  xv_data = cos(2*xv_Lon-pi/3) &
       *(sin(xv_Lat)-1)**2*(sin(xv_Lat)-0.5)*(sin(xv_Lat)+1)

  !---- 通常変換 ----
  call AssertEqual(&
    message='general function of xv_w(w_xv(xv_data))',            &
    answer = xv_data,                                             &
    check = xv_w(w_xv(xv_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xv_data  = cos(xv_Lat)
  xv_Ddata = -2*sin(xv_Lat)

  call AssertEqual(&
    message='general function test of xv_w(w_xv(xv_data,iflag=1,ipow=1))',  &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=1)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_data  = cos(xv_Lat)**2
  xv_Ddata = -2*sin(xv_Lat)
  call AssertEqual(&
    message='general function test of xv_w(w_xv(xv_data,iflag=1,ipow=2))',  &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data,iflag=1,ipow=2)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_data  = sin(xv_Lat)
  xv_Ddata = cos(xv_Lat)**2

  call AssertEqual(&
    message='general function test of xv_w(w_xv(xv_data),iflag=1,ipow=0)',  &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=0),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_data  = cos(xv_Lat)**2
  xv_Ddata = -2.0D0 * sin(xv_Lat)

  call AssertEqual(&
    message='general function test of xv_w(w_xv(xv_data),iflag=1,ipow=2)',  &
    answer = xv_Ddata,                                            &
    check = xv_w(w_xv(xv_data),iflag=1,ipow=2),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !========================= xy_w, w_xy のテスト===========================

  call MessageNotify('M','w_base_mpi_module_test', &
                         'w_base_mpi_module functions xy_w, w_xy tests') 

  !==================== Y_1^0 のテスト ====================
  xy_data = sqrt(3.0D0)*sin(xy_Lat)                      ! Y_1^0
  w_data= 0.0D0 ; w_data(l_nm(1,0))=1.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_1^0 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = 0.0D0
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = sqrt(3.0D0) * ( cos(xy_Lat)**2 - 2*sin(xy_Lat)**2 )
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(3.0D0)*cos(xy_Lat)
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(3.0D0) * sin(xy_Lat)**2
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_1^0','Test of Y_1^0 succeeded!') 

  !==================== Y_1^1 のテスト ====================
  xy_data = sqrt(3.0D0/2)*cos(xy_Lat)*cos(xy_Lon)          ! Y_1^1
  w_data= 0.0D0 ; w_data(l_nm(1,1))=1.0D0/sqrt(2.0D0)

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_1^1 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = -sqrt(3.0D0/2)*cos(xy_Lat)*sin(xy_Lon)          ! Y_1^1
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = - sqrt(3.0D0/2) * 3 * sin(xy_Lat) * cos(xy_Lat) * cos(xy_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = - sqrt(3.0D0/2) * sin(xy_Lat) * cos(xy_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(3.0D0/2) * sin(xy_Lat)* cos(xy_Lat) * cos(xy_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_1^1','Test of Y_1^1 succeeded!') 

  !==================== Y_1^{-1} のテスト ====================
  xy_data = -sqrt(3.0D0/2)*cos(xy_Lat)*sin(xy_Lon)         ! Y_1^{-1}
  w_data= 0.0D0 ; w_data(l_nm(1,-1))=1.0D0/sqrt(2.0D0)

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_1^1 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = -sqrt(3.0D0/2)*cos(xy_Lat)*cos(xy_Lon)          ! Y_1^{-1}
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = sqrt(3.0D0/2) * 3 * sin(xy_Lat) * cos(xy_Lat) * sin(xy_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(3.0D0/2) * sin(xy_Lat) * sin(xy_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = - sqrt(3.0D0/2) * sin(xy_Lat)* cos(xy_Lat) * sin(xy_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !==================== Y_2^0 のテスト ====================
  xy_data = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)                 ! Y_2^0
  w_data= 0.0D0 ; w_data(l_nm(2,0))=1.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^0 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = 0.0D0
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = sqrt(5.0D0)*(   3.0*sin(xy_Lat)*cos(xy_Lat)**2  &
                           - 3.0*sin(xy_Lat)**3 + sin(xy_Lat)  ) 
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(5.0D0)*3.0*sin(xy_Lat)*cos(xy_Lat)
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)*sin(xy_Lat)
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^0','Test of Y_2^0 succeeded!') 

  !==================== Y_2^1 のテスト ====================
  xy_data = sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)! Y_2^1
  w_data= 0.0D0 ; w_data(l_nm(2,1))=1.0D0/sqrt(2.0D0)

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^1 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = -sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat)*sin(xy_Lon)! Y_2^1
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = sqrt(5.0D0/6)*3.0 &
       *(cos(xy_Lat)**3-3*sin(xy_Lat)**2*cos(xy_Lat))*cos(xy_Lon)
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data,iflag=1,ipow=1))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(5.0D0/6)*3.0 * cos(2*xy_Lat) * cos(xy_Lon)
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(5.0D0/6)*3.0*sin(xy_Lat)**2*cos(xy_Lat) * cos(xy_Lon)
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^1','Test of Y_2^1 succeeded!') 

  !==================== Y_2^-1 のテスト ====================
  xy_data = -sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat) * sin(xy_Lon)! Y_2^-1
  w_data= 0.0D0 ; w_data(l_nm(2,-1))=1.0D0/sqrt(2.0D0)

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^-1 Test of w_xy(xy_data)',                       &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data))',                 &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = -sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat)*cos(xy_Lon)! Y_2^-1
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data,iflag=-1))',        &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data),iflag=-1)',        &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = -sqrt(5.0D0/6)*3.0 &
       *(cos(xy_Lat)**3-3*sin(xy_Lat)**2*cos(xy_Lat))*sin(xy_Lon)
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = -sqrt(5.0D0/6)*3.0 * cos(2*xy_Lat) * sin(xy_Lon)
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = -sqrt(5.0D0/6)*3.0*sin(xy_Lat)**2*cos(xy_Lat) * sin(xy_Lon)
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data,iflag=2))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data),iflag=2)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^-1','Test of Y_2^-1 succeeded!') 

  !==================== Y_2^2 のテスト ====================
  xy_data = sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*cos(2*xy_Lon)         ! Y_2^2
  w_data= 0.0D0 ; w_data(l_nm(2,2))=1.0D0/sqrt(2.0D0)

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^2 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2* (-2)* sin(2*xy_Lon)  ! Y_2^2
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = - sqrt(5.0D0/24)*3.0*4*sin(xy_Lat)*cos(xy_Lat)**2*cos(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = -sqrt(5.0D0/24)*3.0*2*cos(xy_Lat)*sin(xy_Lat)*cos(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(xy_Lat)*cos(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^2','Test of Y_2^2 succeeded!') 

  !==================== Y_2^-2 のテスト ====================
  xy_data = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(2*xy_Lon)         ! Y_2^-2
  w_data= 0.0D0 ; w_data(l_nm(2,-2))=1.0D0/sqrt(2.0D0)

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^-2 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data))',                 &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2* 2*cos(2*xy_Lon)  ! Y_2^2
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data,iflag=-1))',        &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data),iflag=-1)',        &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = sqrt(5.0D0/24)*3.0*4*sin(xy_Lat)*cos(xy_Lat)**2*sin(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(5.0D0/24)*3.0*2*cos(xy_Lat)*sin(xy_Lat)*sin(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(xy_Lat)*sin(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data,iflag=2))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data),iflag=2)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^-2','Test of Y_2^-2 succeeded!') 

  !==================== 一般的関数のテスト ====================
  xy_data = cos(2*xy_Lon-pi/3) &
       *(sin(xy_Lat)-1)**2*(sin(xy_Lat)-0.5)*(sin(xy_Lat)+1)

  !---- 通常変換 ----
  call AssertEqual(&
    message='general function of xy_w(w_xy(xy_data))',            &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_data  = cos(xy_Lat)
  xy_Ddata = -2*sin(xy_Lat)

  call AssertEqual(&
    message='general function test of xy_w(w_xy(xy_data,iflag=1,ipow=1))',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=1)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_data  = cos(xy_Lat)**2
  xy_Ddata = -2*sin(xy_Lat)
  call AssertEqual(&
    message='general function test of xy_w(w_xy(xy_data,iflag=1,ipow=2))',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=2)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_data  = sin(xy_Lat)
  xy_Ddata = cos(xy_Lat)**2

  call AssertEqual(&
    message='general function test of xy_w(w_xy(xy_data),iflag=1,ipow=0)',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=0),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_data  = cos(xy_Lat)**2
  xy_Ddata = -2.0D0 * sin(xy_Lat)

  call AssertEqual(&
    message='general function test of xy_w(w_xy(xy_data),iflag=1,ipow=2)',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=2),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of genral function', &
       'Test of general function succeeded!') 


  deallocate(w_data)
  deallocate(xy_data)
  deallocate(xy_Ddata)
  deallocate(xv_data)
  deallocate(xv_Ddata)

  call w_mpi_Finalize

  end do

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

  call MessageNotify('M','w_base_mpi_module_finalize_test', &
       'w_base_mpi_module finalize subroutine tests succeeded.') 


end program w_base_mpi_module_finalize_test

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_module_fftj テストプログラム (積分・平均計算)
!
!履歴  2009/12/15  竹広真一
!
program tee_module_fftj_integral_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=32       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=21       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: zyx_Data(0:km,0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: yx_Data(0:jm-1,0:im-1)          ! 格子データ
  real(8)            :: zx_Data(0:km,0:im-1)            ! 格子データ
  real(8)            :: zy_Data(0:km,0:jm-1)            ! 格子データ
  real(8)            :: x_Data(0:im-1)                  ! 格子データ
  real(8)            :: y_Data(0:jm-1)                  ! 格子データ
  real(8)            :: z_Data(0:km)                    ! 格子データ

  real(8)            :: yx_Ans(0:jm-1,0:im-1)           ! 格子データ
  real(8)            :: zy_Ans(0:km,0:jm-1)             ! 格子データ
  real(8)            :: zx_Ans(0:km,0:im-1)             ! 格子データ

  real(8)            :: x_Ans(0:im-1)                   ! 格子データ
  real(8)            :: y_Ans(0:jm-1)                   ! 格子データ
  real(8)            :: z_Ans(0:km)                     ! 格子データ

  real(8)            :: Ans                             ! 

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','tee_module_fftj_integral_test', &
       'tee_module_fftj integral and average functions tests')

 !---------------- 座標値の設定 ---------------------
  call tee_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

 !------------------- 3 次元関数チェック ----------------------
  zyx_Data = sin(pi*zyx_X) * cos(pi*zyx_Y) * cos(pi*zyx_Z)

  Ans = 0.0D0
  call AssertEqual(&
    message='IntZYX_zyx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',      &
    answer = Ans,                                                 &
    check = IntZYX_zyx(zyx_Data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='AvrZYX_yx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',       &
    answer = Ans,                                                 &
    check = AvrZYX_zyx(zyx_Data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Ans = 0.0D0
  call AssertEqual(&
    message='yx_IntZ_zyx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = yx_Ans,                                              &
    check = yx_IntZ_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='yx_AvrZ_zyx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = yx_Ans,                                              &
    check = yx_AvrZ_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zy_Ans = 0.0D0
  call AssertEqual(&
    message='zy_IntX_zyx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = zy_Ans,                                              &
    check = zy_IntX_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zy_AvrX_zyx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = zy_Ans,                                              &
    check = zy_AvrX_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zx_Ans = 0.0D0
  call AssertEqual(&
    message='zx_IntY_zyx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = zx_Ans,                                              &
    check = zx_IntY_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zx_AvrY_zyx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = zx_Ans,                                              &
    check = zx_AvrY_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  z_Ans = 0.0D0
  call AssertEqual(&
    message='z_IntYX_zyx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = z_Ans,                                               &
    check = z_IntYX_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='z_AvrYX_zyx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = z_Ans,                                               &
    check = z_AvrYX_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_Ans = 0.0D0
  call AssertEqual(&
    message='y_IntZX_zyx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = y_Ans,                                               &
    check = y_IntZX_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='y_AvrZX_zyx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = y_Ans,                                               &
    check = y_AvrZX_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Ans = 0.0D0
  call AssertEqual(&
    message='x_IntZY_zyx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = x_Ans,                                               &
    check = x_IntZY_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='x_AvrZY_zyx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = x_Ans,                                               &
    check = x_AvrZY_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zyx_Data = (1 - sin(pi*zyx_X)) * cos(pi*zyx_Y)**2 * sin(pi*zyx_Z)**2

  Ans = 2.0D0
  call AssertEqual(&
    message='IntZYX_zyx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',      &
    answer = Ans,                                                 &
    check = IntZYX_zyx(zyx_Data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 0.25D0
  call AssertEqual(&
    message='AvrZYX_yx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',       &
    answer = Ans,                                                 &
    check = AvrZYX_zyx(zyx_Data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Ans = (1 - sin(pi*yx_X)) * cos(pi*yx_Y)**2 
  call AssertEqual(&
    message='yx_IntZ_zyx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = yx_Ans,                                              &
    check = yx_IntZ_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  yx_Ans = (1 - sin(pi*yx_X)) * cos(pi*yx_Y)**2/2.0D0
  call AssertEqual(&
    message='yx_AvrZ_zyx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = yx_Ans,                                              &
    check = yx_AvrZ_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zy_Ans = 2*cos(pi*zy_Y)**2 * sin(pi*zy_Z)**2
  call AssertEqual(&
    message='zy_IntX_zyx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = zy_Ans,                                              &
    check = zy_IntX_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zy_Ans = cos(pi*zy_Y)**2 * sin(pi*zy_Z)**2
  call AssertEqual(&
    message='zy_AvrX_zyx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = zy_Ans,                                              &
    check = zy_AvrX_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zx_Ans = (1 - sin(pi*zx_X)) *  sin(pi*zx_Z)**2
  call AssertEqual(&
    message='zx_IntY_zyx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = zx_Ans,                                              &
    check = zx_IntY_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zx_Ans = (1 - sin(pi*zx_X)) *  sin(pi*zx_Z)**2/2.0D0
  call AssertEqual(&
    message='zx_AvrY_zyx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = zx_Ans,                                              &
    check = zx_AvrY_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  z_Ans = 2*sin(pi*z_Z)**2
  call AssertEqual(&
    message='z_IntYX_zyx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = z_Ans,                                               &
    check = z_IntYX_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  z_Ans = sin(pi*z_Z)**2/2.0D0
  call AssertEqual(&
    message='z_AvrYX_zyx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = z_Ans,                                               &
    check = z_AvrYX_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_Ans = 2*cos(pi*y_Y)**2
  call AssertEqual(&
    message='y_IntZX_zyx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = y_Ans,                                               &
    check = y_IntZX_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  y_Ans = cos(pi*y_Y)**2/2.0D0
  call AssertEqual(&
    message='y_AvrZX_zyx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = y_Ans,                                               &
    check = y_AvrZX_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Ans = 1 - sin(pi*x_X)
  call AssertEqual(&
    message='x_IntZY_zyx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = x_Ans,                                               &
    check = x_IntZY_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  x_Ans = (1 - sin(pi*x_X))/4.0D0
  call AssertEqual(&
    message='x_AvrZY_zyx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = x_Ans,                                               &
    check = x_AvrZY_zyx(zyx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !------------------- 2 次元関数チェック ----------------------
  ! YX データ

  yx_Data = sin(pi*yx_X) * cos(pi*yx_Y)

  Ans = 0.0D0
  call AssertEqual(&
    message='IntYX_yx with sin(pi*X)*cos(pi*Y)',                  &
    answer = Ans,                                                 &
    check = IntYX_yx(yx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='AvrYX_yx with sin(pi*X)*cos(pi*Y)',                  &
    answer = Ans,                                                 &
    check = AvrYX_yx(yx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_Ans = 0.0D0
  call AssertEqual(&
    message='y_IntX_yx with sin(pi*X)*cos(pi*Y)',                 &
    answer = y_Ans,                                               &
    check = y_IntX_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='y_AvrX_yx with sin(pi*X)*cos(pi*Y)',                 &
    answer = y_Ans,                                               &
    check = y_AvrX_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Ans = 0.0D0
  call AssertEqual(&
    message='x_IntY_yx with sin(pi*X)*cos(pi*Y)',                 &
    answer = x_Ans,                                               &
    check = x_IntY_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='x_AvrY_yx with sin(pi*X)*cos(pi*Y)',                 &
    answer = x_Ans,                                               &
    check = x_AvrY_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  yx_Data = (1 - sin(pi*yx_X)) * cos(pi*yx_Y)**2

  Ans = 2.0D0
  call AssertEqual(&
    message='IntYX_yx with (1-sin(pi*X)) * cos(pi*Y)**2',         &
    answer = Ans,                                                 &
    check = IntYX_yx(yx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 0.5D0
  call AssertEqual(&
    message='AvrYX_yx with (1-sin(pi*X)) * cos(pi*Y)**2',         &
    answer = Ans,                                                 &
    check = AvrYX_yx(yx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_Ans = 2*cos(pi*y_Y)**2
  call AssertEqual(&
    message='y_IntX_yx with (1-sin(pi*X)) * cos(pi*Y)**2',        &
    answer = y_Ans,                                               &
    check = y_IntX_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  y_Ans = cos(pi*y_Y)**2
  call AssertEqual(&
    message='y_AvrX_yx with (1-sin(pi*X)) * cos(pi*Y)**2',        &
    answer = y_Ans,                                               &
    check = y_AvrX_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Ans = 1 - sin(pi*x_X)
  call AssertEqual(&
    message='x_IntY_yx with (1-sin(pi*X)) * cos(pi*Y)**2',        &
    answer = x_Ans,                                               &
    check = x_IntY_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  x_Ans = 0.5*(1 - sin(pi*x_X))
  call AssertEqual(&
    message='x_AvrY_yx with (1-sin(pi*X)) * cos(pi*Y)**2',        &
    answer = x_Ans,                                               &
    check = x_AvrY_yx(yx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ! ZY データ
  zy_Data = sin(pi*zy_Z) * cos(pi*zy_Y)

  Ans = 0.0D0
  call AssertEqual(&
    message='IntZY_zy with sin(pi*Z)*cos(pi*Y)',                  &
    answer = Ans,                                                 &
    check = IntZY_zy(zy_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='AvrZY_zy with sin(pi*Z)*cos(pi*Y)',                  &
    answer = Ans,                                                 &
    check = AvrZY_zy(zy_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_Ans = 0.0D0
  call AssertEqual(&
    message='y_IntX_zy with sin(pi*Z)*cos(pi*Y)',                 &
    answer = y_Ans,                                               &
    check = y_IntZ_zy(zy_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='y_AvrZ_zy with sin(pi*Z)*cos(pi*Y)',                 &
    answer = y_Ans,                                               &
    check = y_AvrZ_zy(zy_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  z_Ans = 0.0D0
  call AssertEqual(&
    message='z_IntY_zy with sin(pi*Z)*cos(pi*Y)',                 &
    answer = z_Ans,                                               &
    check = z_IntY_zy(zy_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='z_AvrY_zy with sin(pi*Z)*cos(pi*Y)',                 &
    answer = z_Ans,                                               &
    check = z_AvrY_zy(zy_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zy_Data = (1 - sin(pi*zy_Z)) * cos(pi*zy_Y)**2

  Ans = 2.0D0
  call AssertEqual(&
    message='IntZY_zy with (1-sin(pi*Z)) * cos(pi*Y)**2',         &
    answer = Ans,                                                 &
    check = IntZY_zy(zy_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 0.5D0
  call AssertEqual(&
    message='AvrZY_zy with (1-sin(pi*Z)) * cos(pi*Y)**2',         &
    answer = Ans,                                                 &
    check = AvrZY_zy(zy_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_Ans = 2*cos(pi*y_Y)**2
  call AssertEqual(&
    message='y_IntZ_zy with (1-sin(pi*Z)) * cos(pi*Y)**2',        &
    answer = y_Ans,                                               &
    check = y_IntZ_zy(zy_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  y_Ans = cos(pi*y_Y)**2
  call AssertEqual(&
    message='y_AvrZ_zy with (1-sin(pi*Z)) * cos(pi*Y)**2',        &
    answer = y_Ans,                                               &
    check = y_AvrZ_zy(zy_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  z_Ans = 1 - sin(pi*z_Z)
  call AssertEqual(&
    message='z_IntY_zy with (1-sin(pi*Z)) * cos(pi*Y)**2',        &
    answer = z_Ans,                                               &
    check = z_IntY_zy(zy_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  z_Ans = 0.5*(1 - sin(pi*z_Z))
  call AssertEqual(&
    message='z_AvrY_zy with (1-sin(pi*Z)) * cos(pi*Y)**2',        &
    answer = z_Ans,                                               &
    check = z_AvrY_zy(zy_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ! ZX データ
  zx_Data = sin(pi*zx_Z) * cos(pi*zx_X)

  Ans = 0.0D0
  call AssertEqual(&
    message='IntZX_zx with sin(pi*Z)*cos(pi*X)',                  &
    answer = Ans,                                                 &
    check = IntZX_zx(zx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='AvrZX_zx with sin(pi*Z)*cos(pi*X)',                  &
    answer = Ans,                                                 &
    check = AvrZX_zx(zx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Ans = 0.0D0
  call AssertEqual(&
    message='x_IntZ_zx with sin(pi*Z)*cos(pi*X)',                 &
    answer = x_Ans,                                               &
    check = x_IntZ_zx(zx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='x_AvrZ_zx with sin(pi*Z)*cos(pi*X)',                 &
    answer = x_Ans,                                               &
    check = x_AvrZ_zx(zx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  z_Ans = 0.0D0
  call AssertEqual(&
    message='z_IntX_zx with sin(pi*Z)*cos(pi*X)',                 &
    answer = z_Ans,                                               &
    check = z_IntX_zx(zx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='z_AvrX_zx with sin(pi*Z)*cos(pi*X)',                 &
    answer = z_Ans,                                               &
    check = z_AvrX_zx(zx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zx_Data = (1 - sin(pi*zx_Z)) * cos(pi*zx_X)**2

  Ans = 2.0D0
  call AssertEqual(&
    message='IntZX_zx with (1-sin(pi*Z)) * cos(pi*X)**2',         &
    answer = Ans,                                                 &
    check = IntZX_zx(zx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 0.5D0
  call AssertEqual(&
    message='AvrZX_zx with (1-sin(pi*Z)) * cos(pi*X)**2',         &
    answer = Ans,                                                 &
    check = AvrZX_zx(zx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Ans = 2*cos(pi*x_X)**2
  call AssertEqual(&
    message='x_IntZ_zx with (1-sin(pi*Z)) * cos(pi*X)**2',        &
    answer = x_Ans,                                               &
    check = x_IntZ_zx(zx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  x_Ans = cos(pi*x_X)**2
  call AssertEqual(&
    message='x_AvrZ_zx with (1-sin(pi*Z)) * cos(pi*X)**2',        &
    answer = x_Ans,                                               &
    check = x_AvrZ_zx(zx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  z_Ans = 1 - sin(pi*z_Z)
  call AssertEqual(&
    message='z_IntX_zx with (1-sin(pi*Z)) * cos(pi*X)**2',        &
    answer = z_Ans,                                               &
    check = z_IntX_zx(zx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  z_Ans = 0.5*(1 - sin(pi*z_Z))
  call AssertEqual(&
    message='z_AvrX_zx with (1-sin(pi*Z)) * cos(pi*X)**2',        &
    answer = z_Ans,                                               &
    check = z_AvrX_zx(zx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !------------------- 1 次元関数チェック ----------------------
  x_Data = 1 - sin(2*pi*x_X)

  Ans = 2.0D0
  call AssertEqual(&
    message='IntX_x with 1-sin(2*pi*X)',                          &
    answer = Ans,                                                 &
    check = IntX_x(x_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 1.0D0
  call AssertEqual(&
    message='AvrX_x with 1-sin(2*pi*X)',                          &
    answer = Ans,                                                 &
    check = AvrX_x(x_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_Data = cos(pi*y_Y)**2

  Ans = 1.0D0
  call AssertEqual(&
    message='IntY_y with cos(pi*X)**2',                           &
    answer = Ans,                                                 &
    check = IntY_y(y_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 0.5D0
  call AssertEqual(&
    message='AvrY_y with cos(pi*X)**2',                           &
    answer = Ans,                                                 &
    check = AvrY_y(y_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  z_Data = sin(pi*z_Z)**2

  Ans = 1.0D0
  call AssertEqual(&
    message='IntZ_z with sin(pi*Z)**2',                           &
    answer = Ans,                                                 &
    check = IntZ_z(z_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !------------------- 1 次元関数チェック ----------------------
  x_Data = 1 - sin(2*pi*x_X)

  Ans = 2.0D0
  call AssertEqual(&
    message='IntX_x with 1-sin(2*pi*X)',                          &
    answer = Ans,                                                 &
    check = IntX_x(x_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 1.0D0
  call AssertEqual(&
    message='AvrX_x with 1-sin(2*pi*X)',                          &
    answer = Ans,                                                 &
    check = AvrX_x(x_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  y_Data = cos(pi*y_Y)**2

  Ans = 1.0D0
  call AssertEqual(&
    message='IntY_y with cos(pi*X)**2',                           &
    answer = Ans,                                                 &
    check = IntY_y(y_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 0.5D0
  call AssertEqual(&
    message='AvrY_y with cos(pi*X)**2',                           &
    answer = Ans,                                                 &
    check = AvrY_y(y_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  z_Data = sin(pi*z_Z)**2

  Ans = 1.0D0
  call AssertEqual(&
    message='IntZ_z with sin(pi*Z)**2',                           &
    answer = Ans,                                                 &
    check = IntZ_z(z_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 0.5D0
  call AssertEqual(&
    message='AvrZ_z with sin(pi*Z)**2',                           &
    answer = Ans,                                                 &
    check = AvrZ_z(z_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','tee_module_fftj_integral_test', &
       'tee_module_fftj integral and average functions tests succeeded')

end program tee_module_fftj_integral_test

!------------------------------------------------------------------------
! Copyright (c) 2011 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  eea_module_fftj テストプログラム (微分計算)
!
!履歴  2011/12/10  竹広真一
!
program eea_module_fftj_derivative_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use eea_module_fftj
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yxa_Data(0:jm-1,0:im-1,2)    ! 格子データ
  real(8)            :: yxa_Deriv(0:jm-1,0:im-1,2)   ! 格子データ

  integer            :: k=2, l=3

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8), parameter :: pi=3.1415926535897932385D0

  call MessageNotify('M','eea_module_fftj_derivative_test', &
       'eea_module_fftj derivative function tests')

 !---------------- 座標値の設定 ---------------------
  call eea_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
  yxa_Data(:,:,1) = sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  yxa_Data(:,:,2) = cos(k*pi*yx_X) * cos(l*pi*yx_Y)

  yxa_Deriv(:,:,1) = k*pi*cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  yxa_Deriv(:,:,2) = -k*pi*sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  call check3d(yxa_eea(eea_Dx_eea(eea_yxa(yxa_Data))), &
    yxa_Deriv, 'Dx(sin(k*pi*X)*sin(l*pi*Y)),Dx(cos(k*pi*X)*cos(l*pi*Y))')

  yxa_Deriv(:,:,1) = l*pi*sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  yxa_Deriv(:,:,2) = -l*pi*cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check3d(yxa_eea(eea_Dy_eea(eea_yxa(yxa_Data))), &
    yxa_Deriv, 'Dy(sin(k*pi*X)*sin(l*pi*Y)),Dy(cos(k*pi*X)*cos(l*pi*Y)')

  yxa_Deriv(:,:,1) = -((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  yxa_Deriv(:,:,2) = -((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call check3d(yxa_eea(eea_Lapla_eea(eea_yxa(yxa_Data))), &
    yxa_Deriv, 'Lapla(sin(k*pi*X)*sin(l*pi*Y)),Lapla(cos(k*pi*X)*cos(l*pi*Y))')

  yxa_Deriv(:,:,1) = -1.0/((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  yxa_Deriv(:,:,2) = -1.0/((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call check3d(yxa_eea(eea_LaplaInv_eea(eea_yxa(yxa_Data))), &
    yxa_Deriv, 'LaplaInv(sin(k*pi*X)*sin(l*pi*Y)),LaplaInv(cos(k*pi*X)*cos(l*pi*Y))')


  yxa_Data(:,:,1) = sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  yxa_Data(:,:,2) = cos(k*pi*yx_X) * sin(l*pi*yx_Y)

  yxa_Deriv(:,:,1) = k*pi*cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  yxa_Deriv(:,:,2) = -k*pi*sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check3d(yxa_eea(eea_Dx_eea(eea_yxa(yxa_Data))), &
    yxa_Deriv, 'Dx(sin(k*pi*X)*cos(l*pi*Y)),Dx(cos(k*pi*X)*sin(l*pi*Y))')

  yxa_Deriv(:,:,1) = -l*pi*sin(k*pi*yx_X) * sin(l*pi*yx_Y)
  yxa_Deriv(:,:,2) = l*pi*cos(k*pi*yx_X) * cos(l*pi*yx_Y)
  call check3d(yxa_eea(eea_Dy_eea(eea_yxa(yxa_Data))), &
    yxa_Deriv, 'Dy(sin(k*pi*X)*cos(l*pi*Y)),Dy(cos(k*pi*X)*sin(l*pi*Y))')

  yxa_Deriv(:,:,1) = -((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  yxa_Deriv(:,:,2) = -((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check3d(yxa_eea(eea_Lapla_eea(eea_yxa(yxa_Data))), &
    yxa_Deriv, 'Lapla(sin(k*pi*X)*cos(l*pi*Y)),Lapla(cos(k*pi*X)*sin(l*pi*Y))')

  yxa_Deriv(:,:,1) = -1.0/((k*pi)**2 + (l*pi)**2) * sin(k*pi*yx_X) * cos(l*pi*yx_Y)
  yxa_Deriv(:,:,2) = -1.0/((k*pi)**2 + (l*pi)**2) * cos(k*pi*yx_X) * sin(l*pi*yx_Y)
  call check3d(yxa_eea(eea_LaplaInv_eea(eea_yxa(yxa_Data))), &
    yxa_Deriv, 'LaplaInv(sin(k*pi*X)*cos(l*pi*Y)),LaplaInv(cos(k*pi*X)*sin(l*pi*Y))')

  call MessageNotify('M','eea_module_fftj_derivative_test', &
       'eea_module_fftj derivative function tests succeeded!')

contains

  subroutine check3d(var,sol,funcname)
    real(8) :: var(:,:,:)                ! 判定する配列
    real(8) :: sol(:,:,:)                ! 解析解
    character(len=*) :: funcname         ! 関数名

    call AssertEqual(     &
      message = funcname, &
      answer = sol,       &
      check = var,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check3d

end program eea_module_fftj_derivative_test

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wa_spectrum_module_supack テストプログラム :: スペクトル関数のテスト
!
!履歴  2016/03/16  竹広真一 wa_spectrum_mpi_module_test.f90 より改造
!
program wa_spectrum_mpi_module_supack_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wa_mpi_module_supack
  use mpi
  implicit none

  integer, parameter :: im=64, jm=32, nm=21, km=2

  real(8), allocatable ::  wa_data(:,:)
  real(8), allocatable ::  xva_data(:,:,:)

  real(8), dimension(0:nm,-nm:nm,km) ::  nma_data
  real(8), dimension(0:nm,km)        ::  na_data
  real(8), dimension(km)             ::  a_data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer :: n,m
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call wa_mpi_Initial( nm, im, jm, km )

  allocate(wa_data(nc,km))
  allocate(xva_data(0:im-1,1:jc,km))

  call MessageNotify('M','wa_spectrum_mpi_module_supack_test',&
                         'wa_spectrum_module_supack functions tests.') 

  ! 2Y_1^0+3Y_2^1
  xva_data(:,:,1) = 2*sqrt(3.0D0)*sin(xv_Lat) &
                + 3*sqrt(5.0D0/6)*3.0*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)!
  ! 3*Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2
  xva_data(:,:,2) = 3*sqrt(3.0D0)*sin(xv_Lat) & 
                + 2* sqrt(3.0D0/2)*cos(xv_Lat)*cos(xv_Lon) &
                + 2*sqrt(5.0D0)*(3.0/2*sin(xv_Lat)**2-1/2.0) &
                - sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*sin(2*xv_Lon)

  wa_data = wa_xva(xva_data)

  !--------- Energy spectrum ---------
  nma_data=wa_spectrum_VMiss

  do n=0,nm
     do m=-n,n
        nma_data(n,m,:) = 0.0D0
     enddo
  enddo

  nma_data(1,0,1) = 4.0D0
  nma_data(2,1,1) = 2*3*(3.0D0/2)**2/2
  nma_data(2,-1,1)= nma_data(2,1,1)
  nma_data(1,0,2) = 9.0D0
  nma_data(1,1,2) = 1*2*(2/2)**2/2
  nma_data(1,-1,2)= nma_data(1,1,2)
  nma_data(2,0,2) = 12.0D0 
  nma_data(2,-2,2)= 2*3*(1.0D0/2)**2/2
  nma_data(2,2,2) = nma_data(2,-2,2)

  call AssertEqual(&
    message='nma_EnergyFromStreamfunc_wa',                        &
    answer = nma_EnergyFromStreamfunc_wa(wa_data),                &
    check =  nma_data,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  na_data = 0.0D0
  na_data(1,1) = 4.0D0
  na_data(2,1) = 2 * 3 *(3.0D0/2)**2
  na_data(1,2) = 9.0D0 + 1*2*(2/2)**2
  na_data(2,2) = 12.0D0 + 2*3*(1.0D0/2)**2

  call AssertEqual(&
    message='na_EnergyFromStreamfunc_wa',                         &
    answer = na_EnergyFromStreamfunc_wa(wa_data),                 &
    check =  na_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nma_Data = nma_EnergyFromStreamfunc_wa(wa_data)
  a_data = 0.0D0
  do n=0,nm
     do m=-n,n
        a_data = a_data + nma_Data(n,m,:)
     enddo
  enddo

  call AssertEqual(&
    message='total energy by nm-spectrum',                        &
    answer = a_AvrLonLat_xva(                                     &
    0.5*(xva_GradLon_wa(wa_data)**2+xva_GradLat_wa(wa_data)**2) ),&
    check = a_data,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  a_data = a_AvrLonLat_xva( 0.5*(xva_GradLon_wa(wa_data)**2+xva_GradLat_wa(wa_data)**2) )
  call AssertEqual(&
    message='total energy with n-spectrum',                       &
    answer = sum(na_EnergyFromStreamfunc_wa(wa_data),1),          &
    check =  a_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !--------- Enstrophy spectrum ---------
  nma_data=wa_spectrum_VMiss
  do n=0,nm
     do m=-n,n
        nma_data(n,m,:) = 0.0D0
     enddo
  enddo

  nma_data(1,0,1) = 8.0D0
  nma_data(2,1,1) = 2**2*3**2*(3.0D0/2)**2/2
  nma_data(2,-1,1) = nma_data(2,1,1) 

  nma_data(1,0,2)  = 18.0D0
  nma_data(1,1,2)  = 1**2 * 2**2 * (2/2)**2 / 2
  nma_data(1,-1,2) = nma_data(1,1,2)
  nma_data(2,0,2)  = 72.0D0
  nma_data(2,-2,2) = 2**2 * 3**2 * (1.0D0/2)**2 /2
  nma_data(2,2,2)  = nma_data(2,-2,2)

  call AssertEqual(&
    message='nma_EnstrophyFromStreamfunc_wa',                     &
    answer = nma_EnstrophyFromStreamfunc_wa(wa_data),             &
    check =  nma_data,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  na_data = 0.0
  na_data(1,1) = 8.0D0  ;   na_data(2,1) = 2**2*3**2*(3.0D0/2)**2
  na_data(1,2) = 18.0D0 + 1**2 * 2**2 * (2/2)**2
  na_data(2,2) = 72.0D0 + 2**2 * 3**2 * (1.0D0/2)**2

  call AssertEqual(&
    message='na_EnstrophyFromStreamfunc_wa',                      &
    answer = na_EnstrophyFromStreamfunc_wa(wa_data),              &
    check =  na_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nma_Data = nma_EnstrophyFromStreamfunc_wa(wa_data)
  a_data = 0.0D0
  do n=0,nm
     do m=-n,n
        a_data = a_data + nma_Data(n,m,:)
     enddo
  enddo

  call AssertEqual(&
    message='total enstrophy by nm-spectrum',                     &
    answer = a_AvrLonLat_xva( 0.5*(xva_wa(wa_Lapla_wa(wa_data))**2)),&
    check = a_data,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  a_data = a_AvrLonLat_xva( 0.5*(xva_wa(wa_Lapla_wa(wa_data))**2))

  call AssertEqual(&
    message='total energy with n-spectrum',                       &
    answer = sum(na_EnstrophyFromStreamfunc_wa(wa_data),1),       &
    check =  a_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wa_spectrum_mpi_module_supack_test', &
                     'wa_spectrum_module_supack tests succeeded!') 

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wa_spectrum_mpi_module_supack_test

!------------------------------------------------------------------------
! Copyright (c) 2005-2011 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  ee_module テストプログラム (ヤコビアン計算)
!
!履歴  2005/07/19  竹広真一
!      2007/11/09  竹広真一  エラーメッセージ追加
!      2011/02/15  佐々木洋平 dc_test を使うように変更
!
program ee_test_jacobian

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=16, jm=16            ! 格子点の設定(X,Y)
  integer, parameter :: km=5, lm=5              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_A(0:jm-1,0:im-1)     ! 格子データ
  real(8)            :: yx_B(0:jm-1,0:im-1)     ! 格子データ
  real(8)            :: yx_Jacob(0:jm-1,0:im-1)  ! 格子データ

  integer            :: k=4,l=2

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','ee_test_jacobian', &
       'ee_module jacobian function tests')

 !---------------- 座標値の設定 ---------------------
  call ee_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------

!!$  write(6,*) '  Input wavenumbers of the grid data, k and l :'
!!$  read(5,*) k,l
!!$  write(6,*) '  k,l = ', k,l

  yx_A = sin(k*pi*yx_X)
  yx_B = sin(l*pi*yx_Y)
  yx_Jacob = k*pi*cos(k*pi*yx_X) * l*pi*cos(l*pi*yx_Y)

  call check2d(yx_ee(ee_Jacobian_ee_ee(ee_yx(yx_A),ee_yx(yx_B))), yx_Jacob, &
    'Jacob(sin(k*pi*X),sin(l*pi*Y))')

  yx_A = cos(k*pi*yx_X)
  yx_B = cos(l*pi*yx_Y)
  yx_Jacob = k*pi*sin(k*pi*yx_X) * l*pi*sin(l*pi*yx_Y)

  call check2d(yx_ee(ee_Jacobian_ee_ee(ee_yx(yx_A),ee_yx(yx_B))), yx_Jacob, &
    'Jacob(cos(k*pi*X),cos(l*pi*Y))')

  yx_A = sin(k*pi*yx_X)
  yx_B = cos(l*pi*yx_Y)
  yx_Jacob = - k*pi*cos(k*pi*yx_X) * l*pi*sin(l*pi*yx_Y)

  call check2d(yx_ee(ee_Jacobian_ee_ee(ee_yx(yx_A),ee_yx(yx_B))), yx_Jacob, &
    'Jacob(sin(k*pi*X),cos(l*pi*Y))')

  yx_A = cos(k*pi*yx_X)
  yx_B = sin(l*pi*yx_Y)
  yx_Jacob = - k*pi*sin(k*pi*yx_X) * l*pi*cos(l*pi*yx_Y)

  call check2d(yx_ee(ee_Jacobian_ee_ee(ee_yx(yx_A),ee_yx(yx_B))), yx_Jacob, &
    'Jacob(cos(k*pi*X),sin(l*pi*Y))')

  call MessageNotify('M','ee_test_derivative', &
       'ee_module jacobian function tests succeeded!')

contains

  subroutine check2d(var,sol,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:)                ! 判定する配列
    real(8) :: sol(:,:)
    character(len=*) :: funcname

    call AssertEqual(     &
      message = funcname, &
      answer = sol,       &
      check = var,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check2d

end program ee_test_jacobian

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_plane_module テストプログラム :: 補間関数のテスト
!
!履歴  2016/01/01  竹広真一
!
program w_plane_module_Interpolate_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_plane_module
  implicit none

  integer, parameter :: im=128, jm=64, nm=42
  real(8), parameter :: Radius = 1.0D0

  real(8), parameter :: sigma = 5.0D-1
  integer :: m
  
  real(8), dimension(0:im-1,1:jm)   ::  ps_data
  real(8) :: pi

  real(8)  ::  xval = 2.0D-1
  real(8)  ::  yval = 3.5D-1
  real(8)  ::  sval
  real(8)  ::  pval
  real(8)  ::  answer
  
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','w_plane_module', &
                         'w_plane_module interpolate functions tests') 

  call w_plane_Initial( nm, im, jm, radius )

  do m=0,2
  
     ps_data = exp( -ps_S**2/sigma**2 ) * sin( m * ps_Phi ) * ps_S**m

     sval = sqrt(xval**2 + yval**2)
     pval = atan(yval/xval)
     answer = exp( -sval**2/sigma**2 ) * sin( m * pval ) * sval**m

     !---- 補間変換 ----
     call AssertEqual(&
          message='Test of InterpolateOnXY_w',                          &
          answer = answer,                                              &
          check = InterpolateOnXY_w(w_ps(ps_data),xval,yval),           &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

  
  enddo
  
end program w_plane_module_Interpolate_test

!--
!----------------------------------------------------------------------
!     Copyright (c) 2011 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  複素固有値問題サブルーチン (SSL2)
!
!履歴  2011/11/05  竹広真一
!
!++
module ssl2_ceigen
  !
  != ssl2_ceigen
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id: 
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  ! 
  !== 概要
  !
  ! spml/ssl2_ceigen は eigmatrix モジュールの公開サブルーチン ceigen
  ! 用の固有値計算用共通インターフェースを与える.
  !
  !   * 行列 CMAT の i 番目固有値を eigen(i) に格納
  !   * 対応する固有ベクトルを eigvec(:,i) に格納
  !   * 格納する固有値の数は引数 eigen の大きさで決まる
  !   * 固有値の順番は sort と order で定められる. 
  !   * sort によって順番を定めるために用いる量を指定する. 
  !     実部(R), 実部の絶対値(RA), 虚部(I), 虚部の絶対値(IA)
  !   * reverse によって小さい順(.false.), 大きい順(.true.)を指定できる.
  !   * デフォルトは sort='R', reverse=.false.
  !   * 行列 CMAT は保存されない.
  !
  ! 内部では DCEIG2/SSL2 ルーチンによる複素行列の固有値/固有ベクトル計算を
  ! 行っている. が, ユーザーは用いているライブラリとサブルーチンを意識
  ! することなく使うことができる. 
  use dc_message, only : MessageNotify

  implicit none
  private
  public dceig2_ssl2

contains
  subroutine dceig2_ssl2(cmat,eigen,eigvec,info,sort,reverse)
    !
    ! このサブルーチンは固有値計算用共通インターフェースを与える
    ! eigmatrix モジュールの公開サブルーチン ceigen として用いられる. 
    !
    !   * 行列 CMAT の i 番目固有値を eigen(i) に格納
    !   * 対応する固有ベクトルを eigvec(:,i) に格納
    !   * 格納する固有値の数は引数 eigen の大きさで決まる
    !   * 固有値の順番は sort と order で定められる. 
    !   * sort によって順番を定めるために用いる量を指定する. 
    !     実部(R), 実部の絶対値(RA), 虚部(I), 虚部の絶対値(IA)
    !   * reverse によって小さい順(.false.), 大きい順(.true.)を指定できる.
    !   * デフォルトは sort='R', reverse=.false.
    !   * 行列 CMAT は保存されない.
    !
    ! 内部では DCEIG2/SSL2 ルーチンによる複素行列の固有値/固有ベクトル計算を
    ! 行っている. が, ユーザーは用いているライブラリとサブルーチンを意識
    ! することなく使うことができる. 
    !
    interface 
       function indexx(arrin)
         implicit none
         real(8), dimension(:), intent(in)  :: arrin
         integer, dimension(size(arrin))    :: indexx
       end function indexx
    end interface

   !------------ 引数 ------------
    complex(8), dimension(:,:)                :: cmat      ! 入力正方行列
    complex(8), intent(out), dimension(:)     :: eigen     ! 固有値実数部
    complex(8), intent(out), &
      dimension(size(cmat,1),size(eigen))     :: eigvec    ! 固有ベクトル実部
    integer, intent(out)                      :: info      ! ステータス
    character(len=2), intent(in), optional    :: sort      ! 並び変えの量
    logical, intent(in), optional             :: reverse   ! 並び変えスイッチ

   !------------ 作業変数 ------------
    complex(8), dimension(size(cmat,1))              :: ceig  ! 固有値
    complex(8), dimension(size(cmat,1),size(cmat,1)) :: cvec  ! 固有ベクトル
    real(8), dimension(size(cmat,1))                 :: vw    ! 作業変数
    integer, dimension(size(cmat,1))                 :: ivw   ! 作業変数
    integer, dimension(size(cmat,1))                 :: index ! 並び変え用
    integer, parameter :: mode=0   ! DCEIG1へ渡すスイッチ(平衡化省略)

    integer :: nm, i, j

    !------- 形状チェック ------
    if (size(cmat,1) /= size(cmat,2))then
       call MessageNotify('E','DCEIG2_SSL2','Input matrix not square')
    else
       nm = size(cmat,1)
    endif

    !------- DCEIG2/SSL2 による計算 ------
    call dceig2(cmat,nm,nm,mode,ceig,cvec,vw,ivw,info)

    !------- サブルーチンエラー処理 -------
    if ( info /= 0 ) then
       call MessageNotify('W','DCEIG2_SSL2',&
            'Error in calculating eigenvalues/vectors...',i=(/info/) )
       return
    endif

    !------- 固有ベクトル入れ換え -------
    if ( present(sort) ) then
       if ( sort == 'RA' ) then          ! 固有値実部の絶対値
          index=indexx(abs(dble(ceig)))
       elseif ( trim(sort) == 'I' ) then ! 固有値虚部
          index=indexx(aimag(ceig))
       elseif ( sort == 'IA' ) then      ! 固有値虚部の絶対値
          index=indexx(abs(aimag(ceig)))
       else
          index=indexx(dble(ceig))       ! defaultは固有値実部
       endif
    else
       index=indexx(dble(ceig))          ! defaultは固有値実部
    endif

    if ( present(reverse) )then
       if ( reverse ) then               ! 大きい順
          index=index(size(index):1:-1)
       endif
    endif

    do i=1,size(eigen)
       j = index(i)
       eigen(i) = ceig(j)
       eigvec(:,i) = cvec(:,j)
    enddo

  end subroutine dceig2_ssl2

end module ssl2_ceigen

!--
!----------------------------------------------------------------------
! Copyright (c) 2016 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ee_mpi_module
!
!      spml/ee_module モジュールは周期境界条件の下での 2 次元矩形領域の
!      流体運動をスペクトル法により数値計算するための Fortran90 関数を
!      提供する. 
!
!      内部で ISPACK/FTPACKI の Fortran77 サブルーチンを呼んでいる.
!      スペクトルデータおよび格子点データの格納方法については...
!
!履歴  2016/08/08  竹広真一  eee_mpi_module より改造
!      2016/09/22  竹広真一  ef_Lapla_ef, ef_Laplainv_ef 初期化
!
!++
module ee_mpi_module
  !
  != ee_mpi_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/ee_module モジュールは周期境界条件の下での 2 次元矩形領域の
  ! 流体運動をスペクトル法により数値計算するための Fortran90 関数を
  ! 提供する. 
  !
  ! 内部で ISPACK/FTPACKI の Fortran77 サブルーチンを呼んでいる.
  ! スペクトルデータおよび格子点データの格納方法については...
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (ef_, vx_, x_, v_) は, 返す値の形を示している.
  !   ef_ :: スペクトルデータ
  !           (第 1,2 次元がそれぞれ Y,X 方向波数(X について分割配置))
  !   vx_  :: XY 方向 2 次元格子点データ(Y について分散配置
  !   x_   :: X 方向 1 次元格子点データ
  !   v_   :: Y 方向 1 次元格子点データ(分散配置)
  !
  ! * 関数名の間の文字列(Dx, Dy, Lapla, LaplaInv)は,
  !   その関数の作用を表している.
  !
  ! * 関数名の最後 (_ef_ef,_ef,_vx, _x, _v) は, 入力変数の形が
  !   スペクトルデータおよび格子点データであることを示している.
  !    _ef     :: スペクトルデータ
  !    _ef_ef  :: 2 つのスペクトルデータ
  !    _vx     :: 2 次元格子点データ
  !    _x      :: X 方向 1 次元格子点データ
  !    _v      :: Y 方向 1 次元格子点データ
  !
  !=== 各データの種類の説明
  !
  ! * vx : 2 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(,js(ip):je(ip),0:im-1).
  !   * im は X 座標の格子点数であり, サブルーチン ee_mpi_initial にて
  !     Y 方向の全格子点数 jm とともにあらかじめ設定しておく.
  !   * ee_mpi_Initial によってプロセス毎に Y 方向の
  !     分割配置が設定され, その情報が public 変数 js,je,jc に設定される. 
  !   * js が分割配置の最小格子点, je が最大格子点, jc が格子点数である. 
  !
  ! * ef : スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(-lm:lm,2*kc). 
  !   * mm は Y 方向の最大波数であり, サブルーチン ee_mpi_initial にて
  !     X 方向の最大波数 km とともにあらかじめ設定しておく. 
  !     (X, Y 方向波数の順ではない)ことに注意. 
  !   * ee_mpi_Initial によってプロセス毎に X 方向波数の
  !     分割配置が設定され, その情報が public 変数 ls,le,lc に設定される. 
  !   * ks が分割配置の最小波数, ke が最大波数, kc が波数の数である. 
  !     実際の格納のされ方は ks, ks+1,...,ke,-ke,-ke+1,...,-ks の順である.
  !   * 分割配置される前のスペクトルデータの格納のされかたは IPSACK の
  !     P2PACK に基づく. 
  !       ee_S( L, K) : s_{kl} の実部
  !       ee_S(-L,-K) : s_{kl} の虚部
  !       ee_S(-L, K) : s_{k(-l)} の実部
  !       ee_S( L,-K) : s_{k(-l)} の虚部
  !       ee_S( L, 0) : s_{0l} の実部
  !       ee_S(-L, 0) : s_{0l} の虚部
  !       ee_S( 0, K) : s_{k0} の実部
  !       ee_S( 0,-K) : s_{k0} の虚部
  !       ee_S( 0, 0) : s_{00} (実数)
  !   * 元の格子点データが実数であるため, s_{-k-l} = s^*_{kl} なる関係がある.
  !     ただし ^* は複素共役を表す. 
  !
  ! * x, v : X, Y 方向 1 次元格子点データ.
  !   * 変数の種類と次元はそれぞれ real(8), dimension(0:im-1),
  !     real(8), dimension(js(ip):je(ip))
  !
  ! * ef_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * vx_ で始まる関数が返す値は 3 次元格子点データに同じ.
  !
  ! * x_, v_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! ee_mpi_Initial :: スペクトル変換の格子点数, 切断波数の設定
  ! kf_k           :: X 方向波数の位置情報
  !
  !==== 座標変数
  !
  ! x_X, v_Y               :: 格子点座標(X,Y座標)を格納した 1 次元配列
  ! x_X_Weight, v_Y_Weight :: 重み座標を格納した 1 次元配列
  ! vx_X, vx_Y_Z           :: 格子点データの XY 座標(X,Y)
  !                           (格子点データ型 3 次元配列)
  !
  !==== 基本変換
  !
  ! vx_ef :: スペクトルデータから格子データへの変換
  ! ef_vx :: 格子データからスペクトルデータへの変換
  ! xy_vx :: 分散格子点データの集積
  ! ee_ef :: 分散スペクトルデータの集積
  ! ef_ee :: 集積スペクトルデータの分散
  !
  !==== 微分
  !
  ! ef_Lapla_ef       :: スペクトルデータにラプラシアンを作用させる
  ! ef_LaplaInv_ef    :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! ef_Dx_ef          :: スペクトルデータに X 微分を作用させる
  ! ef_Dy_ef          :: スペクトルデータに Y 微分を作用させる
  !
  !==== 非線形計算
  !
  ! ef_Joacobian_ef_ef :: 2 つのスペクトルデータからヤコビアンを計算する.
  ! ef_JoacobianZ_ef   :: 渦度スペクトルデータから非発散方程式の非線形項を計算する
  !
  !==== 積分・平均
  !
  ! IntVX_vx,  AvrVX_vx  :: 2 次元(XY)格子点データの X,Y 方向積分および平均
  ! v_IntX_vx, v_AvrX_vx :: 2 次元(XY)格子点データの X 方向積分および平均
  ! x_IntV_vx, x_AvrV_vx :: 2 次元(XY)格子点データの Y 方向積分および平均
  !
  ! IntX_x, AvrX_x       :: 1 次元(X)格子点データの X 方向積分および平均
  ! IntV_v, AvrV_v       :: 1 次元(Y)格子点データの Y 方向積分および平均
  !
  !==== スペクトル解析
  !
  ! ef_EnergyFromStreamfunc_ef    :: 流れ関数からエネルギースペクトルを計算
  ! ef_EnstrophyFromStreamfunc_ef :: 流れ函数からエンストロフィースペクトルを計算
  !
  !==== 補間計算
  !
  ! Interpolate_ef       :: 任意の点の値をスペクトルデータから計算する
  !
  use dc_message, only : MessageNotify
  use mpi
  implicit none

  private
  public ks, ke, kc
  public js, je, jc
  public kf_k
  public ee_mpi_Initial                                 ! 初期化ルーチン
  public vx_ef, ef_vx                                   ! 基本変換
!!$  public xy_vx                                          ! 基本変換
!!$  public ee_ef, ef_ee                                   ! 基本変換
  public ef_Dx_ef, ef_Dy_ef                             ! 微分
  public ef_Lapla_ef, ef_LaplaInv_ef                    ! 微分
  public ef_Jacobian_ef_ef                              ! ヤコビアン
  public ef_JacobianZ_ef                                ! ヤコビアン

  public IntYX_vx,  AvrYX_vx                            ! 積分・平均
  public v_IntX_vx, v_AvrX_vx                           ! 積分・平均
  public x_IntY_vx, x_AvrY_vx                           ! 積分・平均

  public IntX_x, AvrX_x                                 ! 積分・平均
  public IntY_v, AvrY_v                                 ! 積分・平均

  public Interpolate_ef                                 ! 補間

  public x_X, v_Y                                       ! 座標変数
  public x_X_Weight, v_Y_Weight                         ! 座標変数
  public vx_X, vx_Y                                     ! 座標変数

  public ef_EnergyFromStreamfunc_ef                     ! エネルギー
  public ef_EnstrophyFromStreamfunc_ef                  ! エンストロフィー

  integer :: im=32, jm=32                               ! 格子点の設定(X,Y)
  integer :: km=10, lm=10                               ! 切断波数の設定(X,Y)

  integer, dimension(:), allocatable :: ke              ! X 最大波数
  integer, dimension(:), allocatable :: ks              ! X 最小波数
  integer, dimension(:), allocatable :: kc              ! X 波数の数
  integer, dimension(:), allocatable :: je              ! Y 座標最大格子点
  integer, dimension(:), allocatable :: js              ! Y 座標最小格子点
  integer, dimension(:), allocatable :: jc              ! Y 座標格子点数
  integer :: np                                         ! MPI プロセス数
  integer :: ip                                         ! MPI プロセス ID  

  integer, dimension(:), allocatable :: itj             ! FFT 用配列(Y)
  real(8), dimension(:), allocatable :: tj              ! FFT 用配列(Y)
  integer, dimension(:), allocatable :: iti             ! FFT 用配列(X)
  real(8), dimension(:), allocatable :: ti              ! FFT 用配列(X)

  real(8), dimension(:), allocatable :: x_X             ! 格子点座標(X)
  real(8), dimension(:), allocatable :: v_Y             ! 格子点座標(Y)

  real(8), dimension(:), allocatable :: x_X_Weight      ! 格子点重み(X)
  real(8), dimension(:), allocatable :: v_Y_Weight      ! 格子点重み(Y)

  real(8), dimension(:,:), allocatable :: vx_X          ! 格子点(X)座標(2 次元)
  real(8), dimension(:,:), allocatable :: vx_Y          ! 格子点(Y)座標(2 次元)

  real(8) :: xmin, xmax                                 ! X 座標範囲
  real(8) :: ymin, ymax                                 ! Y 座標範囲
  real(8) :: xl, yl                                     ! 領域の大きさ(X,Y)
 
  real(8), parameter  :: pi=3.1415926535897932385D0

  save im, jm, km, lm, itj, tj, iti, ti
  save ks, ke, kc, js, je, jc, np, ip
  save x_X, v_Y, x_X_Weight, v_Y_Weight, vx_X, vx_Y
  save xmin, xmax, ymin, ymax, xl, yl

contains
  !--------------- 初期化 -----------------
  subroutine ee_mpi_Initial(i_in,j_in,k_in,l_in,xmin_in,xmax_in,ymin_in,ymax_in)
    !
    ! スペクトル変換の格子点数, 波数を設定する.
    ! 領域の範囲は [0,2pi]x[0,2pi] に決め打ち
    !
    ! 他の関数や変数を呼ぶ前に, 最初にこのサブルーチンを呼んで
    ! 初期設定をしなければならない.
    !
    integer,intent(in) :: i_in           ! 格子点数(X)
    integer,intent(in) :: j_in           ! 格子点数(Y)
    integer,intent(in) :: k_in           ! 切断波数(X)
    integer,intent(in) :: l_in           ! 切断波数(Y)

    real(8),intent(in) :: xmin_in, xmax_in     ! X 座標範囲
    real(8),intent(in) :: ymin_in, ymax_in     ! Y 座標範囲
 
    integer :: ii, jj
!!$    integer :: kks, kke, kkc, jjs, jje, jjc
    integer :: iip
    integer :: kp, jp
    integer :: kint, kmod
    integer :: ierr

    im = i_in         ; jm = j_in
    km = k_in         ; lm = l_in

    xmin = xmin_in    ; xmax = xmax_in
    ymin = ymin_in    ; ymax = ymax_in
    xl = xmax-xmin    ; yl = ymax-ymin

    CALL MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
    CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

!!$    kp=km/np+1
!!$    kks=kp*ip
!!$    kke=min(kp*(ip+1)-1,km)
!!$    if(kke.ge.kks) then
!!$       kkc=kke-kks+1
!!$    else
!!$       kkc=0 ;  kks=0  ; kke=0
!!$    end if
!!$
!!$    jp=(jm-1)/np+1
!!$    jjs=jp*ip
!!$    jje=min(jp*(ip+1)-1,jm-1)
!!$    if(jje.ge.jjs) then
!!$       jjc=jje-jjs+1
!!$    else
!!$       jjc=0 ; jjs=0 ; jje=0
!!$    end if

    allocate(ks(0:np-1))
    allocate(ke(0:np-1))
    allocate(kc(0:np-1))
    allocate(js(0:np-1))
    allocate(je(0:np-1))
    allocate(jc(0:np-1))

    allocate(itj(5))
    allocate(iti(5))
    allocate(tj(jm*2))
    allocate(ti(im*2))

    call fttrui(im,iti,ti)
    call fttzui(jm,itj,tj)

    kint = lm/np
    kmod = mod(lm,np)
    kc   = kint
    do iip=0,kmod-1
       kc(iip) = kc(iip) + 1
    end do

    ks(0)=0 ; ke(0) = ks(0) + kc(0) -1
    do iip=1,np-1
       ks(iip) = ks(iip-1) + kc(iip-1)
       ke(iip) = ks(iip) + kc(iip) - 1
    end do
       
    do iip=0,np-1
!!$       kp=lm/np+1
!!$       ks(iip)=kp*iip
!!$       ke(iip)=min(kp*(iip+1)-1,km)
!!$
!!$
!!$       if(ke(iip).ge.ks(iip)) then
!!$          kc(iip)=ke(iip)-ks(iip)+1
!!$       else
!!$          kc(iip)=0 ;  ks(iip)=0  ; ke(iip)=0
!!$       end if

       jp=(jm-1)/np+1
       js(iip)=jp*iip
       je(iip)=min(jp*(iip+1)-1,jm-1)
       if(je(iip).ge.js(iip)) then
          jc(iip)=je(iip)-js(iip)+1
       else
          jc(iip)=0 ; js(iip)=0 ; je(iip)=0
       end if
    enddo

    allocate(x_X(0:im-1))
    allocate(x_X_Weight(0:im-1))
    allocate(v_Y(jc(ip)))
    allocate(v_Y_Weight(jc(ip)))
    allocate(vx_X(jc(ip),0:im-1))
    allocate(vx_Y(jc(ip),0:im-1))

    do ii=0,im-1
       x_X(ii) = xmin + xl/im*ii
    enddo
    x_X_Weight = xl/im

    do jj=1,jc(ip)
       v_Y(jj) = ymin + yl/jm*(js(ip)+jj-1)
    enddo
    v_Y_Weight = yl/jm

    vx_X = spread(x_X,1,jc(ip))
    vx_Y = spread(v_Y,2,im)

    call MessageNotify('M','ee_mpi_initial', &
                       'ee_mpi_module (2020/02/13)is initialized')

  end subroutine ee_mpi_Initial

  !--------------- 波数位置問い合わせ -----------------
  function kf_k(k)
    !
    ! スペクトルデータ eef(-lm,lm,2*kc) での
    ! X 方向波数 L の位置情報(第 2 添え字)を調べる.
    !
    ! X 方向波数については ls,ls+1,... le, -le,-le+1,...,-ls
    ! の順に格納されている.
    !
    integer, intent(IN)  ::  k        ! X 方向波数
    integer              ::  kf_k     ! スペクトルデータ第 2 添え字

    if ( abs(k) < ks(ip) .OR. ke(ip) < abs(k) ) then
       kf_k = -1
    else if ( k >= 0 ) then
       kf_k = k-ks(ip)+1
    else
       kf_k = ks(ip)+2*kc(ip)-abs(k)
    endif

  end function kf_k

  !--------------- 基本変換 -----------------
  function vx_ef(ef)
    !
    ! スペクトルデータから格子データへ変換する.
    !
    real(8), dimension(js(ip):je(ip),0:im-1)        :: vx_ef
                                                        !(out) 格子点データ
    real(8), dimension(-lm:lm,2*kc(ip)), intent(in) :: ef
                                                        !(in)  スペクトルデータ
    real(8), dimension(js(ip):je(ip),2,0:im/2-1) :: vax_work
    real(8), dimension(kc(ip),0:jm-1,2)          :: fya_work
 
    real(8), dimension(jc(ip)*im)       :: y2    
    real(8), dimension(kc(ip)*jm*2)     :: y3

    integer :: k, l

    fya_work = 0.0D0

    do k=1,kc(ip)
       do l=1,lm
          fya_work(k,l,1)    = ef(l,k)
          fya_work(k,l,2)    = ef(-l,2*kc(ip)-k+1)
          fya_work(k,jm-l,1) = ef(-l,k)
          fya_work(k,jm-l,2) = ef(l,2*kc(ip)-k+1)
       enddo
    enddo

    do k=1,kc(ip)
       fya_work(k,0,1) = ef(0,k)
       fya_work(k,0,2) = ef(0,2*kc(ip)-k+1)
    enddo

    if ( ip == 0 ) then
       do l=1,lm
          fya_work(1,l,1) = ef(l,1)
          fya_work(1,l,2) = ef(-l,1)
          fya_work(1,jm-l,1) = ef(l,1)
          fya_work(1,jm-l,2) = -ef(-l,1)
       end do
       fya_work(1,0,1) = ef(0,1)
    endif

    call fttzub(kc(ip),jm,fya_work,y3,itj,tj)

    vax_work = vax_fya(fya_work)

    call fttrub(jc(ip),im,vax_work,y2,iti,ti)

    vx_ef = reshape(vax_work,(/jc(ip),im/))
    
  end function vx_ef

  function ef_vx(vx)
    !
    ! 格子データからスペクトルデータへ変換する.
    !
    real(8), dimension(-lm:lm,2*kc(ip))                  :: ef_vx
                                                      !(out)  スペクトルデータ
    real(8), dimension(js(ip):je(ip),0:im-1), intent(in) :: vx
                                                      !(in) 格子点データ
    real(8), dimension(js(ip):je(ip),2,0:im/2-1) :: vax_work
    real(8), dimension(kc(ip),0:jm-1,2)          :: fya_work
 
    real(8), dimension(jc(ip)*im)       :: y2    
    real(8), dimension(kc(ip)*jm*2)     :: y3

    integer :: k, l

    vax_work = reshape(vx,(/jc(ip),2,im/2/))

    call fttruf(jc(ip),im,vax_work,y2,iti,ti)

    fya_work = fya_vax(vax_work)

    if ( ip == 0 ) fya_work(1,:,2) = 0.0D0
    
    call fttzuf(kc(ip),jm,fya_work,y3,itj,tj)

    do k=1,kc(ip)
       do l=1,lm
          ef_vx(l,k)             = fya_work(k,l,1)
          ef_vx(-l,2*kc(ip)-k+1) = fya_work(k,l,2)
          ef_vx(-l,k)            = fya_work(k,jm-l,1)
          ef_vx(l,2*kc(ip)-k+1)  = fya_work(k,jm-l,2)
       enddo
    enddo

    do k=1,kc(ip)
       ef_vx(0,k)            = fya_work(k,0,1)
       ef_vx(0,2*kc(ip)-k+1) = fya_work(k,0,2)
    enddo

    if ( ip == 0 ) then
       do l=1,lm
          ef_vx(l,1)  = fya_work(1,l,1)
          ef_vx(-l,1) = fya_work(1,l,2)
          ef_vx(l,2*kc(0))  = 0.0D0
          ef_vx(-l,2*kc(0)) = 0.0D0
       end do
       ef_vx(0,1) = fya_work(1,0,1)
       ef_vx(0,2*kc(0)) = 0.0D0
    endif

  end function ef_vx

  function vax_fya(fya)
    real(8), dimension(kc(ip),0:jm-1,2),intent(IN) :: fya
    real(8), dimension(jc(ip),2,0:im/2-1)          :: vax_fya

    real(8), dimension(0:jm-1,2,kc(ip))    :: yaf_work
    real(8), dimension(:,:,:), allocatable :: vaf_work

    integer :: j, k, ips, ipr, ierr, istatus(MPI_STATUS_SIZE)

    vax_fya = 0.0D0

    do k=1,kc(ip)
       do j=0,jm-1
          yaf_work(j,:,k) = fya(k,j,:)
       enddo
    enddo

    do ips=0,np-1
       do ipr=0,np-1
          if ( ipr /= ips ) then
             if ( ip == ips ) then
                allocate(vaf_work(jc(ipr),2,kc(ip)))
                vaf_work = yaf_work(js(ipr):je(ipr),:,:)  
                call MPI_Send(vaf_work,jc(ipr)*2*kc(ips),MPI_REAL8,&
                              ipr,ips,MPI_COMM_WORLD,IERR)
                deallocate(vaf_work)
             endif
             if ( ip == ipr ) then
                call MPI_Recv(vax_fya(1,1,ks(ips)),jc(ipr)*2*kc(ips),MPI_REAL8,&
                              ips,ips,MPI_COMM_WORLD,ISTATUS,IERR)
             endif
          else if ( ip == ipr ) then
             vax_fya(:,:,ks(ip):ke(ip)) = yaf_work(js(ip):je(ip),:,1:kc(ip))
          endif
       enddo
    enddo
    
  end function vax_fya

  function fya_vax(vax)
    real(8), dimension(jc(ip),2,0:im/2-1),intent(IN) :: vax
    real(8), dimension(kc(ip),0:jm-1,2)              :: fya_vax

    real(8), dimension(0:jm-1,2,kc(ip))    :: yaf_work
    real(8), dimension(:,:,:), allocatable :: vaf_work

    integer :: j, k, ips, ipr, ierr, istatus(MPI_STATUS_SIZE)
    
    do ips=0,np-1
       do ipr=0,np-1
          if ( ipr /= ips ) then
             if ( ip == ips ) &
                  call MPI_Send(vax(1,1,ks(ipr)),jc(ips)*2*kc(ipr),MPI_REAL8,&
                                ipr,ips,MPI_COMM_WORLD,IERR)
             if ( ip == ipr ) then
                allocate(vaf_work(jc(ips),2,kc(ip)))
                call MPI_Recv(vaf_work(1,1,1),jc(ips)*2*kc(ipr),MPI_REAL8,&
                                ips,ips,MPI_COMM_WORLD,ISTATUS,IERR)
                yaf_work(js(ips):je(ips),:,:) = vaf_work
                deallocate(vaf_work)
             endif
          else if ( ip == ipr ) then
             yaf_work(js(ip):je(ip),:,1:kc(ip)) = vax(:,:,ks(ip):ke(ip))
          endif
       enddo
    enddo
    
    do k=1,kc(ip)
       do j=0,jm-1
          fya_vax(k,j,:) = yaf_work(j,:,k)
       enddo
    enddo

  end function fya_vax


  !--------------- 微分計算 -----------------
  function ef_Lapla_ef(ef)
    !
    ! 入力スペクトルデータにラプラシアン(∂xx+∂yy)を作用する.
    !
    ! スペクトルデータのラプラシアンとは, 対応する格子点データに
    ! ラプラシアンを作用させたデータのスペクトル変換のことである.
    !
    ! 実際にはスペクトルデータに全波数 (k**2 + l**2) をかける
    ! 計算を行っている. 
    !
    real(8), dimension(-lm:lm,2*kc(ip))              :: ef_Lapla_ef
    !(out) スペクトルデータのラプラシアン

    real(8), dimension(-lm:lm,2*kc(ip)), intent(in)  :: ef
    !(in) 入力スペクトルデータ

    integer kf, k,l
    ! 作業変数

    ef_Lapla_ef = 0.0D0
    do kf=1,kc(ip)
       k = ks(ip) + kf - 1
       do l=-lm,lm
          ef_Lapla_ef(l,kf) = -((2*pi*k/xl)**2+(2*pi*l/yl)**2)*ef(l,kf)
          ef_Lapla_ef(l,2*Kc(ip)-kf+1) &
               = -((2*pi*k/xl)**2+(2*pi*l/yl)**2)*ef(l,2*kc(ip)-kf+1)
       enddo
    enddo
  end function ef_Lapla_ef

  function ef_LaplaInv_ef(ef)
    !
    ! 入力スペクトルデータに逆ラプラシアン(∂xx+∂yy)**(-1)を作用する.
    !
    ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
    ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである.
    !
    ! 実際にはスペクトルデータに全波数 (k**2 + l**2) で割る
    ! 計算を行っている. k=l=0 成分には 0 を代入している. 
    !
    real(8), dimension(-lm:lm,2*kc(ip))             :: ef_LaplaInv_ef
    !(out) スペクトルデータの逆ラプラシアン

    real(8), dimension(-lm:lm,2*kc(ip)), intent(in) :: ef
    !(in) スペクトルデータ

    integer kf, k, l

    ef_LaplaInv_ef = 0.0D0
    do kf=1,kc(ip)
       k = ks(ip) + kf - 1
       do l=-lm,lm
          if ( k == 0 .AND. l == 0 ) then
             ef_LaplaInv_ef(l,kf) = 0.0
          else
             ef_LaplaInv_ef(l,kf) = -ef(l,kf)/((2*pi*k/xl)**2+(2*pi*l/yl)**2)
             ef_LaplaInv_ef(l,2*kc(ip)-kf+1) &
                  = -ef(l,2*kc(ip)-kf+1)/((2*pi*k/xl)**2+(2*pi*l/yl)**2)
          endif
       enddo
    enddo
  end function ef_LaplaInv_ef

  function ef_Dx_ef(ef)
    !
    ! 入力スペクトルデータに X 微分(∂x)を作用する.
    !
    ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
    ! 作用させたデータのスペクトル変換のことである.
    !
    ! 実際にはスペクトルデータに X 方向波数 k をかけて
    ! sin(kx) <-> cos(kx) 成分に入れ換える計算を行っている.
    !
    real(8), dimension(-lm:lm,2*kc(ip))              :: ef_Dx_ef
    !(out) スペクトルデータの X 微分

    real(8), dimension(-lm:lm,2*kc(ip)), intent(in)  :: ef
    !(in) 入力スペクトルデータ

    integer kf, k, l
    ! 作業変数

    do kf=1,kc(ip)
       k = ks(ip) + kf - 1
       do l=-lm,lm
          ef_Dx_ef(l,kf) = -(2*pi*k/xl)*ef(-l,2*kc(ip)-kf+1)
          ef_Dx_ef(l,2*kc(ip)-kf+1) = -(2*pi*(-k)/xl)*ef(-l,kf)
       enddo
    enddo
  end function ef_Dx_ef

  function ef_Dy_ef(ef)
    !
    ! 入力スペクトルデータに Y 微分(∂y)を作用する.
    !
    ! スペクトルデータの X 微分とは, 対応する格子点データに Y 微分を
    ! 作用させたデータのスペクトル変換のことである.
    !
    ! 実際にはスペクトルデータに X 方向波数 l をかけて
    ! sin(ky) <-> cos(ky) 成分に入れ換える計算を行っている.
    !
    real(8), dimension(-lm:lm,2*kc(ip))              :: ef_Dy_ef
    !(out) スペクトルデータの Y 微分

    real(8), dimension(-lm:lm,2*kc(ip)), intent(in)  :: ef
    !(in) 入力スペクトルデータ

    integer kf,l
    ! 作業変数

    do kf=1,kc(ip)
       if ( ip == 0 .AND. kf == 1 ) then
          do l=-lm,lm
             ef_Dy_ef(l,kf) = -(2*pi*l/yl)*ef(-l,kf)
             ef_Dy_ef(l,2*kc(ip)-kf+1) = 0.0D0
          enddo
       else
          do l=-lm,lm
             ef_Dy_ef(l,kf) = -(2*pi*l/yl)*ef(-l,2*kc(ip)-kf+1)
             ef_Dy_ef(l,2*kc(ip)-kf+1) = -(2*pi*l/yl)*ef(-l,kf)   
          enddo
       endif
    enddo
    
  end function ef_Dy_ef

  function ef_Jacobian_ef_ef(ef_a,ef_b)
    !
    !  2 つのスペクトルデータからヤコビアン
    !
    !     J(A,B)=(∂xA)(∂yB)-(∂yA)(∂xB)
    !
    !  を計算する.
    !
    !  2 つのスペクトルデータのヤコビアンとは, 対応する 2 つの
    !  格子点データのヤコビアンのスペクトル変換のことである.
    !
    real(8), dimension(-lm:lm,2*kc(ip))              :: ef_Jacobian_ef_ef
    !(out) 2 つのスペクトルデータのヤコビアン

    real(8), dimension(-lm:lm,2*kc(ip)), intent(in)  :: ef_a
    !(in) 1つ目の入力スペクトルデータ

    real(8), dimension(-lm:lm,2*kc(ip)), intent(in)  :: ef_b
    !(in) 2つ目の入力スペクトルデータ

    ef_Jacobian_ef_ef = ef_vx(   vx_ef(ef_Dx_ef(ef_a))*vx_ef(ef_Dy_ef(ef_b)) &
                               - vx_ef(ef_Dy_ef(ef_a))*vx_ef(ef_Dx_ef(ef_b)) )

  end function ef_Jacobian_ef_ef

  function ef_JacobianZ_ef(ef_zeta)
    !
    ! 渦度スペクトルデータ ζ から流線関数と渦度のヤコビアン
    !
    !     -J(ψ,ζ)=-[(∂xψ)(∂yζ)-(∂yψ)(∂xζ)]
    !
    !  を計算する. ただしψ は (∂xx+∂yy)ψ=ζ を満たす流線関数である.
    !
    real(8), dimension(-lm:lm,2*kc(ip))              :: ef_JacobianZ_ef
    !(out) 流線関数と渦度のヤコビアン

    real(8), dimension(-lm:lm,2*kc(ip)), intent(in)  :: ef_Zeta
    !(in) 渦度スペクトルデータ

    real(8), dimension(jc(ip),0:im-1)   :: vx_U    ! 速度 X 成分
    real(8), dimension(jc(ip),0:im-1)   :: vx_V    ! 速度 Y 成分
    real(8), dimension(-lm:lm,2*kc(ip)) :: ef_UV   ! 

    vx_U = - vx_ef(ef_Dy_ef(ef_LaplaInv_ef(ef_Zeta)))
    vx_V =   vx_ef(ef_Dx_ef(ef_LaplaInv_ef(ef_Zeta)))
    ef_UV = ef_vx(vx_U*vx_V)
    
    ef_JacobianZ_ef = - ( ef_Dx_ef(ef_Dx_ef(ef_UV))-ef_Dy_ef(ef_Dy_ef(ef_UV)) )&
                      - ef_Dx_ef(ef_Dy_ef(ef_vx(vx_V**2 - vx_U**2)))

  end function ef_JacobianZ_ef

  
  !--------------- 積分計算 -----------------
  function IntYX_vx(vx)
    !
    ! 2 次元格子点データの全領域積分および平均.
    !
    ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
    ! 総和を計算している. 
    !
    real(8), dimension(jc(ip),0:im-1)   :: vx          
    !(in)  2 次元格子点データ

    real(8)                             :: IntYX_vx
    !(out) 積分値

    real(8) :: IntYXTmp
    integer :: i, j, ierr
    ! 作業変数

    IntYXTmp = 0.0d0
    do i=0,im-1
       do j=1,jc(ip)
          IntYXTmp = IntYXTmp + vx(j,i) * v_Y_Weight(j) * x_X_Weight(i)
       enddo
    enddo

    CALL MPI_ALLREDUCE(IntYXTmp,IntYX_vx,1,MPI_REAL8, &
                       MPI_SUM,MPI_COMM_WORLD,IERR)
    
  end function IntYX_vx

  function v_IntX_vx(vx)
    !
    ! 2 次元格子点データの X 方向積分
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
    !
    real(8), dimension(jc(ip),0:im-1)   :: vx
    !(in) 2 次元格子点データ

    real(8), dimension(jc(ip))          :: v_IntX_vx
    !(out) 積分された 1 次元(Y)格子点データ

    integer :: i
    ! 作業変数

    v_IntX_vx = 0.0d0
    do i=0,im-1
       v_IntX_vx(:) = v_IntX_vx(:) + vx(:,i) * x_X_Weight(i)
    enddo
  end function v_IntX_vx

  function x_IntY_vx(vx)
    !
    ! 2 次元格子点データの Y 方向積分
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
    !
    real(8), dimension(jc(ip),0:im-1)   :: vx      
    !(in)  2 次元格子点データ

    real(8), dimension(0:im-1)        :: x_IntY_vx 
    !(out) 積分された 1 次元(X)格子点データ

    real(8), dimension(0:im-1)        :: x_IntYTmp
    integer :: j, ierr
    ! 作業変数

    x_IntYTmp = 0.0d0
    do j=1,jc(ip)
       x_IntYTmp(:) = x_IntYTmp(:) + vx(j,:) * v_Y_Weight(j)
    enddo

    CALL MPI_ALLREDUCE(x_IntYTmp,x_IntY_vx,im,MPI_REAL8, &
                       MPI_SUM,MPI_COMM_WORLD,IERR)

  end function x_IntY_vx

  function IntX_x(x)
    !
    ! 1 次元(X)格子点データの X 方向積分
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している. 
    !
    real(8), dimension(0:im-1)   :: x          !(in)  1 次元格子点データ
    real(8)                      :: IntX_x     !(out) 積分値

    IntX_x = sum(x*x_X_Weight)
  end function IntX_x

  function IntY_v(v)      ! Y 方向積分
    !
    ! 1 次元(Y)格子点データの Y 方向積分
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している. 
    !
    real(8), dimension(jc(ip))   :: v          !(in)  1 次元格子点データ
    real(8)                      :: IntY_v     !(out) 積分値

    real(8)                      :: IntYTmp     !(out) 積分値
    integer :: ierr
    
    IntYTmp = sum(v*v_Y_Weight)

    CALL MPI_ALLREDUCE(IntYTmp,IntY_v,1,MPI_REAL8, &
                       MPI_SUM,MPI_COMM_WORLD,IERR)
    
  end function IntY_v

  !--------------- 平均計算 -----------------
  function AvrYX_vx(vx)
    !
    ! 2 次元格子点データの全領域平均
    !
    ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
    ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している. 
    !
    real(8), dimension(jc(ip),0:im-1)   :: vx
    !(in)  2 次元格子点データ

    real(8)                             :: AvrYX_vx    
    !(out) 平均値

    AvrYX_vx = IntYX_vx(vx)/(xl*yl)

  end function AvrYX_vx

  function v_AvrX_vx(vx)
    !
    ! 2 次元格子点データの X 方向平均
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
    ! x_X_Weight の総和で割ることで平均している. 
    !
    real(8), dimension(jc(ip),0:im-1)   :: vx
    !(in) 2 次元格子点データ

    real(8), dimension(jc(ip))          :: v_AvrX_vx
    !(out) 平均された 1 次元(Y)格子点データ

    v_AvrX_vx = v_IntX_vx(vx)/xl

  end function v_AvrX_vx

  function x_AvrY_vx(vx)
    !
    ! 2 次元格子点データの Y 方向平均
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
    ! y_Y_Weight の総和で割ることで平均している. 
    !
    real(8), dimension(jc(ip),0:im-1)   :: vx
    !(in) 2 次元格子点データ

    real(8), dimension(0:im-1)          :: x_AvrY_vx
    !(out) 平均された 1 次元(X)格子点データ

    x_AvrY_vx = x_IntY_vx(vx)/yl

  end function x_AvrY_vx

  function AvrX_x(x)
    !
    ! 1 次元(X)格子点データの X 方向平均
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し, 
    ! x_X_Weight の総和で割ることで平均している. 
    !
    real(8), dimension(0:im-1)   :: x          !(in)  1 次元格子点データ
    real(8)                      :: AvrX_x     !(out) 平均値

    AvrX_x = IntX_x(x)/xl

  end function AvrX_x

  function AvrY_v(v)
    !
    ! 1 次元(Y)格子点データの Y 方向平均
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し, 
    ! y_Y_Weight の総和で割ることで平均している. 
    !
    real(8), dimension(jc(ip)) :: v          !(in)  1 次元格子点データ
    real(8)                    :: AvrY_v     !(out) 平均値

    AvrY_v = IntY_v(v)/yl

  end function AvrY_v
  

  !--------------- スペクトル計算 -----------------
  function ef_EnergyFromStreamfunc_ef(ef_StrFunc)
    !
    ! 流線関数からエネルギースペクトルを計算する. 
    !
    !   E_kl = (1/2)(k^2+l^2)|\psi_kl|^2
    !
    ! * E_kl の総和が場の平均運動エネルギーとなる. 
    ! * それに領域の面積をかけると全運動エネルギーとなる. 
    !
    real(8), dimension(-lm:lm,2*kc(ip))    :: ef_EnergyFromStreamfunc_ef
    ! エネルギースペクトル

    real(8), dimension(-lm:lm,2*kc(ip)), intent(in) :: ef_StrFunc
    ! 流線関数

    integer kf, k,l
    ! 作業変数

    do kf=1,kc(ip)
       k = ks(ip) + kf -1
       do l=-lm,lm
          ef_EnergyFromStreamfunc_ef(l,kf) &
               = 0.5 * ( (2*pi*k/xl)**2 + (2*pi*l/yl)**2 ) & 
               * (ef_StrFunc(l,kf)**2 + ef_StrFunc(-l,2*kc(ip)-kf+1)**2)
          ef_EnergyFromStreamfunc_ef(l,2*kc(ip)-kf+1) &
               = ef_EnergyFromStreamfunc_ef(l,kf)
       enddo
    enddo

  end function ef_EnergyFromStreamfunc_ef

  function ef_EnstrophyFromStreamfunc_ef(ef_StrFunc)
    !
    ! 流線関数からエンストロフィースペクトルを計算する. 
    !
    !   Q_kl = (1/2)(k^2+l^2)^2|\psi_kl|^2
    !
    ! * Q_kl の総和が場の平均エンストロフィーとなる. 
    ! * それに領域の面積をかけると全エンストロフィーとなる. 
    !

    real(8), dimension(-lm:lm,2*kc(ip))    :: ef_EnstrophyFromStreamfunc_ef
    ! エンストロフィーースペクトル

    real(8), dimension(-lm:lm,2*kc(ip)), intent(in) :: ef_StrFunc
    ! 流線関数

    integer kf, k,l
    ! 作業変数

    do kf=1,kc(ip)
       k = ks(ip) + kf -1
       do l=-lm,lm
          ef_EnstrophyFromStreamfunc_ef(l,kf) &
               = 0.5 * ( (2*pi*k/xl)**2 + (2*pi*l/yl)**2 )**2 & 
               * (ef_StrFunc(l,kf)**2 + ef_StrFunc(-l,2*kc(ip)-kf+1)**2)
          ef_EnstrophyFromStreamfunc_ef(l,2*kc(ip)-kf+1) &
               = ef_EnstrophyFromStreamfunc_ef(l,kf)
       enddo
    enddo

  end function ef_EnstrophyFromStreamfunc_ef


  !--------------- 補間計算 -----------------
  function Interpolate_ef( ef_Data, x, y )
    real(8), intent(IN)  :: ef_data(-lm:lm,2*kc(ip))  ! スペクトルデータ
    real(8), intent(IN)  :: x                         ! 補間する点の x 座標 
    real(8), intent(IN)  :: y                         ! 補間する点の y 座標 
    real(8)              :: Interpolate_ef            ! 補間した値
    real(8)              :: InterpolateTmp            ! 作業変数

    integer :: kf, k, l, ierr
    real(8) :: xx, yy

    xx =(2*PI/xl)*(x - xmin)
    yy =(2*PI/yl)*(y - ymin)

    if ( ip == 0 ) then
       InterpolateTmp = ef_Data(0,1)
    else
       InterpolateTmp = 0.0D0
    endif
    
    ! l=0
    if ( ip == 0 ) then
       do kf=2,kc(ip)
          k = ks(ip) + kf -1
          InterpolateTmp = InterpolateTmp &
               + 2*( ef_Data(0,kf)*cos(k*xx) - ef_Data(0,kf_k(-k))*sin(k*xx) )
       end do
    else
       do kf=1,kc(ip)
          k = ks(ip) + kf -1
          InterpolateTmp = InterpolateTmp &
               + 2*( ef_Data(0,kf)*cos(k*xx) - ef_Data(0,kf_k(-k))*sin(k*xx) )
       end do
    endif
       
    ! k=0
    if ( ip == 0 ) then
       do l=1,lm
          InterpolateTmp = InterpolateTmp &
            + 2*( ef_Data(l,kf_k(0))*cos(l*yy) - ef_Data(-l,kf_k(0))*sin(l*yy) )
       end do
    end if

    ! k*l > 0
    do l=1,lm
       if ( ip == 0 ) then
          do kf=2,kc(ip)
             k = ks(ip) + kf -1
             InterpolateTmp = InterpolateTmp &
                  + 2*(  ef_Data(l,kf)*(   cos(k*xx)*cos(l*yy)   &
                                         - sin(k*xx)*sin(l*yy) ) &
                        -ef_Data(-l,kf_k(-k))*(   sin(k*xx)*cos(l*yy)   &
                                                + cos(k*xx)*sin(l*yy) ) )
          end do
       else
          do kf=1,kc(ip)
             k = ks(ip) + kf - 1
             InterpolateTmp = InterpolateTmp &
                  + 2*(  ef_Data(l,kf)*(   cos(k*xx)*cos(l*yy)   &
                                         - sin(k*xx)*sin(l*yy) ) &
                        -ef_Data(-l,kf_k(-k))*(   sin(k*xx)*cos(l*yy)   &
                                                + cos(k*xx)*sin(l*yy) ) )
          end do
       endif
    end do

    ! k*l < 0
    do l=1,lm
       if ( ip == 0 ) then
          do kf=2,kc(ip)
             k = ks(ip) + kf - 1
             InterpolateTmp = InterpolateTmp &
                  + 2*(  ef_Data(-l,kf)*(   cos(k*xx)*cos(l*yy)   &
                                          + sin(k*xx)*sin(l*yy) ) &
                        -ef_Data(l,kf_k(-k))*(   sin(k*xx)*cos(l*yy)   &
                                               - cos(k*xx)*sin(l*yy) ) )
          end do
       else
          do kf=1,kc(ip)
             k = ks(ip) + kf - 1
             InterpolateTmp = InterpolateTmp &
                  + 2*(  ef_Data(-l,kf)*(   cos(k*xx)*cos(l*yy)   &
                                          + sin(k*xx)*sin(l*yy) ) &
                        -ef_Data(l,kf_k(-k))*(   sin(k*xx)*cos(l*yy)   &
                                               - cos(k*xx)*sin(l*yy) ) )
          end do
       endif
    end do

    CALL MPI_ALLREDUCE(InterpolateTmp,Interpolate_ef,1,MPI_REAL8, &
                       MPI_SUM,MPI_COMM_WORLD,IERR)

  end function Interpolate_ef

end module ee_mpi_module

!--
!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  ua_deriv_mpi_module_svpack
!
!  spml/ua_deriv_mpi_module_svpack モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための 
!  モジュール wa_module_svpack の下部モジュールであり, スペクトル法の
!  微分計算のための Fortran90 関数を提供する. 
!
!  球面上の 1 層モデル用 w_deriv_module_svpack モジュールを多層モデル用に
!  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!  対する変換が行える.
!
!  内部で ISPACK2 の SVPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK2/SVPACK のマニュアルを参照されたい.
!
!履歴  2016/07/30  竹広真一 wa_deriv_module_sjpack より多層 MPI 化
!
!      制限
!         ・変換する格子点データ, スペクトルデータの配列の大きさは決めうち
!
module ua_deriv_mpi_module_svpack
  !
  != ua_deriv_mpi_module_svpack
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !  spml/ua_deriv_mpi_module_svpack モジュールは球面上での流体運動を
  !  球面調和函数を用いたスペクトル法によって数値計算するための 
  !  モジュール wa_module_svpack の下部モジュールであり, スペクトル法の
  !  微分計算のための Fortran90 関数を提供する. 
  !
  !  球面上の 1 層モデル用 w_deriv_module_svpack モジュールを多層モデル用に
  !  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  !  対する変換が行える.
  !
  !  内部で ISPACK2 の SVPACK の Fortran77 サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK2/SVPACK のマニュアルを参照されたい.
  !
  use dc_message, only : MessageNotify
  use w_base_module_svpack, only : im, jm, nm=>nn
  use ua_base_mpi_module_svpack, only : xyb_ua, ua_xyb, nc, kc, km, ua_wb, wb_ua
  use w_module_svpack, only : w_Jacobian_w_w
!!$  use w_module_svpack, only : w_xy, xy_w, w_Lapla_w, w_LaplaInv_w, &
!!$                              w_DLon_w, w_Jacobian_w_w

  implicit none
 
  real(8), allocatable  :: D(:)
  ! ラプラシアン演算用配列
  !
  ! スペクトルデータのラプラシアンを計算するための係数
  ! 配列のサイズは(nc*2)
  !

  real(8), allocatable  :: rn(:,:)
  ! ラプラシアン演算用配列(w_module と互換性を保つため)
  !
  ! スペクトルデータのラプラシアンを計算するための係数
  ! 配列のサイズは(nc, 2)
  !
  ! r(L,1) には L 番目の格納位置のスペクトルに対するラプラシアン計算の
  ! 係数 -n(n+1) の値が格納されている.
  !

  ! private im, jm, nm, nc, kc                  ! for Intel Fortran
  private

  public ua_deriv_mpi_Initial
  public ua_deriv_mpi_Finalize
  public ua_Lapla_ua, ua_LaplaInv_ua          ! ラプラシアンと逆演算
  public ua_DLon_ua                           ! 経度微分
  public xyb_GradLon_ua, xyb_GradLat_ua       ! 勾配型微分
  public ua_DivLon_xyb, ua_DivLat_xyb         ! 発散型微分
  public ua_Div_xyb_xyb                       ! 発散型微分
  public ua_JacobianMPI_ua_ua                 ! ヤコビアン
  public xyb_GradLambda_ua, xyb_GradMu_ua     ! 勾配型微分(λ,μ座標)
  public ua_DivLambda_xyb, ua_DivMu_xyb       ! 発散型微分(λ,μ座標)

  public rn                                   ! ラプラシアン演算用配列

  save D, rn

contains

    !--------------- 初期化 -----------------
    subroutine ua_deriv_mpi_initial
      !
      ! スペクトル微分計算に必要となる作業領域を設定する.
      !
      ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで
      ! 初期設定をしなければならない.
      !
      ! 上位サブルーチン ua_mpi_Initial を使用すること.
      !
      allocate(D(nc*2))                      ! ラプラシアン演算用配列
      allocate(rn(nc,2))                     ! ラプラシアン演算用配列

      call suinid(nm,D)

      rn = reshape(D,(/nc,2/))

!!$      ua_mpi_deriv_initialize=.true.

      call MessageNotify('M','ua_deriv_mpi_initial', &
           'ua_deriv_mpi_module_svpack (2016/07/30)is initialized')

    end subroutine ua_deriv_mpi_initial

    !--------------- 微分計算 -----------------
    function ua_Lapla_ua(ua_data)
      !
      ! 入力スペクトルデータにラプラシアン
      !
      !    ▽^2 = 1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)
      !
      ! を作用する(多層用).
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである. 
      !
      real(8), intent(in)  :: ua_data(:,:)
      !(in) 入力スペクトルデータ
      real(8)              :: ua_lapla_ua(nc,size(ua_data,2))
      !(out) 入力スペクトルデータのラプラシアン
      integer :: k

      do k=1,size(ua_data,2)
         call suclap(nm,ua_data(1,k),ua_Lapla_ua(1,k),D,1)
      enddo
      
    end function ua_Lapla_ua

    function ua_LaplaInv_ua(ua_data)
      !
      ! 入力スペクトルデータに逆ラプラシアン
      !
      !    ▽^{-2}
      !      =[1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)]^{-1}
      !
      ! を作用する(多層用).
      !
      ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
      ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである. 
      !
      real(8), intent(in)  :: ua_data(:,:)
      !(in) 入力スペクトルデータ
      real(8)              :: ua_LaplaInv_ua(nc,size(ua_data,2))
      !(out) スペクトルデータの逆ラプラシアン
      integer :: k

      do k=1,size(ua_data,2)
         call suclap(nm,ua_data(1,k),ua_LaplaInv_ua(1,k),D,2)
      enddo

    end function ua_LaplaInv_ua

    function ua_DLon_ua(ua_data)
      !
      ! スペクトルデータに経度微分 ∂/∂λ を作用させる(多層用).
      !
      ! スペクトルデータの経度微分とは, 対応する格子点データに
      ! 経度微分∂/∂λを作用させたデータのスペクトル変換のことである.
      ! 
      real(8), intent(in)  :: ua_data(:,:)
      !(in) 入力スペクトルデータ
      real(8)              :: ua_DLon_ua(nc,size(ua_data,2))
      !(out) スペクトルデータの経度微分
      integer :: k

      do k=1,size(ua_data,2)
         call sucs2x(nm,ua_data(1,k),ua_DLon_ua(1,k))
      enddo

    end function ua_DLon_ua

    function xyb_GradLon_ua(ua_data)
      !
      ! スペクトルデータに勾配型経度微分 1/cosφ・∂/∂λ を
      ! 作用させた格子点データを返す(多層用).
      !
      real(8), intent(in)  :: ua_data(nc,km)
      !(in) 入力スペクトルデータ
      real(8)              :: xyb_GradLon_ua(0:im-1,1:jm,kc)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      xyb_GradLon_ua = xyb_ua(ua_data,ipow=1,iflag=-1)

    end function xyb_GradLon_ua

    function xyb_GradLat_ua(ua_data)
      !
      ! スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させて
      ! 格子点データに変換して返す(多層用).
      !
      real(8), intent(in)  :: ua_data(nc,km)
      !(in) 入力スペクトルデータ
      real(8)              :: xyb_GradLat_ua(0:im-1,1:jm,kc)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      xyb_GradLat_ua = xyb_ua(ua_data,ipow=1,iflag=1)

    end function xyb_GradLat_ua

    function ua_DivLon_xyb(xyb_data)
      !
      ! 格子点データに発散型経度微分 1/cosφ・∂/∂λ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(8), intent(in)  :: xyb_data(0:im-1,jm,kc)
      !(in) 入力格子点データ
      real(8)              :: ua_DivLon_xyb(nc,km)
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      ua_DivLon_xyb = ua_xyb(xyb_data,ipow=1,iflag=-1)

    end function ua_DivLon_xyb

    function ua_DivLat_xyb(xyb_data)
      !
      ! 格子点データに発散型緯度微分 1/cosφ・∂(f cosφ)/∂φ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(8), intent(in)  :: xyb_data(0:im-1,jm,kc)
      !(in) 入力格子点データ
      real(8)              :: ua_DivLat_xyb(nc,km)
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      ua_DivLat_xyb = ua_xyb(xyb_data,ipow=1,iflag=1)

    end function ua_DivLat_xyb

    function ua_Div_xyb_xyb(xyb_u,xyb_v)
      !
      ! 2 つの入力格子点データをベクトル成分とする発散を計算し, 
      ! スペクトルデータとして返す(多層用).
      !
      real(8), intent(in)  :: xyb_u(0:im-1,jm,kc)
      !(in) ベクトル経度成分の格子点データ
      real(8), intent(in)  :: xyb_v(0:im-1,jm,kc)
      !(in) ベクトル緯度成分の格子点データ
      real(8)              :: ua_Div_xyb_xyb(nc,km)
      !(out) 2 つの入力格子点データをベクトル成分とする発散のスペクトルデータ

      ua_Div_xyb_xyb = ua_DivLon_xyb(xyb_u) + ua_DivLat_xyb(xyb_v)

    end function ua_Div_xyb_xyb

    function ua_JacobianMPI_ua_ua(ua_a,ua_b)
      ! 2 つのスペクトルデータにヤコビアン
      !
      !   J(f,g) = ∂f/∂λ・∂g/∂μ - ∂g/∂λ・∂f/∂μ
      !          = ∂f/∂λ・1/cosφ・∂g/∂φ
      !             - ∂g/∂λ・1/cosφ・∂f/∂φ
      !
      ! を作用させる(多層用).
      !
      real(8), intent(in) :: ua_a(nc,km)
      !(in) 1つ目の入力スペクトルデータ
      real(8), intent(in) :: ua_b(nc,km)
      !(in) 2つ目の入力スペクトルデータ
      real(8)             :: ua_JacobianMPI_ua_ua(nc,km)
      !(out) 2 つのスペクトルデータのヤコビアン
      integer :: k

      real(8) :: wb_a((nm+1)**2,kc)
      real(8) :: wb_b((nm+1)**2,kc)
      real(8) :: wb_Jacobian((nm+1)**2,kc)

      wb_a = wb_ua(ua_a)
      wb_b = wb_ua(ua_b)      

      do k=1,kc
         wb_Jacobian(:,k) = w_Jacobian_w_w(wb_a(:,k),wb_b(:,k))
      end do

      ua_JacobianMPI_ua_ua = ua_wb(wb_Jacobian)
      
    end function ua_JacobianMPI_ua_ua

    !--------------- 微分計算 (λ,μ座標系用) -----------------
    function xyb_GradLambda_ua(ua_data)
      !
      ! スペクトルデータに勾配型経度微分 ∂/∂λ を作用する(多層用).
      !
      real(8), intent(in)  :: ua_data(nc,km)
      !(in) 入力スペクトルデータ
      real(8)              :: xyb_GradLambda_ua(0:im-1,jm,kc)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      xyb_GradLambda_ua = xyb_ua(ua_data,ipow=0,iflag=-1)

    end function xyb_GradLambda_ua

    function xyb_GradMu_ua(ua_data)
      !
      ! スペクトルデータに勾配型緯度微分 (1-μ^2)∂/∂μ  (μ=sinφ)
      ! を作用させて格子点データに変換して返す(多層用).
      !
      real(8), intent(in)  :: ua_data(nc,km)
      !(in) 入力スペクトルデータ
      real(8)              :: xyb_GradMu_ua(0:im-1,1:jm,kc)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      xyb_GradMu_ua = xyb_ua(ua_data,ipow=0,iflag=1)

    end function xyb_GradMu_ua

    function ua_DivLambda_xyb(xyb_data)
      !
      ! 格子点データに発散型経度微分 1/(1-μ^2)・∂/∂λ (μ=sinφ) 
      ! を作用させてスペクトルデータに変換して返す(多層用).
      !
      real(8), intent(in)  :: xyb_data(0:im-1,1:jm,kc)
      !(in) 入力格子点データ
      real(8)              :: ua_DivLambda_xyb(nc,km)
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      ua_DivLambda_xyb = ua_xyb(xyb_data,ipow=2,iflag=-1)

    end function ua_DivLambda_xyb

    function ua_DivMu_xyb(xyb_data)
      !
      ! 格子点データに発散型緯度微分 ∂/∂μ (μ=sinφ)を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(8), intent(in)  :: xyb_data(0:im-1,1:jm,kc)
      !(in) 入力格子点データ
      real(8)              :: ua_DivMu_xyb(nc,km)
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      ua_DivMu_xyb = ua_xyb(xyb_data,ipow=2,iflag=1)

    end function ua_DivMu_xyb

  !--------------- 終了処理 -----------------
    subroutine ua_deriv_mpi_Finalize
      ! 
      !
      ! このサブルーチンを単独で用いるのでなく, 
      ! 上位サブルーチン wa_Finalize を使用すること.
      !
      deallocate(D)
      deallocate(rn)
      
      call MessageNotify('M','ua_deriv_mpi_finalize',&
           'ua_deriv_mpi_module_svpack is finalized (2016/08/15) ')

    end subroutine ua_deriv_mpi_Finalize
    
end module ua_deriv_mpi_module_svpack

!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wq_module テストプログラム
!
!      ポロイダルポテンシャルの境界値問題
!
!履歴  2009/12/11  竹広真一   wq_test_polvelbc.f90 より SJPACK 用に改造
!
!メモ
!      2008/07/05  佐々木洋平 1D-1 しか精度保証できないの?
!
program wq_module_polvelbc_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wq_module

  implicit none

  integer,parameter  :: im=32, jm=16, km=8   ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=15         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ra=0.5D0             ! 球半径

  real(8), dimension(0:im-1,1:jm,km)     :: xyr_Poloidal
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_LaplaPol
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_True
  real(8), dimension(0:im-1,1:jm,km)     :: xyr_Zero=0.0D0
  real(8), dimension((nm+1)**2,0:lm)     :: wq_Poloidal
  real(8), dimension((nm+1)**2,0:lm)     :: wq_LaplaPol
  real(8), dimension((nm+1)**2,0:lm)     :: wq_LaplaPol0
  character(len=1), dimension(2), parameter :: BCond=(/'F','R'/)

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  integer :: l

  call MessageNotify('M','wq_module_polvelbc_test', &
       'wq_module wq_LaplaPol2Pol_wq subroutine test')

  call wq_initial(im,jm,km,nm,lm,ra)

  do l=1,2

     ! P_10
     xyr_Poloidal = sin(xyr_Lat) * xyr_Rad * ((xyr_Rad-ra)*(xyr_Rad+ra))**3
!!$     xyr_Poloidal = sin(xyr_Lat) * xyr_Rad * ((xyr_Rad-ra)*(xyr_Rad+ra))**2
     wq_LaplaPol0 = wq_Lapla_wq(wq_xyr(xyr_Poloidal))
     !xyr_LaplaPol = sin(xyr_Lat) * sin( pi*(xyr_Rad-ri)/(ro-ri) )
     ! P_1_1
     !xyr_LaplaPol = cos(xyr_Lat)*cos(xyr_Lon)* xyr_Rad * (xyr_Rad-ra) 
     !xyr_LaplaPol = 2*sin(xyr_Lat)**2 * xyr_Rad * (xyr_Rad-ra) 

     !xyr_Poloidal = xyr_wz(wr_LaplaPol2pol_wr(wr_xyr(xyr_LaplaPol),BCond(l)))
     !xyr_Poloidal = xyr_wq(wq_LaplaPol2PolTau_wq(wq_xyr(xyr_LaplaPol),BCond(l)))

     wq_Poloidal  = wq_LaplaPol2Pol_wq(wq_LaplaPol0,BCond(l),new=.true.)
     wq_LaplaPol  = wq_Lapla_wq(wq_Poloidal)
     xyr_Poloidal = xyr_wq(wq_Poloidal)

     !---------------- 内部チェック -----------------------
     call AssertEqual(&
          message='wq_Laplapol2Pol_wq (internal value)',                &
          answer = wq_LaplaPol(:,0:lm-4),                               &
          check = wq_LaplaPol0(:,0:lm-4),                               &
          significant_digits = check_digits, ignore_digits = ignore     &
       )

     !--------- 上端境界チェック ----------

     !----- Φ=0 at the top ---------
     call AssertEqual(&
          message='wq_LaplaPol2Pol_wq (Φ=0 Top Booundary)',            &
          answer = xyr_Poloidal(:,:,km),                                &
          check = xyr_Zero(:,:,km),                                     &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     !----- dΦ/dr=0, d^2Φ/dr^2 at the top ---------
     if( BCond(l)(1:1) == 'F' ) then
        xyr_True = xyr_wq(wq_RadDRad_wq(wq_RadDRad_wq(wq_Poloidal))&
                                       -wq_RadDRad_wq(wq_Poloidal))/xyr_Rad**2
     else
        xyr_True = xyr_wq(wq_RadDRad_wq(wq_Poloidal))/xyr_Rad
     endif

     call AssertEqual(&
          message='wq_LaplaPol2Pol_wq (Top Booundary)',                 &
          answer = xyr_True(:,:,km),                                    &
          check = xyr_Zero(:,:,km),                                     &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     call MessageNotify('M','wq_module_polvelbc_test', &
          'wq_LaplaPol2Pol_wq: '//BCond(l)//'-Top B.C. test succeeded!')
          
  end do

  call MessageNotify('M','wq_module_polvelbc_test', &
       'wq_module wq_LaplaPol2Pol_wq subroutine test succeeded!')

end program wq_module_polvelbc_test

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wtq_mpi_module_supack テストプログラム
!
!      磁場トロイダルポテンシャルの境界値問題
!
!履歴  2016/04/04  竹広真一   wt_mpi_module_supack_tormagbc_test.f90 より改造
!
program wtq_mpi_module_supack_tormagbc_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wtq_mpi_module_supack
  use mpi

  implicit none

  integer,parameter  :: im=32, jm=16         ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: kmo=16, kmi=10       ! 格子点の設定(球殻動径, 球動径)
  integer,parameter  :: nm=10                ! 切断波数の設定(水平)
  integer,parameter  :: lmo=16, lmi=16       ! 切断波数の設定(球殻動径, 球動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径
 
  real(8), allocatable :: xvz_TORMAG(:,:,:)
  real(8), allocatable :: wt_TORMAG(:,:)
  real(8), allocatable :: xvz_Zero(:,:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8), parameter  :: pi=3.1415926535897932385D0

  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)


  call MessageNotify('M','wtq_mpi_module_supack_tormagbc_test', &
       'wtq_mpi_module_supack wt_TormagBoundaries subroutine test')

  call wtq_mpi_Initial(im,jm,kmi,kmo,nm,lmi,lmo,ri,ro)
 
  allocate(xvz_TORMAG(0:im-1,jc,0:kmo))
  allocate(wt_TORMAG(nc,0:lmo))
  allocate(xvz_Zero(0:im-1,jc,0:kmo))

  xvz_Zero = 0.0D0

 !==================== wt_TormagBoundaries =========================
  ! P_10
  xvz_TORMAG = sin(xvz_lat) * cos( pi*(xvz_rad-ri)/(ro-ri) )
  ! P_1_1
  !xvz_TORMAG = cos(xvz_lat)*cos(xvz_lon)* cos( pi*(xvz_rad-ri)/(ro-ri) )
  !xvz_TORMAG = 2*sin(xvz_lat)**2 * cos( pi*(xvz_rad-ri)/(ro-ri) )

  wt_TORMAG = wt_xvz(xvz_TORMAG)
  call wt_TormagBoundaries(wt_TORMAG)
  xvz_TORMAG = xvz_wt(wt_TORMAG)

  call AssertEqual(&
       message='wt_TormagBoundaries (Top B.C.)',                     &
       answer = xvz_Zero(:,:,0),                                     &
       check = xvz_TORMAG(:,:,0),                                    &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='wt_TormagBoundaries (Bottom B.C.)',                  &
       answer = xvz_Zero(:,:,kmo),                                   &
       check = xvz_TORMAG(:,:,kmo),                                  &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

 !==================== wt_TormagBoundariesGrid =========================
  ! P_10
  !xvz_TORMAG = sin(xvz_lat) * cos( pi*(xvz_rad-ri)/(ro-ri) )
  ! P_1_1
  xvz_TORMAG = cos(xvz_lat)*cos(xvz_lon)* cos( pi*(xvz_rad-ri)/(ro-ri) )
  !xvz_TORMAG = 2*sin(xvz_lat)**2 * cos( pi*(xvz_rad-ri)/(ro-ri) )

  wt_TORMAG = wt_xvz(xvz_TORMAG)
  call wt_TormagBoundariesGrid(wt_TORMAG)
  xvz_TORMAG = xvz_wt(wt_TORMAG)


  call AssertEqual(&
       message='wt_TormagBoundariesGrid (Top B.C.)',                 &
       answer = xvz_Zero(:,:,0),                                     &
       check = xvz_TORMAG(:,:,0),                                    &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='wt_TormagBoundariesGrid (Bottom B.C.)',              &
       answer = xvz_Zero(:,:,kmo),                                   &
       check = xvz_TORMAG(:,:,kmo),                                  &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','wtq_mpi_module_supack_tormagbc_test', &
       'wtq_mpi_module_supack wt_TormagBoundaries subroutine test succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wtq_mpi_module_supack_tormagbc_test

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_deriv_module_sjpack テストプログラム :: 微分関数のテスト
!
!履歴  2009/09/04  竹広真一
!
program w_deriv_module_sjpack_cuda_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_module_sjpack_cuda
  implicit none

  integer, parameter :: im=512, jm=256, nm=170

  real(8), dimension(0:im-1,1:jm)  ::  xy_data1              ! 元の関数
  real(8), dimension(0:im-1,1:jm)  ::  xy_data2              ! 元の関数
  real(8), dimension(0:im-1,1:jm)  ::  xy_ddata              ! 微分の正解
  real(8), dimension(0:im-1,1:jm)  ::  mu                    ! μ=sinφ

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -7

  call MessageNotify('M','w_deriv_module_sjpack_cuda_test', &
                         'w_deriv_module_sjpack_cuda function tests') 

  call w_Initial( nm, im, jm )

  !---- Y_1^{-1} のテスト ----
  xy_data1 = -cos(xy_Lat)*sin(xy_Lon)         ! Y_1^{-1}

  xy_ddata = 2*cos(xy_Lat)*sin(xy_Lon)       ! w_Lapla_w
  call AssertEqual(&
    message='Y_1^0 test of w_Lapla_w',                            &
    answer = xy_ddata,                                            &
    check = xy_w(w_Lapla_w(w_xy(xy_data1))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_ddata = 1.0/2.0*cos(xy_Lat)*sin(xy_Lon)      ! w_LaplaInv_w
  call AssertEqual(&
    message='Y_1^0 test of w_LaplaInv_w',                         &
    answer = xy_ddata,                                            &
    check = xy_w(w_LaplaInv_w(w_xy(xy_data1))),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_ddata = -cos(xy_Lat)*cos(xy_Lon)         ! w_DLon_w
  call AssertEqual(&
    message='Y_1^0 test of w_DLon_w',                             &
    answer = xy_ddata,                                            &
    check = xy_w(w_DLon_w(w_xy(xy_data1))),                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_ddata = -cos(xy_Lon)                     ! xy_GradLon_w
  call AssertEqual(&
    message='Y_1^0 test of xy_GradLon_w',                         &
    answer = xy_ddata,                                            &
    check = xy_GradLon_w(w_xy(xy_data1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_ddata = sin(xy_Lat)*sin(xy_Lon)         ! xy_GradLat_w
  call AssertEqual(&
    message='Y_1^0 test of xy_GradLat_w',                         &
    answer = xy_ddata,                                            &
    check = xy_GradLat_w(w_xy(xy_data1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^1 cosφ のテスト ----
  xy_data1 = sin(xy_Lat)*cos(xy_Lat)**2 * cos(xy_Lon) ! Y_2^1 cosφ

  xy_ddata = -sin(xy_Lat)*cos(xy_Lat)*sin(xy_Lon)    ! w_DivLon_xy
  call AssertEqual(&
    message='Y_2^1 cosφ test of xy_DivLon_w',                    &
    answer = xy_ddata,                                            &
    check = xy_w(w_DivLon_xy(xy_data1)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_ddata = cos(xy_Lat)*(1-4*sin(xy_Lat)**2)*cos(xy_Lon)      ! w_DivLat_w
  call AssertEqual(&
    message='Y_2^1 cosφ test of xy_DivLat_w',                    &
    answer = xy_ddata,                                            &
    check = xy_w(w_DivLat_xy(xy_data1)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Jacobian のテスト ----
  xy_data1 = -cos(xy_Lat)*sin(xy_Lon)                ! Y_1^{-1}
  xy_data2 = sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)   ! Y_2^1

  xy_ddata = 0.0
  call AssertEqual(&
    message='Y_1^-1 test of w_Jacobian_w_w',                      &
    answer = xy_ddata,                                            &
    check = xy_w(w_Jacobian_w_w(w_xy(xy_data1),w_xy(xy_data1))),  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_ddata = sin(xy_Lat)**2 - cos(xy_Lat)**2*cos(xy_Lon)**2
  call AssertEqual(&
    message='Y_1^-1 and Y_2^1 test of w_Jacobian_w_w',            &
    answer = xy_ddata,                                            &
    check = xy_w(w_Jacobian_w_w(w_xy(xy_data1),w_xy(xy_data2))),  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !============== 微分計算 (λ,μ座標系用) のテスト ==============
  mu = sin(xy_Lat)

  !----- Y_2^0 のテスト -----
  xy_data1 = 3*mu**2-1                              ! Y_2^0

  xy_ddata = 0.0
  call AssertEqual(&
    message='Y_2^0 test of xy_GradLambda_w',                      &
    answer = xy_ddata,                                            &
    check = xy_GradLambda_w(w_xy(xy_data1)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_ddata = 6*mu*(1-mu**2)
  call AssertEqual(&
    message='Y_2^0 test of xy_GradMu_w',                          &
    answer = xy_ddata,                                            &
    check = xy_GradMu_w(w_xy(xy_data1)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !----- Y_2^0 cosφ のテスト -----
  xy_data1 = (3*mu**2-1)*(1-mu**2)                ! Y_2^0 (1-μ^2)

  xy_ddata = 0.0
  call AssertEqual(&
    message='Y_2^0 (1-μ^2) test of xy_DivLambda_w',                 &
    answer = xy_ddata,                                            &
    check = xy_w(w_DivLambda_xy(xy_data1)),                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_ddata = (2-3*mu**2)*4*mu
  call AssertEqual(&
    message='Y_2^0 (1-μ^2) test of xy_DivMu_w',                  &
    answer = xy_ddata,                                            &
    check = xy_w(w_DivMu_xy(xy_data1)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','w_deriv_module_sjpack_test', &
                         'w_deriv_module_sjpack function tests succeeded!') 

end program w_deriv_module_sjpack_cuda_test

!------------------------------------------------------------------------
! Copyright (c) 2002-2011 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  ee_module テストプログラム
!
!履歴  2002/08/20  竹広真一
!      2007/11/09  竹広真一  エラーメッセージ追加
!      2008/05/10  竹広真一  解像度複数設定チェック
!      2011/02/15  佐々木洋平 dc_test を使うように変更
!
program ee_intavr2

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=16, jm=16            ! 格子点の設定(X,Y)
  integer, parameter :: km=5, lm=5              ! 切断波数の設定(X,Y)

  integer, parameter :: im2=64, jm2=64            ! 格子点の設定(X,Y)
  integer, parameter :: km2=21, lm2=21            ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: x_Data(0:im-1)            ! 格子データ
  real(8)            :: y_Data(0:jm-1)            ! 格子データ

  real(8)            :: yx_Data2(0:jm2-1,0:im2-1) ! 格子データ
  real(8)            :: x_Data2(0:im2-1)          ! 格子データ
  real(8)            :: y_Data2(0:jm2-1)          ! 格子データ

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer            :: id1, id2, j

  call MessageNotify('M','ee_test_intavr2', &
       'ee_module integral/average function tests')

 !---------------- 座標値の設定 ---------------------
  call ee_initial(im,jm,km,lm,xmin,xmax,ymin,ymax,id1)        ! スペクトル初期化
  call ee_initial(im2,jm2,km2,lm2,xmin,xmax,ymin,ymax,id2)    ! スペクトル初期化

 !------------------- 初期値設定 ----------------------
  ! id1
  write(*,*) 'for id1'
  call ee_ChangeResolutionDomain(id1)

  yx_Data = sin(pi*yx_X) * cos(pi*yx_Y)
  write(6,*) 'f = sin(pi*X)*cos(pi*Y)'

    call check0d(IntYX_yx(yx_Data), 0.0d0, 'IntYX_yx')
    call check0d(AvrYX_yx(yx_Data), 0.0d0, 'AvrYX_yx')

    call check1d(y_IntX_yx(yx_Data), &
      (/(0.0d0, j=0,jm-1)/), 'y_IntX_yx')
    call check1d(y_AvrX_yx(yx_Data), &
      (/(0.0d0, j=0,jm-1)/), 'y_AvrX_yx')

    call check1d(x_IntY_yx(yx_Data), &
      (/(0.0d0, j=0,jm-1)/), 'x_IntY_yx')
    call check1d(x_AvrY_yx(yx_Data), &
      (/(0.0d0, j=0,jm-1)/), 'x_AvrY_yx')

  yx_Data = (1 - sin(pi*yx_X)) * cos(pi*yx_Y)**2
  write(6,*) 'f = (1-sin(pi*X)) * cos(pi*Y)**2'

    call check0d(IntYX_yx(yx_Data),  2.0d0, 'IntYX_yx')
    call check0d(AvrYX_yx(yx_Data), 5.0d-1, 'AvrYX_yx')

    call check1d(y_IntX_yx(yx_Data), 2*cos(pi*y_Y)**2, 'y_IntX_yx')
    call check1d(y_AvrX_yx(yx_Data), cos(pi*y_Y)**2, 'y_AvrX_yx')

    call check1d(x_IntY_yx(yx_Data), (1 - sin(pi*x_X)), 'x_IntY_yx')
    call check1d(x_AvrY_yx(yx_Data), 0.5*(1 - sin(pi*x_X)), 'x_AvrY_yx')

  x_Data = 1 - sin(2*pi*x_X)
  write(6,*) 'f = 1-sin(2*pi*X)'

    call check0d(IntX_x(x_Data), 2.0d0, 'IntX_x')
    call check0d(AvrX_x(x_Data), 1.0d0, 'AvrX_x')

  y_Data = cos(pi*y_Y)**2
  write(6,*) 'f = cos(pi*Y)**2'

    call check0d(IntY_y(y_Data),  1.0d0, 'IntY_y')
    call check0d(AvrY_y(y_Data), 5.0d-1, 'AvrY_y')

  ! id2
  write(*,*) 'for id2'
  call ee_ChangeResolutionDomain(id2)

  yx_Data2 = sin(pi*yx_X) * cos(pi*yx_Y)
  write(6,*) 'f = sin(pi*X)*cos(pi*Y)'

    call check0d(IntYX_yx(yx_Data2), 0.0d0, 'IntYX_yx')
    call check0d(AvrYX_yx(yx_Data2), 0.0d0, 'AvrYX_yx')

    call check1d(y_IntX_yx(yx_Data2),&
      (/(0.0d0, j=0,jm2-1)/), 'y_IntX_yx')
    call check1d(y_AvrX_yx(yx_Data2),&
      (/(0.0d0, j=0,jm2-1)/), 'y_AvrX_yx')

    call check1d(x_IntY_yx(yx_Data2),&
      (/(0.0d0, j=0,jm2-1)/), 'x_IntY_yx')
    call check1d(x_AvrY_yx(yx_Data2),&
      (/(0.0d0, j=0,jm2-1)/), 'x_AvrY_yx')

  yx_Data2 = (1 - sin(pi*yx_X)) * cos(pi*yx_Y)**2
  write(6,*) 'f = (1-sin(pi*X)) * cos(pi*Y)**2'

    call check0d(IntYX_yx(yx_Data2), 2.0d0, 'IntYX_yx')
    call check0d(AvrYX_yx(yx_Data2), 5.0d-1, 'AvrYX_yx')

    call check1d(y_IntX_yx(yx_Data2), 2*cos(pi*y_Y)**2, 'y_IntX_yx')
    call check1d(y_AvrX_yx(yx_Data2), cos(pi*y_Y)**2, 'y_AvrX_yx')

    call check1d(x_IntY_yx(yx_Data2), (1 - sin(pi*x_X)), 'x_IntY_yx')
    call check1d(x_AvrY_yx(yx_Data2), 0.5*(1 - sin(pi*x_X)), 'x_AvrY_yx')

  x_Data2 = 1 - sin(2*pi*x_X)
  write(6,*) 'f = 1-sin(2*pi*X)'

    call check0d(IntX_x(x_Data2), 2.0d0, 'IntX_x')
    call check0d(AvrX_x(x_Data2), 1.0d0, 'AvrX_x')

  y_Data2 = cos(pi*y_Y)**2
  write(6,*) 'f = cos(pi*Y)**2'

    call check0d(IntY_y(y_Data2), 1.0d0, 'IntY_y')
    call check0d(AvrY_y(y_Data2), 5.0d-1, 'AvrY_y')


  call MessageNotify('M','ee_test_intavr2', &
       'ee_module integral/average function tests succeeded!')

contains

  subroutine check1d(var1,sol1,funcname)
    real(8) :: var1(:)                  ! 判定する配列
    real(8) :: sol1(:)                  ! 解析解
    character(len=*) :: funcname        ! 関数名

    call AssertEqual(     &
      message = funcname, &
      answer = sol1,       &
      check = var1,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check1d

  subroutine check0d(var0,sol0,funcname)
    real(8) :: var0                       ! 判定する配列
    real(8) :: sol0                       ! 解析解
    character(len=*) :: funcname          ! 関数名

    call AssertEqual(      &
      message = funcname,  &
      answer = sol0,       &
      check = var0,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check0d

end program ee_intavr2

!--
!----------------------------------------------------------------------
!     Copyright (c) 2009--2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  w_wave_base_module_sjpack
!
!  spml/w_base_module_sjpack モジュールは球面上での 2 次元流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するためのモジュール 
!  w_module_sjpack の下部モジュールであり, スペクトル計算の基本的な 
!  Fortran90 関数を提供する.
!
!  内部で ISPACK の LJPACK(SJPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算
!  法については ISPACK/SJPACK のマニュアルを参照されたい.
!
!== 履歴
!
!      2013/07/02  竹広真一  w_base_module_sjpack より改造
!      2016/07/06  竹広真一  AVX 用 32 bit alignment 対応
!
!      制限
!         ・変換する格子点データ, スペクトルデータの配列の大きさは決めうち
!         ・波数切断の仕方は三角波数切断に決めうち. 
!
!++
module w_wave_base_module_sjpack
  !
  != w_wave_base_module_sjpack
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id: w_base_module_sjpack.f90 586 2013-05-23 17:42:12Z uwabami $
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要.
  !
  !  spml/w_base_module_sjpack モジュールは球面上での 2 次元流体運動を
  !  球面調和函数を用いたスペクトル法によって数値計算するためのモジュール 
  !  w_module_sjpack の下部モジュールであり, スペクトル計算の基本的な 
  !  Fortran90 関数を提供する.
  !
  !  内部で ISPACK の LJPACK(SJPACK の Fortran77 サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算
  !  法については ISPACK/SJPACK のマニュアルを参照されたい.
  !
  use dc_message, only : MessageNotify
  use iso_c_binding
  implicit none

  integer               :: im=2             ! 東西波数成分
  integer               :: jm=32            ! 格子点の設定(南北)
  integer               :: nm=21            ! 計算する最大の全波数の設定
  integer               :: nn=22            ! 切断波数(全波数)の設定
  integer               :: mm=21            ! 切断波数(東西波数)の設定
  integer               :: m = 1            ! 東西波数の設定

  real(8), allocatable  :: p(:,:), r(:)     ! 変換用配列
  real(8), allocatable  :: c(:)             ! 作業配列

  real(8), allocatable  :: y_Lat(:)         ! 緯度経度
  real(8), allocatable  :: y_Lat_Weight(:)  ! 座標重み
  real(8), allocatable  :: xy_Lat(:,:)

  real(8), pointer      :: xy_pdata(:,:),q(:)
  type(C_PTR)           :: pg, pq

  logical               :: w_wave_base_initialize=.false.   ! 初期化フラッグ

  real(8), parameter    :: pi=3.1415926535897932385D0

  private

  public im, jm, nn, mm, nm, m                ! 格子点数, 切断波数
  public p, r                                 ! 変換用作業配列

  public w_base_Initial                       ! 初期化サブルーチン
  public w_base_Finalize                      ! 終了サブルーチン

  public y_Lat                                ! 格子座標
  public y_Lat_Weight                         ! 格子座標重み
  public xy_Lat                               ! 格子座標(im,jm)
  public l_nm, nm_l                           ! 波数格納位置
  public xy_w, w_xy                           ! 変換関数
  public w_DLon_w                             ! 経度微分

  interface l_nm
     module procedure l_nm_array00
     module procedure l_nm_array01
     module procedure l_nm_array10
     module procedure l_nm_array11
  end interface

  interface nm_l
     module procedure nm_l_int
     module procedure nm_l_array
  end interface

  save im, jm, nm, mm, nn, m                  ! 格子点数, 切断波数を記憶
  save p, r                                   ! 変換用配列を記憶
  save c                                      ! 変換用配列の大きさ
  save xy_pdata, q
  save w_wave_base_initialize                 ! 初期化フラグ

  contains
  !--------------- 初期化 -----------------
    subroutine w_base_Initial(n_in,m_in,i_in,j_in)
      !
      ! スペクトル変換の格子点数, 波数を設定する.
      !
      ! 実際の使用には上位サブルーチン w_wave_Initial を用いること.
      !
      integer,intent(in) :: i_in              !(in) 格子点数(東西), 2の巾乗(<=2048)
      integer,intent(in) :: j_in              !(in) 格子点数(南北), 4 の倍数
      integer,intent(in) :: n_in              !(in) 切断全波数
      integer,intent(in) :: m_in              !(in) 東西波数

      integer :: i, j

      if ( m <= 0 ) then
         call MessageNotify('E','w_wave_base_module_initial', &
              'longitudinal wavenumber m must be positive')
      endif

      im = i_in   ; jm = j_in
      nn = n_in   ; nm = n_in+1 ;  mm = n_in      ! default は三角波数切断
      m  = m_in                                   ! 東西波数は 1 成分

      allocate(p(jm/2,mm+4))                  ! 変換用配列
      allocate(r((mm+1)*(2*nm-mm-1)+1))       ! 変換用配列
      allocate(c((mm+1)*(mm+1)))              ! 変換用作業配列

      allocate(y_Lat(1:jm))
      allocate(y_Lat_Weight(1:jm))             ! 格子点座標格納配列
      allocate(xy_Lat(0:im-1,1:jm))        ! 格子点座標格納配列

      call mlallc(pg,jm*im)
      call mlallc(pq,jm/2*7)
      call c_f_pointer(pg, xy_pdata, [IM,JM])
      call c_f_pointer(pq, q, [jm/2*7])

      call ljinit(mm,nm,jm,p,r)

      call sjinic(mm,c)

      do j=1,jm/2
         y_Lat(jm/2+j)   =  asin(p(j,1))        ! 緯度座標
         y_Lat(jm/2-j+1) = -asin(p(j,1))        ! 緯度座標
         y_Lat_Weight(jm/2+j)   = 2*p(j,2)      ! 緯度重み(Gauss grid)
         y_Lat_Weight(jm/2-j+1) = 2*p(j,2)      ! 緯度重み(Gauss grid)
      enddo

      do i=0,im-1
         xy_Lat(i,:) = y_Lat
      enddo

      w_wave_base_initialize = .true.

      call MessageNotify('M','w_wave_base_initial',&
           'w_wave_base_module_sjpack (2016/07/06) for AVX is initialized')

    end subroutine w_base_Initial

  !--------------- 基本関数 -----------------

    function l_nm_array00(n_in,m_in)
      !
      ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 引数 n,m がともに整数値の場合, 整数値を返す. 
      !
      integer               :: l_nm_array00   
      !(out) スペクトルデータの格納位置 

      integer, intent(in)   :: n_in     !(in) 全波数
      integer, intent(in)   :: m_in     !(in) 帯状波数           

      if ( m_in >= 0 ) then
         l_nm_array00 = 2*(n_in-m_in+1)-1
      else
         l_nm_array00 = 2*(n_in+m_in+1)
      endif

    end function l_nm_array00

    function l_nm_array01(n,marray)           ! スペクトルデータの格納位置 
      !
      ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 第 1 引数 n が整数, 第 2 引数 marray が整数 1 次元配列の場合, 
      ! marray と同じ大きさの 1 次元整数配列を返す. 
      !
      integer, intent(in)  :: n               !(in) 全波数
      integer, intent(in)  :: marray(:)       !(in) 帯状波数
      integer              :: l_nm_array01(size(marray))
      !(out) スペクトルデータ位置

      integer              :: i 

      do i=1, size(marray)
         l_nm_array01(i) = l_nm_array00(n,marray(i))
      enddo
    end function l_nm_array01

    function l_nm_array10(narray,m_in)
      !
      ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 第 1 引数 narray が整数 1 次元配列, 第 2 引数  m が整数の場合, 
      ! narray と同じ大きさの 1 次元整数配列を返す. 
      !
      integer, intent(in)  :: narray(:)           !(in) 全波数  
      integer, intent(in)  :: m_in                !(in) 帯状波数
      integer              :: l_nm_array10(size(narray))
      !(out) スペクトルデータ位置

      integer              :: i 

      do i=1, size(narray)
         l_nm_array10(i) = l_nm_array00(narray(i),m_in)
      enddo
    end function l_nm_array10

    function l_nm_array11(narray,marray)
      !
      ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
      ! 
      ! 第 1,2 引数 narray, marray がともに整数 1 次元配列の場合, 
      ! narray, marray と同じ大きさの 1 次元整数配列を返す. 
      ! narray, marray は同じ大きさでなければならない. 
      !
      integer, intent(in)  :: narray(:)          !(in) 全波数  
      integer, intent(in)  :: marray(:)          !(in) 帯状波数
      integer              :: l_nm_array11(size(narray))
      !(out) スペクトルデータ位置

      integer              :: i 

      if ( size(narray) .ne. size(marray) ) then
         call MessageNotify('E','l_nm_array11',&
              'dimensions of input arrays  n and m are different.')
      endif

      do i=1, size(narray)
         l_nm_array11(i) = l_nm_array00(narray(i),marray(i))
      enddo
    end function l_nm_array11

    function nm_l_int(l)
      ! 
      ! スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
      !
      ! 引数 l が整数値の場合, 対応する全波数と帯状波数を
      ! 長さ 2 の 1 次元整数値を返す. 
      ! nm_l(1) が全波数, nm_l(2) が帯状波数である. 
      !
      integer               :: nm_l_int(2)  !(out) 全波数, 帯状波数
      integer, intent(in)   :: l            !(in) スペクトルデータの格納位置

      if ( mod(l,2) == 0 ) then
         nm_l_int(1) = l/2 + m-1
         nm_l_int(2) = -m
      else
         nm_l_int(1) = (l+1)/2 + m-1
         nm_l_int(2) = m
      endif

    end function nm_l_int

    function nm_l_array(larray)
      ! 
      ! スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
      !
      ! 引数 larray が整数 1 次元配列の場合, 
      ! larray に対応する n, m を格納した 2 次元整数配列を返す. 
      ! nm_l_array(:,1) が全波数, nm_l_array(:,2) が帯状波数である. 
      !
      integer, intent(in)  :: larray(:)
      !(out) 全波数, 帯状波数

      integer              :: nm_l_array(size(larray),2)
      !(in) スペクトルデータの格納位置

      integer              :: i

      do i=1, size(larray)
         nm_l_array(i,:) = nm_l_int(larray(i))
      enddo
    end function nm_l_array

  !--------------- 基本変換 -----------------
    function w_DLon_w(w_data)
      !
      ! 入力スペクトルデータに経度微分∂/∂λを作用する. 
      !
      ! スペクトルデータの経度微分とは, 対応する格子点データに
      ! 経度微分を作用させたデータのスペクトル変換のことである. 
      !
      real(8)              :: w_DLon_w(2*(nn-m+1))
      !(out) 入力スペクトルデータのラプラシアン

      real(8), intent(in)  :: w_data(2*(nn-m+1))
      !(in) 入力スペクトルデータ

      integer :: n, n1, n2

      do n=m,nn
         n1 = 2*(n-m+1)-1
         n2 = 2*(n-m+1)
         w_DLon_w(n2) =   m * w_data(n1)
         w_DLon_w(n1) = - m * w_data(n2)
      end do

    end function w_DLon_w

    function xy_w(w_data,ipow,iflag)
      !
      ! スペクトルデータから格子データへ変換する(1 層用).
      !
      real(8)               :: xy_w(0:im-1,1:jm)
      !(out) 格子点データ

      real(8), intent(in)   :: w_data(2*(nn-m+1))
      !(in) スペクトルデータ

      integer, intent(in), optional  :: ipow      
      !(in) 作用させる 1/cosφ の次数. 省略時は 0. 

      integer, intent(in), optional  :: iflag
      !(in) 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた逆変換
      !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
      !    2 : sinφを作用させた逆変換
      !    省略時は 0.
      !
      integer, parameter  :: ipow_default  = 0
      integer, parameter  :: iflag_default = 0

      integer ipval, ifval

      real(8)             :: w_Ydata(2*(nn-m+2))
      ! 作業用スペクトルデータ(lJCS2Y 出力用)

      real(8)  :: ws(2*(nn-m+1))            ! 変換用作業配列
      real(8)  :: ws2(2*(nm-m+1))           ! 変換用作業配列

      if ( .not. w_wave_base_initialize ) then
         call MessageNotify('E','xy_w',&
              'w_wave_base_module_sjpack not initialize yet.')
      endif

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      if ( ifval==0 ) then
         call ljtswg(nm,nn,jm,m,w_Data,xy_pdata,p,q,r,ws,ipval)
         xy_w = xy_pdata
      else if( ifval==-1 ) then
         call ljtswg(nm,nn,jm,m,w_DLon_w(w_data),xy_pdata,p,q,r,ws,ipval)
         xy_w = xy_pdata
      else if( ifval==1 ) then
         call ljcswy(nn,m,w_data,w_Ydata,c)
         call ljtswg(nm,nm,jm,m,w_Ydata,xy_pdata,p,q,r,ws2,ipval)
         xy_w = xy_pdata
      else if( ifval==2 ) then
         call ljtswg(nm,nn,jm,m,w_data,xy_pdata,p,q,r,ws,ipval)
         xy_w = xy_pdata * sin(xy_Lat)
      else
         call MessageNotify('E','xy_w','invalid value of iflag')
      endif

    end function xy_w

    function w_xy(xy_data,ipow,iflag)
      !
      ! 格子データからスペクトルデータへ(正)変換する(1 層用).
      !
      real(8)               :: w_xy(2*(nn-m+1))
      !(out) スペクトルデータ

      real(8), intent(in)   :: xy_data(0:im-1,1:jm)
      !(in) 格子点データ

      integer, intent(in), optional  :: ipow
      !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

      integer, intent(in), optional  :: iflag
      ! 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた正変換 
      !    1 : 緯度微分 1/cosφ・∂(f cos^2φ)/∂φ を作用させた正変換
      !    2 : sinφを作用させた正変換
      !  省略時は 0.


      integer, parameter  :: ipow_default  = 0    ! スイッチデフォルト値
      integer, parameter  :: iflag_default = 0    ! スイッチデフォルト値

      integer ipval, ifval

      real(8)             :: w_Ydata(2*(nn-m+2))
      ! 作業用スペクトルデータ(LJCY2S 出力用)

      real(8)  :: ws(2*(nn-m+1))            ! 変換用作業配列
      real(8)  :: ws2(2*(nm-m+1))           ! 変換用作業配列

      if ( .not. w_wave_base_initialize ) then
         call MessageNotify('E','xy_w',&
              'w_wave_base_module_sjpack not initialize yet.')
      endif

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif
      
      if ( ifval == 0 ) then
         xy_pdata = xy_data
         call ljtgws(nm,nn,jm,m,w_xy,xy_pdata,p,q,r,ws,ipval)
      else if ( ifval == -1 ) then
         xy_pdata = xy_data
         call ljtgws(nm,nn,jm,m,w_xy,xy_pdata,p,q,r,ws,ipval)
         w_xy = w_Dlon_w(w_xy)
      else if ( ifval == 1 ) then
         xy_pdata = xy_data
         call ljtgws(nm,nm,jm,m,w_Ydata,xy_pdata,p,q,r,ws2,ipval)
         call ljcyws(nn,m,w_Ydata,w_xy,c)
      else if ( ifval == 2 ) then
         xy_pdata = xy_data*sin(xy_Lat)
         call ljtgws(nm,nn,jm,m,w_xy,xy_pdata,p,q,r,ws,ipval)
      end if

    end function w_xy

  !--------------- 終了処理 -----------------
    subroutine w_base_Finalize
      !
      ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
      !
      ! 実際の使用には上位サブルーチン w_Finalize を用いること.
      !
      if ( .not. w_wave_base_initialize ) then
         call MessageNotify('W','w_base_Finalize',&
              'w_wave_base_module not initialized yet')
         return
      endif

      deallocate(p)                  ! 変換用配列
      deallocate(r)                  ! 変換用配列
      deallocate(c)                  ! 変換用作業配列

      deallocate(y_Lat)
      deallocate(y_Lat_Weight)       ! 格子点座標格納配列
      deallocate(xy_Lat)             ! 格子点座標格納配列

      nullify(xy_pdata)              ! 変換用作業配列
      nullify(q)                     ! 変換用作業配列
      call mlfree(pg)                ! 変換用作業配列
      call mlfree(pq)                ! 変換用作業配列

      w_wave_base_initialize = .false.

      call MessageNotify('M','w_base_Finalize',&
           'w_wave_base_module_sjpack (2016/07/06) for AVX is finalized')

    end subroutine w_base_Finalize

end module w_wave_base_module_sjpack

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ut_mpi_module_svpack テストプログラム
!
!      磁場トロイダルポテンシャルの境界値問題
!
!履歴  2016/08/04  竹広真一   wt_mpi_module_supack_test_torvelbc.f90 より改造!
!
program ut_mpi_module_svpack_tormagbc_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ut_mpi_module_svpack
  use mpi

  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5      ! 内外半径

  real(8), allocatable :: xyh_TORMAG(:,:,:)
  real(8), allocatable :: ut_TORMAG(:,:)
  real(8), allocatable :: xyh_Zero(:,:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8), parameter  :: pi=3.1415926535897932385D0

  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)


  call MessageNotify('M','ut_mpi_module_svpack_tormagbc_test', &
       'ut_mpi_module_svpack ut_TormagBoundaries subroutine test')

  call ut_mpi_initial(im,jm,km,nm,lm,ri,ro)

  allocate(xyh_TORMAG(0:im-1,jm,kc))
  allocate(ut_TORMAG(nc,0:lm))
  allocate(xyh_Zero(0:im-1,jm,kc))

  xyh_Zero = 0.0D0

 !==================== ut_TormagBoundaries =========================
  ! P_10
  xyh_TORMAG = sin(xyh_lat) * cos( pi*(xyh_rad-ri)/(ro-ri) )
  ! P_1_1
  !xyh_TORMAG = cos(xyh_lat)*cos(xyh_lon)* cos( pi*(xyh_rad-ri)/(ro-ri) )
  !xyh_TORMAG = 2*sin(xyh_lat)**2 * cos( pi*(xyh_rad-ri)/(ro-ri) )

  ut_TORMAG = ut_xyh(xyh_TORMAG)
  call ut_TormagBoundaries(ut_TORMAG)
  xyh_TORMAG = xyh_ut(ut_TORMAG)

  if ( kh_kz(0) /= 0 )then
     call AssertEqual(&
          message='ut_TormagBoundaries (Top B.C.)',                     &
          answer = xyh_Zero(:,:,kh_kz(0)),                              &
          check = xyh_TORMAG(:,:,kh_kz(0)),                             &
          significant_digits = check_digits, ignore_digits = ignore     &
          )
  endif
  if ( kh_kz(km) /= 0 )then
     call AssertEqual(&
          message='ut_TormagBoundaries (Bottom B.C.)',                  &
          answer = xyh_Zero(:,:,kh_kz(km)),                             &
          check = xyh_TORMAG(:,:,kh_kz(km)),                            &
          significant_digits = check_digits, ignore_digits = ignore     &
          )
  endif
     
 !==================== ut_TormagBoundariesGrid =========================
  ! P_10
  !xyh_TORMAG = sin(xyh_lat) * cos( pi*(xyh_rad-ri)/(ro-ri) )
  ! P_1_1
  xyh_TORMAG = cos(xyh_lat)*cos(xyh_lon)* cos( pi*(xyh_rad-ri)/(ro-ri) )
  !xyh_TORMAG = 2*sin(xyh_lat)**2 * cos( pi*(xyh_rad-ri)/(ro-ri) )

  ut_TORMAG = ut_xyh(xyh_TORMAG)
  call ut_TormagBoundariesGrid(ut_TORMAG)
  xyh_TORMAG = xyh_ut(ut_TORMAG)


  if ( kh_kz(0) /= 0 )then
     call AssertEqual(&
          message='ut_TormagBoundariesGrid (Top B.C.)',                 &
          answer = xyh_Zero(:,:, kh_kz(0)),                             &
          check = xyh_TORMAG(:,:, kh_kz(0)),                            &
          significant_digits = check_digits, ignore_digits = ignore     &
          )
  endif
  if ( kh_kz(km) /= 0 )then
     call AssertEqual(&
          message='ut_TormagBoundariesGrid (Bottom B.C.)',              &
          answer = xyh_Zero(:,:, kh_kz(km)),                            &
          check = xyh_TORMAG(:,:, kh_kz(km)),                           &
          significant_digits = check_digits, ignore_digits = ignore     &
          )
  endif
  
  call MessageNotify('M','ut_mpi_module_svpack_tormagbc_test', &
       'ut_mpi_module_svpack ut_TormagBoundaries subroutine test succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ut_mpi_module_svpack_tormagbc_test

!----------------------------------------------------------------------
!     Copyright (c) 2010--2012 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wtq_mpi_module_sjpack テストプログラム :: 補間関数のテスト
!
!履歴  2010/04/18  竹広真一   wt_module_sjpack_interpolate_test.f90 より改造
!      2011/09/14  竹広真一   MPI 並列化
!      2011/09/14  竹広真一   wtq_mpi_module 用に改造
!      2012/04/02  竹広真一   wtq_mpi_module_sjpack 用に改造
!
program wtq_mpi_sjpack_interpol_wt

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wtq_mpi_module_sjpack
  use mpi
  implicit none

  integer,parameter  :: im=32, jm=16         ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: kmo=16, kmi=10       ! 格子点の設定(球殻動径, 球動径)
  integer,parameter  :: nm=10                ! 切断波数の設定(水平)
  integer,parameter  :: lmo=16, lmi=16       ! 切断波数の設定(球殻動径, 球動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), dimension((nm+1)**2,0:lmo)       ::  wt_data
  real(8), dimension(0:im-1,1:jm,0:kmo)     ::  xyz_data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: Alon
  real(8) :: Alat
  real(8) :: Arad
  real(8) :: data_sol
  real(8) :: pi

  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wtq_mpi_module_sjpack_interpolate_wt_test', &
                         'wtq_mpi_module_sjpack wt-interpolate tests') 

  pi = atan(1.0D0)*4.0D0

  Alon = pi/3
  Alat = pi/3
  Arad = 0.75
!!$  Alon =pi/4
!!$  Alat =pi/5
!!$  Arad =0.99
!!$  Alon = 3*pi/5
!!$  Alat = -pi/7
!!$  Arad = 1.333 

  call wtq_mpi_Initial(im,jm,kmi,kmo,nm,lmi,lmo,ri,ro)

  !---- Interpolaate_array000_wt のテスト ----
  xyz_data = sqrt(3.0D0/2)*cos(xyz_Lat)*cos(xyz_Lon) & ! Y_1^1
            * (xyz_Rad-ri) *  (xyz_Rad-ro)

  data_sol = sqrt(3.0D0/2)*cos(ALat)*cos(ALon) * (ARad-ri) *  (ARad-ro)

  wt_data = wt_xyz(xyz_data)

  call AssertEqual(&
       message='Interpolate_wt Y_1^-1',                              &
       answer = data_sol,                                            &
       check = Interpolate_wt(wt_data,alon,alat,arad),      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','wtq_mpi_module_sjpack_interpolate_wt_test',&
                         'wtq_mpi_module_sjpack wt-interpolate function test succeeded!') 

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wtq_mpi_sjpack_interpol_wt

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_mpi_module_supack テストプログラム
!
!      トロイダルポテンシャルの境界値問題
!
!履歴  2016/03/27  竹広真一   wt_module_nmomp_test_torvelbc.f90 より改造!
!
program wt_mpi_module_supack_torvelbc_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wt_mpi_module_supack
  use mpi

  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5      ! 内外半径

  real(8), allocatable :: xvz_TorVel0(:,:,:)
  real(8), allocatable :: xvz_TorVel(:,:,:)
  real(8), allocatable :: wt_TorVel(:,:)
  real(8), allocatable :: xvz_Zero(:,:,:)
  real(8), allocatable :: xvz_True(:,:,:)

  character(len=2), dimension(4),parameter :: BCond=(/'FF','FR','RF','RR'/)


  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8), parameter  :: pi=3.1415926535897932385D0

  integer :: l

  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wt_mpi_module_supack_torvelbc_test', &
       'wt_mpi_module_supack wt_TorgBoundariesGrid subroutine test')

  call wt_mpi_initial(im,jm,km,nm,lm,ri,ro)

  allocate(xvz_TorVel0(0:im-1,jc,0:km))
  allocate(xvz_TorVel(0:im-1,jc,0:km))
  allocate(wt_TorVel(nc,0:lm))
  allocate(xvz_Zero(0:im-1,jc,0:km))
  allocate(xvz_True(0:im-1,jc,0:km))

  xvz_Zero = 0.0D0

  do l=1,4

     ! P_10
     !xvz_TorVel = sin(xvz_lat) * cos( pi*(xvz_rad-ri)/(ro-ri) )
     ! P_1_1
     !xvz_TorVel = cos(xvz_lat)*cos(xvz_lon)* cos( pi*(xvz_rad-ri)/(ro-ri) )
     xvz_TorVel = 2*sin(xvz_lat)**2 * cos( pi*(xvz_rad-ri)/(ro-ri) )

     xvz_TorVel0 = xvz_TorVel
     wt_TorVel = wt_xvz(xvz_TorVel)
     call wt_TorBoundariesGrid(wt_TorVel,cond=BCond(l),new=.true.)
     xvz_TorVel = xvz_wt(wt_TorVel)

     ! 内部チェック
     call AssertEqual(&
          message='wt_TorBoundariesGrid_wt (intenal value)',            &
          answer = xvz_Torvel(:,:,1:km-1),                              &
          check = xvz_Torvel0(:,:,1:km-1),                              &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     ! 上端境界チェック
     if( BCond(l)(1:1) == 'F' ) then
        xvz_True = xvz_wt(wt_DRad_wt(wt_xvz(xvz_TorVel/xvz_Rad)))
     else
        xvz_True = xvz_TorVel
     endif

     call AssertEqual(&
          message='wt_TorvelBoundariesGrid_wt ('//BCond(l)//'-Top B.C)',&
          answer = xvz_Zero(:,:,0),                                     &
          check = xvz_True(:,:,0),                                      &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     ! 下端境界チェック
     if( BCond(l)(2:2) == 'F' ) then
        xvz_True = xvz_wt(wt_DRad_wt(wt_xvz(xvz_TorVel/xvz_Rad)))
     else
        xvz_True = xvz_TorVel
     endif

     call AssertEqual(&
          message='wt_TorvelBoundariesGrid_wt ('//BCond(l)//'-Bottom B.C)',&
          answer = xvz_Zero(:,:,km),                                    &
          check = xvz_True(:,:,km),                                     &
          significant_digits = check_digits, ignore_digits = ignore     &
          )
  enddo

  call MessageNotify('M','wt_mpi_module_supack_torvelbc_test', &
       'wt_mpi_module_supack  wt_TorvelBoundariesGrid subroutine test succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wt_mpi_module_supack_torvelbc_test

!----------------------------------------------------------------------
!     Copyright (c) 2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_av_galerkin_NN_test2d
!
!      チェビシェフ−ガラーキン法
!      両端ノイマン境界条件用モジュールテストプログラム(2次元)
!          f(:,x=xmin)=f(:,x=xmax)=0
!
!      例1 : f(x) = cos(pi*x),    0<x<1
!      例2 : f(x) = cos(2*pi*x),  0<x<1
!
!履歴  2005/12/30  竹広真一  新規作成
!      2006/01/23  竹広真一  モジュール名変更に伴う改訂
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!
program at_av_galerkin_NN_test2d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_av_galerkin_NN
  use at_module

  implicit none

  integer, parameter :: jm=2                   ! 1 次元目格子点数
  integer, parameter :: im=32                  ! 格子点数              
  integer, parameter :: km=32                  ! チェビシェフ切断波数  
  real(8), parameter :: xmin=0.0d0, xmax=1.0d0 ! 計算領域

  real(8) :: ag_data(jm,0:im)
  real(8) :: ag_data_orig(jm,0:im)
  real(8) :: pi
  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = - 10


  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','at_av_galerkin_NN_test2d', &
    & '2D both Neumman B.C.')

  call at_Initial(im,km,xmin,xmax)
  call at_av_galerkin_NN_Initial(im,km)           !--- 両端ディリクレ ---

  ag_data(1,:) = cos(pi*g_X)
  ag_data(2,:) = cos(2.0d0*pi*g_X)
  ag_data_orig = ag_data
  ag_data = ag_av(av_ag(ag_data))

  call AssertEqual(&
    & message = 'Grid -> Galerkin -> Grid ',                    &
    & answer  = ag_data_orig,                                   &
    & check   = ag_data,                                        &
    & significant_digits = check_digits, ignore_digits = ignore &
    )
!  だめな例
!  ag_data = ag_av(av_Dx_av(av_Dx_av(av_data)))
!  よい例 : 微分値はチェビシェフ係数で保持するべし
  ag_data = ag_av(av_at(at_Dx_at(at_Dx_at(at_av(av_ag(ag_data))))))
  ag_data_orig(1,:) = -     pi**2 * ag_data_orig(1,:) 
  ag_data_orig(2,:) = - 4 * pi**2 * ag_data_orig(2,:) 

  call AssertEqual(&
    & message = 'Grid -> Galerkin -> (Dx)^2 -> Grid',           &
    & answer  = ag_data_orig,                                   &
    & check   = ag_data,                                        &
    & significant_digits = check_digits, ignore_digits = ignore &
    )

  call MessageNotify('M','at_av_galerkin_NN_test2d', &
    & '2D both Neumman B.C. succeeded')

end program at_av_galerkin_NN_test2d

!--
!----------------------------------------------------------------------
! Copyright (c) 2011 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  lumatrix_omp : 行列の LU 分解による線形連立方程式の解法(Vector版)
!
!履歴  1990/08/31(numaguti)
!      1999/11/10(takepiro) LUSOLM 追加
!      2002/01/20(takepiro) ispack-f90 用に抜きだし
!      2002/06/10(takepiro) ベクトル長問題対応 lusol2 を用意.
!      2008/10/29(takepiro) OpenMP 用に改造
!      2009/08/06(takepiro) LUMAK1 追加
!      2011/02/20 佐々木洋平 Fortran90 化
!      2016/04/11(takepiro) ベクトル長問題対応 lusol3 を用意.
!++
subroutine lumake(alu, kp, jdim, ndim)
  !
  ! * ndim x ndim の行列 jdim 個を一度に計算
  ! * LU 行列は入力に上書きされる
  !
  implicit none
  integer, intent(in)    :: jdim
  integer, intent(in)    :: ndim
  integer, intent(out)   :: kp(jdim, ndim)
  real(8), intent(inout) :: alu(jdim, ndim, ndim)
  integer :: j, k, m, n
  real(8) :: pivot, temp

  do k=1,ndim-1
    do j=1,jdim
!! pivot 選択
      pivot   = alu(j,k,k)
      kp(j,k) = k
      do m=k+1,ndim
        if ( abs(alu(j,m,k)) .gt. abs(pivot)) then
          pivot   = alu(j,m,k)
          kp(j,k) = m
        end if
      end do
      if ( kp(j,k) .ne. k ) then
        do n=1,ndim
          temp             = alu(j,k,n)
          alu(j,k,n)       = alu(j,kp(j,k),n)
          alu(j,kp(j,k),n) = temp
        end do
      end if

!! LU 分解
      do n=k+1,ndim
        alu(j,k,n) = alu(j,k,n)/pivot
        do m=k+1,ndim
          alu(j,m,n) = alu(j,m,n) - alu(j,m,k) * alu(j,k,n)
        end do
      end do
    end do
  end do
end subroutine lumake

subroutine lumak1(alu, kp, ndim)
  !
  ! * ndim x ndim の行列一個を計算
  ! * LU 行列は入力に上書き
  !
  implicit none
  integer, intent(in)    :: ndim
  real(8), intent(inout) :: alu(ndim,ndim)
  integer, intent(out)   :: kp(ndim)
  call lumake(alu, kp, 1, ndim)
end subroutine lumak1

subroutine lusolv(xv, alu, kp, idim, jdim, ndim)
  !
  ! * ndim x ndim 行列を jdim 個並べた連立方程式 AX = B を idim 個 の B
  !   について計算する.
  ! * 解は右辺入力ベクトルに上書きされる
  !
  implicit none
  integer, intent(in) :: idim
  integer, intent(in) :: jdim
  integer, intent(in) :: ndim
  real(8), intent(inout) :: xv(idim, jdim, ndim)
  real(8), intent(in) :: alu(jdim, ndim, ndim)
  integer, intent(in) :: kp(jdim, ndim)
  integer :: i, j, k, n, nn
  real(8) :: temp

  do k=1, ndim-1
    do i=1, idim
      do j=1,jdim
        if ( kp(j,k) .ne. k ) then
          temp            = xv(i,j,k)
          xv(i,j,k)       = xv(i,j,kp(j,k))
          xv(i,j,kp(j,k)) = temp
        end if
      end do
    end do
  end do

  do n=1, ndim
    do i=1, idim
      do j=1, jdim
        xv(i,j,n) = xv(i,j,n)/alu(j,n,n)
      end do
    end do
    do nn=n+1,ndim
      do i=1, idim
        do j=1, jdim
          xv(i,j,nn) = xv(i,j,nn) - xv(i,j,n) * alu(j,nn,n)
        end do
      end do
    end do
  end do
  do k=ndim-1, 1, -1
    do n=k+1,ndim
      do i=1,idim
        do j=1,jdim
          xv(i,j,k) = xv(i,j,k) - xv(i,j,n) * alu(j,k,n)
        end do
      end do
    end do
  end do
end subroutine lusolv

subroutine lusol3(xv, alu, kp, jdim, ndim)
  !
  ! * ndim x ndim 行列を jdim 個並べた連立方程式 AX = B を jdim 個 の B
  !   について計算する.
  ! * 解は右辺入力ベクトルに上書きされる
  !
  implicit none
  integer, intent(in) :: jdim
  integer, intent(in) :: ndim
  real(8), intent(inout) :: xv(jdim, ndim)
  real(8), intent(in) :: alu(jdim, ndim, ndim)
  integer, intent(in) :: kp(jdim, ndim)
  integer :: j, k, n, nn
  real(8) :: temp

  do k=1, ndim-1
     do j=1,jdim
        if ( kp(j,k) .ne. k ) then
           temp            = xv(j,k)
           xv(j,k)       = xv(j,kp(j,k))
           xv(j,kp(j,k)) = temp
        end if
     end do
  end do

  do n=1, ndim
     do j=1, jdim
        xv(j,n) = xv(j,n)/alu(j,n,n)
     end do
     do nn=n+1,ndim
        do j=1, jdim
          xv(j,nn) = xv(j,nn) - xv(j,n) * alu(j,nn,n)
        end do
     end do
  end do
  do k=ndim-1, 1, -1
    do n=k+1,ndim
       do j=1,jdim
          xv(j,k) = xv(j,k) - xv(j,n) * alu(j,k,n)
       end do
    end do
  end do
end subroutine lusol3

subroutine lusol2(xv, alu, kp, idim, ndim)
  !
  ! * ndim x ndim 型行列の連立方程式 A X = B を idim 個の B に対して計算.
  ! * 解は右辺の入力ベクトルに上書きされる.
  ! * LUSOLV の JDIM = 1 に相当. JDIM=1 には際のベクトル長が短くなるため,
  !   このルーチンを用意している
  !
  implicit none
  integer, intent(in) :: idim
  integer, intent(in) :: ndim
  real(8), intent(inout) :: xv(idim, ndim)
  real(8), intent(in) :: alu(ndim,ndim)
  integer, intent(in) :: kp(ndim)
  integer :: i, k, n, nn
  real(8) :: temp

  do k = 1, ndim-1
    do i = 1, idim
      if ( kp ( k ) .ne. k ) then
        temp           = xv ( i,k )
        xv ( i,k )     = xv ( i,kp(k) )
        xv ( i,kp(k) ) = temp
      endif
    end do
  end do

  do n = 1, ndim
    do i = 1, idim
      xv ( i,n ) = xv ( i,n ) / alu ( n,n )
      do nn = n+1, ndim
        xv ( i,nn ) = xv ( i,nn ) - xv ( i,n ) * alu ( nn,n )
      end do
    end do
  end do

  do k = ndim-1, 1, -1
    do n = k+1, ndim
      do i = 1, idim
        xv ( i,k ) = xv ( i,k ) - xv ( i,n ) * alu ( k,n )
      end do
    end do
  end do

end subroutine lusol2

subroutine lusolm(xv, alu, kp, jmtx, idim, jdim, ndim)
  !
  ! * jdim 個の ndim x ndim 型行列について
  !   連立方程式 A X = B を idim 個の B に対して計算.
  ! * 解は右辺の入力ベクトルに上書きされる.
  !
  implicit none
  integer, intent(in)    :: idim
  integer, intent(in)    :: jdim
  integer, intent(in)    :: ndim
  real(8), intent(inout) :: xv(idim, ndim)
  real(8), intent(in)    :: alu(jdim, ndim, ndim)
  integer, intent(in)    :: kp(jdim, ndim)
  integer, intent(in)    :: jmtx(idim)
  integer :: i, k, n, nn
  real(8) :: temp

  do k = 1, ndim-1
    do i = 1, idim
      if ( kp ( jmtx(i),k ) .ne. k ) then
        temp             = xv ( i,k )
        xv ( i,k )       = xv ( i,kp(jmtx(i),k) )
        xv ( i,kp(jmtx(i),k) ) = temp
      endif
    end do
  end do
  do  n = 1, ndim
    do i = 1, idim
      xv ( i,n ) = xv ( i,n ) / alu ( jmtx(i),n,n )
    end do
    do  nn = n+1, ndim
      do i = 1, idim
        xv ( i,nn ) = xv ( i,nn ) - xv ( i,n ) * alu ( jmtx(i),nn,n )
      end do
    end do
  end do
  do  k = ndim-1, 1, -1
    do  n = k+1, ndim
      do  i = 1, idim
        xv ( i,k ) = xv ( i,k ) - xv ( i,n ) * alu ( jmtx(i),k,n )
      end do
    end do
  end do
end subroutine lusolm

!----------------------------------------------------------------------
! Copyright(c) 2009-2011 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  INDEXX :" 小さい順番号付け テストプログラム
!
!履歴  2009/02/06  竹広真一
!      2011/03/06  佐々木洋平
!
program indexx_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  implicit none

  interface
    function indexx(arrin)
      real(8), dimension(:), intent(in)  :: arrin
      integer, dimension(size(arrin))    :: indexx
    end function indexx
  end interface

  integer, parameter         :: narray = 5
  real(8), dimension(narray) :: array
  integer, dimension(narray) :: indary
  integer, dimension(narray) :: indary_sol

  array = (/-1.0D0, 1.0D0, -3.0D0, 2.0D0, 0.0D0/)
  indary = indexx(array)

  call MessageNotify('M','indexx_test','test of index sorting')

  indary_sol = (/3,1,5,2,4/)
  call AssertEqual(                            &
    message = 'Index check, increasing order', &
    answer  =  indary_sol,                     &
    check   =  indary )

  indary_sol = (/4,2,5,1,3/)
  call AssertEqual(                            &
    message = 'Index check, decreasing order', &
    answer  =  indary_sol,                     &
    check   =  indary(narray:1:-1) )

  call MessageNotify('M','indexx_test','test of index sorting succeeded!')

end program indexx_test

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wa_base_module_supack テストプログラム :: 基本変換関数のテスト
!
!履歴  2016/03/15  竹広真一
!      2016/03/30  竹広真一 wa_cleanup_wa 関数追加
!
program ua_base_mpi_module_svpack_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ua_mpi_module_svpack
  use mpi
  implicit none

  integer, parameter :: im=32, jm=16, nm=10, km=4

  real(8), allocatable ::  ua_data(:,:)
  real(8), allocatable ::  xyb_data(:,:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: pi
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','ua_base_mpi_module_svpack_test', &
                         'ua_base_mpi_module_svpack functions tests') 

  call ua_mpi_Initial( nm, im, jm, km )  
  
  allocate(ua_data(nc,km))
  allocate(xyb_data(0:im-1,jm,kc))

  !========================= xva_wa, wa_xva のテスト===========================

  !---- Y_1^* のテスト ----
  ua_data= 0.0D0 ; xyb_data = 0.0D0
  if ( kp_kl(1) /= 0 ) xyb_data(:,:,kp_kl(1)) = 1.0                  ! Y_0^0
  if ( l_nm(0,0) /= 0 ) ua_data(l_nm(0,0),1)=1.0D0
  if ( kp_kl(2) /= 0 ) xyb_data(:,:,kp_kl(2)) = sqrt(3.0D0)*sin(xy_Lat) ! Y_1^0
  if ( l_nm(1,0) /= 0 ) ua_data(l_nm(1,0),2)=1.0D0
  if ( kp_kl(3) /= 0 ) xyb_data(:,:,kp_kl(3)) = sqrt(3.0D0/2)*cos(xy_Lat)*cos(xy_Lon)     ! Y_1^1
  if ( l_nm(1,1) /= 0 ) ua_data(l_nm(1,1),3)=1.0D0/2.0D0
  if ( kp_kl(4) /= 0 )  xyb_data(:,:,kp_kl(4)) = -sqrt(3.0D0/2)*cos(xy_Lat)*sin(xy_Lon)    ! Y_1^{-1}
  if ( l_nm(1,-1) /= 0 ) ua_data(l_nm(1,-1),4)=1.0D0/2.0D0

  call AssertEqual(&
    message='wa_xya with Y_1^*',                                  &
    answer = ua_cleanup_ua(ua_xyb(xyb_data)),                     &
    check = ua_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyb_ua with Y_1^*',                                  &
    answer = xyb_ua(ua_xyb(xyb_data)),                            &
    check = xyb_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^* のテスト ----
  ua_data= 0.0D0 ; xyb_data = 0.0D0
  if ( kp_kl(1) /= 0 ) &
       xyb_data(:,:,kp_kl(1)) = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0) ! Y_2^0
  if ( l_nm(2,0) /= 0 ) ua_data(l_nm(2,0),1)=1.0D0
  if ( kp_kl(2) /= 0 ) &
       xyb_data(:,:,kp_kl(2)) = sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat)*cos(xy_Lon) !Y_2^1
  if ( l_nm(2,1) /= 0 ) ua_data(l_nm(2,1),2)=1.0D0/2.0D0
  if ( kp_kl(3) /= 0 ) &
       xyb_data(:,:,kp_kl(3)) = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(2*xy_Lon)   ! Y_2^-2
  if ( l_nm(2,-2) /= 0 ) ua_data(l_nm(2,-2),3)=1.0D0/2.0D0
  if ( kp_kl(4) /= 0 ) &
       xyb_data(:,:,kp_kl(4)) = sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*cos(2*xy_Lon)   ! Y_2^2
  if ( l_nm(2,2) /= 0 ) ua_data(l_nm(2,2),4)=1.0D0/2.0D0

  call AssertEqual(&
    message='ua_xyb with Y_2^*',                                  &
    answer = ua_cleanup_ua(ua_xyb(xyb_data)),                     &
    check = ua_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyb_ua with Y_2^*',                                  &
    answer = xyb_ua(ua_xyb(xyb_data)),                            &
    check = xyb_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的関数のテスト ----
  xyb_data = 0.0D0
  if ( kp_kl(1) /= 0 ) &
       xyb_data(:,:,kp_kl(1)) = cos(2*xy_Lon-pi/3) &
          *(sin(xy_Lat)-1)**2*(sin(xy_Lat)-0.5)*(sin(xy_Lat)+1)
  if ( kp_kl(2) /= 0 ) &
       xyb_data(:,:,kp_kl(2)) = sin(2*xy_Lon+pi/2) &
          *(sin(xy_Lat)-1)**2*(sin(xy_Lat)+1)**2
  if ( kp_kl(3) /= 0 ) &
       xyb_data(:,:,kp_kl(3)) = cos(2*xy_Lon+pi/3) &
          *(sin(xy_Lat)-1)*(sin(xy_Lat)-0.5)**2*(sin(xy_Lat)+1)
  if ( kp_kl(4) /= 0 ) &
       xyb_data(:,:,kp_kl(4)) = cos(2*xy_Lon+pi/2) &
          *(sin(xy_Lat)-1)**2*(sin(xy_Lat)+1)**2
       
  call AssertEqual(&
    message='ua_xyb, xyb_ua with a general function',             &
    answer = xyb_ua(ua_xyb(xyb_data)),                            &
    check = xyb_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','ua_base_mpi_module_svpack_test', &
                         'ua_base_mpi_module_svpack functions tests succeeded!') 

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

contains

  function ua_cleanup_ua(ua_data)
    real(8), intent(IN) :: ua_data(:,:)
    real(8)             :: ua_cleanup_ua(nc,size(ua_data,2))

    integer l,nmary(2)

    ua_cleanup_ua = ua_data

    do l=1,nc
       nmary = nm_l(l)
       if ( nmary(1) .lt. 0 ) ua_cleanup_ua(l,:) = 0.0D0
    end do

  end function ua_cleanup_ua

end program ua_base_mpi_module_svpack_test

!----------------------------------------------------------------------
!     Copyright (c) 2012 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wa_deriv_mpi_module テストプログラム :: 微分関数のテスト
!
!履歴  2012/04/03  竹広真一
!
program wa_deriv_mpi_module_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wa_mpi_module
  use mpi
  implicit none

  integer, parameter :: im=32, jm=16, nm=10, km=2

  real(8), allocatable  ::  xva_data1(:,:,:)              ! 元の関数
  real(8), allocatable  ::  xva_data2(:,:,:)              ! 元の関数
  real(8), allocatable  ::  xva_ddata(:,:,:)              ! 微分の正解
  real(8), allocatable  ::  xv_mu(:,:)                    ! μ=sinφ

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer :: iproc, np, ierr


 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wa_deriv_mpi_module_test', &
                         'wa_deriv_mpi_module function tests') 

  call wa_mpi_Initial( nm, im, jm, km )

  allocate(xva_data1(0:im-1,jc,km))
  allocate(xva_data2(0:im-1,jc,km))
  allocate(xva_ddata(0:im-1,jc,km))
  allocate(xv_mu(0:im-1,jc))

  !============== 微分計算 (lon,lat座標系用) のテスト ==============

  !---- Y_1^-1 Y_2^1 のテスト ----
  xva_data1(:,:,1) = -cos(xv_Lat)*sin(xv_Lon)             ! Y_1^{-1}
  xva_data1(:,:,2)  = sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon) ! Y_2^1

  xva_ddata(:,:,1) = 2*cos(xv_Lat)*sin(xv_Lon)             ! wa_Lapla_wa
  xva_ddata(:,:,2) = -6*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon) ! Y_2^1
  call AssertEqual(&
    message='wa_Lapla_wa with Y_1^-1 and Y^2_1',                  &
    answer = xva_wa(wa_Lapla_wa(wa_xva(xva_data1))),              &
    check = xva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xva_ddata(:,:,1) = 1.0/2.0*cos(xv_Lat)*sin(xv_Lon)      ! wa_LaplaInv_wa
  xva_ddata(:,:,2) = -1.0D0/6.0*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)
  call AssertEqual(&
    message='wa_LaplaInv_wa with Y_1^-1 and Y^2_1',               &
    answer = xva_wa(wa_LaplaInv_wa(wa_xva(xva_data1))),           &
    check = xva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xva_ddata(:,:,1) = -cos(xv_Lat)*cos(xv_Lon)         ! wa_DLon_wa
  xva_ddata(:,:,2) = -sin(xv_Lat)*cos(xv_Lat) * sin(xv_Lon)
  call AssertEqual(&
    message='wa_DLon_wa with Y_1^-1 and Y^2_1',                   &
    answer = xva_wa(wa_DLon_wa(wa_xva(xva_data1))),               &
    check = xva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xva_ddata(:,:,1) = -cos(xv_Lon)                     ! xva_GradLon_wa
  xva_ddata(:,:,2) = -sin(xv_Lat) * sin(xv_Lon)
  call AssertEqual(&
    message='xva_GradLon_wa with Y_1^-1 and Y^2_1',               &
    answer = xva_GradLon_wa(wa_xva(xva_data1)),                   &
    check = xva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xva_ddata(:,:,1) = sin(xv_Lat)*sin(xv_Lon)         ! xva_GradLat_wa
  xva_ddata(:,:,2) = cos(2*xv_Lat) * cos(xv_Lon)
  call AssertEqual(&
    message='xva_GradLat_wa with Y_1^-1 and Y^2_1',               &
    answer = xva_GradLat_wa(wa_xva(xva_data1)),                   &
    check = xva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_1^-1 cosφ, Y_2^1 cosφ のテスト ----
  xva_data1(:,:,1) = -cos(xv_Lat)**2*sin(xv_Lon)              ! Y_1^-1 cosφ
  xva_data1(:,:,2) = sin(xv_Lat)*cos(xv_Lat)**2 * cos(xv_Lon) ! Y_2^1 cosφ

  xva_ddata(:,:,1) = -cos(xv_Lat)*cos(xv_Lon)                ! wa_DivLon_xv
  xva_ddata(:,:,2) = -sin(xv_Lat)*cos(xv_Lat)*sin(xv_Lon)    ! wa_DivLon_xv
  call AssertEqual(&
    message='wa_DivLon_xva with Y_1^-1 cosφ and Y^2_1 cosφ',    &
    answer = xva_wa(wa_DivLon_xva(xva_data1)),                    &
    check = xva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xva_ddata(:,:,1) = 3*sin(xv_Lat)*cos(xv_Lat)*sin(xv_Lon)        !wa_DivLat_wa
  xva_ddata(:,:,2) = cos(xv_Lat)*(1-4*sin(xv_Lat)**2)*cos(xv_Lon) !wa_DivLat_wa
  call AssertEqual(&
    message='wa_DivLat_xva with Y_1^-1 cosφ and Y^2_1 cosφ',    &
    answer = xva_wa(wa_DivLat_xva(xva_data1)),                    &
    check = xva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Jacobian のテスト ----
  xva_data1(:,:,1) = -cos(xv_Lat)*sin(xv_Lon)                ! Y_1^{-1}
  xva_data1(:,:,2) = -cos(xv_Lat)*sin(xv_Lon)                ! Y_1^{-1}
  xva_data2(:,:,1) = -cos(xv_Lat)*sin(xv_Lon)                ! Y_1^{-1}
  xva_data2(:,:,2) = sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)   ! Y_2^1

  xva_ddata(:,:,1) = 0.0
  xva_ddata(:,:,2) = sin(xv_Lat)**2 - cos(xv_Lat)**2*cos(xv_Lon)**2
   call AssertEqual(&
    message='wa_JacobianMPI_wa_wa Y_1^-1 and Y^2_1',                 &
    answer = xva_wa(wa_JacobianMPI_wa_wa(wa_xva(xva_data1),wa_xva(xva_data2))), &
    check = xva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  !============== 微分計算 (λ,μ座標系用) のテスト ==============
  xv_mu = sin(xv_Lat)

  !----- Y_2^0, Y_1^1 のテスト -----
  xva_data1(:,:,1) = 3*xv_mu**2-1                              ! Y_2^0
  xva_data1(:,:,2) = sqrt(1-xv_mu**2)*cos(xv_Lon)                  ! Y_1^1

  xva_ddata(:,:,1) = 0.0
  xva_ddata(:,:,2) = -sqrt(1-xv_mu**2)*sin(xv_Lon)
  call AssertEqual(&
    message='xva_GradLambda_wa with Y_2^0 and Y^1_1',             &
    answer = xva_GradLambda_wa(wa_xva(xva_data1)),                &
    check = xva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xva_ddata(:,:,1) = 6*xv_mu*(1-xv_mu**2)
  xva_ddata(:,:,2) = -xv_mu*sqrt(1-xv_mu**2)*cos(xv_Lon)
  call AssertEqual(&
    message='xva_GradMu_wa with Y_2^0 and Y^1_1',                 &
    answer = xva_GradMu_wa(wa_xva(xva_data1)),                    &
    check = xva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !----- Y_2^0(1-μ^2), Y_1^1 (1-μ^2) のテスト -----
  xva_data1(:,:,1) = (3*xv_mu**2-1)*(1-xv_mu**2)       ! Y_2^0 (1-μ^2)
  xva_data1(:,:,2) = (1-xv_mu**2)**(3.0/2)*cos(xv_Lon) ! Y_1^1 (1-μ^2)

  xva_ddata(:,:,1) = 0.0
  xva_ddata(:,:,2) = -(1-xv_mu**2)**(1.0d0/2)*sin(xv_Lon)
  call AssertEqual(&
    message='wa_DivLambda_xva with Y_2^0 (1-μ^2) and Y^1_1 √(1-μ^2)',&
    answer = xva_wa(wa_DivLambda_xva(xva_data1)),                 &
    check = xva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xva_ddata(:,:,1) = (2-3*xv_mu**2)*4*xv_mu
  xva_ddata(:,:,2) = -3.0D0*xv_mu*(1-xv_mu**2)**(1.0D0/2)*cos(xv_Lon)
  call AssertEqual(&
    message='wa_DivMu_xva with Y_2^0 (1-μ^2) and Y^1_1 √(1-μ^2)',&
    answer = xva_wa(wa_DivMu_xva(xva_data1)),                     &
    check = xva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wa_deriv_mpi_module_test', &
                         'wa_deriv_mpi_module function tests succeeded!') 

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wa_deriv_mpi_module_test

!--
!----------------------------------------------------------------------
!  Copyright (c) 2005-2006 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_ad_galerkin_DD1
!
!      チェビシェフ−ガラーキン法両端ディリクレ境界条件用モジュール
!        f(:,i=0)=f(:,i=im)=0
!
!      k 次のガラーキン基底が
!
!        \phi_k(x)=T_k(x) + C_{k-1}T_{k-1}(x) + C_{k-2}T_{k-2}(x) 
!
!      の型式(Type1)
!
!      定式化については解説文書
!
!         「チェビシェフ関数展開を利用したガラーキン法」
!
!      (cheb_gal.pdf)を参照のこと. 
!
!履歴  2005/01/20  竹広真一  新規作成
!      2006/01/23  竹広真一  モジュール名変更
!      2006/01/25  竹広真一  モジュール初期化フラッグ導入
!      2006/02/28  竹広真一  コメントを RDoc 用に変更
!      2009/01/29  佐々木洋平  コメントを RDoc 用に変更
!
!++
module at_ad_galerkin_DD
  !
  != at_ad_galerkin_DD
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/at_ad_galerkin_DD モジュールはチェビシェフ−ガラーキン法,
  ! 両端ディリクレ境界条件
  !
  !      f(:,i=0)=f(:,i=im)=0
  !
  ! を  k 次のガラーキン基底が
  !
  !    \phi_k(x)=T_k(x) + C_{k-1}T_{k-1}(x) + C_{k-2}T_{k-2}(x) 
  !
  ! の型式(Type1)を用いて計算するためのモジュールである.
  !
  ! 定式化については解説文書「チェビシェフ関数展開を利用したガラーキン法」
  ! (cheb_gal.pdf[link:link:cheb_gal.pdf])を参照のこと. 
  !
  use lumatrix
  use at_module
  use dc_message

  implicit none

  private
  public :: at_ad_galerkin_DD_Initial  ! 初期化サブルーチン
  public :: ad_at, d_t                 ! チェビシェフ->ガラーキン変換
  public :: ad_ag, d_g                 ! 格子点->ガラーキンデータ変換
  public :: at_ad, t_d                 ! ガラーキン->チェビシェフ変換
  public :: ag_ad, g_d                 ! ガラーキン->格子点データ変換
  public :: ad_Dx_ad, d_Dx_d           ! X 微分

  real(8), allocatable :: TD(:,:)      ! ガラーキン->チェビシェフ変換行列
  real(8), allocatable :: DT(:,:)      ! チェビシェフ->ガラーキン変換行列
  integer, allocatable :: kp(:)        ! LU 分解用ピボット格納配列

  real(8), allocatable :: alpha(:)     ! チェビシェフ<->ガラーキン行列積係数
  real(8), allocatable :: beta(:)      ! チェビシェフ<->ガラーキン行列和係数

  integer :: im                        ! 格子点数              
  integer :: km                        ! チェビシェフ切断波数  
  integer,parameter :: ks=2            ! ガラーキン基底最低次数

  logical :: DD_Initialized=.false.    ! 初期化フラッグ

  save im, km, TD, DT, kp, alpha, beta, DD_Initialized
  public TD, DT, alpha, beta

contains

  subroutine at_ad_galerkin_DD_Initial(i_in,k_in)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ディリクレ境界条件用モジュール
    !
    ! 初期化サブルーチン
    !

    integer, intent(IN) :: i_in     ! (in)格子点数
    integer, intent(IN) :: k_in     ! (in)チェビシェフ切断波数  

    integer :: k, l, m, n

    im=i_in ; km=k_in

    allocate(TD(0:km,ks:km),DT(ks:km,ks:km),kp(ks:km))
    allocate(alpha(0:km),beta(0:km))

    ! 両端ディリクレ条件用変換行列設定
    TD = 0.0D0
    do k=ks,km
       TD(k,k) = 1.0D0
       TD(k-2,k) = -1.0D0
    enddo

    beta=1.0 ; beta(0)=0.5D0
    if (im .eq. km ) beta(km)=0.5D0

    ! 両端ディリクレ条件用変換逆行列
    alpha=1.0 ; alpha(0)=2.0D0

    DT = 0.0D0
    do m=ks,km
       do n=ks,km
          do l=0,km
             DT(m,n) = DT(m,n) + alpha(l)*TD(l,m)*TD(l,n)
          enddo
       enddo
    enddo

    call LUDecomp(DT,kp)

    call MessageNotify('M','at_ad_galerkin_DD_Initial',&
                           'Conversion matrices initialized')

    DD_Initialized = .true.

  end subroutine at_ad_galerkin_DD_Initial

  function ad_at(at_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ディリクレ境界条件
    !
    ! チェビシェフ係数 -> ガラーキン係数変換(2次元データ)
    !
    real(8), intent(IN) :: at_data(:,0:)                !(in)  チェビシェフ係数
    real(8)             :: ad_at(size(at_data,1),ks:km) !(out) ガラーキン係数  

    real(8)             :: ad_work(size(at_data,1),ks:km)  ! 作業用配列
    
    integer :: k,m

    if ( .not. DD_Initialized ) &
         call MessageNotify('E','ad_at',&
                            'at_ad_galerkin_DD_module not initialized')

    ad_work =0.0
    do m=ks,km
       do k=0,km
          ad_work(:,m) = ad_work(:,m) &
               + alpha(k) * beta(k) * at_data(:,k) * TD(k,m)
       enddo
    enddo

    ad_at = LUSolve(DT,kp,ad_work)

  end function ad_at

  function d_t(t_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ディリクレ境界条件
    !
    ! チェビシェフ係数 -> ガラーキン係数変換(1次元データ)
    !

    real(8), intent(IN) :: t_data(0:km)        !(in)  チェビシェフ係数
    real(8)             :: d_t(ks:km)          !(out) ガラーキン係数  

    real(8)             :: d_work(ks:km)       ! 作業用配列

    integer :: k,m

    if ( .not. DD_Initialized ) &
         call MessageNotify('E','d_t',&
                            'at_ad_galerkin_DD_module not initialized')

    d_work =0.0
    do m=ks,km
       do k=0,km
          d_work(m) = d_work(m) &
               + alpha(k) * beta(k) * t_data(k) * TD(k,m)
       enddo
    enddo

    d_t = LUSolve(DT,kp,d_work)

  end function d_t

  function at_ad(ad_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ディリクレ境界条件
    !
    ! ガラーキン係数 -> チェビシェフ係数変換(2次元データ)
    !

    real(8), intent(IN)  :: ad_data(:,ks:)              !(in)  ガラーキン係数
    real(8)              :: at_ad(size(ad_data,1),0:km) !(out) チェビシェフ係数
    integer :: m, n

    if ( .not. DD_Initialized ) &
         call MessageNotify('E','at_ad',&
                            'at_ad_galerkin_DD_module not initialized')

    at_ad = 0.0D0
    do m=0,km
       do n=ks,km
          at_ad(:,m) = at_ad(:,m) + TD(m,n)*ad_data(:,n)/beta(m)
       enddo
    enddo

  end function at_ad

  function t_d(d_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ディリクレ境界条件
    !
    ! ガラーキン係数 -> チェビシェフ係数変換(1次元データ)
    !
    real(8), intent(IN)  :: d_data(ks:km)       !(in)  ガラーキン係数  
    real(8)              :: t_d(0:km)           !(out) チェビシェフ係数

    integer :: m, n

    if ( .not. DD_Initialized ) &
         call MessageNotify('E','t_d',&
                            'at_ad_galerkin_DD_module not initialized')

    t_d = 0.0D0
    do m=0,km
       do n=ks,km
          t_d(m) = t_d(m) + TD(m,n)*d_data(n)/beta(m)
       enddo
    enddo

  end function t_d

  function ad_ag(ag_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ディリクレ境界条件
    !
    ! 格子点データ -> ガラーキン係数変換(2次元データ)
    !

    real(8), intent(IN)  :: ag_data(:,0:)                !(in)  格子点データ
    real(8)              :: ad_ag(size(ag_data,1),ks:km) !(out) ガラーキン係数

    ad_ag = ad_at(at_ag(ag_data))
  end function ad_ag

  function d_g(g_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ディリクレ境界条件
    !
    ! 格子点データ -> ガラーキン係数変換(1次元データ)
    !
    real(8), intent(IN)  :: g_data(0:im)        !(in)  格子点データ
    real(8)              :: d_g(ks:km)          !(out) ガラーキン係数

    d_g = d_t(t_g(g_data))
  end function d_g

  function ag_ad(ad_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ディリクレ境界条件
    !
    ! ガラーキン係数 -> 格子点データ変換(2次元データ)
    !
    real(8), intent(IN) :: ad_data(:,ks:)              !(in)  ガラーキン係数  
    real(8)             :: ag_ad(size(ad_data,1),0:im) !(out) 格子点データ  
    
    ag_ad = ag_at(at_ad(ad_data))
  end function ag_ad

  function g_d(d_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ディリクレ境界条件
    !
    ! ガラーキン係数 -> 格子点データ変換(1次元データ)
    !
    real(8), intent(IN) :: d_data(ks:km)        !(in)  ガラーキン係数  
    real(8)             :: g_d(0:im)            !(out) 格子点データ  
    
    g_d = g_t(t_d(d_data))
  end function g_d

  function ad_Dx_ad(ad_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ディリクレ境界条件
    !
    ! X 微分計算(2 次元データ)
    !
    real(8), intent(IN) :: ad_data(:,ks:)                  !(in) ガラーキン係数
    real(8)             :: ad_Dx_ad(size(ad_data,1),ks:km) !(out) 微分ガラーキン
    ad_Dx_ad = ad_at(at_Dx_at(at_ad(ad_data)))
  end function ad_Dx_ad

  function d_Dx_d(d_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 両端ディリクレ境界条件
    !
    ! X 微分計算(1 次元データ)
    !
    real(8), intent(IN) :: d_data(ks:km)
    real(8)             :: d_Dx_d(ks:km)

    d_Dx_d = d_t(t_Dx_t(t_d(d_data)))

  end function d_Dx_d

end module at_ad_galerkin_DD

!--
!----------------------------------------------------------------------
!     Copyright (c) 2016 SPMDOEL Development Group
!----------------------------------------------------------------------
!表題  ua_base_mpi_module_svpack
!
!  spml/ua_base_mpi_module_svpack モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための 
!  モジュール ua_mpi_module_svpack の下部モジュールであり, 
!  スペクトル計算の基本的な Fortran90 関数を提供する. 
!
!  球面上の 1 層モデル用 w_base_module_svpack モジュールを多層モデル用に
!  並列化拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!  対する変換が行える.
!
!  内部で ISPACK2 の SVPACK/SUPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK2 の SVPACK/SUPACK のマニュアルを参照されたい.
!
!  このモジュールを使うためには前もって w_mpi_base_initial を呼んで
!  切断波数, 格子点数の設定をしておく必要がある. 
!
!
!履歴  2016/08/15  竹広真一  wa_base_module_svpack より多層 MPI 対応改造
!
!++
module ua_base_mpi_module_svpack
  !
  != ua_base_mpi_module_svpack
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !  spml/ua_base_mpi_module_svpack モジュールは球面上での流体運動を
  !  球面調和函数を用いたスペクトル法によって数値計算するための 
  !  モジュール ua_mpi_module_svpack の下部モジュールであり, 
  !  スペクトル計算の基本的な Fortran90 関数を提供する. 
  !
  !  球面上の 1 層モデル用 w_base_module_svpack モジュールを多層モデル用に
  !  並列化拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  !  対する変換が行える.
  !
  !  内部で ISPACK2 の SVPACK/SUPACK の Fortran77 サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK2 の SVPACK/SUPACK のマニュアルを参照されたい.
  !
  !  このモジュールを使うためには前もって w_mpi_base_initial を呼んで
  !  切断波数, 格子点数の設定をしておく必要がある. 
  !
  use dc_message
  use w_base_module_svpack, only : im, jm, nn, mm, xy_w, w_xy, &
                                   w_StreamPotential2Vector,   &
                                   w_Vector2VorDiv, w_VectorCosLat2VorDiv
  use w_base_mpi_module_supack, only : w_base_mpi_initial, nc, l_nm, nm_l
  use mpi
  
  implicit none

  integer               :: km=16         ! 同時に処理する最大データ数(層の数).
  integer               :: kc
  integer               :: k1, k2
  
  integer               :: np
  integer               :: ip

  private

  public km                                    ! 層数
  public ua_base_mpi_Initial                   ! 初期化サブルーチン
  public ua_base_mpi_Finalize                  ! 終了処理

  public nc
  public kc
  public k1, k2
  
  public l_nm, nm_l
  public kp_kl
  
  public xyb_ua, ua_xyb                        ! 変換関数
  public wb_ua, ua_wb                          ! 変換関数
  public ua_StreamPotential2VectorMPI          ! 流線ポテンシャルから速度場計算
  public ua_Vector2VorDivMPI                   ! 速度場から渦度発散を計算
  public ua_VectorCosLat2VorDivMPI             ! 速度場から渦度発散を計算

  save km                                      ! 最大データ数(層数)を記憶
  save np, ip
  save kc, k1, k2
 
  contains
  !--------------- 初期化 -----------------
    subroutine ua_base_mpi_initial(n_in,i_in,j_in,k_in)
      ! 
      ! ua_base_mpi_module 初期化
      !
      integer,intent(in) :: n_in               !(in) 切断波数
      integer,intent(in) :: i_in               !(in) 格子点数(東西)
      integer,intent(in) :: j_in               !(in) 格子点数(南北)
      integer,intent(in) :: k_in               !(in) 最大データ数(層数)
      
      integer :: ierr
      
      km = k_in

      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)

      call set_layerdiv(ip,k1,k2)
      kc = k2-k1+1                              ! 分散多層データの大きさ

      call w_base_mpi_initial(n_in,i_in,j_in)

      call MessageNotify('M','ua_base_mpi_initial', &
          'ua_base_mpi_module_svpack (2016/08/15) is initialized')

    end subroutine ua_base_mpi_initial

    subroutine set_layerdiv(ip,kk1,kk2)
      integer, intent(IN)  :: ip             ! プロセス番号
      
      integer, intent(OUT) :: kk1            ! 担当する層開始番号
      integer, intent(OUT) :: kk2            ! 担当する層終了番号

      integer :: ki
      
      ki=(km-1)/np+1
      if(ki*ip.lt.km) then
        kk1=1+ki*ip
        kk2=min(km,ki*(ip+1))
      else              ! 当該プロセスでは層データを担当しない場合
        kk1=0
        kk2=-1
      end if

    end subroutine set_layerdiv

    subroutine layer2procinfo(k,ipk,kp)
      integer, intent(IN)  :: k             ! 層番号
      integer, intent(OUT) :: ipk           ! 担当するプロセス番号
      integer, intent(OUT) :: kp            ! プロセス内での分割後層番号

      integer :: iip, kk1, kk2

      do iip=0,np-1
         call set_layerdiv(iip,kk1,kk2)
         if ( kk1 .le. k .AND. k .le. kk2 ) then
            ipk = iip
            kp = k - kk1 + 1
            goto 999
         end if
      end do

      call MessageNotify('E','layer2porcinfo','Process not found.')
      
999   continue
      
    end subroutine layer2procinfo
    
    !--------------- 基本関数 -----------------

    function kp_kl(kl)
      integer, intent(IN) :: kl             ! 層番号(全体)
      integer             :: kp_kl          ! 層番号(分割プロセス中)

      integer :: ipk

      call layer2procinfo(kl,ipk,kp_kl)
      if ( ip /= ipk ) kp_kl = 0

    end function kp_kl
    
    !--------------- データ入れ換え -----------------
    function wb_ua(ua_data)
      real(8), intent(IN) :: ua_data(nc,km)
      real(8)             :: wb_ua((mm+1)**2,kc)

      real(8) :: databuf((MM/NP+1)*(2*(NN+1)-MM/NP*NP)*NP*KM)
      integer :: nb, kk1, kk2, kp, m, ipk, k, kk, ns, ipdest, l, la, ierr

      NB=(MM/NP+1)*(2*(NN+1)-MM/NP*NP)
 
      do ipk=0,np-1
         call set_layerdiv(ipk,kk1,kk2)
         kp = kk2-kk1+1

         CALL MPI_GATHER(ua_data(:,kk1),NB*kp,MPI_REAL8, &
                         databuf,NB*kp,MPI_REAL8,&
                         IPK,MPI_COMM_WORLD,IERR)
      enddo

!$omp parallel do default(shared) private(m,kk,ns,ipdest,l,la)      
      do k=1,kc
         CALL SUCOPY(nn+1,databuf(nb*(k-1)+1),wb_ua(1,k))
         DO M=1,MM
            KK=M/NP
            NS=KK*(2*(NN+1)-(KK-1)*NP)+1
            CALL SUNM2L(NN,M,M,IPDEST,L)
            CALL SVNM2L(NN,M,M,LA)
            CALL SUCOPY(2*(NN+1-M),databuf(ns+nb*kc*ipdest+nb*(k-1)),wb_ua(la,k))   
         enddo
      END DO
!$omp end parallel do      
      
    end function wb_ua

    function ua_wb(wb_data)
      real(8), intent(IN) :: wb_data((mm+1)**2,kc)
      real(8)             :: ua_wb(nc,km)

      real(8) :: databuf( (mm/np+1)*(2*(nn+1)-mm/np*np)*np*km )
      integer :: ipk, kk1, kk2, kp, k, m, kk, NS, NB, IPDEST, L, LA, IERR

      NB=(MM/NP+1)*(2*(NN+1)-MM/NP*NP)
      
!$omp parallel do default(shared) private(m,kk,ns,ipdest,l,la)      
      do k=1,kc
         CALL SUCOPY(nn+1,wb_data(1,k),databuf(nb*(k-1)+1))
         DO M=1,MM
            KK=M/NP
            NS=KK*(2*(NN+1)-(KK-1)*NP)+1
            CALL SUNM2L(NN,M,M,IPDEST,L)
            CALL SVNM2L(NN,M,M,LA)
            CALL SUCOPY(2*(NN+1-M),wb_data(la,k),databuf(ns+nb*kc*ipdest+nb*(k-1)))
         enddo
      END DO
!$omp end parallel do
      
      do ipk=0,np-1
         call set_layerdiv(ipk,kk1,kk2)
         kp = kk2-kk1+1
         if ( kp == 0 ) then
            CALL MPI_SCATTER(databuf,NB*KP,MPI_REAL8,&
                             ua_wb(1,1),NB*KP,MPI_REAL8, &
                             ipk,MPI_COMM_WORLD,IERR)
         else
            CALL MPI_SCATTER(databuf,NB*KP,MPI_REAL8,&
                             ua_wb(1,kk1),NB*KP,MPI_REAL8, &
                             ipk,MPI_COMM_WORLD,IERR)
         endif
      enddo

    end function ua_wb
    
    !--------------- 基本変換 -----------------

    function xyb_ua(ua_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
      !
      ! スペクトルデータから格子データへ変換する(多層用).
      !
      real(8), intent(in)   :: ua_data(nc,km)
      !(in) スペクトルデータ
      !
      real(8)               :: xyb_ua(0:im-1,1:jm,kc)
      !(out) 格子点データ
      !
      integer, intent(in), optional  :: ipow
      !(in) 作用させる 1/cosφ の次数. 省略時は 0. 
      integer, intent(in), optional  :: iflag
      !(in) 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた逆変換
      !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
      !    2 : sinφを作用させた逆変換
      !    省略時は 0.
      !
      integer, parameter  :: ipow_default  = 0
      integer, parameter  :: iflag_default = 0
      integer ipval, ifval

      real(8) :: wb_data((mm+1)**2,kc)
      integer :: k

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      wb_data = wb_ua(ua_data)

      do k=1,kc
        xyb_ua(:,:,k) = xy_w(wb_data(:,k),iflag=ifval,ipow=ipval)
      enddo

    end function xyb_ua

    function ua_xyb(xyb_data,ipow,iflag) ! 格子点 -> 球面調和関数スペクトル
      !
      ! 格子データからスペクトルデータへ(正)変換する(多層用).
      !
      real(8), intent(in)   :: xyb_data(0:im-1,jm,kc)
      !(in) 格子点データ

      real(8)               :: ua_xyb(nc,km)
      !(out) スペクトルデータ

      integer, intent(in), optional  :: ipow
      !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

      integer, intent(in), optional  :: iflag
      ! 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた正変換 
      !    1 : 緯度微分 1/cosφ・∂(f cos^2φ)/∂φ を作用させた正変換
      !    2 : sinφを作用させた正変換
      !  省略時は 0.
      !
      integer, parameter  :: ipow_default  = 0      ! スイッチデフォルト値
      integer, parameter  :: iflag_default = 0      ! スイッチデフォルト値

      integer ipval, ifval

      real(8) :: wb_data((mm+1)**2,kc)
      integer k

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      do k=1,kc
         wb_data(:,k) = w_xy(xyb_data(:,:,k),iflag=ifval,ipow=ipval)
      enddo

      ua_xyb = ua_wb(wb_data)
      
    end function ua_xyb

    !----------- 速度, 渦度・発散, 流線・ポテンシャル計算 -------------

    subroutine ua_StreamPotential2VectorMPI(ua_Psi, ua_Chi, xyb_U, xyb_V)
      !
      ! 流線・ポテンシャル(スペクトルデータ)から速度場(格子データ)に
      ! (逆)変換する(多層用)
      !
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   u cosφ =      ∂χ/∂λ - cosφ∂ψ/∂φ, 
      !   v cosφ = cosφ∂χ/∂φ +      ∂ψ/∂λ 
      !
      real(8), intent(in)    :: ua_Psi(nc,km)
      !(in) 流線関数((nm+1)*(nm+1),:)

      real(8), intent(in)    :: ua_Chi(nc,km)
      !(in) 速度ポテンシャル((nm+1)*(nm+1),:)

      real(8), intent(out)   :: xyb_U(0:im-1,jm,kc)
      !(out) 速度経度成分(0:im-1,1:jm,:)

      real(8), intent(out)   :: xyb_V(0:im-1,jm,kc)
      !(out) 速度緯度成分(0:im-1,1:jm,:)

      real(8)  :: wb_Psi((mm+1)**2,kc)
      !(in) 流線関数((nm+1)*(nm+1),:)

      real(8) :: wb_Chi((mm+1)**2,kc)
      !(in) 速度ポテンシャル((nm+1)*(nm+1),:)

      integer :: k

      wb_Psi = wb_ua(ua_Psi)
      wb_Chi = wb_ua(ua_Chi)
      
      do k=1,kc
         call w_StreamPotential2Vector &
              ( wb_Psi(:,k), wb_Chi(:,k), xyb_U(:,:,k), xyb_V(:,:,k) )
      enddo

    end subroutine ua_StreamPotential2VectorMPI

    subroutine ua_Vector2VorDivMPI(xyb_U, xyb_V, ua_Vor, ua_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(多層用)
      ! 
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xyb_U(0:im-1,jm,kc)
      !(in) 速度経度成分(0:im-1,1:jm,:)

      real(8), intent(in)   :: xyb_V(0:im-1,jm,kc)
      !(in) 速度緯度成分(0:im-1,1:jm,:)

      real(8), intent(out)   :: ua_Vor(nc,km)
      !(out) 渦度
      real(8), intent(out)   :: ua_Div(nc,km)
      !(out) 発散

      real(8)  :: wb_Vor((mm+1)**2,kc)  ! 渦度
      real(8)  :: wb_Div((mm+1)**2,kc)  ! 発散

      integer :: k

      do k=1,kc
         call w_Vector2VorDiv &
               (xyb_U(:,:,k), xyb_V(:,:,k), wb_Vor(:,k), wb_Div(:,k))
      enddo

      ua_Vor = ua_wb(wb_Vor)
      ua_Div = ua_wb(wb_Div)      
      
    end subroutine ua_Vector2VorDivMPI

    subroutine ua_VectorCosLat2VorDivMPI(xyb_UCosLat, xyb_VCosLat, ua_Vor, ua_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(多層用)
      ! 
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xyb_UCosLat(0:im-1,jm,kc)
      !(in) 速度経度成分 * cos(lat) (0:im-1,1:jm,:)

      real(8), intent(in)   :: xyb_VCosLat(0:im-1,jm,kc)
      !(in) 速度緯度成分 * cos(lat) (0:im-1,1:jm,:)

      real(8), intent(out)   :: ua_Vor(nc,km)
      !(out) 流線関数
      real(8), intent(out)   :: ua_Div(nc,km)
      !(out) 速度ポテンシャル

      real(8)  :: wb_Vor((mm+1)**2,kc)  ! 渦度
      real(8)  :: wb_Div((mm+1)**2,kc)  ! 発散

      integer :: k

      do k=1,kc
         call w_VectorCosLat2VorDiv &
               (xyb_UCosLat(:,:,k), xyb_VCosLat(:,:,k), wb_Vor(:,k), wb_Div(:,k))
      enddo

      ua_Vor = ua_wb(wb_Vor)
      ua_Div = ua_wb(wb_Div)      

    end subroutine ua_VectorCosLat2VorDivMPI

  !--------------- 終了処理 -----------------
    subroutine ua_base_mpi_Finalize
      ! 
      !
      ! このサブルーチンを単独で用いるのでなく, 
      ! 上位サブルーチン wa_Finalize を使用すること.
      !
      call MessageNotify('M','ua_base_mpi_finalize',&
           'ua_base_mpi_module_svpack is finalized (dummy, 2016/08/15) ')

    end subroutine ua_base_mpi_Finalize

end module ua_base_mpi_module_svpack

! -*- mode: f90; coding: utf-8 -*-
!--
!------------------------------------------------------------------------
! Copyright (c) 2017 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!++
module asc_module
  !
  != asc_module
  !
  ! Copyright :: 2017 Shin-ichi Takehiro, Youhei SASAKI,
  !              SPMODEL Development Group
  ! License :: MIT/X11. Please see COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/asc_module モジュールは 1 次元周期境界条件の下での流体運動を実
  ! フーリエ変換によるスペクトル法で数値計算するための Fortran90 関数
  ! を提供する.
  !
  ! 2 次元データの 1 次元に関して同時にスペクトル計算を実行するための
  ! 関数も提供しており, 2, 3 次元領域での計算のベースも提供する.
  !
  ! このモジュールは内部で ISPACK/FTPACK の Fortran77 サブルーチンを呼
  ! んでいる. スペクトルデータの格納方法については ISPACK/FTPACK と異なっ
  ! ているので以下のコメントに注意されたい.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (s_, c_, g_, as_, ac_, ag_) は, 返す値の形を示している.
  !   s_  :: スペクトルデータ(sin 変換)
  !   c_  :: スペクトルデータ(cos 変換)
  !   g_  :: 1 次元格子点データ
  !   as_ :: 1 次元スペクトルデータ(sin 変換)が複数並んだ 2 次元データ
  !   ac_ :: 1 次元スペクトルデータ(sin 変換)が複数並んだ 2 次元データ
  !   ag_ :: 1 次元格子点データが複数並んだ 2 次元データ.
  !
  ! * 関数名の間の文字列(Dx)は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_s, _c, _as, _ac, _g, _ag) は, 入力変数の形が
  !   スペクトルデータおよび格子点データであることを示している.
  !   _s  :: スペクトルデータ(sin 変換)
  !   _c  :: スペクトルデータ(cos 変換)
  !   _g  :: 1 次元格子点データ
  !   _as :: 1 次元スペクトルデータ(sin 変換)が複数並んだ 2 次元データ
  !   _ac :: 1 次元スペクトルデータ(cos 変換)が複数並んだ 2 次元データ
  !   _ag :: 1 次元格子点データが複数並んだ 2 次元データ
  !
  !=== 各データの種類の説明
  !
  ! * 以下, DP  = kind(1.0D) である
  ! * g : 1 次元格子点データ.
  !   * 変数の種類と次元は real(DP), dimension(0:im).
  !   * im は X 座標の格子点数であり, サブルーチン ae_Initial にて
  !     あらかじめ設定しておく.
  !
  ! * s : スペクトルデータ(sin 変換).
  !   * 変数の種類と次元は real(8), dimension(km).
  !   * km は X 方向の最大波数であり, サブルーチン asc_Initial にて
  !     あらかじめ設定しておく.
  !
  ! * c : スペクトルデータ(cos 変換).
  !   * 変数の種類と次元は real(8), dimension(0:km).
  !   * km は X 方向の最大波数であり, サブルーチン asc_Initial にて
  !     あらかじめ設定しておく.
  !
  ! * ag : 1 次元(X)格子点データの並んだ 2 次元データ.
  !   * 変数の種類と次元は real(8), dimension(:,0:im).
  !     第 2 次元が X 方向を表す.
  !
  ! * as : 1 次元スペクトルデータ(sin 変換)の並んだ 2 次元データ.
  !   * 変数の種類と次元は real(8), dimension(:,km).
  !     第 2 次元がスペクトルを表す.
  ! * ac : 1 次元スペクトルデータ(cos 変換)の並んだ 2 次元データ.
  !   * 変数の種類と次元は real(8), dimension(:,0:km).
  !     第 2 次元がスペクトルを表す.
  !
  ! * g_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * s_ で始まる関数が返す値はスペクトルデータ(sin 変換)に同じ.
  !
  ! * c_ で始まる関数が返す値はスペクトルデータ(cos 変換)に同じ.
  !
  ! * ag_ で始まる関数が返す値は 1 次元格子点データの並んだ
  !   2 次元データに同じ.
  !
  ! * as_ で始まる関数が返す値は 1 次元スペクトルデータ(sin 変換)の並んだ
  !   2 次元データに同じ.
  !
  ! * ac_ で始まる関数が返す値は 1 次元スペクトルデータ(cos 変換)の並んだ
  !   2 次元データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したもののことである.
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! asc_Initial       :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  !
  !==== 座標変数
  !
  ! g_X              :: 格子点座標(X)を格納した 1 次元配列
  ! g_X_Weight       :: 重み座標を格納した 1 次元配列
  !
  !==== 基本変換
  !
  ! g_s, ag_as       :: スペクトルデータ(sin 変換)から格子データへの変換
  ! g_c, ag_ac       :: スペクトルデータ(cos 変換)から格子データへの変換
  ! s_g, as_ag       :: 格子データからスペクトルデータ(sin 変換)への変換
  ! c_g, ac_ag       :: 格子データからスペクトルデータ(sin 変換)への変換
  !
  !==== 微分
  !
  ! c_Dx_s, ac_Dx_as :: スペクトルデータ(sin 変換)に X 微分を作用させる
  ! s_Dx_c, as_Dx_ac :: スペクトルデータ(cos 変換)に X 微分を作用させる
  !
  !==== 積分・平均
  !
  ! a_Int_ag, a_Avr_ag :: 1 次元格子点データの並んだ 2 次元配列の積分および平均
  ! Int_g, Avr_g       :: 1 次元格子点データの積分および平均
  !
  !==== 補間
  !
  ! Interpolate_s      :: スペクトルデータからの特定の座標の値の補間(1 次元)
  ! Interpolate_c      :: スペクトルデータからの特定の座標の値の補間(1 次元)
  ! a_Interpolate_as   :: スペクトルデータからの特定の座標の値の補間(2 次元)
  ! a_Interpolate_ac   :: スペクトルデータからの特定の座標の値の補間(2 次元)
  !
  !
  use dc_message
  use dc_types, only: DP
  implicit none

  private
  public asc_Initial                      ! 初期化ルーチン
  public ag_as, as_ag, g_s, s_g           ! 基本変換
  public ag_ac, ac_ag, g_c, c_g           ! 基本変換
  public ac_Dx_as, c_Dx_s                 ! 微分
  public as_Dx_ac, s_Dx_c                 ! 微分
  public a_Int_ag, Int_g, a_Avr_ag, Avr_g ! 積分・平均
  public Interpolate_s, a_Interpolate_as  ! 補間
  public Interpolate_c, a_Interpolate_ac  ! 補間
  public g_X, g_X_Weight                  ! 座標変数

  integer            :: im=32             ! 格子点の数
  integer            :: km=10             ! 切断波数
  real(DP)           :: xl=1.0            ! 領域の大きさ

  integer, dimension(5)               :: its, itc
  real(DP), dimension(:),allocatable  :: ts, tc
  real(DP), parameter                 :: pi=3.1415926535897932385D0

  real(DP), allocatable :: g_x(:)         ! 格子点座標(X)を格納した 1 次元配列.
  real(DP), allocatable :: g_x_weight(:)  ! 重み座標を格納した 1 次元配列.
                                          ! X 方向の格子点の間隔が格納してある.

  save im, km, its, ts, itc, tc, xl, g_X, g_X_Weight

  contains
    !--------------- 初期化 -----------------
    subroutine asc_Initial(i,k,xmin,xmax)
      !
      ! スペクトル変換の格子点数, 波数, 領域の大きさを設定する.
      !
      ! 他の関数や変数を呼ぶ前に, 最初にこのサブルーチンを呼んで
      ! 初期設定をしなければならない.
      !
      integer,intent(in)  :: i              ! 格子点の数
      integer,intent(in)  :: k              ! 切断波数
      real(DP),intent(in) :: xmin, xmax     ! X 座標範囲

      integer :: ii

      im = i
      km = k
      xl = xmax-xmin

      if ( im <= 0 .or. km <= 0 ) then
         call MessageNotify('E','asc_Initial', &
              'Number of grid points and waves should be positive')
      elseif ( mod(im,2) /= 0 ) then
         call MessageNotify('E','asc_Initial', &
              'Number of grid points should be even')
      endif

      allocate(ts(5*im/2),tc(im*3))

      call fttcti(im,itc,tc)
      call fttsti(im,its,ts)

      allocate(g_x(0:im))
      do ii=0,im
         g_X(ii) = xmin + xl/im*ii
      enddo

      allocate(g_x_weight(0:im))
      g_X_Weight = xl/im
      g_X_Weight(0)  = xl/(2*im)
      g_X_Weight(im) = xl/(2*im)


#ifdef SPML_VEC
      call MessageNotify('M','asc_initial','asc_module for Vector (2017/05/18) is initialized')
#else
      call MessageNotify('M','asc_initial','asc_module for OpenMP (2017/05/18) is initialized')
#endif

    end subroutine asc_Initial

    !--------------- 基本変換(逆変換) -----------------
    function ag_as(as)
      !
      ! スペクトルデータ(sin 変換)から格子点データへ逆変換する(2 次元データ用)
      !
      ! sin スペクトル逆変換の定義は以下のとおり.
      !
      !   スペクトルデータ s_k (k=1,...,km)
      !   格子点データ     g_j (j=0,...,im)
      !
      !  g_j = \sum_{k=1}^{km}(s_k\sin(\pi jk/im)   (j=0,1,...,im).
      !
      real(DP), dimension(:,:), intent(in)   :: as    !(in)  スペクトルデータ
      real(DP), dimension(size(as,1),0:im)   :: ag_as !(out) 格子点データ

      real(DP), dimension(size(as,1),im)   :: y
      integer :: n, nm, k

      nm=size(as,1)

      ag_as = 0.0D0
      do k=1,km
         ag_as(:,k)   = as(:,k)
      enddo

#ifdef SPML_VEC
      call fttstb(nm,im,ag_as(:,1:im),y,its,ts)
#else
!$omp parallel do default(shared)
      do n=1,nm
        call fttstb(1,im,ag_as(n,1:im),y(n,:),its,ts)
      enddo
!$omp end parallel do
#endif

    end function ag_as

    function g_s(s)
      !
      ! スペクトルデータ(sin 変換)から格子点データへ逆変換する(1 次元データ用)
      !
      ! sin スペクトル逆変換の定義は以下のとおり.
      !
      !   スペクトルデータ s_k (k=1,...,km)
      !   格子点データ     g_j (j=0,...,im)
      !
      !  g_j = \sum_{k=1}^{km}(s_k\sin(\pi jk/im)   (j=0,1,...,im).
      !
      real(DP), dimension(0:im)             :: g_s  !(out) 格子点データ
      real(DP), dimension(km), intent(in)   :: s    !(in)  スペクトルデータ

      real(DP), dimension(1,size(s))  :: as_work
      real(DP), dimension(1,0:im)     :: ag_work

      as_work(1,:) = s
      ag_work = ag_as(as_work)
      g_s = ag_work(1,:)

    end function g_s

    function ag_ac(ac)
      !
      ! スペクトルデータ(cos 変換)から格子点データへ逆変換する(2 次元データ用)
      !
      ! cos スペクトル逆変換の定義は以下のとおり.
      !
      !   スペクトルデータ c_k (k=0,...,km)
      !   格子点データ     g_j (j=0,...,im)
      !
      !  g_j = c_0/2 + c_im(-1)**j
      !      + \sum_{k=1}^{im-1}(c_k\cos(\pi jk/im)   (j=0,1,...,im).
      !
      real(DP), dimension(:,0:), intent(in)   :: ac    !(in)  スペクトルデータ
      real(DP), dimension(size(ac,1),0:im)    :: ag_ac !(out) 格子点データ

      real(DP), dimension(size(ac,1),im)      :: y
      integer :: n, nm, k

      nm=size(ac,1)

      ag_ac = 0.0D0
      do k=0,km
         ag_ac(:,k)   = ac(:,k)
      enddo

#ifdef SPML_VEC
      call fttctb(nm,im,ag_ac,y,itc,tc)
#else
!$omp parallel do default(shared)
      do n=1,nm
        call fttctb(1,im,ag_ac(n,:),y(n,:),itc,tc)
      enddo
!$omp end parallel do
#endif

    end function ag_ac

    function g_c(c)
      !
      ! スペクトルデータ(cos 変換)から格子点データへ逆変換する(1 次元データ用)
      !
      ! cos スペクトル逆変換の定義は以下のとおり.
      !
      !   スペクトルデータ c_k (k=0,...,km)
      !   格子点データ     g_j (j=0,...,im)
      !
      !  g_j = c_0/2 + c_im(-1)**j
      !      + \sum_{k=1}^{im-1}(c_k\cos(\pi jk/im)   (j=0,1,...,im).
      !
      real(DP), dimension(0:im)             :: g_c  !(out) 格子点データ
      real(DP), dimension(0:km), intent(in) :: c    !(in)  スペクトルデータ

      real(DP), dimension(1,size(c))  :: ac_work
      real(DP), dimension(1,0:im)     :: ag_work

      ac_work(1,:) = c
      ag_work = ag_ac(ac_work)
      g_c = ag_work(1,:)

    end function g_c

    !--------------- 基本変換(正変換) -----------------
    function as_ag(ag)
      !
      ! 格子点データからスペクトルデータ(sin 変換)へ正変換する(2 次元データ用)
      !
      ! スペクトル正変換の定義は以下のとおり.
      !
      !   格子点データ     g_j (j=0,...,im)
      !   スペクトルデータ s_k (k=1,...,km)
      !
      !  s_k = (2/im)\sum_{j=1}^{im-1} g_j \sin(\pi jk/im) ]    (k=1,...,km)
      !
      real(DP), dimension(:,:), intent(in)   :: ag     !(in)  格子点データ
      real(DP), dimension(size(ag,1),km)     :: as_ag  !(out) スペクトルデータ

      real(DP), dimension(size(ag,1),im)     :: y
      real(DP), dimension(size(ag,1),0:im)   :: ag_work
      integer :: n, nm, k

      nm = size(ag,1)
      ag_work = ag

#ifdef SPML_VEC
      call fttstf(nm,im,ag_work(:,1:im),y,its,ts)
#else
!$omp parallel do default(shared)
      do n=1,nm
        call fttstf(1,im,ag_work(n,1:im),y(n,:),its,ts)
      enddo
!$omp end parallel do
#endif

      do k=1,km
         as_ag(:,k) = ag_work(:,k)
      enddo

    end function as_ag

    function s_g(g)
      !
      ! 格子点データからスペクトルデータ(sin 変換)へ正変換する(2 次元データ用)
      !
      ! スペクトル正変換の定義は以下のとおり.
      !
      !   格子点データ     g_j (j=0,...,im)
      !   スペクトルデータ s_k (k=1,...,km)
      !
      !  s_k = (2/im)\sum_{j=1}^{im-1} g_j \sin(\pi jk/im) ]    (k=1,...,km)
      !
      real(DP), dimension(km)                  :: s_g   !(out) スペクトルデータ
      real(DP), dimension(0:im), intent(in)    :: g     !(in)  格子点データ

      real(DP), dimension(1,size(g))           :: ag_work
      real(DP), dimension(1,km)                :: as_work

      ag_work(1,:) = g
      as_work = as_ag(ag_work)
      s_g = as_work(1,:)

    end function s_g

    function ac_ag(ag)
      !
      ! 格子点データからスペクトルデータ(cos 変換)へ正変換する(2 次元データ用)
      !
      ! スペクトル正変換の定義は以下のとおり.
      !
      !   格子点データ     g_j (j=0,...,im)
      !   スペクトルデータ c_k (k=0,...,km)
      !
      !  cs_k = (2/im)[ (1/2)g_0 + (1/2)g_im*(-1)^k
      !       + \sum_{j=1}^{im-1} g_j \cos(\pi jk/im) ]    (k=0,1,...,km)
      !
      real(DP), dimension(:,:), intent(in)   :: ag     !(in)  格子点データ
      real(DP), dimension(size(ag,1),0:km)   :: ac_ag  !(out) スペクトルデータ

      real(DP), dimension(size(ag,1),im)     :: y
      real(DP), dimension(size(ag,1),0:im)   :: ag_work
      integer :: n, nm, k

      nm = size(ag,1)
      ag_work = ag

#ifdef SPML_VEC
      call fttctf(nm,im,ag_work,y,itc,tc)
#else
!$omp parallel do default(shared)
      do n=1,nm
        call fttctf(1,im,ag_work(n,:),y(n,:),itc,tc)
      enddo
!$omp end parallel do
#endif

      do k=0,km
         ac_ag(:,k) = ag_work(:,k)
      enddo

    end function ac_ag

    function c_g(g)
      !
      ! 格子点データからスペクトルデータ(cos 変換)へ正変換する(1 次元データ用)
      !
      ! スペクトル正変換の定義は以下のとおり.
      !
      !   格子点データ     g_j (j=0,...,im)
      !   スペクトルデータ c_k (k=0,...,km)
      !
      !  cs_k = (2/im)[ (1/2)g_0 + (1/2)g_im*(-1)^k
      !       + \sum_{j=1}^{im-1} g_j \cos(\pi jk/im) ]    (k=0,1,...,km)
      !
      real(DP), dimension(0:km)                :: c_g   !(out) スペクトルデータ
      real(DP), dimension(0:im), intent(in)    :: g     !(in)  格子点データ

      real(DP), dimension(1,size(g))           :: ag_work
      real(DP), dimension(1,0:km)              :: ac_work

      ag_work(1,:) = g
      ac_work = ac_ag(ag_work)
      c_g = ac_work(1,:)

    end function c_g

  !--------------- 微分計算 -----------------
    function ac_Dx_as(as)
      !
      ! 入力スペクトルデータに X 微分を作用する(2 次元データ).
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      !
      real(DP), dimension(:,:), intent(in)  :: as
      !(in)  入力スペクトルデータ
      real(DP), dimension(size(as,1),0:km)  :: ac_dx_as
      !(out) 入力スペクトルデータの X 微分

      integer ::  k

      ac_Dx_as(:,0) = 0.0D0
      do k=1,km
         ac_Dx_as(:,k) = (pi*k/xl)*as(:,k)
      enddo
    end function ac_Dx_as

    function c_Dx_s(s)
      !
      ! 入力スペクトルデータに X 微分を作用する(1 次元データ).
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      !
      real(DP), dimension(km), intent(in)     :: s
      !(in)  入力スペクトルデータ
      real(DP), dimension(0:km)               :: c_Dx_s
      !(out) 入力スペクトルデータの X 微分
      real(DP), dimension(1,km)               :: as_work
      real(DP), dimension(1,0:km)             :: ac_work

      as_work(1,:) = s
      ac_work = ac_Dx_as(as_work)
      c_Dx_s= ac_work(1,:)

    end function c_Dx_s

    function as_Dx_ac(ac)
      !
      ! 入力スペクトルデータに X 微分を作用する(2 次元データ).
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      !
      real(DP), dimension(:,0:), intent(in) :: ac
      !(in)  入力スペクトルデータ
      real(DP), dimension(size(ac,1),km)    :: as_dx_ac
      !(out) 入力スペクトルデータの X 微分

      integer ::  k

      do k=1,km
         as_Dx_ac(:,k) = -(pi*k/xl)*ac(:,k)
      enddo
    end function as_Dx_ac

    function s_Dx_c(c)
      !
      ! 入力スペクトルデータに X 微分を作用する(1 次元データ).
      !
      ! スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      !
      real(DP), dimension(0:km), intent(in)   :: c
      !(in)  入力スペクトルデータ
      real(DP), dimension(km)                 :: s_Dx_c
      !(out) 入力スペクトルデータの X 微分
      real(DP), dimension(1,km)               :: as_work
      real(DP), dimension(1,0:km)             :: ac_work

      ac_work(1,:) = c
      as_work = as_Dx_ac(ac_work)
      s_Dx_c = as_work(1,:)

    end function s_Dx_c

  !--------------- 積分計算 -----------------
    function a_Int_ag(ag)
      !
      ! 1 次元格子点データが並んだ 2 次元配列の積分
      !
      real(DP), dimension(:,0:), intent(in)     :: ag        !(in) 格子点データ
      real(DP), dimension(size(ag,1))           :: a_Int_ag  !(out) 積分結果
      integer :: i

      a_Int_ag = 0.0D0
      do i=0,im
         a_Int_ag(:) = a_Int_ag(:) + ag(:,i)*g_X_Weight(i)
      enddo
    end function a_Int_ag

    function Int_g(g)
      !
      ! 1 次元格子点データの積分
      !
      real(DP), dimension(0:im), intent(in)   :: g      !(in) 格子点データ
      real(DP)                                :: Int_g  !(out) 積分結果

      Int_g = sum(g*g_X_Weight)

    end function Int_g

    function a_Avr_ag(ag)
      !
      ! 1 次元格子点データが並んだ 2 次元配列の平均
      !
      real(DP), dimension(:,0:), intent(in)     :: ag        !(in) 格子点データ
      real(DP), dimension(size(ag,1))           :: a_Avr_ag  !(out) 平均結果

      a_Avr_ag = a_Int_ag(ag)/sum(g_X_Weight)

    end function a_Avr_ag

    function Avr_g(g)
      !
      ! 1 次元格子点データの平均
      !
      real(DP), dimension(0:im), intent(in)   :: g
      real(DP)                                :: Avr_g

      Avr_g = Int_g(g)/sum(g_X_Weight)

    end function Avr_g

  !--------------- 補間計算 -----------------
    function Interpolate_s(s_data,xval)
      real(DP), dimension(km), intent(IN) :: s_data
      !(in) 入力フーリエデータ
      real(DP), intent(in)                :: xval
      ! 補間する点の座標
      real(DP)                            :: Interpolate_s
      ! 補間した結果の値
      integer :: k
      ! DO 文変数

      Interpolate_s = 0.0D0

      do k=1,km
        Interpolate_s = Interpolate_s + s_data(k)*sin(PI*k/xl*xval-g_X(0))
      enddo

    end function Interpolate_s

    function a_Interpolate_as(as_data,xval)
      real(DP), dimension(:,:), intent(IN)   :: as_data
      !(in) 入力フーリエデータ
      real(DP), intent(in)                   :: xval
      ! 補間する点の座標
      real(DP), dimension(size(as_data,1))   :: a_Interpolate_as
      ! 補間した結果の値
      integer :: k
      ! DO 文変数

      a_Interpolate_as = 0.0D0

      do k=1,km
         a_Interpolate_as = a_Interpolate_as + as_data(:,k)*sin(PI*k/xl*(xval-g_X(0)))
      enddo

    end function a_Interpolate_as

    function Interpolate_c(c_data,xval)
      !
      real(DP), dimension(0:km), intent(IN) :: c_data
      !(in) 入力フーリエデータ
      real(DP), intent(in)                  :: xval
      ! 補間する点の座標
      real(DP)                              :: Interpolate_c
      ! 補間した結果の値
      integer :: k
      ! DO 文変数

      Interpolate_c = c_data(0)/2

      do k=1,km
         Interpolate_c = Interpolate_c + c_data(k)*cos(PI*k/xl*(xval-g_X(0)))
      enddo

    end function Interpolate_c

    function a_Interpolate_ac(ac_data,xval)
      real(DP), dimension(:,0:), intent(IN)  :: ac_data
      !(in) 入力フーリエデータ
      real(DP), intent(in)                   :: xval
      ! 補間する点の座標
      real(DP), dimension(size(ac_data,1))   :: a_Interpolate_ac
      ! 補間した結果の値
      integer :: k
      ! DO 文変数

      a_Interpolate_ac = ac_data(:,0)/2

      do k=1,km
         a_Interpolate_ac = a_Interpolate_ac + ac_data(:,k)*cos(PI*k/xl*(xval-g_X(0)))
      enddo

    end function a_Interpolate_ac

end module asc_module

!----------------------------------------------------------------------
!     Copyright (c) 2013 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_base_module テストプログラム :: 終了処理のテスト
!
!履歴  2013/02/23  竹広真一
!
program w_base_module_sjpack_finazlize

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_module_sjpack
  implicit none

  integer, parameter :: im1=32, jm1=16, nm1=10
  integer, parameter :: im2=64, jm2=32, nm2=21

  real(8), allocatable  ::  w_data(:)
  real(8), allocatable  ::  xy_data(:,:)
  real(8), allocatable  ::  xy_Ddata(:,:)

  real(8) :: pi

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','w_base_module_sjpack', &
       'w_base_module_sjpack finalize subroutine tests') 

  call w_Initial( nm1, im1, jm1 )

  allocate(w_data((nm1+1)**2))
  allocate(xy_data(0:im1-1,1:jm1))
  allocate(xy_Ddata(0:im1-1,1:jm1))

  !==================== Y_1^0 のテスト ====================
  xy_data = sqrt(3.0D0)*sin(xy_Lat)                      ! Y_1^0
  w_data= 0.0D0 ; w_data(l_nm(1,0))=1.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_1^0 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = 0.0D0
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = sqrt(3.0D0) * ( cos(xy_Lat)**2 - 2*sin(xy_Lat)**2 )
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(3.0D0)*cos(xy_Lat)
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(3.0D0) * sin(xy_Lat)**2
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_1^0','Test of Y_1^0 succeeded!') 

  !==================== Y_1^1 のテスト ====================
  xy_data = sqrt(3.0D0/2)*cos(xy_Lat)*cos(xy_Lon)          ! Y_1^1
  w_data= 0.0D0 ; w_data(l_nm(1,1))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_1^1 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = -sqrt(3.0D0/2)*cos(xy_Lat)*sin(xy_Lon)          ! Y_1^1
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = - sqrt(3.0D0/2) * 3 * sin(xy_Lat) * cos(xy_Lat) * cos(xy_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = - sqrt(3.0D0/2) * sin(xy_Lat) * cos(xy_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(3.0D0/2) * sin(xy_Lat)* cos(xy_Lat) * cos(xy_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_1^1','Test of Y_1^1 succeeded!') 

  !==================== Y_1^{-1} のテスト ====================
  xy_data = -sqrt(3.0D0/2)*cos(xy_Lat)*sin(xy_Lon)         ! Y_1^{-1}
  w_data= 0.0D0 ; w_data(l_nm(1,-1))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_1^1 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = -sqrt(3.0D0/2)*cos(xy_Lat)*cos(xy_Lon)          ! Y_1^{-1}
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = sqrt(3.0D0/2) * 3 * sin(xy_Lat) * cos(xy_Lat) * sin(xy_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(3.0D0/2) * sin(xy_Lat) * sin(xy_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = - sqrt(3.0D0/2) * sin(xy_Lat)* cos(xy_Lat) * sin(xy_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !==================== Y_2^0 のテスト ====================
  xy_data = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)                 ! Y_2^0
  w_data= 0.0D0 ; w_data(l_nm(2,0))=1.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^0 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = 0.0D0
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = sqrt(5.0D0)*(   3.0*sin(xy_Lat)*cos(xy_Lat)**2  &
                           - 3.0*sin(xy_Lat)**3 + sin(xy_Lat)  ) 
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(5.0D0)*3.0*sin(xy_Lat)*cos(xy_Lat)
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)*sin(xy_Lat)
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^0','Test of Y_2^0 succeeded!') 

  !==================== Y_2^1 のテスト ====================
  xy_data = sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)! Y_2^1
  w_data= 0.0D0 ; w_data(l_nm(2,1))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^1 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = -sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat)*sin(xy_Lon)! Y_2^1
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = sqrt(5.0D0/6)*3.0 &
       *(cos(xy_Lat)**3-3*sin(xy_Lat)**2*cos(xy_Lat))*cos(xy_Lon)
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data,iflag=1,ipow=1))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(5.0D0/6)*3.0 * cos(2*xy_Lat) * cos(xy_Lon)
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(5.0D0/6)*3.0*sin(xy_Lat)**2*cos(xy_Lat) * cos(xy_Lon)
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^1','Test of Y_2^1 succeeded!') 

  !==================== Y_2^-1 のテスト ====================
  xy_data = -sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat) * sin(xy_Lon)! Y_2^-1
  w_data= 0.0D0 ; w_data(l_nm(2,-1))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^-1 Test of w_xy(xy_data)',                       &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data))',                 &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = -sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat)*cos(xy_Lon)! Y_2^-1
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data,iflag=-1))',        &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data),iflag=-1)',        &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = -sqrt(5.0D0/6)*3.0 &
       *(cos(xy_Lat)**3-3*sin(xy_Lat)**2*cos(xy_Lat))*sin(xy_Lon)
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = -sqrt(5.0D0/6)*3.0 * cos(2*xy_Lat) * sin(xy_Lon)
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = -sqrt(5.0D0/6)*3.0*sin(xy_Lat)**2*cos(xy_Lat) * sin(xy_Lon)
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data,iflag=2))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data),iflag=2)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^-1','Test of Y_2^-1 succeeded!') 

  !==================== Y_2^2 のテスト ====================
  xy_data = sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*cos(2*xy_Lon)         ! Y_2^2
  w_data= 0.0D0 ; w_data(l_nm(2,2))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^2 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2* (-2)* sin(2*xy_Lon)  ! Y_2^2
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = - sqrt(5.0D0/24)*3.0*4*sin(xy_Lat)*cos(xy_Lat)**2*cos(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = -sqrt(5.0D0/24)*3.0*2*cos(xy_Lat)*sin(xy_Lat)*cos(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(xy_Lat)*cos(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^2','Test of Y_2^2 succeeded!') 

  !==================== Y_2^-2 のテスト ====================
  xy_data = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(2*xy_Lon)         ! Y_2^-2
  w_data= 0.0D0 ; w_data(l_nm(2,-2))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^-2 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data))',                 &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2* 2*cos(2*xy_Lon)  ! Y_2^2
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data,iflag=-1))',        &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data),iflag=-1)',        &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = sqrt(5.0D0/24)*3.0*4*sin(xy_Lat)*cos(xy_Lat)**2*sin(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(5.0D0/24)*3.0*2*cos(xy_Lat)*sin(xy_Lat)*sin(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(xy_Lat)*sin(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data,iflag=2))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data),iflag=2)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^-2','Test of Y_2^-2 succeeded!') 

  !==================== 一般的関数のテスト ====================
  xy_data = cos(2*xy_Lon-pi/3) &
       *(sin(xy_Lat)-1)**2*(sin(xy_Lat)-0.5)*(sin(xy_Lat)+1)

  !---- 通常変換 ----
  call AssertEqual(&
    message='general function of xy_w(w_xy(xy_data))',            &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_data  = cos(xy_Lat)
  xy_Ddata = -2*sin(xy_Lat)

  call AssertEqual(&
    message='general function test of xy_w(w_xy(xy_data,iflag=1,ipow=1))',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=1)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_data  = cos(xy_Lat)**2
  xy_Ddata = -2*sin(xy_Lat)
  call AssertEqual(&
    message='general function test of xy_w(w_xy(xy_data,iflag=1,ipow=2))',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=2)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_data  = sin(xy_Lat)
  xy_Ddata = cos(xy_Lat)**2

  call AssertEqual(&
    message='general function test of xy_w(w_xy(xy_data),iflag=1,ipow=0)',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=0),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_data  = cos(xy_Lat)**2
  xy_Ddata = -2.0D0 * sin(xy_Lat)

  call AssertEqual(&
    message='general function test of xy_w(w_xy(xy_data),iflag=1,ipow=2)',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=2),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of genral function', &
       'Test of general function succeeded!') 

  !============================== 解像度変更 =============================

  call w_Finalize
  call w_Initial( nm2, im2, jm2 )

  deallocate(w_data)
  deallocate(xy_data)
  deallocate(xy_Ddata)

  allocate(w_data((nm2+1)**2))
  allocate(xy_data(0:im2-1,1:jm2))
  allocate(xy_Ddata(0:im2-1,1:jm2))

  !==================== Y_1^0 のテスト ====================
  xy_data = sqrt(3.0D0)*sin(xy_Lat)                      ! Y_1^0
  w_data= 0.0D0 ; w_data(l_nm(1,0))=1.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_1^0 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = 0.0D0
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = sqrt(3.0D0) * ( cos(xy_Lat)**2 - 2*sin(xy_Lat)**2 )
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(3.0D0)*cos(xy_Lat)
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(3.0D0) * sin(xy_Lat)**2
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_1^0','Test of Y_1^0 succeeded!') 

  !==================== Y_1^1 のテスト ====================
  xy_data = sqrt(3.0D0/2)*cos(xy_Lat)*cos(xy_Lon)          ! Y_1^1
  w_data= 0.0D0 ; w_data(l_nm(1,1))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_1^1 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = -sqrt(3.0D0/2)*cos(xy_Lat)*sin(xy_Lon)          ! Y_1^1
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = - sqrt(3.0D0/2) * 3 * sin(xy_Lat) * cos(xy_Lat) * cos(xy_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = - sqrt(3.0D0/2) * sin(xy_Lat) * cos(xy_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(3.0D0/2) * sin(xy_Lat)* cos(xy_Lat) * cos(xy_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_1^1','Test of Y_1^1 succeeded!') 

  !==================== Y_1^{-1} のテスト ====================
  xy_data = -sqrt(3.0D0/2)*cos(xy_Lat)*sin(xy_Lon)         ! Y_1^{-1}
  w_data= 0.0D0 ; w_data(l_nm(1,-1))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_1^1 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = -sqrt(3.0D0/2)*cos(xy_Lat)*cos(xy_Lon)          ! Y_1^{-1}
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = sqrt(3.0D0/2) * 3 * sin(xy_Lat) * cos(xy_Lat) * sin(xy_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(3.0D0/2) * sin(xy_Lat) * sin(xy_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = - sqrt(3.0D0/2) * sin(xy_Lat)* cos(xy_Lat) * sin(xy_Lon)
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^1 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !==================== Y_2^0 のテスト ====================
  xy_data = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)                 ! Y_2^0
  w_data= 0.0D0 ; w_data(l_nm(2,0))=1.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^0 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = 0.0D0
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = sqrt(5.0D0)*(   3.0*sin(xy_Lat)*cos(xy_Lat)**2  &
                           - 3.0*sin(xy_Lat)**3 + sin(xy_Lat)  ) 
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(5.0D0)*3.0*sin(xy_Lat)*cos(xy_Lat)
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)*sin(xy_Lat)
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^0','Test of Y_2^0 succeeded!') 

  !==================== Y_2^1 のテスト ====================
  xy_data = sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)! Y_2^1
  w_data= 0.0D0 ; w_data(l_nm(2,1))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^1 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = -sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat)*sin(xy_Lon)! Y_2^1
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = sqrt(5.0D0/6)*3.0 &
       *(cos(xy_Lat)**3-3*sin(xy_Lat)**2*cos(xy_Lat))*cos(xy_Lon)
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data,iflag=1,ipow=1))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(5.0D0/6)*3.0 * cos(2*xy_Lat) * cos(xy_Lon)
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(5.0D0/6)*3.0*sin(xy_Lat)**2*cos(xy_Lat) * cos(xy_Lon)
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^1 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^1','Test of Y_2^1 succeeded!') 

  !==================== Y_2^-1 のテスト ====================
  xy_data = -sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat) * sin(xy_Lon)! Y_2^-1
  w_data= 0.0D0 ; w_data(l_nm(2,-1))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^-1 Test of w_xy(xy_data)',                       &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data))',                 &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = -sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat)*cos(xy_Lon)! Y_2^-1
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data,iflag=-1))',        &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data),iflag=-1)',        &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = -sqrt(5.0D0/6)*3.0 &
       *(cos(xy_Lat)**3-3*sin(xy_Lat)**2*cos(xy_Lat))*sin(xy_Lon)
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = -sqrt(5.0D0/6)*3.0 * cos(2*xy_Lat) * sin(xy_Lon)
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = -sqrt(5.0D0/6)*3.0*sin(xy_Lat)**2*cos(xy_Lat) * sin(xy_Lon)
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data,iflag=2))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-1 Test of xy_w(w_xy(xy_data),iflag=2)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^-1','Test of Y_2^-1 succeeded!') 

  !==================== Y_2^2 のテスト ====================
  xy_data = sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*cos(2*xy_Lon)         ! Y_2^2
  w_data= 0.0D0 ; w_data(l_nm(2,2))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^2 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2* (-2)* sin(2*xy_Lon)  ! Y_2^2
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = - sqrt(5.0D0/24)*3.0*4*sin(xy_Lat)*cos(xy_Lat)**2*cos(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = -sqrt(5.0D0/24)*3.0*2*cos(xy_Lat)*sin(xy_Lat)*cos(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(xy_Lat)*cos(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^2','Test of Y_2^2 succeeded!') 

  !==================== Y_2^-2 のテスト ====================
  xy_data = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(2*xy_Lon)         ! Y_2^-2
  w_data= 0.0D0 ; w_data(l_nm(2,-2))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^-2 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data))',                 &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2* 2*cos(2*xy_Lon)  ! Y_2^2
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data,iflag=-1))',        &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data),iflag=-1)',        &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = sqrt(5.0D0/24)*3.0*4*sin(xy_Lat)*cos(xy_Lat)**2*sin(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(5.0D0/24)*3.0*2*cos(xy_Lat)*sin(xy_Lat)*sin(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(xy_Lat)*sin(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data,iflag=2))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data),iflag=2)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^-2','Test of Y_2^-2 succeeded!') 

  !==================== 一般的関数のテスト ====================
  xy_data = cos(2*xy_Lon-pi/3) &
       *(sin(xy_Lat)-1)**2*(sin(xy_Lat)-0.5)*(sin(xy_Lat)+1)

  !---- 通常変換 ----
  call AssertEqual(&
    message='general function of xy_w(w_xy(xy_data))',            &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_data  = cos(xy_Lat)
  xy_Ddata = -2*sin(xy_Lat)

  call AssertEqual(&
    message='general function test of xy_w(w_xy(xy_data,iflag=1,ipow=1))',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=1)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_data  = cos(xy_Lat)**2
  xy_Ddata = -2*sin(xy_Lat)
  call AssertEqual(&
    message='general function test of xy_w(w_xy(xy_data,iflag=1,ipow=2))',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=2)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_data  = sin(xy_Lat)
  xy_Ddata = cos(xy_Lat)**2

  call AssertEqual(&
    message='general function test of xy_w(w_xy(xy_data),iflag=1,ipow=0)',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=0),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_data  = cos(xy_Lat)**2
  xy_Ddata = -2.0D0 * sin(xy_Lat)

  call AssertEqual(&
    message='general function test of xy_w(w_xy(xy_data),iflag=1,ipow=2)',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=2),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of genral function', &
       'Test of general function succeeded!') 

  call MessageNotify('M','w_base_module_sjpack', &
       'w_base_module_sjpack finalize subroutine tests succeeded.') 

end program w_base_module_sjpack_finazlize

!--
!----------------------------------------------------------------------
! COPYRIGHT (c) 2006-2009 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_aq_galerkin_RRFF1
!
!      チェビシェフ−ガラーキン法
!      非圧縮流体の流線関数・流れポテンシャル用
!
!      case RR: 両端粘着条件(両端で値と 1 階微分が 0)
!               f(:,i=0)=f(:,i=im)=f'(:,i=0)=f'(:,i=im)=0 
!               [ f(:,x=xmax)=f(:,x=xmin)=f'(:,x=xmax)=0=f'(:,x=xmin)=0 ]
!
!      case FF: 両端自由すべり条件(両端で値と 2 階微分が 0)
!               f(:,i=0)=f(:,i=im)=f''(:,i=0)=f''(:,i=im)=0 
!               [ f(:,x=xmax)=f(:,x=xmin)=f''(:,x=xmax)=0=f''(:,x=xmin)=0 ]
!
!      case RF: 片端粘着条件, 片端自由すべり条件
!               (両端で値が 0, 片側で 1 階微分, もう一方で 2 階微分が 0)
!               f(:,i=0)=f(:,i=im)=f'(:,i=0)=f''(:,i=im)=0 
!               [ f(:,x=xmax)=f(:,x=xmin)=f''(:,x=xmax)=0=f'(:,x=xmin)=0 ]
!
!      case FR: 片端自由すべり条件, 片端粘着条件
!               (両端で値が 0, 片側で 2 階微分, もう一方で 1 階微分が 0)
!               f(:,i=0)=f(:,i=im)=f''(:,i=0)=f'(:,i=im)=0 
!               [ f(:,x=xmax)=f(:,x=xmin)=f'(:,x=xmax)=0=f''(:,x=xmin)=0 ]
!
!      k 次のガラーキン基底が
!        \phi_k(x)=T_k(x) + C_{k-1}T_{k-1}(x) + C_{k-2}T_{k-2}(x) 
!                         + C_{k-3}T_{k-3}(x) + C_{k-4}T_{k-4}(x) 
!      の型式(Type1)
!
!      定式化については解説文書
!
!         「チェビシェフ関数展開を利用したガラーキン法」
!
!      (cheb_gal.pdf)を参照のこと. 
!
!履歴  2006/01/24  竹広真一  新規作成
!      2006/01/25  竹広真一  モジュール初期化フラッグ導入
!      2006/02/28  竹広真一  コメントを RDoc 用に変更
!      2009/07/22  佐々木洋平 at_module と境界条件スイッチを揃えた
!
!++
module at_aq_galerkin_RRFF
  !
  != at_aq_galerkin_RRFF
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/at_aq_galerkin_RRFF はチェビシェフ−ガラーキン法,
  ! 非圧縮流体の流線関数・流れポテンシャルに対して,
  !
  ! * case RR: 両端粘着条件(両端で値と 1 階微分が 0)
  !            f(:,i=0)=f(:,i=im)=f'(:,i=0)=f'(:,i=im)=0 
  !            [ f(:,x=xmax)=f(:,x=xmin)=f'(:,x=xmax)=0=f'(:,x=xmin)=0 ]
  !
  ! * case FF: 両端自由すべり条件(両端で値と 2 階微分が 0)
  !            f(:,i=0)=f(:,i=im)=f''(:,i=0)=f''(:,i=im)=0 
  !            [ f(:,x=xmax)=f(:,x=xmin)=f''(:,x=xmax)=0=f''(:,x=xmin)=0 ]
  !
  ! * case RF: 片端粘着条件, 片端自由すべり条件
  !            (両端で値が 0, 片側で 1 階微分, もう一方で 2 階微分が 0)
  !            f(:,i=0)=f(:,i=im)=f'(:,i=0)=f''(:,i=im)=0 
  !            [ f(:,x=xmax)=f(:,x=xmin)=f''(:,x=xmax)=0=f'(:,x=xmin)=0 ]
  !
  ! * case FR: 片端自由すべり条件, 片端粘着条件
  !            (両端で値が 0, 片側で 2 階微分, もう一方で 1 階微分が 0)
  !            f(:,i=0)=f(:,i=im)=f''(:,i=0)=f'(:,i=im)=0 
  !            [ f(:,x=xmax)=f(:,x=xmin)=f'(:,x=xmax)=0=f''(:,x=xmin)=0 ]
  !
  ! を k 次のガラーキン基底が
  !     \phi_k(x)=T_k(x) + C_{k-1}T_{k-1}(x) + C_{k-2}T_{k-2}(x) 
  !                      + C_{k-3}T_{k-3}(x) + C_{k-4}T_{k-4}(x) 
  ! の型式(Type1)を用いて計算するためのモジュールである.
  !
  ! 定式化については解説文書「チェビシェフ関数展開を利用したガラーキン法」
  ! (cheb_gal.pdf[link:link:cheb_gal.pdf])を参照のこと. 
  !
  use lumatrix
  use at_module
  use dc_message

  implicit none

  private
  public :: at_aq_galerkin_RRFF_Initial  ! 初期化サブルーチン
  public :: aq_at, q_t                   ! チェビシェフ->ガラーキン変換
  public :: aq_ag, q_g                   ! 格子点->ガラーキンデータ変換
  public :: at_aq, t_q                   ! ガラーキン->チェビシェフ変換
  public :: ag_aq, g_q                   ! ガラーキン->格子点データ変換
  public :: aq_Dx_aq, q_Dx_q             ! X 微分

  real(8), allocatable :: TQ(:,:)   ! ガラーキン->チェビシェフ変換行列
  real(8), allocatable :: QT(:,:)   ! チェビシェフ->ガラーキン変換行列
  integer, allocatable :: kp(:)     ! LU 分解用ピボット格納配列

  real(8), allocatable :: alpha(:)  ! チェビシェフ<->ガラーキン行列積係数
  real(8), allocatable :: beta(:)   ! チェビシェフ<->ガラーキン行列和係数

  integer :: im                     ! 格子点数              
  integer :: km                     ! チェビシェフ切断波数  
  integer,parameter :: ks=4         ! ガラーキン基底最低次数
  character(LEN=2) :: bc            ! 境界条件(RR/FF/RF/FR)

  logical :: RRFF_Initialized=.false.    ! 初期化フラッグ

  save im, km, bc, TQ, QT, kp, alpha, beta, RRFF_Initialized
  public TQ, QT, alpha, beta

contains

  subroutine at_aq_galerkin_RRFF_Initial(i_in,k_in,bc_in)
    !
    ! チェビシェフ−ガラーキン法
    ! 非圧縮流体の流線関数・流れポテンシャル用
    !
    ! 初期化サブルーチン
    !
    integer, intent(in)          :: i_in     
    ! (in)格子点数
    integer, intent(in)          :: k_in     
    ! (in)チェビシェフ切断波数  
    character(LEN=2), intent(in) :: bc_in    
    ! (in)境界条件(RR/FF/RF/FR)

    integer :: k, l, m, n
    real(8) :: delta

    im=i_in ; km=k_in ; bc=bc_in

    allocate(TQ(0:km,ks:km),QT(ks:km,ks:km),kp(ks:km))
    allocate(alpha(0:km),beta(0:km))


    select case (bc)

    !---- 両端粘着条件用変換行列設定
    case ('RR','rr')
       TQ = 0.0D0
       do k=ks,km
          TQ(k,k)   = 1.0D0
          TQ(k-2,k) = -2.0*(K-2.0D0)/(K-3.0D0)
          TQ(k-4,k) = (K-1.0D0)/(K-3.0D0)
       enddo
       call MessageNotify('M','at_aq_galerkin_RRFF_Initial',&
                          'Conversion matrices for RR-B.C. initialized.')

    !---- 両端自由すべり条件用変換行列設定
    case ('FF','ff','SS','ss')
       TQ = 0.0D0
       do k=ks,km
          TQ(k,k)   = 1.0D0
          TQ(k-2,k) = -(T2(k)-T2(k-4))/(T2(k-2)-T2(k-4))
          TQ(k-4,k) = (T2(k)-T2(k-2))/(T2(k-2)-T2(k-4))
       enddo
       call MessageNotify('M','at_aq_galerkin_RRFF_Initial',&
                          'Conversion matrices for FF-B.C. initialized.')


    !---- 片端粘着条件, 片端自由すべり条件変換行列設定
    case ('RF','rf','RS','rs')
       TQ = 0.0D0
       do k=ks,km
          delta = (T1(k-1)-T1(k-3))*(T2(k-2)-T2(k-4)) &
                + (T2(k-1)-T2(k-3))*(T1(k-2)-T1(k-4))
          TQ(k,k)   = 1.0D0
          TQ(k-3,k) = ( (T2(k-2)-T2(k-4))*(T1(k)-T1(k-2)) &
                        - (T1(k-2)-T1(k-4))*(T2(k)-T2(k-2)) )/delta
          TQ(k-4,k) = ( (T2(k-1)-T2(k-3))*(T1(k)-T1(k-2)) &
                        + (T1(k-1)-T1(k-3))*(T2(k)-T2(k-2)) )/delta
          TQ(k-1,k) = -TQ(k-3,k)
          TQ(k-2,k) = -TQ(k-4,k) - 1.0D0
       enddo
       call MessageNotify('M','at_aq_galerkin_RRFF_Initial',&
                          'Conversion matrices for RF-B.C. initialized.')

    !---- 片端自由すべり条件, 片端粘着条件変換行列設定
    case ('FR','fr','SR','sr')
       TQ = 0.0D0
       do k=ks,km
          delta = (T2(k-1)-T2(k-3))*(T1(k-2)-T1(k-4)) &
                + (T1(k-1)-T1(k-3))*(T2(k-2)-T2(k-4))
          TQ(k,k)   = 1.0D0
          TQ(k-3,k) = ( (T1(k-2)-T1(k-4))*(T2(k)-T2(k-2)) &
                        - (T2(k-2)-T2(k-4))*(T1(k)-T1(k-2)) )/delta
          TQ(k-4,k) = ( (T1(k-1)-T1(k-3))*(T2(k)-T2(k-2)) &
                        + (T2(k-1)-T2(k-3))*(T1(k)-T1(k-2)) )/delta
          TQ(k-1,k) = -TQ(k-3,k)
          TQ(k-2,k) = -TQ(k-4,k) - 1.0D0
       enddo
       call MessageNotify('M','at_aq_galerkin_RRFF_Initial',&
                          'Conversion matrices for FR-B.C. initialized.')

    case default
       call MessageNotify('E','at_aq_galerkin_RRFF_Initial',&
                'Argument for B.C. not valid. Should be RR/FF/RF/FR.')

    end select

    beta=1.0D0 ; beta(0)=0.5D0
    if (im .eq. km ) beta(km)=0.5D0

    ! 両端粘着条件用変換逆行列
    alpha=1.0 ; alpha(0)=2.0D0

    QT = 0.0D0
    do m=ks,km
       do n=ks,km
          do l=0,km
             QT(m,n) = QT(m,n) + alpha(l)*TQ(l,m)*TQ(l,n)
          enddo
       enddo
    enddo

    call LUDecomp(QT,kp)

    RRFF_Initialized=.true.

    contains
      !
      ! k 次チェビシェフ多項式 2 階微分の x=1 での値
      !
      function T2(k)            
        integer, intent(in) :: k
        real(8)             :: T2

        T2 = k**2 * (k**2 -1.0D0) / 3.0D0
      end function T2
      !
      ! k 次チェビシェフ多項式 1 階微分の x=1 での値
      !
      function T1(k)            
        integer, intent(in) :: k
        real(8)             :: T1

        T1 = k**2.0D0
      end function T1

  end subroutine at_aq_galerkin_RRFF_Initial

  function aq_at(at_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 非圧縮流体の流線関数・流れポテンシャル用
    !
    ! チェビシェフ係数 -> ガラーキン係数変換(2次元データ)
    !
    real(8), intent(in) :: at_data(:,0:)                
    !(in)  チェビシェフ係数
    real(8)             :: aq_at(size(at_data,1),ks:km) 
    !(out) ガラーキン係数  

    real(8)             :: aq_work(size(at_data,1),ks:km)  
    ! 作業用配列
    
    integer :: k,m

    if ( .not. RRFF_Initialized ) &
         call MessageNotify('E','aq_at',&
                            'at_aq_galerkin_RRFF_module not initialized')

    aq_work = 0.0D0
    do m=ks,km
       do k=0,km
          aq_work(:,m) = aq_work(:,m) &
               + alpha(k) * beta(k) * at_data(:,k) * TQ(k,m)
       enddo
    enddo

    aq_at = LUSolve(QT,kp,aq_work)
  end function aq_at

  function q_t(t_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 非圧縮流体の流線関数・流れポテンシャル用
    !
    ! チェビシェフ係数 -> ガラーキン係数変換(1次元データ)
    !
    real(8), intent(in) :: t_data(0:km)        
    !(in)  チェビシェフ係数
    real(8)             :: q_t(ks:km)          
    !(out) ガラーキン係数  

    real(8)             :: q_work(ks:km)       
    ! 作業用配列

    integer :: k,m

    if ( .not. RRFF_Initialized ) &
         call MessageNotify('E','q_t',&
                            'at_aq_galerkin_RRFF_module not initialized')

    q_work =0.0D0
    do m=ks,km
       do k=0,km
          q_work(m) = q_work(m) &
               + alpha(k) * beta(k) * t_data(k) * TQ(k,m)
       enddo
    enddo

    q_t = LUSolve(QT,kp,q_work)
  end function q_t

  function at_aq(aq_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 非圧縮流体の流線関数・流れポテンシャル用
    !
    ! ガラーキン係数 -> チェビシェフ係数変換(2次元データ)
    !
    real(8), intent(in)  :: aq_data(:,ks:)              
    !(in)  ガラーキン係数
    real(8)              :: at_aq(size(aq_data,1),0:km) 
    !(out) チェビシェフ係数

    integer :: m, n

    if ( .not. RRFF_Initialized ) &
         call MessageNotify('E','at_aq',&
                            'at_aq_galerkin_RRFF_module not initialized')

    at_aq = 0.0D0
    do m=0,km
       do n=ks,km
          at_aq(:,m) = at_aq(:,m) + TQ(m,n)*aq_data(:,n)/beta(m)
       enddo
    enddo
  end function at_aq

  function t_q(q_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 非圧縮流体の流線関数・流れポテンシャル用
    !
    ! ガラーキン係数 -> チェビシェフ係数変換(1次元データ)
    !
    real(8), intent(in)  :: q_data(ks:km)       
    !(in)  ガラーキン係数  
    real(8)              :: t_q(0:km)           
    !(out) チェビシェフ係数

    integer :: m, n

    if ( .not. RRFF_Initialized ) &
         call MessageNotify('E','t_q',&
                            'at_aq_galerkin_RRFF_module not initialized')

    t_q = 0.0D0
    do m=0,km
       do n=ks,km
          t_q(m) = t_q(m) + TQ(m,n)*q_data(n)/beta(m)
       enddo
    enddo
  end function t_q

  function aq_ag(ag_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 非圧縮流体の流線関数・流れポテンシャル用
    !
    ! 格子点データ -> ガラーキン係数変換(2次元データ)
    !
    real(8), intent(in)  :: ag_data(:,0:)                
    !(in)  格子点データ
    real(8)              :: aq_ag(size(ag_data,1),ks:km) 
    !(out) ガラーキン係数

    aq_ag = aq_at(at_ag(ag_data))
  end function aq_ag

  function q_g(g_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 非圧縮流体の流線関数・流れポテンシャル用
    !
    ! 格子点データ -> ガラーキン係数変換(1次元データ)
    !
    real(8), intent(in)  :: g_data(0:im)        
    !(in)  格子点データ
    real(8)              :: q_g(ks:km)          
    !(out) ガラーキン係数

    q_g = q_t(t_g(g_data))
  end function q_g

  function ag_aq(aq_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 非圧縮流体の流線関数・流れポテンシャル用
    !
    ! ガラーキン係数 -> 格子点データ変換(2次元データ)
    !
    real(8), intent(in) :: aq_data(:,ks:)              
    !(in)  ガラーキン係数  
    real(8)             :: ag_aq(size(aq_data,1),0:im) 
    !(out) 格子点データ  
    
    ag_aq = ag_at(at_aq(aq_data))
  end function ag_aq

  function g_q(q_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 非圧縮流体の流線関数・流れポテンシャル用
    !
    ! ガラーキン係数 -> 格子点データ変換(1次元データ)
    !
    real(8), intent(in) :: q_data(ks:km)        
    !(in)  ガラーキン係数  
    real(8)             :: g_q(0:im)            
    !(out) 格子点データ  
    
    g_q = g_t(t_q(q_data))
  end function g_q

  function aq_Dx_aq(aq_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 非圧縮流体の流線関数・流れポテンシャル用
    !
    ! X 微分計算(2 次元)
    !
    real(8), intent(in) :: aq_data(:,ks:)                  
    !(in) ガラーキン係数
    real(8)             :: aq_Dx_aq(size(aq_data,1),ks:km) 
    !(out) 微分ガラーキン
    aq_Dx_aq = aq_at(at_Dx_at(at_aq(aq_data)))
  end function aq_Dx_aq

  function q_Dx_q(q_data)
    !
    ! チェビシェフ−ガラーキン法
    ! 非圧縮流体の流線関数・流れポテンシャル用
    !
    ! X 微分計算(1 次元)
    !
    real(8), intent(in) :: q_data(ks:km)
    real(8)             :: q_Dx_q(ks:km)

    q_Dx_q = q_t(t_Dx_t(t_q(q_data)))

  end function q_Dx_q

end module at_aq_galerkin_RRFF

!--
!----------------------------------------------------------------------
! Copyright(c) 2017 SPMDODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  wt_zonal_module_svpack
!
!    spml/wt_zonal_module_svpack モジュールは球面上および球殻内での経度方向に
!    一様な帯状的軸対称 2 次元流体運動をスペクトル法によって数値計算する
!    ための Fortran90 関数を提供するものである. 
!
!    水平方向にルジャンドル多項式変換および上下の境界壁を扱うための
!    チェビシェフ多項式変換を用いる場合のスペクトル計算のためのさまざまな
!    関数を提供する. 
!
!    内部で wa_zonal_module_svpack, at_module を用いている. 最下部では
!    ルジャンドル多項式およびチェビシェフ多項式変換のエンジンとして 
!    ISPACK の Fortran77 サブルーチンを用いている.
!
!    関数, サブルーチンの名前と機能は wt_zonal_module のものと同じに
!    設計してある. したがって use 文を wt_zonal_module から 
!    wt_zonal_module_svpack に変更するだけで SVPACK の機能が使えるようになる. 
!
!履歴  2017/03/06  竹広真一  wt_zonal_module_sjpack より SVPACK 用に改造
!
!凡例
!      データ種類と index
!        x : 経度         y : 緯度        z : 動径
!        w : 球面調和関数スペクトル
!        n : 球面調和関数スペクトル(水平全波数)
!        m : 球面調和関数スペクトル(帯状波数)
!        t : チェビシェフ関数スペクトル
!        a : 任意の次元
!
!        xyz : 3 次元格子点データ
!        xy  : 水平 2 次元格子点データ
!        yz  : 子午面 2 次元格子点データ
!        xz  : 緯度面 2 次元格子点データ
!
!        wz  : 水平スペクトル動径格子点データ
!        wt  : スペクトルデータ
!
!++
module wt_zonal_module_svpack
  !
  != wt_zonal_module_svpack
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !    spml/wt_zonal_module_svpack モジュールは球面上および球殻内での経度方向に
  !    一様な帯状的軸対称 2 次元流体運動をスペクトル法によって数値計算する
  !    ための Fortran90 関数を提供するものである. 
  !
  !    水平方向にルジャンドル多項式変換および上下の境界壁を扱うための
  !    チェビシェフ多項式変換を用いる場合のスペクトル計算のためのさまざまな
  !    関数を提供する. 
  !
  !    内部で wa_zonal_module_svpack, at_module を用いている. 最下部では
  !    ルジャンドル多項式およびチェビシェフ多項式変換のエンジンとして 
  !    ISPACK の Fortran77 サブルーチンを用いている.
  !
  !    関数, サブルーチンの名前と機能は wt_zonal_module のものと同じに
  !    設計してある. したがって use 文を wt_zonal_module から 
  !    wt_zonal_module_svpack に変更するだけで SVPACK の機能が使えるようになる.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (wt_, nmz_, nz_, xyz_, wz_, w_, xy_, x_, y_, z_, a_) は, 
  !   返す値の形を示している.
  !   wt_  :: スペクトルデータ(ルジャンドル多項式・チェビシェフ多項式変換)
  !   nmz_ :: 水平スペクトルデータ(全波数 n, 帯状波数各成分, 動径)
  !   nz_  :: 水平スペクトルデータ(全波数 n, 動径)
  !   xyz_ :: 3 次元格子点データ(経度・緯度・動径)
  !   wz_  :: 水平スペクトル, 動径格子点データ
  !
  ! * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla,..)
  !   は, その関数の作用を表している.
  !
  ! * 関数名の最後 (wt_, xyz_, wz_, w_, xy_, x_, y_, z_, a_) は, 入力変数の
  !   形がスペクトルデータおよび格子点データであることを示している.
  !   _wt      :: スペクトルデータ
  !   _xyz     :: 3 次元格子点データ
  !   _xyz_xyz :: 2 つの3 次元格子点データ, ...
  !
  !=== 各データの種類の説明
  !
  ! * xyz : 3 次元格子点データ(経度・緯度・動径)
  !   * 変数の種類と次元は real(8), dimension(0:im-1,1:jm,0:km). 
  !   * im, jm, km はそれぞれ経度, 緯度, 動径座標の格子点数であり, 
  !     サブルーチン wt_Initial にてあらかじめ設定しておく.
  !
  ! * wt : スペクトルデータ
  !   * 変数の種類と次元は real(8), dimension(nm+1,0:lm). 
  !   * nm は球面調和函数の最大全波数, lm はチェビシェフ多項式の最大次数
  !     であり, サブルーチン wt_Initial にてあらかじめ設定しておく. 
  !   * 水平スペクトルデータの格納のされ方は関数 l_nm, nm_l によって調べる
  !     ことができる.
  !
  ! * nmz : 水平スペクトルデータの並んだ 3 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,-nm:nm,0:km). 
  !   * 第 1 次元が水平全波数, 第 2 次元が帯状波数, 第 3 次元が動径座標を表す. 
  !   * nm は球面調和函数の最大全波数であり, サブルーチン wt_Initial にて
  !     あらかじめ設定しておく.
  !
  ! * nz : スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,0:km). 
  !   * 第 1 次元が水平全波数を表す. 
  !   * nm は球面調和函数の最大全波数であり, 
  !     サブルーチン wt_Initial にてあらかじめ設定しておく.
  !
  ! * wz : 水平スペクトル, 動径格子点データ.
  !   * 変数の種類と次元は real(8), dimension(nm+1,0:km).
  !
  ! * wt_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * xyz_ で始まる関数が返す値は 3 次元格子点データに同じ.
  !
  ! * wz_ で始まる関数が返す値は水平スペクトル, 動径格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  ! 
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! wt_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! 
  !==== 座標変数
  !
  ! x_Lon, y_Lat, z_Rad          :: 格子点座標(緯度, 経度, 動径座標)を
  !                                 格納した1 次元配列
  ! x_Lon_Weight, y_Lat_Weight, z_Rad_Weight :: 重み座標を格納した 1 次元配列
  ! xyz_Lon, xyz_Lat, xyz_Rad    :: 格子点データの経度・緯度・動径座標(X,Y,Z)
  !                                 (格子点データ型 3 次元配列)
  !
  !==== 基本変換
  !
  ! xyz_wt, wt_xyz :: スペクトルデータと 3 次元格子データの間の変換
  !                   (球面調和函数, チェビシェフ変換)
  ! xyz_wz, wz_xyz :: 3 次元格子データと水平スペクトル・動径格子データとの
  !                   間の変換 (球面調和函数)
  ! wz_wt, wt_wz   :: スペクトルデータと水平スペクトル・動径格子データとの
  !                   間の変換 (チェビシェフ変換)
  ! w_xy, xy_w     :: スペクトルデータと 2 次元水平格子データの間の変換
  !                   (球面調和函数変換) 
  ! az_at, at_az   :: 同時に複数個行う (チェビシェフ変換)格子データと
  !                   チェビシェフデータの間の変換を
  ! l_nm, nm_l     :: スペクトルデータの格納位置と全波数・帯状波数の変換 
  !
  !==== 微分
  !
  ! wt_DRad_wt          :: スペクトルデータに動径微分∂/∂r を作用させる
  ! wt_DivRad_wt        :: スペクトルデータに発散型動径微分
  !                        1/r^2 ∂/∂r r^2 = ∂/∂r + 2/r を作用させる
  ! wt_RotRad_wt        :: スペクトルデータに回転型動径微分
  !                        1/r ∂/∂rr = ∂/∂r + 1/r を作用させる
  ! wt_Lapla_wt         :: スペクトルデータにラプラシアンを作用させる
  ! xyz_GradLon_wt      :: スペクトルデータに勾配型経度微分
  !                        1/rcosφ・∂/∂λを作用させる
  ! xyz_GradLat_wt      :: スペクトルデータに勾配型緯度微分
  !                        1/r・∂/∂φを作用させる
  ! wt_DivLon_xyz       :: 格子データに発散型経度微分
  !                        1/rcosφ・∂/∂λを作用させる
  ! wt_DivLat_xyz       :: 格子データに発散型緯度微分
  !                        1/rcosφ・∂(g cosφ)/∂φを作用させる
  ! wt_Div_xyz_xyz_xyz  :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! xyz_Div_xyz_xyz_xyz :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! xyz_RotLon_wt_wt    :: ベクトル場の回転の経度成分を計算する
  ! xyz_RotLat_wt_wt    :: ベクトル場の回転の緯度成分を計算する
  ! wt_RotRad_xyz_xyz   :: ベクトル場の回転の動径成分を計算する
  !
  !==== トロイダルポロイダル計算用微分
  !
  ! wt_KxRGrad_wt            :: スペクトルデータに経度微分
  !                             k×r・▽ = ∂/∂λを作用させる
  ! xyz_KGrad_wt             :: スペクトルデータに軸方向微分
  !                             k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r を
  !                             作用させる
  ! wt_L2_wt                 :: スペクトルデータに 
  !                             L2 演算子 = -水平ラプラシアンを作用させる
  ! wt_L2Inv_wt              :: スペクトルデータに
  !                             L2 演算子の逆 = -逆水平ラプラシアンを作用させる
  ! wt_QOperator_wt          :: スペクトルデータに演算子
  !                             Q=(k・▽-1/2(L2 k・▽+ k・▽L2)) を作用させる
  ! wt_RadRot_xyz_xyz        :: ベクトル v の渦度と動径ベクトル r の内積
  !                             r・(▽×v) を計算する
  ! wt_RadRotRot_xyz_xyz_xyz :: ベクトルの v の r・(▽×▽×v) を計算する
  ! wt_Potential2Vector      :: トロイダルポロイダルポテンシャルから
  !                             ベクトル場を計算する
  ! wt_Potential2Rotation    :: トロイダルポロイダルポテンシャルで表される
  !                             非発散ベクトル場の回転の各成分を計算する
  !
  !==== 非線形計算
  !
  ! wt_VGradV    ::  ベクトル v から v・▽v を計算する
  !
  !==== ポロイダル/トロイダルモデル用スペクトル解析
  !
  ! nmz_ToroidalEnergySpectrum_wt, nz_ToroidalEnergySpectrum_wt   ::
  !     トロイダルポテンシャルからエネルギーの球面調和函数各成分を計算する
  ! nmz_PoloidalEnergySpectrum_wt, nz_PoloidalEnergySpectrum_wt   :: 
  !     ポロイダルポテンシャルからエネルギーの球面調和函数各成分を計算する
  !
  !==== 境界値問題
  !
  ! wt_BoundariesTau, wt_BoundariesGrid, wt_Boundaries                   ::
  !     ディリクレ, ノイマン境界条件を適用する(タウ法, 選点法)
  ! wt_TorBoundariesTau, wt_TorBoundariesGrid, wt_TorBoundaries          ::
  !     速度トロイダルポテンシャルの境界条件を適用する(タウ法,選点法)
  ! wz_LaplaPol2Pol_wz, wt_LaplaPol2Pol_wt                               ::
  !     速度ポロイダルポテンシャルΦを▽^2Φから求める
  !     (入出力がそれぞれチェビシェフ格子点,チェビシェフ係数)
  ! wt_TorMagBoundariesTau, wt_TorMagBoundariesGrid, wt_TorMagBoundaries ::
  !     磁場トロイダルポテンシャルの境界条件を適用する(タウ法, 選点法)
  ! wt_PolMagBoundariesTau, wt_PolMagBoundariesGrid, wt_PolMagBoundaries ::
  !     磁場トロイダルポテンシャル境界の境界条件を適用する(タウ法, 選点法)
  !
  !==== 積分・平均(3 次元データ)
  !
  ! IntLonLatRad_xyz, AvrLonLatRad_xyz :: 3 次元格子点データの
  !                                       全領域積分および平均
  ! z_IntLonLat_xyz, z_AvrLonLat_xyz   :: 3 次元格子点データの
  !                                       緯度経度(水平・球面)積分および平均
  ! y_IntLonRad_xyz, y_AvrLonRad_xyz   :: 3 次元格子点データの
  !                                       緯度動径積分および平均
  ! z_IntLatRad_xyz, z_AvrLatRad_xyz   :: 3 次元格子点データの
  !                                       経度動径(子午面)積分および平均
  ! yz_IntLon_xyz, yz_AvrLon_xyz       :: 3 次元格子点データの
  !                                       経度方向積分および平均
  ! xz_IntLat_xyz, xz_AvrLat_xyz       :: 3 次元格子点データの
  !                                       緯度方向積分および平均
  ! xz_IntRad_xyz, xz_AvrRad_xyz       :: 3 次元格子点データの
  !                                       動径方向積分および平均
  !
  !==== 積分・平均(2 次元データ)
  !
  ! IntLonLat_xy, AvrLonLat_xy :: 2 次元格子点データの水平(球面)積分および平均
  ! IntLonRad_xz, AvrLonRad_xz :: 2 次元(XZ)格子点データの経度動径積分
  !                               および平均
  ! IntLatRad_yz, AvrLatRad_yz :: 2 次元(YZ)格子点データの緯度動径(子午面)
  !                               積分および平均 
  ! y_IntLon_xy, y_AvrLon_xy   :: 水平 2 次元(球面)格子点データの経度方向
  !                               積分および平均
  ! x_IntLat_xy, x_AvrLat_xy   :: 水平2 次元(球面)格子点データの緯度方向積分
  !                               および平均
  ! z_IntLon_xz, z_AvrLon_xz   :: 2 次元(XZ)格子点データの経度方向積分および
  !                               平均
  ! x_IntRad_xz, x_AvrRad_xz   :: 2 次元(XZ)格子点データの動径方向積分および
  !                               平均
  ! z_IntLat_yz, z_AvrLat_yz   :: 2 次元(YZ)格子点データの緯度方向積分および
  !                               平均
  ! y_IntRad_yz, y_AvrRad_yz   :: 2 次元(YZ)格子点データの動径方向積分および
  !                               平均                  
  !
  !==== 積分・平均(1 次元データ)
  !
  ! IntLon_x, AvrLon_x  :: 1 次元(X)格子点データの経度方向積分および平均
  ! IntLat_y, AvrLat_y  :: 1 次元(Y)格子点データの緯度方向積分および平均
  ! IntRad_z, AvrRad_z  :: 1 次元(Z)格子点データの動径方向積分および平均
  !
  !==== 補間計算
  !
  ! Interpolate_wt :: スペクトルデータから任意の点の値を補間する. 
  ! 
  use dc_message
  use lumatrix
  use wa_zonal_module_svpack
  use at_module, z_RAD => g_X, z_RAD_WEIGHT => g_X_WEIGHT, &
                 at_az => at_ag, az_at => ag_at, &
                 t_z => t_g, z_t => g_t, &
                 t_Dr_t => t_Dx_t, at_Dr_at => at_Dx_at
  implicit none
  private

  public wt_Initial

  public x_Lon, x_Lon_Weight
  public y_Lat, y_Lat_Weight
  public z_Rad, z_Rad_Weight
  public l_nm, nm_l
  public xy_Lon, xy_Lat
  public xyz_Lon, xyz_Lat, xyz_Rad
  public wz_Rad
  public wt_VMiss

  public w_xy, xy_w
  public at_Dr_at, t_Dr_t, az_at, at_az
  public xyz_wt, wt_xyz, xyz_wz, wz_xyz, wz_wt, wt_wz
  public wt_DRad_wt, wt_DivRad_wt, wt_RotRad_wt, wt_Lapla_wt
  public xyz_GradLon_wt, xyz_gradlat_wt
  public wt_DivLon_xyz, wt_DivLat_xyz
  public wt_Div_xyz_xyz_xyz, xyz_Div_xyz_xyz_xyz
  public xyz_RotLon_wt_wt, xyz_RotLat_wt_wt, wt_RotRad_xyz_xyz

  public yz_IntLon_xyz, xz_IntLat_xyz, xy_IntRad_xyz
  public x_IntLatRad_xyz, y_IntLonRad_xyz, z_IntLonLat_xyz
  public IntLonLatRad_xyz

  public x_IntLat_xy, y_IntLon_xy, IntLonLat_xy
  public z_IntLat_yz, y_IntRad_yz, IntLatRad_yz
  public z_IntLon_xz, x_IntRad_xz, IntLonRad_xz
  public IntLon_x, IntLat_y, IntRad_z

  public yz_AvrLon_xyz, xz_AvrLat_xyz, xy_AvrRad_xyz
  public x_AvrLatRad_xyz, y_AvrLonRad_xyz, z_AvrLonLat_xyz
  public AvrLonLatRad_xyz

  public x_AvrLat_xy, y_AvrLon_xy, AvrLonLat_xy
  public z_AvrLat_yz, y_AvrRad_yz, AvrLatRad_yz
  public z_AvrLon_xz, x_AvrRad_xz, AvrLonRad_xz
  public AvrLon_x, AvrLat_y, AvrRad_z

  public wt_KxRGrad_wt, xyz_KGrad_wt, wt_L2_wt, wt_L2Inv_wt, wt_QOperator_wt
  public wt_RadRot_xyz_xyz, wt_RadRotRot_xyz_xyz_xyz
  public wt_Potential2vector, wt_Potential2Rotation
  public wt_VGradV

  public Interpolate_wt

  public nmz_ToroidalEnergySpectrum_wt, nz_ToroidalEnergySpectrum_wt
  public nmz_PoloidalEnergySpectrum_wt, nz_PoloidalEnergySpectrum_wt

  public wt_Boundaries, wt_TorBoundaries
  public wt_LaplaPol2Pol_wt, wz_LaplaPol2Pol_wz
  public wt_TormagBoundaries, wt_PolmagBoundaries

  public wt_BoundariesTau, wt_TorBoundariesTau, wt_LaplaPol2PolTau_wt
  public wt_TormagBoundariesTau, wt_PolmagBoundariesTau

  public wt_BoundariesGrid, wt_TorBoundariesGrid, wt_LaplaPol2PolGrid_wt
  public wt_TormagBoundariesGrid, wt_PolmagBoundariesGrid

  interface wt_Boundaries
     module procedure wt_BoundariesTau
  end interface

  interface wt_TorBoundaries
     module procedure wt_TorBoundariesTau
  end interface

  interface wt_LaplaPol2Pol_wt
     module procedure wt_LaplaPol2PolTau_wt
  end interface

  interface wt_TorMagBoundaries
     module procedure wt_TorMagBoundariesTau
  end interface

  interface wt_PolMagBoundaries
     module procedure wt_PolMagBoundariesTau
  end interface

  integer            :: im=1, jm=32, km=16   ! 格子点の設定(経度, 緯度, 動径)
  integer            :: nm=21, lm=16         ! 切断波数の設定(水平, 動径)
  real(8)            :: ri=0.0, ro=1.0       ! 球殻内外半径
  real(8), parameter :: pi=3.1415926535897932385D0

  real(8), dimension(:,:,:), allocatable :: xyz_LON, xyz_LAT, xyz_RAD ! 座標
  real(8), dimension(:,:), allocatable   :: wz_RAD                    ! 座標

  real(8) :: wt_VMiss = -999.0        ! 欠損値

  save im, jm, km, nm, lm, ri, ro

  contains
  !--------------- 初期化 -----------------
   subroutine wt_Initial(i,j,k,n,l,r_in,r_out,np,wa_init)
     !
     ! スペクトル変換の格子点数, 波数, 動径座標の範囲を設定する.
     !
     ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
     ! しなければならない. 
     !
     ! np_in は wt_module との互換性のためにおいているだけである. 
     ! OPENMP 計算は実装されていない. 
     !
     integer,intent(in) :: i              ! 格子点数(経度λ)
     integer,intent(in) :: j              ! 格子点数(緯度φ)
     integer,intent(in) :: k              ! 格子点数(動径 r)
     integer,intent(in) :: n              ! 切断波数(水平全波数)
     integer,intent(in) :: l              ! 切断波数(動径波数)

     real(8),intent(in) :: r_in           ! 球殻内半径
     real(8),intent(in) :: r_out          ! 球殻外半径

     integer,intent(in), optional :: np   ! OPENMP での最大スレッド数
     logical,intent(in), optional :: wa_init   ! wa_initial スイッチ

     logical    :: wa_initialize=.true.   ! wa_initial スイッチ
     
     im = i  ; jm = j ; km = k
     nm = n  ; lm = l
     ri = r_in ; ro = r_out

     if ( present(wa_init) ) then
        wa_initialize = wa_init
     else
        wa_initialize = .true.
     endif

     if ( wa_initialize ) then
        if ( present(np) ) then
           call wa_Initial(nm,im,jm,km+1,np)
        else
           call wa_Initial(nm,im,jm,km+1)
        endif
     endif

     call at_Initial(km,lm,r_in,r_out)

     allocate(xyz_Lon(0:im-1,1:jm,0:km))
     allocate(xyz_Lat(0:im-1,1:jm,0:km))
     allocate(xyz_Rad(0:im-1,1:jm,0:km))

     allocate(wz_Rad(nm+1,0:km))

     xyz_Lon = spread(xy_Lon,3,km+1)
     xyz_Lat = spread(xy_Lat,3,km+1)
     xyz_Rad = spread(spread(z_Rad,1,jm),1,im)

     wz_Rad = spread(z_Rad,1,nm+1)

     z_Rad_Weight = z_Rad_Weight * z_Rad**2       ! r^2 dr の積分重み

     call MessageNotify('M','wt_initial', &
          'wt_zonal_module_svpack (2017/03/06) is initialized')

   end subroutine wt_initial

  !--------------- 基本変換 -----------------

    function xyz_wt(wt)
      !
      ! スペクトルデータから 3 次元格子点データへ(逆)変換する.
      !
      real(8), dimension(nm+1,0:lm), intent(in)          :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
      real(8), dimension(0:im-1,1:jm,0:km)               :: xyz_wt
      !(out) 3 次元経度緯度動径格子点データ

      xyz_wt = xya_wa(wz_wt(wt))

    end function xyz_wt

    function wt_xyz(xyz)
      !
      ! 3 次元格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ
      real(8), dimension(nm+1,0:lm)                    :: wt_xyz
      !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

      wt_xyz = wt_wz(wa_xya(xyz))

    end function wt_xyz

    function xyz_wz(wz)
      !
      ! 水平スペクトル・動径格子点データから 3 次元格子点データへ(逆)変換する.
      !
      real(8), dimension(nm+1,0:km), intent(in)          :: wz
      !(in) 2 次元球面調和函数スペクトル・動径格子点データ
      real(8), dimension(0:im-1,1:jm,0:km)               :: xyz_wz
      !(out) 3 次元経度緯度動径格子点データ

      xyz_wz = xya_wa(wz)

    end function xyz_wz

    function wz_xyz(xyz)
      !
      ! 3 次元格子データから水平スペクトル・動径格子点データへ(正)変換する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in)   :: xyz
      !(in) 3 次元経度緯度動径格子点データ
      real(8), dimension(nm+1,0:km)                      :: wz_xyz
      !(out) 2 次元球面調和函数スペクトル・動径格子点データ

      wz_xyz = wa_xya(xyz)

    end function wz_xyz

    function wz_wt(wt)
      !
      ! スペクトルデータから水平スペクトル・動径格子点データへ(正)変換する.
      !
      real(8), dimension(nm+1,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
      real(8), dimension(nm+1,0:km)             :: wz_wt
      !(out) 2 次元球面調和函数スペクトル・動径格子点データ

      wz_wt = az_at(wt)

    end function wz_wt

    function wt_wz(wz)
      !
      ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension(nm+1,0:km), intent(in) :: wz
      !(in) 2 次元球面調和函数スペクトル・動径格子点データ
      real(8), dimension(nm+1,0:lm)             :: wt_wz
      !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

      wt_wz = at_az(wz)

    end function wt_wz

  !--------------- 微分計算 -----------------
    function wt_DRad_wt(wt)
      !
      ! 入力スペクトルデータに動径微分 ∂/∂r を作用する.
      !
      ! スペクトルデータの動径微分とは, 対応する格子点データに動径微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(nm+1,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nm+1,0:lm)             :: wt_DRad_wt
      !(in) 動径微分された2 次元球面調和函数チェビシェフスペクトルデータ

      wt_DRad_wt = at_Dr_at(wt)

    end function wt_DRad_wt

    function wt_DivRad_wt(wt)
      ! 
      ! 入力スペクトルデータに発散型動径微分
      !
      !       1/r^2 ∂/∂r (r^2 .)= ∂/∂r + 2/r
      !
      ! を作用する.
      !
      ! スペクトルデータの発散型動径微分とは, 対応する格子点データに
      ! 発散型動径微分を作用させたデータのスペクトル変換のことである. 
      !
      real(8), dimension(nm+1,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nm+1,0:lm)             :: wt_DivRad_wt
      !(out) 発散型動径微分を作用された 2 次元スペクトルデータ

      wt_DivRad_wt = wt_Drad_wt(wt) + wt_wz(2/wz_rad*wz_wt(wt))


    end function wt_DivRad_wt

    function wt_RotRad_wt(wt)
      !
      ! 入力スペクトルデータに回転型動径微分
      !
      !      1/r ∂(r.)/∂r = ∂(.)/∂r + (.)/r
      !
      ! を作用する.
      !
      ! スペクトルデータの回転型動径微分とは, 対応する格子点データに
      ! 回転型動径微分を作用させたデータのスペクトル変換のことである. 
      !
      real(8), dimension(nm+1,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nm+1,0:lm)             :: wt_RotRad_wt
      !(out) 回転型動径微分を作用された 2 次元スペクトルデータ

      wt_RotRad_wt = wt_Drad_wt(wt) + wt_wz(1/wz_Rad*wz_wt(wt))

    end function wt_RotRad_wt

    function wt_Lapla_wt(wt)
      ! 入力スペクトルデータにラプラシアン
      !
      !     ▽^2 =   1/r^2 cos^2φ・∂^2/∂λ^2 
      !            + 1/r^2 cosφ・∂/∂φ(cosφ∂/∂φ) 
      !            + 1/r^2 ∂/∂r (r^2 ∂/∂r) 
      !
      ! を作用する.
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである. 
      !
      real(8), dimension(nm+1,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nm+1,0:lm)             :: wt_Lapla_wt
      !(out) ラプラシアンを作用された 2 次元スペクトルデータ

      wt_Lapla_wt = wt_DivRad_wt(wt_Drad_wt(wt)) &
                   + wt_wz(wz_wt(wa_Lapla_wa(wt))/wz_Rad**2)

    end function wt_Lapla_wt

    function xyz_GradLon_wt(wt)
      !
      ! スペクトルデータに勾配型経度微分 1/rcosφ・∂/∂λ
      ! を作用させる.
      !
      real(8), dimension(nm+1,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,1:jm,0:km)   :: xyz_GradLon_wt
      !(out) 勾配型経度微分を作用された 2 次元スペクトルデータ

      xyz_GradLon_wt = xya_GradLon_wa(wz_wt(wt))/xyz_Rad

    end function xyz_GradLon_wt

    function xyz_GradLat_wt(wt) 
      !
      ! スペクトルデータに勾配型経度微分 1/r ∂/∂φ を作用させる.
      !
      real(8), dimension(nm+1,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,1:jm,0:km)    :: xyz_GradLat_wt
      !(out) 勾配型緯度微分を作用された 2 次元スペクトルデータ

      xyz_GradLat_wt = xya_GradLat_wa(wz_wt(wt))/xyz_Rad

    end function xyz_GradLat_wt

    function wt_DivLon_xyz(xyz)
      ! 
      ! 格子点データに発散型経度微分 1/rcosφ・∂/∂λ を作用させた
      ! スペクトルデータを返す.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in)   :: xyz
      !(in) 3 次元経度緯度動径格子点データ
      real(8), dimension(nm+1,0:lm)       :: wt_DivLon_xyz
      !(out) 発散型経度微分を作用された 2 次元スペクトルデータ

      wt_DivLon_xyz = wt_wz(wa_DivLon_xya(xyz/xyz_Rad))

    end function wt_DivLon_xyz

    function wt_DivLat_xyz(xyz)
      !
      ! 格子データに発散型緯度微分 1/rcosφ・∂(f cosφ)/∂φ を
      ! 作用させたスペクトルデータを返す.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in)   :: xyz
      !(in) 3 次元経度緯度動径格子点データ
      real(8), dimension(nm+1,0:lm)       :: wt_DivLat_xyz
      !(out) 発散型緯度微分を作用された 2 次元スペクトルデータ

      wt_DivLat_xyz = wt_wz(wa_divlat_xya(xyz/xyz_Rad))

    end function wt_DivLat_xyz

    function wt_Div_xyz_xyz_xyz(xyz_Vlon,xyz_Vlat,xyz_Vrad)
      !
      ! べクトル成分である 3 つの格子データに発散を作用させた
      ! スペクトルデータを返す.
      !
      ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分, 
      ! 動径成分を表し, 発散は 
      !
      !      1/rcosφ・∂u/∂λ + 1/rcosφ・∂(v cosφ)/∂φ 
      !    + 1/r^2 ∂/∂r (r^2 w)
      !
      ! と計算される.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlon
      !(in) ベクトル場の経度成分
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension(nm+1,0:lm)     :: wt_Div_xyz_xyz_xyz
      !(out) ベクトル場の発散

      wt_Div_xyz_xyz_xyz =   wt_DivLon_xyz(xyz_Vlon) &
                           + wt_DivLat_xyz(xyz_Vlat) &
                           + wt_DivRad_wt(wt_xyz(xyz_Vrad))

    end function wt_Div_xyz_xyz_xyz

    function xyz_Div_xyz_xyz_xyz(xyz_Vlon,xyz_Vlat,xyz_Vrad)
      !
      ! ベクトル成分である 3 つの格子データに発散を作用させる.
      !
      ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分, 
      ! 動径成分を表す.
      !
      ! 極の特異性を回避するためにベクトル場に cosφ/r の重みをかけて
      ! 計算している. 
      !
      !      div V = (r/cosφ)・div (Vcosφ/r) + V_φtanφ/r + V_r/r
      ! 
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension(0:im-1,1:jm,0:km)             :: xyz_Div_xyz_xyz_xyz
      !(out) ベクトル場の発散

      xyz_Div_xyz_xyz_xyz &
           = xyz_Rad/cos(xyz_Lat) &
                * xyz_wt(wt_Div_xyz_xyz_xyz(xyz_VLon*cos(xyz_Lat)/xyz_Rad,  &
                                            xyz_VLat*cos(xyz_Lat)/xyz_Rad,  &
                                            xyz_VRad*cos(xyz_Lat)/xyz_Rad ))&
             + xyz_VLat*tan(xyz_Lat)/xyz_Rad &
             + xyz_VRad/xyz_Rad

    end function xyz_Div_xyz_xyz_xyz

    function xyz_RotLon_wt_wt(wt_Vrad,wt_Vlat) 
      !
      ! ベクトル場の動径成分, 緯度成分である第 1, 2 引数 Vrad, Vlat から
      ! 回転の経度成分 
      !
      !    1/r ∂Vrad/∂φ-1/r ∂(r Vlat)/∂r を計算する.
      !
      ! を計算する
      !
      real(8), dimension(nm+1,0:lm), intent(in) :: wt_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension(nm+1,0:lm), intent(in) :: wt_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jm,0:km)                     :: xyz_RotLon_wt_wt
      !(out) ベクトル場の回転の経度成分

        xyz_RotLon_wt_wt =   xyz_GradLat_wt(wt_Vrad) &
                           - xyz_wt(wt_RotRad_wt(wt_Vlat))

    end function xyz_RotLon_wt_wt

    function xyz_RotLat_wt_wt(wt_Vlon,wt_Vrad) 
      !
      ! ベクトル場の経度成分, 動径成分である第 1, 2 引数 Vlon, Vrad から
      ! 回転の緯度成分 
      !
      !    1/r ∂(r Vlon)/∂r - 1/rcosφ・∂Vrad/∂λ
      !
      ! を計算する.
      !
      real(8), dimension(nm+1,0:lm), intent(in) :: wt_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension(nm+1,0:lm), intent(in) :: wt_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension(0:im-1,1:jm,0:km)                     :: xyz_RotLat_wt_wt
      !(out) ベクトル場の回転の緯度成分

        xyz_RotLat_wt_wt =   xyz_wt(wt_RotRad_wt(wt_Vlon)) &
                           - xyz_GradLon_wt(wt_Vrad) 

    end function xyz_RotLat_wt_wt

    function wt_RotRad_xyz_xyz(xyz_Vlat,xyz_Vlon) 
      !
      ! ベクトルの緯度成分, 経度成分である第 1, 2 引数 Vlat, Vlon に対して
      ! ベクトル場の回転の動径成分 
      !
      !    1/rcosφ・∂Vlat/∂λ - 1/rcosφ・∂(Vlon cosφ)/∂φ
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension(nm+1,0:lm)     :: wt_RotRad_xyz_xyz
      !(out) ベクトル場の回転の動径成分

        wt_RotRad_xyz_xyz =   wt_DivLon_xyz(xyz_Vlat) &
                            - wt_DivLat_xyz(xyz_Vlon)

    end function wt_RotRad_xyz_xyz

  !--------------- 積分計算 -----------------
    !----(入力データ xyz)---
    function yz_IntLon_xyz(xyz)  ! 経度(帯状)積分
      !
      ! 3 次元格子点データの経度方向(帯状)積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)dλ を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jm,0:km)  :: yz_IntLon_xyz
      !(out) 経度方向(帯状)積分された 2 次元子午面格子点データ

      integer :: i

      yz_IntLon_xyz = 0.0d0
      do i=0,im-1
         yz_IntLon_xyz(:,:) = yz_IntLon_xyz(:,:) &
                       + xyz(i,:,:) * x_Lon_Weight(i)
      enddo
    end function yz_IntLon_xyz

    function xz_IntLat_xyz(xyz)
      !
      ! 3 次元格子点データの緯度方向域積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) cosφ dφ を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,0:km)  :: xz_IntLat_xyz        
      !(out) 緯度積分された 2 次元緯度動径格子点データ.
      ! 緯度円格子点データ

      integer :: j

      xz_IntLat_xyz = 0.0d0
      do j=1,jm
         xz_IntLat_xyz(:,:) = xz_IntLat_xyz(:,:) &
                       + xyz(:,j,:) * y_Lat_Weight(j)
      enddo
    end function xz_IntLat_xyz

    function xy_IntRad_xyz(xyz)  ! 動径積分
      !
      ! 3 次元格子点データの動径方向域積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) r^2dr を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,1:jm)  :: xy_IntRad_xyz
      !(out) 動径積分された 2 次元経度緯度(水平, 球面)格子点データ

      integer :: k

      xy_IntRad_xyz = 0.0d0
      do k=0,km
         xy_IntRad_xyz(:,:) = xy_IntRad_xyz(:,:) &
                       + xyz(:,:,k) * z_Rad_Weight(k) 
      enddo
    end function xy_IntRad_xyz

    function x_IntLatRad_xyz(xyz)
      !
      ! 3 次元格子点データの緯度動径(子午面)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) r^2cosφ dφdr 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1)     :: x_IntLatRad_xyz
      !(out) 緯度動径(子午面)積分された 1 次元経度格子点データ

      integer :: j, k

      x_IntLatRad_xyz = 0.0D0
      do k=0,km
         do j=1,jm
            x_IntLatRad_xyz = x_IntLatRad_xyz &
                 + xyz(:,j,k) * y_Lat_Weight(j) * z_Rad_Weight(k)
         enddo
      enddo
    end function x_IntLatRad_xyz

    function y_IntLonRad_xyz(xyz)
      !
      ! 3 次元格子点データの経度動径(緯度円)積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) r^2dλdr を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jm)       :: y_IntLonRad_xyz
      !(out) 経度動径(緯度円)積分された 1 次元緯度格子点データ

      integer :: i, k

      y_IntLonRad_xyz = 0
      do k=0,km
         do i=0,im-1
            y_IntLonRad_xyz = y_IntLonRad_xyz &
                 + xyz(i,:,k) * x_Lon_Weight(i) * z_Rad_Weight(k)
         enddo
      enddo
    end function y_IntLonRad_xyz

    function z_IntLonLat_xyz(xyz)  ! 緯度経度(水平)積分
      !
      ! 3 次元格子点データの緯度経度(水平, 球面)積分
      ! 
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) cosφ dλdφ 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:km)     :: z_IntLonLat_xyz
      !(out) 緯度経度(水平, 球面)積分された 1 次元動径格子点データ

      integer :: i, j

      z_IntLonLat_xyz = 0
      do j=1,jm
         do i=0,im-1
            z_IntLonLat_xyz = z_IntLonLat_xyz &
                 + xyz(i,j,:) * x_Lon_Weight(i) * y_Lat_Weight(j)
         enddo
      enddo
    end function z_IntLonLat_xyz

    function IntLonLatRad_xyz(xyz) ! 緯度経度動径(全球)積分
      !
      ! 3 次元格子点データの緯度経度動径(全球)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !     ∫f(λ,φ,r) r^2cosφ dλdφdr 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz 
      !(in) 3 次元経度緯度動径格子点データ

      real(8)                     :: IntLonLatRad_xyz 
      !(out) 全球積分値

      integer :: i, j, k

      IntLonLatRad_xyz = 0
      do k=0,km
         do j=1,jm
            do i=0,im-1
               IntLonLatRad_xyz = IntLonLatRad_xyz &
                    + xyz(i,j,k) * x_Lon_Weight(i) &
                         * y_Lat_Weight(j) * z_Rad_Weight(k)
            enddo
         enddo
      enddo
    end function IntLonLatRad_xyz

    !----(入力データ yz)---
    function z_IntLat_yz(yz)  ! 緯度積分
      !
      ! 2 次元(YZ)格子点データの緯度方向域積分.
      !
      ! 2 次元データ f(φ,r) に対して∫f(φ,r) cosφ dφ を計算する.
      !
      real(8), dimension(jm,0:km), intent(in) :: yz
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(0:km)  :: z_IntLat_yz
      !(out) 緯度積分された 1 次元動径格子点データ

      integer :: j

      z_IntLat_yz = 0.0d0
      do j=1,jm
         z_IntLat_yz(:) = z_IntLat_yz(:) + yz(j,:) * y_Lat_Weight(j)
      enddo
    end function z_IntLat_yz

    function y_IntRad_yz(yz)  ! 動径積分
      !
      ! 2 次元(YZ)格子点データの動径方向域積分.
      !
      ! 2 次元データ f(φ,r) に対して∫f(φ,r) r^2dr を計算する.
      !
      real(8), dimension(1:jm,0:km), intent(in) :: yz
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(1:jm)  :: y_IntRad_yz
      !(out) 動径積分された 1 次元緯度格子点データ

      integer :: k

      y_IntRad_yz = 0.0d0
      do k=0,km
         y_IntRad_yz(:) = y_IntRad_yz(:) &
                       + yz(:,k) * z_Rad_Weight(k) 
      enddo
    end function y_IntRad_yz

    function IntLatRad_yz(yz)
      !
      ! 2 次元(YZ)格子点データの緯度動径積分(子午面)および平均
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) r^2cosφ dφdr を計算する.
      !
      real(8), dimension(1:jm,0:km), intent(in) :: yz
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8)                   :: IntLatRad_yz
      !(out) 積分値
      integer :: j, k

      IntLatRad_yz = 0
      do k=0,km
         do j=1,jm
            IntLatRad_yz = IntLatRad_yz &
                 + yz(j,k) * y_Lat_Weight(j) * z_Rad_Weight(k)
         enddo
      enddo
    end function IntLatRad_yz

    !----(入力データ xz)---
    function z_IntLon_xz(xz)
      !
      ! 2 次元(XZ)格子点データの経度方向積分.
      !
      ! 2 次元データ f(λ,r) に対して ∫f(λ,r)dλ を計算する.
      !
      real(8), dimension(0:im-1,0:km), intent(in) :: xz
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(0:km)  :: z_IntLon_xz
      !(out) 経度積分された 1 次元動径格子点データ

      integer :: i

      z_IntLon_xz = 0.0d0
      do i=0,im-1
         z_IntLon_xz(:) = z_IntLon_xz(:) + xz(i,:) * x_Lon_Weight(i)
      enddo

    end function z_IntLon_xz

    function x_IntRad_xz(xz)
      !
      ! 2 次元(XZ)格子点データの動径方向域積分.
      !
      ! 2 次元データ f(λ,r) に対して ∫f(λ,r) r^2dr を計算する.
      !
      real(8), dimension(0:im-1,0:km), intent(in) :: xz
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(0:im-1)  :: x_IntRad_xz
      !(out) 動径積分された 1 次元経度格子点データ

      integer :: k

      x_IntRad_xz = 0.0d0
      do k=0,km
         x_IntRad_xz(:) = x_IntRad_xz(:) &
                       + xz(:,k) * z_Rad_Weight(k) 
      enddo

    end function x_IntRad_xz

    function IntLonRad_xz(xz)  ! 経度動径(緯度円)積分
      !
      ! 2 次元(XZ)格子点データの経度動径積分
      !
      ! 2 次元データ f(λ,r) に対して∫f(λ,r) r^2dλdr を計算する.
      !
      real(8), dimension(0:im-1,0:km), intent(in) :: xz
      !(in) 2 次元緯度動径格子点データ

      real(8)                                 :: IntLonRad_xz
      !(out) 積分値

      integer :: i, k

      IntLonRad_xz = 0
      do k=0,km
         do i=0,im-1
            IntLonRad_xz = IntLonRad_xz &
                 + xz(i,k) * x_Lon_Weight(i) * z_Rad_Weight(k)
         enddo
      enddo
    end function IntLonRad_xz

    !----(入力データ z)---
    function IntRad_z(z)  ! 動径積分
      !
      ! 1 次元(Z)格子点データの動径方向域積分.
      !
      ! 1 次元データ f(r) に対して ∫f(r) r^2dr を計算する.
      !
      real(8), dimension(0:km), intent(in) :: z
      !(in) 1 次元動径格子点データ

      real(8)                              :: IntRad_z
      !(out) 積分値

      integer :: k

      IntRad_z = 0.0d0
      do k=0,km
         IntRad_z = IntRad_z + z(k) * z_Rad_Weight(k) 
      enddo
    end function IntRad_z

  !--------------- 平均計算 -----------------
    !----(入力データ xyz)---
    function yz_AvrLon_xyz(xyz)  ! 経度(帯状)積分
      !
      ! 3 次元格子点データの経度方向(帯状)平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)dλ/2π を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jm,0:km)  :: yz_AvrLon_xyz
      !(out) 経度方向(帯状)平均された 2 次元子午面格子点データ

      yz_AvrLon_xyz = yz_IntLon_xyz(xyz)/sum(x_Lon_Weight)

    end function yz_AvrLon_xyz

    function xz_AvrLat_xyz(xyz)  ! 緯度積分
      !
      ! 3 次元格子点データの緯度方向域平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)cosφ dφ/2 を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,0:km)  :: xz_AvrLat_xyz
      !(out) 緯度平均された 2 次元緯度動径格子点データ

      xz_AvrLat_xyz = xz_IntLat_xyz(xyz)/sum(y_Lat_Weight)

    end function xz_AvrLat_xyz

    function xy_AvrRad_xyz(xyz)
      !
      ! 3 次元格子点データの動径方向域平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して 
      !
      !    ∫f(λ,φ,r) r^2dr/((r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,1:jm)  :: xy_AvrRad_xyz          
      !(out) 動径平均された 2 次元経度緯度(水平, 球面)格子点データ
      ! 水平格子点データ

      xy_AvrRad_xyz = xy_IntRad_xyz(xyz)/sum(z_Rad_Weight)

    end function xy_AvrRad_xyz

    function x_AvrLatRad_xyz(xyz)  ! 緯度動径(子午面)積分
      !
      ! 3 次元格子点データの緯度動径(子午面)平均
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,,r) r^2cosφ dφdr /(2(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1)     :: x_AvrLatRad_xyz
      !(out) 緯度動径(子午面)平均された 1 次元経度格子点データ

      x_AvrLatRad_xyz = x_IntLatRad_xyz(xyz) &
                   /( sum(y_Lat_Weight)*sum(z_Rad_Weight) )

    end function x_AvrLatRad_xyz

    function y_AvrLonRad_xyz(xyz)  ! 経度動径(緯度円)積分
      !
      ! 3 次元格子点データの経度動径(緯度円)平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !     ∫f(λ,φ,r) r^2dλdr /(2π(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jm)       :: y_AvrLonRad_xyz
      !(out) 経度動径(緯度円)平均された 1 次元緯度格子点データ

      y_AvrLonRad_xyz = y_IntLonRad_xyz(xyz) &
                 /(sum(x_Lon_Weight)*sum(z_Rad_Weight))

    end function y_AvrLonRad_xyz

    function z_AvrLonLat_xyz(xyz)  ! 緯度経度(水平)積分
      !
      ! 3 次元格子点データの緯度経度(水平, 球面)積分
      ! 
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) cosφ dλdφ /4π 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:km)     :: z_AvrLonLat_xyz
      !(out) 緯度経度(水平, 球面)平均された 1 次元動径格子点データ

      z_AvrLonLat_xyz = z_IntLonLat_xyz(xyz) &
                 /(sum(x_Lon_Weight)*sum(y_Lat_Weight))

    end function z_AvrLonLat_xyz

    function AvrLonLatRad_xyz(xyz) ! 緯度経度動径(全球)積分
      !
      ! 3 次元格子点データの緯度経度動径(全球)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) r^2cosφ dλdφdr /(4π(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
      !(in) 3 次元経度緯度動径格子点データ

      real(8)                     :: AvrLonLatRad_xyz
      !(out) 全球平均値

      AvrLonLatRad_xyz = IntLonLatRad_xyz(xyz) &
            /(sum(x_Lon_Weight)*sum(y_Lat_Weight) * sum(z_Rad_Weight))

    end function AvrLonLatRad_xyz

    !----(入力データ yz)---
    function z_AvrLat_yz(yz)
      !
      ! 2 次元(YZ)格子点データの緯度方向域平均.
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) cosφ dφ/2 を計算する.
      !
      real(8), dimension(1:jm,0:km), intent(in) :: yz
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(0:km)  :: z_AvrLat_yz
      !(out) 緯度平均された 1 次元動径格子点データ

      z_AvrLat_yz = z_IntLat_yz(yz)/sum(y_Lat_Weight)

    end function z_AvrLat_yz

    function y_AvrRad_yz(yz)
      !
      ! 2 次元(YZ)格子点データの動径方向域平均.
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) r^2dr /((r[o]^3-r[i]^3)/3) 
      ! を計算する.
      !
      real(8), dimension(1:jm,0:km), intent(in) :: yz
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(1:jm)  :: y_AvrRad_yz
      !(out) 動径平均された 1 次元緯度格子点データ

      y_AvrRad_yz = y_IntRad_yz(yz)/sum(z_Rad_Weight)

    end function y_AvrRad_yz

    function AvrLatRad_yz(yz)  ! 緯度動径(子午面)積分
      !
      ! 2 次元(YZ)格子点データの緯度動径(子午面)平均
      !
      ! 2 次元データ f(φ,r) に対して
      !
      !    ∫f(φ,r) r^2cosφ dφdr /(2(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(1:jm,0:km), intent(in) :: yz
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8)                   :: AvrLatRad_yz
      !(out) 平均値

      AvrLatRad_yz = IntLatRad_yz(yz)/(sum(y_Lat_Weight)*sum(z_Rad_Weight))

    end function AvrLatRad_yz

    !----(入力データ xz)---
    function z_AvrLon_xz(xz)  ! 経度(帯状)積分
      !
      ! 2 次元(XZ)格子点データの経度方向平均.
      !
      ! 2 次元データ f(λ,r) に対して ∫f(λ,r)dλ/2π を計算する.
      !
      real(8), dimension(0:im-1,0:km), intent(in) :: xz
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(0:km)  :: z_AvrLon_xz 
      !(out) 経度平均された 1 次元動径格子点データ

      z_AvrLon_xz = z_IntLon_xz(xz)/sum(x_Lon_Weight)

    end function z_AvrLon_xz

    function x_AvrRad_xz(xz)  ! 動径積分
      !
      ! 2 次元(XZ)格子点データの動径方向域平均.
      !
      ! 2 次元データ f(λ,r) に対して
      !
      !   ∫f(λ,r) r^2dr /((r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,0:km), intent(in) :: xz
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(0:im-1)  :: x_AvrRad_xz
      !(out) 動径平均された 1 次元経度格子点データ

      x_AvrRad_xz = x_IntRad_xz(xz)/sum(z_Rad_Weight)

    end function x_AvrRad_xz

    function AvrLonRad_xz(xz)  ! 経度動径(緯度円)積分
      !
      ! 2 次元(XZ)格子点データの経度動径平均
      !
      ! 2 次元データ f(λ,r) に対して 
      ! 
      !    ∫f(λ,r) r^2dλdr /(2π(r[o]^3-r[i]^3)/3)
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,0:km), intent(in) :: xz    
      ! (in) 2 次元格子点データ
      real(8)                                 :: AvrLonRad_xz      
      ! 積分値

      AvrLonRad_xz = IntLonRad_xz(xz)/(sum(x_Lon_Weight)*sum(z_Rad_Weight))

    end function AvrLonRad_xz

    !----(入力データ z)---
    function AvrRad_z(z)
      !
      ! 1 次元(Z)格子点データの動径方向域平均.
      !
      ! 1 次元データ f(r) に対して ∫f(r) r^2dr /((r[o]^3-r[i]^3)/3) を
      ! 計算する.
      !
      real(8), dimension(0:km), intent(in) :: z
      !(in) 1 次元動径格子点データ
      real(8)                              :: AvrRad_z
      !(out) 平均値

      AvrRad_z = IntRad_z(z)/sum(z_Rad_Weight)

    end function AvrRad_z

  !--------------- ポロイダル/トロイダルモデル用微分 -----------------

    function wt_KxRGrad_wt(wt)
      !
      ! 入力スペクトルデータに経度微分 k×r・▽ = ∂/∂λを作用する.
      !
      real(8), dimension(nm+1,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nm+1,0:lm)             :: wt_KxRGrad_wt
      !(out) 経度微分を作用された 2 次元スペクトルデータ

      wt_KxRGrad_wt =  wa_Dlon_wa(wt)

    end function wt_KxRGrad_wt

    function xyz_KGrad_wt(wt)    ! k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r
      !
      ! 入力スペクトルデータに対応する格子データに軸方向微分 
      !
      !    k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r 
      !
      ! を作用させた格子データが返される. 
      ! ここでベクトル k は球の中心から北極向きの単位ベクトルである.
      !
      real(8), dimension(nm+1,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,1:jm,0:km)                     :: xyz_KGrad_wt
      !(out) 軸方向微分を作用された 2 次元スペクトルデータ

      xyz_KGrad_wt =  cos(xyz_Lat)*xyz_GradLat_wt(wt) &
                    + sin(xyz_Lat)*xyz_wt(wt_Drad_wt(wt))

    end function xyz_KGrad_wt

    function wt_L2_wt(wt)
      !
      ! 入力スペクトルデータに L^2 演算子(=-水平ラプラシアン)を作用する.
      !
      ! L^2 演算子は単位球面上の水平ラプラシアンの逆符号にあたる. 
      !  入力スペクトルデ ータに対応する格子点データに演算子 
      !
      !     L^2 = -1/cos^2φ・∂^2/∂λ^2 - 1/cosφ・∂/∂φ(cosφ∂/∂φ)
      !
      ! を作用させたデータのスペクトル変換が返される.
      !
      real(8), dimension(nm+1,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nm+1,0:lm)             :: wt_L2_wt
      !(out) L^2 演算子を作用された 2 次元スペクトルデータ

      wt_L2_wt = -wa_Lapla_wa(wt)

    end function wt_L2_wt

    function wt_L2Inv_wt(wt)
      !
      ! 入力スペクトルデータに L^2 演算子の逆演算(-逆水平ラプラシアン)を
      ! 作用する.
      !
      ! スペクトルデータに L^2 演算子を作用させる関数 wt_L2_wt の逆計算を
      ! 行う関数である.
      !
      real(8), dimension(nm+1,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nm+1,0:lm)             :: wt_L2Inv_wt
      !(out) L^2 演算子の逆演算を作用された 2 次元スペクトルデータ

      wt_L2Inv_wt = -wa_LaplaInv_wa(wt)

    end function wt_L2Inv_wt

    function wt_QOperator_wt(wt)
      !
      ! 入力スペクトルデータに対応する格子点データに演算子 
      !
      !    Q=(k・▽-1/2(L2 k・▽+ k・▽L2)) 
      !
      ! を作用させたデータのスペクトル変換が返される.
      !
      real(8), dimension(nm+1,0:lm), intent(in) :: wt
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(nm+1,0:lm)             :: wt_QOperator_wt
      !(out) Q 演算子を作用された 2 次元スペクトルデータ

      wt_QOperator_wt = &
             wt_xyz(xyz_KGrad_wt(wt) - xyz_KGrad_wt(wt_L2_wt(wt))/2) &
           - wt_L2_wt(wt_xyz(xyz_KGrad_wt(wt)))/2

    end function wt_QOperator_wt

    function wt_RadRot_xyz_xyz(xyz_VLON,xyz_VLAT)  ! r・(▽×v)
      !
      ! ベクトルの渦度と動径ベクトルの内積 r・(▽×v) を計算する.
      !
      ! 第 1, 2 引数(v[λ], v[φ])がそれぞれベクトルの経度成分, 緯度成分を表す.
      !
      !    r・(▽×v) = 1/cosφ・∂v[φ]/∂λ - 1/cosφ・∂(v[λ] cosφ)/∂φ
      !
      ! のスペクトル データが返される.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_VLON
      !(in) ベクトルの経度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_VLAT
      !(in) ベクトルの緯度成分

      real(8), dimension(nm+1,0:lm)     :: wt_RadRot_xyz_xyz
      !(out) ベクトルの渦度と動径ベクトルの内積

      wt_RadRot_xyz_xyz = wt_wz(wa_DivLon_xya(xyz_VLAT) &
                                - wa_DivLat_xya(xyz_VLON))
      
    end function wt_RadRot_xyz_xyz

    function wt_RadRotRot_xyz_xyz_xyz(xyz_VLON,xyz_VLAT,xyz_VRAD) 
      ! 
      ! ベクトル v に対して r・(▽×▽×v) を計算する.
      !
      ! 第 1, 2, 3 引数(v[λ], v[φ], v[r])がそれぞれベクトルの経度成分, 
      ! 緯度成分, 動径成分を表す. 
      !
      !    r・(▽×▽×v)  = 1/r ∂/∂r (r・( 1/cosφ・∂v[λ]/∂λ 
      !                                  + 1/cosφ・∂(v[φ] cosφ)/∂φ ) ) 
      !                     + L^2 v[r]/r 
      !
      ! のスペクトルデータが返される.
      !
      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_VLON
      !(in) ベクトルの経度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_VLAT
      !(in) ベクトルの緯度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_VRAD
      !(in) ベクトルの動径成分

      real(8), dimension(nm+1,0:lm)     :: wt_RadRotRot_xyz_xyz_xyz
      !(out) ベクトル v の r・(▽×▽×v) 

      wt_RadRotRot_xyz_xyz_xyz = &
               wt_RotRad_wt(wt_wz( &
                   (wa_DivLon_xya(xyz_VLON)+ wa_DivLat_xya(xyz_VLAT)))) &
             + wt_L2_wt(wt_xyz(xyz_VRAD/xyz_RAD))

    end function wt_RadRotRot_xyz_xyz_xyz

    subroutine wt_Potential2Vector(&
         xyz_VLON,xyz_VLAT,xyz_VRAD,wt_TORPOT,wt_POLPOT)
      !
      ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
      !
      !     v = ▽x(Ψr) + ▽x▽x(Φr) 
      !
      ! の各成分を計算する
      !
      real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VLON
      !(out) ベクトル場の経度成分

      real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VLAT
      !(out) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VRAD
      !(out) ベクトル場の動径成分

      real(8), dimension(nm+1,0:lm), intent(in) :: wt_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension(nm+1,0:lm), intent(in) :: wt_POLPOT
      !(in) ポロイダルポテンシャル

      xyz_VLON =   xyz_RAD * xyz_GradLat_wt(wt_TORPOT) &
                 + xya_GradLon_wa(wz_wt(wt_RotRad_wt(wt_POLPOT)))
      xyz_VLAT = - xyz_RAD * xyz_GradLon_wt(wt_TORPOT) &
                 + xya_GradLat_wa(wz_wt(wt_RotRad_wt(wt_POLPOT)))
      xyz_VRAD = xyz_wt(wt_L2_wt(wt_POLPOT))/xyz_RAD

    end subroutine wt_Potential2Vector

    subroutine wt_Potential2Rotation(&
       xyz_RotVLON,xyz_RotVLAT,xyz_RotVRAD,wt_TORPOT,wt_POLPOT)
      !
      ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
      !
      !     v = ▽x(Ψr) + ▽x▽x(Φr) 
      !
      ! に対して, その回転
      !
      !     ▽xv = ▽x▽x(Ψr) + ▽x▽x▽x(Φr) = ▽x▽x(Ψr) - ▽x((▽^2Φ)r)
      !
      ! を計算する. 
      
      ! ベクトル場の回転
      real(8), dimension(0:im-1,1:jm,0:km), intent(OUT) :: xyz_RotVLON
      !(out) 回転の経度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(OUT) :: xyz_RotVLAT
      !(out) 回転の緯度成分

      real(8), dimension(0:im-1,1:jm,0:km), intent(OUT) :: xyz_RotVRAD
      !(out) 回転の動径成分

      ! 入力ベクトル場を表すポテンシャル
      real(8), dimension(nm+1,0:lm), intent(in) :: wt_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension(nm+1,0:lm), intent(in) :: wt_POLPOT
      !(in) ポロイダルポテンシャル

      call wt_Potential2Vector( &
           xyz_RotVLON,xyz_RotVLAT,xyz_RotVRAD, &
           -wt_Lapla_wt(wt_POLPOT), wt_TORPOT)

    end subroutine wt_Potential2Rotation

 !------------------- 非線形項計算 ----------------------
    subroutine wt_VGradV(xyz_VGRADV_LON,xyz_VGRADV_LAT,xyz_VGRADV_RAD, &
                          xyz_VLON,xyz_VLAT,xyz_VRAD )
      !
      ! ベクトル場の v・▽v を計算する.
      !
      ! ベクトル場 v=(v[λ],v[φ],v[r]) に対するv・▽vの各成分は
      ! 次のように計算される.
      !
      !   (v・▽v)[λ] = ▽・(v[λ]v) + v[λ]v[r]/r - v[λ]v[φ]tan(φ)/r
      !   (v・▽v)[φ] = ▽・(v[φ]v) + v[φ]v[r]/r - v[λ]^2tan(φ)/r
      !   (v・▽v)[r] = ▽・(v[r]v) + (v[λ]^2+v[φ]^2)/r
      !
      ! 非発散速度場に対してはポテンシャルから wt_Potential2Rotation を
      ! 用いて回転を計算し, 恒等式 v・▽v = ▽(v[2^/2) - vx▽xv を
      ! 用いる方がよいだろう.
      !
      real(8), dimension(0:im-1,1:jm,0:km),intent(out)   :: xyz_VGRADV_LON
      !(out) (v・▽v) 経度成分

      real(8), dimension(0:im-1,1:jm,0:km),intent(out)   :: xyz_VGRADV_LAT
      !(out) (v・▽v) 緯度成分

      real(8), dimension(0:im-1,1:jm,0:km),intent(out)   :: xyz_VGRADV_RAD
      !(out) (v・▽v) 動径成分

      real(8), dimension(0:im-1,1:jm,0:km),intent(in)    :: xyz_VLON
      !(in) ベクトル場 v の経度成分

      real(8), dimension(0:im-1,1:jm,0:km),intent(in)    :: xyz_VLAT
      !(in) ベクトル場 v の緯度成分

      real(8), dimension(0:im-1,1:jm,0:km),intent(in)    :: xyz_VRAD
      !(in) ベクトル場 v の動径成分

      xyz_VGRADV_LON = &
              xyz_Div_xyz_xyz_xyz( &
                  xyz_VLON * xyz_VLON, xyz_VLON*xyz_VLAT, xyz_VLON*xyz_VRAD ) &
            + xyz_VLON*xyz_VRAD/xyz_RAD              &
            - xyz_VLON*xyz_VLAT*tan(xyz_LAT)/xyz_RAD 

      xyz_VGRADV_LAT = &
              xyz_Div_xyz_xyz_xyz( &
                  xyz_VLAT*xyz_VLON, xyz_VLAT*xyz_VLAT, xyz_VLAT*xyz_VRAD ) &
            + xyz_VLAT*xyz_VRAD/xyz_RAD        &
            + xyz_VLON**2*tan(xyz_LAT)/xyz_RAD 

      xyz_VGRADV_RAD = &
              xyz_Div_xyz_xyz_xyz( &
                  xyz_VRAD*xyz_VLON, xyz_VRAD*xyz_VLAT, xyz_VRAD*xyz_VRAD ) &
            - (xyz_VLON**2 + xyz_VLAT**2)/xyz_RAD 

    end subroutine wt_VGradV

  !--------------- 補間計算 -----------------
    function Interpolate_wt(wt_data,alon,alat,arad)
      !
      ! 緯度 alon, 経度 alat 動径 arad における関数値を
      ! その球面調和変換係数 wa_data から補間計算する
      !
      real(8), intent(IN) :: wt_data(nm+1,0:km)       ! スペクトルデータ
      real(8), intent(IN) :: alon                     ! 補間する位置(経度)
      real(8), intent(IN) :: alat                     ! 補間する位置(緯度)
      real(8), intent(IN) :: arad                     ! 補間する位置(動径)
      real(8) :: Interpolate_wt                       ! 補間した値
      
      Interpolate_wt = &
           Interpolate_w(a_Interpolate_at(wt_data,arad),alon,alat)

    end function Interpolate_wt

  !--------------- ポロイダル/トロイダルモデル用スペクトル解析 ----------------

    function nmz_ToroidalEnergySpectrum_wt(wt_TORPOT)
      !
      ! トロイダルポテンシャルから, トロイダルエネルギーの
      ! 球面調和函数全波数 n, 帯状波数 m の各成分を計算する
      !
      !  * 全波数 n, 帯状波数 m のトロイダルポテンシャルのスペクトル成分
      !    ψ(n,m,r)から全波数 n, 帯状波数 m 成分のトロイダルエネルギー
      !    スペクトルは  (1/2)n(n+1)4πr^2ψ(n,m,r)^2  と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和を動径積分したもの(r^2の重み無し)
      !    が球殻内での全エネルギーに等しい.
      !    
      !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !    wt_VMiss によって設定できる (初期値は -999.0)
      !
      real(8), dimension(nm+1,0:lm), intent(in) :: wt_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension(0:nm,-nm:nm,0:km) :: nmz_ToroidalEnergySpectrum_wt
      !(out) エネルギースペクトルトロイダル成分

      real(8), dimension(nm+1,0:km) ::wz_DATA   ! 作業領域
      integer :: n, m

      nmz_ToroidalEnergySpectrum_wt = wt_VMiss

      wz_DATA = wz_wt(wt_TORPOT)
      do n=0,nm
         do m=1,n
            nmz_ToroidalEnergySpectrum_wt(n,m,:) = 0.0D0
            nmz_ToroidalEnergySpectrum_wt(n,-m,:) = 0.0D0
         enddo
         nmz_ToroidalEnergySpectrum_wt(n,0,:) &
              = 0.5 * n*(n+1)* (4*pi) * z_Rad**2 &
                * wz_DATA(l_nm(n,0),:)**2
      enddo

    end function nmz_ToroidalEnergySpectrum_wt

    function nz_ToroidalEnergySpectrum_wt(wt_TORPOT)
      !
      ! トロイダルポテンシャルから, トロイダルエネルギーの
      ! 球面調和函数全波数の各成分を計算する.
      !
      !  * 全波数 n, 帯状波数 m のトロイダルポテンシャルのスペクトル成分
      !    ψ(n,m,r)から全波数 n 成分のトロイダルエネルギースペクトルは
      !    Σ[m=-n]^n(1/2)n(n+1)4πr^2ψ(n,m,r)^2 と計算される.
      !
      ! * 全てのエネルギースペクトル成分の和を動径積分したもの(r^2の重み無し)
      !    が球殻内での全エネルギーに等しい.
      !
      real(8), dimension(nm+1,0:lm), intent(in) :: wt_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension(0:nm,0:km) :: nz_ToroidalEnergySpectrum_wt 
      !(out) エネルギースペクトルトロイダル成分

      real(8), dimension(nm+1,0:km) ::wz_DATA   ! 作業領域
      integer :: n

      wz_DATA = wz_wt(wt_TORPOT)
      do n=0,nm
         nz_ToroidalEnergySpectrum_wt(n,:) &
              = 0.5 * n*(n+1)* (4*pi) * z_Rad**2 * wz_Data(l_nm(n,0),:)**2
      enddo

    end function nz_ToroidalEnergySpectrum_wt

    function nmz_PoloidalEnergySpectrum_wt(wt_POLPOT)
      !
      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
      ! 球面調和函数全波数 n, 帯状波数 m の各成分を計算する.
      !
      !  * 全波数 n, 帯状波数 m のポロイダルポテンシャルのスペクトル成分
      !    φ(n,m,r)から全波数 n, 帯状波数 m 成分のポロイダルエネルギー
      !    スペクトルは 
      !
      !      (1/2)n(n+1)4πr^2{[d(rφ(n,m,r))/dr]^2 + n(n+1)φ(n,m,r)^2} 
      !
      !    と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和を動径積分したもの(r^2の重み無し)
      !    が球殻内での全エネルギーに等しい.
      !
      !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !    欠損値の値はモジュール変数 wt_VMiss によって設定できる
      !    (初期値は -999.0)
      !
      real(8), dimension(nm+1,0:lm), intent(in) :: wt_POLPOT
      !(in) ポロイダルポテンシャル

      real(8), dimension(0:nm,-nm:nm,0:km) :: nmz_PoloidalEnergySpectrum_wt 
      !(out) エネルギースペクトルポロイダル成分


      real(8), dimension(nm+1,0:km) ::wz_DATA1   ! 作業領域
      real(8), dimension(nm+1,0:km) ::wz_DATA2   ! 作業領域
      integer :: n, m

      nmz_PoloidalEnergySpectrum_wt = wt_VMiss

      wz_Data1 = wz_wt(wt_POLPOT)
      wz_Data2 = wz_Rad*wz_wt(wt_DRad_wt(wt_POLPOT)) &    ! d(rφ)/dr
               + wz_wt(wt_POLPOT)                         ! = rdφ/dr+φ


      do n=0,nm
         do m=1,n
            nmz_PoloidalEnergySpectrum_wt(n,m,:) = 0.0D0
            nmz_PoloidalEnergySpectrum_wt(n,-m,:) = 0.0D0
         enddo
         nmz_PoloidalEnergySpectrum_wt(n,0,:) = &
                 + 0.5* n*(n+1)* (4*pi) &
                 *( wz_Data2(l_nm(n,0),:)**2  &
                   + n*(n+1)*wz_Data1(l_nm(n,0),:)**2 )
      enddo

    end function nmz_PoloidalEnergySpectrum_wt

    function nz_PoloidalEnergySpectrum_wt(wt_POLPOT)
      !
      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
      ! 球面調和函数全波数の各成分を計算する
      !
      !  * 全波数 n, 帯状波数 m のポロイダルポテンシャルのスペクトル成分
      !    φ(n,m,r)から全波数 n 成分のポロイダルエネルギースペクトルは
      !
      !      Σ[m=-n]^n ((1/2)n(n+1)4πr^2{[d(rφ(n,m,r))/dr]^2 
      !                 + n(n+1)φ(n,m,r)^2} 
      !
      !    と計算される.
      !
      !  * 全ての全波数に対してのエネルギースペクトル成分の和を動径積分したもの
      !    (r^2の重み無し)が球殻内での全エネルギーに等しい.
      !
      real(8), dimension(nm+1,0:lm), intent(in) :: wt_POLPOT
      !(in) ポロイダルポテンシャル

      real(8), dimension(0:nm,0:km) :: nz_PoloidalEnergySpectrum_wt
      !(out) エネルギースペクトルポロイダル成分

      real(8), dimension(nm+1,0:km) ::wz_DATA1   ! 作業領域
      real(8), dimension(nm+1,0:km) ::wz_DATA2   ! 作業領域
      integer :: n

      wz_Data1 = wz_wt(wt_POLPOT)
      wz_Data2 = wz_Rad*wz_wt(wt_DRad_wt(wt_POLPOT)) &    ! d(rφ)/dr
               + wz_wt(wt_POLPOT)                         ! = rdφ/dr+φ

      do n=0,nm
         nz_PoloidalEnergySpectrum_wt(n,:) = &
              + 0.5* n*(n+1)* (4*pi) &
              *( wz_Data2(l_nm(n,0),:)**2  &
                + n*(n+1)*wz_Data1(l_nm(n,0),:)**2 )
      enddo

    end function nz_PoloidalEnergySpectrum_wt


  !--------------- 境界値問題 -----------------

    subroutine wt_BoundariesTau(wt,values,cond)
      !
      ! スペクトルデータにディリクレ・ノイマン境界条件を適用する
      ! Chebyshev 空間での境界条件適用(タウ法)
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を
      ! 定める方法をとっている(タウ法).
      !
      real(8), dimension(nm+1,0:lm),intent(inout)      :: wt
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension(nm+1,2), intent(in), optional :: values
              !(in) 境界での 値/勾配 分布を水平スペクトル変換したものを与える. 
              !     省略時は値/勾配 0 となる. 

      character(len=2), intent(in), optional             :: cond
              !(in) 境界条件. 省略時は 'DD'
              !        DD : 両端ディリクレ条件
              !        DN : 上端ディリクレ, 下端ノイマン条件
              !        ND : 上端ノイマン, 下端ディリクレ条件
              !        NN : 両端ノイマン条件

      if (.not. present(cond)) then
         if (present(values)) then
            call at_BoundariesTau_DD(wt,values)
         else
            call at_BoundariesTau_DD(wt)
         endif
         return
      endif

      select case(cond)
      case ('NN')
         if (present(values)) then
            call at_BoundariesTau_NN(wt,values)
         else
            call at_BoundariesTau_NN(wt)
         endif
      case ('DN')
         if (present(values)) then
            call at_BoundariesTau_DN(wt,values)
         else
            call at_BoundariesTau_DN(wt)
         endif
      case ('ND')
         if (present(values)) then
            call at_BoundariesTau_ND(wt,values)
         else
            call at_BoundariesTau_ND(wt)
         endif
      case ('DD')
         if (present(values)) then
            call at_BoundariesTau_DD(wt,values)
         else
            call at_BoundariesTau_DD(wt)
         endif
      case default
         call MessageNotify('E','wt_BoundariesTau','B.C. not supported')
      end select

    end subroutine wt_BoundariesTau

    subroutine wt_BoundariesGrid(wt,values,cond)
      !
      ! スペクトルデータにディリクレ・ノイマン境界条件を適用する
      ! 実空間での境界条件適用
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには 
      ! wt_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある.
      !
      real(8), dimension(nm+1,0:lm),intent(inout)      :: wt
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension(nm+1,2), intent(in), optional :: values
              !(in) 境界での 値/勾配 分布を水平スペクトル変換したものを与える. 
              !    省略時は値/勾配 0 となる. 

      character(len=2), intent(in), optional             :: cond
              !(in) 境界条件. 省略時は 'DD'
              !        DD : 両端ディリクレ条件
              !        DN : 上端ディリクレ, 下端ノイマン条件
              !        ND : 上端ノイマン, 下端ディリクレ条件
              !        NN : 両端ノイマン条件

      if (.not. present(cond)) then
         if (present(values)) then
            call at_boundariesGrid_DD(wt,values)
         else
            call at_boundariesGrid_DD(wt)
         endif
         return
      endif

      select case(cond)
      case ('NN')
         if (present(values)) then
            call at_BoundariesGrid_NN(wt,values)
         else
            call at_BoundariesGrid_NN(wt)
         endif
      case ('DN')
         if (present(values)) then
            call at_BoundariesGrid_DN(wt,values)
         else
            call at_BoundariesGrid_DN(wt)
         endif
      case ('ND')
         if (present(values)) then
            call at_BoundariesGrid_ND(wt,values)
         else
            call at_BoundariesGrid_ND(wt)
         endif
      case ('DD')
         if (present(values)) then
            call at_BoundariesGrid_DD(wt,values)
         else
            call at_BoundariesGrid_DD(wt)
         endif
      case default
         call MessageNotify('E','wt_BoundariesGrid','B.C. not supported')
      end select

    end subroutine wt_BoundariesGrid

    subroutine wt_TorBoundariesTau(wt_TORPOT,values,cond,new) 
      !
      ! 速度トロイダルポテンシャルに対して境界条件を適用する. 
      ! Chebyshev 空間での境界条件適用. 
      !
      ! 速度トロイダルポテンシャルΨに対して与えられる境界条件は
      !
      !   * 粘着条件 : Ψ = Ψb(lon,lat). Ψb は境界球面での速度分布. 
      !                                   default は 0(静止状態).
      !
      !   * 応力なし条件 : ∂(Ψ/r)/∂r = 0.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nm+1,0:lm),intent(inout)      :: wt_TORPOT
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension(nm+1,2), intent(in), optional :: values
              !(in) 両端境界でのトロイダルポテンシャル
              !     粘着条件の時のみ有効

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:), allocatable  :: alu
      integer, dimension(:), allocatable    :: kp
      real(8), dimension(0:lm)              :: t_data
      real(8), dimension(0:km)              :: z_data
      logical                               :: rigid1, rigid2   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','wt_TorBoundariesTau','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(0:lm,0:lm),kp(0:lm))

         do l=0,lm
            t_data = 0.0D0 ; t_data(l) = 1.0D0
            alu(:,l) = t_data

            ! 力学的条件粘着条件 
            if ( rigid1 ) then
               z_data = z_t(t_data)
            else
               z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
            endif
            alu(lm-1,l) = z_data(0)       ! 境界 k=0 での条件式代入

            if ( rigid2 ) then
               z_data = z_t(t_data)
            else
               z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
            endif
            alu(lm,l)   = z_data(km)      ! 境界 k=km での条件式代入
         enddo

         call ludecomp(alu,kp)

         if ( rigid1 .AND. present(values) ) then 
            call MessageNotify('M','wt_TorBoundariesTau',&
                 'Toroidal potential at k=0 was given by the optional variable.')
         else if ( rigid1 .AND. (.NOT.present(values)) ) then
            call MessageNotify('M','wt_TorBoundariesTau',&
                 'Toroidal potential at k=0 was set to zero.')
         else if ( (.NOT. rigid1) .AND. present(values) ) then
            call MessageNotify('W','wt_TorBoundariesTau',&
                 'Boundary value k=0 cannot be set under stress-free condition.')
         endif

         if ( rigid2 .AND. present(values) ) then 
            call MessageNotify('M','wt_TorBoundariesTau',&
                 'Toroidal potential at k=0 was given by the optional variable.')
         else if ( rigid2 .AND. (.NOT.present(values)) ) then
            call MessageNotify('M','wt_TorBoundariesTau',&
                 'Toroidal potential at k=0 was set to zero.')
         else if ( (.NOT. rigid2) .AND. present(values) ) then
            call MessageNotify('W','wt_TorBoundariesTau',&
                 'Boundary value k=0 cannot be set under stress-free condition.')
         endif

         call MessageNotify('M','wt_TorBoundariesTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      if ( rigid1 .AND. present(values) ) then
         wt_torpot(:,lm-1) = values(:,1)
      else
         wt_torpot(:,lm-1) = 0.0D0
      endif
      if ( rigid2 .AND. present(values) ) then
         wt_torpot(:,lm)   = values(:,2)
      else
         wt_torpot(:,lm) = 0.0D0
      endif

      wt_torpot = lusolve(alu,kp,wt_TORPOT)

    end subroutine wt_TorBoundariesTau

    subroutine wt_TorBoundariesGrid(wt_TORPOT,values,cond,new) 
      !
      ! 速度トロイダルポテンシャルに対して境界条件を適用する.
      ! 実空間での境界条件適用
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには 
      ! wt_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある. 
      !
      ! 速度トロイダルポテンシャルΨに対して与えられる境界条件は
      !
      !   * 粘着条件 : Ψ = Ψb(lon,lat). Ψb は境界球面での速度分布. 
      !                                   default は 0 (静止状態).
      !
      !   * 応力なし条件 : ∂(Ψ/r)/∂r = 0.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nm+1,0:lm),intent(inout)      :: wt_TORPOT
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension(nm+1,2), intent(in), optional :: values
              !(in) 両端境界でのトロイダルポテンシャル
              !     粘着条件の時のみ有効

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(nm+1,0:km):: wz_TORPOT
      real(8), dimension(:,:), allocatable  :: alu
      integer, dimension(:), allocatable    :: kp
      real(8), dimension(0:lm)              :: t_data
      real(8), dimension(0:km)              :: z_data
      logical                               :: rigid1, rigid2   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','wt_TorBoundariesGrid','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','TorBoundariesGrid', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(0:km,0:lm),kp(0:lm))

         do l=0,lm
            t_data = 0.0D0 ; t_data(l)=1.0D0
            alu(:,l) = z_t(t_data)

            if ( rigid1 ) then
               z_data = z_t(t_data)
            else
               z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
            endif
            alu(0,l) = z_data(0)        ! 境界 k=0 での条件式代入

            if ( rigid2 ) then
               z_data = z_t(t_data)
            else
               z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
            endif
            alu(km,l)   = z_data(km)    ! 境界 k=km での条件式代入
         end do

         call ludecomp(alu,kp)

         if ( rigid1 .AND. present(values) ) then 
            call MessageNotify('M','wt_TorBoundariesGrid',&
                 'Toroidal potential at k=0 was given by the optional variable.')
         else if ( rigid1 .AND. (.NOT.present(values)) ) then
            call MessageNotify('M','wt_TorBoundariesGrid',&
                 'Toroidal potential at k=0 was set to zero.')
         else if ( (.NOT. rigid1) .AND. present(values) ) then
            call MessageNotify('W','wt_TorBoundariesGrid',&
                 'Boundary value at k=0 cannot be set under stress-free condition.')
         endif

         if ( rigid2 .AND. present(values) ) then 
            call MessageNotify('M','wt_TorBoundariesGrid',&
                 'Toroidal potential at k=km was given by the optional variable.')
         else if ( rigid2 .AND. (.NOT.present(values)) ) then
            call MessageNotify('M','wt_TorBoundariesGrid',&
                 'Toroidal potential at k=km was set to zero.')
         else if ( (.NOT. rigid2) .AND. present(values) ) then
            call MessageNotify('W','wt_TorBoundariesGrid',&
                 'Boundary value at k=km cannot be set under stress-free condition.')
         endif

         call MessageNotify('M','wt_TorBoundariesGrid',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      wz_TorPot       = wz_wt(wt_TorPot)

      if ( rigid1 .AND. present(values) ) then
         wz_TorPot(:,0)  = values(:,1)
      else
         wz_TorPot(:,0)  = 0.0D0
      endif

      if ( rigid2 .AND. present(values) ) then
         wz_TorPot(:,km) = values(:,2)
      else
         wz_TorPot(:,km) = 0.0D0
      endif

      wt_torpot = lusolve(alu,kp,wz_TorPot)

    end subroutine wt_TorBoundariesGrid

    function wz_LaplaPol2Pol_wz(wz,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      !
      ! チェビシェフ格子点空間で境界条件を適用している. 
      ! この関数を用いるためには wt_Initial にて設定する
      ! チェビシェフ切断波数(lm)と鉛直格子点数(km)を等しく
      ! しておく必要がある. 
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !   ▽^2Φ = f
      !     Φ = const. at boundaries.
      !     ∂Φ/∂r = 0 at boundaries           (粘着条件) 
      !     or ∂^2Φ/∂r^2 = 0 at boundaries    (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nm+1,0:km),intent(in)  :: wz
              !(in) 入力▽^2φ分布

      real(8), dimension(nm+1,0:km)             :: wz_LaplaPol2Pol_wz
              !(out) 出力ポロイダルポテンシャル分布

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(nm+1,0:km)  :: wz_work
      real(8), dimension(0:km,0:km)           :: gg
      real(8), dimension(0:km,0:km)           :: gg_work
      logical                                 :: rigid1, rigid2   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: k,n
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','wz_laplapol2pol_wz','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','wz_LaplaPol2Pol_wz', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(nm+1,0:km,0:km),kp(nm+1,0:km))

         do k=0,km
            wz_work = 0.0D0 ; wz_work(:,k) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,k) = wz_wt(wt_lapla_wt(wt_wz(wz_work)))
         enddo

         ! 運動学的条件. 流線は境界で一定
         gg = 0.0D0
         do k=0,km
            gg(k,k)=1.0D0
         enddo
         do n=1,nm+1
            alu(n,0,:)   = gg(:,0)
            alu(n,km,:)  = gg(:,km)
         enddo

         ! 力学的条件粘着条件 
         if ( rigid1 ) then
            gg_work=az_at(at_dr_at(at_az(gg)))
         else
            gg_work=az_at(at_dr_at(at_dr_at(at_az(gg))))
         endif
         do n=1,nm+1
            alu(n,1,:) = gg_work(:,0)
         enddo

         ! 力学的条件粘着条件 
         if ( rigid2 ) then
            gg_work=az_at(at_dr_at(at_az(gg)))
         else
            gg_work=az_at(at_dr_at(at_dr_at(at_az(gg))))
         endif
         do n=1,nm+1
            alu(n,km-1,:) = gg_work(:,km)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','wz_LaplaPol2Pol_wz',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      wz_work         = wz
      wz_work(:,1)    = 0.0D0               ! 力学的条件
      wz_work(:,km-1) = 0.0D0               ! 力学的条件
      wz_work(:,0)    = 0.0D0               ! 運動学的条件
      wz_work(:,km)   = 0.0D0               ! 運動学的条件 

      wz_laplapol2pol_wz = lusolve(alu,kp,wz_work)

    end function wz_LaplaPol2Pol_wz

    function wt_LaplaPol2PolTau_wt(wt,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      ! チェビシェフタウ法で境界条件を適用している. 
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !    ▽^2Φ = f
      !      Φ = const. at boundaries.
      !      ∂Φ/∂r = 0 at boundaries          (粘着条件) 
      !      or ∂^2Φ/∂r^2 = 0 at boundaries   (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nm+1,0:lm),intent(in)  :: wt
              !(in) 入力▽^2φ分布

      real(8), dimension(nm+1,0:lm)             :: wt_LaplaPol2PolTau_wt
              !(out) 出力ポロイダルポテンシャル分布

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(nm+1,0:km)           :: wz_work
      real(8), dimension(nm+1,0:lm)           :: wt_work
      logical                                 :: rigid1, rigid2   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','wt_LaplaPol2PolTau_wt','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(nm+1,0:lm,0:lm),kp(nm+1,0:lm))

         alu = 0.0D0
         do l=0,lm-2
            wt_work = 0.0D0 ; wt_work(:,l) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,l) = wt_Lapla_wt(wt_work)
         enddo

         ! 運動学的条件. 流線は境界で一定
         do l=0,lm
            wt_work=0.0D0
            wt_work(:,l) = 1.0D0
            wz_work = wz_wt(wt_work)

            alu(:,lm-1,l)  = wz_work(:,0)
            alu(:,lm,l)    = wz_work(:,km)

            ! 力学的条件粘着条件 
            if ( rigid1 ) then
               wz_work=wz_wt(wt_DRad_wt(wt_work))
            else
               wz_work=wz_wt(wt_DRad_wt(wt_DRad_wt(wt_work)))
            endif
            alu(:,lm-2,l) = wz_work(:,0)

            ! 力学的条件粘着条件 
            if ( rigid2 ) then
               wz_work=wz_wt(wt_DRad_wt(wt_work))
            else
               wz_work=wz_wt(wt_DRad_wt(wt_DRad_wt(wt_work)))
            endif
            alu(:,lm-3,l) = wz_work(:,km)
         end do

         call ludecomp(alu,kp)

         call MessageNotify('M','wt_LaplaPol2PolTau_wt',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      wt_work         = wt
      wt_work(:,lm)   = 0.0D0               ! 運動学的条件 
      wt_work(:,lm-1) = 0.0D0               ! 運動学的条件
      wt_work(:,lm-2) = 0.0D0               ! 力学的条件
      wt_work(:,lm-3) = 0.0D0               ! 力学的条件

      wt_LaplaPol2PolTau_wt = lusolve(alu,kp,wt_work)

    end function wt_LaplaPol2PolTau_wt

    function wt_LaplaPol2PolGrid_wt(wt,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      ! チェビシェフ格子点空間で境界条件を適用している. 
      !
      ! この関数を用いるためには wt_Initial にて設定する
      ! チェビシェフ切断波数(lm)と鉛直格子点数(km)を等しく
      ! しておく必要がある. 
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !    ▽^2Φ = f
      !      Φ = const. at boundaries.
      !      ∂Φ/∂r = 0 at boundaries          (粘着条件) 
      !      or ∂^2Φ/∂r^2 = 0 at boundaries   (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      ! 最終的にチェビシェフ係数の解が欲しい場合には, wz_LaplaPol2Pol_wz に
      ! 比べてチェビシェフ -- 格子点変換が 1 回分少なくて済む.
      !
      real(8), dimension(nm+1,0:lm),intent(in)  :: wt
              !(in) 入力▽^2φ分布

      real(8), dimension(nm+1,0:lm)             :: wt_LaplaPol2PolGrid_wt
              !(out) 出力ポロイダルポテンシャル分布

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(nm+1,0:km)  :: wz_work
      real(8), dimension(nm+1,0:lm)  :: wt_work
      real(8), dimension(0:lm,0:lm)           :: tt_I
      real(8), dimension(0:lm,0:km)           :: tz_work
      logical                                 :: rigid1, rigid2   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l,n
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','wt_LaplaPol2PolGrid_wt','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','wt_LaplaPol2PolGrid_wt', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(nm+1,0:km,0:lm),kp(nm+1,0:lm))

         do l=0,lm
            wt_work = 0.0D0 ; wt_work(:,l) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,l) = wz_wt(wt_Lapla_wt(wt_work))
         enddo

         ! 運動学的条件. 流線は境界で一定
         tt_I = 0.0D0
         do l=0,lm
            tt_I(l,l)=1.0D0
         enddo

         ! 非電気伝導体
         tz_work = az_at(tt_I)

         do n=1,nm+1
            alu(n,0,:)  = tz_work(:,0)
            alu(n,km,:) = tz_work(:,km)
         enddo

         ! 力学的条件粘着条件 
         if ( rigid1 ) then
            tz_work=az_at(at_Dr_at(tt_I))
         else
            tz_work=az_at(at_Dr_at(at_Dr_at(tt_I)))
         endif
         do n=1,nm+1
            alu(n,1,:) = tz_work(:,0)
         enddo

         ! 力学的条件粘着条件 
         if ( rigid2 ) then
            tz_work=az_at(at_Dr_at(tt_I))
         else
            tz_work=az_at(at_Dr_at(at_Dr_at(tt_I)))
         endif
         do n=1,nm+1
            alu(n,km-1,:) = tz_work(:,km)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','wt_LaplaPol2PolGrid_wt',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      wz_work         = wz_wt(wt)
      wz_work(:,1)    = 0.0D0               ! 力学的条件
      wz_work(:,km-1) = 0.0D0               ! 力学的条件
      wz_work(:,0)    = 0.0D0               ! 運動学的条件
      wz_work(:,km)   = 0.0D0               ! 運動学的条件 

      wt_LaplaPol2PolGrid_wt = lusolve(alu,kp,wz_work)

    end function wt_LaplaPol2PolGrid_wt

    subroutine wt_TormagBoundariesTau(wt_TOR,new)
      
      ! 磁場トロイダルポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
      ! とっている(タウ法). 現在のところ境界物質が非電気伝導体の場合のみ
      ! 対応している. その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 外側
      !    wt_psi = 0   at the outer boundary
      ! 内側
      !    wt_psi = 0       at the inner boundary
      ! 
      ! であるから wt_Boundaries で対応可能だが, 将来のため別途作成しておく.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nm+1,0:lm),intent(inout)   :: wt_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: wt_I
      real(8), dimension(:,:), allocatable    :: wz_PSI

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: l
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(wt_I) ) deallocate(wt_I)
         if ( allocated(wz_PSI) ) deallocate(wz_PSI)

         allocate(alu(nm+1,0:lm,0:lm),kp(nm+1,0:lm))
         allocate(wt_I(nm+1,0:lm),wz_PSI(nm+1,0:km))

         do l=0,lm
            wt_I = 0.0D0 ; wt_I(:,l)=1.0D0
            alu(:,:,l) = wt_I

            ! 非電気伝導体
            wz_PSI = wz_wt(wt_I)

            alu(:,lm-1,l) = wz_PSI(:,0)
            alu(:,lm,l)   = wz_PSI(:,km)
         enddo

         call ludecomp(alu,kp)

         deallocate(wt_I,wz_PSI)

         call MessageNotify('M','TormagBoundariesTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      wt_TOR(:,lm-1) = 0.0D0
      wt_TOR(:,lm)   = 0.0D0
      wt_TOR = lusolve(alu,kp,wt_TOR)

    end subroutine wt_TormagBoundariesTau

    subroutine wt_TormagBoundariesGrid(wt_TOR,new)
      !
      ! 磁場トロイダルポテンシャルに対して境界条件を適用する.
      ! 鉛直実空間での境界条件適用.
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには 
      ! wt_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある. 
      !
      ! 現在のところ境界物質が非電気伝導体の場合のみ対応している. 
      ! その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 外側
      !    wt_psi = 0   at the outer boundary
      ! 内側
      !    wt_psi = 0       at the inner boundary
      ! 
      ! であるので wt_Boundaries で対応可能だが, 将来のため別途作成しておく
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nm+1,0:lm),intent(inout)   :: wt_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: wt_I
      real(8), dimension(:,:), allocatable    :: wz_PSI
      real(8), dimension(nm+1,0:km)  :: wz_TOR

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: l
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','TorMagBoundariesGrid', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(wt_I) ) deallocate(wt_I)
         if ( allocated(wz_PSI) ) deallocate(wz_PSI)

         allocate(alu(nm+1,0:km,0:lm),kp(nm+1,0:lm))
         allocate(wt_I(nm+1,0:lm),wz_PSI(nm+1,0:km))

         do l=0,lm
            wt_I = 0.0D0 ; wt_I(:,l)=1.0D0
            wz_PSI = wz_wt(wt_I)
            alu(:,:,l) = wz_PSI

            ! 非電気伝導体
            alu(:,0,l)  = wz_PSI(:,0)
            alu(:,km,l) = wz_PSI(:,km)
         enddo

         call ludecomp(alu,kp)

         deallocate(wt_I,wz_PSI)

         call MessageNotify('M','TormagBoundariesGrid',&
                           'Matrix to apply  b.c. newly produced.')
      endif
      
      wz_TOR       = wz_wt(wt_TOR)
      wz_TOR(:,0)  = 0.0D0
      wz_TOR(:,km) = 0.0D0
      wt_TOR = lusolve(alu,kp,wz_TOR)

    end subroutine wt_TormagBoundariesGrid

    subroutine wt_PolmagBoundariesTau(wt_POL,new)
      !
      ! 磁場ポロイダルポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
      ! とっている(タウ法). 現在のところ境界物質が非電気伝導体の場合のみ
      ! 対応している. その場合, 磁場ポロイダルポテンシャルの各水平スペクトル
      ! 成分 h にたいして境界条件が与えられ,
      !
      !  * 外側境界 : dh/dr + (n+1)h/r = 0
      !  * 内側境界 : dh/dr - nh/r = 0
      !
      ! である. ここで n は h の水平全波数である. 
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nm+1,0:lm),intent(inout)   :: wt_POL
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: wt_I
      real(8), dimension(:,:), allocatable    :: wz_PSI
      real(8), dimension(:,:), allocatable    :: wz_DPSIDR
      real(8), dimension(:), allocatable      :: w_n

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: l, n, nn(2)
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(wt_I) ) deallocate(wt_I)
         if ( allocated(wz_PSI) ) deallocate(wz_PSI)
         if ( allocated(wz_DPSIDR) ) deallocate(wz_DPSIDR)
         if ( allocated(w_n) ) deallocate(w_n)

         allocate(alu(nm+1,0:lm,0:lm),kp(nm+1,0:lm))
         allocate(wt_I(nm+1,0:lm),w_n(nm+1))
         allocate(wz_PSI(nm+1,0:km),wz_DPSIDR(nm+1,0:km))

         do n=1,nm+1
            nn=nm_l(n)
            w_n(n) = nn(1)
         enddo

         do l=0,lm
            wt_I = 0.0D0 ; wt_I(:,l) = 1.0D0
            alu(:,:,l) = wt_I

            wz_PSI = wz_wt(wt_I)
            wz_DPSIDR = wz_wt(wt_DRad_wt(wt_I))
            alu(:,lm-1,l) = wz_DPSIDR(:,0) + (w_n+1) * wz_PSI(:,0)/z_RAD(0)
            alu(:,lm,l)   = wz_DPSIDR(:,km) - w_n * wz_PSI(:,km)/z_RAD(km)
         enddo

         call ludecomp(alu,kp)

         deallocate(wt_I,wz_PSI,wz_DPSIDR)

         call MessageNotify('M','PolmagBoundariesTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      wt_POL(:,lm-1) = 0.0D0
      wt_POL(:,lm)   = 0.0D0
      wt_POL = lusolve(alu,kp,wt_POL)

    end subroutine wt_PolmagBoundariesTau

    subroutine wt_PolmagBoundariesGrid(wt_POL,new)
      !
      ! 磁場ポロイダルポテンシャルに対して境界条件を適用する.
      ! 鉛直実空間での境界条件適用. 
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには 
      ! wt_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある. 
      !
      ! 現在のところ境界物質が非電気伝導体の場合のみ対応している. 
      ! その場合, 磁場ポロイダルポテンシャルの各水平スペクトル成分 h に
      ! たいして境界条件が与えられ,
      !
      !  * 外側境界 : dh/dr + (n+1)h/r = 0
      !  * 内側境界 : dh/dr - nh/r = 0
      !
      ! である. ここで n は h の水平全波数である. 
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension(nm+1,0:lm),intent(inout)   :: wt_POL
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: wt_I
      real(8), dimension(:,:), allocatable    :: wz_PSI
      real(8), dimension(:,:), allocatable    :: wz_DPSIDR
      real(8), dimension(:), allocatable      :: w_n

      real(8), dimension(nm+1,0:km)  :: wz_POL

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: l, n, nn(2)
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','PolMagBoundariesGrid', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(wt_I) ) deallocate(wt_I)
         if ( allocated(wz_PSI) ) deallocate(wz_PSI)
         if ( allocated(wz_DPSIDR) ) deallocate(wz_DPSIDR)
         if ( allocated(w_n) ) deallocate(w_n)

         allocate(alu(nm+1,0:lm,0:lm),kp(nm+1,0:lm))
         allocate(wt_I(nm+1,0:lm),w_n(nm+1))
         allocate(wz_PSI(nm+1,0:km),wz_DPSIDR(nm+1,0:km))

         do n=1,nm+1
            nn=nm_l(n)
            w_n(n) = nn(1)
         enddo

         do l=0,lm
            wt_I = 0.0D0 ; wt_I(:,l) = 1.0D0
            wz_PSI = wz_wt(wt_I)
            alu(:,:,l) = wz_PSI

            wz_DPSIDR = wz_wt(wt_DRad_wt(wt_I))
            alu(:,0,l)  = wz_DPSIDR(:,0) + (w_n+1) * wz_PSI(:,0)/z_RAD(0)
            alu(:,km,l) = wz_DPSIDR(:,km) - w_n * wz_PSI(:,km)/z_RAD(km)
         enddo

         call ludecomp(alu,kp)

         deallocate(wt_I,wz_PSI,wz_DPSIDR,w_n)

         call MessageNotify('M','PolmagBoundariesGrid',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      wz_POL       = wz_wt(wt_POL)
      wz_POL(:,0)  = 0.0D0
      wz_POL(:,km) = 0.0D0
      wt_POL = lusolve(alu,kp,wz_POL)

    end subroutine wt_PolmagBoundariesGrid

end module wt_zonal_module_svpack

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_zonal_module_sjpack テストプログラム :: 微分関数のテスト
!
!履歴  2009/09/22  竹広真一
!
program w_zonal_module_sjpack_deriv

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_zonal_module_sjpack
  implicit none

  integer, parameter :: im=1, jm=16, nm=10

  real(8), dimension(0:im-1,1:jm)  ::  xy_data1              ! 元の関数
  real(8), dimension(0:im-1,1:jm)  ::  xy_data2              ! 元の関数
  real(8), dimension(0:im-1,1:jm)  ::  xy_ddata              ! 微分の正解
  real(8), dimension(0:im-1,1:jm)  ::  mu                    ! μ=sinφ

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  real(8)                          ::  pi

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','w_zonal_module_sjpack_deriv_test', &
                         'w_zonal_module_sjpack derivative function tests') 

  call w_Initial( nm, im, jm )

  !---- Y_1^0 のテスト ----
  xy_data1 = sin(xy_Lat)                         ! Y_1^0

  xy_ddata = -2.0D0*sin(xy_Lat)                  ! w_Lapla_w
  call AssertEqual(&
    message='Y_1^0 Test of w_Lapla_w',                            &
    answer = xy_ddata,                                            &
    check = xy_w(w_Lapla_w(w_xy(xy_data1))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_ddata = -1.0D0/2.0D0*sin(xy_Lat)            ! w_LaplaInv_w
  call AssertEqual(&
    message='Y_1^0 Test of w_LaplaInv_w',                         &
    answer = xy_ddata,                                            &
    check = xy_w(w_LaplaInv_w(w_xy(xy_data1))),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_ddata = 0.0D0                           ! w_DLon_w
  call AssertEqual(&
    message='Y_1^0 Test of w_DLon_w',                             &
    answer = xy_ddata,                                            &
    check = xy_w(w_DLon_w(w_xy(xy_data1))),                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_ddata = 0.0D0                           ! xy_GradLon_w
  call AssertEqual(&
    message='Y_1^0 Test of xy_GradLon_w',                         &
    answer = xy_ddata,                                            &
    check = xy_GradLon_w(w_xy(xy_data1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_ddata = cos(xy_Lat)                    ! xy_GradLat_w
  call AssertEqual(&
    message='Y_1^0 Test of xy_GradLat_w',                         &
    answer = xy_ddata,                                            &
    check = xy_GradLat_w(w_xy(xy_data1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^0 cosφ のテスト ----
  xy_data1 = (3.0D0/2.0D0*sin(xy_Lat)**2 - 1.0D0/2.0D0)*cos(xy_Lat)
  ! Y_2^0 cosφ

  xy_ddata = 0.0D0                          ! w_DivLon_xy
  call AssertEqual(&
    message='Y_2^0 cos φ Test of w_DivLon_xy',                   &
    answer = xy_ddata,                                            &
    check = xy_w(w_DivLon_xy(xy_data1)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_ddata = 3*sin(xy_Lat)*(cos(xy_Lat)**2-sin(xy_Lat)**2) + sin(xy_Lat)
  ! w_DivLat_w
  call AssertEqual(&
    message='Y_2^0 cos φ Test of w_DivLat_xy',                   &
    answer = xy_ddata,                                            &
    check = xy_w(w_DivLat_xy(xy_data1)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Jacobian のテスト ----
  xy_data1 = sin(xy_Lat)                             ! Y_1^0
  xy_data2 = 3.0D0/2.0D0*sin(xy_Lat)**2-1.0D0/2.0D0  ! Y_2^0

  xy_ddata = 0.0
  call AssertEqual(&
    message='Y_1^0 Test of w_Jacobian_w_w',                       &
    answer = xy_ddata,                                            &
    check = xy_w(w_Jacobian_w_w(w_xy(xy_data1),w_xy(xy_data1))),  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_ddata = 0.0D0
  call AssertEqual(&
    message='Y_1^0  and Y_2^0 Test of w_Jacobian_w_w',            &
    answer = xy_ddata,                                            &
    check = xy_w(w_Jacobian_w_w(w_xy(xy_data1),w_xy(xy_data2))),  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !============== 微分計算 (λ,μ座標系用) のテスト ==============
  mu = sin(xy_Lat)

  !----- Y_2^0 のテスト -----
  xy_data1 = 3*mu**2-1                              ! Y_2^0

  xy_ddata = 0.0
  call AssertEqual(&
    message='Y_2^0 Test of xy_GradLambda_w',                      &
    answer = xy_ddata,                                            &
    check = xy_GradLambda_w(w_xy(xy_data1)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_ddata = 6*mu*(1-mu**2)
  call AssertEqual(&
    message='Y_2^0 Test of xy_GradMu_w',                          &
    answer = xy_ddata,                                            &
    check = xy_GradMu_w(w_xy(xy_data1)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !----- Y_2^0 cosφ のテスト -----
  xy_data1 = (3*mu**2-1)*(1-mu**2)                ! Y_2^0 (1-μ^2)

  xy_ddata = 0.0
  call AssertEqual(&
    message='Y_2^0 cos φ Test of w_DivLambda_xy',                &
    answer = xy_ddata,                                            &
    check = xy_w(w_DivLambda_xy(xy_data1)),                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_ddata = (2-3*mu**2)*4*mu
  call AssertEqual(&
    message='Y_2^0 cos φ Test of w_DivMu_xy',                    &
    answer = xy_ddata,                                            &
    check = xy_w(w_DivMu_xy(xy_data1)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','w_zonal_module_sjpack_deriv_test', &
       'w_zonal_module_sjpack derivative function tests succeeded!') 

end program w_zonal_module_sjpack_deriv

!--
!----------------------------------------------------------------------
! Copyright(c) 2008-2013 SPMDODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  eq_module
!      2 次元円盤領域問題, Fourier 展開 + 多項式展開法
!
!      spml/eq_module モジュールは 2 次元円盤領域での流体運動を
!      スペクトル法により数値計算を実行するための Fortran90 関数を提供する.
!      周期的な境界条件を扱うための方位角方向へのフーリエ変換と
!      境界壁を扱うための動径方向の多項式変換を用いる場合の
!      スペクトル計算のためのさまざまな関数を提供する.
!
!      内部で ae_module, aq_module を用いている.
!      最下部ではフーリエ変換およびチェビシェフ変換のエンジンとして
!      ISPACK/FTPACK の Fortran77 サブルーチンを用いている.
!
!      Matsushima and Marcus (1994) の多項式に関する説明は
!      doc/spectral_radial.tex を参照のこと.
!
!
!履歴  2008/04/11  竹広真一  et_module より改造
!      2008/05/02  竹広真一  コメント修正
!      2008/10/29  竹広真一  eq_Vor2Strm_eq 行列生成ルーチン改良
!      2009/01/09  竹広真一  eq_Initial メッセージに日付を追加
!      2009/01/29  佐々木洋平 コメントを RDoc 用に修正
!      2009/07/31  竹広真一  境界条件計算用配列を threadprivate 指定(OpenMP)
!      2010/03/10  佐々木洋平  threadprivate 削除(コンパイラ依存)
!      2011/03/07  佐々木洋平  境界条件用論理変数を初期化, if 文削除
!      2013/08/20  竹広真一  gnu fortran 対応
!
!++
module eq_module
  !
  != eq_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/eq_module モジュールは 2 次元円盤領域での流体運動を
  ! スペクトル法により数値計算を実行するための Fortran90 関数を提供する.
  ! 周期的な境界条件を扱うための方位角方向へのフーリエ変換と
  ! 境界壁を扱うための動径方向の多項式変換を用いる場合の
  ! スペクトル計算のためのさまざまな関数を提供する.
  !
  ! 内部で ae_module, aq_module を用いている.
  ! 最下部ではフーリエ変換およびチェビシェフ変換のエンジンとして
  ! ISPACK/FTPACK の Fortran77 サブルーチンを用いている.
  !
  ! Matsushima and Marcus (1994) の多項式に関する説明は
  ! 動径座標のスペクトル法(spectral_radial.pdf[link:./spectral_radial.pdf])を
  ! 参照のこと.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (eq_, rp_, r_, p_) は, 返す値の形を示している.
  !   eq_ :: 2次元スペクトルデータ
  !   rp_ :: 2 次元格子点データ
  !   r_  :: 動径方向 1 次元格子点データ
  !   p_  :: 方位角方向 1 次元格子点データ
  !
  ! * 関数名の間の文字列(Dr, Dp, Lapla, LaplaInv, Jacobian)は,
  !   その関数の作用を表している.
  !
  ! * 関数名の最後 (_eq_eq,_eq,_rp, _r, _p) は, 入力変数のスペクトルデータ
  !   および格子点データであることを示している.
  !   _eq    :: 2次元スペクトルデータ
  !   _eq_eq :: 2 つの2次元スペクトルデータ
  !   _rp    :: 2 次元格子点データ
  !   _r     :: 動径方向 1 次元格子点データ
  !   _p     :: 方位角方向 1 次元格子点データ
  !
  !=== 各データの種類の説明
  !
  ! * rp : 2 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(jm,0:im-1).
  !   * im, jm はそれぞれ方位角, 動径座標の格子点数であり,
  !     サブルーチン eq_initial にてあらかじめ設定しておく.
  !   * 第 1 次元が動径座標の格子点位置番号, 第 2 次元が方位角座標の
  !     格子点位置番号である.
  !
  ! * eq : 2 次元スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(-km:km,0:lm).
  !   * km, lm はそれぞれ方位角, 動径方向の最大波数であり,
  !     サブルーチン eq_initial にてあらかじめ設定しておく.
  !   * 動径スペクトルデータの格納のされ方については
  !     aq_module.f90 を参照のこと.
  !
  ! * p, r : X, Y 方向 1 次元格子点データ.
  !   * 変数の種類と次元はそれぞれ real(8), dimension(0:im-1)
  !     および real(8), dimension(jm).
  !
  ! * e, q : 1 次元スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(-km:km)
  !     および real(8), dimension(0:lm).
  !
  ! * ap, ar : 1 次元格子点データの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(:,0:im-1)
  !     および real(8), dimension(:,jm).
  !
  ! * ae, aq : 1 次元スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(:,-km:km)
  !     および real(8), dimension(:,0:lm).
  !
  ! * eq_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * rp_ で始まる関数が返す値は 2 次元格子点データに同じ.
  !
  ! * p_, p_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! eq_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  !
  !==== 座標変数
  !
  ! p_Phi, r_Rad               ::  格子点座標(X,Y座標)を格納した 1 次元配列
  ! p_Phi_Weight, r_Rad_Weight ::  重み座標を格納した 1 次元配列
  ! rp_Phi, rp_Rad             ::  格子点データの XY 座標(X,Y)
  !                                (格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! rp_eq :: スペクトルデータから格子データへの変換
  ! eq_rp :: 格子データからスペクトルデータへの変換
  ! ap_ae, p_e :: 方位角方向のスペクトルデータから格子データへの変換
  ! ar_aq, r_q :: 動径方向のスペクトルデータから格子データへの変換
  ! ae_ap, e_p :: 方位角方向の格子点データからスペクトルデータへの変換
  ! aq_ar, q_r :: 動径方向の格子点データからスペクトルデータへの変換
  !
  !==== 微分
  !
  ! eq_Lapla_eq  :: スペクトルデータにラプラシアンを作用させる
  ! eq_DPhi_eq, ae_DPhi_ae, e_DPhi_e :: スペクトルデータに
  !                                     方位角微分を作用させる
  ! eq_RadDRad_eq, aq_RadDRad_aq, q_RadDRad_q :: スペクトルデータに
  !                                              動径微分を作用させる
  ! eq_Jacobian_eq_eq :: 2 つのスペクトルデータからヤコビアンを計算する
  !
  !==== 境界値問題
  !
  ! eq_Boundary    :: ディリクレ, ノイマン境界条件の適用
  ! eq_LaplaInv_eq :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! eq_Vor2Strm_eq :: 渦度から流線を計算する
  !
  !==== 積分・平均
  !
  ! IntRadPhi_rp, AvrRadPhi_rp   :: 2 次元格子点データの全領域積分および平均
  ! r_IntPhi_rp, r_AvrPhi_rp :: 2 次元格子点データの方位角方向積分および平均
  ! IntPhi_p, AvrPhi_p       :: 1 次元(X)格子点データの方位角方向積分および平均
  ! p_IntRad_rp, p_AvrRad_rp :: 2 次元格子点データの動径方向積分および平均
  ! IntRad_r, AvrRad_r       :: 1 次元(Y)格子点データの動径方向積分および平均
  !
  use dc_message
  use lumatrix
  use ae_module, p_Phi => g_X, p_Phi_weight => g_X_Weight, &
                 e_p => e_g, ae_ap => ae_ag, &
                 p_e => g_e, ap_ae => ag_ae, &
                 ae_DPhi_ae => ae_Dx_ae, e_DPhi_e => e_Dx_e
  use aq_module, r_Rad => g_R, r_Rad_Weight => g_R_Weight, &
                 aq_ar => aq_ag, q_r => q_g, &
                 ar_aq => ag_aq, r_q => g_q, &
                 q_RadDRad_q => q_rDr_q, aq_RadDRad_aq => aq_rDr_aq

  implicit none
  private

  public eq_Initial                                       ! 初期化

  public p_Phi, p_Phi_Weight, rp_Phi                      ! 座標変数
  public r_Rad, r_Rad_Weight, rp_Rad, er_Rad              ! 座標変数

  public rp_eq, eq_rp                                     ! 基本変換
  public er_eq, eq_er                                     ! 基本変換
  public er_rp, rp_er                                     ! 基本変換
  public e_p, p_e, ae_ap, ap_ae                           ! 基本変換
  public q_r, r_q, aq_ar, ar_aq                           ! 基本変換

  public eq_DPhi_eq, e_DPhi_e, ae_DPhi_ae                 ! 微分
  public eq_RadDRad_eq, q_RadDRad_q, aq_RadDRad_aq        ! 微分
  public er_Lapla_eq, eq_Lapla_eq                         ! 微分

  public eq_Jacobian_eq_eq                                ! 非線形計算

  public eq_Boundary                                      ! 境界値問題
  public aq_Boundary_D, aq_Boundary_N                     ! 境界値問題
  public eq_LaplaInv_eq, eq_Vor2Strm_eq                   ! 境界値問題

  public IntRadPhi_rp, r_IntPhi_rp, p_IntRad_rp, IntPhi_p, IntRad_r   ! 積分
  public AvrRadPhi_rp, r_AvrPhi_rp, p_AvrRad_rp, AvrPhi_p, AvrRad_r   ! 平均

  integer            :: im=32, jm=8      ! 格子点の設定(Phi,Rad)
  integer            :: km=10, lm=5      ! 切断波数の設定(Phi,Rad)
  real(8)            :: ra=1.0           ! 領域の大きさ
  real(8), parameter :: pi=3.1415926535897932385D0

  real(8), parameter :: alpha = 1.0D0        ! 展開多項式パラメター  0 < α <= 1
  real(8), parameter :: beta  = 1.0D0        ! 展開多項式パラメター  0 < β

  real(8), dimension(:,:), allocatable :: rp_Phi, rp_Rad
  real(8), dimension(:,:), allocatable :: er_Rad
  integer, dimension(:), allocatable   :: md

  save im, jm, km, lm, ra, md

  contains
  !--------------- 初期化 -----------------
    subroutine eq_Initial(i,j,k,l,ra_in)
      !
      ! スペクトル変換の格子点数, 波数, 領域の大きさを設定する.
      !
      ! 他の関数や変数を呼ぶ前に, 最初にこのサブルーチンを呼んで
      ! 初期設定をしなければならない.
      !
      integer,intent(in) :: i           ! 格子点数(X)
      integer,intent(in) :: j           ! 格子点数(Y)
      integer,intent(in) :: k           ! 切断波数(X)
      integer,intent(in) :: l           ! 切断波数(Y)

      real(8),intent(in) :: ra_in       ! 半径

      integer :: kk

      im = i       ; jm = j
      km = k       ; lm = l
      ra = ra_in

      allocate(md(-km:km))

      do kk=-km,km
         md(kk) = abs(kk)
      enddo

      call ae_initial(im,km,0.0D0,2*pi)
      call aq_Initial(jm,lm,ra,alpha,beta,md)

      allocate(rp_Phi(jm,0:im-1),rp_Rad(jm,0:im-1))
      rp_Phi = spread(p_Phi,1,jm)
      rp_Rad = spread(r_Rad,2,im)

      allocate(er_Rad(-km:km,jm))
      er_Rad = spread(r_Rad,1,2*km+1)

      call MessageNotify('M','eq_initial','eq_module (2013/08/20) is initialized')
    end subroutine eq_initial

  !--------------- 基本変換 -----------------

    function rp_eq(eq)
      !
      ! スペクトルデータから格子データへ変換する.
      !
      real(8), dimension(jm,0:im-1)                :: rp_eq
      !(out) 格子点データ

      real(8), dimension(-km:km,0:lm), intent(in)  :: eq
      !(in) スペクトルデータ

      real(8), dimension(-km:km,jm)                :: er
      real(8), dimension(jm,-km:km)                :: re

      integer :: j, k
      
      !rp_eq = ap_ae(transpose(ar_aq(eq)))
      !
      ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
      !
      er = ar_aq(eq)
      do j=1,jm
         do k=-km,km
            re(j,k) = er(k,j)
         enddo
      enddo
      rp_eq = ap_ae(re)

    end function rp_eq

    function eq_rp(rp)
      !
      ! 格子データからスペクトルデータへ変換する.
      !
      real(8), dimension(-km:km,0:lm)              :: eq_rp
      !(out) スペクトルデータ

      real(8), dimension(jm,0:im-1), intent(in)    :: rp
      !(in) 格子点データ

      real(8), dimension(-km:km,jm)                :: er
      real(8), dimension(jm,-km:km)                :: re

      integer :: j, k
      
      !eq_rp = aq_ar(transpose(ae_ap(rp)))
      !
      ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
      !
      re = ae_ap(rp)
      do j=1,jm
         do k=-km,km
            er(k,j) = re(j,k)
         enddo
      enddo
      eq_rp = aq_ar(er)

    end function eq_rp

    function eq_er(er)
      !
      ! 動径格子データからスペクトルデータへ変換する.
      !
      real(8), dimension(-km:km,0:lm)              :: eq_er
      !(out) スペクトルデータ

      real(8), dimension(-km:km,jm), intent(in)    :: er
      !(in) 格子点データ

      eq_er = aq_ar(er)

    end function eq_er

    function er_eq(eq)
      !
      ! 動径格子データからスペクトルデータへ変換する.
      !
      real(8), dimension(-km:km,jm)                :: er_eq
      !(out) 格子点データ

      real(8), dimension(-km:km,0:lm), intent(in)  :: eq
      !(out) スペクトルデータ

      er_eq = ar_aq(eq)

    end function er_eq

    function rp_er(er)
      !
      ! スペクトルデータから格子データへ変換する.
      !
      real(8), dimension(jm,0:im-1)              :: rp_er
      !(out) 格子点データ

      real(8), dimension(-km:km,jm), intent(in)  :: er
      !(in) スペクトルデータ

      real(8), dimension(jm,-km:km)              :: re

      integer :: j, k

      !rp_er = ap_ae(transpose(er))
      !
      ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
      !
      do j=1,jm
         do k=-km,km
            re(j,k) = er(k,j)
         enddo
      enddo
      rp_er = ap_ae(re)

    end function rp_er

    function er_rp(rp)
      !
      ! 格子データからスペクトルデータへ変換する.
      !
      real(8), dimension(-km:km,jm)                :: er_rp
      !(out) スペクトルデータ

      real(8), dimension(jm,0:im-1), intent(in)    :: rp
      !(in) 格子点データ

      real(8), dimension(jm,-km:km)                :: re

      integer :: j, k

      !er_rp = transpose(ae_ap(rp))
      !
      ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
      !
      re = ae_ap(rp)
      do j=1,jm
         do k=-km,km
            er_rp(k,j) = re(j,k)
         enddo
      enddo

    end function er_rp

  !--------------- 微分計算 -----------------

    function eq_DPhi_eq(eq)
      !
      ! 入力スペクトルデータに方位角微分(∂φ)を作用する.
      !
      ! スペクトルデータのφ微分とは, 対応する格子点データにφ微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      ! 実際にはスペクトルデータに X 方向波数 k をかけて
      ! sin(kx) <-> cos(kx) 成分に入れ換える計算を行っている.
      !
      real(8), dimension(-km:km,0:lm)                :: eq_DPhi_eq
      real(8), dimension(-km:km,0:lm), intent(in)    :: eq
      integer k

      do k=-km,km
         eq_DPhi_eq(k,:)  =  -k*eq(-k,:)
      enddo
    end function eq_DPhi_eq

    function eq_RadDRad_eq(eq)
      !
      ! 入力スペクトルデータに動径微分(r∂r)を作用する.
      !
      ! スペクトルデータの動径微分とは, 対応する格子点データに動径微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(-km:km,0:lm)               :: eq_RadDRad_eq
      !(out) スペクトルデータの動径微分

      real(8), dimension(-km:km,0:lm), intent(in)   :: eq
      !(in) 入力スペクトルデータ

      eq_RadDRad_eq = aq_RadDRad_aq(eq)

    end function eq_RadDRad_eq

    function er_Lapla_eq(eq)
      !
      ! 入力スペクトルデータにラプラシアン
      !  (1/r)(∂r(r∂r)+ (1/r^2) ∂φφ を作用する.
      !
      real(8), dimension(-km:km,jm)                :: er_Lapla_eq
      !(out) スペクトルデータのラプラシアン

      real(8), dimension(-km:km,0:lm), intent(in)  :: eq
      !(in) 入力スペクトルデータ

      real(8), dimension(-km:km,0:lm)              :: eq_work

      integer k

      do k=-km,km
         eq_work(k,:) = -k**2 * eq(k,:)
      enddo

      er_Lapla_eq = er_eq(eq_work + eq_RadDRad_eq(eq_RadDRad_eq(eq)))/er_Rad**2

    end function er_Lapla_eq

    function eq_Lapla_eq(eq)
      !
      ! 入力スペクトルデータにラプラシアン
      !  (1/r)(∂r(r∂r)+ (1/r^2) ∂φφ を作用する.
      !
      ! スペクトルデータのラプラシアンとは,
      ! 対応する格子点データにラプラシアンを作用させたデータの
      ! スペクトル変換のことである.
      !
      real(8), dimension(-km:km,0:lm)              :: eq_Lapla_eq
      !(out) スペクトルデータのラプラシアン

      real(8), dimension(-km:km,0:lm), intent(in)  :: eq
      !(in) 入力スペクトルデータ

      eq_Lapla_eq = eq_er(er_Lapla_eq(eq))

    end function eq_Lapla_eq

    function eq_Jacobian_eq_eq(eq_a,eq_b)
      !
      !  2 つのスペクトルデータからヤコビアン
      !
      !     J(A,B)=1/r[(∂rA)(∂φB)-(∂φA)(∂rB)]
      !
      !  を計算する. 1/r のファクターがついていることに注意.
      !
      !  2 つのスペクトルデータのヤコビアンとは, 対応する 2 つの
      !  格子点データのヤコビアンのスペクトル変換のことである.
      !
      real(8), dimension(-km:km,0:lm)                :: eq_Jacobian_eq_eq
      !(out) 2 つのスペクトルデータのヤコビアン

      real(8), dimension(-km:km,0:lm), intent(in)    :: eq_a
      !(in) 1つ目の入力スペクトルデータ

      real(8), dimension(-km:km,0:lm), intent(in)    :: eq_b
      !(in) 2つ目の入力スペクトルデータ

      eq_Jacobian_eq_eq = eq_rp(&
           (  rp_eq(eq_RadDRad_eq(eq_a)) * rp_eq(eq_DPhi_eq(eq_b))   &
             -rp_eq(eq_DPhi_eq(eq_a)) * rp_eq(eq_RadDRad_eq(eq_b)) ) &
           /rp_Rad**2)

    end function eq_Jacobian_eq_eq


  !--------------- 境界値問題 -----------------

    subroutine eq_Boundary(eq,value,cond)
      !
      ! ディリクレ, ノイマン条件の適用. チェビシェフ空間での計算
      !
      ! 実際には中で呼ばれている aq_module のサブルーチン
      ! aq_Boundary_D,, aq_Boundary_N を用いている.
      ! これらを直接呼ぶことも出来る.
      !
      real(8), dimension(-km:km,0:lm),intent(inout)      :: eq
              ! 境界条件を適用するデータ. 修正された値を返す.

      real(8), dimension(-km:km), intent(in), optional   :: value
              ! 境界での 値/勾配 分布を水平スペクトル変換したものを与える.
              ! 省略時は値/勾配 0 となる.

      character(len=1), intent(in), optional             :: cond
              ! 境界条件. 省略時は 'D'
              !   D : 両端ディリクレ
              !   N : 両端ノイマン

      if (.not. present(cond)) then
         if (present(value)) then
            call aq_Boundary_D(eq,value)
         else
            call aq_Boundary_D(eq)
         endif
         return
      endif

      select case(cond)
      case ('N')
         if (present(value)) then
            call aq_Boundary_N(eq,value)
         else
            call aq_Boundary_N(eq)
         endif
      case ('D')
         if (present(value)) then
            call aq_Boundary_D(eq,value)
         else
            call aq_Boundary_D(eq)
         endif
      case default
         call MessageNotify('E','eq_Boundaries','B.C. not supported')
      end select

    end subroutine eq_Boundary

    function eq_LaplaInv_eq(eq,value)
      !
      ! 境界で値を与える条件(ディリクレ条件)下で,
      ! 入力スペクトルデータに逆ラプラシアン
      ! [(1/r)(∂r(r∂r)+ (1/r^2) ∂φφ]^{-1} を作用する.
      !
      ! タウ法による計算
      !
      ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
      ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(8), dimension(-km:km,0:lm),intent(in)  :: eq
      !(in) スペクトルデータ

      real(8), dimension(-km:km,0:lm)             :: eq_LaplaInv_eq
      !(out) スペクトルデータの逆ラプラシアン

      real(8), dimension(-km:km), intent(in), optional :: value
      !(in) 境界値. 省略時は 0 が設定される.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(-km:km,0:lm)         :: eq_work
      real(8), dimension(-km:km,jm)           :: er_work
      real(8), dimension(-km:km)              :: value1       ! 境界値

      logical :: first = .true.
      integer :: k, l
      save    :: alu, kp, first

      if (.not. present(value)) then
         value1=0
      else
         value1 = value
      endif

      if ( first ) then
         first = .false.

         allocate(alu(-km:km,0:lm,0:lm),kp(-km:km,0:lm))

         do l=0,lm
            eq_work = 0.0 ; eq_work(:,l) = 1.0
            alu(:,:,l) = eq_er(er_Lapla_eq(eq_work))
         enddo

         ! 0 成分のところを 1 で埋める.
         do k=-km,km
            do l=0,md(k)-1
               alu(k,l,l) = 1.0D0
            enddo
            do l=md(k)+1,lm,2
               alu(k,l,l) = 1.0D0
            enddo
         enddo

         ! 境界条件 r=ra で値を与える.
         do k=-km,km
            do l=0,lm
               eq_work=0 ; eq_work(k,l)=1.0
               er_work=er_eq(eq_work)
               if ( mod(md(k),2) .eq. mod(lm,2) ) then
                  alu(k,lm,l) = er_work(k,jm)
               else
                  alu(k,lm-1,l) = er_work(k,jm)
               endif
            enddo
         enddo

         call ludecomp(alu,kp)
      endif

      eq_work = eq
      do k=-km,km
         if ( mod(md(k),2) .eq. mod(lm,2) ) then
            eq_work(k,lm)   = value1(k)
         else
            eq_work(k,lm-1) = value1(k)
         endif
      enddo
      eq_LaplaInv_eq = lusolve(alu,kp,eq_work)

    end function eq_LaplaInv_eq

    function eq_Vor2Strm_eq(eq,value,cond,new)
      !
      ! 渦度から流線を求める.
      !
      ! Chebyshev-tau 法による計算
      ! 渦度 \zeta を与えて流線 \psi を求める.
      !    \nabla^2 \psi = \zeta,
      !    \psi = const. at the boundary
      ! 粘着条件
      !    \DP{\psi}{r} = 0 at the boundary
      ! 応力なし条件
      !    r\DP{}{r}(1/r\DP{\psi}{r})  = 0 at the boundary
      !
      ! l=0,lm 成分の式の代わりに境界条件を与える.
      !
      real(8), dimension(-km:km,0:lm),intent(in)  :: eq
              !(in) 入力渦度分布

      real(8), dimension(-km:km,0:lm)             :: eq_Vor2Strm_eq
              !(out) 出力流線関数分布

      real(8), intent(in), optional               :: value
              ! 流線境界値. 境界で一定なので波数 0 成分のみ

      character(len=1), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'R'
              !     R    : 上側粘着条件
              !     F    : 上側応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu, alub
      integer, dimension(:,:), allocatable    :: kp, kpb

      real(8), dimension(-km:km,0:lm)         :: eq_work
      real(8), dimension(-km:km,jm)           :: er_work
      real(8)                                 :: value1          ! 境界値
      logical                                 :: rigid = .true.

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: k, l
      save    :: alu, kp, first
      save    :: alub, kpb

      if (.not. present(value)) then
         value1 = 0
      else
         value1 = value
      endif

      select case (cond)
      case ('R')
        rigid = .TRUE.
      case ('F')
        rigid = .FALSE.
      case default
        call MessageNotify('E','eq_Vor2Strm_eq','B.C. not supported')
      end select

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(-km:km,0:lm,0:lm),kp(-km:km,0:lm))

         if ( allocated(alub) ) deallocate(alub)
         if ( allocated(kpb) ) deallocate(kpb)
         allocate(alub(-km:km,0:lm,0:lm),kpb(-km:km,0:lm))

         ! 内部条件
         do l=0,lm
            eq_work = 0.0 ; eq_work(:,l) = 1.0
            alu(:,:,l) = eq_er(er_Lapla_eq(eq_work))
         enddo

         ! 0 成分のところを 1 で埋める.
         do k=-km,km
            do l=0,md(k)-1
               alu(k,l,l) = 1.0D0
            enddo
            do l=md(k)+1,lm,2
               alu(k,l,l) = 1.0D0
            enddo
         enddo

         ! alu(:,:,nd(k)) 列は 0 なので 1 をいれておく.
         ! l=md(k) 成分は境界条件で決める.
         do k=-km,km
            if ( mod(md(k),2) .eq. mod(lm,2) ) then
               alu(k,lm,md(k)) = 1.0D0
            else
               alu(k,lm-1,md(k)) = 1.0D0
            endif
         enddo

         call ludecomp(alu,kp)

         !---- 境界条件計算用行列 -----
         alub = 0.0
         do l=0,lm
            alub(:,l,l) = 1.0D0
         enddo

         ! 運動学的条件. 流線は境界で一定
         !     l=nd(n) 成分を境界条件で決める.
         do l=0,lm
            eq_work = 0.0 ; eq_work(:,l)=1.0D0
            er_work = er_eq(eq_work)
            do k=-km,km
               alub(k,md(k),l) = er_work(k,jm)
            enddo
         enddo

         ! 力学的条件粘着条件
         !     l=lm or lm-1 成分を境界条件で決める.
         if ( rigid ) then
            do l=0,lm
               eq_work = 0.0 ;  eq_work(:,l)=1.0D0
               er_work=er_eq(eq_RadDRad_eq(eq_work))/er_Rad
               do k=-km,km
                  if ( mod(md(k),2) .eq. mod(lm,2) ) then
                     alub(k,lm,l) = er_work(k,jm)
                  else
                     alub(k,lm-1,l) = er_work(k,jm)
                  endif
               end do
            enddo
         else
            do l=0,lm
               eq_work = 0.0 ; eq_work(:,l)=1.0D0
               er_work=er_eq(eq_RadDRad_eq(eq_RadDRad_eq(eq_work)) &
                            -2*eq_RadDRad_eq(eq_work))/er_Rad**2
               do k=-km,km
                  if ( mod(md(k),2) .eq. mod(lm,2) ) then
                     alub(k,lm,l) = er_work(k,jm)
                  else
                     alub(k,lm-1,l) = er_work(k,jm)
                  endif
               end do
            enddo
         endif

         call ludecomp(alub,kpb)

         if ( rigid ) then
            call MessageNotify('M','eq_Vor2Strm_eq',&
                              'Matrix to apply rigid b.c. newly produced.')
         else
            call MessageNotify('M','eq_Vor2Strm_eq',&
                              'Matrix to apply stress-free b.c. newly produced.')
         endif
      endif

      ! 内部領域計算
      eq_work = eq
      eq_work = lusolve(alu,kp,eq_work)

      ! 境界条件計算
      do k=-km,km
         eq_work(k,md(k)) = 0.0D0
         if ( mod(md(k),2) .eq. mod(lm,2) ) then
            eq_work(k,lm)   = 0.0D0
         else
            eq_work(k,lm-1) = 0.0D0
         endif
      enddo
      eq_work(0,0)   = value1*2.0D0     ! 運動学的条件. 波数 0 は重み 1/2

      eq_Vor2Strm_eq = lusolve(alub,kpb,eq_work)

    end function eq_Vor2Strm_eq

  !--------------- 積分計算 -----------------
    function IntRadPhi_rp(rp)
      !
      ! 2 次元格子点データの全領域積分および平均.
      !
      ! 実際には格子点データ各点毎に p_Phi_Weight, r_Rad_Weight をかけた
      ! 総和を計算している.
      !
      real(8), dimension(jm,0:im-1)   :: rp
      !(in)  2 次元格子点データ

      real(8)                         :: IntRadPhi_rp
      !(out) 積分値

      integer :: i, j

      IntRadPhi_rp = 0.0d0
      do i=0,im-1
         do j=1,jm
            IntRadPhi_rp = IntRadPhi_rp + rp(j,i) * r_Rad_Weight(j) * p_Phi_Weight(i)
         enddo
      enddo
    end function IntRadPhi_rp

    function r_IntPhi_rp(rp)
      !
      ! 2 次元格子点データの Phi 方向積分
      !
      ! 実際には格子点データ各点毎に p_Phi_Weight をかけた総和を計算している.
      !
      real(8), dimension(jm,0:im-1)   :: rp
      !(in) 2 次元格子点データ

      real(8), dimension(jm)          :: r_IntPhi_rp
      !(out) 積分された 1 次元(Rad)格子点データ

      integer :: i
      ! 作業変数

      r_IntPhi_rp = 0.0d0
      do i=0,im-1
         r_IntPhi_rp(:) = r_IntPhi_rp(:) + rp(:,i) * p_Phi_Weight(i)
      enddo
    end function r_IntPhi_rp

    function p_IntRad_rp(rp)
      !
      ! 2 次元格子点データの Rad 方向積分
      !
      ! 実際には格子点データ各点毎に r_Rad_Weight をかけた総和を計算している.
      !
      real(8), dimension(jm,0:im-1)   :: rp
      !(in)  2 次元格子点データ

      real(8), dimension(0:im-1)      :: p_IntRad_rp
      !(out) 積分された 1 次元(Phi)格子点データ

      integer :: j
      ! 作業変数

      p_IntRad_rp = 0.0d0
      do j=1,jm
         p_IntRad_rp(:) = p_IntRad_rp(:) + rp(j,:) * r_Rad_Weight(j)
      enddo
    end function p_IntRad_rp

    function IntPhi_p(p)
      !
      ! 1 次元(Phi)格子点データの Phi 方向積分
      !
      ! 実際には格子点データ各点毎に p_Phi_Weight をかけた総和を計算している.
      !
      real(8), dimension(0:im-1)   :: p         !(in)  1 次元格子点データ
      real(8)                      :: IntPhi_p    !(out) 積分値

      IntPhi_p = sum(p*p_Phi_Weight)
    end function IntPhi_p

    function IntRad_r(r)
      !
      ! 1 次元(Rad)格子点データの Rad 方向積分
      !
      ! 実際には格子点データ各点毎に r_Rad_Weight をかけた総和を計算している.
      !
      real(8), dimension(jm)   :: r          !(in)  1 次元格子点データ
      real(8)                  :: IntRad_r     !(out) 積分値

      IntRad_r = sum(r*r_Rad_Weight)
    end function IntRad_r

  !--------------- 平均計算 -----------------
    function AvrRadPhi_rp(rp)
      !
      ! 2 次元格子点データの全領域平均
      !
      ! 実際には格子点データ各点毎に p_Phi_Weight, r_Rad_Weight をかけた
      ! 総和を計算し, p_Phi_Weight*r_Rad_Weight の総和で割ることで平均している.
      !
      real(8), dimension(jm,0:im-1)   :: rp
      !(in)  2 次元格子点データ

      real(8)                         :: AvrRadPhi_rp
      !(out) 平均値

      AvrRadPhi_rp = IntRadPhi_rp(rp)/(sum(p_Phi_weight)*sum(r_Rad_weight))
    end function AvrRadPhi_rp

    function r_AvrPhi_rp(rp)
      !
      ! 2 次元格子点データの Phi 方向平均
      !
      ! 実際には格子点データ各点毎に p_Phi_Weight をかけた総和を計算し,
      ! p_Phi_Weight の総和で割ることで平均している.
      !
      real(8), dimension(jm,0:im-1)   :: rp
      !(in) 2 次元格子点データ

      real(8), dimension(jm)          :: r_AvrPhi_rp
      !(out) 平均された 1 次元(Rad)格子点

      r_AvrPhi_rp = r_IntPhi_rp(rp)/sum(p_Phi_weight)
    end function r_AvrPhi_rp

    function p_AvrRad_rp(rp)
      !
      ! 2 次元格子点データの Rad 方向平均
      !
      ! 実際には格子点データ各点毎に r_Rad_Weight をかけた総和を計算し,
      ! r_Rad_Weight の総和で割ることで平均している.
      !
      real(8), dimension(jm,0:im-1)   :: rp
      !(in) 2 次元格子点データ

      real(8), dimension(0:im-1)      :: p_AvrRad_rp
      !(out) 平均された 1 次元(Phi)格子点

      p_AvrRad_rp = p_IntRad_rp(rp)/sum(r_Rad_weight)
    end function p_AvrRad_rp

    function AvrPhi_p(p)
      !
      ! 1 次元(Phi)格子点データの Phi 方向平均
      !
      ! 実際には格子点データ各点毎に p_Phi_Weight をかけた総和を計算し,
      ! p_Phi_Weight の総和で割ることで平均している.
      !
      real(8), dimension(0:im-1)   :: p          !(in)  1 次元格子点データ
      real(8)                      :: AvrPhi_p     !(out) 平均値

      AvrPhi_p = IntPhi_p(p)/sum(p_Phi_weight)
    end function AvrPhi_p

    function AvrRad_r(r)
      !
      ! 1 次元(Rad)格子点データの Rad 方向平均
      !
      ! 実際には格子点データ各点毎に r_Rad_Weight をかけた総和を計算し,
      ! r_Rad_Weight の総和で割ることで平均している.
      !
      real(8), dimension(jm)   :: r            !(in)  1 次元格子点データ
      real(8)                  :: AvrRad_r     !(out) 平均値

      AvrRad_r = IntRad_r(r)/sum(r_Rad_weight)
    end function AvrRad_r

end module eq_module

!----------------------------------------------------------------------
!     Copyright (c) 2012 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wtq_mpi_module_sjpack テストプログラム :: wq_mpi_module_sjpack 基本変換関数のテスト
!
!履歴  2012/04/02  竹広真一
!
program wtq_mpi_module_sjpack_base_wq

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wtq_mpi_module_sjpack
  use mpi
  implicit none

  integer,parameter  :: im=32, jm=16         ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: kmo=16, kmi=10       ! 格子点の設定(球殻動径, 球動径)
  integer,parameter  :: nm=10                ! 切断波数の設定(水平)
  integer,parameter  :: lmo=10, lmi=16       ! 切断波数の設定(球殻動径, 球動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8), allocatable ::  xvr_data(:,:,:)
  real(8) :: pi
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','wtq_mpi_module_sjpack_wq_base_test', &
                         'wtq_mpi_module_sjpack wq-basic transformation functions tests') 

  call wtq_mpi_Initial(im,jm,kmi,kmo,nm,lmi,lmo,ri,ro)

  allocate(xvr_data(0:im-1,jc,kmi))

  !---- Y_1^* のテスト ----
  xvr_data = sqrt(3.0D0)*sin(xvr_Lat)*xvr_Rad        ! r Y_1^0 
  call AssertEqual(&
    message='xvr_wq with r Y_1^0',                                &
    answer = xvr_data,                                            &
    check = xvr_wq(wq_xvr(xvr_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xvr_data = sqrt(3.0D0/2)*cos(xvr_Lat)*cos(xvr_Lon)*xvr_Rad**3   ! r^3Y_1^1 
  call AssertEqual(&
    message='xvr_wq with r^3 Y_1^1',                              &
    answer = xvr_data,                                            &
    check = xvr_wq(wq_xvr(xvr_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xvr_data = -sqrt(3.0D0/2)*cos(xvr_Lat)*sin(xvr_Lon) * xvr_Rad**5  !r^5Y_1^{-1}
  call AssertEqual(&
    message='xvr_wq with r^5 Y_1^-1',                             &
    answer = xvr_data,                                            &
    check = xvr_wq(wq_xvr(xvr_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^* のテスト ----
  !r^2 Y_2^0
  xvr_data = sqrt(5.0D0)*(3.0/2*sin(xvr_Lat)**2-1/2.0) * xvr_Rad**2
  call AssertEqual(&
    message='xvr_wq with r^2 Y_2^0',                              &
    answer = xvr_data,                                            &
    check = xvr_wq(wq_xvr(xvr_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !r^4 Y_2^1 
  xvr_data = sqrt(5.0D0/6)*3.0*sin(xvr_Lat)*cos(xvr_Lat)*cos(xvr_Lon) &
            * xvr_Rad**4
  call AssertEqual(&
    message='xvr_wq with r^4 Y_2^1',                              &
    answer = xvr_data,                                            &
    check = xvr_wq(wq_xvr(xvr_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !r^6 Y_2^-2
  xvr_data = -sqrt(5.0D0/24)*3.0*cos(xvr_Lat)**2*sin(2*xvr_Lon)* xvr_Rad**6
  call AssertEqual(&
    message='xvr_wq with r^6 Y_2^-2',                             &
    answer = xvr_data,                                            &
    check = xvr_wq(wq_xvr(xvr_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wtq_mpi_module_sjpack_base_wq_test', &
                         'wtq_mpi_module_sjpack wq-basic functions tests succeeded!') 


 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wtq_mpi_module_sjpack_base_wq

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wsc_module_svpack テストプログラム
!
!      微分のテスト
!  
!履歴  2017/05/21  竹広真一
!
program wsc_module_svpack_derivative1

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wsc_module_svpack
  use wa_module_svpack, only : wa_Lapla_wa
  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=10         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Data
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_DData

  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VLon
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VLat
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VRad
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Div
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Psi

  real(8), dimension(0:im-1,1:jm,0:km)     ::  xyz_xi

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer, parameter :: nmin=1, nmax=9

  integer :: n

  real(8) :: pi

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','wsc_module_svpack_derivative_test1', &
       'wsc_module_svpack derivative function test #1')

  call wsc_Initial(im,jm,km,nm,lm,ri,ro)

  xyz_xi = (xyz_Rad - ri)/(ro-ri)

  !==================== wc_DRad_ws, ws_DRad_wc ====================  
  xyz_Data  = sin(PI*xyz_xi)
  xyz_DData = PI*cos(PI*xyz_xi)
  !
  call AssertEqual(&
       message='wc_DRad_ws with sin(z)',                             &
       answer = xyz_DData,                                           &
       check = xyz_wc(wc_DRad_ws(ws_xyz(xyz_Data))),                 &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_Data  = cos(2*PI*xyz_xi)
  xyz_DData = -2*PI*sin(2*PI*xyz_xi)
  !
  call AssertEqual(&
       message='ws_DRad_wc with cos(2z)',                            &
       answer = xyz_DData,                                           &
       check = xyz_ws(ws_DRad_wc(wc_xyz(xyz_Data))),                 &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !==================== wc_DivRad_ws, ws_DivRad_wc ====================  

  xyz_Data = cos(xyz_Lat)*sin(xyz_Lat) * sin(xyz_Lon) * cos(PI*xyz_xi) ! Y_2^-1 cos(z)
  xyz_DData = -PI* cos(xyz_Lat)*sin(xyz_Lat) * sin(xyz_Lon) * sin(PI*xyz_xi)
  !
  call AssertEqual(&
       message='ws_DivRad_wc with Y_2^-1 cos(z)',                    &
       answer = xyz_DData,                                           &
       check = xyz_ws(ws_DivRad_wc(wc_xyz(xyz_Data))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_Data = cos(xyz_Lat)*sin(xyz_Lat) * cos(xyz_Lon) * sin(2*PI*xyz_xi) ! Y_2^1 sin(2z)
  xyz_DData =2*PI*cos(xyz_Lat)*sin(xyz_Lat) * cos(xyz_Lon) * cos(2*PI*xyz_xi)
  !
  call AssertEqual(&
       message='wc_DivRad_ws with Y_2^1 sin(2z)',                    &
       answer = xyz_DData,                                           &
       check = xyz_wc(wc_DivRad_ws(ws_xyz(xyz_Data))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !==================== wc_RotRad_ws, ws_RotRad_wc ====================  

  xyz_Data = sin(xyz_Lat) * cos(3*PI*xyz_xi) ! Y_2^0 cos(3z)
  xyz_DData = -3*PI* sin(xyz_Lat) * sin(3*PI*xyz_xi)
  !
  call AssertEqual(&
       message='ws_RotRad_wc with Y_2^0 cos(3z)',                    &
       answer = xyz_DData,                                           &
       check = xyz_ws(ws_RotRad_wc(wc_xyz(xyz_Data))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_Data = sin(xyz_Lat) * sin(4*PI*xyz_xi) ! Y_2^0 sin(4z)
  xyz_DData = 4*PI* sin(xyz_Lat) * cos(4*PI*xyz_xi)
  !
  call AssertEqual(&
       message='wc_RotRad_ws with Y_2^0 sin(4z)',                    &
       answer = xyz_DData,                                           &
       check = xyz_wc(wc_RotRad_ws(ws_xyz(xyz_Data))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !==================== ws_Lapla_ws, wc_Lapla_wc ====================  
  
  xyz_Data  = cos(xyz_Lat)*sin(xyz_Lon)*sin(3*PI*xyz_xi)  ! Y_1^-1 sin(3z)
  xyz_DData = -( 9*PI**2 + 1*2/Ro**2) * xyz_Data
  !
  call AssertEqual(&
       message='ws_Lapla_ws with Y_1^-1 sin(3z)',                    &
       answer = xyz_DData,                                           &
       check = xyz_ws(ws_Lapla_ws(ws_xyz(xyz_Data))),                &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_Data  = cos(xyz_Lat)*cos(xyz_Lon)*cos(4*PI*xyz_xi)  ! Y_1^1 cos(4z)
  xyz_DData = -( 16*PI**2 + 1*2/Ro**2) * xyz_Data
  !
  call AssertEqual(&
       message='wc_Lapla_wc with Y_1^1 cos(4z)',                     &
       answer = xyz_DData,                                           &
       check = xyz_wc(wc_Lapla_wc(wc_xyz(xyz_Data))),                &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !==================== ws_LaplaInv_ws, wc_LaplaInv_wc ====================  
  
  xyz_Data  = cos(xyz_Lat)*sin(xyz_Lon)*sin(3*PI*xyz_xi)  ! Y_1^-1 sin(3z)
  xyz_DData = -1.0D0/( 9*PI**2 + 1*2/Ro**2) * xyz_Data
  !
  call AssertEqual(&
       message='ws_LaplaInv_ws with Y_1^-1 sin(3z)',                 &
       answer = xyz_DData,                                           &
       check = xyz_ws(ws_LaplaInv_ws(ws_xyz(xyz_Data))),             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_Data  = cos(xyz_Lat)*sin(xyz_Lon)*sin(2*PI*xyz_xi)  ! Y_1^-1 sin(2z)
  xyz_DData = -1.0D0/( 4*PI**2 + 1*2/Ro**2) * xyz_Data
  !
  call AssertEqual(&
       message='ws_LaplaInv_ws with Y_1^-1 sin(2z)',                 &
       answer = xyz_DData,                                           &
       check = xyz_ws(ws_LaplaInv_ws(ws_xyz(xyz_Data))),             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_Data  = cos(xyz_Lat)*cos(xyz_Lon)*cos(4*PI*xyz_xi)  ! Y_1^1 cos(4z)
  xyz_DData = -1.0D0/( 16*PI**2 + 1*2/Ro**2) * xyz_Data
  !
  call AssertEqual(&
       message='wc_LaplaInv_wc with Y_1^1 cos(4z)',                  &
       answer = xyz_DData,                                           &
       check = xyz_wc(wc_LaplaInv_wc(wc_xyz(xyz_Data))),             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_Data  = cos(xyz_Lat)*cos(xyz_Lon)*cos(5*PI*xyz_xi)  ! Y_1^1 cos(4z)
  xyz_DData = -1.0D0/( 25*PI**2 + 1*2/Ro**2) * xyz_Data
  !
  call AssertEqual(&
       message='wc_LaplaInv_wc with Y_1^1 cos(5z)',                  &
       answer = xyz_DData,                                           &
       check = xyz_wc(wc_LaplaInv_wc(wc_xyz(xyz_Data))),             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  !========== xyz_GradLon_ws, xyz_GradLat_ws ==========

  ! ------ Y_1^-1 sin(z) Toridal field -----

  xyz_Psi = cos(xyz_Lat)*sin(xyz_Lon) * sin(PI*xyz_xi)    ! Y_1^-1 sin(z)
  xyz_VRad = 0

  xyz_VLon =  cos(xyz_Lon) * sin(PI*xyz_xi) /Ro
  call AssertEqual(&
       message='xyz_GradLon_ws with Y_1^-1 sin(z)',                  &
       answer = xyz_VLon,                                            &
       check = xyz_GradLon_ws(ws_xyz(xyz_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_VLat = -sin(xyz_Lat)*sin(xyz_Lon) * sin(PI*xyz_xi) /Ro
  call AssertEqual(&
       message='xyz_GradLat_ws with Y_1^-1 sin(z)',                  &
       answer = xyz_VLat,                                            &
       check = xyz_GradLat_ws(ws_xyz(xyz_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !========== xyz_GradLon_wc, xyz_GradLat_wc, wc_Div_xyz_xyz_xyz, wc_RotRad_xyz_xyz ==========
  ! ------ Y_1^1 cos(2z) Toridal field -----

  xyz_Psi = cos(xyz_Lat)*cos(xyz_Lon) * cos(2*PI*xyz_xi)    ! Y_1^1 cos(2z)
  xyz_VRad = 0

  xyz_VLon =  - sin(xyz_Lon) * cos(2*PI*xyz_xi) /Ro
  call AssertEqual(&
       message='xyz_GradLon_wc with Y_1^1 cos(2z)',                  &
       answer = xyz_VLon,                                            &
       check = xyz_GradLon_wc(wc_xyz(xyz_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_VLat = -sin(xyz_Lat)*cos(xyz_Lon) * cos(2*PI*xyz_xi) /Ro
  call AssertEqual(&
       message='xyz_GradLat_wc with Y_1^1 cos(2z)',                  &
       answer = xyz_VLat,                                            &
       check = xyz_GradLat_wc(wc_xyz(xyz_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_Div = - 2 * xyz_Psi/Ro**2
  call AssertEqual(&
       message='wc_Div_xyz_xyz_xyz with Toroiral Y_1^-1 cos(2z)',     &
       answer = xyz_Div,                                              &
       check = xyz_wc(wc_Div_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore      &
       )

  xyz_VLat = - xyz_Vlat
  call AssertEqual(&
       message='wc_RotRad_xyz_xyz_xyz with Toroiral Y_1^-1 cos(2z)',  &
       answer = xyz_Div,                                              &
       check = xyz_wc(wc_RotRad_xyz_xyz(xyz_VLon,xyz_VLat)),          &
       significant_digits = check_digits, ignore_digits = ignore      &
       )


  ! ------ Y_2^-1 sin(z) Poloidal field -----

  xyz_Psi = cos(xyz_Lat)*sin(xyz_Lat) * sin(xyz_Lon) * sin(PI*xyz_xi) ! Y_2^-1 sin(z)

  xyz_VLon = xyz_GradLon_wc(wc_DRad_ws(ws_xyz(xyz_Psi)))*Ro ! PI*sin(lat)cos(lon))cos(z)
  xyz_VLat = xyz_GradLat_wc(wc_DRad_ws(ws_xyz(xyz_Psi)))*Ro ! PI*cos(2lat)sin(lon)cos(z)
  xyz_Vrad = -xyz_wz(wa_Lapla_wa(wz_xyz(xyz_Psi)))/Ro       ! (2*3/Ro) Psi

  xyz_DData = 0.0D0
  call AssertEqual(&
       message='wc_Div_xyz_xyz_xyz with  Y_2^-1 sin(z)',                &
       answer = xyz_DData,                                              &
       check =  xyz_wc(wc_Div_xyz_xyz_xyz(xyz_Vlon,xyz_Vlat,xyz_Vrad)), &
       significant_digits = check_digits, ignore_digits = ignore        &
       )

  ! ------ Y_2^-1 cos(z) Poloidal field -----

  xyz_Psi = cos(xyz_Lat)*sin(xyz_Lat) * sin(xyz_Lon) * cos(PI*xyz_xi) ! Y_2^-1 sin(z)

  xyz_VLon = xyz_GradLon_ws(ws_DRad_wc(wc_xyz(xyz_Psi)))*Ro ! PI*sin(lat)cos(lon))cos(z)
  xyz_VLat = xyz_GradLat_ws(ws_DRad_wc(wc_xyz(xyz_Psi)))*Ro ! PI*cos(2lat)sin(lon)cos(z)
  xyz_Vrad = -xyz_wz(wa_Lapla_wa(wz_xyz(xyz_Psi)))/Ro       ! (2*3/Ro) Psi

  xyz_DData = 0.0D0
  call AssertEqual(&
       message='ws_Div_xyz_xyz_xyz with  Y_2^-1 sin(z)',                &
       answer = xyz_DData,                                              &
       check =  xyz_ws(ws_Div_xyz_xyz_xyz(xyz_Vlon,xyz_Vlat,xyz_Vrad)), &
       significant_digits = check_digits, ignore_digits = ignore        &
       )

!!$  !========== xyz_RotLon_ws_wc, xyz_RotLat_wc_ws ============
!!$
!!$  ! ------ Y_2^-1 sin(z) Poloidal field -----
!!$
!!$  xyz_Psi = cos(xyz_Lat)*sin(xyz_Lat) * sin(xyz_Lon) * sin(PI*xyz_xi) ! Y_2^-1 sin(z)
!!$
!!$  xyz_VLon = xyz_GradLon_wc(wc_DRad_ws(ws_xyz(xyz_Psi)))*Ro ! PI*sin(lat)cos(lon))cos(z)
!!$  xyz_VLat = xyz_GradLat_wc(wc_DRad_ws(ws_xyz(xyz_Psi)))*Ro ! PI*cos(2lat)sin(lon)cos(z)
!!$  xyz_Vrad = -xyz_wz(wa_Lapla_wa(wz_xyz(xyz_Psi)))/Ro ! (2*3/Ro) Psi
!!$
!!$  xyz_DData = 0.0D0
!!$  call AssertEqual(&
!!$       message='wc_Div_xyz_xyz_xyz with  Y_2^-1 sin(z)',                &
!!$       answer = xyz_DData,                                              &
!!$       check =  xyz_wc(wc_Div_xyz_xyz_xyz(xyz_Vlon,xyz_Vlat,xyz_Vrad)), &
!!$       significant_digits = check_digits, ignore_digits = ignore        &
!!$       )
!!$  
!!$  xyz_DData = (2*3/Ro**2 + PI**2) * cos(2*xyz_Lat) * sin(xyz_Lon) * sin(PI*xyz_xi)
  
!!$  call AssertEqual(&
!!$       message='xyz_RadLon_wt with  Y_2^-1 sin(z)',                   &
!!$       answer = xyz_DData,                                            &
!!$       check =  xyz_RotLon_ws_wc(ws_xyz(xyz_Vrad),wc_xyz(xyz_Vlat)),  &
!!$       significant_digits = check_digits, ignore_digits = ignore      &
!!$       )
!!$
!!$  xyz_DData = -(2*3/Ro**2 + PI**2) * sin(xyz_Lat)*cos(xyz_Lon)*sin(PI*xyz_xi)
!!$  call AssertEqual(&
!!$       message='xyz_RadLat_wt with  Y_2^-1 sin(z)',                   &
!!$       answer = xyz_DData,                                            &
!!$       check =  xyz_RotLat_wc_ws(wc_xyz(xyz_Vlon),ws_xyz(xyz_Vrad)),  &
!!$       significant_digits = check_digits, ignore_digits = ignore      &
!!$       )
!!$

!!$  xyz_VLat = xyz_Rad**(n-1)*cos(2*xyz_Lat)*sin(xyz_Lon)
!!$  call AssertEqual(&
!!$       message='xyz_GradLat_wt with r^2 Y_2^-1',                     &
!!$       answer = xyz_VLat,                                            &
!!$       check = xyz_GradLat_wt(wt_xyz(xyz_Psi)),                      &
!!$       significant_digits = check_digits, ignore_digits = ignore     &
!!$       )
!!$
!!$  xyz_Div = - 6* xyz_Psi/xyz_Rad**2
!!$  call AssertEqual(&
!!$       message='wt_Div_xyz_xyz_xyz_wt with Toroiral r2 Y_1^-1',      &
!!$       answer = xyz_Div,                                             &
!!$       check = xyz_wt(wt_Div_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)),&
!!$       significant_digits = check_digits, ignore_digits = ignore     &
!!$       )
!!$
!!$  !==================== wt_DivLon_xyz, wt_DivLat_xyz ====================
!!$  n=2
!!$  write(6,*)'n =',n
!!$
!!$  xyz_VLon  = xyz_rad**n * cos(xyz_Lat)**2*sin(xyz_Lon)
!!$  xyz_DData = xyz_rad**(n-1)*cos(xyz_Lat)*cos(xyz_Lon)
!!$  call AssertEqual(&
!!$       message='wt_DivLon_xyz with r^n cos^2 φ sinλ',              &
!!$       answer = xyz_DData,                                           &
!!$       check = xyz_wt(wt_DivLon_xyz(xyz_VLon)),                      &
!!$       significant_digits = check_digits, ignore_digits = ignore     &
!!$       )
!!$
!!$  xyz_VLat   = xyz_rad**n * cos(xyz_Lat)**2*sin(xyz_Lon)
!!$  xyz_DData = -3*xyz_rad**(n-1)*cos(xyz_Lat)*sin(xyz_Lat)*sin(xyz_Lon)
!!$  call AssertEqual(&
!!$       message='wt_DivLat_xyz with r^n cos^2 φ sinλ',              &
!!$       answer = xyz_DData,                                           &
!!$       check = xyz_wt(wt_DivLat_xyz(xyz_VLat)),                      &
!!$       significant_digits = check_digits, ignore_digits = ignore     &
!!$       )
!!$
  call MessageNotify('M','wsc_module_svpack_derivative_test1', &
       'wsc_module_svpack derivative function test #1 succeeded!')

end program wsc_module_svpack_derivative1

!--
!----------------------------------------------------------------------
! Copyright(c) 2017 SPMDODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  scee_module_fftj
!
!    spml/scee_module_fftj モジュールは平行平板間での 3 次元流体運動を
!    スペクトル法によって数値計算するための Fortran90 関数を提供する
!    ものである.
!
!    水平方向にフーリエ数変換および上下の境界壁を扱うための
!    sin/cos 変換を用いる場合のスペクトル計算のためのさまざまな
!    関数を提供する.
!
!    内部で ee_module_fftj, asc_module を用いている. 最下部ではフーリエ
!    およびチェビシェフ変換のエンジンとして ISPACK の Fortran77
!    サブルーチンを用いている.
!
!
!履歴  2017/05/26  竹広真一  作成
!
!凡例
!      データ種類と index
!        x : 水平(X)        y : 水平(Y)        z : 鉛直
!        e : フーリエ変換スペクトル
!        l : フーリエ関数スペクトル(X 方向波数)
!        m : フーリエ関数スペクトル(Y 方向波数)
!        s : sin 関数スペクトル
!        c : cos 関数スペクトル
!        a : 任意の次元
!
!        zyx : 3 次元格子点データ
!        yx  : 水平 2 次元格子点データ
!        zy  : 鉛直 2 次元格子点データ
!        zx  : 鉛直 2 次元格子点データ
!
!        zee : 水平スペクトル鉛直格子点データ
!        see : スペクトルデータ鉛直 sin 変換格子
!        cee : スペクトルデータ鉛直 cos 変換格子
!
!++
module scee_module_fftj
  !
  != scee_module_fftj
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !    spml/scee_module_fftj モジュールは平行平板間での 3 次元流体運動を
  !    スペクトル法によって数値計算するための Fortran90 関数を提供する
  !    ものである.
  !
  !    水平方向にフーリエ数変換および上下の境界壁を扱うための
  !    sin/cos 変換を用いる場合のスペクトル計算のためのさまざまな
  !    関数を提供する.
  !
  !    内部で ee_module_fftj, asc_module を用いている. 最下部ではフーリエ
  !    およびチェビシェフ変換のエンジンとして ISPACK の Fortran77
  !    サブルーチンを用いている.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (see_, cee_, zyx_, zee_, ee_, yx_, x_, y_, z_, a_) は,
  !   返す値の形を示している.
  !   see_  :: スペクトルデータ(2 重フーリエ・sin変換)
  !   cee_  :: スペクトルデータ(2 重フーリエ・cos変換)
  !   zyx_ :: 3 次元格子点データ(水平 2 次元鉛直 1 次元・)
  !   zee_ :: 水平スペクトル, 鉛直格子点データ
  !   e2a_ :: 1 次元化した水平スペクトル, 任意座標データ
  !   aee_ :: 任意座標データ, 水平スペクトルデータ
  !
  ! * 関数名の間の文字列(Dx, Dy, Dz, Lapla,..)
  !   は, その関数の作用を表している.
  !
  ! * 関数名の最後 (see_, cee_, zyx_, zee_, ee_, yx_, x_, y_, z_, a_) は, 
  !   入力変数の形がスペクトルデータおよび格子点データであることを示している.
  !   _see :: スペクトルデータ(2 重フーリエ・sin変換)
  !   _cee :: スペクトルデータ(2 重フーリエ・cos変換)  
  !   _zyx :: 3 次元格子点データ(水平 2 次元鉛直 1 次元・)
  !   _zee :: 水平スペクトル, 鉛直格子点データ
  !   _e2a :: 1 次元化した水平スペクトル, 任意座標データ
  !   _aee :: 任意座標データ, 水平スペクトルデータ
  !
  !=== 各データの種類の説明
  !
  ! * zyx : 3 次元格子点データ(鉛直, 水平 2 次元)
  !   * 変数の種類と次元は real(8), dimension(0:km,0:jm-1,0:im-1).
  !   * im, jm, km はそれぞれ水平 X, Y, 鉛直 Z 座標の格子点数であり,
  !     サブルーチン tee_Initial にてあらかじめ設定しておく.
  !
  ! * see : スペクトルデータ
  !   * 変数の種類と次元は real(8), dimension(nm,-mm:mm,-lm:lm).
  !   * lm, mm は X,Y 方向最大波数, nm は sin 級数の最大次数
  !     であり, サブルーチン tee_Initial にてあらかじめ設定しておく.
  !
  ! * cee : スペクトルデータ
  !   * 変数の種類と次元は real(8), dimension(0:nm,-mm:mm,-lm:lm).
  !   * lm, mm は X,Y 方向最大波数, nm は cos 級数の最大次数
  !     であり, サブルーチン tee_Initial にてあらかじめ設定しておく.
  !
  ! * zee : 水平スペクトル, 鉛直格子点データ.
  !   * 変数の種類と次元は real(8), dimension(0:km,-mm:mm,-lm:lm).
  !
  ! * e2a : 1 次元化した水平スペクトル, 任意座標データ
  !   * 変数の種類と次元は real(8), dimension((2*mm+1)*(2*lm+1),:)
  !
  ! * aee :   任意座標データ, 水平スペクトルデータ
  !   * 変数の種類と次元は real(8), dimension(:,-mm:mm,-lm:lm).
  !
  ! * see_, cee_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * zyx_ で始まる関数が返す値は 3 次元格子点データに同じ.
  !
  ! * zee_ で始まる関数が返す値は水平スペクトル, 動径格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! scee_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  !
  !==== 座標変数
  !
  ! x_X, y_Y, z_Z                :: 格子点座標(水平 X,Y, 鉛直 Z 座標)を
  !                                 格納した1 次元配列
  ! x_X_Weight, y_X_Weight, z_Z_Weight :: 重み座標を格納した 1 次元配列
  ! zyx_X, zyx_Y, zyx_Z          :: 格子点データの水平鉛直座標(X,Y,Z)
  !                                 (格子点データ型 3 次元配列)
  ! yx_X, yx_Y                   :: 格子点データの水平座標(X,Y)
  ! zy_Z, zy_Y                   :: 格子点データの鉛直水平座標(Z,Y)
  ! zx_Z, zx_X                   :: 格子点データの鉛直水平座標(Z,X)
  !                                 (格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! zyx_see, see_zyx :: スペクトルデータと 3 次元格子データの間の変換
  !                     (2 重フーリエ, sin 変換)
  ! zyx_cee, cee_zyx :: スペクトルデータと 3 次元格子データの間の変換
  !                     (2 重フーリエ, cos 変換)
  ! zyx_zee, zee_zyx :: 3 次元格子データと水平スペクトル・鉛直格子データとの間
  !                     の変換 (2 重フーリエ変換)
  ! zee_see, see_zee :: スペクトルデータと水平スペクトル・鉛直格子データとの間
  !                     の変換 (sin変換)
  ! zee_cee, cee_zee :: スペクトルデータと水平スペクトル・鉛直格子データとの間
  !                     の変換 (cos変換)
  ! ee_yx, yx_ee     :: スペクトルデータと 2 次元水平格子データの間の変換
  !                     (2 重フーリエ変換)
  ! az_as, as_az     :: 格子データと sin 変換データの間の変換を同時に複数個行う
  ! az_ac, ac_az     :: 格子データと cos 変換データの間の変換を同時に複数個行う
  ! e2a_aee, aee_e2a :: 水平スペクトル軸を 1 次元化し転置, 転置 ２次元化する.
  !
  !==== 微分
  !
  ! see_Dx_see          :: スペクトルデータに動径微分∂/∂x を作用させる
  ! cee_Dx_cee          :: スペクトルデータに動径微分∂/∂x を作用させる
  ! see_Dy_see          :: スペクトルデータに動径微分∂/∂y を作用させる
  ! cee_Dy_cee          :: スペクトルデータに動径微分∂/∂y を作用させる
  ! see_Dz_cee          :: スペクトルデータに動径微分∂/∂z を作用させる
  ! cee_Dz_see          :: スペクトルデータに動径微分∂/∂z を作用させる
  !
  ! see_Lapla_see       :: スペクトルデータにラプラシアンを作用させる
  ! cee_Lapla_cee       :: スペクトルデータにラプラシアンを作用させる
  ! see_LaplaInv_see    :: スペクトルデータに逆ラプラシアンを作用させる
  ! cee_LaplaInv_cee    :: スペクトルデータに逆ラプラシアンを作用させる
  ! see_LaplaH_see      :: スペクトルデータに水平ラプラシアンを作用させる
  ! cee_LaplaH_cee      :: スペクトルデータに水平ラプラシアンを作用させる
  ! see_LaplaHInv_see   :: スペクトルデータに逆水平ラプラシアンを作用させる
  ! cee_LaplaHInv_cee   :: スペクトルデータに逆水平ラプラシアンを作用させる
  !
  ! see_Div_zyx_zyx_zyx :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! cee_Div_zyx_zyx_zyx :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  !
  !==== トロイダルポロイダル計算用微分
  !
  ! see_ZRot_zyx_zyx         :: ベクトル v の渦度と動径ベクトル r の内積
  !                             z・(▽×v) を計算する
  ! cee_ZRot_zyx_zyx         :: ベクトル v の渦度と動径ベクトル r の内積
  !                             z・(▽×v) を計算する
  ! see_ZRotRot_zyx_zyx_zyx  :: ベクトルの v の z・(▽×▽×v) を計算する
  ! cee_ZRotRot_zyx_zyx_zyx  :: ベクトルの v の z・(▽×▽×v) を計算する
  ! scee_Potential2Vector_see_cee :: トロイダルポロイダルポテンシャルから
  !                                  ベクトル場を計算する
  ! scee_Potential2Vector_cee_see :: トロイダルポロイダルポテンシャルから
  !                                  ベクトル場を計算する
  ! scee_Potential2Rotation_see_cee :: トロイダルポロイダルポテンシャルで表される
  !                                    非発散ベクトル場の回転の各成分を計算する
  ! scee_Potential2Rotation_cee_see :: トロイダルポロイダルポテンシャルで表される
  !                                    非発散ベクトル場の回転の各成分を計算する
  !
  !==== ポロイダル/トロイダルモデル用スペクトル解析
  !
  ! zee_ToroidalEnergySpectrum_cee, zee_ToroidalEnergySpectrum_see ::
  !     トロイダルポテンシャルからエネルギーのフーリエ各成分を計算する
  ! zee_PoloidalEnergySpectrum_tee, zee_PoloidalEnergySpectrum_cee ::
  !     ポロイダルポテンシャルからエネルギーのフーリエ各成分を計算する
  !
  !==== 積分・平均(3 次元データ)
  !
  ! IntZYX_zyx, AvrZYX_zyx     :: 3 次元格子点データの全領域積分および平均
  ! z_IntYX_zyx, z_AvrYX_zyx   :: 3 次元格子点データの水平積分および平均
  ! y_IntZX_zyx, y_AvrZX_zyx   :: 3 次元格子点データのZX積分および平均
  ! z_IntZY_zyx, z_AvrZY_zyx   :: 3 次元格子点データのZY積分および平均
  ! zy_IntX_zyx, zy_AvrX_zyx   :: 3 次元格子点データの水平X方向積分および平均
  ! zx_IntY_zyx, zx_AvrY_zyx   :: 3 次元格子点データの水平Y方向積分および平均
  ! zx_IntZ_zyx, zx_AvrZ_zyx   :: 3 次元格子点データの鉛直方向積分および平均
  !
  !==== 積分・平均(2 次元データ)
  !
  ! IntYX_yx, AvrYX_yx :: 2 次元格子点データの水平積分および平均
  ! IntZX_zx, AvrZX_zx :: 2 次元(ZX)格子点データのZX積分および平均
  ! IntZY_zy, AvrZY_zy :: 2 次元(ZY)格子点データのZY積分および平均
  ! y_IntX_yx, y_AvrX_yx   :: 水平 2 次元格子点データのX方向積分および平均
  ! x_IntY_yx, x_AvrY_yx   :: 水平2 次元格子点データのY方向積分および平均
  ! z_IntX_zx, z_AvrX_zx   :: 2 次元(ZX)格子点データのX方向積分および平均
  ! x_IntZ_zx, x_AvrZ_zx   :: 2 次元(ZX)格子点データのZ方向積分および平均
  ! z_IntY_zy, z_AvrY_zy   :: 2 次元(ZY)格子点データのY方向積分および平均
  ! y_IntZ_zy, y_AvrZ_zy   :: 2 次元(ZY)格子点データのZ方向積分および平均
  !
  !==== 積分・平均(1 次元データ)
  !
  ! IntX_x, AvrX_x  :: 1 次元(X)格子点データのX方向積分および平均
  ! IntY_y, AvrY_y  :: 1 次元(Y)格子点データのY方向積分および平均
  ! IntZ_z, AvrZ_z  :: 1 次元(Z)格子点データのZ方向積分および平均
  !
  !==== 補間計算
  !
  ! Interpolate_cee :: スペクトルデータから任意の点の値を補間する.
  ! Interpolate_see :: スペクトルデータから任意の点の値を補間する.  
  !
  use dc_message
  use lumatrix
  use ee_module_fftj
  use asc_module, z_Z => g_X, z_Z_WEIGHT => g_X_WEIGHT, &
                  as_az => as_ag, az_as => ag_as, &
                  ac_az => ac_ag, az_ac => ag_ac, &
                  s_z => s_g, z_s => g_s, &
                  c_z => c_g, z_c => g_c, &                 
                  c_Dz_s => c_Dx_s, ac_Dz_as => ac_Dx_as, &
                  s_Dz_c => s_Dx_c, as_Dz_ac => as_Dx_ac
  implicit none
  private

  public scee_Initial

  public x_X, x_X_Weight
  public y_Y, y_Y_Weight
  public z_Z, z_Z_Weight
  public yx_X, yx_Y, zy_Z, zy_Y, zx_X, zx_Z
  public zyx_X, zyx_Y, zyx_Z
  public zee_Z
  public scee_VMiss

  public ee_yx, yx_ee
  public ac_Dz_as, as_Dz_ac, c_Dz_s, s_Dz_c
  public az_ac, az_as, ac_az, as_az, z_c, z_s, c_z, s_z
  public zyx_see, see_zyx, zee_see, see_zee
  public zyx_cee, cee_zyx, zee_cee, cee_zee
  public zyx_zee, zee_zyx 
  public e2z_e2s, e2s_e2z
  public e2z_e2c, e2c_e2z   
  public aee_e2a, e2a_aee, ee_e2, e2_ee
  public cee_Dx_cee, see_Dx_see, cee_Dy_cee, see_Dy_see, see_Dz_cee, cee_Dz_see
  public cee_Lapla_cee, see_Lapla_see
  public cee_LaplaInv_cee, see_LaplaInv_see
  public cee_LaplaH_cee, see_LaplaH_see, cee_LaplaHInv_cee, see_LaplaHInv_see
  public cee_Div_zyx_zyx_zyx, see_Div_zyx_zyx_zyx

  public zy_IntX_zyx, zx_IntY_zyx, yx_IntZ_zyx
  public x_IntZY_zyx, y_IntZX_zyx, z_IntYX_zyx
  public IntZYX_zyx

  public x_IntY_yx, y_IntX_yx, IntYX_yx
  public z_IntY_zy, y_IntZ_zy, IntZY_zy
  public z_IntX_zx, x_IntZ_zx, IntZX_zx
  public IntX_x, IntY_y, IntZ_z

  public zy_AvrX_zyx, zx_AvrY_zyx, yx_AvrZ_zyx
  public x_AvrZY_zyx, y_AvrZX_zyx, z_AvrYX_zyx
  public AvrZYX_zyx

  public x_AvrY_yx, y_AvrX_yx, AvrYX_yx
  public z_AvrY_zy, y_AvrZ_zy, AvrZY_zy
  public z_AvrX_zx, x_AvrZ_zx, AvrZX_zx
  public AvrX_x, AvrY_y, AvrZ_z

  public cee_ZRot_zyx_zyx, see_ZRot_zyx_zyx
  public cee_ZRotRot_zyx_zyx_zyx, see_ZRotRot_zyx_zyx_zyx
  public scee_Potential2vector_cee_see, scee_Potential2vector_see_cee
  public scee_Potential2Rotation_cee_see, scee_Potential2Rotation_see_cee

  public Interpolate_cee, Interpolate_see

  public zee_ToroidalEnergySpectrum_cee, zee_ToroidalEnergySpectrum_see ! nz_ToroidalEnergySpectrum_wt
  public zee_PoloidalEnergySpectrum_cee, zee_PoloidalEnergySpectrum_see ! nz_PoloidalEnergySpectrum_wt

  integer            :: im=32, jm=32, km=16  ! 格子点の設定(X,Y,Z)
  integer            :: lm=10, mm=10, nm=16  ! 切断波数の設定(水平X,Y, 鉛直Z)
  real(8)            :: xl, yl, zl           ! 領域の大きさ(水平X,Y, 鉛直Z)

  real(8), parameter :: pi=3.1415926535897932385D0

  real(8), dimension(:,:,:), allocatable :: zyx_X, zyx_Y, zyx_Z    ! 座標
  real(8), dimension(:,:),   allocatable :: zy_Z, zy_Y             ! 座標
  real(8), dimension(:,:),   allocatable :: zx_Z, zx_X             ! 座標
  real(8), dimension(:,:,:), allocatable :: zee_Z                  ! 座標

  real(8) :: scee_VMiss = -999.0        ! 欠損値

  save im, jm, km, lm, mm, nm, xl, yl, zl

contains
  !--------------- 初期化 -----------------
  subroutine scee_Initial(i,j,k,l,m,n,xmin,xmax,ymin,ymax,zmin,zmax)
     !
     ! スペクトル変換の格子点数, 波数, 各座標の範囲を設定する.
     !
     ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
     ! しなければならない.
     !
     integer,intent(in) :: i              ! 格子点数(水平X)
     integer,intent(in) :: j              ! 格子点数(水平Y)
     integer,intent(in) :: k              ! 格子点数(鉛直Z)
     integer,intent(in) :: l              ! 切断波数(水平X波数)
     integer,intent(in) :: m              ! 切断波数(水平Y波数)
     integer,intent(in) :: n              ! 切断波数(鉛直Z波数)

     real(8),intent(in) :: xmin, xmax     ! X 方向領域
     real(8),intent(in) :: ymin, ymax     ! Y 方向領域
     real(8),intent(in) :: zmin, zmax     ! Z 方向領域

     integer            :: id

     im = i  ; jm = j ; km = k
     lm = l  ; mm = m ; nm = n
     xl = xmax - xmin
     yl = ymax - ymin
     zl = zmax - zmin

     call ee_Initial(im,jm,lm,mm,xmin,xmax,ymin,ymax,id)

     call asc_Initial(km,nm,zmin,zmax)

     allocate(zyx_X(0:km,0:jm-1,0:im-1))
     allocate(zyx_Y(0:km,0:jm-1,0:im-1))
     allocate(zyx_Z(0:km,0:jm-1,0:im-1))

     allocate(zy_Z(0:km,0:jm-1))
     allocate(zy_Y(0:km,0:jm-1))
     allocate(zx_Z(0:km,0:im-1))
     allocate(zx_X(0:km,0:im-1))

     allocate(zee_Z(0:km,-mm:mm,-lm:lm))

     zyx_X = spread(yx_X,1,km+1)
     zyx_Y = spread(yx_Y,1,km+1)
     zyx_Z = spread(spread(z_Z,2,jm),3,im)

     zy_Z = spread(z_Z,2,jm)
     zy_Y = spread(y_Y,1,km+1)

     zx_Z = spread(z_Z,2,im)
     zx_X = spread(x_X,1,km+1)

     zee_Z = spread(spread(z_Z,2,2*mm+1),3,2*lm+1)

     call MessageNotify('M','tee_initial', &
          'scee_module_fftj (2017/05/28) is initialized')

   end subroutine scee_Initial

   !--------------- 基本変換 -----------------
   
   function zyx_see(see)
     !
     ! スペクトルデータから 3 次元格子点データへ(逆)変換する.
     !
     real(8), dimension(nm,-mm:mm,-lm:lm), intent(in) :: see
     !(in) 2 重フーリエ sin スペクトルデータ
     real(8), dimension(0:km,0:jm-1,0:im-1)           :: zyx_see
     !(out) 3 次元格子点データ

     zyx_see = zyx_zee(zee_see(see))

   end function zyx_see

   function see_zyx(zyx)
     !
     ! 3 次元格子点データからスペクトルデータへ(正)変換する.
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
     !(in) 3 次元格子点データ
     real(8), dimension(nm,-mm:mm,-lm:lm)               :: see_zyx
     !(out) 2 重フーリエ sin スペクトルデータ

     see_zyx = see_zee(zee_zyx(zyx))

   end function see_zyx

   function zyx_cee(cee)
     !
     ! スペクトルデータから 3 次元格子点データへ(逆)変換する.
     !
     real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: cee
     !(in) 2 重フーリエ cos スペクトルデータ
     real(8), dimension(0:km,0:jm-1,0:im-1)             :: zyx_cee
     !(out) 3 次元格子点データ

     zyx_cee = zyx_zee(zee_cee(cee))

   end function zyx_cee

   function cee_zyx(zyx)
     !
     ! 3 次元格子点データからスペクトルデータへ(正)変換する.
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
     !(in) 3 次元格子点データ
     real(8), dimension(0:nm,-mm:mm,-lm:lm)             :: cee_zyx
     !(out) 2 重フーリエ cos スペクトルデータ

     cee_zyx = cee_zee(zee_zyx(zyx))

   end function cee_zyx

   function zyx_zee(zee)
     !
     ! 水平スペクトル・鉛直格子点データから 3 次元格子点データへ(逆)変換する.
     !
     real(8), dimension(0:km,-mm:mm,-lm:lm), intent(in) :: zee
     !(in) 2 次元水平スペクトル・鉛直格子点データ
     real(8), dimension(0:km,0:jm-1,0:im-1)             :: zyx_zee
     !(out) 3 次元格子点データ
     real(8), dimension(-mm:mm,-lm:lm)                  :: ee
     real(8), dimension(0:jm-1,0:im-1)                  :: yx

     integer :: k

     do k = 0, km
        !zyx_zee(k,:,:) = yx_ee(zee(k,:,:))
        !
        ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
        !
        ee = zee(k,-mm:mm,-lm:lm)
        yx = yx_ee(ee)
        zyx_zee(k,:,:) = yx
     enddo

   end function zyx_zee

   function zee_zyx(zyx)
     !
     ! 3 次元格子データから水平スペクトル・鉛直格子点データへ(正)変換する.
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
     !(in) 3 次元格子点データ
     real(8), dimension(0:km,-mm:mm,-lm:lm)             :: zee_zyx
     !(out) 2 次元スペクトル・鉛直格子点データ
     real(8), dimension(-mm:mm,-lm:lm)                  :: ee
     real(8), dimension(0:jm-1,0:im-1)                  :: yx

     integer :: k

     do k = 0, km
        !zee_zyx(k,:,:) = ee_yx(zyx(k,:,:))
        !
        ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
        !
        yx = zyx(k,0:jm-1,0:im-1)
        ee = ee_yx(yx)
        zee_zyx(k,:,:) = ee
     enddo

   end function zee_zyx

   function zee_see(see)
     !
     ! スペクトルデータから水平スペクトル・鉛直格子点データへ(正)変換する.
     !
     real(8), dimension(nm,-mm:mm,-lm:lm), intent(in) :: see
     !(in) 2 次元水平スペクトル鉛直 sin スペクトルデータ
     real(8), dimension(0:km,-mm:mm,-lm:lm)           :: zee_see
     !(out) 2 次元水平スペクトル・鉛直格子点データ

     zee_see = aee_e2a(e2z_e2s(e2a_aee(see)))

   end function zee_see

   function see_zee(zee)
     !
     ! 水平スペクトル・鉛直格子点データからスペクトルデータへ(正)変換する.
     !
     real(8), dimension(0:km,-mm:mm,-lm:lm), intent(in) :: zee
     !(in) 2 次元水平スペクトル・鉛直格子点データ
     real(8), dimension(nm,-mm:mm,-lm:lm)               :: see_zee
     !(out) 2 次元水平鉛直 sin スペクトルデータ

     see_zee = aee_e2a(e2s_e2z(e2a_aee(zee)))

   end function see_zee

   function zee_cee(cee)
     !
     ! スペクトルデータから水平スペクトル・鉛直格子点データへ(正)変換する.
     !
     real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: cee
     !(in) 2 次元水平スペクトル鉛直 cos スペクトルデータ
     real(8), dimension(0:km,-mm:mm,-lm:lm)             :: zee_cee
     !(out) 2 次元水平スペクトル・鉛直格子点データ

     zee_cee = aee_e2a(e2z_e2c(e2a_aee(cee)))

   end function zee_cee

   function cee_zee(zee)
     !
     ! 水平スペクトル・鉛直格子点データからスペクトルデータへ(正)変換する.
     !
     real(8), dimension(0:km,-mm:mm,-lm:lm), intent(in) :: zee
     !(in) 2 次元水平スペクトル・鉛直格子点データ
     real(8), dimension(0:nm,-mm:mm,-lm:lm)             :: cee_zee
     !(out) 2 次元水平鉛直 cos スペクトルデータ

     cee_zee = aee_e2a(e2c_e2z(e2a_aee(zee)))

   end function cee_zee

   function e2z_e2s(e2s)
     !
     ! 鉛直スペクトルを格子点に変換する
     !
     real(8), dimension((2*lm+1)*(2*mm+1),nm)    :: e2s
     !(in)  1 次元化された水平スペクトル・鉛直スペクトル
     real(8), dimension((2*lm+1)*(2*mm+1),0:km)  :: e2z_e2s
     !(out) 1 次元化された水平スペクトル・鉛直格子座標

     e2z_e2s = az_as(e2s)

   end function e2z_e2s

   function e2s_e2z(e2z)
     !
     ! 鉛直格子点をスペクトルに変換する
     !
     real(8), dimension((2*lm+1)*(2*mm+1),0:km)  :: e2z
     !(in)  1 次元化された水平スペクトル・鉛直格子座標
     real(8), dimension((2*lm+1)*(2*mm+1),nm)    :: e2s_e2z
     !(out) 1 次元化された水平スペクトル・鉛直スペクトル

     e2s_e2z = as_az(e2z)

   end function e2s_e2z

   function e2z_e2c(e2c)
     !
     ! 鉛直スペクトルを格子点に変換する
     !
     real(8), dimension((2*lm+1)*(2*mm+1),0:nm)    :: e2c
     !(in)  1 次元化された水平スペクトル・鉛直スペクトル
     real(8), dimension((2*lm+1)*(2*mm+1),0:km)    :: e2z_e2c
     !(out) 1 次元化された水平スペクトル・鉛直格子座標

     e2z_e2c = az_ac(e2c)

   end function e2z_e2c

   function e2c_e2z(e2z)
     !
     ! 鉛直格子点をスペクトルに変換する
     !
     real(8), dimension((2*lm+1)*(2*mm+1),0:km)  :: e2z
     !(in)  1 次元化された水平スペクトル・鉛直格子座標
     real(8), dimension((2*lm+1)*(2*mm+1),0:nm)  :: e2c_e2z
     !(out) 1 次元化された水平スペクトル・鉛直スペクトル

     e2c_e2z = ac_az(e2z)

   end function e2c_e2z
   
   function e2a_aee(aee)
     !
     ! 水平スペクトルを 1 次元化転置する.
     !
     real(8), dimension(:,-mm:,-lm:), intent(in)        :: aee
     !(in) 任意座標・水平 2 次元スペクトルデータ dimension(:,-mm:mm,-lm:lm)
     real(8), dimension((2*lm+1)*(2*mm+1),size(aee,1))  :: e2a_aee
     !(out) 1 次元化された水平スペクトル・任意座標データ

     integer :: j,k,l,m
     !
     !e2a_aee = transpose(reshape(aee,(/size(aee,1),(2*lm+1)*(2*mm+1)/)))
     !
     ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
     !

     do k=1,size(aee,1)
        do l=-lm,lm
           do m=-mm,mm
              j = (m+mm+1)+ (2*mm+1)*(l+lm)
              e2a_aee(j,k) = aee(k,m,l)
           enddo
        enddo
     enddo

   end function e2a_aee

   function aee_e2a(e2a)
     !
     ! 水平スペクトルを転置展開する.
     !
     real(8), dimension(:,:),intent(in)                 :: e2a
     !(in) 1 次元化された水平スペクトル・任意座標データ
     !     dimmension((2*mm*1)*(2*lm*1),:)
     real(8), dimension(size(e2a,2),-mm:mm,-lm:lm)      :: aee_e2a
     !(out) 任意座標・水平 2 次元スペクトルデータ

     integer :: j,k,l,m
     !
     !aee_e2a = reshape(transpose(e2a),(/size(e2a,2),2*mm+1,2*lm+1/))
     !
     ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
     !

     do k=1,size(e2a,2)
        do l=-lm,lm
           do m=-mm,mm
              j = (m+mm+1) + (2*mm+1)*(l+lm)
              aee_e2a(k,m,l) = e2a(j,k)
           enddo
        enddo
     enddo

   end function aee_e2a

   function e2_ee(ee)
     !
     ! 水平スペクトルを 1 次元化転置する.
     !
     real(8), dimension(-mm:,-lm:), intent(in)        :: ee
     !(in) 任意座標・水平 2 次元スペクトルデータ dimension(-mm:mm,-lm:lm)
     real(8), dimension((2*lm+1)*(2*mm+1))            :: e2_ee
     !(out) 1 次元化された水平スペクトル・任意座標データ

     integer :: j,l,m

     !e2_ee = reshape(e2a_aee(reshape(ee,(/1,2*mm+1,2*lm+1/))), &
     !                (/(2*lm+1)*(2*mm+1)/))
     !
     ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
     !

     do l=-lm,lm
        do m=-mm,mm
           j = (m+mm+1)+ (2*mm+1)*(l+lm)
           e2_ee(j) = ee(m,l)
        enddo
     enddo

   end function e2_ee

   function ee_e2(e2)
     !
     ! 水平スペクトルを転置展開する.
     !
     real(8), dimension(:),intent(in)                   :: e2
     !(in) 1 次元化された水平スペクトル・任意座標データ
     !     dimmension((2*mm*1)*(2*lm*1),:)
     real(8), dimension(-mm:mm,-lm:lm)                  :: ee_e2
     !(out) 任意座標・水平 2 次元スペクトルデータ

     integer :: j,l,m

     !ee_e2 = reshape(aee_e2a(reshape(e2,(/(2*mm+1)*(2*lm+1),1/))), &
     !                (/2*mm+1,2*lm+1/))
     !
     ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
     !

     do l=-lm,lm
        do m=-mm,mm
           j = (m+mm+1) + (2*mm+1)*(l+lm)
           ee_e2(m,l) = e2(j)
        enddo
     enddo

   end function ee_e2

   !--------------- 微分計算 -----------------
   function cee_Dx_cee(cee)
     !
     ! 入力スペクトルデータに水平微分 ∂/∂x を作用する.
     !
     ! スペクトルデータのX微分とは, 対応する格子点データにX微分を
     ! 作用させたデータのスペクトル変換のことである.
     !
     real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: cee
     !(in) 入力スペクトルデータ

     real(8), dimension(0:nm,-mm:mm,-lm:lm)             :: cee_Dx_cee
     !(in) X微分されたスペクトルデータ

     integer :: n

     do n=0,nm
        cee_Dx_cee(n,:,:) = ee_Dx_ee(cee(n,:,:))
     enddo

   end function cee_Dx_cee

   function see_Dx_see(see)
     !
     ! 入力スペクトルデータに水平微分 ∂/∂x を作用する.
     !
     ! スペクトルデータのX微分とは, 対応する格子点データにX微分を
     ! 作用させたデータのスペクトル変換のことである.
     !
     real(8), dimension(nm,-mm:mm,-lm:lm), intent(in) :: see
     !(in) 入力スペクトルデータ

     real(8), dimension(nm,-mm:mm,-lm:lm)             :: see_Dx_see
     !(in) X微分されたスペクトルデータ

     integer :: n

     do n=1,nm
        see_Dx_see(n,:,:) = ee_Dx_ee(see(n,:,:))
     enddo

   end function see_Dx_see

   function cee_Dy_cee(cee)
     !
     ! 入力スペクトルデータに水平微分 ∂/∂y を作用する.
     !
     ! スペクトルデータのY微分とは, 対応する格子点データにY微分を
     ! 作用させたデータのスペクトル変換のことである.
     !
     real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: cee
     !(in) 入力スペクトルデータ

     real(8), dimension(0:nm,-mm:mm,-lm:lm)             :: cee_Dy_cee
     !(in) X微分されたスペクトルデータ

     integer :: n

     do n=0,nm
        cee_Dy_cee(n,:,:) = ee_Dy_ee(cee(n,:,:))
     enddo

   end function cee_Dy_cee

   function see_Dy_see(see)
     !
     ! 入力スペクトルデータに水平微分 ∂/∂y を作用する.
     !
     ! スペクトルデータのY微分とは, 対応する格子点データにY微分を
     ! 作用させたデータのスペクトル変換のことである.
     !
     real(8), dimension(nm,-mm:mm,-lm:lm), intent(in) :: see
     !(in) 入力スペクトルデータ

     real(8), dimension(nm,-mm:mm,-lm:lm)             :: see_Dy_see
     !(in) X微分されたスペクトルデータ

     integer :: n

     do n=1,nm
        see_Dy_see(n,:,:) = ee_Dy_ee(see(n,:,:))
     enddo

   end function see_Dy_see

   function see_Dz_cee(cee)
     !
     ! 入力スペクトルデータに鉛直微分 ∂/∂z を作用する.
     !
     ! スペクトルデータの鉛直微分とは, 対応する格子点データに鉛直微分を
     ! 作用させたデータのスペクトル変換のことである.
     !
     real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: cee
     !(in) 入力スペクトルデータ

     real(8), dimension(nm,-mm:mm,-lm:lm)               :: see_Dz_cee
     !(in) 鉛直微分されたスペクトルデータ

     see_Dz_cee = aee_e2a(e2s_Dz_e2c(e2a_aee(cee)))

   end function see_Dz_cee

   function cee_Dz_see(see)
     !
     ! 入力スペクトルデータに鉛直微分 ∂/∂z を作用する.
     !
     ! スペクトルデータの鉛直微分とは, 対応する格子点データに鉛直微分を
     ! 作用させたデータのスペクトル変換のことである.
     !
     real(8), dimension(nm,-mm:mm,-lm:lm), intent(in) :: see
     !(in) 入力スペクトルデータ

     real(8), dimension(0:nm,-mm:mm,-lm:lm)           :: cee_Dz_see
     !(in) 鉛直微分されたスペクトルデータ

     cee_Dz_see = aee_e2a(e2c_Dz_e2s(e2a_aee(see)))     

   end function cee_Dz_see

   function e2s_Dz_e2c(e2c)
     !
     ! 入力スペクトルデータに鉛直微分 ∂/∂z を作用する.
     !
     ! スペクトルデータの鉛直微分とは, 対応する格子点データに鉛直微分を
     ! 作用させたデータのスペクトル変換のことである.
     !
     real(8), dimension((2*lm+1)*(2*mm+1),0:nm), intent(IN) :: e2c
     !(in) 入力スペクトルデータ

     real(8), dimension((2*lm+1)*(2*mm+1),nm)           :: e2s_Dz_e2c
     !(in) 鉛直微分されたスペクトルデータ
     
     e2s_Dz_e2c = as_Dz_ac(e2c)
   end function e2s_Dz_e2c
     
   function e2c_Dz_e2s(e2s)
     !
     ! 入力スペクトルデータに鉛直微分 ∂/∂z を作用する.
     !
     ! スペクトルデータの鉛直微分とは, 対応する格子点データに鉛直微分を
     ! 作用させたデータのスペクトル変換のことである.
     !
     real(8), dimension((2*lm+1)*(2*mm+1),nm), intent(IN) :: e2s
     !(in) 入力スペクトルデータ

     real(8), dimension((2*lm+1)*(2*mm+1),0:nm)           :: e2c_Dz_e2s 
     !(in) 鉛直微分されたスペクトルデータ
     
     e2c_Dz_e2s = ac_Dz_as(e2s)
   end function e2c_Dz_e2s
     
   function cee_Lapla_cee(cee)
     !
     ! 入力スペクトルデータにラプラシアン
     !
     !     ▽^2 = ∂^2/∂X^2 + ∂^2/∂Y^2 + ∂^2/∂Z^2
     !
     ! を作用する.
     !
     ! スペクトルデータのラプラシアンとは, 対応する格子点データに
     ! ラプラシアンを作用させたデータのスペクトル変換のことである.
     !
     real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: cee
     !(in) 2 次元球面調和函数 cos スペクトルデータ

     real(8), dimension(0:nm,-mm:mm,-lm:lm)             :: cee_Lapla_cee
     !(out) ラプラシアンを作用された 2 次元スペクトルデータ

     cee_Lapla_cee = cee_LaplaH_cee(cee) + cee_Dz_see(see_Dz_cee(cee))

   end function cee_Lapla_cee

   function see_Lapla_see(see)
     !
     ! 入力スペクトルデータにラプラシアン
     !
     !     ▽^2 = ∂^2/∂X^2 + ∂^2/∂Y^2 + ∂^2/∂Z^2
     !
     ! を作用する.
     !
     ! スペクトルデータのラプラシアンとは, 対応する格子点データに
     ! ラプラシアンを作用させたデータのスペクトル変換のことである.
     !
     real(8), dimension(nm,-mm:mm,-lm:lm), intent(in) :: see
     !(in) 2 次元球面調和函数 sin スペクトルデータ

     real(8), dimension(nm,-mm:mm,-lm:lm)             :: see_Lapla_see
     !(out) ラプラシアンを作用された 2 次元スペクトルデータ

     see_Lapla_see = see_LaplaH_see(see) + see_Dz_cee(cee_Dz_see(see))

   end function see_Lapla_see

   function cee_LaplaInv_cee(cee)
     !
     ! スペクトルデータに逆ラプラシアンを作用させる. 
     !
     real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: cee
     !(in) 2 次元球面調和函数 cos スペクトルデータ

     real(8), dimension(0:nm,-mm:mm,-lm:lm)             :: cee_LaplaInv_cee
     !(out) ラプラシアンを作用された 2 次元スペクトルデータ

     real(8), allocatable, dimension(:,:,:) :: cee_LaplaInvFactor
     logical :: first=.true.

     save first, cee_LaplaInvFactor

     if ( first ) then
        first = .false.
        allocate(cee_LaplaInvFactor(0:nm,-mm:mm,-lm:lm))
        cee_LaplaInvFactor = 1.0D0
        cee_LaplaInvFactor = 1.0D0/cee_Lapla_cee(cee_LaplaInvFactor)
        cee_LaplaInvFactor(0,0,0) = 0.0D0
     end if

     cee_LaplaInv_cee = cee_LaplaInvFactor * cee

   end function cee_LaplaInv_cee
   
   function see_LaplaInv_see(see)
     !
     ! スペクトルデータに逆ラプラシアンを作用させる. 
     !
     real(8), dimension(nm,-mm:mm,-lm:lm), intent(in) :: see
     !(in) 2 次元球面調和函数 cos スペクトルデータ

     real(8), dimension(nm,-mm:mm,-lm:lm)             :: see_LaplaInv_see
     !(out) ラプラシアンを作用された 2 次元スペクトルデータ

     real(8), allocatable, dimension(:,:,:) :: see_LaplaInvFactor
     logical :: first=.true.

     save first, see_LaplaInvFactor

     if ( first ) then
        first = .false.
        allocate(see_LaplaInvFactor(nm,-mm:mm,-lm:lm))
        see_LaplaInvFactor = 1.0D0
        see_LaplaInvFactor = 1.0D0/see_Lapla_see(see_LaplaInvFactor)
     end if

     see_LaplaInv_see = see_LaplaInvFactor * see

   end function see_LaplaInv_see
   
   function cee_LaplaH_cee(cee)
     !
     ! 入力スペクトルデータに水平ラプラシアン
     !
     !     ▽^2_H = ∂^2/∂X^2 + ∂^2/∂Y^2
     !
     ! を作用する.
     !
     ! スペクトルデータの水平ラプラシアンとは, 対応する格子点データに
     ! 水平ラプラシアンを作用させたデータのスペクトル変換のことである.
     !
     real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: cee
     !(in) 入力スペクトルデータ

     real(8), dimension(0:nm,-mm:mm,-lm:lm)             :: cee_LaplaH_cee
     !(out) 水平ラプラシアンを作用された 2 次元スペクトルデータ

     integer :: n

     do n=0,nm
        cee_LaplaH_cee(n,:,:) = ee_Lapla_ee(cee(n,:,:))
     enddo

   end function cee_LaplaH_cee

   function see_LaplaH_see(see)
     !
     ! 入力スペクトルデータに水平ラプラシアン
     !
     !     ▽^2_H = ∂^2/∂X^2 + ∂^2/∂Y^2
     !
     ! を作用する.
     !
     ! スペクトルデータの水平ラプラシアンとは, 対応する格子点データに
     ! 水平ラプラシアンを作用させたデータのスペクトル変換のことである.
     !
     real(8), dimension(nm,-mm:mm,-lm:lm), intent(in) :: see
     !(in) 入力スペクトルデータ

     real(8), dimension(nm,-mm:mm,-lm:lm)             :: see_LaplaH_see
     !(out) 水平ラプラシアンを作用された 2 次元スペクトルデータ

     integer :: n

     do n=1,nm
        see_LaplaH_see(n,:,:) = ee_Lapla_ee(see(n,:,:))
     enddo

   end function see_LaplaH_see

   function cee_LaplaHInv_cee(cee)
     !
     ! 入力スペクトルデータに逆水平ラプラシアン
     !
     !     ▽^-2_H = (∂^2/∂X^2 + ∂^2/∂Y^2)^-1
     !
     ! を作用する.
     !
     ! スペクトルデータの逆水平ラプラシアンとは, 対応する格子点データに
     ! 逆水平ラプラシアンを作用させたデータのスペクトル変換のことである.
     !
     real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: cee
     !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

     real(8), dimension(0:nm,-mm:mm,-lm:lm)             :: cee_LaplaHInv_cee
     !(out) 逆水平ラプラシアンを作用された 2 次元スペクトルデータ

     integer :: n

     do n=0,nm
        cee_LaplaHInv_cee(n,:,:) = ee_LaplaInv_ee(cee(n,:,:))
     enddo

   end function cee_LaplaHInv_cee

   function see_LaplaHInv_see(see)
     !
     ! 入力スペクトルデータに逆水平ラプラシアン
     !
     !     ▽^-2_H = (∂^2/∂X^2 + ∂^2/∂Y^2)^-1
     !
     ! を作用する.
     !
     ! スペクトルデータの逆水平ラプラシアンとは, 対応する格子点データに
     ! 逆水平ラプラシアンを作用させたデータのスペクトル変換のことである.
     !
     real(8), dimension(nm,-mm:mm,-lm:lm), intent(in) :: see
     !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

     real(8), dimension(nm,-mm:mm,-lm:lm)             :: see_LaplaHInv_see
     !(out) 逆水平ラプラシアンを作用された 2 次元スペクトルデータ

     integer :: n

     do n=1,nm
        see_LaplaHInv_see(n,:,:) = ee_LaplaInv_ee(see(n,:,:))
     enddo

   end function see_LaplaHInv_see

   function see_Div_zyx_zyx_zyx(zyx_VX,zyx_VY,zyx_VZ)
     !
     ! べクトル成分である 3 つの格子データに発散を作用させた
     ! スペクトルデータを返す.
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VX
     !(in) ベクトル場のX成分
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VY
     !(in) ベクトル場のY成分

     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VZ
     !(in) ベクトル場のZ成分

     real(8), dimension(nm,-mm:mm,-lm:lm)     :: see_Div_zyx_zyx_zyx
     !(out) ベクトル場の発散

     see_Div_zyx_zyx_zyx =   see_Dx_see(see_zyx(zyx_VX)) &
          + see_Dy_see(see_zyx(zyx_VY)) &
          + see_Dz_cee(cee_zyx(zyx_VZ))

   end function see_Div_zyx_zyx_zyx

   function cee_Div_zyx_zyx_zyx(zyx_VX,zyx_VY,zyx_VZ)
     !
     ! べクトル成分である 3 つの格子データに発散を作用させた
     ! スペクトルデータを返す.
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VX
     !(in) ベクトル場のX成分
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VY
     !(in) ベクトル場のY成分

     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VZ
     !(in) ベクトル場のZ成分

     real(8), dimension(0:nm,-mm:mm,-lm:lm)     :: cee_Div_zyx_zyx_zyx
     !(out) ベクトル場の発散

     cee_Div_zyx_zyx_zyx =   cee_Dx_cee(cee_zyx(zyx_VX)) &
          + cee_Dy_cee(cee_zyx(zyx_VY)) &
          + cee_Dz_see(see_zyx(zyx_VZ))

   end function cee_Div_zyx_zyx_zyx

   !--------------- 積分計算 -----------------
   !----(入力データ zyx)---
   function zy_IntX_zyx(zyx)  ! X積分
     !
     ! 3 次元格子点データのX方向積分.
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
     !(in) 3 次元格子点データ

     real(8), dimension(0:km,0:jm-1)  :: zy_IntX_zyx
     !(out) X方向積分された 2 次元ZY格子点データ

     integer :: i

     zy_IntX_zyx = 0.0d0
     do i=0,im-1
        zy_IntX_zyx(:,:) = zy_IntX_zyx(:,:) &
             + zyx(:,:,i) * x_X_Weight(i)
     enddo
   end function zy_IntX_zyx

   function zx_IntY_zyx(zyx)
     !
     ! 3 次元格子点データのY方向域積分.
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
     !(in) 3 次元格子点データ

     real(8), dimension(0:km,0:im-1)  :: zx_IntY_zyx
     !(out) Y積分された 2 次元ZY格子点データ.

     integer :: j

     zx_IntY_zyx = 0.0d0
     do j=0,jm-1
        zx_IntY_zyx(:,:) = zx_IntY_zyx(:,:) &
             + zyx(:,j,:) * y_Y_Weight(j)
     enddo
   end function zx_IntY_zyx

   function yx_IntZ_zyx(zyx)  ! Z積分
     !
     ! 3 次元格子点データのZ方向積分.
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
     !(in) 3 次元格子点データ

     real(8), dimension(0:jm-1,0:im-1)  :: yx_IntZ_zyx
     !(out) Z積分された 2 次元YX(水平)格子点データ

     integer :: k

     yx_IntZ_zyx = 0.0d0
     do k=0,km
        yx_IntZ_zyx(:,:) = yx_IntZ_zyx(:,:) &
             + zyx(k,:,:) * z_Z_Weight(k)
     enddo
   end function yx_IntZ_zyx

   function x_IntZY_zyx(zyx)
     !
     ! 3 次元格子点データのZY積分
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
     !(in) 3 次元ZYX格子点データ

     real(8), dimension(0:im-1)     :: x_IntZY_zyx
     !(out) ZY(子午面)積分された 1 次元X格子点データ

     integer :: j, k

     x_IntZY_zyx = 0.0D0
     do j=0,jm-1
        do k=0,km
           x_IntZY_zyx = x_IntZY_zyx &
                + zyx(k,j,:) * y_Y_Weight(j) * z_Z_Weight(k)
        enddo
     enddo
   end function x_IntZY_zyx

   function y_IntZX_zyx(zyx)
     !
     ! 3 次元格子点データのZX積分.
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
     !(in) 3 次元ZYX格子点データ

     real(8), dimension(0:jm-1)       :: y_IntZX_zyx
     !(out) ZX積分された 1 次元Y格子点データ

     integer :: i, k

     y_IntZX_zyx = 0
     do i=0,im-1
        do k=0,km
           y_IntZX_zyx = y_IntZX_zyx &
                + zyx(k,:,i) * x_X_Weight(i) * z_Z_Weight(k)
        enddo
     enddo
   end function y_IntZX_zyx

   function z_IntYX_zyx(zyx)  ! YX(水平)積分
     !
     ! 3 次元格子点データのYX(水平)積分
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
     !(in) 3 次元ZYX格子点データ

     real(8), dimension(0:km)     :: z_IntYX_zyx
     !(out) YX(水平)積分された 1 次元Z格子点データ

     integer :: i, j

     z_IntYX_zyx = 0
     do j=0,jm-1
        do i=0,im-1
           z_IntYX_zyx = z_IntYX_zyx &
                + zyx(:,j,i) * x_X_Weight(i) * y_Y_Weight(j)
        enddo
     enddo
   end function z_IntYX_zyx

   function IntZYX_zyx(zyx) ! ZYX(全領域)積分
     !
     ! 3 次元格子点データのZYX(全領域)積分
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
     !(in) 3 次元格子点データ

     real(8)                     :: IntZYX_zyx
     !(out) 全領域積分値

     integer :: i, j, k

     IntZYX_zyx = 0
     do i=0,im-1
        do j=0,jm-1
           do k=0,km
              IntZYX_zyx = IntZYX_zyx &
                   + zyx(k,j,i) * x_X_Weight(i) &
                   * y_Y_Weight(j) * z_Z_Weight(k)
           enddo
        enddo
     enddo
   end function IntZYX_zyx

   !----(入力データ zy)---
   function z_IntY_zy(zy)  ! Y積分
     !
     ! 2 次元(ZY)格子点データのY方向積分.
     !
     real(8), dimension(0:km,0:jm-1), intent(in) :: zy
     !(in) 2 次元ZY(子午面)格子点データ

     real(8), dimension(0:km)  :: z_IntY_zy
     !(out) Y積分された 1 次元Z格子点データ

     integer :: j

     z_IntY_zy = 0.0d0
     do j=0,jm-1
        z_IntY_zy(:) = z_IntY_zy(:) + zy(:,j) * y_Y_Weight(j)
     enddo
   end function z_IntY_zy

   function y_IntZ_zy(zy)  ! Z積分
     !
     ! 2 次元(ZY)格子点データのZ方向域積分.
     !
     real(8), dimension(0:km,0:jm-1), intent(in) :: zy
     !(in) 2 次元ZY格子点データ

     real(8), dimension(0:jm-1)  :: y_IntZ_zy
     !(out) Z積分された 1 次元Y格子点データ

     integer :: k

     y_IntZ_zy = 0.0d0
     do k=0,km
        y_IntZ_zy(:) = y_IntZ_zy(:) &
             + zy(k,:) * z_Z_Weight(k)
     enddo
   end function y_IntZ_zy

   function IntZY_zy(zy)
     !
     ! 2 次元(ZY)格子点データのZY積分
     !
     real(8), dimension(0:km,0:jm-1), intent(in) :: zy
     !(in) 2 次元ZY(子午面)格子点データ

     real(8)                   :: IntZY_zy
     !(out) 積分値
     integer :: j, k

     IntZY_zy = 0
     do j=0,jm-1
        do k=0,km
           IntZY_zy = IntZY_zy &
                + zy(k,j) * y_Y_Weight(j) * z_Z_Weight(k)
        enddo
     enddo
   end function IntZY_zy

   !----(入力データ zx)---
   function z_IntX_zx(zx)
     !
     ! 2 次元(ZX)格子点データのX方向積分.
     !
     real(8), dimension(0:km,0:im-1), intent(in) :: zx
     !(in) 2 次元ZY格子点データ

     real(8), dimension(0:km)  :: z_IntX_zx
     !(out) X積分された 1 次元Z格子点データ

     integer :: i

     z_IntX_zx = 0.0d0
     do i=0,im-1
        z_IntX_zx(:) = z_IntX_zx(:) + zx(:,i) * x_X_Weight(i)
     enddo

   end function z_IntX_zx

   function x_IntZ_zx(zx)
     !
     ! 2 次元(ZX)格子点データのZ方向積分.
     !
     real(8), dimension(0:km,0:im-1), intent(in) :: zx
     !(in) 2 次元ZY格子点データ

     real(8), dimension(0:im-1)  :: x_IntZ_zx
     !(out) Z積分された 1 次元X格子点データ

     integer :: k

     x_IntZ_zx = 0.0d0
     do k=0,km
        x_IntZ_zx(:) = x_IntZ_zx(:) &
             + zx(k,:) * z_Z_Weight(k)
     enddo

   end function x_IntZ_zx

   function IntZX_zx(zx)  ! ZX積分
     !
     ! 2 次元(ZX)格子点データのZX積分
     !
     real(8), dimension(0:km,0:im-1), intent(in) :: zx
     !(in) 2 次元ZY格子点データ

     real(8)                                 :: IntZX_zx
     !(out) 積分値

     integer :: i, k

     IntZX_zx = 0
     do i=0,im-1
        do k=0,km
           IntZX_zx = IntZX_zx &
                + zx(k,i) * x_X_Weight(i) * z_Z_Weight(k)
        enddo
     enddo
   end function IntZX_zx

   !----(入力データ z)---
   function IntZ_z(z)  ! Z積分
     !
     ! 1 次元(Z)格子点データのZ方向積分.
     !
     real(8), dimension(0:km), intent(in) :: z
     !(in) 1 次元Z格子点データ

     real(8)                              :: IntZ_z
     !(out) 積分値

     integer :: k

     IntZ_z = 0.0d0
     do k=0,km
        IntZ_z = IntZ_z + z(k) * z_Z_Weight(k)
     enddo
   end function IntZ_z

   !--------------- 平均計算 -----------------
   !----(入力データ zyx)---
   function zy_AvrX_zyx(zyx)  ! X積分
     !
     ! 3 次元格子点データのX方向平均.
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
     !(in) 3 次元ZYX格子点データ

     real(8), dimension(0:km,0:jm-1)  :: zy_AvrX_zyx
     !(out) X方向平均された 2 次元子午面格子点データ

     zy_AvrX_zyx = zy_IntX_zyx(zyx)/sum(x_X_Weight)

   end function zy_AvrX_zyx

   function zx_AvrY_zyx(zyx)  ! Y平均
     !
     ! 3 次元格子点データのY方向域平均.
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
     !(in) 3 次元格子点データ

     real(8), dimension(0:km,0:im-1)  :: zx_AvrY_zyx
     !(out) Y平均された 2 次元ZX格子点データ

     zx_AvrY_zyx = zx_IntY_zyx(zyx)/sum(y_Y_Weight)

   end function zx_AvrY_zyx

   function yx_AvrZ_zyx(zyx)
     !
     ! 3 次元格子点データのZ方向平均.
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
     !(in) 3 次元格子点データ

     real(8), dimension(0:jm-1,0:im-1)  :: yx_AvrZ_zyx
     !(out) Z平均された 2 次元YX(水平)格子点データ

     yx_AvrZ_zyx = yx_IntZ_zyx(zyx)/sum(z_Z_Weight)

   end function yx_AvrZ_zyx

   function x_AvrZY_zyx(zyx)  ! ZY積分
     !
     ! 3 次元格子点データのZY平均
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
     !(in) 3 次元ZYX格子点データ

     real(8), dimension(0:im-1)     :: x_AvrZY_zyx
     !(out) ZY平均された 1 次元X格子点データ

     x_AvrZY_zyx = x_IntZY_zyx(zyx) &
          /( sum(y_Y_Weight)*sum(z_Z_Weight) )

   end function x_AvrZY_zyx

   function y_AvrZX_zyx(zyx)  ! ZX積分
     !
     ! 3 次元格子点データのZX平均.
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
     !(in) 3 次元格子点データ

     real(8), dimension(0:jm-1)       :: y_AvrZX_zyx
     !(out) ZX平均された 1 次元Y格子点データ

     y_AvrZX_zyx = y_IntZX_zyx(zyx) &
          /(sum(x_X_Weight)*sum(z_Z_Weight))

   end function y_AvrZX_zyx

   function z_AvrYX_zyx(zyx)  ! YX(水平)積分
     !
     ! 3 次元格子点データのYX(水平)積分
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
     !(in) 3 次元格子点データ

     real(8), dimension(0:km)     :: z_AvrYX_zyx
     !(out) YX(水平)平均された 1 次元Z格子点データ

     z_AvrYX_zyx = z_IntYX_zyx(zyx) &
          /(sum(x_X_Weight)*sum(y_Y_Weight))

   end function z_AvrYX_zyx

   function AvrZYX_zyx(zyx) ! ZYX(全領域)積分
     !
     ! 3 次元格子点データのZYX(全領域)積分
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx
     !(in) 3 次元ZYX格子点データ

     real(8)                     :: AvrZYX_zyx
     !(out) 全領域平均値

     AvrZYX_zyx = IntZYX_zyx(zyx) &
          /(sum(x_X_Weight)*sum(y_Y_Weight) * sum(z_Z_Weight))

   end function AvrZYX_zyx

   !----(入力データ zy)---
   function z_AvrY_zy(zy)
     !
     ! 2 次元(ZY)格子点データのY方向平均.
     !
     real(8), dimension(0:km,0:jm-1), intent(in) :: zy
     !(in) 2 次元ZY格子点データ

     real(8), dimension(0:km)  :: z_AvrY_zy
     !(out) Y平均された 1 次元Z格子点データ

     z_AvrY_zy = z_IntY_zy(zy)/sum(y_Y_Weight)

   end function z_AvrY_zy

   function y_AvrZ_zy(zy)
     !
     ! 2 次元(ZY)格子点データのZ方向平均.
     !
     real(8), dimension(0:km,0:jm-1), intent(in) :: zy
     !(in) 2 次元ZY格子点データ

     real(8), dimension(0:jm-1)  :: y_AvrZ_zy
     !(out) Z平均された 1 次元Y格子点データ

     y_AvrZ_zy = y_IntZ_zy(zy)/sum(z_Z_Weight)

   end function y_AvrZ_zy

   function AvrZY_zy(zy)  ! ZY平均
     !
     ! 2 次元(ZY)格子点データのZY平均
     !
     real(8), dimension(0:km,0:jm-1), intent(in) :: zy
     !(in) 2 次元ZY(子午面)格子点データ

     real(8)                   :: AvrZY_zy
     !(out) 平均値

     AvrZY_zy = IntZY_zy(zy)/(sum(y_Y_Weight)*sum(z_Z_Weight))

   end function AvrZY_zy

   !----(入力データ zx)---
   function z_AvrX_zx(zx)  ! X積分
     !
     ! 2 次元(ZX)格子点データのX方向平均.
     !
     real(8), dimension(0:km,0:im-1), intent(in) :: zx
     !(in) 2 次元ZY格子点データ

     real(8), dimension(0:km)  :: z_AvrX_zx
     !(out) X平均された 1 次元Z格子点データ

     z_AvrX_zx = z_IntX_zx(zx)/sum(x_X_Weight)

   end function z_AvrX_zx

   function x_AvrZ_zx(zx)  ! Z平均
     !
     ! 2 次元(ZX)格子点データのZ方向平均.
     !
     real(8), dimension(0:km,0:im-1), intent(in) :: zx
     !(in) 2 次元ZY格子点データ

     real(8), dimension(0:im-1)  :: x_AvrZ_zx
     !(out) Z平均された 1 次元X格子点データ

     x_AvrZ_zx = x_IntZ_zx(zx)/sum(z_Z_Weight)

   end function x_AvrZ_zx

   function AvrZX_zx(zx)  ! ZX積分
     !
     ! 2 次元(ZX)格子点データのZX平均
     !
     real(8), dimension(0:km,0:im-1), intent(in) :: zx
     ! (in) 2 次元格子点データ
     real(8)                                 :: AvrZX_zx
     ! 平均値

     AvrZX_zx = IntZX_zx(zx)/(sum(x_X_Weight)*sum(z_Z_Weight))

   end function AvrZX_zx

   !----(入力データ z)---
   function AvrZ_z(z)
     !
     ! 1 次元(Z)格子点データのZ方向平均.
     !
     real(8), dimension(0:km), intent(in) :: z
     !(in) 1 次元Z格子点データ
     real(8)                              :: AvrZ_z
     !(out) 平均値

     AvrZ_z = IntZ_z(z)/sum(z_Z_Weight)

   end function AvrZ_z


   !--------------- ポロイダル/トロイダルモデル用微分 -----------------
!!$   function wt_KxRGrad_wt(wt)
!!$     !
!!$     ! 入力スペクトルデータにX微分 k×r・▽ = ∂/∂λを作用する.
!!$     !
!!$     real(8), dimension(-lm:lm,-mm,mm,0:nm), intent(in) :: wt
!!$     !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$     real(8), dimension(-lm:lm,-mm,mm,0:nm)             :: wt_KxRGrad_wt
!!$     !(out) X微分を作用された 2 次元スペクトルデータ
!!$
!!$     wt_KxRGrad_wt =  wa_Dlon_wa(wt)
!!$
!!$   end function wt_KxRGrad_wt
!!$
!!$   function zyx_KGrad_wt(wt)    ! k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r
!!$     !
!!$     ! 入力スペクトルデータに対応する格子データに軸方向微分
!!$     !
!!$     !    k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r
!!$     !
!!$     ! を作用させた格子データが返される.
!!$     ! ここでベクトル k は球の中心から北極向きの単位ベクトルである.
!!$     !
!!$     real(8), dimension(-lm:lm,-mm,mm,0:nm), intent(in) :: wt
!!$     !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$     real(8), dimension(0:km,0:jm-1,0:im-1)                     :: yzx_KGrad_wt
!!$     !(out) 軸方向微分を作用された 2 次元スペクトルデータ
!!$
!!$     xzy_KGrad_wt =  cos(xyz_Y)*xyz_GradY_wt(wt) &
!!$          + sin(xyz_Y)*xyz_wt(wt_Drad_wt(wt))
!!$
!!$   end function zyx_KGrad_wt
!!$
!!$   function wt_L2_wt(wt)
!!$     !
!!$     ! 入力スペクトルデータに L^2 演算子(=-水平ラプラシアン)を作用する.
!!$     !
!!$     ! L^2 演算子は単位球面上の水平ラプラシアンの逆符号にあたる.
!!$     !  入力スペクトルデ ータに対応する格子点データに演算子
!!$     !
!!$     !     L^2 = -1/cos^2φ・∂^2/∂λ^2 - 1/cosφ・∂/∂φ(cosφ∂/∂φ)
!!$     !
!!$     ! を作用させたデータのスペクトル変換が返される.
!!$     !
!!$     real(8), dimension(-lm:lm,-mm,mm,0:nm), intent(in) :: wt
!!$     !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$     real(8), dimension(-lm:lm,-mm,mm,0:nm)             :: wt_L2_wt
!!$     !(out) L^2 演算子を作用された 2 次元スペクトルデータ
!!$
!!$     wt_L2_wt = -wa_Lapla_wa(wt)
!!$
!!$   end function wt_L2_wt
!!$
!!$   function wt_L2Inv_wt(wt)
!!$     !
!!$     ! 入力スペクトルデータに L^2 演算子の逆演算(-逆水平ラプラシアン)を
!!$     ! 作用する.
!!$     !
!!$     ! スペクトルデータに L^2 演算子を作用させる関数 wt_L2_wt の逆計算を
!!$     ! 行う関数である.
!!$     !
!!$     real(8), dimension(-lm:lm,-mm,mm,0:nm), intent(in) :: wt
!!$     !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$     real(8), dimension(-lm:lm,-mm,mm,0:nm)             :: wt_L2Inv_wt
!!$     !(out) L^2 演算子の逆演算を作用された 2 次元スペクトルデータ
!!$
!!$     wt_L2Inv_wt = -wa_LaplaInv_wa(wt)
!!$
!!$   end function wt_L2Inv_wt
!!$
!!$   function wt_QOperator_wt(wt)
!!$     !
!!$     ! 入力スペクトルデータに対応する格子点データに演算子
!!$     !
!!$     !    Q=(k・▽-1/2(L2 k・▽+ k・▽L2))
!!$     !
!!$     ! を作用させたデータのスペクトル変換が返される.
!!$     !
!!$     real(8), dimension(-lm:lm,-mm,mm,0:nm), intent(in) :: wt
!!$     !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$     real(8), dimension(-lm:lm,-mm,mm,0:nm)             :: wt_QOperator_wt
!!$     !(out) Q 演算子を作用された 2 次元スペクトルデータ
!!$
!!$     wt_QOperator_wt = &
!!$          wt_xyz(xyz_KGrad_wt(wt) - xyz_KGrad_wt(wt_L2_wt(wt))/2) &
!!$          - wt_L2_wt(wt_xyz(xyz_KGrad_wt(wt)))/2
!!$
!!$   end function wt_QOperator_wt

   function cee_ZRot_zyx_zyx(zyx_VX,zyx_VY)  ! z・(▽×v)
     !
     ! ベクトルの渦度とZベクトルの内積 z・(▽×v) を計算する.
     !
     ! 第 1, 2 引数(v[x], v[y])がそれぞれベクトルのX成分, Y成分を表す.
     !
     !    z・(▽×v) = ∂v[y]/∂x - ∂(v[x])/∂y
     !
     ! のスペクトル データが返される.
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VX
     !(in) ベクトルのX成分

     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VY
     !(in) ベクトルのY成分

     real(8), dimension(0:nm,-mm:mm,-lm:lm)     :: cee_ZRot_zyx_zyx
     !(out) ベクトルの渦度とZベクトルの内積

     cee_ZRot_zyx_zyx = cee_DX_cee(cee_zyx(zyx_VY)) &
          - cee_DY_cee(cee_zyx(zyx_VX))

   end function cee_ZRot_zyx_zyx

   function see_ZRot_zyx_zyx(zyx_VX,zyx_VY)  ! z・(▽×v)
     !
     ! ベクトルの渦度とZベクトルの内積 z・(▽×v) を計算する.
     !
     ! 第 1, 2 引数(v[x], v[y])がそれぞれベクトルのX成分, Y成分を表す.
     !
     !    z・(▽×v) = ∂v[y]/∂x - ∂(v[x])/∂y
     !
     ! のスペクトル データが返される.
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VX
     !(in) ベクトルのX成分

     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VY
     !(in) ベクトルのY成分

     real(8), dimension(nm,-mm:mm,-lm:lm)     :: see_ZRot_zyx_zyx
     !(out) ベクトルの渦度とZベクトルの内積

     see_ZRot_zyx_zyx = see_DX_see(see_zyx(zyx_VY)) &
          - see_DY_see(see_zyx(zyx_VX))

   end function see_ZRot_zyx_zyx

   function cee_ZRotRot_zyx_zyx_zyx(zyx_VX,zyx_VY,zyx_VZ)
     !
     ! ベクトル v に対して z・(▽×▽×v) を計算する.
     !
     ! 第 1, 2, 3 引数(v[x], v[y], v[z])がそれぞれベクトルのX成分,
     ! Y成分, Z成分を表す.
     !
     !    z・(▽×▽×v)  = ∂/∂z (∂v[x]/∂x + ∂(v[y])/∂y ) )
     !                    - ▽_H^2 v[z]
     !
     ! のスペクトルデータが返される.
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VX
     !(in) ベクトルのX成分

     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VY
     !(in) ベクトルのY成分

     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VZ
     !(in) ベクトルのZ成分

     real(8), dimension(0:nm,-mm:mm,-lm:lm)     :: cee_ZRotRot_zyx_zyx_zyx
     !(out) ベクトル v の z・(▽×▽×v)

     cee_ZRotRot_zyx_zyx_zyx = &
          cee_DZ_see(   see_DX_see(see_zyx(zyx_VX))   &
                      + see_DY_see(see_zyx(zyx_VY)) ) &
        - cee_LaplaH_cee(cee_zyx(zyx_VZ))

   end function cee_ZRotRot_zyx_zyx_zyx

   function see_ZRotRot_zyx_zyx_zyx(zyx_VX,zyx_VY,zyx_VZ)
     !
     ! ベクトル v に対して z・(▽×▽×v) を計算する.
     !
     ! 第 1, 2, 3 引数(v[x], v[y], v[z])がそれぞれベクトルのX成分,
     ! Y成分, Z成分を表す.
     !
     !    z・(▽×▽×v)  = ∂/∂z (∂v[x]/∂x + ∂(v[y])/∂y ) )
     !                    - ▽_H^2 v[z]
     !
     ! のスペクトルデータが返される.
     !
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VX
     !(in) ベクトルのX成分

     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VY
     !(in) ベクトルのY成分

     real(8), dimension(0:km,0:jm-1,0:im-1), intent(in) :: zyx_VZ
     !(in) ベクトルのZ成分

     real(8), dimension(nm,-mm:mm,-lm:lm)     :: see_ZRotRot_zyx_zyx_zyx
     !(out) ベクトル v の z・(▽×▽×v)

     see_ZRotRot_zyx_zyx_zyx = &
          see_DZ_cee(   cee_DX_cee(cee_zyx(zyx_VX))   &
                      + cee_DY_cee(cee_zyx(zyx_VY)) ) &
        - see_LaplaH_see(see_zyx(zyx_VZ))

   end function see_ZRotRot_zyx_zyx_zyx

   subroutine scee_Potential2Vector_cee_see(&
        zyx_VX,zyx_VY,zyx_VZ,cee_Torvel,see_Polvel)
     !
     ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
     !
     !     v = ▽x(Ψz) + ▽x▽x(Φz)
     !
     ! の各成分を計算する
     !
     real(8), dimension(0:km,0:jm-1,0:im-1)     :: zyx_VX
     !(out) ベクトル場のX成分

     real(8), dimension(0:km,0:jm-1,0:im-1)     :: zyx_VY
     !(out) ベクトル場のY成分

     real(8), dimension(0:km,0:jm-1,0:im-1)     :: zyx_VZ
     !(out) ベクトル場のZ成分

     real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: cee_Torvel
     !(in) トロイダルポテンシャル

     real(8), dimension(nm,-mm:mm,-lm:lm), intent(in)   :: see_Polvel
     !(in) ポロイダルポテンシャル

     zyx_VX = zyx_cee(   cee_DY_cee(cee_Torvel) &
                       + cee_DX_cee(cee_DZ_see(see_Polvel))  )
     zyx_VY = zyx_cee( - cee_DX_cee(cee_Torvel) &
                       + cee_DY_cee(cee_DZ_see(see_Polvel))  )
     zyx_VZ = -zyx_see(see_LaplaH_see(see_Polvel))

   end subroutine scee_Potential2Vector_cee_see

   subroutine scee_Potential2Vector_see_cee(&
        zyx_VX,zyx_VY,zyx_VZ,see_Torvel,cee_Polvel)
     !
     ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
     !
     !     v = ▽x(Ψz) + ▽x▽x(Φz)
     !
     ! の各成分を計算する
     !
     real(8), dimension(0:km,0:jm-1,0:im-1)     :: zyx_VX
     !(out) ベクトル場のX成分

     real(8), dimension(0:km,0:jm-1,0:im-1)     :: zyx_VY
     !(out) ベクトル場のY成分

     real(8), dimension(0:km,0:jm-1,0:im-1)     :: zyx_VZ
     !(out) ベクトル場のZ成分

     real(8), dimension(nm,-mm:mm,-lm:lm), intent(in)   :: see_Torvel
     !(in) トロイダルポテンシャル

     real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: cee_Polvel
     !(in) ポロイダルポテンシャル

     zyx_VX = zyx_see(   see_DY_see(see_Torvel) &
                       + see_DX_see(see_DZ_cee(cee_Polvel))  )
     zyx_VY = zyx_see( - see_DX_see(see_Torvel) &
                       + see_DY_see(see_DZ_cee(cee_Polvel))  )
     zyx_VZ = -zyx_cee(cee_LaplaH_cee(cee_Polvel))

   end subroutine scee_Potential2Vector_see_cee

   subroutine scee_Potential2Rotation_cee_see(&
        zyx_RotVX,zyx_RotVY,zyx_RotVZ,cee_Torvel,see_Polvel)
     !
     ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
     !
     !     v = ▽x(Ψz) + ▽x▽x(Φz)
     !
     ! に対して, その回転
     !
     !     ▽xv = ▽x▽x(Ψz) + ▽x▽x▽x(Φz) = ▽x▽x(Ψz) - ▽x((▽^2Φ)z)
     !
     ! を計算する.

     ! ベクトル場の回転
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(OUT) :: zyx_RotVX
     !(out) 回転のX成分

     real(8), dimension(0:km,0:jm-1,0:im-1), intent(OUT) :: zyx_RotVY
     !(out) 回転のY成分

     real(8), dimension(0:km,0:jm-1,0:im-1), intent(OUT) :: zyx_RotVZ
     !(out) 回転のZ成分

     ! 入力ベクトル場を表すポテンシャル
     real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: cee_Torvel
     !(in) トロイダルポテンシャル

     real(8), dimension(nm,-mm:mm,-lm:lm), intent(in)   :: see_Polvel
     !(in) ポロイダルポテンシャル


     call scee_Potential2Vector_see_cee(&
          zyx_RotVX,zyx_RotVY,zyx_RotVZ,-see_Lapla_see(see_Polvel),cee_Torvel)
     
   end subroutine scee_Potential2Rotation_cee_see

   subroutine scee_Potential2Rotation_see_cee(&
        zyx_RotVX,zyx_RotVY,zyx_RotVZ,see_Torvel,cee_Polvel)
     !
     ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
     !
     !     v = ▽x(Ψz) + ▽x▽x(Φz)
     !
     ! に対して, その回転
     !
     !     ▽xv = ▽x▽x(Ψz) + ▽x▽x▽x(Φz) = ▽x▽x(Ψz) - ▽x((▽^2Φ)z)
     !
     ! を計算する.

     ! ベクトル場の回転
     real(8), dimension(0:km,0:jm-1,0:im-1), intent(OUT) :: zyx_RotVX
     !(out) 回転のX成分

     real(8), dimension(0:km,0:jm-1,0:im-1), intent(OUT) :: zyx_RotVY
     !(out) 回転のY成分

     real(8), dimension(0:km,0:jm-1,0:im-1), intent(OUT) :: zyx_RotVZ
     !(out) 回転のZ成分

     ! 入力ベクトル場を表すポテンシャル
     real(8), dimension(nm,-mm:mm,-lm:lm), intent(in)   :: see_Torvel
     !(in) トロイダルポテンシャル

     real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: cee_Polvel
     !(in) ポロイダルポテンシャル


     call scee_Potential2Vector_cee_see(&
          zyx_RotVX,zyx_RotVY,zyx_RotVZ,-cee_Lapla_cee(cee_Polvel),see_Torvel)
     
   end subroutine scee_Potential2Rotation_see_cee

   !--------------- 補間計算 -----------------
   function Interpolate_cee(cee_data,x,y,z)
     !
     ! (x,y,z) における関数値を
     ! そのスペクトル係数 tee_data から補間計算する
     !
     real(8), intent(IN) :: cee_data(0:nm,-mm:mm,-lm:lm)  ! スペクトルデータ
     real(8), intent(IN) :: x                             ! 補間する位置(X)
     real(8), intent(IN) :: y                             ! 補間する位置(Y)
     real(8), intent(IN) :: z                             ! 補間する位置(Z)
     real(8) :: Interpolate_cee                           ! 補間した値

     Interpolate_cee = &
          Interpolate_ee(ee_e2(a_Interpolate_ac(e2a_aee(cee_data),z)),x,y)

   end function Interpolate_cee

   function Interpolate_see(see_data,x,y,z)
     !
     ! (x,y,z) における関数値を
     ! そのスペクトル係数 tee_data から補間計算する
     !
     real(8), intent(IN) :: see_data(nm,-mm:mm,-lm:lm)  ! スペクトルデータ
     real(8), intent(IN) :: x                           ! 補間する位置(X)
     real(8), intent(IN) :: y                           ! 補間する位置(Y)
     real(8), intent(IN) :: z                           ! 補間する位置(Z)
     real(8) :: Interpolate_see                         ! 補間した値

     Interpolate_see = &
          Interpolate_ee(ee_e2(a_Interpolate_as(e2a_aee(see_data),z)),x,y)

   end function Interpolate_see

   
   !--------------- ポロイダル/トロイダルモデル用スペクトル解析 ----------------
   
   function zee_ToroidalEnergySpectrum_cee(cee_TORPOT)
     !
     ! トロイダルポテンシャルから, トロイダルエネルギーの
     ! 水平 X 波数 l, Y  波数 m の各成分を計算する
     !
     !  * X 波数 l, Y 波数 m のトロイダルポテンシャルのスペクトル成分
     !    ψ(l,m,z)から水平 X 波数 l, Y 波数 m 成分のトロイダルエネルギー
     !    スペクトルは  (1/2)(l**2+m**2)|ψ(l,m,z)|^2  と計算される.
     !
     !  * 全てのエネルギースペクトル成分の和をZ積分したものが領域内での
     !    水平平均エネルギーに等しい.
     !
     real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: cee_TORPOT
     !(in) トロイダルポテンシャル

     real(8), dimension(0:km,-mm:mm,-lm:lm) :: zee_ToroidalEnergySpectrum_cee
     !(out) エネルギースペクトルトロイダル成分

     real(8), dimension(0:km,-mm:mm,-lm:lm) :: zee_Work
     integer :: l, m

     zee_Work = zee_cee(cee_Torpot)
     do l=-lm,lm
        do m=-mm,mm
           zee_ToroidalEnergySpectrum_cee(:,m,l) &
                = 0.5 * ((2*PI*l/xl)**2+(2*PI*m/yl)**2) &
                * ( zee_Work(:,m,l)**2 + zee_Work(:,-m,-l)**2 )
        enddo
     enddo

   end function zee_ToroidalEnergySpectrum_cee

   function zee_ToroidalEnergySpectrum_see(see_TORPOT)
     !
     ! トロイダルポテンシャルから, トロイダルエネルギーの
     ! 水平 X 波数 l, Y  波数 m の各成分を計算する
     !
     !  * X 波数 l, Y 波数 m のトロイダルポテンシャルのスペクトル成分
     !    ψ(l,m,z)から水平 X 波数 l, Y 波数 m 成分のトロイダルエネルギー
     !    スペクトルは  (1/2)(l**2+m**2)|ψ(l,m,z)|^2  と計算される.
     !
     !  * 全てのエネルギースペクトル成分の和をZ積分したものが領域内での
     !    水平平均エネルギーに等しい.
     !
     real(8), dimension(nm,-mm:mm,-lm:lm), intent(in) :: see_TORPOT
     !(in) トロイダルポテンシャル

     real(8), dimension(0:km,-mm:mm,-lm:lm) :: zee_ToroidalEnergySpectrum_see
     !(out) エネルギースペクトルトロイダル成分

     real(8), dimension(0:km,-mm:mm,-lm:lm) :: zee_Work
     integer :: l, m

     zee_Work = zee_see(see_Torpot)
     do l=-lm,lm
        do m=-mm,mm
           zee_ToroidalEnergySpectrum_see(:,m,l) &
                = 0.5 * ((2*PI*l/xl)**2+(2*PI*m/yl)**2) &
                * ( zee_Work(:,m,l)**2 + zee_Work(:,-m,-l)**2 )
        enddo
     enddo

   end function zee_ToroidalEnergySpectrum_see

!!$    function nz_ToroidalEnergySpectrum_wt(wt_TORPOT)
!!$      !
!!$      ! トロイダルポテンシャルから, トロイダルエネルギーの
!!$      ! 球面調和函数全波数の各成分を計算する.
!!$      !
!!$      !  * 全波数 n, 帯状波数 m のトロイダルポテンシャルのスペクトル成分
!!$      !    ψ(n,m,r)から全波数 n 成分のトロイダルエネルギースペクトルは
!!$      !    Σ[m=-n]^n(1/2)n(n+1)4πr^2ψ(n,m,r)^2 と計算される.
!!$      !
!!$      ! * 全てのエネルギースペクトル成分の和をZ積分したもの(r^2の重み無し)
!!$      !    が球殻内での全エネルギーに等しい.
!!$      !
!!$      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: wt_TORPOT
!!$      !(in) トロイダルポテンシャル
!!$
!!$      real(8), dimension(0:nm,0:km) :: nz_ToroidalEnergySpectrum_wt
!!$      !(out) エネルギースペクトルトロイダル成分
!!$
!!$      real(8), dimension((nm+1)*(nm+1),0:km) ::wz_DATA   ! 作業領域
!!$      integer :: n, m
!!$
!!$      wz_DATA = wz_wt(wt_TORPOT)
!!$      do n=0,nm
!!$         nz_ToroidalEnergySpectrum_wt(n,:) &
!!$              = 0.5 * n*(n+1)* (4*pi) * z_Z**2 &
!!$                * sum(wz_Data(l_nm(n,(/(m,m=-n,n)/)),:)**2,1)
!!$      enddo
!!$
!!$    end function nz_ToroidalEnergySpectrum_wt

    function zee_PoloidalEnergySpectrum_cee(cee_POLPOT)
      !
      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
      ! 水平 X 波数 l, Y 波数 m の各成分を計算する.
      !
      !  * X 波数 l, Y 波数 m のポロイダルポテンシャルのスペクトル成分
      !    φ(l,m,z)から X 波数 l, Y 波数 m 成分のポロイダルエネルギー
      !    スペクトルは
      !
      !      (1/2)(l**2+m**2){[dφ(n,m,z)/dz]^2 + (l**2+m**2)φ(n,m,z)^2}
      !
      !    と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和をZ積分したもの
      !    が水平平均エネルギーに等しい.
      !
      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: cee_POLPOT
      !(in) ポロイダルポテンシャル

      real(8), dimension(0:km,-nm:nm,-lm:lm) :: zee_PoloidalEnergySpectrum_cee
      !(out) エネルギースペクトルポロイダル成分


      real(8), dimension(0:km,-mm:mm,-lm:lm) :: zee_Data   ! 作業領域
      real(8), dimension(0:km,-mm:mm,-lm:lm) :: zee_DData  ! 作業領域
      integer :: l, m

      zee_Data = zee_cee(cee_POLPOT)
      zee_DData = zee_see(see_DZ_cee(cee_POLPOT))

      do l=-lm,lm
         do m=-mm,mm
            zee_PoloidalEnergySpectrum_cee(:,m,l) =                   &
                 + 0.5* ((2*pi*l/xl)**2+(2*pi*m/yl)**2)               &
                 *(   zee_DData(:,m,l)**2 + zee_DData(:,-m,-l)**2     &
                    + ((2*pi*l/xl)**2+(2*pi*m/yl)**2)                 &
                         *( zee_Data(:,m,l)**2 + zee_Data(:,-m,-l)**2))
         enddo
      enddo

    end function zee_PoloidalEnergySpectrum_cee

    function zee_PoloidalEnergySpectrum_see(see_POLPOT)
      !
      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
      ! 水平 X 波数 l, Y 波数 m の各成分を計算する.
      !
      !  * X 波数 l, Y 波数 m のポロイダルポテンシャルのスペクトル成分
      !    φ(l,m,z)から X 波数 l, Y 波数 m 成分のポロイダルエネルギー
      !    スペクトルは
      !
      !      (1/2)(l**2+m**2){[dφ(n,m,z)/dz]^2 + (l**2+m**2)φ(n,m,z)^2}
      !
      !    と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和をZ積分したもの
      !    が水平平均エネルギーに等しい.
      !
      real(8), dimension(nm,-mm:mm,-lm:lm), intent(in) :: see_POLPOT
      !(in) ポロイダルポテンシャル

      real(8), dimension(0:km,-nm:nm,-lm:lm) :: zee_PoloidalEnergySpectrum_see
      !(out) エネルギースペクトルポロイダル成分


      real(8), dimension(0:km,-mm:mm,-lm:lm) :: zee_Data   ! 作業領域
      real(8), dimension(0:km,-mm:mm,-lm:lm) :: zee_DData  ! 作業領域
      integer :: l, m

      zee_Data = zee_see(see_POLPOT)
      zee_DData = zee_cee(cee_DZ_see(see_POLPOT))

      do l=-lm,lm
         do m=-mm,mm
            zee_PoloidalEnergySpectrum_see(:,m,l) =                   &
                 + 0.5* ((2*pi*l/xl)**2+(2*pi*m/yl)**2)               &
                 *(   zee_DData(:,m,l)**2 + zee_DData(:,-m,-l)**2     &
                    + ((2*pi*l/xl)**2+(2*pi*m/yl)**2)                 &
                         *( zee_Data(:,m,l)**2 + zee_Data(:,-m,-l)**2))
         enddo
      enddo

    end function zee_PoloidalEnergySpectrum_see

!!$    function nz_PoloidalEnergySpectrum_wt(wt_POLPOT)
!!$      !
!!$      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
!!$      ! 球面調和函数全波数の各成分を計算する
!!$      !
!!$      !  * 全波数 n, 帯状波数 m のポロイダルポテンシャルのスペクトル成分
!!$      !    φ(n,m,r)から全波数 n 成分のポロイダルエネルギースペクトルは
!!$      !
!!$      !      Σ[m=-n]^n ((1/2)n(n+1)4πr^2{[d(rφ(n,m,r))/dr]^2
!!$      !                 + n(n+1)φ(n,m,r)^2}
!!$      !
!!$      !    と計算される.
!!$      !
!!$      !  * 全ての全波数に対してのエネルギースペクトル成分の和をZ積分したもの
!!$      !    (r^2の重み無し)が球殻内での全エネルギーに等しい.
!!$      !
!!$      real(8), dimension(0:nm,-mm:mm,-lm:lm), intent(in) :: wt_POLPOT
!!$      !(in) ポロイダルポテンシャル
!!$
!!$      real(8), dimension(0:nm,0:km) :: nz_PoloidalEnergySpectrum_wt
!!$      !(out) エネルギースペクトルポロイダル成分
!!$
!!$      real(8), dimension((nm+1)*(nm+1),0:km) ::wz_DATA1   ! 作業領域
!!$      real(8), dimension((nm+1)*(nm+1),0:km) ::wz_DATA2   ! 作業領域
!!$      integer :: n, m
!!$
!!$      wz_Data1 = wz_wt(wt_POLPOT)
!!$      wz_Data2 = wz_Z*wz_wt(wt_DZ_wt(wt_POLPOT)) &    ! d(rφ)/dr
!!$               + wz_wt(wt_POLPOT)                         ! = rdφ/dr+φ
!!$
!!$      do n=0,nm
!!$         nz_PoloidalEnergySpectrum_wt(n,:) = &
!!$              + 0.5* n*(n+1)* (4*pi) &
!!$              *( sum(wz_Data2(l_nm(n,(/(m,m=-n,n)/)),:)**2,1)  &
!!$                + n*(n+1)*sum(wz_Data1(l_nm(n,(/(m,m=-n,n)/)),:)**2,1) )
!!$      enddo
!!$
!!$    end function nz_PoloidalEnergySpectrum_wt

end module scee_module_fftj

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_module テストプログラム 
!      (トロイダルポロイダルポテンシャル, スペクトル)
!
!履歴  2009/12/22  竹広真一
!
program tee_module_spectrum_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=10       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: zyx_Torvel(0:km,0:jm-1,0:im-1)  ! 格子データ
  real(8)            :: zyx_Polvel(0:km,0:jm-1,0:im-1)  ! 格子データ

  real(8)            :: zyx_VX(0:km,0:jm-1,0:im-1)      ! 格子データ
  real(8)            :: zyx_VY(0:km,0:jm-1,0:im-1)      ! 格子データ
  real(8)            :: zyx_VZ(0:km,0:jm-1,0:im-1)      ! 格子データ

  real(8)            :: zee_Spectrum(0:km,-mm:mm,-lm:lm)! スペクトルデータ
  real(8)            :: zee_Ans(0:km,-mm:mm,-lm:lm)     ! スペクトルデータ

  real(8)            :: Ans

  integer            :: l=2, m=5

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  call MessageNotify('M','tee_module_spectrum_test', &
       'tee_module toroidal poloidal potential spectrum functions tests')

 !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call tee_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

 !------------------- zee_ToroidalEnergySpectrum_tee ----------------------
  zyx_Torvel = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)
  zyx_Polvel = 0.0D0

  call tee_Potential2Vector(zyx_VX,zyx_VY,zyx_VZ,&
       tee_zyx(zyx_Torvel),tee_zyx(zyx_Polvel))

  zee_Ans= 0.0D0
  zee_Ans(:,m,l) = ((l*pi)**2+(m*pi)**2)*((2*z_Z**2 -1)*0.25)**2/2
  zee_Ans(:,-m,-l) = zee_Ans(:,m,l)
  zee_Ans(:,-m,l) = ((l*pi)**2+(m*pi)**2)*((2*z_Z**2 -1)*0.25)**2/2
  zee_Ans(:,m,-l) = zee_Ans(:,-m,l)

  Ans = 0.5*IntZYX_zyx(zyx_VX**2 + zyx_VY**2 + zyx_VZ**2)

  zee_Spectrum=zee_ToroidalEnergySpectrum_tee(tee_zyx(zyx_Torvel))

  call AssertEqual(&
    message='zee_ToroidalEnergySpectrum_tee',                     &
    answer = zee_Ans,                                             &
    check = zee_SPectrum,                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='zee_ToroidalEnergySpectrum_tee(total)',              &
    answer = Ans,                                                 &
    check = (xmax-xmin)*(ymax-ymin)*IntZ_z(sum(sum(zee_Spectrum,3),2)),&
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !------------------- zee_PoloidalEnergySpectrum_tee ----------------------
  zyx_Torvel = 0.0D0
  zyx_Polvel = cos(l*pi*zyx_X) * cos(m*pi*zyx_Y) * (2*zyx_Z**2 -1)

  call tee_Potential2Vector(zyx_VX,zyx_VY,zyx_VZ,&
       tee_zyx(zyx_Torvel),tee_zyx(zyx_Polvel))

  zee_Ans= 0.0D0
  zee_Ans(:,m,l) = 0.5*( ((l*pi)**2+(m*pi)**2)*(4*z_Z*0.25)**2 &
                        +((l*pi)**2+(m*pi)**2)**2*((2*z_Z**2 -1)*0.25)**2 )
  zee_Ans(:,-m,-l) = zee_Ans(:,m,l)
                     
  zee_Ans(:,-m,l)= 0.5*( ((l*pi)**2+(m*pi)**2)*(4*z_Z*0.25)**2 &
                        +((l*pi)**2+(m*pi)**2)**2*((2*z_Z**2 -1)*0.25)**2 )
  zee_Ans(:,m,-l) = zee_Ans(:,-m,l)

  Ans = 0.5*IntZYX_zyx(zyx_VX**2 + zyx_VY**2 + zyx_VZ**2)

  zee_Spectrum=zee_PoloidalEnergySpectrum_tee(tee_zyx(zyx_Polvel))

  call AssertEqual(&
    message='zee_PoloidalEnergySpectrum_tee',                     &
    answer = zee_Ans,                                             &
    check = zee_SPectrum,                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='zee_PoloidalEnergySpectrum_tee(total)',              &
    answer = Ans,                                                 &
    check = (xmax-xmin)*(ymax-ymin)*IntZ_z(sum(sum(zee_Spectrum,3),2)),&
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','tee_module_spectrum_test', &
       'tee_module toroidal poloidal potential spectrum functions tests suceeded!')

end program tee_module_spectrum_test

!--
!----------------------------------------------------------------------
!     Copyright (c) 2002-2013 SPMDOEL Development Group
!----------------------------------------------------------------------
!表題  wa_base_module
!
!  spml/wa_base_module モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための 
!  モジュール wa_module の下部モジュールであり, スペクトル計算の
!  基本的な Fortran90 関数を提供する. 
!
!  球面上の 1 層モデル用 w_base_module モジュールを多層モデル用に
!  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!  対する変換が行える.
!
!  内部で ISPACK の SPPACK と SNPACK の Fortran77 サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
!
!  このモジュールを使うためには前もって w_base_initial を呼んで
!  切断波数, 格子点数の設定をしておく必要がある. 
!
!
!履歴  2002/02/02  竹広真一  多層用に改造
!      2002/03/30  竹広真一  モジュール名変更
!      2002/05/25  竹広真一  格子点座標を区別すべく命名法変更
!      2005/01/09  竹広真一  msgdmp -> MessageNotify に変更
!      2005/07/09  竹広真一  OPENMP 版変換ルーチンに対応
!                            バンク競合を避けるための作業配列追加
!      2005/07/10  竹広真一  OpenMP セットアップのメッセージ出力
!      2006/03/08  竹広真一  コメントを RDoc 用に修正
!      2007/11/21  竹広真一  初期化サブルーチンメッセージ出力
!      2008/05/31  竹広真一  初期化サブルーチン分離
!      2008/06/22  佐々木洋平 水平方向の格子点データ配列の始点を
!                              1 から 0 に変更
!      2008/06/28  佐々木洋平 コメントを RDoc 用に微修正
!      2008/07/07  竹広真一  配列最終次元の不定性を許容する変更
!      2008/12/29  竹広真一  xya_wa, wa_xya コメント修正
!      2009/01/09  竹広真一  wa_base_Initial メッセージに日付を追加
!      2009/01/29  佐々木洋平 コメントを RDoc 用に微修正
!      2009/07/30  竹広真一   作業領域をローカル変数に変更(for OpenMP)
!      2013/02/13  竹広真一  wa_StreamPotential2Vector,  
!                            wa_Vector2VorDiv 導入
!      2013/02/14  竹広真一  w_VectorCosLat2VorDiv 導入
!      2013/02/23  竹広真一  wa_base_Finalize 導入
!
!++
module wa_base_module
  !
  != wa_base_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/wa_base_module モジュールは球面上での流体運動を
  ! 球面調和函数を用いたスペクトル法によって数値計算するための 
  ! モジュール wa_module の下部モジュールであり, スペクトル計算の
  ! 基本的な Fortran90 関数を提供する. 
  !
  ! 球面上の 1 層モデル用 w_base_module モジュールを多層モデル用に
  ! 拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  ! 対する変換が行える.
  !
  ! 内部で ISPACK の SPPACK と SNPACK の Fortran77 サブルーチンを呼んでいる. 
  ! スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  ! ついては ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
  !
  ! このモジュールを使うためには前もって w_base_initial を呼んで
  ! 切断波数, 格子点数の設定をしておく必要がある. 
  !
  use dc_message
  use w_base_module, only : im, jm, nm, it, t, y, ip, p, r, ia, a, openmp, np,&
                            w_StreamPotential2Vector, &
                            w_Vector2VorDiv, w_VectorCosLat2VorDiv

  implicit none

  integer               :: km=16         ! 同時に処理する最大データ数(層の数)

  integer, allocatable  :: ipk(:,:)            ! 変換用配列(多層用)
  real(8), allocatable  :: pk(:,:), rk(:,:)    ! 変換用配列(多層用)

  integer               :: id=65, jd=33        ! xya_work の大きさ
  integer               :: iw                  ! ww, ws の大きさ

  logical               :: wa_base_initialize = .false. ! 初期化フラグ

  real(8), parameter    :: pi=3.14159265358979

  private

  public km                                    ! 層数
  public wa_base_Initial                       ! 初期化サブルーチン
  public wa_base_Finalize                      ! 終了処理

  public xya_wa, wa_xya                        ! 変換関数
  public wa_StreamPotential2Vector             ! 流線ポテンシャルから速度場計算
  public wa_Vector2VorDiv                      ! 速度場から渦度発散を計算
  public wa_VectorCosLat2VorDiv                ! 速度場から渦度発散を計算

  save km                                      ! 最大データ数(層数)を記憶
  save ipk, pk, rk                             ! 変換用配列を記憶
  save id, jd, iw                              ! 変換用配列の大きさ

  save wa_base_initialize                      ! 初期化フラグ

  contains
  !--------------- 初期化 -----------------
    subroutine wa_base_initial(k_in)
      ! 
      ! スペクトル変換の最大データ数(層数)を設定する.
      !
      ! このサブルーチンを単独で用いるのでなく, 
      ! 上位サブルーチン wa_Initial を使用すること.
      !
      integer,intent(in) :: k_in               !(in) 最大データ数(層数)

      km = k_in

      allocate(ipk(km,((nm+1)/2+nm+1)*2))      ! 変換用配列(多層用)
      allocate(pk(km,((nm+1)/2+nm+1)*jm))      ! 変換用配列(多層用)
      allocate(rk(km,((nm+1)/2*2+3)*(nm/2+1))) ! 変換用配列(多層用)

      if ( im/2*2 .eq. im ) then
         id = im+1 
      else
         id = im
      endif
      if ( openmp ) then
         jd = jm
      else if ( jm/2*2 .eq. jm ) then
         jd = jm+1
      else
         jd = jm
      endif

      if ( openmp ) then
         iw=km*(im+nm+1)*3*jm/2
         call MessageNotify('M','wa_base_Initial', &
              'OpenMP computation was set up.')
      else
         iw=km * max((nm+4)*(nm+3),jd*3*(nm+1),jd*im)
      endif

      call snkini(nm,jm,km,ip,p,r,ipk,pk,rk)

      wa_base_initialize = .true.

      call MessageNotify('M','wa_base_initial',&
           'wa_base_module (2013/02/23) is initialized')

    end subroutine wa_base_Initial

  !--------------- 基本変換 -----------------

    function xya_wa(wa_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
      !
      ! スペクトルデータから格子データへ変換する(多層用).
      !
      real(8), intent(in)   :: wa_data(:,:)
      !(in) スペクトルデータ((nm+1)*(nm+1),:)
      !
      real(8)               :: xya_wa(0:im-1,1:jm,size(wa_data,2))
      !(out) 格子点データ(0:im-1,1:jm,:)
      !
      integer, intent(in), optional  :: ipow
      !(in) 作用させる 1/cosφ の次数. 省略時は 0. 
      integer, intent(in), optional  :: iflag
      !(in) 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた正変換
      !    1 : 緯度微分を作用させた正変換
      !    2 : sinφを作用させた正変換
      !    省略時は 0.
      !
      integer, parameter  :: ipow_default  = 0
      integer, parameter  :: iflag_default = 0
      integer ipval, ifval
      integer k, i

      real(8) :: xya_work(id,jd,km)              ! 変換用配列
      real(8) :: q(km*((nm+1)/2+nm+1)*jm)        ! 作業配列(多層用)
      real(8) :: ws(iw),ww(iw)                   ! 作業用配列(多層用)
      real(8) :: wv(km*(nm+4)*(nm+3)*np)         ! 作業用配列(OPENMP用)

      logical :: first=.true.                    ! 初回判定スイッチ
      save first

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      if  ( size(wa_data,1) /= (nm+1)**2 ) then
         call MessageNotify('E','xya_wa','Size of 1st dimension invalid.')
      end if

      k=size(wa_data,2)
      if  ( k > km ) then
         call MessageNotify('E','xya_wa','Size of 2nd dimension invalid.')
      else  if ( openmp ) then
         if ( first ) then
            call MessageNotify('M','xya_wa', &
                 'OpenMP routine SNTSOG/SNPACK is used for spherical harmonic transformation.')
         endif
         call sntsog(nm,im,id,jm,k,wa_data,xya_work,&
              it,t,y,ipk(1:k,:),pk(1:k,:),rk(1:k,:),&
              ia,a,q,ws,ww,wv,ipval,ifval)
      else
         call snts2g(nm,im,id,jm,jd,k,wa_data, xya_work,&
              it,t,y,ipk(1:k,:),pk(1:k,:),rk(1:k,:),ia,a,q,ws,ww,ipval,ifval)
      endif

      do i=0,im-1
        xya_wa(i,1:jm,1:k) = xya_work(i+1,1:jm,1:k)
      enddo
      first = .false.

    end function xya_wa

    function wa_xya(xya_data,ipow,iflag) ! 格子点 -> 球面調和関数スペクトル
      !
      ! 格子データからスペクトルデータへ(正)変換する(多層用).
      !
      real(8), intent(in)   :: xya_data(0:,:,:)
      !(in) 格子点データ(0:im-1,1:jm,:)

      real(8)               :: wa_xya((nm+1)*(nm+1),size(xya_data,3))
      !(out) スペクトルデータ((nm+1)*(nm+1),:)

      integer, intent(in), optional  :: ipow
      !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

      integer, intent(in), optional  :: iflag
      ! 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた正変換
      !    1 : 緯度微分を作用させた正変換
      !    2 : sinφを作用させた正変換
      !  省略時は 0.

      integer, parameter  :: ipow_default  = 0      ! スイッチデフォルト値
      integer, parameter  :: iflag_default = 0      ! スイッチデフォルト値

      integer ipval, ifval
      integer i,k

      real(8) :: xya_work(id,jd,km)               ! 変換用配列
      real(8) :: q(km*((nm+1)/2+nm+1)*jm)         ! 作業配列(多層用)
      real(8) :: ws(iw),ww(iw)                    ! 作業用配列(多層用)
      real(8) :: wv(km*(nm+4)*(nm+3)*np)          ! 作業用配列(OPENMP用)

      logical :: first=.true.                     ! 初回判定スイッチ
      save first

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      if ( size(xya_data,1) /= im ) then
         call MessageNotify('E','wa_xya','Size of 1st dimension invalid.')
      endif

      if ( size(xya_data,2) /= jm ) then
         call MessageNotify('E','wa_xya','Size of 2nd dimension invalid.')
      endif

      k = size(xya_data,3)
      if ( k > km ) then
         call MessageNotify('E','wa_xya','Size of 3rd dimension invalid.')
      endif

      do i=0,im-1
        xya_work(i+1,1:jm,1:k) = xya_data(i,1:jm,1:k)
      enddo

      if ( openmp ) then
         if ( first ) then
            call MessageNotify('M','wa_xya', &
                 'OpenMP routine SNTGOS/SNPACK is used for spherical harmonic transformation.')
         endif
         call sntgos(nm,im,id,jm,k,xya_work,wa_xya,&
              it,t,y,ipk(1:k,:),pk(1:k,:),rk(1:k,:),&
              ia,a,q,ws,ww,wv,ipval,ifval)
      else
         call sntg2s(nm,im,id,jm,jd,k,xya_work,wa_xya,&
              it,t,y,ipk(1:k,:),pk(1:k,:),rk(1:k,:),ia,a,q,ws,ww,ipval,ifval)
      endif
      first = .false.

    end function wa_xya

  !----------- 速度, 渦度・発散, 流線・ポテンシャル計算 -------------

    subroutine wa_StreamPotential2Vector(wa_Psi, wa_Chi, xya_U, xya_V)
      !
      ! 流線・ポテンシャル(スペクトルデータ)から速度場(格子データ)に
      ! (逆)変換する(多層用)
      !
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   u cosφ =      ∂χ/∂λ - cosφ∂ψ/∂φ, 
      !   v cosφ = cosφ∂χ/∂φ +      ∂ψ/∂λ 
      !
      real(8), intent(in)   :: wa_Psi(:,:)
      !(in) 流線関数((nm+1)*(nm+1),:)

      real(8), intent(in)   :: wa_Chi(:,:)
      !(in) 速度ポテンシャル((nm+1)*(nm+1),:)

      real(8), intent(out)   :: xya_U(0:im-1,1:jm,size(wa_Psi,2))
      !(out) 速度経度成分(0:im-1,1:jm,:)

      real(8), intent(out)   :: xya_V(0:im-1,1:jm,size(wa_Psi,2))
      !(out) 速度緯度成分(0:im-1,1:jm,:)

      integer :: k

      do k=1,size(wa_Psi,2)
         call w_StreamPotential2Vector &
              ( wa_Psi(:,k), wa_Chi(:,k), xya_U(:,:,k), xya_V(:,:,k) )
      enddo

    end subroutine wa_StreamPotential2Vector

    subroutine wa_Vector2VorDiv(xya_U, xya_V, wa_Vor, wa_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(多層用)
      ! 
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xya_U(0:,:,:)
      !(in) 速度経度成分(0:im-1,1:jm,:)

      real(8), intent(in)   :: xya_V(0:,:,:)
      !(in) 速度緯度成分(0:im-1,1:jm,:)

      real(8), intent(out)   :: wa_Vor((nm+1)*(nm+1),size(xya_U,3))
      !(out) 流線関数
      real(8), intent(out)   :: wa_Div((nm+1)*(nm+1),size(xya_U,3))
      !(out) 速度ポテンシャル

      integer :: k

      do k=1,size(xya_U,3)
         call w_Vector2VorDiv &
               (xya_U(:,:,k), xya_V(:,:,k), wa_Vor(:,k), wa_Div(:,k))
      enddo
    end subroutine wa_Vector2VorDiv

    subroutine wa_VectorCosLat2VorDiv(xya_UCosLat, xya_VCosLat, wa_Vor, wa_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(多層用)
      ! 
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ. 
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ 
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xya_UCosLat(0:,:,:)
      !(in) 速度経度成分 * cos(lat) (0:im-1,1:jm,:)

      real(8), intent(in)   :: xya_VCosLat(0:,:,:)
      !(in) 速度緯度成分 * cos(lat) (0:im-1,1:jm,:) 

      real(8), intent(out)   :: wa_Vor((nm+1)*(nm+1),size(xya_UCosLat,3))
      !(out) 流線関数
      real(8), intent(out)   :: wa_Div((nm+1)*(nm+1),size(xya_UCosLat,3))
      !(out) 速度ポテンシャル

      integer :: k

      do k=1,size(xya_UCosLat,3)
         call w_VectorCosLat2VorDiv &
               (xya_UCosLat(:,:,k), xya_VCosLat(:,:,k), wa_Vor(:,k), wa_Div(:,k))
      enddo
    end subroutine wa_VectorCosLat2VorDiv

  !--------------- 終了処理 -----------------
    subroutine wa_base_Finalize
      ! 
      ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
      !
      ! このサブルーチンを単独で用いるのでなく, 
      ! 上位サブルーチン wa_Finalize を使用すること.
      !
      if ( .not. wa_base_initialize ) then
          call MessageNotify('W','wa_base_Finalize',&
               'wa_base_module not initialized yet')
          return
      endif

      deallocate(ipk)      ! 変換用配列(多層用)
      deallocate(pk)       ! 変換用配列(多層用)
      deallocate(rk)       ! 変換用配列(多層用)

      call MessageNotify('M','wa_base_finalize',&
           'wa_base_module (2013/02/23) is finalized')

    end subroutine wa_base_Finalize

  end module wa_base_module

!------------------------------------------------------------------------
! COPYRIGHT (c) 2007-2010 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  au_module テストプログラム
!
!履歴  2007/12/28  竹広真一
!      2008/01/05  竹広真一  g_Dr2_u のテスト追加
!      2010/12/21  佐々木洋平 dc_test を使用するように修正
!
program au_test_base1d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use au_module
  implicit none
  integer, parameter :: im=32, km=32
  real(8), parameter :: ra=2.0D0
  real(8), dimension(0:im) :: g_z
  real(8), dimension(0:km) :: u_z_sol
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','au_test_base1d','au_module 1-dim function tests')

  call au_initial(im,km,ra,(/0/))

  call MessageNotify('M','au_test_base1d', 'Test1: T_1(2*r**2/a**2 - 1)')

  g_z = 2*(g_R/ra)**2 - 1
  u_z_sol = 0.0D0 ; u_z_sol(1) = 1.0D0

  call AssertEqual(&
    message='u_g(g_z)',                                           &
    answer = u_z_sol,                                             &
    check = u_g(g_z),                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='g_u(u_g(g_z))',                                      &
    answer = g_z,                                                 &
    check = g_u(u_g(g_z)),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='g_dr_u(u_g(g_z))',                                   &
    answer = 4.0d0*g_R/ra**2,                                     &
    check = g_Dr_u(u_g(g_z)),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','au_test_base1d', 'Test1: OK')

  call MessageNotify('M','au_test_base1d', 'Test2: T_2(2*r**2/a**2 - 1) - 1')

  g_z = 2.0d0*(2.0d0*g_R**2/ra**2 - 1.0d0)**2 - 1.0d0
  u_z_sol = 0.0d0 ;  u_z_sol(2) = 1.0d0

  call AssertEqual(&
    message='u_g(g_z)',                                           &
    answer = u_z_sol,                                             &
    check = u_g(g_z),                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='g_u(u_g(g_z))',                                      &
    answer = g_z,                                                 &
    check = g_u(u_g(g_z)),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='g_dr_u(u_g(g_z))',                                   &
    answer = 16.0d0*g_R/ra**2*(2*g_R**2/ra**2-1),                 &
    check = g_Dr_u(u_g(g_z)),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='g_dr2_u(u_g(g_z))',                                  &
    answer = 96.0d0*g_R**2/ra**4 - 16.0d0/ra**2 ,                 &
    check = g_Dr2_u(u_g(g_z)),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','au_test_base1d', 'Test2: OK')

  call MessageNotify('M','au_test_base1d','au_module 1-dim test suceeded!')

end program au_test_base1d

!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  eee_mpi_module テストプログラム (正逆変換)
!
!履歴  2008/05/21  竹広真一
!
program eee_mpi_test_gatherv

  use dc_message, only : MessageNotify
  use eee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=32          ! 格子点の設定(X,Y,Z)
  integer, parameter :: lm=10, mm=10, nm=10          ! 切断波数の設定(X,Y,Z)

 !---- 変数 ----
  real(8), allocatable :: zxv_Data(:,:,:)            ! 格子データ
  real(8), allocatable :: xyz_Data(:,:,:)            ! 格子データ

  integer            :: l=5,m=3,n=2
  integer            :: np, ip, ierr
  integer            :: i, j, k

 !---- 座標変数など ----
  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: eps = 1.0d-10            ! 判定誤差

  call MessageNotify('M','eee_mpi_test_transform', &
       'eee_module transform function tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

 !---------------- 座標値の設定 ---------------------
  call eee_mpi_initial(im,jm,km,lm,mm,nm)

 !---------------- 変数の割付け ---------------------
  allocate(zxv_Data(0:km-1,0:im-1,js(ip):je(ip)))
  allocate(xyz_Data(0:im-1,0:jm-1,0:km-1))

 !------------------- 初期値設定 ----------------------
  write(6,*) '*** Test of eee_mpi_module : grid -> grid transformation check.'
  write(6,*) '  The result will be printed '
  write(6,*) '  only when the error is larger than ', eps
  write(6,*)

!!$  write(6,*) '  Input wavenumbers of the grid data, l,m and n :'
!!$  read(5,*) l,m,n
!!$  write(6,*) '  l,m,n = ', l,m,n

  zxv_Data = sin(l*zxv_X) * sin(m*zxv_Y) * sin(n*zxv_Z)

  do k=0,km-1
     do j=0,jm-1
        do i=0,im-1
           xyz_Data(i,j,k) = &
                sin(l*(2*pi/im*i))*sin(m*(2*pi/jm*j))*sin(n*(2*pi/km*k))
        enddo
     enddo
  enddo

  call check3d((xyz_zxv(zxv_Data))-xyz_Data, eps, &
       'Data gathering of sin(l*X)*sin(m*Y)**sin(n*Z)')


  call MPI_FINALIZE(IERR)

 stop
contains

  subroutine check3d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:,:)              ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    character(len=3) ::cip
    integer i, j, k

    if ( present(funcname) )then
       write(cip,'(I3)') IP
       write(6,*) '  Checking ', funcname, ' for IP='//trim(adjustl(cip))
    endif

    do k=1,size(var,3)
       do j=1,size(var,2)
          do i=1,size(var,1)
             if (abs(var(i,j,k)) .gt. eps ) then
                write(6,*) &
                  '    Value larger than EPS : i= ', i, '  j= ', j, '  k= ', k, &
                  var(i,j,k)
                call MessageNotify('E','eee_mpi_test_transform', &
                  'transform error too large')
             endif
          enddo
       enddo
    enddo
  end subroutine check3d

end program eee_mpi_test_gatherv

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_zonal_module_sjpack テストプログラム
!
!      微分のテスト
!  
!履歴  2009/09/26  竹広真一  wt_module_sjpack_deriv_test1.f90 を改造
!
program wt_zonal_module_sjpack_deriv1

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wt_zonal_module_sjpack
  implicit none

  integer,parameter  :: im=1, jm=16, km=16   ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Data
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_DData

  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_GradLon
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_GradLat
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_DivLon
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_DivLat
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VLon
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VLat
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VRad
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Div
  real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_Psi


  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer, parameter :: nmin=1, nmax=9

  integer :: n

  call MessageNotify('M','wt_zonal_module_sjpack_deriv1_test', &
       'wt_zonal_module_sjpack derivative function test #1')

  call wt_Initial(im,jm,km,nm,lm,ri,ro)

  !==================== wt_DivRad_wt ====================
  do n=nmin,nmax
     write(6,*) 'n=',n
     xyz_Data = xyz_Rad**n
     xyz_DData = (n+2)*xyz_Rad**(n-1)

     call AssertEqual(&
       message='wt_Divrat_wt with r^n',                              &
       answer = xyz_DData,                                           &
       check = xyz_wt(wt_DivRad_wt(wt_xyz(xyz_Data))),               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  enddo

  !========== xyz_GradLon_wt, xyz_GradLat_wt, wt_Div_xyz_xyz_xyz ==========

  ! ------ r^2 Y_1^0 Toridal field -----
  n = 2
  xyz_VRad = 0.0D0
  xyz_Psi = xyz_Rad**n * sin(xyz_Lat)   ! r**2 P_1^0

  xyz_GradLon =  0.0D0
  call AssertEqual(&
       message='xyz_GradLon_wt with r^2 Y_1^0',                     &
       answer = xyz_GradLon,                                         &
       check = xyz_GradLon_wt(wt_xyz(xyz_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_GradLat =  xyz_Rad**(n-1)*cos(xyz_Lat)
  call AssertEqual(&
       message='xyz_GradLat_wt with r^2 Y_1^0',                     &
       answer = xyz_GradLat,                                         &
       check = xyz_GradLat_wt(wt_xyz(xyz_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_VLon =  xyz_GradLon_wt(wt_xyz(xyz_Psi))
  xyz_VLat =  xyz_GradLat_wt(wt_xyz(xyz_Psi))
  xyz_VRad = 0.0D0

  xyz_Div = - 2.0D0* xyz_Psi/xyz_Rad**2.0D0

  call AssertEqual(&
       message='wt_Div_xyz_xyz_xyz_wt with Toroiral r^2 Y_1^0',     &
       answer = xyz_Div,                                             &
       check = xyz_wt(wt_Div_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! ------ r^2Y_2^0 Toridal field -----
  xyz_Psi = xyz_Rad**n * (3.0D0/2.0D0*sin(xyz_Lat)**2 - 1.0D0/2.0D0)  ! P_2^0

  xyz_GradLon =  0.0D0
  call AssertEqual(&
       message='xyz_GradLon_wt with r^2 Y_2^0',                      &
       answer = xyz_GradLon,                                         &
       check =  xyz_GradLon_wt(wt_xyz(xyz_Psi)),                     &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_GradLat =  xyz_Rad**(n-1)*3*sin(xyz_Lat)*cos(xyz_Lat)
  call AssertEqual(&
       message='xyz_GradLat_wt with r^2 Y_2^0',                      &
       answer = xyz_GradLat,                                         &
       check = xyz_GradLat_wt(wt_xyz(xyz_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xyz_VLon =  xyz_GradLon_wt(wt_xyz(xyz_Psi))
  xyz_VLat =  xyz_GradLat_wt(wt_xyz(xyz_Psi))
  xyz_VRad = 0.0D0

  xyz_Div = - 6* xyz_Psi/xyz_Rad**2

  call AssertEqual(&
       message='wt_Div_xyz_xyz_xyz_wt with Toroiral r2 Y_1^0',       &
       answer = xyz_Div,                                             &
       check = xyz_wt(wt_Div_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !==================== wt_DivLon_xyz, wt_DivLat_xyz ====================
  n=2
  write(6,*)'n =',n

  xyz_VLon   = xyz_rad**n * sin(xyz_Lat)*cos(xyz_Lat)
  xyz_DivLon = 0.0D0

  xyz_VLat   = xyz_rad**n * sin(xyz_Lat)*cos(xyz_Lat)
  xyz_DivLat = xyz_rad**(n-1)*(cos(xyz_Lat)**2-2*sin(xyz_Lat)**2)

  call AssertEqual(&
       message='wt_DivLon_xyz with r^n cosφ sinφ',              &
       answer = xyz_DivLon,                                          &
       check = xyz_wt(wt_DivLon_xyz(xyz_VLon)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wt_DivLat_xyz with r^n cosφ sinφ',              &
       answer = xyz_DivLat,                                          &
       check = xyz_wt(wt_DivLat_xyz(xyz_VLat)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','wt_zonal_module_sjpack_deriv1_test', &
       'wt_zonal_module_sjpack derivative function test #1 succeeded!')

end program wt_zonal_module_sjpack_deriv1

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_wave_module_svpack テストプログラム
!
!      トロイダルポロイダル関係微分関数のテスト
!  
!履歴  2017/03/09  竹広真一  wt_wave_module_sjpack_derivative_test2.f90 より改造
!
program wt_wave_module_svpack_derivative_test2

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wt_wave_module_svpack
  implicit none

  integer,parameter  :: im=2,  jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  integer,parameter  :: m=1                  ! 東西波数の設定
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  real(8), dimension(0:im-1,jm,0:km)     :: xyz_DData
  real(8), dimension(0:im-1,jm,0:km)     :: xyz_Psi
  real(8), dimension(2*(nm-m+1),0:lm)    :: wt_Psi
  real(8), dimension(2*(nm-m+1),0:lm)    :: wt_Phi

  real(8), dimension(0:im-1,jm,0:km)     :: xyz_VLon
  real(8), dimension(0:im-1,jm,0:km)     :: xyz_VLat
  real(8), dimension(0:im-1,jm,0:km)     :: xyz_VRad
  real(8), dimension(0:im-1,jm,0:km)     :: xyz_RadRot
  real(8), dimension(0:im-1,jm,0:km)     :: xyz_RadRotRot

  integer, parameter :: n=2
  integer :: j

  call MessageNotify('M','wt_wave_module_svpack_derivative_test2', &
       'wt_wave_module_svpack derivative function test #2')

  call wt_initial(im,jm,km,nm,m,lm,ri,ro)

  !========== wt_KxRGrad_wt, xyz_KGrad_wt, wt_QOperator_wt ==========

  ! ----------------- 例 1 --------------------
  xyz_Psi = xyz_rad**n * cos(xyz_Lat)   ! r**2 P_1^1

  do j=1,jm
     xyz_DData(0,j,:) = -m*z_Rad**n * cos(y_Lat(j))
     xyz_DData(1,j,:) =  m*z_Rad**n * cos(y_Lat(j))
  enddo
  call AssertEqual(&
       message='wt_KxRGrad_wt with r^2 P_1^1',                     &
       answer = xyz_DData,                                           &
       check = xyz_wt(wt_KxRGrad_wt(wt_xyz(xyz_Psi))),           &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! k ・▽ r**n Y_1^1 = (n-1)*r**(n-1)* Y_2^1
  xyz_DData = (n-1)*xyz_Rad**(n-1)* cos(xyz_Lat)*sin(xyz_Lat)
  call AssertEqual(&
       message='xyz_KGrad_wt with r^2 P_1^1',                       &
       answer = xyz_DData,                                           &
       check = xyz_KGrad_wt(wt_xyz(xyz_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  ! Q r**n Y_1^1 = -3*(n-1)*r**(n-1)* Y_2^1
  xyz_DData = - 3*(n-1)*xyz_Rad**(n-1)* cos(xyz_Lat)*sin(xyz_Lat)
  call AssertEqual(&
       message='wt_QOperator_wt r^2 P_1^1',                        &
       answer = xyz_DData,                                           &
       check = xyz_wt(wt_QOperator_wt(wt_xyz(xyz_Psi))),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

! ----------------- 例 2 --------------------
  xyz_Psi = cos(xyz_Lat)*sin(xyz_Lat) ! P_2^1

  do j=1,jm
     xyz_DData(0,j,:) = -m*cos(y_Lat(j))*sin(y_Lat(j)) ! P_2^1
     xyz_DData(1,j,:) =  m*cos(y_Lat(j))*sin(y_Lat(j)) ! P_2^1
  enddo
  call AssertEqual(&
       message='wt_KxRGrad_wt with P_2^1',                         &
       answer = xyz_DData,                                         &
       check = xyz_wt(wt_KxRGrad_wt(wt_xyz(xyz_Psi))),             &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! k・▽ Y_2^1 = (- 4 Y_3^1 / 15 - Y_1^1 /5) 
  xyz_DData = cos(2*xyz_Lat)*cos(xyz_Lat)/xyz_rad
  call AssertEqual(&
       message='xyz_KGrad_wt with P_2^1',                           &
       answer = xyz_DData,                                          &
       check = xyz_KGrad_wt(wt_xyz(xyz_Psi)),                       &
       significant_digits = check_digits, ignore_digits = ignore    &
       )

  xyz_DData = (16*sin(xyz_Lat)**2 - 5)*cos(xyz_lat)/xyz_rad
  call AssertEqual(&
       message='wt_QOperator_wt P_2^1',                            &
       answer = xyz_DData,                                         &
       check = xyz_wt(wt_QOperator_wt(wt_xyz(xyz_Psi))),           &
       significant_digits = check_digits, ignore_digits = ignore   &
       )


  !========== wt_RadRot_xyz_xyz, wt_RadRotRot_xyz_xyz_xyz ==========

  !--------- 鉛直渦度を伴うベクトル場 ----------
  xyz_Psi = xyz_Rad**2 * cos(xyz_Lat)   ! r**2 P_1^1
  !xyz_Psi = xyz_Rad**2 * cos(xyz_Lat)*sin(xyz_Lat)   ! r**2 P_2^1

  xyz_VLon =   xyz_GradLat_wt(wt_xyz(xyz_Psi*xyz_Rad))
  xyz_VLat = - xyz_GradLon_wt(wt_xyz(xyz_Psi*xyz_Rad))
  xyz_VRad = 0
  xyz_RadRot = 2 * xyz_Psi                           ! r・▽×▽×(ψr) = L_2ψ
  !xyz_RadRot = 6 * xyz_Psi                           ! r・▽×▽×(ψr) = L_2ψ
  xyz_RadRotRot = 0

  call AssertEqual(&
      message='wt_RadRot_xyz_xyz with r^2 P_1^1 toroidal field',    &
       answer = xyz_RadRot,                                          &
       check = xyz_wt(wt_RadRot_xyz_xyz(xyz_VLon,xyz_VLat)),       &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wt_RadRotRot_xyz_xyz with r^2 P_1^1 toroidal field',&
       answer = xyz_RadRotRot,                                       &
       check = xyz_wt(wt_RadRotRot_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !---------- 鉛直速度を伴うベクトル場 -----------
  xyz_VRad = xyz_wt(wt_L2_wt(wt_xyz(xyz_Psi/xyz_Rad)))
  xyz_VLat = xyz_GradLat_wt(wt_DRad_wt(wt_xyz(xyz_Psi*xyz_Rad)))
  xyz_VLon = xyz_GradLon_wt(wt_DRad_wt(wt_xyz(xyz_Psi*xyz_Rad)))

  xyz_RadRot = 0
  xyz_RadRotRot = -xyz_wt(wt_L2_wt(wt_Lapla_wt(wt_xyz(xyz_Psi))))
                 ! r・▽×▽×▽×▽×(ψr) = -L_2▽^2ψ

  call AssertEqual(&
      message='wt_RadRot_xyz_xyz with non-vortical field',          &
       answer = xyz_RadRot,                                          &
       check = xyz_wt(wt_RadRot_xyz_xyz(xyz_VLon,xyz_VLat)),       &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='wt_RadRotRot_xyz_xyz_xyz with non-vortical field',  &
       answer = xyz_RadRotRot,                                       &
       check = xyz_wt(wt_RadRotRot_xyz_xyz_xyz(xyz_VLon,xyz_VLat,xyz_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  !========== wt_Potential2Vector, wt_Potential2Rotation ==========

  ! ----------------- 例 4 --------------------
  ! ポロイダル速度場

  wt_Psi = 0.0D0
  wt_Phi = wt_xyz(xyz_Rad**2 * cos(xyz_Lat))

  call wt_Potential2Vector(&
       xyz_VLon,xyz_VLat,xyz_VRad,wt_Psi, wt_Phi )

  do j=1,jm
     xyz_DData(0,j,:) = -m * 3 * z_Rad
     xyz_DData(1,j,:) =  m * 3 * z_Rad
  enddo
  call AssertEqual(&
      message='wt_Potential2Vector (Lon) with poloidal field',       &
       answer = xyz_VLon,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = - 3 * xyz_Rad * sin(xyz_Lat)
  call AssertEqual(&
      message='wt_Potential2Vector (Lat) with poloidal field',       &
       answer = xyz_VLat,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 2 * xyz_Rad * cos(xyz_Lat)
  call AssertEqual(&
      message='wt_Potential2Vector (Rad) with poloidal field',      &
      answer = xyz_VRad,                                            &
      check = xyz_DData,                                            &
      significant_digits = check_digits, ignore_digits = ignore     &
       )

  call wt_Potential2Rotation(&
       xyz_VLon,xyz_VLat,xyz_VRad, wt_Psi, wt_Phi )

  xyz_DData = 4*sin(xyz_Lat)
  call AssertEqual(&
      message='wt_Potential2Rotation (Lon) with poloidal field',     &
       answer = xyz_VLon,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  do j=1,jm
     xyz_DData(0,j,:) = -m*4
     xyz_DData(1,j,:) =  m*4
  enddo
  call AssertEqual(&
      message='wt_Potential2Rotation (Lat) with poloidal field',     &
       answer = xyz_VLat,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  xyz_DData = 0.0D0
  call AssertEqual(&
      message='wt_Potential2Rotation (Rad) with poloidal field',     &
       answer = xyz_VRad,                                            &
       check = xyz_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','wt_module_svpack_derivative_test2', &
       'wt_module_svpack derivative function test #2 succeeded!')

end program wt_wave_module_svpack_derivative_test2

!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wt_module テストプログラム
!
!      磁場トロイダルポテンシャルの境界値問題
!
!履歴  2008/12/30  竹広真一
!
program wt_zonal_test_tormagbc

  use dc_message, only : MessageNotify
  use wt_zonal_module

  implicit none

  integer,parameter  :: im=1, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16        ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5      ! 内外半径

  real(8), dimension(0:im-1,1:jm,0:km)           :: xyz_TORMAG
  real(8), dimension(nm+1,0:lm)   :: wt_TORMAG

  real(8), parameter  :: pi=3.1415926535897932385D0
  real(8), parameter  :: eps=1D-10

  integer :: i,j 

  call MessageNotify('M','wt_zonal_test_tormagbc', &
       'wt_zonal_module  wt_TormagBoundaries subroutine test')

  write( 6,* ) 
  write( 6,* ) 'Output is displayed if computational error is larger than',eps

  call wt_initial(im,jm,km,nm,lm,ri,ro)

 !==================== wt_TormagBoundaries =========================
  ! P_10
  xyz_TORMAG = sin(xyz_lat) * cos( pi*(xyz_rad-ri)/(ro-ri) )
  ! P_1_1
  !xyz_TORMAG = cos(xyz_lat)*cos(xyz_lon)* cos( pi*(xyz_rad-ri)/(ro-ri) )
  !xyz_TORMAG = 2*sin(xyz_lat)**2 * cos( pi*(xyz_rad-ri)/(ro-ri) )

  wt_TORMAG = wt_xyz(xyz_TORMAG)
  call wt_TormagBoundaries(wt_TORMAG)
  xyz_TORMAG = xyz_wt(wt_TORMAG)

  do j=1,jm
     do i=0,im-1
        if ( abs(xyz_TORMAG(i,j,0)) > eps ) then
           write(6,*) 'Top B.C. : ', i,j,xyz_TORMAG(i,j,0)
           call MessageNotify('E','wt_test_tormagbc',&
                              'Top B.C. error too large')
        endif
        if ( abs(xyz_TORMAG(i,j,km)) > eps ) then
           write(6,*) 'Bottom B.C. : ', i,j,xyz_TORMAG(i,j,km)
           call MessageNotify('E','wt_test_tormagbc',&
                              'Bottom B.C. error too large')
        endif
     enddo
  enddo

  call MessageNotify('M','wt_test_tormagbc', &
       'wt_TormagBoundaries test succeeded!')

 !==================== wt_TormagBoundariesGrid =========================
  ! P_10
  xyz_TORMAG = sin(xyz_lat) * cos( pi*(xyz_rad-ri)/(ro-ri) )
  ! P_1_1
  !xyz_TORMAG = cos(xyz_lat)*cos(xyz_lon)* cos( pi*(xyz_rad-ri)/(ro-ri) )
  !xyz_TORMAG = 2*sin(xyz_lat)**2 * cos( pi*(xyz_rad-ri)/(ro-ri) )

  wt_TORMAG = wt_xyz(xyz_TORMAG)
  call wt_TormagBoundariesGrid(wt_TORMAG)
  xyz_TORMAG = xyz_wt(wt_TORMAG)

  do j=1,jm
     do i=0,im-1
        if ( abs(xyz_TORMAG(i,j,0)) > eps ) then
           write(6,*) 'Top B.C. : ', i,j,xyz_TORMAG(i,j,0)
           call MessageNotify('E','wt_test_tormagbc',&
                              'Top B.C. error too large')
        endif
        if ( abs(xyz_TORMAG(i,j,km)) > eps ) then
           write(6,*) 'Bottom B.C. : ', i,j,xyz_TORMAG(i,j,km)
           call MessageNotify('E','wt_test_tormagbc',&
                              'Bottom B.C. error too large')
        endif
     enddo
  enddo

  call MessageNotify('M','wt_test_tormagbc', &
       'wt_TormagBoundariesGrid test succeeded!')


  call MessageNotify('M','wt_test_tormagbc', &
       'wt_module  wt_TormagBoundaries subroutine test succeded')


end program wt_zonal_test_tormagbc

! -*- mode: f90; coding: utf-8 -*-
!--
!----------------------------------------------------------------------
! Copyright(c) 2002-2016 SPMDODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_module
!
!      spml/at_module モジュールは 1 次元有限領域の下での流体運動を
!      チェビシェフ変換によりスペクトル数値計算するための Fortran90 関数を
!      提供する.
!
!      2 次元データの 1 次元に関して同時にスペクトル計算を実行するための
!      関数も提供しており, 2, 3 次元領域での計算のベースも提供する.
!
!      このモジュールは内部で ISPACK/FTPACK の Fortran77 サブルーチンを
!      呼んでいる. スペクトルデータおよび格子点データの格納方法については
!      ISPACK/FTPACK のマニュアルを参照されたい.
!
!
!履歴  2002/01/24  竹広真一
!      2002/02/06  竹広真一  重み導入. 共通インターフェースなくす.
!                            配列の形に応じたインターフェース名
!      2002/03/25  竹広真一  モジュール名変更
!      2002/08/20  竹広真一  積分・平均関数追加
!      2002/11/10  竹広真一  実空間での境界条件ルーチン追加
!      2005/01/09  竹広真一  msgdmp -> MessageNotify に変更
!      2006/03/06  竹広真一  コメントを RDoc 用に修正
!      2006/03/19  竹広真一  変数・手続き群の要約をコメントに追加
!      2007/10/24  竹広真一  補間用関数追加
!                            at_Initial 呼び直すこと可能にするために
!                            allocate された public 変数を deallocate する.
!      2007/11/21  竹広真一  初期化サブルーチンメッセージ出力
!      2007/12/27  竹広真一  コメント間違い訂正
!      2009/01/04  竹広真一  spml 書法に反するため
!                            Interpolate1dim_t, a_Interpolate1dim_at 削除
!      2009/01/09  竹広真一  at_Initial メッセージに日付を追加
!      2009/01/29  佐々木洋平 コメントをRDoc 用に修正
!      2009/07/31  竹広真一  境界条件計算用配列を threadprivate 指定(OpenMP)
!      2009/12/05  竹広真一  threadprivate 指定コメントアウト
!      2010/03/10  佐々木洋平  threadprivate 削除(コンパイラ依存)
!      2013/07/06  竹広真一  at_Finalize 作成
!      2016/08/28  竹広真一  OpenMP 並列オプション追加
!      2016/09/22  竹広真一  at_Boundaries, t_Boundaries 追加
!      2016/09/26  竹広真一  at_BoundariesGrid, t_BoundariesGrid 追加
!
!++
module at_module
  !
  != at_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/at_module モジュールは 1 次元有限領域の下での流体運動を
  ! チェビシェフ変換によりスペクトル数値計算するための Fortran90 関数を
  ! 提供する.
  !
  ! 2 次元データの 1 次元に関して同時にスペクトル計算を実行するための
  ! 関数も提供しており, 2, 3 次元領域での計算のベースも提供する.
  !
  ! このモジュールは内部で ISPACK/FTPACK の Fortran77 サブルーチンを
  ! 呼んでいる. スペクトルデータおよび格子点データの格納方法については
  ! ISPACK/FTPACK のマニュアルを参照されたい.
  !
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (t_, g_, at_, ag_) は, 返す値の形を示している.
  !   t_  :: チェビシェフデータ
  !   g_  :: 1 次元格子点データ
  !   at_ :: 1 次元チェビシェフデータが複数並んだ 2 次元データ
  !   ag_ :: 1 次元格子点データが複数並んだ 2 次元データ.
  !
  ! * 関数名の間の文字列(Dx)は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_e,_at,_g, _ag) は, 入力変数の形がチェビシェフデータ
  !   および格子点データであることを示している.
  !   _t  :: チェビシェフデータ
  !   _g  :: 1 次元格子点データ
  !   _at :: 1 次元チェビシェフデータが複数並んだ 2 次元データ
  !   _ag :: 1 次元格子点データが複数並んだ 2 次元データ
  !
  !=== 各データの種類の説明
  !
  ! * g : 1 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(0:im).
  !   * im は X 座標の格子点数であり, サブルーチン at_Initial にて
  !     あらかじめ設定しておく.
  !
  ! * t : チェビシェフデータ.
  !   * 変数の種類と次元は real(8), dimension(0:km).
  !   * km は X 方向の最大波数であり, サブルーチン at_Initial にて
  !     あらかじめ設定しておく. スペクトルデータの格納のされ方については...
  !
  ! * ag : 1 次元(X)格子点データの並んだ 2 次元データ.
  !   * 変数の種類と次元は real(8), dimension(:,0:im).
  !     第 2 次元が X 方向を表す.
  !
  ! * at : 1 次元チェビシェフデータの並んだ 2 次元データ.
  !   * 変数の種類と次元は real(8), dimension(:,0:km).
  !     第 2 次元がスペクトルを表す.
  !
  ! * g_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * t_ で始まる関数が返す値はチェビシェフデータに同じ.
  !
  ! * ag_ で始まる関数が返す値は 1 次元格子点データの並んだ
  !   2 次元データに同じ.
  !
  ! * at_ で始まる関数が返す値は 1 次元チェビシェフデータの並んだ
  !   2 次元データに同じ.
  !
  ! * チェビシェフデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをチェビシェフ変換したもののことである.
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! at_Initial  :: チェビシェフ変換の格子点数, 波数, 領域の大きさの設定
  !
  !==== 座標変数
  !
  ! g_X        :: 格子点座標(X)を格納した 1 次元配列
  ! g_X_Weight :: 重み座標を格納した 1 次元配列
  !
  !==== 基本変換
  !
  ! g_t, ag_at :: チェビシェフデータから格子データへの変換
  ! t_g, at_ag :: 格子データからチェビシェフデータへの変換
  !
  !==== 微分
  !
  ! t_Dx_t, at_Dx_at :: チェビシェフデータに X 微分を作用させる
  !
  !==== 補間
  !
  ! Interpolate_t,
  ! a_Interpolate_at  ::
  ! チェビシェフデータから任意の点での値を求める
  !
  !==== 境界値問題
  !
  ! at_Boundaries_DD, at_Boundaries_DN,
  ! at_Boundaries_ND, at_Boundaries_NN  ::
  ! ディリクレ,ノイマン境界条件の適用
  !
  ! at_BoundariesTau_DD, at_BoundariesTau_DN,
  ! at_BoundariesTau_ND, at_BoundariesTau_NN  ::
  ! ディリクレ, ノイマン境界条件の適用(タウ法)
  !
  ! at_BoundariesGrid_DD, at_BoundariesGrid_DN,
  ! at_BoundariesGrid_ND, at_BoundariesGrid_NN  ::
  ! ディリクレ, ノイマン境界条件の適用(選点法)
  !
  !==== 積分・平均
  !
  ! a_Int_ag, a_Avr_ag :: 1 次元格子点データの並んだ 2 次元配列の積分および平均
  ! Int_g, Avr_g       :: 1 次元格子点データの積分および平均
  !
  use dc_message
  use lumatrix
  implicit none
  private
  private im, km
  public g_X, g_X_Weight                      ! 座標変数
  public at_Initial                           ! 初期化
  public at_Finalize                          ! 終了処理
  public ag_at, at_ag, g_t, t_g               ! 基本変換
  public at_Dx_at, t_Dx_t                     ! 微分
  public Interpolate_t, a_Interpolate_at      ! 補間
  public at_Boundaries, t_Boundaries          ! 境界条件
  public at_Boundaries_DD, at_Boundaries_DN   ! 境界条件
  public at_Boundaries_ND, at_Boundaries_NN   ! 境界条件
  public at_BoundariesTau_DD, at_BoundariesTau_DN     ! 境界条件
  public at_BoundariesTau_ND, at_BoundariesTau_NN     ! 境界条件
  public at_BoundariesGrid, t_BoundariesGrid          ! 境界条件
  public at_BoundariesGrid_DD, at_BoundariesGrid_DN   ! 境界条件
  public at_BoundariesGrid_ND, at_BoundariesGrid_NN   ! 境界条件
  public a_Int_ag, Int_g, a_Avr_ag, Avr_g             ! 積分・平均

  interface at_Boundaries_DD
     !
     ! 両端ディリクレ型境界条件の適用(タウ法).
     ! 両境界での値を与える.
     !
     ! * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !   使い分けている. ユーザーインターフェースは共通であるので
     !   下部ルーチンを呼ぶ必要はない.
     !
     !== 引数と結果の型
     !
     ! * 1 次元チェビシェフデータの並んだ 2 次元配列の場合
     !
     !    real(8), dimension(:,0:km),intent(inout)       :: at_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(size(at_data,1),2), intent(in), optional :: values
     !    !(in) 適用する境界値
     !
     ! * 1 次元チェビシェフデータの場合
     !
     !    real(8), dimension(0:km),intent(inout)       :: t_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(2), intent(in), optional  :: values
     !    !(in) 適用する境界値
     !
     module procedure at_BoundariesTau_DD_1d, at_BoundariesTau_DD_2d
  end interface

  interface at_Boundaries_DN
     !
     ! ディリクレ・ノイマン型境界条件の適用(タウ法).
     ! i=0 で値, i=im で勾配の値を与える.
     !
     ! * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !   使い分けている. ユーザーインターフェースは共通であるので
     !   下部ルーチンを呼ぶ必要はない.
     !
     !== 引数と結果の型
     !
     ! * 1 次元チェビシェフデータの並んだ 2 次元配列の場合
     !
     !    real(8), dimension(:,0:km),intent(inout)       :: at_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(size(at_data,1),2), intent(in), optional :: values
     !    !(in) 適用する境界値
     !
     ! * 1 次元チェビシェフデータの場合
     !
     !    real(8), dimension(0:km),intent(inout)       :: t_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(2), intent(in), optional  :: values
     !    !(in) 適用する境界値
     !
     module procedure at_BoundariesTau_DN_1d, at_BoundariesTau_DN_2d
  end interface

  interface at_Boundaries_ND
     !
     ! ノイマン・ディリクレ型境界条件の適用(タウ法).
     ! i=0 で勾配の値, i=im で値を与える.
     !
     !  * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !    使い分けている. ユーザーインターフェースは共通であるので
     !    下部ルーチンを呼ぶ必要はない.
     !
     !== 引数と結果の型
     !
     ! * 1 次元チェビシェフデータの並んだ 2 次元配列の場合
     !
     !   real(8), dimension(:,0:km),intent(inout)       :: at_data
     !   !(inout) 境界条件を適用するチェビシェフデータ
     !
     !   real(8), dimension(size(at_data,1),2), intent(in), optional :: values
     !   !(in) 適用する境界値
     !
     ! * 1 次元チェビシェフデータの場合
     !
     !   real(8), dimension(0:km),intent(inout)       :: t_data
     !   !(inout) 境界条件を適用するチェビシェフデータ
     !
     !   real(8), dimension(2), intent(in), optional  :: values
     !   !(in) 適用する境界値
     !
     module procedure at_BoundariesTau_ND_1d, at_BoundariesTau_ND_2d
  end interface

  interface at_Boundaries_NN
     !
     ! 両端ノイマン条件の適用(タウ法).
     ! 両境界で勾配の値を与える.
     !
     !  * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !    使い分けている. ユーザーインターフェースは共通であるので
     !    下部ルーチンを呼ぶ必要はない.
     !
     !==  引数と結果の型
     !
     ! * 1 次元チェビシェフデータの並んだ 2 次元配列の場合
     !
     !   real(8), dimension(:,0:km),intent(inout)       :: at_data
     !   !(inout) 境界条件を適用するチェビシェフデータ
     !
     !   real(8), dimension(size(at_data,1),2), intent(in), optional :: values
     !   !(in) 適用する境界値
     !
     ! * 1 次元チェビシェフデータの場合
     !
     !   real(8), dimension(0:km),intent(inout)       :: t_data
     !   !(inout) 境界条件を適用するチェビシェフデータ
     !
     !   real(8), dimension(2), intent(in), optional  :: values
     !   !(in) 適用する境界値
     !
     module procedure at_BoundariesTau_NN_1d, at_BoundariesTau_NN_2d
  end interface

  interface at_BoundariesTau_DD
     !
     ! 両端ディリクレ型境界条件の適用(タウ法).
     ! 両境界での値を与える.
     !
     !  * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !    使い分けている. ユーザーインターフェースは共通であるので
     !    下部ルーチンを呼ぶ必要はない.
     !
     !== 引数と結果の型
     !
     !  * 1 次元チェビシェフデータの並んだ 2 次元配列の場合
     !
     !    real(8), dimension(:,0:km),intent(inout)       :: at_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(size(at_data,1),2), intent(in), optional :: values
     !    !(in) 適用する境界値
     !
     !  * 1 次元チェビシェフデータの場合
     !
     !    real(8), dimension(0:km),intent(inout)       :: t_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(2), intent(in), optional  :: values
     !    !(in) 適用する境界値
     !
     module procedure at_BoundariesTau_DD_1d, at_BoundariesTau_DD_2d
  end interface

  interface at_BoundariesTau_DN
     !
     ! ディリクレ・ノイマン型境界条件の適用(タウ法).
     ! i=0 で値, i=im で勾配の値を与える.
     !
     !  * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !    使い分けている. ユーザーインターフェースは共通であるので
     !    下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     !  * 1 次元チェビシェフデータの並んだ 2 次元配列の場合
     !
     !    real(8), dimension(:,0:km),intent(inout)       :: at_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(size(at_data,1),2), intent(in), optional :: values
     !    !(in) 適用する境界値
     !
     !  * 1 次元チェビシェフデータの場合
     !
     !    real(8), dimension(0:km),intent(inout)       :: t_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(2), intent(in), optional  :: values
     !    !(in) 適用する境界値
     !
     module procedure at_BoundariesTau_DN_1d, at_BoundariesTau_DN_2d
  end interface

  interface at_BoundariesTau_ND
     !
     ! ノイマン・ディリクレ型境界条件の適用(タウ法).
     ! i=0 で勾配の値, i=im で値を与える.
     !
     !  * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !    使い分けている. ユーザーインターフェースは共通であるので
     !    下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     !  * 1 次元チェビシェフデータの並んだ 2 次元配列の場合
     !
     !    real(8), dimension(:,0:km),intent(inout)       :: at_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(size(at_data,1),2), intent(in), optional :: values
     !    !(in) 適用する境界値
     !
     !  * 1 次元チェビシェフデータの場合
     !
     !    real(8), dimension(0:km),intent(inout)       :: t_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(2), intent(in), optional  :: values
     !    !(in) 適用する境界値
     !
     module procedure at_BoundariesTau_ND_1d, at_BoundariesTau_ND_2d
  end interface

  interface at_BoundariesTau_NN
     !
     ! 両端ノイマン条件の適用(タウ法).
     ! 両境界で勾配の値を与える.
     !
     !  * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !    使い分けている. ユーザーインターフェースは共通であるので
     !    下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     !  * 1 次元チェビシェフデータの並んだ 2 次元配列の場合
     !
     !    real(8), dimension(:,0:km),intent(inout)       :: at_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(size(at_data,1),2), intent(in), optional :: values
     !    !(in) 適用する境界値
     !
     !  * 1 次元チェビシェフデータの場合
     !
     !    real(8), dimension(0:km),intent(inout)       :: t_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(2), intent(in), optional  :: values
     !    !(in) 適用する境界値
     !
     module procedure at_BoundariesTau_NN_1d, at_BoundariesTau_NN_2d
  end interface

  interface at_BoundariesGrid_DD
     !
     ! 両端ディリクレ型境界条件の適用(実空間での評価).
     ! 両境界での値を与える.
     !
     !  * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !    使い分けている. ユーザーインターフェースは共通であるので
     !    下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     !  * 1 次元チェビシェフデータの並んだ 2 次元配列の場合
     !
     !    real(8), dimension(:,0:km),intent(inout)       :: at_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(size(at_data,1),2), intent(in), optional :: values
     !    !(in) 適用する境界値
     !
     !  * 1 次元チェビシェフデータの場合
     !
     !    real(8), dimension(0:km),intent(inout)       :: t_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(2), intent(in), optional  :: values
     !    !(in) 適用する境界値
     !
     module procedure at_BoundariesGrid_DD_1d, at_BoundariesGrid_DD_2d
  end interface

  interface at_BoundariesGrid_DN
     !
     ! ディリクレ・ノイマン型境界条件の適用(実空間での評価).
     ! i=0 で値, i=im で勾配の値を与える.
     !
     !  * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !    使い分けている. ユーザーインターフェースは共通であるので
     !    下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     !  * 1 次元チェビシェフデータの並んだ 2 次元配列の場合
     !
     !    real(8), dimension(:,0:km),intent(inout)       :: at_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(size(at_data,1),2), intent(in), optional :: values
     !    !(in) 適用する境界値
     !
     !  * 1 次元チェビシェフデータの場合
     !
     !    real(8), dimension(0:km),intent(inout)       :: t_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(2), intent(in), optional  :: values
     !    !(in) 適用する境界値
     !
     module procedure at_BoundariesGrid_DN_1d, at_BoundariesGrid_DN_2d
  end interface

  interface at_BoundariesGrid_ND
     !
     ! ノイマン・ディリクレ型境界条件の適用(実空間での評価)
     ! i=0 で勾配の値, i=im で値を与える.
     !
     !  * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !    使い分けている. ユーザーインターフェースは共通であるので
     !    下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     !  * 1 次元チェビシェフデータの並んだ 2 次元配列の場合
     !
     !    real(8), dimension(:,0:km),intent(inout)       :: at_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(size(at_data,1),2), intent(in), optional :: values
     !    !(in) 適用する境界値
     !
     !  * 1 次元チェビシェフデータの場合
     !
     !    real(8), dimension(0:km),intent(inout)       :: t_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(2), intent(in), optional  :: values
     !    !(in) 適用する境界値
     !
     module procedure at_BoundariesGrid_ND_1d, at_BoundariesGrid_ND_2d
  end interface

  interface at_BoundariesGrid_NN
     !
     ! 両端ノイマン条件の適用(実空間での評価).
     ! 両境界で勾配の値を与える.
     !
     !  * 境界条件を適用する配列の次元によって内部でサブルーチンを
     !    使い分けている. ユーザーインターフェースは共通であるので
     !    下部ルーチンを呼ぶ必要はない.
     !
     ! 引数と結果の型
     !
     !  * 1 次元チェビシェフデータの並んだ 2 次元配列の場合
     !
     !    real(8), dimension(:,0:km),intent(inout)       :: at_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(size(at_data,1),2), intent(in), optional :: values
     !    !(in) 適用する境界値
     !
     !  * 1 次元チェビシェフデータの場合
     !
     !    real(8), dimension(0:km),intent(inout)       :: t_data
     !    !(inout) 境界条件を適用するチェビシェフデータ
     !
     !    real(8), dimension(2), intent(in), optional  :: values
     !    !(in) 適用する境界値
     !
     module procedure at_BoundariesGrid_NN_1d, at_BoundariesGrid_NN_2d
  end interface


  integer, dimension(5)              :: it
  real(8), dimension(:), allocatable :: t
  real(8), parameter                 :: pi=3.1415926535897932385D0

  integer :: im, km                        ! 格子点数, 切断波数
  real(8) :: xl                            ! 領域の大きさ

  real(8), allocatable :: g_X(:)
  ! 格子点座標
  ! km 次のチェビシェフ多項式の零点から定まる格子点

  real(8), allocatable :: g_X_Weight(:)
  ! 格子点重み座標
  ! 各格子点における積分のための重みが格納してある

  logical :: at_Initialize = .false.
  ! 初期化スイッチ

  logical :: at_BoundariesTau_DD_first = .true.
  ! 境界条件ルーチン初期化スイッチ

  logical :: at_BoundariesTau_DN_first = .true.
  ! 境界条件ルーチン初期化スイッチ

  logical :: at_BoundariesTau_ND_first = .true.
  ! 境界条件ルーチン初期化スイッチ

  logical :: at_BoundariesTau_NN_first = .true.
  ! 境界条件ルーチン初期化スイッチ

  logical :: at_BoundariesGrid_DD_first = .true.
  ! 境界条件ルーチン初期化スイッチ

  logical :: at_BoundariesGrid_DN_first = .true.
  ! 境界条件ルーチン初期化スイッチ

  logical :: at_BoundariesGrid_ND_first = .true.
  ! 境界条件ルーチン初期化スイッチ

  logical :: at_BoundariesGrid_NN_first = .true.
  ! 境界条件ルーチン初期化スイッチ

  save :: im, km, xl, it, t, g_X, g_X_Weight, at_Initialize
  save :: at_BoundariesTau_DD_first
  save :: at_BoundariesTau_DN_first
  save :: at_BoundariesTau_ND_first
  save :: at_BoundariesTau_NN_first
  save :: at_BoundariesGrid_DD_first
  save :: at_BoundariesGrid_DN_first
  save :: at_BoundariesGrid_ND_first
  save :: at_BoundariesGrid_NN_first

contains

! ---- 初期化 ----
  subroutine at_Initial(i,k,xmin,xmax)
    !
    ! チェビシェフ変換の格子点数, 波数, 領域の大きさを設定する.
    !
    ! 他の関数や変数を呼ぶ前に, 最初にこのサブルーチンを呼んで
    ! 初期設定をしなければならない.
    !
    integer,intent(in) :: i              !(in) 格子点数
    integer,intent(in) :: k              !(in) 切断波数
    real(8),intent(in) :: xmin, xmax     !(in) 座標の範囲

    integer :: ii,kk

    im=i ; km=k
    xl = xmax-xmin

    if ( im <= 0 .or. km <= 0 ) then
       call MessageNotify('E','at_initial', &
            'Number of grid points and waves should be positive')
    elseif ( mod(im,2) /= 0 ) then
       call MessageNotify('E','at_initial','Number of grid points should be even')
    elseif ( km > im ) then
       call MessageNotify('E','at_initial','KM shoud be less equal IM')
    endif

    if ( allocated(t) ) deallocate(t)
    allocate(t(3*im))
    call fttcti(im,it,t)

    if ( allocated(g_X) ) deallocate(g_X)
    allocate(g_X(0:im))
    do ii=0,im
       g_X(ii) = (xmax+xmin)/2 + xl/2 * cos(pi*ii/im)
    enddo

    if ( allocated(g_X_Weight) ) deallocate(g_X_Weight)
    allocate(g_X_Weight(0:im))
    do ii=0,im
       g_X_Weight(ii) = 1.0
       do kk=2,km,2
          g_X_Weight(ii) = g_X_Weight(ii) &
                          + 2/(1D0-kk**2) * cos(kk*ii*pi/im)
       enddo
       if ( (km == im) .and. (mod(im,2)==0) ) then  ! 最後の和は factor 1/2.
          g_X_Weight(ii) = g_X_Weight(ii) &
                          - 1/(1D0-km**2)* cos(km*ii*pi/im)
       endif
       g_X_Weight(ii) = 2D0/im * g_X_Weight(ii) * xl/2
    enddo
    g_X_Weight(0)  = g_X_Weight(0) / 2
    g_X_Weight(im) = g_X_Weight(im) / 2

    at_Initialize = .true.

#ifdef SPML_VEC
    call MessageNotify('M','at_initial','at_module for Vector (2016/09/26) is initialized')
#else
    call MessageNotify('M','at_initial','at_module for OpenMP (2016/09/26) is initialized')
#endif
   end subroutine at_Initial

! ---- 逆変換 ----
  function ag_at(at_data)
    !
    ! チェビシェフデータから格子データへ変換する(2 次元配列用).
    !
    real(8), dimension(:,:), intent(in)      :: at_data
    !(in) チェビシェフデータ

    real(8), dimension(size(at_data,1),0:im) :: ag_at
    !(out) 格子点データ

    real(8), dimension(size(at_data,1),im) :: y
    ! 作業用配列
    integer :: nm, n

    nm = size(at_data,1)
    if ( size(at_data,2)-1 < km ) then
       call MessageNotify('E','ag_at', &
            'The Chebyshev dimension of input data too small.')
    elseif ( size(at_data,2)-1 > km ) then
       call MessageNotify('W','ag_at', &
            'The Chebyshev dimension of input data too large.')
    endif

    ag_at = 0.0D0
    ag_at(:,0:km)=at_data

#ifdef SPML_VEC
    call fttctb(nm,im,ag_at,y,it,t)
#else
!$omp parallel do default(shared)
    do n=1,nm
       call fttctb(1,im,ag_at(n,:),y(n,:),it,t)
    enddo
!$omp end parallel do
#endif

  end function ag_at

  function g_t(t_data)
    !
    ! チェビシェフデータから格子データへ変換する(1 次元配列用).
    !
    real(8), dimension(:), intent(in)  :: t_data
    !(in) チェビシェフデータ

    real(8), dimension(0:im)           :: g_t
    !(out) 格子点データ

    real(8), dimension(1,size(t_data)) :: t_work
    ! 作業用配列
    real(8), dimension(1,0:im)         :: g_work
    ! 作業用配列

    t_work(1,:) = t_data
    g_work = ag_at(t_work)
    g_t = g_work(1,:)

  end function g_t


! ---- 正変換 ----
  function at_ag(ag_data)
    !
    ! 格子データからチェビシェフデータへ変換する(2 次元配列用).
    !
    real(8), dimension(:,:), intent(in)      :: ag_data
    !(in) 格子点データ

    real(8), dimension(size(ag_data,1),0:km) :: at_ag
    !(out) チェビシェフデータ

    real(8), dimension(size(ag_data,1),im)   :: y
    real(8), dimension(size(ag_data,1),0:im) :: ag_work
    integer :: n, nm

    nm = size(ag_data,1)
!!$    if ( size(ag_data,2)-1 < im ) then
!!$       call MessageNotify('E','at_ag', &
!!$            'The Grid points of input data too small.')
!!$    elseif ( size(ag_data,2)-1 > im ) then
!!$       call MessageNotify('W','at_ag', &
!!$            'The Grid points of input data too large.')
!!$    endif
    ag_work = ag_data

#ifdef SPML_VEC
    call fttctf(nm,im,ag_work,y,it,t)
#else
!$omp parallel do default(shared)
    do n=1,nm
       call fttctf(1,im,ag_work(n,:),y(n,:),it,t)
    enddo
!$omp end parallel do
#endif

    at_ag = ag_work(:,0:km)

  end function at_ag

  function t_g(g_data)  ! 台形格子 -> スペクトル
    !
    ! 格子データからチェビシェフデータへ変換する(1 次元配列用).
    !
    real(8), dimension(:), intent(in)     :: g_data
    !(in) 格子点データ

    real(8), dimension(0:km)              :: t_g
    !(out) チェビシェフデータ

    real(8), dimension(1,size(g_data)) :: ag_work
    real(8), dimension(1,0:km)         :: at_work

    ag_work(1,:) = g_data
    at_work = at_ag(ag_work)
    t_g = at_work(1,:)

  end function t_g

! ---- 微分計算 ----
  function at_Dx_at(at_data)
    !
    ! 入力チェビシェフデータに X 微分を作用する(2 次元配列用).
    !
    ! チェビシェフデータの X 微分とは, 対応する格子点データに X 微分を
    ! 作用させたデータのチェビシェフ変換のことである.
    !
    !
    real(8), dimension(:,0:), intent(in)                    :: at_data
    !(in) 入力チェビシェフデータ

    real(8), dimension(size(at_data,1),0:size(at_data,2)-1) :: at_Dx_at
    !(out) チェビシェフデータの X 微分

    integer :: m, k
    integer :: nm, kmax

    nm=size(at_data,1)
    kmax=size(at_data,2)-1
!!$    if ( kmax  < km ) then
!!$       call MessageNotify('W','at_Dx_at', &
!!$            'The Chebyshev dimension of input data too small.')
!!$    elseif ( kmax > km ) then
!!$       call MessageNotify('E','at_Dx_at', &
!!$            'The Chebyshev dimension of input data too large.')
!!$    endif

    if ( kmax == im ) then
       do m=1,nm
          at_Dx_at(m,kmax)   = 0.
          at_Dx_at(m,kmax-1) = 2 * km * at_data(m,kmax) /2
       enddo
    else
       do m=1,nm
          at_Dx_at(m,kmax)   = 0.
          at_Dx_at(m,kmax-1) = 2 * km * at_data(m,kmax)
          ! スタートはグリッド対応最大波数未満. Factor 1/2 不要
       enddo
    endif

    do k=kmax-2,0,-1
       do m=1,nm
          at_Dx_at(m,k) = at_Dx_at(m,k+2) + 2*(k+1)*at_data(m,k+1)
       enddo
    enddo

    do k=0,kmax
       do m=1,nm
          at_Dx_at(m,k) = 2/xl * at_Dx_at(m,k)
       enddo
    enddo

  end function at_Dx_at

  function t_Dx_t(t_data)
    !
    ! 入力チェビシェフデータに X 微分を作用する(1 次元配列用).
    !
    ! チェビシェフデータの X 微分とは, 対応する格子点データに X 微分を
    ! 作用させたデータのチェビシェフ変換のことである.
    !
    !
    real(8), dimension(:), intent(in)   :: t_data
    !(in) 入力チェビシェフデータ

    real(8), dimension(size(t_data))    :: t_Dx_t
    !(out) チェビシェフデータの X 微分

    real(8), dimension(1,size(t_data))  :: at_work
    ! 作業用配列

    at_work(1,:) = t_data
    at_work = at_Dx_at(at_work)
    t_Dx_t = at_work(1,:)

  end function t_Dx_t

!--------------- 積分計算 -----------------
    function a_Int_ag(ag)
      !
      ! 1 次元格子点データが並んだ 2 次元配列の積分
      !
      real(8), dimension(:,0:), intent(in)     :: ag
      !(in)入力格子点データ

      real(8), dimension(size(ag,1))           :: a_Int_ag
      !(out) 積分したデータ
      integer :: i

      if ( size(ag,2) < im+1 ) then
         call MessageNotify('E','ae_ag', &
              'The Grid points of input data too small.')
      elseif ( size(ag,2) > im+1 ) then
         call MessageNotify('W','ae_ag', &
              'The Grid points of input data too large.')
      endif

      a_Int_ag = 0.0d0
      do i=0,im
         a_Int_ag(:) = a_Int_ag(:) + ag(:,i)*g_X_Weight(i)
      enddo
    end function a_Int_ag

    function Int_g(g)
      !
      ! 1 次元格子点データの積分および平均.
      !
      real(8), dimension(0:im), intent(in)   :: g
      !(in) 格子点データ

      real(8)                                :: Int_g
      !(out) 積分値

      Int_g = sum(g*g_X_Weight)
    end function Int_g

    function a_Avr_ag(ag)
      !
      ! 1 次元格子点データが並んだ 2 次元配列の平均
      !
      real(8), dimension(:,0:), intent(in)   :: ag
      !(in)入力格子点データ

      real(8), dimension(size(ag,1))         :: a_Avr_ag
      !(out) 平均したデータ

      a_Avr_ag = a_Int_ag(ag)/sum(g_X_Weight)
    end function a_Avr_ag

    function Avr_g(g)
      !
      ! 1 次元格子点データの平均
      !
      real(8), dimension(0:im), intent(in)   :: g
      !(in) 格子点データ

      real(8)                                :: Avr_g
      !(out) 積分値

      Avr_g = Int_g(g)/sum(g_X_Weight)
    end function Avr_g

! ---- 補間計算 ----
  function Interpolate_t(t_data,xval)
    real(8), dimension(0:), intent(in)  :: t_data
    !(in) 入力チェビシェフデータ

    real(8), intent(in)                 :: xval
    ! 補間する点の座標

    real(8)                             :: Interpolate_t
    ! 補間した結果の値

    integer :: kmax
    ! 入力配列の最大次数

    real(8) :: y2, y1, y0, x
    ! Crenshow's reccurence formula 計算用変数

    integer :: k
    ! DO 文変数

    kmax = size(t_data)-1

    x =(xval -(g_X(0)+g_X(im))/2 )/(g_X(0)-g_X(im))*2

    y2 = 0 ; y1 = 0
    do k=kmax,1,-1
       y0 = 2*x*y1 - y2 + t_data(k)
       y2 = y1 ; y1 = y0
    enddo

    Interpolate_t = - y2 + x*y1 + t_data(0)/2
    if ( kmax == im ) then
       Interpolate_t = Interpolate_t -t_data(kmax)/2*cos(kmax*acos(x))
    endif

  end function Interpolate_t

  function a_Interpolate_at(at_data,xval)
    real(8), dimension(:,0:), intent(in) :: at_data
    !(in) 入力チェビシェフデータ

    real(8), intent(in)                  :: xval
    ! 補間する点の座標

    real(8), dimension(size(at_data,1))  :: a_Interpolate_at
    ! 補間した結果の値

    integer :: kmax
    ! 入力配列の最大次数

    real(8), dimension(size(at_data,1))  :: y2, y1, y0
    real(8)                              :: x
    ! Crenshow's reccurence formula 計算用変数

    integer :: k
    ! DO 文変数

    kmax = size(at_data,2)-1

    x =(xval -(g_X(0)+g_X(im))/2 )/(g_X(0)-g_X(im))*2

    y2 = 0 ; y1 = 0
    do k=kmax,1,-1
       y0 = 2*x*y1 - y2 + at_data(:,k)
       y2 = y1 ; y1 = y0
    enddo

    a_Interpolate_at = - y2 + x*y1 + at_data(:,0)/2
    if ( kmax == im ) then
       a_Interpolate_at = a_Interpolate_at -at_data(:,kmax)/2*cos(kmax*acos(x))
    endif
  end function a_Interpolate_at

!---- 境界条件(タウ法) ----

  subroutine at_Boundaries(at_data,cond,values)
    !
    ! 境界条件の適用(タウ法, 2 次元配列用)
    ! 境界条件と両境界での値をオプションで与える.
    ! デフォルトは DD, values = 0
    !

    real(8), intent(INOUT)                  :: at_data(:,:)
    !(inout) 境界条件を適用するチェビシェフデータ(m,0:km)

    character(len=2), intent(IN), optional  :: cond
    !(in) 境界条件. DD : 両端ディリクレ
    !               DN : 上端ディリクレ, 下端ノイマン
    !               ND : 上端ノイマン,   下端ディリクレ
    !               NN : 両端ノイマン

    real(8), dimension(:,:), intent(in), optional  :: values
    !(in) 境界値(m,2)

    real(8)          :: BCvalues(size(at_data),2)
    character(len=2) :: BC

    if ( present(cond) ) then
       BC = cond
    else
       BC = 'DD'
    endif

    if ( present(values) ) then
       BCvalues = values
    else
       BCvalues = 0.0D0
    endif

    if ( BC == 'DD' ) call at_Boundaries_DD(at_data,BCvalues)
    if ( BC == 'DN' ) call at_Boundaries_DN(at_data,BCValues)
    if ( BC == 'ND' ) call at_Boundaries_ND(at_data,BCValues)
    if ( BC == 'NN' ) call at_Boundaries_NN(at_data,BCValues)

  end subroutine at_Boundaries

  subroutine t_Boundaries(t_data,cond,values)
    !
    ! 境界条件の適用(タウ法, 1 次元配列用)
    ! 境界条件と両境界での値をオプションで与える.
    ! デフォルトは DD, values = 0
    !

    real(8), intent(INOUT)                  :: t_data(:)
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    character(len=2), intent(IN), optional  :: cond
    !(in) 境界条件. DD : 両端ディリクレ
    !               DN : 上端ディリクレ, 下端ノイマン
    !               ND : 上端ノイマン,   下端ディリクレ
    !               NN : 両端ノイマン

    real(8), dimension(2), intent(in), optional  :: values
    !(in) 境界値(2)

    real(8)          :: BCvalues(2)
    character(len=2) :: BC


    if ( present(cond) ) then
       BC = cond
    else
       BC = 'DD'
    endif

    if ( present(values) ) then
       BCvalues = values
    else
       BCvalues = 0.0D0
    endif

    if ( BC == 'DD' ) call at_Boundaries_DD(t_data,BCvalues)
    if ( BC == 'DN' ) call at_Boundaries_DN(t_data,BCvalues)
    if ( BC == 'ND' ) call at_Boundaries_ND(t_data,BCvalues)
    if ( BC == 'NN' ) call at_Boundaries_NN(t_data,BCvalues)

  end subroutine t_Boundaries


!---- Dirichlet 型境界条件(タウ法) ----

  subroutine at_BoundariesTau_DD_2d(at_data,values)
    !
    ! Dirichlet 型境界条件の適用(タウ法, 2 次元配列用)
    ! 両境界での値を与える.
    !
    real(8), dimension(:,0:),intent(inout)         :: at_data ! データ(m,0:km)
    !(inout) 境界条件を適用するチェビシェフデータ(m,0:km)

    real(8), dimension(:,:), intent(in), optional  :: values
    !(in) 境界値(m,2)

    real(8), dimension(:,:), allocatable  :: alu
    integer, dimension(:), allocatable    :: kp
    real(8), dimension(0:km,0:km)         :: tt_data
    real(8), dimension(0:km,0:im)         :: tg_data
    real(8), dimension(size(at_data,1))   :: value1, value2           ! 境界値

    integer :: k
    save    :: alu, kp

    if ( size(at_data,2)-1 < km ) then
       call MessageNotify('E','at_BoundariesTau_DD', &
            'The Chebyshev dimension of input data too small.')
    elseif ( size(at_data,2)-1 > km ) then
       call MessageNotify('W','at_BoundariesTau_DD', &
            'The Chebyshev dimension of input data too large.')
    endif

    if (.not. present(values)) then
       value1=0 ; value2=0
    else
       value1 = values(:,1) ; value2 = values(:,2)
    endif

    if ( at_BoundariesTau_DD_first ) then
       at_BoundariesTau_DD_first = .false.

       if (allocated(alu)) deallocate(alu)
       if (allocated(kp))  deallocate(kp)

       allocate(alu(0:km,0:km),kp(0:km))

       tt_data=0
       do k=0,km
          tt_data(k,k)=1
       enddo
       alu = tt_data

       tg_data = ag_at(tt_data)
       alu(km-1,:) = tg_data(:,0)
       alu(km,:)   = tg_data(:,im)

       call ludecomp(alu,kp)
    endif

    at_data(:,km-1) = value1
    at_data(:,km)   = value2
    at_data = lusolve(alu,kp,at_data)

  end subroutine at_BoundariesTau_DD_2d

  subroutine at_BoundariesTau_DD_1d(t_data,values)
    !
    ! Dirichlet 型境界条件の適用(タウ法, 1 次元配列用)
    ! 両境界での値を与える.
    !
    real(8), dimension(0:km),intent(inout)       :: t_data
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    real(8), dimension(2), intent(in), optional  :: values
    !(in) 境界値

    real(8), dimension(1,0:km)                   :: at_work
    real(8), dimension(1,2)                      :: vwork           ! 境界値

    if (.not. present(values)) then
       vwork(1,1)=0 ; vwork(1,2)=0
    else
       vwork(1,:) = values
    endif

    at_work(1,:)=t_data
    call at_BoundariesTau_DD_2d(at_work,vwork)
    t_data=at_work(1,:)

  end subroutine at_BoundariesTau_DD_1d


!---- Dirichlet/Neumann 型境界条件(タウ法) ----

  subroutine at_BoundariesTau_DN_2d(at_data,values)
    !
    ! Dirichlet/Neumann 型境界条件の適用(タウ法, 2 次元配列用)
    ! i=0 で値, i=im で勾配の値を与える.
    !
    real(8), dimension(:,0:),intent(inout)         :: at_data
    !(inout) 境界条件を適用するチェビシェフデータ(m,0:km)

    real(8), dimension(:,:), intent(in), optional  :: values
    !(in) 境界値(m,2)

    real(8), dimension(:,:), allocatable  :: alu
    integer, dimension(:), allocatable    :: kp
    real(8), dimension(0:km,0:km)         :: tt_data
    real(8), dimension(0:km,0:im)         :: tg_data
    real(8), dimension(size(at_data,1))    :: value1, value2           ! 境界値

    integer :: k
    save    :: alu, kp

    if ( size(at_data,2)-1 < km ) then
       call MessageNotify('E','at_BoundariesTau_DN', &
            'The Chebyshev dimension of input data too small.')
    elseif ( size(at_data,2)-1 > km ) then
       call MessageNotify('W','at_BoundariesTau_DN', &
            'The Chebyshev dimension of input data too large.')
    endif

    if (.not. present(values)) then
       value1=0 ; value2=0
    else
       value1 = values(:,1) ; value2 = values(:,2)
    endif

    if (  at_BoundariesTau_DN_first ) then
       at_BoundariesTau_DN_first = .false.

       if (allocated(alu)) deallocate(alu)
       if (allocated(kp)) deallocate(kp)

       allocate(alu(0:km,0:km),kp(0:km))

       tt_data = 0
       do k=0,km
          tt_data(k,k)=1
       enddo
       alu = tt_data

       tg_data = ag_at(tt_data)
       alu(km-1,:) = tg_data(:,0)
       tg_data = ag_at(at_Dx_at(tt_data))
       alu(km,:)   = tg_data(:,im)

       call ludecomp(alu,kp)
    endif

    at_data(:,km-1) = value1
    at_data(:,km)   = value2
    at_data = lusolve(alu,kp,at_data)

  end subroutine at_BoundariesTau_DN_2d

  subroutine at_BoundariesTau_DN_1d(t_data,values)
    !
    ! Dirichlet/Neumann 型境界条件の適用(タウ法, 1 次元配列用)
    ! i=0 で値, i=im で勾配の値を与える.
    !
    real(8), dimension(0:km),intent(inout)       :: t_data
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    real(8), dimension(2), intent(in), optional  :: values
    !(in) 境界値

    real(8), dimension(1,0:km)                   :: at_work
    real(8), dimension(1,2)                      :: vwork           ! 境界値

    if (.not. present(values)) then
       vwork(1,1)=0 ; vwork(1,2)=0
    else
       vwork(1,:) = values
    endif

    at_work(1,:)=t_data
    call at_BoundariesTau_DN_2d(at_work,vwork)
    t_data=at_work(1,:)

  end subroutine at_BoundariesTau_DN_1d

!---- Neumann/Dirichlet 型境界条件(タウ法) ----

  subroutine at_BoundariesTau_ND_2d(at_data,values)
    !
    ! Neumann/Dirichlet 型境界条件の適用(タウ法, 2 次元配列用)
    ! i=0 で勾配の値, i=im で値を与える.
    !
    real(8), dimension(:,0:),intent(inout)         :: at_data
    !(inout) 境界条件を適用するチェビシェフデータ(m,0:km)

    real(8), dimension(:,:), intent(in), optional  :: values
    !(in) 境界値(m,2)

    real(8), dimension(:,:), allocatable  :: alu
    integer, dimension(:), allocatable    :: kp
    real(8), dimension(0:km,0:km)         :: tt_data
    real(8), dimension(0:km,0:im)         :: tg_data
    real(8), dimension(size(at_data,1))    :: value1, value2           ! 境界値

    integer :: k
    save    :: alu, kp

    if ( size(at_data,2)-1 < km ) then
       call MessageNotify('E','at_BoundariesTau_ND', &
            'The Chebyshev dimension of input data too small.')
    elseif ( size(at_data,2)-1 > km ) then
       call MessageNotify('W','at_BoundariesTau_ND', &
            'The Chebyshev dimension of input data too large.')
    endif

    if (.not. present(values)) then
       value1=0 ; value2=0
    else
       value1 = values(:,1) ; value2 = values(:,2)
    endif

    if ( at_BoundariesTau_ND_first ) then
       at_BoundariesTau_ND_first = .false.

       if (allocated(alu)) deallocate(alu)
       if (allocated(kp)) deallocate(kp)

       allocate(alu(0:km,0:km),kp(0:km))

       tt_data = 0
       do k=0,km
          tt_data(k,k)=1
       enddo
       alu = tt_data

       tg_data = ag_at(at_Dx_at(tt_data))
       alu(km-1,:) = tg_data(:,0)
       tg_data = ag_at(tt_data)
       alu(km,:)   = tg_data(:,im)

       call ludecomp(alu,kp)
    endif

    at_data(:,km-1) = value1
    at_data(:,km)   = value2
    at_data = lusolve(alu,kp,at_data)

  end subroutine at_BoundariesTau_ND_2d

  subroutine at_BoundariesTau_ND_1d(t_data,values)
    !
    ! Neumann/Dirichlet 型境界条件の適用(タウ法, 1 次元配列用)
    ! i=0 で勾配の値, i=im で値を与える.
    !
    real(8), dimension(0:km),intent(inout)       :: t_data
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    real(8), dimension(2), intent(in), optional  :: values
    !(in) 境界値

    real(8), dimension(1,0:km)                   :: at_work
    real(8), dimension(1,2)                      :: vwork           ! 境界値

    if (.not. present(values)) then
       vwork(1,1)=0 ; vwork(1,2)=0
    else
       vwork(1,:) = values
    endif

    at_work(1,:)=t_data
    call at_BoundariesTau_ND_2d(at_work,vwork)
    t_data=at_work(1,:)

  end subroutine at_BoundariesTau_ND_1d


!---- Neumann 型境界条件(タウ法) ----

  subroutine at_BoundariesTau_NN_2d(at_data,values)
    !
    ! Neumann/Dirichlet 型境界条件の適用(タウ法, 2 次元配列用)
    ! 両境界で勾配の値を与える.
    !
    real(8), dimension(:,0:),intent(inout)         :: at_data
    !(inout) 境界条件を適用するチェビシェフデータ(m,0:km)

    real(8), dimension(:,:), intent(in), optional  :: values
    !(in) 境界値(m,2)

    real(8), dimension(:,:), allocatable  :: alu
    integer, dimension(:), allocatable    :: kp
    real(8), dimension(0:km,0:km)         :: tt_data
    real(8), dimension(0:km,0:im)         :: tg_data
    real(8), dimension(size(at_data,1))    :: value1, value2           ! 境界値

    integer :: k
    save    :: alu, kp

    if ( size(at_data,2)-1 < km ) then
       call MessageNotify('E','at_BoundariesTau_NN', &
            'The Chebyshev dimension of input data too small.')
    elseif ( size(at_data,2)-1 > km ) then
       call MessageNotify('W','at_BoundariesTau_NN', &
            'The Chebyshev dimension of input data too large.')
    endif

    if (.not. present(values)) then
       value1=0 ; value2=0
    else
       value1 = values(:,1) ; value2 = values(:,2)
    endif

    if ( at_BoundariesTau_NN_first ) then
       at_BoundariesTau_NN_first = .false.

       if (allocated(alu)) deallocate(alu)
       if (allocated(kp)) deallocate(kp)

       allocate(alu(0:km,0:km),kp(0:km))

       tt_data = 0
       do k=0,km
          tt_data(k,k)=1
       enddo
       alu = tt_data

       tg_data = ag_at(at_Dx_at(tt_data))
       alu(km-1,:) = tg_data(:,0)
       alu(km,:)   = tg_data(:,im)

       call ludecomp(alu,kp)
    endif

    at_data(:,km-1) = value1
    at_data(:,km)   = value2
    at_data = lusolve(alu,kp,at_data)

  end subroutine at_BoundariesTau_NN_2d

  subroutine at_BoundariesTau_NN_1d(t_data,values)
    !
    ! Neumann/Dirichlet 型境界条件の適用(タウ法, 1 次元配列用)
    ! 両境界で勾配の値を与える.
    !
    ! このサブルーチンを直接使うことを勧めない.
    ! 共通インターフェース at_Boundaries_NN を用いること.
    !
    real(8), dimension(0:km),intent(inout)       :: t_data
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    real(8), dimension(2), intent(in), optional  :: values
    !(in) 境界値

    real(8), dimension(1,0:km)                   :: at_work
    real(8), dimension(1,2)                      :: vwork           ! 境界値

    if (.not. present(values)) then
       vwork(1,1)=0 ; vwork(1,2)=0
    else
       vwork(1,:) = values
    endif

    at_work(1,:)=t_data
    call at_BoundariesTau_NN_2d(at_work,vwork)
    t_data=at_work(1,:)

  end subroutine at_BoundariesTau_NN_1d


!---- 境界条件(実空間での評価) ----

  subroutine at_BoundariesGrid(at_data,cond,values)
    !
    ! 境界条件の適用(実空間での評価, 2 次元配列用)
    ! 境界条件と両境界での値をオプションで与える.
    ! デフォルトは DD, values = 0
    !

    real(8), intent(INOUT)                  :: at_data(:,:)
    !(inout) 境界条件を適用するチェビシェフデータ(m,0:km)

    character(len=2), intent(IN), optional  :: cond
    !(in) 境界条件. DD : 両端ディリクレ
    !               DN : 上端ディリクレ, 下端ノイマン
    !               ND : 上端ノイマン,   下端ディリクレ
    !               NN : 両端ノイマン

    real(8), dimension(:,:), intent(in), optional  :: values
    !(in) 境界値(m,2)

    real(8)          :: BCvalues(size(at_data),2)
    character(len=2) :: BC

    if ( present(cond) ) then
       BC = cond
    else
       BC = 'DD'
    endif

    if ( present(values) ) then
       BCvalues = values
    else
       BCvalues = 0.0D0
    endif

    if ( BC == 'DD' ) call at_BoundariesGrid_DD(at_data,BCvalues)
    if ( BC == 'DN' ) call at_BoundariesGrid_DN(at_data,BCValues)
    if ( BC == 'ND' ) call at_BoundariesGrid_ND(at_data,BCValues)
    if ( BC == 'NN' ) call at_BoundariesGrid_NN(at_data,BCValues)

  end subroutine at_BoundariesGrid

  subroutine t_BoundariesGrid(t_data,cond,values)
    !
    ! 境界条件の適用(タウ法, 1 次元配列用)
    ! 境界条件と両境界での値をオプションで与える.
    ! デフォルトは DD, values = 0
    !

    real(8), intent(INOUT)                  :: t_data(:)
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    character(len=2), intent(IN), optional  :: cond
    !(in) 境界条件. DD : 両端ディリクレ
    !               DN : 上端ディリクレ, 下端ノイマン
    !               ND : 上端ノイマン,   下端ディリクレ
    !               NN : 両端ノイマン

    real(8), dimension(2), intent(in), optional  :: values
    !(in) 境界値(2)

    real(8)          :: BCvalues(2)
    character(len=2) :: BC


    if ( present(cond) ) then
       BC = cond
    else
       BC = 'DD'
    endif

    if ( present(values) ) then
       BCvalues = values
    else
       BCvalues = 0.0D0
    endif

    if ( BC == 'DD' ) call at_BoundariesGrid_DD(t_data,BCvalues)
    if ( BC == 'DN' ) call at_BoundariesGrid_DN(t_data,BCvalues)
    if ( BC == 'ND' ) call at_BoundariesGrid_ND(t_data,BCvalues)
    if ( BC == 'NN' ) call at_BoundariesGrid_NN(t_data,BCvalues)

  end subroutine t_BoundariesGrid


!---- Dirichlet 型境界条件(実空間での評価) ----

  subroutine at_BoundariesGrid_DD_2d(at_data,values)
    !
    ! Dirichlet 型境界条件の適用(実空間での評価, 2 次元配列用)
    ! 両境界での値を与える.
    !
    real(8), dimension(:,0:),intent(inout)         :: at_data
    !(inout) 境界条件を適用するチェビシェフデータ(m,0:km)

    real(8), dimension(:,:), intent(in), optional  :: values
    !(in) 境界値(m,2)

    real(8), dimension(:,:), allocatable     :: alu
    integer, dimension(:), allocatable       :: kp
    real(8), dimension(size(at_data,1),0:im) :: ag_data
    real(8), dimension(0:km,0:km)            :: tt_data
    real(8), dimension(0:km,0:im)            :: tg_data
    real(8), dimension(size(at_data,1))      :: value1, value2  ! 境界値

    integer :: k
    save    :: alu, kp

    if ( im /= km ) then
       call MessageNotify('E','at_BoundariesGrid_DD', &
            'Chebyshev truncation and number of grid points should be same.')
    endif

    if ( size(at_data,2)-1 < km ) then
       call MessageNotify('E','at_BoundariesGrid_DD', &
            'The Chebyshev dimension of input data too small.')
    elseif ( size(at_data,2)-1 > km ) then
       call MessageNotify('W','at_BoundariesGrid_DD', &
            'The Chebyshev dimension of input data too large.')
    endif

    if (.not. present(values)) then
       value1=0 ; value2=0
    else
       value1 = values(:,1) ; value2 = values(:,2)
    endif

    if ( at_BoundariesGrid_DD_first ) then
       at_BoundariesGrid_DD_first = .false.

       if (allocated(alu)) deallocate(alu)
       if (allocated(kp)) deallocate(kp)

       allocate(alu(0:im,0:km),kp(0:im))

       tt_data = 0
       do k=0,km
          tt_data(k,k)=1.0
       enddo
       tg_data = ag_at(tt_data)
       alu = transpose(tg_data)
!       alu(km-1,:) = tg_data(:,0)
!       alu(km,:)   = tg_data(:,im)

       call ludecomp(alu,kp)
    endif

    ag_data = ag_at(at_data)
    ag_data(:,0)  = value1
    ag_data(:,im) = value2
    at_data = lusolve(alu,kp,ag_data)

  end subroutine at_BoundariesGrid_DD_2d

  subroutine at_BoundariesGrid_DD_1d(t_data,values)
    !
    ! Dirichlet 型境界条件の適用(実空間での評価, 1 次元配列用)
    ! 両境界での値を与える.
    !
    real(8), dimension(0:km),intent(inout)       :: t_data
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    real(8), dimension(2), intent(in), optional  :: values
    !(in) 境界値

    real(8), dimension(1,0:km)                   :: at_work
    real(8), dimension(1,2)                      :: vwork           ! 境界値

    if (.not. present(values)) then
       vwork(1,1)=0 ; vwork(1,2)=0
    else
       vwork(1,:) = values
    endif

    at_work(1,:)=t_data
    call at_BoundariesGrid_DD_2d(at_work,vwork)
    t_data=at_work(1,:)

  end subroutine at_BoundariesGrid_DD_1d

!---- Dirichlet/Neumann 型境界条件(実空間での評価) ----

  subroutine at_BoundariesGrid_DN_2d(at_data,values)
    !
    ! Dirichlet/Neumann 型境界条件の適用(実空間での評価, 2 次元配列用)
    ! i=0 で値, i=im で勾配の値を与える.
    !
    real(8), dimension(:,0:),intent(inout)         :: at_data
    !(inout) 境界条件を適用するチェビシェフデータ(m,0:km)

    real(8), dimension(:,:), intent(in), optional  :: values
    !(in) 境界値(m,2)

    real(8), dimension(:,:), allocatable     :: alu
    integer, dimension(:), allocatable       :: kp
    real(8), dimension(size(at_data,1),0:im) :: ag_data
    real(8), dimension(0:km,0:km)            :: tt_data
    real(8), dimension(0:km,0:im)            :: tg_data
    real(8), dimension(size(at_data,1))      :: value1, value2  ! 境界値

    integer :: k
    save    :: alu, kp

    if ( im /= km ) then
       call MessageNotify('E','at_BoundariesGrid_DN', &
            'Chebyshev truncation and number of grid points should be same.')
    endif

    if ( size(at_data,2)-1 < km ) then
       call MessageNotify('E','at_BoundariesGrid_DN', &
            'The Chebyshev dimension of input data too small.')
    elseif ( size(at_data,2)-1 > km ) then
       call MessageNotify('W','at_BoundariesGrid_DN', &
            'The Chebyshev dimension of input data too large.')
    endif

    if (.not. present(values)) then
       value1=0 ; value2=0
    else
       value1 = values(:,1) ; value2 = values(:,2)
    endif

    if ( at_BoundariesGrid_DN_first ) then
       at_BoundariesGrid_DN_first = .false.

       if (allocated(alu)) deallocate(alu)
       if (allocated(kp)) deallocate(kp)

       allocate(alu(0:im,0:km),kp(0:im))

       tt_data = 0
       do k=0,km
          tt_data(k,k)=1.0
       enddo
       tg_data = ag_at(tt_data)
       alu = transpose(tg_data)

       tg_data = ag_at(at_dx_at(tt_data))
       alu(im,:) = tg_data(:,im)

       call ludecomp(alu,kp)
    endif

    ag_data = ag_at(at_data)
    ag_data(:,0)  = value1
    ag_data(:,im) = value2
    at_data = lusolve(alu,kp,ag_data)

  end subroutine at_BoundariesGrid_DN_2d

  subroutine at_BoundariesGrid_DN_1d(t_data,values)
    !
    ! Dirichlet/Neumann 型境界条件の適用(実空間での評価, 1 次元配列用)
    ! i=0 で値, i=im で勾配の値を与える.
    !
    real(8), dimension(0:km),intent(inout)       :: t_data
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    real(8), dimension(2), intent(in), optional  :: values
    !(in) 境界値

    real(8), dimension(1,0:km)                   :: at_work
    real(8), dimension(1,2)                      :: vwork           ! 境界値

    if (.not. present(values)) then
       vwork(1,1)=0 ; vwork(1,2)=0
    else
       vwork(1,:) = values
    endif

    at_work(1,:)=t_data
    call at_BoundariesGrid_DN_2d(at_work,vwork)
    t_data=at_work(1,:)

  end subroutine at_BoundariesGrid_DN_1d

!---- Neumann/Dirichlet 型境界条件(実空間での評価) ----

  subroutine at_BoundariesGrid_ND_2d(at_data,values)
    !
    ! Neumann/Dirichlet 型境界条件の適用(実空間での評価, 2 次元配列用)
    ! i=0 で勾配の値, i=im で値を与える.
    !
    real(8), dimension(:,0:),intent(inout)         :: at_data
    !(inout) 境界条件を適用するチェビシェフデータ(m,0:km)

    real(8), dimension(:,:), intent(in), optional  :: values
    !(in) 境界値(m,2)

    real(8), dimension(:,:), allocatable     :: alu
    integer, dimension(:), allocatable       :: kp
    real(8), dimension(size(at_data,1),0:im) :: ag_data
    real(8), dimension(0:km,0:km)            :: tt_data
    real(8), dimension(0:km,0:im)            :: tg_data
    real(8), dimension(size(at_data,1))      :: value1, value2  ! 境界値

    integer :: k
    save    :: alu, kp

    if ( im /= km ) then
       call MessageNotify('E','at_BoundariesGrid_ND', &
            'Chebyshev truncation and number of grid points should be same.')
    endif

    if ( size(at_data,2)-1 < km ) then
       call MessageNotify('E','at_BoundariesGrid_ND', &
            'The Chebyshev dimension of input data too small.')
    elseif ( size(at_data,2)-1 > km ) then
       call MessageNotify('W','at_BoundariesGrid_DD', &
            'The Chebyshev dimension of input data too large.')
    endif

    if (.not. present(values)) then
       value1=0 ; value2=0
    else
       value1 = values(:,1) ; value2 = values(:,2)
    endif

    if ( at_BoundariesGrid_ND_first ) then
       at_BoundariesGrid_ND_first = .false.

       if (allocated(alu)) deallocate(alu)
       if (allocated(kp)) deallocate(kp)

       allocate(alu(0:im,0:km),kp(0:im))

       tt_data = 0
       do k=0,km
          tt_data(k,k)=1.0
       enddo
       tg_data = ag_at(tt_data)
       alu = transpose(tg_data)

       tg_data = ag_at(at_dx_at(tt_data))
       alu(0,:)  = tg_data(:,0)

       call ludecomp(alu,kp)
    endif

    ag_data = ag_at(at_data)
    ag_data(:,0)  = value1
    ag_data(:,im) = value2
    at_data = lusolve(alu,kp,ag_data)

  end subroutine at_BoundariesGrid_ND_2d

  subroutine at_BoundariesGrid_ND_1d(t_data,values)
    !
    ! Neumann 型境界条件の適用(実空間での評価, 1 次元配列用)
    ! i=0 で勾配の値, i=im で値を与える.
    !
    real(8), dimension(0:km),intent(inout)       :: t_data
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    real(8), dimension(2), intent(in), optional  :: values
    !(in) 境界値

    real(8), dimension(1,0:km)                   :: at_work
    real(8), dimension(1,2)                      :: vwork           ! 境界値

    if (.not. present(values)) then
       vwork(1,1)=0 ; vwork(1,2)=0
    else
       vwork(1,:) = values
    endif

    at_work(1,:)=t_data
    call at_BoundariesGrid_ND_2d(at_work,vwork)
    t_data=at_work(1,:)

  end subroutine at_BoundariesGrid_ND_1d

!---- Neumann 型境界条件 ----

  subroutine at_BoundariesGrid_NN_2d(at_data,values)
    !
    ! Neumann 型境界条件の適用(実空間での評価, 2 次元配列用)
    ! 両境界で勾配の値を与える.
    !
    real(8), dimension(:,0:),intent(inout)         :: at_data
    !(inout) 境界条件を適用するチェビシェフデータ(m,0:km)

    real(8), dimension(:,:), intent(in), optional  :: values
    !(in) 境界値(m,2)

    real(8), dimension(:,:), allocatable     :: alu
    integer, dimension(:), allocatable       :: kp
    real(8), dimension(size(at_data,1),0:im) :: ag_data
    real(8), dimension(0:km,0:km)            :: tt_data
    real(8), dimension(0:km,0:im)            :: tg_data
    real(8), dimension(size(at_data,1))      :: value1, value2  ! 境界値

    integer :: k
    save    :: alu, kp

    if ( im /= km ) then
       call MessageNotify('E','at_BoundariesGrid_NN', &
            'Chebyshev truncation and number of grid points should be same.')
    endif

    if ( size(at_data,2)-1 < km ) then
       call MessageNotify('E','at_BoundariesGrid_NN', &
            'The Chebyshev dimension of input data too small.')
    elseif ( size(at_data,2)-1 > km ) then
       call MessageNotify('W','at_BoundariesGrid_NN', &
            'The Chebyshev dimension of input data too large.')
    endif

    if (.not. present(values)) then
       value1=0 ; value2=0
    else
       value1 = values(:,1) ; value2 = values(:,2)
    endif

    if ( at_BoundariesGrid_NN_first ) then
       at_BoundariesGrid_NN_first = .false.

       if (allocated(alu)) deallocate(alu)
       if (allocated(kp)) deallocate(kp)

       allocate(alu(0:im,0:km),kp(0:im))

       tt_data = 0
       do k=0,km
          tt_data(k,k)=1.0
       enddo
       tg_data = ag_at(tt_data)
       alu = transpose(tg_data)

       tg_data = ag_at(at_dx_at(tt_data))
       alu(0,:)  = tg_data(:,0)
       alu(im,:) = tg_data(:,im)

       call ludecomp(alu,kp)
    endif

    ag_data = ag_at(at_data)
    ag_data(:,0)  = value1
    ag_data(:,im) = value2
    at_data = lusolve(alu,kp,ag_data)

  end subroutine at_BoundariesGrid_NN_2d

  subroutine at_BoundariesGrid_NN_1d(t_data,values)
    !
    ! Neumann 型境界条件の適用(実空間での評価, 1 次元配列用)
    ! 両境界で勾配の値を与える.
    !
    real(8), dimension(0:km),intent(inout)       :: t_data
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    real(8), dimension(2), intent(in), optional  :: values
    !(in) 境界値

    real(8), dimension(1,0:km)                   :: at_work
    real(8), dimension(1,2)                      :: vwork           ! 境界値

    if (.not. present(values)) then
       vwork(1,1)=0 ; vwork(1,2)=0
    else
       vwork(1,:) = values
    endif

    at_work(1,:)=t_data
    call at_BoundariesGrid_NN_2d(at_work,vwork)
    t_data=at_work(1,:)

  end subroutine at_BoundariesGrid_NN_1d

! ---- 終了処理 ----
  subroutine at_Finalize
    !
    ! モジュールの終了処理(割り付け配列の解放)をおこなう.
    !
    if ( .not. at_initialize ) then
       call MessageNotify('W','at_Finalize',&
            'at_module not initialized yet')
       return
    endif

    deallocate(t)                  ! 変換用配列

    deallocate(g_X)
    deallocate(g_X_Weight)       ! 格子点座標格納配列

    at_initialize = .false.

    at_BoundariesTau_DD_first = .true.
    at_BoundariesTau_DN_first = .true.
    at_BoundariesTau_ND_first = .true.
    at_BoundariesTau_NN_first = .true.
    at_BoundariesGrid_DD_first = .true.
    at_BoundariesGrid_DN_first = .true.
    at_BoundariesGrid_ND_first = .true.
    at_BoundariesGrid_NN_first = .true.

    call MessageNotify('M','at_Finalize','at_module (2013/07/06) is finalized')

  end subroutine at_Finalize

end module at_module

!----------------------------------------------------------------------
! Copyright (c) 2002-2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_module テストプログラム
!
!履歴  2002/04/10  竹広真一
!      2007/10/25  竹広真一  エラーメッセージ追加
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!
program at_test_weight

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_module
  implicit none
  integer, parameter :: im=32, km=32
  real(8), parameter :: xmin=0.0D0, xmax=2.0D0
  real(8), dimension(0:im) :: g_z
  real(8), parameter       :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10
  integer :: i

  call MessageNotify('M','at_test_weight', &
    & 'Test of g_X_Weight')

  do i=1,2
    call at_initial(im,km/i,xmin,xmax)
    g_z(:) = 1.0d0
    call check0d( sum(g_z*g_x_weight), 2.0d0, &
      & 'z=1, int_0^2 z dx = 2')
    g_z(:) = g_x**2
    call check0d( sum(g_z*g_x_weight), 8.0d0/3.0d0, &
      & 'z=x**2, int_0^2 z dx = 8/3')
    g_z(:) = sin(pi*g_x/2)
    call check0d( sum(g_z*g_x_weight), 4.0d0/pi, &
      & 'z=sin(pi*x/2), int_0^2 z dx = 4/pi')
  end do

  call MessageNotify('M','Test of g_X_Weight', &
    'Test of g_X_Weight suceeded!')

contains

  subroutine check0d(var,true,funcname)
    real(8) :: var
    real(8) :: true
    character(len=*), optional :: funcname

    call AssertEqual(&
      & message = funcname,   &
      & answer  = true,       &
      & check   = var,        &
      significant_digits = check_digits, ignore_digits = ignore   &
      )
  end subroutine check0d

end program at_test_weight

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wa_zonal_module_svpack テストプログラム :: 積分・平均関数のテスト
!
!履歴  2017/03/06  竹広真一
!
program wa_zonal_module_svpack_integral

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wa_zonal_module_svpack
  use dc_trace, only : SetDebug
  implicit none

  integer, parameter :: im=1, jm=64, nm=42, km=2

  real(8), dimension(0:im-1,1:jm,km) ::  xya_data            ! 元の関数
  real(8), dimension(0:im-1,km)      ::  xa_idata            ! 積分・平均の正解
  real(8), dimension(1:jm,km)        ::  ya_idata            ! 積分・平均の正解
  real(8), dimension(km)             ::  a_idata             ! 積分・平均の正解

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  real(8) :: pi

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','wa_zonal_module_svpack_integral_test', &
                         'wa_zonal_module_svpack integral/average function tests') 

  call wa_Initial( nm, im, jm, km )

  !---- 積分のテスト ----
  xya_data(:,:,1) = sin(xy_Lat)**2
  xya_data(:,:,2) = sin(xy_Lat)**4

  a_idata(1) = 4*pi/3       ! a_IntLonLat_xya
  a_idata(2) = 4*pi/5       ! a_IntLonLat_xya
  call AssertEqual(&
    message='a_IntLonLat_xya',                                    &
    answer = a_idata,                                             &
    check = a_IntLonLat_xya(xya_data),                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ya_idata(:,1) = 2*pi*sin(y_Lat)**2       ! y_IntLon_xya
  ya_idata(:,2) = 2*pi*sin(y_Lat)**4       ! y_IntLon_xya
  call AssertEqual(&
    message='ya_IntLon_xya',                                      &
    answer = ya_idata,                                            &
    check = ya_IntLon_xya(xya_data),                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='a_IntLat_ya',                                        &
    answer = a_idata,                                             &
    check = a_IntLat_ya(ya_idata),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xa_idata(:,1) = 2.0D0/3       ! x_IntLat_xya
  xa_idata(:,2) = 2.0D0/5       ! x_IntLat_xya
  call AssertEqual(&
    message='xa_IntLat_xya',                                      &
    answer = xa_idata,                                            &
    check = xa_IntLat_xya(xya_data),                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='a_IntLon_xa',                                        &
    answer = a_idata,                                             &
    check = a_IntLon_xa(xa_idata),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 平均のテスト ----
  xya_data(:,:,1) = sin(xy_Lat)**2
  xya_data(:,:,2) = sin(xy_Lat)**4

  a_idata(1) = 1.0D0/3       ! AvrLonLat_xya
  a_idata(2) = 1.0D0/5       ! AvrLonLat_xya
  call AssertEqual(&
    message='a_AvrLonLat_xya',                                    &
    answer = a_idata,                                             &
    check = a_AvrLonLat_xya(xya_data),                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ya_idata(:,1) = sin(y_Lat)**2       ! y_AvrLon_xya
  ya_idata(:,2) = sin(y_Lat)**4       ! y_AvrLon_xya
  call AssertEqual(&
    message='ya_AvrLon_xya',                                      &
    answer = ya_idata,                                            &
    check = ya_AvrLon_xya(xya_data),                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='a_AvrLat_ya',                                        &
    answer = a_idata,                                             &
    check = a_AvrLat_ya(ya_idata),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xa_idata(:,1) = 1.0D0/3       ! x_AvrLat_xya
  xa_idata(:,2) = 1.0D0/5       ! x_AvrLat_xya
  call AssertEqual(&
    message='xa_AvrLat_xya',                                      &
    answer = xa_idata,                                            &
    check = xa_AvrLat_xya(xya_data),                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='a_AvrLon_xa',                                        &
    answer = a_idata,                                             &
    check = a_AvrLon_xa(xa_idata),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wa_zonal_module_svpack_integral_test', &
       'wa_zonal_module_svpack integral/average function tests succeeded!') 

end program wa_zonal_module_svpack_integral

!----------------------------------------------------------------------
!     Copyright (c) 2010--2011 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wtq_mpi_module テストプログラム
!
!      トロイダルポテンシャルの境界値問題
!
!履歴  2010/04/18  竹広真一   wt_module_sjpack_test_torvelbc.f90 より改造
!      2011/09/14  竹広真一   MPI 並列化
!      2011/09/14  竹広真一   wtq_mpi_module 用に改造
!
program wtq_mpi_module_torvelbc_wt_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wtq_mpi_module
  use mpi

  implicit none

  integer,parameter  :: im=32, jm=16         ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: kmo=16, kmi=10       ! 格子点の設定(球殻動径, 球動径)
  integer,parameter  :: nm=10                ! 切断波数の設定(水平)
  integer,parameter  :: lmo=16, lmi=16       ! 切断波数の設定(球殻動径, 球動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), dimension(0:im-1,1:jm,0:kmo)           :: xyz_TorVel0
  real(8), dimension(0:im-1,1:jm,0:kmo)           :: xyz_TorVel
  real(8), dimension((nm+1)*(nm+1),0:lmo)   :: wt_TorVel
  real(8), dimension(0:im-1,1:jm,0:kmo)     :: xyz_Zero = 0.0D0
  character(len=2), dimension(4),parameter :: BCond=(/'FF','FR','RF','RR'/)

  real(8), dimension(0:im-1,1:jm,0:kmo)           :: xyz_True

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8), parameter  :: pi=3.1415926535897932385D0

  integer :: l
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wtq_mpi_module_torvelbc_wt_test', &
       'wtq_mpi_module wt_TorgBoundariesGrid subroutine test')

  call wtq_mpi_Initial(im,jm,kmi,kmo,nm,lmi,lmo,ri,ro)

  do l=1,4

     ! P_10
     !xyz_TorVel = sin(xyz_lat) * cos( pi*(xyz_rad-ri)/(ro-ri) )
     ! P_1_1
     !xyz_TorVel = cos(xyz_lat)*cos(xyz_lon)* cos( pi*(xyz_rad-ri)/(ro-ri) )
     xyz_TorVel = 2*sin(xyz_lat)**2 * cos( pi*(xyz_rad-ri)/(ro-ri) )

     xyz_TorVel0 = xyz_TorVel
     wt_TorVel = wt_xyz(xyz_TorVel)
     call wt_TorBoundariesGrid(wt_TorVel,cond=BCond(l),new=.true.)
     xyz_TorVel = xyz_wt(wt_TorVel)

     ! 内部チェック
     call AssertEqual(&
          message='wt_TorBoundariesGrid_wt (intenal value)',            &
          answer = xyz_Torvel(:,:,1:kmo-1),                              &
          check = xyz_Torvel0(:,:,1:kmo-1),                              &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     ! 上端境界チェック
     if( BCond(l)(1:1) == 'F' ) then
        xyz_True = xyz_wt(wt_DRad_wt(wt_xyz(xyz_TorVel/xyz_Rad)))
     else
        xyz_True = xyz_TorVel
     endif

     call AssertEqual(&
          message='wt_TorvelBoundariesGrid_wt ('//BCond(l)//'-Top B.C)',&
          answer = xyz_Zero(:,:,0),                                     &
          check = xyz_True(:,:,0),                                      &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     ! 下端境界チェック
     if( BCond(l)(2:2) == 'F' ) then
        xyz_True = xyz_wt(wt_DRad_wt(wt_xyz(xyz_TorVel/xyz_Rad)))
     else
        xyz_True = xyz_TorVel
     endif

     call AssertEqual(&
          message='wt_TorvelBoundariesGrid_wt ('//BCond(l)//'-Bottom B.C)',&
          answer = xyz_Zero(:,:,kmo),                                    &
          check = xyz_True(:,:,kmo),                                     &
          significant_digits = check_digits, ignore_digits = ignore     &
          )
  enddo

  call MessageNotify('M','wtq_mpi_module_torvelbc_wt_test', &
       'wtq_mpi_module wt_TorvelBoundariesGrid subroutine test succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wtq_mpi_module_torvelbc_wt_test

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  la_module テストプログラム :: 積分・平均関数のテスト
!
!履歴  2009/09/22  竹広真一
!
program la_module_integral_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use la_module
  use dc_trace, only : SetDebug
  implicit none

  integer, parameter :: jm=64, nm=42, km=2

  real(8), dimension(1:jm,km)        ::  ya_data            ! 元の関数
  real(8), dimension(km)             ::  a_idata            ! 積分・平均の正解
  real(8), parameter                 ::  eps = 1.0D-10
  real(8) :: pi

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','la_module_integral_test', &
                         'la_module integral/average function tests') 

  call la_Initial( nm, jm )

  !---- 積分のテスト ----
  ya_data(:,1) = pi*sin(y_Lat)**2
  ya_data(:,2) = pi*sin(y_Lat)**4

  a_idata(1) = 2*pi/3       ! a_IntLat_ya
  a_idata(2) = 2*pi/5       ! a_IntLat_ya

  call AssertEqual(&
    message='Test of a_IntLat_ya',                                &
    answer = a_idata,                                             &
    check = a_IntLat_ya(ya_data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 平均のテスト ----
  ya_data(:,1) = 0.5*sin(y_Lat)**2
  ya_data(:,2) = 0.5*sin(y_Lat)**4

  a_idata(1) = 1.0D0/6       ! a_AvrLonLat_ya
  a_idata(2) = 1.0D0/10      ! a_AvrLonLat_ya

  call AssertEqual(&
    message='Test of a_AvrLat_ya',                                &
    answer = a_idata,                                             &
    check = a_AvrLat_ya(ya_data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','la_module_integral_test', &
       'la_module integral/average function tests succeeded!') 

end program la_module_integral_test

!----------------------------------------------------------------------
!     Copyright (c) 2009 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_zonal_module_sjpack テストプログラム :: スペクトル解析関数のテスト
!
!履歴  2009/09/22  竹広真一
!
program w_zonal_module_sjpack_spectrum

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_zonal_module_sjpack
  implicit none

  integer, parameter :: im=1, jm=8, nm=10

  real(8), dimension(nm+1)        ::  w_data
  real(8), dimension(0:im-1,1:jm) ::  xy_data

  real(8), dimension(0:nm,-nm:nm) ::  nm_data
  real(8), dimension(0:nm)        ::  n_data
  real(8)                         ::  data

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  integer :: n,m

  call w_Initial( nm, im, jm )

  call MessageNotify('M','w_zonal_module_sjpack_spectrum_test',&
                         'w_zonal_module_sjpack spectrum function tests') 

  !================= 2Y_1^0+3Y_2^0 のテスト ================
  xy_data = 2*sqrt(3.0D0)*sin(xy_Lat) &                  ! 2Y_1^0+3Y_2^0
          + 3*sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)
  w_data = w_xy(xy_data)

  !--------- Energy spectrum ---------
  nm_data=w_spectrum_VMiss
  do n=0,nm
     do m=-n,n
        nm_data(n,m) = 0.0
     enddo
  enddo
  nm_data(1,0) = 4.0D0 ;   nm_data(2,0) = 27.0D0

  call AssertEqual(&
    message='nm_EnergyFromStreamFunc',                            &
    answer = nm_data,                                             &
    check = nm_EnergyFromStreamfunc_w(w_data),                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  n_data = 0.0; n_data(1) = 4.0D0 ;   n_data(2) = 27.0D0

  call AssertEqual(&
    message='n_EnergyFromStreamFunc',                             &
    answer = n_data,                                              &
    check = n_EnergyFromStreamfunc_w(w_data),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  data = 0.0D0
  nm_data = nm_EnergyFromStreamfunc_w(w_data)
  do n=0,nm
     do m=-n,n
        data = data + nm_data(n,m)
     enddo
  enddo

  call AssertEqual(&
    message='total energy by nm-spectrum',                       &
    answer =  AvrLonLat_xy( &
              0.5*(xy_GradLon_w(w_data)**2+xy_GradLat_w(w_data)**2) ),&
    check = data,                                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='total energy by n-spectrum',                        &
    answer =  AvrLonLat_xy( &
              0.5*(xy_GradLon_w(w_data)**2+xy_GradLat_w(w_data)**2) ),&
    check = sum(n_EnergyFromStreamfunc_w(w_data)),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !--------- Enstrophy spectrum ---------
  nm_data=w_spectrum_VMiss
  do n=0,nm
     do m=-n,n
        nm_data(n,m) = 0.0
     enddo
  enddo

  nm_data(1,0) = 8.0D0 ;   nm_data(2,0) = 162.0D0

  call AssertEqual(&
    message='nm_EnstrophyFromStreamFunc',                         &
    answer = nm_data,                                             &
    check = nm_EnstrophyFromStreamfunc_w(w_data),                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  n_data = 0.0; n_data(1) = 8.0D0 ;   n_data(2) = 162.0D0

  call AssertEqual(&
    message='n_EnstrophyFromStreamFunc',                          &
    answer = n_data,                                              &
    check = n_EnstrophyFromStreamfunc_w(w_data),                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  data = 0.0D0
  nm_data = nm_EnstrophyFromStreamfunc_w(w_data)
  do n=0,nm
     do m=-n,n
        data = data + nm_data(n,m)
     enddo
  enddo

  call AssertEqual(&
    message='total enstrophy by nm-spectrum',                     &
    answer = AvrLonLat_xy( 0.5*(xy_w(w_Lapla_w(w_data))**2)),     &
    check = data,                                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='total enstrophy by n-spectrum',                      &
    answer = AvrLonLat_xy( 0.5*(xy_w(w_Lapla_w(w_data))**2)),     &
    check = sum(n_EnstrophyFromStreamfunc_w(w_data)),             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','w_zonal_module_sjpack_spectrum_test',&
                         'w_zonal_module_sjpack spectrum function tests succeeded!')

end program w_zonal_module_sjpack_spectrum

!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  eq_module テストプログラム
!      渦度から流線を求める関数
!
!履歴  2008/04/13  竹広真一  
!      
!
program eq_test_Vor2Strm

  use dc_message, only : MessageNotify
  use eq_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=16             ! 格子点の設定(Phi,Rad)
  integer, parameter :: km=10, lm=21             ! 切断波数の設定(Phi,Rad)

 !---- 座標変数など ----
  real(8), parameter :: ra=1.5

  real(8), parameter :: eps = 1.0d-8            ! 判定誤差

  real(8)            :: rp_Vor(jm,0:im-1)     ! 格子データ
  real(8)            :: rp_Psi(jm,0:im-1)     ! 格子データ
  real(8)            :: rp_Vor_sol(jm,0:im-1) ! 格子データ
  real(8)            :: rp_Psi_sol(jm,0:im-1) ! 格子データ
  real(8)            :: rp_dPsidr(jm,0:im-1)  ! 格子データ
  real(8)            :: rp_d2Psidr2(jm,0:im-1)! 格子データ

  real(8)            :: eq_Psi(-km:km,0:lm)   ! スペクトルデータ

  integer            :: k=2

  call MessageNotify('M','eq_test_Vor2Strm', &
       'eq_module Stream function calculation from vorticity tests')

 !---------------- 座標値の設定 ---------------------
  call eq_Initial(im,jm,km,lm,ra)                ! スペクトル初期化

!----- eq_Vor2Strm (F) ------
  rp_Psi_sol = sin(k*rp_Phi)*rp_Rad**k*(rp_Rad**2-ra**2)**3

  rp_Vor_sol = rp_er(er_Lapla_eq(eq_rp(rp_Psi_sol)))
  eq_Psi = eq_Vor2Strm_eq(eq_rp(rp_Vor_sol),cond='F',new=.true.)
  rp_Psi = rp_eq(eq_Psi)
  rp_Vor = rp_er(er_Lapla_eq(eq_Psi))
  rp_d2Psidr2 = rp_eq(eq_RadDRad_eq(eq_RadDRad_eq(eq_Psi)) &
                      -2.0D0*eq_RadDRad_eq(eq_Psi))/rp_Rad**2

  call check2d(rp_Psi - rp_Psi_sol, eps, &
           'F-B.C. eq_Vor2Strm_eq Stream function test')

  call check2d(rp_Vor - rp_Vor_sol, eps, &
           'F-B.C. eq_Vor2Strm_eq Vorticity test')

  if ( maxval(abs(rp_Psi(jm,:))) > eps  ) then
     call MessageNotify('E','Test of eq_Vor2Strm', &
          'Kinematic B.C. error too large.')
  endif
  if ( maxval(abs(rp_d2Psidr2(jm,:))) > eps  ) then
     call MessageNotify('E','Test of eq_Vor2Strm', &
          'Free B.C. error too large.')
  endif

  call MessageNotify('M','Test of eq_Vor2Strm','Test of F-b.c. suceeded!')

!----- eq_Vor2Strm (R) ------
  rp_Psi_sol = sin(k*rp_Phi)*rp_Rad**k*(rp_Rad**2-ra**2)**2
  rp_Vor_sol = rp_er(er_Lapla_eq(eq_rp(rp_Psi_sol)))
  eq_Psi = eq_Vor2Strm_eq(eq_rp(rp_Vor_sol),cond='R',new=.true.)
  rp_Psi = rp_eq(eq_Psi)
  rp_Vor = rp_er(er_Lapla_eq(eq_Psi))
  rp_dPsidr = rp_eq(eq_RadDRad_eq(eq_Psi))/rp_Rad

  call check2d(rp_Psi - rp_Psi_sol, eps, &
           'R-B.C. eq_Vor2Strm_eq Stream function test')

  call check2d(rp_Vor - rp_Vor_sol, eps, &
           'R-B.C. eq_Vor2Strm_eq Vorticity test')

  if ( maxval(abs(rp_Psi(jm,:))) > eps  ) then
     call MessageNotify('E','Test of eq_Vor2Strm', &
          'Kinematic B.C. error too large.')
  endif
  if ( maxval(abs(rp_dPsidr(jm,:))) > eps  ) then
     call MessageNotify('E','Test of eq_Vor2Strm', &
          'Rigid B.C. error too large.')
  endif

  call MessageNotify('M','Test of eq_Vor2Strm','Test of R-b.c. suceeded!')

  call MessageNotify('M','eq_test_Vor2Strum', &
       'eq_module Stream function calculation from vorticity tests')

contains

  subroutine check2d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:)                ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    integer i, j

    if ( present(funcname) )then
       write(6,*) '  Checking ', funcname, '...'
    endif

    do i=1,size(var,1)
       do j=1,size(var,2)
          if (abs(var(i,j)) .gt. eps ) then
             write(6,*) &
                  '    Value larger than EPS : i= ', i, '  j= ', j, var(i,j)
             call MessageNotify('E','eq_test_Vor2strm', &
                  'error too large')
          endif
       enddo
    enddo
  end subroutine check2d

end program eq_test_Vor2Strm

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  la_module_svpack テストプログラム :: 補間関数のテスト
!
!履歴  2017/03/06  竹広真一
!
program la_module_svpack_interpolate

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use la_module_svpack
  implicit none

  integer, parameter :: jm=8, nm=10, km=3

  real(8), dimension(0:nm,km)   ::  la_data
  real(8), dimension(1:jm,km)   ::  ya_data

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  real(8) :: Alat
  real(8), dimension(km) :: a_data_sol
  real(8) :: pi

  pi = atan(1.0D0)*4.0D0
  Alat = pi/3

  call la_Initial( nm, jm )

  call MessageNotify('M','la_module_svpack_interpolate_test', &
                         'la_module_svpack interpolate function tests') 


  !---- P_1 のテスト ----
  ya_data(:,1)  = sqrt(3.0D0)*sin(y_Lat)                      ! P_1
  a_data_sol(1) = sqrt(3.0D0)*sin(ALat)

  ya_data(:,2)  = sqrt(5.0D0)*(3.0/2*sin(y_Lat)**2-1/2.0)    ! P_2
  a_data_sol(2) = sqrt(5.0D0)*(3.0/2*sin(alat)**2-1.0/2)

  ya_data(:,3)  = sqrt(7.0D0)*(5.0/2*sin(y_Lat)**3-3*sin(y_Lat)/2.0) ! P_3
  a_data_sol(3) = sqrt(7.0D0)*(5.0/2*sin(alat)**3-3.0*sin(alat)/2)

  la_data = la_ya(ya_data)

  call AssertEqual(&
    message='P_* Test of interpolate function',                   &
    answer = a_data_sol,                                          &
    check = a_Interpolate_la(la_data,alat),                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的な関数のテスト ----
  ya_data(:,1)  = (sin(y_Lat)-1)**2*(sin(y_Lat)-0.5)*(sin(y_Lat)+1)
  a_data_sol(1) = (sin(ALat)-1)**2*(sin(ALat)-0.5)*(sin(ALat)+1)
  ya_data(:,2)  = (sin(y_Lat)-1)**2*(sin(y_Lat)+1)**2
  a_data_sol(2) = (sin(aLat)-1)**2*(sin(aLat)+1)**2
  ya_data(:,3)  = (sin(y_Lat)-1)**3*(sin(y_Lat)+1)
  a_data_sol(3) = (sin(aLat)-1)**3*(sin(aLat)+1)

  la_data = la_ya(ya_data)

  call AssertEqual(&
    message='generaul function Test of interpolate function',     &
    answer = a_data_sol,                                          &
    check = a_Interpolate_la(la_data,alat),                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','la_module_svpack_interpolate_test', &
                         'la_module_svpack interpolate function tests succeeded!') 

end program la_module_svpack_interpolate

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wa_interpolate_module_svpack テストプログラム :: 補間関数のテスト
!
!履歴  2016/04/21  竹広真一 wa_interpolate_module_sjpack_test.f90 より SVPACK 用に改造
!
program wa_interpolate_module_svpack_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wa_module_svpack
  implicit none

  integer, parameter :: im=32, jm=16, nm=10, km=3

  real(8), dimension((nm+1)**2,km) ::  wa_data
  real(8), dimension(0:im-1,1:jm,km)     ::  xya_data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: Alon
  real(8) :: Alat
  real(8), dimension(km) :: a_data_sol
  real(8) :: pi

  pi = atan(1.0D0)*4.0D0
  Alon = pi/5 ; Alat = pi/3

  call wa_Initial( nm, im, jm, km )

  call MessageNotify('M','wa_test_Interpolate', &
                         'wa_interpolate_module interpolate(00) tests') 


  !---- Y_1^* のテスト ----
  xya_data(:,:,1) = sqrt(3.0D0)*sin(xy_Lat)                      ! Y_1^0
  a_data_sol(1) = sqrt(3.0D0)*sin(ALat)

  xya_data(:,:,2) = sqrt(3.0D0/2)*cos(xy_Lat)*cos(xy_Lon)          ! Y_1^1
  a_data_sol(2) = sqrt(3.0D0/2)*cos(ALat)*cos(ALon)

  xya_data(:,:,3)   = -sqrt(3.0D0)*cos(xy_Lat)*sin(xy_Lon)         ! Y_1^{-1}
  a_data_sol(3) = -sqrt(3.0D0)*cos(ALat)*sin(ALon)

  wa_data = wa_xya(xya_data)

  call AssertEqual(&
    message='a_Interpolate_wa with Y_1^*',                        &
    answer = a_Interpolate_wa(wa_data,alon,alat),                 &
    check =  a_data_sol,                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^* のテスト ----
  xya_data(:,:,1) = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)            ! Y_2^0
  a_data_sol(1) = sqrt(5.0D0)*(3.0/2*sin(alat)**2-1.0/2)
  xya_data(:,:,2) = sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)!Y_2^1
  a_data_sol(2) = sqrt(5.0D0/6)*3.0*sin(ALat)*cos(ALat) * cos(ALon)
  xya_data(:,:,3) = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(2*xy_Lon)    ! Y_2^-2
  a_data_sol(3) = -sqrt(5.0D0/24)*3.0*cos(ALat)**2*sin(2*ALon)

  wa_data = wa_xya(xya_data)

  call AssertEqual(&
    message='a_Interpolate_wa with Y_2^*',                        &
    answer = a_Interpolate_wa(wa_data,alon,alat),                 &
    check =  a_data_sol,                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的なのテスト ----
  xya_data(:,:,1) = cos(2*xy_Lon-pi/3) &
       *(sin(xy_Lat)-1)**2*(sin(xy_Lat)-0.5)*(sin(xy_Lat)+1)
  a_data_sol(1) = cos(2*ALon-pi/3) &
       *(sin(ALat)-1)**2*(sin(ALat)-0.5)*(sin(ALat)+1)
  xya_data(:,:,2) = sin(2*xy_Lon-pi/3)*(sin(xy_Lat)-1)**2*(sin(xy_Lat)+1)**2
  a_data_sol(2) = sin(2*aLon-pi/3)*(sin(aLat)-1)**2*(sin(aLat)+1)**2
  xya_data(:,:,3) = sin(2*xy_Lon+pi/3)*(sin(xy_Lat)-1)**3*(sin(xy_Lat)+1)
  a_data_sol(3) = sin(2*aLon+pi/3)*(sin(aLat)-1)**3*(sin(aLat)+1)

  wa_data = wa_xya(xya_data)

  call AssertEqual(&
    message='a_Interpolate_wa with a general function',           &
    answer = a_Interpolate_wa(wa_data,alon,alat),                 &
    check =  a_data_sol,                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wa_Interpolate_module_svpack_test', &
                      'wa_interpolate_module_svpack function tests succeeded') 

end program wa_interpolate_module_svpack_test

!------------------------------------------------------------------------
! Copyright (c) 2008-2010 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  eee_module テストプログラム (微分計算)
!
!履歴  2008/05/03  竹広真一
!      2008/05/10  竹広真一  解像度複数設定チェック
!      2010/03/21  佐々木洋平 判定誤差を修正
!
program eee_test_derivative

  use dc_message, only : MessageNotify
  use eee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=64, km=16          ! 格子点の設定(X,Y,Z)
  integer, parameter :: lm=10, mm=21, nm=5          ! 切断波数の設定(X,Y,Z)

  integer, parameter :: im2=64, jm2=64, km2=64       ! 格子点の設定(X,Y,Z)
  integer, parameter :: lm2=21, mm2=21, nm2=21       ! 切断波数の設定(X,Y,Z)

 !---- 変数 ----
  real(8)            :: zyx_Data(0:km-1,0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: zyx_Deriv(0:km-1,0:jm-1,0:im-1)   ! 格子データ

  real(8)            :: zyx_Data2(0:km2-1,0:jm2-1,0:im2-1)    ! 格子データ
  real(8)            :: zyx_Deriv2(0:km2-1,0:jm2-1,0:im2-1)   ! 格子データ

  integer            :: l=2, m=3, n=5
  integer            :: id1, id2

 !---- 座標変数など ----
  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: eps = 1.0d-9            ! 判定誤差

  call MessageNotify('M','eee_test_derivative', &
       'eee_module derivative function tests')

 !---------------- 座標値の設定 ---------------------
  call eee_initial(im,jm,km,lm,mm,nm,id1)
  call eee_initial(im2,jm2,km2,lm2,mm2,nm2,id2)

 !------------------- 初期値設定 ----------------------
  write(6,*) '*** Test of eee_module : derivative function check.'
  write(6,*) '  The result will be printed '
  write(6,*) '  only when the error is larger than ', eps
  write(6,*)

!!$  write(6,*) '  Input wavenumbers of the grid data, l,m and n :'
!!$  read(5,*) l,m,n
  write(6,*) '  l,m,n = ', l,m,n

  ! id1
  write(*,*) 'for id1'
  call eee_ChangeResolution(id1)

  zyx_Data = sin(l*zyx_X) * sin(m*zyx_Y) * sin(n*zyx_Z)
  zyx_Deriv = l*cos(l*zyx_X) * sin(m*zyx_Y)* sin(n*zyx_Z)
  call check3d(zyx_eee(eee_Dx_eee(eee_zyx(zyx_Data)))-zyx_Deriv, &
       eps, 'Dx(sin(l*X)*sin(m*Y)*sin(n*Z))')
  zyx_Deriv = m*sin(l*zyx_X) * cos(m*zyx_Y) * sin(n*zyx_Z)
  call check3d(zyx_eee(eee_Dy_eee(eee_zyx(zyx_Data)))-zyx_Deriv, &
       eps, 'Dy(sin(l*X)*sin(m*Y)*sin(n*Z))')
  zyx_Deriv = n*sin(l*zyx_X) * sin(m*zyx_Y) * cos(n*zyx_Z)
  call check3d(zyx_eee(eee_Dz_eee(eee_zyx(zyx_Data)))-zyx_Deriv, &
       eps, 'Dz(sin(l*X)*sin(m*Y)*sin(n*Z))')

  zyx_Deriv = -(l**2 + m**2 + n**2) &
                 * sin(l*zyx_X) * sin(m*zyx_Y) * sin(n*zyx_Z)
  call check3d(zyx_eee(eee_Lapla_eee(eee_zyx(zyx_Data)))-zyx_Deriv, &
       eps, 'Lapla(sin(l*X)*sin(m*Y)*sin(n*Z))')
  zyx_Deriv = -1.0/(l**2 + m**2+ n**2) &
                 * sin(l*zyx_X) * sin(m*zyx_Y) * sin(n*zyx_Z)
  call check3d(zyx_eee(eee_LaplaInv_eee(eee_zyx(zyx_Data)))-zyx_Deriv, &
       eps, 'LaplaInv(sin(l*X)*sin(m*Y)*sin(n*Z))')

  zyx_Data = cos(l*zyx_X) * cos(m*zyx_Y) * cos(n*zyx_Z)
  zyx_Deriv = -l*sin(l*zyx_X) * cos(m*zyx_Y)* cos(n*zyx_Z)
  call check3d(zyx_eee(eee_Dx_eee(eee_zyx(zyx_Data)))-zyx_Deriv, &
       eps, 'Dx(cos(l*X)*cos(m*Y)*cos(n*Z))')
  zyx_Deriv = -m*cos(l*zyx_X) * sin(m*zyx_Y) * cos(n*zyx_Z)
  call check3d(zyx_eee(eee_Dy_eee(eee_zyx(zyx_Data)))-zyx_Deriv, &
       eps, 'Dy(cos(l*X)*cos(m*Y)*cos(n*Z))')
  zyx_Deriv = -n*cos(l*zyx_X) * cos(m*zyx_Y) * sin(n*zyx_Z)
  call check3d(zyx_eee(eee_Dz_eee(eee_zyx(zyx_Data)))-zyx_Deriv, &
       eps, 'Dz(cos(l*X)*cos(m*Y)*cos(n*Z))')

  zyx_Deriv = -(l**2 + m**2 + n**2) &
                 * cos(l*zyx_X) * cos(m*zyx_Y) * cos(n*zyx_Z)
  call check3d(zyx_eee(eee_Lapla_eee(eee_zyx(zyx_Data)))-zyx_Deriv, &
       eps, 'Lapla(cos(l*X)*cos(m*Y)*cos(n*Z))')
  zyx_Deriv = -1.0/(l**2 + m**2+ n**2) &
                 * cos(l*zyx_X) * cos(m*zyx_Y) * cos(n*zyx_Z)
  call check3d(zyx_eee(eee_LaplaInv_eee(eee_zyx(zyx_Data)))-zyx_Deriv, &
       eps, 'LaplaInv(cos(l*X)*cos(m*Y)*cos(n*Z))')

  ! id2
  write(*,*) 'for id2'
  call eee_ChangeResolution(id2)

  zyx_Data2 = sin(l*zyx_X) * sin(m*zyx_Y) * sin(n*zyx_Z)
  zyx_Deriv2 = l*cos(l*zyx_X) * sin(m*zyx_Y)* sin(n*zyx_Z)
  call check3d(zyx_eee(eee_Dx_eee(eee_zyx(zyx_Data2)))-zyx_Deriv2, &
       eps, 'Dx(sin(l*X)*sin(m*Y)*sin(n*Z))')
  zyx_Deriv2 = m*sin(l*zyx_X) * cos(m*zyx_Y) * sin(n*zyx_Z)
  call check3d(zyx_eee(eee_Dy_eee(eee_zyx(zyx_Data2)))-zyx_Deriv2, &
       eps, 'Dy(sin(l*X)*sin(m*Y)*sin(n*Z))')
  zyx_Deriv2 = n*sin(l*zyx_X) * sin(m*zyx_Y) * cos(n*zyx_Z)
  call check3d(zyx_eee(eee_Dz_eee(eee_zyx(zyx_Data2)))-zyx_Deriv2, &
       eps, 'Dz(sin(l*X)*sin(m*Y)*sin(n*Z))')

  zyx_Deriv2 = -(l**2 + m**2 + n**2) &
                 * sin(l*zyx_X) * sin(m*zyx_Y) * sin(n*zyx_Z)
  call check3d(zyx_eee(eee_Lapla_eee(eee_zyx(zyx_Data2)))-zyx_Deriv2, &
       eps, 'Lapla(sin(l*X)*sin(m*Y)*sin(n*Z))')
  zyx_Deriv2 = -1.0/(l**2 + m**2+ n**2) &
                 * sin(l*zyx_X) * sin(m*zyx_Y) * sin(n*zyx_Z)
  call check3d(zyx_eee(eee_LaplaInv_eee(eee_zyx(zyx_Data2)))-zyx_Deriv2, &
       eps, 'LaplaInv(sin(l*X)*sin(m*Y)*sin(n*Z))')

  zyx_Data2 = cos(l*zyx_X) * cos(m*zyx_Y) * cos(n*zyx_Z)
  zyx_Deriv2 = -l*sin(l*zyx_X) * cos(m*zyx_Y)* cos(n*zyx_Z)
  call check3d(zyx_eee(eee_Dx_eee(eee_zyx(zyx_Data2)))-zyx_Deriv2, &
       eps, 'Dx(cos(l*X)*cos(m*Y)*cos(n*Z))')
  zyx_Deriv2 = -m*cos(l*zyx_X) * sin(m*zyx_Y) * cos(n*zyx_Z)
  call check3d(zyx_eee(eee_Dy_eee(eee_zyx(zyx_Data2)))-zyx_Deriv2, &
       eps, 'Dy(cos(l*X)*cos(m*Y)*cos(n*Z))')
  zyx_Deriv2 = -n*cos(l*zyx_X) * cos(m*zyx_Y) * sin(n*zyx_Z)
  call check3d(zyx_eee(eee_Dz_eee(eee_zyx(zyx_Data2)))-zyx_Deriv2, &
       eps, 'Dz(cos(l*X)*cos(m*Y)*cos(n*Z))')

  zyx_Deriv2 = -(l**2 + m**2 + n**2) &
                 * cos(l*zyx_X) * cos(m*zyx_Y) * cos(n*zyx_Z)
  call check3d(zyx_eee(eee_Lapla_eee(eee_zyx(zyx_Data2)))-zyx_Deriv2, &
       eps, 'Lapla(cos(l*X)*cos(m*Y)*cos(n*Z))')
  zyx_Deriv2 = -1.0/(l**2 + m**2+ n**2) &
                 * cos(l*zyx_X) * cos(m*zyx_Y) * cos(n*zyx_Z)
  call check3d(zyx_eee(eee_LaplaInv_eee(eee_zyx(zyx_Data2)))-zyx_Deriv2, &
       eps, 'LaplaInv(cos(l*X)*cos(m*Y)*cos(n*Z))')

  call MessageNotify('M','eee_test_derivative', &
       'eee_module derivative function tests succeeded!')

 stop
contains

  subroutine check3d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:,:)              ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    integer i, j, k

    if ( present(funcname) )then
       write(6,*) '  Checking ', funcname, '...'
    endif

    do k=1,size(var,3)
       do j=1,size(var,2)
          do i=1,size(var,1)
             if (abs(var(i,j,k)) .gt. eps ) then
                write(6,*) &
                  '    Value larger than EPS : i= ', i, '  j= ', j, '  k= ', k, &
                  var(i,j,k)
                call MessageNotify('E','eee_test_transform', &
                  'transform error too large')
             endif
          enddo
       enddo
    enddo
  end subroutine check3d

end program eee_test_derivative

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wa_base_module_supack テストプログラム :: 基本変換関数のテスト
!
!履歴  2016/03/15  竹広真一
!      2016/03/30  竹広真一 wa_cleanup_wa 関数追加
!
program wa_base_mpi_module_supack_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wa_mpi_module_supack
  use mpi
  implicit none

  integer, parameter :: im=32, jm=16, nm=10, km=3

  real(8), allocatable ::  wa_data(:,:)
  real(8), allocatable ::  xva_data(:,:,:)
  real(8), allocatable ::  xya_data(:,:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: pi
  integer :: iproc, np, ierr

  integer :: n, k

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','wa_base_mpi_module_supack_test', &
                         'wa_base_mpi_module_supack functions tests') 

  call wa_mpi_Initial( nm, im, jm, km )

  allocate(wa_data(nc,km))
  allocate(xva_data(0:im-1,jc,km))
  allocate(xya_data(0:im-1,jm,km))

  !========================= xva_wa, wa_xva のテスト===========================

  !---- Y_1^* のテスト ----
  xva_data(:,:,1) = sqrt(3.0D0)*sin(xv_Lat)                   ! Y_1^0
  wa_data= 0.0D0 ; if ( l_nm(1,0) /= 0 ) wa_data(l_nm(1,0),1)=1.0D0
  xva_data(:,:,2) = sqrt(3.0D0/2)*cos(xv_Lat)*cos(xv_Lon)     ! Y_1^1
  if ( l_nm(1,1) /= 0 ) wa_data(l_nm(1,1),2)=1.0D0/2.0D0
  xva_data(:,:,3) = -sqrt(3.0D0/2)*cos(xv_Lat)*sin(xv_Lon)    ! Y_1^{-1}
  if ( l_nm(1,-1) /= 0 ) wa_data(l_nm(1,-1),3)=1.0D0/2.0D0

  call AssertEqual(&
    message='wa_xva with Y_1^*',                                  &
    answer = wa_cleanup_wa(wa_xva(xva_data)),                     &
    check = wa_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xva_wa with Y_1^*',                                  &
    answer = xva_wa(wa_xva(xva_data)),                            &
    check = xva_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^* のテスト ----
  xva_data(:,:,1) = sqrt(5.0D0)*(3.0/2*sin(xv_Lat)**2-1/2.0)           ! Y_2^0
  wa_data= 0.0D0 ; if ( l_nm(2,0) /= 0 ) wa_data(l_nm(2,0),1)=1.0D0
  xva_data(:,:,2) = sqrt(5.0D0/6)*3.0*sin(xv_Lat)*cos(xv_Lat)*cos(xv_Lon)!Y_2^1
  if ( l_nm(2,1) /= 0 ) wa_data(l_nm(2,1),2)=1.0D0/2.0D0
  xva_data(:,:,3) = -sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*sin(2*xv_Lon)   ! Y_2^-2
  if ( l_nm(2,-2) /= 0 ) wa_data(l_nm(2,-2),3)=1.0D0/2.0D0

  call AssertEqual(&
    message='wa_xva with Y_2^*',                                  &
    answer = wa_cleanup_wa(wa_xva(xva_data)),                     &
    check = wa_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xva_wa with Y_2^*',                                  &
    answer = xva_wa(wa_xva(xva_data)),                            &
    check = xva_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的関数のテスト ----
  xva_data(:,:,1) = cos(2*xv_Lon-pi/3) &
       *(sin(xv_Lat)-1)**2*(sin(xv_Lat)-0.5)*(sin(xv_Lat)+1)
  xva_data(:,:,2) = sin(2*xv_Lon+pi/2) &
       *(sin(xv_Lat)-1)**2*(sin(xv_Lat)+1)**2
  xva_data(:,:,3) = cos(2*xv_Lon+pi/3) &
       *(sin(xv_Lat)-1)*(sin(xv_Lat)-0.5)**2*(sin(xv_Lat)+1)

  call AssertEqual(&
    message='wa_xva, xva_wa with a general function',             &
    answer = xva_wa(wa_xva(xva_data)),                            &
    check = xva_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wa_base_mpi_module_supack_test', &
                         'wa_base_mpi_module_supack functions tests succeeded!') 

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

contains

  function wa_cleanup_wa(wa_data)
    real(8), intent(IN) :: wa_data(:,:)
    real(8)             :: wa_cleanup_wa(nc,size(wa_data,2))

    integer l,nmary(2)

    wa_cleanup_wa = wa_data

    do l=1,nc
       nmary = nm_l(l)
       if ( nmary(1) .lt. 0 ) wa_cleanup_wa(l,:) = 0.0D0
    end do

  end function wa_cleanup_wa

end program wa_base_mpi_module_supack_test

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wsc_mpi_module_spuack テストプログラム
!      積分・平均計算
!
!履歴  2017/03/27  竹広真一   wt_mpi_module_test_itegral.f90 より改造
!
program wsc_mpi_module_supack_integral_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wsc_mpi_module_supack
  use mpi

  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), dimension(0:im-1,0:km)            :: xz_Data
  real(8), dimension(0:im-1)                 :: x_Data
  real(8), dimension(0:km)                   :: z_Data
  real(8)                                    :: Data

  real(8), allocatable :: xvz_Data(:,:,:)

  real(8), allocatable :: xv_Data(:,:)
  real(8), allocatable :: vz_Data(:,:)
  real(8), allocatable :: v_Data(:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  real(8), parameter  :: pi=3.1415926535897932385D0

  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wsc_mpi_module_supack_integral_test', &
       'wsc_mpi_module_supack integration functions tests')

  call wsc_mpi_Initial(im,jm,km,nm,lm,ri,ro)

  allocate(xvz_Data(0:im-1,1:jc,0:km))

  allocate(xv_Data(0:im-1,1:jc))
  allocate(vz_Data(1:jc,0:km))
  allocate(v_Data(1:jc))
  
  !---------- 定数 ----------
  xvz_Data = 1.0D0

  vz_Data = 2*pi
  call AssertEqual(&
       message='vz_IntLon_xvz with constant field',                &
       answer = vz_Data,                                           &
       check = vz_IntLon_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xz_Data = 2.0D0
  call AssertEqual(&
       message='xz_IntLat_xvz with constant field',                &
       answer = xz_Data,                                           &
       check = xz_IntLat_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xv_Data = ro**2*(ro-ri)
  call AssertEqual(&
       message='xv_IntRad_xvz with constant field',                &
       answer = xv_Data,                                           &
       check = xv_IntRad_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  z_Data = 4*pi
  call AssertEqual(&
       message='z_IntLonLat_xvz with constant field',              &
       answer = z_Data,                                            &
       check = z_IntLonLat_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2*ro**2*(ro-ri)
  call AssertEqual(&
       message='x_IntLatRad_xvz with constant field',              &
       answer = x_Data,                                            &
       check = x_IntLatRad_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = 2*pi*ro**2*(ro-ri)
  call AssertEqual(&
       message='v_IntLonRad_xvz with constant field',              &
       answer = v_Data,                                            &
       check = v_IntLonRad_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = 4*pi*ro**2*(ro-ri)
  call AssertEqual(&
       message='IntLonLatRad_xvz with constant field',             &
       answer = Data,                                              &
       check = IntLonLatRad_xvz(xvz_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  !------------------ r -----------------------
  xvz_Data = xvz_Rad 

  vz_Data = 2*pi* xvz_Rad(1,:,:)
  call AssertEqual(&
       message='vz_IntLon_xvz with r-field',                       &
       answer = vz_Data,                                           &
       check = vz_IntLon_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xz_Data = 2.0D0 * xvz_Data(:,1,:)
  call AssertEqual(&
       message='xz_IntLat_xvz with r-field',                       &
       answer = xz_Data,                                           &
       check = xz_IntLat_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xv_Data = 1/2.0D0*ro**2*(ro**2-ri**2)
  call AssertEqual(&
       message='xv_IntRad_xvz with r field',                       &
       answer = xv_Data,                                           &
       check = xv_IntRad_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  z_Data = 4*pi * xvz_Data(1,1,:)
  call AssertEqual(&
       message='z_IntLonLat_xvz with r field',                     &
       answer = z_Data,                                            &
       check = z_IntLonLat_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = ro**2*(ro**2-ri**2)
  call AssertEqual(&
       message='x_IntLatRad_xvz with r field',                     &
       answer = x_Data,                                            &
       check = x_IntLatRad_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = pi*ro**2*(ro**2-ri**2)
  call AssertEqual(&
       message='v_IntLonRad_xvz with r field',                     &
       answer = v_Data,                                            &
       check = v_IntLonRad_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = 2*pi*ro**2*(ro**2-ri**2)
  call AssertEqual(&
       message='IntLonLatRad_xvz with r field',                   &
       answer = Data,                                             &
       check = IntLonLatRad_xvz(xvz_Data),                        &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  !--------- sin(phi)**2  ---------
  xvz_Data = sin(xvz_Lat)**2

  vz_Data = 2*pi* xvz_Data(1,:,:)
  call AssertEqual(&
       message='vz_IntLon_xvz with sin^2φ field',                 &
       answer = vz_Data,                                           &
       check = vz_IntLon_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xz_Data = 2.0D0/3.0D0
  call AssertEqual(&
       message='xz_IntLat_xvz with sin^2φ field',                 &
       answer = xz_Data,                                           &
       check = xz_IntLat_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xv_Data = ro**2*(ro-ri) * xvz_Data(:,:,1)
  call AssertEqual(&
       message='xv_IntRad_xvz with sin^2φ field',                 &
       answer = xv_Data,                                           &
       check = xv_IntRad_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  z_Data = 4*pi/3.0
  call AssertEqual(&
       message='z_IntLonLat_xvz with sin^2φ field',               &
       answer = z_Data,                                            &
       check = z_IntLonLat_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2/3.0D0*ro**2*(ro-ri)
  call AssertEqual(&
       message='x_IntLatRad_xvz with sin^2φ field',               &
       answer = x_Data,                                            &
       check = x_IntLatRad_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = 2*pi*ro**2*(ro-ri) * xvz_Data(1,:,1)
  call AssertEqual(&
       message='v_IntLonRad_xvz with sin^2φ field',               &
       answer = v_Data,                                            &
       check = v_IntLonRad_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = 4*pi/3*ro**2*(ro-ri)
  call AssertEqual(&
       message='IntLonLatRad_xvz with constant field',             &
       answer = Data,                                              &
       check = IntLonLatRad_xvz(xvz_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xvz_Data = sin(xvz_Lon)**2

  vz_Data = pi
  call AssertEqual(&
       message='vz_IntLon_xvz with sin(lambda)**2',                &
       answer = vz_Data,                                           &
       check = vz_IntLon_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xz_Data = 2.0D0 * xvz_Data(:,1,:)
  call AssertEqual(&
       message='xz_IntLat_xvz with sin(lambda)**2',                &
       answer = xz_Data,                                           &
       check = xz_IntLat_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xv_Data = ro**2*(ro-ri) * xvz_Data(:,:,1)
  call AssertEqual(&
       message='xv_IntRad_xvz with sin(lambda)**2',                &
       answer = xv_Data,                                           &
       check = xv_IntRad_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  z_Data = 2*pi
  call AssertEqual(&
       message='z_IntLonLat_xvz with sin(lambda)**2',              &
       answer = z_Data,                                            &
       check = z_IntLonLat_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2.0D0*ro**2*(ro-ri) * xvz_Data(:,1,1)
  call AssertEqual(&
       message='x_IntLatRad_xvz with sin(lambda)**2',              &
       answer = x_Data,                                            &
       check = x_IntLatRad_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = pi* ro**2*(ro-ri)
  call AssertEqual(&
       message='v_IntLonRad_xvz with sin(lambda)**2',              &
       answer = v_Data,                                            &
       check = v_IntLonRad_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLatRad_xvz with sin(lambda)**2',             &
       answer = 2*pi*ro**2*(ro-ri),                                &
       check = IntLonLatRad_xvz(xvz_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(xv) =============================
  ! 定数
  xv_Data = 1.0D0

  v_Data = 2*pi
  call AssertEqual(&
       message='v_IntLon_xv with constant field',                  &
       answer = v_Data,                                            &
       check = v_IntLon_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2.0D0
  call AssertEqual(&
       message='x_IntLat_xv with constant field',                  &
       answer = x_Data,                                            &
       check = x_IntLat_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLat_xv with constant field',                 &
       answer = 4*pi,                                              &
       check = IntLonLat_xv(xv_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xv_Data = sin(xv_Lon)**2

  v_Data = pi 
  call AssertEqual(&
       message='v_IntLon_xv with sin(lambda)**2',                  &
       answer = v_Data,                                            &
       check = v_IntLon_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2.0d0 * xv_Data(:,1)
  call AssertEqual(&
       message='x_IntLat_xv with sin(lambda)**2',                  &
       answer = x_Data,                                            &
       check = x_IntLat_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLat_xv with sin(lambda)**2',                 &
       answer = 2*pi,                                              &
       check = IntLonLat_xv(xv_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  xv_Data = sin(xv_Lat)**2

  v_Data = 2*pi* xv_Data(1,:)
  call AssertEqual(&
       message='v_IntLon_xv with sin(phi)**2',                     &
       answer = v_Data,                                            &
       check = v_IntLon_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2.0D0/3.0D0
  call AssertEqual(&
       message='x_IntLat_xv with sin(phi)**2',                     &
       answer = x_Data,                                            &
       check = x_IntLat_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLat_xv with sin(phi)**2',                    &
       answer = 4*pi/3.0,                                          &
       check = IntLonLat_xv(xv_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(vz) =============================
  ! 定数
  vz_Data = 1.0D0

  z_Data = 2.0D0
  call AssertEqual(&
       message='z_IntLat_vz with constant field',                  &
       answer = z_Data,                                            &
       check = z_IntLat_vz(vz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = ro**2*(ro-ri)
  call AssertEqual(&
       message='v_IntRad_vz with constant field',                  &
       answer = v_Data,                                            &
       check = v_IntRad_vz(vz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLatRad_vz with constant field',                 &
       answer = 2*ro**2*(ro-ri),                                   &
       check = IntLatRad_vz(vz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin^2(z)
  vz_Data = sin(PI*(xvz_Rad(0,:,:)-ri)/(ro-ri))**2
!  vz_Data = xvz_Rad(0,:,:)**2

  z_Data = 2.0D0 * vz_Data(1,:)
  call AssertEqual(&
       message='z_IntLat_vz with sin^2(z)',                        &
       answer = z_Data,                                            &
       check = z_IntLat_vz(vz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = 1/2.0D0*(ro-ri)*ro**2
  call AssertEqual(&
       message='v_IntRad_vz with sin^2(z)',                        &
       answer = v_Data,                                            &
       check = v_IntRad_vz(vz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLatRad_vz with sin^2(z)',                       &
       answer = ro**2*(ro-ri),                                     &
       check = IntLatRad_vz(vz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  vz_Data = sin(xvz_Lat(0,:,:))**2

  z_Data = 2.0D0/3.0D0
  call AssertEqual(&
       message='z_IntLat_vz with sin(phi)**2',                     &
       answer = z_Data,                                            &
       check = z_IntLat_vz(vz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = ro**2*(ro-ri) * vz_Data(:,1)
  call AssertEqual(&
       message='v_IntRad_vz with sin(phi)**2',                     &
       answer = v_Data,                                            &
       check = v_IntRad_vz(vz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLatRad_vz with sin(phi)**2',                    &
       answer = 2/3.0D0*ro**2*(ro-ri),                             &
       check = IntLatRad_vz(vz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(xz) =============================
  ! 定数
  xz_Data = 1.0D0

  z_Data = 2*pi
  call AssertEqual(&
       message='z_IntLon_xz with constant field',                  &
       answer = z_Data,                                            &
       check = z_IntLon_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = ro**2*(ro-ri)
  call AssertEqual(&
       message='x_IntRad_xz with constant field',                  &
       answer = x_Data,                                            &
       check = x_IntRad_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonRad_xz with constant field',                 &
       answer = 2*pi*ro**2*(ro-ri),                                &
       check = IntLonRad_xz(xz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xz_Data = sin(xvz_Lon(:,1,:))**2

  z_Data = pi
  call AssertEqual(&
       message='z_IntLon_xz with sin(lambda)**2',                  &
       answer = z_Data,                                            &
       check = z_IntLon_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = ro**2*(ro-ri) * xz_Data(:,1)
  call AssertEqual(&
       message='x_IntRad_xz with sin(lambda)**2',                  &
       answer = x_Data,                                            &
       check = x_IntRad_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonRad_xz with sin(lambda)**2',                 &
       answer = pi*ro**2*(ro-ri),                                  &
       check = IntLonRad_xz(xz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! cos^2(z) 
  xz_Data = spread(cos(PI*(z_Rad-ri)/(ro-ri))**2,1,im)

  z_Data = 2*pi* xz_Data(1,:)
  call AssertEqual(&
       message='z_IntLon_xz with cos^2(z)',                        &
       answer = z_Data,                                            &
       check = z_IntLon_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/2.0D0*ro**2*(ro-ri)
  call AssertEqual(&
       message='x_IntRad_xz with cos^2(z)',                        &
       answer = x_Data,                                            &
       check = x_IntRad_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonRad_xz with cos^2(z)',                       &
       answer = pi*ro**2*(ro-ri),                                  &
       check = IntLonRad_xz(xz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(x) =============================
  ! 定数
  x_Data = 1.0D0

  call AssertEqual(&
       message='IntLon_x with constant field',                     &
       answer = 2*pi,                                              &
       check = IntLon_x(x_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  x_Data = sin(x_Lon)**2

  call AssertEqual(&
       message='IntLon_x with sin(lambda)**2',                     &
       answer = pi,                                                &
       check = IntLon_x(x_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(y) =============================
  ! 定数
  v_Data = 1.0D0

  call AssertEqual(&
       message='IntLat_v with constant field',                     &
       answer = 2.0D0,                                             &
       check = IntLat_v(v_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  v_Data = sin(v_Lat)**2

  call AssertEqual(&
       message='IntLat_v with sin(phi)**2',                        &
       answer = 2.0D0/3.0D0,                                       &
       check = IntLat_v(v_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(z) =============================
  ! 定数
  z_Data = 1.0D0

  call AssertEqual(&
       message='IntRad_r with constant field',                     &
       answer = ro**2*(ro-ri),                                     &
       check = IntRad_z(z_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin^2(z)
  z_Data = sin(PI*(z_Rad-ri)/(ro-ri))**2

  call AssertEqual(&
       message='IntRad_r with sin^2(z)',                           &
       answer = 1/2.0D0*ro**2*(ro-ri),                             &
       check = IntRad_z(z_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

!============================ 平均(xvz) ==============================

 !---------- 定数 ----------
  xvz_Data = 1.0D0

  vz_Data = 1.0D0
  call AssertEqual(&
       message='vz_AvrLon_xvz with constant field',                &
       answer = vz_Data,                                           &
       check = vz_AvrLon_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xz_Data = 1.0D0
  call AssertEqual(&
       message='xz_AvrLat_xvz with constant field',                &
       answer = xz_Data,                                           &
       check = xz_AvrLat_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xv_Data = 1.0D0
  call AssertEqual(&
       message='xv_AvrRad_xvz with constant field',                &
       answer = xv_Data,                                           &
       check = xv_AvrRad_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  z_Data = 1.0D0
  call AssertEqual(&
       message='z_AvrLonLat_xvz with constant field',              &
       answer = z_Data,                                            &
       check = z_AvrLonLat_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0
  call AssertEqual(&
       message='x_AvrLatRad_xvz with constant field',              &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = 1.0D0
  call AssertEqual(&
       message='v_AvrLonRad_xvz with constant field',              &
       answer = v_Data,                                            &
       check = v_AvrLonRad_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = 1.0D0
  call AssertEqual(&
       message='AvrLonLatRad_xvz with constant field',             &
       answer = Data,                                              &
       check = AvrLonLatRad_xvz(xvz_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  !------------------ r -----------------------
  xvz_Data = xvz_Rad 

  vz_Data = xvz_Rad(1,:,:)
  call AssertEqual(&
       message='vz_AvrLon_xvz with r-field',                &
       answer = vz_Data,                                           &
       check = vz_AvrLon_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xz_Data = xvz_Data(:,1,:)
  call AssertEqual(&
       message='xz_AvrLat_xvz with r-field',                &
       answer = xz_Data,                                           &
       check = xz_AvrLat_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xv_Data = 1.0D0/2.0D0*ro**2*(ro**2-ri**2)/(ro**2*(ro-ri))
  call AssertEqual(&
       message='xv_AvrRad_xvz with r field',                &
       answer = xv_Data,                                           &
       check = xv_AvrRad_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  z_Data = xvz_Data(1,1,:)
  call AssertEqual(&
       message='z_AvrLonLat_xvz with r field',                     &
       answer = z_Data,                                            &
       check = z_AvrLonLat_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0/2.0D0*ro**2*(ro**2-ri**2)/(ro**2*(ro-ri))
  call AssertEqual(&
       message='x_AvrLatRad_xvz with r field',                     &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = PI*ro**2*(ro**2-ri**2)/(2*PI*ro**2*(ro-ri))
  call AssertEqual(&
       message='v_AvrLonRad_xvz with r field',                     &
       answer = v_Data,                                            &
       check = v_AvrLonRad_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = 2.0*PI*ro**2*(ro**2-ri**2)/(4*PI*(ro**2*(ro-ri)))
  call AssertEqual(&
       message='AvrLonLatRad_xvz with r field',                    &
       answer = Data,                                              &
       check = AvrLonLatRad_xvz(xvz_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  !--------- sin(phi)**2  ---------
  xvz_Data = sin(xvz_Lat)**2

  vz_Data = xvz_Data(1,:,:)
  call AssertEqual(&
       message='vz_AvrLon_xvz with sin^2φ field',                 &
       answer = vz_Data,                                           &
       check = vz_AvrLon_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xz_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='xz_AvrLat_xvz with sin^2φ field',                 &
       answer = xz_Data,                                           &
       check = xz_AvrLat_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xv_Data = xvz_Data(:,:,1)
  call AssertEqual(&
       message='xv_AvrRad_xvz with sin^2φ field',                 &
       answer = xv_Data,                                           &
       check = xv_AvrRad_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  z_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='z_AvrLonLat_xvz with sin^2φ field',               &
       answer = z_Data,                                            &
       check = z_AvrLonLat_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='x_AvrLatRad_xvz with sin^2φ field',               &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = xvz_Data(1,:,1)
  call AssertEqual(&
       message='v_AvrLonRad_xvz with sin^2φ field',               &
       answer = v_Data,                                            &
       check = v_AvrLonRad_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = 1.0D0/3D0
  call AssertEqual(&
       message='AvrLonLatRad_xvz with constant field',             &
       answer = Data,                                              &
       check = AvrLonLatRad_xvz(xvz_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xvz_Data = sin(xvz_Lon)**2

  vz_Data = 0.5D0
  call AssertEqual(&
       message='vz_AvrLon_xvz with sin(lambda)**2',                &
       answer = vz_Data,                                           &
       check = vz_AvrLon_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xz_Data = xvz_Data(:,1,:)
  call AssertEqual(&
       message='xz_AvrLat_xvz with sin(lambda)**2',                &
       answer = xz_Data,                                           &
       check = xz_AvrLat_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xv_Data = xvz_Data(:,:,1)
  call AssertEqual(&
       message='xv_AvrRad_xvz with sin(lambda)**2',                &
       answer = xv_Data,                                           &
       check = xv_AvrRad_xvz(xvz_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  z_Data = 0.5D0
  call AssertEqual(&
       message='z_AvrLonLat_xvz with sin(lambda)**2',              &
       answer = z_Data,                                            &
       check = z_AvrLonLat_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = xvz_Data(:,1,1)
  call AssertEqual(&
       message='x_AvrLatRad_xvz with sin(lambda)**2',              &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = 0.5D0
  call AssertEqual(&
       message='v_AvrLonRad_xvz with sin(lambda)**2',              &
       answer = v_Data,                                            &
       check = v_AvrLonRad_xvz(xvz_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLatRad_xvz with sin(lambda)**2',             &
       answer = 0.5D0,                                             &
       check = AvrLonLatRad_xvz(xvz_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(xv) =============================
  ! 定数
  xv_Data = 1.0D0

  v_Data = 1.0D0
  call AssertEqual(&
       message='v_AvrLon_xv with constant field',                  &
       answer = v_Data,                                            &
       check = v_AvrLon_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0
  call AssertEqual(&
       message='x_AvrLat_xv with constant field',                  &
       answer = x_Data,                                            &
       check = x_AvrLat_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLat_xv with constant field',                 &
       answer = 1.0D0,                                             &
       check = AvrLonLat_xv(xv_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xv_Data = sin(xv_Lon)**2

  v_Data = 0.5D0
  call AssertEqual(&
       message='v_AvrLon_xv with sin(lambda)**2',                  &
       answer = v_Data,                                            &
       check = v_AvrLon_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = xv_Data(:,1)
  call AssertEqual(&
       message='x_AvrLat_xv with sin(lambda)**2',                  &
       answer = x_Data,                                            &
       check = x_AvrLat_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLat_xv with sin(lambda)**2',                 &
       answer = 0.5D0,                                             &
       check = AvrLonLat_xv(xv_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  xv_Data = sin(xv_Lat)**2

  v_Data = xv_Data(1,:)
  call AssertEqual(&
       message='v_AvrLon_xv with sin(phi)**2',                     &
       answer = v_Data,                                            &
       check = v_AvrLon_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='x_AvrLat_xv with sin(phi)**2',                     &
       answer = x_Data,                                            &
       check = x_AvrLat_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLat_xv with sin(phi)**2',                    &
       answer = 1.0D0/3.0D0,                                       &
       check = AvrLonLat_xv(xv_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(vz) =============================
  ! 定数
  vz_Data = 1.0D0

  z_Data = 1.0D0
  call AssertEqual(&
       message='z_AvrLat_vz with constant field',                  &
       answer = z_Data,                                            &
       check = z_AvrLat_vz(vz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = 1.0D0
  call AssertEqual(&
       message='v_AvrRad_vz with constant field',                  &
       answer = v_Data,                                            &
       check = v_AvrRad_vz(vz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLatRad_vz with constant field',                 &
       answer = 1.0D0,                                             &
       check = AvrLatRad_vz(vz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2 
  vz_Data = sin(PI*(xvz_Rad(0,:,:)-ri)/(ro-ri))**2

  z_Data = vz_Data(1,:)
  call AssertEqual(&
       message='z_AvrLat_vz with sin^2(z)',                        &
       answer = z_Data,                                            &
       check = z_AvrLat_vz(vz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = 1.0D0/2.0D0*ro**2*(ro-ri)/(ro**2*(ro-ri))
  call AssertEqual(&
       message='v_AvrRad_vz with sin^2(z)',                        &
       answer = v_Data,                                            &
       check = v_AvrRad_vz(vz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLatRad_vz with sin^2(z)',                       &
       answer = 1.0D0/2.0D0*ro**2*(ro-ri)/(ro**2*(ro-ri)),         &
       check = AvrLatRad_vz(vz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  vz_Data = sin(xvz_Lat(0,:,:))**2

  z_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='z_AvrLat_vz with sin(phi)**2',                     &
       answer = z_Data,                                            &
       check = z_AvrLat_vz(vz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = vz_Data(:,1)
  call AssertEqual(&
       message='v_AvrRad_vz with sin(phi)**2',                     &
       answer = v_Data,                                            &
       check = v_AvrRad_vz(vz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLatRad_vz with sin(phi)**2',                    &
       answer = 1.0D0/3.0D0,                                       &
       check = AvrLatRad_vz(vz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(xz) =============================
  ! 定数
  xz_Data = 1.0D0

  z_Data = 1.0D0
  call AssertEqual(&
       message='z_AvrLon_xz with constant field',                  &
       answer = z_Data,                                            &
       check = z_AvrLon_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0
  call AssertEqual(&
       message='x_AvrRad_xz with constant field',                  &
       answer = x_Data,                                            &
       check = x_AvrRad_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonRad_xz with constant field',                 &
       answer = 1.0D0,                                             &
       check = AvrLonRad_xz(xz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xz_Data = sin(xvz_Lon(:,1,:))**2

  z_Data = 0.5D0
  call AssertEqual(&
       message='z_AvrLon_xz with sin(lambda)**2',                  &
       answer = z_Data,                                            &
       check = z_AvrLon_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = xz_Data(:,1)
  call AssertEqual(&
       message='x_AvrRad_xz with sin(lambda)**2',                  &
       answer = x_Data,                                            &
       check = x_AvrRad_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonRad_xz with sin(lambda)**2',                 &
       answer = 0.5D0,                                             &
       check = AvrLonRad_xz(xz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! cos^2(z)
  xz_Data = spread(cos(PI*(z_Rad-ri)/(ro-ri))**2,1,im)

  z_Data = xz_Data(1,:)
  call AssertEqual(&
       message='z_AvrLon_xz with cos^2(z)',                        &
       answer = z_Data,                                            &
       check = z_AvrLon_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0/2.0D0*ro**2*(ro-ri)/(ro**2*(ro-ri))
  call AssertEqual(&
       message='x_AvrRad_xz with cos^2(z)',                        &
       answer = x_Data,                                            &
       check = x_AvrRad_xz(xz_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonRad_xz with cos^2(z)',                       &
       answer = 1.0D0/2.0D0*ro**2*(ro-ri)/(ro**2*(ro-ri)),         &
       check = AvrLonRad_xz(xz_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(x) =============================
  ! 定数
  x_Data = 1.0D0

  call AssertEqual(&
       message='AvrLon_x with constant field',                     &
       answer = 1.0D0,                                             &
       check = AvrLon_x(x_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  x_Data = sin(x_Lon)**2

  call AssertEqual(&
       message='AvrLon_x with sin(lambda)**2',                     &
       answer = 0.5D0,                                             &
       check = AvrLon_x(x_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(y) =============================
  ! 定数
  v_Data = 1.0D0

  xz_Data = 1.0D0
  call AssertEqual(&
       message='AvrLat_v with constant field',                     &
       answer = 1.0D0,                                             &
       check = AvrLat_v(v_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2 
  v_Data = sin(v_Lat)**2

  call AssertEqual(&
       message='AvrLat_v with sin(phi)**2',                        &
       answer = 1.0D0/3.0D0,                                       &
       check = AvrLat_v(v_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(z) =============================
  ! 定数
  z_Data = 1.0D0

  call AssertEqual(&
       message='AvrRad_r with constant field',                     &
       answer = 1.0D0,                                             &
       check = AvrRad_z(z_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! cos^2(z) 
  z_Data = cos(PI*(z_Rad-ri)/(ro-ri))**2

  call AssertEqual(&
       message='AvrRad_r with cos^2(z)',                           &
       answer = 1.0D0/2.0D0*ro**2*(ro-ri)/(ro**2*(ro-ri)),         &
       check = AvrRad_z(z_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)
  
end program wsc_mpi_module_supack_integral_test

!----------------------------------------------------------------------
!     Copyright (c) 2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_af_galerkin_MM_test1d
!
!      チェビシェフ−ガラーキン法
!      ディリクレ・ノイマン混合境界条件用モジュールテストプログラム(1次元)
!          cfdx1_xmax f'(:,i=0)  + cfdx0_xmax f(:,i=0)  = 0,
!          cfdx1_xmin f'(:,i=im) + cfdx0_xmin f(:,i=im) = 0,
!
!      例1 : 両端ディリクレ条件
!            cfdx1_xmax=0, cfdx0_xmax = 1, cfdx1_xmin=0, cfdx0_xmin = 1
!            f(x) = (x-xmin) * (xmax-x)  
!
!      例2 : 片端ディリクレ片端ノイマン境界条件
!            cfdx1_xmax=0, cfdx0_xmax = 1, cfdx1_xmin=1, cfdx0_xmin = 0
!            f(x) = (x-xmin)**2 * (xmax-x)
!
!      例3 : 片端ノイマン片端ディリクレ境界条件
!            cfdx1_xmax=1, cfdx0_xmax = 0, cfdx1_xmin=0, cfdx0_xmin = 1
!            f(x) = (x-xmin)* (xmax-x)**2
!
!      例4 : ディリクレ・ノイマン混合境界条件
!            cfdx1_xmax=1, cfdx0_xmax = -1, cfdx1_xmin=1, cfdx0_xmin = 1
!            f(x) = x**3 - 2 x**2, 0<x<1
!
!      例5 : 両端ノイマン混合境界条件
!            cfdx1_xmax=1, cfdx0_xmax = 1, cfdx1_xmin=0, cfdx0_xmin = 0
!            f(x) = (x-xmin)**2 * (xmax-x)**2, 0<x<1
!
!履歴  2006/01/03  竹広真一  新規作成
!      2006/01/23  竹広真一  モジュール名変更に伴う改訂
!      2006/02/15  竹広真一  係数行列式 0 の場合に対応
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!
program at_af_galerkin_MM_test1d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_af_galerkin_MM
  use at_module

  implicit none

  integer, parameter :: im=8, km=4
  real(8), parameter :: xmin=0.0d0, xmax=1.0d0

  real(8) :: g_data(0:im)
  real(8) :: g_data_orig(0:im)

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = - 12

  call at_Initial(im,km,xmin,xmax)

  call MessageNotify('M','at_af_galerkin_MM_test1d', &
    & '1D Mixed B.C.')

  !--- 両端ディリクレ境界条件 ---
  call at_af_galerkin_MM_Initial(im,km,       &
       cfdx0_xmax=1.0D0, cfdx1_xmax=0.0D0, &
       cfdx0_xmin=1.0D0, cfdx1_xmin=0.0D0  )

  g_data = (g_X-xmin)*(xmax-g_X)
  g_data_orig = g_data
  g_data=g_f(f_t(t_g(g_data)))

  call check1d(g_data, g_data_orig, &
    & 'Check both Dirichlt B.C.')


  !--- 片端ディリクレ片端ノイマン境界条件 ---
  call at_af_galerkin_MM_Initial(im,km,       &
       cfdx0_xmax=1.0D0, cfdx1_xmax=0.0D0, &
       cfdx0_xmin=0.0D0, cfdx1_xmin=1.0D0  )

  g_data = (g_X-xmin)**2 * (xmax-g_X)
  g_data_orig = g_data
  g_data=g_f(f_t(t_g(g_data)))

  call check1d(g_data, g_data_orig, &
    & 'Check Dirichlt and Neuman B.C.')

  !--- 片端ノイマン片端ディリクレ境界条件 ---
  call at_af_galerkin_MM_Initial(im,km,       &
       cfdx0_xmax=0.0D0, cfdx1_xmax=1.0D0, &
       cfdx0_xmin=1.0D0, cfdx1_xmin=0.0D0  )

  g_data = (g_X-xmin) * (xmax-g_X)**2
  g_data_orig = g_data
  g_data=g_f(f_t(t_g(g_data)))

  call check1d(g_data, g_data_orig, &
    & 'Check Neumman and Dirichlt B.C.')

  !--- ディリクレ・ノイマン混合境界条件 ---
  call at_af_galerkin_MM_Initial(im,km,        &
       cfdx0_xmax=1.0D0, cfdx1_xmax=-1.0D0, &
       cfdx0_xmin=1.0D0, cfdx1_xmin=1.0D0    )

  g_data = g_X**3 - 2*g_X**2
  g_data_orig = g_data
  g_data=g_f(f_t(t_g(g_data)))

  call check1d(g_data, g_data_orig, &
    & 'Check Neumman and Dirichlt mixed B.C.')


  !--- 両端ノイマン境界条件 ---
  call at_af_galerkin_MM_Initial(im,km,       &
       cfdx0_xmax=0.0D0, cfdx1_xmax=1.0D0, &
       cfdx0_xmin=0.0D0, cfdx1_xmin=1.0D0  )

  g_data = (g_X-xmin)**2*(xmax-g_X)**2
  g_data_orig = g_data
  g_data=g_f(f_t(t_g(g_data)))

  call check1d(g_data, g_data_orig, &
    & 'Check both Neumman B.C.')

  call MessageNotify('M','at_af_galerkin_MM_test1d', &
    & '1D Mixed B.C. succeeded')

contains
  subroutine check1d(var, true, funcname)
    real(8) :: var(:)
    real(8) :: true(:)
    character(len=*), optional :: funcname

    call AssertEqual(&
      & message = funcname,   &
      & answer  = true,       &
      & check   = var,        &
      significant_digits = check_digits, ignore_digits = ignore   &
      )
  end subroutine check1d

end program at_af_galerkin_MM_test1d

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  la_module_svpack テストプログラム :: 基本変換関数のテスト
!
!履歴  2017/03/06  竹広真一
!
program la_module_svpack_base_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use la_module_svpack
  implicit none

  integer :: jm(2)=(/16,32/)
  integer :: nm(2)=(/10,21/)
  integer :: km(2)=(/3,3/)

  real(8), allocatable ::  ya_data(:,:)
  real(8), allocatable ::  la_data(:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  integer :: n

  call MessageNotify('M','la_module_svpack_base_test', &
                         'la_module_svpack basic functions tests') 

  do n=1,2

  call la_Initial( nm(n), jm(n) )

  allocate(la_data(0:nm(n),km(n)))
  allocate(ya_data(1:jm(n),km(n)))

  !---- P_* のテスト ----
  la_data= 0.0D0 
  ya_data(:,1) = sqrt(3.0D0)*sin(y_Lat)                   ! P_1
  la_data(1,1)=1.0D0
  ya_data(:,2) = sqrt(5.0D0)*(3.0/2*sin(y_Lat)**2-1/2.0)  ! P_2
  la_data(2,2)=1.0D0
  ya_data(:,3) = sqrt(7.0D0)*(5.0/2*sin(y_Lat)**3-3/2.0*sin(y_Lat))  ! P_3
  la_data(3,3)=1.0D0

  call AssertEqual(&
    message='P_* Test of la_ya(ya_data)',                         &
    answer = la_data,                                             &
    check = la_ya(ya_data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='P_* Test of ya_la(la_ya(ya_data))',                  &
    answer = ya_data,                                             &
    check = ya_la(la_ya(ya_data)),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的関数のテスト ----
  ya_data(:,1) = (sin(y_Lat)-1)**2*(sin(y_Lat)-0.5)*(sin(y_Lat)+1)
  ya_data(:,2) = (sin(y_Lat)-1)**2*(sin(y_Lat)+1)**2
  ya_data(:,3) = (sin(y_Lat)-1)*(sin(y_Lat)-0.5)**2*(sin(y_Lat)+1)

  call AssertEqual(&
    message='general function Test of ya_la(la_ya(ya_data))',     &
    answer = ya_data,                                             &
    check = ya_la(la_ya(ya_data)),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  deallocate(la_data)
  deallocate(ya_data)

  call la_Finalize

  enddo

  call MessageNotify('M','la_module_svpack_base_test', &
                         'la_module_svpack basic functions tests succeeded!') 

end program la_module_svpack_base_test

!----------------------------------------------------------------------
!     Copyright (c) 2017 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  scee_module_fftj テストプログラム (補間計算)
!
!履歴  2017/05/28  竹広真一
!
program scee_module_fftj_interpolate

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use scee_module_fftj
  implicit none

  !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=10       ! 切断波数の設定(X,Y)

  !---- 変数 ----
  real(8)            :: zyx_Data(0:km,0:jm-1,0:im-1)      ! 格子データ
  real(8)            :: x=0.2, y=0.7, z=0.4
  real(8)            :: Ans

  integer            :: l=2, m=5

  !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','scee_module_fftj_interpolate_test', &
       'scee_module_fftj interpolate function test')

  !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call scee_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

  !------------------- Interpolate_cee ----------------------
  zyx_Data = sin(l*pi*zyx_X) * sin(m*pi*zyx_Y) * cos(PI*(zyx_Z-zmin)/(zmax-zmin))

  Ans = sin(l*pi*X) * sin(m*pi*Y) * cos(PI*(Z-zmin)/(zmax-zmin))

  call AssertEqual(&
    message='Interpolate_cee',&
    answer = Ans,                                                 &
    check = Interpolate_cee(cee_zyx(zyx_Data),x,y,z),             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !------------------- Interpolate_see ----------------------
  zyx_Data = sin(l*pi*zyx_X) * cos(m*pi*zyx_Y) * sin(2*PI*(zyx_Z-zmin)/(zmax-zmin))

  Ans = sin(l*pi*X) * cos(m*pi*Y) * sin(2*PI*(Z-zmin)/(zmax-zmin))

  call AssertEqual(&
    message='Interpolate_see',&
    answer = Ans,                                                 &
    check = Interpolate_see(see_zyx(zyx_Data),x,y,z),             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  call MessageNotify('M','scee_module_fftj_interpolate_test', &
       'scee_module_fftj interpolate function test succeeded!')


end program scee_module_fftj_interpolate

!----------------------------------------------------------------------
!     Copyright (c) 2008 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  eee_module テストプログラム (正逆変換)
!
!履歴  2008/05/02  竹広真一
!      2008/05/10  竹広真一  解像度複数設定チェック
!
!備考  少なくとも一つ波数 が 0 のスペクトル成分のいくつかが逆負号になる. 
!
program eee_test_transform

  use dc_message, only : MessageNotify
  use eee_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=32          ! 格子点の設定(X,Y,Z)
  integer, parameter :: lm=10, mm=10, nm=10          ! 切断波数の設定(X,Y,Z)

  integer, parameter :: im2=64, jm2=64, km2=64       ! 格子点の設定(X,Y,Z)
  integer, parameter :: lm2=21, mm2=21, nm2=21       ! 切断波数の設定(X,Y,Z)

 !---- 変数 ----
  real(8)            :: zyx_Data(0:km-1,0:jm-1,0:im-1)    ! 格子データ
  real(8)            :: eee_Data(-nm:nm,-mm:mm,-lm:lm)    ! スペクトルデータ

  real(8)            :: zyx_Data2(0:km2-1,0:jm2-1,0:im2-1)    ! 格子データ
  real(8)            :: eee_Data2(-nm2:nm2,-mm2:mm2,-lm2:lm2) ! スペクトルデータ
  real(8)            :: eee_Data3(-nm:nm,-mm:mm,-lm:lm)    ! スペクトルデータ

  integer            :: l=5,m=3,n=2
  integer            :: id1, id2, id3

 !---- 座標変数など ----
  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: eps = 1.0d-10            ! 判定誤差

  call MessageNotify('M','eee_test_transform', &
       'eee_module transform function tests')

 !---------------- 座標値の設定 ---------------------
  call eee_initial(im,jm,km,lm,mm,nm,id1)
  call eee_initial(im2,jm2,km2,lm2,mm2,nm2,id2)
  call eee_initial(im2,jm2,km2,lm,mm,nm,id3)
  call eee_initial(im2,jm2,km2,lm2,mm2,nm2)
  call eee_initial(im2,jm2,km2,lm2,mm2,nm2)
  call eee_initial(im2,jm2,km2,lm2,mm2,nm2)
  call eee_initial(im2,jm2,km2,lm2,mm2,nm2)
  call eee_initial(im2,jm2,km2,lm2,mm2,nm2)
  call eee_initial(im2,jm2,km2,lm2,mm2,nm2)
  call eee_initial(im2,jm2,km2,lm2,mm2,nm2)
  call eee_initial(im2,jm2,km2,lm2,mm2,nm2)

 !------------------- 初期値設定 ----------------------
  write(6,*) '*** Test of eee_module : grid -> spectral -> grid transformation check.'
  write(6,*) '  The result will be printed '
  write(6,*) '  only when the error is larger than ', eps
  write(6,*)

!!$  write(6,*) '  Input wavenumbers of the grid data, l,m and n :'
!!$  read(5,*) l,m,n
!!$  write(6,*) '  l,m,n = ', l,m,n

  ! id1
  write(*,*) 'for id1'
  call eee_ChangeResolution(id1)

  zyx_Data = sin(l*zyx_X) * sin(m*zyx_Y) * sin(n*zyx_Z)

  eee_Data = 0.0 
  if ( l /= 0 .and. m/=0 .and. n/=0 )then
     eee_Data(-n,-m,-l) = 0.125 ; eee_Data(-n,m,-l)=-0.125
     eee_Data(n,-m,-l) =-0.125  ; eee_Data(n,m,-l) = 0.125
  endif

  call check3d(eee_zyx(zyx_Data)-eee_Data, eps, &
       'Transform sin(l*X)*sin(m*Y)**sin(n*Z)')
  call check3d(zyx_eee(eee_zyx(zyx_Data))-zyx_Data, eps, &
       'Inverse transform sin(l*X)*sin(m*Y)**sin(n*Z)')

  zyx_Data = cos(l*zyx_X) * cos(m*zyx_Y) * cos(n*zyx_Z)
  eee_Data = 0.0 

  if ( l /= 0 .and. m/=0 .and. n/=0 )then
     eee_Data(n,m,l) = 0.125  ; eee_Data(-n,m,l) = 0.125  
     eee_Data(n,-m,l) = 0.125  ; eee_Data(-n,-m,l) = 0.125 
  elseif( l==0 .and. m/=0 .and. n/=0 )then
     eee_Data(n,m,0) = -0.25 ;  eee_Data(-n,m,0) = -0.25
  elseif( l/=0 .and. m==0 .and. n/=0 )then
     eee_Data(n,0,l) = -0.25 ;  eee_Data(-n,0,l) = -0.25
  elseif( l/=0 .and. m/=0 .and. n==0 )then
     eee_Data(0,m,l) = -0.25 ;  eee_Data(0,-m,l) = -0.25
  elseif( l==0 .and. m==0 .and. n/=0 )then
     eee_Data(n,0,0) = 0.5
  elseif( l/=0 .and. m==0 .and. n==0 )then
     eee_Data(0,0,l) = -0.5
  elseif( l==0 .and. m/=0 .and. n==0 )then
     eee_Data(0,m,0) = -0.5
  endif
     
  call check3d(eee_zyx(zyx_Data)-eee_Data, eps, &
       'Transform cos(l*X)*cos(m*Y)*cos(n*Z)')
  call check3d(zyx_eee(eee_zyx(zyx_Data))-zyx_Data, eps,&
       'Inverse transoform cos(l*X)*cos(m*Y)*cos(n*Z)')

  zyx_Data = sin(l*zyx_X) * cos(m*zyx_Y) * cos(n*zyx_Z)
  eee_Data = 0.0
  if ( l /= 0 .and. m/=0 .and. n/=0 )then
     eee_Data(-n,-m,-l) = -0.125  ; eee_Data(n,-m,-l) = -0.125  
     eee_Data(-n,m,-l) = -0.125  ; eee_Data(n,m,-l) = -0.125  
  elseif ( l /= 0 .and. m==0 .and. n/=0 )then
     eee_Data(-n,0,-l) = 0.25  ;  eee_Data(n,0,-l) = 0.25
  elseif ( l /= 0 .and. m/=0 .and. n==0 )then
     eee_Data(0,m,-l) = 0.25  ;  eee_Data(0,-m,-l) = 0.25
  elseif ( l /= 0 .and. m==0 .and. n==0 )then
     eee_Data(0,0,-l) = 0.5
  endif
  call check3d(eee_zyx(zyx_Data)-eee_Data, eps, &
       'Transform sin(l*X)*cos(m*Y)*cos(n*Z)')
  call check3d(zyx_eee(eee_zyx(zyx_Data))-zyx_Data, eps, &
       'Inverse transform sin(l*X)*cos(m*Y)*cos(n*Z)')

  zyx_Data = cos(l*zyx_X) * sin(m*zyx_Y) * sin(n*zyx_Z)
  eee_Data = 0.0 ;
  if ( l /= 0 .and. m/=0 .and. n/=0 )then
     eee_Data(n,m,l)  = -0.125  ; eee_Data(n,-m,l)  = 0.125  
     eee_Data(-n,m,l) = 0.125  ; eee_Data(-n,-m,l) = -0.125  
  elseif ( l == 0 .and. m/=0 .and. n/=0 )then
     eee_Data(n,m,0) = 0.25  ;  eee_Data(-n,m,0) = -0.25
  endif

  call check3d(eee_zyx(zyx_Data)-eee_Data, eps, &
       'Transform cos(l*X)*sin(m*Y)*sin(n*Z)')
  call check3d(zyx_eee(eee_zyx(zyx_Data))-zyx_Data, eps,&
       'Inverse transform cos(l*X)*sin(m*Y)*sin(n*Z)')

  ! id2
  write(*,*) 'for id2'
  call eee_ChangeResolution(id2)

  zyx_Data2 = sin(l*zyx_X) * sin(m*zyx_Y) * sin(n*zyx_Z)

  eee_Data2 = 0.0 
  if ( l /= 0 .and. m/=0 .and. n/=0 )then
     eee_Data2(-n,-m,-l) = 0.125 ; eee_Data2(-n,m,-l)=-0.125
     eee_Data2(n,-m,-l) =-0.125  ; eee_Data2(n,m,-l) = 0.125
  endif

  call check3d(eee_zyx(zyx_Data2)-eee_Data2, eps, &
       'Transform sin(l*X)*sin(m*Y)**sin(n*Z)')
  call check3d(zyx_eee(eee_zyx(zyx_Data2))-zyx_Data2, eps, &
       'Inverse transform sin(l*X)*sin(m*Y)**sin(n*Z)')

  zyx_Data2 = cos(l*zyx_X) * cos(m*zyx_Y) * cos(n*zyx_Z)
  eee_Data2 = 0.0 

  if ( l /= 0 .and. m/=0 .and. n/=0 )then
     eee_Data2(n,m,l) = 0.125  ; eee_Data2(-n,m,l) = 0.125  
     eee_Data2(n,-m,l) = 0.125  ; eee_Data2(-n,-m,l) = 0.125 
  elseif( l==0 .and. m/=0 .and. n/=0 )then
     eee_Data2(n,m,0) = -0.25 ;  eee_Data2(-n,m,0) = -0.25
  elseif( l/=0 .and. m==0 .and. n/=0 )then
     eee_Data2(n,0,l) = -0.25 ;  eee_Data2(-n,0,l) = -0.25
  elseif( l/=0 .and. m/=0 .and. n==0 )then
     eee_Data2(0,m,l) = -0.25 ;  eee_Data2(0,-m,l) = -0.25
  elseif( l==0 .and. m==0 .and. n/=0 )then
     eee_Data2(n,0,0) = 0.5
  elseif( l/=0 .and. m==0 .and. n==0 )then
     eee_Data2(0,0,l) = -0.5
  elseif( l==0 .and. m/=0 .and. n==0 )then
     eee_Data2(0,m,0) = -0.5
  endif
     
  call check3d(eee_zyx(zyx_Data2)-eee_Data2, eps, &
       'Transform cos(l*X)*cos(m*Y)*cos(n*Z)')
  call check3d(zyx_eee(eee_zyx(zyx_Data2))-zyx_Data2, eps,&
       'Inverse transoform cos(l*X)*cos(m*Y)*cos(n*Z)')

  zyx_Data2 = sin(l*zyx_X) * cos(m*zyx_Y) * cos(n*zyx_Z)
  eee_Data2 = 0.0
  if ( l /= 0 .and. m/=0 .and. n/=0 )then
     eee_Data2(-n,-m,-l) = -0.125  ; eee_Data2(n,-m,-l) = -0.125  
     eee_Data2(-n,m,-l) = -0.125  ; eee_Data2(n,m,-l) = -0.125  
  elseif ( l /= 0 .and. m==0 .and. n/=0 )then
     eee_Data2(-n,0,-l) = 0.25  ;  eee_Data2(n,0,-l) = 0.25
  elseif ( l /= 0 .and. m/=0 .and. n==0 )then
     eee_Data2(0,m,-l) = 0.25  ;  eee_Data2(0,-m,-l) = 0.25
  elseif ( l /= 0 .and. m==0 .and. n==0 )then
     eee_Data2(0,0,-l) = 0.5
  endif
  call check3d(eee_zyx(zyx_Data2)-eee_Data2, eps, &
       'Transform sin(l*X)*cos(m*Y)*cos(n*Z)')
  call check3d(zyx_eee(eee_zyx(zyx_Data2))-zyx_Data2, eps, &
       'Inverse transform sin(l*X)*cos(m*Y)*cos(n*Z)')

  zyx_Data2 = cos(l*zyx_X) * sin(m*zyx_Y) * sin(n*zyx_Z)
  eee_Data2 = 0.0 ;
  if ( l /= 0 .and. m/=0 .and. n/=0 )then
     eee_Data2(n,m,l)  = -0.125  ; eee_Data2(n,-m,l)  = 0.125  
     eee_Data2(-n,m,l) = 0.125  ; eee_Data2(-n,-m,l) = -0.125  
  elseif ( l == 0 .and. m/=0 .and. n/=0 )then
     eee_Data2(n,m,0) = 0.25  ;  eee_Data2(-n,m,0) = -0.25
  endif

  call check3d(eee_zyx(zyx_Data2)-eee_Data2, eps, &
       'Transform cos(l*X)*sin(m*Y)*sin(n*Z)')
  call check3d(zyx_eee(eee_zyx(zyx_Data2))-zyx_Data2, eps,&
       'Inverse transform cos(l*X)*sin(m*Y)*sin(n*Z)')

  ! id1 and id3
  write(*,*) 'for id1 and id3'

  call eee_ChangeResolution(id1)
  zyx_Data = sin(l*zyx_X) * sin(m*zyx_Y) * sin(n*zyx_Z)
  eee_Data = eee_zyx(zyx_Data)
  call eee_ChangeResolution(id3)
  zyx_Data2 = sin(l*zyx_X) * sin(m*zyx_Y) * sin(n*zyx_Z)
  eee_Data3 = eee_zyx(zyx_Data2)
  call check3d(eee_Data3-eee_Data, eps, &
       'Transform sin(l*X)*sin(m*Y)**sin(n*Z)')

  call eee_ChangeResolution(id1)
  zyx_Data = cos(l*zyx_X) * cos(m*zyx_Y) * cos(n*zyx_Z)
  eee_Data = eee_zyx(zyx_Data)
  call eee_ChangeResolution(id3)
  zyx_Data2 = cos(l*zyx_X) * cos(m*zyx_Y) * cos(n*zyx_Z)
  eee_Data3 = eee_zyx(zyx_Data2)
  call check3d(eee_Data3-eee_Data, eps, &
       'Transform cos(l*X)*cos(m*Y)*cos(n*Z)')

  call eee_ChangeResolution(id1)
  zyx_Data = sin(l*zyx_X) * cos(m*zyx_Y) * cos(n*zyx_Z)
  eee_Data = eee_zyx(zyx_Data)
  call eee_ChangeResolution(id3)
  zyx_Data2 = sin(l*zyx_X) * cos(m*zyx_Y) * cos(n*zyx_Z)
  eee_Data3 = eee_zyx(zyx_Data2)
  call check3d(eee_Data3-eee_Data, eps, &
       'Transform sin(l*X)*cos(m*Y)*cos(n*Z)')

  call eee_ChangeResolution(id1)
  zyx_Data = cos(l*zyx_X) * sin(m*zyx_Y) * sin(n*zyx_Z)
  eee_Data = eee_zyx(zyx_Data)
  call eee_ChangeResolution(id3)
  zyx_Data2 = cos(l*zyx_X) * sin(m*zyx_Y) * sin(n*zyx_Z)
  eee_Data3 = eee_zyx(zyx_Data2)
  call check3d(eee_Data3-eee_Data, eps, &
       'Transform cos(l*X)*sin(m*Y)*sin(n*Z)')

  call MessageNotify('M','eee_test_transform', &
       'eee_module transform function tests succeeded!')

 stop
contains

  subroutine check3d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:,:)              ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    integer i, j, k

    if ( present(funcname) )then
       write(6,*) '  Checking ', funcname, '...'
    endif

    do k=1,size(var,3)
       do j=1,size(var,2)
          do i=1,size(var,1)
             if (abs(var(i,j,k)) .gt. eps ) then
                write(6,*) &
                  '    Value larger than EPS : i= ', i, '  j= ', j, '  k= ', k, &
                  var(i,j,k)
                call MessageNotify('E','eee_test_transform', &
                  'transform error too large')
             endif
          enddo
       enddo
    enddo
  end subroutine check3d

end program eee_test_transform

!----------------------------------------------------------------------
!     Copyright (c) 2010--2012 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wtq_module テストプログラム :: 基本変換関数のテスト
!
!履歴  2010/04/18  竹広真一   wt_module_sjpack_test_base.f90 より改造
!      2011/09/13  竹広真一   MPI 並列化
!      2011/09/14  竹広真一   wtq_mpi_module 用に改造
!      2012/04/02  竹広真一   wtq_mpi_module_sjpack 用に改造
!      2012/04/03  竹広真一   wtq_module_sjpack 用に改造
!      2012/04/03  竹広真一   wtq_module 用に改造
!
program wtq_module_base_wt_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wtq_module
  implicit none

  integer,parameter  :: im=32, jm=16         ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: kmo=16, kmi=10       ! 格子点の設定(球殻動径, 球動径)
  integer,parameter  :: nm=10                ! 切断波数の設定(水平)
  integer,parameter  :: lmo=10, lmi=16       ! 切断波数の設定(球殻動径, 球動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  real(8), dimension((nm+1)**2,0:lmo)       ::  wt_data
  real(8), dimension(0:im-1,1:jm,0:kmo)     ::  xyz_data
  real(8), dimension(0:im-1,1:jm,0:kmo)     ::  xyz_xi

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: pi

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','wtq_module_base_wt_test', &
                         'wtq_module wt-basic transformation functions tests') 

  call wtq_Initial(im,jm,kmi,kmo,nm,lmi,lmo,ri,ro)

  xyz_xi = (xyz_Rad - (ro+ri)/2 )*2/(ro-ri)

  !---- Y_1^* のテスト ----
  xyz_data = sqrt(3.0D0)*sin(xyz_Lat)*xyz_xi            ! Y_1^0 T_1
  wt_data= 0.0D0 ; wt_data(l_nm(1,0),1)=1.0D0

  call AssertEqual(&
    message='wt_xyz with Y_1^0 T_1',                              &
    answer = wt_data,                                             &
    check = wt_xyz(xyz_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_wt with Y_1^0 T_1',                              &
    answer = xyz_data,                                            &
    check = xyz_wt(wt_xyz(xyz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xyz_data = sqrt(3.0D0/2)*cos(xyz_Lat)*cos(xyz_Lon)     ! Y_1^1 T_0
  wt_data= 0.0D0 ;  wt_data(l_nm(1,1),0)=1.0D0/sqrt(2.0D0)*2

  call AssertEqual(&
    message='wt_xyz with Y_1^1 T_0',                              &
    answer = wt_data,                                             &
    check = wt_xyz(xyz_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_wt with Y_1^1 T_0',                              &
    answer = xyz_data,                                            &
    check = xyz_wt(wt_xyz(xyz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xyz_data = -sqrt(3.0D0/2)*cos(xyz_Lat)*sin(xyz_Lon)*(2*xyz_xi**2-1) !Y_1^{-1}T_2
  wt_data= 0.0D0 ;  wt_data(l_nm(1,-1),2)=1.0D0/sqrt(2.0D0)

  call AssertEqual(&
    message='wt_xyz with Y_1^-1 T_2',                             &
    answer = wt_data,                                             &
    check = wt_xyz(xyz_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_wt with Y_1^-1 T_2',                             &
    answer = xyz_data,                                            &
    check = xyz_wt(wt_xyz(xyz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^* のテスト ----
  ! Y_2^0 T_3
  xyz_data = sqrt(5.0D0)*(3.0/2*sin(xyz_Lat)**2-1/2.0)*(4*xyz_xi**3-3*xyz_xi) 
  wt_data= 0.0D0 ; wt_data(l_nm(2,0),3)=1.0D0

  call AssertEqual(&
    message='wt_xyz with Y_2^0 T_3',                              &
    answer = wt_data,                                             &
    check = wt_xyz(xyz_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_wt with Y_2^0 T_3',                              &
    answer = xyz_data,                                            &
    check = xyz_wt(wt_xyz(xyz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !Y_2^1 T_4
  xyz_data = sqrt(5.0D0/6)*3.0*sin(xyz_Lat)*cos(xyz_Lat)*cos(xyz_Lon) &
            *(8*xyz_xi**4 - 8*xyz_xi**2 + 1 )
  wt_data= 0.0D0 ; wt_data(l_nm(2,1),4)=1.0D0/sqrt(2.0D0)

  call AssertEqual(&
    message='wt_xyz with Y_2^1 T_4',                              &
    answer = wt_data,                                             &
    check = wt_xyz(xyz_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_wt with Y_2^1 T_4',                              &
    answer = xyz_data,                                            &
    check = xyz_wt(wt_xyz(xyz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ! Y_2^-2
  xyz_data = -sqrt(5.0D0/24)*3.0*cos(xyz_Lat)**2*sin(2*xyz_Lon) &
            *(16*xyz_xi**5-20*xyz_xi**3+5*xyz_xi)
  wt_data= 0.0D0 ; wt_data(l_nm(2,-2),5)=1.0D0/sqrt(2.0D0)

  call AssertEqual(&
    message='wt_xyz with Y_2^-2 T_5',                             &
    answer = wt_data,                                             &
    check = wt_xyz(xyz_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xyz_wt with Y_2^-2 T_5',                             &
    answer = xyz_data,                                            &
    check = xyz_wt(wt_xyz(xyz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的関数のテスト ----
  xyz_data = cos(2*xyz_Lon-pi/3) &
       *(sin(xyz_Lat)-1)**2*(sin(xyz_Lat)-0.5)*(sin(xyz_Lat)+1) &
       *exp(xyz_Rad)

  call AssertEqual(&
    message='xyz_wt and wt_xyz with a general function',          &
    answer = xyz_data,                                            &
    check = xyz_wt(wt_xyz(xyz_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wtq_module_base_wt_test', &
                         'wtq_module wt-basic functions tests succeeded!') 


end program wtq_module_base_wt_test
